"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(V){for(var t=[],_=0,k=V.length;_<k;_++)t[_]=re[V[_]];return t};const We=this,Ce=typeof global=="object"?global:{};var he;(function(V){V.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof V.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}V.Environment=t})(he||(he={}));var he;(function(V){class t{constructor(f,v,h){this.type=f,this.detail=v,this.timestamp=h}}V.LoaderEvent=t;class _{constructor(f){this._events=[new t(1,"",f)]}record(f,v){this._events.push(new t(f,v,V.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}V.LoaderEventRecorder=_;class k{record(f,v){}getEvents(){return[]}}k.INSTANCE=new k,V.NullLoaderEventRecorder=k})(he||(he={}));var he;(function(V){class t{static fileUriToFilePath(k,r){if(r=decodeURI(r).replace(/%23/g,"#"),k){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(k,r){return k.length>=r.length&&k.substr(0,r.length)===r}static endsWith(k,r){return k.length>=r.length&&k.substr(k.length-r.length)===r}static containsQueryString(k){return/^[^\#]*\?/gi.test(k)}static isAbsolutePath(k){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(k)}static forEachProperty(k,r){if(k){let f;for(f in k)k.hasOwnProperty(f)&&r(f,k[f])}}static isEmpty(k){let r=!0;return t.forEachProperty(k,()=>{r=!1}),r}static recursiveClone(k){if(!k||typeof k!="object"||k instanceof RegExp||!Array.isArray(k)&&Object.getPrototypeOf(k)!==Object.prototype)return k;let r=Array.isArray(k)?[]:{};return t.forEachProperty(k,(f,v)=>{v&&typeof v=="object"?r[f]=t.recursiveClone(v):r[f]=v}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(k){return t.startsWith(k,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=V.global.performance&&typeof V.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?V.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,V.Utilities=t})(he||(he={}));var he;(function(V){function t(r){if(r instanceof Error)return r;const f=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(f.stack=r.stack),f}V.ensureError=t;class _{static validateConfigurationOptions(f){function v(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=v),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(V.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,v=null){let h=V.Utilities.recursiveClone(v||{});return V.Utilities.forEachProperty(f,(l,s)=>{l==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(s):l==="paths"&&typeof h.paths<"u"?V.Utilities.forEachProperty(s,(g,A)=>h.paths[g]=A):l==="config"&&typeof h.config<"u"?V.Utilities.forEachProperty(s,(g,A)=>h.config[g]=A):h[l]=V.Utilities.recursiveClone(s)}),_.validateConfigurationOptions(h)}}V.ConfigurationOptionsUtil=_;class k{constructor(f,v){if(this._env=f,this.options=_.mergeConfigurationOptions(v),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,l=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],V.Utilities.forEachProperty(this.options.paths,(f,v)=>{Array.isArray(v)?this.sortedPathsRules.push({from:f,to:v}):this.sortedPathsRules.push({from:f,to:[v]})}),this.sortedPathsRules.sort((f,v)=>v.from.length-f.from.length)}cloneAndMerge(f){return new k(this._env,_.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let v;for(let h=0,l=this.sortedPathsRules.length;h<l;h++)if(v=this.sortedPathsRules[h],V.Utilities.startsWith(f,v.from)){let s=[];for(let g=0,A=v.to.length;g<A;g++)s.push(v.to[g]+f.substr(v.from.length));return s}return[f]}_addUrlArgsToUrl(f){return V.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let v=0,h=f.length;v<h;v++)f[v]=this._addUrlArgsToUrl(f[v]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let v=f,h;if(!V.Utilities.endsWith(v,".js")&&!V.Utilities.isAbsolutePath(v)){h=this._applyPaths(v);for(let l=0,s=h.length;l<s;l++)this.isBuild()&&h[l]==="empty:"||(V.Utilities.isAbsolutePath(h[l])||(h[l]=this.options.baseUrl+h[l]),!V.Utilities.endsWith(h[l],".js")&&!V.Utilities.containsQueryString(h[l])&&(h[l]=h[l]+".js"))}else!V.Utilities.endsWith(v,".js")&&!V.Utilities.containsQueryString(v)&&(v=v+".js"),h=[v];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let v=f;return V.Utilities.isAbsolutePath(v)||(v=this._applyPaths(v)[0],V.Utilities.isAbsolutePath(v)||(v=this.options.baseUrl+v)),this._addUrlArgsIfNecessaryToUrl(v)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||V.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}V.Configuration=k})(he||(he={}));var he;(function(V){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,g,A,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new _:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new _;let $={callback:A,errorback:b};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push($);return}this._callbackMap[g]=[$],this._scriptLoader.load(s,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(s){let g=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<g.length;A++)g[A].callback()}triggerErrorback(s,g){let A=this._callbackMap[s];delete this._callbackMap[s];for(let b=0;b<A.length;b++)A[b].errorback(g)}}class _{attachListeners(s,g,A){let b=()=>{s.removeEventListener("load",$),s.removeEventListener("error",e)},$=N=>{b(),g()},e=N=>{b(),A(N)};s.addEventListener("load",$),s.addEventListener("error",e)}load(s,g,A,b){if(/^node\|/.test(g)){let $=s.getConfig().getOptionsLiteral(),e=v(s.getRecorder(),$.nodeRequire||V.global.nodeRequire),N=g.split("|"),R=null;try{R=e(N[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let $=document.createElement("script");$.setAttribute("async","async"),$.setAttribute("type","text/javascript"),this.attachListeners($,A,b);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),$.setAttribute("src",g);const{cspNonce:N}=s.getConfig().getOptionsLiteral();N&&$.setAttribute("nonce",N),document.getElementsByTagName("head")[0].appendChild($)}}}function k(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=k(s)),this._cachedCanUseEval}load(s,g,A,b){if(/^node\|/.test(g)){const $=s.getConfig().getOptionsLiteral(),e=v(s.getRecorder(),$.nodeRequire||V.global.nodeRequire),N=g.split("|");let R=null;try{R=e(N[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:$}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(g).then(N=>{if(N.status!==200)throw new Error(N.statusText);return N.text()}).then(N=>{N=`${N}
//# sourceURL=${g}`,($?self.eval($.createScript("",N)):new Function(N)).call(self),A()}).then(void 0,b);return}try{$&&(g=$.createScriptURL(g)),importScripts(g),A()}catch(N){b(N)}}}}class f{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,g){const{nodeCachedData:A}=g.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,$=s("module");function e(N){const R=N.constructor;let L=function(a){try{return N.require(a)}finally{}};return L.resolve=function(a,o){return R._resolveFilename(a,N,!1,o)},L.resolve.paths=function(a){return R._resolveLookupPaths(a,N)},L.main=process.mainModule,L.extensions=R._extensions,L.cache=R._cache,L}$.prototype._compile=function(N,R){const L=$.wrap(N.replace(/^#!.*/,"")),d=g.getRecorder(),a=b._getCachedDataPath(A,R),o={filename:R};let u;try{const M=b._fs.readFileSync(a);u=M.slice(0,16),o.cachedData=M.slice(16),d.record(60,a)}catch{d.record(61,a)}const i=new b._vm.Script(L,o),c=i.runInThisContext(o),E=b._path.dirname(R),m=e(this),w=[this.exports,m,this,R,E,process,Ce,Buffer],p=c.apply(this.exports,w);return b._handleCachedData(i,L,a,!o.cachedData,g),b._verifyCachedData(i,L,a,u,g),p}}load(s,g,A,b){const $=s.getConfig().getOptionsLiteral(),e=v(s.getRecorder(),$.nodeRequire||V.global.nodeRequire),N=$.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(g)){let L=g.split("|"),d=null;try{d=e(L[1])}catch(a){b(a);return}s.enqueueDefineAnonymousModule([],()=>d),A()}else{g=V.Utilities.fileUriToFilePath(this._env.isWindows,g);const L=this._path.normalize(g),d=this._getElectronRendererScriptPathOrUri(L),a=!!$.nodeCachedData,o=a?this._getCachedDataPath($.nodeCachedData,g):void 0;this._readSourceAndCachedData(L,o,R,(u,i,c,E)=>{if(u){b(u);return}let m;i.charCodeAt(0)===f._BOM?m=f._PREFIX+i.substring(1)+f._SUFFIX:m=f._PREFIX+i+f._SUFFIX,m=N(m,L);const w={filename:d,cachedData:c},p=this._createAndEvalScript(s,m,w,A,b);this._handleCachedData(p,m,o,a&&!c,s),this._verifyCachedData(p,m,o,E,s)})}}_createAndEvalScript(s,g,A,b,$){const e=s.getRecorder();e.record(31,A.filename);const N=new this._vm.Script(g,A),R=N.runInThisContext(A),L=s.getGlobalAMDDefineFunc();let d=!1;const a=function(){return d=!0,L.apply(null,arguments)};return a.amd=L.amd,R.call(V.global,s.getGlobalAMDRequireFunc(),a,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),d?b():$(new Error(`Didn't receive define call in ${A.filename}!`)),N}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let g=s.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,g){const A=this._crypto.createHash("md5").update(g,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(g).replace(/\.js$/,"");return this._path.join(s.path,`${b}-${A}.code`)}_handleCachedData(s,g,A,b,$){s.cachedDataRejected?this._fs.unlink(A,e=>{$.getRecorder().record(62,A),this._createAndWriteCachedData(s,g,A,$),e&&$.getConfig().onError(e)}):b&&this._createAndWriteCachedData(s,g,A,$)}_createAndWriteCachedData(s,g,A,b){let $=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,N=0,R;const L=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(g,"utf8").digest());const d=s.createCachedData();if(!(d.length===0||d.length===e||N>=5)){if(d.length<e){L();return}e=d.length,this._fs.writeFile(A,Buffer.concat([R,d]),a=>{a&&b.getConfig().onError(a),b.getRecorder().record(63,A),L()})}},$*Math.pow(4,N++))};L()}_readSourceAndCachedData(s,g,A,b){if(!g)this._fs.readFile(s,{encoding:"utf8"},b);else{let $,e,N,R=2;const L=d=>{d?b(d):--R===0&&b(void 0,$,e,N)};this._fs.readFile(s,{encoding:"utf8"},(d,a)=>{$=a,L(d)}),this._fs.readFile(g,(d,a)=>{!d&&a&&a.length>0?(N=a.slice(0,16),e=a.slice(16),A.record(60,g)):A.record(61,g),L()})}}_verifyCachedData(s,g,A,b,$){b&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();b.equals(e)||($.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,N=>{N&&$.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function v(l,s){if(s.__$__isRecorded)return s;const g=function(b){l.record(33,b);try{return s(b)}finally{l.record(34,b)}};return g.__$__isRecorded=!0,g}V.ensureRecordedNodeRequire=v;function h(l){return new t(l)}V.createScriptLoader=h})(he||(he={}));var he;(function(V){class t{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,g;for(g=/\/\.\//;g.test(s);)s=s.replace(g,"/");for(s=s.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(s);)s=s.replace(g,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return V.Utilities.isAbsolutePath(s)||(V.Utilities.startsWith(s,"./")||V.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),V.ModuleIdResolver=t;class _{constructor(l,s,g,A,b,$){this.id=l,this.strId=s,this.dependencies=g,this._callback=A,this._errorback=b,this.moduleIdResolver=$,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(V.global,s),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(l,s,g,A){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(g,A):{returnedValue:g.apply(V.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,g,A){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let $=_._invokeFactory(s,this.strId,this._callback,g);b=$.producedError,l.record(22,this.strId),!b&&typeof $.returnedValue<"u"&&(!this.exportsPassedIn||V.Utilities.isEmpty(this.exports))&&(this.exports=$.returnedValue)}else this.exports=this._callback;if(b){let $=V.ensureError(b);$.phase="factory",$.moduleId=this.strId,$.neededBy=A(this.id),this.error=$,s.onError($)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}V.Module=_;class k{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class r{constructor(l){this.id=l}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),V.RegularDependency=r;class f{constructor(l,s,g){this.id=l,this.pluginId=s,this.pluginParam=g}}V.PluginDependency=f;class v{constructor(l,s,g,A,b=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=b,this._defineFunc=g,this._requireFunc=A,this._moduleIdProvider=new k,this._config=new V.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let g=$=>$.replace(/\\/g,"/"),A=g(l),b=s.split(/\n/);for(let $=0;$<b.length;$++){let e=b[$].match(/(.*):(\d+):(\d+)\)?$/);if(e){let N=e[1],R=e[2],L=e[3],d=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(d),N=g(N),N===A){let a={line:parseInt(R,10),col:parseInt(L,10)};return a.line===1&&(a.col-=53),a}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let g=0,A=this._modules2.length;g<A;g++){let b=this._modules2[g];if(!b)continue;let $=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,N=this._buildInfoDependencies[b.id];l[s++]={id:b.strId,path:$,defineLocation:$&&e?v._findRelevantLocationInStack($,e):null,dependencies:N,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new V.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=V.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:l,callback:s}}defineModule(l,s,g,A,b,$=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let N=new _(e,l,this._normalizeDependencies(s,$),g,A,$);this._modules2[e]=N,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(N.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(N)}_normalizeDependency(l,s){if(l==="exports")return r.EXPORTS;if(l==="module")return r.MODULE;if(l==="require")return r.REQUIRE;let g=l.indexOf("!");if(g>=0){let A=s.resolveModule(l.substr(0,g)),b=s.resolveModule(l.substr(g+1)),$=this._moduleIdProvider.getModuleId(A+"!"+b),e=this._moduleIdProvider.getModuleId(A);return new f($,e,b)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let g=[],A=0;for(let b=0,$=l.length;b<$;b++)g[A++]=this._normalizeDependency(l[b],s);return g}_relativeRequire(l,s,g,A){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(V.Utilities.generateAnonymousModule(),s,g,A,null,l)}synchronousRequire(l,s=new t(l)){let g=this._normalizeDependency(l,s),A=this._modules2[g.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(l,s){let g=this._config.shouldRecordStats();s?this._config=new V.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let g=this._moduleIdProvider.getStrModuleId(l),A=(this._inverseDependencies2[l]||[]).map($=>this._moduleIdProvider.getStrModuleId($));const b=V.ensureError(s);return b.phase="loading",b.moduleId=g,b.neededBy=A,b}_onLoadError(l,s){const g=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new _(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let A=[];for(let e=0,N=this._moduleIdProvider.getMaxModuleId();e<N;e++)A[e]=!1;let b=!1,$=[];for($.push(l),A[l]=!0;$.length>0;){let e=$.shift(),N=this._modules2[e];N&&(b=N.onDependencyError(g)||b);let R=this._inverseDependencies2[e];if(R)for(let L=0,d=R.length;L<d;L++){let a=R[L];A[a]||($.push(a),A[a]=!0)}}b||this._config.onError(g)}_hasDependencyPath(l,s){let g=this._modules2[l];if(!g)return!1;let A=[];for(let $=0,e=this._moduleIdProvider.getMaxModuleId();$<e;$++)A[$]=!1;let b=[];for(b.push(g),A[l]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let N=0,R=e.length;N<R;N++){let L=e[N];if(L.id===s)return!0;let d=this._modules2[L.id];d&&!A[L.id]&&(A[L.id]=!0,b.push(d))}}return!1}_findCyclePath(l,s,g){if(l===s||g===50)return[l];let A=this._modules2[l];if(!A)return null;let b=A.dependencies;if(b)for(let $=0,e=b.length;$<e;$++){let N=this._findCyclePath(b[$].id,s,g+1);if(N!==null)return N.push(l),N}return null}_createRequire(l){let s=(g,A,b)=>this._relativeRequire(l,g,A,b);return s.toUrl=g=>this._config.requireToUrl(l.resolveModule(g)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(g,A=!1)=>{this.configure(g,A)},s.__$__nodeRequire=V.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),g=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&g.push("node|"+s);let b=-1,$=e=>{if(b++,b>=g.length)this._onLoadError(l,e);else{let N=g[b],R=this.getRecorder();if(this._config.isBuild()&&N==="empty:"){this._buildInfoPath[l]=N,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}R.record(10,N),this._scriptLoader.load(this,N,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=N),R.record(11,N),this._onLoad(l)},L=>{R.record(12,N),$(L)})}};$(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let g=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};g.error=A=>{this._config.onError(this._createLoadError(s.id,A))},l.load(s.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let g=0,A=s.length;g<A;g++){let b=s[g];if(b===r.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===r.MODULE){l.unresolvedDependenciesCount--;continue}if(b===r.REQUIRE){l.unresolvedDependenciesCount--;continue}let $=this._modules2[b.id];if($&&$.isComplete()){if($.error){l.onDependencyError($.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,l.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(N=>this._moduleIdProvider.getStrModuleId(N)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof f){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let N=this._inversePluginDependencies2.get(b.pluginId);N||(N=[],this._inversePluginDependencies2.set(b.pluginId,N)),N.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let g=l.dependencies,A=[];if(g)for(let N=0,R=g.length;N<R;N++){let L=g[N];if(L===r.EXPORTS){A[N]=l.exports;continue}if(L===r.MODULE){A[N]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(L===r.REQUIRE){A[N]=this._createRequire(l.moduleIdResolver);continue}let d=this._modules2[L.id];if(d){A[N]=d.exports;continue}A[N]=null}const b=N=>(this._inverseDependencies2[N]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));l.complete(s,this._config,A,b);let $=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,$)for(let N=0,R=$.length;N<R;N++){let L=$[N],d=this._modules2[L];d.unresolvedDependenciesCount--,d.unresolvedDependenciesCount===0&&this._onModuleComplete(d)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let N=0,R=e.length;N<R;N++)this._loadPluginDependency(l.exports,e[N])}}}V.ModuleManager=v})(he||(he={}));var ne,he;(function(V){const t=new V.Environment;let _=null;const k=function(h,l,s){typeof h!="string"&&(s=l,l=h,h=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),h?_.defineModule(h,l,s,null,null):_.enqueueDefineAnonymousModule(l,s)};k.amd={jQuery:!0};const r=function(h,l=!1){_.configure(h,l)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return _.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){_.defineModule(V.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=r,f.getConfig=function(){return _.getConfig().getOptionsLiteral()},f.reset=function(){_=_.reset()},f.getBuildInfo=function(){return _.getBuildInfo()},f.getStats=function(){return _.getLoaderEvents()},f.define=k;function v(){if(typeof V.global.require<"u"||typeof require<"u"){const h=V.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const l=V.ensureRecordedNodeRequire(_.getRecorder(),h);V.global.nodeRequire=l,f.nodeRequire=l,f.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(V.global.define=k),V.global.require=f)}V.init=v,(typeof V.global.define!="function"||!V.global.define.amd)&&(_=new V.ModuleManager(t,V.createScriptLoader(t),k,f,V.Utilities.getHighPerformanceTimestamp()),typeof V.global.require<"u"&&typeof V.global.require!="function"&&f.config(V.global.require),ne=function(){return k.apply(null,arguments)},ne.amd=k.amd,typeof doNotInitLoader>"u"&&v())})(he||(he={})),ne(re[66],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function _(h,l,s,g){if(g=g||{},(g["vs/css"]||{}).disabled){s({});return}const b=l.toUrl(h+".css");k(h,b,()=>{s({})},$=>{typeof s.error=="function"&&s.error("Could not find "+b+".")})}t.load=_;function k(h,l,s,g){if(r(h,l)){s();return}f(h,l,s,g)}function r(h,l){const s=window.document.getElementsByTagName("link");for(let g=0,A=s.length;g<A;g++){const b=s[g].getAttribute("data-name"),$=s[g].getAttribute("href");if(b===h||$===l)return!0}return!1}function f(h,l,s,g){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",h),v(h,A,s,g),A.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(A)}function v(h,l,s,g){const A=()=>{l.removeEventListener("load",b),l.removeEventListener("error",$)},b=e=>{A(),s()},$=e=>{A(),g(e)};l.addEventListener("load",b),l.addEventListener("error",$)}}),ne("vs/nls",["require","exports"],function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let _=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const k="i-default";function r(R,L){let d;return L.length===0?d=R:d=R.replace(/\{(\d+)\}/g,(a,o)=>{const u=o[0],i=L[u];let c=a;return typeof i=="string"?c=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(c=String(i)),c}),_&&(d="\uFF3B"+d.replace(/[aouei]/g,"$&$&")+"\uFF3D"),d}function f(R,L){let d=R[L];return d||(d=R["*"],d)?d:null}function v(R){return R.charAt(R.length-1)==="/"?R:R+"/"}async function h(R,L,d){const a=v(R)+v(L)+"vscode/"+v(d),o=await fetch(a);if(o.ok)return await o.json();throw new Error(`${o.status} - ${o.statusText}`)}function l(R){return function(L,d){const a=Array.prototype.slice.call(arguments,2);return r(R[L],a)}}function s(R){return(L,d,...a)=>({value:r(R[L],a),original:r(d,a)})}function g(R,L,...d){return r(L,d)}t.localize=g;function A(R,L,...d){const a=r(L,d);return{value:a,original:a}}t.localize2=A;function b(R){}t.getConfiguredDefaultLocale=b;function $(R){_=R}t.setPseudoTranslation=$;function e(R,L){return{localize:l(L[R]),localize2:s(L[R]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??(d=>{})}}t.create=e;function N(R,L,d,a){const o=a["vs/nls"]??{};if(!R||R.length===0)return d({localize:g,localize2:A,getConfiguredDefaultLocale:()=>o.availableLanguages?.["*"]});const u=o.availableLanguages?f(o.availableLanguages,R):null,i=u===null||u===k;let c=".nls";i||(c=c+"."+u);const E=m=>{Array.isArray(m)?(m.localize=l(m),m.localize2=s(m)):(m.localize=l(m[R]),m.localize2=s(m[R])),m.getConfiguredDefaultLocale=()=>o.availableLanguages?.["*"],d(m)};typeof o.loadBundle=="function"?o.loadBundle(R,u,(m,w)=>{m?L([R+".nls"],E):E(w)}):o.translationServiceUrl&&!i?(async()=>{try{const m=await h(o.translationServiceUrl,u,R);return E(m)}catch(m){if(!u.includes("-"))return console.error(m),L([R+".nls"],E);try{const w=u.split("-")[0],p=await h(o.translationServiceUrl,w,R);return o.availableLanguages??(o.availableLanguages={}),o.availableLanguages["*"]=w,E(p)}catch(w){return console.error(w),L([R+".nls"],E)}}})():L([R+c],E,m=>{if(c===".nls"){console.error("Failed trying to load default language strings",m);return}console.error(`Failed to load message bundle for language ${u}. Falling back to the default language:`,m),L([R+".nls"],E)})}t.load=N}),function(){const V=globalThis.MonacoEnvironment,t=V&&V.baseUrl?V.baseUrl:"../../../";function _(g,A){if(V?.createTrustedTypesPolicy)try{return V.createTrustedTypesPolicy(g,A)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(g,A)}catch(b){console.warn(b);return}}const k=_("amdLoader",{createScriptURL:g=>g,createScript:(g,...A)=>{const b=A.slice(0,-1).join(","),$=A.pop().toString();return`(function anonymous(${b}) { ${$}
})`}});function r(){try{return(k?globalThis.eval(k.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((g,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(k?globalThis.eval(k.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,A);return}k?importScripts(k.createScriptURL(b)):importScripts(b),g()})}function v(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:k,amdModulesPattern:/^vs\//})}function h(g){f().then(()=>{v(),require([g],function(A){setTimeout(function(){const b=A.create(($,e)=>{globalThis.postMessage($,e)},null);for(globalThis.onmessage=$=>b.onmessage($.data,$.ports);s.length>0;){const $=s.shift();b.onmessage($.data,$.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&v();let l=!0;const s=[];globalThis.onmessage=g=>{if(!l){s.push(g);return}l=!1,h(g.data)}}(),ne(re[9],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function _(N,R,L){const d=k(N,R);if(d!==-1)return N[d]}t.$fb=_;function k(N,R,L=N.length-1){for(let d=L;d>=0;d--){const a=N[d];if(R(a))return d}return-1}t.$gb=k;function r(N,R){const L=f(N,R);return L===-1?void 0:N[L]}t.$hb=r;function f(N,R,L=0,d=N.length){let a=L,o=d;for(;a<o;){const u=Math.floor((a+o)/2);R(N[u])?a=u+1:o=u}return a-1}t.$ib=f;function v(N,R){const L=h(N,R);return L===N.length?void 0:N[L]}t.$jb=v;function h(N,R,L=0,d=N.length){let a=L,o=d;for(;a<o;){const u=Math.floor((a+o)/2);R(N[u])?o=u:a=u+1}return a}t.$kb=h;function l(N,R,L=0,d=N.length){const a=h(N,R,L,d);return a===N.length?-1:a}t.$lb=l;class s{constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!R(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const L=f(this.e,R,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$mb=s,s.assertInvariants=!1;function g(N,R){if(N.length===0)return;let L=N[0];for(let d=1;d<N.length;d++){const a=N[d];R(a,L)>0&&(L=a)}return L}t.$nb=g;function A(N,R){if(N.length===0)return;let L=N[0];for(let d=1;d<N.length;d++){const a=N[d];R(a,L)>=0&&(L=a)}return L}t.$ob=A;function b(N,R){return g(N,(L,d)=>-R(L,d))}t.$pb=b;function $(N,R){if(N.length===0)return-1;let L=0;for(let d=1;d<N.length;d++){const a=N[d];R(a,N[L])>0&&(L=d)}return L}t.$qb=$;function e(N,R){for(const L of N){const d=R(L);if(d!==void 0)return d}}t.$rb=e}),ne(re[34],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=void 0;function _(v,h){const l=Object.create(null);for(const s of v){const g=h(s);let A=l[g];A||(A=l[g]=[]),A.push(s)}return l}t.$E=_;function k(v,h){const l=[],s=[];for(const g of v)h.has(g)||l.push(g);for(const g of h)v.has(g)||s.push(g);return{removed:l,added:s}}t.$F=k;function r(v,h){const l=[],s=[];for(const[g,A]of v)h.has(g)||l.push(A);for(const[g,A]of h)v.has(g)||s.push(A);return{removed:l,added:s}}t.$G=r;function f(v,h){const l=new Set;for(const s of h)v.has(s)&&l.add(s);return l}t.$H=f}),ne(re[35],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=t.$$s=t.$0s=t.$9s=void 0;function _(h,l){const s=Math.pow(10,l);return Math.round(h*s)/s}class k{constructor(l,s,g,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=_(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}t.$9s=k;class r{constructor(l,s,g,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.l=_(Math.max(Math.min(1,g),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,b=l.a,$=Math.max(s,g,A),e=Math.min(s,g,A);let N=0,R=0;const L=(e+$)/2,d=$-e;if(d>0){switch(R=Math.min(L<=.5?d/(2*L):d/(2-2*L),1),$){case s:N=(g-A)/d+(g<A?6:0);break;case g:N=(A-s)/d+2;break;case A:N=(s-g)/d+4;break}N*=60,N=Math.round(N)}return new r(N,R,L,b)}static i(l,s,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?l+(s-l)*6*g:g<1/2?s:g<2/3?l+(s-l)*(2/3-g)*6:l}static toRGBA(l){const s=l.h/360,{s:g,l:A,a:b}=l;let $,e,N;if(g===0)$=e=N=A;else{const R=A<.5?A*(1+g):A+g-A*g,L=2*A-R;$=r.i(L,R,s+1/3),e=r.i(L,R,s),N=r.i(L,R,s-1/3)}return new k(Math.round($*255),Math.round(e*255),Math.round(N*255),b)}}t.$0s=r;class f{constructor(l,s,g,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.v=_(Math.max(Math.min(1,g),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,b=Math.max(s,g,A),$=Math.min(s,g,A),e=b-$,N=b===0?0:e/b;let R;return e===0?R=0:b===s?R=((g-A)/e%6+6)%6:b===g?R=(A-s)/e+2:R=(s-g)/e+4,new f(Math.round(R*60),N,b,l.a)}static toRGBA(l){const{h:s,s:g,v:A,a:b}=l,$=A*g,e=$*(1-Math.abs(s/60%2-1)),N=A-$;let[R,L,d]=[0,0,0];return s<60?(R=$,L=e):s<120?(R=e,L=$):s<180?(L=$,d=e):s<240?(L=e,d=$):s<300?(R=e,d=$):s<=360&&(R=$,d=e),R=Math.round((R+N)*255),L=Math.round((L+N)*255),d=Math.round((d+N)*255),new k(R,L,d,b)}}t.$$s=f;class v{static fromHex(l){return v.Format.CSS.parseHex(l)||v.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:f.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof k)this.rgba=l;else if(l instanceof r)this.i=l,this.rgba=r.toRGBA(l);else if(l instanceof f)this.j=l,this.rgba=f.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&k.equals(this.rgba,l.rgba)&&r.equals(this.hsla,l.hsla)&&f.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=v.k(this.rgba.r),s=v.k(this.rgba.g),g=v.k(this.rgba.b),A=.2126*l+.7152*s+.0722*g;return _(A,4)}static k(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g?(s+.05)/(g+.05):(g+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g}isDarkerThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s<g}lighten(l){return new v(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new v(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g,b:A,a:b}=this.rgba;return new v(new k(s,g,A,b*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const s=l.rgba,g=this.rgba.a,A=s.a,b=g+A*(1-g);if(b<1e-6)return v.transparent;const $=this.rgba.r*g/b+s.r*A*(1-g)/b,e=this.rgba.g*g/b+s.g*A*(1-g)/b,N=this.rgba.b*g/b+s.b*A*(1-g)/b;return new v(new k($,e,N,b))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g,b:A,a:b}=this.rgba;return new v(new k(l.rgba.r-b*(l.rgba.r-s),l.rgba.g-b*(l.rgba.g-g),l.rgba.b-b*(l.rgba.b-A),1))}flatten(...l){const s=l.reduceRight((g,A)=>v.o(A,g));return v.o(this,s)}static o(l,s){const g=1-l.rgba.a;return new v(new k(g*s.rgba.r+l.rgba.a*l.rgba.r,g*s.rgba.g+l.rgba.a*l.rgba.g,g*s.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(l,s,g){if(l.isLighterThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),b=s.getRelativeLuminance();return g=g*(b-A)/b,l.lighten(g)}static getDarkerColor(l,s,g){if(l.isDarkerThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),b=s.getRelativeLuminance();return g=g*(A-b)/A,l.darken(g)}}t.$_s=v,v.white=new v(new k(255,255,255,1)),v.black=new v(new k(0,0,0,1)),v.red=new v(new k(255,0,0,1)),v.blue=new v(new k(0,0,255,1)),v.green=new v(new k(0,255,0,1)),v.cyan=new v(new k(0,255,255,1)),v.lightgrey=new v(new k(211,211,211,1)),v.transparent=new v(new k(0,0,0,0)),function(h){let l;(function(s){let g;(function(A){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:h.Format.CSS.formatRGBA(i)}A.formatRGB=b;function $(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}A.formatRGBA=$;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(i)}A.formatHSL=e;function N(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}A.formatHSLA=N;function R(i){const c=i.toString(16);return c.length!==2?"0"+c:c}function L(i){return`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}`}A.formatHex=L;function d(i,c=!1){return c&&i.rgba.a===1?h.Format.CSS.formatHex(i):`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}${R(Math.round(i.rgba.a*255))}`}A.formatHexA=d;function a(i){return i.isOpaque()?h.Format.CSS.formatHex(i):h.Format.CSS.formatRGBA(i)}A.format=a;function o(i){const c=i.length;if(c===0||i.charCodeAt(0)!==35)return null;if(c===7){const E=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),m=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),w=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new h(new k(E,m,w,1))}if(c===9){const E=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),m=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),w=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),p=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new h(new k(E,m,w,p/255))}if(c===4){const E=u(i.charCodeAt(1)),m=u(i.charCodeAt(2)),w=u(i.charCodeAt(3));return new h(new k(16*E+E,16*m+m,16*w+w))}if(c===5){const E=u(i.charCodeAt(1)),m=u(i.charCodeAt(2)),w=u(i.charCodeAt(3)),p=u(i.charCodeAt(4));return new h(new k(16*E+E,16*m+m,16*w+w,(16*p+p)/255))}return null}A.parseHex=o;function u(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=s.CSS||(s.CSS={}))})(l=h.Format||(h.Format={}))}(v||(t.$_s=v={}))}),ne(re[36],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ks=void 0;class _{constructor(r,f,v,h){this.originalStart=r,this.originalLength=f,this.modifiedStart=v,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Ks=_}),ne(re[3],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class _{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(c=>{c(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$W=_,t.$X=new _;function k(u){t.$X.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=k;function r(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$Z=r;function f(u){s(u)||t.$X.onUnexpectedError(u)}t.$1=f;function v(u){s(u)||t.$X.onUnexpectedExternalError(u)}t.$2=v;function h(u){if(u instanceof Error){const{name:i,message:c}=u,E=u.stacktrace||u.stack;return{$isError:!0,name:i,message:c,stack:E,noTelemetry:a.isErrorNoTelemetry(u)}}return u}t.$3=h;const l="Canceled";function s(u){return u instanceof g?!0:u instanceof Error&&u.name===l&&u.message===l}t.$4=s;class g extends Error{constructor(){super(l),this.name=this.message}}t.$5=g;function A(){const u=new Error(l);return u.name=u.message,u}t.$6=A;function b(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$7=b;function $(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$8=$;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function N(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$0=N;class R extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$$=R;class L extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$_=L;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=d;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const c=new a;return c.message=i.message,c.stack=i.stack,c}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$bb=a;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.$cb=o}),ne(re[6],se([0,1,3,9]),function(V,t,_,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function r(U,C=0){return U[U.length-(1+C)]}t.$sb=r;function f(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$tb=f;function v(U,C,W=(Q,K)=>Q===K){if(U===C)return!0;if(!U||!C||U.length!==C.length)return!1;for(let Q=0,K=U.length;Q<K;Q++)if(!W(U[Q],C[Q]))return!1;return!0}t.$ub=v;function h(U,C){const W=U.length-1;C<W&&(U[C]=U[W]),U.pop()}t.$vb=h;function l(U,C,W){return s(U.length,Q=>W(U[Q],C))}t.$wb=l;function s(U,C){let W=0,Q=U-1;for(;W<=Q;){const K=(W+Q)/2|0,G=C(K);if(G<0)W=K+1;else if(G>0)Q=K-1;else return K}return-(W+1)}t.$xb=s;function g(U,C,W){if(U=U|0,U>=C.length)throw new TypeError("invalid index");const Q=C[Math.floor(C.length*Math.random())],K=[],G=[],Z=[];for(const ee of C){const Y=W(ee,Q);Y<0?K.push(ee):Y>0?G.push(ee):Z.push(ee)}return U<K.length?g(U,K,W):U<K.length+Z.length?Z[0]:g(U-(K.length+Z.length),G,W)}t.$yb=g;function A(U,C){const W=[];let Q;for(const K of U.slice(0).sort(C))!Q||C(Q[0],K)!==0?(Q=[K],W.push(Q)):Q.push(K);return W}t.$zb=A;function*b(U,C){let W,Q;for(const K of U)Q!==void 0&&C(Q,K)?W.push(K):(W&&(yield W),W=[K]),Q=K;W&&(yield W)}t.$Ab=b;function $(U,C){for(let W=0;W<=U.length;W++)C(W===0?void 0:U[W-1],W===U.length?void 0:U[W])}t.$Bb=$;function e(U,C){for(let W=0;W<U.length;W++)C(W===0?void 0:U[W-1],U[W],W+1===U.length?void 0:U[W+1])}t.$Cb=e;function N(U,C,W){const Q=[];function K(ee,Y,ie){if(Y===0&&ie.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===ee?(le.deleteCount+=Y,le.toInsert.push(...ie)):Q.push({start:ee,deleteCount:Y,toInsert:ie})}let G=0,Z=0;for(;;){if(G===U.length){K(G,0,C.slice(Z));break}if(Z===C.length){K(G,U.length-G,[]);break}const ee=U[G],Y=C[Z],ie=W(ee,Y);ie===0?(G+=1,Z+=1):ie<0?(K(G,1,[]),G+=1):ie>0&&(K(G,0,[Y]),Z+=1)}return Q}t.$Db=N;function R(U,C,W){const Q=N(U,C,W),K=[],G=[];for(const Z of Q)K.push(...U.slice(Z.start,Z.start+Z.deleteCount)),G.push(...Z.toInsert);return{removed:K,added:G}}t.$Eb=R;function L(U,C,W){if(W===0)return[];const Q=U.slice(0,W).sort(C);return a(U,C,Q,W,U.length),Q}t.top=L;function d(U,C,W,Q,K){return W===0?Promise.resolve([]):new Promise((G,Z)=>{(async()=>{const ee=U.length,Y=U.slice(0,W).sort(C);for(let ie=W,le=Math.min(W+Q,ee);ie<ee;ie=le,le=Math.min(le+Q,ee)){if(ie>W&&await new Promise(oe=>setTimeout(oe)),K&&K.isCancellationRequested)throw new _.$5;a(U,C,Y,ie,le)}return Y})().then(G,Z)})}t.$Gb=d;function a(U,C,W,Q,K){for(const G=W.length;Q<K;Q++){const Z=U[Q];if(C(Z,W[G-1])<0){W.pop();const ee=(0,k.$kb)(W,Y=>C(Z,Y)<0);W.splice(ee,0,Z)}}}function o(U){return U.filter(C=>!!C)}t.$Hb=o;function u(U){let C=0;for(let W=0;W<U.length;W++)U[W]&&(U[C]=U[W],C+=1);U.length=C}t.$Ib=u;function i(U,C,W){U.splice(W,0,U.splice(C,1)[0])}t.$Jb=i;function c(U){return!Array.isArray(U)||U.length===0}t.$Kb=c;function E(U){return Array.isArray(U)&&U.length>0}t.$Lb=E;function m(U,C=W=>W){const W=new Set;return U.filter(Q=>{const K=C(Q);return W.has(K)?!1:(W.add(K),!0)})}t.$Mb=m;function w(U){const C=new Set;return W=>{const Q=U(W);return C.has(Q)?!1:(C.add(Q),!0)}}t.$Nb=w;function p(U,C){return U.length>0?U[0]:C}t.$Ob=p;function M(U,C){return U.length>0?U[U.length-1]:C}t.$Pb=M;function F(U,C,W=(Q,K)=>Q===K){let Q=0;for(let K=0,G=Math.min(U.length,C.length);K<G&&W(U[K],C[K]);K++)Q++;return Q}t.$Qb=F;function y(U){return[].concat(...U)}t.$Rb=y;function P(U,C){let W=typeof C=="number"?U:0;typeof C=="number"?W=U:(W=0,C=U);const Q=[];if(W<=C)for(let K=W;K<C;K++)Q.push(K);else for(let K=W;K>C;K--)Q.push(K);return Q}t.$Sb=P;function S(U,C,W){return U.reduce((Q,K)=>(Q[C(K)]=W?W(K):K,Q),Object.create(null))}t.$Tb=S;function T(U,C){return U.push(C),()=>q(U,C)}t.$Ub=T;function q(U,C){const W=U.indexOf(C);if(W>-1)return U.splice(W,1),C}t.$Vb=q;function O(U,C,W){const Q=U.slice(0,C),K=U.slice(C);return Q.concat(W,K)}t.$Wb=O;function D(U,C){let W;if(typeof C=="number"){let Q=C;W=()=>{const K=Math.sin(Q++)*179426549;return K-Math.floor(K)}}else W=Math.random;for(let Q=U.length-1;Q>0;Q-=1){const K=Math.floor(W()*(Q+1)),G=U[Q];U[Q]=U[K],U[K]=G}}t.$Xb=D;function j(U,C){const W=U.indexOf(C);W>-1&&(U.splice(W,1),U.unshift(C))}t.$Yb=j;function z(U,C){const W=U.indexOf(C);W>-1&&(U.splice(W,1),U.push(C))}t.$Zb=z;function x(U,C){for(const W of C)U.push(W)}t.$1b=x;function J(U,C){return Array.isArray(U)?U.map(C):C(U)}t.$2b=J;function te(U){return Array.isArray(U)?U:[U]}t.$3b=te;function n(U){return U[Math.floor(Math.random()*U.length)]}t.$4b=n;function ae(U,C,W){const Q=$e(U,C),K=U.length,G=W.length;U.length=K+G;for(let Z=K-1;Z>=Q;Z--)U[Z+G]=U[Z];for(let Z=0;Z<G;Z++)U[Z+Q]=W[Z]}t.$5b=ae;function de(U,C,W,Q){const K=$e(U,C);let G=U.splice(K,W);return G===void 0&&(G=[]),ae(U,K,Q),G}t.$6b=de;function $e(U,C){return C<0?Math.max(C+U.length,0):Math.min(C,U.length)}var ve;(function(U){function C(G){return G<0}U.isLessThan=C;function W(G){return G<=0}U.isLessThanOrEqual=W;function Q(G){return G>0}U.isGreaterThan=Q;function K(G){return G===0}U.isNeitherLessOrGreaterThan=K,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function Me(U,C){return(W,Q)=>C(U(W),U(Q))}t.$7b=Me;function we(...U){return(C,W)=>{for(const Q of U){const K=Q(C,W);if(!ve.isNeitherLessOrGreaterThan(K))return K}return ve.neitherLessOrGreaterThan}}t.$8b=we;const pe=(U,C)=>U-C;t.$9b=pe;const Te=(U,C)=>(0,t.$9b)(U?1:0,C?1:0);t.$0b=Te;function Se(U){return(C,W)=>-U(C,W)}t.$$b=Se;class Ie{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let W=this.c;for(;W<this.g.length&&C(this.g[W]);)W++;const Q=W===this.c?null:this.g.slice(this.c,W);return this.c=W,Q}takeFromEndWhile(C){let W=this.d;for(;W>=0&&C(this.g[W]);)W--;const Q=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const W=this.g.slice(this.c,this.c+C);return this.c+=C,W}}t.$_b=Ie;class Ee{constructor(C){this.iterate=C}forEach(C){this.iterate(W=>(C(W),!0))}toArray(){const C=[];return this.iterate(W=>(C.push(W),!0)),C}filter(C){return new Ee(W=>this.iterate(Q=>C(Q)?W(Q):!0))}map(C){return new Ee(W=>this.iterate(Q=>W(C(Q))))}some(C){let W=!1;return this.iterate(Q=>(W=C(Q),!W)),W}findFirst(C){let W;return this.iterate(Q=>C(Q)?(W=Q,!1):!0),W}findLast(C){let W;return this.iterate(Q=>(C(Q)&&(W=Q),!0)),W}findLastMaxBy(C){let W,Q=!0;return this.iterate(K=>((Q||ve.isGreaterThan(C(K,W)))&&(Q=!1,W=K),!0)),W}}t.$ac=Ee,Ee.empty=new Ee(U=>{})}),ne(re[13],se([0,1,3]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8c=t.$7c=t.$6c=t.$5c=t.ok=void 0;function k(l,s){if(!l)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=k;function r(l,s="Unreachable"){throw new Error(s)}t.$5c=r;function f(l){if(!l)throw new _.$cb("Assertion Failed")}t.$6c=f;function v(l){if(!l()){debugger;l(),(0,_.$1)(new _.$cb("Assertion Failed"))}}t.$7c=v;function h(l,s){let g=0;for(;g<l.length-1;){const A=l[g],b=l[g+1];if(!s(A,b))return!1;g++}return!0}t.$8c=h}),ne(re[19],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function _(k,r){const f=this;let v=!1,h;return function(){if(v)return h;if(v=!0,r)try{h=k.apply(f,arguments)}finally{r()}else h=k.apply(f,arguments);return h}}t.$db=_}),ne(re[20],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var _;(function(k){function r(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}k.is=r;const f=Object.freeze([]);function v(){return f}k.empty=v;function*h(u){yield u}k.single=h;function l(u){return r(u)?u:h(u)}k.wrap=l;function s(u){return u||f}k.from=s;function*g(u){for(let i=u.length-1;i>=0;i--)yield u[i]}k.reverse=g;function A(u){return!u||u[Symbol.iterator]().next().done===!0}k.isEmpty=A;function b(u){return u[Symbol.iterator]().next().value}k.first=b;function $(u,i){for(const c of u)if(i(c))return!0;return!1}k.some=$;function e(u,i){for(const c of u)if(i(c))return c}k.find=e;function*N(u,i){for(const c of u)i(c)&&(yield c)}k.filter=N;function*R(u,i){let c=0;for(const E of u)yield i(E,c++)}k.map=R;function*L(...u){for(const i of u)yield*i}k.concat=L;function d(u,i,c){let E=c;for(const m of u)E=i(E,m);return E}k.reduce=d;function*a(u,i,c=u.length){for(i<0&&(i+=u.length),c<0?c+=u.length:c>u.length&&(c=u.length);i<c;i++)yield u[i]}k.slice=a;function o(u,i=Number.POSITIVE_INFINITY){const c=[];if(i===0)return[c,u];const E=u[Symbol.iterator]();for(let m=0;m<i;m++){const w=E.next();if(w.done)return[c,k.empty()];c.push(w.value)}return[c,{[Symbol.iterator](){return E}}]}k.consume=o})(_||(t.Iterable=_={}))}),ne(re[37],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tq=t.KeyMod=t.KeyCodeUtils=t.$Sq=t.$Rq=t.$Qq=t.$Pq=t.$Oq=t.ScanCode=t.KeyCode=void 0;var _;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(_||(t.KeyCode=_={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k||(t.ScanCode=k={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,R){this._keyCodeToStr[N]=R,this._strToKeyCode[R.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const f=new r,v=new r,h=new r;t.$Oq=new Array(230),t.$Pq={};const l=[],s=Object.create(null),g=Object.create(null);t.$Qq={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>s[e]||0,toString:e=>l[e]||"None"},t.$Rq=[],t.$Sq=[];for(let e=0;e<=193;e++)t.$Rq[e]=-1;for(let e=0;e<=132;e++)t.$Sq[e]=-1;(function(){const e="",N=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],L=[];for(const d of N){const[a,o,u,i,c,E,m,w,p]=d;if(L[o]||(L[o]=!0,l[o]=u,s[u]=o,g[u.toLowerCase()]=o,a&&(t.$Rq[o]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$Sq[i]=o))),!R[i]){if(R[i]=!0,!c)throw new Error(`String representation missing for key code ${i} around scan code ${u}`);f.define(i,c),v.define(i,w||c),h.define(i,p||w||c)}E&&(t.$Oq[E]=i),m&&(t.$Pq[m]=i)}t.$Sq[3]=46})();var A;(function(e){function N(u){return f.keyCodeToStr(u)}e.toString=N;function R(u){return f.strToKeyCode(u)}e.fromString=R;function L(u){return v.keyCodeToStr(u)}e.toUserSettingsUS=L;function d(u){return h.keyCodeToStr(u)}e.toUserSettingsGeneral=d;function a(u){return v.strToKeyCode(u)||h.strToKeyCode(u)}e.fromUserSettings=a;function o(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(u)}e.toElectronAccelerator=o})(A||(t.KeyCodeUtils=A={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function $(e,N){const R=(N&65535)<<16>>>0;return(e|R)>>>0}t.$Tq=$}),ne(re[38],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class _{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=_}),ne(re[21],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=void 0;class _{constructor(f){this.element=f,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class k{constructor(){this.a=_.Undefined,this.b=_.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===_.Undefined}clear(){let f=this.a;for(;f!==_.Undefined;){const v=f.next;f.prev=_.Undefined,f.next=_.Undefined,f=v}this.a=_.Undefined,this.b=_.Undefined,this.c=0}unshift(f){return this.d(f,!1)}push(f){return this.d(f,!0)}d(f,v){const h=new _(f);if(this.a===_.Undefined)this.a=h,this.b=h;else if(v){const s=this.b;this.b=h,h.prev=s,s.next=h}else{const s=this.a;this.a=h,h.next=s,s.prev=h}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(h))}}shift(){if(this.a!==_.Undefined){const f=this.a.element;return this.e(this.a),f}}pop(){if(this.b!==_.Undefined){const f=this.b.element;return this.e(this.b),f}}e(f){if(f.prev!==_.Undefined&&f.next!==_.Undefined){const v=f.prev;v.next=f.next,f.next.prev=v}else f.prev===_.Undefined&&f.next===_.Undefined?(this.a=_.Undefined,this.b=_.Undefined):f.next===_.Undefined?(this.b=this.b.prev,this.b.next=_.Undefined):f.prev===_.Undefined&&(this.a=this.a.next,this.a.prev=_.Undefined);this.c-=1}*[Symbol.iterator](){let f=this.a;for(;f!==_.Undefined;)yield f.element,f=f.next}}t.$3c=k}),ne(re[22],se([0,1]),function(V,t){"use strict";var _,k,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function f(d,a,o){let u=d.get(a);return u===void 0&&(u=o,d.set(a,u)),u}t.$xc=f;function v(d){const a=[];return d.forEach((o,u)=>{a.push(`${u} => ${o}`)}),`Map(${d.size}) {${a.join(", ")}}`}t.$yc=v;function h(d){const a=[];return d.forEach(o=>{a.push(o)}),`Set(${d.size}) {${a.join(", ")}}`}t.$zc=h;class l{constructor(a,o){this.uri=a,this.value=o}}function s(d){return Array.isArray(d)}class g{constructor(a,o){if(this[_]="ResourceMap",a instanceof g)this.b=new Map(a.b),this.c=o??g.a;else if(s(a)){this.b=new Map,this.c=o??g.a;for(const[u,i]of a)this.set(u,i)}else this.b=new Map,this.c=a??g.a}set(a,o){return this.b.set(this.c(a),new l(a,o)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,o){typeof o<"u"&&(a=a.bind(o));for(const[u,i]of this.b)a(i.value,i.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}t.$Ac=g,g.a=d=>d.toString();class A{constructor(a,o){this[k]="ResourceSet",!a||typeof a=="function"?this.a=new g(a):(this.a=new g(o),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,o){this.a.forEach((u,i)=>a.call(o,i,i,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=A;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class ${constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,o=0){const u=this.a.get(a);if(u)return o!==0&&this.j(u,o),u.value}set(a,o,u=0){let i=this.a.get(a);if(i)i.value=o,u!==0&&this.j(i,u);else{switch(i={key:a,value:o,next:void 0,previous:void 0},u){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(a,i),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const o=this.a.get(a);if(o)return this.a.delete(a),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,o){const u=this.e;let i=this.b;for(;i;){if(o?a.bind(o)(i.value,i.key,this):a(i.value,i.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const a=this,o=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.key,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return i}values(){const a=this,o=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.value,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return i}entries(){const a=this,o=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:[u.key,u.value],done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let o=this.b,u=this.size;for(;o&&u>a;)this.a.delete(o.key),o=o.next,u--;this.b=o,this.d=u,o&&(o.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const o=a.next,u=a.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}a.next=void 0,a.previous=void 0,this.e++}j(a,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(a===this.b)return;const u=a.next,i=a.previous;a===this.c?(i.next=void 0,this.c=i):(u.previous=i,i.next=u),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(o===2){if(a===this.c)return;const u=a.next,i=a.previous;a===this.b?(u.previous=void 0,this.b=u):(u.previous=i,i.next=u),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((o,u)=>{a.push([u,o])}),a}fromJSON(a){this.clear();for(const[o,u]of a)this.set(o,u)}}t.$Cc=$;class e extends ${constructor(a,o=1){super(),this.k=a,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,o=2){return super.get(a,o)}peek(a){return super.get(a,0)}set(a,o){return super.set(a,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Dc=e;class N{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let o=this.a.get(a)||0;return o===0?!1:(o--,o===0?this.a.delete(a):this.a.set(a,o),!0)}has(a){return this.a.has(a)}}t.$Ec=N;class R{constructor(a){if(this.a=new Map,this.b=new Map,a)for(const[o,u]of a)this.set(o,u)}clear(){this.a.clear(),this.b.clear()}set(a,o){this.a.set(a,o),this.b.set(o,a)}get(a){return this.a.get(a)}getKey(a){return this.b.get(a)}delete(a){const o=this.a.get(a);return o===void 0?!1:(this.a.delete(a),this.b.delete(o),!0)}forEach(a,o){this.a.forEach((u,i)=>{a.call(o,u,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Fc=R;class L{constructor(){this.a=new Map}add(a,o){let u=this.a.get(a);u||(u=new Set,this.a.set(a,u)),u.add(o)}delete(a,o){const u=this.a.get(a);u&&(u.delete(o),u.size===0&&this.a.delete(a))}forEach(a,o){const u=this.a.get(a);u&&u.forEach(o)}get(a){const o=this.a.get(a);return o||new Set}}t.$Gc=L}),ne(re[10],se([0,1,6,34,22,19,20]),function(V,t,_,k,r,f,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=void 0;const h=!1;let l=null;class s{constructor(){this.b=new Map}c(T){let q=this.b.get(T);return q||(q={parent:null,source:null,isSingleton:!1,value:T,idx:s.a++},this.b.set(T,q)),q}trackDisposable(T){const q=this.c(T);q.source||(q.source=new Error().stack)}setParent(T,q){const O=this.c(T);O.parent=q}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,q){const O=q.get(T);if(O)return O;const D=T.parent?this.f(this.c(T.parent),q):T;return q.set(T,D),D}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,T).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(T=10,q){let O;if(q)O=q;else{const J=new Map,te=[...this.b.values()].filter(ae=>ae.source!==null&&!this.f(ae,J).isSingleton);if(te.length===0)return;const n=new Set(te.map(ae=>ae.value));if(O=te.filter(ae=>!(ae.parent&&n.has(ae.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function D(J){function te(ae,de){for(;ae.length>0&&de.some($e=>typeof $e=="string"?$e===ae[0]:ae[0].match($e));)ae.shift()}const n=J.source.split(`
`).map(ae=>ae.trim().replace("at ","")).filter(ae=>ae!=="");return te(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const j=new r.$Gc;for(const J of O){const te=D(J);for(let n=0;n<=te.length;n++)j.add(te.slice(0,n).join(`
`),J)}O.sort((0,_.$7b)(J=>J.idx,_.$9b));let z="",x=0;for(const J of O.slice(0,T)){x++;const te=D(J),n=[];for(let ae=0;ae<te.length;ae++){let de=te[ae];de=`(shared with ${j.get(te.slice(0,ae+1).join(`
`)).size}/${O.length} leaks) at ${de}`;const ve=j.get(te.slice(0,ae).join(`
`)),Me=(0,k.$E)([...ve].map(we=>D(we)[ae]),we=>we);delete Me[te[ae]];for(const[we,pe]of Object.entries(Me))n.unshift(`    - stacktraces of ${pe.length} other leaks continue with ${we}`);n.unshift(de)}z+=`


==================== Leaking disposable ${x}/${O.length}: ${J.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return O.length>T&&(z+=`


... and ${O.length-T} more leaking disposables

`),{leaks:O,details:z}}}t.$Hc=s,s.a=0;function g(S){l=S}if(t.$Ic=g,h){const S="__is_disposable_tracked__";g(new class{trackDisposable(T){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[S]||console.log(q)},3e3)}setParent(T,q){if(T&&T!==i.None)try{T[S]=!0}catch{}}markAsDisposed(T){if(T&&T!==i.None)try{T[S]=!0}catch{}}markAsSingleton(T){}})}function A(S){return l?.trackDisposable(S),S}t.$Jc=A;function b(S){l?.markAsDisposed(S)}t.$Kc=b;function $(S,T){l?.setParent(S,T)}function e(S,T){if(l)for(const q of S)l.setParent(q,T)}function N(S){return l?.markAsSingleton(S),S}t.$Lc=N;function R(S){return typeof S.dispose=="function"&&S.dispose.length===0}t.$Mc=R;function L(S){if(v.Iterable.is(S)){const T=[];for(const q of S)if(q)try{q.dispose()}catch(O){T.push(O)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}t.$Nc=L;function d(S){for(const T of S)R(T)&&T.dispose();return[]}t.$Oc=d;function a(...S){const T=o(()=>L(S));return e(S,T),T}t.$Pc=a;function o(S){const T=A({dispose:(0,f.$db)(()=>{b(T),S()})});return T}t.$Qc=o;class u{constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return $(T,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),$(T,null))}}t.$Rc=u,u.DISABLE_DISPOSED_WARNING=!1;class i{constructor(){this.q=new u,A(this),$(this.q,this)}dispose(){b(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}t.$Sc=i,i.None=Object.freeze({dispose(){}});class c{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&$(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&$(T,null),T}}t.$Tc=c;class E{constructor(T){this.a=new c,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}t.$Uc=E;class m{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Vc=m;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(T){let q=T;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,b(this))},this}}t.$Wc=w;class p{constructor(){this.a=new Map}acquire(T,...q){let O=this.a.get(T);O||(O={counter:0,object:this.b(T,...q)},this.a.set(T,O));const{object:D}=O,j=(0,f.$db)(()=>{--O.counter===0&&(this.c(T,O.object),this.a.delete(T))});return O.counter++,{object:D,dispose:j}}}t.$Xc=p;class M{constructor(T){this.a=T}async acquire(T,...q){const O=this.a.acquire(T,...q);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(D){throw O.dispose(),D}}}t.$Yc=M;class F{constructor(T){this.object=T}dispose(){}}t.$Zc=F;function y(S){const T=new u;try{S(T)}finally{T.dispose()}}t.$1c=y;class P{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,q,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(T)?.dispose(),this.a.set(T,q)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$2c=P}),ne(re[14],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$D=t.$C=t.$B=t.$A=t.$z=t.$y=t.$x=t.OS=t.OperatingSystem=t.$v=t.$u=t.$t=t.$s=t.$r=t.Language=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.$g=t.$f=t.$e=t.$d=t.$c=t.$b=t.Platform=t.$a=void 0,t.$a="en";let _=!1,k=!1,r=!1,f=!1,v=!1,h=!1,l=!1,s=!1,g=!1,A=!1,b,$=t.$a,e=t.$a,N,R;const L=globalThis;let d;typeof L.vscode<"u"&&typeof L.vscode.process<"u"?d=L.vscode.process:typeof process<"u"&&(d=process);const a=typeof d?.versions?.electron=="string",o=a&&d?.type==="renderer";if(typeof navigator=="object"&&!o){R=navigator.userAgent,_=R.indexOf("Windows")>=0,k=R.indexOf("Macintosh")>=0,s=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=R.indexOf("Linux")>=0,A=R?.indexOf("Mobi")>=0,h=!0,b=t.$a,$=b,e=navigator.language;const y=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),P=y&&y.getAttribute("data-settings");if(P)try{const S=JSON.parse(P),T=S.availableLanguages["*"];b=S.locale,e=S.osLocale,$=T||t.$a,N=S._translationsConfigFile}catch{}}else if(typeof d=="object"){_=d.platform==="win32",k=d.platform==="darwin",r=d.platform==="linux",f=r&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,l=a,g=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t.$a,$=t.$a;const y=d.env.VSCODE_NLS_CONFIG;if(y)try{const P=JSON.parse(y),S=P.availableLanguages["*"];b=P.locale,e=P.osLocale,$=S||t.$a,N=P._translationsConfigFile}catch{}v=!0}else console.error("Unable to resolve platform.");var u;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(u||(t.Platform=u={}));function i(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$b=i;let c=0;k?c=1:_?c=3:r&&(c=2),t.$c=_,t.$d=k,t.$e=r,t.$f=f,t.$g=v,t.$h=l,t.$i=h,t.$j=h&&typeof L.importScripts=="function",t.$k=t.$j?L.origin:void 0,t.$l=s,t.$m=A,t.$n=g,t.$o=c,t.$p=R,t.$q=$;var E;(function(y){function P(){return t.$q}y.value=P;function S(){return t.$q.length===2?t.$q==="en":t.$q.length>=3?t.$q[0]==="e"&&t.$q[1]==="n"&&t.$q[2]==="-":!1}y.isDefaultVariant=S;function T(){return t.$q==="en"}y.isDefault=T})(E||(t.Language=E={})),t.$r=b,t.$s=e,t.$t=N,t.$u=typeof L.postMessage=="function"&&!L.importScripts,t.$v=(()=>{if(t.$u){const y=[];L.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let T=0,q=y.length;T<q;T++){const O=y[T];if(O.id===S.data.vscodeScheduleAsyncWork){y.splice(T,1),O.callback();return}}});let P=0;return S=>{const T=++P;y.push({id:T,callback:S}),L.postMessage({vscodeScheduleAsyncWork:T},"*")}}return y=>setTimeout(y)})();var m;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(m||(t.OperatingSystem=m={})),t.OS=k||s?2:_?1:3;let w=!0,p=!1;function M(){if(!p){p=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,w=new Uint16Array(y.buffer)[0]===(2<<8)+1}return w}t.$x=M,t.$y=!!(t.$p&&t.$p.indexOf("Chrome")>=0),t.$z=!!(t.$p&&t.$p.indexOf("Firefox")>=0),t.$A=!!(!t.$y&&t.$p&&t.$p.indexOf("Safari")>=0),t.$B=!!(t.$p&&t.$p.indexOf("Edg/")>=0),t.$C=!!(t.$p&&t.$p.indexOf("Android")>=0);function F(y){return parseFloat(y)>=20}t.$D=F}),ne(re[39],se([0,1,14]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let k;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const f=r.process;k={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return _.$c?"win32":_.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.$dc=k.platform,t.$ec=k.arch}),ne(re[40],se([0,1,39]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const k=65,r=97,f=90,v=122,h=46,l=47,s=92,g=58,A=63;class b extends Error{constructor(c,E,m){let w;typeof E=="string"&&E.indexOf("not ")===0?(w="must not be",E=E.replace(/^not /,"")):w="must be";const p=c.indexOf(".")!==-1?"property":"argument";let M=`The "${c}" ${p} ${w} of type ${E}`;M+=`. Received type ${typeof m}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function $(i,c){if(i===null||typeof i!="object")throw new b(c,"Object",i)}function e(i,c){if(typeof i!="string")throw new b(c,"string",i)}const N=_.$dc==="win32";function R(i){return i===l||i===s}function L(i){return i===l}function d(i){return i>=k&&i<=f||i>=r&&i<=v}function a(i,c,E,m){let w="",p=0,M=-1,F=0,y=0;for(let P=0;P<=i.length;++P){if(P<i.length)y=i.charCodeAt(P);else{if(m(y))break;y=l}if(m(y)){if(!(M===P-1||F===1))if(F===2){if(w.length<2||p!==2||w.charCodeAt(w.length-1)!==h||w.charCodeAt(w.length-2)!==h){if(w.length>2){const S=w.lastIndexOf(E);S===-1?(w="",p=0):(w=w.slice(0,S),p=w.length-1-w.lastIndexOf(E)),M=P,F=0;continue}else if(w.length!==0){w="",p=0,M=P,F=0;continue}}c&&(w+=w.length>0?`${E}..`:"..",p=2)}else w.length>0?w+=`${E}${i.slice(M+1,P)}`:w=i.slice(M+1,P),p=P-M-1;M=P,F=0}else y===h&&F!==-1?++F:F=-1}return w}function o(i,c){$(c,"pathObject");const E=c.dir||c.root,m=c.base||`${c.name||""}${c.ext||""}`;return E?E===c.root?`${E}${m}`:`${E}${i}${m}`:m}t.$fc={resolve(...i){let c="",E="",m=!1;for(let w=i.length-1;w>=-1;w--){let p;if(w>=0){if(p=i[w],e(p,"path"),p.length===0)continue}else c.length===0?p=_.cwd():(p=_.env[`=${c}`]||_.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==c.toLowerCase()&&p.charCodeAt(2)===s)&&(p=`${c}\\`));const M=p.length;let F=0,y="",P=!1;const S=p.charCodeAt(0);if(M===1)R(S)&&(F=1,P=!0);else if(R(S))if(P=!0,R(p.charCodeAt(1))){let T=2,q=T;for(;T<M&&!R(p.charCodeAt(T));)T++;if(T<M&&T!==q){const O=p.slice(q,T);for(q=T;T<M&&R(p.charCodeAt(T));)T++;if(T<M&&T!==q){for(q=T;T<M&&!R(p.charCodeAt(T));)T++;(T===M||T!==q)&&(y=`\\\\${O}\\${p.slice(q,T)}`,F=T)}}}else F=1;else d(S)&&p.charCodeAt(1)===g&&(y=p.slice(0,2),F=2,M>2&&R(p.charCodeAt(2))&&(P=!0,F=3));if(y.length>0)if(c.length>0){if(y.toLowerCase()!==c.toLowerCase())continue}else c=y;if(m){if(c.length>0)break}else if(E=`${p.slice(F)}\\${E}`,m=P,P&&c.length>0)break}return E=a(E,!m,"\\",R),m?`${c}\\${E}`:`${c}${E}`||"."},normalize(i){e(i,"path");const c=i.length;if(c===0)return".";let E=0,m,w=!1;const p=i.charCodeAt(0);if(c===1)return L(p)?"\\":i;if(R(p))if(w=!0,R(i.charCodeAt(1))){let F=2,y=F;for(;F<c&&!R(i.charCodeAt(F));)F++;if(F<c&&F!==y){const P=i.slice(y,F);for(y=F;F<c&&R(i.charCodeAt(F));)F++;if(F<c&&F!==y){for(y=F;F<c&&!R(i.charCodeAt(F));)F++;if(F===c)return`\\\\${P}\\${i.slice(y)}\\`;F!==y&&(m=`\\\\${P}\\${i.slice(y,F)}`,E=F)}}}else E=1;else d(p)&&i.charCodeAt(1)===g&&(m=i.slice(0,2),E=2,c>2&&R(i.charCodeAt(2))&&(w=!0,E=3));let M=E<c?a(i.slice(E),!w,"\\",R):"";return M.length===0&&!w&&(M="."),M.length>0&&R(i.charCodeAt(c-1))&&(M+="\\"),m===void 0?w?`\\${M}`:M:w?`${m}\\${M}`:`${m}${M}`},isAbsolute(i){e(i,"path");const c=i.length;if(c===0)return!1;const E=i.charCodeAt(0);return R(E)||c>2&&d(E)&&i.charCodeAt(1)===g&&R(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let c,E;for(let p=0;p<i.length;++p){const M=i[p];e(M,"path"),M.length>0&&(c===void 0?c=E=M:c+=`\\${M}`)}if(c===void 0)return".";let m=!0,w=0;if(typeof E=="string"&&R(E.charCodeAt(0))){++w;const p=E.length;p>1&&R(E.charCodeAt(1))&&(++w,p>2&&(R(E.charCodeAt(2))?++w:m=!1))}if(m){for(;w<c.length&&R(c.charCodeAt(w));)w++;w>=2&&(c=`\\${c.slice(w)}`)}return t.$fc.normalize(c)},relative(i,c){if(e(i,"from"),e(c,"to"),i===c)return"";const E=t.$fc.resolve(i),m=t.$fc.resolve(c);if(E===m||(i=E.toLowerCase(),c=m.toLowerCase(),i===c))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===s;)w++;let p=i.length;for(;p-1>w&&i.charCodeAt(p-1)===s;)p--;const M=p-w;let F=0;for(;F<c.length&&c.charCodeAt(F)===s;)F++;let y=c.length;for(;y-1>F&&c.charCodeAt(y-1)===s;)y--;const P=y-F,S=M<P?M:P;let T=-1,q=0;for(;q<S;q++){const D=i.charCodeAt(w+q);if(D!==c.charCodeAt(F+q))break;D===s&&(T=q)}if(q!==S){if(T===-1)return m}else{if(P>S){if(c.charCodeAt(F+q)===s)return m.slice(F+q+1);if(q===2)return m.slice(F+q)}M>S&&(i.charCodeAt(w+q)===s?T=q:q===2&&(T=3)),T===-1&&(T=0)}let O="";for(q=w+T+1;q<=p;++q)(q===p||i.charCodeAt(q)===s)&&(O+=O.length===0?"..":"\\..");return F+=T,O.length>0?`${O}${m.slice(F,y)}`:(m.charCodeAt(F)===s&&++F,m.slice(F,y))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const c=t.$fc.resolve(i);if(c.length<=2)return i;if(c.charCodeAt(0)===s){if(c.charCodeAt(1)===s){const E=c.charCodeAt(2);if(E!==A&&E!==h)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(d(c.charCodeAt(0))&&c.charCodeAt(1)===g&&c.charCodeAt(2)===s)return`\\\\?\\${c}`;return i},dirname(i){e(i,"path");const c=i.length;if(c===0)return".";let E=-1,m=0;const w=i.charCodeAt(0);if(c===1)return R(w)?i:".";if(R(w)){if(E=m=1,R(i.charCodeAt(1))){let F=2,y=F;for(;F<c&&!R(i.charCodeAt(F));)F++;if(F<c&&F!==y){for(y=F;F<c&&R(i.charCodeAt(F));)F++;if(F<c&&F!==y){for(y=F;F<c&&!R(i.charCodeAt(F));)F++;if(F===c)return i;F!==y&&(E=m=F+1)}}}}else d(w)&&i.charCodeAt(1)===g&&(E=c>2&&R(i.charCodeAt(2))?3:2,m=E);let p=-1,M=!0;for(let F=c-1;F>=m;--F)if(R(i.charCodeAt(F))){if(!M){p=F;break}}else M=!1;if(p===-1){if(E===-1)return".";p=E}return i.slice(0,p)},basename(i,c){c!==void 0&&e(c,"ext"),e(i,"path");let E=0,m=-1,w=!0,p;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(E=2),c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let M=c.length-1,F=-1;for(p=i.length-1;p>=E;--p){const y=i.charCodeAt(p);if(R(y)){if(!w){E=p+1;break}}else F===-1&&(w=!1,F=p+1),M>=0&&(y===c.charCodeAt(M)?--M===-1&&(m=p):(M=-1,m=F))}return E===m?m=F:m===-1&&(m=i.length),i.slice(E,m)}for(p=i.length-1;p>=E;--p)if(R(i.charCodeAt(p))){if(!w){E=p+1;break}}else m===-1&&(w=!1,m=p+1);return m===-1?"":i.slice(E,m)},extname(i){e(i,"path");let c=0,E=-1,m=0,w=-1,p=!0,M=0;i.length>=2&&i.charCodeAt(1)===g&&d(i.charCodeAt(0))&&(c=m=2);for(let F=i.length-1;F>=c;--F){const y=i.charCodeAt(F);if(R(y)){if(!p){m=F+1;break}continue}w===-1&&(p=!1,w=F+1),y===h?E===-1?E=F:M!==1&&(M=1):E!==-1&&(M=-1)}return E===-1||w===-1||M===0||M===1&&E===w-1&&E===m+1?"":i.slice(E,w)},format:o.bind(null,"\\"),parse(i){e(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const E=i.length;let m=0,w=i.charCodeAt(0);if(E===1)return R(w)?(c.root=c.dir=i,c):(c.base=c.name=i,c);if(R(w)){if(m=1,R(i.charCodeAt(1))){let T=2,q=T;for(;T<E&&!R(i.charCodeAt(T));)T++;if(T<E&&T!==q){for(q=T;T<E&&R(i.charCodeAt(T));)T++;if(T<E&&T!==q){for(q=T;T<E&&!R(i.charCodeAt(T));)T++;T===E?m=T:T!==q&&(m=T+1)}}}}else if(d(w)&&i.charCodeAt(1)===g){if(E<=2)return c.root=c.dir=i,c;if(m=2,R(i.charCodeAt(2))){if(E===3)return c.root=c.dir=i,c;m=3}}m>0&&(c.root=i.slice(0,m));let p=-1,M=m,F=-1,y=!0,P=i.length-1,S=0;for(;P>=m;--P){if(w=i.charCodeAt(P),R(w)){if(!y){M=P+1;break}continue}F===-1&&(y=!1,F=P+1),w===h?p===-1?p=P:S!==1&&(S=1):p!==-1&&(S=-1)}return F!==-1&&(p===-1||S===0||S===1&&p===F-1&&p===M+1?c.base=c.name=i.slice(M,F):(c.name=i.slice(M,p),c.base=i.slice(M,F),c.ext=i.slice(p,F))),M>0&&M!==m?c.dir=i.slice(0,M-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(N){const i=/\\/g;return()=>{const c=_.cwd().replace(i,"/");return c.slice(c.indexOf("/"))}}return()=>_.cwd()})();t.$gc={resolve(...i){let c="",E=!1;for(let m=i.length-1;m>=-1&&!E;m--){const w=m>=0?i[m]:u();e(w,"path"),w.length!==0&&(c=`${w}/${c}`,E=w.charCodeAt(0)===l)}return c=a(c,!E,"/",L),E?`/${c}`:c.length>0?c:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===l,E=i.charCodeAt(i.length-1)===l;return i=a(i,!c,"/",L),i.length===0?c?"/":E?"./":".":(E&&(i+="/"),c?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let c;for(let E=0;E<i.length;++E){const m=i[E];e(m,"path"),m.length>0&&(c===void 0?c=m:c+=`/${m}`)}return c===void 0?".":t.$gc.normalize(c)},relative(i,c){if(e(i,"from"),e(c,"to"),i===c||(i=t.$gc.resolve(i),c=t.$gc.resolve(c),i===c))return"";const E=1,m=i.length,w=m-E,p=1,M=c.length-p,F=w<M?w:M;let y=-1,P=0;for(;P<F;P++){const T=i.charCodeAt(E+P);if(T!==c.charCodeAt(p+P))break;T===l&&(y=P)}if(P===F)if(M>F){if(c.charCodeAt(p+P)===l)return c.slice(p+P+1);if(P===0)return c.slice(p+P)}else w>F&&(i.charCodeAt(E+P)===l?y=P:P===0&&(y=0));let S="";for(P=E+y+1;P<=m;++P)(P===m||i.charCodeAt(P)===l)&&(S+=S.length===0?"..":"/..");return`${S}${c.slice(p+y)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===l;let E=-1,m=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===l){if(!m){E=w;break}}else m=!1;return E===-1?c?"/":".":c&&E===1?"//":i.slice(0,E)},basename(i,c){c!==void 0&&e(c,"ext"),e(i,"path");let E=0,m=-1,w=!0,p;if(c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let M=c.length-1,F=-1;for(p=i.length-1;p>=0;--p){const y=i.charCodeAt(p);if(y===l){if(!w){E=p+1;break}}else F===-1&&(w=!1,F=p+1),M>=0&&(y===c.charCodeAt(M)?--M===-1&&(m=p):(M=-1,m=F))}return E===m?m=F:m===-1&&(m=i.length),i.slice(E,m)}for(p=i.length-1;p>=0;--p)if(i.charCodeAt(p)===l){if(!w){E=p+1;break}}else m===-1&&(w=!1,m=p+1);return m===-1?"":i.slice(E,m)},extname(i){e(i,"path");let c=-1,E=0,m=-1,w=!0,p=0;for(let M=i.length-1;M>=0;--M){const F=i.charCodeAt(M);if(F===l){if(!w){E=M+1;break}continue}m===-1&&(w=!1,m=M+1),F===h?c===-1?c=M:p!==1&&(p=1):c!==-1&&(p=-1)}return c===-1||m===-1||p===0||p===1&&c===m-1&&c===E+1?"":i.slice(c,m)},format:o.bind(null,"/"),parse(i){e(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const E=i.charCodeAt(0)===l;let m;E?(c.root="/",m=1):m=0;let w=-1,p=0,M=-1,F=!0,y=i.length-1,P=0;for(;y>=m;--y){const S=i.charCodeAt(y);if(S===l){if(!F){p=y+1;break}continue}M===-1&&(F=!1,M=y+1),S===h?w===-1?w=y:P!==1&&(P=1):w!==-1&&(P=-1)}if(M!==-1){const S=p===0&&E?1:p;w===-1||P===0||P===1&&w===M-1&&w===p+1?c.base=c.name=i.slice(S,M):(c.name=i.slice(S,w),c.base=i.slice(S,M),c.ext=i.slice(w,M))}return p>0?c.dir=i.slice(0,p-1):E&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=N?t.$fc.normalize:t.$gc.normalize,t.$ic=N?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=N?t.$fc.join:t.$gc.join,t.$kc=N?t.$fc.resolve:t.$gc.resolve,t.$lc=N?t.$fc.relative:t.$gc.relative,t.$mc=N?t.$fc.dirname:t.$gc.dirname,t.$nc=N?t.$fc.basename:t.$gc.basename,t.$oc=N?t.$fc.extname:t.$gc.extname,t.$pc=N?t.$fc.format:t.$gc.format,t.$qc=N?t.$fc.parse:t.$gc.parse,t.$rc=N?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=N?t.$fc.sep:t.$gc.sep,t.$tc=N?t.$fc.delimiter:t.$gc.delimiter}),ne(re[23],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Od=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class k{static create(f){return new k(f)}constructor(f){this.c=_&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Od=k}),ne(re[11],se([0,1,3,19,10,21,23]),function(V,t,_,k,r,f,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.Event=void 0;const h=!1,l=!1;var s;(function(y){y.None=()=>r.$Sc.None;function P(G){if(l){const{onDidAddListener:Z}=G,ee=e.create();let Y=0;G.onDidAddListener=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),Z?.()}}}function S(G,Z){return n(G,()=>{},0,void 0,!0,void 0,Z)}y.defer=S;function T(G){return(Z,ee=null,Y)=>{let ie=!1,le;return le=G(oe=>{if(!ie)return le?le.dispose():ie=!0,Z.call(ee,oe)},null,Y),ie&&le.dispose(),le}}y.once=T;function q(G,Z,ee){return J((Y,ie=null,le)=>G(oe=>Y.call(ie,Z(oe)),null,le),ee)}y.map=q;function O(G,Z,ee){return J((Y,ie=null,le)=>G(oe=>{Z(oe),Y.call(ie,oe)},null,le),ee)}y.forEach=O;function D(G,Z,ee){return J((Y,ie=null,le)=>G(oe=>Z(oe)&&Y.call(ie,oe),null,le),ee)}y.filter=D;function j(G){return G}y.signal=j;function z(...G){return(Z,ee=null,Y)=>{const ie=(0,r.$Pc)(...G.map(le=>le(oe=>Z.call(ee,oe))));return te(ie,Y)}}y.any=z;function x(G,Z,ee,Y){let ie=ee;return q(G,le=>(ie=Z(ie,le),ie),Y)}y.reduce=x;function J(G,Z){let ee;const Y={onWillAddFirstListener(){ee=G(ie.fire,ie)},onDidRemoveLastListener(){ee?.dispose()}};Z||P(Y);const ie=new a(Y);return Z?.add(ie),ie.event}function te(G,Z){return Z instanceof Array?Z.push(G):Z&&Z.add(G),G}function n(G,Z,ee=100,Y=!1,ie=!1,le,oe){let ge,me,ye,Pe=0,Fe;const Le={leakWarningThreshold:le,onWillAddFirstListener(){ge=G(Be=>{Pe++,me=Z(me,Be),Y&&!ye&&(De.fire(me),me=void 0),Fe=()=>{const Oe=me;me=void 0,ye=void 0,(!Y||Pe>1)&&De.fire(Oe),Pe=0},typeof ee=="number"?(clearTimeout(ye),ye=setTimeout(Fe,ee)):ye===void 0&&(ye=0,queueMicrotask(Fe))})},onWillRemoveListener(){ie&&Pe>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,ge.dispose()}};oe||P(Le);const De=new a(Le);return oe?.add(De),De.event}y.debounce=n;function ae(G,Z=0,ee){return y.debounce(G,(Y,ie)=>Y?(Y.push(ie),Y):[ie],Z,void 0,!0,void 0,ee)}y.accumulate=ae;function de(G,Z=(Y,ie)=>Y===ie,ee){let Y=!0,ie;return D(G,le=>{const oe=Y||!Z(le,ie);return Y=!1,ie=le,oe},ee)}y.latch=de;function $e(G,Z,ee){return[y.filter(G,Z,ee),y.filter(G,Y=>!Z(Y),ee)]}y.split=$e;function ve(G,Z=!1,ee=[],Y){let ie=ee.slice(),le=G(me=>{ie?ie.push(me):ge.fire(me)});Y&&Y.add(le);const oe=()=>{ie?.forEach(me=>ge.fire(me)),ie=null},ge=new a({onWillAddFirstListener(){le||(le=G(me=>ge.fire(me)),Y&&Y.add(le))},onDidAddFirstListener(){ie&&(Z?setTimeout(oe):oe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return Y&&Y.add(ge),ge.event}y.buffer=ve;function Me(G,Z){return(Y,ie,le)=>{const oe=Z(new pe);return G(function(ge){const me=oe.evaluate(ge);me!==we&&Y.call(ie,me)},void 0,le)}}y.chain=Me;const we=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(Z){return this.f.push(Z),this}forEach(Z){return this.f.push(ee=>(Z(ee),ee)),this}filter(Z){return this.f.push(ee=>Z(ee)?ee:we),this}reduce(Z,ee){let Y=ee;return this.f.push(ie=>(Y=Z(Y,ie),Y)),this}latch(Z=(ee,Y)=>ee===Y){let ee=!0,Y;return this.f.push(ie=>{const le=ee||!Z(ie,Y);return ee=!1,Y=ie,le?ie:we}),this}evaluate(Z){for(const ee of this.f)if(Z=ee(Z),Z===we)break;return Z}}function Te(G,Z,ee=Y=>Y){const Y=(...ge)=>oe.fire(ee(...ge)),ie=()=>G.on(Z,Y),le=()=>G.removeListener(Z,Y),oe=new a({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return oe.event}y.fromNodeEventEmitter=Te;function Se(G,Z,ee=Y=>Y){const Y=(...ge)=>oe.fire(ee(...ge)),ie=()=>G.addEventListener(Z,Y),le=()=>G.removeEventListener(Z,Y),oe=new a({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return oe.event}y.fromDOMEventEmitter=Se;function Ie(G){return new Promise(Z=>T(G)(Z))}y.toPromise=Ie;function Ee(G){const Z=new a;return G.then(ee=>{Z.fire(ee)},()=>{Z.fire(void 0)}).finally(()=>{Z.dispose()}),Z.event}y.fromPromise=Ee;function U(G,Z,ee){return Z(ee),G(Y=>Z(Y))}y.runAndSubscribe=U;function C(G,Z){let ee=null;function Y(le){ee?.dispose(),ee=new r.$Rc,Z(le,ee)}Y(void 0);const ie=G(le=>Y(le));return(0,r.$Qc)(()=>{ie.dispose(),ee?.dispose()})}y.runAndSubscribeWithStore=C;class W{constructor(Z,ee){this._observable=Z,this.f=0,this.g=!1;const Y={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};ee||P(Y),this.emitter=new a(Y),ee&&ee.add(this.emitter)}beginUpdate(Z){this.f++}handlePossibleChange(Z){}handleChange(Z,ee){this.g=!0}endUpdate(Z){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Q(G,Z){return new W(G,Z).emitter.event}y.fromObservable=Q;function K(G){return(Z,ee,Y)=>{let ie=0,le=!1;const oe={beginUpdate(){ie++},endUpdate(){ie--,ie===0&&(G.reportChanges(),le&&(le=!1,Z.call(ee)))},handlePossibleChange(){},handleChange(){le=!0}};G.addObserver(oe),G.reportChanges();const ge={dispose(){G.removeObserver(oe)}};return Y instanceof r.$Rc?Y.add(ge):Array.isArray(Y)&&Y.push(ge),ge}}y.fromObservableLight=K})(s||(t.Event=s={}));class g{constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${g.f++}`,g.all.add(this)}start(P){this.g=new v.$Od,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}t.$Qd=g,g.all=new Set,g.f=0;let A=-1;function b(y){const P=A;return A=y,{dispose(){A=P}}}t.$Rd=b;class ${constructor(P,S=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=S,this.g=0}dispose(){this.f?.clear()}check(P,S){const T=this.threshold;if(T<=0||S<T)return;this.f||(this.f=new Map);const q=this.f.get(P.value)||0;if(this.f.set(P.value,q+1),this.g-=1,this.g<=0){this.g=T*.5;let O,D=0;for(const[j,z]of this.f)(!O||D<z)&&(O=j,D=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${D}):`),console.warn(O)}return()=>{const O=this.f.get(P.value)||0;this.f.set(P.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let N=0;class R{constructor(P){this.value=P,this.id=N++}}const L=2,d=(y,P)=>{if(y instanceof R)P(y);else for(let S=0;S<y.length;S++){const T=y[S];T&&P(T)}};class a{constructor(P){this.w=0,this.f=P,this.g=A>0||this.f?.leakWarningThreshold?new $(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const P=this.t;queueMicrotask(()=>{d(P,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(P,S,T)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Sc.None;if(this.m)return r.$Sc.None;S&&(P=P.bind(S));const q=new R(P);let O,D;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),O=this.g.check(q.stack,this.w+1)),h&&(q.stack=D??e.create()),this.t?this.t instanceof R?(this.u??(this.u=new u),this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,r.$Qc)(()=>{O?.(),this.x(q)});return T instanceof r.$Rc?T.add(j):Array.isArray(T)&&T.push(j),j}),this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,T=S.indexOf(P);if(T===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[T]=void 0;const q=this.u.current===this;if(this.w*L<=S.length){let O=0;for(let D=0;D<S.length;D++)S[D]?S[O++]=S[D]:q&&(this.u.end--,O<this.u.i&&this.u.i--);S.length=O}}y(P,S){if(!P)return;const T=this.f?.onListenerError||_.$1;if(!T){P.value(S);return}try{P.value(S)}catch(q){T(q)}}z(P){const S=P.current.t;for(;P.i<P.end;)this.y(S[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof R)this.y(this.t,P);else{const S=this.u;S.enqueue(this,P,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Sd=a;const o=()=>new u;t.$Td=o;class u{constructor(){this.i=-1,this.end=0}enqueue(P,S,T){this.i=0,this.end=T,this.current=P,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends a{async fireAsync(P,S,T){if(this.t)for(this.h||(this.h=new f.$3c),d(this.t,q=>this.h.push([q.value,P]));this.h.size>0&&!S.isCancellationRequested;){const[q,O]=this.h.shift(),D=[],j={...O,token:S,waitUntil:z=>{if(Object.isFrozen(D))throw new Error("waitUntil can NOT be called asynchronous");T&&(z=T(z,q)),D.push(z)}};try{q(j)}catch(z){(0,_.$1)(z);continue}Object.freeze(D),await Promise.allSettled(D).then(z=>{for(const x of z)x.status==="rejected"&&(0,_.$1)(x.reason)})}}}t.$Ud=i;class c extends a{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new f.$3c,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$Vd=c;class E extends c{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$Wd=E;class m extends a{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}t.$Xd=m;class w{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const S={event:P,listener:null};this.h.push(S),this.g&&this.m(S);const T=()=>{this.g&&this.o(S);const q=this.h.indexOf(S);this.h.splice(q,1)};return(0,r.$Qc)((0,k.$db)(T))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(S=>this.f.fire(S))}o(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.f.dispose()}}t.$Yd=w;class p{constructor(P,S,T,q){this.f=new r.$Rc;const O=this.f.add(new w),D=this.f.add(new r.$2c);function j(z){D.set(z,O.add(q(z)))}for(const z of P)j(z);this.f.add(S(z=>{j(z)})),this.f.add(T(z=>{D.deleteAndDispose(z)})),this.event=O.event}dispose(){this.f.dispose()}}t.$Zd=p;class M{constructor(){this.f=[]}wrapEvent(P){return(S,T,q)=>P(O=>{const D=this.f[this.f.length-1];D?D.push(()=>S.call(T,O)):S.call(T,O)},void 0,q)}bufferEvents(P){const S=[];this.f.push(S);const T=P();return this.f.pop(),S.forEach(q=>q()),T}}t.$1d=M;class F{constructor(){this.f=!1,this.g=s.None,this.h=r.$Sc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$2d=F}),ne(re[24],se([0,1,11]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.CancellationToken=void 0;const k=Object.freeze(function(h,l){const s=setTimeout(h.bind(l),0);return{dispose(){clearTimeout(s)}}});var r;(function(h){function l(s){return s===h.None||s===h.Cancelled||s instanceof f?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}h.isCancellationToken=l,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(r||(t.CancellationToken=r={}));class f{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?k:(this.b||(this.b=new _.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class v{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new f),this.f}cancel(){this.f?this.f instanceof f&&this.f.cancel():this.f=r.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof f&&this.f.dispose():this.f=r.None}}t.$3d=v}),ne(re[41],se([0,1,24]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$De=t.$Ce=t.$Be=void 0;class k{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new _.$3d,l=this.b(h.token);return this.a={promise:l,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}t.$Be=k;class r{constructor(h){this.c=h,this.a=void 0,this.b=void 0}get(h){const l=JSON.stringify(h);return this.b!==l&&(this.b=l,this.a=this.c(h)),this.a}}t.$Ce=r;class f{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const l=this.b(h);return this.a.set(h,l),l}}t.$De=f}),ne(re[7],se([0,1,41,38]),function(V,t,_,k){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Df=t.$Cf=t.$Bf=t.$Af=t.GraphemeBreakType=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=void 0;function f(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.$Ge=f;const v=/{(\d+)}/g;function h(I,...B){return B.length===0?I:I.replace(v,function(H,X){const ue=parseInt(X,10);return isNaN(ue)||ue<0||ue>=B.length?H:B[ue]})}t.$He=h;const l=/{([^}]+)}/g;function s(I,B){return Object.keys(B).length===0?I:I.replace(l,(H,X)=>B[X]??H)}t.$Ie=s;function g(I){return I.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$Je=g;function A(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ke=A;function b(I,B){let H=0;const X=B.charCodeAt(0);for(let ue=I.length-1;ue>=0;ue--)I.charCodeAt(ue)===X&&H++;return H}t.$Le=b;function $(I,B,H="\u2026"){return I.length<=B?I:`${I.substr(0,B)}${H}`}t.$Me=$;function e(I,B,H="\u2026"){if(I.length<=B)return I;const X=Math.ceil(B/2)-H.length/2,ue=Math.floor(B/2)-H.length/2;return`${I.substr(0,X)}${H}${I.substr(I.length-ue)}`}t.$Ne=e;function N(I,B=" "){const H=R(I,B);return L(H,B)}t.$Oe=N;function R(I,B){if(!I||!B)return I;const H=B.length;if(H===0||I.length===0)return I;let X=0;for(;I.indexOf(B,X)===X;)X=X+H;return I.substring(X)}t.$Pe=R;function L(I,B){if(!I||!B)return I;const H=B.length,X=I.length;if(H===0||X===0)return I;let ue=X,ce=-1;for(;ce=I.lastIndexOf(B,ue-1),!(ce===-1||ce+H!==ue);){if(ce===0)return"";ue=ce}return I.substring(0,ue)}t.$Qe=L;function d(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Re=d;function a(I){return I.replace(/\*/g,"")}t.$Se=a;function o(I,B,H={}){if(!I)throw new Error("Cannot create regex from empty string");B||(I=A(I)),H.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let X="";return H.global&&(X+="g"),H.matchCase||(X+="i"),H.multiline&&(X+="m"),H.unicode&&(X+="u"),new RegExp(I,X)}t.$Te=o;function u(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.$Ue=u;function i(I){return I.split(/\r\n|\r|\n/)}t.$Ve=i;function c(I){for(let B=0,H=I.length;B<H;B++){const X=I.charCodeAt(B);if(X!==32&&X!==9)return B}return-1}t.$We=c;function E(I,B=0,H=I.length){for(let X=B;X<H;X++){const ue=I.charCodeAt(X);if(ue!==32&&ue!==9)return I.substring(B,X)}return I.substring(B,H)}t.$Xe=E;function m(I,B=I.length-1){for(let H=B;H>=0;H--){const X=I.charCodeAt(H);if(X!==32&&X!==9)return H}return-1}t.$Ye=m;function w(I,B,H){const X=[];let ue=0;for(const ce of I.matchAll(B)){if(X.push(I.slice(ue,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");ue=ce.index+ce[0].length,X.push(H(ce[0],...ce.slice(1),ce.index,I,ce.groups))}return X.push(I.slice(ue)),Promise.all(X).then(ce=>ce.join(""))}t.$Ze=w;function p(I,B){return I<B?-1:I>B?1:0}t.$1e=p;function M(I,B,H=0,X=I.length,ue=0,ce=B.length){for(;H<X&&ue<ce;H++,ue++){const Ae=I.charCodeAt(H),fe=B.charCodeAt(ue);if(Ae<fe)return-1;if(Ae>fe)return 1}const be=X-H,ke=ce-ue;return be<ke?-1:be>ke?1:0}t.$2e=M;function F(I,B){return y(I,B,0,I.length,0,B.length)}t.$3e=F;function y(I,B,H=0,X=I.length,ue=0,ce=B.length){for(;H<X&&ue<ce;H++,ue++){let Ae=I.charCodeAt(H),fe=B.charCodeAt(ue);if(Ae===fe)continue;if(Ae>=128||fe>=128)return M(I.toLowerCase(),B.toLowerCase(),H,X,ue,ce);S(Ae)&&(Ae-=32),S(fe)&&(fe-=32);const Ne=Ae-fe;if(Ne!==0)return Ne}const be=X-H,ke=ce-ue;return be<ke?-1:be>ke?1:0}t.$4e=y;function P(I){return I>=48&&I<=57}t.$5e=P;function S(I){return I>=97&&I<=122}t.$6e=S;function T(I){return I>=65&&I<=90}t.$7e=T;function q(I,B){return I.length===B.length&&y(I,B)===0}t.$8e=q;function O(I,B){const H=B.length;return B.length>I.length?!1:y(I,B,0,H)===0}t.$9e=O;function D(I,B){const H=Math.min(I.length,B.length);let X;for(X=0;X<H;X++)if(I.charCodeAt(X)!==B.charCodeAt(X))return X;return H}t.$0e=D;function j(I,B){const H=Math.min(I.length,B.length);let X;const ue=I.length-1,ce=B.length-1;for(X=0;X<H;X++)if(I.charCodeAt(ue-X)!==B.charCodeAt(ce-X))return X;return H}t.$$e=j;function z(I){return 55296<=I&&I<=56319}t.$_e=z;function x(I){return 56320<=I&&I<=57343}t.$af=x;function J(I,B){return(I-55296<<10)+(B-56320)+65536}t.$bf=J;function te(I,B,H){const X=I.charCodeAt(H);if(z(X)&&H+1<B){const ue=I.charCodeAt(H+1);if(x(ue))return J(X,ue)}return X}t.$cf=te;function n(I,B){const H=I.charCodeAt(B-1);if(x(H)&&B>1){const X=I.charCodeAt(B-2);if(z(X))return J(X,H)}return H}class ae{get offset(){return this.e}constructor(B,H=0){this.c=B,this.d=B.length,this.e=H}setOffset(B){this.e=B}prevCodePoint(){const B=n(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=te(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$df=ae;class de{get offset(){return this.c.offset}constructor(B,H=0){this.c=new ae(B,H)}nextGraphemeLength(){const B=Le.getInstance(),H=this.c,X=H.offset;let ue=B.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const ce=H.offset,be=B.getGraphemeBreakType(H.nextCodePoint());if(Pe(ue,be)){H.setOffset(ce);break}ue=be}return H.offset-X}prevGraphemeLength(){const B=Le.getInstance(),H=this.c,X=H.offset;let ue=B.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const ce=H.offset,be=B.getGraphemeBreakType(H.prevCodePoint());if(Pe(be,ue)){H.setOffset(ce);break}ue=be}return X-H.offset}eol(){return this.c.eol()}}t.$ef=de;function $e(I,B){return new de(I,B).nextGraphemeLength()}t.$ff=$e;function ve(I,B){return new de(I,B).prevGraphemeLength()}t.$gf=ve;function Me(I,B){B>0&&x(I.charCodeAt(B))&&B--;const H=B+$e(I,B);return[H-ve(I,H),H]}t.$hf=Me;function we(I){const B=new de(I);let H=0;for(;!B.eol();)H++,B.nextGraphemeLength();return H}t.$if=we;let pe;function Te(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(I){return pe||(pe=Te()),pe.test(I)}t.$jf=Se;const Ie=/^[\t\n\r\x20-\x7E]*$/;function Ee(I){return Ie.test(I)}t.$kf=Ee,t.$lf=/[\u2028\u2029]/;function U(I){return t.$lf.test(I)}t.$mf=U;function C(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.$nf=C;function W(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.$of=W;function Q(I,B){if(I.length<B)return I;const H=/\b/g;let X=0;for(;H.test(I)&&!(I.length-H.lastIndex<B);)X=H.lastIndex,H.lastIndex+=1;return I.substring(X).replace(/^\s/,"")}t.$pf=Q;const K=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,G=/\x1b\].*?\x07/g;function Z(I){return I&&(I=I.replace(K,"").replace(G,"")),I}t.$qf=Z,t.$rf=String.fromCharCode(65279);function ee(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.$sf=ee;function Y(I){return ee(I)?I.substr(1):I}t.$tf=Y;function ie(I,B){if(!I||!B||I.length<B.length)return!1;const H=B.length,X=I.toLowerCase();let ue=0,ce=-1;for(;ue<H;){const be=X.indexOf(B[ue],ce+1);if(be<0)return!1;ce=be,ue++}return!0}t.$uf=ie;function le(I,B=!1){return I?(B&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.$vf=le;function oe(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.$wf=oe;function ge(I,B=1){if(B===0)return"";let H=-1;do H=I.indexOf(`
`,H+1),B--;while(B>0&&H>=0);return H===-1?I:(I[H-1]==="\r"&&H--,I.substr(0,H))}t.$xf=ge;function me(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.$yf=me;function ye(I){return Le.getInstance().getGraphemeBreakType(I)}t.$zf=ye;function Pe(I,B){return I===0?B!==5&&B!==7:I===2&&B===3?!1:I===4||I===2||I===3||B===4||B===2||B===3?!0:!(I===8&&(B===8||B===9||B===11||B===12)||(I===11||I===9)&&(B===9||B===10)||(I===12||I===10)&&B===10||B===5||B===13||B===7||I===1||I===13&&B===14||I===6&&B===6)}var Fe;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(t.GraphemeBreakType=Fe={}));class Le{static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=De()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const H=this.d,X=H.length/3;let ue=1;for(;ue<=X;)if(B<H[3*ue])ue=2*ue;else if(B>H[3*ue+1])ue=2*ue+1;else return H[3*ue+2];return 0}}Le.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(I,B){if(I===0)return 0;const H=Oe(I,B);if(H!==void 0)return H;const X=new ae(B,I);return X.prevCodePoint(),X.offset}t.$Af=Be;function Oe(I,B){const H=new ae(B,I);let X=H.prevCodePoint();for(;xe(X)||X===65039||X===8419;){if(H.offset===0)return;X=H.prevCodePoint()}if(!W(X))return;let ue=H.offset;return ue>0&&H.prevCodePoint()===8205&&(ue=H.offset),ue}function xe(I){return 127995<=I&&I<=127999}var Ve;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),t.$Bf="\xA0";class qe{static getInstance(B){return r.d.get(Array.from(B))}static getLocales(){return r.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Cf=qe,r=qe,qe.c=new k.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.d=new _.$Ce(I=>{function B(fe){const Ne=new Map;for(let Re=0;Re<fe.length;Re+=2)Ne.set(fe[Re],fe[Re+1]);return Ne}function H(fe,Ne){const Re=new Map(fe);for(const[Ue,je]of Ne)Re.set(Ue,je);return Re}function X(fe,Ne){if(!fe)return Ne;const Re=new Map;for(const[Ue,je]of fe)Ne.has(Ue)&&Re.set(Ue,je);return Re}const ue=r.c.value;let ce=I.filter(fe=>!fe.startsWith("_")&&fe in ue);ce.length===0&&(ce=["_default"]);let be;for(const fe of ce){const Ne=B(ue[fe]);be=X(be,Ne)}const ke=B(ue._common),Ae=H(ke,be);return new r(Ae)}),qe.e=new k.$V(()=>Object.keys(r.c.value).filter(I=>!I.startsWith("_")));class _e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(_e.c())),this.d}static isInvisibleCharacter(B){return _e.e().has(B)}static get codePoints(){return _e.e()}}t.$Df=_e,_e.d=void 0}),ne(re[42],se([0,1,7]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vi=t.$Ui=t.$Ti=t.$Si=t.$Ri=t.$Qi=t.$Pi=void 0;function k(L){return r(L,0)}t.$Pi=k;function r(L,d){switch(typeof L){case"object":return L===null?f(349,d):Array.isArray(L)?l(L,d):s(L,d);case"string":return h(L,d);case"boolean":return v(L,d);case"number":return f(L,d);case"undefined":return f(937,d);default:return f(617,d)}}t.$Qi=r;function f(L,d){return(d<<5)-d+L|0}t.$Ri=f;function v(L,d){return f(L?433:863,d)}function h(L,d){d=f(149417,d);for(let a=0,o=L.length;a<o;a++)d=f(L.charCodeAt(a),d);return d}t.$Si=h;function l(L,d){return d=f(104579,d),L.reduce((a,o)=>r(o,a),d)}function s(L,d){return d=f(181387,d),Object.keys(L).sort().reduce((a,o)=>(a=h(o,a),r(L[o],a)),d)}class g{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=r(d,this.g),this.g}}t.$Ti=g;var A;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function b(L,d,a=32){const o=a-d,u=~((1<<o)-1);return(L<<d|(u&L)>>>o)>>>0}function $(L,d=0,a=L.byteLength,o=0){for(let u=0;u<a;u++)L[d+u]=o}function e(L,d,a="0"){for(;L.length<d;)L=a+L;return L}function N(L,d=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(a=>a.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),d/4)}t.$Ui=N;class R{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const a=d.length;if(a===0)return;const o=this.p;let u=this.r,i=this.u,c,E;for(i!==0?(c=i,E=-1,i=0):(c=d.charCodeAt(0),E=0);;){let m=c;if(_.$_e(c))if(E+1<a){const w=d.charCodeAt(E+1);_.$af(w)?(E++,m=_.$bf(c,w)):m=65533}else{i=c;break}else _.$af(c)&&(m=65533);if(u=this.w(o,u,m),E++,E<a)c=d.charCodeAt(E);else break}this.r=u,this.u=i}w(d,a,o){return o<128?d[a++]=o:o<2048?(d[a++]=192|(o&1984)>>>6,d[a++]=128|(o&63)>>>0):o<65536?(d[a++]=224|(o&61440)>>>12,d[a++]=128|(o&4032)>>>6,d[a++]=128|(o&63)>>>0):(d[a++]=240|(o&1835008)>>>18,d[a++]=128|(o&258048)>>>12,d[a++]=128|(o&4032)>>>6,d[a++]=128|(o&63)>>>0),a>=64&&(this.y(),a-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),a}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=R.g,a=this.q;for(let M=0;M<64;M+=4)d.setUint32(M,a.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)d.setUint32(M,b(d.getUint32(M-12,!1)^d.getUint32(M-32,!1)^d.getUint32(M-56,!1)^d.getUint32(M-64,!1),1),!1);let o=this.h,u=this.l,i=this.m,c=this.n,E=this.o,m,w,p;for(let M=0;M<80;M++)M<20?(m=u&i|~u&c,w=1518500249):M<40?(m=u^i^c,w=1859775393):M<60?(m=u&i|u&c|i&c,w=2400959708):(m=u^i^c,w=3395469782),p=b(o,5)+m+E+w+d.getUint32(M*4,!1)&4294967295,E=c,c=i,i=b(u,30),u=o,o=p;this.h=this.h+o&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+c&4294967295,this.o=this.o+E&4294967295}}t.$Vi=R,R.g=new DataView(new ArrayBuffer(320))}),ne(re[25],se([0,1,36,42]),function(V,t,_,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ns=t.$Ms=t.$Ls=void 0;class r{constructor(b){this.a=b}getElements(){const b=this.a,$=new Int32Array(b.length);for(let e=0,N=b.length;e<N;e++)$[e]=b.charCodeAt(e);return $}}t.$Ls=r;function f(A,b,$){return new g(new r(A),new r(b)).ComputeDiff($).changes}t.$Ms=f;class v{static Assert(b,$){if(!b)throw new Error($)}}class h{static Copy(b,$,e,N,R){for(let L=0;L<R;L++)e[N+L]=b[$+L]}static Copy2(b,$,e,N,R){for(let L=0;L<R;L++)e[N+L]=b[$+L]}}var l;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new _.$Ks(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,$){this.b=Math.min(this.b,b),this.c=Math.min(this.c,$),this.d++}AddModifiedElement(b,$){this.b=Math.min(this.b,b),this.c=Math.min(this.c,$),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(b,$,e=null){this.a=e,this.b=b,this.c=$;const[N,R,L]=g.o(b),[d,a,o]=g.o($);this.d=L&&o,this.e=N,this.f=R,this.g=d,this.h=a,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const $=b.getElements();if(g.n($)){const e=new Int32Array($.length);for(let N=0,R=$.length;N<R;N++)e[N]=(0,k.$Si)($[N],0);return[$,e,!0]}return $ instanceof Int32Array?[[],$,!1]:[[],new Int32Array($),!1]}p(b,$){return this.f[b]!==this.h[$]?!1:this.d?this.e[b]===this.g[$]:!0}q(b,$){if(!this.p(b,$))return!1;const e=g.r(this.b,b),N=g.r(this.c,$);return e===N}static r(b,$){return typeof b.getStrictElement=="function"?b.getStrictElement($):null}s(b,$){return this.f[b]!==this.f[$]?!1:this.d?this.e[b]===this.e[$]:!0}u(b,$){return this.h[b]!==this.h[$]?!1:this.d?this.g[b]===this.g[$]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,$,e,N,R){const L=[!1];let d=this.w(b,$,e,N,L);return R&&(d=this.z(d)),{quitEarly:L[0],changes:d}}w(b,$,e,N,R){for(R[0]=!1;b<=$&&e<=N&&this.p(b,e);)b++,e++;for(;$>=b&&N>=e&&this.p($,N);)$--,N--;if(b>$||e>N){let i;return e<=N?(v.Assert(b===$+1,"originalStart should only be one more than originalEnd"),i=[new _.$Ks(b,0,e,N-e+1)]):b<=$?(v.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),i=[new _.$Ks(b,$-b+1,e,0)]):(v.Assert(b===$+1,"originalStart should only be one more than originalEnd"),v.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const L=[0],d=[0],a=this.y(b,$,e,N,L,d,R),o=L[0],u=d[0];if(a!==null)return a;if(!R[0]){const i=this.w(b,o,e,u,R);let c=[];return R[0]?c=[new _.$Ks(o+1,$-(o+1)+1,u+1,N-(u+1)+1)]:c=this.w(o+1,$,u+1,N,R),this.H(i,c)}return[new _.$Ks(b,$-b+1,e,N-e+1)]}x(b,$,e,N,R,L,d,a,o,u,i,c,E,m,w,p,M,F){let y=null,P=null,S=new s,T=$,q=e,O=E[0]-p[0]-N,D=-1073741824,j=this.k.length-1;do{const z=O+b;z===T||z<q&&o[z-1]<o[z+1]?(i=o[z+1],m=i-O-N,i<D&&S.MarkNextChange(),D=i,S.AddModifiedElement(i+1,m),O=z+1-b):(i=o[z-1]+1,m=i-O-N,i<D&&S.MarkNextChange(),D=i-1,S.AddOriginalElement(i,m+1),O=z-1-b),j>=0&&(o=this.k[j],b=o[0],T=1,q=o.length-1)}while(--j>=-1);if(y=S.getReverseChanges(),F[0]){let z=E[0]+1,x=p[0]+1;if(y!==null&&y.length>0){const J=y[y.length-1];z=Math.max(z,J.getOriginalEnd()),x=Math.max(x,J.getModifiedEnd())}P=[new _.$Ks(z,c-z+1,x,w-x+1)]}else{S=new s,T=L,q=d,O=E[0]-p[0]-a,D=1073741824,j=M?this.m.length-1:this.m.length-2;do{const z=O+R;z===T||z<q&&u[z-1]>=u[z+1]?(i=u[z+1]-1,m=i-O-a,i>D&&S.MarkNextChange(),D=i+1,S.AddOriginalElement(i+1,m+1),O=z+1-R):(i=u[z-1],m=i-O-a,i>D&&S.MarkNextChange(),D=i,S.AddModifiedElement(i+1,m+1),O=z-1-R),j>=0&&(u=this.m[j],R=u[0],T=1,q=u.length-1)}while(--j>=-1);P=S.getChanges()}return this.H(y,P)}y(b,$,e,N,R,L,d){let a=0,o=0,u=0,i=0,c=0,E=0;b--,e--,R[0]=0,L[0]=0,this.k=[],this.m=[];const m=$-b+(N-e),w=m+1,p=new Int32Array(w),M=new Int32Array(w),F=N-e,y=$-b,P=b-e,S=$-N,q=(y-F)%2===0;p[F]=b,M[y]=$,d[0]=!1;for(let O=1;O<=m/2+1;O++){let D=0,j=0;u=this.J(F-O,O,F,w),i=this.J(F+O,O,F,w);for(let x=u;x<=i;x+=2){x===u||x<i&&p[x-1]<p[x+1]?a=p[x+1]:a=p[x-1]+1,o=a-(x-F)-P;const J=a;for(;a<$&&o<N&&this.p(a+1,o+1);)a++,o++;if(p[x]=a,a+o>D+j&&(D=a,j=o),!q&&Math.abs(x-y)<=O-1&&a>=M[x])return R[0]=a,L[0]=o,J<=M[x]&&1447>0&&O<=1447+1?this.x(F,u,i,P,y,c,E,S,p,M,a,$,R,o,N,L,q,d):null}const z=(D-b+(j-e)-O)/2;if(this.a!==null&&!this.a(D,z))return d[0]=!0,R[0]=D,L[0]=j,z>0&&1447>0&&O<=1447+1?this.x(F,u,i,P,y,c,E,S,p,M,a,$,R,o,N,L,q,d):(b++,e++,[new _.$Ks(b,$-b+1,e,N-e+1)]);c=this.J(y-O,O,y,w),E=this.J(y+O,O,y,w);for(let x=c;x<=E;x+=2){x===c||x<E&&M[x-1]>=M[x+1]?a=M[x+1]-1:a=M[x-1],o=a-(x-y)-S;const J=a;for(;a>b&&o>e&&this.p(a,o);)a--,o--;if(M[x]=a,q&&Math.abs(x-F)<=O&&a<=p[x])return R[0]=a,L[0]=o,J>=p[x]&&1447>0&&O<=1447+1?this.x(F,u,i,P,y,c,E,S,p,M,a,$,R,o,N,L,q,d):null}if(O<=1447){let x=new Int32Array(i-u+2);x[0]=F-u+1,h.Copy2(p,u,x,1,i-u+1),this.k.push(x),x=new Int32Array(E-c+2),x[0]=y-c+1,h.Copy2(M,c,x,1,E-c+1),this.m.push(x)}}return this.x(F,u,i,P,y,c,E,S,p,M,a,$,R,o,N,L,q,d)}z(b){for(let $=0;$<b.length;$++){const e=b[$],N=$<b.length-1?b[$+1].originalStart:this.f.length,R=$<b.length-1?b[$+1].modifiedStart:this.h.length,L=e.originalLength>0,d=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<R&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!d||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const a=[null];if($<b.length-1&&this.I(b[$],b[$+1],a)){b[$]=a[0],b.splice($+1,1),$--;continue}}for(let $=b.length-1;$>=0;$--){const e=b[$];let N=0,R=0;if($>0){const i=b[$-1];N=i.originalStart+i.originalLength,R=i.modifiedStart+i.modifiedLength}const L=e.originalLength>0,d=e.modifiedLength>0;let a=0,o=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const c=e.originalStart-i,E=e.modifiedStart-i;if(c<N||E<R||L&&!this.s(c,c+e.originalLength)||d&&!this.u(E,E+e.modifiedLength))break;const w=(c===N&&E===R?5:0)+this.G(c,e.originalLength,E,e.modifiedLength);w>o&&(o=w,a=i)}e.originalStart-=a,e.modifiedStart-=a;const u=[null];if($>0&&this.I(b[$-1],b[$],u)){b[$-1]=u[0],b.splice($,1),$++;continue}}if(this.d)for(let $=1,e=b.length;$<e;$++){const N=b[$-1],R=b[$],L=R.originalStart-N.originalStart-N.originalLength,d=N.originalStart,a=R.originalStart+R.originalLength,o=a-d,u=N.modifiedStart,i=R.modifiedStart+R.modifiedLength,c=i-u;if(L<5&&o<20&&c<20){const E=this.A(d,o,u,c,L);if(E){const[m,w]=E;(m!==N.originalStart+N.originalLength||w!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=m-N.originalStart,N.modifiedLength=w-N.modifiedStart,R.originalStart=m+L,R.modifiedStart=w+L,R.originalLength=a-R.originalStart,R.modifiedLength=i-R.modifiedStart)}}}return b}A(b,$,e,N,R){if($<R||N<R)return null;const L=b+$-R+1,d=e+N-R+1;let a=0,o=0,u=0;for(let i=b;i<L;i++)for(let c=e;c<d;c++){const E=this.B(i,c,R);E>0&&E>a&&(a=E,o=i,u=c)}return a>0?[o,u]:null}B(b,$,e){let N=0;for(let R=0;R<e;R++){if(!this.p(b+R,$+R))return 0;N+=this.e[b+R].length}return N}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,$){if(this.C(b)||this.C(b-1))return!0;if($>0){const e=b+$;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,$){if(this.E(b)||this.E(b-1))return!0;if($>0){const e=b+$;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,$,e,N){const R=this.D(b,$)?1:0,L=this.F(e,N)?1:0;return R+L}H(b,$){const e=[];if(b.length===0||$.length===0)return $.length>0?$:b;if(this.I(b[b.length-1],$[0],e)){const N=new Array(b.length+$.length-1);return h.Copy(b,0,N,0,b.length-1),N[b.length-1]=e[0],h.Copy($,1,N,b.length,$.length-1),N}else{const N=new Array(b.length+$.length);return h.Copy(b,0,N,0,b.length),h.Copy($,0,N,b.length,$.length),N}}I(b,$,e){if(v.Assert(b.originalStart<=$.originalStart,"Left change is not less than or equal to right change"),v.Assert(b.modifiedStart<=$.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=$.originalStart||b.modifiedStart+b.modifiedLength>=$.modifiedStart){const N=b.originalStart;let R=b.originalLength;const L=b.modifiedStart;let d=b.modifiedLength;return b.originalStart+b.originalLength>=$.originalStart&&(R=$.originalStart+$.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=$.modifiedStart&&(d=$.modifiedStart+$.modifiedLength-b.modifiedStart),e[0]=new _.$Ks(N,R,L,d),!0}else return e[0]=null,!1}J(b,$,e,N){if(b>=0&&b<N)return b;const R=e,L=N-e-1,d=$%2===0;if(b<0){const a=R%2===0;return d===a?0:1}else{const a=L%2===0;return d===a?N-1:N-2}}}t.$Ns=g}),ne(re[26],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=void 0;function _(u){return typeof u=="string"}t.$Ef=_;function k(u){return Array.isArray(u)&&u.every(i=>_(i))}t.$Ff=k;function r(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$Gf=r;function f(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}t.$Hf=f;function v(u){return typeof u=="number"&&!isNaN(u)}t.$If=v;function h(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Jf=h;function l(u){return u===!0||u===!1}t.$Kf=l;function s(u){return typeof u>"u"}t.$Lf=s;function g(u){return!A(u)}t.$Mf=g;function A(u){return s(u)||u===null}t.$Nf=A;function b(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$Of=b;function $(u){if(A(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Pf=$;function e(...u){const i=[];for(let c=0;c<u.length;c++){const E=u[c];if(A(E))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);i.push(E)}return i}t.$Qf=e;const N=Object.prototype.hasOwnProperty;function R(u){if(!r(u))return!1;for(const i in u)if(N.call(u,i))return!1;return!0}t.$Rf=R;function L(u){return typeof u=="function"}t.$Sf=L;function d(...u){return u.length>0&&u.every(L)}t.$Tf=d;function a(u,i){const c=Math.min(u.length,i.length);for(let E=0;E<c;E++)o(u[E],i[E])}t.$Uf=a;function o(u,i){if(_(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(L(i)){try{if(u instanceof i)return}catch{}if(!A(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Vf=o}),ne(re[43],se([0,1,26]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8j=t.$7j=t.$6j=void 0;const k=Object.create(null);function r(h,l){if((0,_.$Ef)(l)){const s=k[l];if(s===void 0)throw new Error(`${h} references an unknown codicon: ${l}`);l=s}return k[h]=l,{id:h}}function f(){return k}t.$6j=f;function v(){return Object.values(t.$8j)}t.$7j=v,t.$8j={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),ne(re[15],se([0,1,26]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tn=t.$sn=t.$rn=t.$qn=t.$pn=t.$on=t.$nn=t.$mn=t.$ln=t.$kn=t.$jn=t.$in=void 0;function k(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const d=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([a,o])=>{d[a]=o&&typeof o=="object"?k(o):o}),d}t.$in=k;function r(L){if(!L||typeof L!="object")return L;const d=[L];for(;d.length>0;){const a=d.shift();Object.freeze(a);for(const o in a)if(f.call(a,o)){const u=a[o];typeof u=="object"&&!Object.isFrozen(u)&&!(0,_.$Hf)(u)&&d.push(u)}}return L}t.$jn=r;const f=Object.prototype.hasOwnProperty;function v(L,d){return h(L,d,new Set)}t.$kn=v;function h(L,d,a){if((0,_.$Nf)(L))return L;const o=d(L);if(typeof o<"u")return o;if(Array.isArray(L)){const u=[];for(const i of L)u.push(h(i,d,a));return u}if((0,_.$Gf)(L)){if(a.has(L))throw new Error("Cannot clone recursive data-structure");a.add(L);const u={};for(const i in L)f.call(L,i)&&(u[i]=h(L[i],d,a));return a.delete(L),u}return L}function l(L,d,a=!0){return(0,_.$Gf)(L)?((0,_.$Gf)(d)&&Object.keys(d).forEach(o=>{o in L?a&&((0,_.$Gf)(L[o])&&(0,_.$Gf)(d[o])?l(L[o],d[o],a):L[o]=d[o]):L[o]=d[o]}),L):d}t.$ln=l;function s(L,d){if(L===d)return!0;if(L==null||d===null||d===void 0||typeof L!=typeof d||typeof L!="object"||Array.isArray(L)!==Array.isArray(d))return!1;let a,o;if(Array.isArray(L)){if(L.length!==d.length)return!1;for(a=0;a<L.length;a++)if(!s(L[a],d[a]))return!1}else{const u=[];for(o in L)u.push(o);u.sort();const i=[];for(o in d)i.push(o);if(i.sort(),!s(u,i))return!1;for(a=0;a<u.length;a++)if(!s(L[u[a]],d[u[a]]))return!1}return!0}t.$mn=s;function g(L){const d=new Set;return JSON.stringify(L,(a,o)=>{if((0,_.$Gf)(o)||Array.isArray(o)){if(d.has(o))return"[Circular]";d.add(o)}return o})}t.$nn=g;function A(L,d){const a=Object.create(null);return!L||!d||Object.keys(d).forEach(u=>{const i=L[u],c=d[u];s(i,c)||(a[u]=c)}),a}t.$on=A;function b(L,d){const a=d.toLowerCase(),o=Object.keys(L).find(u=>u.toLowerCase()===a);return o?L[o]:L[d]}t.$pn=b;function $(L,d){const a=Object.create(null);for(const[o,u]of Object.entries(L))d(o,u)&&(a[o]=u);return a}t.$qn=$;function e(L){let d=[];for(;Object.prototype!==L;)d=d.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return d}t.$rn=e;function N(L){const d=[];for(const a of e(L))typeof L[a]=="function"&&d.push(a);return d}t.$sn=N;function R(L,d){const a=u=>function(){const i=Array.prototype.slice.call(arguments,0);return d(u,i)},o={};for(const u of L)o[u]=a(u);return o}t.$tn=R}),ne(re[27],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fe=t.$Ee=t.Constants=void 0;var _;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_||(t.Constants=_={}));function k(f){return f<0?0:f>255?255:f|0}t.$Ee=k;function r(f){return f<0?0:f>4294967295?4294967295:f|0}t.$Fe=r}),ne(re[16],se([0,1,40,14]),function(V,t,_,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,f=/^\//,v=/^\/\//;function h(m,w){if(!m.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!r.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!f.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(m,w){return!m&&!w?"file":m}function s(m,w){switch(m){case"https":case"http":case"file":w?w[0]!==A&&(w=A+w):w=A;break}return w}const g="",A="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class ${static isUri(w){return w instanceof $?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,p,M,F,y,P=!1){typeof w=="object"?(this.scheme=w.scheme||g,this.authority=w.authority||g,this.path=w.path||g,this.query=w.query||g,this.fragment=w.fragment||g):(this.scheme=l(w,P),this.authority=p||g,this.path=s(this.scheme,M||g),this.query=F||g,this.fragment=y||g,h(this,P))}get fsPath(){return o(this,!1)}with(w){if(!w)return this;let{scheme:p,authority:M,path:F,query:y,fragment:P}=w;return p===void 0?p=this.scheme:p===null&&(p=g),M===void 0?M=this.authority:M===null&&(M=g),F===void 0?F=this.path:F===null&&(F=g),y===void 0?y=this.query:y===null&&(y=g),P===void 0?P=this.fragment:P===null&&(P=g),p===this.scheme&&M===this.authority&&F===this.path&&y===this.query&&P===this.fragment?this:new R(p,M,F,y,P)}static parse(w,p=!1){const M=b.exec(w);return M?new R(M[2]||g,E(M[4]||g),E(M[5]||g),E(M[7]||g),E(M[9]||g),p):new R(g,g,g,g,g)}static file(w){let p=g;if(k.$c&&(w=w.replace(/\\/g,A)),w[0]===A&&w[1]===A){const M=w.indexOf(A,2);M===-1?(p=w.substring(2),w=A):(p=w.substring(2,M),w=w.substring(M)||A)}return new R("file",p,w,g,g)}static from(w,p){return new R(w.scheme,w.authority,w.path,w.query,w.fragment,p)}static joinPath(w,...p){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return k.$c&&w.scheme==="file"?M=$.file(_.$fc.join(o(w,!0),...p)).path:M=_.$gc.join(w.path,...p),w.with({path:M})}toString(w=!1){return u(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof $)return w;{const p=new R(w);return p._formatted=w.external??null,p._fsPath=w._sep===N?w.fsPath??null:null,p}}else return w}}t.URI=$;function e(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}t.$vc=e;const N=k.$c?1:void 0;class R extends ${constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(w=!1){return w?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=N),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const L={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(m,w,p){let M,F=-1;for(let y=0;y<m.length;y++){const P=m.charCodeAt(y);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||w&&P===47||p&&P===91||p&&P===93||p&&P===58)F!==-1&&(M+=encodeURIComponent(m.substring(F,y)),F=-1),M!==void 0&&(M+=m.charAt(y));else{M===void 0&&(M=m.substr(0,y));const S=L[P];S!==void 0?(F!==-1&&(M+=encodeURIComponent(m.substring(F,y)),F=-1),M+=S):F===-1&&(F=y)}}return F!==-1&&(M+=encodeURIComponent(m.substring(F))),M!==void 0?M:m}function a(m){let w;for(let p=0;p<m.length;p++){const M=m.charCodeAt(p);M===35||M===63?(w===void 0&&(w=m.substr(0,p)),w+=L[M]):w!==void 0&&(w+=m[p])}return w!==void 0?w:m}function o(m,w){let p;return m.authority&&m.path.length>1&&m.scheme==="file"?p=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?w?p=m.path.substr(1):p=m.path[1].toLowerCase()+m.path.substr(2):p=m.path,k.$c&&(p=p.replace(/\//g,"\\")),p}t.$wc=o;function u(m,w){const p=w?a:d;let M="",{scheme:F,authority:y,path:P,query:S,fragment:T}=m;if(F&&(M+=F,M+=":"),(y||F==="file")&&(M+=A,M+=A),y){let q=y.indexOf("@");if(q!==-1){const O=y.substr(0,q);y=y.substr(q+1),q=O.lastIndexOf(":"),q===-1?M+=p(O,!1,!1):(M+=p(O.substr(0,q),!1,!1),M+=":",M+=p(O.substr(q+1),!1,!0)),M+="@"}y=y.toLowerCase(),q=y.lastIndexOf(":"),q===-1?M+=p(y,!1,!0):(M+=p(y.substr(0,q),!1,!0),M+=y.substr(q))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const q=P.charCodeAt(1);q>=65&&q<=90&&(P=`/${String.fromCharCode(q+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const q=P.charCodeAt(0);q>=65&&q<=90&&(P=`${String.fromCharCode(q+32)}:${P.substr(2)}`)}M+=p(P,!0,!1)}return S&&(M+="?",M+=p(S,!1,!1)),T&&(M+="#",M+=w?T:d(T,!1,!1)),M}function i(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+i(m.substr(3)):m}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(m){return m.match(c)?m.replace(c,w=>i(w)):m}}),ne(re[67],se([0,1,3,11,10,15,14,7]),function(V,t,_,k,r,f,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let s=!1;function g(E){v.$i&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(E.message))}t.logOnceWebWorkerWarning=g;var A;(function(E){E[E.Request=0]="Request",E[E.Reply=1]="Reply",E[E.SubscribeEvent=2]="SubscribeEvent",E[E.Event=3]="Event",E[E.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class b{constructor(m,w,p,M){this.vsWorker=m,this.req=w,this.method=p,this.args=M,this.type=0}}class ${constructor(m,w,p,M){this.vsWorker=m,this.seq=w,this.res=p,this.err=M,this.type=1}}class e{constructor(m,w,p,M){this.vsWorker=m,this.req=w,this.eventName=p,this.arg=M,this.type=2}}class N{constructor(m,w,p){this.vsWorker=m,this.req=w,this.event=p,this.type=3}}class R{constructor(m,w){this.vsWorker=m,this.req=w,this.type=4}}class L{constructor(m){this.a=-1,this.g=m,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(m){this.a=m}sendMessage(m,w){const p=String(++this.b);return new Promise((M,F)=>{this.c[p]={resolve:M,reject:F},this.o(new b(this.a,p,m,w))})}listen(m,w){let p=null;const M=new k.$Sd({onWillAddFirstListener:()=>{p=String(++this.b),this.d.set(p,M),this.o(new e(this.a,p,m,w))},onDidRemoveLastListener:()=>{this.d.delete(p),this.o(new R(this.a,p)),p=null}});return M.event}handleMessage(m){!m||!m.vsWorker||this.a!==-1&&m.vsWorker!==this.a||this.h(m)}h(m){switch(m.type){case 1:return this.j(m);case 0:return this.k(m);case 2:return this.l(m);case 3:return this.m(m);case 4:return this.n(m)}}j(m){if(!this.c[m.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[m.seq];if(delete this.c[m.seq],m.err){let p=m.err;m.err.$isError&&(p=new Error,p.name=m.err.name,p.message=m.err.message,p.stack=m.err.stack),w.reject(p);return}w.resolve(m.res)}k(m){const w=m.req;this.g.handleMessage(m.method,m.args).then(M=>{this.o(new $(this.a,w,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,_.$3)(M.detail)),this.o(new $(this.a,w,void 0,(0,_.$3)(M)))})}l(m){const w=m.req,p=this.g.handleEvent(m.eventName,m.arg)(M=>{this.o(new N(this.a,w,M))});this.f.set(w,p)}m(m){if(!this.d.has(m.req)){console.warn("Got event for unknown req");return}this.d.get(m.req).fire(m.event)}n(m){if(!this.f.has(m.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(m.req).dispose(),this.f.delete(m.req)}o(m){const w=[];if(m.type===0)for(let p=0;p<m.args.length;p++)m.args[p]instanceof ArrayBuffer&&w.push(m.args[p]);else m.type===1&&m.res instanceof ArrayBuffer&&w.push(m.res);this.g.sendMessage(m,w)}}class d extends r.$Sc{constructor(m,w,p){super();let M=null;this.a=this.B(m.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{M?.(q)})),this.c=new L({sendMessage:(q,O)=>{this.a.postMessage(q,O)},handleMessage:(q,O)=>{if(typeof p[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(p[q].apply(p,O))}catch(D){return Promise.reject(D)}},handleEvent:(q,O)=>{if(o(q)){const D=p[q].call(p,O);if(typeof D!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return D}if(a(q)){const D=p[q];if(typeof D!="function")throw new Error(`Missing event ${q} on main thread host.`);return D}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let F=null;const y=globalThis.require;typeof y<"u"&&typeof y.getConfig=="function"?F=y.getConfig():typeof globalThis.requirejs<"u"&&(F=globalThis.requirejs.s.contexts._.config);const P=(0,f.$sn)(p);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(F)),w,P]);const S=(q,O)=>this.g(q,O),T=(q,O)=>this.c.listen(q,O);this.f=new Promise((q,O)=>{M=O,this.b.then(D=>{q(u(D,S,T))},D=>{O(D),this.h("Worker failed to load "+w,D)})})}getProxyObject(){return this.f}g(m,w){return new Promise((p,M)=>{this.b.then(()=>{this.c.sendMessage(m,w).then(p,M)},M)})}h(m,w){console.error(m),console.info(w)}}t.SimpleWorkerClient=d;function a(E){return E[0]==="o"&&E[1]==="n"&&h.$7e(E.charCodeAt(2))}function o(E){return/^onDynamic/.test(E)&&h.$7e(E.charCodeAt(9))}function u(E,m,w){const p=y=>function(){const P=Array.prototype.slice.call(arguments,0);return m(y,P)},M=y=>function(P){return w(y,P)},F={};for(const y of E){if(o(y)){F[y]=M(y);continue}if(a(y)){F[y]=w(y,void 0);continue}F[y]=p(y)}return F}class i{constructor(m,w){this.a=w,this.b=null,this.c=new L({sendMessage:(p,M)=>{m(p,M)},handleMessage:(p,M)=>this.d(p,M),handleEvent:(p,M)=>this.f(p,M)})}onmessage(m){this.c.handleMessage(m)}d(m,w){if(m===l)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this.b[m].apply(this.b,w))}catch(p){return Promise.reject(p)}}f(m,w){if(!this.b)throw new Error("Missing requestHandler");if(o(m)){const p=this.b[m].call(this.b,w);if(typeof p!="function")throw new Error(`Missing dynamic event ${m} on request handler.`);return p}if(a(m)){const p=this.b[m];if(typeof p!="function")throw new Error(`Missing event ${m} on request handler.`);return p}throw new Error(`Malformed event name ${m}`)}g(m,w,p,M){this.c.setWorkerId(m);const P=u(M,(S,T)=>this.c.sendMessage(S,T),(S,T)=>this.c.listen(S,T));return this.a?(this.b=this.a(P),Promise.resolve((0,f.$sn)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy!==void 0&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((S,T)=>{(globalThis.require||V)([p],O=>{if(this.b=O.create(P),!this.b){T(new Error("No RequestHandler!"));return}S((0,f.$sn)(this.b))},T)}))}}t.SimpleWorkerServer=i;function c(E){return new i(E,null)}t.create=c}),ne(re[28],se([0,1,27]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6s=t.$5s=void 0;class k{constructor(h){const l=(0,_.$Ee)(h);this.c=l,this.a=k.d(l),this.b=new Map}static d(h){const l=new Uint8Array(256);return l.fill(h),l}set(h,l){const s=(0,_.$Ee)(l);h>=0&&h<256?this.a[h]=s:this.b.set(h,s)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$5s=k;var r;(function(v){v[v.False=0]="False",v[v.True=1]="True"})(r||(r={}));class f{constructor(){this.a=new k(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}t.$6s=f}),ne(re[4],se([0,1,3]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ps=t.$Os=void 0;class k{static addRange(v,h){let l=0;for(;l<h.length&&h[l].endExclusive<v.start;)l++;let s=l;for(;s<h.length&&h[s].start<=v.endExclusive;)s++;if(l===s)h.splice(l,0,v);else{const g=Math.min(v.start,h[l].start),A=Math.max(v.endExclusive,h[s-1].endExclusive);h.splice(l,s-l,new k(g,A))}}static tryCreate(v,h){if(!(v>h))return new k(v,h)}static ofLength(v){return new k(0,v)}static ofStartAndLength(v,h){return new k(v,v+h)}constructor(v,h){if(this.start=v,this.endExclusive=h,v>h)throw new _.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(v){return new k(this.start+v,this.endExclusive+v)}deltaStart(v){return new k(this.start+v,this.endExclusive)}deltaEnd(v){return new k(this.start,this.endExclusive+v)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(v){return this.start===v.start&&this.endExclusive===v.endExclusive}containsRange(v){return this.start<=v.start&&v.endExclusive<=this.endExclusive}contains(v){return this.start<=v&&v<this.endExclusive}join(v){return new k(Math.min(this.start,v.start),Math.max(this.endExclusive,v.endExclusive))}intersect(v){const h=Math.max(this.start,v.start),l=Math.min(this.endExclusive,v.endExclusive);if(h<=l)return new k(h,l)}intersectsOrTouches(v){const h=Math.max(this.start,v.start),l=Math.min(this.endExclusive,v.endExclusive);return h<=l}isBefore(v){return this.endExclusive<=v.start}isAfter(v){return this.start>=v.endExclusive}slice(v){return v.slice(this.start,this.endExclusive)}clip(v){if(this.isEmpty)throw new _.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,v))}clipCyclic(v){if(this.isEmpty)throw new _.$cb(`Invalid clipping range: ${this.toString()}`);return v<this.start?this.endExclusive-(this.start-v)%this.length:v>=this.endExclusive?this.start+(v-this.start)%this.length:v}map(v){const h=[];for(let l=this.start;l<this.endExclusive;l++)h.push(v(l));return h}forEach(v){for(let h=this.start;h<this.endExclusive;h++)v(h)}}t.$Os=k;class r{constructor(){this.a=[]}addRange(v){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<v.start;)h++;let l=h;for(;l<this.a.length&&this.a[l].start<=v.endExclusive;)l++;if(h===l)this.a.splice(h,0,v);else{const s=Math.min(v.start,this.a[h].start),g=Math.max(v.endExclusive,this.a[l-1].endExclusive);this.a.splice(h,l-h,new k(s,g))}}toString(){return this.a.map(v=>v.toString()).join(", ")}intersectsStrict(v){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<=v.start;)h++;return h<this.a.length&&this.a[h].start<v.endExclusive}intersectWithRange(v){const h=new r;for(const l of this.a){const s=l.intersect(v);s&&h.addRange(s)}return h}intersectWithRangeLength(v){return this.intersectWithRange(v).length}get length(){return this.a.reduce((v,h)=>v+h.length,0)}}t.$Ps=r}),ne(re[5],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gs=void 0;class _{constructor(r,f){this.lineNumber=r,this.column=f}with(r=this.lineNumber,f=this.column){return r===this.lineNumber&&f===this.column?this:new _(r,f)}delta(r=0,f=0){return this.with(this.lineNumber+r,this.column+f)}equals(r){return _.equals(this,r)}static equals(r,f){return!r&&!f?!0:!!r&&!!f&&r.lineNumber===f.lineNumber&&r.column===f.column}isBefore(r){return _.isBefore(this,r)}static isBefore(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<f.column}isBeforeOrEqual(r){return _.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<=f.column}static compare(r,f){const v=r.lineNumber|0,h=f.lineNumber|0;if(v===h){const l=r.column|0,s=f.column|0;return l-s}return v-h}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new _(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$Gs=_}),ne(re[2],se([0,1,5]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hs=void 0;class k{constructor(f,v,h,l){f>h||f===h&&v>l?(this.startLineNumber=h,this.startColumn=l,this.endLineNumber=f,this.endColumn=v):(this.startLineNumber=f,this.startColumn=v,this.endLineNumber=h,this.endColumn=l)}isEmpty(){return k.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return k.containsPosition(this,f)}static containsPosition(f,v){return!(v.lineNumber<f.startLineNumber||v.lineNumber>f.endLineNumber||v.lineNumber===f.startLineNumber&&v.column<f.startColumn||v.lineNumber===f.endLineNumber&&v.column>f.endColumn)}static strictContainsPosition(f,v){return!(v.lineNumber<f.startLineNumber||v.lineNumber>f.endLineNumber||v.lineNumber===f.startLineNumber&&v.column<=f.startColumn||v.lineNumber===f.endLineNumber&&v.column>=f.endColumn)}containsRange(f){return k.containsRange(this,f)}static containsRange(f,v){return!(v.startLineNumber<f.startLineNumber||v.endLineNumber<f.startLineNumber||v.startLineNumber>f.endLineNumber||v.endLineNumber>f.endLineNumber||v.startLineNumber===f.startLineNumber&&v.startColumn<f.startColumn||v.endLineNumber===f.endLineNumber&&v.endColumn>f.endColumn)}strictContainsRange(f){return k.strictContainsRange(this,f)}static strictContainsRange(f,v){return!(v.startLineNumber<f.startLineNumber||v.endLineNumber<f.startLineNumber||v.startLineNumber>f.endLineNumber||v.endLineNumber>f.endLineNumber||v.startLineNumber===f.startLineNumber&&v.startColumn<=f.startColumn||v.endLineNumber===f.endLineNumber&&v.endColumn>=f.endColumn)}plusRange(f){return k.plusRange(this,f)}static plusRange(f,v){let h,l,s,g;return v.startLineNumber<f.startLineNumber?(h=v.startLineNumber,l=v.startColumn):v.startLineNumber===f.startLineNumber?(h=v.startLineNumber,l=Math.min(v.startColumn,f.startColumn)):(h=f.startLineNumber,l=f.startColumn),v.endLineNumber>f.endLineNumber?(s=v.endLineNumber,g=v.endColumn):v.endLineNumber===f.endLineNumber?(s=v.endLineNumber,g=Math.max(v.endColumn,f.endColumn)):(s=f.endLineNumber,g=f.endColumn),new k(h,l,s,g)}intersectRanges(f){return k.intersectRanges(this,f)}static intersectRanges(f,v){let h=f.startLineNumber,l=f.startColumn,s=f.endLineNumber,g=f.endColumn;const A=v.startLineNumber,b=v.startColumn,$=v.endLineNumber,e=v.endColumn;return h<A?(h=A,l=b):h===A&&(l=Math.max(l,b)),s>$?(s=$,g=e):s===$&&(g=Math.min(g,e)),h>s||h===s&&l>g?null:new k(h,l,s,g)}equalsRange(f){return k.equalsRange(this,f)}static equalsRange(f,v){return!f&&!v?!0:!!f&&!!v&&f.startLineNumber===v.startLineNumber&&f.startColumn===v.startColumn&&f.endLineNumber===v.endLineNumber&&f.endColumn===v.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(f){return new _.$Gs(f.endLineNumber,f.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(f){return new _.$Gs(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,v){return new k(this.startLineNumber,this.startColumn,f,v)}setStartPosition(f,v){return new k(f,v,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(f){return new k(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return k.collapseToEnd(this)}static collapseToEnd(f){return new k(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new k(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,v=f){return new k(f.lineNumber,f.column,v.lineNumber,v.column)}static lift(f){return f?new k(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,v){return!(f.endLineNumber<v.startLineNumber||f.endLineNumber===v.startLineNumber&&f.endColumn<v.startColumn||v.endLineNumber<f.startLineNumber||v.endLineNumber===f.startLineNumber&&v.endColumn<f.startColumn)}static areIntersecting(f,v){return!(f.endLineNumber<v.startLineNumber||f.endLineNumber===v.startLineNumber&&f.endColumn<=v.startColumn||v.endLineNumber<f.startLineNumber||v.endLineNumber===f.startLineNumber&&v.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,v){if(f&&v){const s=f.startLineNumber|0,g=v.startLineNumber|0;if(s===g){const A=f.startColumn|0,b=v.startColumn|0;if(A===b){const $=f.endLineNumber|0,e=v.endLineNumber|0;if($===e){const N=f.endColumn|0,R=v.endColumn|0;return N-R}return $-e}return A-b}return s-g}return(f?1:0)-(v?1:0)}static compareRangesUsingEnds(f,v){return f.endLineNumber===v.endLineNumber?f.endColumn===v.endColumn?f.startLineNumber===v.startLineNumber?f.startColumn-v.startColumn:f.startLineNumber-v.startLineNumber:f.endColumn-v.endColumn:f.endLineNumber-v.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.$Hs=k}),ne(re[44],se([0,1,2]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Is=void 0;class k{static insert(f,v){return{range:new _.$Hs(f.lineNumber,f.column,f.lineNumber,f.column),text:v,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,v){return{range:f,text:v}}static replaceMove(f,v){return{range:f,text:v,forceMoveMarkers:!0}}}t.$Is=k}),ne(re[12],se([0,1,3,4,2,9]),function(V,t,_,k,r,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rs=t.$Qs=void 0;class v{static fromRange(s){return new v(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new v(s.startLineNumber,s.endLineNumber+1)}static subtract(s,g){return g?s.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<s.endLineNumberExclusive?[new v(s.startLineNumber,g.startLineNumber),new v(g.endLineNumberExclusive,s.endLineNumberExclusive)]:g.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<s.endLineNumberExclusive?[new v(Math.max(g.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new v(s.startLineNumber,Math.min(g.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let g=new h(s[0].slice());for(let A=1;A<s.length;A++)g=g.getUnion(new h(s[A].slice()));return g.ranges}static ofLength(s,g){return new v(s,s+g)}static deserialize(s){return new v(s[0],s[1])}constructor(s,g){if(s>g)throw new _.$cb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=s,this.endLineNumberExclusive=g}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new v(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new v(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new v(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const g=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(g<=A)return new v(g,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$Hs(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$Hs(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const g=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)g.push(s(A));return g}forEach(s){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)s(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new k.$Os(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Qs=v;class h{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const g=(0,f.$kb)(this.c,b=>b.endLineNumberExclusive>=s.startLineNumber),A=(0,f.$ib)(this.c,b=>b.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)this.c.splice(g,0,s);else if(g===A-1){const b=this.c[g];this.c[g]=b.join(s)}else{const b=this.c[g].join(this.c[A-1]).join(s);this.c.splice(g,A-g,b)}}contains(s){const g=(0,f.$hb)(this.c,A=>A.startLineNumber<=s);return!!g&&g.endLineNumberExclusive>s}intersects(s){const g=(0,f.$hb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const g=[];let A=0,b=0,$=null;for(;A<this.c.length||b<s.c.length;){let e=null;if(A<this.c.length&&b<s.c.length){const N=this.c[A],R=s.c[b];N.startLineNumber<R.startLineNumber?(e=N,A++):(e=R,b++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[b],b++);$===null?$=e:$.endLineNumberExclusive>=e.startLineNumber?$=new v($.startLineNumber,Math.max($.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push($),$=e)}return $!==null&&g.push($),new h(g)}subtractFrom(s){const g=(0,f.$kb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,f.$ib)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)return new h([s]);const b=[];let $=s.startLineNumber;for(let e=g;e<A;e++){const N=this.c[e];N.startLineNumber>$&&b.push(new v($,N.startLineNumber)),$=N.endLineNumberExclusive}return $<s.endLineNumberExclusive&&b.push(new v($,s.endLineNumberExclusive)),new h(b)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const g=[];let A=0,b=0;for(;A<this.c.length&&b<s.c.length;){const $=this.c[A],e=s.c[b],N=$.intersect(e);N&&!N.isEmpty&&g.push(N),$.endLineNumberExclusive<e.endLineNumberExclusive?A++:b++}return new h(g)}getWithDelta(s){return new h(this.c.map(g=>g.delta(s)))}}t.$Rs=h}),ne(re[45],se([0,1,5,2]),function(V,t,_,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Js=t.SelectionDirection=void 0;var r;(function(v){v[v.LTR=0]="LTR",v[v.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class f extends k.$Hs{constructor(h,l,s,g){super(h,l,s,g),this.selectionStartLineNumber=h,this.selectionStartColumn=l,this.positionLineNumber=s,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,l){return h.selectionStartLineNumber===l.selectionStartLineNumber&&h.selectionStartColumn===l.selectionStartColumn&&h.positionLineNumber===l.positionLineNumber&&h.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,l){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,l):new f(h,l,this.startLineNumber,this.startColumn)}getPosition(){return new _.$Gs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new _.$Gs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,l){return this.getDirection()===0?new f(h,l,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,l)}static fromPositions(h,l=h){return new f(h.lineNumber,h.column,l.lineNumber,l.column)}static fromRange(h,l){return l===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,l){if(h&&!l||!h&&l)return!1;if(!h&&!l)return!0;if(h.length!==l.length)return!1;for(let s=0,g=h.length;s<g;s++)if(!this.selectionsEqual(h[s],l[s]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,l,s,g,A){return A===0?new f(h,l,s,g):new f(s,g,h,l)}}t.$Js=f}),ne(re[46],se([0,1,28]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8s=t.$7s=t.WordCharacterClass=void 0;var k;(function(v){v[v.Regular=0]="Regular",v[v.Whitespace=1]="Whitespace",v[v.WordSeparator=2]="WordSeparator"})(k||(t.WordCharacterClass=k={}));class r extends _.$5s{constructor(h){super(0);for(let l=0,s=h.length;l<s;l++)this.set(h.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$7s=r;function f(v){const h={};return l=>(h.hasOwnProperty(l)||(h[l]=v(l)),h[l])}t.$8s=f(v=>new r(v))}),ne(re[29],se([0,1,20,10,21]),function(V,t,_,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$js=t.$is=t.$hs=t.$gs=t.$fs=void 0,t.$fs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(A=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const $ of t.$fs)A.indexOf($)>=0||(b+="\\"+$);return b+="\\s]+)",new RegExp(b,"g")}t.$gs=f();function v(A){let b=t.$gs;if(A&&A instanceof RegExp)if(A.global)b=A;else{let $="g";A.ignoreCase&&($+="i"),A.multiline&&($+="m"),A.unicode&&($+="u"),b=new RegExp(A.source,$)}return b.lastIndex=0,b}t.$hs=v;const h=new r.$3c;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(A){const b=h.unshift(A);return(0,k.$Qc)(b)}t.$is=l;function s(A,b,$,e,N){if(b=v(b),N||(N=_.Iterable.first(h)),$.length>N.maxLen){let o=A-N.maxLen/2;return o<0?o=0:e+=o,$=$.substring(o,A+N.maxLen/2),s(A,b,$,e,N)}const R=Date.now(),L=A-1-e;let d=-1,a=null;for(let o=1;!(Date.now()-R>=N.timeBudget);o++){const u=L-N.windowSize*o;b.lastIndex=Math.max(0,u);const i=g(b,$,L,d);if(!i&&a||(a=i,u<=0))break;d=u}if(a){const o={word:a[0],startColumn:e+1+a.index,endColumn:e+1+a.index+a[0].length};return b.lastIndex=0,o}return null}t.$js=s;function g(A,b,$,e){let N;for(;N=A.exec(b);){const R=N.index||0;if(R<=$&&A.lastIndex>=$)return N;if(e>0&&R>e)return null}return null}}),ne(re[8],se([0,1,6,3,4]),function(V,t,_,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zZ=t.$yZ=t.$xZ=t.$wZ=t.$vZ=void 0;class f{static trivial(A,b){return new f([new v(r.$Os.ofLength(A.length),r.$Os.ofLength(b.length))],!1)}static trivialTimedOut(A,b){return new f([new v(r.$Os.ofLength(A.length),r.$Os.ofLength(b.length))],!0)}constructor(A,b){this.diffs=A,this.hitTimeout=b}}t.$vZ=f;class v{static invert(A,b){const $=[];return(0,_.$Bb)(A,(e,N)=>{$.push(v.fromOffsetPairs(e?e.getEndExclusives():h.zero,N?N.getStarts():new h(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),$}static fromOffsetPairs(A,b){return new v(new r.$Os(A.offset1,b.offset1),new r.$Os(A.offset2,b.offset2))}constructor(A,b){this.seq1Range=A,this.seq2Range=b}swap(){return new v(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new v(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new v(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new v(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new v(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const b=this.seq1Range.intersect(A.seq1Range),$=this.seq2Range.intersect(A.seq2Range);if(!(!b||!$))return new v(b,$)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$wZ=v;class h{constructor(A,b){this.offset1=A,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}}t.$xZ=h,h.zero=new h(0,0),h.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class l{isValid(){return!0}}t.$yZ=l,l.instance=new l;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new k.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$zZ=s}),ne(re[30],se([0,1,4,8]),function(V,t,_,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EZ=void 0;class r{compute(s,g,A=k.$yZ.instance){if(s.length===0||g.length===0)return k.$vZ.trivial(s,g);const b=s,$=g;function e(c,E){for(;c<b.length&&E<$.length&&b.getElement(c)===$.getElement(E);)c++,E++;return c}let N=0;const R=new v;R.set(0,e(0,0));const L=new h;L.set(0,R.get(0)===0?null:new f(null,0,0,R.get(0)));let d=0;e:for(;;){if(N++,!A.isValid())return k.$vZ.trivialTimedOut(b,$);const c=-Math.min(N,$.length+N%2),E=Math.min(N,b.length+N%2);for(d=c;d<=E;d+=2){let m=0;const w=d===E?-1:R.get(d+1),p=d===c?-1:R.get(d-1)+1;m++;const M=Math.min(Math.max(w,p),b.length),F=M-d;if(m++,M>b.length||F>$.length)continue;const y=e(M,F);R.set(d,y);const P=M===w?L.get(d+1):L.get(d-1);if(L.set(d,y!==M?new f(P,M,F,y-M):P),R.get(d)===b.length&&R.get(d)-d===$.length)break e}}let a=L.get(d);const o=[];let u=b.length,i=$.length;for(;;){const c=a?a.x+a.length:0,E=a?a.y+a.length:0;if((c!==u||E!==i)&&o.push(new k.$wZ(new _.$Os(c,u),new _.$Os(E,i))),!a)break;u=a.x,i=a.y,a=a.prev}return o.reverse(),new k.$vZ(o,!1)}}t.$EZ=r;class f{constructor(s,g,A,b){this.prev=s,this.x=g,this.y=A,this.length=b}}class v{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=g}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=g}}}class h{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){s<0?(s=-s-1,this.b[s]=g):this.a[s]=g}}}),ne(re[47],se([0,1,6,4,8]),function(V,t,_,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MZ=t.$LZ=t.$KZ=t.$JZ=t.$IZ=void 0;function f(e,N,R){let L=R;return L=v(e,N,L),L=v(e,N,L),L=h(e,N,L),L}t.$IZ=f;function v(e,N,R){if(R.length===0)return R;const L=[];L.push(R[0]);for(let a=1;a<R.length;a++){const o=L[L.length-1];let u=R[a];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=u.seq1Range.start-o.seq1Range.endExclusive;let c;for(c=1;c<=i&&!(e.getElement(u.seq1Range.start-c)!==e.getElement(u.seq1Range.endExclusive-c)||N.getElement(u.seq2Range.start-c)!==N.getElement(u.seq2Range.endExclusive-c));c++);if(c--,c===i){L[L.length-1]=new r.$wZ(new k.$Os(o.seq1Range.start,u.seq1Range.endExclusive-i),new k.$Os(o.seq2Range.start,u.seq2Range.endExclusive-i));continue}u=u.delta(-c)}L.push(u)}const d=[];for(let a=0;a<L.length-1;a++){const o=L[a+1];let u=L[a];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=o.seq1Range.start-u.seq1Range.endExclusive;let c;for(c=0;c<i&&!(!e.isStronglyEqual(u.seq1Range.start+c,u.seq1Range.endExclusive+c)||!N.isStronglyEqual(u.seq2Range.start+c,u.seq2Range.endExclusive+c));c++);if(c===i){L[a+1]=new r.$wZ(new k.$Os(u.seq1Range.start+i,o.seq1Range.endExclusive),new k.$Os(u.seq2Range.start+i,o.seq2Range.endExclusive));continue}c>0&&(u=u.delta(c))}d.push(u)}return L.length>0&&d.push(L[L.length-1]),d}function h(e,N,R){if(!e.getBoundaryScore||!N.getBoundaryScore)return R;for(let L=0;L<R.length;L++){const d=L>0?R[L-1]:void 0,a=R[L],o=L+1<R.length?R[L+1]:void 0,u=new k.$Os(d?d.seq1Range.start+1:0,o?o.seq1Range.endExclusive-1:e.length),i=new k.$Os(d?d.seq2Range.start+1:0,o?o.seq2Range.endExclusive-1:N.length);a.seq1Range.isEmpty?R[L]=l(a,e,N,u,i):a.seq2Range.isEmpty&&(R[L]=l(a.swap(),N,e,i,u).swap())}return R}function l(e,N,R,L,d){let o=1;for(;e.seq1Range.start-o>=L.start&&e.seq2Range.start-o>=d.start&&R.isStronglyEqual(e.seq2Range.start-o,e.seq2Range.endExclusive-o)&&o<100;)o++;o--;let u=0;for(;e.seq1Range.start+u<L.endExclusive&&e.seq2Range.endExclusive+u<d.endExclusive&&R.isStronglyEqual(e.seq2Range.start+u,e.seq2Range.endExclusive+u)&&u<100;)u++;if(o===0&&u===0)return e;let i=0,c=-1;for(let E=-o;E<=u;E++){const m=e.seq2Range.start+E,w=e.seq2Range.endExclusive+E,p=e.seq1Range.start+E,M=N.getBoundaryScore(p)+R.getBoundaryScore(m)+R.getBoundaryScore(w);M>c&&(c=M,i=E)}return e.delta(i)}function s(e,N,R){const L=[];for(const d of R){const a=L[L.length-1];if(!a){L.push(d);continue}d.seq1Range.start-a.seq1Range.endExclusive<=2||d.seq2Range.start-a.seq2Range.endExclusive<=2?L[L.length-1]=new r.$wZ(a.seq1Range.join(d.seq1Range),a.seq2Range.join(d.seq2Range)):L.push(d)}return L}t.$JZ=s;function g(e,N,R){const L=[];let d;function a(){if(!d)return;const u=d.s1Range.length-d.deleted,i=d.s2Range.length-d.added;Math.max(d.deleted,d.added)+(d.count-1)>u&&L.push(new r.$wZ(d.s1Range,d.s2Range)),d=void 0}for(const u of R){let i=function(p,M){if(!d||!d.s1Range.containsRange(p)||!d.s2Range.containsRange(M))if(d&&!(d.s1Range.endExclusive<p.start&&d.s2Range.endExclusive<M.start)){const P=k.$Os.tryCreate(d.s1Range.endExclusive,p.start),S=k.$Os.tryCreate(d.s2Range.endExclusive,M.start);d.deleted+=P?.length??0,d.added+=S?.length??0,d.s1Range=d.s1Range.join(p),d.s2Range=d.s2Range.join(M)}else a(),d={added:0,deleted:0,count:0,s1Range:p,s2Range:M};const F=p.intersect(u.seq1Range),y=M.intersect(u.seq2Range);d.count++,d.deleted+=F?.length??0,d.added+=y?.length??0};const c=e.findWordContaining(u.seq1Range.start-1),E=N.findWordContaining(u.seq2Range.start-1),m=e.findWordContaining(u.seq1Range.endExclusive),w=N.findWordContaining(u.seq2Range.endExclusive);c&&m&&E&&w&&c.equals(m)&&E.equals(w)?i(c,E):(c&&E&&i(c,E),m&&w&&i(m,w))}return a(),A(R,L)}t.$KZ=g;function A(e,N){const R=[];for(;e.length>0||N.length>0;){const L=e[0],d=N[0];let a;L&&(!d||L.seq1Range.start<d.seq1Range.start)?a=e.shift():a=N.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=a.seq1Range.start?R[R.length-1]=R[R.length-1].join(a):R.push(a)}return R}function b(e,N,R){let L=R;if(L.length===0)return L;let d=0,a;do{a=!1;const o=[L[0]];for(let u=1;u<L.length;u++){let E=function(w,p){const M=new k.$Os(c.seq1Range.endExclusive,i.seq1Range.start);return e.getText(M).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||p.seq1Range.length+p.seq2Range.length>5)};const i=L[u],c=o[o.length-1];E(c,i)?(a=!0,o[o.length-1]=o[o.length-1].join(i)):o.push(i)}L=o}while(d++<10&&a);return L}t.$LZ=b;function $(e,N,R){let L=R;if(L.length===0)return L;let d=0,a;do{a=!1;const u=[L[0]];for(let i=1;i<L.length;i++){let m=function(p,M){const F=new k.$Os(E.seq1Range.endExclusive,c.seq1Range.start);if(e.countLinesIn(F)>5||F.length>500)return!1;const P=e.getText(F).trim();if(P.length>20||P.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(p.seq1Range),T=p.seq1Range.length,q=N.countLinesIn(p.seq2Range),O=p.seq2Range.length,D=e.countLinesIn(M.seq1Range),j=M.seq1Range.length,z=N.countLinesIn(M.seq2Range),x=M.seq2Range.length,J=2*40+50;function te(n){return Math.min(n,J)}return Math.pow(Math.pow(te(S*40+T),1.5)+Math.pow(te(q*40+O),1.5),1.5)+Math.pow(Math.pow(te(D*40+j),1.5)+Math.pow(te(z*40+x),1.5),1.5)>(J**1.5)**1.5*1.3};const c=L[i],E=u[u.length-1];m(E,c)?(a=!0,u[u.length-1]=u[u.length-1].join(c)):u.push(c)}L=u}while(d++<10&&a);const o=[];return(0,_.$Cb)(L,(u,i,c)=>{let E=i;function m(P){return P.length>0&&P.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const w=e.extendToFullLines(i.seq1Range),p=e.getText(new k.$Os(w.start,i.seq1Range.start));m(p)&&(E=E.deltaStart(-p.length));const M=e.getText(new k.$Os(i.seq1Range.endExclusive,w.endExclusive));m(M)&&(E=E.deltaEnd(M.length));const F=r.$wZ.fromOffsetPairs(u?u.getEndExclusives():r.$xZ.zero,c?c.getStarts():r.$xZ.max),y=E.intersect(F);o.push(y)}),o}t.$MZ=$}),ne(re[48],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HZ=void 0;class _{constructor(f,v){this.a=f,this.b=v}getElement(f){return this.a[f]}get length(){return this.a.length}getBoundaryScore(f){const v=f===0?0:k(this.b[f-1]),h=f===this.b.length?0:k(this.b[f]);return 1e3-(v+h)}getText(f){return this.b.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,v){return this.b[f]===this.b[v]}}t.$HZ=_;function k(r){let f=0;for(;f<r.length&&(r.charCodeAt(f)===32||r.charCodeAt(f)===9);)f++;return f}}),ne(re[17],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CZ=t.$BZ=t.$AZ=void 0;class _{constructor(v,h){this.width=v,this.height=h,this.a=[],this.a=new Array(v*h)}get(v,h){return this.a[v+h*this.width]}set(v,h,l){this.a[v+h*this.width]=l}}t.$AZ=_;function k(f){return f===32||f===9}t.$BZ=k;class r{static b(v){let h=this.a.get(v);return h===void 0&&(h=this.a.size,this.a.set(v,h)),h}constructor(v,h,l){this.range=v,this.lines=h,this.source=l,this.d=[];let s=0;for(let g=v.startLineNumber-1;g<v.endLineNumberExclusive-1;g++){const A=h[g];for(let $=0;$<A.length;$++){s++;const e=A[$],N=r.b(e);this.d[N]=(this.d[N]||0)+1}s++;const b=r.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=s}computeSimilarity(v){let h=0;const l=Math.max(this.d.length,v.d.length);for(let s=0;s<l;s++)h+=Math.abs((this.d[s]??0)-(v.d[s]??0));return 1-h/(this.c+v.c)}}t.$CZ=r,r.a=new Map}),ne(re[49],se([0,1,4,8,17]),function(V,t,_,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DZ=void 0;class f{compute(h,l,s=k.$yZ.instance,g){if(h.length===0||l.length===0)return k.$vZ.trivial(h,l);const A=new r.$AZ(h.length,l.length),b=new r.$AZ(h.length,l.length),$=new r.$AZ(h.length,l.length);for(let o=0;o<h.length;o++)for(let u=0;u<l.length;u++){if(!s.isValid())return k.$vZ.trivialTimedOut(h,l);const i=o===0?0:A.get(o-1,u),c=u===0?0:A.get(o,u-1);let E;h.getElement(o)===l.getElement(u)?(o===0||u===0?E=0:E=A.get(o-1,u-1),o>0&&u>0&&b.get(o-1,u-1)===3&&(E+=$.get(o-1,u-1)),E+=g?g(o,u):1):E=-1;const m=Math.max(i,c,E);if(m===E){const w=o>0&&u>0?$.get(o-1,u-1):0;$.set(o,u,w+1),b.set(o,u,3)}else m===i?($.set(o,u,0),b.set(o,u,1)):m===c&&($.set(o,u,0),b.set(o,u,2));A.set(o,u,m)}const e=[];let N=h.length,R=l.length;function L(o,u){(o+1!==N||u+1!==R)&&e.push(new k.$wZ(new _.$Os(o+1,N),new _.$Os(u+1,R))),N=o,R=u}let d=h.length-1,a=l.length-1;for(;d>=0&&a>=0;)b.get(d,a)===3?(L(d,a),d--,a--):b.get(d,a)===1?d--:a--;return L(-1,-1),e.reverse(),new k.$vZ(e,!1)}}t.$DZ=f}),ne(re[31],se([0,1,9,4,5,2,17]),function(V,t,_,k,r,f,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FZ=void 0;class h{constructor(e,N,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let L=!1;N.start>0&&N.endExclusive>=e.length&&(N=new k.$Os(N.start-1,N.endExclusive),L=!0),this.lineRange=N,this.c[0]=0;for(let d=this.lineRange.start;d<this.lineRange.endExclusive;d++){let a=e[d],o=0;if(L)o=a.length,a="",L=!1;else if(!R){const u=a.trimStart();o=a.length-u.length,a=u.trimEnd()}this.d.push(o);for(let u=0;u<a.length;u++)this.b.push(a.charCodeAt(u));d<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[d-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new k.$Os(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(N=>String.fromCharCode(N)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const N=b(e>0?this.b[e-1]:-1),R=b(e<this.b.length?this.b[e]:-1);if(N===7&&R===8)return 0;let L=0;return N!==R&&(L+=10,N===0&&R===1&&(L+=1)),L+=A(N),L+=A(R),L}translateOffset(e){if(this.lineRange.isEmpty)return new r.$Gs(this.lineRange.start+1,1);const N=(0,_.$ib)(this.c,R=>R<=e);return new r.$Gs(this.lineRange.start+N+1,e-this.c[N]+this.d[N]+1)}translateRange(e){return f.$Hs.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let N=e;for(;N>0&&l(this.b[N-1]);)N--;let R=e;for(;R<this.b.length&&l(this.b[R]);)R++;return new k.$Os(N,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,N){return this.b[e]===this.b[N]}extendToFullLines(e){const N=(0,_.$hb)(this.c,L=>L<=e.start)??0,R=(0,_.$jb)(this.c,L=>e.endExclusive<=L)??this.b.length;return new k.$Os(N,R)}}t.$FZ=h;function l($){return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57}var s;(function($){$[$.WordLower=0]="WordLower",$[$.WordUpper=1]="WordUpper",$[$.WordNumber=2]="WordNumber",$[$.End=3]="End",$[$.Other=4]="Other",$[$.Separator=5]="Separator",$[$.Space=6]="Space",$[$.LineBreakCR=7]="LineBreakCR",$[$.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const g={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:3,[7]:10,[8]:10};function A($){return g[$]}function b($){return $===10?8:$===13?7:(0,v.$BZ)($)?6:$>=97&&$<=122?0:$>=65&&$<=90?1:$>=48&&$<=57?2:$===-1?3:$===44||$===59?5:4}}),ne(re[32],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ws=t.$Vs=void 0;class _{constructor(f,v,h){this.changes=f,this.moves=v,this.hitTimeout=h}}t.$Vs=_;class k{constructor(f,v){this.lineRangeMapping=f,this.changes=v}flip(){return new k(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.$Ws=k}),ne(re[18],se([0,1,12]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Us=t.$Ts=t.$Ss=void 0;class k{static inverse(h,l,s){const g=[];let A=1,b=1;for(const e of h){const N=new r(new _.$Qs(A,e.original.startLineNumber),new _.$Qs(b,e.modified.startLineNumber),void 0);N.modified.isEmpty||g.push(N),A=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const $=new r(new _.$Qs(A,l+1),new _.$Qs(b,s+1),void 0);return $.modified.isEmpty||g.push($),g}constructor(h,l){this.original=h,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new k(this.modified,this.original)}join(h){return new k(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$Ss=k;class r extends k{constructor(h,l,s){super(h,l),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}}t.$Ts=r;class f{constructor(h,l){this.originalRange=h,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.$Us=f}),ne(re[50],se([0,1,8,18,6,9,22,12,4,31,17,30]),function(V,t,_,k,r,f,v,h,l,s,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GZ=void 0;function b(a,o,u,i,c,E){let{moves:m,excludedChanges:w}=e(a,o,u,E);if(!E.isValid())return[];const p=a.filter(F=>!w.has(F)),M=N(p,i,c,o,u,E);return(0,r.$1b)(m,M),m=L(m),m=m.filter(F=>{const y=F.original.toOffsetRange().slice(o).map(S=>S.trim());return y.join(`
`).length>=15&&$(y,S=>S.length>=2)>=2}),m=d(a,m),m}t.$GZ=b;function $(a,o){let u=0;for(const i of a)o(i)&&u++;return u}function e(a,o,u,i){const c=[],E=a.filter(p=>p.modified.isEmpty&&p.original.length>=3).map(p=>new g.$CZ(p.original,o,p)),m=new Set(a.filter(p=>p.original.isEmpty&&p.modified.length>=3).map(p=>new g.$CZ(p.modified,u,p))),w=new Set;for(const p of E){let M=-1,F;for(const y of m){const P=p.computeSimilarity(y);P>M&&(M=P,F=y)}if(M>.9&&F&&(m.delete(F),c.push(new k.$Ss(p.range,F.range)),w.add(p.source),w.add(F.source)),!i.isValid())return{moves:c,excludedChanges:w}}return{moves:c,excludedChanges:w}}function N(a,o,u,i,c,E){const m=[],w=new v.$Gc;for(const P of a)for(let S=P.original.startLineNumber;S<P.original.endLineNumberExclusive-2;S++){const T=`${o[S-1]}:${o[S+1-1]}:${o[S+2-1]}`;w.add(T,{range:new h.$Qs(S,S+3)})}const p=[];a.sort((0,r.$7b)(P=>P.modified.startLineNumber,r.$9b));for(const P of a){let S=[];for(let T=P.modified.startLineNumber;T<P.modified.endLineNumberExclusive-2;T++){const q=`${u[T-1]}:${u[T+1-1]}:${u[T+2-1]}`,O=new h.$Qs(T,T+3),D=[];w.forEach(q,({range:j})=>{for(const x of S)if(x.originalLineRange.endLineNumberExclusive+1===j.endLineNumberExclusive&&x.modifiedLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive){x.originalLineRange=new h.$Qs(x.originalLineRange.startLineNumber,j.endLineNumberExclusive),x.modifiedLineRange=new h.$Qs(x.modifiedLineRange.startLineNumber,O.endLineNumberExclusive),D.push(x);return}const z={modifiedLineRange:O,originalLineRange:j};p.push(z),D.push(z)}),S=D}if(!E.isValid())return[]}p.sort((0,r.$$b)((0,r.$7b)(P=>P.modifiedLineRange.length,r.$9b)));const M=new h.$Rs,F=new h.$Rs;for(const P of p){const S=P.modifiedLineRange.startLineNumber-P.originalLineRange.startLineNumber,T=M.subtractFrom(P.modifiedLineRange),q=F.subtractFrom(P.originalLineRange).getWithDelta(S),O=T.getIntersection(q);for(const D of O.ranges){if(D.length<3)continue;const j=D,z=D.delta(-S);m.push(new k.$Ss(z,j)),M.addRange(j),F.addRange(z)}}m.sort((0,r.$7b)(P=>P.original.startLineNumber,r.$9b));const y=new f.$mb(a);for(let P=0;P<m.length;P++){const S=m[P],T=y.findLastMonotonous(te=>te.original.startLineNumber<=S.original.startLineNumber),q=(0,f.$hb)(a,te=>te.modified.startLineNumber<=S.modified.startLineNumber),O=Math.max(S.original.startLineNumber-T.original.startLineNumber,S.modified.startLineNumber-q.modified.startLineNumber),D=y.findLastMonotonous(te=>te.original.startLineNumber<S.original.endLineNumberExclusive),j=(0,f.$hb)(a,te=>te.modified.startLineNumber<S.modified.endLineNumberExclusive),z=Math.max(D.original.endLineNumberExclusive-S.original.endLineNumberExclusive,j.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let x;for(x=0;x<O;x++){const te=S.original.startLineNumber-x-1,n=S.modified.startLineNumber-x-1;if(te>i.length||n>c.length||M.contains(n)||F.contains(te)||!R(i[te-1],c[n-1],E))break}x>0&&(F.addRange(new h.$Qs(S.original.startLineNumber-x,S.original.startLineNumber)),M.addRange(new h.$Qs(S.modified.startLineNumber-x,S.modified.startLineNumber)));let J;for(J=0;J<z;J++){const te=S.original.endLineNumberExclusive+J,n=S.modified.endLineNumberExclusive+J;if(te>i.length||n>c.length||M.contains(n)||F.contains(te)||!R(i[te-1],c[n-1],E))break}J>0&&(F.addRange(new h.$Qs(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+J)),M.addRange(new h.$Qs(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+J))),(x>0||J>0)&&(m[P]=new k.$Ss(new h.$Qs(S.original.startLineNumber-x,S.original.endLineNumberExclusive+J),new h.$Qs(S.modified.startLineNumber-x,S.modified.endLineNumberExclusive+J)))}return m}function R(a,o,u){if(a.trim()===o.trim())return!0;if(a.length>300&&o.length>300)return!1;const c=new A.$EZ().compute(new s.$FZ([a],new l.$Os(0,1),!1),new s.$FZ([o],new l.$Os(0,1),!1),u);let E=0;const m=_.$wZ.invert(c.diffs,a.length);for(const F of m)F.seq1Range.forEach(y=>{(0,g.$BZ)(a.charCodeAt(y))||E++});function w(F){let y=0;for(let P=0;P<a.length;P++)(0,g.$BZ)(F.charCodeAt(P))||y++;return y}const p=w(a.length>o.length?a:o);return E/p>.6&&p>10}function L(a){if(a.length===0)return a;a.sort((0,r.$7b)(u=>u.original.startLineNumber,r.$9b));const o=[a[0]];for(let u=1;u<a.length;u++){const i=o[o.length-1],c=a[u],E=c.original.startLineNumber-i.original.endLineNumberExclusive,m=c.modified.startLineNumber-i.modified.endLineNumberExclusive;if(E>=0&&m>=0&&E+m<=2){o[o.length-1]=i.join(c);continue}o.push(c)}return o}function d(a,o){const u=new f.$mb(a);return o=o.filter(i=>{const c=u.findLastMonotonous(w=>w.original.startLineNumber<i.original.endLineNumberExclusive)||new k.$Ss(new h.$Qs(1,1),new h.$Qs(1,1)),E=(0,f.$hb)(a,w=>w.modified.startLineNumber<i.modified.endLineNumberExclusive);return c!==E}),o}}),ne(re[51],se([0,1,6,13,12,4,2,8,49,30,50,47,32,18,31,48]),function(V,t,_,k,r,f,v,h,l,s,g,A,b,$,e,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PZ=t.$OZ=t.$NZ=void 0;class R{constructor(){this.e=new l.$DZ,this.f=new s.$EZ}computeDiff(o,u,i){if(o.length<=1&&(0,_.$ub)(o,u,(J,te)=>J===te))return new b.$Vs([],[],!1);if(o.length===1&&o[0].length===0||u.length===1&&u[0].length===0)return new b.$Vs([new $.$Ts(new r.$Qs(1,o.length+1),new r.$Qs(1,u.length+1),[new $.$Us(new v.$Hs(1,1,o.length,o[0].length+1),new v.$Hs(1,1,u.length,u[0].length+1))])],[],!1);const c=i.maxComputationTimeMs===0?h.$yZ.instance:new h.$zZ(i.maxComputationTimeMs),E=!i.ignoreTrimWhitespace,m=new Map;function w(J){let te=m.get(J);return te===void 0&&(te=m.size,m.set(J,te)),te}const p=o.map(J=>w(J.trim())),M=u.map(J=>w(J.trim())),F=new N.$HZ(p,o),y=new N.$HZ(M,u),P=(()=>F.length+y.length<1700?this.e.compute(F,y,c,(J,te)=>o[J]===u[te]?u[te].length===0?.1:1+Math.log(1+u[te].length):.99):this.f.compute(F,y))();let S=P.diffs,T=P.hitTimeout;S=(0,A.$IZ)(F,y,S),S=(0,A.$LZ)(F,y,S);const q=[],O=J=>{if(E)for(let te=0;te<J;te++){const n=D+te,ae=j+te;if(o[n]!==u[ae]){const de=this.j(o,u,new h.$wZ(new f.$Os(n,n+1),new f.$Os(ae,ae+1)),c,E);for(const $e of de.mappings)q.push($e);de.hitTimeout&&(T=!0)}}};let D=0,j=0;for(const J of S){(0,k.$7c)(()=>J.seq1Range.start-D===J.seq2Range.start-j);const te=J.seq1Range.start-D;O(te),D=J.seq1Range.endExclusive,j=J.seq2Range.endExclusive;const n=this.j(o,u,J,c,E);n.hitTimeout&&(T=!0);for(const ae of n.mappings)q.push(ae)}O(o.length-D);const z=L(q,o,u);let x=[];return i.computeMoves&&(x=this.h(z,o,u,p,M,c,E)),(0,k.$7c)(()=>{function J(n,ae){if(n.lineNumber<1||n.lineNumber>ae.length)return!1;const de=ae[n.lineNumber-1];return!(n.column<1||n.column>de.length+1)}function te(n,ae){return!(n.startLineNumber<1||n.startLineNumber>ae.length+1||n.endLineNumberExclusive<1||n.endLineNumberExclusive>ae.length+1)}for(const n of z){if(!n.innerChanges)return!1;for(const ae of n.innerChanges)if(!(J(ae.modifiedRange.getStartPosition(),u)&&J(ae.modifiedRange.getEndPosition(),u)&&J(ae.originalRange.getStartPosition(),o)&&J(ae.originalRange.getEndPosition(),o)))return!1;if(!te(n.modified,u)||!te(n.original,o))return!1}return!0}),new b.$Vs(z,x,T)}h(o,u,i,c,E,m,w){return(0,g.$GZ)(o,u,i,c,E,m).map(F=>{const y=this.j(u,i,new h.$wZ(F.original.toOffsetRange(),F.modified.toOffsetRange()),m,w),P=L(y.mappings,u,i,!0);return new b.$Ws(F,P)})}j(o,u,i,c,E){const m=new e.$FZ(o,i.seq1Range,E),w=new e.$FZ(u,i.seq2Range,E),p=m.length+w.length<500?this.e.compute(m,w,c):this.f.compute(m,w,c);let M=p.diffs;return M=(0,A.$IZ)(m,w,M),M=(0,A.$KZ)(m,w,M),M=(0,A.$JZ)(m,w,M),M=(0,A.$MZ)(m,w,M),{mappings:M.map(y=>new $.$Us(m.translateRange(y.seq1Range),w.translateRange(y.seq2Range))),hitTimeout:p.hitTimeout}}}t.$NZ=R;function L(a,o,u,i=!1){const c=[];for(const E of(0,_.$Ab)(a.map(m=>d(m,o,u)),(m,w)=>m.original.overlapOrTouch(w.original)||m.modified.overlapOrTouch(w.modified))){const m=E[0],w=E[E.length-1];c.push(new $.$Ts(m.original.join(w.original),m.modified.join(w.modified),E.map(p=>p.innerChanges[0])))}return(0,k.$7c)(()=>!i&&c.length>0&&c[0].original.startLineNumber!==c[0].modified.startLineNumber?!1:(0,k.$8c)(c,(E,m)=>m.original.startLineNumber-E.original.endLineNumberExclusive===m.modified.startLineNumber-E.modified.endLineNumberExclusive&&E.original.endLineNumberExclusive<m.original.startLineNumber&&E.modified.endLineNumberExclusive<m.modified.startLineNumber)),c}t.$OZ=L;function d(a,o,u){let i=0,c=0;a.modifiedRange.endColumn===1&&a.originalRange.endColumn===1&&a.originalRange.startLineNumber+i<=a.originalRange.endLineNumber&&a.modifiedRange.startLineNumber+i<=a.modifiedRange.endLineNumber&&(c=-1),a.modifiedRange.startColumn-1>=u[a.modifiedRange.startLineNumber-1].length&&a.originalRange.startColumn-1>=o[a.originalRange.startLineNumber-1].length&&a.originalRange.startLineNumber<=a.originalRange.endLineNumber+c&&a.modifiedRange.startLineNumber<=a.modifiedRange.endLineNumber+c&&(i=1);const E=new r.$Qs(a.originalRange.startLineNumber+i,a.originalRange.endLineNumber+1+c),m=new r.$Qs(a.modifiedRange.startLineNumber+i,a.modifiedRange.endLineNumber+1+c);return new $.$Ts(E,m,[a])}t.$PZ=d}),ne(re[33],se([0,1,25,32,18,7,2,13,12]),function(V,t,_,k,r,f,v,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ys=t.$Xs=void 0;const s=3;class g{computeDiff(i,c,E){const w=new L(i,c,{maxComputationTime:E.maxComputationTimeMs,shouldIgnoreTrimWhitespace:E.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),p=[];let M=null;for(const F of w.changes){let y;F.originalEndLineNumber===0?y=new l.$Qs(F.originalStartLineNumber+1,F.originalStartLineNumber+1):y=new l.$Qs(F.originalStartLineNumber,F.originalEndLineNumber+1);let P;F.modifiedEndLineNumber===0?P=new l.$Qs(F.modifiedStartLineNumber+1,F.modifiedStartLineNumber+1):P=new l.$Qs(F.modifiedStartLineNumber,F.modifiedEndLineNumber+1);let S=new r.$Ts(y,P,F.charChanges?.map(T=>new r.$Us(new v.$Hs(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new v.$Hs(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===S.modified.startLineNumber||M.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new r.$Ts(M.original.join(S.original),M.modified.join(S.modified),M.innerChanges&&S.innerChanges?M.innerChanges.concat(S.innerChanges):void 0),p.pop()),p.push(S),M=S}return(0,h.$7c)(()=>(0,h.$8c)(p,(F,y)=>y.original.startLineNumber-F.original.endLineNumberExclusive===y.modified.startLineNumber-F.modified.endLineNumberExclusive&&F.original.endLineNumberExclusive<y.original.startLineNumber&&F.modified.endLineNumberExclusive<y.modified.startLineNumber)),new k.$Vs(p,[],w.quitEarly)}}t.$Xs=g;function A(u,i,c,E){return new _.$Ns(u,i,c).ComputeDiff(E)}class b{constructor(i){const c=[],E=[];for(let m=0,w=i.length;m<w;m++)c[m]=d(i[m],1),E[m]=a(i[m],1);this.lines=i,this.a=c,this.b=E}getElements(){const i=[];for(let c=0,E=this.lines.length;c<E;c++)i[c]=this.lines[c].substring(this.a[c]-1,this.b[c]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,c,E){const m=[],w=[],p=[];let M=0;for(let F=c;F<=E;F++){const y=this.lines[F],P=i?this.a[F]:1,S=i?this.b[F]:y.length+1;for(let T=P;T<S;T++)m[M]=y.charCodeAt(T-1),w[M]=F+1,p[M]=T,M++;!i&&F<E&&(m[M]=10,w[M]=F+1,p[M]=y.length+1,M++)}return new $(m,w,p)}}class ${constructor(i,c,E){this.a=i,this.b=c,this.d=E}toString(){return"["+this.a.map((i,c)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[c]},${this.d[c]})`).join(", ")+"]"}e(i,c){if(i<0||i>=c.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,c,E,m,w,p,M,F){this.originalStartLineNumber=i,this.originalStartColumn=c,this.originalEndLineNumber=E,this.originalEndColumn=m,this.modifiedStartLineNumber=w,this.modifiedStartColumn=p,this.modifiedEndLineNumber=M,this.modifiedEndColumn=F}static createFromDiffChange(i,c,E){const m=c.getStartLineNumber(i.originalStart),w=c.getStartColumn(i.originalStart),p=c.getEndLineNumber(i.originalStart+i.originalLength-1),M=c.getEndColumn(i.originalStart+i.originalLength-1),F=E.getStartLineNumber(i.modifiedStart),y=E.getStartColumn(i.modifiedStart),P=E.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),S=E.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(m,w,p,M,F,y,P,S)}}function N(u){if(u.length<=1)return u;const i=[u[0]];let c=i[0];for(let E=1,m=u.length;E<m;E++){const w=u[E],p=w.originalStart-(c.originalStart+c.originalLength),M=w.modifiedStart-(c.modifiedStart+c.modifiedLength);Math.min(p,M)<s?(c.originalLength=w.originalStart+w.originalLength-c.originalStart,c.modifiedLength=w.modifiedStart+w.modifiedLength-c.modifiedStart):(i.push(w),c=w)}return i}class R{constructor(i,c,E,m,w){this.originalStartLineNumber=i,this.originalEndLineNumber=c,this.modifiedStartLineNumber=E,this.modifiedEndLineNumber=m,this.charChanges=w}static createFromDiffResult(i,c,E,m,w,p,M){let F,y,P,S,T;if(c.originalLength===0?(F=E.getStartLineNumber(c.originalStart)-1,y=0):(F=E.getStartLineNumber(c.originalStart),y=E.getEndLineNumber(c.originalStart+c.originalLength-1)),c.modifiedLength===0?(P=m.getStartLineNumber(c.modifiedStart)-1,S=0):(P=m.getStartLineNumber(c.modifiedStart),S=m.getEndLineNumber(c.modifiedStart+c.modifiedLength-1)),p&&c.originalLength>0&&c.originalLength<20&&c.modifiedLength>0&&c.modifiedLength<20&&w()){const q=E.createCharSequence(i,c.originalStart,c.originalStart+c.originalLength-1),O=m.createCharSequence(i,c.modifiedStart,c.modifiedStart+c.modifiedLength-1);if(q.getElements().length>0&&O.getElements().length>0){let D=A(q,O,w,!0).changes;M&&(D=N(D)),T=[];for(let j=0,z=D.length;j<z;j++)T.push(e.createFromDiffChange(D[j],q,O))}}return new R(F,y,P,S,T)}}class L{constructor(i,c,E){this.a=E.shouldComputeCharChanges,this.b=E.shouldPostProcessCharChanges,this.d=E.shouldIgnoreTrimWhitespace,this.e=E.shouldMakePrettyDiff,this.f=i,this.g=c,this.h=new b(i),this.j=new b(c),this.k=o(E.maxComputationTime),this.l=o(E.maxComputationTime===0?0:Math.min(E.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=A(this.h,this.j,this.k,this.e),c=i.changes,E=i.quitEarly;if(this.d){const M=[];for(let F=0,y=c.length;F<y;F++)M.push(R.createFromDiffResult(this.d,c[F],this.h,this.j,this.l,this.a,this.b));return{quitEarly:E,changes:M}}const m=[];let w=0,p=0;for(let M=-1,F=c.length;M<F;M++){const y=M+1<F?c[M+1]:null,P=y?y.originalStart:this.f.length,S=y?y.modifiedStart:this.g.length;for(;w<P&&p<S;){const T=this.f[w],q=this.g[p];if(T!==q){{let O=d(T,1),D=d(q,1);for(;O>1&&D>1;){const j=T.charCodeAt(O-2),z=q.charCodeAt(D-2);if(j!==z)break;O--,D--}(O>1||D>1)&&this.m(m,w+1,1,O,p+1,1,D)}{let O=a(T,1),D=a(q,1);const j=T.length+1,z=q.length+1;for(;O<j&&D<z;){const x=T.charCodeAt(O-1),J=T.charCodeAt(D-1);if(x!==J)break;O++,D++}(O<j||D<z)&&this.m(m,w+1,O,j,p+1,D,z)}}w++,p++}y&&(m.push(R.createFromDiffResult(this.d,y,this.h,this.j,this.l,this.a,this.b)),w+=y.originalLength,p+=y.modifiedLength)}return{quitEarly:E,changes:m}}m(i,c,E,m,w,p,M){if(this.n(i,c,E,m,w,p,M))return;let F;this.a&&(F=[new e(c,E,c,m,w,p,w,M)]),i.push(new R(c,c,w,w,F))}n(i,c,E,m,w,p,M){const F=i.length;if(F===0)return!1;const y=i[F-1];return y.originalEndLineNumber===0||y.modifiedEndLineNumber===0?!1:y.originalEndLineNumber===c&&y.modifiedEndLineNumber===w?(this.a&&y.charChanges&&y.charChanges.push(new e(c,E,c,m,w,p,w,M)),!0):y.originalEndLineNumber+1===c&&y.modifiedEndLineNumber+1===w?(y.originalEndLineNumber=c,y.modifiedEndLineNumber=w,this.a&&y.charChanges&&y.charChanges.push(new e(c,E,c,m,w,p,w,M)),!0):!1}}t.$Ys=L;function d(u,i){const c=f.$We(u);return c===-1?i:c+1}function a(u,i){const c=f.$Ye(u);return c===-1?i:c+2}function o(u){if(u===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<u}}),ne(re[52],se([0,1,33,51]),function(V,t,_,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QZ=void 0,t.$QZ={getLegacy:()=>new _.$Xs,getDefault:()=>new k.$NZ}}),ne(re[53],se([0,1,35]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RZ=void 0;function k(b){const $=[];for(const e of b){const N=Number(e);(N||N===0&&e.replace(/\s/g,"")!=="")&&$.push(N)}return $}function r(b,$,e,N){return{red:b/255,blue:e/255,green:$/255,alpha:N}}function f(b,$){const e=$.index,N=$[0].length;if(!e)return;const R=b.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+N}}function v(b,$){if(!b)return;const e=_.$_s.Format.CSS.parseHex($);if(e)return{range:b,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(b,$,e){if(!b||$.length!==1)return;const R=$[0].values(),L=k(R);return{range:b,color:r(L[0],L[1],L[2],e?L[3]:1)}}function l(b,$,e){if(!b||$.length!==1)return;const R=$[0].values(),L=k(R),d=new _.$_s(new _.$0s(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:b,color:r(d.rgba.r,d.rgba.g,d.rgba.b,d.rgba.a)}}function s(b,$){return typeof b=="string"?[...b.matchAll($)]:b.findMatches($)}function g(b){const $=[],N=s(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(N.length>0)for(const R of N){const L=R.filter(u=>u!==void 0),d=L[1],a=L[2];if(!a)continue;let o;if(d==="rgb"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;o=h(f(b,R),s(a,u),!1)}else if(d==="rgba"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=h(f(b,R),s(a,u),!0)}else if(d==="hsl"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;o=l(f(b,R),s(a,u),!1)}else if(d==="hsla"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=l(f(b,R),s(a,u),!0)}else d==="#"&&(o=v(f(b,R),d+a));o&&$.push(o)}return $}function A(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:g(b)}t.$RZ=A}),ne(re[54],se([0,1,28]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rZ=t.$qZ=t.$pZ=t.State=void 0;var k;(function($){$[$.Invalid=0]="Invalid",$[$.Start=1]="Start",$[$.H=2]="H",$[$.HT=3]="HT",$[$.HTT=4]="HTT",$[$.HTTP=5]="HTTP",$[$.F=6]="F",$[$.FI=7]="FI",$[$.FIL=8]="FIL",$[$.BeforeColon=9]="BeforeColon",$[$.AfterColon=10]="AfterColon",$[$.AlmostThere=11]="AlmostThere",$[$.End=12]="End",$[$.Accept=13]="Accept",$[$.LastKnownState=14]="LastKnownState"})(k||(t.State=k={}));class r{constructor(e,N,R){const L=new Uint8Array(e*N);for(let d=0,a=e*N;d<a;d++)L[d]=R;this.a=L,this.rows=e,this.cols=N}get(e,N){return this.a[e*this.cols+N]}set(e,N,R){this.a[e*this.cols+N]=R}}class f{constructor(e){let N=0,R=0;for(let d=0,a=e.length;d<a;d++){const[o,u,i]=e[d];u>N&&(N=u),o>R&&(R=o),i>R&&(R=i)}N++,R++;const L=new r(R,N,0);for(let d=0,a=e.length;d<a;d++){const[o,u,i]=e[d];L.set(o,u,i)}this.a=L,this.b=N}nextState(e,N){return N<0||N>=this.b?0:this.a.get(e,N)}}t.$pZ=f;let v=null;function h(){return v===null&&(v=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),v}var l;(function($){$[$.None=0]="None",$[$.ForceTermination=1]="ForceTermination",$[$.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let s=null;function g(){if(s===null){s=new _.$5s(0);const $=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<$.length;N++)s.set($.charCodeAt(N),1);const e=".,;:";for(let N=0;N<e.length;N++)s.set(e.charCodeAt(N),2)}return s}class A{static a(e,N,R,L,d){let a=d-1;do{const o=N.charCodeAt(a);if(e.get(o)!==2)break;a--}while(a>L);if(L>0){const o=N.charCodeAt(L-1),u=N.charCodeAt(a);(o===40&&u===41||o===91&&u===93||o===123&&u===125)&&a--}return{range:{startLineNumber:R,startColumn:L+1,endLineNumber:R,endColumn:a+2},url:N.substring(L,a+1)}}static computeLinks(e,N=h()){const R=g(),L=[];for(let d=1,a=e.getLineCount();d<=a;d++){const o=e.getLineContent(d),u=o.length;let i=0,c=0,E=0,m=1,w=!1,p=!1,M=!1,F=!1;for(;i<u;){let y=!1;const P=o.charCodeAt(i);if(m===13){let S;switch(P){case 40:w=!0,S=0;break;case 41:S=w?0:1;break;case 91:M=!0,p=!0,S=0;break;case 93:M=!1,S=p?0:1;break;case 123:F=!0,S=0;break;case 125:S=F?0:1;break;case 39:case 34:case 96:E===P?S=1:E===39||E===34||E===96?S=0:S=1;break;case 42:S=E===42?1:0;break;case 124:S=E===124?1:0;break;case 32:S=M?0:1;break;default:S=R.get(P)}S===1&&(L.push(A.a(R,o,d,c,i)),y=!0)}else if(m===12){let S;P===91?(p=!0,S=0):S=R.get(P),S===1?y=!0:m=13}else m=N.nextState(m,P),m===0&&(y=!0);y&&(m=1,w=!1,p=!1,F=!1,c=i+1,E=P),i++}m===13&&L.push(A.a(R,o,d,c,u))}return L}}t.$qZ=A;function b($){return!$||typeof $.getLineCount!="function"||typeof $.getLineContent!="function"?[]:A.computeLinks($)}t.$rZ=b}),ne(re[55],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sZ=void 0;class _{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(r,f,v,h,l){if(r&&f){const s=this.a(f,l);if(s)return{range:r,value:s}}if(v&&h){const s=this.a(h,l);if(s)return{range:v,value:s}}return null}a(r,f){const v=this.b(r,f);return v!==null?v:this.d(r,f)}b(r,f){const v=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let h=Number(r);const l=parseFloat(r);return!isNaN(h)&&!isNaN(l)&&h===l?h===0&&!f?null:(h=Math.floor(h*v),h+=f?v:-v,String(h/v)):null}d(r,f){return this.e(this.c,r,f)}e(r,f,v){let h=null;for(let l=0,s=r.length;h===null&&l<s;l++)h=this.f(r[l],f,v);return h}f(r,f,v){let h=r.indexOf(f);return h>=0?(h+=v?1:-1,h<0?h=r.length-1:h%=r.length,r[h]):null}}t.$sZ=_,_.INSTANCE=new _}),ne(re[56],se([0,1,15]),function(V,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5u=t.$4u=t.$3u=t.$2u=t.ModelConstants=t.PositionAffinity=t.$1u=t.TrackedRangeStickiness=t.$Zu=t.$Yu=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var k;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(k||(t.OverviewRulerLane=k={}));var r;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var f;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var v;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var h;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(h||(t.EndOfLinePreference=h={}));var l;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var s;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,_.$mn)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}t.$Yu=g;class A{constructor(u,i){this._findMatchBrand=void 0,this.range=u,this.matches=i}}t.$Zu=A;var b;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function $(o){return o&&typeof o.read=="function"}t.$1u=$;var e;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var N;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(N||(t.ModelConstants=N={}));class R{constructor(u,i,c,E,m,w){this.identifier=u,this.range=i,this.text=c,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=m,this._isTracked=w}}t.$2u=R;class L{constructor(u,i,c){this.regex=u,this.wordSeparators=i,this.simpleSearch=c}}t.$3u=L;class d{constructor(u,i,c){this.reverseEdits=u,this.changes=i,this.trimAutoWhitespaceLineNumbers=c}}t.$4u=d;function a(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}t.$5u=a}),ne(re[57],se([0,1,6,27]),function(V,t,_,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0u=t.$9u=t.$8u=void 0;class r{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,s){l=(0,k.$Fe)(l);const g=this.a,A=this.b,b=s.length;return b===0?!1:(this.a=new Uint32Array(g.length+b),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l),l+b),this.a.set(s,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(l,s){return l=(0,k.$Fe)(l),s=(0,k.$Fe)(s),this.a[l]===s?!1:(this.a[l]=s,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,s){l=(0,k.$Fe)(l),s=(0,k.$Fe)(s);const g=this.a,A=this.b;if(l>=g.length)return!1;const b=g.length-l;return s>=b&&(s=b),s===0?!1:(this.a=new Uint32Array(g.length-s),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l+s),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,k.$Fe)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),l>=this.a.length&&(l=this.a.length-1);for(let g=s;g<=l;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,g=this.a.length-1,A=0,b=0,$=0;for(;s<=g;)if(A=s+(g-s)/2|0,b=this.b[A],$=b-this.a[A],l<$)g=A-1;else if(l>=b)s=A+1;else break;return new v(A,l-$)}}t.$8u=r;class f{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const s=this.e[l],g=s>0?this.d[s-1]:0;return new v(s,l-g)}removeValues(l,s){this.a.splice(l,s),this.f(l)}insertValues(l,s){this.a=(0,_.$Wb)(this.a,l,s),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,s=this.a.length;l<s;l++){const g=this.a[l],A=l>0?this.d[l-1]:0;this.d[l]=A+g;for(let b=0;b<g;b++)this.e[A+b]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,s){this.a[l]!==s&&(this.a[l]=s,this.f(l))}}t.$9u=f;class v{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}t.$0u=v}),ne(re[58],se([0,1,7,5,57]),function(V,t,_,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$u=void 0;class f{constructor(h,l,s,g){this.d=h,this.f=l,this.g=s,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(h){h.eol&&h.eol!==this.g&&(this.g=h.eol,this.j=null);const l=h.changes;for(const s of l)this.o(s.range),this.p(new k.$Gs(s.range.startLineNumber,s.range.startColumn),s.text);this.h=h.versionId,this.k=null}l(){if(!this.j){const h=this.g.length,l=this.f.length,s=new Uint32Array(l);for(let g=0;g<l;g++)s[g]=this.f[g].length+h;this.j=new r.$8u(s)}}n(h,l){this.f[h]=l,this.j&&this.j.setValue(h,this.f[h].length+this.g.length)}o(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.startLineNumber-1].substring(h.endColumn-1));return}this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.endLineNumber-1].substring(h.endColumn-1)),this.f.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.j&&this.j.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}p(h,l){if(l.length===0)return;const s=(0,_.$Ve)(l);if(s.length===1){this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]+this.f[h.lineNumber-1].substring(h.column-1));return}s[s.length-1]+=this.f[h.lineNumber-1].substring(h.column-1),this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]);const g=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(h.lineNumber+A-1,0,s[A]),g[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(h.lineNumber,g)}}t.$$u=f}),ne(re[59],se([0,1,7,46,5,2,56]),function(V,t,_,k,r,f,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QB=t.$PB=t.$OB=t.$NB=t.$MB=t.$LB=void 0;const h=999;class l{constructor(d,a,o,u){this.searchString=d,this.isRegex=a,this.matchCase=o,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=s(this.searchString):d=this.searchString.indexOf(`
`)>=0;let a=null;try{a=_.$Te(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch{return null}if(!a)return null;let o=!this.isRegex&&!d;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new v.$3u(a,this.wordSeparators?(0,k.$8s)(this.wordSeparators):null,o?this.searchString:null)}}t.$LB=l;function s(L){if(!L||L.length===0)return!1;for(let d=0,a=L.length;d<a;d++){const o=L.charCodeAt(d);if(o===10)return!0;if(o===92){if(d++,d>=a)break;const u=L.charCodeAt(d);if(u===110||u===114||u===87)return!0}}return!1}t.$MB=s;function g(L,d,a){if(!a)return new v.$Zu(L,null);const o=[];for(let u=0,i=d.length;u<i;u++)o[u]=d[u];return new v.$Zu(L,o)}t.$NB=g;class A{constructor(d){const a=[];let o=0;for(let u=0,i=d.length;u<i;u++)d.charCodeAt(u)===10&&(a[o++]=u);this.a=a}findLineFeedCountBeforeOffset(d){const a=this.a;let o=0,u=a.length-1;if(u===-1||d<=a[0])return 0;for(;o<u;){const i=o+((u-o)/2>>0);a[i]>=d?u=i-1:a[i+1]>=d?(o=i,u=i):o=i+1}return o+1}}class b{static findMatches(d,a,o,u,i){const c=a.parseSearchRequest();return c?c.regex.multiline?this.b(d,o,new R(c.wordSeparators,c.regex),u,i):this.c(d,o,c,u,i):[]}static a(d,a,o,u,i,c){let E,m=0;u?(m=u.findLineFeedCountBeforeOffset(i),E=a+i+m):E=a+i;let w;if(u){const y=u.findLineFeedCountBeforeOffset(i+c.length)-m;w=E+c.length+y}else w=E+c.length;const p=d.getPositionAt(E),M=d.getPositionAt(w);return new f.$Hs(p.lineNumber,p.column,M.lineNumber,M.column)}static b(d,a,o,u,i){const c=d.getOffsetAt(a.getStartPosition()),E=d.getValueInRange(a,1),m=d.getEOL()===`\r
`?new A(E):null,w=[];let p=0,M;for(o.reset(0);M=o.next(E);)if(w[p++]=g(this.a(d,c,E,m,M.index,M[0]),M,u),p>=i)return w;return w}static c(d,a,o,u,i){const c=[];let E=0;if(a.startLineNumber===a.endLineNumber){const w=d.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return E=this.d(o,w,a.startLineNumber,a.startColumn-1,E,c,u,i),c}const m=d.getLineContent(a.startLineNumber).substring(a.startColumn-1);E=this.d(o,m,a.startLineNumber,a.startColumn-1,E,c,u,i);for(let w=a.startLineNumber+1;w<a.endLineNumber&&E<i;w++)E=this.d(o,d.getLineContent(w),w,0,E,c,u,i);if(E<i){const w=d.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);E=this.d(o,w,a.endLineNumber,0,E,c,u,i)}return c}static d(d,a,o,u,i,c,E,m){const w=d.wordSeparators;if(!E&&d.simpleSearch){const F=d.simpleSearch,y=F.length,P=a.length;let S=-y;for(;(S=a.indexOf(F,S+y))!==-1;)if((!w||N(w,a,P,S,y))&&(c[i++]=new v.$Zu(new f.$Hs(o,S+1+u,o,S+1+y+u),null),i>=m))return i;return i}const p=new R(d.wordSeparators,d.regex);let M;p.reset(0);do if(M=p.next(a),M&&(c[i++]=g(new f.$Hs(o,M.index+1+u,o,M.index+1+M[0].length+u),M,E),i>=m))return i;while(M);return i}static findNextMatch(d,a,o,u){const i=a.parseSearchRequest();if(!i)return null;const c=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.e(d,o,c,u):this.f(d,o,c,u)}static e(d,a,o,u){const i=new r.$Gs(a.lineNumber,1),c=d.getOffsetAt(i),E=d.getLineCount(),m=d.getValueInRange(new f.$Hs(i.lineNumber,i.column,E,d.getLineMaxColumn(E)),1),w=d.getEOL()===`\r
`?new A(m):null;o.reset(a.column-1);const p=o.next(m);return p?g(this.a(d,c,m,w,p.index,p[0]),p,u):a.lineNumber!==1||a.column!==1?this.e(d,new r.$Gs(1,1),o,u):null}static f(d,a,o,u){const i=d.getLineCount(),c=a.lineNumber,E=d.getLineContent(c),m=this.g(o,E,c,a.column,u);if(m)return m;for(let w=1;w<=i;w++){const p=(c+w-1)%i,M=d.getLineContent(p+1),F=this.g(o,M,p+1,1,u);if(F)return F}return null}static g(d,a,o,u,i){d.reset(u-1);const c=d.next(a);return c?g(new f.$Hs(o,c.index+1,o,c.index+1+c[0].length),c,i):null}static findPreviousMatch(d,a,o,u){const i=a.parseSearchRequest();if(!i)return null;const c=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.h(d,o,c,u):this.j(d,o,c,u)}static h(d,a,o,u){const i=this.b(d,new f.$Hs(1,1,a.lineNumber,a.column),o,u,10*h);if(i.length>0)return i[i.length-1];const c=d.getLineCount();return a.lineNumber!==c||a.column!==d.getLineMaxColumn(c)?this.h(d,new r.$Gs(c,d.getLineMaxColumn(c)),o,u):null}static j(d,a,o,u){const i=d.getLineCount(),c=a.lineNumber,E=d.getLineContent(c).substring(0,a.column-1),m=this.k(o,E,c,u);if(m)return m;for(let w=1;w<=i;w++){const p=(i+c-w-1)%i,M=d.getLineContent(p+1),F=this.k(o,M,p+1,u);if(F)return F}return null}static k(d,a,o,u){let i=null,c;for(d.reset(0);c=d.next(a);)i=g(new f.$Hs(o,c.index+1,o,c.index+1+c[0].length),c,u);return i}}t.$OB=b;function $(L,d,a,o,u){if(o===0)return!0;const i=d.charCodeAt(o-1);if(L.get(i)!==0||i===13||i===10)return!0;if(u>0){const c=d.charCodeAt(o);if(L.get(c)!==0)return!0}return!1}function e(L,d,a,o,u){if(o+u===a)return!0;const i=d.charCodeAt(o+u);if(L.get(i)!==0||i===13||i===10)return!0;if(u>0){const c=d.charCodeAt(o+u-1);if(L.get(c)!==0)return!0}return!1}function N(L,d,a,o,u){return $(L,d,a,o,u)&&e(L,d,a,o,u)}t.$PB=N;class R{constructor(d,a){this._wordSeparators=d,this.a=a,this.b=-1,this.c=0}reset(d){this.a.lastIndex=d,this.b=-1,this.c=0}next(d){const a=d.length;let o;do{if(this.b+this.c===a||(o=this.a.exec(d),!o))return null;const u=o.index,i=o[0].length;if(u===this.b&&i===this.c){if(i===0){_.$cf(d,a,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=i,!this._wordSeparators||N(this._wordSeparators,d,a,u,i))return o}while(o);return null}}t.$QB=R}),ne(re[60],se([0,1,2,59,7,13,29]),function(V,t,_,k,r,f,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$oZ=void 0;class h{static computeUnicodeHighlights(e,N,R){const L=R?R.startLineNumber:1,d=R?R.endLineNumber:e.getLineCount(),a=new g(N),o=a.getCandidateCodePoints();let u;o==="allNonBasicAscii"?u=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):u=new RegExp(`${l(Array.from(o))}`,"g");const i=new k.$QB(null,u),c=[];let E=!1,m,w=0,p=0,M=0;e:for(let F=L,y=d;F<=y;F++){const P=e.getLineContent(F),S=P.length;i.reset(0);do if(m=i.next(P),m){let T=m.index,q=m.index+m[0].length;if(T>0){const z=P.charCodeAt(T-1);r.$_e(z)&&T--}if(q+1<S){const z=P.charCodeAt(q-1);r.$_e(z)&&q++}const O=P.substring(T,q);let D=(0,v.$js)(T+1,v.$gs,P,0);D&&D.endColumn<=T+1&&(D=null);const j=a.shouldHighlightNonBasicASCII(O,D?D.word:null);if(j!==0){j===3?w++:j===2?p++:j===1?M++:(0,f.$5c)(j);const z=1e3;if(c.length>=z){E=!0;break e}c.push(new _.$Hs(F,T+1,F,q+1))}}while(m)}return{ranges:c,hasMore:E,ambiguousCharacterCount:w,invisibleCharacterCount:p,nonBasicAsciiCharacterCount:M}}static computeUnicodeHighlightReason(e,N){const R=new g(N);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const d=e.codePointAt(0),a=R.ambiguousCharacters.getPrimaryConfusable(d),o=r.$Cf.getLocales().filter(u=>!r.$Cf.getInstance(new Set([...N.allowedLocales,u])).isAmbiguous(d));return{kind:0,confusableWith:String.fromCodePoint(a),notAmbiguousInLocales:o}}case 1:return{kind:2}}}}t.$oZ=h;function l($,e){return`[${r.$Ke($.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function($){$[$.Ambiguous=0]="Ambiguous",$[$.Invisible=1]="Invisible",$[$.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$Cf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const N of r.$Df.codePoints)A(String.fromCodePoint(N))||e.add(N);if(this.b.ambiguousCharacters)for(const N of this.ambiguousCharacters.getConfusableCodePoints())e.add(N);for(const N of this.a)e.delete(N);return e}shouldHighlightNonBasicASCII(e,N){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,d=!1;if(N)for(const a of N){const o=a.codePointAt(0),u=r.$kf(a);L=L||u,!u&&!this.ambiguousCharacters.isAmbiguous(o)&&!r.$Df.isInvisibleCharacter(o)&&(d=!0)}return!L&&d?0:this.b.invisibleCharacters&&!A(e)&&r.$Df.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A($){return $===" "||$===`
`||$==="	"}var b;(function($){$[$.None=0]="None",$[$.NonBasicASCII=1]="NonBasicASCII",$[$.Invisible=2]="Invisible",$[$.Ambiguous=3]="Ambiguous"})(b||(b={}))}),ne(re[61],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowAiIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var _;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(_||(t.AccessibilitySupport=_={}));var k;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(k||(t.CodeActionTriggerType=k={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var f;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var v;(function(n){n[n.Deprecated=1]="Deprecated"})(v||(t.CompletionItemTag=v={}));var h;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var A;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var $;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})($||(t.EditorOption=$={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var N;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(N||(t.EndOfLineSequence=N={}));var R;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(R||(t.GlyphMarginLane=R={}));var L;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var d;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(d||(t.InjectedTextCursorStops=d={}));var a;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(a||(t.InlayHintKind=a={}));var o;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(o||(t.InlineCompletionTriggerKind=o={}));var u;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(u||(t.KeyCode=u={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var c;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(c||(t.MarkerTag=c={}));var E;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(E||(t.MinimapPosition=E={}));var m;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(m||(t.MouseTargetType=m={}));var w;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(w||(t.OverlayWidgetPositionPreference=w={}));var p;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(p||(t.OverviewRulerLane=p={}));var M;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(M||(t.PositionAffinity=M={}));var F;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(F||(t.RenderLineNumbersType=F={}));var y;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(y||(t.RenderMinimap=y={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var S;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(S||(t.ScrollbarVisibility=S={}));var T;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(T||(t.SelectionDirection=T={}));var q;(function(n){n.Off="off",n.OnCode="onCode",n.On="on"})(q||(t.ShowAiIconMode=q={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O||(t.SignatureHelpTriggerKind=O={}));var D;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(D||(t.SymbolKind=D={}));var j;(function(n){n[n.Deprecated=1]="Deprecated"})(j||(t.SymbolTag=j={}));var z;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(z||(t.TextEditorCursorBlinkingStyle=z={}));var x;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(x||(t.TextEditorCursorStyle=x={}));var J;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(J||(t.TrackedRangeStickiness=J={}));var te;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(te||(t.WrappingIndent=te={}))}),ne(re[62],se([0,1,11,10]),function(V,t,_,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gt=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new _.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,l){return this.a.set(h,l),this.handleChange([h]),(0,k.$Qc)(()=>{this.a.get(h)===l&&(this.a.delete(h),this.handleChange([h]))})}get(h){return this.a.get(h)||null}registerFactory(h,l){this.b.get(h)?.dispose();const s=new f(this,h,l);return this.b.set(h,s),(0,k.$Qc)(()=>{const g=this.b.get(h);!g||g!==s||(this.b.delete(h),g.dispose())})}async getOrCreate(h){const l=this.get(h);if(l)return l;const s=this.b.get(h);return!s||s.isResolved?null:(await s.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const s=this.b.get(h);return!!(!s||s.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$gt=r;class f extends k.$Sc{get isResolved(){return this.c}constructor(h,l,s){super(),this.f=h,this.g=l,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const h=await this.h.tokenizationSupport;this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),ne(re[63],se([68,69]),function(V,t){return V.create("vs/editor/common/languages",t)}),ne(re[64],se([0,1,43,16,44,2,62,63]),function(V,t,_,k,r,f,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$zt=t.$yt=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$xt=t.$wt=t.SymbolKinds=t.SymbolTag=t.$vt=t.$ut=t.SymbolKind=t.$tt=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$st=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$rt=t.$qt=t.$pt=void 0;class l{constructor(j,z,x){this.offset=j,this.type=z,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$pt=l;class s{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}t.$qt=s;class g{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}t.$rt=g;var A;(function(D){D[D.Method=0]="Method",D[D.Function=1]="Function",D[D.Constructor=2]="Constructor",D[D.Field=3]="Field",D[D.Variable=4]="Variable",D[D.Class=5]="Class",D[D.Struct=6]="Struct",D[D.Interface=7]="Interface",D[D.Module=8]="Module",D[D.Property=9]="Property",D[D.Event=10]="Event",D[D.Operator=11]="Operator",D[D.Unit=12]="Unit",D[D.Value=13]="Value",D[D.Constant=14]="Constant",D[D.Enum=15]="Enum",D[D.EnumMember=16]="EnumMember",D[D.Keyword=17]="Keyword",D[D.Text=18]="Text",D[D.Color=19]="Color",D[D.File=20]="File",D[D.Reference=21]="Reference",D[D.Customcolor=22]="Customcolor",D[D.Folder=23]="Folder",D[D.TypeParameter=24]="TypeParameter",D[D.User=25]="User",D[D.Issue=26]="Issue",D[D.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var b;(function(D){const j=new Map;j.set(0,_.$8j.symbolMethod),j.set(1,_.$8j.symbolFunction),j.set(2,_.$8j.symbolConstructor),j.set(3,_.$8j.symbolField),j.set(4,_.$8j.symbolVariable),j.set(5,_.$8j.symbolClass),j.set(6,_.$8j.symbolStruct),j.set(7,_.$8j.symbolInterface),j.set(8,_.$8j.symbolModule),j.set(9,_.$8j.symbolProperty),j.set(10,_.$8j.symbolEvent),j.set(11,_.$8j.symbolOperator),j.set(12,_.$8j.symbolUnit),j.set(13,_.$8j.symbolValue),j.set(15,_.$8j.symbolEnum),j.set(14,_.$8j.symbolConstant),j.set(15,_.$8j.symbolEnum),j.set(16,_.$8j.symbolEnumMember),j.set(17,_.$8j.symbolKeyword),j.set(27,_.$8j.symbolSnippet),j.set(18,_.$8j.symbolText),j.set(19,_.$8j.symbolColor),j.set(20,_.$8j.symbolFile),j.set(21,_.$8j.symbolReference),j.set(22,_.$8j.symbolCustomColor),j.set(23,_.$8j.symbolFolder),j.set(24,_.$8j.symbolTypeParameter),j.set(25,_.$8j.account),j.set(26,_.$8j.issues);function z(te){let n=j.get(te);return n||(console.info("No codicon found for CompletionItemKind "+te),n=_.$8j.symbolProperty),n}D.toIcon=z;const x=new Map;x.set("method",0),x.set("function",1),x.set("constructor",2),x.set("field",3),x.set("variable",4),x.set("class",5),x.set("struct",6),x.set("interface",7),x.set("module",8),x.set("property",9),x.set("event",10),x.set("operator",11),x.set("unit",12),x.set("value",13),x.set("constant",14),x.set("enum",15),x.set("enum-member",16),x.set("enumMember",16),x.set("keyword",17),x.set("snippet",27),x.set("text",18),x.set("color",19),x.set("file",20),x.set("reference",21),x.set("customcolor",22),x.set("folder",23),x.set("type-parameter",24),x.set("typeParameter",24),x.set("account",25),x.set("issue",26);function J(te,n){let ae=x.get(te);return typeof ae>"u"&&!n&&(ae=9),ae}D.fromString=J})(b||(t.CompletionItemKinds=b={}));var $;(function(D){D[D.Deprecated=1]="Deprecated"})($||(t.CompletionItemTag=$={}));var e;(function(D){D[D.None=0]="None",D[D.KeepWhitespace=1]="KeepWhitespace",D[D.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var N;(function(D){D[D.Invoke=0]="Invoke",D[D.TriggerCharacter=1]="TriggerCharacter",D[D.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(N||(t.CompletionTriggerKind=N={}));var R;(function(D){D[D.Automatic=0]="Automatic",D[D.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class L{constructor(j,z,x,J){this.range=j,this.text=z,this.completionKind=x,this.isSnippetText=J}equals(j){return f.$Hs.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}t.$st=L;var d;(function(D){D[D.Invoke=1]="Invoke",D[D.Auto=2]="Auto"})(d||(t.CodeActionTriggerType=d={}));var a;(function(D){D[D.Invoke=1]="Invoke",D[D.TriggerCharacter=2]="TriggerCharacter",D[D.ContentChange=3]="ContentChange"})(a||(t.SignatureHelpTriggerKind=a={}));var o;(function(D){D[D.Text=0]="Text",D[D.Read=1]="Read",D[D.Write=2]="Write"})(o||(t.DocumentHighlightKind=o={}));function u(D){return D&&k.URI.isUri(D.uri)&&f.$Hs.isIRange(D.range)&&(f.$Hs.isIRange(D.originSelectionRange)||f.$Hs.isIRange(D.targetSelectionRange))}t.$tt=u;var i;(function(D){D[D.File=0]="File",D[D.Module=1]="Module",D[D.Namespace=2]="Namespace",D[D.Package=3]="Package",D[D.Class=4]="Class",D[D.Method=5]="Method",D[D.Property=6]="Property",D[D.Field=7]="Field",D[D.Constructor=8]="Constructor",D[D.Enum=9]="Enum",D[D.Interface=10]="Interface",D[D.Function=11]="Function",D[D.Variable=12]="Variable",D[D.Constant=13]="Constant",D[D.String=14]="String",D[D.Number=15]="Number",D[D.Boolean=16]="Boolean",D[D.Array=17]="Array",D[D.Object=18]="Object",D[D.Key=19]="Key",D[D.Null=20]="Null",D[D.EnumMember=21]="EnumMember",D[D.Struct=22]="Struct",D[D.Event=23]="Event",D[D.Operator=24]="Operator",D[D.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$ut={[17]:(0,h.localize)(0,null),[16]:(0,h.localize)(1,null),[4]:(0,h.localize)(2,null),[13]:(0,h.localize)(3,null),[8]:(0,h.localize)(4,null),[9]:(0,h.localize)(5,null),[21]:(0,h.localize)(6,null),[23]:(0,h.localize)(7,null),[7]:(0,h.localize)(8,null),[0]:(0,h.localize)(9,null),[11]:(0,h.localize)(10,null),[10]:(0,h.localize)(11,null),[19]:(0,h.localize)(12,null),[5]:(0,h.localize)(13,null),[1]:(0,h.localize)(14,null),[2]:(0,h.localize)(15,null),[20]:(0,h.localize)(16,null),[15]:(0,h.localize)(17,null),[18]:(0,h.localize)(18,null),[24]:(0,h.localize)(19,null),[3]:(0,h.localize)(20,null),[6]:(0,h.localize)(21,null),[14]:(0,h.localize)(22,null),[22]:(0,h.localize)(23,null),[25]:(0,h.localize)(24,null),[12]:(0,h.localize)(25,null)};function c(D,j){return(0,h.localize)(26,null,D,t.$ut[j])}t.$vt=c;var E;(function(D){D[D.Deprecated=1]="Deprecated"})(E||(t.SymbolTag=E={}));var m;(function(D){const j=new Map;j.set(0,_.$8j.symbolFile),j.set(1,_.$8j.symbolModule),j.set(2,_.$8j.symbolNamespace),j.set(3,_.$8j.symbolPackage),j.set(4,_.$8j.symbolClass),j.set(5,_.$8j.symbolMethod),j.set(6,_.$8j.symbolProperty),j.set(7,_.$8j.symbolField),j.set(8,_.$8j.symbolConstructor),j.set(9,_.$8j.symbolEnum),j.set(10,_.$8j.symbolInterface),j.set(11,_.$8j.symbolFunction),j.set(12,_.$8j.symbolVariable),j.set(13,_.$8j.symbolConstant),j.set(14,_.$8j.symbolString),j.set(15,_.$8j.symbolNumber),j.set(16,_.$8j.symbolBoolean),j.set(17,_.$8j.symbolArray),j.set(18,_.$8j.symbolObject),j.set(19,_.$8j.symbolKey),j.set(20,_.$8j.symbolNull),j.set(21,_.$8j.symbolEnumMember),j.set(22,_.$8j.symbolStruct),j.set(23,_.$8j.symbolEvent),j.set(24,_.$8j.symbolOperator),j.set(25,_.$8j.symbolTypeParameter);function z(x){let J=j.get(x);return J||(console.info("No codicon found for SymbolKind "+x),J=_.$8j.symbolProperty),J}D.toIcon=z})(m||(t.SymbolKinds=m={}));class w{static asEditOperation(j){return r.$Is.replace(f.$Hs.lift(j.range),j.text)}}t.$wt=w;class p{static fromValue(j){switch(j){case"comment":return p.Comment;case"imports":return p.Imports;case"region":return p.Region}return new p(j)}constructor(j){this.value=j}}t.$xt=p,p.Comment=new p("comment"),p.Imports=new p("imports"),p.Region=new p("region");var M;(function(D){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}D.is=j})(M||(t.Command=M={}));var F;(function(D){D[D.Collapsed=0]="Collapsed",D[D.Expanded=1]="Expanded"})(F||(t.CommentThreadCollapsibleState=F={}));var y;(function(D){D[D.Unresolved=0]="Unresolved",D[D.Resolved=1]="Resolved"})(y||(t.CommentThreadState=y={}));var P;(function(D){D[D.Editing=0]="Editing",D[D.Preview=1]="Preview"})(P||(t.CommentMode=P={}));var S;(function(D){D[D.Published=0]="Published",D[D.Draft=1]="Draft"})(S||(t.CommentState=S={}));var T;(function(D){D[D.Type=1]="Type",D[D.Parameter=2]="Parameter"})(T||(t.InlayHintKind=T={}));class q{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$yt=q,t.$zt=new v.$gt;var O;(function(D){D[D.None=0]="None",D[D.Option=1]="Option",D[D.Default=2]="Default",D[D.Preferred=3]="Preferred"})(O||(t.ExternalUriOpenerPriority=O={}))}),ne(re[65],se([0,1,24,11,37,16,5,2,45,64,61]),function(V,t,_,k,r,f,v,h,l,s,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uZ=t.$tZ=void 0;class A{static chord(e,N){return(0,r.$Tq)(e,N)}}t.$tZ=A,A.CtrlCmd=2048,A.Shift=1024,A.Alt=512,A.WinCtrl=256;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:_.$3d,Emitter:k.$Sd,KeyCode:g.KeyCode,KeyMod:A,Position:v.$Gs,Range:h.$Hs,Selection:l.$Js,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:f.URI,Token:s.$pt}}t.$uZ=b}),ne(re[70],se([0,1,25,16,5,2,58,29,54,55,65,23,60,33,52,15,3,53]),function(V,t,_,k,r,f,v,h,l,s,g,A,b,$,e,N,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class d extends v.$$u{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const c=[];for(let E=0;E<this.f.length;E++){const m=this.f[E],w=this.offsetAt(new r.$Gs(E+1,1)),p=m.matchAll(i);for(const M of p)(M.index||M.index===0)&&(M.index=M.index+w),c.push(M)}return c}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,c){const E=(0,h.$js)(i.column,(0,h.$hs)(c),this.f[i.lineNumber-1],0);return E?new f.$Hs(i.lineNumber,E.startColumn,i.lineNumber,E.endColumn):null}getWordUntilPosition(i,c){const E=this.getWordAtPosition(i,c);return E?{word:this.f[i.lineNumber-1].substring(E.startColumn-1,i.column-1),startColumn:E.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const c=this.f,E=this.q.bind(this);let m=0,w="",p=0,M=[];return{*[Symbol.iterator](){for(;;)if(p<M.length){const F=w.substring(M[p].start,M[p].end);p+=1,yield F}else if(m<c.length)w=c[m],M=E(w,i),p=0,m+=1;else break}}}getLineWords(i,c){const E=this.f[i-1],m=this.q(E,c),w=[];for(const p of m)w.push({word:E.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return w}q(i,c){const E=[];let m;for(c.lastIndex=0;(m=c.exec(i))&&m[0].length!==0;)E.push({start:m.index,end:m.index+m[0].length});return E}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const c=this.g,E=i.startLineNumber-1,m=i.endLineNumber-1,w=[];w.push(this.f[E].substring(i.startColumn-1));for(let p=E+1;p<m;p++)w.push(this.f[p]);return w.push(this.f[m].substring(0,i.endColumn-1)),w.join(c)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const c=this.j.getIndexOf(i),E=this.f[c.index].length;return{lineNumber:1+c.index,column:1+Math.min(c.remainder,E)}}r(i){const c=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),E=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return c.lineNumber!==i.startLineNumber||c.column!==i.startColumn||E.lineNumber!==i.endLineNumber||E.column!==i.endColumn?{startLineNumber:c.lineNumber,startColumn:c.column,endLineNumber:E.lineNumber,endColumn:E.column}:i}s(i){if(!r.$Gs.isIPosition(i))throw new Error("bad position");let{lineNumber:c,column:E}=i,m=!1;if(c<1)c=1,E=1,m=!0;else if(c>this.f.length)c=this.f.length,E=this.f[c-1].length+1,m=!0;else{const w=this.f[c-1].length+1;E<1?(E=1,m=!0):E>w&&(E=w,m=!0)}return m?{lineNumber:c,column:E}:i}}class a{constructor(i,c){this.d=i,this.f=Object.create(null),this.g=c,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(c=>i.push(this.f[c])),i}acceptNewModel(i){this.f[i.url]=new d(k.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,c){if(!this.f[i])return;this.f[i].onEvents(c)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,c,E){const m=this.j(i);return m?b.$oZ.computeUnicodeHighlights(m,c,E):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,c,E,m){const w=this.j(i),p=this.j(c);return!w||!p?null:a.l(w,p,E,m)}static l(i,c,E,m){const w=m==="advanced"?e.$QZ.getDefault():e.$QZ.getLegacy(),p=i.getLinesContent(),M=c.getLinesContent(),F=w.computeDiff(p,M,E),y=F.changes.length>0?!1:this.n(i,c);function P(S){return S.map(T=>[T.original.startLineNumber,T.original.endLineNumberExclusive,T.modified.startLineNumber,T.modified.endLineNumberExclusive,T.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:y,quitEarly:F.hitTimeout,changes:P(F.changes),moves:F.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,P(S.changes)])}}static n(i,c){const E=i.getLineCount(),m=c.getLineCount();if(E!==m)return!1;for(let w=1;w<=E;w++){const p=i.getLineContent(w),M=c.getLineContent(w);if(p!==M)return!1}return!0}async computeDirtyDiff(i,c,E){const m=this.j(i),w=this.j(c);if(!m||!w)return null;const p=m.getLinesContent(),M=w.getLinesContent();return new $.$Ys(p,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:E,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,c,E){const m=this.j(i);if(!m)return c;const w=[];let p;c=c.slice(0).sort((F,y)=>{if(F.range&&y.range)return f.$Hs.compareRangesUsingStarts(F.range,y.range);const P=F.range?0:1,S=y.range?0:1;return P-S});let M=0;for(let F=1;F<c.length;F++)f.$Hs.getEndPosition(c[M].range).equals(f.$Hs.getStartPosition(c[F].range))?(c[M].range=f.$Hs.fromPositions(f.$Hs.getStartPosition(c[M].range),f.$Hs.getEndPosition(c[F].range)),c[M].text+=c[F].text):(M++,c[M]=c[F]);c.length=M+1;for(let{range:F,text:y,eol:P}of c){if(typeof P=="number"&&(p=P),f.$Hs.isEmpty(F)&&!y)continue;const S=m.getValueInRange(F);if(y=y.replace(/\r\n|\n|\r/g,m.eol),S===y)continue;if(Math.max(y.length,S.length)>a.o){w.push({range:F,text:y});continue}const T=(0,_.$Ms)(S,y,E),q=m.offsetAt(f.$Hs.lift(F).getStartPosition());for(const O of T){const D=m.positionAt(q+O.originalStart),j=m.positionAt(q+O.originalStart+O.originalLength),z={text:y.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:D.lineNumber,startColumn:D.column,endLineNumber:j.lineNumber,endColumn:j.column}};m.getValueInRange(z.range)!==z.text&&w.push(z)}}return typeof p=="number"&&w.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(i,c,E){const m=this.j(i);if(!m)return c;const w=[];let p;c=c.slice(0).sort((M,F)=>{if(M.range&&F.range)return f.$Hs.compareRangesUsingStarts(M.range,F.range);const y=M.range?0:1,P=F.range?0:1;return y-P});for(let{range:M,text:F,eol:y}of c){let D=function(z,x){return new r.$Gs(z.lineNumber+x.lineNumber-1,x.lineNumber===1?z.column+x.column-1:x.column)},j=function(z,x){const J=[];for(let te=x.startLineNumber;te<=x.endLineNumber;te++){const n=z[te-1];te===x.startLineNumber&&te===x.endLineNumber?J.push(n.substring(x.startColumn-1,x.endColumn-1)):te===x.startLineNumber?J.push(n.substring(x.startColumn-1)):te===x.endLineNumber?J.push(n.substring(0,x.endColumn-1)):J.push(n)}return J};if(typeof y=="number"&&(p=y),f.$Hs.isEmpty(M)&&!F)continue;const P=m.getValueInRange(M);if(F=F.replace(/\r\n|\n|\r/g,m.eol),P===F)continue;if(Math.max(F.length,P.length)>a.o){w.push({range:M,text:F});continue}const S=P.split(/\r\n|\n|\r/),T=F.split(/\r\n|\n|\r/),q=e.$QZ.getDefault().computeDiff(S,T,E),O=f.$Hs.lift(M).getStartPosition();for(const z of q.changes)if(z.innerChanges)for(const x of z.innerChanges)w.push({range:f.$Hs.fromPositions(D(O,x.originalRange.getStartPosition()),D(O,x.originalRange.getEndPosition())),text:j(T,x.modifiedRange).join(m.eol)});else throw new R.$cb("The experimental diff algorithm always produces inner changes")}return typeof p=="number"&&w.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(i){const c=this.j(i);return c?(0,l.$rZ)(c):null}async computeDefaultDocumentColors(i){const c=this.j(i);return c?(0,L.$RZ)(c):null}async textualSuggest(i,c,E,m){const w=new A.$Od,p=new RegExp(E,m),M=new Set;e:for(const F of i){const y=this.j(F);if(y){for(const P of y.words(p))if(!(P===c||!isNaN(Number(P)))&&(M.add(P),M.size>a.p))break e}}return{words:Array.from(M),duration:w.elapsed()}}async computeWordRanges(i,c,E,m){const w=this.j(i);if(!w)return Object.create(null);const p=new RegExp(E,m),M=Object.create(null);for(let F=c.startLineNumber;F<c.endLineNumber;F++){const y=w.getLineWords(F,p);for(const P of y){if(!isNaN(Number(P.word)))continue;let S=M[P.word];S||(S=[],M[P.word]=S),S.push({startLineNumber:F,startColumn:P.startColumn,endLineNumber:F,endColumn:P.endColumn})}}return M}async navigateValueSet(i,c,E,m,w){const p=this.j(i);if(!p)return null;const M=new RegExp(m,w);c.startColumn===c.endColumn&&(c={startLineNumber:c.startLineNumber,startColumn:c.startColumn,endLineNumber:c.endLineNumber,endColumn:c.endColumn+1});const F=p.getValueInRange(c),y=p.getWordAtPosition({lineNumber:c.startLineNumber,column:c.startColumn},M);if(!y)return null;const P=p.getValueInRange(y);return s.$sZ.INSTANCE.navigateValueSet(c,F,y,P,E)}loadForeignModule(i,c,E){const m=(M,F)=>this.d.fhr(M,F),p={host:(0,N.$tn)(E,m),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(p,c),Promise.resolve((0,N.$sn)(this.h))):new Promise((M,F)=>{V([i],y=>{this.h=y.create(p,c),M((0,N.$sn)(this.h))},F)})}fmr(i,c){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,c))}catch(E){return Promise.reject(E)}}}t.EditorSimpleWorker=a,a.o=1e5,a.p=1e4;function o(u){return new a(u,null)}t.create=o,typeof importScripts=="function"&&(globalThis.monaco=(0,g.$uZ)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
