"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/base/common/map","os","vs/base/common/process","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/errorMessage","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/mime","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/json","vs/base/common/glob","path","net","vs/editor/common/core/position","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","vs/server/node/server.main"],ve=function(he){for(var e=[],y=0,A=he.length;y<A;y++)e[y]=we[he[y]];return e};define(we[96],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class y{static get(){const s=new Map,P=new Map,D=new Map,S=new Map;function p(f,g){f.has(g.detail)||f.set(g.detail,-g.timestamp)}function v(f,g){const c=f.get(g.detail);c&&(c>=0||f.set(g.detail,c+g.timestamp))}let I=[];typeof he=="function"&&typeof he.getStats=="function"&&(I=he.getStats().slice(0).sort((f,g)=>f.timestamp-g.timestamp));for(const f of I)switch(f.type){case 10:p(s,f);break;case 11:case 12:v(s,f);break;case 21:p(P,f);break;case 22:v(P,f);break;case 33:p(D,f);break;case 34:v(D,f);break;case 31:p(S,f);break;case 32:v(S,f);break}let E=0;D.forEach(f=>E+=f);function w(f){const g=[];return f.forEach((c,m)=>g.push([m,c])),g}return{amdLoad:w(s),amdInvoke:w(P),nodeRequire:w(D),nodeEval:w(S),nodeRequireTotal:E}}static toMarkdownTable(s,P){let D="";const S=[];return s.forEach((p,v)=>{S[v]=p.length}),P.forEach(p=>{p.forEach((v,I)=>{typeof v>"u"&&(v=p[I]="-");const E=v.toString().length;S[I]=Math.max(E,S[I])})}),s.forEach((p,v)=>{D+=`| ${p+" ".repeat(S[v]-p.toString().length)} `}),D+=`|
`,s.forEach((p,v)=>{D+=`| ${"-".repeat(S[v])} `}),D+=`|
`,P.forEach(p=>{p.forEach((v,I)=>{typeof v<"u"&&(D+=`| ${v+" ".repeat(S[I]-v.toString().length)} `)}),D+=`|
`}),D}}e.$U=y}),define(we[141],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function y(c,m,h){const d=A(c,m);if(d!==-1)return c[d]}e.$fb=y;function A(c,m,h=c.length-1){for(let d=h;d>=0;d--){const l=c[d];if(m(l))return d}return-1}e.$gb=A;function s(c,m){const h=P(c,m);return h===-1?void 0:c[h]}e.$hb=s;function P(c,m,h=0,d=c.length){let l=h,$=d;for(;l<$;){const u=Math.floor((l+$)/2);m(c[u])?l=u+1:$=u}return l-1}e.$ib=P;function D(c,m){const h=S(c,m);return h===c.length?void 0:c[h]}e.$jb=D;function S(c,m,h=0,d=c.length){let l=h,$=d;for(;l<$;){const u=Math.floor((l+$)/2);m(c[u])?$=u:l=u+1}return l}e.$kb=S;function p(c,m,h=0,d=c.length){const l=S(c,m,h,d);return l===c.length?-1:l}e.$lb=p;class v{constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(v.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!m(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const h=P(this.e,m,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$mb=v,v.assertInvariants=!1;function I(c,m){if(c.length===0)return;let h=c[0];for(let d=1;d<c.length;d++){const l=c[d];m(l,h)>0&&(h=l)}return h}e.$nb=I;function E(c,m){if(c.length===0)return;let h=c[0];for(let d=1;d<c.length;d++){const l=c[d];m(l,h)>=0&&(h=l)}return h}e.$ob=E;function w(c,m){return I(c,(h,d)=>-m(h,d))}e.$pb=w;function f(c,m){if(c.length===0)return-1;let h=0;for(let d=1;d<c.length;d++){const l=c[d];m(l,c[h])>0&&(h=d)}return h}e.$qb=f;function g(c,m){for(const h of c){const d=m(h);if(d!==void 0)return d}}e.$rb=g}),define(we[142],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=void 0;function y(D,S){const p=Object.create(null);for(const v of D){const I=S(v);let E=p[I];E||(E=p[I]=[]),E.push(v)}return p}e.$E=y;function A(D,S){const p=[],v=[];for(const I of D)S.has(I)||p.push(I);for(const I of S)D.has(I)||v.push(I);return{removed:p,added:v}}e.$F=A;function s(D,S){const p=[],v=[];for(const[I,E]of D)S.has(I)||p.push(E);for(const[I,E]of S)D.has(I)||v.push(E);return{removed:p,added:v}}e.$G=s;function P(D,S){const p=new Set;for(const v of S)D.has(v)&&p.add(v);return p}e.$H=P}),define(we[74],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function y(D){return(S,p,v)=>{let I=null,E=null;if(typeof v.value=="function"?(I="value",E=v.value):typeof v.get=="function"&&(I="get",E=v.get),!E)throw new Error("not supported");v[I]=D(E,p)}}function A(D,S,p){let v=null,I=null;if(typeof p.value=="function"?(v="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(v="get",I=p.get),!I)throw new Error("not supported");const E=`$memoize$${S}`;p[v]=function(...w){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,w)}),this[E]}}e.$th=A;function s(D,S,p){return y((v,I)=>{const E=`$debounce$${I}`,w=`$debounce$result$${I}`;return function(...f){this[w]||(this[w]=p?p():void 0),clearTimeout(this[E]),S&&(this[w]=S(this[w],...f),f=[this[w]]),this[E]=setTimeout(()=>{v.apply(this,f),this[w]=p?p():void 0},D)}})}e.$uh=s;function P(D,S,p){return y((v,I)=>{const E=`$throttle$timer$${I}`,w=`$throttle$result$${I}`,f=`$throttle$lastRun$${I}`,g=`$throttle$pending$${I}`;return function(...c){if(this[w]||(this[w]=p?p():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[w]=S(this[w],...c)),this[g])return;const m=this[f]+D;m<=Date.now()?(this[f]=Date.now(),v.apply(this,[this[w]]),this[w]=p?p():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[f]=Date.now(),v.apply(this,[this[w]]),this[w]=p?p():void 0},m-Date.now()))}})}e.$vh=P}),define(we[11],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class y{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?l.isErrorNoTelemetry(n)?new l(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(i=>{i(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=y,e.$X=new y;function A(u){e.$X.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=A;function s(u){if(!u||typeof u!="object")return!1;const n=u;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function P(u){v(u)||e.$X.onUnexpectedError(u)}e.$1=P;function D(u){v(u)||e.$X.onUnexpectedExternalError(u)}e.$2=D;function S(u){if(u instanceof Error){const{name:n,message:i}=u,o=u.stacktrace||u.stack;return{$isError:!0,name:n,message:i,stack:o,noTelemetry:l.isErrorNoTelemetry(u)}}return u}e.$3=S;const p="Canceled";function v(u){return u instanceof I?!0:u instanceof Error&&u.name===p&&u.message===p}e.$4=v;class I extends Error{constructor(){super(p),this.name=this.message}}e.$5=I;function E(){const u=new Error(p);return u.name=u.message,u}e.$6=E;function w(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$7=w;function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$8=f;class g extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=g;function c(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$0=c;class m extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=m;class h extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=h;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class l extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof l)return n;const i=new l;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=l;class $ extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$cb=$}),define(we[18],ve([1,0,11,141]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(X,x=0){return X[X.length-(1+x)]}e.$sb=s;function P(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.$tb=P;function D(X,x,z=(q,M)=>q===M){if(X===x)return!0;if(!X||!x||X.length!==x.length)return!1;for(let q=0,M=X.length;q<M;q++)if(!z(X[q],x[q]))return!1;return!0}e.$ub=D;function S(X,x){const z=X.length-1;x<z&&(X[x]=X[z]),X.pop()}e.$vb=S;function p(X,x,z){return v(X.length,q=>z(X[q],x))}e.$wb=p;function v(X,x){let z=0,q=X-1;for(;z<=q;){const M=(z+q)/2|0,H=x(M);if(H<0)z=M+1;else if(H>0)q=M-1;else return M}return-(z+1)}e.$xb=v;function I(X,x,z){if(X=X|0,X>=x.length)throw new TypeError("invalid index");const q=x[Math.floor(x.length*Math.random())],M=[],H=[],_=[];for(const ae of x){const fe=z(ae,q);fe<0?M.push(ae):fe>0?H.push(ae):_.push(ae)}return X<M.length?I(X,M,z):X<M.length+_.length?_[0]:I(X-(M.length+_.length),H,z)}e.$yb=I;function E(X,x){const z=[];let q;for(const M of X.slice(0).sort(x))!q||x(q[0],M)!==0?(q=[M],z.push(q)):q.push(M);return z}e.$zb=E;function*w(X,x){let z,q;for(const M of X)q!==void 0&&x(q,M)?z.push(M):(z&&(yield z),z=[M]),q=M;z&&(yield z)}e.$Ab=w;function f(X,x){for(let z=0;z<=X.length;z++)x(z===0?void 0:X[z-1],z===X.length?void 0:X[z])}e.$Bb=f;function g(X,x){for(let z=0;z<X.length;z++)x(z===0?void 0:X[z-1],X[z],z+1===X.length?void 0:X[z+1])}e.$Cb=g;function c(X,x,z){const q=[];function M(ae,fe,le){if(fe===0&&le.length===0)return;const $e=q[q.length-1];$e&&$e.start+$e.deleteCount===ae?($e.deleteCount+=fe,$e.toInsert.push(...le)):q.push({start:ae,deleteCount:fe,toInsert:le})}let H=0,_=0;for(;;){if(H===X.length){M(H,0,x.slice(_));break}if(_===x.length){M(H,X.length-H,[]);break}const ae=X[H],fe=x[_],le=z(ae,fe);le===0?(H+=1,_+=1):le<0?(M(H,1,[]),H+=1):le>0&&(M(H,0,[fe]),_+=1)}return q}e.$Db=c;function m(X,x,z){const q=c(X,x,z),M=[],H=[];for(const _ of q)M.push(...X.slice(_.start,_.start+_.deleteCount)),H.push(..._.toInsert);return{removed:M,added:H}}e.$Eb=m;function h(X,x,z){if(z===0)return[];const q=X.slice(0,z).sort(x);return l(X,x,q,z,X.length),q}e.top=h;function d(X,x,z,q,M){return z===0?Promise.resolve([]):new Promise((H,_)=>{(async()=>{const ae=X.length,fe=X.slice(0,z).sort(x);for(let le=z,$e=Math.min(z+q,ae);le<ae;le=$e,$e=Math.min($e+q,ae)){if(le>z&&await new Promise(ye=>setTimeout(ye)),M&&M.isCancellationRequested)throw new y.$5;l(X,x,fe,le,$e)}return fe})().then(H,_)})}e.$Gb=d;function l(X,x,z,q,M){for(const H=z.length;q<M;q++){const _=X[q];if(x(_,z[H-1])<0){z.pop();const ae=(0,A.$kb)(z,fe=>x(_,fe)<0);z.splice(ae,0,_)}}}function $(X){return X.filter(x=>!!x)}e.$Hb=$;function u(X){let x=0;for(let z=0;z<X.length;z++)X[z]&&(X[x]=X[z],x+=1);X.length=x}e.$Ib=u;function n(X,x,z){X.splice(z,0,X.splice(x,1)[0])}e.$Jb=n;function i(X){return!Array.isArray(X)||X.length===0}e.$Kb=i;function o(X){return Array.isArray(X)&&X.length>0}e.$Lb=o;function r(X,x=z=>z){const z=new Set;return X.filter(q=>{const M=x(q);return z.has(M)?!1:(z.add(M),!0)})}e.$Mb=r;function t(X){const x=new Set;return z=>{const q=X(z);return x.has(q)?!1:(x.add(q),!0)}}e.$Nb=t;function a(X,x){return X.length>0?X[0]:x}e.$Ob=a;function b(X,x){return X.length>0?X[X.length-1]:x}e.$Pb=b;function C(X,x,z=(q,M)=>q===M){let q=0;for(let M=0,H=Math.min(X.length,x.length);M<H&&z(X[M],x[M]);M++)q++;return q}e.$Qb=C;function L(X){return[].concat(...X)}e.$Rb=L;function k(X,x){let z=typeof x=="number"?X:0;typeof x=="number"?z=X:(z=0,x=X);const q=[];if(z<=x)for(let M=z;M<x;M++)q.push(M);else for(let M=z;M>x;M--)q.push(M);return q}e.$Sb=k;function R(X,x,z){return X.reduce((q,M)=>(q[x(M)]=z?z(M):M,q),Object.create(null))}e.$Tb=R;function N(X,x){return X.push(x),()=>Y(X,x)}e.$Ub=N;function Y(X,x){const z=X.indexOf(x);if(z>-1)return X.splice(z,1),x}e.$Vb=Y;function ee(X,x,z){const q=X.slice(0,x),M=X.slice(x);return q.concat(z,M)}e.$Wb=ee;function G(X,x){let z;if(typeof x=="number"){let q=x;z=()=>{const M=Math.sin(q++)*179426549;return M-Math.floor(M)}}else z=Math.random;for(let q=X.length-1;q>0;q-=1){const M=Math.floor(z()*(q+1)),H=X[q];X[q]=X[M],X[M]=H}}e.$Xb=G;function ne(X,x){const z=X.indexOf(x);z>-1&&(X.splice(z,1),X.unshift(x))}e.$Yb=ne;function Z(X,x){const z=X.indexOf(x);z>-1&&(X.splice(z,1),X.push(x))}e.$Zb=Z;function T(X,x){for(const z of x)X.push(z)}e.$1b=T;function oe(X,x){return Array.isArray(X)?X.map(x):x(X)}e.$2b=oe;function Q(X){return Array.isArray(X)?X:[X]}e.$3b=Q;function te(X){return X[Math.floor(Math.random()*X.length)]}e.$4b=te;function J(X,x,z){const q=ie(X,x),M=X.length,H=z.length;X.length=M+H;for(let _=M-1;_>=q;_--)X[_+H]=X[_];for(let _=0;_<H;_++)X[_+q]=z[_]}e.$5b=J;function V(X,x,z,q){const M=ie(X,x);let H=X.splice(M,z);return H===void 0&&(H=[]),J(X,M,q),H}e.$6b=V;function ie(X,x){return x<0?Math.max(x+X.length,0):Math.min(x,X.length)}var ue;(function(X){function x(H){return H<0}X.isLessThan=x;function z(H){return H<=0}X.isLessThanOrEqual=z;function q(H){return H>0}X.isGreaterThan=q;function M(H){return H===0}X.isNeitherLessOrGreaterThan=M,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function se(X,x){return(z,q)=>x(X(z),X(q))}e.$7b=se;function me(...X){return(x,z)=>{for(const q of X){const M=q(x,z);if(!ue.isNeitherLessOrGreaterThan(M))return M}return ue.neitherLessOrGreaterThan}}e.$8b=me;const B=(X,x)=>X-x;e.$9b=B;const W=(X,x)=>(0,e.$9b)(X?1:0,x?1:0);e.$0b=W;function O(X){return(x,z)=>-X(x,z)}e.$$b=O;class j{constructor(x){this.g=x,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(x){let z=this.c;for(;z<this.g.length&&x(this.g[z]);)z++;const q=z===this.c?null:this.g.slice(this.c,z);return this.c=z,q}takeFromEndWhile(x){let z=this.d;for(;z>=0&&x(this.g[z]);)z--;const q=z===this.d?null:this.g.slice(z+1,this.d+1);return this.d=z,q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const x=this.g[this.c];return this.c++,x}removeLast(){const x=this.g[this.d];return this.d--,x}takeCount(x){const z=this.g.slice(this.c,this.c+x);return this.c+=x,z}}e.$_b=j;class re{constructor(x){this.iterate=x}forEach(x){this.iterate(z=>(x(z),!0))}toArray(){const x=[];return this.iterate(z=>(x.push(z),!0)),x}filter(x){return new re(z=>this.iterate(q=>x(q)?z(q):!0))}map(x){return new re(z=>this.iterate(q=>z(x(q))))}some(x){let z=!1;return this.iterate(q=>(z=x(q),!z)),z}findFirst(x){let z;return this.iterate(q=>x(q)?(z=q,!1):!0),z}findLast(x){let z;return this.iterate(q=>(x(q)&&(z=q),!0)),z}findLastMaxBy(x){let z,q=!0;return this.iterate(M=>((q||ue.isGreaterThan(x(M,z)))&&(q=!1,z=M),!0)),z}}e.$ac=re,re.empty=new re(X=>{})}),define(we[97],ve([1,0,11]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function A(p,v){if(!p)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=A;function s(p,v="Unreachable"){throw new Error(v)}e.$5c=s;function P(p){if(!p)throw new y.$cb("Assertion Failed")}e.$6c=P;function D(p){if(!p()){debugger;p(),(0,y.$1)(new y.$cb("Assertion Failed"))}}e.$7c=D;function S(p,v){let I=0;for(;I<p.length-1;){const E=p[I],w=p[I+1];if(!v(E,w))return!1;I++}return!0}e.$8c=S}),define(we[75],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function y(A,s){const P=this;let D=!1,S;return function(){if(D)return S;if(D=!0,s)try{S=A.apply(P,arguments)}finally{s()}else S=A.apply(P,arguments);return S}}e.$db=y}),define(we[47],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(A){function s(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}A.is=s;const P=Object.freeze([]);function D(){return P}A.empty=D;function*S(u){yield u}A.single=S;function p(u){return s(u)?u:S(u)}A.wrap=p;function v(u){return u||P}A.from=v;function*I(u){for(let n=u.length-1;n>=0;n--)yield u[n]}A.reverse=I;function E(u){return!u||u[Symbol.iterator]().next().done===!0}A.isEmpty=E;function w(u){return u[Symbol.iterator]().next().value}A.first=w;function f(u,n){for(const i of u)if(n(i))return!0;return!1}A.some=f;function g(u,n){for(const i of u)if(n(i))return i}A.find=g;function*c(u,n){for(const i of u)n(i)&&(yield i)}A.filter=c;function*m(u,n){let i=0;for(const o of u)yield n(o,i++)}A.map=m;function*h(...u){for(const n of u)yield*n}A.concat=h;function d(u,n,i){let o=i;for(const r of u)o=n(o,r);return o}A.reduce=d;function*l(u,n,i=u.length){for(n<0&&(n+=u.length),i<0?i+=u.length:i>u.length&&(i=u.length);n<i;n++)yield u[n]}A.slice=l;function $(u,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,u];const o=u[Symbol.iterator]();for(let r=0;r<n;r++){const t=o.next();if(t.done)return[i,A.empty()];i.push(t.value)}return[i,{[Symbol.iterator](){return o}}]}A.consume=$})(y||(e.Iterable=y={}))}),define(we[76],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var A;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var s;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var P;(function(n){n.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function D(n,i=!1){let o=0;const r=n.length;let t="",a=0,b=16,C=0;function L(ne){let Z=0,T=0;for(;Z<ne;){const oe=n.charCodeAt(o);if(oe>=48&&oe<=57)T=T*16+oe-48;else if(oe>=65&&oe<=70)T=T*16+oe-65+10;else if(oe>=97&&oe<=102)T=T*16+oe-97+10;else break;o++,Z++}return Z<ne&&(T=-1),T}function k(ne){o=ne,t="",a=0,b=16,C=0}function R(){const ne=o;if(n.charCodeAt(o)===48)o++;else for(o++;o<n.length&&v(n.charCodeAt(o));)o++;if(o<n.length&&n.charCodeAt(o)===46)if(o++,o<n.length&&v(n.charCodeAt(o)))for(o++;o<n.length&&v(n.charCodeAt(o));)o++;else return C=3,n.substring(ne,o);let Z=o;if(o<n.length&&(n.charCodeAt(o)===69||n.charCodeAt(o)===101))if(o++,(o<n.length&&n.charCodeAt(o)===43||n.charCodeAt(o)===45)&&o++,o<n.length&&v(n.charCodeAt(o))){for(o++;o<n.length&&v(n.charCodeAt(o));)o++;Z=o}else C=3;return n.substring(ne,Z)}function N(){let ne="",Z=o;for(;;){if(o>=r){ne+=n.substring(Z,o),C=2;break}const T=n.charCodeAt(o);if(T===34){ne+=n.substring(Z,o),o++;break}if(T===92){if(ne+=n.substring(Z,o),o++,o>=r){C=2;break}switch(n.charCodeAt(o++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const Q=L(4);Q>=0?ne+=String.fromCharCode(Q):C=4;break}default:C=5}Z=o;continue}if(T>=0&&T<=31)if(p(T)){ne+=n.substring(Z,o),C=2;break}else C=6;o++}return ne}function Y(){if(t="",C=0,a=o,o>=r)return a=r,b=17;let ne=n.charCodeAt(o);if(S(ne)){do o++,t+=String.fromCharCode(ne),ne=n.charCodeAt(o);while(S(ne));return b=15}if(p(ne))return o++,t+=String.fromCharCode(ne),ne===13&&n.charCodeAt(o)===10&&(o++,t+=`
`),b=14;switch(ne){case 123:return o++,b=1;case 125:return o++,b=2;case 91:return o++,b=3;case 93:return o++,b=4;case 58:return o++,b=6;case 44:return o++,b=5;case 34:return o++,t=N(),b=10;case 47:{const Z=o-1;if(n.charCodeAt(o+1)===47){for(o+=2;o<r&&!p(n.charCodeAt(o));)o++;return t=n.substring(Z,o),b=12}if(n.charCodeAt(o+1)===42){o+=2;const T=r-1;let oe=!1;for(;o<T;){if(n.charCodeAt(o)===42&&n.charCodeAt(o+1)===47){o+=2,oe=!0;break}o++}return oe||(o++,C=1),t=n.substring(Z,o),b=13}return t+=String.fromCharCode(ne),o++,b=16}case 45:if(t+=String.fromCharCode(ne),o++,o===r||!v(n.charCodeAt(o)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=R(),b=11;default:for(;o<r&&ee(ne);)o++,ne=n.charCodeAt(o);if(a!==o){switch(t=n.substring(a,o),t){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return t+=String.fromCharCode(ne),o++,b=16}}function ee(ne){if(S(ne)||p(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let ne;do ne=Y();while(ne>=12&&ne<=15);return ne}return{setPosition:k,getPosition:()=>o,scan:i?G:Y,getToken:()=>b,getTokenValue:()=>t,getTokenOffset:()=>a,getTokenLength:()=>o-a,getTokenError:()=>C}}e.$9m=D;function S(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function p(n){return n===10||n===13||n===8232||n===8233}function v(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function E(n,i){const o=[],r=new Object;let t;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function C(L,k,R,N){a.value=L,a.offset=k,a.length=R,a.type=N,a.colonOffset=void 0,t=a}try{l(n,{onObjectBegin:(L,k)=>{if(i<=L)throw r;t=void 0,b=i>L,o.push("")},onObjectProperty:(L,k,R)=>{if(i<k||(C(L,k,R,"property"),o[o.length-1]=L,i<=k+R))throw r},onObjectEnd:(L,k)=>{if(i<=L)throw r;t=void 0,o.pop()},onArrayBegin:(L,k)=>{if(i<=L)throw r;t=void 0,o.push(0)},onArrayEnd:(L,k)=>{if(i<=L)throw r;t=void 0,o.pop()},onLiteralValue:(L,k,R)=>{if(i<k||(C(L,k,R,u(L)),i<=k+R))throw r},onSeparator:(L,k,R)=>{if(i<=k)throw r;if(L===":"&&t&&t.type==="property")t.colonOffset=k,b=!1,t=void 0;else if(L===","){const N=o[o.length-1];typeof N=="number"?o[o.length-1]=N+1:(b=!0,o[o.length-1]=""),t=void 0}}})}catch(L){if(L!==r)throw L}return{path:o,previousNode:t,isAtPropertyKey:b,matches:L=>{let k=0;for(let R=0;k<L.length&&R<o.length;R++)if(L[k]===o[R]||L[k]==="*")k++;else if(L[k]!=="**")return!1;return k===L.length}}}e.$0m=E;function w(n,i=[],o=P.DEFAULT){let r=null,t=[];const a=[];function b(L){Array.isArray(t)?t.push(L):r!==null&&(t[r]=L)}return l(n,{onObjectBegin:()=>{const L={};b(L),a.push(t),t=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{const L=[];b(L),a.push(t),t=L,r=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:b,onError:(L,k,R)=>{i.push({error:L,offset:k,length:R})}},o),t[0]}e.$$m=w;function f(n,i=[],o=P.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(L){r.type==="property"&&(r.length=L-r.offset,r=r.parent)}function a(L){return r.children.push(L),L}l(n,{onObjectBegin:L=>{r=a({type:"object",offset:L,length:-1,parent:r,children:[]})},onObjectProperty:(L,k,R)=>{r=a({type:"property",offset:k,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:L,offset:k,length:R,parent:r})},onObjectEnd:(L,k)=>{r.length=L+k-r.offset,r=r.parent,t(L+k)},onArrayBegin:(L,k)=>{r=a({type:"array",offset:L,length:-1,parent:r,children:[]})},onArrayEnd:(L,k)=>{r.length=L+k-r.offset,r=r.parent,t(L+k)},onLiteralValue:(L,k,R)=>{a({type:u(L),offset:k,length:R,parent:r,value:L}),t(k+R)},onSeparator:(L,k,R)=>{r.type==="property"&&(L===":"?r.colonOffset=k:L===","&&t(k))},onError:(L,k,R)=>{i.push({error:L,offset:k,length:R})}},o);const C=r.children[0];return C&&delete C.parent,C}e.$_m=f;function g(n,i){if(!n)return;let o=n;for(const r of i)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let t=!1;for(const a of o.children)if(Array.isArray(a.children)&&a.children[0].value===r){o=a.children[1],t=!0;break}if(!t)return}else{const t=r;if(o.type!=="array"||t<0||!Array.isArray(o.children)||t>=o.children.length)return;o=o.children[t]}return o}e.$an=g;function c(n){if(!n.parent||!n.parent.children)return[];const i=c(n.parent);if(n.parent.type==="property"){const o=n.parent.children[0].value;i.push(o)}else if(n.parent.type==="array"){const o=n.parent.children.indexOf(n);o!==-1&&i.push(o)}return i}e.$bn=c;function m(n){switch(n.type){case"array":return n.children.map(m);case"object":{const i=Object.create(null);for(const o of n.children){const r=o.children[1];r&&(i[o.children[0].value]=m(r))}return i}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$cn=m;function h(n,i,o=!1){return i>=n.offset&&i<n.offset+n.length||o&&i===n.offset+n.length}e.$dn=h;function d(n,i,o=!1){if(h(n,i,o)){const r=n.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=i;t++){const a=d(r[t],i,o);if(a)return a}return n}}e.$en=d;function l(n,i,o=P.DEFAULT){const r=D(n,!1);function t(se){return se?()=>se(r.getTokenOffset(),r.getTokenLength()):()=>!0}function a(se){return se?me=>se(me,r.getTokenOffset(),r.getTokenLength()):()=>!0}const b=t(i.onObjectBegin),C=a(i.onObjectProperty),L=t(i.onObjectEnd),k=t(i.onArrayBegin),R=t(i.onArrayEnd),N=a(i.onLiteralValue),Y=a(i.onSeparator),ee=t(i.onComment),G=a(i.onError),ne=o&&o.disallowComments,Z=o&&o.allowTrailingComma;function T(){for(;;){const se=r.scan();switch(r.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:ne||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(se){case 12:case 13:ne?oe(10):ee();break;case 16:oe(1);break;case 15:case 14:break;default:return se}}}function oe(se,me=[],B=[]){if(G(se),me.length+B.length>0){let W=r.getToken();for(;W!==17;){if(me.indexOf(W)!==-1){T();break}else if(B.indexOf(W)!==-1)break;W=T()}}}function Q(se){const me=r.getTokenValue();return se?N(me):C(me),T(),!0}function te(){switch(r.getToken()){case 11:{let se=0;try{se=JSON.parse(r.getTokenValue()),typeof se!="number"&&(oe(2),se=0)}catch{oe(2)}N(se);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return T(),!0}function J(){return r.getToken()!==10?(oe(3,[],[2,5]),!1):(Q(!1),r.getToken()===6?(Y(":"),T(),ue()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function V(){b(),T();let se=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(se||oe(4,[],[]),Y(","),T(),r.getToken()===2&&Z)break}else se&&oe(6,[],[]);J()||oe(4,[],[2,5]),se=!0}return L(),r.getToken()!==2?oe(7,[2],[]):T(),!0}function ie(){k(),T();let se=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(se||oe(4,[],[]),Y(","),T(),r.getToken()===4&&Z)break}else se&&oe(6,[],[]);ue()||oe(4,[],[4,5]),se=!0}return R(),r.getToken()!==4?oe(8,[4],[]):T(),!0}function ue(){switch(r.getToken()){case 3:return ie();case 1:return V();case 10:return Q(!0);default:return te()}}return T(),r.getToken()===17?o.allowEmptyContent?!0:(oe(4,[],[]),!1):ue()?(r.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$fn=l;function $(n,i){const o=D(n),r=[];let t,a=0,b;do switch(b=o.getPosition(),t=o.scan(),t){case 12:case 13:case 17:a!==b&&r.push(n.substring(a,b)),i!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,i)),a=o.getPosition();break}while(t!==17);return r.join("")}e.$gn=$;function u(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$hn=u}),define(we[59],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class y{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=y}),define(we[98],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class y{constructor(P){this.element=P,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class A{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let P=this.a;for(;P!==y.Undefined;){const D=P.next;P.prev=y.Undefined,P.next=y.Undefined,P=D}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,D){const S=new y(P);if(this.a===y.Undefined)this.a=S,this.b=S;else if(D){const v=this.b;this.b=S,S.prev=v,v.next=S}else{const v=this.a;this.a=S,S.next=v,v.prev=S}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(S))}}shift(){if(this.a!==y.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==y.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==y.Undefined&&P.next!==y.Undefined){const D=P.prev;D.next=P.next,P.next.prev=D}else P.prev===y.Undefined&&P.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):P.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):P.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==y.Undefined;)yield P.element,P=P.next}}e.$3c=A}),define(we[26],ve([1,0]),function(he,e){"use strict";var y,A,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function P(d,l,$){let u=d.get(l);return u===void 0&&(u=$,d.set(l,u)),u}e.$xc=P;function D(d){const l=[];return d.forEach(($,u)=>{l.push(`${u} => ${$}`)}),`Map(${d.size}) {${l.join(", ")}}`}e.$yc=D;function S(d){const l=[];return d.forEach($=>{l.push($)}),`Set(${d.size}) {${l.join(", ")}}`}e.$zc=S;class p{constructor(l,$){this.uri=l,this.value=$}}function v(d){return Array.isArray(d)}class I{constructor(l,$){if(this[y]="ResourceMap",l instanceof I)this.b=new Map(l.b),this.c=$??I.a;else if(v(l)){this.b=new Map,this.c=$??I.a;for(const[u,n]of l)this.set(u,n)}else this.b=new Map,this.c=l??I.a}set(l,$){return this.b.set(this.c(l),new p(l,$)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,$){typeof $<"u"&&(l=l.bind($));for(const[u,n]of this.b)l(n.value,n.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}e.$Ac=I,I.a=d=>d.toString();class E{constructor(l,$){this[A]="ResourceSet",!l||typeof l=="function"?this.a=new I(l):(this.a=new I($),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,$){this.a.forEach((u,n)=>l.call($,n,n,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=E;var w;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class f{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,$=0){const u=this.a.get(l);if(u)return $!==0&&this.j(u,$),u.value}set(l,$,u=0){let n=this.a.get(l);if(n)n.value=$,u!==0&&this.j(n,u);else{switch(n={key:l,value:$,next:void 0,previous:void 0},u){case 0:this.h(n);break;case 1:this.g(n);break;case 2:this.h(n);break;default:this.h(n);break}this.a.set(l,n),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const $=this.a.get(l);if($)return this.a.delete(l),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,$){const u=this.e;let n=this.b;for(;n;){if($?l.bind($)(n.value,n.key,this):l(n.value,n.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const l=this,$=this.e;let u=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==$)throw new Error("LinkedMap got modified during iteration.");if(u){const i={value:u.key,done:!1};return u=u.next,i}else return{value:void 0,done:!0}}};return n}values(){const l=this,$=this.e;let u=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==$)throw new Error("LinkedMap got modified during iteration.");if(u){const i={value:u.value,done:!1};return u=u.next,i}else return{value:void 0,done:!0}}};return n}entries(){const l=this,$=this.e;let u=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==$)throw new Error("LinkedMap got modified during iteration.");if(u){const i={value:[u.key,u.value],done:!1};return u=u.next,i}else return{value:void 0,done:!0}}};return n}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let $=this.b,u=this.size;for(;$&&u>l;)this.a.delete($.key),$=$.next,u--;this.b=$,this.d=u,$&&($.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const $=l.next,u=l.previous;if(!$||!u)throw new Error("Invalid list");$.previous=u,u.next=$}l.next=void 0,l.previous=void 0,this.e++}j(l,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(l===this.b)return;const u=l.next,n=l.previous;l===this.c?(n.next=void 0,this.c=n):(u.previous=n,n.next=u),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if($===2){if(l===this.c)return;const u=l.next,n=l.previous;l===this.b?(u.previous=void 0,this.b=u):(u.previous=n,n.next=u),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach(($,u)=>{l.push([u,$])}),l}fromJSON(l){this.clear();for(const[$,u]of l)this.set($,u)}}e.$Cc=f;class g extends f{constructor(l,$=1){super(),this.k=l,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,$=2){return super.get(l,$)}peek(l){return super.get(l,0)}set(l,$){return super.set(l,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=g;class c{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let $=this.a.get(l)||0;return $===0?!1:($--,$===0?this.a.delete(l):this.a.set(l,$),!0)}has(l){return this.a.has(l)}}e.$Ec=c;class m{constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[$,u]of l)this.set($,u)}clear(){this.a.clear(),this.b.clear()}set(l,$){this.a.set(l,$),this.b.set($,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const $=this.a.get(l);return $===void 0?!1:(this.a.delete(l),this.b.delete($),!0)}forEach(l,$){this.a.forEach((u,n)=>{l.call($,u,n,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=m;class h{constructor(){this.a=new Map}add(l,$){let u=this.a.get(l);u||(u=new Set,this.a.set(l,u)),u.add($)}delete(l,$){const u=this.a.get(l);u&&(u.delete($),u.size===0&&this.a.delete(l))}forEach(l,$){const u=this.a.get(l);u&&u.forEach($)}get(l){const $=this.a.get(l);return $||new Set}}e.$Gc=h}),define(we[2],ve([1,0,18,142,26,75,47]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const S=!1;let p=null;class v{constructor(){this.b=new Map}c(N){let Y=this.b.get(N);return Y||(Y={parent:null,source:null,isSingleton:!1,value:N,idx:v.a++},this.b.set(N,Y)),Y}trackDisposable(N){const Y=this.c(N);Y.source||(Y.source=new Error().stack)}setParent(N,Y){const ee=this.c(N);ee.parent=Y}markAsDisposed(N){this.b.delete(N)}markAsSingleton(N){this.c(N).isSingleton=!0}f(N,Y){const ee=Y.get(N);if(ee)return ee;const G=N.parent?this.f(this.c(N.parent),Y):N;return Y.set(N,G),G}getTrackedDisposables(){const N=new Map;return[...this.b.entries()].filter(([,ee])=>ee.source!==null&&!this.f(ee,N).isSingleton).flatMap(([ee])=>ee)}computeLeakingDisposables(N=10,Y){let ee;if(Y)ee=Y;else{const oe=new Map,Q=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,oe).isSingleton);if(Q.length===0)return;const te=new Set(Q.map(J=>J.value));if(ee=Q.filter(J=>!(J.parent&&te.has(J.parent))),ee.length===0)throw new Error("There are cyclic diposable chains!")}if(!ee)return;function G(oe){function Q(J,V){for(;J.length>0&&V.some(ie=>typeof ie=="string"?ie===J[0]:J[0].match(ie));)J.shift()}const te=oe.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return Q(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const ne=new s.$Gc;for(const oe of ee){const Q=G(oe);for(let te=0;te<=Q.length;te++)ne.add(Q.slice(0,te).join(`
`),oe)}ee.sort((0,y.$7b)(oe=>oe.idx,y.$9b));let Z="",T=0;for(const oe of ee.slice(0,N)){T++;const Q=G(oe),te=[];for(let J=0;J<Q.length;J++){let V=Q[J];V=`(shared with ${ne.get(Q.slice(0,J+1).join(`
`)).size}/${ee.length} leaks) at ${V}`;const ue=ne.get(Q.slice(0,J).join(`
`)),se=(0,A.$E)([...ue].map(me=>G(me)[J]),me=>me);delete se[Q[J]];for(const[me,B]of Object.entries(se))te.unshift(`    - stacktraces of ${B.length} other leaks continue with ${me}`);te.unshift(V)}Z+=`


==================== Leaking disposable ${T}/${ee.length}: ${oe.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return ee.length>N&&(Z+=`


... and ${ee.length-N} more leaking disposables

`),{leaks:ee,details:Z}}}e.$Hc=v,v.a=0;function I(R){p=R}if(e.$Ic=I,S){const R="__is_disposable_tracked__";I(new class{trackDisposable(N){const Y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{N[R]||console.log(Y)},3e3)}setParent(N,Y){if(N&&N!==n.None)try{N[R]=!0}catch{}}markAsDisposed(N){if(N&&N!==n.None)try{N[R]=!0}catch{}}markAsSingleton(N){}})}function E(R){return p?.trackDisposable(R),R}e.$Jc=E;function w(R){p?.markAsDisposed(R)}e.$Kc=w;function f(R,N){p?.setParent(R,N)}function g(R,N){if(p)for(const Y of R)p.setParent(Y,N)}function c(R){return p?.markAsSingleton(R),R}e.$Lc=c;function m(R){return typeof R.dispose=="function"&&R.dispose.length===0}e.$Mc=m;function h(R){if(D.Iterable.is(R)){const N=[];for(const Y of R)if(Y)try{Y.dispose()}catch(ee){N.push(ee)}if(N.length===1)throw N[0];if(N.length>1)throw new AggregateError(N,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}e.$Nc=h;function d(R){for(const N of R)m(N)&&N.dispose();return[]}e.$Oc=d;function l(...R){const N=$(()=>h(R));return g(R,N),N}e.$Pc=l;function $(R){const N=E({dispose:(0,P.$db)(()=>{w(N),R()})});return N}e.$Qc=$;class u{constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(N){if(!N)return N;if(N===this)throw new Error("Cannot register a disposable on itself!");return f(N,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(N),N}delete(N){if(N){if(N===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(N),N.dispose()}}deleteAndLeak(N){N&&this.f.has(N)&&(this.f.delete(N),f(N,null))}}e.$Rc=u,u.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this.q=new u,E(this),f(this.q,this)}dispose(){w(this),this.q.dispose()}B(N){if(N===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(N)}}e.$Sc=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(N){this.b||N===this.a||(this.a?.dispose(),N&&f(N,this),this.a=N)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const N=this.a;return this.a=void 0,N&&f(N,null),N}}e.$Tc=i;class o{constructor(N){this.a=new i,this.b=!1,this.a.value=N}get value(){return this.a.value}set value(N){this.b||N===this.a.value||(this.a.value=N)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=o;class r{constructor(N){this.b=N,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=r;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(N){let Y=N;return this.unset=()=>Y=void 0,this.isset=()=>Y!==void 0,this.dispose=()=>{Y&&(Y(),Y=void 0,w(this))},this}}e.$Wc=t;class a{constructor(){this.a=new Map}acquire(N,...Y){let ee=this.a.get(N);ee||(ee={counter:0,object:this.b(N,...Y)},this.a.set(N,ee));const{object:G}=ee,ne=(0,P.$db)(()=>{--ee.counter===0&&(this.c(N,ee.object),this.a.delete(N))});return ee.counter++,{object:G,dispose:ne}}}e.$Xc=a;class b{constructor(N){this.a=N}async acquire(N,...Y){const ee=this.a.acquire(N,...Y);try{return{object:await ee.object,dispose:()=>ee.dispose()}}catch(G){throw ee.dispose(),G}}}e.$Yc=b;class C{constructor(N){this.object=N}dispose(){}}e.$Zc=C;function L(R){const N=new u;try{R(N)}finally{N.dispose()}}e.$1c=L;class k{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(N){return this.a.has(N)}get size(){return this.a.size}get(N){return this.a.get(N)}set(N,Y,ee=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ee||this.a.get(N)?.dispose(),this.a.set(N,Y)}deleteAndDispose(N){this.a.get(N)?.dispose(),this.a.delete(N)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=k}),function(he,e){typeof define=="function"&&define.amd?define(we[143],ve([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(x,z){for(var q=0;q<z.length;q++){var M=z[q];M.enumerable=M.enumerable||!1,M.configurable=!0,"value"in M&&(M.writable=!0),Object.defineProperty(x,M.key,M)}}function y(x,z,q){return z&&e(x.prototype,z),q&&e(x,q),Object.defineProperty(x,"prototype",{writable:!1}),x}function A(x,z){if(x){if(typeof x=="string")return s(x,z);var q=Object.prototype.toString.call(x).slice(8,-1);if(q==="Object"&&x.constructor&&(q=x.constructor.name),q==="Map"||q==="Set")return Array.from(x);if(q==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(q))return s(x,z)}}function s(x,z){(z==null||z>x.length)&&(z=x.length);for(var q=0,M=new Array(z);q<z;q++)M[q]=x[q];return M}function P(x,z){var q=typeof Symbol<"u"&&x[Symbol.iterator]||x["@@iterator"];if(q)return(q=q.call(x)).next.bind(q);if(Array.isArray(x)||(q=A(x))||z&&x&&typeof x.length=="number"){q&&(x=q);var M=0;return function(){return M>=x.length?{done:!0}:{done:!1,value:x[M++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=D();function S(x){he.defaults=x}var p=/[&<>"']/,v=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(z){return w[z]};function g(x,z){if(z){if(p.test(x))return x.replace(v,f)}else if(I.test(x))return x.replace(E,f);return x}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(x){return x.replace(c,function(z,q){return q=q.toLowerCase(),q==="colon"?":":q.charAt(0)==="#"?q.charAt(1)==="x"?String.fromCharCode(parseInt(q.substring(2),16)):String.fromCharCode(+q.substring(1)):""})}var h=/(^|[^\[])\^/g;function d(x,z){x=typeof x=="string"?x:x.source,z=z||"";var q={replace:function(H,_){return _=_.source||_,_=_.replace(h,"$1"),x=x.replace(H,_),q},getRegex:function(){return new RegExp(x,z)}};return q}var l=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(x,z,q){if(x){var M;try{M=decodeURIComponent(m(q)).replace(l,"").toLowerCase()}catch{return null}if(M.indexOf("javascript:")===0||M.indexOf("vbscript:")===0||M.indexOf("data:")===0)return null}z&&!$.test(q)&&(q=t(z,q));try{q=encodeURI(q).replace(/%25/g,"%")}catch{return null}return q}var n={},i=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function t(x,z){n[" "+x]||(i.test(x)?n[" "+x]=x+"/":n[" "+x]=L(x,"/",!0)),x=n[" "+x];var q=x.indexOf(":")===-1;return z.substring(0,2)==="//"?q?z:x.replace(o,"$1")+z:z.charAt(0)==="/"?q?z:x.replace(r,"$1")+z:x+z}var a={exec:function(){}};function b(x){for(var z=1,q,M;z<arguments.length;z++){q=arguments[z];for(M in q)Object.prototype.hasOwnProperty.call(q,M)&&(x[M]=q[M])}return x}function C(x,z){var q=x.replace(/\|/g,function(_,ae,fe){for(var le=!1,$e=ae;--$e>=0&&fe[$e]==="\\";)le=!le;return le?"|":" |"}),M=q.split(/ \|/),H=0;if(M[0].trim()||M.shift(),M.length>0&&!M[M.length-1].trim()&&M.pop(),M.length>z)M.splice(z);else for(;M.length<z;)M.push("");for(;H<M.length;H++)M[H]=M[H].trim().replace(/\\\|/g,"|");return M}function L(x,z,q){var M=x.length;if(M===0)return"";for(var H=0;H<M;){var _=x.charAt(M-H-1);if(_===z&&!q)H++;else if(_!==z&&q)H++;else break}return x.slice(0,M-H)}function k(x,z){if(x.indexOf(z[1])===-1)return-1;for(var q=x.length,M=0,H=0;H<q;H++)if(x[H]==="\\")H++;else if(x[H]===z[0])M++;else if(x[H]===z[1]&&(M--,M<0))return H;return-1}function R(x){x&&x.sanitize&&!x.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(x,z){if(z<1)return"";for(var q="";z>1;)z&1&&(q+=x),z>>=1,x+=x;return q+x}function Y(x,z,q,M){var H=z.href,_=z.title?g(z.title):null,ae=x[1].replace(/\\([\[\]])/g,"$1");if(x[0].charAt(0)!=="!"){M.state.inLink=!0;var fe={type:"link",raw:q,href:H,title:_,text:ae,tokens:M.inlineTokens(ae)};return M.state.inLink=!1,fe}return{type:"image",raw:q,href:H,title:_,text:g(ae)}}function ee(x,z){var q=x.match(/^(\s+)(?:```)/);if(q===null)return z;var M=q[1];return z.split(`
`).map(function(H){var _=H.match(/^\s+/);if(_===null)return H;var ae=_[0];return ae.length>=M.length?H.slice(M.length):H}).join(`
`)}var G=function(){function x(q){this.options=q||he.defaults}var z=x.prototype;return z.space=function(M){var H=this.rules.block.newline.exec(M);if(H&&H[0].length>0)return{type:"space",raw:H[0]}},z.code=function(M){var H=this.rules.block.code.exec(M);if(H){var _=H[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:H[0],codeBlockStyle:"indented",text:this.options.pedantic?_:L(_,`
`)}}},z.fences=function(M){var H=this.rules.block.fences.exec(M);if(H){var _=H[0],ae=ee(_,H[3]||"");return{type:"code",raw:_,lang:H[2]?H[2].trim():H[2],text:ae}}},z.heading=function(M){var H=this.rules.block.heading.exec(M);if(H){var _=H[2].trim();if(/#$/.test(_)){var ae=L(_,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(_=ae.trim())}return{type:"heading",raw:H[0],depth:H[1].length,text:_,tokens:this.lexer.inline(_)}}},z.hr=function(M){var H=this.rules.block.hr.exec(M);if(H)return{type:"hr",raw:H[0]}},z.blockquote=function(M){var H=this.rules.block.blockquote.exec(M);if(H){var _=H[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:H[0],tokens:this.lexer.blockTokens(_,[]),text:_}}},z.list=function(M){var H=this.rules.block.list.exec(M);if(H){var _,ae,fe,le,$e,ye,Ae,Re,ge,ke,De,Me,Te=H[1].trim(),He=Te.length>1,Ue={type:"list",raw:"",ordered:He,start:He?+Te.slice(0,-1):"",loose:!1,items:[]};Te=He?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=He?Te:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");M&&(Me=!1,!(!(H=Ke.exec(M))||this.rules.block.hr.test(M)));){if(_=H[0],M=M.substring(_.length),Re=H[2].split(`
`,1)[0],ge=M.split(`
`,1)[0],this.options.pedantic?(le=2,De=Re.trimLeft()):(le=H[2].search(/[^ ]/),le=le>4?1:le,De=Re.slice(le),le+=H[1].length),ye=!1,!Re&&/^ *$/.test(ge)&&(_+=ge+`
`,M=M.substring(ge.length+1),Me=!0),!Me)for(var tt=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ze=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),be=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");M&&(ke=M.split(`
`,1)[0],Re=ke,this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(Re)||be.test(Re)||tt.test(Re)||Ze.test(M)));){if(Re.search(/[^ ]/)>=le||!Re.trim())De+=`
`+Re.slice(le);else if(!ye)De+=`
`+Re;else break;!ye&&!Re.trim()&&(ye=!0),_+=ke+`
`,M=M.substring(ke.length+1)}Ue.loose||(Ae?Ue.loose=!0:/\n *\n *$/.test(_)&&(Ae=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(De),ae&&(fe=ae[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:_,task:!!ae,checked:fe,loose:!1,text:De}),Ue.raw+=_}Ue.items[Ue.items.length-1].raw=_.trimRight(),Ue.items[Ue.items.length-1].text=De.trimRight(),Ue.raw=Ue.raw.trimRight();var Ie=Ue.items.length;for($e=0;$e<Ie;$e++){this.lexer.state.top=!1,Ue.items[$e].tokens=this.lexer.blockTokens(Ue.items[$e].text,[]);var Ce=Ue.items[$e].tokens.filter(function(Fe){return Fe.type==="space"}),je=Ce.every(function(Fe){for(var qe=Fe.raw.split(""),Ve=0,Qe=P(qe),Je;!(Je=Qe()).done;){var xe=Je.value;if(xe===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ue.loose&&Ce.length&&je&&(Ue.loose=!0,Ue.items[$e].loose=!0)}return Ue}},z.html=function(M){var H=this.rules.block.html.exec(M);if(H){var _={type:"html",raw:H[0],pre:!this.options.sanitizer&&(H[1]==="pre"||H[1]==="script"||H[1]==="style"),text:H[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(H[0]):g(H[0]);_.type="paragraph",_.text=ae,_.tokens=this.lexer.inline(ae)}return _}},z.def=function(M){var H=this.rules.block.def.exec(M);if(H){H[3]&&(H[3]=H[3].substring(1,H[3].length-1));var _=H[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:_,raw:H[0],href:H[2],title:H[3]}}},z.table=function(M){var H=this.rules.block.table.exec(M);if(H){var _={type:"table",header:C(H[1]).map(function(Ae){return{text:Ae}}),align:H[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:H[3]&&H[3].trim()?H[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(_.header.length===_.align.length){_.raw=H[0];var ae=_.align.length,fe,le,$e,ye;for(fe=0;fe<ae;fe++)/^ *-+: *$/.test(_.align[fe])?_.align[fe]="right":/^ *:-+: *$/.test(_.align[fe])?_.align[fe]="center":/^ *:-+ *$/.test(_.align[fe])?_.align[fe]="left":_.align[fe]=null;for(ae=_.rows.length,fe=0;fe<ae;fe++)_.rows[fe]=C(_.rows[fe],_.header.length).map(function(Ae){return{text:Ae}});for(ae=_.header.length,le=0;le<ae;le++)_.header[le].tokens=this.lexer.inline(_.header[le].text);for(ae=_.rows.length,le=0;le<ae;le++)for(ye=_.rows[le],$e=0;$e<ye.length;$e++)ye[$e].tokens=this.lexer.inline(ye[$e].text);return _}}},z.lheading=function(M){var H=this.rules.block.lheading.exec(M);if(H)return{type:"heading",raw:H[0],depth:H[2].charAt(0)==="="?1:2,text:H[1],tokens:this.lexer.inline(H[1])}},z.paragraph=function(M){var H=this.rules.block.paragraph.exec(M);if(H){var _=H[1].charAt(H[1].length-1)===`
`?H[1].slice(0,-1):H[1];return{type:"paragraph",raw:H[0],text:_,tokens:this.lexer.inline(_)}}},z.text=function(M){var H=this.rules.block.text.exec(M);if(H)return{type:"text",raw:H[0],text:H[0],tokens:this.lexer.inline(H[0])}},z.escape=function(M){var H=this.rules.inline.escape.exec(M);if(H)return{type:"escape",raw:H[0],text:g(H[1])}},z.tag=function(M){var H=this.rules.inline.tag.exec(M);if(H)return!this.lexer.state.inLink&&/^<a /i.test(H[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(H[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:H[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):g(H[0]):H[0]}},z.link=function(M){var H=this.rules.inline.link.exec(M);if(H){var _=H[2].trim();if(!this.options.pedantic&&/^</.test(_)){if(!/>$/.test(_))return;var ae=L(_.slice(0,-1),"\\");if((_.length-ae.length)%2===0)return}else{var fe=k(H[2],"()");if(fe>-1){var le=H[0].indexOf("!")===0?5:4,$e=le+H[1].length+fe;H[2]=H[2].substring(0,fe),H[0]=H[0].substring(0,$e).trim(),H[3]=""}}var ye=H[2],Ae="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ye);Re&&(ye=Re[1],Ae=Re[3])}else Ae=H[3]?H[3].slice(1,-1):"";return ye=ye.trim(),/^</.test(ye)&&(this.options.pedantic&&!/>$/.test(_)?ye=ye.slice(1):ye=ye.slice(1,-1)),Y(H,{href:ye&&ye.replace(this.rules.inline._escapes,"$1"),title:Ae&&Ae.replace(this.rules.inline._escapes,"$1")},H[0],this.lexer)}},z.reflink=function(M,H){var _;if((_=this.rules.inline.reflink.exec(M))||(_=this.rules.inline.nolink.exec(M))){var ae=(_[2]||_[1]).replace(/\s+/g," ");if(ae=H[ae.toLowerCase()],!ae||!ae.href){var fe=_[0].charAt(0);return{type:"text",raw:fe,text:fe}}return Y(_,ae,_[0],this.lexer)}},z.emStrong=function(M,H,_){_===void 0&&(_="");var ae=this.rules.inline.emStrong.lDelim.exec(M);if(ae&&!(ae[3]&&_.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=ae[1]||ae[2]||"";if(!fe||fe&&(_===""||this.rules.inline.punctuation.exec(_))){var le=ae[0].length-1,$e,ye,Ae=le,Re=0,ge=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,H=H.slice(-1*M.length+le);(ae=ge.exec(H))!=null;)if($e=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!$e){if(ye=$e.length,ae[3]||ae[4]){Ae+=ye;continue}else if((ae[5]||ae[6])&&le%3&&!((le+ye)%3)){Re+=ye;continue}if(Ae-=ye,!(Ae>0)){if(ye=Math.min(ye,ye+Ae+Re),Math.min(le,ye)%2){var ke=M.slice(1,le+ae.index+ye);return{type:"em",raw:M.slice(0,le+ae.index+ye+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var De=M.slice(2,le+ae.index+ye-1);return{type:"strong",raw:M.slice(0,le+ae.index+ye+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},z.codespan=function(M){var H=this.rules.inline.code.exec(M);if(H){var _=H[2].replace(/\n/g," "),ae=/[^ ]/.test(_),fe=/^ /.test(_)&&/ $/.test(_);return ae&&fe&&(_=_.substring(1,_.length-1)),_=g(_,!0),{type:"codespan",raw:H[0],text:_}}},z.br=function(M){var H=this.rules.inline.br.exec(M);if(H)return{type:"br",raw:H[0]}},z.del=function(M){var H=this.rules.inline.del.exec(M);if(H)return{type:"del",raw:H[0],text:H[2],tokens:this.lexer.inlineTokens(H[2])}},z.autolink=function(M,H){var _=this.rules.inline.autolink.exec(M);if(_){var ae,fe;return _[2]==="@"?(ae=g(this.options.mangle?H(_[1]):_[1]),fe="mailto:"+ae):(ae=g(_[1]),fe=ae),{type:"link",raw:_[0],text:ae,href:fe,tokens:[{type:"text",raw:ae,text:ae}]}}},z.url=function(M,H){var _;if(_=this.rules.inline.url.exec(M)){var ae,fe;if(_[2]==="@")ae=g(this.options.mangle?H(_[0]):_[0]),fe="mailto:"+ae;else{var le;do le=_[0],_[0]=this.rules.inline._backpedal.exec(_[0])[0];while(le!==_[0]);ae=g(_[0]),_[1]==="www."?fe="http://"+ae:fe=ae}return{type:"link",raw:_[0],text:ae,href:fe,tokens:[{type:"text",raw:ae,text:ae}]}}},z.inlineText=function(M,H){var _=this.rules.inline.text.exec(M);if(_){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(_[0]):g(_[0]):_[0]:ae=g(this.options.smartypants?H(_[0]):_[0]),{type:"text",raw:_[0],text:ae}}},x}(),ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=d(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=d(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=d(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=d(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=d(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=d(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=b({},ne),ne.gfm=b({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=d(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.paragraph=d(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ne.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=b({},ne.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:d(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Z.punctuation=d(Z.punctuation).replace(/punctuation/g,Z._punctuation).getRegex(),Z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Z.escapedEmSt=/\\\*|\\_/g,Z._comment=d(ne._comment).replace("(?:-->|$)","-->").getRegex(),Z.emStrong.lDelim=d(Z.emStrong.lDelim).replace(/punct/g,Z._punctuation).getRegex(),Z.emStrong.rDelimAst=d(Z.emStrong.rDelimAst,"g").replace(/punct/g,Z._punctuation).getRegex(),Z.emStrong.rDelimUnd=d(Z.emStrong.rDelimUnd,"g").replace(/punct/g,Z._punctuation).getRegex(),Z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Z.autolink=d(Z.autolink).replace("scheme",Z._scheme).replace("email",Z._email).getRegex(),Z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Z.tag=d(Z.tag).replace("comment",Z._comment).replace("attribute",Z._attribute).getRegex(),Z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Z.link=d(Z.link).replace("label",Z._label).replace("href",Z._href).replace("title",Z._title).getRegex(),Z.reflink=d(Z.reflink).replace("label",Z._label).replace("ref",ne._label).getRegex(),Z.nolink=d(Z.nolink).replace("ref",ne._label).getRegex(),Z.reflinkSearch=d(Z.reflinkSearch,"g").replace("reflink",Z.reflink).replace("nolink",Z.nolink).getRegex(),Z.normal=b({},Z),Z.pedantic=b({},Z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",Z._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Z._label).getRegex()}),Z.gfm=b({},Z.normal,{escape:d(Z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Z.gfm.url=d(Z.gfm.url,"i").replace("email",Z.gfm._extended_email).getRegex(),Z.breaks=b({},Z.gfm,{br:d(Z.br).replace("{2,}","*").getRegex(),text:d(Z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(x){return x.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function oe(x){var z="",q,M,H=x.length;for(q=0;q<H;q++)M=x.charCodeAt(q),Math.random()>.5&&(M="x"+M.toString(16)),z+="&#"+M+";";return z}var Q=function(){function x(q){this.tokens=[],this.tokens.links=Object.create(null),this.options=q||he.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var M={block:ne.normal,inline:Z.normal};this.options.pedantic?(M.block=ne.pedantic,M.inline=Z.pedantic):this.options.gfm&&(M.block=ne.gfm,this.options.breaks?M.inline=Z.breaks:M.inline=Z.gfm),this.tokenizer.rules=M}x.lex=function(M,H){var _=new x(H);return _.lex(M)},x.lexInline=function(M,H){var _=new x(H);return _.inlineTokens(M)};var z=x.prototype;return z.lex=function(M){M=M.replace(/\r\n|\r/g,`
`),this.blockTokens(M,this.tokens);for(var H;H=this.inlineQueue.shift();)this.inlineTokens(H.src,H.tokens);return this.tokens},z.blockTokens=function(M,H){var _=this;H===void 0&&(H=[]),this.options.pedantic?M=M.replace(/\t/g,"    ").replace(/^ +$/gm,""):M=M.replace(/^( *)(\t+)/gm,function(Ae,Re,ge){return Re+"    ".repeat(ge.length)});for(var ae,fe,le,$e;M;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ae){return(ae=Ae.call({lexer:_},M,H))?(M=M.substring(ae.raw.length),H.push(ae),!0):!1}))){if(ae=this.tokenizer.space(M)){M=M.substring(ae.raw.length),ae.raw.length===1&&H.length>0?H[H.length-1].raw+=`
`:H.push(ae);continue}if(ae=this.tokenizer.code(M)){M=M.substring(ae.raw.length),fe=H[H.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):H.push(ae);continue}if(ae=this.tokenizer.fences(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.heading(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.hr(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.blockquote(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.list(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.html(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.def(M)){M=M.substring(ae.raw.length),fe=H[H.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.lheading(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(le=M,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ae=1/0,Re=M.slice(1),ge=void 0;_.options.extensions.startBlock.forEach(function(ke){ge=ke.call({lexer:this},Re),typeof ge=="number"&&ge>=0&&(Ae=Math.min(Ae,ge))}),Ae<1/0&&Ae>=0&&(le=M.substring(0,Ae+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(le))){fe=H[H.length-1],$e&&fe.type==="paragraph"?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):H.push(ae),$e=le.length!==M.length,M=M.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(M)){M=M.substring(ae.raw.length),fe=H[H.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):H.push(ae);continue}if(M){var ye="Infinite loop on byte: "+M.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return this.state.top=!0,H},z.inline=function(M,H){return H===void 0&&(H=[]),this.inlineQueue.push({src:M,tokens:H}),H},z.inlineTokens=function(M,H){var _=this;H===void 0&&(H=[]);var ae,fe,le,$e=M,ye,Ae,Re;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(ye=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)ge.includes(ye[0].slice(ye[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,ye.index)+"["+N("a",ye[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ye=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,ye.index)+"["+N("a",ye[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ye=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,ye.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;M;)if(Ae||(Re=""),Ae=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(ae=De.call({lexer:_},M,H))?(M=M.substring(ae.raw.length),H.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.tag(M)){M=M.substring(ae.raw.length),fe=H[H.length-1],fe&&ae.type==="text"&&fe.type==="text"?(fe.raw+=ae.raw,fe.text+=ae.text):H.push(ae);continue}if(ae=this.tokenizer.link(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.reflink(M,this.tokens.links)){M=M.substring(ae.raw.length),fe=H[H.length-1],fe&&ae.type==="text"&&fe.type==="text"?(fe.raw+=ae.raw,fe.text+=ae.text):H.push(ae);continue}if(ae=this.tokenizer.emStrong(M,$e,Re)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.codespan(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.br(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.del(M)){M=M.substring(ae.raw.length),H.push(ae);continue}if(ae=this.tokenizer.autolink(M,oe)){M=M.substring(ae.raw.length),H.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(M,oe))){M=M.substring(ae.raw.length),H.push(ae);continue}if(le=M,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Me=M.slice(1),Te=void 0;_.options.extensions.startInline.forEach(function(He){Te=He.call({lexer:this},Me),typeof Te=="number"&&Te>=0&&(De=Math.min(De,Te))}),De<1/0&&De>=0&&(le=M.substring(0,De+1))}(),ae=this.tokenizer.inlineText(le,T)){M=M.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(Re=ae.raw.slice(-1)),Ae=!0,fe=H[H.length-1],fe&&fe.type==="text"?(fe.raw+=ae.raw,fe.text+=ae.text):H.push(ae);continue}if(M){var ke="Infinite loop on byte: "+M.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return H},y(x,null,[{key:"rules",get:function(){return{block:ne,inline:Z}}}]),x}(),te=function(){function x(q){this.options=q||he.defaults}var z=x.prototype;return z.code=function(M,H,_){var ae=(H||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(M,ae);fe!=null&&fe!==M&&(_=!0,M=fe)}return M=M.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+g(ae,!0)+'">'+(_?M:g(M,!0))+`</code></pre>
`:"<pre><code>"+(_?M:g(M,!0))+`</code></pre>
`},z.blockquote=function(M){return`<blockquote>
`+M+`</blockquote>
`},z.html=function(M){return M},z.heading=function(M,H,_,ae){if(this.options.headerIds){var fe=this.options.headerPrefix+ae.slug(_);return"<h"+H+' id="'+fe+'">'+M+"</h"+H+`>
`}return"<h"+H+">"+M+"</h"+H+`>
`},z.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},z.list=function(M,H,_){var ae=H?"ol":"ul",fe=H&&_!==1?' start="'+_+'"':"";return"<"+ae+fe+`>
`+M+"</"+ae+`>
`},z.listitem=function(M){return"<li>"+M+`</li>
`},z.checkbox=function(M){return"<input "+(M?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},z.paragraph=function(M){return"<p>"+M+`</p>
`},z.table=function(M,H){return H&&(H="<tbody>"+H+"</tbody>"),`<table>
<thead>
`+M+`</thead>
`+H+`</table>
`},z.tablerow=function(M){return`<tr>
`+M+`</tr>
`},z.tablecell=function(M,H){var _=H.header?"th":"td",ae=H.align?"<"+_+' align="'+H.align+'">':"<"+_+">";return ae+M+("</"+_+`>
`)},z.strong=function(M){return"<strong>"+M+"</strong>"},z.em=function(M){return"<em>"+M+"</em>"},z.codespan=function(M){return"<code>"+M+"</code>"},z.br=function(){return this.options.xhtml?"<br/>":"<br>"},z.del=function(M){return"<del>"+M+"</del>"},z.link=function(M,H,_){if(M=u(this.options.sanitize,this.options.baseUrl,M),M===null)return _;var ae='<a href="'+g(M)+'"';return H&&(ae+=' title="'+H+'"'),ae+=">"+_+"</a>",ae},z.image=function(M,H,_){if(M=u(this.options.sanitize,this.options.baseUrl,M),M===null)return _;var ae='<img src="'+M+'" alt="'+_+'"';return H&&(ae+=' title="'+H+'"'),ae+=this.options.xhtml?"/>":">",ae},z.text=function(M){return M},x}(),J=function(){function x(){}var z=x.prototype;return z.strong=function(M){return M},z.em=function(M){return M},z.codespan=function(M){return M},z.del=function(M){return M},z.html=function(M){return M},z.text=function(M){return M},z.link=function(M,H,_){return""+_},z.image=function(M,H,_){return""+_},z.br=function(){return""},x}(),V=function(){function x(){this.seen={}}var z=x.prototype;return z.serialize=function(M){return M.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},z.getNextSafeSlug=function(M,H){var _=M,ae=0;if(this.seen.hasOwnProperty(_)){ae=this.seen[M];do ae++,_=M+"-"+ae;while(this.seen.hasOwnProperty(_))}return H||(this.seen[M]=ae,this.seen[_]=0),_},z.slug=function(M,H){H===void 0&&(H={});var _=this.serialize(M);return this.getNextSafeSlug(_,H.dryrun)},x}(),ie=function(){function x(q){this.options=q||he.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new V}x.parse=function(M,H){var _=new x(H);return _.parse(M)},x.parseInline=function(M,H){var _=new x(H);return _.parseInline(M)};var z=x.prototype;return z.parse=function(M,H){H===void 0&&(H=!0);var _="",ae,fe,le,$e,ye,Ae,Re,ge,ke,De,Me,Te,He,Ue,Ke,tt,Ze,et,be,Ie=M.length;for(ae=0;ae<Ie;ae++){if(De=M[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(be=this.options.extensions.renderers[De.type].call({parser:this},De),be!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){_+=be||"";continue}switch(De.type){case"space":continue;case"hr":{_+=this.renderer.hr();continue}case"heading":{_+=this.renderer.heading(this.parseInline(De.tokens),De.depth,m(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{_+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(ge="",Re="",$e=De.header.length,fe=0;fe<$e;fe++)Re+=this.renderer.tablecell(this.parseInline(De.header[fe].tokens),{header:!0,align:De.align[fe]});for(ge+=this.renderer.tablerow(Re),ke="",$e=De.rows.length,fe=0;fe<$e;fe++){for(Ae=De.rows[fe],Re="",ye=Ae.length,le=0;le<ye;le++)Re+=this.renderer.tablecell(this.parseInline(Ae[le].tokens),{header:!1,align:De.align[le]});ke+=this.renderer.tablerow(Re)}_+=this.renderer.table(ge,ke);continue}case"blockquote":{ke=this.parse(De.tokens),_+=this.renderer.blockquote(ke);continue}case"list":{for(Me=De.ordered,Te=De.start,He=De.loose,$e=De.items.length,ke="",fe=0;fe<$e;fe++)Ke=De.items[fe],tt=Ke.checked,Ze=Ke.task,Ue="",Ke.task&&(et=this.renderer.checkbox(tt),He?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=et+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=et+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:et}):Ue+=et),Ue+=this.parse(Ke.tokens,He),ke+=this.renderer.listitem(Ue,Ze,tt);_+=this.renderer.list(ke,Me,Te);continue}case"html":{_+=this.renderer.html(De.text);continue}case"paragraph":{_+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(ke=De.tokens?this.parseInline(De.tokens):De.text;ae+1<Ie&&M[ae+1].type==="text";)De=M[++ae],ke+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);_+=H?this.renderer.paragraph(ke):ke;continue}default:{var Ce='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return _},z.parseInline=function(M,H){H=H||this.renderer;var _="",ae,fe,le,$e=M.length;for(ae=0;ae<$e;ae++){if(fe=M[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(le=this.options.extensions.renderers[fe.type].call({parser:this},fe),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){_+=le||"";continue}switch(fe.type){case"escape":{_+=H.text(fe.text);break}case"html":{_+=H.html(fe.text);break}case"link":{_+=H.link(fe.href,fe.title,this.parseInline(fe.tokens,H));break}case"image":{_+=H.image(fe.href,fe.title,fe.text);break}case"strong":{_+=H.strong(this.parseInline(fe.tokens,H));break}case"em":{_+=H.em(this.parseInline(fe.tokens,H));break}case"codespan":{_+=H.codespan(fe.text);break}case"br":{_+=H.br();break}case"del":{_+=H.del(this.parseInline(fe.tokens,H));break}case"text":{_+=H.text(fe.text);break}default:{var ye='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(ye);return}else throw new Error(ye)}}}return _},x}();function ue(x,z,q){if(typeof x>"u"||x===null)throw new Error("marked(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");if(typeof z=="function"&&(q=z,z=null),z=b({},ue.defaults,z||{}),R(z),q){var M=z.highlight,H;try{H=Q.lex(x,z)}catch($e){return q($e)}var _=function(ye){var Ae;if(!ye)try{z.walkTokens&&ue.walkTokens(H,z.walkTokens),Ae=ie.parse(H,z)}catch(Re){ye=Re}return z.highlight=M,ye?q(ye):q(null,Ae)};if(!M||M.length<3||(delete z.highlight,!H.length))return _();var ae=0;ue.walkTokens(H,function($e){$e.type==="code"&&(ae++,setTimeout(function(){M($e.text,$e.lang,function(ye,Ae){if(ye)return _(ye);Ae!=null&&Ae!==$e.text&&($e.text=Ae,$e.escaped=!0),ae--,ae===0&&_()})},0))}),ae===0&&_();return}function fe($e){if($e.message+=`
Please report this to https://github.com/markedjs/marked.`,z.silent)return"<p>An error occurred:</p><pre>"+g($e.message+"",!0)+"</pre>";throw $e}try{var le=Q.lex(x,z);if(z.walkTokens){if(z.async)return Promise.all(ue.walkTokens(le,z.walkTokens)).then(function(){return ie.parse(le,z)}).catch(fe);ue.walkTokens(le,z.walkTokens)}return ie.parse(le,z)}catch($e){fe($e)}}ue.options=ue.setOptions=function(x){return b(ue.defaults,x),S(ue.defaults),ue},ue.getDefaults=D,ue.defaults=he.defaults,ue.use=function(){for(var x=arguments.length,z=new Array(x),q=0;q<x;q++)z[q]=arguments[q];var M=b.apply(void 0,[{}].concat(z)),H=ue.defaults.extensions||{renderers:{},childTokens:{}},_;z.forEach(function(ae){if(ae.extensions&&(_=!0,ae.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var $e=H.renderers?H.renderers[le.name]:null;$e?H.renderers[le.name]=function(){for(var ye=arguments.length,Ae=new Array(ye),Re=0;Re<ye;Re++)Ae[Re]=arguments[Re];var ge=le.renderer.apply(this,Ae);return ge===!1&&(ge=$e.apply(this,Ae)),ge}:H.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");H[le.level]?H[le.level].unshift(le.tokenizer):H[le.level]=[le.tokenizer],le.start&&(le.level==="block"?H.startBlock?H.startBlock.push(le.start):H.startBlock=[le.start]:le.level==="inline"&&(H.startInline?H.startInline.push(le.start):H.startInline=[le.start]))}le.childTokens&&(H.childTokens[le.name]=le.childTokens)})),ae.renderer&&function(){var le=ue.defaults.renderer||new te,$e=function(Re){var ge=le[Re];le[Re]=function(){for(var ke=arguments.length,De=new Array(ke),Me=0;Me<ke;Me++)De[Me]=arguments[Me];var Te=ae.renderer[Re].apply(le,De);return Te===!1&&(Te=ge.apply(le,De)),Te}};for(var ye in ae.renderer)$e(ye);M.renderer=le}(),ae.tokenizer&&function(){var le=ue.defaults.tokenizer||new G,$e=function(Re){var ge=le[Re];le[Re]=function(){for(var ke=arguments.length,De=new Array(ke),Me=0;Me<ke;Me++)De[Me]=arguments[Me];var Te=ae.tokenizer[Re].apply(le,De);return Te===!1&&(Te=ge.apply(le,De)),Te}};for(var ye in ae.tokenizer)$e(ye);M.tokenizer=le}(),ae.walkTokens){var fe=ue.defaults.walkTokens;M.walkTokens=function(le){var $e=[];return $e.push(ae.walkTokens.call(this,le)),fe&&($e=$e.concat(fe.call(this,le))),$e}}_&&(M.extensions=H),ue.setOptions(M)})},ue.walkTokens=function(x,z){for(var q=[],M=function(){var fe=_.value;switch(q=q.concat(z.call(ue,fe)),fe.type){case"table":{for(var le=P(fe.header),$e;!($e=le()).done;){var ye=$e.value;q=q.concat(ue.walkTokens(ye.tokens,z))}for(var Ae=P(fe.rows),Re;!(Re=Ae()).done;)for(var ge=Re.value,ke=P(ge),De;!(De=ke()).done;){var Me=De.value;q=q.concat(ue.walkTokens(Me.tokens,z))}break}case"list":{q=q.concat(ue.walkTokens(fe.items,z));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[fe.type]?ue.defaults.extensions.childTokens[fe.type].forEach(function(Te){q=q.concat(ue.walkTokens(fe[Te],z))}):fe.tokens&&(q=q.concat(ue.walkTokens(fe.tokens,z)))}},H=P(x),_;!(_=H()).done;)M();return q},ue.parseInline=function(x,z){if(typeof x>"u"||x===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");z=b({},ue.defaults,z||{}),R(z);try{var q=Q.lexInline(x,z);return z.walkTokens&&ue.walkTokens(q,z.walkTokens),ie.parseInline(q,z)}catch(M){if(M.message+=`
Please report this to https://github.com/markedjs/marked.`,z.silent)return"<p>An error occurred:</p><pre>"+g(M.message+"",!0)+"</pre>";throw M}},ue.Parser=ie,ue.parser=ie.parse,ue.Renderer=te,ue.TextRenderer=J,ue.Lexer=Q,ue.lexer=Q.lex,ue.Tokenizer=G,ue.Slugger=V,ue.parse=ue;var se=ue.options,me=ue.setOptions,B=ue.use,W=ue.walkTokens,O=ue.parseInline,j=ue,re=ie.parse,X=Q.lex;he.Lexer=Q,he.Parser=ie,he.Renderer=te,he.Slugger=V,he.TextRenderer=J,he.Tokenizer=G,he.getDefaults=D,he.lexer=X,he.marked=ue,he.options=se,he.parse=j,he.parseInline=O,he.parser=re,he.setOptions=me,he.use=B,he.walkTokens=W,Object.defineProperty(he,"__esModule",{value:!0})}),define(we[144],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0;function y(c){const m=P(c);if(m&&m.length>0)return new Uint32Array(m)}e.$Nj=y;let A=0;const s=new Uint32Array(10);function P(c){if(A=0,D(c,E,4352),A>0||(D(c,w,4449),A>0)||(D(c,f,4520),A>0)||(D(c,g,12593),A))return s.subarray(0,A);if(c>=44032&&c<=55203){const m=c-44032,h=m%588,d=Math.floor(m/588),l=Math.floor(h/28),$=h%28-1;if(d<E.length?D(d,E,0):4352+d-12593<g.length&&D(4352+d,g,12593),l<w.length?D(l,w,0):4449+l-12593<g.length&&D(4449+l-12593,g,12593),$>=0&&($<f.length?D($,f,0):4520+$-12593<g.length&&D(4520+$-12593,g,12593)),A>0)return s.subarray(0,A)}}function D(c,m,h){c>=h&&c<h+m.length&&S(m[c-h])}function S(c){c!==0&&(s[A++]=c&255,c>>8&&(s[A++]=c>>8&255),c>>16&&(s[A++]=c>>16&255))}var p;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var v;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(v||(v={}));var I;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(I||(I={}));const E=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),f=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(we[99],ve([1,0,26]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=void 0;const A=new y.$Dc(1e4);function s(v){return p(v,"NFC",A)}e.$Cl=s;const P=new y.$Dc(1e4);function D(v){return p(v,"NFD",P)}e.$Dl=D;const S=/[^\u0000-\u0080]/;function p(v,I,E){if(!v)return v;const w=E.get(v);if(w)return w;let f;return S.test(v)?f=v.normalize(I):f=v,E.set(v,f),f}e.$El=function(){const v=/[\u0300-\u036f]/g;return function(I){return D(I).replace(v,"")}}()}),define(we[145],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.rot=e.$3l=void 0;function y(S,p,v){return Math.min(Math.max(S,p),v)}e.$3l=y;function A(S,p){return(p+S%p)%p}e.rot=A;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$5l=s;class P{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$6l=P;class D{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const v=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$7l=D}),function(){function he(s){const P=[];typeof s=="number"&&P.push("code/timeOrigin",s);function D(p){P.push(p,Date.now())}function S(){const p=[];for(let v=0;v<P.length;v+=2)p.push({name:P[v],startTime:P[v+1]});return p}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))P.push({name:D.name,startTime:Math.round(s+D.startTime)});return P}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function y(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=y(A))}(),define(we[4],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D=e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.$b=e.Platform=e.$a=void 0,e.$a="en";let y=!1,A=!1,s=!1,P=!1,D=!1,S=!1,p=!1,v=!1,I=!1,E=!1,w,f=e.$a,g=e.$a,c,m;const h=globalThis;let d;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?d=h.vscode.process:typeof process<"u"&&(d=process);const l=typeof d?.versions?.electron=="string",$=l&&d?.type==="renderer";if(typeof navigator=="object"&&!$){m=navigator.userAgent,y=m.indexOf("Windows")>=0,A=m.indexOf("Macintosh")>=0,v=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,s=m.indexOf("Linux")>=0,E=m?.indexOf("Mobi")>=0,S=!0,w=e.$a,f=w,g=navigator.language;const L=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),k=L&&L.getAttribute("data-settings");if(k)try{const R=JSON.parse(k),N=R.availableLanguages["*"];w=R.locale,g=R.osLocale,f=N||e.$a,c=R._translationsConfigFile}catch{}}else if(typeof d=="object"){y=d.platform==="win32",A=d.platform==="darwin",s=d.platform==="linux",P=s&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,p=l,I=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$a,f=e.$a;const L=d.env.VSCODE_NLS_CONFIG;if(L)try{const k=JSON.parse(L),R=k.availableLanguages["*"];w=k.locale,g=k.osLocale,f=R||e.$a,c=k._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var u;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(u||(e.Platform=u={}));function n(L){switch(L){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$b=n;let i=0;A?i=1:y?i=3:s&&(i=2),e.$c=y,e.$d=A,e.$e=s,e.$f=P,e.$g=D,e.$h=p,e.$i=S,e.$j=S&&typeof h.importScripts=="function",e.$k=e.$j?h.origin:void 0,e.$l=v,e.$m=E,e.$n=I,e.$o=i,e.$p=m,e.$q=f;var o;(function(L){function k(){return e.$q}L.value=k;function R(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}L.isDefaultVariant=R;function N(){return e.$q==="en"}L.isDefault=N})(o||(e.Language=o={})),e.$r=w,e.$s=g,e.$t=c,e.$u=typeof h.postMessage=="function"&&!h.importScripts,e.$v=(()=>{if(e.$u){const L=[];h.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let N=0,Y=L.length;N<Y;N++){const ee=L[N];if(ee.id===R.data.vscodeScheduleAsyncWork){L.splice(N,1),ee.callback();return}}});let k=0;return R=>{const N=++k;L.push({id:N,callback:R}),h.postMessage({vscodeScheduleAsyncWork:N},"*")}}return L=>setTimeout(L)})();var r;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=A||v?2:y?1:3;let t=!0,a=!1;function b(){if(!a){a=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,t=new Uint16Array(L.buffer)[0]===(2<<8)+1}return t}e.$x=b,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function C(L){return parseFloat(L)>=20}e.$D=C}),define(we[28],ve([1,0,4]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const P=s.process;A={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return y.$c?"win32":y.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$dc=A.platform,e.$ec=A.arch}),define(we[7],ve([1,0,28]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const A=65,s=97,P=90,D=122,S=46,p=47,v=92,I=58,E=63;class w extends Error{constructor(i,o,r){let t;typeof o=="string"&&o.indexOf("not ")===0?(t="must not be",o=o.replace(/^not /,"")):t="must be";const a=i.indexOf(".")!==-1?"property":"argument";let b=`The "${i}" ${a} ${t} of type ${o}`;b+=`. Received type ${typeof r}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function f(n,i){if(n===null||typeof n!="object")throw new w(i,"Object",n)}function g(n,i){if(typeof n!="string")throw new w(i,"string",n)}const c=y.$dc==="win32";function m(n){return n===p||n===v}function h(n){return n===p}function d(n){return n>=A&&n<=P||n>=s&&n<=D}function l(n,i,o,r){let t="",a=0,b=-1,C=0,L=0;for(let k=0;k<=n.length;++k){if(k<n.length)L=n.charCodeAt(k);else{if(r(L))break;L=p}if(r(L)){if(!(b===k-1||C===1))if(C===2){if(t.length<2||a!==2||t.charCodeAt(t.length-1)!==S||t.charCodeAt(t.length-2)!==S){if(t.length>2){const R=t.lastIndexOf(o);R===-1?(t="",a=0):(t=t.slice(0,R),a=t.length-1-t.lastIndexOf(o)),b=k,C=0;continue}else if(t.length!==0){t="",a=0,b=k,C=0;continue}}i&&(t+=t.length>0?`${o}..`:"..",a=2)}else t.length>0?t+=`${o}${n.slice(b+1,k)}`:t=n.slice(b+1,k),a=k-b-1;b=k,C=0}else L===S&&C!==-1?++C:C=-1}return t}function $(n,i){f(i,"pathObject");const o=i.dir||i.root,r=i.base||`${i.name||""}${i.ext||""}`;return o?o===i.root?`${o}${r}`:`${o}${n}${r}`:r}e.$fc={resolve(...n){let i="",o="",r=!1;for(let t=n.length-1;t>=-1;t--){let a;if(t>=0){if(a=n[t],g(a,"path"),a.length===0)continue}else i.length===0?a=y.cwd():(a=y.env[`=${i}`]||y.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==i.toLowerCase()&&a.charCodeAt(2)===v)&&(a=`${i}\\`));const b=a.length;let C=0,L="",k=!1;const R=a.charCodeAt(0);if(b===1)m(R)&&(C=1,k=!0);else if(m(R))if(k=!0,m(a.charCodeAt(1))){let N=2,Y=N;for(;N<b&&!m(a.charCodeAt(N));)N++;if(N<b&&N!==Y){const ee=a.slice(Y,N);for(Y=N;N<b&&m(a.charCodeAt(N));)N++;if(N<b&&N!==Y){for(Y=N;N<b&&!m(a.charCodeAt(N));)N++;(N===b||N!==Y)&&(L=`\\\\${ee}\\${a.slice(Y,N)}`,C=N)}}}else C=1;else d(R)&&a.charCodeAt(1)===I&&(L=a.slice(0,2),C=2,b>2&&m(a.charCodeAt(2))&&(k=!0,C=3));if(L.length>0)if(i.length>0){if(L.toLowerCase()!==i.toLowerCase())continue}else i=L;if(r){if(i.length>0)break}else if(o=`${a.slice(C)}\\${o}`,r=k,k&&i.length>0)break}return o=l(o,!r,"\\",m),r?`${i}\\${o}`:`${i}${o}`||"."},normalize(n){g(n,"path");const i=n.length;if(i===0)return".";let o=0,r,t=!1;const a=n.charCodeAt(0);if(i===1)return h(a)?"\\":n;if(m(a))if(t=!0,m(n.charCodeAt(1))){let C=2,L=C;for(;C<i&&!m(n.charCodeAt(C));)C++;if(C<i&&C!==L){const k=n.slice(L,C);for(L=C;C<i&&m(n.charCodeAt(C));)C++;if(C<i&&C!==L){for(L=C;C<i&&!m(n.charCodeAt(C));)C++;if(C===i)return`\\\\${k}\\${n.slice(L)}\\`;C!==L&&(r=`\\\\${k}\\${n.slice(L,C)}`,o=C)}}}else o=1;else d(a)&&n.charCodeAt(1)===I&&(r=n.slice(0,2),o=2,i>2&&m(n.charCodeAt(2))&&(t=!0,o=3));let b=o<i?l(n.slice(o),!t,"\\",m):"";return b.length===0&&!t&&(b="."),b.length>0&&m(n.charCodeAt(i-1))&&(b+="\\"),r===void 0?t?`\\${b}`:b:t?`${r}\\${b}`:`${r}${b}`},isAbsolute(n){g(n,"path");const i=n.length;if(i===0)return!1;const o=n.charCodeAt(0);return m(o)||i>2&&d(o)&&n.charCodeAt(1)===I&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,o;for(let a=0;a<n.length;++a){const b=n[a];g(b,"path"),b.length>0&&(i===void 0?i=o=b:i+=`\\${b}`)}if(i===void 0)return".";let r=!0,t=0;if(typeof o=="string"&&m(o.charCodeAt(0))){++t;const a=o.length;a>1&&m(o.charCodeAt(1))&&(++t,a>2&&(m(o.charCodeAt(2))?++t:r=!1))}if(r){for(;t<i.length&&m(i.charCodeAt(t));)t++;t>=2&&(i=`\\${i.slice(t)}`)}return e.$fc.normalize(i)},relative(n,i){if(g(n,"from"),g(i,"to"),n===i)return"";const o=e.$fc.resolve(n),r=e.$fc.resolve(i);if(o===r||(n=o.toLowerCase(),i=r.toLowerCase(),n===i))return"";let t=0;for(;t<n.length&&n.charCodeAt(t)===v;)t++;let a=n.length;for(;a-1>t&&n.charCodeAt(a-1)===v;)a--;const b=a-t;let C=0;for(;C<i.length&&i.charCodeAt(C)===v;)C++;let L=i.length;for(;L-1>C&&i.charCodeAt(L-1)===v;)L--;const k=L-C,R=b<k?b:k;let N=-1,Y=0;for(;Y<R;Y++){const G=n.charCodeAt(t+Y);if(G!==i.charCodeAt(C+Y))break;G===v&&(N=Y)}if(Y!==R){if(N===-1)return r}else{if(k>R){if(i.charCodeAt(C+Y)===v)return r.slice(C+Y+1);if(Y===2)return r.slice(C+Y)}b>R&&(n.charCodeAt(t+Y)===v?N=Y:Y===2&&(N=3)),N===-1&&(N=0)}let ee="";for(Y=t+N+1;Y<=a;++Y)(Y===a||n.charCodeAt(Y)===v)&&(ee+=ee.length===0?"..":"\\..");return C+=N,ee.length>0?`${ee}${r.slice(C,L)}`:(r.charCodeAt(C)===v&&++C,r.slice(C,L))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$fc.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===v){if(i.charCodeAt(1)===v){const o=i.charCodeAt(2);if(o!==E&&o!==S)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(d(i.charCodeAt(0))&&i.charCodeAt(1)===I&&i.charCodeAt(2)===v)return`\\\\?\\${i}`;return n},dirname(n){g(n,"path");const i=n.length;if(i===0)return".";let o=-1,r=0;const t=n.charCodeAt(0);if(i===1)return m(t)?n:".";if(m(t)){if(o=r=1,m(n.charCodeAt(1))){let C=2,L=C;for(;C<i&&!m(n.charCodeAt(C));)C++;if(C<i&&C!==L){for(L=C;C<i&&m(n.charCodeAt(C));)C++;if(C<i&&C!==L){for(L=C;C<i&&!m(n.charCodeAt(C));)C++;if(C===i)return n;C!==L&&(o=r=C+1)}}}}else d(t)&&n.charCodeAt(1)===I&&(o=i>2&&m(n.charCodeAt(2))?3:2,r=o);let a=-1,b=!0;for(let C=i-1;C>=r;--C)if(m(n.charCodeAt(C))){if(!b){a=C;break}}else b=!1;if(a===-1){if(o===-1)return".";a=o}return n.slice(0,a)},basename(n,i){i!==void 0&&g(i,"ext"),g(n,"path");let o=0,r=-1,t=!0,a;if(n.length>=2&&d(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(o=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let b=i.length-1,C=-1;for(a=n.length-1;a>=o;--a){const L=n.charCodeAt(a);if(m(L)){if(!t){o=a+1;break}}else C===-1&&(t=!1,C=a+1),b>=0&&(L===i.charCodeAt(b)?--b===-1&&(r=a):(b=-1,r=C))}return o===r?r=C:r===-1&&(r=n.length),n.slice(o,r)}for(a=n.length-1;a>=o;--a)if(m(n.charCodeAt(a))){if(!t){o=a+1;break}}else r===-1&&(t=!1,r=a+1);return r===-1?"":n.slice(o,r)},extname(n){g(n,"path");let i=0,o=-1,r=0,t=-1,a=!0,b=0;n.length>=2&&n.charCodeAt(1)===I&&d(n.charCodeAt(0))&&(i=r=2);for(let C=n.length-1;C>=i;--C){const L=n.charCodeAt(C);if(m(L)){if(!a){r=C+1;break}continue}t===-1&&(a=!1,t=C+1),L===S?o===-1?o=C:b!==1&&(b=1):o!==-1&&(b=-1)}return o===-1||t===-1||b===0||b===1&&o===t-1&&o===r+1?"":n.slice(o,t)},format:$.bind(null,"\\"),parse(n){g(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const o=n.length;let r=0,t=n.charCodeAt(0);if(o===1)return m(t)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(m(t)){if(r=1,m(n.charCodeAt(1))){let N=2,Y=N;for(;N<o&&!m(n.charCodeAt(N));)N++;if(N<o&&N!==Y){for(Y=N;N<o&&m(n.charCodeAt(N));)N++;if(N<o&&N!==Y){for(Y=N;N<o&&!m(n.charCodeAt(N));)N++;N===o?r=N:N!==Y&&(r=N+1)}}}}else if(d(t)&&n.charCodeAt(1)===I){if(o<=2)return i.root=i.dir=n,i;if(r=2,m(n.charCodeAt(2))){if(o===3)return i.root=i.dir=n,i;r=3}}r>0&&(i.root=n.slice(0,r));let a=-1,b=r,C=-1,L=!0,k=n.length-1,R=0;for(;k>=r;--k){if(t=n.charCodeAt(k),m(t)){if(!L){b=k+1;break}continue}C===-1&&(L=!1,C=k+1),t===S?a===-1?a=k:R!==1&&(R=1):a!==-1&&(R=-1)}return C!==-1&&(a===-1||R===0||R===1&&a===C-1&&a===b+1?i.base=i.name=n.slice(b,C):(i.name=n.slice(b,a),i.base=n.slice(b,C),i.ext=n.slice(a,C))),b>0&&b!==r?i.dir=n.slice(0,b-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(c){const n=/\\/g;return()=>{const i=y.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>y.cwd()})();e.$gc={resolve(...n){let i="",o=!1;for(let r=n.length-1;r>=-1&&!o;r--){const t=r>=0?n[r]:u();g(t,"path"),t.length!==0&&(i=`${t}/${i}`,o=t.charCodeAt(0)===p)}return i=l(i,!o,"/",h),o?`/${i}`:i.length>0?i:"."},normalize(n){if(g(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===p,o=n.charCodeAt(n.length-1)===p;return n=l(n,!i,"/",h),n.length===0?i?"/":o?"./":".":(o&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return g(n,"path"),n.length>0&&n.charCodeAt(0)===p},join(...n){if(n.length===0)return".";let i;for(let o=0;o<n.length;++o){const r=n[o];g(r,"path"),r.length>0&&(i===void 0?i=r:i+=`/${r}`)}return i===void 0?".":e.$gc.normalize(i)},relative(n,i){if(g(n,"from"),g(i,"to"),n===i||(n=e.$gc.resolve(n),i=e.$gc.resolve(i),n===i))return"";const o=1,r=n.length,t=r-o,a=1,b=i.length-a,C=t<b?t:b;let L=-1,k=0;for(;k<C;k++){const N=n.charCodeAt(o+k);if(N!==i.charCodeAt(a+k))break;N===p&&(L=k)}if(k===C)if(b>C){if(i.charCodeAt(a+k)===p)return i.slice(a+k+1);if(k===0)return i.slice(a+k)}else t>C&&(n.charCodeAt(o+k)===p?L=k:k===0&&(L=0));let R="";for(k=o+L+1;k<=r;++k)(k===r||n.charCodeAt(k)===p)&&(R+=R.length===0?"..":"/..");return`${R}${i.slice(a+L)}`},toNamespacedPath(n){return n},dirname(n){if(g(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===p;let o=-1,r=!0;for(let t=n.length-1;t>=1;--t)if(n.charCodeAt(t)===p){if(!r){o=t;break}}else r=!1;return o===-1?i?"/":".":i&&o===1?"//":n.slice(0,o)},basename(n,i){i!==void 0&&g(i,"ext"),g(n,"path");let o=0,r=-1,t=!0,a;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let b=i.length-1,C=-1;for(a=n.length-1;a>=0;--a){const L=n.charCodeAt(a);if(L===p){if(!t){o=a+1;break}}else C===-1&&(t=!1,C=a+1),b>=0&&(L===i.charCodeAt(b)?--b===-1&&(r=a):(b=-1,r=C))}return o===r?r=C:r===-1&&(r=n.length),n.slice(o,r)}for(a=n.length-1;a>=0;--a)if(n.charCodeAt(a)===p){if(!t){o=a+1;break}}else r===-1&&(t=!1,r=a+1);return r===-1?"":n.slice(o,r)},extname(n){g(n,"path");let i=-1,o=0,r=-1,t=!0,a=0;for(let b=n.length-1;b>=0;--b){const C=n.charCodeAt(b);if(C===p){if(!t){o=b+1;break}continue}r===-1&&(t=!1,r=b+1),C===S?i===-1?i=b:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||r===-1||a===0||a===1&&i===r-1&&i===o+1?"":n.slice(i,r)},format:$.bind(null,"/"),parse(n){g(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const o=n.charCodeAt(0)===p;let r;o?(i.root="/",r=1):r=0;let t=-1,a=0,b=-1,C=!0,L=n.length-1,k=0;for(;L>=r;--L){const R=n.charCodeAt(L);if(R===p){if(!C){a=L+1;break}continue}b===-1&&(C=!1,b=L+1),R===S?t===-1?t=L:k!==1&&(k=1):t!==-1&&(k=-1)}if(b!==-1){const R=a===0&&o?1:a;t===-1||k===0||k===1&&t===b-1&&t===a+1?i.base=i.name=n.slice(R,b):(i.name=n.slice(R,t),i.base=n.slice(R,b),i.ext=n.slice(t,b))}return a>0?i.dir=n.slice(0,a-1):o&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(we[60],ve([1,0,7]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=e.$4r=void 0,e.$4r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(I){const E=(0,y.$oc)(I),w=A[E.toLowerCase()];return w!==void 0?w:D(I)}e.$5r=P;function D(I){const E=(0,y.$oc)(I);return s[E.toLowerCase()]}e.$6r=D;function S(I){for(const E in s)if(s[E]===I)return E}e.$7r=S;const p=/^(.+)\/(.+?)(;.+)?$/;function v(I,E){const w=p.exec(I);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:E?void 0:I}e.$8r=v}),define(we[61],ve([1,0,4]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.TerminateResponseCode=e.Source=void 0;var A;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(A||(e.Source=A={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function P(S,...p){const v=p.reduce((w,f)=>(w[f]=!0,w),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(S).filter(w=>!v[w]).forEach(w=>{for(let f=0;f<I.length;f++)if(w.search(I[f])!==-1){delete S[w];break}})}e.$Nl=P;function D(S){S&&(delete S.DEBUG,y.$d&&delete S.DYLD_LIBRARY_PATH,y.$e&&delete S.LD_PRELOAD)}e.$Ol=D}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var A in y)(typeof exports=="object"?exports:he)[A]=y[A]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function y(A){if(e[A])return e[A].exports;var s=e[A]={i:A,l:!1,exports:{}};return he[A].call(s.exports,s,s.exports,y),s.l=!0,s.exports}return y.m=he,y.c=e,y.d=function(A,s,P){y.o(A,s)||Object.defineProperty(A,s,{enumerable:!0,get:P})},y.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},y.t=function(A,s){if(1&s&&(A=y(A)),8&s||4&s&&typeof A=="object"&&A&&A.__esModule)return A;var P=Object.create(null);if(y.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:A}),2&s&&typeof A!="string")for(var D in A)y.d(P,D,function(S){return A[S]}.bind(null,D));return P},y.n=function(A){var s=A&&A.__esModule?function(){return A.default}:function(){return A};return y.d(s,"a",s),s},y.o=function(A,s){return Object.prototype.hasOwnProperty.call(A,s)},y.p="",y(y.s=0)}([function(he,e,y){(function(A){var s;e=he.exports=B,s=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],p=e.src=[],v=0,I=v++;p[I]="0|[1-9]\\d*";var E=v++;p[E]="[0-9]+";var w=v++;p[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=v++;p[f]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var g=v++;p[g]="("+p[E]+")\\.("+p[E]+")\\.("+p[E]+")";var c=v++;p[c]="(?:"+p[I]+"|"+p[w]+")";var m=v++;p[m]="(?:"+p[E]+"|"+p[w]+")";var h=v++;p[h]="(?:-("+p[c]+"(?:\\."+p[c]+")*))";var d=v++;p[d]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var l=v++;p[l]="[0-9A-Za-z-]+";var $=v++;p[$]="(?:\\+("+p[l]+"(?:\\."+p[l]+")*))";var u=v++,n="v?"+p[f]+p[h]+"?"+p[$]+"?";p[u]="^"+n+"$";var i="[v=\\s]*"+p[g]+p[d]+"?"+p[$]+"?",o=v++;p[o]="^"+i+"$";var r=v++;p[r]="((?:<|>)?=?)";var t=v++;p[t]=p[E]+"|x|X|\\*";var a=v++;p[a]=p[I]+"|x|X|\\*";var b=v++;p[b]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[h]+")?"+p[$]+"?)?)?";var C=v++;p[C]="[v=\\s]*("+p[t]+")(?:\\.("+p[t]+")(?:\\.("+p[t]+")(?:"+p[d]+")?"+p[$]+"?)?)?";var L=v++;p[L]="^"+p[r]+"\\s*"+p[b]+"$";var k=v++;p[k]="^"+p[r]+"\\s*"+p[C]+"$";var R=v++;p[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=v++;p[N]="(?:~>?)";var Y=v++;p[Y]="(\\s*)"+p[N]+"\\s+",S[Y]=new RegExp(p[Y],"g");var ee=v++;p[ee]="^"+p[N]+p[b]+"$";var G=v++;p[G]="^"+p[N]+p[C]+"$";var ne=v++;p[ne]="(?:\\^)";var Z=v++;p[Z]="(\\s*)"+p[ne]+"\\s+",S[Z]=new RegExp(p[Z],"g");var T=v++;p[T]="^"+p[ne]+p[b]+"$";var oe=v++;p[oe]="^"+p[ne]+p[C]+"$";var Q=v++;p[Q]="^"+p[r]+"\\s*("+i+")$|^$";var te=v++;p[te]="^"+p[r]+"\\s*("+n+")$|^$";var J=v++;p[J]="(\\s*)"+p[r]+"\\s*("+i+"|"+p[b]+")",S[J]=new RegExp(p[J],"g");var V=v++;p[V]="^\\s*("+p[b]+")\\s+-\\s+("+p[b]+")\\s*$";var ie=v++;p[ie]="^\\s*("+p[C]+")\\s+-\\s+("+p[C]+")\\s*$";var ue=v++;p[ue]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)s(se,p[se]),S[se]||(S[se]=new RegExp(p[se]));function me(ge,ke){if(ge instanceof B)return ge;if(typeof ge!="string"||ge.length>P||!(ke?S[o]:S[u]).test(ge))return null;try{return new B(ge,ke)}catch{return null}}function B(ge,ke){if(ge instanceof B){if(ge.loose===ke)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof B))return new B(ge,ke);s("SemVer",ge,ke),this.loose=ke;var De=ge.trim().match(ke?S[o]:S[u]);if(!De)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+De[1],this.minor=+De[2],this.patch=+De[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");De[4]?this.prerelease=De[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Te=+Me;if(Te>=0&&Te<D)return Te}return Me}):this.prerelease=[],this.build=De[5]?De[5].split("."):[],this.format()}e.parse=me,e.valid=function(ge,ke){var De=me(ge,ke);return De?De.version:null},e.clean=function(ge,ke){var De=me(ge.trim().replace(/^[=v]+/,""),ke);return De?De.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(ge){return s("SemVer.compare",this.version,this.loose,ge),ge instanceof B||(ge=new B(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},B.prototype.compareMain=function(ge){return ge instanceof B||(ge=new B(ge,this.loose)),O(this.major,ge.major)||O(this.minor,ge.minor)||O(this.patch,ge.patch)},B.prototype.comparePre=function(ge){if(ge instanceof B||(ge=new B(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var ke=0;do{var De=this.prerelease[ke],Me=ge.prerelease[ke];if(s("prerelease compare",ke,De,Me),De===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(De===void 0)return-1;if(De!==Me)return O(De,Me)}while(++ke)},B.prototype.inc=function(ge,ke){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var De=this.prerelease.length;--De>=0;)typeof this.prerelease[De]=="number"&&(this.prerelease[De]++,De=-2);De===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,ke,De,Me){typeof De=="string"&&(Me=De,De=void 0);try{return new B(ge,De).inc(ke,Me).version}catch{return null}},e.diff=function(ge,ke){if(x(ge,ke))return null;var De=me(ge),Me=me(ke);if(De.prerelease.length||Me.prerelease.length){for(var Te in De)if((Te==="major"||Te==="minor"||Te==="patch")&&De[Te]!==Me[Te])return"pre"+Te;return"prerelease"}for(var Te in De)if((Te==="major"||Te==="minor"||Te==="patch")&&De[Te]!==Me[Te])return Te},e.compareIdentifiers=O;var W=/^[0-9]+$/;function O(ge,ke){var De=W.test(ge),Me=W.test(ke);return De&&Me&&(ge=+ge,ke=+ke),De&&!Me?-1:Me&&!De?1:ge<ke?-1:ge>ke?1:0}function j(ge,ke,De){return new B(ge,De).compare(new B(ke,De))}function re(ge,ke,De){return j(ge,ke,De)>0}function X(ge,ke,De){return j(ge,ke,De)<0}function x(ge,ke,De){return j(ge,ke,De)===0}function z(ge,ke,De){return j(ge,ke,De)!==0}function q(ge,ke,De){return j(ge,ke,De)>=0}function M(ge,ke,De){return j(ge,ke,De)<=0}function H(ge,ke,De,Me){var Te;switch(ke){case"===":typeof ge=="object"&&(ge=ge.version),typeof De=="object"&&(De=De.version),Te=ge===De;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof De=="object"&&(De=De.version),Te=ge!==De;break;case"":case"=":case"==":Te=x(ge,De,Me);break;case"!=":Te=z(ge,De,Me);break;case">":Te=re(ge,De,Me);break;case">=":Te=q(ge,De,Me);break;case"<":Te=X(ge,De,Me);break;case"<=":Te=M(ge,De,Me);break;default:throw new TypeError("Invalid operator: "+ke)}return Te}function _(ge,ke){if(ge instanceof _){if(ge.loose===ke)return ge;ge=ge.value}if(!(this instanceof _))return new _(ge,ke);s("comparator",ge,ke),this.loose=ke,this.parse(ge),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(ge,ke){return O(ke,ge)},e.major=function(ge,ke){return new B(ge,ke).major},e.minor=function(ge,ke){return new B(ge,ke).minor},e.patch=function(ge,ke){return new B(ge,ke).patch},e.compare=j,e.compareLoose=function(ge,ke){return j(ge,ke,!0)},e.rcompare=function(ge,ke,De){return j(ke,ge,De)},e.sort=function(ge,ke){return ge.sort(function(De,Me){return e.compare(De,Me,ke)})},e.rsort=function(ge,ke){return ge.sort(function(De,Me){return e.rcompare(De,Me,ke)})},e.gt=re,e.lt=X,e.eq=x,e.neq=z,e.gte=q,e.lte=M,e.cmp=H,e.Comparator=_;var ae={};function fe(ge,ke){if(ge instanceof fe)return ge.loose===ke?ge:new fe(ge.raw,ke);if(ge instanceof _)return new fe(ge.value,ke);if(!(this instanceof fe))return new fe(ge,ke);if(this.loose=ke,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(De){return this.parseRange(De.trim())},this).filter(function(De){return De.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function le(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function $e(ge,ke,De,Me,Te,He,Ue,Ke,tt,Ze,et,be,Ie){return((ke=le(De)?"":le(Me)?">="+De+".0.0":le(Te)?">="+De+"."+Me+".0":">="+ke)+" "+(Ke=le(tt)?"":le(Ze)?"<"+(+tt+1)+".0.0":le(et)?"<"+tt+"."+(+Ze+1)+".0":be?"<="+tt+"."+Ze+"."+et+"-"+be:"<="+Ke)).trim()}function ye(ge,ke){for(var De=0;De<ge.length;De++)if(!ge[De].test(ke))return!1;if(ke.prerelease.length){for(De=0;De<ge.length;De++)if(s(ge[De].semver),ge[De].semver!==ae&&ge[De].semver.prerelease.length>0){var Me=ge[De].semver;if(Me.major===ke.major&&Me.minor===ke.minor&&Me.patch===ke.patch)return!0}return!1}return!0}function Ae(ge,ke,De){try{ke=new fe(ke,De)}catch{return!1}return ke.test(ge)}function Re(ge,ke,De,Me){var Te,He,Ue,Ke,tt;switch(ge=new B(ge,Me),ke=new fe(ke,Me),De){case">":Te=re,He=M,Ue=X,Ke=">",tt=">=";break;case"<":Te=X,He=q,Ue=re,Ke="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(ge,ke,Me))return!1;for(var Ze=0;Ze<ke.set.length;++Ze){var et=ke.set[Ze],be=null,Ie=null;if(et.forEach(function(Ce){Ce.semver===ae&&(Ce=new _(">=0.0.0")),be=be||Ce,Ie=Ie||Ce,Te(Ce.semver,be.semver,Me)?be=Ce:Ue(Ce.semver,Ie.semver,Me)&&(Ie=Ce)}),be.operator===Ke||be.operator===tt||(!Ie.operator||Ie.operator===Ke)&&He(ge,Ie.semver)||Ie.operator===tt&&Ue(ge,Ie.semver))return!1}return!0}_.prototype.parse=function(ge){var ke=this.loose?S[Q]:S[te],De=ge.match(ke);if(!De)throw new TypeError("Invalid comparator: "+ge);this.operator=De[1],this.operator==="="&&(this.operator=""),De[2]?this.semver=new B(De[2],this.loose):this.semver=ae},_.prototype.toString=function(){return this.value},_.prototype.test=function(ge){return s("Comparator.test",ge,this.loose),this.semver===ae||(typeof ge=="string"&&(ge=new B(ge,this.loose)),H(ge,this.operator,this.semver,this.loose))},_.prototype.intersects=function(ge,ke){if(!(ge instanceof _))throw new TypeError("a Comparator is required");var De;if(this.operator==="")return De=new fe(ge.value,ke),Ae(this.value,De,ke);if(ge.operator==="")return De=new fe(this.value,ke),Ae(ge.semver,De,ke);var Me=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),He=this.semver.version===ge.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),Ke=H(this.semver,"<",ge.semver,ke)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),tt=H(this.semver,">",ge.semver,ke)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Me||Te||He&&Ue||Ke||tt},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(ge){var ke=this.loose;ge=ge.trim(),s("range",ge,ke);var De=ke?S[ie]:S[V];ge=ge.replace(De,$e),s("hyphen replace",ge),ge=ge.replace(S[J],"$1$2$3"),s("comparator trim",ge,S[J]),ge=(ge=(ge=ge.replace(S[Y],"$1~")).replace(S[Z],"$1^")).split(/\s+/).join(" ");var Me=ke?S[Q]:S[te],Te=ge.split(" ").map(function(He){return function(Ue,Ke){return s("comp",Ue),Ue=function(tt,Ze){return tt.trim().split(/\s+/).map(function(et){return function(be,Ie){s("caret",be,Ie);var Ce=Ie?S[oe]:S[T];return be.replace(Ce,function(je,Fe,qe,Ve,Qe){var Je;return s("caret",be,je,Fe,qe,Ve,Qe),le(Fe)?Je="":le(qe)?Je=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":le(Ve)?Je=Fe==="0"?">="+Fe+"."+qe+".0 <"+Fe+"."+(+qe+1)+".0":">="+Fe+"."+qe+".0 <"+(+Fe+1)+".0.0":Qe?(s("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Je=Fe==="0"?qe==="0"?">="+Fe+"."+qe+"."+Ve+Qe+" <"+Fe+"."+qe+"."+(+Ve+1):">="+Fe+"."+qe+"."+Ve+Qe+" <"+Fe+"."+(+qe+1)+".0":">="+Fe+"."+qe+"."+Ve+Qe+" <"+(+Fe+1)+".0.0"):(s("no pr"),Je=Fe==="0"?qe==="0"?">="+Fe+"."+qe+"."+Ve+" <"+Fe+"."+qe+"."+(+Ve+1):">="+Fe+"."+qe+"."+Ve+" <"+Fe+"."+(+qe+1)+".0":">="+Fe+"."+qe+"."+Ve+" <"+(+Fe+1)+".0.0"),s("caret return",Je),Je})}(et,Ze)}).join(" ")}(Ue,Ke),s("caret",Ue),Ue=function(tt,Ze){return tt.trim().split(/\s+/).map(function(et){return function(be,Ie){var Ce=Ie?S[G]:S[ee];return be.replace(Ce,function(je,Fe,qe,Ve,Qe){var Je;return s("tilde",be,je,Fe,qe,Ve,Qe),le(Fe)?Je="":le(qe)?Je=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":le(Ve)?Je=">="+Fe+"."+qe+".0 <"+Fe+"."+(+qe+1)+".0":Qe?(s("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Je=">="+Fe+"."+qe+"."+Ve+Qe+" <"+Fe+"."+(+qe+1)+".0"):Je=">="+Fe+"."+qe+"."+Ve+" <"+Fe+"."+(+qe+1)+".0",s("tilde return",Je),Je})}(et,Ze)}).join(" ")}(Ue,Ke),s("tildes",Ue),Ue=function(tt,Ze){return s("replaceXRanges",tt,Ze),tt.split(/\s+/).map(function(et){return function(be,Ie){be=be.trim();var Ce=Ie?S[k]:S[L];return be.replace(Ce,function(je,Fe,qe,Ve,Qe,Je){s("xRange",be,je,Fe,qe,Ve,Qe,Je);var xe=le(qe),rt=xe||le(Ve),Xe=rt||le(Qe);return Fe==="="&&Xe&&(Fe=""),xe?je=Fe===">"||Fe==="<"?"<0.0.0":"*":Fe&&Xe?(rt&&(Ve=0),Xe&&(Qe=0),Fe===">"?(Fe=">=",rt?(qe=+qe+1,Ve=0,Qe=0):Xe&&(Ve=+Ve+1,Qe=0)):Fe==="<="&&(Fe="<",rt?qe=+qe+1:Ve=+Ve+1),je=Fe+qe+"."+Ve+"."+Qe):rt?je=">="+qe+".0.0 <"+(+qe+1)+".0.0":Xe&&(je=">="+qe+"."+Ve+".0 <"+qe+"."+(+Ve+1)+".0"),s("xRange return",je),je})}(et,Ze)}).join(" ")}(Ue,Ke),s("xrange",Ue),Ue=function(tt,Ze){return s("replaceStars",tt,Ze),tt.trim().replace(S[ue],"")}(Ue,Ke),s("stars",Ue),Ue}(He,ke)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(He){return!!He.match(Me)})),Te=Te.map(function(He){return new _(He,ke)})},fe.prototype.intersects=function(ge,ke){if(!(ge instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(De){return De.every(function(Me){return ge.set.some(function(Te){return Te.every(function(He){return Me.intersects(He,ke)})})})})},e.toComparators=function(ge,ke){return new fe(ge,ke).set.map(function(De){return De.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new B(ge,this.loose));for(var ke=0;ke<this.set.length;ke++)if(ye(this.set[ke],ge))return!0;return!1},e.satisfies=Ae,e.maxSatisfying=function(ge,ke,De){var Me=null,Te=null;try{var He=new fe(ke,De)}catch{return null}return ge.forEach(function(Ue){He.test(Ue)&&(Me&&Te.compare(Ue)!==-1||(Te=new B(Me=Ue,De)))}),Me},e.minSatisfying=function(ge,ke,De){var Me=null,Te=null;try{var He=new fe(ke,De)}catch{return null}return ge.forEach(function(Ue){He.test(Ue)&&(Me&&Te.compare(Ue)!==1||(Te=new B(Me=Ue,De)))}),Me},e.validRange=function(ge,ke){try{return new fe(ge,ke).range||"*"}catch{return null}},e.ltr=function(ge,ke,De){return Re(ge,ke,"<",De)},e.gtr=function(ge,ke,De){return Re(ge,ke,">",De)},e.outside=Re,e.prerelease=function(ge,ke){var De=me(ge,ke);return De&&De.prerelease.length?De.prerelease:null},e.intersects=function(ge,ke,De){return ge=new fe(ge,De),ke=new fe(ke,De),ge.intersects(ke)},e.coerce=function(ge){if(ge instanceof B)return ge;if(typeof ge!="string")return null;var ke=ge.match(S[R]);return ke==null?null:me((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,y(1))},function(he,e){var y,A,s=he.exports={};function P(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S(m){if(y===setTimeout)return setTimeout(m,0);if((y===P||!y)&&setTimeout)return y=setTimeout,setTimeout(m,0);try{return y(m,0)}catch{try{return y.call(null,m,0)}catch{return y.call(this,m,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:P}catch{y=P}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var p,v=[],I=!1,E=-1;function w(){I&&p&&(I=!1,p.length?v=p.concat(v):E=-1,v.length&&f())}function f(){if(!I){var m=S(w);I=!0;for(var h=v.length;h;){for(p=v,v=[];++E<h;)p&&p[E].run();E=-1,h=v.length}p=null,I=!1,function(d){if(A===clearTimeout)return clearTimeout(d);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(d);try{A(d)}catch{try{return A.call(null,d)}catch{return A.call(this,d)}}}(m)}}function g(m,h){this.fun=m,this.array=h}function c(){}s.nextTick=function(m){var h=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)h[d-1]=arguments[d];v.push(new g(m,h)),v.length!==1||I||S(f)},g.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=c,s.addListener=c,s.once=c,s.off=c,s.removeListener=c,s.removeAllListeners=c,s.emit=c,s.prependListener=c,s.prependOnceListener=c,s.listeners=function(m){return[]},s.binding=function(m){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(m){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(we[146],ve([1,0]),function(he,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0;class A{constructor(S,p,v){this.level=S,this.key=p,this.value=v,this.forward=[]}}const s=void 0;class P{constructor(S,p=2**16){this.comparator=S,this[y]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new A(this.c,s,s)}get size(){return this.f}clear(){this.e=new A(this.c,s,s),this.f=0}has(S){return!!P.g(this,S,this.comparator)}get(S){return P.g(this,S,this.comparator)?.value}set(S,p){return P.h(this,S,p,this.comparator)&&(this.f+=1),this}delete(S){const p=P.k(this,S,this.comparator);return p&&(this.f-=1),p}forEach(S,p){let v=this.e.forward[0];for(;v;)S.call(p,v.value,v.key,this),v=v.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",p=this.e.forward[0];for(;p;)S+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return S}static g(S,p,v){let I=S.e;for(let E=S.d-1;E>=0;E--)for(;I.forward[E]&&v(I.forward[E].key,p)<0;)I=I.forward[E];if(I=I.forward[0],I&&v(I.key,p)===0)return I}static h(S,p,v,I){const E=[];let w=S.e;for(let f=S.d-1;f>=0;f--){for(;w.forward[f]&&I(w.forward[f].key,p)<0;)w=w.forward[f];E[f]=w}if(w=w.forward[0],w&&I(w.key,p)===0)return w.value=v,!1;{const f=P.j(S);if(f>S.d){for(let g=S.d;g<f;g++)E[g]=S.e;S.d=f}w=new A(f,p,v);for(let g=0;g<f;g++)w.forward[g]=E[g].forward[g],E[g].forward[g]=w;return!0}}static j(S,p=.5){let v=1;for(;Math.random()<p&&v<S.c;)v+=1;return v}static k(S,p,v){const I=[];let E=S.e;for(let w=S.d-1;w>=0;w--){for(;E.forward[w]&&v(E.forward[w].key,p)<0;)E=E.forward[w];I[w]=E}if(E=E.forward[0],!E||v(E.key,p)!==0)return!1;for(let w=0;w<S.d&&I[w].forward[w]===E;w++)I[w].forward[w]=E.forward[w];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$Mr=P}),define(we[62],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(P){return new A(P)}constructor(P){this.c=y&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=A}),define(we[5],ve([1,0,11,75,2,98,62]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const S=!1,p=!1;var v;(function(L){L.None=()=>s.$Sc.None;function k(H){if(p){const{onDidAddListener:_}=H,ae=g.create();let fe=0;H.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),_?.()}}}function R(H,_){return te(H,()=>{},0,void 0,!0,void 0,_)}L.defer=R;function N(H){return(_,ae=null,fe)=>{let le=!1,$e;return $e=H(ye=>{if(!le)return $e?$e.dispose():le=!0,_.call(ae,ye)},null,fe),le&&$e.dispose(),$e}}L.once=N;function Y(H,_,ae){return oe((fe,le=null,$e)=>H(ye=>fe.call(le,_(ye)),null,$e),ae)}L.map=Y;function ee(H,_,ae){return oe((fe,le=null,$e)=>H(ye=>{_(ye),fe.call(le,ye)},null,$e),ae)}L.forEach=ee;function G(H,_,ae){return oe((fe,le=null,$e)=>H(ye=>_(ye)&&fe.call(le,ye),null,$e),ae)}L.filter=G;function ne(H){return H}L.signal=ne;function Z(...H){return(_,ae=null,fe)=>{const le=(0,s.$Pc)(...H.map($e=>$e(ye=>_.call(ae,ye))));return Q(le,fe)}}L.any=Z;function T(H,_,ae,fe){let le=ae;return Y(H,$e=>(le=_(le,$e),le),fe)}L.reduce=T;function oe(H,_){let ae;const fe={onWillAddFirstListener(){ae=H(le.fire,le)},onDidRemoveLastListener(){ae?.dispose()}};_||k(fe);const le=new l(fe);return _?.add(le),le.event}function Q(H,_){return _ instanceof Array?_.push(H):_&&_.add(H),H}function te(H,_,ae=100,fe=!1,le=!1,$e,ye){let Ae,Re,ge,ke=0,De;const Me={leakWarningThreshold:$e,onWillAddFirstListener(){Ae=H(He=>{ke++,Re=_(Re,He),fe&&!ge&&(Te.fire(Re),Re=void 0),De=()=>{const Ue=Re;Re=void 0,ge=void 0,(!fe||ke>1)&&Te.fire(Ue),ke=0},typeof ae=="number"?(clearTimeout(ge),ge=setTimeout(De,ae)):ge===void 0&&(ge=0,queueMicrotask(De))})},onWillRemoveListener(){le&&ke>0&&De?.()},onDidRemoveLastListener(){De=void 0,Ae.dispose()}};ye||k(Me);const Te=new l(Me);return ye?.add(Te),Te.event}L.debounce=te;function J(H,_=0,ae){return L.debounce(H,(fe,le)=>fe?(fe.push(le),fe):[le],_,void 0,!0,void 0,ae)}L.accumulate=J;function V(H,_=(fe,le)=>fe===le,ae){let fe=!0,le;return G(H,$e=>{const ye=fe||!_($e,le);return fe=!1,le=$e,ye},ae)}L.latch=V;function ie(H,_,ae){return[L.filter(H,_,ae),L.filter(H,fe=>!_(fe),ae)]}L.split=ie;function ue(H,_=!1,ae=[],fe){let le=ae.slice(),$e=H(Re=>{le?le.push(Re):Ae.fire(Re)});fe&&fe.add($e);const ye=()=>{le?.forEach(Re=>Ae.fire(Re)),le=null},Ae=new l({onWillAddFirstListener(){$e||($e=H(Re=>Ae.fire(Re)),fe&&fe.add($e))},onDidAddFirstListener(){le&&(_?setTimeout(ye):ye())},onDidRemoveLastListener(){$e&&$e.dispose(),$e=null}});return fe&&fe.add(Ae),Ae.event}L.buffer=ue;function se(H,_){return(fe,le,$e)=>{const ye=_(new B);return H(function(Ae){const Re=ye.evaluate(Ae);Re!==me&&fe.call(le,Re)},void 0,$e)}}L.chain=se;const me=Symbol("HaltChainable");class B{constructor(){this.f=[]}map(_){return this.f.push(_),this}forEach(_){return this.f.push(ae=>(_(ae),ae)),this}filter(_){return this.f.push(ae=>_(ae)?ae:me),this}reduce(_,ae){let fe=ae;return this.f.push(le=>(fe=_(fe,le),fe)),this}latch(_=(ae,fe)=>ae===fe){let ae=!0,fe;return this.f.push(le=>{const $e=ae||!_(le,fe);return ae=!1,fe=le,$e?le:me}),this}evaluate(_){for(const ae of this.f)if(_=ae(_),_===me)break;return _}}function W(H,_,ae=fe=>fe){const fe=(...Ae)=>ye.fire(ae(...Ae)),le=()=>H.on(_,fe),$e=()=>H.removeListener(_,fe),ye=new l({onWillAddFirstListener:le,onDidRemoveLastListener:$e});return ye.event}L.fromNodeEventEmitter=W;function O(H,_,ae=fe=>fe){const fe=(...Ae)=>ye.fire(ae(...Ae)),le=()=>H.addEventListener(_,fe),$e=()=>H.removeEventListener(_,fe),ye=new l({onWillAddFirstListener:le,onDidRemoveLastListener:$e});return ye.event}L.fromDOMEventEmitter=O;function j(H){return new Promise(_=>N(H)(_))}L.toPromise=j;function re(H){const _=new l;return H.then(ae=>{_.fire(ae)},()=>{_.fire(void 0)}).finally(()=>{_.dispose()}),_.event}L.fromPromise=re;function X(H,_,ae){return _(ae),H(fe=>_(fe))}L.runAndSubscribe=X;function x(H,_){let ae=null;function fe($e){ae?.dispose(),ae=new s.$Rc,_($e,ae)}fe(void 0);const le=H($e=>fe($e));return(0,s.$Qc)(()=>{le.dispose(),ae?.dispose()})}L.runAndSubscribeWithStore=x;class z{constructor(_,ae){this._observable=_,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{_.addObserver(this)},onDidRemoveLastListener:()=>{_.removeObserver(this)}};ae||k(fe),this.emitter=new l(fe),ae&&ae.add(this.emitter)}beginUpdate(_){this.f++}handlePossibleChange(_){}handleChange(_,ae){this.g=!0}endUpdate(_){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function q(H,_){return new z(H,_).emitter.event}L.fromObservable=q;function M(H){return(_,ae,fe)=>{let le=0,$e=!1;const ye={beginUpdate(){le++},endUpdate(){le--,le===0&&(H.reportChanges(),$e&&($e=!1,_.call(ae)))},handlePossibleChange(){},handleChange(){$e=!0}};H.addObserver(ye),H.reportChanges();const Ae={dispose(){H.removeObserver(ye)}};return fe instanceof s.$Rc?fe.add(Ae):Array.isArray(fe)&&fe.push(Ae),Ae}}L.fromObservableLight=M})(v||(e.Event=v={}));class I{constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${I.f++}`,I.all.add(this)}start(k){this.g=new D.$Od,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Qd=I,I.all=new Set,I.f=0;let E=-1;function w(L){const k=E;return E=L,{dispose(){E=k}}}e.$Rd=w;class f{constructor(k,R=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=R,this.g=0}dispose(){this.f?.clear()}check(k,R){const N=this.threshold;if(N<=0||R<N)return;this.f||(this.f=new Map);const Y=this.f.get(k.value)||0;if(this.f.set(k.value,Y+1),this.g-=1,this.g<=0){this.g=N*.5;let ee,G=0;for(const[ne,Z]of this.f)(!ee||G<Z)&&(ee=ne,G=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${G}):`),console.warn(ee)}return()=>{const ee=this.f.get(k.value)||0;this.f.set(k.value,ee-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class m{constructor(k){this.value=k,this.id=c++}}const h=2,d=(L,k)=>{if(L instanceof m)k(L);else for(let R=0;R<L.length;R++){const N=L[R];N&&k(N)}};class l{constructor(k){this.w=0,this.f=k,this.g=E>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new I(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const k=this.t;queueMicrotask(()=>{d(k,R=>R.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(k,R,N)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Sc.None;if(this.m)return s.$Sc.None;R&&(k=k.bind(R));const Y=new m(k);let ee,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Y.stack=g.create(),ee=this.g.check(Y.stack,this.w+1)),S&&(Y.stack=G??g.create()),this.t?this.t instanceof m?(this.u??(this.u=new u),this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.w++;const ne=(0,s.$Qc)(()=>{ee?.(),this.x(Y)});return N instanceof s.$Rc?N.add(ne):Array.isArray(N)&&N.push(ne),ne}),this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const R=this.t,N=R.indexOf(k);if(N===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,R[N]=void 0;const Y=this.u.current===this;if(this.w*h<=R.length){let ee=0;for(let G=0;G<R.length;G++)R[G]?R[ee++]=R[G]:Y&&(this.u.end--,ee<this.u.i&&this.u.i--);R.length=ee}}y(k,R){if(!k)return;const N=this.f?.onListenerError||y.$1;if(!N){k.value(R);return}try{k.value(R)}catch(Y){N(Y)}}z(k){const R=k.current.t;for(;k.i<k.end;)this.y(R[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,k);else{const R=this.u;R.enqueue(this,k,this.t.length),this.z(R)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=l;const $=()=>new u;e.$Td=$;class u{constructor(){this.i=-1,this.end=0}enqueue(k,R,N){this.i=0,this.end=N,this.current=k,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends l{async fireAsync(k,R,N){if(this.t)for(this.h||(this.h=new P.$3c),d(this.t,Y=>this.h.push([Y.value,k]));this.h.size>0&&!R.isCancellationRequested;){const[Y,ee]=this.h.shift(),G=[],ne={...ee,token:R,waitUntil:Z=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");N&&(Z=N(Z,Y)),G.push(Z)}};try{Y(ne)}catch(Z){(0,y.$1)(Z);continue}Object.freeze(G),await Promise.allSettled(G).then(Z=>{for(const T of Z)T.status==="rejected"&&(0,y.$1)(T.reason)})}}}e.$Ud=n;class i extends l{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new P.$3c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Vd=i;class o extends i{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Wd=o;class r extends l{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(R=>super.fire(R)),this.h=[]}))}}e.$Xd=r;class t{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const R={event:k,listener:null};this.h.push(R),this.g&&this.m(R);const N=()=>{this.g&&this.o(R);const Y=this.h.indexOf(R);this.h.splice(Y,1)};return(0,s.$Qc)((0,A.$db)(N))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(R=>this.f.fire(R))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Yd=t;class a{constructor(k,R,N,Y){this.f=new s.$Rc;const ee=this.f.add(new t),G=this.f.add(new s.$2c);function ne(Z){G.set(Z,ee.add(Y(Z)))}for(const Z of k)ne(Z);this.f.add(R(Z=>{ne(Z)})),this.f.add(N(Z=>{G.deleteAndDispose(Z)})),this.event=ee.event}dispose(){this.f.dispose()}}e.$Zd=a;class b{constructor(){this.f=[]}wrapEvent(k){return(R,N,Y)=>k(ee=>{const G=this.f[this.f.length-1];G?G.push(()=>R.call(N,ee)):R.call(N,ee)},void 0,Y)}bufferEvents(k){const R=[];this.f.push(R);const N=k();return this.f.pop(),R.forEach(Y=>Y()),N}}e.$1d=b;class C{constructor(){this.f=!1,this.g=v.None,this.h=s.$Sc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=C}),define(we[20],ve([1,0,5]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const A=Object.freeze(function(S,p){const v=setTimeout(S.bind(p),0);return{dispose(){clearTimeout(v)}}});var s;(function(S){function p(v){return v===S.None||v===S.Cancelled||v instanceof P?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}S.isCancellationToken=p,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(s||(e.CancellationToken=s={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new y.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=s.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=s.None}}e.$3d=D}),define(we[147],ve([1,0,20]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class A{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new y.$3d,p=this.b(S.token);return this.a={promise:p,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$Be=A;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const p=JSON.stringify(S);return this.b!==p&&(this.b=p,this.a=this.c(S)),this.a}}e.$Ce=s;class P{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const p=this.b(S);return this.a.set(S,p),p}}e.$De=P}),define(we[48],ve([1,0,11,2]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function s($){const u=$;return u?typeof u.read=="function":!1}e.$4d=s;function P($){const u=$;return u?[u.on,u.pause,u.resume,u.destroy].every(n=>typeof n=="function"):!1}e.$5d=P;function D($){const u=$;return u?P(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$6d=D;function S($,u){return new p($,u)}e.$7d=S;class p{constructor(u,n){this.e=u,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(n=>n(u))}h(u){this.c.error.length===0?(0,y.$1)(u):this.c.error.slice(0).forEach(n=>n(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,n){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(u,n){if(this.a.destroyed)return;let i;switch(u){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const o=i.indexOf(n);o>=0&&i.splice(o,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v($,u){const n=[];let i;for(;(i=$.read())!==null;)n.push(i);return u(n)}e.$8d=v;function I($,u,n){const i=[];let o;for(;(o=$.read())!==null&&i.length<n;)i.push(o);return o===null&&i.length>0?u(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o<"u"){const r=o;return o=void 0,r}return $.read()}}}e.$9d=I;function E($,u){return new Promise((n,i)=>{const o=[];w($,{onData:r=>{u&&o.push(r)},onError:r=>{u?i(r):n(void 0)},onEnd:()=>{n(u?u(o):void 0)}})})}e.$0d=E;function w($,u,n){$.on("error",i=>{n?.isCancellationRequested||u.onError(i)}),$.on("end",()=>{n?.isCancellationRequested||u.onEnd()}),$.on("data",i=>{n?.isCancellationRequested||u.onData(i)})}e.$$d=w;function f($,u){return new Promise((n,i)=>{const o=new A.$Rc,r=[],t=C=>{if(r.push(C),r.length>u)return o.dispose(),$.pause(),n({stream:$,buffer:r,ended:!1})},a=C=>(o.dispose(),i(C)),b=()=>(o.dispose(),n({stream:$,buffer:r,ended:!0}));o.add((0,A.$Qc)(()=>$.removeListener("error",a))),$.on("error",a),o.add((0,A.$Qc)(()=>$.removeListener("end",b))),$.on("end",b),o.add((0,A.$Qc)(()=>$.removeListener("data",t))),$.on("data",t)})}e.$_d=f;function g($,u){const n=S(u);return n.end($),n}e.$ae=g;function c(){const $=S(()=>{throw new Error("not supported")});return $.end(),$}e.$be=c;function m($){let u=!1;return{read:()=>u?null:(u=!0,$)}}e.$ce=m;function h($,u,n){const i=S(n);return w($,{onData:o=>i.write(u.data(o)),onError:o=>i.error(u.error?u.error(o):o),onEnd:()=>i.end()}),i}e.$de=h;function d($,u,n){let i=!1;return{read:()=>{const o=u.read();return i?o:(i=!0,o!==null?n([$,o]):$)}}}e.$ee=d;function l($,u,n){let i=!1;const o=S(n);return w(u,{onData:r=>i?o.write(r):(i=!0,o.write(n([$,r]))),onError:r=>o.error(r),onEnd:()=>{i||(i=!0,o.write($)),o.end()}}),o}e.$fe=l}),define(we[15],ve([1,0,59,48]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const s=typeof Buffer<"u",P=new y.$V(()=>new Uint8Array(256));let D,S;class p{static alloc(R){return s?new p(Buffer.allocUnsafe(R)):new p(new Uint8Array(R))}static wrap(R){return s&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new p(R)}static fromString(R,N){return!(N?.dontUseNodeBuffer||!1)&&s?new p(Buffer.from(R)):(D||(D=new TextEncoder),new p(D.encode(R)))}static fromByteArray(R){const N=p.alloc(R.length);for(let Y=0,ee=R.length;Y<ee;Y++)N.buffer[Y]=R[Y];return N}static concat(R,N){if(typeof N>"u"){N=0;for(let G=0,ne=R.length;G<ne;G++)N+=R[G].byteLength}const Y=p.alloc(N);let ee=0;for(let G=0,ne=R.length;G<ne;G++){const Z=R[G];Y.set(Z,ee),ee+=Z.byteLength}return Y}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=p.alloc(this.byteLength);return R.set(this),R}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(R,N){return new p(this.buffer.subarray(R,N))}set(R,N){if(R instanceof p)this.buffer.set(R.buffer,N);else if(R instanceof Uint8Array)this.buffer.set(R,N);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),N);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return w(this.buffer,R)}writeUInt32BE(R,N){f(this.buffer,R,N)}readUInt32LE(R){return g(this.buffer,R)}writeUInt32LE(R,N){c(this.buffer,R,N)}readUInt8(R){return m(this.buffer,R)}writeUInt8(R,N){h(this.buffer,R,N)}indexOf(R,N=0){return v(this.buffer,R instanceof p?R.buffer:R,N)}}e.$ge=p;function v(k,R,N=0){const Y=R.byteLength,ee=k.byteLength;if(Y===0)return 0;if(Y===1)return k.indexOf(R[0]);if(Y>ee-N)return-1;const G=P.value;G.fill(R.length);for(let oe=0;oe<R.length;oe++)G[R[oe]]=R.length-oe-1;let ne=N+R.length-1,Z=ne,T=-1;for(;ne<ee;)if(k[ne]===R[Z]){if(Z===0){T=ne;break}ne--,Z--}else ne+=Math.max(R.length-Z,G[k[ne]]),Z=R.length-1;return T}e.$he=v;function I(k,R){return k[R+0]<<0>>>0|k[R+1]<<8>>>0}e.$ie=I;function E(k,R,N){k[N+0]=R&255,R=R>>>8,k[N+1]=R&255}e.$je=E;function w(k,R){return k[R]*2**24+k[R+1]*2**16+k[R+2]*2**8+k[R+3]}e.$ke=w;function f(k,R,N){k[N+3]=R,R=R>>>8,k[N+2]=R,R=R>>>8,k[N+1]=R,R=R>>>8,k[N]=R}e.$le=f;function g(k,R){return k[R+0]<<0>>>0|k[R+1]<<8>>>0|k[R+2]<<16>>>0|k[R+3]<<24>>>0}e.$me=g;function c(k,R,N){k[N+0]=R&255,R=R>>>8,k[N+1]=R&255,R=R>>>8,k[N+2]=R&255,R=R>>>8,k[N+3]=R&255}e.$ne=c;function m(k,R){return k[R]}e.$oe=m;function h(k,R,N){k[N]=R}e.$pe=h;function d(k){return A.$8d(k,R=>p.concat(R))}e.$qe=d;function l(k){return A.$ce(k)}e.$re=l;function $(k){return A.$0d(k,R=>p.concat(R))}e.$se=$;async function u(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await $(k.stream)])}e.$te=u;function n(k){return A.$ae(k,R=>p.concat(R))}e.$ue=n;function i(k){return A.$de(k,{data:R=>typeof R=="string"?p.fromString(R):p.wrap(R)},R=>p.concat(R))}e.$ve=i;function o(k){return A.$7d(R=>p.concat(R),k)}e.$we=o;function r(k,R){return A.$ee(k,R,N=>p.concat(N))}e.$xe=r;function t(k,R){return A.$fe(k,R,N=>p.concat(N))}e.$ye=t;function a(k){let R=0,N=0,Y=0;const ee=new Uint8Array(Math.floor(k.length/4*3)),G=Z=>{switch(N){case 3:ee[Y++]=R|Z,N=0;break;case 2:ee[Y++]=R|Z>>>2,R=Z<<6,N=3;break;case 1:ee[Y++]=R|Z>>>4,R=Z<<4,N=2;break;default:R=Z<<2,N=1}};for(let Z=0;Z<k.length;Z++){const T=k.charCodeAt(Z);if(T>=65&&T<=90)G(T-65);else if(T>=97&&T<=122)G(T-97+26);else if(T>=48&&T<=57)G(T-48+52);else if(T===43||T===45)G(62);else if(T===47||T===95)G(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${k[Z]}`)}}const ne=Y;for(;N>0;)G(0);return p.wrap(ee).slice(0,ne)}e.$ze=a;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function L({buffer:k},R=!0,N=!1){const Y=N?C:b;let ee="";const G=k.byteLength%3;let ne=0;for(;ne<k.byteLength-G;ne+=3){const Z=k[ne+0],T=k[ne+1],oe=k[ne+2];ee+=Y[Z>>>2],ee+=Y[(Z<<4|T>>>4)&63],ee+=Y[(T<<2|oe>>>6)&63],ee+=Y[oe&63]}if(G===1){const Z=k[ne+0];ee+=Y[Z>>>2],ee+=Y[Z<<4&63],R&&(ee+="==")}else if(G===2){const Z=k[ne+0],T=k[ne+1];ee+=Y[Z>>>2],ee+=Y[(Z<<4|T>>>4)&63],ee+=Y[T<<2&63],R&&(ee+="=")}return ee}e.$Ae=L}),define(we[17],ve([1,0,147,59]),function(he,e,y,A){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Df=e.$Cf=e.$Bf=e.$Af=e.GraphemeBreakType=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function P(be){return!be||typeof be!="string"?!0:be.trim().length===0}e.$Ge=P;const D=/{(\d+)}/g;function S(be,...Ie){return Ie.length===0?be:be.replace(D,function(Ce,je){const Fe=parseInt(je,10);return isNaN(Fe)||Fe<0||Fe>=Ie.length?Ce:Ie[Fe]})}e.$He=S;const p=/{([^}]+)}/g;function v(be,Ie){return Object.keys(Ie).length===0?be:be.replace(p,(Ce,je)=>Ie[je]??Ce)}e.$Ie=v;function I(be){return be.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.$Je=I;function E(be){return be.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=E;function w(be,Ie){let Ce=0;const je=Ie.charCodeAt(0);for(let Fe=be.length-1;Fe>=0;Fe--)be.charCodeAt(Fe)===je&&Ce++;return Ce}e.$Le=w;function f(be,Ie,Ce="\u2026"){return be.length<=Ie?be:`${be.substr(0,Ie)}${Ce}`}e.$Me=f;function g(be,Ie,Ce="\u2026"){if(be.length<=Ie)return be;const je=Math.ceil(Ie/2)-Ce.length/2,Fe=Math.floor(Ie/2)-Ce.length/2;return`${be.substr(0,je)}${Ce}${be.substr(be.length-Fe)}`}e.$Ne=g;function c(be,Ie=" "){const Ce=m(be,Ie);return h(Ce,Ie)}e.$Oe=c;function m(be,Ie){if(!be||!Ie)return be;const Ce=Ie.length;if(Ce===0||be.length===0)return be;let je=0;for(;be.indexOf(Ie,je)===je;)je=je+Ce;return be.substring(je)}e.$Pe=m;function h(be,Ie){if(!be||!Ie)return be;const Ce=Ie.length,je=be.length;if(Ce===0||je===0)return be;let Fe=je,qe=-1;for(;qe=be.lastIndexOf(Ie,Fe-1),!(qe===-1||qe+Ce!==Fe);){if(qe===0)return"";Fe=qe}return be.substring(0,Fe)}e.$Qe=h;function d(be){return be.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Re=d;function l(be){return be.replace(/\*/g,"")}e.$Se=l;function $(be,Ie,Ce={}){if(!be)throw new Error("Cannot create regex from empty string");Ie||(be=E(be)),Ce.wholeWord&&(/\B/.test(be.charAt(0))||(be="\\b"+be),/\B/.test(be.charAt(be.length-1))||(be=be+"\\b"));let je="";return Ce.global&&(je+="g"),Ce.matchCase||(je+="i"),Ce.multiline&&(je+="m"),Ce.unicode&&(je+="u"),new RegExp(be,je)}e.$Te=$;function u(be){return be.source==="^"||be.source==="^$"||be.source==="$"||be.source==="^\\s*$"?!1:!!(be.exec("")&&be.lastIndex===0)}e.$Ue=u;function n(be){return be.split(/\r\n|\r|\n/)}e.$Ve=n;function i(be){for(let Ie=0,Ce=be.length;Ie<Ce;Ie++){const je=be.charCodeAt(Ie);if(je!==32&&je!==9)return Ie}return-1}e.$We=i;function o(be,Ie=0,Ce=be.length){for(let je=Ie;je<Ce;je++){const Fe=be.charCodeAt(je);if(Fe!==32&&Fe!==9)return be.substring(Ie,je)}return be.substring(Ie,Ce)}e.$Xe=o;function r(be,Ie=be.length-1){for(let Ce=Ie;Ce>=0;Ce--){const je=be.charCodeAt(Ce);if(je!==32&&je!==9)return Ce}return-1}e.$Ye=r;function t(be,Ie,Ce){const je=[];let Fe=0;for(const qe of be.matchAll(Ie)){if(je.push(be.slice(Fe,qe.index)),qe.index===void 0)throw new Error("match.index should be defined");Fe=qe.index+qe[0].length,je.push(Ce(qe[0],...qe.slice(1),qe.index,be,qe.groups))}return je.push(be.slice(Fe)),Promise.all(je).then(qe=>qe.join(""))}e.$Ze=t;function a(be,Ie){return be<Ie?-1:be>Ie?1:0}e.$1e=a;function b(be,Ie,Ce=0,je=be.length,Fe=0,qe=Ie.length){for(;Ce<je&&Fe<qe;Ce++,Fe++){const Je=be.charCodeAt(Ce),xe=Ie.charCodeAt(Fe);if(Je<xe)return-1;if(Je>xe)return 1}const Ve=je-Ce,Qe=qe-Fe;return Ve<Qe?-1:Ve>Qe?1:0}e.$2e=b;function C(be,Ie){return L(be,Ie,0,be.length,0,Ie.length)}e.$3e=C;function L(be,Ie,Ce=0,je=be.length,Fe=0,qe=Ie.length){for(;Ce<je&&Fe<qe;Ce++,Fe++){let Je=be.charCodeAt(Ce),xe=Ie.charCodeAt(Fe);if(Je===xe)continue;if(Je>=128||xe>=128)return b(be.toLowerCase(),Ie.toLowerCase(),Ce,je,Fe,qe);R(Je)&&(Je-=32),R(xe)&&(xe-=32);const rt=Je-xe;if(rt!==0)return rt}const Ve=je-Ce,Qe=qe-Fe;return Ve<Qe?-1:Ve>Qe?1:0}e.$4e=L;function k(be){return be>=48&&be<=57}e.$5e=k;function R(be){return be>=97&&be<=122}e.$6e=R;function N(be){return be>=65&&be<=90}e.$7e=N;function Y(be,Ie){return be.length===Ie.length&&L(be,Ie)===0}e.$8e=Y;function ee(be,Ie){const Ce=Ie.length;return Ie.length>be.length?!1:L(be,Ie,0,Ce)===0}e.$9e=ee;function G(be,Ie){const Ce=Math.min(be.length,Ie.length);let je;for(je=0;je<Ce;je++)if(be.charCodeAt(je)!==Ie.charCodeAt(je))return je;return Ce}e.$0e=G;function ne(be,Ie){const Ce=Math.min(be.length,Ie.length);let je;const Fe=be.length-1,qe=Ie.length-1;for(je=0;je<Ce;je++)if(be.charCodeAt(Fe-je)!==Ie.charCodeAt(qe-je))return je;return Ce}e.$$e=ne;function Z(be){return 55296<=be&&be<=56319}e.$_e=Z;function T(be){return 56320<=be&&be<=57343}e.$af=T;function oe(be,Ie){return(be-55296<<10)+(Ie-56320)+65536}e.$bf=oe;function Q(be,Ie,Ce){const je=be.charCodeAt(Ce);if(Z(je)&&Ce+1<Ie){const Fe=be.charCodeAt(Ce+1);if(T(Fe))return oe(je,Fe)}return je}e.$cf=Q;function te(be,Ie){const Ce=be.charCodeAt(Ie-1);if(T(Ce)&&Ie>1){const je=be.charCodeAt(Ie-2);if(Z(je))return oe(je,Ce)}return Ce}class J{get offset(){return this.e}constructor(Ie,Ce=0){this.c=Ie,this.d=Ie.length,this.e=Ce}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=te(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=Q(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.$df=J;class V{get offset(){return this.c.offset}constructor(Ie,Ce=0){this.c=new J(Ie,Ce)}nextGraphemeLength(){const Ie=Me.getInstance(),Ce=this.c,je=Ce.offset;let Fe=Ie.getGraphemeBreakType(Ce.nextCodePoint());for(;!Ce.eol();){const qe=Ce.offset,Ve=Ie.getGraphemeBreakType(Ce.nextCodePoint());if(ke(Fe,Ve)){Ce.setOffset(qe);break}Fe=Ve}return Ce.offset-je}prevGraphemeLength(){const Ie=Me.getInstance(),Ce=this.c,je=Ce.offset;let Fe=Ie.getGraphemeBreakType(Ce.prevCodePoint());for(;Ce.offset>0;){const qe=Ce.offset,Ve=Ie.getGraphemeBreakType(Ce.prevCodePoint());if(ke(Ve,Fe)){Ce.setOffset(qe);break}Fe=Ve}return je-Ce.offset}eol(){return this.c.eol()}}e.$ef=V;function ie(be,Ie){return new V(be,Ie).nextGraphemeLength()}e.$ff=ie;function ue(be,Ie){return new V(be,Ie).prevGraphemeLength()}e.$gf=ue;function se(be,Ie){Ie>0&&T(be.charCodeAt(Ie))&&Ie--;const Ce=Ie+ie(be,Ie);return[Ce-ue(be,Ce),Ce]}e.$hf=se;function me(be){const Ie=new V(be);let Ce=0;for(;!Ie.eol();)Ce++,Ie.nextGraphemeLength();return Ce}e.$if=me;let B;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function O(be){return B||(B=W()),B.test(be)}e.$jf=O;const j=/^[\t\n\r\x20-\x7E]*$/;function re(be){return j.test(be)}e.$kf=re,e.$lf=/[\u2028\u2029]/;function X(be){return e.$lf.test(be)}e.$mf=X;function x(be){return be>=11904&&be<=55215||be>=63744&&be<=64255||be>=65281&&be<=65374}e.$nf=x;function z(be){return be>=127462&&be<=127487||be===8986||be===8987||be===9200||be===9203||be>=9728&&be<=10175||be===11088||be===11093||be>=127744&&be<=128591||be>=128640&&be<=128764||be>=128992&&be<=129008||be>=129280&&be<=129535||be>=129648&&be<=129782}e.$of=z;function q(be,Ie){if(be.length<Ie)return be;const Ce=/\b/g;let je=0;for(;Ce.test(be)&&!(be.length-Ce.lastIndex<Ie);)je=Ce.lastIndex,Ce.lastIndex+=1;return be.substring(je).replace(/^\s/,"")}e.$pf=q;const M=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,H=/\x1b\].*?\x07/g;function _(be){return be&&(be=be.replace(M,"").replace(H,"")),be}e.$qf=_,e.$rf=String.fromCharCode(65279);function ae(be){return!!(be&&be.length>0&&be.charCodeAt(0)===65279)}e.$sf=ae;function fe(be){return ae(be)?be.substr(1):be}e.$tf=fe;function le(be,Ie){if(!be||!Ie||be.length<Ie.length)return!1;const Ce=Ie.length,je=be.toLowerCase();let Fe=0,qe=-1;for(;Fe<Ce;){const Ve=je.indexOf(Ie[Fe],qe+1);if(Ve<0)return!1;qe=Ve,Fe++}return!0}e.$uf=le;function $e(be,Ie=!1){return be?(Ie&&(be=be.replace(/\\./g,"")),be.toLowerCase()!==be):!1}e.$vf=$e;function ye(be){return be.charAt(0).toUpperCase()+be.slice(1)}e.$wf=ye;function Ae(be,Ie=1){if(Ie===0)return"";let Ce=-1;do Ce=be.indexOf(`
`,Ce+1),Ie--;while(Ie>0&&Ce>=0);return Ce===-1?be:(be[Ce-1]==="\r"&&Ce--,be.substr(0,Ce))}e.$xf=Ae;function Re(be){return be=be%(2*26),be<26?String.fromCharCode(97+be):String.fromCharCode(65+be-26)}e.$yf=Re;function ge(be){return Me.getInstance().getGraphemeBreakType(be)}e.$zf=ge;function ke(be,Ie){return be===0?Ie!==5&&Ie!==7:be===2&&Ie===3?!1:be===4||be===2||be===3||Ie===4||Ie===2||Ie===3?!0:!(be===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(be===11||be===9)&&(Ie===9||Ie===10)||(be===12||be===10)&&Ie===10||Ie===5||Ie===13||Ie===7||be===1||be===13&&Ie===14||be===6&&Ie===6)}var De;(function(be){be[be.Other=0]="Other",be[be.Prepend=1]="Prepend",be[be.CR=2]="CR",be[be.LF=3]="LF",be[be.Control=4]="Control",be[be.Extend=5]="Extend",be[be.Regional_Indicator=6]="Regional_Indicator",be[be.SpacingMark=7]="SpacingMark",be[be.L=8]="L",be[be.V=9]="V",be[be.T=10]="T",be[be.LV=11]="LV",be[be.LVT=12]="LVT",be[be.ZWJ=13]="ZWJ",be[be.Extended_Pictographic=14]="Extended_Pictographic"})(De||(e.GraphemeBreakType=De={}));class Me{static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=Te()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ce=this.d,je=Ce.length/3;let Fe=1;for(;Fe<=je;)if(Ie<Ce[3*Fe])Fe=2*Fe;else if(Ie>Ce[3*Fe+1])Fe=2*Fe+1;else return Ce[3*Fe+2];return 0}}Me.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(be,Ie){if(be===0)return 0;const Ce=Ue(be,Ie);if(Ce!==void 0)return Ce;const je=new J(Ie,be);return je.prevCodePoint(),je.offset}e.$Af=He;function Ue(be,Ie){const Ce=new J(Ie,be);let je=Ce.prevCodePoint();for(;Ke(je)||je===65039||je===8419;){if(Ce.offset===0)return;je=Ce.prevCodePoint()}if(!z(je))return;let Fe=Ce.offset;return Fe>0&&Ce.prevCodePoint()===8205&&(Fe=Ce.offset),Fe}function Ke(be){return 127995<=be&&be<=127999}var tt;(function(be){be[be.zwj=8205]="zwj",be[be.emojiVariantSelector=65039]="emojiVariantSelector",be[be.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.$Bf="\xA0";class Ze{static getInstance(Ie){return s.d.get(Array.from(Ie))}static getLocales(){return s.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Cf=Ze,s=Ze,Ze.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ze.d=new y.$Ce(be=>{function Ie(xe){const rt=new Map;for(let Xe=0;Xe<xe.length;Xe+=2)rt.set(xe[Xe],xe[Xe+1]);return rt}function Ce(xe,rt){const Xe=new Map(xe);for(const[lt,at]of rt)Xe.set(lt,at);return Xe}function je(xe,rt){if(!xe)return rt;const Xe=new Map;for(const[lt,at]of xe)rt.has(lt)&&Xe.set(lt,at);return Xe}const Fe=s.c.value;let qe=be.filter(xe=>!xe.startsWith("_")&&xe in Fe);qe.length===0&&(qe=["_default"]);let Ve;for(const xe of qe){const rt=Ie(Fe[xe]);Ve=je(Ve,rt)}const Qe=Ie(Fe._common),Je=Ce(Qe,Ve);return new s(Je)}),Ze.e=new A.$V(()=>Object.keys(s.c.value).filter(be=>!be.startsWith("_")));class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Ie){return et.e().has(Ie)}static get codePoints(){return et.e()}}e.$Df=et,et.d=void 0}),define(we[148],ve([1,0,26,144,17]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.FuzzyScore=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.or=void 0;function P(...le){return function($e,ye){for(let Ae=0,Re=le.length;Ae<Re;Ae++){const ge=le[Ae]($e,ye);if(ge)return ge}return null}}e.or=P,e.$Pj=D.bind(void 0,!1),e.$Qj=D.bind(void 0,!0);function D(le,$e,ye){if(!ye||ye.length<$e.length)return null;let Ae;return le?Ae=s.$9e(ye,$e):Ae=ye.indexOf($e)===0,Ae?$e.length>0?[{start:0,end:$e.length}]:[]:null}function S(le,$e){const ye=$e.toLowerCase().indexOf(le.toLowerCase());return ye===-1?null:[{start:ye,end:ye+le.length}]}e.$Rj=S;function p(le,$e){return v(le.toLowerCase(),$e.toLowerCase(),0,0)}e.$Sj=p;function v(le,$e,ye,Ae){if(ye===le.length)return[];if(Ae===$e.length)return null;if(le[ye]===$e[Ae]){let Re=null;return(Re=v(le,$e,ye+1,Ae+1))?$({start:Ae,end:Ae+1},Re):null}return v(le,$e,ye,Ae+1)}function I(le){return 97<=le&&le<=122}function E(le){return 65<=le&&le<=90}e.$Tj=E;function w(le){return 48<=le&&le<=57}function f(le){return le===32||le===9||le===10||le===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>g.add(le.charCodeAt(0)));function c(le){return f(le)||g.has(le)}function m(le,$e){return le===$e||c(le)&&c($e)}const h=new Map;function d(le){if(h.has(le))return h.get(le);let $e;const ye=(0,A.$Nj)(le);return ye&&($e=ye),h.set(le,$e),$e}function l(le){return I(le)||E(le)||w(le)}function $(le,$e){return $e.length===0?$e=[le]:le.end===$e[0].start?$e[0].start=le.start:$e.unshift(le),$e}function u(le,$e){for(let ye=$e;ye<le.length;ye++){const Ae=le.charCodeAt(ye);if(E(Ae)||w(Ae)||ye>0&&!l(le.charCodeAt(ye-1)))return ye}return le.length}function n(le,$e,ye,Ae){if(ye===le.length)return[];if(Ae===$e.length)return null;if(le[ye]!==$e[Ae].toLowerCase())return null;{let Re=null,ge=Ae+1;for(Re=n(le,$e,ye+1,Ae+1);!Re&&(ge=u($e,ge))<$e.length;)Re=n(le,$e,ye+1,ge),ge++;return Re===null?null:$({start:Ae,end:Ae+1},Re)}}function i(le){let $e=0,ye=0,Ae=0,Re=0,ge=0;for(let He=0;He<le.length;He++)ge=le.charCodeAt(He),E(ge)&&$e++,I(ge)&&ye++,l(ge)&&Ae++,w(ge)&&Re++;const ke=$e/le.length,De=ye/le.length,Me=Ae/le.length,Te=Re/le.length;return{upperPercent:ke,lowerPercent:De,alphaPercent:Me,numericPercent:Te}}function o(le){const{upperPercent:$e,lowerPercent:ye}=le;return ye===0&&$e>.6}function r(le){const{upperPercent:$e,lowerPercent:ye,alphaPercent:Ae,numericPercent:Re}=le;return ye>.2&&$e<.8&&Ae>.6&&Re<.2}function t(le){let $e=0,ye=0,Ae=0,Re=0;for(let ge=0;ge<le.length;ge++)Ae=le.charCodeAt(ge),E(Ae)&&$e++,I(Ae)&&ye++,f(Ae)&&Re++;return($e===0||ye===0)&&Re===0?le.length<=30:$e<=5}function a(le,$e){if(!$e||($e=$e.trim(),$e.length===0)||!t(le)||$e.length>60)return null;const ye=i($e);if(!r(ye)){if(!o(ye))return null;$e=$e.toLowerCase()}let Ae=null,Re=0;for(le=le.toLowerCase();Re<$e.length&&(Ae=n(le,$e,0,Re))===null;)Re=u($e,Re+1);return Ae}e.$Uj=a;function b(le,$e,ye=!1){if(!$e||$e.length===0)return null;let Ae=null,Re=0;for(le=le.toLowerCase(),$e=$e.toLowerCase();Re<$e.length&&(Ae=C(le,$e,0,Re,ye),Ae===null);)Re=L($e,Re+1);return Ae}e.$Vj=b;function C(le,$e,ye,Ae,Re){let ge=0;if(ye===le.length)return[];if(Ae===$e.length)return null;if(!m(le.charCodeAt(ye),$e.charCodeAt(Ae))){const Me=d(le.charCodeAt(ye));if(!Me)return null;for(let Te=0;Te<Me.length;Te++)if(!m(Me[Te],$e.charCodeAt(Ae+Te)))return null;ge+=Me.length-1}let ke=null,De=Ae+ge+1;if(ke=C(le,$e,ye+1,De,Re),!Re)for(;!ke&&(De=L($e,De))<$e.length;)ke=C(le,$e,ye+1,De,Re),De++;if(!ke)return null;if(le.charCodeAt(ye)!==$e.charCodeAt(Ae)){const Me=d(le.charCodeAt(ye));if(!Me)return ke;for(let Te=0;Te<Me.length;Te++)if(Me[Te]!==$e.charCodeAt(Ae+Te))return ke}return $({start:Ae,end:Ae+ge+1},ke)}function L(le,$e){for(let ye=$e;ye<le.length;ye++)if(c(le.charCodeAt(ye))||ye>0&&c(le.charCodeAt(ye-1)))return ye;return le.length}const k=P(e.$Qj,a,S),R=P(e.$Qj,a,p),N=new y.$Dc(1e4);function Y(le,$e,ye=!1){if(typeof le!="string"||typeof $e!="string")return null;let Ae=N.get(le);Ae||(Ae=new RegExp(s.$Re(le),"i"),N.set(le,Ae));const Re=Ae.exec($e);return Re?[{start:Re.index,end:Re.index+Re[0].length}]:ye?R(le,$e):k(le,$e)}e.$Wj=Y;function ee(le,$e){const ye=z(le,le.toLowerCase(),0,$e,$e.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ye?ne(ye):null}e.$Xj=ee;function G(le,$e,ye,Ae,Re,ge){const ke=Math.min(13,le.length);for(;ye<ke;ye++){const De=z(le,$e,ye,Ae,Re,ge,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,ge]}e.$Yj=G;function ne(le){if(typeof le>"u")return[];const $e=[],ye=le[1];for(let Ae=le.length-1;Ae>1;Ae--){const Re=le[Ae]+ye,ge=$e[$e.length-1];ge&&ge.end===Re?ge.end=Re+1:$e.push({start:Re,end:Re+1})}return $e}e.$Zj=ne;const Z=128;function T(){const le=[],$e=[];for(let ye=0;ye<=Z;ye++)$e[ye]=0;for(let ye=0;ye<=Z;ye++)le.push($e.slice(0));return le}function oe(le){const $e=[];for(let ye=0;ye<=le;ye++)$e[ye]=0;return $e}const Q=oe(2*Z),te=oe(2*Z),J=T(),V=T(),ie=T(),ue=!1;function se(le,$e,ye,Ae,Re){function ge(De,Me,Te=" "){for(;De.length<Me;)De=Te+De;return De}let ke=` |   |${Ae.split("").map(De=>ge(De,3)).join("|")}
`;for(let De=0;De<=ye;De++)De===0?ke+=" |":ke+=`${$e[De-1]}|`,ke+=le[De].slice(0,Re+1).map(Me=>ge(Me.toString(),3)).join("|")+`
`;return ke}function me(le,$e,ye,Ae){le=le.substr($e),ye=ye.substr(Ae),console.log(se(V,le,le.length,ye,ye.length)),console.log(se(ie,le,le.length,ye,ye.length)),console.log(se(J,le,le.length,ye,ye.length))}function B(le,$e){if($e<0||$e>=le.length)return!1;const ye=le.codePointAt($e);switch(ye){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!s.$of(ye)}}function W(le,$e){if($e<0||$e>=le.length)return!1;switch(le.charCodeAt($e)){case 32:case 9:return!0;default:return!1}}function O(le,$e,ye){return $e[le]!==ye[le]}function j(le,$e,ye,Ae,Re,ge,ke=!1){for(;$e<ye&&Re<ge;)le[$e]===Ae[Re]&&(ke&&(Q[$e]=Re),$e+=1),Re+=1;return $e===ye}e.$1j=j;var re;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(re||(re={}));var X;(function(le){le.Default=[-100,0];function $e(ye){return!ye||ye.length===2&&ye[0]===-100&&ye[1]===0}le.isDefault=$e})(X||(e.FuzzyScore=X={}));class x{constructor($e,ye){this.firstMatchCanBeWeak=$e,this.boostFullMatch=ye}}e.$2j=x,x.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function z(le,$e,ye,Ae,Re,ge,ke=x.default){const De=le.length>Z?Z:le.length,Me=Ae.length>Z?Z:Ae.length;if(ye>=De||ge>=Me||De-ye>Me-ge||!j($e,ye,De,Re,ge,Me,!0))return;q(De,Me,ye,ge,$e,Re);let Te=1,He=1,Ue=ye,Ke=ge;const tt=[!1];for(Te=1,Ue=ye;Ue<De;Te++,Ue++){const Ce=Q[Ue],je=te[Ue],Fe=Ue+1<De?te[Ue+1]:Me;for(He=Ce-ge+1,Ke=Ce;Ke<Fe;He++,Ke++){let qe=Number.MIN_SAFE_INTEGER,Ve=!1;Ke<=je&&(qe=M(le,$e,Ue,ye,Ae,Re,Ke,Me,ge,J[Te-1][He-1]===0,tt));let Qe=0;qe!==Number.MAX_SAFE_INTEGER&&(Ve=!0,Qe=qe+V[Te-1][He-1]);const Je=Ke>Ce,xe=Je?V[Te][He-1]+(J[Te][He-1]>0?-5:0):0,rt=Ke>Ce+1&&J[Te][He-1]>0,Xe=rt?V[Te][He-2]+(J[Te][He-2]>0?-5:0):0;if(rt&&(!Je||Xe>=xe)&&(!Ve||Xe>=Qe))V[Te][He]=Xe,ie[Te][He]=3,J[Te][He]=0;else if(Je&&(!Ve||xe>=Qe))V[Te][He]=xe,ie[Te][He]=2,J[Te][He]=0;else if(Ve)V[Te][He]=Qe,ie[Te][He]=1,J[Te][He]=J[Te-1][He-1]+1;else throw new Error("not possible")}}if(ue&&me(le,ye,Ae,ge),!tt[0]&&!ke.firstMatchCanBeWeak)return;Te--,He--;const Ze=[V[Te][He],ge];let et=0,be=0;for(;Te>=1;){let Ce=He;do{const je=ie[Te][Ce];if(je===3)Ce=Ce-2;else if(je===2)Ce=Ce-1;else break}while(Ce>=1);et>1&&$e[ye+Te-1]===Re[ge+He-1]&&!O(Ce+ge-1,Ae,Re)&&et+1>J[Te][Ce]&&(Ce=He),Ce===He?et++:et=1,be||(be=Ce),Te--,He=Ce-1,Ze.push(He)}Me===De&&ke.boostFullMatch&&(Ze[0]+=2);const Ie=be-De;return Ze[0]-=Ie,Ze}e.$3j=z;function q(le,$e,ye,Ae,Re,ge){let ke=le-1,De=$e-1;for(;ke>=ye&&De>=Ae;)Re[ke]===ge[De]&&(te[ke]=De,ke--),De--}function M(le,$e,ye,Ae,Re,ge,ke,De,Me,Te,He){if($e[ye]!==ge[ke])return Number.MIN_SAFE_INTEGER;let Ue=1,Ke=!1;return ke===ye-Ae?Ue=le[ye]===Re[ke]?7:5:O(ke,Re,ge)&&(ke===0||!O(ke-1,Re,ge))?(Ue=le[ye]===Re[ke]?7:5,Ke=!0):B(ge,ke)&&(ke===0||!B(ge,ke-1))?Ue=5:(B(ge,ke-1)||W(ge,ke-1))&&(Ue=5,Ke=!0),Ue>1&&ye===Ae&&(He[0]=!0),Ke||(Ke=O(ke,Re,ge)||B(ge,ke-1)||W(ge,ke-1)),ye===Ae?ke>Me&&(Ue-=Ke?3:5):Te?Ue+=Ke?2:0:Ue+=Ke?0:1,ke+1===De&&(Ue-=Ke?3:5),Ue}function H(le,$e,ye,Ae,Re,ge,ke){return ae(le,$e,ye,Ae,Re,ge,!0,ke)}e.$4j=H;function _(le,$e,ye,Ae,Re,ge,ke){return ae(le,$e,ye,Ae,Re,ge,!1,ke)}e.$5j=_;function ae(le,$e,ye,Ae,Re,ge,ke,De){let Me=z(le,$e,ye,Ae,Re,ge,De);if(Me&&!ke)return Me;if(le.length>=3){const Te=Math.min(7,le.length-1);for(let He=ye+1;He<Te;He++){const Ue=fe(le,He);if(Ue){const Ke=z(Ue,Ue.toLowerCase(),ye,Ae,Re,ge,De);Ke&&(Ke[0]-=3,(!Me||Ke[0]>Me[0])&&(Me=Ke))}}}return Me}function fe(le,$e){if($e+1>=le.length)return;const ye=le[$e],Ae=le[$e+1];if(ye!==Ae)return le.slice(0,$e)+Ae+ye+le.slice($e+2)}}),define(we[63],ve([1,0,17]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=void 0;function A(h){return s(h,0)}e.$Pi=A;function s(h,d){switch(typeof h){case"object":return h===null?P(349,d):Array.isArray(h)?p(h,d):v(h,d);case"string":return S(h,d);case"boolean":return D(h,d);case"number":return P(h,d);case"undefined":return P(937,d);default:return P(617,d)}}e.$Qi=s;function P(h,d){return(d<<5)-d+h|0}e.$Ri=P;function D(h,d){return P(h?433:863,d)}function S(h,d){d=P(149417,d);for(let l=0,$=h.length;l<$;l++)d=P(h.charCodeAt(l),d);return d}e.$Si=S;function p(h,d){return d=P(104579,d),h.reduce((l,$)=>s($,l),d)}function v(h,d){return d=P(181387,d),Object.keys(h).sort().reduce((l,$)=>(l=S($,l),s(h[$],l)),d)}class I{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=s(d,this.g),this.g}}e.$Ti=I;var E;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function w(h,d,l=32){const $=l-d,u=~((1<<$)-1);return(h<<d|(u&h)>>>$)>>>0}function f(h,d=0,l=h.byteLength,$=0){for(let u=0;u<l;u++)h[d+u]=$}function g(h,d,l="0"){for(;h.length<d;)h=l+h;return h}function c(h,d=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(l=>l.toString(16).padStart(2,"0")).join(""):g((h>>>0).toString(16),d/4)}e.$Ui=c;class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const l=d.length;if(l===0)return;const $=this.p;let u=this.r,n=this.u,i,o;for(n!==0?(i=n,o=-1,n=0):(i=d.charCodeAt(0),o=0);;){let r=i;if(y.$_e(i))if(o+1<l){const t=d.charCodeAt(o+1);y.$af(t)?(o++,r=y.$bf(i,t)):r=65533}else{n=i;break}else y.$af(i)&&(r=65533);if(u=this.w($,u,r),o++,o<l)i=d.charCodeAt(o);else break}this.r=u,this.u=n}w(d,l,$){return $<128?d[l++]=$:$<2048?(d[l++]=192|($&1984)>>>6,d[l++]=128|($&63)>>>0):$<65536?(d[l++]=224|($&61440)>>>12,d[l++]=128|($&4032)>>>6,d[l++]=128|($&63)>>>0):(d[l++]=240|($&1835008)>>>18,d[l++]=128|($&258048)>>>12,d[l++]=128|($&4032)>>>6,d[l++]=128|($&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=m.g,l=this.q;for(let b=0;b<64;b+=4)d.setUint32(b,l.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)d.setUint32(b,w(d.getUint32(b-12,!1)^d.getUint32(b-32,!1)^d.getUint32(b-56,!1)^d.getUint32(b-64,!1),1),!1);let $=this.h,u=this.l,n=this.m,i=this.n,o=this.o,r,t,a;for(let b=0;b<80;b++)b<20?(r=u&n|~u&i,t=1518500249):b<40?(r=u^n^i,t=1859775393):b<60?(r=u&n|u&i|n&i,t=2400959708):(r=u^n^i,t=3395469782),a=w($,5)+r+o+t+d.getUint32(b*4,!1)&4294967295,o=i,i=n,n=w(u,30),u=$,$=a;this.h=this.h+$&4294967295,this.l=this.l+u&4294967295,this.m=this.m+n&4294967295,this.n=this.n+i&4294967295,this.o=this.o+o&4294967295}}e.$Vi=m,m.g=new DataView(new ArrayBuffer(320))}),define(we[64],ve([1,0,17]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(A||(A={})),function(s){const P="error",D="warning",S="warn",p="info",v="ignore";function I(w){return w?y.$8e(P,w)?s.Error:y.$8e(D,w)||y.$8e(S,w)?s.Warning:y.$8e(p,w)?s.Info:s.Ignore:s.Ignore}s.fromValue=I;function E(w){switch(w){case s.Error:return P;case s.Warning:return D;case s.Info:return p;default:return v}}s.toString=E}(A||(A={})),e.default=A}),define(we[149],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(we[65],ve([1,0,18,17]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const g=f.charCodeAt(0),c=this.b.charCodeAt(this.c);return g-c}value(){return this.b[this.c]}}e.$4h=s;class P{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,A.$2e)(f,this.b,0,f.length,this.c,this.d):(0,A.$4e)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=P;class D{constructor(f=!0,g=!0){this.f=f,this.g=g}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let g=f.length-1;g>=0;g--,this.c--){const c=this.b.charCodeAt(g);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,A.$2e)(f,this.b,0,f.length,this.d,this.e):(0,A.$4e)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=D;var S;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(S||(S={}));class p{constructor(f,g){this.f=f,this.g=g,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,A.$3e)(f,this.c.scheme);if(this.d[this.e]===2)return(0,A.$3e)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,A.$1e)(f,this.c.query);if(this.d[this.e]===5)return(0,A.$1e)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=p;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(I||(I={}));class E{static forUris(f=()=>!1,g=()=>!1){return new E(new p(f,g))}static forPaths(f=!1){return new E(new D(void 0,!f))}static forStrings(){return new E(new s)}static forConfigKeys(){return new E(new P)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,g){if(g){const c=g.slice(0);(0,y.$Xb)(c);for(const m of c)this.set(m,f)}else{const c=f.slice(0);(0,y.$Xb)(c);for(const m of c)this.set(m[0],m[1])}}set(f,g){const c=this.b.reset(f);let m;this.c||(this.c=new v,this.c.segment=c.value());const h=[];for(m=this.c;;){const l=c.cmp(m.segment);if(l>0)m.left||(m.left=new v,m.left.segment=c.value()),h.push([-1,m]),m=m.left;else if(l<0)m.right||(m.right=new v,m.right.segment=c.value()),h.push([1,m]),m=m.right;else if(c.hasNext())c.next(),m.mid||(m.mid=new v,m.mid.segment=c.value()),h.push([0,m]),m=m.mid;else break}const d=m.value;m.value=g,m.key=f;for(let l=h.length-1;l>=0;l--){const $=h[l][1];$.updateHeight();const u=$.balanceFactor();if(u<-1||u>1){const n=h[l][0],i=h[l+1][0];if(n===1&&i===1)h[l][1]=$.rotateLeft();else if(n===-1&&i===-1)h[l][1]=$.rotateRight();else if(n===1&&i===-1)$.right=h[l+1][1]=h[l+1][1].rotateRight(),h[l][1]=$.rotateLeft();else if(n===-1&&i===1)$.left=h[l+1][1]=h[l+1][1].rotateLeft(),h[l][1]=$.rotateRight();else throw new Error;if(l>0)switch(h[l-1][0]){case-1:h[l-1][1].left=h[l][1];break;case 1:h[l-1][1].right=h[l][1];break;case 0:h[l-1][1].mid=h[l][1];break}else this.c=h[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const g=this.b.reset(f);let c=this.c;for(;c;){const m=g.cmp(c.segment);if(m>0)c=c.left;else if(m<0)c=c.right;else if(g.hasNext())g.next(),c=c.mid;else break}return c}has(f){const g=this.d(f);return!(g?.value===void 0&&g?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,g){const c=this.b.reset(f),m=[];let h=this.c;for(;h;){const d=c.cmp(h.segment);if(d>0)m.push([-1,h]),h=h.left;else if(d<0)m.push([1,h]),h=h.right;else if(c.hasNext())c.next(),m.push([0,h]),h=h.mid;else break}if(h){if(g?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const d=this.f(h.right);if(d.key){const{key:l,value:$,segment:u}=d;this.e(d.key,!1),h.key=l,h.value=$,h.segment=u}}else{const d=h.left??h.right;if(m.length>0){const[l,$]=m[m.length-1];switch(l){case-1:$.left=d;break;case 0:$.mid=d;break;case 1:$.right=d;break}}else this.c=d}for(let d=m.length-1;d>=0;d--){const l=m[d][1];l.updateHeight();const $=l.balanceFactor();if($>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),m[d][1]=l.rotateLeft()):$<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),m[d][1]=l.rotateRight()),d>0)switch(m[d-1][0]){case-1:m[d-1][1].left=m[d][1];break;case 1:m[d-1][1].right=m[d][1];break;case 0:m[d-1][1].mid=m[d][1];break}else this.c=m[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const g=this.b.reset(f);let c=this.c,m;for(;c;){const h=g.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(g.hasNext())g.next(),m=c.value||m,c=c.mid;else break}return c&&c.value||m}findSuperstr(f){return this.g(f,!1)}g(f,g){const c=this.b.reset(f);let m=this.c;for(;m;){const h=c.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else return m.mid?this.h(m.mid):g?m.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[g,c]of this)f(c,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const g=[];return this.j(f,g),g[Symbol.iterator]()}j(f,g){f&&(f.left&&this.j(f.left,g),f.value&&g.push([f.key,f.value]),f.mid&&this.j(f.mid,g),f.right&&this.j(f.right,g))}_isBalanced(){const f=g=>{if(!g)return!0;const c=g.balanceFactor();return c<-1||c>1?!1:f(g.left)&&f(g.right)};return f(this.c)}}e.$8h=E}),define(we[8],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=void 0;function y(u){return typeof u=="string"}e.$Ef=y;function A(u){return Array.isArray(u)&&u.every(n=>y(n))}e.$Ff=A;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$Gf=s;function P(u){const n=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof n}e.$Hf=P;function D(u){return typeof u=="number"&&!isNaN(u)}e.$If=D;function S(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$Jf=S;function p(u){return u===!0||u===!1}e.$Kf=p;function v(u){return typeof u>"u"}e.$Lf=v;function I(u){return!E(u)}e.$Mf=I;function E(u){return v(u)||u===null}e.$Nf=E;function w(u,n){if(!u)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.$Of=w;function f(u){if(E(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$Pf=f;function g(...u){const n=[];for(let i=0;i<u.length;i++){const o=u[i];if(E(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(o)}return n}e.$Qf=g;const c=Object.prototype.hasOwnProperty;function m(u){if(!s(u))return!1;for(const n in u)if(c.call(u,n))return!1;return!0}e.$Rf=m;function h(u){return typeof u=="function"}e.$Sf=h;function d(...u){return u.length>0&&u.every(h)}e.$Tf=d;function l(u,n){const i=Math.min(u.length,n.length);for(let o=0;o<i;o++)$(u[o],n[o])}e.$Uf=l;function $(u,n){if(y(n)){if(typeof u!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(h(n)){try{if(u instanceof n)return}catch{}if(!E(u)&&u.constructor===n||n.length===1&&n.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Vf=$}),define(we[49],ve([1,0,8]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=void 0;const A=Object.create(null);function s(S,p){if((0,y.$Ef)(p)){const v=A[p];if(v===void 0)throw new Error(`${S} references an unknown codicon: ${p}`);p=v}return A[S]=p,{id:S}}function P(){return A}e.$6j=P;function D(){return Object.values(e.$8j)}e.$7j=D,e.$8j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(we[39],ve([1,0,7,4,17,8]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function D(a){return a===47||a===92}e.$Wf=D;function S(a){return a.replace(/[\\/]/g,y.$gc.sep)}e.$Xf=S;function p(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Yf=p;function v(a,b=y.$gc.sep){if(!a)return"";const C=a.length,L=a.charCodeAt(0);if(D(L)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let R=3;const N=R;for(;R<C&&!D(a.charCodeAt(R));R++);if(N!==R&&!D(a.charCodeAt(R+1))){for(R+=1;R<C;R++)if(D(a.charCodeAt(R)))return a.slice(0,R+1).replace(/[\\/]/g,b)}}return b}else if(h(L)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+b:a.slice(0,2);let k=a.indexOf("://");if(k!==-1){for(k+=3;k<C;k++)if(D(a.charCodeAt(k)))return a.slice(0,k+1)}return""}e.$Zf=v;function I(a){if(!A.$c||!a||a.length<5)return!1;let b=a.charCodeAt(0);if(b!==92||(b=a.charCodeAt(1),b!==92))return!1;let C=2;const L=C;for(;C<a.length&&(b=a.charCodeAt(C),b!==92);C++);return!(L===C||(b=a.charCodeAt(C+1),isNaN(b)||b===92))}e.$1f=I;const E=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(a,b=A.$c){const C=b?E:w;return!(!a||a.length===0||/^\s+$/.test(a)||(C.lastIndex=0,C.test(a))||b&&f.test(a)||a==="."||a===".."||b&&a[a.length-1]==="."||b&&a.length!==a.trim().length||a.length>255)}e.$2f=g;function c(a,b,C){const L=a===b;return!C||L?L:!a||!b?!1:(0,s.$8e)(a,b)}e.$3f=c;function m(a,b,C,L=y.sep){if(a===b)return!0;if(!a||!b||b.length>a.length)return!1;if(C){if(!(0,s.$9e)(a,b))return!1;if(b.length===a.length)return!0;let R=b.length;return b.charAt(b.length-1)===L&&R--,a.charAt(R)===L}return b.charAt(b.length-1)!==L&&(b+=L),a.indexOf(b)===0}e.$4f=m;function h(a){return a>=65&&a<=90||a>=97&&a<=122}e.$5f=h;function d(a,b){return A.$c&&a.endsWith(":")&&(a+=y.sep),(0,y.$ic)(a)||(a=(0,y.$jc)(b,a)),a=(0,y.$hc)(a),A.$c?(a=(0,s.$Qe)(a,y.sep),a.endsWith(":")&&(a+=y.sep)):(a=(0,s.$Qe)(a,y.sep),a||(a=y.sep)),a}e.$6f=d;function l(a){const b=(0,y.$hc)(a);return A.$c?a.length>3?!1:$(b)&&(a.length===2||b.charCodeAt(2)===92):b===y.$gc.sep}e.$7f=l;function $(a,b=A.$c){return b?h(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$8f=$;function u(a,b=A.$c){return $(a,b)?a[0]:void 0}e.$9f=u;function n(a,b,C){return b.length>a.length?-1:a===b?0:(C&&(a=a.toLowerCase(),b=b.toLowerCase()),a.indexOf(b))}e.$0f=n;function i(a){const b=a.split(":");let C,L,k;for(const R of b){const N=Number(R);(0,P.$If)(N)?L===void 0?L=N:k===void 0&&(k=N):C=C?[C,R].join(":"):R}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:L!==void 0?L:void 0,column:k!==void 0?k:L!==void 0?1:void 0}}e.$$f=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(a,b,C=8){let L="";for(let R=0;R<C;R++){let N;R===0&&A.$c&&!b&&(C===3||C===4)?N=r:N=o,L+=N.charAt(Math.floor(Math.random()*N.length))}let k;return b?k=`${b}-${L}`:k=L,a?(0,y.$jc)(a,k):k}e.$_f=t}),define(we[23],ve([1,0,8]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=void 0;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const d=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([l,$])=>{d[l]=$&&typeof $=="object"?A($):$}),d}e.$in=A;function s(h){if(!h||typeof h!="object")return h;const d=[h];for(;d.length>0;){const l=d.shift();Object.freeze(l);for(const $ in l)if(P.call(l,$)){const u=l[$];typeof u=="object"&&!Object.isFrozen(u)&&!(0,y.$Hf)(u)&&d.push(u)}}return h}e.$jn=s;const P=Object.prototype.hasOwnProperty;function D(h,d){return S(h,d,new Set)}e.$kn=D;function S(h,d,l){if((0,y.$Nf)(h))return h;const $=d(h);if(typeof $<"u")return $;if(Array.isArray(h)){const u=[];for(const n of h)u.push(S(n,d,l));return u}if((0,y.$Gf)(h)){if(l.has(h))throw new Error("Cannot clone recursive data-structure");l.add(h);const u={};for(const n in h)P.call(h,n)&&(u[n]=S(h[n],d,l));return l.delete(h),u}return h}function p(h,d,l=!0){return(0,y.$Gf)(h)?((0,y.$Gf)(d)&&Object.keys(d).forEach($=>{$ in h?l&&((0,y.$Gf)(h[$])&&(0,y.$Gf)(d[$])?p(h[$],d[$],l):h[$]=d[$]):h[$]=d[$]}),h):d}e.$ln=p;function v(h,d){if(h===d)return!0;if(h==null||d===null||d===void 0||typeof h!=typeof d||typeof h!="object"||Array.isArray(h)!==Array.isArray(d))return!1;let l,$;if(Array.isArray(h)){if(h.length!==d.length)return!1;for(l=0;l<h.length;l++)if(!v(h[l],d[l]))return!1}else{const u=[];for($ in h)u.push($);u.sort();const n=[];for($ in d)n.push($);if(n.sort(),!v(u,n))return!1;for(l=0;l<u.length;l++)if(!v(h[u[l]],d[u[l]]))return!1}return!0}e.$mn=v;function I(h){const d=new Set;return JSON.stringify(h,(l,$)=>{if((0,y.$Gf)($)||Array.isArray($)){if(d.has($))return"[Circular]";d.add($)}return $})}e.$nn=I;function E(h,d){const l=Object.create(null);return!h||!d||Object.keys(d).forEach(u=>{const n=h[u],i=d[u];v(n,i)||(l[u]=i)}),l}e.$on=E;function w(h,d){const l=d.toLowerCase(),$=Object.keys(h).find(u=>u.toLowerCase()===l);return $?h[$]:h[d]}e.$pn=w;function f(h,d){const l=Object.create(null);for(const[$,u]of Object.entries(h))d($,u)&&(l[$]=u);return l}e.$qn=f;function g(h){let d=[];for(;Object.prototype!==h;)d=d.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return d}e.$rn=g;function c(h){const d=[];for(const l of g(h))typeof h[l]=="function"&&d.push(l);return d}e.$sn=c;function m(h,d){const l=u=>function(){const n=Array.prototype.slice.call(arguments,0);return d(u,n)},$={};for(const u of h)$[u]=l(u);return $}e.$tn=m}),define(we[100],ve([1,0,49]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$9j=e.ThemeColor=void 0;var A;(function(D){function S(p){return p&&typeof p=="object"&&typeof p.id=="string"}D.isThemeColor=S})(A||(e.ThemeColor=A={}));function s(D){return{id:D}}e.$9j=s;var P;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function p(d){const l=S.exec(d.id);if(!l)return p(y.$8j.error);const[,$,u]=l,n=["codicon","codicon-"+$];return u&&n.push("codicon-modifier-"+u.substring(1)),n}D.asClassNameArray=p;function v(d){return p(d).join(" ")}D.asClassName=v;function I(d){return"."+p(d).join(".")}D.asCSSSelector=I;function E(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||A.isThemeColor(d.color))}D.isThemeIcon=E;const w=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function f(d){const l=w.exec(d);if(!l)return;const[,$]=l;return{id:$}}D.fromString=f;function g(d){return{id:d}}D.fromId=g;function c(d,l){let $=d.id;const u=$.lastIndexOf("~");return u!==-1&&($=$.substring(0,u)),l&&($=`${$}~${l}`),{id:$}}D.modify=c;function m(d){const l=d.id.lastIndexOf("~");if(l!==-1)return d.id.substring(l+1)}D.getModifier=m;function h(d,l){return d.id===l.id&&d.color?.id===l.color?.id}D.isEqual=h})(P||(e.ThemeIcon=P={}))}),define(we[150],ve([1,0,148,17,100]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=void 0;const P="$(",D=new RegExp(`\\$\\(${s.ThemeIcon.iconNameExpression}(?:${s.ThemeIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${D.source}`,"g");function p(h){return h.replace(S,(d,l)=>l?d:`\\${d}`)}e.$0j=p;const v=new RegExp(`\\\\${D.source}`,"g");function I(h){return h.replace(v,d=>`\\${d}`)}e.$$j=I;const E=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function w(h){return h.indexOf(P)===-1?h:h.replace(E,(d,l,$,u)=>$?d:l||u||"")}e.$_j=w;function f(h){return h?h.replace(/\$\((.*?)\)/g,(d,l)=>` ${l} `).trim():""}e.$ak=f;const g=new RegExp(`\\$\\(${s.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(h){g.lastIndex=0;let d="";const l=[];let $=0;for(;;){const u=g.lastIndex,n=g.exec(h),i=h.substring(u,n?.index);if(i.length>0){d+=i;for(let o=0;o<i.length;o++)l.push($)}if(!n)break;$+=n[0].length}return{text:d,iconOffsets:l}}e.$bk=c;function m(h,d,l=!1){const{text:$,iconOffsets:u}=d;if(!u||u.length===0)return(0,y.$Wj)(h,$,l);const n=(0,A.$Pe)($," "),i=$.length-n.length,o=(0,y.$Wj)(h,n,l);if(o)for(const r of o){const t=u[r.start+i]+i;r.start+=t,r.end+=t}return o}e.$ck=m}),define(we[3],ve([1,0,7,4]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,P=/^\//,D=/^\/\//;function S(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!s.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!P.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(r,t){return!r&&!t?"file":r}function v(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const I="",E="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(t){return t instanceof f?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,a,b,C,L,k=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=p(t,k),this.authority=a||I,this.path=v(this.scheme,b||I),this.query=C||I,this.fragment=L||I,S(this,k))}get fsPath(){return $(this,!1)}with(t){if(!t)return this;let{scheme:a,authority:b,path:C,query:L,fragment:k}=t;return a===void 0?a=this.scheme:a===null&&(a=I),b===void 0?b=this.authority:b===null&&(b=I),C===void 0?C=this.path:C===null&&(C=I),L===void 0?L=this.query:L===null&&(L=I),k===void 0?k=this.fragment:k===null&&(k=I),a===this.scheme&&b===this.authority&&C===this.path&&L===this.query&&k===this.fragment?this:new m(a,b,C,L,k)}static parse(t,a=!1){const b=w.exec(t);return b?new m(b[2]||I,o(b[4]||I),o(b[5]||I),o(b[7]||I),o(b[9]||I),a):new m(I,I,I,I,I)}static file(t){let a=I;if(A.$c&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const b=t.indexOf(E,2);b===-1?(a=t.substring(2),t=E):(a=t.substring(2,b),t=t.substring(b)||E)}return new m("file",a,t,I,I)}static from(t,a){return new m(t.scheme,t.authority,t.path,t.query,t.fragment,a)}static joinPath(t,...a){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return A.$c&&t.scheme==="file"?b=f.file(y.$fc.join($(t,!0),...a)).path:b=y.$gc.join(t.path,...a),t.with({path:b})}toString(t=!1){return u(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof f)return t;{const a=new m(t);return a._formatted=t.external??null,a._fsPath=t._sep===c?t.fsPath??null:null,a}}else return t}}e.URI=f;function g(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}e.$vc=g;const c=A.$c?1:void 0;class m extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(t=!1){return t?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=c),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(r,t,a){let b,C=-1;for(let L=0;L<r.length;L++){const k=r.charCodeAt(L);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||t&&k===47||a&&k===91||a&&k===93||a&&k===58)C!==-1&&(b+=encodeURIComponent(r.substring(C,L)),C=-1),b!==void 0&&(b+=r.charAt(L));else{b===void 0&&(b=r.substr(0,L));const R=h[k];R!==void 0?(C!==-1&&(b+=encodeURIComponent(r.substring(C,L)),C=-1),b+=R):C===-1&&(C=L)}}return C!==-1&&(b+=encodeURIComponent(r.substring(C))),b!==void 0?b:r}function l(r){let t;for(let a=0;a<r.length;a++){const b=r.charCodeAt(a);b===35||b===63?(t===void 0&&(t=r.substr(0,a)),t+=h[b]):t!==void 0&&(t+=r[a])}return t!==void 0?t:r}function $(r,t){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,A.$c&&(a=a.replace(/\//g,"\\")),a}e.$wc=$;function u(r,t){const a=t?l:d;let b="",{scheme:C,authority:L,path:k,query:R,fragment:N}=r;if(C&&(b+=C,b+=":"),(L||C==="file")&&(b+=E,b+=E),L){let Y=L.indexOf("@");if(Y!==-1){const ee=L.substr(0,Y);L=L.substr(Y+1),Y=ee.lastIndexOf(":"),Y===-1?b+=a(ee,!1,!1):(b+=a(ee.substr(0,Y),!1,!1),b+=":",b+=a(ee.substr(Y+1),!1,!0)),b+="@"}L=L.toLowerCase(),Y=L.lastIndexOf(":"),Y===-1?b+=a(L,!1,!0):(b+=a(L.substr(0,Y),!1,!0),b+=L.substr(Y))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const Y=k.charCodeAt(1);Y>=65&&Y<=90&&(k=`/${String.fromCharCode(Y+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const Y=k.charCodeAt(0);Y>=65&&Y<=90&&(k=`${String.fromCharCode(Y+32)}:${k.substr(2)}`)}b+=a(k,!0,!1)}return R&&(b+="?",b+=a(R,!1,!1)),N&&(b+="#",b+=t?N:d(N,!1,!1)),b}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(r){return r.match(i)?r.replace(i,t=>n(t)):r}}),define(we[151],ve([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$bq=e.$aq=e.$_p=void 0;function A(v){const I=v;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.$_p=A;function s(v){const I=[];let E;try{const w=JSON.parse(v.arguments),f=w[w.length-1];f&&f.__$stack&&(w.pop(),E=f.__$stack),I.push(...w)}catch{I.push("Unable to log remote console arguments",v.arguments)}return{args:I,stack:E}}e.$aq=s;function P(v){if(typeof v!="string")return P(s(v).stack);const I=v;if(I){const E=D(I),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(w&&w.length===4)return{uri:y.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$bq=P;function D(v){if(!v)return v;const I=v.indexOf(`
`);return I===-1?v:v.substring(0,I)}function S(v,I){const{args:E,stack:w}=s(v),f=typeof E[0]=="string"&&E.length===1;let g=D(w);g&&(g=`(${g.trim()})`);let c=[];if(typeof E[0]=="string"?g&&f?c=[`%c[${I}] %c${E[0]} %c${g}`,p("blue"),p(""),p("grey")]:c=[`%c[${I}] %c${E[0]}`,p("blue"),p(""),...E.slice(1)]:c=[`%c[${I}]%`,p("blue"),...E],g&&!f&&c.push(g),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,c)}e.log=S;function p(v){return`color: ${v}`}}),define(we[50],ve([1,0,15,3]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function s(p){return JSON.stringify(p,D)}e.$wh=s;function P(p){let v=JSON.parse(p);return v=S(v),v}e.$xh=P;function D(p,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:v.flags}:v}function S(p,v=0){if(!p||v>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return A.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof y.$ge||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let I=0;I<p.length;++I)p[I]=S(p[I],v+1);else for(const I in p)Object.hasOwnProperty.call(p,I)&&(p[I]=S(p[I],v+1))}return p}e.$yh=S}),define(we[12],ve([1,0,11,4,17,3]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var D;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function S(w,f){return P.URI.isUri(w)?(0,s.$8e)(w.scheme,f):(0,s.$9e)(w,f+":")}e.$ag=S;function p(w,...f){return f.some(g=>S(w,g))}e.$bg=p,e.$cg="vscode-tkn",e.$dg="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f){this.f=`${f}/${D.vscodeRemoteResource}`}set(f,g,c){this.a[f]=g,this.b[f]=c}setConnectionToken(f,g){this.c[f]=g}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(l){return y.$1(l),f}const g=f.authority;let c=this.a[g];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const m=this.b[g],h=this.c[g];let d=`path=${encodeURIComponent(f.path)}`;return typeof h=="string"&&(d+=`&${e.$dg}=${encodeURIComponent(h)}`),P.URI.from({scheme:A.$i?this.d:D.vscodeRemoteResource,authority:`${c}:${m}`,path:A.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:d})}}e.$eg=new v,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class I{asBrowserUri(f){const g=this.b(f,he);return this.uriToBrowserUri(g)}uriToBrowserUri(f){return f.scheme===D.vscodeRemote?e.$eg.rewrite(f):f.scheme===D.file&&(A.$g||A.$k===`${D.vscodeFileResource}://${I.a}`)?f.with({scheme:D.vscodeFileResource,authority:f.authority||I.a,query:null,fragment:null}):f}asFileUri(f){const g=this.b(f,he);return this.uriToFileUri(g)}uriToFileUri(f){return f.scheme===D.vscodeFileResource?f.with({scheme:D.file,authority:f.authority!==I.a?f.authority:null,query:null,fragment:null}):f}b(f,g){return P.URI.isUri(f)?f:P.URI.parse(g.toUrl(f))}}I.a=e.$jg,e.$kg=new I;var E;(function(w){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(f.get("3"));const g="vscode-coi";function c(h){let d;typeof h=="string"?d=new URL(h).searchParams:h instanceof URL?d=h.searchParams:P.URI.isUri(h)&&(d=new URL(h.toString(!0)).searchParams);const l=d?.get(g);if(l)return f.get(l)}w.getHeadersFromQuery=c;function m(h,d,l){if(!globalThis.crossOriginIsolated)return;const $=d&&l?"3":l?"2":"1";h instanceof URLSearchParams?h.set(g,$):h[g]=$}w.addSearchParam=m})(E||(e.COI=E={}))}),define(we[152],ve([1,0,96,12,4,3]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=void 0;class D{constructor(w,f,g){this.id=w,this.dependencies=f,this.callback=g}}class S{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,f,g)=>{typeof w!="string"&&(g=f,f=w,w=null),(typeof f!="object"||!Array.isArray(f))&&(g=f,f=null),this.c.push(new D(w,f,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const f=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!f)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(w){return new Promise((f,g)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",h),c.removeEventListener("error",d)},h=l=>{m(),f(this.c.pop())},d=l=>{m(),g(l)};c.addEventListener("load",h),c.addEventListener("error",d),this.f&&(w=this.f.createScriptURL(w)),c.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(w){return new Promise((f,g)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),f(this.c.pop())}catch(c){g(c)}})}async j(w){try{const f=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=P.URI.parse(w).fsPath,h=f.readFileSync(m).toString(),d=c.wrap(h.replace(/^#!.*/,""));return new g.Script(d).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}S.INSTANCE=new S;const p=new Map;let v={};typeof globalThis.require=="object"&&(v=globalThis.require.paths??{});async function I(E,w,f){if(y.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),v[E]&&(E=v[E]);const g=`${E}/${w}`;if(p.has(g))return p.get(g);let c;if(/^\w[\w\d+.-]*:\/\//.test(g))c=g;else{const l=`${f&&!s.$i?A.$hg:A.$gg}/${g}`;c=A.$kg.asBrowserUri(l).toString(!0)}const m=S.INSTANCE.load(c);return p.set(g,m),m}else return await new Promise((g,c)=>{he([E],g,c)})}e.$ZC=I}),define(we[19],ve([1,0,39,12,7,4,17,3]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function p(f){return(0,S.$wc)(f,!0)}e.$rg=p;class v{constructor(g){this.a=g}compare(g,c,m=!1){return g===c?0:(0,D.$1e)(this.getComparisonKey(g,m),this.getComparisonKey(c,m))}isEqual(g,c,m=!1){return g===c?!0:!g||!c?!1:this.getComparisonKey(g,m)===this.getComparisonKey(c,m)}getComparisonKey(g,c=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,c,m=!1){if(g.scheme===c.scheme){if(g.scheme===A.Schemas.file)return y.$4f(p(g),p(c),this.a(g))&&g.query===c.query&&(m||g.fragment===c.fragment);if((0,e.$Ig)(g.authority,c.authority))return y.$4f(g.path,c.path,this.a(g),"/")&&g.query===c.query&&(m||g.fragment===c.fragment)}return!1}joinPath(g,...c){return S.URI.joinPath(g,...c)}basenameOrAuthority(g){return(0,e.$Ag)(g)||g.authority}basename(g){return s.$gc.basename(g.path)}extname(g){return s.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let c;return g.scheme===A.Schemas.file?c=S.URI.file(s.$mc(p(g))).path:(c=s.$gc.dirname(g.path),g.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),c="/")),g.with({path:c})}normalizePath(g){if(!g.path.length)return g;let c;return g.scheme===A.Schemas.file?c=S.URI.file(s.$hc(p(g))).path:c=s.$gc.normalize(g.path),g.with({path:c})}relativePath(g,c){if(g.scheme!==c.scheme||!(0,e.$Ig)(g.authority,c.authority))return;if(g.scheme===A.Schemas.file){const d=s.$lc(p(g),p(c));return P.$c?y.$Xf(d):d}let m=g.path||"/";const h=c.path||"/";if(this.a(g)){let d=0;for(const l=Math.min(m.length,h.length);d<l&&!(m.charCodeAt(d)!==h.charCodeAt(d)&&m.charAt(d).toLowerCase()!==h.charAt(d).toLowerCase());d++);m=h.substr(0,d)+m.substr(d)}return s.$gc.relative(m,h)}resolvePath(g,c){if(g.scheme===A.Schemas.file){const m=S.URI.file(s.$kc(p(g),c));return g.with({authority:m.authority,path:m.path})}return c=y.$Yf(c),g.with({path:s.$gc.resolve(g.path,c)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,c){return g===c||g!==void 0&&c!==void 0&&(0,D.$8e)(g,c)}hasTrailingPathSeparator(g,c=s.sep){if(g.scheme===A.Schemas.file){const m=p(g);return m.length>y.$Zf(m).length&&m[m.length-1]===c}else{const m=g.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,c=s.sep){return(0,e.$Jg)(g,c)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,c=s.sep){let m=!1;if(g.scheme===A.Schemas.file){const h=p(g);m=h!==void 0&&h.length===y.$Zf(h).length&&h[h.length-1]===c}else{c="/";const h=g.path;m=h.length===1&&h.charCodeAt(h.length-1)===47}return!m&&!(0,e.$Jg)(g,c)?g.with({path:g.path+"/"}):g}}e.$sg=v,e.$tg=new v(()=>!1),e.$ug=new v(f=>f.scheme===A.Schemas.file?!P.$e:!0),e.$vg=new v(f=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function I(f,g){const c=[];for(let m=0;m<f.length;m++){const h=g(f[m]);f.some((d,l)=>l===m?!1:(0,e.$xg)(h,g(d)))||c.push(f[m])}return c}e.$Mg=I;var E;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function g(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(l=>{const[$,u]=l.split(":");$&&u&&m.set($,u)});const d=c.path.substring(0,c.path.indexOf(";"));return d&&m.set(f.META_DATA_MIME,d),m}f.parseMetaData=g})(E||(e.DataUri=E={}));function w(f,g,c){if(g){let m=f.path;return m&&m[0]!==s.$gc.sep&&(m=s.$gc.sep+m),f.with({scheme:c,authority:g,path:m})}return f.with({scheme:c})}e.$Ng=w}),define(we[14],ve([1,0,20,11,5,2,19,4,149,59]),function(he,e,y,A,s,P,D,S,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function I(z){return!!z&&typeof z.then=="function"}e.$Og=I;function E(z){const q=new y.$3d,M=z(q.token),H=new Promise((_,ae)=>{const fe=q.token.onCancellationRequested(()=>{fe.dispose(),q.dispose(),ae(new A.$5)});Promise.resolve(M).then(le=>{fe.dispose(),q.dispose(),_(le)},le=>{fe.dispose(),q.dispose(),ae(le)})});return new class{cancel(){q.cancel()}then(_,ae){return H.then(_,ae)}catch(_){return this.then(void 0,_)}finally(_){return H.finally(_)}}}e.$Pg=E;function w(z,q,M){return new Promise((H,_)=>{const ae=q.onCancellationRequested(()=>{ae.dispose(),H(M)});z.then(H,_).finally(()=>ae.dispose())})}e.$Qg=w;function f(z,q){return new Promise((M,H)=>{const _=q.onCancellationRequested(()=>{_.dispose(),H(new A.$5)});z.then(M,H).finally(()=>_.dispose())})}e.$Rg=f;async function g(z){let q=-1;const M=z.map((H,_)=>H.then(ae=>(q=_,ae)));try{return await Promise.race(M)}finally{z.forEach((H,_)=>{_!==q&&H.cancel()})}}e.$Sg=g;function c(z,q,M){let H;const _=setTimeout(()=>{H?.(void 0),M?.()},q);return Promise.race([z.finally(()=>clearTimeout(_)),new Promise(ae=>H=ae)])}e.$Tg=c;function m(z){return new Promise((q,M)=>{const H=z();I(H)?H.then(q,M):q(H)})}e.$Ug=m;class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const M=()=>{if(this.b=null,this.f)return;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(M,M).then(H)})}return new Promise((M,H)=>{this.b.then(M,H)})}return this.a=q(),new Promise((M,H)=>{this.a.then(_=>{this.a=null,M(_)},_=>{this.a=null,H(_)})})}dispose(){this.f=!0}}e.$Vg=h;class d{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Wg=d;class l{constructor(){this.a=new Map}queue(q,M){const _=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(q)===_&&this.a.delete(q)});return this.a.set(q,_),_}}e.$Xg=l;const $=(z,q)=>{let M=!0;const H=setTimeout(()=>{M=!1,q()},z);return{isTriggered:()=>M,dispose:()=>{clearTimeout(H),M=!1}}},u=z=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,z())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class n{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,M=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((_,ae)=>{this.d=_,this.f=ae}).then(()=>{if(this.b=null,this.d=null,this.g){const _=this.g;return this.g=null,_()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=M===p.$Pd?u(H):$(M,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=n;class i{constructor(q){this.a=new n(q),this.b=new h}trigger(q,M){return this.a.trigger(()=>this.b.queue(q),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=i;class o{constructor(){this.a=!1,this.b=new Promise((q,M)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=o;class r extends o{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$2g=r;function t(z,q){return q?new Promise((M,H)=>{const _=setTimeout(()=>{ae.dispose(),M()},z),ae=q.onCancellationRequested(()=>{clearTimeout(_),ae.dispose(),H(new A.$5)})}):E(M=>t(z,M))}e.$3g=t;function a(z,q=0,M){const H=setTimeout(()=>{z(),M&&_.dispose()},q),_=(0,P.$Qc)(()=>{clearTimeout(H),M?.deleteAndLeak(_)});return M?.add(_),_}e.$4g=a;function b(z){const q=[];let M=0;const H=z.length;function _(){return M<H?z[M++]():null}function ae(fe){fe!=null&&q.push(fe);const le=_();return le?le.then(ae):Promise.resolve(q)}return Promise.resolve(null).then(ae)}e.$5g=b;function C(z,q=H=>!!H,M=null){let H=0;const _=z.length,ae=()=>{if(H>=_)return Promise.resolve(M);const fe=z[H++];return Promise.resolve(fe()).then($e=>q($e)?Promise.resolve($e):ae())};return ae()}e.$6g=C;function L(z,q=H=>!!H,M=null){if(z.length===0)return Promise.resolve(M);let H=z.length;const _=()=>{H=-1;for(const ae of z)ae.cancel?.()};return new Promise((ae,fe)=>{for(const le of z)le.then($e=>{--H>=0&&q($e)?(_(),ae($e)):H===0&&ae(M)}).catch($e=>{--H>=0&&(_(),fe($e))})})}e.$7g=L;class k{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new s.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((M,H)=>{this.f.push({factory:q,c:M,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const M=q.factory();M.then(q.c,q.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=k;class R extends k{constructor(){super(1)}}e.$9g=R;class N{constructor(){this.a=new V,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$0g=N;class Y{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new se;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,M=D.$tg){const H=M.getComparisonKey(q);let _=this.a.get(H);if(!_){_=new R;const ae=this.f++,fe=s.Event.once(_.onDrained)(()=>{_?.dispose(),this.a.delete(H),this.h(),this.d?.deleteAndDispose(ae),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$2c),this.d.set(ae,fe),this.a.set(H,_)}return _}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=Y;class ee{constructor(q,M){this.a=-1,typeof q=="function"&&typeof M=="number"&&this.setIfNotSet(q,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},M)}setIfNotSet(q,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},M))}}e.$_g=ee;class G{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(q,M,H=globalThis){this.cancel();const _=H.setInterval(()=>{q()},M);this.d=(0,P.$Qc)(()=>{H.clearInterval(_),this.d=void 0})}dispose(){this.cancel()}}e.$ah=G;class ne{constructor(q,M){this.b=-1,this.a=q,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=ne;class Z{constructor(q,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=q,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=Z;class T extends ne{constructor(q,M){super(q,M),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$dh=T;class oe extends P.$Sc{constructor(q,M){super(),this.g=q,this.h=M,this.a=[],this.b=this.B(new P.$Tc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of q)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(z,q)=>{(0,S.$v)(()=>{if(M)return;const H=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,H-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.$gh=(z,q,M)=>{const H=z.requestIdleCallback(q,typeof M=="number"?{timeout:M}:void 0);let _=!1;return{dispose(){_||(_=!0,z.cancelIdleCallback(H))}}},e.$fh=z=>(0,e.$gh)(globalThis,z)}();class Q{constructor(q,M){this.g=!1,this.d=()=>{try{this.j=M()}catch(H){this.l=H}finally{this.g=!0}},this.f=(0,e.$gh)(q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=Q;class te extends Q{constructor(q){super(globalThis,q)}}e.$ih=te;async function J(z,q,M){let H;for(let _=0;_<M;_++)try{return await z()}catch(ae){H=ae,await t(q)}throw H}e.$jh=J;class V{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,M,H){return this.a={taskId:q,cancel:()=>H?.(),promise:M},M.then(()=>this.d(q),()=>this.d(q)),M}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let M,H;const _=new Promise((ae,fe)=>{M=ae,H=fe});this.b={run:q,promise:_,promiseResolve:M,promiseReject:H}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=V;class ie{constructor(q,M=()=>Date.now()){this.d=q,this.f=M,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$lh=ie;var ue;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(ue||(ue={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,M)=>{this.a=q,this.b=M})}complete(q){return new Promise(M=>{this.a(q),this.d={outcome:0,value:q},M()})}error(q){return new Promise(M=>{this.b(q),this.d={outcome:1,value:q},M()})}cancel(){return this.error(new A.$5)}}e.$mh=se;var me;(function(z){async function q(H){let _;const ae=await Promise.all(H.map(fe=>fe.then(le=>le,le=>{_||(_=le)})));if(typeof _<"u")throw _;return ae}z.settled=q;function M(H){return new Promise(async(_,ae)=>{try{await H(_,ae)}catch(fe){ae(fe)}})}z.withAsyncBody=M})(me||(e.Promises=me={}));class B{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=q.then(M=>(this.a=M,this.d=!0,M),M=>{throw this.b=M,this.d=!0,M})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=B;class W{constructor(q){this.b=q,this.a=new v.$V(()=>new B(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=W;var O;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(O||(O={}));class j{static fromArray(q){return new j(M=>{M.emitMany(q)})}static fromPromise(q){return new j(async M=>{M.emitMany(await q)})}static fromPromises(q){return new j(async M=>{await Promise.all(q.map(async H=>M.emitOne(await H)))})}static merge(q){return new j(async M=>{await Promise.all(q.map(async H=>{for await(const _ of H)M.emitOne(_)}))})}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new s.$Sd,queueMicrotask(async()=>{const M={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(q(M)),this.j()}catch(H){this.k(H)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(q,M){return new j(async H=>{for await(const _ of q)H.emitOne(M(_))})}map(q){return j.map(this,q)}static filter(q,M){return new j(async H=>{for await(const _ of q)M(_)&&H.emitOne(_)})}filter(q){return j.filter(this,q)}static coalesce(q){return j.filter(q,M=>!!M)}coalesce(){return j.coalesce(this)}static async toPromise(q){const M=[];for await(const H of q)M.push(H);return M}toPromise(){return j.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$ph=j,j.EMPTY=j.fromArray([]);class re extends j{constructor(q,M){super(M),this.l=q}cancel(){this.l.cancel()}}e.$qh=re;function X(z){const q=new y.$3d,M=z(q.token);return new re(q,async H=>{const _=q.token.onCancellationRequested(()=>{_.dispose(),q.dispose(),H.reject(new A.$5)});try{for await(const ae of M){if(q.token.isCancellationRequested)return;H.emitOne(ae)}_.dispose(),q.dispose()}catch(ae){_.dispose(),q.dispose(),H.reject(ae)}})}e.$rh=X;class x{constructor(){this.a=new se,this.b=new j(H=>{if(q){H.reject(q);return}return M&&H.emitMany(M),this.d=_=>H.reject(_),this.f=_=>H.emitOne(_),this.a.p});let q,M;this.f=H=>{M||(M=[]),M.push(H)},this.d=H=>{q||(q=H)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(q){this.d(q),this.a.complete()}emitOne(q){this.f(q)}}e.$sh=x}),define(we[77],ve([1,0,18,14,39,26,7,4,17]),function(he,e,y,A,s,P,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function v(){return Object.create(null)}e.$Dj=v,e.$Ej="**",e.$Fj="/";const I="[/\\\\]",E="[^/\\\\]",w=/\//g;function f(te,J){switch(te){case 0:return"";case 1:return`${E}*?`;default:return`(?:${I}|${E}+${I}${J?`|${I}${E}+`:""})*?`}}function g(te,J){if(!te)return[];const V=[];let ie=!1,ue=!1,se="";for(const me of te){switch(me){case J:if(!ie&&!ue){V.push(se),se="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}se+=me}return se&&V.push(se),V}e.$Gj=g;function c(te){if(!te)return"";let J="";const V=g(te,e.$Fj);if(V.every(ie=>ie===e.$Ej))J=".*";else{let ie=!1;V.forEach((ue,se)=>{if(ue===e.$Ej){if(ie)return;J+=f(2,se===V.length-1)}else{let me=!1,B="",W=!1,O="";for(const j of ue){if(j!=="}"&&me){B+=j;continue}if(W&&(j!=="]"||!O)){let re;j==="-"?re=j:(j==="^"||j==="!")&&!O?re="^":j===e.$Fj?re="":re=(0,p.$Ke)(j),O+=re;continue}switch(j){case"{":me=!0;continue;case"[":W=!0;continue;case"}":{const X=`(?:${g(B,",").map(x=>c(x)).join("|")})`;J+=X,me=!1,B="";break}case"]":{J+="["+O+"]",W=!1,O="";break}case"?":J+=E;continue;case"*":J+=f(1);continue;default:J+=(0,p.$Ke)(j)}}se<V.length-1&&(V[se+1]!==e.$Ej||se+2<V.length)&&(J+=I)}ie=ue===e.$Ej})}return J}const m=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,$=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new P.$Dc(1e4),i=function(){return!1},o=function(){return null};function r(te,J){if(!te)return o;let V;typeof te!="string"?V=te.pattern:V=te,V=V.trim();const ie=`${V}_${!!J.trimForExclusions}`;let ue=n.get(ie);if(ue)return t(ue,te);let se;return m.test(V)?ue=b(V.substr(4),V):(se=h.exec(a(V,J)))?ue=C(se[1],V):(J.trimForExclusions?l:d).test(V)?ue=L(V,J):(se=$.exec(a(V,J)))?ue=k(se[1].substr(1),V,!0):(se=u.exec(a(V,J)))?ue=k(se[1],V,!1):ue=R(V),n.set(ie,ue),t(ue,te)}function t(te,J){if(typeof J=="string")return te;const V=function(ie,ue){return(0,s.$4f)(ie,J.base,!S.$e)?te((0,p.$Pe)(ie.substr(J.base.length),D.sep),ue):null};return V.allBasenames=te.allBasenames,V.allPaths=te.allPaths,V.basenames=te.basenames,V.patterns=te.patterns,V}function a(te,J){return J.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function b(te,J){return function(V,ie){return typeof V=="string"&&V.endsWith(te)?J:null}}function C(te,J){const V=`/${te}`,ie=`\\${te}`,ue=function(me,B){return typeof me!="string"?null:B?B===te?J:null:me===te||me.endsWith(V)||me.endsWith(ie)?J:null},se=[te];return ue.basenames=se,ue.patterns=[J],ue.allBasenames=se,ue}function L(te,J){const V=oe(te.slice(1,-1).split(",").map(B=>r(B,J)).filter(B=>B!==o),te),ie=V.length;if(!ie)return o;if(ie===1)return V[0];const ue=function(B,W){for(let O=0,j=V.length;O<j;O++)if(V[O](B,W))return te;return null},se=V.find(B=>!!B.allBasenames);se&&(ue.allBasenames=se.allBasenames);const me=V.reduce((B,W)=>W.allPaths?B.concat(W.allPaths):B,[]);return me.length&&(ue.allPaths=me),ue}function k(te,J,V){const ie=D.sep===D.$gc.sep,ue=ie?te:te.replace(w,D.sep),se=D.sep+ue,me=D.$gc.sep+te;let B;return V?B=function(W,O){return typeof W=="string"&&(W===ue||W.endsWith(se)||!ie&&(W===te||W.endsWith(me)))?J:null}:B=function(W,O){return typeof W=="string"&&(W===ue||!ie&&W===te)?J:null},B.allPaths=[(V?"*/":"./")+te],B}function R(te){try{const J=new RegExp(`^${c(te)}$`);return function(V){return J.lastIndex=0,typeof V=="string"&&J.test(V)?te:null}}catch{return o}}function N(te,J,V){return!te||typeof J!="string"?!1:Y(te)(J,void 0,V)}e.$Hj=N;function Y(te,J={}){if(!te)return i;if(typeof te=="string"||ee(te)){const V=r(te,J);if(V===o)return i;const ie=function(ue,se){return!!V(ue,se)};return V.allBasenames&&(ie.allBasenames=V.allBasenames),V.allPaths&&(ie.allPaths=V.allPaths),ie}return Z(te,J)}e.$Ij=Y;function ee(te){const J=te;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$Jj=ee;function G(te){return te.allBasenames||[]}e.$Kj=G;function ne(te){return te.allPaths||[]}e.$Lj=ne;function Z(te,J){const V=oe(Object.getOwnPropertyNames(te).map(B=>T(B,te[B],J)).filter(B=>B!==o)),ie=V.length;if(!ie)return o;if(!V.some(B=>!!B.requiresSiblings)){if(ie===1)return V[0];const B=function(j,re){let X;for(let x=0,z=V.length;x<z;x++){const q=V[x](j,re);if(typeof q=="string")return q;(0,A.$Og)(q)&&(X||(X=[]),X.push(q))}return X?(async()=>{for(const x of X){const z=await x;if(typeof z=="string")return z}return null})():null},W=V.find(j=>!!j.allBasenames);W&&(B.allBasenames=W.allBasenames);const O=V.reduce((j,re)=>re.allPaths?j.concat(re.allPaths):j,[]);return O.length&&(B.allPaths=O),B}const ue=function(B,W,O){let j,re;for(let X=0,x=V.length;X<x;X++){const z=V[X];z.requiresSiblings&&O&&(W||(W=(0,D.$nc)(B)),j||(j=W.substr(0,W.length-(0,D.$oc)(B).length)));const q=z(B,W,j,O);if(typeof q=="string")return q;(0,A.$Og)(q)&&(re||(re=[]),re.push(q))}return re?(async()=>{for(const X of re){const x=await X;if(typeof x=="string")return x}return null})():null},se=V.find(B=>!!B.allBasenames);se&&(ue.allBasenames=se.allBasenames);const me=V.reduce((B,W)=>W.allPaths?B.concat(W.allPaths):B,[]);return me.length&&(ue.allPaths=me),ue}function T(te,J,V){if(J===!1)return o;const ie=r(te,V);if(ie===o)return o;if(typeof J=="boolean")return ie;if(J){const ue=J.when;if(typeof ue=="string"){const se=(me,B,W,O)=>{if(!O||!ie(me,B))return null;const j=ue.replace("$(basename)",()=>W),re=O(j);return(0,A.$Og)(re)?re.then(X=>X?te:null):re?te:null};return se.requiresSiblings=!0,se}}return ie}function oe(te,J){const V=te.filter(B=>!!B.basenames);if(V.length<2)return te;const ie=V.reduce((B,W)=>{const O=W.basenames;return O?B.concat(O):B},[]);let ue;if(J){ue=[];for(let B=0,W=ie.length;B<W;B++)ue.push(J)}else ue=V.reduce((B,W)=>{const O=W.patterns;return O?B.concat(O):B},[]);const se=function(B,W){if(typeof B!="string")return null;if(!W){let j;for(j=B.length;j>0;j--){const re=B.charCodeAt(j-1);if(re===47||re===92)break}W=B.substr(j)}const O=ie.indexOf(W);return O!==-1?ue[O]:null};se.basenames=ie,se.patterns=ue,se.allBasenames=ie;const me=te.filter(B=>!B.basenames);return me.push(se),me}function Q(te,J){return(0,y.$ub)(te,J,(V,ie)=>typeof V=="string"&&typeof ie=="string"?V===ie:typeof V!="string"&&typeof ie!="string"?V.base===ie.base&&V.pattern===ie.pattern:!1)}e.$Mj=Q}),define(we[101],ve([1,0,11,150,19,17,3]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(S||(e.MarkdownStringTextNewlineStyle=S={}));class p{constructor(h="",d=!1){if(this.value=h,typeof this.value!="string")throw(0,y.$7)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(h,d=0){return this.value+=w(this.supportThemeIcons?(0,A.$0j)(h):h).replace(/([ \t]+)/g,(l,$)=>"&nbsp;".repeat($.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,d){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(h,d,l){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(h),")"),l&&(this.value+=` "${this.c(this.c(l,'"'),")")}"`),this.value+=")",this}c(h,d){const l=new RegExp((0,P.$Ke)(d),"g");return h.replace(l,($,u)=>h.charAt(u-1)!=="\\"?`\\${$}`:$)}}e.$dk=p;function v(m){return I(m)?!m.value:Array.isArray(m)?m.every(v):!0}e.$ek=v;function I(m){return m instanceof p?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||typeof m.isTrusted=="object"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.$fk=I;function E(m,h){return m===h?!0:!m||!h?!1:m.value===h.value&&m.isTrusted===h.isTrusted&&m.supportThemeIcons===h.supportThemeIcons&&m.supportHtml===h.supportHtml&&(m.baseUri===h.baseUri||!!m.baseUri&&!!h.baseUri&&(0,s.$wg)(D.URI.from(m.baseUri),D.URI.from(h.baseUri)))}e.$gk=E;function w(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$hk=w;function f(m){return m.replace(/"/g,"&quot;")}e.$ik=f;function g(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$jk=g;function c(m){const h=[],d=m.split("|").map($=>$.trim());m=d[0];const l=d[1];if(l){const $=/height=(\d+)/.exec(l),u=/width=(\d+)/.exec(l),n=$?$[1]:"",i=u?u[1]:"",o=isFinite(parseInt(i)),r=isFinite(parseInt(n));o&&h.push(`width="${i}"`),r&&h.push(`height="${n}"`)}return{href:m,dimensions:h}}e.$kk=c}),define(we[153],ve([1,0,18,39,7,4,19,17]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=void 0;function p(r,t){const{os:a,tildify:b,relative:C}=t;if(C){const R=v(r,C,a);if(typeof R=="string")return R}let L=r.fsPath;if(a===1&&!P.$c?L=L.replace(/\//g,"\\"):a!==1&&P.$c&&(L=L.replace(/\\/g,"/")),a!==1&&b?.userHome){const R=b.userHome.fsPath;let N;r.scheme!==b.userHome.scheme&&r.path[0]===s.$gc.sep&&r.path[1]!==s.$gc.sep?N=b.userHome.with({path:r.path}).fsPath:N=L,L=w(N,R,a)}return(a===1?s.$fc:s.$gc).normalize(I(L,a===1))}e.$Hv=p;function v(r,t,a){const b=a===1?s.$fc:s.$gc,C=a===3?D.$tg:D.$vg,L=t.getWorkspace(),k=(0,y.$Ob)(L.folders);if(!k)return;r.scheme!==k.uri.scheme&&r.path[0]===s.$gc.sep&&r.path[1]!==s.$gc.sep&&(r=k.uri.with({path:r.path}));const R=t.getWorkspaceFolder(r);if(!R)return;let N;if(C.isEqual(R.uri,r)?N="":N=C.relativePath(R.uri,r)??"",N&&(N=b.normalize(N)),L.folders.length>1&&!t.noPrefix){const Y=R.name?R.name:C.basenameOrAuthority(R.uri);N=N?`${Y} \u2022 ${N}`:Y}return N}function I(r,t=P.$c){return(0,A.$8f)(r,t)?r.charAt(0).toUpperCase()+r.slice(1):r}e.$Iv=I;let E=Object.create(null);function w(r,t,a=P.OS){if(a===1||!r||!t)return r;let b=E.original===t?E.normalized:void 0;b||(b=t,P.$c&&(b=(0,A.$Xf)(b)),b=`${(0,S.$Qe)(b,s.$gc.sep)}${s.$gc.sep}`,E={original:t,normalized:b});let C=r;return P.$c&&(C=(0,A.$Xf)(C)),(a===3?C.startsWith(b):(0,S.$9e)(C,b))?`~/${C.substr(b.length)}`:r}e.$Jv=w;function f(r,t){return r.replace(/^~($|\/|\\)/,`${t}$1`)}e.$Kv=f;const g="\u2026",c="\\\\",m="~";function h(r,t=s.sep){const a=new Array(r.length);let b=!1;for(let C=0;C<r.length;C++){const L=r[C];if(L===""){a[C]=`.${t}`;continue}if(!L){a[C]=L;continue}b=!0;let k="",R=L;R.indexOf(c)===0?(k=R.substr(0,R.indexOf(c)+c.length),R=R.substr(R.indexOf(c)+c.length)):R.indexOf(t)===0?(k=R.substr(0,R.indexOf(t)+t.length),R=R.substr(R.indexOf(t)+t.length)):R.indexOf(m)===0&&(k=R.substr(0,R.indexOf(m)+m.length),R=R.substr(R.indexOf(m)+m.length));const N=R.split(t);for(let Y=1;b&&Y<=N.length;Y++)for(let ee=N.length-Y;b&&ee>=0;ee--){b=!1;let G=N.slice(ee,ee+Y).join(t);for(let ne=0;!b&&ne<r.length;ne++)if(ne!==C&&r[ne]&&r[ne].indexOf(G)>-1){const Z=ee+Y===N.length,T=ee>0&&r[ne].indexOf(t)>-1?t+G:G,oe=r[ne].endsWith(T);b=!Z||oe}if(!b){let ne="";(N[0].endsWith(":")||k!=="")&&(ee===1&&(ee=0,Y++,G=N[0]+t+G),ee>0&&(ne=N[0]+t),ne=k+ne),ee>0&&(ne=ne+g+t),ne=ne+G,ee+Y<N.length&&(ne=ne+t+g),a[C]=ne}}b&&(a[C]=L)}return a}e.$Lv=h;var d;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function l(r,t=Object.create(null)){const a=[];let b=!1,C="";for(const L of r)if(L==="$"||b&&L==="{")C&&a.push({value:C,type:d.TEXT}),C="",b=!0;else if(L==="}"&&b){const k=t[C];if(typeof k=="string")k.length&&a.push({value:k,type:d.VARIABLE});else if(k){const R=a[a.length-1];(!R||R.type!==d.SEPARATOR)&&a.push({value:k.label,type:d.SEPARATOR})}C="",b=!1}else C+=L;return C&&!b&&a.push({value:C,type:d.TEXT}),a.filter((L,k)=>{if(L.type===d.SEPARATOR){const R=a[k-1],N=a[k+1];return[R,N].every(Y=>Y&&(Y.type===d.VARIABLE||Y.type===d.TEXT)&&Y.value.length>0)}return!0}).map(L=>L.value).join("")}e.$Mv=l;function $(r,t){return P.$d||t?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$d?"&":"&&"):r.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$Nv=$;function u(r,t){return P.$d||t?r.replace(/\(&&\w\)|&&/g,""):P.$c?r.replace(/&&|&/g,a=>a==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.$Ov=u;function n(r){return r.replace(/&/g,"&&")}e.$Pv=n;function i(r){if(r.endsWith("]")){const t=r.lastIndexOf(" [",r.length-2);if(t!==-1){const a=o(r.substring(0,t));return{name:a.name,parentPath:a.parentPath+r.substring(t)}}}return o(r)}e.$Qv=i;function o(r){const t=r.indexOf("/")!==-1?s.$gc:s.$fc,a=t.basename(r),b=t.dirname(r);return a.length?{name:a,parentPath:b}:{name:b,parentPath:""}}}),define(we[51],ve([1,0,15,3]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=void 0;function s(E){return E.toJSON()}class P{constructor(w){this.a=w}transformIncoming(w){const f=this.a.transformIncoming(w);return f===w?w:s(A.URI.from(f))}transformOutgoing(w){const f=this.a.transformOutgoing(w);return f===w?w:s(A.URI.from(f))}transformOutgoingURI(w){const f=this.a.transformOutgoing(w);return f===w?w:A.URI.from(f)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Zm=P,e.$1m=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function D(E,w,f){if(!E||f>200)return null;if(typeof E=="object"){if(E instanceof A.URI)return w.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const c=D(E[g],w,f+1);c!==null&&(E[g]=c)}}return null}function S(E,w){const f=D(E,w,0);return f===null?E:f}e.$2m=S;function p(E,w,f,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return f?A.URI.revive(w.transformIncoming(E)):w.transformIncoming(E);if(E instanceof y.$ge)return null;for(const c in E)if(Object.hasOwnProperty.call(E,c)){const m=p(E[c],w,f,g+1);m!==null&&(E[c]=m)}}return null}function v(E,w){const f=p(E,w,!1,0);return f===null?E:f}e.$3m=v;function I(E,w){const f=p(E,w,!0,0);return f===null?E:f}e.$4m=I}),define(we[21],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(s){return y.test(s)}e.$lg=A,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let p=0;p<S.length;p++)S[p]=Math.floor(Math.random()*256);return S};const P=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){s(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let p=0,v="";return v+=D[P[p++]],v+=D[P[p++]],v+=D[P[p++]],v+=D[P[p++]],v+="-",v+=D[P[p++]],v+=D[P[p++]],v+="-",v+=D[P[p++]],v+=D[P[p++]],v+="-",v+=D[P[p++]],v+=D[P[p++]],v+="-",v+=D[P[p++]],v+=D[P[p++]],v+=D[P[p++]],v+=D[P[p++]],v+=D[P[p++]],v+=D[P[p++]],v}}()}),define(we[154],ve([1,0,18,47,21]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.$at=void 0;function P(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.$at=P;function D(E,w,f){const g={id:(0,s.$mg)(),name:E,uri:w,data:f};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.$bt=D;class S{constructor(){this.a=new Map}get size(){let w=0;for(const f of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const f=[...this.a.keys()];return A.Iterable.some(this,([g,c])=>c.asFile())&&f.push("files"),I(p(w),f)}get(w){return this.a.get(this.b(w))?.[0]}append(w,f){const g=this.a.get(w);g?g.push(f):this.a.set(this.b(w),[f])}replace(w,f){this.a.set(this.b(w),[f])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,f]of this.a)for(const g of f)yield[w,g]}b(w){return p(w)}}e.$ct=S;function p(E){return E.toLowerCase()}function v(E,w){return I(p(E),w.map(p))}e.$dt=v;function I(E,w){if(E==="*/*")return w.length>0;if(w.includes(E))return!0;const f=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!f)return!1;const[g,c,m]=f;return m==="*"?w.some(h=>h.startsWith(c+"/")):!1}e.$et=Object.freeze({create:E=>(0,y.$Mb)(E.map(w=>w.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$et.split(E).filter(w=>!w.startsWith("#"))})}),function(){"use strict";function he(e,y,A){function s(f){return new Promise(g=>y.exists(f,g))}function P(f){return new Promise((g,c)=>{const m=new Date;y.utimes(f,m,m,h=>h?c(h):g())})}function D(f){return new Promise((g,c)=>y.mkdir(f,{recursive:!0},m=>m&&m.code!=="EEXIST"?c(m):g(f)))}function S(f){return new Promise((g,c)=>y.rm(f,{recursive:!0,force:!0,maxRetries:3},m=>m?c(m):g()))}function p(f){return new Promise((g,c)=>y.readFile(f,"utf8",(m,h)=>m?c(m):g(h)))}function v(f,g){return new Promise((c,m)=>y.writeFile(f,g,"utf8",h=>h?m(h):c()))}async function I(f){const g=e.join(f,"languagepacks.json");try{return JSON.parse(await p(g))}catch{}}function E(f,g){try{for(;g;){if(f[g])return g;{const c=g.lastIndexOf("-");if(c>0)g=g.substring(0,c);else return}}}catch(c){console.error("Resolving language pack configuration failed.",c)}}function w(f,g,c,m,h){const d=function($){return A.mark("code/didGenerateNls"),Promise.resolve({locale:$,osLocale:h,availableLanguages:{}})};if(A.mark("code/willGenerateNls"),m==="pseudo")return Promise.resolve({locale:m,osLocale:h,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:m,osLocale:h,availableLanguages:{}});if(m&&(m==="en"||m==="en-us"))return Promise.resolve({locale:m,osLocale:h,availableLanguages:{}});const l=m;try{return f?I(g).then($=>{if(!$)return d(l);const u=E($,m);if(!u)return d(l);m=u;const n=$[m];let i;return!n||typeof n.hash!="string"||!n.translations||typeof(i=n.translations.vscode)!="string"?d(l):s(i).then(o=>{if(!o)return d(l);const r=n.hash+"."+m,t=e.join(g,"clp",r),a=e.join(t,f),b=e.join(t,"tcf.json"),C=e.join(t,"corrupted.info"),L={locale:l,osLocale:h,availableLanguages:{"*":m},_languagePackId:r,_translationsConfigFile:b,_cacheRoot:t,_resolvedLanguagePackCoreLocation:a,_corruptedFile:C};return s(C).then(k=>{let R;return k?R=S(t):R=Promise.resolve(void 0),R.then(()=>s(a).then(N=>N?(P(a).catch(()=>{}),A.mark("code/didGenerateNls"),L):D(a).then(()=>Promise.all([p(c),p(i)])).then(Y=>{const ee=JSON.parse(Y[0]),G=JSON.parse(Y[1]).contents,ne=Object.keys(ee.bundles),Z=[];for(const T of ne){const oe=ee.bundles[T],Q=Object.create(null);for(const te of oe){const J=ee.keys[te],V=ee.messages[te],ie=G[te];let ue;if(ie){ue=[];for(let se=0;se<J.length;se++){const me=J[se],B=typeof me=="string"?me:me.key;let W=ie[B];W===void 0&&(W=V[se]),ue.push(W)}}else ue=V;Q[te]=ue}Z.push(v(e.join(a,T.replace(/\//g,"!")+".nls.json"),JSON.stringify(Q)))}return Z.push(v(b,JSON.stringify(n.translations))),Promise.all(Z)}).then(()=>(A.mark("code/didGenerateNls"),L)).catch(Y=>(console.error("Generating translation files failed.",Y),d(m)))))})})}):d(l)}catch($){return console.error("Generating translation files failed.",$),d(m)}}return{getNLSConfiguration:w}}if(typeof define=="function")define(we[155],ve([78,29,41]),function(e,y,A){return he(e,y,A)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),A=require("../common/performance");module.exports=he(e,y,A)}else throw new Error("Unknown context")}(),define(we[156],ve([1,0,27]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const S=D.replace(/\-/g,":").toLowerCase();return!A.has(S)}function P(){const D=(0,y.networkInterfaces)();for(const S in D){const p=D[S];if(p){for(const{mac:v}of p)if(s(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$5m=P}),define(we[102],ve([1,0,27,65,21,156,4]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=void 0,e.$6m=new class{c(w){return this.a||(this.a=A.$8h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,f=0;const g=(0,y.networkInterfaces)();for(const c in g){const m=g[c];if(m)for(const{mac:h,internal:d}of m)d||(f+=1,this.c(h.toUpperCase())&&(w+=1))}this.b=f>0?w/f:0}return this.b}};let S;async function p(w){return S||(S=(async()=>await v(w)||s.$mg())()),S}e.$7m=p;async function v(w){try{const f=await new Promise((c,m)=>{he(["crypto"],c,m)}),g=(0,P.$5m)();return f.createHash("sha256").update(g,"utf8").digest("hex")}catch(f){w(f);return}}const I="Software\\Microsoft\\SQMClient";async function E(w){if(D.$c){const f=await new Promise((g,c)=>{he(["@vscode/windows-registry"],g,c)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",I,"MachineId")||""}catch(g){return w(g),""}}return""}e.$8m=E}),define(we[157],ve([1,0,29,297,298,4]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=void 0;async function D(S){if(P.$d||P.$c)return;let p;for(const v of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{p=await(0,A.open)(v,y.constants.R_OK);break}catch{}if(!p){S("Unable to retrieve release information from known identifier paths.");return}try{const v=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),I={id:"unknown"};for await(const E of(0,s.createInterface)({input:p.createReadStream(),crlfDelay:1/0})){if(!E.includes("="))continue;const w=E.split("=")[0].toUpperCase().trim();if(v.has(w)){const f=E.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?I.id=f:w==="ID_LIKE"?I.id_like=f:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(I.version_id=f)}}return I}catch(v){S(v)}}e.$ng=D}),define(we[22],ve([1,0,29,27,299,14,39,99,7,4,19,3]),function(he,e,y,A,s,P,D,S,p,v,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function f(T,oe=w.UNLINK,Q){if((0,D.$7f)(T))throw new Error("rimraf - will refuse to recursively delete root");return oe===w.UNLINK?c(T):g(T,Q)}async function g(T,oe=(0,D.$_f)((0,A.tmpdir)())){try{try{await y.promises.rename(T,oe)}catch(Q){return Q.code==="ENOENT"?void 0:c(T)}c(oe).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function c(T){return(0,s.promisify)(y.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function m(T){if((0,D.$7f)(T))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function h(T,oe){return $(await(oe?d(T):(0,s.promisify)(y.readdir)(T)))}async function d(T){try{return await(0,s.promisify)(y.readdir)(T,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const oe=[],Q=await h(T);for(const te of Q){let J=!1,V=!1,ie=!1;try{const ue=await e.Promises.lstat((0,p.$jc)(T,te));J=ue.isFile(),V=ue.isDirectory(),ie=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}oe.push({name:te,isFile:()=>J,isDirectory:()=>V,isSymbolicLink:()=>ie})}return oe}function l(T){return $(y.readdirSync(T))}e.readdirSync=l;function $(T){return T.map(oe=>typeof oe=="string"?v.$d?(0,S.$Cl)(oe):oe:(oe.name=v.$d?(0,S.$Cl)(oe.name):oe.name,oe))}async function u(T){const oe=await h(T),Q=[];for(const te of oe)await i.existsDirectory((0,p.$jc)(T,te))&&Q.push(te);return Q}function n(T,oe=1e3){return new Promise(Q=>{let te=!1;const J=setInterval(()=>{te||(te=!0,y.access(T,V=>{te=!1,V&&(clearInterval(J),Q(void 0))}))},oe)})}e.whenDeleted=n;var i;(function(T){async function oe(J){let V;try{if(V=await e.Promises.lstat(J),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(v.$c&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ue}throw ie}}T.stat=oe;async function Q(J){try{const{stat:V,symbolicLink:ie}=await T.stat(J);return V.isFile()&&ie?.dangling!==!0}catch{}return!1}T.existsFile=Q;async function te(J){try{const{stat:V,symbolicLink:ie}=await T.stat(J);return V.isDirectory()&&ie?.dangling!==!0}catch{}return!1}T.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const o=new P.$$g;function r(T,oe,Q){return o.queueFor(E.URI.file(T),I.$ug).queue(()=>{const te=L(Q);return new Promise((J,V)=>b(T,oe,te,ie=>ie?V(ie):J()))})}let t=!0;function a(T){t=T}e.configureFlushOnWrite=a;function b(T,oe,Q,te){if(!t)return y.writeFile(T,oe,{mode:Q.mode,flag:Q.flag},te);y.open(T,Q.flag,Q.mode,(J,V)=>{if(J)return te(J);y.writeFile(V,oe,ie=>{if(ie)return y.close(V,()=>te(ie));y.fdatasync(V,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),a(!1)),y.close(V,se=>te(se))))})})}function C(T,oe,Q){const te=L(Q);if(!t)return y.writeFileSync(T,oe,{mode:te.mode,flag:te.flag});const J=y.openSync(T,te.flag,te.mode);try{y.writeFileSync(J,oe);try{y.fdatasyncSync(J)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),a(!1)}}finally{y.closeSync(J)}}e.writeFileSync=C;function L(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function k(T,oe,Q=6e4){if(T!==oe)try{v.$c&&typeof Q=="number"?await R(T,oe,Date.now(),Q):await(0,s.promisify)(y.rename)(T,oe)}catch(te){if(T.toLowerCase()!==oe.toLowerCase()&&te.code==="EXDEV"||T.endsWith("."))await N(T,oe,{preserveSymlinks:!1}),await f(T,w.MOVE);else throw te}}async function R(T,oe,Q,te,J=0){try{return await(0,s.promisify)(y.rename)(T,oe)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-Q>=te)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${V}`),V;if(J===0){let ie=!1;try{const{stat:ue}=await i.stat(oe);ue.isFile()||(ie=!0)}catch{}if(ie)throw V}return await(0,P.$3g)(Math.min(100,J*10)),R(T,oe,Q,te,J+1)}}async function N(T,oe,Q){return ee(T,oe,{root:{source:T,target:oe},options:Q,handledSourcePaths:new Set})}const Y=511;async function ee(T,oe,Q){if(Q.handledSourcePaths.has(T))return;Q.handledSourcePaths.add(T);const{stat:te,symbolicLink:J}=await i.stat(T);if(J){if(Q.options.preserveSymlinks)try{return await Z(T,oe,Q)}catch{}if(J.dangling)return}return te.isDirectory()?G(T,oe,te.mode&Y,Q):ne(T,oe,te.mode&Y)}async function G(T,oe,Q,te){await e.Promises.mkdir(oe,{recursive:!0,mode:Q});const J=await h(T);for(const V of J)await ee((0,p.$jc)(T,V),(0,p.$jc)(oe,V),te)}async function ne(T,oe,Q){await e.Promises.copyFile(T,oe),await e.Promises.chmod(oe,Q)}async function Z(T,oe,Q){let te=await e.Promises.readlink(T);(0,D.$4f)(te,Q.root.source,!v.$e)&&(te=(0,p.$jc)(Q.root.target,te.substr(Q.root.source.length+1))),await e.Promises.symlink(te,oe)}e.Promises=new class{get access(){return(0,s.promisify)(y.access)}get stat(){return(0,s.promisify)(y.stat)}get lstat(){return(0,s.promisify)(y.lstat)}get utimes(){return(0,s.promisify)(y.utimes)}get read(){return(T,oe,Q,te,J)=>new Promise((V,ie)=>{y.read(T,oe,Q,te,J,(ue,se,me)=>ue?ie(ue):V({bytesRead:se,buffer:me}))})}get readFile(){return(0,s.promisify)(y.readFile)}get write(){return(T,oe,Q,te,J)=>new Promise((V,ie)=>{y.write(T,oe,Q,te,J,(ue,se,me)=>ue?ie(ue):V({bytesWritten:se,buffer:me}))})}get appendFile(){return(0,s.promisify)(y.appendFile)}get fdatasync(){return(0,s.promisify)(y.fdatasync)}get truncate(){return(0,s.promisify)(y.truncate)}get copyFile(){return(0,s.promisify)(y.copyFile)}get open(){return(0,s.promisify)(y.open)}get close(){return(0,s.promisify)(y.close)}get symlink(){return(0,s.promisify)(y.symlink)}get readlink(){return(0,s.promisify)(y.readlink)}get chmod(){return(0,s.promisify)(y.chmod)}get mkdir(){return(0,s.promisify)(y.mkdir)}get unlink(){return(0,s.promisify)(y.unlink)}get rmdir(){return(0,s.promisify)(y.rmdir)}get realpath(){return(0,s.promisify)(y.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return u}get writeFile(){return r}get rm(){return f}get rename(){return k}get copy(){return N}}}),define(we[158],ve([1,0,29,7,4,17,22]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=void 0;function S(w){if(s.$e)return w;const f=(0,A.$mc)(w);if(w===f)return w;const g=((0,A.$nc)(w)||w).toLowerCase();try{const m=(0,D.readdirSync)(f).filter(h=>h.toLowerCase()===g);if(m.length===1){const h=S(f);if(h)return(0,A.$jc)(h,m[0])}else if(m.length>1){const h=m.indexOf(g);if(h>=0){const d=S(f);if(d)return(0,A.$jc)(d,m[h])}}}catch{}return null}e.$gq=S;async function p(w){if(s.$e)return w;const f=(0,A.$mc)(w);if(w===f)return w;const g=((0,A.$nc)(w)||w).toLowerCase();try{const m=(await D.Promises.readdir(f)).filter(h=>h.toLowerCase()===g);if(m.length===1){const h=await p(f);if(h)return(0,A.$jc)(h,m[0])}else if(m.length>1){const h=m.indexOf(g);if(h>=0){const d=await p(f);if(d)return(0,A.$jc)(d,m[h])}}}catch{}return null}e.$hq=p;async function v(w){try{return await D.Promises.realpath(w)}catch{const g=E(w);return await D.Promises.access(g,y.constants.R_OK),g}}e.$iq=v;function I(w){try{return y.realpathSync(w)}catch{const g=E(w);return y.accessSync(g,y.constants.R_OK),g}}e.$jq=I;function E(w){return(0,P.$Qe)((0,A.$hc)(w),A.sep)}}),define(we[159],ve([1,0,79]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=e.$og=void 0;function A(S,p,v,I=1){let E=!1;return new Promise(w=>{const f=setTimeout(()=>{if(!E)return E=!0,w(0)},v);s(S,p,I,g=>{if(!E)return E=!0,clearTimeout(f),w(g)})})}e.$og=A;function s(S,p,v,I){if(p===0)return I(0);const E=new y.Socket;E.once("connect",()=>(D(E),s(S+v,p-1,v,I))),E.once("data",()=>{}),E.once("error",w=>(D(E),w.code!=="ECONNREFUSED"?s(S+v,p-1,v,I):I(S))),E.connect(S,"127.0.0.1")}e.$pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(S,p,v,I="127.0.0.1"){let E=!1,w,f=1;const g=y.createServer({pauseOnConnect:!0});function c(m,h){E||(E=!0,g.removeAllListeners(),g.close(),w&&clearTimeout(w),h(m))}return new Promise(m=>{w=setTimeout(()=>{c(0,m)},v),g.on("listening",()=>{c(S,m)}),g.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&f<p?(S++,f++,g.listen(S,I)):c(0,m)}),g.on("close",()=>{c(0,m)}),g.listen(S,I)})}e.$qg=P;function D(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(p){console.error(p)}}}),define(we[103],ve([1,0,27,7,22]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=void 0;const P=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var p;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(p||(p={}));let v;switch(process.arch){case"ia32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class E{constructor(u,n,i){this.exePath=u,this.displayName=n,this.a=i}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:$=!1}={}){return $?v===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:$=!1,findPreview:u=!1}={}){const n=w({useAlternateBitness:$});if(!n)return null;const i=A.$jc(n,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(i))return null;let o=-1,r=null;for(const b of await s.Promises.readdir(i)){let C=-1;if(u){const k=b.indexOf("-");if(k<0)continue;const R=b.substring(0,k);if(!P.test(R)||b.substring(k+1)!=="preview")continue;C=parseInt(R,10)}else{if(!P.test(b))continue;C=parseInt(b,10)}if(C<=o)continue;const L=A.$jc(i,b,"pwsh.exe");await s.SymlinkSupport.existsFile(L)&&(r=L,o=C)}if(!r)return null;const t=n.includes("x86")?" (x86)":"",a=u?" Preview":"";return new E(r,`PowerShell${a}${t}`,!0)}async function g({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const u=A.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:n,pwshMsixName:i}=$?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await s.Promises.readdir(u))if(n.test(o)){const r=A.$jc(u,o,"pwsh.exe");return new E(r,i)}return null}function c(){const $=A.$jc(y.homedir(),".dotnet","tools","pwsh.exe");return new E($,".NET Core PowerShell Global Tool")}function m(){const $=A.$jc(process.env.windir,v===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E($,"Windows PowerShell",!0)}async function*h(){let $=await f();$&&(yield $),$=await f({useAlternateBitness:!0}),$&&(yield $),$=await g(),$&&(yield $),$=c(),$&&(yield $),$=await f({findPreview:!0}),$&&(yield $),$=await g({findPreview:!0}),$&&(yield $),$=await f({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=m(),$&&(yield $)}async function*d(){for await(const $ of h())await $.exists()&&(yield $)}e.$Ll=d;async function l(){for await(const $ of d())return $;return null}e.$Ml=l}),define(we[104],ve([1,0,7,4,28,61,8,22]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ql=e.$Pl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function p(E=s.env){return E.comspec||"cmd.exe"}e.$Pl=p;function v(E){let w=[],f=!1;const g=function(c){if(f){w.push(c);return}(!E.send(c,h=>{if(h&&console.error(h),f=!1,w.length>0){const d=w.slice(0);w=[],d.forEach(l=>g(l))}})||A.$c)&&(f=!0)};return{send:g}}e.$Ql=v;var I;(function(E){async function w(f,g,c){if(y.$ic(f))return f;if(g===void 0&&(g=s.cwd()),y.$mc(f)!=="."||(c===void 0&&D.$Ef(s.env.PATH)&&(c=s.env.PATH.split(y.$tc)),c===void 0||c.length===0))return y.$jc(g,f);async function h(d){if(await S.Promises.exists(d)){let l;try{l=await S.Promises.stat(d)}catch($){$.message.startsWith("EACCES")&&(l=await S.Promises.lstat(d))}return l?!l.isDirectory():!1}return!1}for(const d of c){let l;if(y.$ic(d)?l=y.$jc(d,f):l=y.$jc(g,d,f),await h(l))return l;let $=l+".com";if(await h($)||($=l+".exe",await h($)))return $}return y.$jc(g,f)}E.findExecutable=w})(I||(e.win32=I={}))}),define(we[105],ve([1,0,52,12]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=void 0;function s(D){return new Promise((S,p)=>{let v;const I=new Map;function E(f,g,c,m,h){const d=I.get(g);if(f===D||d){const l={name:w(c),cmd:c,pid:f,ppid:g,load:m,mem:h};I.set(f,l),f===D&&(v=l),d&&(d.children||(d.children=[]),d.children.push(l),d.children.length>1&&(d.children=d.children.sort(($,u)=>$.pid-u.pid)))}}function w(f){const g=/--utility-sub-type=network/i,c=/--ms-enable-electron-run-as-node/i,m=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(m.exec(f))return"electron-crash-reporter";if(h.exec(f))return"winpty-agent";if(d.exec(f))return"conpty-agent";let $=l.exec(f);if($&&$.length===2)return $[1]==="renderer"?"window":$[1]==="utility"?g.exec(f)?"utility-network-service":"utility-process":$[1]==="extensionHost"?"extension-host":$[1];const u=/[a-zA-Z-]+\.js/g;let n="";do $=u.exec(f),$&&(n+=$+" ");while($);return n&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${n})`:c.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,c)=>{he(["@vscode/windows-process-tree"],g,c)}).then(g=>{g.getProcessList(D,c=>{if(!c){p(new Error(`Root process ${D} not found`));return}g.getProcessCpuUsage(c,m=>{const h=new Map;m.forEach(d=>{const l=f(d.commandLine||"");h.set(d.pid,{name:w(l),cmd:l,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),v=h.get(D),v?(h.forEach(d=>{const l=h.get(d.ppid);l&&(l.children||(l.children=[]),l.children.push(d))}),h.forEach(d=>{d.children&&(d.children=d.children.sort((l,$)=>l.pid-$.pid))}),S(v)):p(new Error(`Root process ${D} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let f=function(){let g=[v];const c=[];for(;g.length;){const h=g.shift();h&&(c.push(h.pid),h.children&&(g=g.concat(h.children)))}let m=JSON.stringify(A.$kg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+c.join(" "),(0,y.exec)(m,{},(h,d,l)=>{if(h||l)p(h||new Error(l.toString()));else{const $=d.toString().split(`
`);for(let u=0;u<c.length;u++){const n=I.get(c[u]);n.load=parseFloat($[u])}if(!v){p(new Error(`Root process ${D} not found`));return}S(v)}})};(0,y.exec)("which ps",{},(g,c,m)=>{if(g||m)if(process.platform!=="linux")p(g||new Error(m.toString()));else{const h=JSON.stringify(A.$kg.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(h,{},(d,l,$)=>{d||$?p(d||new Error($.toString())):(P(l,E),f())})}else{const h=c.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${h} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,$,u)=>{l||u&&!u.includes("screen size is bogus")?p(l||new Error(u.toString())):(P($,E),process.platform==="linux"?f():v?S(v):p(new Error(`Root process ${D} not found`)))})}})}})}e.$Qr=s;function P(D,S){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=D.toString().split(`
`);for(const I of v){const E=p.exec(I.trim());E&&E.length===6&&S(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(we[106],ve([1,0,27,4,103,104]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=void 0;async function D(E,w){return E===1?A.$c?I():P.$Pl(w):p(E,w)}e.$Rl=D;let S=null;function p(E,w){if(A.$e&&E===2||A.$d&&E===3)return"/bin/bash";if(!S){let f;if(A.$c)f="/bin/bash";else{if(f=w.SHELL,!f)try{f=(0,y.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}S=f}return S}let v=null;async function I(){return v||(v=(await(0,s.$Ml)()).exePath),v}}),function(){function he(){function e(){return process.uncHostAllowlist}function y(p){const v=new Set;if(Array.isArray(p))for(const I of p)typeof I=="string"&&v.add(I);return Array.from(v)}function A(){const p=e();return p?Array.from(p):[]}function s(p){if(process.platform!=="win32")return;const v=e();if(v)if(typeof p=="string")v.add(p.toLowerCase());else for(const I of y(p))s(I)}function P(p){if(typeof p!="string")return;const v=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let I;for(const E of v){if(p.indexOf(E)!==0)continue;const f=p.indexOf("\\",E.length);if(f===-1)continue;const g=p.substring(E.length,f);if(g){I=g;break}}return I}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:s,getUNCHost:P,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return he()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=he():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Ne=this&&this.__decorate||function(he,e,y,A){var s=arguments.length,P=s<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,y):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(he,e,y,A);else for(var S=he.length-1;S>=0;S--)(D=he[S])&&(P=(s<3?D(P):s>3?D(e,y,P):D(e,y))||P);return s>3&&P&&Object.defineProperty(e,y,P),P};define(we[42],ve([1,0,18,14,15,20,74,11,5,2,50,17,8]),function(he,e,y,A,s,P,D,S,p,v,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.ProxyChannel=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.RequestInitiator=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0;var f;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(f||(f={}));function g(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(c||(c={}));function m(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(h||(h={}));function d(J){let V=0;for(let ie=0;;ie+=7){const ue=J.read(1);if(V|=(ue.buffer[0]&127)<<ie,!(ue.buffer[0]&128))return V}}const l=o(0);function $(J,V){if(V===0){J.write(l);return}let ie=0;for(let se=V;se!==0;se=se>>>7)ie++;const ue=s.$ge.alloc(ie);for(let se=0;V!==0;se++)ue.buffer[se]=V&127,V=V>>>7,V>0&&(ue.buffer[se]|=128);J.write(ue)}class u{constructor(V){this.b=V,this.a=0}read(V){const ie=this.b.slice(this.a,this.a+V);return this.a+=ie.byteLength,ie}}e.$zh=u;class n{constructor(){this.a=[]}get buffer(){return s.$ge.concat(this.a)}write(V){this.a.push(V)}}e.$Ah=n;var i;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(i||(i={}));function o(J){const V=s.$ge.alloc(1);return V.writeUInt8(J,0),V}const r={Undefined:o(i.Undefined),String:o(i.String),Buffer:o(i.Buffer),VSBuffer:o(i.VSBuffer),Array:o(i.Array),Object:o(i.Object),Uint:o(i.Int)},t=typeof Buffer<"u";function a(J,V){if(typeof V>"u")J.write(r.Undefined);else if(typeof V=="string"){const ie=s.$ge.fromString(V);J.write(r.String),$(J,ie.byteLength),J.write(ie)}else if(t&&Buffer.isBuffer(V)){const ie=s.$ge.wrap(V);J.write(r.Buffer),$(J,ie.byteLength),J.write(ie)}else if(V instanceof s.$ge)J.write(r.VSBuffer),$(J,V.byteLength),J.write(V);else if(Array.isArray(V)){J.write(r.Array),$(J,V.length);for(const ie of V)a(J,ie)}else if(typeof V=="number"&&(V|0)===V)J.write(r.Uint),$(J,V);else{const ie=s.$ge.fromString(JSON.stringify(V));J.write(r.Object),$(J,ie.byteLength),J.write(ie)}}e.$Bh=a;function b(J){switch(J.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return J.read(d(J)).toString();case i.Buffer:return J.read(d(J)).buffer;case i.VSBuffer:return J.read(d(J));case i.Array:{const ie=d(J),ue=[];for(let se=0;se<ie;se++)ue.push(b(J));return ue}case i.Object:return JSON.parse(J.read(d(J)).toString());case i.Int:return d(J)}}e.$Ch=b;class C{constructor(V,ie,ue=null,se=1e3){this.h=V,this.j=ie,this.k=ue,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(me=>this.q(me)),this.m({type:200})}registerChannel(V,ie){this.b.set(V,ie),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const ie=this.o([V.type]);this.k?.logOutgoing(ie,0,1,m(V.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([V.type,V.id],V.data);this.k?.logOutgoing(ie,V.id,1,m(V.type),V.data);return}}}o(V,ie=void 0){const ue=new n;return a(ue,V),a(ue,ie),this.p(ue.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const ie=new u(V),ue=b(ie),se=b(ie),me=ue[0];switch(me){case 100:return this.k?.logIncoming(V.byteLength,ue[1],1,`${g(me)}: ${ue[2]}.${ue[3]}`,se),this.s({type:me,id:ue[1],channelName:ue[2],name:ue[3],arg:se});case 102:return this.k?.logIncoming(V.byteLength,ue[1],1,`${g(me)}: ${ue[2]}.${ue[3]}`,se),this.t({type:me,id:ue[1],channelName:ue[2],name:ue[3],arg:se});case 101:return this.k?.logIncoming(V.byteLength,ue[1],1,`${g(me)}`),this.u({type:me,id:ue[1]});case 103:return this.k?.logIncoming(V.byteLength,ue[1],1,`${g(me)}`),this.u({type:me,id:ue[1]})}}s(V){const ie=this.b.get(V.channelName);if(!ie){this.v(V);return}const ue=new P.$3d;let se;try{se=ie.call(this.j,V.name,V.arg,ue.token)}catch(W){se=Promise.reject(W)}const me=V.id;se.then(W=>{this.m({id:me,data:W,type:201})},W=>{W instanceof Error?this.m({id:me,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.m({id:me,data:W,type:203})}).finally(()=>{B.dispose(),this.d.delete(V.id)});const B=(0,v.$Qc)(()=>ue.cancel());this.d.set(V.id,B)}t(V){const ie=this.b.get(V.channelName);if(!ie){this.v(V);return}const ue=V.id,me=ie.listen(this.j,V.name,V.arg)(B=>this.m({id:ue,data:B,type:204}));this.d.set(V.id,me)}u(V){const ie=this.d.get(V.id);ie&&(ie.dispose(),this.d.delete(V.id))}v(V){let ie=this.g.get(V.channelName);ie||(ie=[],this.g.set(V.channelName,ie));const ue=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:V,timeoutTimer:ue})}w(V){const ie=this.g.get(V);if(ie){for(const ue of ie)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.s(ue.request);break;case 102:this.t(ue.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=C;var L;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(L||(e.RequestInitiator=L={}));class k{constructor(V,ie=null){this.l=V,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ue=>this.s(ue)),this.j=ie}getChannel(V){const ie=this;return{call(ue,se,me){return ie.a?Promise.reject(new S.$5):ie.m(V,ue,se,me)},listen(ue,se){return ie.a?p.Event.None:ie.o(V,ue,se)}}}m(V,ie,ue,se=P.CancellationToken.None){const me=this.g++,W={id:me,type:100,channelName:V,name:ie,arg:ue};if(se.isCancellationRequested)return Promise.reject(new S.$5);let O;return new Promise((re,X)=>{if(se.isCancellationRequested)return X(new S.$5);const x=()=>{const H=_=>{switch(_.type){case 201:this.f.delete(me),re(_.data);break;case 202:{this.f.delete(me);const ae=new Error(_.data.message);ae.stack=Array.isArray(_.data.stack)?_.data.stack.join(`
`):_.data.stack,ae.name=_.data.name,X(ae);break}case 203:this.f.delete(me),X(_.data);break}};this.f.set(me,H),this.p(W)};let z=null;this.b===h.Idle?x():(z=(0,A.$Pg)(H=>this.u()),z.then(()=>{z=null,x()}));const q=()=>{z?(z.cancel(),z=null):this.p({id:me,type:101}),X(new S.$5)},M=se.onCancellationRequested(q);O=(0,v.$Pc)((0,v.$Qc)(q),M),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(V,ie,ue){const se=this.g++,B={id:se,type:102,channelName:V,name:ie,arg:ue};let W=null;const O=new p.$Sd({onWillAddFirstListener:()=>{W=(0,A.$Pg)(re=>this.u()),W.then(()=>{W=null,this.d.add(O),this.p(B)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.d.delete(O),this.p({id:se,type:103}))}}),j=re=>O.fire(re.data);return this.f.set(se,j),O.event}p(V){switch(V.type){case 100:case 102:{const ie=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(ie,V.id,0,`${g(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const ie=this.q([V.type,V.id]);this.j?.logOutgoing(ie,V.id,0,g(V.type));return}}}q(V,ie=void 0){const ue=new n;return a(ue,V),a(ue,ie),this.r(ue.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const ie=new u(V),ue=b(ie),se=b(ie),me=ue[0];switch(me){case 200:return this.j?.logIncoming(V.byteLength,0,0,m(me)),this.t({type:ue[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ue[1],0,m(me),se),this.t({type:ue[0],id:ue[1],data:se})}}t(V){if(V.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=k,Ne([D.$th],k.prototype,"onDidInitializePromise",null);class R{get connections(){const V=[];return this.f.forEach(ie=>V.push(ie)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new p.$Sd,this.onDidAddConnection=this.g.event,this.h=new p.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new v.$Rc,this.j.add(V(({protocol:ie,onDidClientDisconnect:ue})=>{const se=p.Event.once(ie.onMessage);this.j.add(se(me=>{const B=new u(me),W=b(B),O=new C(ie,W),j=new k(ie);this.a.forEach((X,x)=>O.registerChannel(x,X));const re={channelServer:O,channelClient:j,ctx:W};this.f.add(re),this.g.fire(re),this.j.add(ue(()=>{O.dispose(),j.dispose(),this.f.delete(re),this.h.fire(re)}))}))}))}getChannel(V,ie){const ue=this;return{call(se,me,B){let W;if((0,w.$Sf)(ie)){const j=(0,y.$4b)(ue.connections.filter(ie));W=j?Promise.resolve(j):p.Event.toPromise(p.Event.filter(ue.onDidAddConnection,ie))}else W=ie.routeCall(ue,se,me);const O=W.then(j=>j.channelClient.getChannel(V));return Y(O).call(se,me,B)},listen(se,me){if((0,w.$Sf)(ie))return ue.k(V,ie,se,me);const B=ie.routeEvent(ue,se,me).then(W=>W.channelClient.getChannel(V));return Y(B).listen(se,me)}}}k(V,ie,ue,se){const me=this;let B;const W=new p.$Sd({onWillAddFirstListener:()=>{B=new v.$Rc;const O=new p.$Yd,j=new Map,re=x=>{const q=x.channelClient.getChannel(V).listen(ue,se),M=O.add(q);j.set(x,M)},X=x=>{const z=j.get(x);z&&(z.dispose(),j.delete(x))};me.connections.filter(ie).forEach(re),p.Event.filter(me.onDidAddConnection,ie)(re,void 0,B),me.onDidRemoveConnection(X,void 0,B),O.event(W.fire,W,B),B.add(O)},onDidRemoveLastListener:()=>{B?.dispose(),B=void 0}});return W.event}registerChannel(V,ie){this.a.set(V,ie);for(const ue of this.f)ue.channelServer.registerChannel(V,ie)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Fh=R;class N{constructor(V,ie,ue=null){const se=new n;a(se,ie),V.send(se.buffer),this.a=new k(V,ue),this.d=new C(V,ie,ue)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,ie){this.d.registerChannel(V,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Gh=N;function Y(J){return{call(V,ie,ue){return J.then(se=>se.call(V,ie,ue))},listen(V,ie){const ue=new p.$2d;return J.then(se=>ue.input=se.listen(V,ie)),ue.event}}}e.$Hh=Y;function ee(J){let V=!1;return{call(ie,ue,se){return V?J.call(ie,ue,se):(0,A.$3g)(0).then(()=>V=!0).then(()=>J.call(ie,ue,se))},listen(ie,ue){if(V)return J.listen(ie,ue);const se=new p.$2d;return(0,A.$3g)(0).then(()=>V=!0).then(()=>se.input=J.listen(ie,ue)),se.event}}}e.$Ih=ee;class G{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const ie of V.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await p.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$Jh=G;var ne;(function(J){function V(me,B,W){const O=me,j=W&&W.disableMarshalling,re=new Map;for(const X in O)ue(X)&&re.set(X,p.Event.buffer(O[X],!0,void 0,B));return new class{listen(X,x,z){const q=re.get(x);if(q)return q;if(se(x)){const M=O[x];if(typeof M=="function")return M.call(O,z)}throw new S.$bb(`Event not found: ${x}`)}call(X,x,z){const q=O[x];if(typeof q=="function"){if(!j&&Array.isArray(z))for(let H=0;H<z.length;H++)z[H]=(0,I.$yh)(z[H]);let M=q.apply(O,z);return M instanceof Promise||(M=Promise.resolve(M)),M}throw new S.$bb(`Method not found: ${x}`)}}}J.fromService=V;function ie(me,B){const W=B&&B.disableMarshalling;return new Proxy({},{get(O,j){if(typeof j=="string")return B?.properties?.has(j)?B.properties.get(j):se(j)?function(re){return me.listen(j,re)}:ue(j)?me.listen(j):async function(...re){let X;B&&!(0,w.$Nf)(B.context)?X=[B.context,...re]:X=re;const x=await me.call(j,X);return W?x:(0,I.$yh)(x)};throw new S.$bb(`Property not found: ${String(j)}`)}})}J.toService=ie;function ue(me){return me[0]==="o"&&me[1]==="n"&&E.$7e(me.charCodeAt(2))}function se(me){return/^onDynamic/.test(me)&&E.$7e(me.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const V=J.toString();if(V!=="[object Object]")return V}return J}function oe(J){return Array.isArray(J)?J.map(T):T(J)}function Q(J,V,ie,ue,se,me,B){B=oe(B);const W=Z[se],O=W[ue%W.length];let j=[`%c[${J}]%c[${String(V).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${me}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(me)?(j=j.concat(B),j.push(")")):j.push(B),console.log.apply(console,j)}class te{constructor(V,ie){this.d=V,this.f=ie,this.a=0,this.b=0}logOutgoing(V,ie,ue,se,me){this.b+=V,Q(this.d,this.b,V,ie,ue,se,me)}logIncoming(V,ie,ue,se,me){this.a+=V,Q(this.f,this.a,V,ie,ue,se,me)}}e.$Kh=te}),define(we[107],ve([1,0,15,5,2,42]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.ProtocolConstants=e.$Lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var S;(function(r){r.enableDiagnostics=!1,r.records=[];const t=new WeakMap;let a=0;function b(L,k){if(!t.has(L)){const R=String(++a);t.set(L,R)}return t.get(L)}function C(L,k,R,N){if(!r.enableDiagnostics)return;const Y=b(L,k);if(N instanceof y.$ge||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const ee=y.$ge.alloc(N.byteLength);ee.set(N),r.records.push({timestamp:Date.now(),id:Y,label:k,type:R,buff:ee})}else r.records.push({timestamp:Date.now(),id:Y,label:k,type:R,data:N})}r.traceSocketEvent=C})(S||(e.SocketDiagnostics=S={}));var p;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let v=null;function I(){return v||(v=y.$ge.alloc(0)),v}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,a){if(t===0)return I();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const k=this.a[0];return a&&(this.a.shift(),this.b-=t),k}if(this.a[0].byteLength>t){const k=this.a[0].slice(0,t);return a&&(this.a[0]=this.a[0].slice(t),this.b-=t),k}const b=y.$ge.alloc(t);let C=0,L=0;for(;t>0;){const k=this.a[L];if(k.byteLength>t){const R=k.slice(0,t);b.set(R,C),C+=t,a&&(this.a[L]=k.slice(t),this.b-=t),t-=t}else b.set(k,C),C+=k.byteLength,a?(this.a.shift(),this.b-=k.byteLength):L++,t-=k.byteLength}return b}}e.$Lh=E;var w;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(w||(w={}));function f(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class c{constructor(t,a,b,C){this.type=t,this.id=a,this.ack=b,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends s.$Sc{constructor(t){super(),this.f=this.B(new A.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,C=this.g.id,L=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new c(b,C,L,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=y.$ge.alloc(13);a.writeUInt8(t.type,0),a.writeUInt32BE(t.id,1),a.writeUInt32BE(t.ack,5),a.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(a,t.data)}g(t,a){const b=this.f===0;return this.d.push(t,a),this.f+=t.byteLength+a.byteLength,b}h(){const t=y.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,a){this.g(t,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class d extends s.$Sc{constructor(t){super(),this.f=new A.$Sd,this.onMessage=this.f.event,this.g=new A.$Sd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new h(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new c(1,0,0,t))}}e.$Mh=d;class l extends P.$Gh{static fromSocket(t,a){return new l(new d(t),a)}get onDidDispose(){return this.b.onDidDispose}constructor(t,a,b=null){super(t,a,b),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Nh=l;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Oh=$;class u{constructor(t){this.data=t,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let t=0,a=this.a;for(;a;)a=a.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let a=0,b=this.a;for(;b;)t[a++]=b.data,b=b.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const a=new u(t);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const t=Date.now();for(let a=0;a<i.a;a++)this.c[a]=t-1e3*a;setInterval(()=>{for(let a=i.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),a=(1+i.a)*1e3;let b=0;for(let C=0;C<i.a;C++)t-this.c[C]<=a&&b++;return 1-b/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;class o{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??i.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Rc,this.o=t.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new c(5,0,0,I());this.p.write(t),this.p.flush()}sendPause(){const t=new c(7,0,0,I());this.p.write(t)}sendResume(){const t=new c(8,0,0,I());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,a){this.a=!0,this.r.dispose(),this.r=new s.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new c(3,0,this.h,I());this.p.write(t);const a=this.b.toArray();for(let b=0,C=a.length;b<C;b++)this.p.write(a[b]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const a=this.b.peek();if(a&&a.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new c(6,0,0,I())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let b=0,C=a.length;b<C;b++)this.p.write(a[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const a=++this.c;this.h=this.g;const b=new c(1,a,this.h,t);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(t){const a=new c(2,0,0,t);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),a=Date.now()-t.writtenTime,b=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(a>=2e4&&b>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:b});return}const L=Math.max(2e4-a,2e4-b,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},L)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new c(3,0,this.h,I());this.p.write(t)}D(){this.h=this.g;const t=new c(9,0,this.h,I());this.p.write(t)}}e.$Ph=o}),define(we[108],ve([1,0,52,14,15,20,151,11,5,2,23,104,61,42]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;class g extends f.$Dh{constructor(h){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",d=>s.$ge.wrap(Buffer.from(d,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$dq=g;class c{constructor(h,d){this.i=h,this.j=d,this.c=new Set,this.g=new Map,this.h=new p.$Sd,this.onDidProcessExit=this.h.event;const l=d&&d.timeout?d.timeout:6e4;this.b=new A.$Yg(l),this.d=null,this.f=null}getChannel(h){const d=this;return{call(l,$,u){return d.k(h,l,$,u)},listen(l,$){return d.l(h,l,$)}}}k(h,d,l,$=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const u=this.n(h),n=(0,A.$Pg)(r=>u.call(d,l,r)),i=$.onCancellationRequested(()=>n.cancel()),o=(0,v.$Qc)(()=>n.cancel());return this.c.add(o),n.finally(()=>{i.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(h,d,l){if(!this.b)return p.Event.None;this.b.cancel();let $;const u=new p.$Sd({onWillAddFirstListener:()=>{$=this.n(h).listen(d,l)(u.fire,u),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,I.$in)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,w.$Ol)(d.env),this.d=(0,y.fork)(this.i,h,d);const l=new p.$Sd;p.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,D.$_p)(t)){(0,D.log)(t,`IPC Library: ${this.j.serverName}`);return}l.fire(s.$ge.wrap(Buffer.from(t,"base64")))});const u=this.j.useQueue?(0,E.$Ql)(this.d):this.d,n=t=>this.d&&this.d.connected&&u.send(t.buffer.toString("base64")),i=l.event,o={send:n,onMessage:i};this.f=new f.$Eh(o);const r=()=>this.o();process.once("exit",r),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,a)=>{process.removeListener("exit",r),this.c.forEach(b=>(0,v.$Nc)(b)),this.c.clear(),t!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:a})})}return this.f}n(h){let d=this.g.get(h);return d||(d=this.m.getChannel(h),this.g.set(h,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$eq=c}),define(we[160],ve([1,0,14,5,2,50,8]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.StorageState=e.$cp=e.StorageHint=void 0;var S;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function p(w){const f=w;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$cp=p;var v;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(v||(e.StorageState=v={}));class I extends s.$Sc{constructor(f,g=Object.create(null)){super(),this.r=f,this.s=g,this.b=this.B(new A.$Vd),this.onDidChangeStorage=this.b.event,this.c=v.None,this.f=new Map,this.g=this.B(new y.$Zg(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((g,c)=>this.w(c,g)),f.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(f,g){if(this.c===v.Closed)return;let c=!1;(0,D.$Nf)(g)?c=this.f.delete(f):this.f.get(f)!==g&&(this.f.set(f,g),c=!0),c&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===v.None&&(this.c=v.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,g){const c=this.f.get(f);return(0,D.$Nf)(c)?g:c}getBoolean(f,g){const c=this.get(f);return(0,D.$Nf)(c)?g:c==="true"}getNumber(f,g){const c=this.get(f);return(0,D.$Nf)(c)?g:parseInt(c,10)}getObject(f,g){const c=this.get(f);return(0,D.$Nf)(c)?g:(0,P.$xh)(c)}async set(f,g,c=!1){if(this.c===v.Closed)return;if((0,D.$Nf)(g))return this.delete(f,c);const m=(0,D.$Gf)(g)||Array.isArray(g)?(0,P.$wh)(g):String(g);if(this.f.get(f)!==m)return this.f.set(f,m),this.j.set(f,m),this.h.delete(f),this.b.fire({key:f,external:c}),this.D()}async delete(f,g=!1){if(!(this.c===v.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:g}),this.D()}async optimize(){if(this.c!==v.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=v.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$dp=I,I.a=100;class E{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((g,c)=>this.a.set(c,g)),f.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$ep=E}),define(we[80],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class y{constructor(s,P){this.lineNumber=s,this.column=P}with(s=this.lineNumber,P=this.column){return s===this.lineNumber&&P===this.column?this:new y(s,P)}delta(s=0,P=0){return this.with(this.lineNumber+s,this.column+P)}equals(s){return y.equals(this,s)}static equals(s,P){return!s&&!P?!0:!!s&&!!P&&s.lineNumber===P.lineNumber&&s.column===P.column}isBefore(s){return y.isBefore(this,s)}static isBefore(s,P){return s.lineNumber<P.lineNumber?!0:P.lineNumber<s.lineNumber?!1:s.column<P.column}isBeforeOrEqual(s){return y.isBeforeOrEqual(this,s)}static isBeforeOrEqual(s,P){return s.lineNumber<P.lineNumber?!0:P.lineNumber<s.lineNumber?!1:s.column<=P.column}static compare(s,P){const D=s.lineNumber|0,S=P.lineNumber|0;if(D===S){const p=s.column|0,v=P.column|0;return p-v}return D-S}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(s){return new y(s.lineNumber,s.column)}static isIPosition(s){return s&&typeof s.lineNumber=="number"&&typeof s.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Gs=y}),define(we[43],ve([1,0,80]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;class A{constructor(P,D,S,p){P>S||P===S&&D>p?(this.startLineNumber=S,this.startColumn=p,this.endLineNumber=P,this.endColumn=D):(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=S,this.endColumn=p)}isEmpty(){return A.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return A.containsPosition(this,P)}static containsPosition(P,D){return!(D.lineNumber<P.startLineNumber||D.lineNumber>P.endLineNumber||D.lineNumber===P.startLineNumber&&D.column<P.startColumn||D.lineNumber===P.endLineNumber&&D.column>P.endColumn)}static strictContainsPosition(P,D){return!(D.lineNumber<P.startLineNumber||D.lineNumber>P.endLineNumber||D.lineNumber===P.startLineNumber&&D.column<=P.startColumn||D.lineNumber===P.endLineNumber&&D.column>=P.endColumn)}containsRange(P){return A.containsRange(this,P)}static containsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>P.endColumn)}strictContainsRange(P){return A.strictContainsRange(this,P)}static strictContainsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<=P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>=P.endColumn)}plusRange(P){return A.plusRange(this,P)}static plusRange(P,D){let S,p,v,I;return D.startLineNumber<P.startLineNumber?(S=D.startLineNumber,p=D.startColumn):D.startLineNumber===P.startLineNumber?(S=D.startLineNumber,p=Math.min(D.startColumn,P.startColumn)):(S=P.startLineNumber,p=P.startColumn),D.endLineNumber>P.endLineNumber?(v=D.endLineNumber,I=D.endColumn):D.endLineNumber===P.endLineNumber?(v=D.endLineNumber,I=Math.max(D.endColumn,P.endColumn)):(v=P.endLineNumber,I=P.endColumn),new A(S,p,v,I)}intersectRanges(P){return A.intersectRanges(this,P)}static intersectRanges(P,D){let S=P.startLineNumber,p=P.startColumn,v=P.endLineNumber,I=P.endColumn;const E=D.startLineNumber,w=D.startColumn,f=D.endLineNumber,g=D.endColumn;return S<E?(S=E,p=w):S===E&&(p=Math.max(p,w)),v>f?(v=f,I=g):v===f&&(I=Math.min(I,g)),S>v||S===v&&p>I?null:new A(S,p,v,I)}equalsRange(P){return A.equalsRange(this,P)}static equalsRange(P,D){return!P&&!D?!0:!!P&&!!D&&P.startLineNumber===D.startLineNumber&&P.startColumn===D.startColumn&&P.endLineNumber===D.endLineNumber&&P.endColumn===D.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(P){return new y.$Gs(P.endLineNumber,P.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(P){return new y.$Gs(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,D){return new A(this.startLineNumber,this.startColumn,P,D)}setStartPosition(P,D){return new A(P,D,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(P){return new A(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(P){return new A(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new A(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,D=P){return new A(P.lineNumber,P.column,D.lineNumber,D.column)}static lift(P){return P?new A(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<P.startColumn)}static areIntersecting(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<=D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,D){if(P&&D){const v=P.startLineNumber|0,I=D.startLineNumber|0;if(v===I){const E=P.startColumn|0,w=D.startColumn|0;if(E===w){const f=P.endLineNumber|0,g=D.endLineNumber|0;if(f===g){const c=P.endColumn|0,m=D.endColumn|0;return c-m}return f-g}return E-w}return v-I}return(P?1:0)-(D?1:0)}static compareRangesUsingEnds(P,D){return P.endLineNumber===D.endLineNumber?P.endColumn===D.endColumn?P.startLineNumber===D.startLineNumber?P.startColumn-D.startColumn:P.startLineNumber-D.startLineNumber:P.endColumn-D.endColumn:P.endLineNumber-D.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Hs=A}),define(we[161],ve([1,0,43]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;class A{static insert(P,D){return{range:new y.$Hs(P.lineNumber,P.column,P.lineNumber,P.column),text:D,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,D){return{range:P,text:D}}static replaceMove(P,D){return{range:P,text:D,forceMoveMarkers:!0}}}e.$Is=A}),define(we[162],ve([1,0,5,2]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0;class s{constructor(){this.a=new Map,this.b=new Map,this.c=new y.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(S){this.c.fire({changedLanguages:S,changedColorMap:!1})}register(S,p){return this.a.set(S,p),this.handleChange([S]),(0,A.$Qc)(()=>{this.a.get(S)===p&&(this.a.delete(S),this.handleChange([S]))})}get(S){return this.a.get(S)||null}registerFactory(S,p){this.b.get(S)?.dispose();const v=new P(this,S,p);return this.b.set(S,v),(0,A.$Qc)(()=>{const I=this.b.get(S);!I||I!==v||(this.b.delete(S),I.dispose())})}async getOrCreate(S){const p=this.get(S);if(p)return p;const v=this.b.get(S);return!v||v.isResolved?null:(await v.resolve(),this.get(S))}isResolved(S){if(this.get(S))return!0;const v=this.b.get(S);return!!(!v||v.isResolved)}setColorMap(S){this.d=S,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$gt=s;class P extends A.$Sc{get isResolved(){return this.c}constructor(S,p,v){super(),this.f=S,this.g=p,this.h=v,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const S=await this.h.tokenizationSupport;this.c=!0,S&&!this.a&&this.B(this.f.register(this.g,S))}}}),define(we[163],ve([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(we[164],ve([1,0,5,2,163]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class P extends A.$Sc{constructor(w,f="",g="",c=!0,m){super(),this.h=this.B(new y.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=f,this.u=g,this.w=c,this.C=m}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,f){this.C&&await this.C(w)}}e.$Gi=P;class D extends A.$Sc{constructor(){super(...arguments),this.f=this.B(new y.$Sd),this.onWillRun=this.f.event,this.m=this.B(new y.$Sd),this.onDidRun=this.m.event}async run(w,f){if(!w.enabled)return;this.f.fire({action:w});let g;try{await this.u(w,f)}catch(c){g=c}this.m.fire({action:w,error:g})}async u(w,f){await w.run(f)}}e.$Hi=D;class S{constructor(){this.id=S.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let f=[];for(const g of w)g.length&&(f.length?f=[...f,new S,...g]:f=g);return f}async run(){}}e.$Ii=S,S.ID="vs.actions.separator";class p{get actions(){return this.a}constructor(w,f,g,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=f,this.class=c,this.a=g}async run(){}}e.$Ji=p;class v extends P{constructor(){super(v.ID,s.localize(0,null),void 0,!1)}}e.$Ki=v,v.ID="vs.actions.empty";function I(E){return{id:E.id,label:E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked??!1,run:async(...w)=>E.run(...w),tooltip:E.label}}e.$Li=I}),define(we[165],ve([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(we[166],ve([1,0,165]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0;const A=60,s=A*60,P=s*24,D=P*7,S=P*30,p=P*365;function v(E,w,f,g){typeof E!="number"&&(E=E.getTime());const c=Math.round((new Date().getTime()-E)/1e3);if(c<-30)return(0,y.localize)(0,null,v(new Date().getTime()+c*1e3,!1));if(!g&&c<30)return(0,y.localize)(1,null);let m;return c<A?(m=c,w?m===1?f?(0,y.localize)(2,null,m):(0,y.localize)(3,null,m):f?(0,y.localize)(4,null,m):(0,y.localize)(5,null,m):m===1?f?(0,y.localize)(6,null,m):(0,y.localize)(7,null,m):f?(0,y.localize)(8,null,m):(0,y.localize)(9,null,m)):c<s?(m=Math.floor(c/A),w?m===1?f?(0,y.localize)(10,null,m):(0,y.localize)(11,null,m):f?(0,y.localize)(12,null,m):(0,y.localize)(13,null,m):m===1?f?(0,y.localize)(14,null,m):(0,y.localize)(15,null,m):f?(0,y.localize)(16,null,m):(0,y.localize)(17,null,m)):c<P?(m=Math.floor(c/s),w?m===1?f?(0,y.localize)(18,null,m):(0,y.localize)(19,null,m):f?(0,y.localize)(20,null,m):(0,y.localize)(21,null,m):m===1?f?(0,y.localize)(22,null,m):(0,y.localize)(23,null,m):f?(0,y.localize)(24,null,m):(0,y.localize)(25,null,m)):c<D?(m=Math.floor(c/P),w?m===1?(0,y.localize)(26,null,m):(0,y.localize)(27,null,m):m===1?(0,y.localize)(28,null,m):(0,y.localize)(29,null,m)):c<S?(m=Math.floor(c/D),w?m===1?f?(0,y.localize)(30,null,m):(0,y.localize)(31,null,m):f?(0,y.localize)(32,null,m):(0,y.localize)(33,null,m):m===1?f?(0,y.localize)(34,null,m):(0,y.localize)(35,null,m):f?(0,y.localize)(36,null,m):(0,y.localize)(37,null,m)):c<p?(m=Math.floor(c/S),w?m===1?f?(0,y.localize)(38,null,m):(0,y.localize)(39,null,m):f?(0,y.localize)(40,null,m):(0,y.localize)(41,null,m):m===1?f?(0,y.localize)(42,null,m):(0,y.localize)(43,null,m):f?(0,y.localize)(44,null,m):(0,y.localize)(45,null,m)):(m=Math.floor(c/p),w?m===1?f?(0,y.localize)(46,null,m):(0,y.localize)(47,null,m):f?(0,y.localize)(48,null,m):(0,y.localize)(49,null,m):m===1?f?(0,y.localize)(50,null,m):(0,y.localize)(51,null,m):f?(0,y.localize)(52,null,m):(0,y.localize)(53,null,m))}e.$rm=v;function I(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$sm=I}),define(we[167],ve([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(we[40],ve([1,0,18,8,167]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function P(E,w){return w&&(E.stack||E.stacktrace)?s.localize(0,null,S(E),D(E.stack)||D(E.stacktrace)):S(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function S(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?s.localize(1,null,E.message):E.message||s.localize(2,null)}function p(E=null,w=!1){if(!E)return s.localize(3,null);if(Array.isArray(E)){const f=y.$Hb(E),g=p(f[0],w);return f.length>1?s.localize(4,null,g,f.length):g}if(A.$Ef(E))return E;if(E.detail){const f=E.detail;if(f.error)return P(f.error,w);if(f.exception)return P(f.exception,w)}return E.stack?P(E,w):E.message?E.message:s.localize(5,null)}e.$Mi=p;function v(E){const w=E;return w instanceof Error&&Array.isArray(w.actions)}e.$Ni=v;function I(E,w){let f;return typeof E=="string"?f=new Error(E):f=E,f.actions=w,f}e.$Oi=I}),define(we[168],ve([9,10]),function(he,e){return he.create("vs/base/common/jsonErrorMessages",e)}),define(we[169],ve([1,0,168]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;function A(s){switch(s){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.$Kp=A}),define(we[170],ve([9,10]),function(he,e){return he.create("vs/base/node/zip",e)}),define(we[81],ve([1,0,29,14,7,8,22,170]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.zip=e.$zp=e.$yp=void 0,e.$yp="end of central directory record signature not found";const p=new RegExp(e.$yp);class v extends Error{constructor(u,n){let i=n.message;switch(u){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=u,this.cause=n}}e.$zp=v;function I($){const u=$.externalFileAttributes>>16||33188;return[448,56,7].map(n=>u&n).reduce((n,i)=>n+i,u&61440)}function E($){if($ instanceof v)return $;let u;return p.test($.message)&&(u="CorruptZip"),new v(u,$)}function w($,u,n,i,o,r){const t=s.$mc(u),a=s.$jc(i,t);if(!a.startsWith(i))return Promise.reject(new Error(S.localize(0,null,u)));const b=s.$jc(i,u);let C;return r.onCancellationRequested(()=>{C?.destroy()}),Promise.resolve(D.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((L,k)=>{if(!r.isCancellationRequested)try{C=(0,y.createWriteStream)(b,{mode:n}),C.once("close",()=>L()),C.once("error",k),$.once("error",k),$.pipe(C)}catch(R){k(R)}}))}function f($,u,n,i){let o=(0,A.$Pg)(()=>Promise.resolve()),r=0;const t=i.onCancellationRequested(()=>{o.cancel(),$.close()});return new Promise((a,b)=>{const C=new A.$Wg,L=k=>{k.isCancellationRequested||(r++,$.readEntry())};$.once("error",b),$.once("close",()=>o.then(()=>{i.isCancellationRequested||$.entryCount===r?a():b(new v("Incomplete",new Error(S.localize(1,null,r,$.entryCount))))},b)),$.readEntry(),$.on("entry",k=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(k.fileName)){L(i);return}const R=k.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(R)){const ee=s.$jc(u,R);o=(0,A.$Pg)(G=>D.Promises.mkdir(ee,{recursive:!0}).then(()=>L(G)).then(void 0,b));return}const N=c($,k),Y=I(k);o=(0,A.$Pg)(ee=>C.queue(()=>N.then(G=>w(G,R,Y,u,n,ee).then(()=>L(ee)))).then(null,b))})}).finally(()=>t.dispose())}async function g($,u=!1){const{open:n}=await new Promise((i,o)=>{he(["yauzl"],i,o)});return new Promise((i,o)=>{n($,u?{lazyEntries:!0}:void 0,(r,t)=>{r?o(E(r)):i((0,P.$Pf)(t))})})}function c($,u){return new Promise((n,i)=>{$.openReadStream(u,(o,r)=>{o?i(E(o)):n((0,P.$Pf)(r))})})}async function m($,u){const{ZipFile:n}=await new Promise((i,o)=>{he(["yazl"],i,o)});return new Promise((i,o)=>{const r=new n;u.forEach(a=>{a.contents?r.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&r.addFile(a.localPath,a.path)}),r.end();const t=(0,y.createWriteStream)($);r.outputStream.pipe(t),r.outputStream.once("error",o),t.once("error",o),t.once("finish",()=>i($))})}e.zip=m;function h($,u,n={},i){const o=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=g($,!0);return n.overwrite&&(r=r.then(t=>D.Promises.rm(u).then(()=>t))),r.then(t=>f(t,u,{sourcePathRegex:o},i))}e.$Bp=h;function d($,u){return g($).then(n=>new Promise((i,o)=>{n.on("entry",r=>{r.fileName===u&&c(n,r).then(t=>i(t),t=>o(t))}),n.once("close",()=>o(new Error(S.localize(2,null,u))))}))}function l($,u){return d($,u).then(n=>new Promise((i,o)=>{const r=[];n.once("error",o),n.on("data",t=>r.push(t)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$Cp=l}),define(we[171],ve([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(we[172],ve([1,0,49,3,161,43,162,171]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$zt=e.$yt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$xt=e.$wt=e.SymbolKinds=e.SymbolTag=e.$vt=e.$ut=e.SymbolKind=e.$tt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$st=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$rt=e.$qt=e.$pt=void 0;class p{constructor(ne,Z,T){this.offset=ne,this.type=Z,this.language=T,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$pt=p;class v{constructor(ne,Z){this.tokens=ne,this.endState=Z,this._tokenizationResultBrand=void 0}}e.$qt=v;class I{constructor(ne,Z){this.tokens=ne,this.endState=Z,this._encodedTokenizationResultBrand=void 0}}e.$rt=I;var E;(function(G){G[G.Method=0]="Method",G[G.Function=1]="Function",G[G.Constructor=2]="Constructor",G[G.Field=3]="Field",G[G.Variable=4]="Variable",G[G.Class=5]="Class",G[G.Struct=6]="Struct",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Event=10]="Event",G[G.Operator=11]="Operator",G[G.Unit=12]="Unit",G[G.Value=13]="Value",G[G.Constant=14]="Constant",G[G.Enum=15]="Enum",G[G.EnumMember=16]="EnumMember",G[G.Keyword=17]="Keyword",G[G.Text=18]="Text",G[G.Color=19]="Color",G[G.File=20]="File",G[G.Reference=21]="Reference",G[G.Customcolor=22]="Customcolor",G[G.Folder=23]="Folder",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue",G[G.Snippet=27]="Snippet"})(E||(e.CompletionItemKind=E={}));var w;(function(G){const ne=new Map;ne.set(0,y.$8j.symbolMethod),ne.set(1,y.$8j.symbolFunction),ne.set(2,y.$8j.symbolConstructor),ne.set(3,y.$8j.symbolField),ne.set(4,y.$8j.symbolVariable),ne.set(5,y.$8j.symbolClass),ne.set(6,y.$8j.symbolStruct),ne.set(7,y.$8j.symbolInterface),ne.set(8,y.$8j.symbolModule),ne.set(9,y.$8j.symbolProperty),ne.set(10,y.$8j.symbolEvent),ne.set(11,y.$8j.symbolOperator),ne.set(12,y.$8j.symbolUnit),ne.set(13,y.$8j.symbolValue),ne.set(15,y.$8j.symbolEnum),ne.set(14,y.$8j.symbolConstant),ne.set(15,y.$8j.symbolEnum),ne.set(16,y.$8j.symbolEnumMember),ne.set(17,y.$8j.symbolKeyword),ne.set(27,y.$8j.symbolSnippet),ne.set(18,y.$8j.symbolText),ne.set(19,y.$8j.symbolColor),ne.set(20,y.$8j.symbolFile),ne.set(21,y.$8j.symbolReference),ne.set(22,y.$8j.symbolCustomColor),ne.set(23,y.$8j.symbolFolder),ne.set(24,y.$8j.symbolTypeParameter),ne.set(25,y.$8j.account),ne.set(26,y.$8j.issues);function Z(Q){let te=ne.get(Q);return te||(console.info("No codicon found for CompletionItemKind "+Q),te=y.$8j.symbolProperty),te}G.toIcon=Z;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function oe(Q,te){let J=T.get(Q);return typeof J>"u"&&!te&&(J=9),J}G.fromString=oe})(w||(e.CompletionItemKinds=w={}));var f;(function(G){G[G.Deprecated=1]="Deprecated"})(f||(e.CompletionItemTag=f={}));var g;(function(G){G[G.None=0]="None",G[G.KeepWhitespace=1]="KeepWhitespace",G[G.InsertAsSnippet=4]="InsertAsSnippet"})(g||(e.CompletionItemInsertTextRule=g={}));var c;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var m;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class h{constructor(ne,Z,T,oe){this.range=ne,this.text=Z,this.completionKind=T,this.isSnippetText=oe}equals(ne){return P.$Hs.lift(this.range).equalsRange(ne.range)&&this.text===ne.text&&this.completionKind===ne.completionKind&&this.isSnippetText===ne.isSnippetText}}e.$st=h;var d;(function(G){G[G.Invoke=1]="Invoke",G[G.Auto=2]="Auto"})(d||(e.CodeActionTriggerType=d={}));var l;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var $;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})($||(e.DocumentHighlightKind=$={}));function u(G){return G&&A.URI.isUri(G.uri)&&P.$Hs.isIRange(G.range)&&(P.$Hs.isIRange(G.originSelectionRange)||P.$Hs.isIRange(G.targetSelectionRange))}e.$tt=u;var n;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(n||(e.SymbolKind=n={})),e.$ut={[17]:(0,S.localize)(0,null),[16]:(0,S.localize)(1,null),[4]:(0,S.localize)(2,null),[13]:(0,S.localize)(3,null),[8]:(0,S.localize)(4,null),[9]:(0,S.localize)(5,null),[21]:(0,S.localize)(6,null),[23]:(0,S.localize)(7,null),[7]:(0,S.localize)(8,null),[0]:(0,S.localize)(9,null),[11]:(0,S.localize)(10,null),[10]:(0,S.localize)(11,null),[19]:(0,S.localize)(12,null),[5]:(0,S.localize)(13,null),[1]:(0,S.localize)(14,null),[2]:(0,S.localize)(15,null),[20]:(0,S.localize)(16,null),[15]:(0,S.localize)(17,null),[18]:(0,S.localize)(18,null),[24]:(0,S.localize)(19,null),[3]:(0,S.localize)(20,null),[6]:(0,S.localize)(21,null),[14]:(0,S.localize)(22,null),[22]:(0,S.localize)(23,null),[25]:(0,S.localize)(24,null),[12]:(0,S.localize)(25,null)};function i(G,ne){return(0,S.localize)(26,null,G,e.$ut[ne])}e.$vt=i;var o;(function(G){G[G.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var r;(function(G){const ne=new Map;ne.set(0,y.$8j.symbolFile),ne.set(1,y.$8j.symbolModule),ne.set(2,y.$8j.symbolNamespace),ne.set(3,y.$8j.symbolPackage),ne.set(4,y.$8j.symbolClass),ne.set(5,y.$8j.symbolMethod),ne.set(6,y.$8j.symbolProperty),ne.set(7,y.$8j.symbolField),ne.set(8,y.$8j.symbolConstructor),ne.set(9,y.$8j.symbolEnum),ne.set(10,y.$8j.symbolInterface),ne.set(11,y.$8j.symbolFunction),ne.set(12,y.$8j.symbolVariable),ne.set(13,y.$8j.symbolConstant),ne.set(14,y.$8j.symbolString),ne.set(15,y.$8j.symbolNumber),ne.set(16,y.$8j.symbolBoolean),ne.set(17,y.$8j.symbolArray),ne.set(18,y.$8j.symbolObject),ne.set(19,y.$8j.symbolKey),ne.set(20,y.$8j.symbolNull),ne.set(21,y.$8j.symbolEnumMember),ne.set(22,y.$8j.symbolStruct),ne.set(23,y.$8j.symbolEvent),ne.set(24,y.$8j.symbolOperator),ne.set(25,y.$8j.symbolTypeParameter);function Z(T){let oe=ne.get(T);return oe||(console.info("No codicon found for SymbolKind "+T),oe=y.$8j.symbolProperty),oe}G.toIcon=Z})(r||(e.SymbolKinds=r={}));class t{static asEditOperation(ne){return s.$Is.replace(P.$Hs.lift(ne.range),ne.text)}}e.$wt=t;class a{static fromValue(ne){switch(ne){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(ne)}constructor(ne){this.value=ne}}e.$xt=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var b;(function(G){function ne(Z){return!Z||typeof Z!="object"?!1:typeof Z.id=="string"&&typeof Z.title=="string"}G.is=ne})(b||(e.Command=b={}));var C;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(C||(e.CommentThreadCollapsibleState=C={}));var L;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(L||(e.CommentThreadState=L={}));var k;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(k||(e.CommentMode=k={}));var R;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(R||(e.CommentState=R={}));var N;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(N||(e.InlayHintKind=N={}));class Y{constructor(ne){this.b=ne,this.a=null}dispose(){this.a&&this.a.then(ne=>{ne&&ne.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$yt=Y,e.$zt=new D.$gt;var ee;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(ee||(e.ExternalUriOpenerPriority=ee={}))}),define(we[173],ve([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[174],ve([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(we[175],ve([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(we[176],ve([9,10]),function(he,e){return he.create("vs/platform/environment/node/argv",e)}),define(we[177],ve([9,10]),function(he,e){return he.create("vs/platform/environment/node/argvHelper",e)}),define(we[178],ve([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[179],ve([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[180],ve([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(we[181],ve([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(we[182],ve([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[183],ve([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[184],ve([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[185],ve([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[186],ve([9,10]),function(he,e){return he.create("vs/platform/files/common/fileService",e)}),define(we[187],ve([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(we[188],ve([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(we[189],ve([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[190],ve([9,10]),function(he,e){return he.create("vs/platform/languagePacks/common/languagePacks",e)}),define(we[191],ve([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(we[192],ve([9,10]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(we[193],ve([9,10]),function(he,e){return he.create("vs/platform/shell/node/shellEnv",e)}),define(we[194],ve([9,10]),function(he,e){return he.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[195],ve([9,10]),function(he,e){return he.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[196],ve([9,10]),function(he,e){return he.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[197],ve([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(we[198],ve([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(we[199],ve([9,10]),function(he,e){return he.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(we[200],ve([9,10]),function(he,e){return he.create("vs/server/node/serverEnvironmentService",e)}),define(we[201],ve([9,10]),function(he,e){return he.create("vs/server/node/serverServices",e)}),define(we[202],ve([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(we[203],ve([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(we[204],ve([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[205],ve([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(we[206],ve([1,0,11,175]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var s;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(s||(e.TokenType=s={}));function P(...v){switch(v.length){case 1:return(0,A.localize)(0,null,v[0]);case 2:return(0,A.localize)(1,null,v[0],v[1]);case 3:return(0,A.localize)(2,null,v[0],v[1],v[2]);default:return}}const D=(0,A.localize)(3,null),S=(0,A.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(I){return this.c=I,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(I){return this.r()||this.c.charCodeAt(this.e)!==I?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(I){this.f.push({type:I,offset:this.d})}l(I){const E=this.d,w=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:w};this.g.push({offset:E,lexeme:w,additionalInfo:I}),this.f.push(f)}n(){this.m.lastIndex=this.d;const I=this.m.exec(this.c);if(I){this.e=this.d+I[0].length;const E=this.c.substring(this.d,this.e),w=p.b.get(E);w?this.k(w):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let I=this.e,E=!1,w=!1;for(;;){if(I>=this.c.length){this.e=I,this.l(S);return}const g=this.c.charCodeAt(I);if(E)E=!1;else if(g===47&&!w){I++;break}else g===91?w=!0:g===92?E=!0:g===93&&(w=!1);I++}for(;I<this.c.length&&p.a.has(this.c.charCodeAt(I));)I++;this.e=I;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=p,p.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0))),p.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(we[207],ve([1,0,5,2]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=void 0;class s{constructor(){this.a=new y.$Sd,this.b=new y.$Sd,this.c=new y.$Sd,this.d=new y.$Sd}call(S,p,v){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:v[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:v[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:v[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:v[0],port:v[1],subId:v[2]}))}throw new Error("Method not implemented.")}listen(S,p,v){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$1n=s,s.ChannelName="extensionhostdebugservice";class P extends A.$Sc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,p,v){this.b.call("attach",[S,p,v])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,p){this.b.call("terminate",[S,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,p){return this.b.call("openExtensionDevelopmentHostWindow",[S,p])}}e.$2n=P}),define(we[208],ve([1,0,3]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=void 0;class A{constructor(D){this.a=D}listen(D,S,p){throw new Error("Invalid listen")}call(D,S,p){switch(S){case"download":return this.a.download(y.URI.revive(p[0]),y.URI.revive(p[1]))}throw new Error("Invalid call")}}e.$4n=A;class s{constructor(D,S){this.a=D,this.b=S}async download(D,S){const p=this.b();p&&(D=p.transformOutgoingURI(D),S=p.transformOutgoingURI(S)),await this.a.call("download",[D,S])}}e.$5n=s}),define(we[209],ve([1,0,166,74,12,7,28,19,3]),function(he,e,y,A,s,P,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=e.$um=e.$tm=void 0,e.$tm=/^([^.]+\..+):(.+)$/;class v{get appRoot(){return(0,P.$mc)(s.$kg.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,P.$jc)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Dg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Dg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,y.$sm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.$jc)(this.userDataPath,"logs",f)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Dg)(p.URI.file((0,P.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Dg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Dg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Dg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=D.env.VSCODE_PORTABLE;return f?p.URI.file((0,P.$jc)(f,"argv.json")):(0,S.$Dg)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,P.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,P.$kc)(f):(0,P.$hc)((0,P.$jc)(s.$kg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?p.URI.file((0,P.$kc)(f)):p.URI.file((0,P.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,P.$kc)(f);const g=D.env.VSCODE_EXTENSIONS;if(g)return g;const c=D.env.VSCODE_PORTABLE;return c?(0,P.$jc)(c,"extensions"):(0,S.$Dg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(g=>/^[^:/?#]+?:\/\//.test(g)?p.URI.parse(g):p.URI.file((0,P.$hc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?p.URI.parse(f):p.URI.file((0,P.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$tm.test(f))}get extensionLogLevel(){const f=[];for(const g of this.args.log||[]){const c=e.$tm.exec(g);c&&c[1]&&c[2]&&f.push([c[1],c[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,S.$Dg)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=D.env.VSCODE_PORTABLE;return f?p.URI.file((0,P.$jc)(f,"policy.json")):(0,S.$Dg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,g,c){this.a=f,this.b=g,this.c=c,this.editSessionId=this.args.editSessionId}}e.$um=v,Ne([A.$th],v.prototype,"appRoot",null),Ne([A.$th],v.prototype,"userHome",null),Ne([A.$th],v.prototype,"userDataPath",null),Ne([A.$th],v.prototype,"appSettingsHome",null),Ne([A.$th],v.prototype,"tmpDir",null),Ne([A.$th],v.prototype,"cacheHome",null),Ne([A.$th],v.prototype,"stateResource",null),Ne([A.$th],v.prototype,"userRoamingDataHome",null),Ne([A.$th],v.prototype,"userDataSyncHome",null),Ne([A.$th],v.prototype,"sync",null),Ne([A.$th],v.prototype,"machineSettingsResource",null),Ne([A.$th],v.prototype,"workspaceStorageHome",null),Ne([A.$th],v.prototype,"localHistoryHome",null),Ne([A.$th],v.prototype,"keyboardLayoutResource",null),Ne([A.$th],v.prototype,"argvResource",null),Ne([A.$th],v.prototype,"isExtensionDevelopment",null),Ne([A.$th],v.prototype,"untitledWorkspacesHome",null),Ne([A.$th],v.prototype,"builtinExtensionsPath",null),Ne([A.$th],v.prototype,"extensionsPath",null),Ne([A.$th],v.prototype,"extensionDevelopmentLocationURI",null),Ne([A.$th],v.prototype,"extensionDevelopmentKind",null),Ne([A.$th],v.prototype,"extensionTestsLocationURI",null),Ne([A.$th],v.prototype,"debugExtensionHost",null),Ne([A.$th],v.prototype,"logLevel",null),Ne([A.$th],v.prototype,"extensionLogLevel",null),Ne([A.$th],v.prototype,"serviceMachineIdResource",null),Ne([A.$th],v.prototype,"disableTelemetry",null),Ne([A.$th],v.prototype,"disableWorkspaceTrust",null),Ne([A.$th],v.prototype,"useInMemorySecretStorage",null),Ne([A.$th],v.prototype,"policyFile",null);function I(w,f){return E(w["inspect-extensions"],w["inspect-brk-extensions"],5870,f,w.debugId,w.extensionEnvironment)}e.$vm=I;function E(w,f,g,c,m,h){const l=Number(f||w)||(c?null:g),$=l?!!f:!1;let u;if(h)try{u=JSON.parse(h)}catch{}return{port:l,break:$,debugId:m,env:u}}e.$wm=E}),define(we[66],ve([1,0,300,4,176]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0;const P={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Sl=["tunnel","serve-web"],e.$Tl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(c,m,h=D){const d=c.find(a=>a.length>0&&a[0]!=="-"),l={},$=["_"],u=[],n={};let i;for(const a in m){const b=m[a];b.type==="subcommand"?a===d&&(i=b):(b.alias&&(l[a]=b.alias),b.type==="string"||b.type==="string[]"?($.push(a),b.deprecates&&$.push(...b.deprecates)):b.type==="boolean"&&(u.push(a),b.deprecates&&u.push(...b.deprecates)),b.global&&(n[a]=b))}if(i&&d){const a=n;for(const k in i.options)a[k]=i.options[k];const b=c.filter(k=>k!==d),C=h.getSubcommandReporter?h.getSubcommandReporter(d):void 0,L=S(b,a,C);return{[d]:L,_:[]}}const o=y(c,{string:$,boolean:u,alias:l}),r={},t=o;r._=o._.map(a=>String(a)).filter(a=>a.length>0),delete t._;for(const a in m){const b=m[a];if(b.type==="subcommand")continue;b.alias&&delete t[b.alias];let C=t[a];if(b.deprecates)for(const L of b.deprecates)t.hasOwnProperty(L)&&(C||(C=t[L],C&&h.onDeprecatedOption(L,b.deprecationMessage||(0,s.localize)(37,null,a))),delete t[L]);if(typeof C<"u"){if(b.type==="string[]"){if(Array.isArray(C)||(C=[C]),!b.allowEmptyValue){const L=C.filter(k=>k.length>0);L.length!==C.length&&(h.onEmptyValue(a),C=L.length>0?L:void 0)}}else b.type==="string"&&(Array.isArray(C)?(C=C.pop(),h.onMultipleValues(a,C)):!C&&!b.allowEmptyValue&&(h.onEmptyValue(a),C=void 0));r[a]=C,b.deprecationMessage&&h.onDeprecatedOption(a,b.deprecationMessage)}delete t[a]}for(const a in t)h.onUnknownOption(a);return r}e.$Ul=S;function p(c,m){let h="";return m.args&&(Array.isArray(m.args)?h=` <${m.args.join("> <")}>`:h=` <${m.args}>`),m.alias?`-${m.alias} --${c}${h}`:`--${c}${h}`}function v(c,m){const h=[];for(const d in c){const l=c[d],$=p(d,l);h.push([$,l.description])}return I(h,m)}e.$Vl=v;function I(c,m){const d=c.reduce((u,n)=>Math.max(u,n[0].length),12)+2+1;if(m-d<25)return c.reduce((u,n)=>u.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const l=m-d-1,$=[];for(const u of c){const n=u[0],i=w(u[1],l),o=E(d-n.length-2);$.push("  "+n+o+i[0]);for(let r=1;r<i.length;r++)$.push(E(d)+i[r])}return $}function E(c){return" ".repeat(c)}function w(c,m){const h=[];for(;c.length;){const d=c.length<m?c.length:c.lastIndexOf(" ",m),l=c.slice(0,d).trim();c=c.slice(d),h.push(l)}return h}function f(c,m,h,d,l){const $=process.stdout.isTTY&&process.stdout.columns||80,u=l?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",n=[`${c} ${h}`];n.push(""),n.push(`${(0,s.localize)(39,null)}: ${m} [${(0,s.localize)(40,null)}]${u}`),n.push(""),l?.noPipe!==!0&&(A.$c?n.push((0,s.localize)(41,null,m)):n.push((0,s.localize)(42,null,m)),n.push(""));const i={},o=[];for(const r in d){const t=d[r];if(t.type==="subcommand")t.description&&o.push({command:r,description:t.description});else if(t.description&&t.cat){let a=i[t.cat];a||(i[t.cat]=a={}),a[r]=t}}for(const r in i){const t=r,a=i[t];a&&(n.push(P[t]),n.push(...v(a,$)),n.push(""))}return o.length&&(n.push((0,s.localize)(43,null)),n.push(...I(o.map(r=>[r.command,r.description]),$)),n.push("")),n.join(`
`)}e.$Wl=f;function g(c,m){return`${c||(0,s.localize)(44,null)}
${m||(0,s.localize)(45,null)}
${process.arch}`}e.$Xl=g}),define(we[210],ve([1,0,301,177,66]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=void 0;function P(E,w){const f=(l,$)=>{console.warn((0,A.localize)(0,null,l,$))},g=l=>{console.warn((0,A.localize)(1,null,l))},c=(l,$)=>{console.warn((0,A.localize)(2,null,l,$))},m=l=>({onUnknownOption:$=>{s.$Sl.includes(l)||console.warn((0,A.localize)(3,null,$,l))},onMultipleValues:f,onEmptyValue:g,onDeprecatedOption:c,getSubcommandReporter:s.$Sl.includes(l)?m:void 0}),h={onUnknownOption:l=>{console.warn((0,A.localize)(4,null,l))},onMultipleValues:f,onEmptyValue:g,onDeprecatedOption:c,getSubcommandReporter:m},d=(0,s.$Ul)(E,s.$Tl,w?h:void 0);return d.goto&&d._.forEach(l=>y(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,A.localize)(5,null))),d}function D(E){const w=E.findIndex(f=>!/^-/.test(f));if(w>-1)return[...E.slice(0,w),...E.slice(w+1)]}function S(E){let[,...w]=E;process.env.VSCODE_DEV&&(w=D(w)||[]);const f=!I(process.env);return P(w,f)}e.$Yl=S;function p(E){let[,,...w]=E;return process.env.VSCODE_DEV&&(w=D(w)||[]),P(w,!0)}e.$Zl=p;function v(E,...w){const f=E.indexOf("--");return f===-1?E.push(...w):E.splice(f,0,...w),E}e.$1l=v;function I(E){return E.VSCODE_CLI==="1"}e.$2l=I}),function(){"use strict";function he(e,y,A){function s(D,S){const p=P(D,S),v=[p];return e.isAbsolute(p)||v.unshift(A),e.resolve(...v)}function P(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,S);const I=D["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(E,"AppData","Roaming")}break;case"darwin":v=e.join(y.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,S)}return{getUserDataPath:s}}if(typeof define=="function")define(we[211],ve([78,27,28]),function(e,y,A){return he(e,y,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=he(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[109],ve([1,0,27,209,211]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;class P extends A.$um{constructor(v,I){super(v,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,s.getUserDataPath)(v,I.nameShort)},I)}}e.$xm=P;function D(p,v){return(0,A.$wm)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,v,p.extensionEnvironment)}e.$ym=D;function S(p,v){return(0,A.$wm)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,v,p.extensionEnvironment)}e.$zm=S}),define(we[212],ve([1,0,8,181]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;function s(D,S,p,v){try{P(D,S,p,v)}catch(I){D.error(I?.message??I)}return S}e.$Lp=s;function P(D,S,p,v){const I=(E,w,f)=>{const g=E[w];if((0,y.$Ef)(g)){const c=g,m=c.length;if(m>1&&c[0]==="%"&&c[m-1]==="%"){const h=c.substr(1,m-2);let d=p[h];d===void 0&&v&&(d=v[h]);const l=typeof d=="string"?d:d?.message,$=v?.[h],u=typeof $=="string"?$:$?.message;if(!l){u||D.warn(`[${S.name}]: ${(0,A.localize)(0,null,h)}`);return}if(f&&(w==="title"||w==="category")&&u&&u!==l){const n={value:l,original:u};E[w]=n}else E[w]=l}}else if((0,y.$Gf)(g))for(const c in g)g.hasOwnProperty(c)&&(c==="commands"?I(g,c,!0):I(g,c,f));else if(Array.isArray(g))for(let c=0;c<g.length;c++)I(g,c,f)};for(const E in S)S.hasOwnProperty(E)&&I(S,E)}}),define(we[213],ve([1,0,81,184]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;function s(P){return(0,y.$Cp)(P,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.$Tp=s}),define(we[82],ve([1,0,19,64,185,53]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function p(h){return h=h.trim(),h==="*"||D.test(h)}e.$Zo=p;function v(h){if(!p(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=h.match(D);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.$1o=v;function I(h){if(!h)return null;const d=h.majorBase,l=h.majorMustEqual,$=h.minorBase;let u=h.minorMustEqual;const n=h.patchBase;let i=h.patchMustEqual;h.hasCaret&&(d===0||(u=!1),i=!1);let o=0;if(h.preRelease){const r=S.exec(h.preRelease);if(r){const[,t,a,b]=r;o=Date.UTC(Number(t),Number(a)-1,Number(b))}}return{majorBase:d,majorMustEqual:l,minorBase:$,minorMustEqual:u,patchBase:n,patchMustEqual:i,isMinimum:h.hasGreaterEquals,notBefore:o}}e.$2o=I;function E(h,d,l){let $;typeof h=="string"?$=I(v(h)):$=h;let u;d instanceof Date?u=d.getTime():typeof d=="string"&&(u=new Date(d).getTime());let n;if(typeof l=="string"?n=I(v(l)):n=l,!$||!n)return!1;const i=$.majorBase,o=$.minorBase,r=$.patchBase;let t=n.majorBase,a=n.minorBase,b=n.patchBase;const C=n.notBefore;let L=n.majorMustEqual,k=n.minorMustEqual,R=n.patchMustEqual;return n.isMinimum?i>t?!0:i<t?!1:o>a?!0:o<a||u&&u<C?!1:r>=b:(i===1&&t===0&&(!L||!k||!R)&&(t=1,a=0,b=0,L=!0,k=!1,R=!1),i<t?!1:i>t?!L:o<a?!1:o>a?!k:r<b?!1:r>b?!R:!(u&&u<C))}e.$3o=E;function w(h,d,l,$,u){const n=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return n.push([A.default.Error,s.localize(0,null)]),n;if(typeof $.name!="string")return n.push([A.default.Error,s.localize(1,null,"name")]),n;if(typeof $.version!="string")return n.push([A.default.Error,s.localize(2,null,"version")]),n;if(!$.engines)return n.push([A.default.Error,s.localize(3,null,"engines")]),n;if(typeof $.engines.vscode!="string")return n.push([A.default.Error,s.localize(4,null,"engines.vscode")]),n;if(typeof $.extensionDependencies<"u"&&!m($.extensionDependencies))return n.push([A.default.Error,s.localize(5,null,"extensionDependencies")]),n;if(typeof $.activationEvents<"u"){if(!m($.activationEvents))return n.push([A.default.Error,s.localize(6,null,"activationEvents")]),n;if(typeof $.main>"u"&&typeof $.browser>"u")return n.push([A.default.Error,s.localize(7,null,"activationEvents","main","browser")]),n}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&n.push([A.default.Warning,s.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return n.push([A.default.Error,s.localize(9,null,"main")]),n;{const r=(0,y.$Dg)(l,$.main);(0,y.$xg)(r,l)||n.push([A.default.Warning,s.localize(10,null,r.path,l.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return n.push([A.default.Error,s.localize(11,null,"browser")]),n;{const r=(0,y.$Dg)(l,$.browser);(0,y.$xg)(r,l)||n.push([A.default.Warning,s.localize(12,null,r.path,l.path)])}}if(!P.valid($.version))return n.push([A.default.Error,s.localize(13,null)]),n;const i=[];if(!f(h,d,$,u,i))for(const r of i)n.push([A.default.Error,r]);return n}e.$4o=w;function f(h,d,l,$,u){return $||typeof l.main>"u"&&typeof l.browser>"u"?!0:c(h,d,l.engines.vscode,u)}e.$5o=f;function g(h,d,l){return h==="*"||c(d,l,h)}e.$6o=g;function c(h,d,l,$=[]){const u=I(v(l));if(!u)return $.push(s.localize(14,null,l)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return $.push(s.localize(15,null,l)),!1}else if(!u.majorMustEqual)return $.push(s.localize(16,null,l)),!1;return E(h,d,u)?!0:($.push(s.localize(17,null,h,l)),!1)}function m(h){if(!Array.isArray(h))return!1;for(let d=0,l=h.length;d<l;d++)if(typeof h[d]!="string")return!1;return!0}}),define(we[214],ve([1,0,15,21]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;async function s(P,D,S){let p=S&&S.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const I=(await D.readFile(P.serviceMachineIdResource)).value.toString();p=(0,A.$lg)(I)?I:null}catch{p=null}if(!p){p=(0,A.$mg)();try{await D.writeFile(P.serviceMachineIdResource,y.$ge.fromString(p))}catch{}}return S?.store("storage.serviceMachineId",p,-1,1),p}e.$np=s}),define(we[67],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class y{constructor(s,P=[],D=!1){this.ctor=s,this.staticArguments=P,this.supportsDelayedInstantiation=D}}e.$Yh=y}),define(we[215],ve([1,0,67]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.InstantiationType=void 0;const A=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function P(S,p,v){p instanceof y.$Yh||(p=new y.$Yh(p,[],!!v)),A.push([S,p])}e.$Kr=P;function D(){return A}e.$Lr=D}),define(we[216],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;class y{constructor(P,D){this.key=P,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$pq=y;class A{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const D of this.a.values())D.outgoing.size===0&&P.push(D);return P}insertEdge(P,D){const S=this.lookupOrInsertNode(P),p=this.lookupOrInsertNode(D);S.outgoing.set(p.key,p),p.incoming.set(S.key,S)}removeNode(P){const D=this.b(P);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(P){const D=this.b(P);let S=this.a.get(D);return S||(S=new y(D,P),this.a.set(D,S)),S}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[D,S]of this.a)P.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,D]of this.a){const S=new Set([P]),p=this.c(D,S);if(p)return p}}c(P,D){for(const[S,p]of P.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const v=this.c(p,D);if(v)return v;D.delete(S)}}}e.$qq=A}),define(we[6],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var y;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(p){return p[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(y||(e._util=y={})),e.$1h=s("instantiationService");function A(D,S,p){S[y.DI_TARGET]===S?S[y.DI_DEPENDENCIES].push({id:D,index:p}):(S[y.DI_DEPENDENCIES]=[{id:D,index:p}],S[y.DI_TARGET]=S)}function s(D){if(y.serviceIds.has(D))return y.serviceIds.get(D);const S=function(p,v,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(S,p,I)};return S.toString=()=>D,y.serviceIds.set(D,S),S}e.$2h=s;function P(D){return D}e.$3h=P}),define(we[24],ve([1,0,8,3,6]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,s.$2h)("configurationService");function P(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof A.URI)}e.$wi=P;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof A.URI)}e.$xi=D;var S;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function p(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=p;function v(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$zi=v;function I(h,d){const l=Object.create(null);for(const $ in h)E(l,$,h[$],d);return l}e.$Ai=I;function E(h,d,l,$){const u=d.split("."),n=u.pop();let i=h;for(let o=0;o<u.length;o++){const r=u[o];let t=i[r];switch(typeof t){case"undefined":t=i[r]=Object.create(null);break;case"object":break;default:$(`Ignoring ${d} as ${u.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}i=t}if(typeof i=="object"&&i!==null)try{i[n]=l}catch{$(`Ignoring ${d} as ${u.join(".")} is ${JSON.stringify(i)}`)}else $(`Ignoring ${d} as ${u.join(".")} is ${JSON.stringify(i)}`)}e.$Bi=E;function w(h,d){const l=d.split(".");f(h,l)}e.$Ci=w;function f(h,d){const l=d.shift();if(d.length===0){delete h[l];return}if(Object.keys(h).indexOf(l)!==-1){const $=h[l];typeof $=="object"&&!Array.isArray($)&&(f($,d),Object.keys($).length===0&&delete h[l])}}function g(h,d,l){function $(i,o){let r=i;for(const t of o){if(typeof r!="object"||r===null)return;r=r[t]}return r}const u=d.split("."),n=$(h,u);return typeof n>"u"?l:n}e.$Di=g;function c(h,d,l){Object.keys(d).forEach($=>{$!=="__proto__"&&($ in h?y.$Gf(h[$])&&y.$Gf(d[$])?c(h[$],d[$],l):l&&(h[$]=d[$]):h[$]=d[$])})}e.$Ei=c;function m(h){return h.replace(/[\[\]]/g,"")}e.$Fi=m}),define(we[68],ve([1,0,4,17,206,6,174,11]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",y.$d),p.set("isLinux",y.$e),p.set("isWindows",y.$c),p.set("isWeb",y.$i),p.set("isMacNative",y.$d&&!y.$i),p.set("isEdge",y.$B),p.set("isFirefox",y.$z),p.set("isChrome",y.$y),p.set("isSafari",y.$A);function v(W,O){if(p.get(W)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(W,O)}e.$Xi=v;const I=Object.prototype.hasOwnProperty;var E;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const w={regexParsingWithErrorRecovery:!0},f=(0,D.localize)(0,null),g=(0,D.localize)(1,null),c=(0,D.localize)(2,null),m=(0,D.localize)(3,null),h=(0,D.localize)(4,null),d=(0,D.localize)(5,null),l=(0,D.localize)(6,null),$=(0,D.localize)(7,null);class u{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=w){this.k=O,this.d=new s.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const re=this.D(),X=re.type===17?d:void 0;throw this.h.push({message:h,offset:re.offset,lexeme:s.$Wi.getLexeme(re),additionalInfo:X}),u.c}return j}catch(j){if(j!==u.c)throw j;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const j=this.o();O.push(j)}return O.length===1?O[0]:n.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const j=this.s();O.push(j)}return O.length===1?O[0]:n.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,m),j?.negate()}case 17:return this.z(),N.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const j=this.l();return this.A(1,m),j}case 17:{const j=O.lexeme;if(this.z(),this.y(9)){const X=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),X.type!==10)throw this.B("REGEX",X);const x=X.lexeme,z=x.lastIndexOf("/"),q=z===x.length-1?void 0:this.w(x.substring(z+1));let M;try{M=new RegExp(x.substring(1,z),q)}catch{throw this.B("REGEX",X)}return T.create(j,M)}switch(X.type){case 10:case 19:{const x=[X.lexeme];this.z();let z=this.D(),q=0;for(let fe=0;fe<X.lexeme.length;fe++)X.lexeme.charCodeAt(fe)===40?q++:X.lexeme.charCodeAt(fe)===41&&q--;for(;!this.E()&&z.type!==15&&z.type!==16;){switch(z.type){case 0:q++;break;case 1:q--;break;case 10:case 18:for(let fe=0;fe<z.lexeme.length;fe++)z.lexeme.charCodeAt(fe)===40?q++:X.lexeme.charCodeAt(fe)===41&&q--}if(q<0)break;x.push(s.$Wi.getLexeme(z)),this.z(),z=this.D()}const M=x.join(""),H=M.lastIndexOf("/"),_=H===M.length-1?void 0:this.w(M.substring(H+1));let ae;try{ae=new RegExp(M.substring(1,H),_)}catch{throw this.B("REGEX",X)}return n.regex(j,ae)}case 18:{const x=X.lexeme;this.z();let z=null;if(!(0,A.$Ge)(x)){const q=x.indexOf("/"),M=x.lastIndexOf("/");if(q!==M&&q>=0){const H=x.slice(q+1,M),_=x[M+1]==="i"?"i":"";try{z=new RegExp(H,_)}catch{throw this.B("REGEX",X)}}}if(z===null)throw this.B("REGEX",X);return T.create(j,z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const X=this.u();return n.notIn(j,X)}switch(this.D().type){case 3:{this.z();const X=this.u();if(this.x().type===18)return n.equals(j,X);switch(X){case"true":return n.has(j);case"false":return n.not(j);default:return n.equals(j,X)}}case 4:{this.z();const X=this.u();if(this.x().type===18)return n.notEquals(j,X);switch(X){case"true":return n.not(j);case"false":return n.has(j);default:return n.notEquals(j,X)}}case 5:return this.z(),ne.create(j,this.u());case 6:return this.z(),Z.create(j,this.u());case 7:return this.z(),ee.create(j,this.u());case 8:return this.z(),G.create(j,this.u());case 13:return this.z(),n.in(j,this.u());default:return n.has(j)}}case 20:throw this.h.push({message:l,offset:O.offset,lexeme:"",additionalInfo:$}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,j){if(this.C(O))return this.z();throw this.B(j,this.D())}B(O,j,re){const X=(0,D.localize)(8,null,O,s.$Wi.getLexeme(j)),x=j.offset,z=s.$Wi.getLexeme(j);return this.h.push({message:X,offset:x,lexeme:z,additionalInfo:re}),u.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=u,u.c=new Error;class n{static false(){return t.INSTANCE}static true(){return a.INSTANCE}static has(O){return b.create(O)}static equals(O,j){return C.create(O,j)}static notEquals(O,j){return R.create(O,j)}static regex(O,j){return T.create(O,j)}static in(O,j){return L.create(O,j)}static notIn(O,j){return k.create(O,j)}static not(O){return N.create(O)}static and(...O){return te.create(O,null,!0)}static or(...O){return J.create(O,null,!0)}static greater(O,j){return ee.create(O,j)}static greaterEquals(O,j){return G.create(O,j)}static smaller(O,j){return ne.create(O,j)}static smallerEquals(O,j){return Z.create(O,j)}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Zi=n,n.c=new u({regexParsingWithErrorRecovery:!1});function i(W){const O=new u({regexParsingWithErrorRecovery:!1});return W.map(j=>(O.parse(j),O.lexingErrors.length>0?O.lexingErrors.map(re=>({errorMessage:re.additionalInfo?(0,D.localize)(9,null,re.additionalInfo):(0,D.localize)(10,null),offset:re.offset,length:re.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(re=>({errorMessage:re.additionalInfo?`${re.message}. ${re.additionalInfo}`:re.message,offset:re.offset,length:re.lexeme.length})):[]))}e.$1i=i;function o(W,O){const j=W?W.substituteConstants():void 0,re=O?O.substituteConstants():void 0;return!j&&!re?!0:!j||!re?!1:j.equals(re)}e.$2i=o;function r(W,O){return W.cmp(O)}class t{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return a.INSTANCE}}e.$3i=t,t.INSTANCE=new t;class a{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return t.INSTANCE}}e.$4i=a,a.INSTANCE=new a;class b{static create(O,j=null){const re=p.get(O);return typeof re=="boolean"?re?a.INSTANCE:t.INSTANCE:new b(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=p.get(this.key);return typeof O=="boolean"?O?a.INSTANCE:t.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$5i=b;class C{static create(O,j,re=null){if(typeof j=="boolean")return j?b.create(O,re):N.create(O,re);const X=p.get(O);return typeof X=="boolean"?j===(X?"true":"false")?a.INSTANCE:t.INSTANCE:new C(O,j,re)}constructor(O,j,re){this.c=O,this.d=j,this.f=re,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=p.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?a.INSTANCE:t.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$6i=C;class L{static create(O,j){return new L(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),re=O.getValue(this.d);return Array.isArray(j)?j.includes(re):typeof re=="string"&&typeof j=="object"&&j!==null?I.call(j,re):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$7i=L;class k{static create(O,j){return new k(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=L.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=k;class R{static create(O,j,re=null){if(typeof j=="boolean")return j?N.create(O,re):b.create(O,re);const X=p.get(O);return typeof X=="boolean"?j===(X?"true":"false")?t.INSTANCE:a.INSTANCE:new R(O,j,re)}constructor(O,j,re){this.c=O,this.d=j,this.f=re,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=p.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?t.INSTANCE:a.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$9i=R;class N{static create(O,j=null){const re=p.get(O);return typeof re=="boolean"?re?t.INSTANCE:a.INSTANCE:new N(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:ie(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=p.get(this.c);return typeof O=="boolean"?O?t.INSTANCE:a.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$0i=N;function Y(W,O){if(typeof W=="string"){const j=parseFloat(W);isNaN(j)||(W=j)}return typeof W=="string"||typeof W=="number"?O(W):t.INSTANCE}class ee{static create(O,j,re=null){return Y(j,X=>new ee(O,X,re))}constructor(O,j,re){this.c=O,this.d=j,this.f=re,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$$i=ee;class G{static create(O,j,re=null){return Y(j,X=>new G(O,X,re))}constructor(O,j,re){this.c=O,this.d=j,this.f=re,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$_i=G;class ne{static create(O,j,re=null){return Y(j,X=>new ne(O,X,re))}constructor(O,j,re){this.c=O,this.d=j,this.f=re,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$aj=ne;class Z{static create(O,j,re=null){return Y(j,X=>new Z(O,X,re))}constructor(O,j,re){this.c=O,this.d=j,this.f=re,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$bj=Z;class T{static create(O,j){return new T(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",re=O.f?O.f.source:"";return j<re?-1:j>re?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",re=O.f?O.f.source:"";return this.d===O.d&&j===re}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$cj=T;class oe{static create(O){return new oe(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new oe(this.c.map(O))}negate(){return this.c}}e.$dj=oe;function Q(W){let O=null;for(let j=0,re=W.length;j<re;j++){const X=W[j].substituteConstants();if(W[j]!==X&&O===null){O=[];for(let x=0;x<j;x++)O[x]=W[x]}O!==null&&(O[j]=X)}return O===null?W:O}class te{static create(O,j,re){return te.d(O,j,re)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,re=this.expr.length;j<re;j++){const X=r(this.expr[j],O.expr[j]);if(X!==0)return X}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,re=this.expr.length;j<re;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:te.create(O,this.c,!1)}evaluate(O){for(let j=0,re=this.expr.length;j<re;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,re){const X=[];let x=!1;for(const z of O)if(z){if(z.type===1){x=!0;continue}if(z.type===0)return t.INSTANCE;if(z.type===6){X.push(...z.expr);continue}X.push(z)}if(X.length===0&&x)return a.INSTANCE;if(X.length!==0){if(X.length===1)return X[0];X.sort(r);for(let z=1;z<X.length;z++)X[z-1].equals(X[z])&&(X.splice(z,1),z--);if(X.length===1)return X[0];for(;X.length>1;){const z=X[X.length-1];if(z.type!==9)break;X.pop();const q=X.pop(),M=X.length===0,H=J.create(z.expr.map(_=>te.create([_,q],null,re)),null,M);H&&(X.push(H),X.sort(r))}if(X.length===1)return X[0];if(re){for(let z=0;z<X.length;z++)for(let q=z+1;q<X.length;q++)if(X[z].negate().equals(X[q]))return t.INSTANCE;if(X.length===1)return X[0]}return new te(X,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new te(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=J.create(O,this,!0)}return this.c}}e.$ej=te;class J{static create(O,j,re){return J.d(O,j,re)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,re=this.expr.length;j<re;j++){const X=r(this.expr[j],O.expr[j]);if(X!==0)return X}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,re=this.expr.length;j<re;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:J.create(O,this.c,!1)}evaluate(O){for(let j=0,re=this.expr.length;j<re;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,re){let X=[],x=!1;if(O){for(let z=0,q=O.length;z<q;z++){const M=O[z];if(M){if(M.type===0){x=!0;continue}if(M.type===1)return a.INSTANCE;if(M.type===9){X=X.concat(M.expr);continue}X.push(M)}}if(X.length===0&&x)return t.INSTANCE;X.sort(r)}if(X.length!==0){if(X.length===1)return X[0];for(let z=1;z<X.length;z++)X[z-1].equals(X[z])&&(X.splice(z,1),z--);if(X.length===1)return X[0];if(re){for(let z=0;z<X.length;z++)for(let q=z+1;q<X.length;q++)if(X[z].negate().equals(X[q]))return a.INSTANCE;if(X.length===1)return X[0]}return new J(X,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new J(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),re=O.shift(),X=[];for(const x of B(j))for(const z of B(re))X.push(te.create([x,z],null,!1));O.unshift(J.create(X,null,!1))}this.c=J.create(O,this,!0)}return this.c}}e.$fj=J;class V extends b{static all(){return V.d.values()}constructor(O,j,re){super(O,null),this.f=j,typeof re=="object"?V.d.push({...re,key:O}):re!==!0&&V.d.push({key:O,description:re,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return C.create(this.key,O)}notEqualsTo(O){return R.create(this.key,O)}}e.$gj=V,V.d=[],e.$hj=(0,P.$2h)("contextKeyService");function ie(W,O){return W<O?-1:W>O?1:0}function ue(W,O,j,re){return W<j?-1:W>j?1:O<re?-1:O>re?1:0}function se(W,O){if(W.type===0||O.type===1)return!0;if(W.type===9)return O.type===9?me(W.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(se(W,j))return!0;return!1}if(W.type===6){if(O.type===6)return me(O.expr,W.expr);for(const j of W.expr)if(se(j,O))return!0;return!1}return W.equals(O)}e.$ij=se;function me(W,O){let j=0,re=0;for(;j<W.length&&re<O.length;){const X=W[j].cmp(O[re]);if(X<0)return!1;X===0&&j++,re++}return j===W.length}function B(W){return W.type===9?W.expr:[W]}}),define(we[217],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.ID=void 0,e.ID="diagnosticsService",e.$Em=(0,y.$2h)(e.ID);function A(P){return!!P.hostName&&!!P.errorMessage}e.$Fm=A;class s{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Gm=s}),define(we[83],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=void 0,e.$3n=(0,y.$2h)("downloadService")}),define(we[25],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,y.$2h)("environmentService"),e.$0h=(0,y.$3h)(e.$9h)}),define(we[30],ve([1,0,179,6]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$lo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0,e.$_n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ao=new RegExp(e.$_n),e.$bo="__web_extension",e.$co="skipWalkthrough",e.$do="extensionsSync",e.$eo="dependecyOrPackExtensionInstall";function s(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$fo=s;function P(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$go=P;function D(h,d){switch(h){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$ho=D;function S(h,d){return d==="web"&&!h.includes("web")}e.$io=S;function p(h,d,l){return S(d,l)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===l}e.$jo=p;function v(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$ko=v;var I;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var E;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var w;(function(h){h.Install="install",h.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var f;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$lo=(0,A.$2h)("extensionGalleryService");var g;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var c;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class m extends Error{constructor(d,l){super(d),this.code=l,this.name=l}}e.$mo=m,e.$no=(0,A.$2h)("extensionManagementService"),e.$oo="extensionsIdentifiers/disabled",e.$po="extensionsIdentifiers/enabled",e.$qo=(0,A.$2h)("IGlobalExtensionEnablementService"),e.$ro=(0,A.$2h)("IExtensionTipsService"),e.$so=(0,y.localize)(0,null),e.$to={value:e.$so,original:"Extensions"},e.$uo={value:(0,y.localize)(1,null),original:"Preferences"}}),define(we[218],ve([1,0,5,2,23,3,51,30]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$wp=e.$vp=void 0;function p(m,h){return m?P.URI.revive(h?h.transformIncoming(m):m):void 0}function v(m,h){return h?h.transformOutgoingURI(m):m}function I(m,h){h=h||D.$1m;const d=m.manifest;return{...(0,D.$4m)({...m,manifest:void 0},h),manifest:d}}function E(m,h){return m?.profileLocation?(0,D.$4m)(m,h??D.$1m):m}function w(m,h){return h?(0,s.$kn)(m,d=>d instanceof P.URI?h.transformOutgoingURI(d):void 0):m}class f{constructor(h,d){this.a=h,this.b=d,this.onInstallExtension=y.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=y.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,d){const l=this.b(h);switch(d){case"onInstallExtension":return y.Event.map(this.onInstallExtension,$=>({...$,profileLocation:$.profileLocation?v($.profileLocation,l):$.profileLocation}));case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,$=>$.map(u=>({...u,local:u.local?w(u.local,l):u.local,profileLocation:u.profileLocation?v(u.profileLocation,l):u.profileLocation})));case"onUninstallExtension":return y.Event.map(this.onUninstallExtension,$=>({...$,profileLocation:$.profileLocation?v($.profileLocation,l):$.profileLocation}));case"onDidUninstallExtension":return y.Event.map(this.onDidUninstallExtension,$=>({...$,profileLocation:$.profileLocation?v($.profileLocation,l):$.profileLocation}));case"onDidUpdateExtensionMetadata":return y.Event.map(this.onDidUpdateExtensionMetadata,$=>w($,l))}throw new Error("Invalid listen")}async call(h,d,l){const $=this.b(h);switch(d){case"zip":{const u=I(l[0],$),n=await this.a.zip(u);return v(n,$)}case"unzip":return this.a.unzip(p(l[0],$));case"install":return this.a.install(p(l[0],$),E(l[1],$));case"installFromLocation":return this.a.installFromLocation(p(l[0],$),p(l[1],$));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(l[0],p(l[1],$),p(l[2],$));case"getManifest":return this.a.getManifest(p(l[0],$));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(l[0]);case"installFromGallery":return this.a.installFromGallery(l[0],E(l[1],$));case"installGalleryExtensions":{const u=l[0];return this.a.installGalleryExtensions(u.map(({extension:n,options:i})=>({extension:n,options:E(i,$)??{}})))}case"uninstall":return this.a.uninstall(I(l[0],$),E(l[1],$));case"reinstallFromGallery":return this.a.reinstallFromGallery(I(l[0],$));case"getInstalled":return(await this.a.getInstalled(l[0],p(l[1],$))).map(n=>w(n,$));case"toggleAppliationScope":{const u=await this.a.toggleAppliationScope(I(l[0],$),p(l[1],$));return w(u,$)}case"copyExtensions":return this.a.copyExtensions(p(l[0],$),p(l[1],$));case"updateMetadata":{const u=await this.a.updateMetadata(I(l[0],$),l[1],p(l[2],$));return w(u,$)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(l[0],l[1],l[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$vp=f;class g extends A.$Sc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new y.$Sd),this.f=this.B(new y.$Sd),this.g=this.B(new y.$Sd),this.h=this.B(new y.$Sd),this.j=this.B(new y.$Sd),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?P.URI.revive(d.source):d.source,profileLocation:P.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map(l=>({...l,local:l.local?I(l.local,null):l.local,source:this.r(l.source)?P.URI.revive(l.source):l.source,profileLocation:P.URI.revive(l.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:P.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:P.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(I(d,null))))}n(h,d){h.fire(d)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const d=await this.getTargetPlatform();return h.allTargetPlatforms.some(l=>(0,S.$jo)(l,h.allTargetPlatforms,d))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(d=>P.URI.revive(d)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,d){return Promise.resolve(this.m.call("install",[h,d])).then(l=>I(l,null))}installFromLocation(h,d){return Promise.resolve(this.m.call("installFromLocation",[h,d])).then(l=>I(l,null))}async installExtensionsFromProfile(h,d,l){return(await this.m.call("installExtensionsFromProfile",[h,d,l])).map(u=>I(u,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,d){return Promise.resolve(this.m.call("installFromGallery",[h,d])).then(l=>I(l,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(l=>({...l,local:l.local?I(l.local,null):l.local,source:this.r(l.source)?P.URI.revive(l.source):l.source,profileLocation:P.URI.revive(l.profileLocation)}))}uninstall(h,d){return Promise.resolve(this.m.call("uninstall",[h,d]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(d=>I(d,null))}getInstalled(h=null,d){return Promise.resolve(this.m.call("getInstalled",[h,d])).then(l=>l.map($=>I($,null)))}updateMetadata(h,d,l){return Promise.resolve(this.m.call("updateMetadata",[h,d,l])).then($=>I($,null))}toggleAppliationScope(h,d){return this.m.call("toggleAppliationScope",[h,d]).then(l=>I(l,null))}copyExtensions(h,d){return this.m.call("copyExtensions",[h,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,d,l){const $=await this.m.call("download",[h,d,l]);return P.URI.revive($)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$wp=g;class c{constructor(h){this.a=h}listen(h,d){throw new Error("Invalid listen")}call(h,d,l){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(P.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$xp=c}),define(we[84],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=void 0,e.$sp=(0,y.$2h)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((P,D)=>he(["node-vsce-sign"],async S=>P(S),D))),this.a}async verify(P,D,S){let p;try{p=await this.b()}catch{return!1}return p.verify(P,D,S)}}e.$tp=A}),define(we[16],ve([1,0,65,7,17,8,3,187,6,4,12,59]),function(he,e,y,A,s,P,D,S,p,v,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileKind=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileOperationResult=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileChangeType=e.$Dk=e.FileOperation=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileSystemProviderErrorCode=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderCapabilities=e.$nk=e.FilePermission=e.FileType=e.$mk=e.$lk=void 0,e.$lk=(0,p.$2h)("fileService");function w(se){return se.create===!0}e.$mk=w;var f;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var g;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function c(se){const me=se;return!!me&&typeof me.onDidChange=="function"}e.$nk=c;var m;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function h(se){return!!(se.capabilities&2)}e.$ok=h;function d(se){return!!(se.capabilities&8)}e.$pk=d;function l(se){return!!(se.capabilities&131072)}e.$qk=l;function $(se){return!!(se.capabilities&4)}e.$rk=$;function u(se){return!!(se.capabilities&16)}e.$sk=u;function n(se){return h(se)?!!(se.capabilities&16384):!1}e.$tk=n;function i(se){return h(se)?!!(se.capabilities&32768):!1}e.$uk=i;function o(se){return!!(se.capabilities&65536)}e.$vk=o;function r(se){return!!(se.capabilities&2048)}e.$wk=r;var t;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class a extends Error{static create(me,B){const W=new a(me.toString(),B);return L(W,B),W}constructor(me,B){super(me),this.code=B}}e.$xk=a;function b(se,me){return a.create(se,me)}e.$yk=b;function C(se){return se||b((0,S.localize)(0,null),t.Unknown)}e.$zk=C;function L(se,me){return se.name=me?`${me} (FileSystemError)`:"FileSystemError",se}e.$Ak=L;function k(se){if(!se)return t.Unknown;if(se instanceof a)return se.code;const me=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!me)return t.Unknown;switch(me[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Bk=k;function R(se){if(se instanceof Z)return se.fileOperationResult;switch(k(se)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Ck=R;var N;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class Y{constructor(me,B,W){this.resource=me,this.operation=B,this.target=W}isOperation(me){return this.operation===me}}e.$Dk=Y;var ee;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(ee||(e.FileChangeType=ee={}));class G{constructor(me,B){this.c=B,this.b=void 0,this.d=new E.$V(()=>{const W=y.$8h.forUris(()=>this.c);return W.fill(this.rawAdded.map(O=>[O,!0])),W}),this.f=new E.$V(()=>{const W=y.$8h.forUris(()=>this.c);return W.fill(this.rawUpdated.map(O=>[O,!0])),W}),this.g=new E.$V(()=>{const W=y.$8h.forUris(()=>this.c);return W.fill(this.rawDeleted.map(O=>[O,!0])),W}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const W of me){switch(W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}this.b!==G.a&&(typeof W.cId=="number"?this.b===void 0?this.b=W.cId:this.b!==W.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(me,...B){return this.h(me,{includeChildren:!1},...B)}affects(me,...B){return this.h(me,{includeChildren:!0},...B)}h(me,B,...W){if(!me)return!1;const O=W.length>0;return!!((!O||W.includes(1))&&(this.d.value.get(me)||B.includeChildren&&this.d.value.findSuperstr(me))||(!O||W.includes(0))&&(this.f.value.get(me)||B.includeChildren&&this.f.value.findSuperstr(me))||(!O||W.includes(2))&&(this.g.value.findSubstr(me)||B.includeChildren&&this.g.value.findSuperstr(me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(me){return this.b===me}hasCorrelation(){return typeof this.b=="number"}}e.$Ek=G,G.a=null;function ne(se,me,B){return!se||!me||se===me||me.length>se.length?!1:(me.charAt(me.length-1)!==A.sep&&(me+=A.sep),B?(0,s.$9e)(se,me):se.indexOf(me)===0)}e.$Fk=ne;class Z extends Error{constructor(me,B,W){super(me),this.fileOperationResult=B,this.options=W}}e.$Gk=Z;class T extends Z{constructor(me,B,W,O){super(me,B,O),this.fileOperationResult=B,this.size=W}}e.$Hk=T;class oe extends Z{constructor(me,B,W){super(me,2,W),this.stat=B}}e.$Ik=oe;var Q;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$Jk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Kk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Lk="files.associations",e.$Mk="files.exclude",e.$Nk="files.readonlyInclude",e.$Ok="files.readonlyExclude",e.$Pk="files.readonlyFromPermissions";var te;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$Qk="";function J(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$Rk=J;async function V(se,me){if(!me.hasProvider(D.URI.from({scheme:se.scheme})))return new Promise(B=>{const W=me.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===se.scheme&&O.added&&(W.dispose(),B())})})}e.$Sk=V;class ie{static formatSize(me){return(0,P.$If)(me)||(me=0),me<ie.KB?(0,S.localize)(1,null,me.toFixed(0)):me<ie.MB?(0,S.localize)(2,null,(me/ie.KB).toFixed(2)):me<ie.GB?(0,S.localize)(3,null,(me/ie.MB).toFixed(2)):me<ie.TB?(0,S.localize)(4,null,(me/ie.GB).toFixed(2)):(0,S.localize)(5,null,(me/ie.TB).toFixed(2))}}e.$Tk=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;function ue(se){const me=typeof se=="string"||se?.scheme===I.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===I.Schemas.file?1024*ie.MB:me?10*ie.MB:v.$i?50*ie.MB:1024*ie.MB}e.$Uk=ue}),define(we[110],ve([1,0,15,11,188,16]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;async function D(I,E,w,f,g,c){let m;try{await S(I,E,w,f,g,c)}catch(h){m=h}finally{m&&g.errorTransformer&&(m=g.errorTransformer(m)),typeof m<"u"&&w.error(m),w.end()}}e.$1p=D;async function S(I,E,w,f,g,c){p(c);const m=await I.open(E,{create:!1});try{p(c);let h=0,d=0,l=g&&typeof g.length=="number"?g.length:void 0,$=y.$ge.alloc(Math.min(g.bufferSize,typeof l=="number"?l:g.bufferSize)),u=g&&typeof g.position=="number"?g.position:0,n=0;do d=await I.read(m,u,$.buffer,n,$.byteLength-n),u+=d,n+=d,h+=d,typeof l=="number"&&(l-=d),n===$.byteLength&&(await w.write(f($)),$=y.$ge.alloc(Math.min(g.bufferSize,typeof l=="number"?l:g.bufferSize)),n=0);while(d>0&&(typeof l!="number"||l>0)&&p(c)&&v(h,g));if(n>0){let i=n;typeof l=="number"&&(i=Math.min(n,l)),w.write(f($.slice(0,i)))}}catch(h){throw(0,P.$zk)(h)}finally{await I.close(m)}}function p(I){if(I.isCancellationRequested)throw(0,A.$6)();return!0}function v(I,E){if(typeof E?.limits?.size=="number"&&I>E.limits.size)throw(0,P.$yk)((0,s.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(we[54],ve([1,0,77,2,7,4,3,16]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=void 0;function p(h){return h.recursive===!0}e.$3p=p;class v extends A.$Sc{constructor(d,l,$,u){super(),this.h=d,this.j=l,this.m=$,this.n=u,this.c=this.B(new A.$Tc),this.f=void 0,this.g=0}s(){const d=new A.$Rc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(l=>this.h(l))),d.add(this.b.onDidLogMessage(l=>this.j(l))),d.add(this.b.onDidError(l=>this.t(l)))}t(d){this.n.restartOnError?this.g<v.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4p=v,v.a=5;class I extends v{constructor(d,l,$){super(d,l,$,{type:"node.js",restartOnError:!1})}}e.$5p=I;class E extends v{constructor(d,l,$){super(d,l,$,{type:"universal",restartOnError:!0})}}e.$6p=E;function w(h){return h.map(d=>({type:d.type,resource:D.URI.revive(d.resource),cId:d.cId}))}e.$7p=w;function f(h){const d=new m;for(const l of h)d.processEvent(l);return d.coalesce()}e.$8p=f;function g(h,d){return typeof d=="string"&&!d.startsWith(y.$Ej)&&!(0,s.$ic)(d)?{base:h,pattern:d}:d}e.$9p=g;function c(h,d){const l=[];for(const $ of d)l.push((0,y.$Ij)(g(h,$)));return l}e.$0p=c;class m{constructor(){this.a=new Set,this.b=new Map}c(d){return P.$e?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const l=this.b.get(this.c(d));let $=!1;if(l){const u=l.type,n=d.type;l.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?$=!0:u===1&&n===2?(this.b.delete(this.c(d)),this.a.delete(l)):u===2&&n===1?l.type=0:u===1&&n===0||(l.type=n)}else $=!0;$&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],l=[];return Array.from(this.a).filter($=>$.type!==2?(d.push($),!1):!0).sort(($,u)=>$.resource.fsPath.length-u.resource.fsPath.length).filter($=>l.some(u=>(0,S.$Fk)($.resource.fsPath,u,!P.$e))?!1:(l.push($.resource.fsPath),!0)).concat(d)}}}),define(we[219],ve([1,0,15,40,11,5,2,48,21,16,54]),function(he,e,y,A,s,P,D,S,p,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=e.$WN=void 0,e.$WN="localFilesystem";class E extends D.$Sc{constructor(f,g){super(),this.a=f,this.b=g,this.onDidChangeCapabilities=P.Event.None,this.f=this.B(new P.$Sd),this.onDidChangeFile=this.f.event,this.g=this.B(new P.$Sd),this.onDidWatchError=this.g.event,this.h=(0,p.$mg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,g){const{buffer:c}=await this.a.call("readFile",[f,g]);return c}readFileStream(f,g,c){const m=(0,S.$7d)(d=>y.$ge.concat(d.map(l=>y.$ge.wrap(l))).buffer),h=new D.$Rc;return h.add(this.a.listen("readFileStream",[f,g])(d=>{if(d instanceof y.$ge)m.write(d.buffer);else{if(d==="end")m.end();else{let l;if(d instanceof Error)l=d;else{const $=d;l=(0,v.$yk)($.message??(0,A.$Mi)($),$.code??v.FileSystemProviderErrorCode.Unknown)}m.error(l),m.end()}h.dispose()}})),h.add(c.onCancellationRequested(()=>{m.error((0,s.$6)()),m.end(),h.dispose()})),m}writeFile(f,g,c){return this.a.call("writeFile",[f,y.$ge.wrap(g),c])}open(f,g){return this.a.call("open",[f,g])}close(f){return this.a.call("close",[f])}async read(f,g,c,m,h){const[d,l]=await this.a.call("read",[f,g,h]);return c.set(d.buffer.slice(0,l),m),l}write(f,g,c,m,h){return this.a.call("write",[f,g,y.$ge.wrap(c),m,h])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,g){return this.a.call("delete",[f,g])}rename(f,g,c){return this.a.call("rename",[f,g,c])}copy(f,g,c){return this.a.call("copy",[f,g,c])}cloneFile(f,g){return this.a.call("cloneFile",[f,g])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const g=f;this.f.fire((0,I.$7p)(g))}else{const g=f;this.g.fire(g)}}))}watch(f,g){const c=(0,p.$mg)();return this.a.call("watch",[this.h,c,f,g]),(0,D.$Qc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$XN=E}),define(we[220],ve([1,0,29,14,20,39,2,99,7,4,19,3,158,22,54]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=void 0;class c extends D.$Sc{constructor(d,l,$,u){super(),this.m=d,this.n=l,this.r=$,this.s=u,this.c=this.B(new A.$eh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.n(n))),this.f=this.B(new A.$dh(n=>this.z(n),c.b)),this.g=(0,g.$0p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,g.$0p)(this.m.path,this.m.includes):void 0,this.j=new s.$3d,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await f.Promises.stat(d);this.B(await this.w(d,l.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let l=d.path;try{l=await f.Promises.realpath(d.path),d.path===l&&(l=await(0,w.$hq)(d.path)??d.path),d.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${l})`)}catch{}return l}async w(d,l){if(v.$d&&(0,P.$4f)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Sc.None;const $=new s.$3d(this.j.token),u=new D.$Rc;try{const n=E.URI.file(this.m.path),i=(0,p.$nc)(d),o=(0,y.watch)(d);u.add((0,D.$Qc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${d}'`);const r=new Set;if(l)try{for(const a of await f.Promises.readdir(d))r.add(a)}catch(a){this.D(a)}const t=new Map;u.add((0,D.$Qc)(()=>{for(const[,a]of t)a.dispose();t.clear()})),o.on("error",(a,b)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${a}, ${b})`),this.dispose()}),o.on("change",(a,b)=>{if($.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${b}`);let C="";if(b&&(C=b.toString(),v.$d&&(C=(0,S.$Cl)(C))),!(!C||a!=="change"&&a!=="rename"))if(l)if(a==="rename"){t.get(C)?.dispose();const L=setTimeout(async()=>{if(t.delete(C),C===i&&!await f.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,p.$jc)(d,C));if($.token.isCancellationRequested)return;let R;k?r.has(C)?R=0:(R=1,r.add(C)):(r.delete(C),R=2),this.y({resource:(0,I.$Dg)(n,C),type:R,cId:this.m.correlationId})},c.a);t.set(C,(0,D.$Qc)(()=>clearTimeout(L)))}else{let L;r.has(C)?L=0:(L=1,r.add(C)),this.y({resource:(0,I.$Dg)(n,C),type:L,cId:this.m.correlationId})}else if(a==="rename"||C!==i){const L=setTimeout(async()=>{const k=await f.Promises.exists(d);$.token.isCancellationRequested||(k?(this.y({resource:n,type:0,cId:this.m.correlationId},!0),u.add(await this.w(d,!1))):(this.y({resource:n,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);u.clear(),u.add((0,D.$Qc)(()=>clearTimeout(L)))}else this.y({resource:n,type:0,cId:this.m.correlationId},!0)})}catch(n){await f.Promises.exists(d)&&!$.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${n.toString()})`)}return(0,D.$Qc)(()=>{$.dispose(!0),u.dispose()})}y(d,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!l&&this.g.some($=>$(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some($=>$(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const l=(0,g.$8p)(d);if(l.length>0){if(this.s)for(const u of l)this.G(` >> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(v.$e)return f.Promises.exists(d);try{const l=(0,p.$nc)(d);return(await f.Promises.readdir((0,p.$mc)(d))).some(u=>u===l)}catch(l){return this.G(l),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$kq=c,c.a=100,c.b=75;async function m(h,d,l,$,u=512){const n=await f.Promises.open(h,"r"),i=Buffer.allocUnsafe(u),o=new s.$3d($);let r,t=!1;const a={path:h,excludes:[],recursive:!1},b=new c(a,C=>{(async()=>{for(const{type:L}of C)if(L===0){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:k}=await f.Promises.read(n,i,0,u,null);if(!k||o.token.isCancellationRequested)break;d(i.slice(0,k))}}catch(k){r=new Error(k),o.dispose(!0)}finally{t=!1}}})()});return await b.ready,l(),new Promise((C,L)=>{o.token.onCancellationRequested(async()=>{b.dispose();try{await f.Promises.close(n)}catch(k){r=new Error(k)}r?L(r):C()})})}e.$lq=m}),define(we[221],ve([1,0,5,77,2,4,220]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class S extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new y.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new y.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch(v){const I=this.j(v),E=I.filter(f=>{const g=this.c.get(f.path);return g?!(0,A.$Mj)(g.request.excludes,f.excludes)||!(0,A.$Mj)(g.request.includes,f.includes):!0}),w=Array.from(this.c.values()).filter(({request:f})=>!I.find(g=>g.path===f.path&&(0,A.$Mj)(g.excludes,f.excludes)&&(0,A.$Mj)(g.includes,f.includes))).map(({request:f})=>f.path);E.length&&this.m(`Request to start watching: ${E.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const f of w)this.h(f);for(const f of E)this.g(f)}g(v){const I=new D.$kq(v,w=>this.a.fire(w),w=>this.b.fire(w),this.f),E={request:v,instance:I};this.c.set(v.path,E)}async stop(){for(const[v]of this.c)this.h(v);this.c.clear()}h(v){const I=this.c.get(v);I&&(this.c.delete(v),I.instance.dispose())}j(v){const I=new Map;for(const E of v){const w=P.$e?E.path:E.path.toLowerCase();let f=I.get(E.correlationId);f||(f=new Map,I.set(E.correlationId,f)),f.set(w,E)}return Array.from(I.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(v){this.f=v;for(const[,I]of this.c)I.instance.setVerboseLogging(v)}m(v){this.f&&this.b.fire({type:"trace",message:this.n(v)})}n(v,I){return I?`[File Watcher (node.js)] ${v} (path: ${I.request.path})`:`[File Watcher (node.js)] ${v}`}}e.$mq=S}),define(we[222],ve([1,0,54,221]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class s extends y.$5p{constructor(D,S,p){super(D,S,p),this.s()}r(D){return D.add(new A.$mq)}}e.$nq=s}),define(we[223],ve([1,0,12,42,108,54]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class D extends P.$6p{constructor(p,v,I){super(p,v,I),this.s()}r(p){const v=p.add(new s.$eq(y.$kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(v.onDidProcessExit(({code:I,signal:E})=>this.t(`terminated by itself with code ${I}, signal: ${E}`))),A.ProxyChannel.toService((0,A.$Ih)(v.getChannel("watcher")))}}e.$fq=D}),define(we[85],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class y{constructor(...s){this.a=new Map;for(const[P,D]of s)this.set(P,D)}set(s,P){const D=this.a.get(s);return this.a.set(s,P),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Zh=y}),define(we[111],ve([1,0,14,11,2,67,216,6,85,98]),function(he,e,y,A,s,P,D,S,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;const I=!1;class E extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class w{constructor(m=new p.$Zh,h=!1,d,l=I){this.f=m,this.g=h,this.h=d,this.i=l,this.o=new Set,this.f.set(S.$1h,this),this._globalGraph=l?d?._globalGraph??new D.$qq($=>$):void 0}createChild(m){return new w(m,this.g,this,this.i)}invokeFunction(m,...h){const d=g.traceInvocation(this.i,m);let l=!1;try{return m({get:u=>{if(l)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(u,d);if(!n)throw new Error(`[invokeFunction] unknown service '${u}'`);return n}},...h)}finally{l=!0,d.stop()}}createInstance(m,...h){let d,l;return m instanceof P.$Yh?(d=g.traceCreation(this.i,m.ctor),l=this.j(m.ctor,m.staticArguments.concat(h),d)):(d=g.traceCreation(this.i,m),l=this.j(m,h,d)),d.stop(),l}j(m,h=[],d){const l=S._util.getServiceDependencies(m).sort((n,i)=>n.index-i.index),$=[];for(const n of l){const i=this.m(n.id,d);i||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${n.id}.`,!1),$.push(i)}const u=l.length>0?l[0].index:h.length;if(h.length!==u){console.trace(`[createInstance] First service dependency of ${m.name} at position ${u+1} conflicts with ${h.length} static arguments`);const n=u-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,u)}return Reflect.construct(m,h.concat($))}k(m,h){if(this.f.get(m)instanceof P.$Yh)this.f.set(m,h);else if(this.h)this.h.k(m,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const h=this.f.get(m);return!h&&this.h?this.h.l(m):h}m(m,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const d=this.l(m);return d instanceof P.$Yh?this.q(m,d,h.branch(m,!0)):(h.branch(m,!1),d)}q(m,h,d){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,h,d)}finally{this.o.delete(m)}}r(m,h,d){const l=new D.$qq(n=>n.id.toString());let $=0;const u=[{id:m,desc:h,_trace:d}];for(;u.length;){const n=u.pop();if(l.lookupOrInsertNode(n),$++>1e3)throw new E(l);for(const i of S._util.getServiceDependencies(n.desc.ctor)){const o=this.l(i.id);if(o||this.u(`[createInstance] ${m} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(i.id)),o instanceof P.$Yh){const r={id:i.id,desc:o,_trace:n._trace.branch(i.id,!0)};l.insertEdge(n,r),u.push(r)}}}for(;;){const n=l.roots();if(n.length===0){if(!l.isEmpty())throw new E(l);break}for(const{data:i}of n){if(this.l(i.id)instanceof P.$Yh){const r=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,r)}l.removeNode(i)}}return this.l(m)}s(m,h,d=[],l,$){if(this.f.get(m)instanceof P.$Yh)return this.t(m,h,d,l,$);if(this.h)return this.h.s(m,h,d,l,$);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(m,h,d=[],l,$){if(l){const u=new w(void 0,this.g,this,this.i);u.c=String(m);const n=new Map,i=new y.$ih(()=>{const o=u.j(h,d,$);for(const[r,t]of n){const a=o[r];if(typeof a=="function")for(const b of t)a.apply(o,b)}return n.clear(),o});return new Proxy(Object.create(null),{get(o,r){if(!i.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let b=n.get(r);return b||(b=new v.$3c,n.set(r,b)),(L,k,R)=>{const N=b.push([L,k,R]);return(0,s.$Qc)(N)}}if(r in o)return o[r];const t=i.value;let a=t[r];return typeof a!="function"||(a=a.bind(t),o[r]=a),a},set(o,r,t){return i.value[r]=t,!0},getPrototypeOf(o){return h.prototype}})}else return this.j(h,d,$)}u(m,h){if(h&&console.warn(m),this.g)throw new Error(m)}}e.$rq=w;var f;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(f||(f={}));class g{static traceInvocation(m,h){return m?new g(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(m,h){return m?new g(1,h.name):g.c}constructor(m,h){this.type=m,this.name=h,this.g=Date.now(),this.h=[]}branch(m,h){const d=new g(3,m.toString());return this.h.push([m,h,d]),d}stop(){const m=Date.now()-this.g;g.f+=m;let h=!1;function d($,u){const n=[],i=new Array($+1).join("	");for(const[o,r,t]of u.h)if(r&&t){h=!0,n.push(`${i}CREATES -> ${o}`);const a=d($+1,t);a&&n.push(a)}else n.push(`${i}uses -> ${o}`);return n.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(m>2||h)&&g.all.add(l.join(`
`))}}e.$sq=g,g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0}),define(we[224],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$bv=void 0,e.$bv=(0,y.$2h)("labelService");var A;(function(s){s[s.SHORT=0]="SHORT",s[s.MEDIUM=1]="MEDIUM",s[s.LONG=2]="LONG"})(A||(e.Verbosity=A={}))});var Le=this&&this.__param||function(he,e){return function(y,A){e(y,A,he)}};define(we[86],ve([1,0,20,2,4,190,30,6]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=void 0;function p(I){return I.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$6q=p,e.$7q=(0,S.$2h)("languagePackService");let v=class extends A.$Sc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new y.$3d;setTimeout(()=>E.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=w.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(m=>m.startsWith("lp-"))).map(c=>{const m=c.properties.localizedLanguages?.[0],h=p(c);return{...this.f(h,m,c),extensionId:c.identifier.id,galleryExtension:c}});return g.push(this.f("en","English")),g}f(E,w,f){const g=w??E;let c;if(g!==E&&(c=`(${E})`),E.toLowerCase()===s.$q.toLowerCase()&&(c??(c=""),c+=(0,P.localize)(0,null)),f?.installCount){c??(c="");const m=f.installCount;let h;m>1e6?h=`${Math.floor(m/1e5)/10}M`:m>1e3?h=`${Math.floor(m/1e3)}K`:h=String(m),c+=` $(cloud-download) ${h}`}return{id:E,label:g,description:c}}};e.$8q=v,e.$8q=v=Ne([Le(0,D.$lo)],v)}),define(we[13],ve([1,0,40,5,63,2,26,4,19,8,3,68,6]),function(he,e,y,A,s,P,D,S,p,v,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,w.$2h)("logService"),e.$kj=(0,w.$2h)("loggerService");function f(){return new Date().toISOString()}function g(L){return(0,v.$If)(L)}e.$lj=g;var c;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$mj=c.Info;function m(L,k,R){switch(k){case c.Trace:L.trace(R);break;case c.Debug:L.debug(R);break;case c.Info:L.info(R);break;case c.Warning:L.warn(R);break;case c.Error:L.error(R);break;case c.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=m;function h(L,k=!1){let R="";for(let N=0;N<L.length;N++){let Y=L[N];if(Y instanceof Error&&(Y=(0,y.$Mi)(Y,k)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}R+=(N>0?" ":"")+Y}return R}class d extends P.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new A.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==c.Off&&this.b<=k}}e.$oj=d;class l extends d{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...R){this.f(c.Trace)&&this.g(c.Trace,h([k,...R],!0))}debug(k,...R){this.f(c.Debug)&&this.g(c.Debug,h([k,...R]))}info(k,...R){this.f(c.Info)&&this.g(c.Info,h([k,...R]))}warn(k,...R){this.f(c.Warning)&&this.g(c.Warning,h([k,...R]))}error(k,...R){if(this.f(c.Error))if(k instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=k.stack,this.g(c.Error,h(N))}else this.g(c.Error,h([k,...R]))}flush(){}}e.$pj=l;class $ extends d{constructor(k=e.$mj){super(),this.setLevel(k),this.g=!S.$c}trace(k,...R){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...R):console.log(`[main ${f()}]`,k,...R))}debug(k,...R){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...R):console.log(`[main ${f()}]`,k,...R))}info(k,...R){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...R):console.log(`[main ${f()}]`,k,...R))}warn(k,...R){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,k,...R):console.warn(`[main ${f()}]`,k,...R))}error(k,...R){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,k,...R):console.error(`[main ${f()}]`,k,...R))}dispose(){}flush(){}}e.$qj=$;class u extends d{constructor(k=e.$mj,R=!0){super(),this.g=R,this.setLevel(k)}trace(k,...R){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...R):console.log(k,...R))}debug(k,...R){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...R):console.log(k,...R))}info(k,...R){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...R):console.log(k,...R))}warn(k,...R){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...R):console.log(k,...R))}error(k,...R){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...R):console.error(k,...R))}dispose(){}flush(){}}e.$rj=u;class n extends d{constructor(k,R=e.$mj){super(),this.g=k,this.setLevel(R)}trace(k,...R){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(k),...R])}debug(k,...R){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(k),...R])}info(k,...R){this.f(c.Info)&&this.g.log(c.Info,[this.h(k),...R])}warn(k,...R){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(k),...R])}error(k,...R){this.f(c.Error)&&this.g.log(c.Error,[this.h(k),...R])}h(k){return typeof k=="string"?k:(0,y.$Mi)(k,this.f(c.Trace))}dispose(){}flush(){}}e.$sj=n;class i extends d{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const R of this.g)R.setLevel(k);super.setLevel(k)}trace(k,...R){for(const N of this.g)N.trace(k,...R)}debug(k,...R){for(const N of this.g)N.debug(k,...R)}info(k,...R){for(const N of this.g)N.info(k,...R)}warn(k,...R){for(const N of this.g)N.warn(k,...R)}error(k,...R){for(const N of this.g)N.error(k,...R)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$tj=i;class o extends P.$Sc{constructor(k,R,N){if(super(),this.h=k,this.j=R,this.b=new D.$Ac,this.c=this.B(new A.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Sd),this.onDidChangeVisibility=this.g.event,N)for(const Y of N)this.b.set(Y.resource,{logger:void 0,info:Y})}m(k){return(0,v.$Ef)(k)?[...this.b.values()].find(R=>R.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,R){const N=this.n(k),Y=(0,v.$Ef)(k)?k:R?.id??(0,s.$Pi)(N.toString()).toString(16);let ee=this.b.get(N)?.logger;const G=R?.logLevel==="always"?c.Trace:R?.logLevel;ee||(ee=this.s(N,G??this.getLogLevel(N)??this.h,{...R,id:Y}));const ne={logger:ee,info:{resource:N,id:Y,logLevel:G,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(ne.info),this.b.set(N,ne),ee}n(k){return(0,v.$Ef)(k)?(0,p.$Dg)(this.j,`${k}.log`):k}setLogLevel(k,R){if(I.URI.isUri(k)){const N=k,Y=R,ee=this.b.get(N);ee&&Y!==ee.info.logLevel&&(ee.info.logLevel=Y===this.h?void 0:Y,ee.logger?.setLevel(Y),this.b.set(ee.info.resource,ee),this.f.fire([N,Y]))}else{this.h=k;for(const[N,Y]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,R){const N=this.m(k);N&&R!==!N.info.hidden&&(N.info.hidden=!R,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,R]))}getLogLevel(k){let R;return k&&(R=this.b.get(k)?.info.logLevel),R??this.h}registerLogger(k){const R=this.b.get(k.resource);R?R.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const R=this.b.get(k);R&&(R.logger&&R.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=o;class r{constructor(){this.onDidChangeLogLevel=new A.$Sd().event}setLevel(k){}getLevel(){return c.Info}trace(k,...R){}debug(k,...R){}info(k,...R){}warn(k,...R){}error(k,...R){}critical(k,...R){}dispose(){}flush(){}}e.$vj=r;class t extends r{}e.$wj=t;function a(L){if(L.verbose)return c.Trace;if(typeof L.logLevel=="string"){const k=C(L.logLevel.toLowerCase());if(k!==void 0)return k}return e.$mj}e.$xj=a;function b(L){switch(L){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$yj=b;function C(L){switch(L){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$zj=C,e.$Aj=new E.$gj("logLevel",b(c.Info))}),define(we[225],ve([1,0,18,14,11,5,2,7,54,13]),function(he,e,y,A,s,P,D,S,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class I extends D.$Sc{constructor(w,f){super(),this.a=w,this.b=f,this.c=this.B(new P.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Zg(0)),this.w=[],this.y=this.B(new A.$Zg(0))}watch(w,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(w,f):this.z(w,f)}n(w,f){const g={path:this.H(w),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},c=(0,y.$Ub)(this.j,g);return this.r(),(0,D.$Qc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,s.$1)(w))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,p.$7p)(f)),f=>this.G(f),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const f of this.j)(0,p.$3p)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const f of this.j)(0,p.$3p)(f)&&w.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,f){const g={path:this.H(w),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},c=(0,y.$Ub)(this.w,g);return this.C(),(0,D.$Qc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,s.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,p.$7p)(w)),w=>this.G(w),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,S.$hc)(w.fsPath)}}e.$$p=I}),define(we[112],ve([1,0,18,14,15,20,5,63,47,2,65,12,41,19,48,186,16,110,13,11]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;let u=$=class extends v.$Sc{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new D.$Sd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Sd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Sd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Sd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Sd),this.Y=this.B(new D.$Sd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Sd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$$g)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${i}`);const r=new v.$Rc;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),r.add(o.onDidChangeFile(t=>{const a=new m.$Ek(t,!this.S(o));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof o.onDidWatchError=="function"&&r.add(o.onDidWatchError(t=>this.Z.fire(new Error(t)))),r.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,v.$Qc)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,v.$Nc)(r)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(r){o.push(r)}}),!this.h.has(i)&&await A.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const r=this.h.get(i.scheme);return!!(r&&r.capabilities&o)}listCapabilities(){return p.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,f.$Hg)(i))throw new m.$Gk((0,c.localize)(0,null,this.sb(i)),8);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const r=new l.$bb;throw r.message=(0,c.localize)(1,null,i.toString()),r}return o}async m(i){const o=await this.j(i);if((0,m.$rk)(o)||(0,m.$ok)(o)||(0,m.$sk)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const o=await this.j(i);if((0,m.$rk)(o)||(0,m.$ok)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.s(i,o)}catch(r){throw(0,m.$Bk)(r)===m.FileSystemProviderErrorCode.FileNotFound?new m.$Gk((0,c.localize)(2,null,this.sb(i)),1):(0,m.$zk)(r)}}async s(i,o){const r=await this.j(i),t=this.S(r),a=o?.resolveTo,b=o?.resolveSingleChildDescendants,C=o?.resolveMetadata,L=await r.stat(i);let k;return this.t(r,i,L,void 0,!!C,(R,N)=>(k||(k=I.$8h.forUris(()=>!t),k.set(i,!0),a&&k.fill(!0,a)),k.get(R.resource)||k.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&b?N===1:!1))}async t(i,o,r,t,a,b){const{providerExtUri:C}=this.R(i),L={resource:o,name:C.basename(o),isFile:(r.type&m.FileType.File)!==0,isDirectory:(r.type&m.FileType.Directory)!==0,isSymbolicLink:(r.type&m.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&m.FilePermission.Readonly)||!!(i.capabilities&2048),locked:!!((r.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Rk)({mtime:r.mtime,size:r.size}),children:void 0};if(L.isDirectory&&b(L,t)){try{const k=await i.readdir(o),R=await A.Promises.settled(k.map(async([N,Y])=>{try{const ee=C.joinPath(o,N),G=a?await i.stat(ee):{type:Y};return await this.t(i,ee,G,k.length,a,b)}catch(ee){return this.b.trace(ee),null}}));L.children=(0,y.$Hb)(R)}catch(k){this.b.trace(k),L.children=[]}return L}return L}async resolveAll(i){return A.Promises.settled(i.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),r=await o.stat(i);return this.t(o,i,r,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.u(i,o)}catch(r){return r}return!0}async u(i,o){if(!o?.overwrite&&await this.exists(i))throw new m.$Gk((0,c.localize)(3,null,this.sb(i)),3,o)}async createFile(i,o=s.$ge.fromString(""),r){await this.u(i,r);const t=await this.writeFile(i,o);return this.r.fire(new m.$Dk(i,0,t)),t}async writeFile(i,o,r){const t=this.qb(await this.n(i),i),{providerExtUri:a}=this.R(t);let b=r;if((0,m.$uk)(t)&&!b?.atomic){const C=t.enforceAtomicWriteFile?.(i);C&&(b={...r,atomic:C})}try{await this.w(t,i,b)||await this.U(t,a.dirname(i));let L;if((0,m.$ok)(t)&&!(o instanceof s.$ge))if((0,g.$5d)(o)){const k=await(0,g.$_d)(o,3);k.ended?L=s.$ge.concat(k.buffer):L=k}else L=(0,g.$9d)(o,k=>s.$ge.concat(k),3);else L=o;!(0,m.$rk)(t)||(0,m.$ok)(t)&&L instanceof s.$ge||(0,m.$ok)(t)&&(0,m.$uk)(t)&&b?.atomic?await this.hb(t,i,b,L):await this.db(t,i,b,L instanceof s.$ge?(0,s.$re)(L):L),this.r.fire(new m.$Dk(i,4))}catch(C){throw new m.$Gk((0,c.localize)(4,null,this.sb(i),(0,m.$zk)(C).toString()),(0,m.$Ck)(C),b)}return this.resolve(i,{resolveMetadata:!0})}async w(i,o,r){const t=!!r?.unlock;if(t&&!(i.capabilities&8192))throw new Error((0,c.localize)(5,null,this.sb(o)));if(!!r?.atomic){if(!(i.capabilities&32768))throw new Error((0,c.localize)(6,null,this.sb(o)));if(!(i.capabilities&2))throw new Error((0,c.localize)(7,null,this.sb(o)));if(t)throw new Error((0,c.localize)(8,null,this.sb(o)))}let b;try{b=await i.stat(o)}catch{return}if(b.type&m.FileType.Directory)throw new m.$Gk((0,c.localize)(9,null,this.sb(o)),0,r);if(this.rb(o,b),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==m.$Qk&&typeof b.mtime=="number"&&typeof b.size=="number"&&r.mtime<b.mtime&&r.etag!==(0,m.$Rk)({mtime:r.mtime,size:b.size}))throw new m.$Gk((0,c.localize)(10,null),3,r);return b}async readFile(i,o,r){const t=await this.m(i);return o?.atomic?this.z(t,i,o,r):this.C(t,i,o,r)}async z(i,o,r,t){return new Promise((a,b)=>{this.cb.queueFor(o,this.R(i).providerExtUri).queue(async()=>{try{const C=await this.C(i,o,r,t);a(C)}catch(C){b(C)}})})}async C(i,o,r,t){const a=await this.D(i,o,{...r,preferUnbuffered:!0},t);return{...a,value:await(0,s.$se)(a.value)}}async readFileStream(i,o,r){const t=await this.m(i);return this.D(t,i,o,r)}async D(i,o,r,t){const a=new P.$3d(t);let b=r;(0,m.$tk)(i)&&i.enforceAtomicReadFile?.(o)&&(b={...r,atomic:!0});const C=this.J(o,b).then(k=>k,k=>{throw a.dispose(!0),k});let L;try{return typeof b?.etag=="string"&&b.etag!==m.$Qk&&await C,b?.atomic&&(0,m.$tk)(i)||!((0,m.$rk)(i)||(0,m.$sk)(i))||(0,m.$ok)(i)&&b?.preferUnbuffered?L=this.I(i,o,b):(0,m.$sk)(i)?L=this.G(i,o,a.token,b):L=this.H(i,o,a.token,b),L.on("end",()=>a.dispose()),L.on("error",()=>a.dispose()),{...await C,value:L}}catch(k){throw L&&await(0,g.$0d)(L),this.F(k,o,b)}}F(i,o,r){const t=(0,c.localize)(11,null,this.sb(o),(0,m.$zk)(i).toString());return i instanceof m.$Ik?new m.$Ik(t,i.stat,r):i instanceof m.$Hk?new m.$Hk(t,i.fileOperationResult,i.size,i.options):new m.$Gk(t,(0,m.$Ck)(i),r)}G(i,o,r,t=Object.create(null)){const a=i.readFileStream(o,t,r);return(0,g.$de)(a,{data:b=>b instanceof s.$ge?b:s.$ge.wrap(b),error:b=>this.F(b,o,t)},b=>s.$ge.concat(b))}H(i,o,r,t=Object.create(null)){const a=(0,s.$we)();return(0,h.$1p)(i,o,a,b=>b,{...t,bufferSize:this.a,errorTransformer:b=>this.F(b,o,t)},r),a}I(i,o,r){const t=(0,g.$7d)(a=>s.$ge.concat(a));return(async()=>{try{let a;r?.atomic&&(0,m.$tk)(i)?a=await i.readFile(o,{atomic:!0}):a=await i.readFile(o),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.L(o,a.byteLength,r),t.end(s.$ge.wrap(a))}catch(a){t.error(a),t.end()}})(),t}async J(i,o){const r=await this.resolve(i,{resolveMetadata:!0});if(r.isDirectory)throw new m.$Gk((0,c.localize)(12,null,this.sb(i)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.$Qk&&o.etag===r.etag)throw new m.$Ik((0,c.localize)(13,null),r,o);return this.L(i,r.size,o),r}L(i,o,r){if(typeof r?.limits?.size=="number"&&o>r.limits.size)throw new m.$Hk((0,c.localize)(14,null,this.sb(i)),7,o,r)}async canMove(i,o,r){return this.M(i,o,"move",r)}async canCopy(i,o,r){return this.M(i,o,"copy",r)}async M(i,o,r,t){if(i.toString()!==o.toString())try{const a=r==="move"?this.qb(await this.n(i),i):await this.m(i),b=this.qb(await this.n(o),o);await this.Q(a,i,b,o,r,t)}catch(a){return a}return!0}async move(i,o,r){const t=this.qb(await this.n(i),i),a=this.qb(await this.n(o),o),b=await this.N(t,i,a,o,"move",!!r),C=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$Dk(i,b==="move"?2:3,C)),C}async copy(i,o,r){const t=await this.m(i),a=this.qb(await this.n(o),o),b=await this.N(t,i,a,o,"copy",!!r),C=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$Dk(i,b==="copy"?3:2,C)),C}async N(i,o,r,t,a,b){if(o.toString()===t.toString())return a;const{exists:C,isSameResourceWithDifferentPathCase:L}=await this.Q(i,o,r,t,a,b);if(C&&!L&&b&&await this.del(t,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(t)),a==="copy"){if(i===r&&(0,m.$pk)(i))await i.copy(o,t,{overwrite:b});else{const k=await this.resolve(o);k.isDirectory?await this.P(i,k,r,t):await this.O(i,o,r,t)}return a}else return i===r?(await i.rename(o,t,{overwrite:b}),a):(await this.N(i,o,r,t,"copy",b),await this.del(o,{recursive:!0}),"copy")}async O(i,o,r,t){if((0,m.$rk)(i)&&(0,m.$rk)(r))return this.jb(i,o,r,t);if((0,m.$rk)(i)&&(0,m.$ok)(r))return this.pb(i,o,r,t);if((0,m.$ok)(i)&&(0,m.$rk)(r))return this.nb(i,o,r,t);if((0,m.$ok)(i)&&(0,m.$ok)(r))return this.lb(i,o,r,t)}async P(i,o,r,t){await r.mkdir(t),Array.isArray(o.children)&&await A.Promises.settled(o.children.map(async a=>{const b=this.R(r).providerExtUri.joinPath(t,a.name);return a.isDirectory?this.P(i,await this.resolve(a.resource),r,b):this.O(i,a.resource,r,b)}))}async Q(i,o,r,t,a,b){let C=!1;if(i===r){const{providerExtUri:k,isPathCaseSensitive:R}=this.R(i);if(R||(C=k.isEqual(o,t)),C&&a==="copy")throw new Error((0,c.localize)(15,null,this.sb(o),this.sb(t)));if(!C&&k.isEqualOrParent(t,o))throw new Error((0,c.localize)(16,null,this.sb(o),this.sb(t)))}const L=await this.exists(t);if(L&&!C){if(!b)throw new m.$Gk((0,c.localize)(17,null,this.sb(o),this.sb(t)),4);if(i===r){const{providerExtUri:k}=this.R(i);if(k.isEqualOrParent(o,t))throw new Error((0,c.localize)(18,null,this.sb(o),this.sb(t)))}}return{exists:L,isSameResourceWithDifferentPathCase:C}}R(i){const o=this.S(i);return{providerExtUri:o?f.$tg:f.$vg,isPathCaseSensitive:o}}S(i){return!!(i.capabilities&1024)}async createFolder(i){const o=this.qb(await this.j(i),i);await this.U(o,i);const r=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new m.$Dk(i,0,r)),r}async U(i,o){const r=[],{providerExtUri:t}=this.R(i);for(;!t.isEqual(o,t.dirname(o));)try{if(!((await i.stat(o)).type&m.FileType.Directory))throw new Error((0,c.localize)(19,null,this.sb(o)));break}catch(a){if((0,m.$Bk)(a)!==m.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(t.basename(o)),o=t.dirname(o)}for(let a=r.length-1;a>=0;a--){o=t.joinPath(o,r[a]);try{await i.mkdir(o)}catch(b){if((0,m.$Bk)(b)!==m.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(i,o){try{await this.W(i,o)}catch(r){return r}return!0}async W(i,o){const r=this.qb(await this.j(i),i),t=!!o?.useTrash;if(t&&!(r.capabilities&4096))throw new Error((0,c.localize)(20,null,this.sb(i)));const a=o?.atomic;if(a&&!(r.capabilities&65536))throw new Error((0,c.localize)(21,null,this.sb(i)));if(t&&a)throw new Error((0,c.localize)(22,null,this.sb(i)));let b;try{b=await r.stat(i)}catch{}if(b)this.rb(i,b);else throw new m.$Gk((0,c.localize)(23,null,this.sb(i)),1);if(!!!o?.recursive){const L=await this.resolve(i);if(L.isDirectory&&Array.isArray(L.children)&&L.children.length>0)throw new Error((0,c.localize)(24,null,this.sb(i)))}return r}async del(i,o){const r=await this.W(i,o);let t=o;if((0,m.$vk)(r)&&!t?.atomic){const L=r.enforceAtomicDelete?.(i);L&&(t={...o,atomic:L})}const a=!!t?.useTrash,b=!!t?.recursive,C=t?.atomic??!1;await r.delete(i,{recursive:b,useTrash:a,atomic:C}),this.r.fire(new m.$Dk(i,1))}async cloneFile(i,o){const r=await this.j(i),t=this.qb(await this.n(o),o);if(r===t&&this.R(r).providerExtUri.isEqual(i,o))return;if(r===t&&(0,m.$qk)(r))return r.cloneFile(i,o);await this.U(t,this.R(t).providerExtUri.dirname(o));const a=this.cb.queueFor(i,this.R(r).providerExtUri);return r===t&&(0,m.$pk)(r)?a.queue(()=>r.copy(i,o,{overwrite:!0})):a.queue(()=>this.O(r,i,t,o))}createWatcher(i,o){return this.watch(i,{...o,correlationId:$.ab++})}watch(i,o={recursive:!1,excludes:[]}){const r=new v.$Rc;let t=!1,a=()=>{t=!0};r.add((0,v.$Qc)(()=>a())),(async()=>{try{const C=await this.bb(i,o);t?(0,v.$Nc)(C):a=()=>(0,v.$Nc)(C)}catch(C){this.b.error(C)}})();const b=o.correlationId;if(typeof b=="number"){const C=r.add(new D.$Sd);return r.add(this.X.event(k=>{k.correlates(b)&&C.fire(k)})),{onDidChange:C.event,dispose:()=>r.dispose()}}return r}async bb(i,o){const r=await this.j(i),t=(0,S.$Pi)([this.R(r).providerExtUri.getComparisonKey(i),o]);let a=this.$.get(t);return a||(a={count:0,disposable:r.watch(i,o)},this.$.set(t,a)),a.count+=1,(0,v.$Qc)(()=>{a&&(a.count--,a.count===0&&((0,v.$Nc)(a.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,v.$Nc)(i.disposable);this.$.clear()}async db(i,o,r,t){return this.cb.queueFor(o,this.R(i).providerExtUri).queue(async()=>{const a=await i.open(o,{create:!0,unlock:r?.unlock??!1});try{(0,g.$5d)(t)||(0,g.$6d)(t)?await this.eb(i,a,t):await this.fb(i,a,t)}catch(b){throw(0,m.$zk)(b)}finally{await i.close(a)}})}async eb(i,o,r){let t=0,a;if((0,g.$6d)(r)){if(r.buffer.length>0){const b=s.$ge.concat(r.buffer);await this.gb(i,o,b,b.byteLength,t,0),t+=b.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((b,C)=>{(0,g.$$d)(a,{onData:async L=>{a.pause();try{await this.gb(i,o,L,L.byteLength,t,0)}catch(k){return C(k)}t+=L.byteLength,setTimeout(()=>a.resume())},onError:L=>C(L),onEnd:()=>b()})})}async fb(i,o,r){let t=0,a;for(;(a=r.read())!==null;)await this.gb(i,o,a,a.byteLength,t,0),t+=a.byteLength}async gb(i,o,r,t,a,b){let C=0;for(;C<t;){const L=await i.write(o,a+C,r.buffer,b+C,t-C);C+=L}}async hb(i,o,r,t){return this.cb.queueFor(o,this.R(i).providerExtUri).queue(()=>this.ib(i,o,r,t))}async ib(i,o,r,t){let a;t instanceof s.$ge?a=t:(0,g.$5d)(t)?a=await(0,s.$se)(t):(0,g.$6d)(t)?a=await(0,s.$te)(t):a=(0,s.$qe)(t),await i.writeFile(o,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async jb(i,o,r,t){return this.cb.queueFor(t,this.R(r).providerExtUri).queue(()=>this.kb(i,o,r,t))}async kb(i,o,r,t){let a,b;try{a=await i.open(o,{create:!1}),b=await r.open(t,{create:!0,unlock:!1});const C=s.$ge.alloc(this.a);let L=0,k=0,R=0;do R=await i.read(a,L,C.buffer,k,C.byteLength-k),await this.gb(r,b,C,R,L,k),L+=R,k+=R,k===C.byteLength&&(k=0);while(R>0)}catch(C){throw(0,m.$zk)(C)}finally{await A.Promises.settled([typeof a=="number"?i.close(a):Promise.resolve(),typeof b=="number"?r.close(b):Promise.resolve()])}}async lb(i,o,r,t){return this.cb.queueFor(t,this.R(r).providerExtUri).queue(()=>this.mb(i,o,r,t))}async mb(i,o,r,t){return r.writeFile(t,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,o,r,t){return this.cb.queueFor(t,this.R(r).providerExtUri).queue(()=>this.ob(i,o,r,t))}async ob(i,o,r,t){const a=await r.open(t,{create:!0,unlock:!1});try{const b=await i.readFile(o);await this.gb(r,a,s.$ge.wrap(b),b.byteLength,0,0)}catch(b){throw(0,m.$zk)(b)}finally{await r.close(a)}}async pb(i,o,r,t){const a=await(0,s.$se)(this.H(i,o,P.CancellationToken.None));await this.hb(r,t,void 0,a)}qb(i,o){if(i.capabilities&2048)throw new m.$Gk((0,c.localize)(25,null,this.sb(o)),6);return i}rb(i,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.$Gk((0,c.localize)(26,null,this.sb(i)),6)}sb(i){return i.scheme===E.Schemas.file?i.fsPath:i.toString(!0)}};e.$2p=u,u.ab=0,e.$2p=u=$=Ne([Le(0,d.$jj)],u)}),define(we[69],ve([1,0,29,302,14,26,15,5,39,2,7,4,19,48,22,189,16,110,225,40,223,222]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0,(()=>{try{(0,A.gracefulify)(y)}catch(i){console.error(`Error enabling graceful-fs: ${(0,l.$Mi)(i)}`)}})();class n extends d.$$p{constructor(o,r){super(o,r),this.onDidChangeCapabilities=S.Event.None,this.N=new P.$Ac(t=>w.$ug.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$e&&(this.J|=1024)),this.J}async stat(o){try{const{stat:r,symbolicLink:t}=await g.SymlinkSupport.stat(this.H(o));return{type:this.M(r,t),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:m.FilePermission.Locked}}catch(r){throw this.fb(r)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const r=await g.Promises.readdir(this.H(o),{withFileTypes:!0}),t=[];return await Promise.all(r.map(async a=>{try{let b;a.isSymbolicLink()?b=(await this.stat((0,w.$Dg)(o,a.name))).type:b=this.M(a),t.push([a.name,b])}catch(b){this.a.trace(b)}})),t}catch(r){throw this.fb(r)}}M(o,r){let t;return r?.dangling?t=m.FileType.Unknown:o.isFile()?t=m.FileType.File:o.isDirectory()?t=m.FileType.Directory:t=m.FileType.Unknown,r&&(t|=m.FileType.SymbolicLink),t}async O(o){const r=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let t;for(;t=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await t.wait();const a=new s.$1g;return this.N.set(o,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,v.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.N.get(o)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),a.open()})}async readFile(o,r){let t;try{r?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),t=await this.O(o));const a=this.H(o);return await g.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{t?.dispose()}}P(o){n.I&&this.a.trace(o)}readFileStream(o,r,t){const a=(0,f.$7d)(b=>D.$ge.concat(b.map(C=>D.$ge.wrap(C))).buffer);return(0,h.$1p)(this,o,a,b=>b.buffer,{...r,bufferSize:256*1024},t),a}async writeFile(o,r,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,w.$Dg)((0,w.$Cg)(o),`${(0,w.$Ag)(o)}${t.atomic.postfix}`),r,t):this.S(o,r,t)}async Q(o){try{const r=this.H(o),{symbolicLink:t}=await g.SymlinkSupport.stat(r);if(t)return!1}catch{}return!0}async R(o,r,t,a){const b=new v.$Rc;try{b.add(await this.O(o)),b.add(await this.O(r)),await this.S(r,t,a,!0);try{await this.rename(r,o,{overwrite:!0})}catch(C){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{b.dispose()}}async S(o,r,t,a){let b;try{const C=this.H(o);if(!t.create||!t.overwrite){if(await g.Promises.exists(C)){if(!t.overwrite)throw(0,m.$yk)((0,c.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,m.$yk)((0,c.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(o,{create:!0,unlock:t.unlock},a),await this.write(b,0,r,0,r.byteLength)}catch(C){throw await this.gb(o,C)}finally{typeof b=="number"&&await this.close(b)}}static configureFlushOnWrite(o){n.Y=o}async open(o,r,t){const a=this.H(o);let b;(0,m.$mk)(r)&&!t&&(b=await this.O(o));let C;try{if((0,m.$mk)(r)&&r.unlock)try{const{stat:k}=await g.SymlinkSupport.stat(a);k.mode&128||await g.Promises.chmod(a,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let L;if((0,m.$mk)(r)){if(E.$c)try{await g.Promises.truncate(a,0),L="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}L||(L="w")}else L="r";C=await g.Promises.open(a,L)}catch(L){throw b?.dispose(),(0,m.$mk)(r)?await this.gb(o,L):this.fb(L)}if(this.U.set(C,0),(0,m.$mk)(r)&&this.X.set(C,o),b){const L=this.W.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${a})`),this.W.set(C,b),L&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${a})`),L.dispose())}return C}async close(o){const r=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&n.Y)try{await g.Promises.fdatasync(o)}catch(t){n.configureFlushOnWrite(!1),this.a.error(t)}return await g.Promises.close(o)}catch(t){throw this.fb(t)}finally{r&&(this.W.get(o)===r&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),r.dispose())}}async read(o,r,t,a,b){const C=this.Z(o,r);let L=null;try{L=(await g.Promises.read(o,t,a,b,C)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(o,C,L)}return L}Z(o,r){return r===this.U.get(o)?null:r}$(o,r,t){const a=this.U.get(o);typeof a=="number"&&(typeof r=="number"||(typeof t=="number"?this.U.set(o,a+t):this.U.delete(o)))}async write(o,r,t,a,b){return(0,s.$jh)(()=>this.ab(o,r,t,a,b),100,3)}async ab(o,r,t,a,b){const C=this.Z(o,r);let L=null;try{L=(await g.Promises.write(o,t,a,b,C)).bytesWritten}catch(k){throw await this.gb(this.X.get(o),k)}finally{this.$(o,C,L)}return L}async mkdir(o){try{await g.Promises.mkdir(this.H(o))}catch(r){throw this.fb(r)}}async delete(o,r){try{const t=this.H(o);if(r.recursive){let a;r?.atomic!==!1&&r.atomic.postfix&&(a=(0,I.$jc)((0,I.$mc)(t),`${(0,I.$nc)(t)}${r.atomic.postfix}`)),await g.Promises.rm(t,g.RimRafMode.MOVE,a)}else try{await g.Promises.unlink(t)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let b=!1;try{const{stat:C,symbolicLink:L}=await g.SymlinkSupport.stat(t);b=C.isDirectory()&&!L}catch{}if(b)await g.Promises.rmdir(t);else throw a}else throw a}}catch(t){throw this.fb(t)}}async rename(o,r,t){const a=this.H(o),b=this.H(r);if(a!==b)try{await this.bb(o,r,"move",t.overwrite),await g.Promises.rename(a,b)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,c.localize)(2,null,(0,I.$nc)(a),(0,I.$nc)((0,I.$mc)(b)),C.toString()))),this.fb(C)}}async copy(o,r,t){const a=this.H(o),b=this.H(r);if(a!==b)try{await this.bb(o,r,"copy",t.overwrite),await g.Promises.copy(a,b,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,c.localize)(3,null,(0,I.$nc)(a),(0,I.$nc)((0,I.$mc)(b)),C.toString()))),this.fb(C)}}async bb(o,r,t,a){const b=this.H(o),C=this.H(r);let L=!1;if(!!(this.capabilities&1024)||(L=(0,p.$3f)(b,C,!0)),L){if(t==="copy")throw(0,m.$yk)((0,c.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const R=await this.L(o);if(!R)throw(0,m.$yk)((0,c.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const N=await this.L(r);if(N){if(!a)throw(0,m.$yk)((0,c.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);R.type&m.FileType.File&&N.type&m.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,r){return this.cb(o,r,!1)}async cb(o,r,t){const a=this.H(o),b=this.H(r),C=!!(this.capabilities&1024);if((0,p.$3f)(a,b,!C))return;const L=new v.$Rc;try{L.add(await this.O(o)),L.add(await this.O(r)),t&&await g.Promises.mkdir((0,I.$mc)(b),{recursive:!0}),await g.Promises.copyFile(a,b)}catch(k){if(k.code==="ENOENT"&&!t)return this.cb(o,r,!0);throw this.fb(k)}finally{L.dispose()}}t(o,r,t){return new $.$fq(a=>o(a),a=>r(a),t)}F(o,r,t){return new u.$nq(a=>o(a),a=>r(a),t)}fb(o){if(o instanceof m.$xk)return o;let r=o,t;switch(o.code){case"ENOENT":t=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=m.FileSystemProviderErrorCode.Unknown;break;default:t=m.FileSystemProviderErrorCode.Unknown}return(0,m.$yk)(r,t)}async gb(o,r){let t=this.fb(r);if(o&&t.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await g.SymlinkSupport.stat(this.H(o));a.mode&128||(t=(0,m.$yk)(r,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return t}}e.$oq=n,n.I=!1,n.Y=!0}),define(we[226],ve([1,0,5,69,2,15,48,20]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=void 0;class p extends s.$Sc{constructor(E,w){super(),this.a=E,this.b=w,this.F=new Map,this.G=new Map}call(E,w,f){const g=this.c(E);switch(w){case"stat":return this.g(g,f[0]);case"readdir":return this.h(g,f[0]);case"open":return this.r(g,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(g,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(g,f[0],f[1],f[2]);case"rename":return this.z(g,f[0],f[1],f[2]);case"copy":return this.C(g,f[0],f[1],f[2]);case"cloneFile":return this.D(g,f[0],f[1]);case"mkdir":return this.w(g,f[0]);case"delete":return this.y(g,f[0],f[1]);case"watch":return this.I(g,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${w} not found`)}listen(E,w,f){const g=this.c(E);switch(w){case"fileChange":return this.H(g,f[0]);case"readFileStream":return this.m(g,f[0],f[1])}throw new Error(`Unknown event ${w}`)}g(E,w){const f=this.f(E,w,!0);return this.a.stat(f)}h(E,w){const f=this.f(E,w);return this.a.readdir(f)}async j(E,w,f){const g=this.f(E,w,!0);this.b.trace(`File action: readFile ${g.path}`);const c=await this.a.readFile(g,f);return P.$ge.wrap(c)}m(E,w,f){const g=this.f(E,w,!0),c=new S.$3d,m=new y.$Sd({onDidRemoveLastListener:()=>{c.cancel()}});this.b.trace(`File action: readFileStream ${g.path}`);const h=this.a.readFileStream(g,f,c.token);return(0,D.$$d)(h,{onData:d=>m.fire(P.$ge.wrap(d)),onError:d=>m.fire(d),onEnd:()=>{m.fire("end"),m.dispose(),c.dispose()}}),m.event}n(E,w,f,g){const c=this.f(E,w);return this.b.trace(`File action: writeFile ${c.path}`),this.a.writeFile(c,f.buffer,g)}r(E,w,f){const g=this.f(E,w,!0);return this.a.open(g,f)}s(E){return this.a.close(E)}async t(E,w,f){const g=P.$ge.alloc(f),c=0,m=await this.a.read(E,w,g.buffer,c,f);return[g,m]}u(E,w,f,g,c){return this.a.write(E,w,f.buffer,g,c)}w(E,w){const f=this.f(E,w);return this.a.mkdir(f)}y(E,w,f){const g=this.f(E,w);return this.a.delete(g,f)}z(E,w,f,g){const c=this.f(E,w),m=this.f(E,f);return this.a.rename(c,m,g)}C(E,w,f,g){const c=this.f(E,w),m=this.f(E,f);return this.a.copy(c,m,g)}D(E,w,f){const g=this.f(E,w),c=this.f(E,f);return this.a.cloneFile(g,c)}H(E,w){const f=new y.$Sd({onWillAddFirstListener:()=>{this.F.set(w,this.L(E,f))},onDidRemoveLastListener:()=>{(0,s.$Nc)(this.F.get(w)),this.F.delete(w)}});return f.event}async I(E,w,f,g,c){const m=this.F.get(w);if(m){const h=this.f(E,g),d=m.watch(f,h,c);this.G.set(w+f,d)}}async J(E,w){const f=E+w,g=this.G.get(f);g&&((0,s.$Nc)(g),this.G.delete(f))}dispose(){super.dispose();for(const[,E]of this.G)E.dispose();this.G.clear();for(const[,E]of this.F)E.dispose();this.F.clear()}}e.$Wr=p;class v extends s.$Sc{constructor(E,w,f,g){super(),this.c=E,this.f=f,this.g=g,this.a=new Map,this.b=this.B(new A.$oq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(w)}h(E){const w=this.B(new y.$Sd);this.B(w.event(f=>{E.fire(f.map(g=>({resource:this.c.transformOutgoingURI(g.resource),type:g.type,cId:g.cId})))})),this.B(this.b.onDidChangeFile(f=>w.fire(f))),this.B(this.b.onDidWatchError(f=>E.fire(f)))}j(E){}m(E){}watch(E,w,f){const g=this.m(this.g);return Array.isArray(g)&&(f.excludes=[...f.excludes,...g]),this.a.set(E,this.b.watch(w,f)),(0,s.$Qc)(()=>{(0,s.$Nc)(this.a.get(E)),this.a.delete(E)})}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),super.dispose()}}e.$Xr=v}),define(we[113],ve([1,0,3,5,13,2]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=e.$mr=void 0;class D extends s.$uj{constructor(E,w,f,g,c){super(w,f,g),this.r=E,this.t=c,this.B(c.listen("onDidChangeLogLevel",E)(m=>{(0,s.$lj)(m)?super.setLogLevel(m):super.setLogLevel(y.URI.revive(m[0]),m[1])})),this.B(c.listen("onDidChangeVisibility",E)(([m,h])=>super.setVisibility(y.URI.revive(m),h))),this.B(c.listen("onDidChangeLoggers",E)(({added:m,removed:h})=>{for(const d of m)super.registerLogger({...d,resource:y.URI.revive(d.resource)});for(const d of h)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new s.$sj({log:(E,w)=>{this.t.call("consoleLog",[E,w])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,w){super.setLogLevel(E,w),this.t.call("setLogLevel",[E,w])}setVisibility(E,w){super.setVisibility(E,w),this.t.call("setVisibility",[this.n(E),w])}s(E,w,f){return new S(this.t,E,w,f,this.r)}static setLogLevel(E,w,f){return E.call("setLogLevel",[w,f])}}e.$mr=D;class S extends s.$pj{constructor(E,w,f,g,c){super(g?.logLevel==="always"),this.r=E,this.s=w,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[w,g,c]).then(()=>{this.u(this.n),this.m=!0})}g(E,w){const f=[[E,w]];this.m?this.u(f):this.n.push(...f)}u(E){this.r.call("log",[this.s,E])}}class p{constructor(E,w){this.a=E,this.b=w}listen(E,w){const f=this.b(E);switch(w){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(c=>this.c(c,f)),removed:[...g.removed].map(c=>this.c(c,f))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,g=>[f.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,g=>(0,s.$lj)(g)?g:[f.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${w}`)}async call(E,w,f){const g=this.b(E);switch(w){case"setLogLevel":return(0,s.$lj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(y.URI.revive(g.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,g)))}throw new Error(`Call not found: ${w}`)}c(E,w){return{...E,resource:w.transformOutgoingURI(E.resource)}}}e.$nr=p;class v extends P.$Sc{constructor(E,w){super(),w.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(f=>w.call("setLogLevel",[f]))),w.call("getRegisteredLoggers").then(f=>{for(const g of f)E.registerLogger({...g,resource:y.URI.revive(g.resource)})}),this.B(w.listen("onDidChangeVisibility")(([f,g])=>E.setVisibility(y.URI.revive(f),g))),this.B(w.listen("onDidChangeLoggers")(({added:f,removed:g})=>{for(const c of f)E.registerLogger({...c,resource:y.URI.revive(c.resource)});for(const c of g)E.deregisterLogger(c.resource)}))}}e.$or=v}),define(we[114],ve([1,0,2,13]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dO=void 0;class s extends y.$Sc{constructor(D,S=[]){super(),this.a=new A.$tj([D,...S]),this.B(D.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.$dO=s}),define(we[227],ve([1,0,16,13]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5N=void 0;var s;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(s||(s={}));async function P(v,I,E,w,f){try{const g=await new Promise((m,h)=>{he(["@vscode/spdlog"],m,h)});g.setFlushOn(s.Trace);const c=await g.createAsyncRotatingLogger(v,I,E,w);return f?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(g){console.error(g)}return null}function D(v,I,E){switch(I){case A.LogLevel.Trace:v.trace(E);break;case A.LogLevel.Debug:v.debug(E);break;case A.LogLevel.Info:v.info(E);break;case A.LogLevel.Warning:v.warn(E);break;case A.LogLevel.Error:v.error(E);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function S(v,I){switch(I){case A.LogLevel.Trace:v.setLevel(s.Trace);break;case A.LogLevel.Debug:v.setLevel(s.Debug);break;case A.LogLevel.Info:v.setLevel(s.Info);break;case A.LogLevel.Warning:v.setLevel(s.Warning);break;case A.LogLevel.Error:v.setLevel(s.Error);break;case A.LogLevel.Off:v.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class p extends A.$pj{constructor(I,E,w,f,g){super(),this.m=[],this.setLevel(g),this.n=this.s(I,E,w,f),this.B(this.onDidChangeLogLevel(c=>{this.r&&S(this.r,c)}))}async s(I,E,w,f){const g=w?6:1,c=30/g*y.$Tk.MB,m=await P(I,E,c,g,f);if(m){this.r=m,S(this.r,this.getLevel());for(const{level:h,message:d}of this.m)D(this.r,h,d);this.m=[]}}g(I,E){this.r?D(this.r,I,E):this.getLevel()<=I&&this.m.push({level:I,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$5N=p}),define(we[115],ve([1,0,21,13,227]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6N=void 0;class P extends A.$uj{s(S,p,v){return new s.$5N((0,y.$mg)(),S.fsPath,!v?.donotRotate,!!v?.donotUseFormatters,p)}}e.$6N=P}),define(we[228],ve([1,0,64,191,6]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var D;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(D||(e.MarkerSeverity=D={})),function(p){function v(g,c){return c-g}p.compare=v;const I=Object.create(null);I[p.Error]=(0,A.localize)(0,null),I[p.Warning]=(0,A.localize)(1,null),I[p.Info]=(0,A.localize)(2,null);function E(g){return I[g]||""}p.toString=E;function w(g){switch(g){case y.default.Error:return p.Error;case y.default.Warning:return p.Warning;case y.default.Info:return p.Info;case y.default.Ignore:return p.Hint}}p.fromSeverity=w;function f(g){switch(g){case p.Error:return y.default.Error;case p.Warning:return y.default.Warning;case p.Info:return y.default.Info;case p.Hint:return y.default.Ignore}}p.toSeverity=f}(D||(e.MarkerSeverity=D={}));var S;(function(p){const v="";function I(w){return E(w,!0)}p.makeKey=I;function E(w,f){const g=[v];return w.source?g.push(w.source.replace("\xA6","\\\xA6")):g.push(v),w.code?typeof w.code=="string"?g.push(w.code.replace("\xA6","\\\xA6")):g.push(w.code.value.replace("\xA6","\\\xA6")):g.push(v),w.severity!==void 0&&w.severity!==null?g.push(D.toString(w.severity)):g.push(v),w.message&&f?g.push(w.message.replace("\xA6","\\\xA6")):g.push(v),w.startLineNumber!==void 0&&w.startLineNumber!==null?g.push(w.startLineNumber.toString()):g.push(v),w.startColumn!==void 0&&w.startColumn!==null?g.push(w.startColumn.toString()):g.push(v),w.endLineNumber!==void 0&&w.endLineNumber!==null?g.push(w.endLineNumber.toString()):g.push(v),w.endColumn!==void 0&&w.endColumn!==null?g.push(w.endColumn.toString()):g.push(v),g.push(v),g.join("\xA6")}p.makeKeyOptionalMessage=E})(S||(e.IMarkerData=S={})),e.$nt=(0,s.$2h)("markerService")}),define(we[70],ve([1,0,5,47,2,6]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=void 0,e.$wn=(0,P.$2h)("policy");class D extends s.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new y.$Sd),this.onDidChange=this.h.event}async updatePolicyDefinitions(v){const I=Object.keys(this.f).length;return this.f={...v,...this.f},I!==Object.keys(this.f).length&&await this.j(v),A.Iterable.reduce(this.g.entries(),(E,[w,f])=>({...E,[w]:f}),{})}getPolicyValue(v){return this.g.get(v)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(v,[I,E])=>({...v,[I]:{definition:E,value:this.g.get(I)}}),{})}}e.$xn=D;class S{constructor(){this.onDidChange=y.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$yn=S}),define(we[55],ve([1,0,28]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const P=s.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,y.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:P.version})}Object.assign(A,{extensionsGallery:y.env.EXTENSIONS_GALLERY?JSON.parse(y.env.EXTENSIONS_GALLERY):A.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else A={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.85.0",sha256:"85a97d373a6f92359f5db7bfc5a2fa6c5763b22c6ad07c962dfe32c84a079f3b",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"4.20.0-rc.1",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.85.0",commit:"962283051886d59307d489b67787ae04cbb7a324",date:"2023-12-08T10:20:54.785Z"},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(we[31],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,y.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"}),define(we[37],ve([1,0,97,8]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0;class s{constructor(){this.a=new Map}add(D,S){y.ok(A.$Ef(D)),y.ok(A.$Gf(S)),y.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$un=new s}),define(we[229],ve([1,0,5,37]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$vn={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class P{constructor(){this.b=new y.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,v){this.a[s(p)]=v,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const D=new P;A.$un.add(e.$vn.JSONContribution,D)}),define(we[56],ve([1,0,18,5,8,173,24,229,37]),function(he,e,y,A,s,P,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.ConfigurationScope=e.$zn=e.EditPresentationTypes=void 0;var v;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.$zn={Configuration:"base.contributions.configuration"};var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn="vscode://schemas/settings/resourceLanguage",e.$Hn="vscode://schemas/settings/configurationDefaults";const E=p.$un.as(S.$vn.JSONContribution);class w{constructor(){this.h=new Set,this.i=new A.$Sd,this.onDidSchemaChange=this.i.event,this.j=new A.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Gn,this.g),this.v()}registerConfiguration(n,i=!0){this.registerConfigurations([n],i)}registerConfigurations(n,i=!0){const o=new Set;this.n(n,i,o),E.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(n){const i=new Set;this.o(n,i),E.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:n,remove:i}){const o=new Set;this.o(i,o),this.n(n,!1,o),E.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(n){const i=new Set;this.k(n,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(n,i){const o=[];for(const{overrides:r,source:t}of n)for(const a in r)if(i.add(a),e.$Jn.test(a)){const b=this.a.get(a),C=b?.valuesSources??new Map;if(t)for(const N of Object.keys(r[a]))C.set(N,t);const L={...b?.value||{},...r[a]};this.a.set(a,{source:t,value:L,valuesSources:C});const k=(0,D.$Fi)(a),R={type:"object",default:L,description:P.localize(1,null,k),$ref:e.$Gn,defaultDefaultValue:L,source:s.$Ef(t)?void 0:t,defaultValueSource:t};o.push(...c(a)),this.d[a]=R,this.b.properties[a]=R}else{this.a.set(a,{value:r[a],source:t});const b=this.d[a];b&&(this.w(a,b),this.r(a,b))}this.m(o)}deregisterDefaultConfigurations(n){const i=new Set;this.l(n,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(n,i){for(const{overrides:o,source:r}of n)for(const t in o){const a=this.a.get(t),b=s.$Ef(r)?r:r?.id,C=s.$Ef(a?.source)?a?.source:a?.source?.id;if(b===C)if(i.add(t),this.a.delete(t),e.$Jn.test(t))delete this.d[t],delete this.b.properties[t];else{const L=this.d[t];L&&(this.w(t,L),this.r(t,L))}}this.u()}deltaConfiguration(n){let i=!1;const o=new Set;n.removedDefaults&&(this.l(n.removedDefaults,o),i=!0),n.addedDefaults&&(this.k(n.addedDefaults,o),i=!0),n.removedConfigurations&&this.o(n.removedConfigurations,o),n.addedConfigurations&&this.n(n.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const i of n)this.h.add(i);this.u()}n(n,i,o){n.forEach(r=>{this.p(r,i,r.extensionInfo,r.restrictedProperties,void 0,o),this.c.push(r),this.q(r)})}o(n,i){const o=r=>{if(r.properties)for(const t in r.properties){i.add(t);const a=this.d[t];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[t],this.s(t,r.properties[t])}r.allOf?.forEach(t=>o(t))};for(const r of n){o(r);const t=this.c.indexOf(r);t!==-1&&this.c.splice(t,1)}}p(n,i=!0,o,r,t=3,a){t=s.$Nf(n.scope)?t:n.scope;const b=n.properties;if(b)for(const L in b){const k=b[L];if(i&&l(L,k)){delete b[L];continue}if(k.source=o,k.defaultDefaultValue=b[L].default,this.w(L,k),e.$Jn.test(L)?k.scope=void 0:(k.scope=s.$Nf(k.scope)?t:k.scope,k.restricted=s.$Nf(k.restricted)?!!r?.includes(L):k.restricted),b[L].hasOwnProperty("included")&&!b[L].included){this.f[L]=b[L],delete b[L];continue}else this.d[L]=b[L],b[L].policy?.name&&this.e.set(b[L].policy.name,L);!b[L].deprecationMessage&&b[L].markdownDeprecationMessage&&(b[L].deprecationMessage=b[L].markdownDeprecationMessage),a.add(L)}const C=n.allOf;if(C)for(const L of C)this.p(L,i,o,r,t,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const i=o=>{const r=o.properties;if(r)for(const a in r)this.r(a,r[a]);o.allOf?.forEach(i)};i(n)}r(n,i){switch(e.$An.properties[n]=i,i.scope){case 1:e.$Bn.properties[n]=i;break;case 2:e.$Cn.properties[n]=i;break;case 6:e.$Dn.properties[n]=i;break;case 3:e.$En.properties[n]=i;break;case 4:e.$Fn.properties[n]=i;break;case 5:e.$Fn.properties[n]=i,this.g.properties[n]=i;break}}s(n,i){switch(delete e.$An.properties[n],i.scope){case 1:delete e.$Bn.properties[n];break;case 2:delete e.$Cn.properties[n];break;case 6:delete e.$Dn.properties[n];break;case 3:delete e.$En.properties[n];break;case 4:case 5:delete e.$Fn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const i=`[${n}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$Gn};this.w(i,o),e.$An.properties[i]=o,e.$Bn.properties[i]=o,e.$Cn.properties[i]=o,e.$Dn.properties[i]=o,e.$En.properties[i]=o,e.$Fn.properties[i]=o}}v(){const n={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$Gn};e.$An.patternProperties[e.$In]=n,e.$Bn.patternProperties[e.$In]=n,e.$Cn.patternProperties[e.$In]=n,e.$Dn.patternProperties[e.$In]=n,e.$En.patternProperties[e.$In]=n,e.$Fn.patternProperties[e.$In]=n,this.i.fire()}w(n,i){const o=this.a.get(n);let r=o?.value,t=o?.source;s.$Lf(r)&&(r=i.defaultDefaultValue,t=void 0),s.$Lf(r)&&(r=h(i.type)),i.default=r,i.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",g=new RegExp(f,"g");e.$In=`^(${f})+$`,e.$Jn=new RegExp(e.$In);function c(u){const n=[];if(e.$Jn.test(u)){let i=g.exec(u);for(;i?.length;){const o=i[1].trim();o&&n.push(o),i=g.exec(u)}}return(0,y.$Mb)(n)}e.$Kn=c;function m(u){return u.reduce((n,i)=>`${n}[${i}]`,"")}e.$Ln=m;function h(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Mn=h;const d=new w;p.$un.add(e.$zn.Configuration,d);function l(u,n){return u.trim()?e.$Jn.test(u)?P.localize(7,null,u):d.getConfigurationProperties()[u]!==void 0?P.localize(8,null,u):n.policy?.name&&d.getPolicyConfigurations().get(n.policy?.name)!==void 0?P.localize(9,null,u,n.policy?.name,d.getPolicyConfigurations().get(n.policy?.name)):null:P.localize(6,null)}e.$Nn=l;function $(){const u=[],n=d.getConfigurationProperties();for(const i of Object.keys(n))u.push([i,n[i].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$On=$}),define(we[116],ve([1,0,18,5,76,2,26,23,8,3,24,56,37]),function(he,e,y,A,s,P,D,S,p,v,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=void 0;function f(i){return Object.isFrozen(i)?i:S.$jn(i)}class g{constructor(o={},r=[],t=[],a){this.b=o,this.c=r,this.d=t,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(r=>{if(r instanceof g)return r;const t=new c("");return t.parseRaw(r),t.configurationModel});this.f=o.reduce((r,t)=>t===r?t:r.merge(t),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,I.$Di)(this.contents,o):this.contents}inspect(o,r){const t=this.rawConfiguration.getValue(o),a=r?this.rawConfiguration.getOverrideValue(o,r):void 0,b=r?this.rawConfiguration.override(r).getValue(o):t;return{value:t,override:a,merged:b}}getOverrideValue(o,r){const t=this.i(r);return t?o?(0,I.$Di)(t,o):t:void 0}getKeysForOverrideIdentifier(o){const r=[];for(const t of this.overrides)t.identifiers.includes(o)&&r.push(...t.keys);return y.$Mb(r)}getAllOverrideIdentifiers(){const o=[];for(const r of this.overrides)o.push(...r.identifiers);return y.$Mb(o)}override(o){let r=this.a.get(o);return r||(r=this.g(o),this.a.set(o,r)),r}merge(...o){const r=S.$in(this.contents),t=S.$in(this.overrides),a=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const C of o)if(b.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(r,C.contents);for(const L of C.overrides){const[k]=t.filter(R=>y.$ub(R.identifiers,L.identifiers));k?(this.h(k.contents,L.contents),k.keys.push(...L.keys),k.keys=y.$Mb(k.keys)):t.push(S.$in(L))}for(const L of C.keys)a.indexOf(L)===-1&&a.push(L)}return new g(r,a,t,b.every(C=>C instanceof g)?void 0:b)}g(o){const r=this.i(o);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const t={};for(const a of y.$Mb([...Object.keys(this.contents),...Object.keys(r)])){let b=this.contents[a];const C=r[a];C&&(typeof b=="object"&&typeof C=="object"?(b=S.$in(b),this.h(b,C)):b=C),t[a]=b}return new g(t,this.keys,this.overrides)}h(o,r){for(const t of Object.keys(r)){if(t in o&&p.$Gf(o[t])&&p.$Gf(r[t])){this.h(o[t],r[t]);continue}o[t]=S.$in(r[t])}}i(o){let r=null,t=null;const a=b=>{b&&(t?this.h(t,b):t=S.$in(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===o?r=b.contents:b.identifiers.includes(o)&&a(b.contents);return a(r),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,r){this.j(o,r,!0)}setValue(o,r){this.j(o,r,!1)}removeValue(o){const r=this.keys.indexOf(o);r!==-1&&(this.keys.splice(r,1),(0,I.$Ci)(this.contents,o),E.$Jn.test(o)&&this.overrides.splice(this.overrides.findIndex(t=>y.$ub(t.identifiers,(0,E.$Kn)(o))),1))}j(o,r,t){(0,I.$Bi)(this.contents,o,r,a=>console.error(a)),t=t||this.keys.indexOf(o)===-1,t&&this.keys.push(o),E.$Jn.test(o)&&this.overrides.push({identifiers:(0,E.$Kn)(o),keys:Object.keys(this.contents[o]),contents:(0,I.$Ai)(this.contents[o],a=>console.error(a))})}}e.$Pn=g;class c{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,r){if(!p.$Nf(o)){const t=this.g(o);this.parseRaw(t,r)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,r){this.a=o;const{contents:t,keys:a,overrides:b,restricted:C,hasExcludedProperties:L}=this.h(o,r);this.b=new g(t,a,b,L?[o]:void 0),this.c=C||[]}g(o){let r={},t=null,a=[];const b=[],C=[];function L(R){Array.isArray(a)?a.push(R):t!==null&&(a[t]=R)}const k={onObjectBegin:()=>{const R={};L(R),b.push(a),a=R,t=null},onObjectProperty:R=>{t=R},onObjectEnd:()=>{a=b.pop()},onArrayBegin:()=>{const R=[];L(R),b.push(a),a=R,t=null},onArrayEnd:()=>{a=b.pop()},onLiteralValue:L,onError:(R,N,Y)=>{C.push({error:R,offset:N,length:Y})}};if(o)try{s.$fn(o,k),r=a[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return r}h(o,r){const t=w.$un.as(E.$zn.Configuration).getConfigurationProperties(),a=this.i(o,t,!0,r);o=a.raw;const b=(0,I.$Ai)(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),C=Object.keys(o),L=this.j(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:b,keys:C,overrides:L,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(o,r,t,a){let b=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:b};const C={},L=[];for(const k in o)if(E.$Jn.test(k)&&t){const R=this.i(o[k],r,!1,a);C[k]=R.raw,b=b||R.hasExcludedProperties,L.push(...R.restricted)}else{const R=r[k],N=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&L.push(k),!a.exclude?.includes(k)&&(a.include?.includes(k)||(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&!(a.skipRestricted&&R?.restricted))?C[k]=o[k]:b=!0}return{raw:C,restricted:L,hasExcludedProperties:b}}j(o,r){const t=[];for(const a of Object.keys(o))if(E.$Jn.test(a)){const b={};for(const C in o[a])b[C]=o[a][C];t.push({identifiers:(0,E.$Kn)(a),keys:Object.keys(b),contents:(0,I.$Ai)(b,r)})}return t}}e.$Qn=c;class m extends P.$Sc{constructor(o,r,t,a){super(),this.c=o,this.f=r,this.g=a,this.b=this.B(new A.$Sd),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&t.isEqual(b.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Rn=m;class h{constructor(o,r,t,a,b,C,L,k,R,N,Y,ee,G){this.a=o,this.b=r,this.c=t,this.overrideIdentifiers=a,this.d=b,this.f=C,this.g=L,this.h=k,this.i=R,this.j=N,this.k=Y,this.l=ee,this.m=G}get value(){return f(this.c)}n(o,r,t){const a=o.inspect(r,t);return{get value(){return f(a.value)},get override(){return f(a.override)},get merged(){return f(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(o,r,t,a,b=new g,C=new g,L=new D.$Ac,k=new g,R=new D.$Ac){this.c=o,this.d=r,this.f=t,this.g=a,this.h=b,this.i=C,this.j=L,this.l=k,this.m=R,this.a=null,this.b=new D.$Ac,this.n=null}getValue(o,r,t){return this.p(o,r,t).getValue(o)}updateValue(o,r,t={}){let a;t.resource?(a=this.m.get(t.resource),a||(a=new g,this.m.set(t.resource,a))):a=this.l,r===void 0?a.removeValue(o):a.setValue(o,r),t.resource||(this.a=null)}inspect(o,r,t){const a=this.p(o,r,t),b=this.t(r.resource,t),C=r.resource?this.m.get(r.resource)||this.l:this.l,L=new Set;for(const k of a.overrides)for(const R of k.identifiers)a.getOverrideValue(o,R)!==void 0&&L.add(R);return new h(o,r,a.getValue(o),L.size?[...L]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,b||void 0,C)}keys(o){const r=this.t(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,r){this.j.set(o,r),this.b.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,r){const t=[];if(!r){const{added:a,updated:b,removed:C}=u(this.c,o);r=[...a,...b,...C]}for(const a of r)for(const b of(0,E.$Kn)(a)){const C=this.c.getKeysForOverrideIdentifier(b),L=o.getKeysForOverrideIdentifier(b),k=[...L.filter(R=>C.indexOf(R)===-1),...C.filter(R=>L.indexOf(R)===-1),...C.filter(R=>!S.$mn(this.c.override(b).getValue(R),o.override(b).getValue(R)))];t.push([b,k])}return this.updateDefaultConfiguration(o),{keys:r,overrides:t}}compareAndUpdatePolicyConfiguration(o){const{added:r,updated:t,removed:a}=u(this.d,o),b=[...r,...t,...a];return b.length&&this.updatePolicyConfiguration(o),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:r,updated:t,removed:a,overrides:b}=u(this.applicationConfiguration,o),C=[...r,...t,...a];return C.length&&this.updateApplicationConfiguration(o),{keys:C,overrides:b}}compareAndUpdateLocalUserConfiguration(o){const{added:r,updated:t,removed:a,overrides:b}=u(this.localUserConfiguration,o),C=[...r,...t,...a];return C.length&&this.updateLocalUserConfiguration(o),{keys:C,overrides:b}}compareAndUpdateRemoteUserConfiguration(o){const{added:r,updated:t,removed:a,overrides:b}=u(this.remoteUserConfiguration,o),C=[...r,...t,...a];return C.length&&this.updateRemoteUserConfiguration(o),{keys:C,overrides:b}}compareAndUpdateWorkspaceConfiguration(o){const{added:r,updated:t,removed:a,overrides:b}=u(this.workspaceConfiguration,o),C=[...r,...t,...a];return C.length&&this.updateWorkspaceConfiguration(o),{keys:C,overrides:b}}compareAndUpdateFolderConfiguration(o,r){const t=this.folderConfigurations.get(o),{added:a,updated:b,removed:C,overrides:L}=u(t,r),k=[...a,...b,...C];return(k.length||!t)&&this.updateFolderConfiguration(o,r),{keys:k,overrides:L}}compareAndDeleteFolderConfiguration(o){const r=this.folderConfigurations.get(o);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:t,updated:a,removed:b,overrides:C}=u(r,void 0);return{keys:[...t,...a,...b],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(o,r,t){let a=this.q(r,t);return r.overrideIdentifier&&(a=a.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(a=a.merge(this.d)),a}q({resource:o},r){let t=this.r();if(r&&o){const a=r.getFolder(o);a&&(t=this.s(a.uri)||t);const b=this.m.get(o);b&&(t=t.merge(b))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(o){let r=this.b.get(o);if(!r){const t=this.r(),a=this.j.get(o);a?(r=t.merge(a),this.b.set(o,r)):r=t}return r}t(o,r){if(r&&o){const t=r.getFolder(o);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,r)=>{const{contents:t,overrides:a,keys:b}=this.j.get(r);return o.push([r,{contents:t,overrides:a,keys:b}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(r=>o.add(r)),this.userConfiguration.keys.forEach(r=>o.add(r)),this.i.keys.forEach(r=>o.add(r)),this.j.forEach(r=>r.keys.forEach(t=>o.add(t))),[...o.values()]}u(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>o.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>o.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>o.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(t=>o.add(t))),[...o.values()]}v(o){const r=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(t=>r.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(t=>r.add(t)),this.i.getKeysForOverrideIdentifier(o).forEach(t=>r.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(o).forEach(a=>r.add(a))),[...r.values()]}static parse(o){const r=this.w(o.defaults),t=this.w(o.policy),a=this.w(o.application),b=this.w(o.user),C=this.w(o.workspace),L=o.folders.reduce((k,R)=>(k.set(v.URI.revive(R[0]),this.w(R[1])),k),new D.$Ac);return new d(r,t,a,b,new g,C,L,new g,new D.$Ac)}static w(o){return new g(o.contents,o.keys,o.overrides)}}e.$Sn=d;function l(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const o=new Set,r=new Map;for(const a of i)a.keys.forEach(b=>o.add(b)),a.overrides.forEach(([b,C])=>{const L=(0,D.$xc)(r,b,new Set);C.forEach(k=>L.add(k))});const t=[];return r.forEach((a,b)=>t.push([b,[...a.values()]])),{keys:[...o.values()],overrides:t}}e.$Tn=l;class ${constructor(o,r,t,a){this.change=o,this.f=r,this.g=t,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const b of o.keys)this.affectedKeys.add(b);for(const[,b]of o.overrides)for(const C of b)this.affectedKeys.add(C);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(o,r){const t=this.a+o,a=this.d.indexOf(t);if(a<0)return!1;const b=a+t.length;if(b>=this.d.length)return!1;const C=this.d.charCodeAt(b);if(C!==this.b&&C!==this.c)return!1;if(r){const L=this.previousConfiguration?this.previousConfiguration.getValue(o,r,this.f?.workspace):void 0,k=this.g.getValue(o,r,this.h);return!S.$mn(L,k)}return!0}}e.$Un=$;function u(i,o){const{added:r,removed:t,updated:a}=n(o?.rawConfiguration,i?.rawConfiguration),b=[],C=i?.getAllOverrideIdentifiers()||[],L=o?.getAllOverrideIdentifiers()||[];if(o){const k=L.filter(R=>!C.includes(R));for(const R of k)b.push([R,o.getKeysForOverrideIdentifier(R)])}if(i){const k=C.filter(R=>!L.includes(R));for(const R of k)b.push([R,i.getKeysForOverrideIdentifier(R)])}if(o&&i){for(const k of C)if(L.includes(k)){const R=n({contents:i.getOverrideValue(void 0,k)||{},keys:i.getKeysForOverrideIdentifier(k)},{contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)});b.push([k,[...R.added,...R.removed,...R.updated]])}}return{added:r,removed:t,updated:a,overrides:b}}function n(i,o){const r=i?o?i.keys.filter(b=>o.keys.indexOf(b)===-1):[...i.keys]:[],t=o?i?o.keys.filter(b=>i.keys.indexOf(b)===-1):[...o.keys]:[],a=[];if(i&&o){for(const b of o.keys)if(i.keys.indexOf(b)!==-1){const C=(0,I.$Di)(o.contents,b),L=(0,I.$Di)(i.contents,b);S.$mn(C,L)||a.push(b)}}return{added:r,removed:t,updated:a}}}),define(we[230],ve([1,0,18,5,2,23,8,116,56,13,70,37]),function(he,e,y,A,s,P,D,S,p,v,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=e.$Wn=e.$Vn=void 0;class w extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new A.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$Pn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$un.as(p.$zn.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:h})=>this.c(Array.from(m),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,h){this.h(m,E.$un.as(p.$zn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new S.$Pn;const m=E.$un.as(p.$zn.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,h){const d=this.f();for(const l of m){const $=d[l],u=h[l];$!==void 0?this.b.addValue(l,$):u?this.b.addValue(l,u.default):this.b.removeValue(l)}}}e.$Vn=w;class f{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new S.$Pn}async initialize(){return this.configurationModel}}e.$Wn=f;let g=class extends s.$Sc{get configurationModel(){return this.b}constructor(m,h,d){super(),this.c=m,this.f=h,this.g=d,this.a=this.B(new A.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$Pn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const h={},d=[],l=E.$un.as(p.$zn.Configuration).getConfigurationProperties();for(const $ of m){const u=l[$];if(!u){d.push($);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}d.push($),h[u.policy.name]={type:u.type}}}return(0,D.$Rf)(h)||await this.f.updatePolicyDefinitions(h),d}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const h=E.$un.as(p.$zn.Configuration).getPolicyConfigurations(),d=(0,y.$Hb)(m.map(l=>h.get(l)));this.m(d,!0)}m(m,h){this.g.trace("PolicyConfiguration#update",m);const d=E.$un.as(p.$zn.Configuration).getConfigurationProperties(),l=[],$=this.b.isEmpty();for(const u of m){const n=d[u]?.policy?.name;if(n){const i=this.f.getPolicyValue(n);($?i!==void 0:!(0,P.$mn)(this.b.getValue(u),i))&&l.push([u,i])}else this.b.getValue(u)!==void 0&&l.push([u,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const u=this.b;this.b=new S.$Pn;for(const n of u.keys)this.b.setValue(n,u.getValue(n));for(const[n,i]of l)i===void 0?this.b.removeValue(n):this.b.setValue(n,i);h&&this.a.fire(this.b)}}};e.$Xn=g,e.$Xn=g=Ne([Le(1,I.$wn),Le(2,v.$jj)],g)}),define(we[117],ve([1,0,14,5,2,19,24,116,230,70]),function(he,e,y,A,s,P,D,S,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0;class I extends s.$Sc{constructor(w,f,g,c){super(),this.j=w,this.h=this.B(new A.$Sd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$Vn),this.c=g instanceof v.$yn?new p.$Wn:this.B(new p.$Xn(this.b,g,c)),this.f=this.B(new S.$Rn(this.j,{},P.$ug,f)),this.a=new S.$Sn(this.b.configurationModel,this.c.configurationModel,new S.$Pn,new S.$Pn),this.g=this.B(new y.$bh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:m,properties:h})=>this.n(m,h))),this.B(this.c.onDidChangeConfiguration(m=>this.r(m))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,f,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$Sn(w,f,new S.$Pn,g)}getConfigurationData(){return this.a.toData()}getValue(w,f){const g=typeof w=="string"?w:void 0,c=(0,D.$wi)(w)?w:(0,D.$wi)(f)?f:{};return this.a.getValue(g,c,void 0)}updateValue(w,f,g,c){return Promise.reject(new Error("not supported"))}inspect(w){return this.a.inspect(w,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.m(w)}m(w){const f=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(w);this.s(g,f,2)}n(w,f){const g=this.a.toData(),c=this.a.compareAndUpdateDefaultConfiguration(w,f);this.s(c,g,7)}r(w){const f=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(w);this.s(g,f,7)}s(w,f,g){const c=new S.$Un(w,{data:f},this.a);c.source=g,c.sourceConfig=this.t(g),this.h.fire(c)}t(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Yn=I}),define(we[118],ve([1,0,11,6]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.RemoteAuthorityResolverErrorCode=e.$5k=e.$4k=e.RemoteConnectionType=e.$3k=void 0,e.$3k=(0,A.$2h)("remoteAuthorityResolverService");var s;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class P{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$4k=P;class D{constructor(E,w){this.host=E,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$5k=D;var S;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class p extends y.$bb{static isNotAvailable(E){return E instanceof p&&E._code===S.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof p&&E._code===S.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof p&&E._code===S.NoResolverFound}static isInvalidAuthority(E){return E instanceof p&&E._code===S.InvalidAuthority}static isHandled(E){return E instanceof p&&E.isHandled}constructor(E,w=S.Unknown,f){super(E),this._message=E,this._code=w,this._detail=f,this.isHandled=w===S.NotAvailable&&f===!0,Object.setPrototypeOf(this,p.prototype)}}e.$6k=p;function v(I){const E=I.indexOf("+");return E===-1?I:I.substring(0,E)}e.$7k=v}),define(we[231],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gO=e.$fO=void 0,e.$fO=(0,y.$2h)("IRemoteExtensionsScannerService"),e.$gO="remoteExtensionsScanner"}),define(we[57],ve([1,0,12]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0;function A(v){return v.scheme===y.Schemas.vscodeRemote?v.authority:void 0}e.$8k=A;function s(v){if(!v)return;const I=v.indexOf("+");return I<0?v:v.substr(0,I)}e.$9k=s;function P(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.$0k=P;function D(v){const{host:I,port:E}=p(v);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:E}}e.$$k=D;function S(v,I){let{host:E,port:w}=p(v);return typeof w>"u"&&(w=I),{host:E,port:w}}e.$_k=S;function p(v){const I=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const E=v.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const w=v.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:v,port:void 0}}}),define(we[35],ve([1,0,17,6,57]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.TargetPlatform=e.ExtensionType=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=void 0,e.$bm="extensions.user.cache",e.$cm="extensions.builtin.cache",e.$dm="undefined_publisher",e.$em=["ui","workspace","web"];function P(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$fm=P,e.$gm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(D||(e.ExtensionType=D={}));var S;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class p{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,h){if(typeof m>"u"||m===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof m=="string"||typeof h=="string"){const d=typeof m=="string"?m:m.value,l=typeof h=="string"?h:h.value;return y.$8e(d,l)}return m._lower===h._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$hm=p;class v{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const h of m)this.add(h)}add(m){this.c.add(p.toKey(m))}delete(m){return this.c.delete(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}}e.$im=v;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(p.toKey(m))}get(m){return this.c.get(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}set(m,h){this.c.set(p.toKey(m),h)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$jm=I;function E(c){return w(c)}e.$km=E;function w(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$lm=w;function f(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$mm=f;function g(c,m){if(m){const h=`onResolveRemoteAuthority:${(0,s.$9k)(m)}`;return!!c.activationEvents?.includes(h)}return!1}e.$nm=g,e.$om=(0,A.$2h)("IBuiltinExtensionsScannerService")}),define(we[232],ve([1,0,11,35]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=void 0;class s{constructor(){this.a=new Map,this.b=new WeakMap}register(D,S){this.a.set(D,S)}readActivationEvents(D){return this.b.has(D)||this.b.set(D,this.c(D)),this.b.get(D)}createActivationEventsMap(D){const S=Object.create(null);for(const p of D){const v=this.readActivationEvents(p);v.length>0&&(S[A.$hm.toKey(p.identifier)]=v)}return S}c(D){if(typeof D.main>"u"&&typeof D.browser>"u")return[];const S=Array.isArray(D.activationEvents)?D.activationEvents.slice(0):[];for(let p=0;p<S.length;p++)S[p]==="onUri"&&(S[p]=`onUri:${A.$hm.toKey(D.identifier)}`);if(!D.contributes)return S;for(const p in D.contributes){const v=this.a.get(p);if(!v)continue;const I=D.contributes[p],E=Array.isArray(I)?I:[I];try{v(E,S)}catch(w){(0,y.$1)(w)}}return S}}e.$2E=s,e.$3E=new s}),define(we[233],ve([1,0,2,35,16]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class P extends y.$Sc{constructor(S,p,v,I,E){super(),this.a=S,this.b=p,this.c=v,this.f=E,this.B(I.onDidInstallExtensions(w=>this.g(w))),this.B(I.onDidUninstallExtension(w=>this.h(w)))}g(S){for(const p of S)p.local&&this.invalidate(p.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const p of this.a.profiles)this.c.extUri.isEqual(p.extensionsResource,S)&&await this.j(p);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,A.$bm))}catch(p){(0,s.$Ck)(p)!==1&&this.f.error(p)}}}e.$Up=P}),define(we[44],ve([1,0,15,11,2,192,56,6,13,37]),function(he,e,y,A,s,P,D,S,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$7o=(0,S.$2h)("requestService");class I{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?u[n]="*****":u[n]=this.b[n];this.a=u}return this.a}}class E extends s.$Sc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,P.localize)(0,null),when:p.$Aj.isEqualTo((0,p.$yj)(p.LogLevel.Trace)).serialize()})}async c(u,n,i){const o=`${u} #${++this.b}: ${n.url}`;this.a.trace(`${o} - begin`,n.type,new I(n.headers??{}));try{const r=await i();return this.a.trace(`${o} - end`,n.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.a.error(`${o} - error`,n.type,(0,A.$0)(r)),r}}}e.$8o=E;function w($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}e.$9o=w;function f($){return $.res.statusCode===204}e.$0o=f;async function g($){return f($)?null:(await(0,y.$se)($.stream)).toString()}e.$$o=g;async function c($){if(!w($))throw new Error("Server returned "+$.res.statusCode);return g($)}e.$_o=c;async function m($){if(!w($))throw new Error("Server returned "+$.res.statusCode);if(f($))return null;const n=(await(0,y.$se)($.stream)).toString();try{return JSON.parse(n)}catch(i){throw i.message+=`:
`+n,i}}e.$ap=m;function h($){l($)}e.$bp=h;let d;function l($){const u=v.$un.as(D.$zn.Configuration),n=d;d={id:"http",order:15,title:(0,P.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,P.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(6,null),(0,P.localize)(7,null),(0,P.localize)(8,null),(0,P.localize)(9,null)],default:"override",description:(0,P.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,P.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[d],remove:n?[n]:[]})}l(1)}),define(we[234],ve([1,0,20,12,16,44]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=void 0;let D=class{constructor(p,v){this.a=p,this.b=v}async download(p,v,I=y.CancellationToken.None){if(p.scheme===A.Schemas.file||p.scheme===A.Schemas.vscodeRemote){await this.b.copy(p,v);return}const E={type:"GET",url:p.toString(!0)},w=await this.a.request(E,I);if(w.res.statusCode===200)await this.b.writeFile(v,w.stream);else{const f=await(0,P.$_o)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${f}`)}}};e.$wO=D,e.$wO=D=Ne([Le(0,P.$7o),Le(1,s.$lk)],D)}),define(we[235],ve([1,0,15,20]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;class s{constructor(S){this.a=S}listen(S,p){throw new Error("Invalid listen")}call(S,p,v,I=A.CancellationToken.None){switch(p){case"request":return this.a.request(v[0],I).then(async({res:E,stream:w})=>{const f=await(0,y.$se)(w);return[{statusCode:E.statusCode,headers:E.headers},f]});case"resolveProxy":return this.a.resolveProxy(v[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$0q=s;class P{constructor(S){this.a=S}async request(S,p){const[v,I]=await this.a.call("request",[S],p);return{res:v,stream:(0,y.$ue)(I)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$$q=P}),define(we[236],ve([1,0,87,8]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;function s(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function P(D,S,p={}){const v=(0,y.parse)(D),I=p.proxyUrl||s(v,S);if(!I)return null;const E=(0,y.parse)(I);if(!/^https?:$/.test(E.protocol||""))return null;const w={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,A.$Kf)(p.strictSSL)?p.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((f,g)=>{he(["http-proxy-agent"],f,g)})).HttpProxyAgent(I,w):new(await new Promise((f,g)=>{he(["https-proxy-agent"],f,g)})).HttpsProxyAgent(I,w)}e.$_q=P}),define(we[88],ve([1,0,52,7,193,20,40,11,4,21,106,210,14,145]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=void 0;let g;async function c(h,d,l,$){return l["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.$c?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$2l)($)&&!l["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$2l)($)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=w.Promises.withAsyncBody(async(u,n)=>{const i=new P.$3d;let o=1e4;const r=h.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(o=(0,f.$3l)(r,1,120)*1e3);const t=setTimeout(()=>{i.dispose(!0),n(new Error((0,s.localize)(0,null)))},o);try{u(await m(d,i.token))}catch(a){!(0,S.$4)(a)&&!i.token.isCancellationRequested?n(new Error((0,s.localize)(1,null,(0,D.$Mi)(a)))):u({})}finally{clearTimeout(t),i.dispose()}})),g)}e.$8l=c;async function m(h,d){const l=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",l);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",$);const u=(0,v.$mg)().replace(/-/g,"").substr(0,12),n=new RegExp(u+"({.*})"+u),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",i);const o=await(0,I.$Rl)(p.OS,i);return h.trace("getUnixShellEnvironment#shell",o),new Promise((r,t)=>{if(d.isCancellationRequested)return t(new S.$5);const a=(0,A.$nc)(o);let b,C;const L=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(b=`& '${process.execPath}' ${L} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,C=["-Login","-Command"]):a==="nu"?(b=`^'${process.execPath}' ${L} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,C=["-i","-l","-c"]):(b=`'${process.execPath}' ${L} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,a==="tcsh"||a==="csh"?C=["-ic"]:C=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),b);const k=(0,y.spawn)(o,[...C,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});d.onCancellationRequested(()=>(k.kill(),t(new S.$5))),k.on("error",Y=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Mi)(Y)),t(Y)});const R=[];k.stdout.on("data",Y=>R.push(Y));const N=[];k.stderr.on("data",Y=>N.push(Y)),k.on("close",(Y,ee)=>{const G=Buffer.concat(R).toString("utf8");h.trace("getUnixShellEnvironment#raw",G);const ne=Buffer.concat(N).toString("utf8");if(ne.trim()&&h.trace("getUnixShellEnvironment#stderr",ne),Y||ee)return t(new Error((0,s.localize)(2,null,Y,ee)));const Z=n.exec(G),T=Z?Z[1]:"{}";try{const oe=JSON.parse(T);l?oe.ELECTRON_RUN_AS_NODE=l:delete oe.ELECTRON_RUN_AS_NODE,$?oe.ELECTRON_NO_ATTACH_CONSOLE=$:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",oe),r(oe)}catch(oe){h.error("getUnixShellEnvironment#errorCaught",(0,D.$Mi)(oe)),t(oe)}})})}}),define(we[237],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8N=e.$7N=void 0,e.$7N=(0,y.$2h)("stateReadService"),e.$8N=(0,y.$2h)("stateService")}),define(we[238],ve([1,0,14,15,2,8,25,16,13]),function(he,e,y,A,s,P,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=e.$0N=e.$9N=e.SaveStrategy=void 0;var v;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(v||(e.SaveStrategy=v={}));class I extends s.$Sc{constructor(g,c,m,h){super(),this.h=g,this.j=c,this.m=m,this.n=h,this.a=Object.create(null),this.b="",this.c=this.B(new y.$Zg(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(g){g.fileOperationResult!==1&&this.m.error(g)}}getItem(g,c){const m=this.a[g];return(0,P.$Nf)(m)?c:m}setItem(g,c){this.setItems([{key:g,data:c}])}setItems(g){let c=!1;for(const{key:m,data:h}of g)this.a[m]!==h&&((0,P.$Nf)(h)?(0,P.$Lf)(this.a[m])||(this.a[m]=void 0,c=!0):(this.a[m]=h,c=!0));c&&this.s()}removeItem(g){(0,P.$Lf)(this.a[g])||(this.a[g]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const g=JSON.stringify(this.a,null,4);if(g!==this.b)try{await this.n.writeFile(this.h,A.$ge.fromString(g),{atomic:{postfix:".vsctmp"}}),this.b=g}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$9N=I;let E=class extends s.$Sc{constructor(g,c,m,h){super(),this.a=this.B(new I(c.stateResource,g,m,h))}async init(){await this.a.init()}getItem(g,c){return this.a.getItem(g,c)}};e.$0N=E,e.$0N=E=Ne([Le(1,D.$9h),Le(2,p.$jj),Le(3,S.$lk)],E);class w extends E{setItem(g,c){this.a.setItem(g,c)}setItems(g){this.a.setItems(g)}removeItem(g){this.a.removeItem(g)}close(){return this.a.close()}}e.$$N=w}),define(we[119],ve([1,0,4,28,21]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=void 0;function P(p){if(y.$o===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function D(p,v,I,E,w,f,g,c,m){const h=Object.create(null);h["common.machineId"]=f,h["common.sqmId"]=g,h.sessionID=(0,s.$mg)()+Date.now(),h.commitHash=E,h.version=w,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,y.$b)(y.$o),h["common.nodePlatform"]=A.$dc,h["common.nodeArch"]=I,h["common.product"]=m||"desktop",c&&(h["common.msftInternal"]=c);let d=0;const l=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),y.$f&&(h["common.snap"]="true");const $=P(v);return $&&(h["common.platformDetail"]=$),h}e.$vo=D;function S(p){const v=A.env.USERDNSDOMAIN;if(!v)return!1;const I=v.toLowerCase();return p.some(E=>I===E)}e.$wo=S}),define(we[239],ve([1,0,18,11,2,23,16]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var S;(function(v){function I(E,w){return E.callstack<w.callstack?-1:E.callstack>w.callstack?1:0}v.compare=I})(S||(e.ErrorEvent=S={}));class p{constructor(I,E=p.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new s.$Rc,this.c=I,this.d=E;const w=A.$X.addListener(f=>this.j(f));this.h.add((0,s.$Qc)(w)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(I){if(!I||I.code||(I.detail&&I.detail.stack&&(I=I.detail),A.$bb.isErrorNoTelemetry(I)||I instanceof D.$Gk||typeof I?.message=="string"&&I.message.includes("Unable to read file")))return;const E=Array.isArray(I.stack)?I.stack.join(`
`):I.stack,w=I.message?I.message:(0,P.$nn)(I);E&&this.k({msg:w,callstack:E})}k(I){const E=(0,y.$wb)(this.g,I,S.compare);E<0?(I.count=1,this.g.splice(~E,0,I)):(this.g[E].count||(this.g[E].count=0),this.g[E].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const I of this.g)this.c.publicLogError2("UnhandledError",I);this.g.length=0}}p.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=p}),define(we[240],ve([1,0,2]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;class A extends y.$Sc{constructor(P,D){super(),this.a=P,this.b=D}async call(P,D,S){switch(D){case"updateTelemetryLevel":{const{telemetryLevel:p}=S;return this.a.updateInjectedTelemetryLevel(p)}case"logTelemetry":{const{eventName:p,data:v}=S;return this.b?this.b.log(p,v):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${D} not found`)}listen(P,D,S){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$3r=A}),define(we[32],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=void 0,e.$pl=(0,y.$2h)("telemetryService"),e.$ql=(0,y.$2h)("customEndpointTelemetryService"),e.$rl="telemetry.currentSessionDate",e.$sl="telemetry.firstSessionDate",e.$tl="telemetry.lastSessionDate",e.$ul="telemetry.machineId",e.$vl="telemetry.sqmId",e.$wl="telemetry",e.$xl="telemetry.telemetryLevel",e.$yl="telemetry.enableCrashReporter",e.$zl="telemetry.enableTelemetry";var A;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var s;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(we[241],ve([1,0,27,14,76,12,7,4,3,102,22,105,217,16,31,32]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=e.$Rr=void 0;const m=new Map;async function h(n,i){const o=`${n}::${i.join(":")}`,r=m.get(o);if(r)return r;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,b=new Map,C=2e4;function L(R,N,Y,ee){const G=N.substring(R.length+1);return A.Promises.withAsyncBody(async ne=>{let Z;try{Z=await I.Promises.readdir(N,{withFileTypes:!0})}catch{ne();return}if(ee.count>=C){ee.count+=Z.length,ee.maxReached=!0,ne();return}let T=Z.length;if(T===0){ne();return}let oe=Z;ee.count+Z.length>C&&(ee.maxReached=!0,T=C-ee.count,oe=Z.slice(0,T)),ee.count+=Z.length;for(const Q of oe)if(Q.isDirectory()){if(Y.includes(Q.name)||await L(R,(0,D.$jc)(N,Q.name),Y,ee),--T===0){ne();return}}else{const te=Q.name.lastIndexOf(".");if(te>=0){const J=Q.name.substring(te+1);J&&a.set(J,(a.get(J)??0)+1)}for(const J of t)J.relativePathPattern?.test(G)!==!1&&J.filePattern.test(Q.name)&&b.set(J.tag,(b.get(J.tag)??0)+1);if(--T===0){ne();return}}})}const k=A.Promises.withAsyncBody(async R=>{const N={count:0,maxReached:!1};await L(n,n,i,N);const Y=await $(n);R({configFiles:d(b),fileTypes:d(a),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:Y})});return m.set(o,k),k}e.$Rr=h;function d(n){return Array.from(n.entries(),([i,o])=>({name:i,count:o})).sort((i,o)=>o.count-i.count)}function l(){const n={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/f.$Tk.GB).toFixed(2)}GB (${(y.freemem()/f.$Tk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.$6m.value()*100)}%`},i=y.cpus();return i&&i.length>0&&(n.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),n}e.$Sr=l;async function $(n){try{const i=new Map,o=(0,D.$jc)(n,".vscode","launch.json"),r=await I.Promises.readFile(o),t=[],a=(0,s.$$m)(r.toString(),t);if(t.length)return console.log(`Unable to parse ${o}`),[];if((0,s.$hn)(a)==="object"&&a.configurations)for(const b of a.configurations){const C=b.type;C&&(i.has(C)?i.set(C,i.get(C)+1):i.set(C,1))}return d(i)}catch{return[]}}e.$Tr=$;let u=class{constructor(i,o){this.c=i,this.d=o}f(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}g(i){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const r=y.cpus();return r&&r.length>0&&o.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),o.push(`Memory (System):  ${(y.totalmem()/f.$Tk.GB).toFixed(2)}GB (${(y.freemem()/f.$Tk.GB).toFixed(2)}GB free)`),S.$c||o.push(`Load (avg):       ${y.loadavg().map(t=>Math.round(t)).join(", ")}`),o.push(`VM:               ${Math.round(v.$6m.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([(0,E.$Qr)(i.mainPID),this.k(i)]).then(async r=>{let[t,a]=r,b=this.m(i,t);return o.forEach(C=>{if((0,w.$Fm)(C))b+=`
${C.errorMessage}`,a+=`
${C.errorMessage}`;else if(b+=`

Remote: ${C.hostName}`,C.processes&&(b+=`
${this.m(i,C.processes)}`),C.workspaceMetadata){a+=`
|  Remote: ${C.hostName}`;for(const L of Object.keys(C.workspaceMetadata)){const k=C.workspaceMetadata[L];let R=`${k.fileCount} files`;k.maxFilesReached&&(R=`more than ${R}`),a+=`|    Folder (${L}): ${R}`,a+=this.h(k)}}}),{processInfo:b,workspaceInfo:a}})}async getSystemInfo(i,o){const{memory:r,vmHint:t,os:a,cpus:b}=l(),C={os:a,memory:r,cpus:b,vmHint:t,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return S.$c||(C.load=`${y.loadavg().map(L=>Math.round(L)).join(", ")}`),S.$e&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(i,o){const r=[];return(0,E.$Qr)(i.mainPID).then(async t=>(r.push(""),r.push(this.g(i)),r.push(""),r.push(this.m(i,t)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(i))),o.forEach(a=>{if((0,w.$Fm)(a))r.push(`
${a.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${a.hostName}`),r.push(this.f(a.machineInfo)),a.processes&&r.push(this.m(i,a.processes)),a.workspaceMetadata)for(const b of Object.keys(a.workspaceMetadata)){const C=a.workspaceMetadata[b];let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),r.push(`Folder (${b}): ${L}`),r.push(this.h(C))}}),r.push(""),r.push(""),r.join(`
`)))}h(i){const o=[];let t=0;const a=(k,R)=>{const N=` ${k}(${R})`;t+N.length>60?(o.push(b),b="|                 ",t=b.length):t+=N.length,b+=N};let b="|      File types:";const C=10,L=i.fileTypes.length>C?C:i.fileTypes.length;for(let k=0;k<L;k++){const R=i.fileTypes[k];a(R.name,R.count)}if(o.push(b),i.configFiles.length>=0&&(b="|      Conf files:",t=0,i.configFiles.forEach(k=>{a(k.name,k.count)}),o.push(b)),i.launchConfigFiles.length>0){let k="|      Launch Configs:";i.launchConfigFiles.forEach(R=>{const N=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;k+=N}),o.push(k)}return o.join(`
`)}j(i){const o=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(o-r.length)}  ${i[r]}`).join(`
                  `)}k(i){const o=[],r=[];return i.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(o.push(`|  Window (${t.title})`),t.folderURIs.forEach(a=>{const b=p.URI.revive(a);if(b.scheme===P.Schemas.file){const C=b.fsPath;r.push(h(C,["node_modules",".git"]).then(L=>{let k=`${L.fileCount} files`;L.maxFilesReached&&(k=`more than ${k}`),o.push(`|    Folder (${(0,D.$nc)(C)}): ${k}`),o.push(this.h(L))}).catch(L=>{o.push(`|      Error: Unable to collect workspace stats for folder ${C} (${L.toString()})`)}))}else o.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(t=>o.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(i,o){const r=new Map;i.windows.forEach(a=>r.set(a.pid,`window [${a.id}] (${a.title})`)),i.pidToNames.forEach(({pid:a,name:b})=>r.set(a,b));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),o&&this.n(i.mainPID,r,t,o,0),t.join(`
`)}n(i,o,r,t,a){const b=a===0;let C;b?C=t.pid===i?`${this.d.applicationName} main`:"remote agent":o.has(t.pid)?C=o.get(t.pid):C=`${"  ".repeat(a)} ${t.name}`;const L=process.platform==="win32"?t.mem:y.totalmem()*(t.mem/100);r.push(`${t.load.toFixed(0).padStart(5," ")}	${(L/f.$Tk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(t.children)&&t.children.forEach(k=>this.n(i,o,r,k,a+1))}async getWorkspaceFileExtensions(i){const o=new Set;for(const{uri:r}of i.folders){const t=p.URI.revive(r);if(t.scheme!==P.Schemas.file)continue;const a=t.fsPath;try{(await h(a,["node_modules",".git"])).fileTypes.forEach(C=>o.add(C.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const r=p.URI.revive(o);if(r.scheme!==P.Schemas.file)continue;const t=r.fsPath;try{const a=await h(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:b.name,count:b.count})}),a.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:b.name,count:b.count})}),a.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$Ur=u,e.$Ur=u=Ne([Le(0,c.$pl),Le(1,g.$Bj)],u)}),define(we[38],ve([1,0,23,8,5,24,57,119,32]),function(he,e,y,A,s,P,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;class v{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$xo=v;class I{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yo=I,e.$zo=new I;class E{async publicLog(t,a,b){}async publicLogError(t,a,b){}}e.$Ao=E,e.$Bo="telemetry",e.$Co="extensionTelemetryLog",e.$Do={log:()=>null,flush:()=>Promise.resolve(null)};function w(r,t){return s.Event.debounce(t.onDidChangeConfiguration,(b,C)=>{const L=b?new Set([...b.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:L}},1e3,!0)(b=>{b.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,P.$yi)(b.source),configurationKeys:Array.from(b.affectedKeys)})})}e.$Eo=w;function f(r,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!r.enableTelemetry)}e.$Fo=f;function g(r,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.$Go=g;function c(r){const t=r.getValue(p.$xl),a=r.getValue(p.$yl);if(r.getValue(p.$zl)===!1||a===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Ho=c;function m(r){const t={},a={},b={};l(r,b);for(let C in b){C=C.length>150?C.substr(C.length-149):C;const L=b[C];typeof L=="number"?a[C]=L:typeof L=="boolean"?a[C]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${L.length}`),t[C]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(t[C]=L)}return{properties:t,measurements:a}}e.$Io=m;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(r){if(!r)return"none";const t=(0,D.$9k)(r);return h.has(t)?t:"other"}e.$Jo=d;function l(r,t,a=0,b){if(r)for(const C of Object.getOwnPropertyNames(r)){const L=r[C],k=b?b+C:C;Array.isArray(L)?t[k]=(0,y.$nn)(L):L instanceof Date?t[k]=L.toISOString():(0,A.$Gf)(L)?a<2?l(L,t,a+1,k+"."):t[k]=(0,y.$nn)(L):t[k]=L}}function $(r,t){const a=r.msftInternalDomains||[],b=t.getValue("telemetry.internalTesting");return(0,S.$wo)(a)||b}e.$Ko=$;function u(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.$Lo=u;function n(r,t){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let a=r;const b=[];for(const R of t)for(;;){const N=R.exec(r);if(!N)break;b.push([N.index,R.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(a="";;){const R=L.exec(r);if(!R)break;const N=b.some(([Y,ee])=>R.index<ee&&Y<L.lastIndex);!C.test(R[0])&&!N&&(a+=r.substring(k,R.index)+"<REDACTED: user-file-path>",k=L.lastIndex)}return k<r.length&&(a+=r.substr(k)),a}function i(r){if(!r)return r;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of t)if(a.regex.test(r))return`<REDACTED: ${a.label}>`;return r}function o(r,t){return(0,y.$kn)(r,a=>{if(a instanceof v||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let b=a.replaceAll("%20"," ");b=n(b,t);for(const C of t)b=b.replace(C,"");return b=i(b),b}})}e.$Mo=o}),define(we[36],ve([1,0,17,30,35,4,3,11,28,38]),function(he,e,y,A,s,P,D,S,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;function I(o,r){return o.uuid&&r.uuid?o.uuid===r.uuid:o.id===r.id?!0:(0,y.$3e)(o.id,r.id)===0}e.$No=I;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(r){const t=r.manifest?r.manifest.version:r.version,a=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new w(r.identifier,t,a)}static parse(r){const t=E.exec(r);return t&&t[1]&&t[2]?new w({id:t[1]},t[2],t[4]||void 0):null}constructor(r,t,a="undefined"){this.version=t,this.targetPlatform=a,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof w?I(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.$Oo=w;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(o){const r=f.exec(o);return r&&r[1]?[m(r[1]),r[2]]:[m(o),void 0]}e.$Po=g;function c(o,r){return`${o}.${r}`}e.$Qo=c;function m(o){return o.toLowerCase()}e.$Ro=m;function h(o,r){return m(c(o??s.$dm,r))}e.$So=h;function d(o,r){const t=[],a=b=>{for(const C of t)if(C.some(L=>I(r(L),r(b))))return C;return null};for(const b of o){const C=a(b);C?C.push(b):t.push([b])}return t}e.$To=d;function l(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$Uo=l;function $(o){return{id:new v.$xo(o.identifier.id),name:new v.$xo(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Vo=$,e.$Wo=new s.$hm("pprice.better-merge");function u(o,r){const t=[],a=r.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const b=a.shift();if(b&&t.every(C=>!I(C.identifier,{id:b}))){const C=o.filter(L=>I(L.identifier,{id:b}));C.length===1&&(t.push(C[0]),a.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Xo=u;async function n(o,r){if(!P.$e)return!1;let t;try{t=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){r.debug("Error while getting the os-release file.",(0,S.$0)(b))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(o,r){const t=await n(o,r),a=(0,A.$ho)(t?"alpine":P.$o,p.$ec);return r.debug("ComputeTargetPlatform:",a),a}e.$Yo=i}),define(we[120],ve([1,0,20,11,12,19,53,3,180,30,36,35]),function(he,e,y,A,s,P,D,S,p,v,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;const w=m=>(0,p.localize)(0,null,m),f=(0,p.localize)(1,null,"ms-dotnettools.csharp");function g(m,h){return h?`${m.publisher}.${m.name}@${m.version}`:`${m.publisher}.${m.name}`}let c=class{constructor(h,d,l){this.a=h,this.b=d,this.d=l}get f(){}async listExtensions(h,d,l){let $=await this.b.getInstalled(1,l);const u=E.$gm.map(i=>i.toLowerCase());if(d&&d!==""){if(u.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),u.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,p.localize)(2,null,this.f)),$=$.sort((i,o)=>i.identifier.id.localeCompare(o.identifier.id));let n;for(const i of $)n!==i.identifier.id&&(n=i.identifier.id,this.a.info(g(i.manifest,h)))}async installExtensions(h,d,l,$){const u=[];try{const n=[];h.length&&this.a.info(this.f?(0,p.localize)(3,null,this.f):(0,p.localize)(4,null));const i=[];let o=[];const r=(a,b,C)=>{o.push({id:a,version:b!=="prerelease"?b:void 0,installOptions:{...l,isBuiltin:C,installPreReleaseVersion:b==="prerelease"||l.installPreReleaseVersion}})};for(const a of h)if(a instanceof S.URI)i.push({vsix:a,installOptions:l});else{const[b,C]=(0,I.$Po)(a);r(b,C,!1)}for(const a of d)if(a instanceof S.URI)i.push({vsix:a,installOptions:{...l,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[b,C]=(0,I.$Po)(a);r(b,C,!0)}const t=await this.b.getInstalled(1,l.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:a,installOptions:b})=>{try{const C=await this.g(a,b,$,t);C&&n.push(C)}catch(C){this.a.error(C),u.push(a.toString())}})),o.length&&(o=o.filter(({id:a,version:b})=>{const C=t.find(L=>(0,I.$No)(L.identifier,{id:a}));if(C){if(!$&&(!b||b==="prerelease"&&C.preRelease))return this.a.info((0,p.localize)(5,null,a,C.manifest.version,a)),!1;if(b&&C.manifest.version===b)return this.a.info((0,p.localize)(6,null,`${a}@${b}`)),!1}return!0}),o.length)){const a=await this.h(o);await Promise.all(o.map(async b=>{const C=a.get(b.id.toLowerCase());if(C)try{const L=await this.j(b,C,t);L&&n.push(L)}catch(L){this.a.error(L.message||L.stack||L),u.push(b.id)}else this.a.error(`${w(b.version?`${b.id}@${b.version}`:b.id)}
${f}`),u.push(b.id)}))}}catch(n){throw this.a.error((0,p.localize)(7,null,(0,A.$0)(n))),n}if(u.length)throw new Error((0,p.localize)(8,null,u.join(", ")))}async g(h,d,l,$){const u=await this.b.getManifest(h);if(!u)throw new Error("Invalid vsix");if(await this.l(u,l,d.profileLocation,$))try{return await this.b.install(h,d),this.a.info((0,p.localize)(9,null,(0,P.$Ag)(h))),u}catch(i){if((0,A.$4)(i))return this.a.info((0,p.localize)(10,null,(0,P.$Ag)(h))),null;throw i}return null}async h(h){const d=new Map,l=h.some(n=>n.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),u=[];for(const n of h)v.$ao.test(n.id)&&u.push({...n,preRelease:l});if(u.length){const n=await this.d.getExtensions(u,{targetPlatform:$},y.CancellationToken.None);for(const i of n)d.set(i.identifier.id.toLowerCase(),i)}return d}async j({id:h,version:d,installOptions:l},$,u){const n=await this.d.getManifest($,y.CancellationToken.None);if(n&&!this.k(n))return null;const i=u.find(o=>(0,I.$No)(o.identifier,$.identifier));if(i){if($.version===i.manifest.version)return this.a.info((0,p.localize)(11,null,d?`${h}@${d}`:h)),null;this.a.info((0,p.localize)(12,null,h,$.version))}try{l.isBuiltin?this.a.info(d?(0,p.localize)(13,null,h,d):(0,p.localize)(14,null,h)):this.a.info(d?(0,p.localize)(15,null,h,d):(0,p.localize)(16,null,h));const o=await this.b.installFromGallery($,{...l,installGivenVersion:!!d});return this.a.info((0,p.localize)(17,null,h,o.manifest.version)),n}catch(o){if((0,A.$4)(o))return this.a.info((0,p.localize)(18,null,h)),null;throw o}}k(h){return!0}async l(h,d,l,$){if(!d){const u={id:(0,I.$So)(h.publisher,h.name)},n=$.find(i=>(0,I.$No)(u,i.identifier)&&(0,D.gt)(i.manifest.version,h.version));if(n)return this.a.info((0,p.localize)(19,null,n.identifier.id,n.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,d,l){const $=async n=>{if(n instanceof S.URI){const i=await this.b.getManifest(n);return g(i)}return n},u=[];for(const n of h){const i=await $(n),r=(await this.b.getInstalled(void 0,l)).filter(t=>(0,I.$No)(t.identifier,{id:i}));if(!r.length)throw new Error(`${this.m(i)}
${f}`);if(r.some(t=>t.type===0)){this.a.info((0,p.localize)(20,null,i));return}if(!d&&r.some(t=>t.isBuiltin)){this.a.info((0,p.localize)(21,null,i));return}this.a.info((0,p.localize)(22,null,i));for(const t of r)await this.b.uninstall(t,{profileLocation:l}),u.push(t);this.f?this.a.info((0,p.localize)(23,null,i,this.f)):this.a.info((0,p.localize)(24,null,i))}}async locateExtension(h){const d=await this.b.getInstalled();h.forEach(l=>{d.forEach($=>{if($.identifier.id===l&&$.location.scheme===s.Schemas.file){this.a.info($.location.fsPath);return}})})}m(h){return this.f?(0,p.localize)(25,null,h,this.f):(0,p.localize)(26,null,h)}};e.$up=c,e.$up=c=Ne([Le(1,v.$no),Le(2,v.$lo)],c)}),define(we[242],ve([1,0,14,11,2,12,19,53,8,21,22,81,24,25,30,36,84,16,13]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let $=l=class extends s.$Sc{constructor(n,i,o,r,t,a){super(),this.h=i,this.j=o,this.m=r,this.n=t,this.r=a,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(n,i,o){await this.g;const r=(0,D.$Dg)(this.extensionsDownloadDir,this.z(n));try{await this.w(n,r,a=>this.j.download(n,a,i))}catch(a){throw new g.$mo(a.message,g.ExtensionManagementErrorCode.Download)}let t=!1;if(o&&this.t(n)){const a=await this.u(n);try{t=await this.n.verify(r.fsPath,a.fsPath,this.r.getLevel()===d.LogLevel.Trace)}catch(b){const C=b;if(t=C.code,C.output&&this.r.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${C.output}`),t===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(r)}catch(L){this.r.error(L)}throw new g.$mo(E.$yp,g.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(a)}catch(b){this.r.error(b)}}}return t===!0?this.r.info(`Extension signature is verified: ${n.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${n.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${n.identifier.id}`),{location:r,verificationStatus:t}}t(n){if(!n.isSigned)return!1;const i=this.m.getValue("extensions.verifySignature");return(0,p.$Kf)(i)?i:!0}async u(n){await this.g;const i=(0,D.$Dg)(this.extensionsDownloadDir,`${this.z(n)}${l.c}`);return await this.w(n,i,o=>this.j.downloadSignatureArchive(n,o)),i}async w(n,i,o){if(await this.h.exists(i))return;if(i.scheme!==P.Schemas.file){await o(i);return}const r=(0,D.$Dg)(this.extensionsDownloadDir,`.${(0,v.$mg)()}`);await this.h.exists(r)||await o(r);try{await I.Promises.rename(r.fsPath,i.fsPath,2*60*1e3)}catch(t){try{await this.h.del(r)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,i.path);else throw this.r.info(`Rename failed because of ${(0,A.$0)(t)}. Deleted the file from downloaded location`,r.path),t}}async delete(n){await this.g,await this.h.del(n)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const i=[],o=[],r=[];for(const b of n.children)if(b.name.endsWith(l.c))r.push(b.resource);else{const C=c.$Oo.parse(b.name);C&&o.push([C,b])}const t=(0,c.$To)(o,([b])=>b),a=[];for(const b of t)b.sort((C,L)=>S.rcompare(C[0].version,L[0].version)),i.push(...b.slice(1).map(C=>C[1].resource)),a.push(b[0][1]);a.sort((b,C)=>b.mtime-C.mtime),i.push(...a.slice(0,Math.max(0,a.length-this.f)).map(b=>b.resource)),i.push(...r),await y.Promises.settled(i.map(b=>(this.r.trace("Deleting from cache",b.path),this.h.del(b))))}}catch(n){this.r.error(n)}}z(n){return this.f?c.$Oo.create(n).toString().toLowerCase():(0,v.$mg)()}};e.$Rp=$,$.c=".sigzip",e.$Rp=$=l=Ne([Le(0,f.$0h),Le(1,h.$lk),Le(2,g.$lo),Le(3,w.$vi),Le(4,m.$sp),Le(5,d.$jj)],$)}),define(we[243],ve([1,0,5,2,26,36,35]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;class S extends A.$Sc{constructor(v,I,E,w,f,g,c){super(),this.f=v,this.g=I,this.h=E,this.j=w,this.m=f,this.n=g,this.r=c,this.a=this.B(new y.$Sd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$2c),this.s().then(null,m=>c.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(v=>this.u(v.added))),this.B(this.j.onAddExtensions(v=>this.w(v))),this.B(this.j.onDidAddExtensions(v=>this.y(v))),this.B(this.j.onRemoveExtensions(v=>this.z(v))),this.B(this.j.onDidRemoveExtensions(v=>this.C(v))),this.B(this.n.onDidFilesChange(v=>this.D(v)))}async u(v){try{v.length&&await Promise.all(v.map(I=>(this.c.set(I.id,(0,A.$Pc)(this.n.watch(this.m.extUri.dirname(I.extensionsResource)),this.n.watch(I.extensionsResource))),this.G(I.extensionsResource))))}catch(I){throw this.r.error(I),I}}async w(v){for(const I of v.extensions)this.I(this.L(I.identifier,I.version),v.profileLocation)}async y(v){for(const I of v.extensions){const E=this.L(I.identifier,I.version);v.error?this.J(E,v.profileLocation):this.I(E,v.profileLocation)}}async z(v){for(const I of v.extensions)this.J(this.L(I.identifier,I.version),v.profileLocation)}async C(v){const I=[],E=[];for(const w of v.extensions){const f=this.L(w.identifier,w.version);v.error?this.I(f,v.profileLocation):(this.J(f,v.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),E.push(this.f.scanInstalledExtensionAtLocation(w.location).then(g=>{g?I.push(g):this.r.info("Extension not found at the location",w.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(E),I.length&&await this.H(I)}catch(w){this.r.error(w)}}D(v){for(const I of this.h.profiles)v.contains(I.extensionsResource,0,1)&&this.F(I.extensionsResource)}async F(v){const I=[],E=[],w=await this.j.scanProfileExtensions(v),f=new Set,g=new Set;for(const[c,m]of this.b)m.has(v)&&g.add(c);for(const c of w){const m=this.L(c.identifier,c.version);f.add(m),g.has(m)||(I.push(c.identifier),this.I(m,v))}for(const c of g)if(!f.has(c)){const m=this.M(c);m&&(E.push(m.identifier),this.J(c,v))}(I.length||E.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:v}:void 0,removed:E.length?{extensions:E,profileLocation:v}:void 0})}async G(v){const I=await this.j.scanProfileExtensions(v);for(const E of I)this.I(this.L(E.identifier,E.version),v)}async H(v){v||(v=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),v.length&&await this.f.markAsUninstalled(...v)}I(v,I){let E=this.b.get(v);E||this.b.set(v,E=new s.$Bc(w=>this.m.extUri.getComparisonKey(w))),E.add(I)}J(v,I){const E=this.b.get(v);E&&E.delete(I),E?.size||this.b.delete(v)}L(v,I){return`${D.$hm.toKey(v.id)}@${I}`}M(v){const[I,E]=(0,P.$Po)(v);return E?{identifier:{id:I},version:E}:void 0}}e.$Vp=S}),define(we[244],ve([1,0,214,38]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;async function s(P,D,S,p,v,I,E){const w={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P} (${D.nameShort})`};if((0,A.$Fo)(D,S)&&(0,A.$Ho)(p)===3){const f=await(0,y.$np)(S,v,I);w["X-Market-User-Id"]=f,w["VSCode-SessionId"]=E.machineId||f}return w}e.$op=s}),define(we[121],ve([1,0,89,18,14,2,12,7,22,25,30,36,13,86,3]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;let c=class extends f.$8q{constructor(l,$,u,n){super(u),this.h=l,this.j=n,this.g=this.B(new m($,n)),this.h.registerParticipant({postInstall:async i=>this.m(i),postUninstall:async i=>this.n(i)})}async getBuiltInExtensionTranslationsUri(l,$){const n=(await this.g.getLanguagePacks())[$];if(!n){this.j.warn(`No language pack found for ${$}`);return}const i=n.translations[l];return i?g.URI.file(i):void 0}async getInstalledLanguages(){const l=await this.g.getLanguagePacks(),$=Object.keys(l).map(u=>{const n=l[u];return{...this.f(u,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return $.push(this.f("en","English")),$.sort((u,n)=>u.label.localeCompare(n.label)),$}async m(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",l.identifier.id),await this.update())}async n(l){const $=await this.g.getLanguagePacks();Object.keys($).some(u=>$[u]&&$[u].extensions.some(n=>(0,E.$No)(n.extensionIdentifier,l.identifier)))&&(this.j.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,$]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),u=await this.g.update($);return!(0,A.$ub)(Object.keys(l),Object.keys(u))}};e.$9q=c,e.$9q=c=Ne([Le(0,I.$no),Le(1,v.$0h),Le(2,I.$lo),Le(3,w.$jj)],c);let m=class extends P.$Sc{constructor(l,$){super(),this.j=$,this.c={},this.f=(0,S.$jc)(l.userDataPath,"languagepacks.json"),this.g=new s.$9g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(l){return this.s($=>{Object.keys($).forEach(u=>delete $[u]),this.m($,...l)}).then(()=>this.c)}m(l,...$){for(const u of $)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.n(l,u);Object.keys(l).forEach(u=>this.r(l[u]))}n(l,$){const u=$.identifier,n=$.manifest.contributes&&$.manifest.contributes.localizations?$.manifest.contributes.localizations:[];for(const i of n)if($.location.scheme===D.Schemas.file&&h(i)){let o=l[i.languageId];o||(o={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},l[i.languageId]=o);const r=o.extensions.filter(t=>(0,E.$No)(t.extensionIdentifier,u))[0];r?r.version=$.manifest.version:o.extensions.push({extensionIdentifier:u,version:$.manifest.version});for(const t of i.translations)o.translations[t.id]=(0,S.$jc)($.location.fsPath,t.path)}}r(l){if(l){const $=(0,y.createHash)("md5");for(const u of l.extensions)$.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);l.hash=$.digest("hex")}}s(l=()=>null){return this.g.queue(()=>{let $=null;return p.Promises.readFile(this.f,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>($=l(u),u)).then(u=>{for(const i of Object.keys(u))u[i]||delete u[i];this.c=u,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),p.Promises.writeFile(this.f,n)}).then(()=>$,u=>this.j.error(u))})}};m=Ne([Le(0,v.$0h),Le(1,w.$jj)],m);function h(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const l of d.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(we[245],ve([1,0,152,11,23,38]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3N=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function p(I,E,w){const f=await(0,y.$ZC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,y.$ZC)("@microsoft/1ds-post-js","dist/ms.post.js"),c=new f.AppInsightsCore,m=new g.PostChannel,h={instrumentationKey:I,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(w){h.extensionConfig={};const d={alwaysUseXhrOverride:!0,httpXHROverride:w};h.extensionConfig[m.identifier]=d}return c.initialize(h,[]),c.addTelemetryInitializer(d=>{E&&(d.ext=d.ext??{},d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),c}class v{constructor(E,w,f,g,c){this.e=E,this.f=w,this.g=f,this.h=c,this.c=D,this.d=S,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=p(this.a,this.e,this.h)),this.b.then(w=>{E(w)},w=>{(0,A.$1)(w),console.error(w)})}}log(E,w){if(!this.a)return;w=(0,s.$ln)(w,this.g),w=(0,P.$Io)(w);const f=this.f+"/"+E;try{this.i(g=>{g.pluginVersionString=w?.properties.version??"Unknown",g.track({name:f,baseData:{name:f,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$3N=v}),define(we[246],ve([1,0,2,23,4,17,194,24,56,55,31,37,32,38]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;let g=class{constructor(h,d,l){this.k=d,this.l=l,this.d={},this.i=new y.$Rc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,P.$Ke)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,P.$Ke)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(w.$xl)||$.affectsConfiguration(w.$zl)||$.affectsConfiguration(w.$yl))&&this.m()}))}setExperimentProperty(h,d){this.d[h]=d}m(){let h=(0,f.$Ho)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const l=d.usage?3:d.error?2:0;h=Math.min(h,l)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,d,l){this.g<d||(l=(0,A.$ln)(l,this.d),l=(0,f.$Mo)(l,this.j),l=(0,A.$ln)(l,this.c),this.b.forEach($=>$.log(h,l)))}publicLog(h,d){this.n(h,3,d)}publicLog2(h,d){this.publicLog(h,d)}publicLogError(h,d){this.h&&this.n(h,2,d)}publicLogError2(h,d){this.publicLogError(h,d)}};e.$cr=g,g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$cr=g=Ne([Le(1,S.$vi),Le(2,I.$Bj)],g);function c(){const m=(0,D.localize)(0,null,v.default.nameLong),h=v.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=s.$i?"":(0,D.localize)(3,null),l=(0,D.localize)(4,null),$=(0,D.localize)(5,null),u=(0,D.localize)(6,null),n=(0,D.localize)(7,null),i=`
|       | ${l} | ${$} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,D.localize)(8,null);return`
${m} ${h} ${d}

&nbsp;

${n}
${i}

&nbsp;

${o}
`}E.$un.as(p.$zn.Configuration).registerConfiguration({id:w.$wl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[w.$xl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$un.as(p.$zn.Configuration).registerConfiguration({id:w.$wl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[w.$zl]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,D.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,D.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${w.$xl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[247],ve([1,0,24,6,31,32,246,38]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.$Zr=void 0;let p=class extends D.$cr{constructor(I,E,w,f){super(I,w,f),this.o=E}publicLog(I,E){if(!(this.o<3))return super.publicLog(I,E)}publicLog2(I,E){return this.publicLog(I,E)}publicLogError(I,E){return this.o<2?Promise.resolve(void 0):super.publicLogError(I,E)}publicLogError2(I,E){return this.publicLogError(I,E)}async updateInjectedTelemetryLevel(I){if(I===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,I):I,this.o===0&&this.dispose()}};e.$Zr=p,e.$Zr=p=Ne([Le(2,y.$vi),Le(3,s.$Bj)],p),e.$1r=new class extends S.$yo{async updateInjectedTelemetryLevel(){}},e.$2r=(0,A.$3h)(P.$pl)}),define(we[248],ve([1,0,15,20,249,245]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=void 0;async function D(I,E){const w=await E.request(I,A.CancellationToken.None),f=(await(0,y.$se)(w.stream)).toString(),g=w.res.statusCode??200;return{headers:w.res.headers,statusCode:g,responseData:f}}async function S(I){const E={method:I.type,headers:I.headers};return new Promise((f,g)=>{const c=s.request(I.url??"",E,m=>{m.on("data",function(h){f({headers:m.headers,statusCode:m.statusCode??200,responseData:h.toString()})}),m.on("error",function(h){g(h)})});c.write(I.data,m=>{m&&g(m)}),c.end()})}async function p(I,E,w){const f=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),g={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:f};try{const c=I?await D(g,I):await S(g);w(c.statusCode,c.headers,c.responseData)}catch{w(0,{})}}class v extends P.$3N{constructor(E,w,f,g,c){const m={sendPOST:(h,d)=>{p(E,h,d)}};super(w,f,g,c,m)}}e.$4N=v}),define(we[250],ve([1,0,11,239]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class s extends A.default{i(){(0,y.setUnexpectedErrorHandler)(S=>console.error(S));const D=[];process.on("unhandledRejection",(S,p)=>{D.push(p),setTimeout(()=>{const v=D.indexOf(p);v>=0&&p.catch(I=>{D.splice(v,1),(0,y.$4)(I)||(console.warn(`rejected promise not handled within 1 second: ${I}`),I.stack&&console.warn(`stack trace: ${I.stack}`),S&&(0,y.$1)(S))})},1e3)}),process.on("rejectionHandled",S=>{const p=D.indexOf(S);p>=0&&D.splice(p,1)}),process.on("uncaughtException",S=>{(0,y.$Z)(S)||(0,y.$1)(S)})}}e.default=s}),define(we[122],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(we[123],ve([1,0,4,122]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;const s=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class P{constructor(I){this.collections=I,this.a=new Map,this.b=new Map,I.forEach((E,w)=>{this.d(E,w);const f=E.map.entries();let g=f.next();for(;!g.done;){const c=g.value[1],m=g.value[0];let h=this.a.get(m);if(h||(h=[],this.a.set(m,h)),h.length>0&&h[0].type===A.EnvironmentVariableMutatorType.Replace){g=f.next();continue}const d={extensionIdentifier:w,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};d.scope||delete d.scope,h.unshift(d),g=f.next()}})}async applyToProcessEnvironment(I,E,w){let f;y.$c&&(f={},Object.keys(I).forEach(g=>f[g.toLowerCase()]=g));for(const[g,c]of this.getVariableMap(E)){const m=y.$c&&f[g.toLowerCase()]||g;for(const h of c){const d=w?await w(h.value):h.value;if(h.options?.applyAtProcessCreation??!0)switch(h.type){case A.EnvironmentVariableMutatorType.Append:I[m]=(I[m]||"")+d;break;case A.EnvironmentVariableMutatorType.Prepend:I[m]=d+(I[m]||"");break;case A.EnvironmentVariableMutatorType.Replace:I[m]=d;break}if(h.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${s.get(h.type)}`;I[l]=(I[l]?I[l]+":":"")+g+"="+this.c(d)}}}}c(I){return I.replaceAll(":","\\x3a")}diff(I,E){const w=new Map,f=new Map,g=new Map;if(I.getVariableMap(E).forEach((c,m)=>{const h=this.getVariableMap(E).get(m),d=S(c,h);d&&w.set(m,d)}),this.getVariableMap(E).forEach((c,m)=>{const h=I.getVariableMap(E).get(m),d=S(c,h);d&&g.set(m,d)}),this.getVariableMap(E).forEach((c,m)=>{const h=I.getVariableMap(E).get(m),d=p(c,h);d&&f.set(m,d)}),!(w.size===0&&f.size===0&&g.size===0))return{added:w,changed:f,removed:g}}getVariableMap(I){const E=new Map;for(const w of this.a.values()){const f=w.filter(g=>D(g,I));f.length>0&&E.set(f[0].variable,f)}return E}getDescriptionMap(I){const E=new Map;for(const w of this.b.values()){const f=w.filter(g=>D(g,I,!0));for(const g of f)E.set(g.extensionIdentifier,g.description)}return E}d(I,E){if(!I.descriptionMap)return;const w=I.descriptionMap.entries();let f=w.next();for(;!f.done;){const g=f.value[1],c=f.value[0];let m=this.b.get(c);m||(m=[],this.b.set(c,m));const h={extensionIdentifier:E,scope:g.scope,description:g.description};h.scope||delete h.scope,m.push(h),f=w.next()}}}e.$Er=P;function D(v,I,E=!1){return v.scope?!!(v.scope.workspaceFolder&&I?.workspaceFolder&&v.scope.workspaceFolder.index===I.workspaceFolder.index):E?I===v.scope:!0}function S(v,I){if(!I)return v;const E=new Set;I.forEach(f=>E.add(f.extensionIdentifier));const w=[];return v.forEach(f=>{E.has(f.extensionIdentifier)||w.push(f)}),w.length===0?void 0:w}function p(v,I){if(!I)return;const E=new Map;I.forEach(f=>E.set(f.extensionIdentifier,f));const w=[];return v.forEach(f=>{const g=E.get(f.extensionIdentifier);g&&(f.type!==g.type||f.value!==g.value||f.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index)&&w.push(g)}),w.length===0?void 0:w}}),define(we[90],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0;function y(p){return[...p.entries()]}e.$yr=y;function A(p){return p?[...p.entries()]:[]}e.$zr=A;function s(p){return new Map(p)}e.$Ar=s;function P(p){return new Map(p??[])}e.$Br=P;function D(p){return Array.from(p.entries()).map(v=>[v[0],y(v[1].map),A(v[1].descriptionMap)])}e.$Cr=D;function S(p){return new Map(p.map(v=>[v[0],{map:s(v[1]),descriptionMap:P(v[2])}]))}e.$Dr=S}),define(we[251],ve([1,0,14,20,5,2,13]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;let S=class extends P.$Sc{constructor(v,I){super(),this.h=I,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Sd),this.onCreateRequest=this.g.event,this.b=v===void 0?15e3:v,this.B((0,P.$Qc)(()=>{for(const E of this.f.values())(0,P.$Nc)(E)}))}createRequest(v){return new Promise((I,E)=>{const w=++this.a;this.c.set(w,I),this.g.fire({requestId:w,...v});const f=new A.$3d;(0,y.$3g)(this.b,f.token).then(()=>E(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,P.$Qc)(()=>f.cancel())])})}acceptReply(v,I){const E=this.c.get(v);E?(this.c.delete(v),(0,P.$Nc)(this.f.get(v)||[]),this.f.delete(v),E(I)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${v}`)}};e.$pr=S,e.$pr=S=Ne([Le(1,D.$jj)],S)}),define(we[91],ve([1,0,6,68,37]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.$jr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ir=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$hr=void 0,e.$hr=new A.$gj("terminalTabFocusMode",!1,!0);var P;(function(u){u.AutomationProfile="terminal.integrated.automationProfile.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(P||(e.TerminalSettingPrefix=P={}));var D;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",u.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",u.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",u.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var S;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(S||(e.PosixShellType=S={}));var p;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(p||(e.WindowsShellType=p={}));var v;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(v||(e.TitleEventSource=v={}));var I;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var E;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$ir=(0,y.$2h)("ptyService");var w;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var f;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var g;(function(u){u.TerminalView="view",u.Editor="editor"})(g||(e.TerminalLocationString=g={}));var c;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var m;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var h;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(h||(e.ProfileSource=h={}));var d;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var l;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$jr={Backend:"workbench.contributions.terminal.processBackend"};class ${constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const i=this.b(n.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}s.$un.add(e.$jr.Backend,new $),e.$kr=(0,y.$2h)("localPtyService"),e.$lr=(0,y.$2h)("terminalLogService")}),define(we[252],ve([1,0,4]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.$GN=e.$FN=void 0;function A(D){let S=D;S.includes("\\")&&(S=S.replace(/\\/g,"\\\\"));const p=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return S=S.replace(p,""),`'${S}'`}e.$FN=A;function s(D,S,p){if(!D)return"";if(!S)return D;S.match(/[\/\\]$/)&&(S=S.slice(0,S.length-1));const v=D.replace(/\\/g,"/").toLowerCase(),I=S.replace(/\\/g,"/").toLowerCase();return v.includes(I)?`~${p}${D.slice(S.length+1)}`:D}e.$GN=s;function P(D){return D.match(/^['"].*['"]$/)&&(D=D.substring(1,D.length-1)),y.OS===1&&D&&D[1]===":"?D[0].toUpperCase()+D.substring(1):D}e.$HN=P}),define(we[253],ve([1,0,49,3,196,100]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=e.$qr=void 0;function D(w,f){const g=[{name:null,description:(0,s.localize)(0,null)}];return g.push(...w.map(c=>({name:c.profileName,description:S(c)}))),f&&g.push(...f.map(c=>({name:c.title,description:p(c)}))),{values:g.map(c=>c.name),markdownDescriptions:g.map(c=>c.description)}}e.$qr=D;function S(w){let f=`$(${P.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:y.$8j.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?f+=`
- args: "${w.args}"`:f+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(f+=`
- overrideName: ${w.overrideName}`),w.color&&(f+=`
- color: ${w.color}`),w.env&&(f+=`
- env: ${JSON.stringify(w.env)}`),f}function p(w){return`$(${P.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:y.$8j.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function v(w,f){if(!w&&!f)return!0;if(typeof w=="string"&&typeof f=="string")return w===f;if(Array.isArray(w)&&Array.isArray(f)){if(w.length!==f.length)return!1;for(let g=0;g<w.length;g++)if(w[g]!==f[g])return!1;return!0}return!1}e.$rr=v;function I(w,f){if(!w&&!f)return!0;if(!w||!f)return!1;if(P.ThemeIcon.isThemeIcon(w)&&P.ThemeIcon.isThemeIcon(f))return w.id===f.id&&w.color===f.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof f=="object"&&"light"in f&&"dark"in f){const g=w,c=f;if((A.URI.isUri(g.light)||E(g.light))&&(A.URI.isUri(g.dark)||E(g.dark))&&(A.URI.isUri(c.light)||E(c.light))&&(A.URI.isUri(c.dark)||E(c.dark)))return g.light.path===c.light.path&&g.dark.path===c.dark.path}if(A.URI.isUri(w)&&A.URI.isUri(f)||E(w)||E(f)){const g=w,c=f;return g.path===c.path&&g.scheme===c.scheme}return!1}e.$sr=I;function E(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.$tr=E}),define(we[254],ve([1,0,49,4,195,56,37,253]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=e.$ur=void 0,e.$ur={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$vr={type:"string",enum:Array.from((0,y.$7j)(),m=>m.id),markdownEnumDescriptions:Array.from((0,y.$7j)(),m=>`$(${m.id})`)};const p={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$vr},color:{description:(0,s.localize)(3,null),...e.$ur},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...p}},I={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...p}};function E(m){const h=m===2?"linux":m===1?"osx":"windows";return(0,s.localize)(7,null,(0,A.$b)(m),'```json\n"terminal.integrated.profile.'+h+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:E(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...p}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...p}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:E(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...p}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:E(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...p}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){D.$un.as(P.$zn.Configuration).registerConfiguration(w),c()}e.$wr=f;let g;function c(m,h){const d=D.$un.as(P.$zn.Configuration);let l;m&&(l=(0,S.$qr)(m?.profiles,h));const $=g;g={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:m?.os===3?l?.values:void 0,markdownEnumDescriptions:m?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:m?.os===2?l?.values:void 0,markdownEnumDescriptions:m?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:m?.os===1?l?.values:void 0,markdownEnumDescriptions:m?.os===1?l?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[g],remove:$?[$]:[]})}e.$xr=c}),define(we[255],ve([1,0,2,12,108,25,109]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=void 0;let S=class extends y.$Sc{constructor(v,I){super(),this.a=v,this.b=I}start(){const v={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:A.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},I=(0,D.$ym)(this.b.args,this.b.isBuilt);I&&(I.break&&I.port?v.debugBrk=I.port:!I.break&&I.port&&(v.debug=I.port));const E=new s.$eq(A.$kg.asFileUri("bootstrap-fork").fsPath,v),w=new y.$Rc;return w.add(E),{client:E,store:w,onDidProcessExit:E.onDidProcessExit}}};e.$lO=S,e.$lO=S=Ne([Le(1,P.$9h)],S)}),define(we[256],ve([1,0,27,12,23,7,4,28,17,8,22,122,90,123]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.$Fr=void 0;function g(){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let t=0;return r&&r.length===4&&(t=parseInt(r[3])),t}e.$Fr=g;async function c(r,t,a,b=S.env,C=I.Promises.exists){if(P.$ic(r))return await C(r)?r:void 0;if(t===void 0&&(t=S.cwd()),P.$mc(r)!=="."){const N=P.$jc(t,r);return await C(N)?N:void 0}const k=(0,s.$pn)(b,"PATH");if(a===void 0&&(0,v.$Ef)(k)&&(a=k.split(P.$tc)),a===void 0||a.length===0){const N=P.$jc(t,r);return await C(N)?N:void 0}for(const N of a){let Y;if(P.$ic(N)?Y=P.$jc(N,r):Y=P.$jc(t,N,r),await C(Y))return Y;if(D.$c){let ee=Y+".com";if(await C(ee)||(ee=Y+".exe",await C(ee)))return ee}}const R=P.$jc(t,r);return await C(R)?R:void 0}e.$Gr=c;function m(r,t,a,b,C){const L=D.$c&&(!t.windowsEnableConpty||g()<18309);if(!t.shellIntegration.enabled||!r.executable||r.isFeatureTerminal||r.hideFromUser||r.ignoreShellIntegration||L)return;const k=r.args,R=S.$dc==="win32"?P.$nc(r.executable).toLowerCase():P.$nc(r.executable),N=P.$mc(A.$kg.asFileUri("").fsPath);let Y;const ee={VSCODE_INJECTION:"1"};if(t.shellIntegration.nonce&&(ee.VSCODE_NONCE=t.shellIntegration.nonce),D.$c){if(R==="pwsh.exe"||R==="powershell.exe")return!k||i(k)?Y=l.get(d.WindowsPwsh):n(k)&&(Y=l.get(d.WindowsPwshLogin)),Y?(Y=[...Y],Y[Y.length-1]=(0,p.$He)(Y[Y.length-1],N,""),{newArgs:Y,envMixin:ee}):void 0;b.warn(`Shell integration cannot be enabled for executable "${r.executable}" and args`,r.args);return}switch(R){case"bash":return!k||k.length===0?Y=l.get(d.Bash):o(k)&&(ee.VSCODE_SHELL_LOGIN="1",h(t,ee),Y=l.get(d.Bash)),Y?(Y=[...Y],Y[Y.length-1]=(0,p.$He)(Y[Y.length-1],N),{newArgs:Y,envMixin:ee}):void 0;case"fish":{const G=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ne=P.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return ee.XDG_DATA_DIRS=`${G}:${ne}`,h(t,ee),{newArgs:void 0,envMixin:ee}}case"pwsh":return!k||i(k)?Y=l.get(d.Pwsh):n(k)&&(Y=l.get(d.PwshLogin)),Y?(Y=[...Y],Y[Y.length-1]=(0,p.$He)(Y[Y.length-1],N,""),{newArgs:Y,envMixin:ee}):void 0;case"zsh":{if(!k||k.length===0?Y=l.get(d.Zsh):o(k)?(Y=l.get(d.ZshLogin),h(t,ee)):(k===l.get(d.Zsh)||k===l.get(d.ZshLogin))&&(Y=k),!Y)return;Y=[...Y],Y[Y.length-1]=(0,p.$He)(Y[Y.length-1],N);let G;try{G=y.userInfo().username}catch{G="unknown"}const ne=P.$jc(y.tmpdir(),`${G}-${C.applicationName}-zsh`);ee.ZDOTDIR=ne;const Z=a?.ZDOTDIR??y.homedir()??"~";ee.USER_ZDOTDIR=Z;const T=[];return T.push({source:P.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:P.$jc(ne,".zshrc")}),T.push({source:P.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:P.$jc(ne,".zprofile")}),T.push({source:P.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:P.$jc(ne,".zshenv")}),T.push({source:P.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:P.$jc(ne,".zlogin")}),{newArgs:Y,envMixin:ee,filesToCopy:T}}}b.warn(`Shell integration cannot be enabled for executable "${r.executable}" and args`,r.args)}e.$Hr=m;function h(r,t){if(D.$d&&r.environmentVariableCollections){const a=(0,w.$Dr)(r.environmentVariableCollections),C=new f.$Er(a).getVariableMap({workspaceFolder:r.workspaceFolder}).get("PATH"),L=[];if(C)for(const k of C)k.type===E.EnvironmentVariableMutatorType.Prepend&&L.push(k.value);L.length>0&&(t.VSCODE_PATH_PREFIX=L.join(""))}}var d;(function(r){r.WindowsPwsh="windows-pwsh",r.WindowsPwshLogin="windows-pwsh-login",r.Pwsh="pwsh",r.PwshLogin="pwsh-login",r.Zsh="zsh",r.ZshLogin="zsh-login",r.Bash="bash"})(d||(d={}));const l=new Map;l.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(d.Zsh,["-i"]),l.set(d.ZshLogin,["-il"]),l.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const $=["-login","-l"],u=["-nol","-nologo"];function n(r){return typeof r=="string"?$.includes(r.toLowerCase()):r.length===1&&$.includes(r[0].toLowerCase())||r.length===2&&($.includes(r[0].toLowerCase())||$.includes(r[1].toLowerCase()))&&(u.includes(r[0].toLowerCase())||u.includes(r[1].toLowerCase()))}function i(r){return typeof r=="string"?u.includes(r.toLowerCase()):r.length===0||r?.length===1&&u.includes(r[0].toLowerCase())}function o(r){return r==="string"&&$.includes(r.toLowerCase())||typeof r!="string"&&r.length===1&&$.includes(r[0].toLowerCase())}}),define(we[257],ve([1,0,52,49,7,4,8,22,103,256,78]),function(he,e,y,A,s,P,D,S,p,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;var E;(function(a){a.UnixShellsPath="/etc/shells"})(E||(E={}));let w,f=!0;function g(a,b,C,L,k=process.env,R,N,Y,ee){return R=R||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},P.$c?c(C,R,k,N,L.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:L.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:L.getValue("terminal.integrated.defaultProfile.windows"),ee,Y):o(R,N,C,a&&typeof a=="object"?{...a}:L.getValue(P.$e?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:L.getValue(P.$e?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),ee,Y,k)}e.$Ir=g;async function c(a,b,C,L,k,R,N,Y,ee){const G=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${G?"Sysnative":"System32"}`;let Z=!1;(0,v.$Fr)()>=16299&&(Z=!0),await l(Y);const T=new Map;if(a){T.set("PowerShell",{source:"PowerShell",icon:A.$8j.terminalPowershell,isAutoDetected:!0}),T.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$8j.terminalPowershell,isAutoDetected:!0}),T.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),T.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:A.$8j.terminalCmd,isAutoDetected:!0}),T.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),T.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.$8j.terminalBash,isAutoDetected:!0});const Q=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;T.set("Cmder",{path:`${ne}\\cmd.exe`,args:["/K",Q],requiresPath:process.env.CMDER_ROOT?Q:{path:Q,isUnsafe:!0},isAutoDetected:!0})}r(R,T);const oe=await m(T.entries(),N,b,C,L,ee);if(a&&k)try{const Q=await n(`${ne}\\${Z?"wsl":"bash"}.exe`,N);for(const te of Q)(!R||!(te.profileName in R))&&oe.push(te)}catch{f&&(L?.info("WSL is not installed, so could not detect WSL profiles"),f=!1)}return oe}async function m(a,b,C,L=process.env,k,R){const N=[];for(const[Y,ee]of a)N.push(h(Y,ee,b,C,L,k,R));return(await Promise.all(N)).filter(Y=>!!Y)}async function h(a,b,C,L,k=process.env,R,N){if(b===null)return;let Y,ee,G;if("source"in b&&!("path"in b)){const oe=w?.get(b.source);if(!oe)return;Y=oe.paths,ee=b.args||oe.args,b.icon?G=d(b.icon):oe.icon&&(G=oe.icon)}else Y=Array.isArray(b.path)?b.path:[b.path],ee=P.$c||Array.isArray(b.args)?b.args:void 0,G=d(b.icon);let ne;if(N){const oe=Y.map(te=>typeof te=="string"?te:te.path),Q=await N(oe);ne=new Array(Y.length);for(let te=0;te<Y.length;te++)typeof Y[te]=="string"?ne[te]=Q[te]:ne[te]={path:Q[te],isUnsafe:!0}}else ne=Y.slice();let Z;if(b.requiresPath){let oe;if((0,D.$Ef)(b.requiresPath)?oe=b.requiresPath:(oe=b.requiresPath.path,b.requiresPath.isUnsafe&&(Z=oe)),!await L.existsFile(oe))return}const T=await t(a,C,ne,L,k,ee,b.env,b.overrideName,b.isAutoDetected,Z);if(!T){R?.debug("Terminal profile not validated",a,Y);return}return T.isAutoDetected=b.isAutoDetected,T.icon=G,T.color=b.color,T}function d(a){return typeof a=="string"?{id:a}:a}async function l(a){if(w&&!a)return;const[b,C]=await Promise.all([$(),a||u()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:C,icon:A.$8j.terminalPowershell})}async function $(){const a=new Set,b=await(0,v.$Gr)("git.exe");if(b){const k=(0,I.dirname)(b);a.add((0,I.resolve)(k,"../.."))}function C(k,R){R&&k.add(R)}C(a,process.env.ProgramW6432),C(a,process.env.ProgramFiles),C(a,process.env["ProgramFiles(X86)"]),C(a,`${process.env.LocalAppData}\\Program`);const L=[];for(const k of a)L.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return L.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),L.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),L}async function u(){const a=[];for await(const b of(0,p.$Ll)())a.push(b.exePath);return a}async function n(a,b){const C=[],L=await new Promise((N,Y)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(ee,G)=>{if(ee)return Y("Problem occurred when getting wsl distros");N(G)})});if(!L)return[];const k=new RegExp(/[\r?\n]/),R=L.split(k).filter(N=>N.trim().length>0&&N!=="");for(const N of R){if(N===""||N.startsWith("docker-desktop"))continue;const Y=`${N} (WSL)`,ee={profileName:Y,path:a,args:["-d",`${N}`],isDefault:Y===b,icon:i(N),isAutoDetected:!1};C.push(ee)}return C}function i(a){return a.includes("Ubuntu")?A.$8j.terminalUbuntu:a.includes("Debian")?A.$8j.terminalDebian:A.$8j.terminalLinux}async function o(a,b,C,L,k,R,N,Y){const ee=new Map;if(C&&await a.existsFile("/etc/shells")){const G=(await a.readFile("/etc/shells")).toString(),ne=(R||G.split(`
`)).map(T=>{const oe=T.indexOf("#");return oe===-1?T:T.substring(0,oe)}).filter(T=>T.trim().length>0),Z=new Map;for(const T of ne){let oe=(0,s.$nc)(T),Q=Z.get(oe)||0;Q++,Q>1&&(oe=`${oe} (${Q})`),Z.set(oe,Q),ee.set(oe,{path:T,isAutoDetected:!0})}}return r(L,ee),await m(ee.entries(),k,a,Y,b,N)}function r(a,b){if(a)for(const[C,L]of Object.entries(a))L===null||typeof L!="object"||!("path"in L)&&!("source"in L)?b.delete(C):(L.icon=L.icon||b.get(C)?.icon,b.set(C,L))}async function t(a,b,C,L,k,R,N,Y,ee,G){if(C.length===0)return Promise.resolve(void 0);const ne=C.shift();if(ne==="")return t(a,b,C,L,k,R,N,Y,ee);const Z=typeof ne!="string"&&ne.isUnsafe,T=typeof ne=="string"?ne:ne.path,oe={profileName:a,path:T,args:R,env:N,overrideName:Y,isAutoDetected:ee,isDefault:a===b,isUnsafePath:Z,requiresUnsafePath:G};if((0,s.$nc)(T)===T){const te=k.PATH?k.PATH.split(s.$tc):void 0,J=await(0,v.$Gr)(T,void 0,te,void 0,L.existsFile);return J?(oe.path=J,oe.isFromPath=!0,oe):t(a,b,C,L,k,R)}return await L.existsFile((0,s.$hc)(T))?oe:t(a,b,C,L,k,R,N,Y,ee)}}),define(we[258],ve([1,0,5,2,4,42,24,13,113,88,251,91,254,257,106,62]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=void 0;var m;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let h=class extends A.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,$,u,n){super(),this.M=l,this.N=$,this.O=u,this.P=n,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new y.$Sd),this.onPtyHostExit=this.u.event,this.w=this.B(new y.$Sd),this.onPtyHostStart=this.w.event,this.y=this.B(new y.$Sd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new y.$Sd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new y.$Sd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new y.$Sd),this.onProcessData=this.D.event,this.F=this.B(new y.$Sd),this.onProcessReady=this.F.event,this.G=this.B(new y.$Sd),this.onProcessReplay=this.G.event,this.H=this.B(new y.$Sd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new y.$Sd),this.onDidRequestDetach=this.I.event,this.J=this.B(new y.$Sd),this.onDidChangeProperty=this.J.event,this.L=this.B(new y.$Sd),this.onProcessExit=this.L.event,(0,w.$wr)(),this.B(this.M),this.B((0,A.$Qc)(()=>this.W())),this.j=this.B(new I.$pr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&y.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$c)return process.env;try{return await(0,v.$8l)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),$=l.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),P.ProxyChannel.toService($.getChannel(E.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=m.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const n=P.ProxyChannel.toService($.getChannel(E.TerminalIpcChannels.PtyHost));return this.B(n.onProcessData(i=>this.D.fire(i))),this.B(n.onProcessReady(i=>this.F.fire(i))),this.B(n.onProcessExit(i=>this.L.fire(i))),this.B(n.onDidChangeProperty(i=>this.J.fire(i))),this.B(n.onProcessReplay(i=>this.G.fire(i))),this.B(n.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(n.onDidRequestDetach(i=>this.I.fire(i))),this.B(new p.$or(this.P,$.getChannel(E.TerminalIpcChannels.Logger))),this.a=l,this.b=n,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,n]}async createProcess(l,$,u,n,i,o,r,t,a,b,C){const L=setTimeout(()=>this.$(),E.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(l,$,u,n,i,o,r,t,a,b,C);return clearTimeout(L),k}updateTitle(l,$,u){return this.f.updateTitle(l,$,u)}updateIcon(l,$,u,n){return this.f.updateIcon(l,$,u,n)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,$){return this.f.detachFromProcess(l,$)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,$){return this.f.shutdown(l,$)}input(l,$){return this.f.input(l,$)}processBinary(l,$){return this.f.processBinary(l,$)}resize(l,$,u){return this.f.resize(l,$,u)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,$){return this.f.acknowledgeDataEvent(l,$)}setUnicodeVersion(l,$){return this.f.setUnicodeVersion(l,$)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new c.$Od,$=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...$]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,$){return this.f.installAutoReply(l,$)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,g.$Rl)(l??s.OS,process.env)}async getProfiles(l,$,u,n=!1){const i=await this.S();return(0,f.$Ir)($,u,n,this.N,i,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,$){return this.f.getWslPath(l,$)}getRevivedPtyNewId(l,$){return this.f.getRevivedPtyNewId(l,$)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,$){return this.f.requestDetachInstance(l,$)}async acceptDetachInstanceReply(l,$){return this.f.acceptDetachInstanceReply(l,$)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,$,u){return this.f.reviveTerminalProcesses(l,$,u)}async refreshProperty(l,$){return this.f.refreshProperty(l,$)}async updateProperty(l,$,u){return this.f.updateProperty(l,$,u)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?E.HeartbeatConstants.ConnectingBeatInterval:E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier+E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${E.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,$){return this.j.createRequest({workspaceId:l,originalText:$})}async acceptPtyHostResolvedVariables(l,$){this.j.acceptReply(l,$)}};e.$Jr=h,e.$Jr=h=Ne([Le(1,D.$vi),Le(2,S.$jj),Le(3,S.$kj)],h)}),define(we[34],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=void 0,e.$Vk=(0,y.$2h)("IUriIdentityService")}),define(we[124],ve([1,0,34,215,16,19,146,5,2]),function(he,e,y,A,s,P,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=void 0;class v{constructor(w){this.uri=w,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let I=class{constructor(w){this.g=w,this.c=new p.$Rc,this.f=2**16;const f=new Map,g=c=>{let m=f.get(c.scheme);return m===void 0&&(m=w.hasProvider(c)&&!this.g.hasCapability(c,1024),f.set(c.scheme,m)),m};this.c.add(S.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(c=>{f.delete(c.scheme)})),this.extUri=new P.$sg(g),this.d=new D.$Mr((c,m)=>this.extUri.compare(c,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,P.$Eg)(w));const f=this.d.get(w);return f?f.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new v(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((g,c)=>g[1].time<c[1].time?1:g[1].time>c[1].time?-1:0);v._clock=0,this.d.clear();const f=this.f*.5;for(let g=0;g<f;g++)this.d.set(w[g][0],w[g][1].touch())}};e.$Nr=I,e.$Nr=I=Ne([Le(0,s.$lk)],I),(0,A.$Kr)(y.$Vk,I,1)}),define(we[92],ve([1,0,198,7,65,19,3,6,12]),function(he,e,y,A,s,P,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,S.$2h)("contextService");function v(r){const t=r;return typeof t?.id=="string"&&D.URI.isUri(t.uri)}e.$_h=v;function I(r){return typeof r?.id=="string"&&!v(r)&&!w(r)}e.$ai=I,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function E(r,t){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,A.$nc)(r)}:t?e.$bi:e.$ci;const a=r;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$di=E;function w(r){const t=r;return typeof t?.id=="string"&&D.URI.isUri(t.configPath)}e.$ei=w;function f(r){const t=r;if(t?.uri)return{id:t.id,uri:D.URI.revive(t.uri)};const a=r;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(r?.id)return{id:r.id}}e.$fi=f;var g;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function c(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$gi=c;function m(r){const t=r;return!!(t&&typeof t=="object"&&D.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$hi=m;class h{constructor(t,a,b,C,L){this.h=t,this.j=b,this.k=C,this.l=L,this.c=s.$8h.forUris(this.l,()=>!0),this.folders=a}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=s.$8h.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=h;class d{constructor(t,a){this.raw=a,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,P.$Dg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=d;function l(r){return new d({uri:r,index:0,name:(0,P.$zg)(r)},{uri:r.toString()})}e.$ki=l,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,y.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function $(r,t){return P.$ug.isEqualOrParent(r,t.untitledWorkspacesHome)}e.$pi=$;function u(r){let t;return D.URI.isUri(r)?t=r:t=r.configuration,t?.scheme===p.Schemas.tmp}e.$qi=u,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(r){return r.id===e.$ri}e.$si=n;function i(r,t){return!$(r,t)&&!u(r)}e.$ti=i;function o(r){return(typeof r=="string"?(0,A.$oc)(r):(0,P.$Bg)(r))===e.$mi}e.$ui=o}),define(we[33],ve([1,0,63,5,2,19,3,197,25,16,6,13,92,26,34,14,21,17,8]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.ProfileResourceType=void 0;var l;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function $(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&D.URI.isUri(t.location)&&D.URI.isUri(t.globalStorageHome)&&D.URI.isUri(t.settingsResource)&&D.URI.isUri(t.keybindingsResource)&&D.URI.isUri(t.tasksResource)&&D.URI.isUri(t.snippetsHome)&&D.URI.isUri(t.extensionsResource))}e.$Wk=$,e.$Xk=(0,I.$2h)("IUserDataProfilesService");function u(r,t){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:D.URI.revive(r.location).with({scheme:t}),globalStorageHome:D.URI.revive(r.globalStorageHome).with({scheme:t}),settingsResource:D.URI.revive(r.settingsResource).with({scheme:t}),keybindingsResource:D.URI.revive(r.keybindingsResource).with({scheme:t}),tasksResource:D.URI.revive(r.tasksResource).with({scheme:t}),snippetsHome:D.URI.revive(r.snippetsHome).with({scheme:t}),extensionsResource:D.URI.revive(r.extensionsResource).with({scheme:t}),cacheHome:D.URI.revive(r.cacheHome).with({scheme:t}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.$Yk=u;function n(r,t,a,b,C,L){return{id:r,name:t,location:a,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:L&&C?.useDefaultFlags?.globalState?L.globalStorageHome:(0,P.$Dg)(a,"globalStorage"),settingsResource:L&&C?.useDefaultFlags?.settings?L.settingsResource:(0,P.$Dg)(a,"settings.json"),keybindingsResource:L&&C?.useDefaultFlags?.keybindings?L.keybindingsResource:(0,P.$Dg)(a,"keybindings.json"),tasksResource:L&&C?.useDefaultFlags?.tasks?L.tasksResource:(0,P.$Dg)(a,"tasks.json"),snippetsHome:L&&C?.useDefaultFlags?.snippets?L.snippetsHome:(0,P.$Dg)(a,"snippets"),extensionsResource:L&&C?.useDefaultFlags?.extensions?L.extensionsResource:(0,P.$Dg)(a,"extensions.json"),cacheHome:(0,P.$Dg)(b,r),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$Zk=n;let i=class extends s.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,a,b,C){super(),this.t=t,this.u=a,this.w=b,this.y=C,this.f=!0,this.h=this.B(new A.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,P.$Dg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Dg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),a=[t];if(this.f)try{for(const L of this.O()){if(!L.name||!(0,d.$Ef)(L.name)||!L.location){this.y.warn("Skipping the invalid stored profile",L.location||L.name);continue}a.push(n((0,P.$Ag)(L.location),L.name,L.location,this.g,{shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags},t))}}catch(L){this.y.error(L)}const b=new f.$Ac,C=new Map;if(a.length)try{const L=this.Q();if(L.workspaces)for(const[k,R]of Object.entries(L.workspaces)){const N=D.URI.parse(k),Y=a.find(ee=>ee.id===R);Y&&b.set(N,Y)}if(L.emptyWindows)for(const[k,R]of Object.entries(L.emptyWindows)){const N=a.find(Y=>Y.id===R);N&&C.set(k,N)}}catch(L){this.y.error(L)}this.z={profiles:a,workspaces:b,emptyWindows:C}}return this.z}D(){const t=n("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const a="Temp",b=new RegExp(`${(0,h.$Ke)(a)}\\s(\\d+)`);let C=0;for(const k of this.profiles){const R=b.exec(k.name),N=R?parseInt(R[1]):0;C=N>C?N:C}const L=`${a} ${C+1}`;return this.createProfile((0,y.$Pi)((0,m.$mg)()).toString(16),L,{transient:!0},t)}async createNamedProfile(t,a,b){return this.createProfile((0,y.$Pi)((0,m.$mg)()).toString(16),t,a,b)}async createProfile(t,a,b,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const L=await this.F(t,a,b);return C&&await this.setProfileForWorkspace(C,L),L}async F(t,a,b){if(!(0,d.$Ef)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(a);return C||(C=(async()=>{try{const L=this.profiles.find(N=>N.name===a||N.id===t);if(L)return L;const k=n(t,a,(0,P.$Dg)(this.profilesHome,t),this.g,b,this.defaultProfile);await this.u.createFolder(k.location);const R=[];return this.j.fire({profile:k,join(N){R.push(N)}}),await c.Promises.settled(R),this.I([k],[],[]),k}finally{this.r.delete(a)}})(),this.r.set(a,C)),C}async updateProfile(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(C=>C.id===t.id);if(!b)throw new Error(`Profile '${t.name}' does not exist`);return b=n(b.id,a.name??b.name,b.location,this.g,{shortName:a.shortName??b.shortName,icon:a.icon===null?void 0:a.icon??b.icon,transient:a.transient??b.isTransient,useDefaultFlags:a.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(C=>C.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);const b=[];this.m.fire({profile:a,join(C){b.push(C)}});try{await Promise.allSettled(b)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(C){(0,v.$Ck)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(C=>C.id===a.id);if(!b)throw new Error(`Profile '${a.name}' does not exist`);this.L(t,b)}unsetWorkspace(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(a=>a.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(t.map(a=>this.removeProfile(a)))}getProfileForWorkspace(t){const a=this.G(t);return D.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(t){return(0,w.$_h)(t)?t.uri:(0,w.$ei)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,t.location)))}I(t,a,b){const C=[...this.profiles,...t],L=[];this.s.profiles=[];for(let k of C)k.isDefault||a.some(R=>k.id===R.id)||(k=b.find(R=>k.id===R.id)??k,k.isTransient?this.s.profiles.push(k):L.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(L),this.z=void 0,this.J(t,a,b)}J(t,a,b){this.h.fire({added:t,removed:a,updated:b,all:this.profiles})}L(t,a,b){b=a?.isTransient?!0:b,b||this.L(t,void 0,!0);const C=this.G(t),L=b?this.s:this.C;D.URI.isUri(C)?(L.workspaces.delete(C),a&&L.workspaces.set(C,a)):(L.emptyWindows.delete(C),a&&L.emptyWindows.set(C,a)),b||this.M()}M(){const t={};for(const[b,C]of this.C.workspaces.entries())t[b.toString()]=C.id;const a={};for(const[b,C]of this.C.emptyWindows.entries())a[b.toString()]=C.id;this.R({workspaces:t,emptyWindows:a}),this.z=void 0}N(t){const a={},b=this.D();if(t.workspaces)for(const[L,k]of Object.entries(t.workspaces)){const R=D.URI.parse(k);a[L]=this.w.extUri.isEqual(R,b.location)?b.id:this.w.extUri.basename(R)}const C={};if(t.emptyWindows)for(const[L,k]of Object.entries(t.emptyWindows)){const R=D.URI.parse(k);C[L]=this.w.extUri.isEqual(R,b.location)?b.id:this.w.extUri.basename(R)}return{workspaces:a,emptyWindows:C}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$1k=i,i.b="userDataProfiles",i.c="profileAssociations",e.$1k=i=Ne([Le(0,p.$9h),Le(1,v.$lk),Le(2,g.$Vk),Le(3,E.$jj)],i);class o extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$2k=o}),define(we[259],ve([1,0,18,14,20,11,5,2,4,8,3,178,30,36,35,13,31,32,34,33]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0;let $=class extends S.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,a,b,C,L,k){super(),this.z=t,this.C=a,this.D=b,this.F=C,this.G=L,this.H=k,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$Sd),this.s=this.B(new D.$Sd),this.t=this.B(new D.$Sd),this.u=this.B(new D.$Sd),this.w=this.B(new D.$Sd),this.y=[],this.B((0,S.$Qc)(()=>{this.j.forEach(({task:R})=>R.cancel()),this.m.forEach(R=>R.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const a=await this.getTargetPlatform();return t.allTargetPlatforms.some(b=>(0,w.$jo)(b,t.allTargetPlatforms,a))}async installFromGallery(t,a={}){try{const C=(await this.installGalleryExtensions([{extension:t,options:a}])).find(({identifier:L})=>(0,f.$No)(L,t.identifier));if(C?.local)return C?.local;throw C?.error?C.error:n(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(b){throw n(b)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new w.$mo(E.localize(0,null),w.ExtensionManagementErrorCode.Internal);const a=[],b=[];await Promise.allSettled(t.map(async({extension:C,options:L})=>{try{const k=await this.O(C,!!L?.installGivenVersion,!!L?.installPreReleaseVersion);b.push({...k,options:L})}catch(k){a.push({identifier:C.identifier,operation:2,source:C,error:k})}})),b.length&&a.push(...await this.I(b));for(const C of a)C.error&&(this.F.error("Failed to install extension.",C.identifier.id),this.F.error(C.error),C.source&&!I.URI.isUri(C.source)&&i(this.C,"extensionGallery:install",{extensionData:(0,f.$Vo)(C.source),error:C.error}));return a}async uninstall(t,a={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,a)}async toggleAppliationScope(t,a){if((0,g.$km)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let b=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||(b=await this.ab(t,this.H.defaultProfile.extensionsResource,a));for(const C of this.H.profiles){const L=(await this.getInstalled(1,C.extensionsResource)).find(k=>(0,f.$No)(k.identifier,t.identifier));L?this.w.fire(L):this.u.fire({identifier:t.identifier,profileLocation:C.extensionsResource})}return b}else{const b=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:b.identifier,operation:2,local:b,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),b}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const a=[];return await Promise.allSettled(t.map(async b=>{try{const C=await this.J(b,(L,k)=>t.some(R=>(0,f.$Ro)(k.identifier.id)===(0,f.$So)(R.manifest.publisher,R.manifest.name))?!1:this.L(L,k));a.push(...C)}catch(C){a.push({identifier:{id:(0,f.$So)(b.manifest.publisher,b.manifest.name)},operation:2,source:b.extension,error:C})}})),this.s.fire(a),a}async J({manifest:t,extension:a,options:b},C){const L=b.isApplicationScoped||b.isBuiltin||(0,g.$km)(t),k={...b,installOnlyNewlyAddedFromExtensionPack:I.URI.isUri(a)?b.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:L,profileLocation:L?this.H.defaultProfile.extensionsResource:b.profileLocation??this.Y()},R=Z=>`${f.$Oo.create(Z).toString()}${k.profileLocation?`-${k.profileLocation.toString()}`:""}`;if(!I.URI.isUri(a)){const Z=this.j.get(R(a));if(Z)return this.F.info("Extensions is already requested to install",a.identifier.id),await Z.task.waitUntilTaskIsFinished(),[]}const N=[],Y=[],ee=[],G=this.Z(t,a,k);I.URI.isUri(a)||this.j.set(R(a),{task:G,waitingTasks:[]}),this.n.fire({identifier:G.identifier,source:a,profileLocation:k.profileLocation}),this.F.info("Installing extension:",G.identifier.id),N.push({task:G,manifest:t});let ne=!1;try{if(k.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",G.identifier.id);else try{const T=await this.N(G.identifier,t,!!k.installOnlyNewlyAddedFromExtensionPack,!!k.installPreReleaseVersion,k.profileLocation),oe=await this.getInstalled(void 0,k.profileLocation),Q={...k,donotIncludePackAndDependencies:!0,context:{...k.context,[w.$eo]:!0}};for(const{gallery:te,manifest:J}of(0,y.$Mb)(T,({gallery:V})=>V.identifier.id)){ne=ne||!!J.extensionDependencies?.some(ue=>(0,f.$No)({id:ue},G.identifier));const V=R(te),ie=this.j.get(V);if(ie){if(C(G,ie.task)){const ue=ie.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,G.identifier.id),ie.waitingTasks.push(G),Y.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,se=>se.some(me=>(0,f.$No)(me.identifier,ue)))).then(se=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,G.identifier.id),!se.find(B=>(0,f.$No)(B.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else if(!oe.some(({identifier:ue})=>(0,f.$No)(ue,te.identifier))){const ue=this.Z(J,te,Q);this.j.set(V,{task:ue,waitingTasks:[G]}),this.n.fire({identifier:ue.identifier,source:te,profileLocation:k.profileLocation}),this.F.info("Installing extension:",ue.identifier.id,G.identifier.id),N.push({task:ue,manifest:J})}}}catch(T){if(I.URI.isUri(G.source))(0,y.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",G.identifier.id,T.message),(0,y.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",G.identifier.id,T.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",G.identifier.id),T}const Z=N.reduce((T,{task:oe,manifest:Q})=>(T.set(oe.identifier.id.toLowerCase(),{task:oe,manifest:Q}),T),new Map);for(;Z.size;){let T;const oe=[...Z.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(te=>Z.has(te.toLowerCase())));oe.length?T=Z.size===1?oe:oe.filter(({task:Q})=>!(Q===G&&!ne)):(this.F.info("Found extensions with circular dependencies",oe.map(({task:Q})=>Q.identifier.id)),T=[...Z.values()]),await this.M(T.map(async({task:Q})=>{const te=new Date().getTime();try{const J=await Q.run();if(await this.M(this.y.map(V=>V.postInstall(J,Q.source,k,s.CancellationToken.None))),!I.URI.isUri(Q.source)){const V=Q.operation===3,ie=V?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(i(this.C,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Vo)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-te,durationSinceUpdate:ie}),p.$i&&Q.operation!==3)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}ee.push({local:J,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw I.URI.isUri(Q.source)||i(this.C,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Vo)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-te,error:J}),this.F.error("Error while installing the extension:",Q.identifier.id),J}finally{Z.delete(Q.identifier.id.toLowerCase())}}))}return Y.length&&await this.M(Y),ee.forEach(({identifier:T})=>this.F.info("Extension installed successfully:",T.id)),ee}catch(Z){if(N.forEach(({task:T})=>T.cancel()),ee.length)try{const T=await Promise.allSettled(ee.map(({local:oe})=>this.$(oe,{versionOnly:!0,profileLocation:k.profileLocation}).run()));for(let oe=0;oe<T.length;oe++){const Q=T[oe],{identifier:te}=ee[oe];Q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",te.id):this.F.warn("Rollback: Error while uninstalling extension",te.id,(0,P.$0)(Q.reason))}}catch(T){this.F.warn("Error while rolling back extensions",(0,P.$0)(T),ee.map(({identifier:oe})=>oe.id))}return N.map(({task:T})=>({identifier:T.identifier,operation:2,source:T.source,context:k.context,profileLocation:k.profileLocation,error:Z}))}finally{for(const{task:Z}of N)Z.source&&!I.URI.isUri(Z.source)&&this.j.delete(R(Z.source))}}L(t,a){for(const[,{task:b,waitingTasks:C}]of this.j.entries())if(b===t&&(C.includes(a)||C.some(L=>this.L(L,a)))||b===a&&C[0]&&!this.L(t,C[0]))return!1;return!0}async M(t){const a=[],b=[],C=await Promise.allSettled(t);for(const L of C)L.status==="fulfilled"?a.push(L.value):b.push(L.reason);if(b.length)throw u(b);return a}async N(t,a,b,C,L){if(!this.z.isEnabled())return[];const k=await this.getInstalled(void 0,L),R=[],N=[],Y=async(ee,G)=>{R.push(ee);const ne=G.extensionDependencies||[],Z=[...ne];if(G.extensionPack){const T=b?k.find(oe=>(0,f.$No)(oe.identifier,ee)):void 0;for(const oe of G.extensionPack)T&&T.manifest.extensionPack&&T.manifest.extensionPack.some(Q=>(0,f.$No)({id:Q},{id:oe}))||Z.every(Q=>!(0,f.$No)({id:Q},{id:oe}))&&Z.push(oe)}if(Z.length){const T=Z.filter(oe=>R.every(Q=>!(0,f.$No)(Q,{id:oe})));if(T.length){const oe=await this.z.getExtensions(T.map(Q=>({id:Q,preRelease:C})),s.CancellationToken.None);for(const Q of oe){if(R.find(V=>(0,f.$No)(V,Q.identifier)))continue;const te=ne.some(V=>(0,f.$No)({id:V},Q.identifier));let J;try{J=await this.O(Q,!1,C)}catch(V){if(te)throw V;this.F.info("Skipping the packed extension as it cannot be installed",Q.identifier.id,(0,P.$0)(V));continue}N.push({gallery:J.extension,manifest:J.manifest}),await Y(J.extension.identifier,J.manifest)}}}};return await Y(t,a),N}async O(t,a,b){let C;const L=await this.getExtensionsControlManifest();if(L.malicious.some(N=>(0,f.$No)(t.identifier,N)))throw new w.$mo(E.localize(1,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);const k=L.deprecated[t.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),C=(await this.z.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},s.CancellationToken.None))[0],!C)throw new w.$mo(E.localize(2,null,t.identifier.id,k.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const N=await this.getTargetPlatform();throw new w.$mo(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,w.$fo)(N)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(C=await this.P(t,a,b),!C)throw!b&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],s.CancellationToken.None))[0]?new w.$mo(E.localize(4,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$mo(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",C.identifier.id);const R=await this.z.getManifest(C,s.CancellationToken.None);if(R===null)throw new w.$mo(`Missing manifest for extension ${C.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(R.version!==C.version)throw new w.$mo(`Cannot install '${C.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:R}}async P(t,a,b){const C=await this.getTargetPlatform();let L=null;return!a&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==b&&(L=(await this.z.getExtensions([{...t.identifier,preRelease:b}],{targetPlatform:C,compatible:!0},s.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(t,b,C)&&(L=t),L||(a?L=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:C,compatible:!0},s.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(t,b,C)),L}async Q(t,a){const b={...a,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},C=ee=>`${ee.id.toLowerCase()}${b.versionOnly?`-${t.manifest.version}`:""}${b.profileLocation?`@${b.profileLocation.toString()}`:""}`,L=this.m.get(C(t.identifier));if(L)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),L.waitUntilTaskIsFinished();const k=ee=>{const G=this.$(ee,b);return this.m.set(C(G.extension.identifier),G),b.profileLocation?this.F.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,b.profileLocation.toString()):this.F.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.t.fire({identifier:ee.identifier,profileLocation:b.profileLocation,applicationScoped:ee.isApplicationScoped}),G},R=(ee,G)=>{G?b.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,b.profileLocation.toString(),G.message):this.F.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,G.message):b.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,b.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Uo)(ee),error:G}),this.u.fire({identifier:ee.identifier,error:G?.code,profileLocation:b.profileLocation,applicationScoped:ee.isApplicationScoped})},N=[],Y=[];try{N.push(k(t));const ee=await this.getInstalled(1,b.profileLocation);if(b.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const G=this.U(t,ee);for(const ne of G)this.m.has(C(ne.identifier))?this.F.info("Extensions is already requested to uninstall",ne.identifier.id):N.push(k(ne))}b.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(N.map(G=>G.extension),ee,t),await this.M(N.map(async G=>{try{if(await G.run(),await this.M(this.y.map(ne=>ne.postUninstall(G.extension,b,s.CancellationToken.None))),G.extension.identifier.uuid)try{await this.z.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,"uninstall")}catch{}R(G.extension)}catch(ne){const Z=ne instanceof w.$mo?ne:new w.$mo((0,P.$0)(ne),w.ExtensionManagementErrorCode.Internal);throw R(G.extension,Z),Z}finally{Y.push(G)}}))}catch(ee){const G=ee instanceof w.$mo?ee:new w.$mo((0,P.$0)(ee),w.ExtensionManagementErrorCode.Internal);for(const ne of N){try{ne.cancel()}catch{}Y.includes(ne)||R(ne.extension,G)}throw G}finally{for(const ee of N)this.m.delete(C(ee.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}R(t,a,b){for(const C of t){const L=this.W(C,a);if(L.length){const k=L.filter(R=>!t.some(N=>(0,f.$No)(N.identifier,R.identifier)));if(k.length)throw new Error(this.S(C,k,b))}}}S(t,a,b){return b===t?a.length===1?E.localize(6,null,b.manifest.displayName||b.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(7,null,b.manifest.displayName||b.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(8,null,b.manifest.displayName||b.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?E.localize(9,null,b.manifest.displayName||b.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(10,null,b.manifest.displayName||b.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(11,null,b.manifest.displayName||b.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}U(t,a,b=[]){if(b.indexOf(t)!==-1)return[];b.push(t);const C=t.manifest.extensionPack?t.manifest.extensionPack:[];if(C.length){const L=a.filter(R=>!R.isBuiltin&&C.some(N=>(0,f.$No)({id:N},R.identifier))),k=[];for(const R of L)k.push(...this.U(R,a,b));return[...L,...k]}return[]}W(t,a){return a.filter(b=>b.manifest.extensionDependencies&&b.manifest.extensionDependencies.some(C=>(0,f.$No)({id:C},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Dp=$,e.$Dp=$=Ne([Le(0,w.$lo),Le(1,h.$pl),Le(2,d.$Vk),Le(3,c.$jj),Le(4,m.$Bj),Le(5,l.$Xk)],$);function u(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((a,b)=>new Error(`${a.message}${a.message?",":""}${b instanceof Error?b.message:b}`),new Error(""))}e.$Ep=u;function n(r){if(r instanceof w.$mo)return r;const t=new w.$mo(r.message,w.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}e.$Fp=n;function i(r,t,{extensionData:a,verificationStatus:b,duration:C,error:L,durationSinceUpdate:k}){let R,N;(0,v.$Mf)(b)&&(b===!0?b="Verified":(b===!1||(R=w.ExtensionManagementErrorCode.Signature,N=b),b="Unverified")),L&&(L instanceof w.$mo?(R=L.code,L.code===w.ExtensionManagementErrorCode.Signature&&(N=L.message)):R=w.ExtensionManagementErrorCode.Internal),r.publicLog(t,{...a,verificationStatus:b,success:!L,duration:C,errorcode:R,errorcodeDetail:N,durationSinceUpdate:k})}class o{constructor(){this.d=new A.$1g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$Pg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$Pg)(t=>new Promise((a,b)=>{const C=t.onCancellationRequested(()=>{C.dispose(),b(new P.$5)})})),this.d.open()),this.g.cancel()}}e.$Gp=o}),define(we[45],ve([1,0,14,15,2,5,26,3,30,36,16,6,13,33,34,8,11,32]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class l extends Error{constructor(o,r){super(o),this.code=r}}e.$Hp=l,e.$Ip=(0,E.$2h)("IExtensionsProfileScannerService");let $=class extends s.$Sc{constructor(o,r,t,a,b,C){super(),this.j=o,this.m=r,this.n=t,this.r=a,this.s=b,this.t=C,this.b=this.B(new P.$Sd),this.onAddExtensions=this.b.event,this.c=this.B(new P.$Sd),this.onDidAddExtensions=this.c.event,this.f=this.B(new P.$Sd),this.onRemoveExtensions=this.f.event,this.g=this.B(new P.$Sd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(o,r){return this.u(o,void 0,r)}async addExtensionsToProfile(o,r){const t=[],a=[];try{return await this.u(r,b=>{const C=[];for(const L of b)o.some(([k])=>(0,v.$No)(k.identifier,L.identifier)&&k.manifest.version!==L.version)?t.push(L):C.push(L);for(const[L,k]of o){const R=C.findIndex(Y=>(0,v.$No)(Y.identifier,L.identifier)&&Y.version===L.manifest.version),N={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:k};R===-1?(a.push(N),C.push(N)):C.splice(R,1,N)}return a.length&&this.b.fire({extensions:a,profileLocation:r}),t.length&&this.f.fire({extensions:t,profileLocation:r}),C}),a.length&&this.c.fire({extensions:a,profileLocation:r}),t.length&&this.g.fire({extensions:t,profileLocation:r}),a}catch(b){throw a.length&&this.c.fire({extensions:a,error:b,profileLocation:r}),t.length&&this.g.fire({extensions:t,error:b,profileLocation:r}),b}}async updateMetadata(o,r){const t=[];return await this.u(r,a=>{const b=[];for(const C of a){const L=o.find(([k])=>(0,v.$No)(k.identifier,C.identifier)&&k.manifest.version===C.version);L&&(C.metadata={...C.metadata,...L[1]},t.push(C)),b.push(C)}return b}),t}async removeExtensionFromProfile(o,r){const t=[];try{await this.u(r,a=>{const b=[];for(const C of a)(0,v.$No)(C.identifier,o.identifier)?t.push(C):b.push(C);return t.length&&this.f.fire({extensions:t,profileLocation:r}),b}),t.length&&this.g.fire({extensions:t,profileLocation:r})}catch(a){throw t.length&&this.g.fire({extensions:t,error:a,profileLocation:r}),a}}async u(o,r,t){return this.F(o).queue(async()=>{let a=[],b;try{const C=await this.m.readFile(o);b=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,I.$Ck)(C)!==1)throw C;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&t?.bailOutWhenFileNotFound)throw new l((0,m.$0)(C),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(o);let C=!1;for(const L of b){u(L)||this.w(o);let k;if((0,c.$Ef)(L.relativeLocation)&&L.relativeLocation)k=this.z(L.relativeLocation);else if((0,c.$Ef)(L.location))k=this.z(L.location),C=!0,L.relativeLocation=L.location,L.location=k.toJSON();else{k=S.URI.revive(L.location);const R=this.y(k);R&&(C=!0,L.relativeLocation=R)}a.push({identifier:L.identifier,location:k,version:L.version,metadata:L.metadata})}C&&await this.m.writeFile(o,A.$ge.fromString(JSON.stringify(b)))}if(r){a=r(a);const C=a.map(L=>({identifier:L.identifier,version:L.version,location:L.location.toJSON(),relativeLocation:this.y(L.location),metadata:L.metadata}));await this.m.writeFile(o,A.$ge.fromString(JSON.stringify(C)))}return a})}w(o){const r=new l(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),r=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(o)).value.toString()}catch(b){if((0,I.$Ck)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",o.toString());let a;try{const b=JSON.parse(t);Array.isArray(b)&&b.every(C=>u(C))?a=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ge.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,I.$Ck)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(o)}catch(b){(0,I.$Ck)(b)!==1&&this.t.error(b)}try{await this.m.del(r)}catch(b){(0,I.$Ck)(b)!==1&&this.t.error(b)}return a})()),this.C}F(o){let r=this.h.get(o);return r||(r=new y.$9g,this.h.set(o,r)),r}};e.$Jp=$,e.$Jp=$=Ne([Le(1,I.$lk),Le(2,f.$Xk),Le(3,g.$Vk),Le(4,h.$pl),Le(5,w.$jj)],$);function u(i){return(0,c.$Gf)(i)&&(0,p.$ko)(i.identifier)&&(n(i.location)||(0,c.$Ef)(i.location)&&i.location)&&((0,c.$Lf)(i.relativeLocation)||(0,c.$Ef)(i.relativeLocation))&&i.version&&(0,c.$Ef)(i.version)}function n(i){return i?(0,c.$Ef)(i.path)&&(0,c.$Ef)(i.scheme):!1}}),define(we[58],ve([1,0,18,14,23,15,11,76,169,2,12,7,4,19,53,64,8,3,182,25,36,35,82,16,6,13,31,5,50,45,33,34,212]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u,n,i,o,r,t,a,b,C,L,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=e.$Op=e.$Np=e.$Mp=e.Translations=void 0;var N;(function(oe){function Q(te,J){if(te===J)return!0;const V=Object.keys(te),ie=new Set;for(const ue of Object.keys(J))ie.add(ue);if(V.length!==ie.size)return!1;for(const ue of V){if(te[ue]!==J[ue])return!1;ie.delete(ue)}return ie.size===0}oe.equals=Q})(N||(e.Translations=N={})),e.$Mp=(0,o.$2h)("IExtensionsScannerService");let Y=class extends v.$Sc{constructor(Q,te,J,V,ie,ue,se,me,B,W,O,j){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=te,this.r=J,this.s=V,this.t=ie,this.u=ue,this.w=se,this.y=me,this.z=B,this.C=W,this.D=O,this.F=j,this.g=this.B(new a.$Sd),this.onDidChangeCache=this.g.event,this.h=(0,f.$Dg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ne,this.s,this.h)),this.m=this.B(this.F.createInstance(ne,this.s,this.h)),this.n=this.B(this.F.createInstance(G,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,$.$Yo)(this.w,this.y)),this.G}async scanAllExtensions(Q,te,J){const[V,ie]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(te)]),ue=J?await this.scanExtensionsUnderDevelopment(Q,[...V,...ie]):[];return this.L(V,ie,ue,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const te=[];te.push(this.M(!!Q.useCache,Q.language)),te.push(this.N(Q.language,!!Q.checkControlFile));const[J,V]=await Promise.all(te);return this.J([...J,...V],0,Q,!1)}async scanUserExtensions(Q){const te=Q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const J=this.D.extUri.isEqual(Q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(te,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,J),ie=Q.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ue;try{ue=await ie.scanExtensions(V)}catch(se){if(se instanceof C.$Hp&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ue=await ie.scanExtensions(V);else throw se}return ue=await this.J(ue,1,Q,!0),this.y.trace("Scanned user extensions:",ue.length),ue}async scanExtensionsUnderDevelopment(Q,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const J=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===I.Schemas.file).map(async V=>{const ie=await this.P(V,!1,1,!0,Q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ie)).map(se=>(se.type=te.find(me=>(0,$.$No)(me.identifier,se.identifier))?.type??se.type,this.n.validate(se,ie)))}))).flat();return this.J(J,"development",Q,!0)}return[]}async scanExistingExtension(Q,te,J){const V=await this.P(Q,!1,te,!0,J.language,!0,void 0),ie=await this.n.scanExtension(V);return!ie||!J.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(Q,te,J){const V=await this.P(Q,!1,te,!0,J.language,!0,void 0),ie=await this.n.scanOneOrMultipleExtensions(V);return this.J(ie,te,J,!0)}async scanMetadata(Q){const te=(0,f.$Dg)(Q,"package.json"),J=(await this.w.readFile(te)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(Q,te){const J=(0,f.$Dg)(Q,"package.json"),V=(await this.w.readFile(J)).value.toString(),ie=JSON.parse(V);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,ie.__metadata={...ie.__metadata,...te},await this.w.writeFile((0,f.$Dg)(Q,"package.json"),P.$ge.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof C.$Hp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.u.addExtensionsToProfile(Q.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,P.$ge.fromString(JSON.stringify([])))}catch(te){(0,i.$Ck)(te)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.y.error(Q)}finally{this.H=void 0}})()),this.H}async J(Q,te,J,V){return J.includeAllVersions||(Q=this.L(te===0?Q:void 0,te===1?Q:void 0,te==="development"?Q:void 0,await this.getTargetPlatform(),V)),J.includeInvalid||(Q=Q.filter(ie=>ie.isValid)),Q.sort((ie,ue)=>{const se=E.$nc(ie.location.fsPath),me=E.$nc(ue.location.fsPath);return se<me?-1:se>me?1:0})}L(Q,te,J,V,ie){const ue=(me,B,W)=>{if(me.isValid&&!B.isValid)return!1;if(me.isValid===B.isValid){if(ie&&g.gt(me.manifest.version,B.manifest.version))return this.y.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${me.location.path} with version ${me.manifest.version}`),!1;if(g.eq(me.manifest.version,B.manifest.version)){if(me.type===0)return this.y.debug(`Skipping extension ${B.location.path} in favour of system extension ${me.location.path} with same version`),!1;if(me.targetPlatform===V)return this.y.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return W?this.y.warn(`Overwriting user extension ${me.location.path} with ${B.location.path}.`):this.y.debug(`Overwriting user extension ${me.location.path} with ${B.location.path}.`),!0},se=new u.$jm;return Q?.forEach(me=>{const B=se.get(me.identifier.id);(!B||ue(B,me,!1))&&se.set(me.identifier.id,me)}),te?.forEach(me=>{const B=se.get(me.identifier.id);if(!B&&Q&&me.type===0){this.y.debug(`Skipping obsolete system extension ${me.location.path}.`);return}(!B||ue(B,me,!1))&&se.set(me.identifier.id,me)}),J?.forEach(me=>{const B=se.get(me.identifier.id);(!B||ue(B,me,!0))&&se.set(me.identifier.id,me),se.set(me.identifier.id,me)}),[...se.values()]}async M(Q,te){this.y.trace("Started scanning system extensions");const J=await this.P(this.systemExtensionsLocation,!1,0,!0,te,!0,void 0),ie=await(Q&&!J.devMode?this.j:this.n).scanExtensions(J);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(Q,te){const J=this.z.isBuilt?[]:this.C.builtInExtensions;if(!J?.length)return[];this.y.trace("Started scanning dev system extensions");const V=te?await this.O():{},ie=[],ue=h.URI.file(E.$hc(E.$jc(I.$kg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const me of J){const B=V[me.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":ie.push((0,f.$Dg)(ue,me.name));break;default:ie.push(h.URI.file(B));break}}const se=await Promise.all(ie.map(async me=>this.n.scanExtension(await this.P(me,!1,0,!0,Q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",se.length),(0,y.$Hb)(se)}async O(){try{const Q=await this.w.readFile(this.r);return JSON.parse(Q.value.toString())}catch{return{}}}async P(Q,te,J,V,ie,ue,se){const me=await this.f(ie??w.$q),B=await this.Q(Q),W=te&&!this.D.extUri.isEqual(Q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=W?await this.Q(W):void 0;return new ee(Q,B,W,O,te,se,J,V,ue,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ie,me)}async Q(Q){try{const te=await this.w.stat(Q);if(typeof te.mtime=="number")return te.mtime}catch{}}};e.$Np=Y,e.$Np=Y=Ne([Le(4,L.$Xk),Le(5,C.$Ip),Le(6,i.$lk),Le(7,r.$jj),Le(8,l.$9h),Le(9,t.$Bj),Le(10,k.$Vk),Le(11,o.$1h)],Y);class ee{constructor(Q,te,J,V,ie,ue,se,me,B,W,O,j,re,X,x){this.location=Q,this.mtime=te,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=V,this.profile=ie,this.profileScanOptions=ue,this.type=se,this.excludeObsolete=me,this.validate=B,this.productVersion=W,this.productDate=O,this.productCommit=j,this.devMode=re,this.language=X,this.translations=x}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,te){return(0,f.$wg)(Q.location,te.location)&&Q.mtime===te.mtime&&(0,f.$wg)(Q.applicationExtensionslocation,te.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&Q.profile===te.profile&&s.$mn(Q.profileScanOptions,te.profileScanOptions)&&Q.type===te.type&&Q.excludeObsolete===te.excludeObsolete&&Q.validate===te.validate&&Q.productVersion===te.productVersion&&Q.productDate===te.productDate&&Q.productCommit===te.productCommit&&Q.devMode===te.devMode&&Q.language===te.language&&N.equals(Q.translations,te.translations)}}e.$Op=ee;let G=class extends v.$Sc{constructor(Q,te,J,V,ie){super(),this.f=Q,this.g=te,this.h=J,this.j=V,this.m=ie}async scanExtensions(Q){const te=Q.profile?await this.r(Q):await this.n(Q);let J={};if(Q.excludeObsolete&&Q.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();J=JSON.parse(V)}catch{}return(0,m.$Rf)(J)?te:te.filter(V=>!J[$.$Oo.create(V).toString()])}async n(Q){const te=await this.j.resolve(Q.location);if(!te.children?.length)return[];const J=await Promise.all(te.children.map(async V=>{if(!V.isDirectory||Q.type===1&&(0,f.$Ag)(V.resource).indexOf(".")===0)return null;const ie=new ee(V.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(ie)}));return(0,y.$Hb)(J).sort((V,ie)=>V.location.path<ie.location.path?-1:1)}async r(Q){let te=await this.s(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.h.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){te=te.filter(V=>!V.metadata?.isApplicationScoped);const J=await this.s(Q.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,Q);te.push(...J)}return te}async s(Q,te,J){const V=await this.g.scanProfileExtensions(Q,J.profileScanOptions);if(!V.length)return[];const ie=await Promise.all(V.map(async ue=>{if(te(ue)){const se=new ee(ue.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(se,ue.metadata)}return null}));return(0,y.$Hb)(ie)}async scanOneOrMultipleExtensions(Q){try{if(await this.j.exists((0,f.$Dg)(Q.location,"package.json"))){const te=await this.scanExtension(Q);return te?[te]:[]}else return await this.scanExtensions(Q)}catch(te){return this.m.error(`Error scanning extensions at ${Q.location.path}:`,(0,D.$0)(te)),[]}}async scanExtension(Q,te){try{let J=await this.scanExtensionManifest(Q.location);if(J){J.publisher||(J.publisher=u.$dm),te=te??J.__metadata,delete J.__metadata;const V=(0,$.$So)(J.publisher,J.name),ie=te?.id?{id:V,uuid:te.id}:{id:V},ue=te?.isSystem?0:Q.type,se=ue===0||!!te?.isBuiltin;J=await this.t(Q.location,J,ee.createNlsConfiguration(Q));const me={type:ue,identifier:ie,manifest:J,location:Q.location,isBuiltin:se,targetPlatform:te?.targetPlatform??"undefined",metadata:te,isValid:!0,validations:[]};return Q.validate?this.validate(me,Q):me}}catch(J){Q.type!==0&&this.m.error(J)}return null}validate(Q,te){let J=!0;const V=(0,n.$4o)(te.productVersion,te.productDate,te.location,Q.manifest,Q.isBuiltin);for(const[ie,ue]of V)ie===c.default.Error&&(J=!1,this.m.error(this.z(te.location,ue)));return Q.isValid=J,Q.validations=V,Q}async scanExtensionManifest(Q){const te=(0,f.$Dg)(Q,"package.json");let J;try{J=(await this.j.readFile(te)).value.toString()}catch(ie){return(0,i.$Ck)(ie)!==1&&this.m.error(this.z(Q,(0,d.localize)(0,null,te.path,ie.message))),null}let V;try{V=JSON.parse(J)}catch{const ue=[];(0,S.$$m)(J,ue);for(const se of ue)this.m.error(this.z(Q,(0,d.localize)(1,null,te.path,se.offset,se.length,(0,p.$Kp)(se.error))));return null}return(0,S.$hn)(V)!=="object"?(this.m.error(this.z(Q,(0,d.localize)(2,null,te.path))),null):V}async t(Q,te,J){const V=await this.u(Q,te,J);if(V)try{const ie=[],ue=await this.w(V.default,ie);if(ie.length>0)return ie.forEach(me=>{this.m.error(this.z(Q,(0,d.localize)(3,null,V.default?.path,(0,p.$Kp)(me.error))))}),te;if((0,S.$hn)(V)!=="object")return this.m.error(this.z(Q,(0,d.localize)(4,null,V.default?.path))),te;const se=V.values||Object.create(null);return(0,R.$Lp)(this.m,te,se,ue)}catch{}return te}async u(Q,te,J){const V=(0,f.$Dg)(Q,"package.nls.json"),ie=(B,W)=>{W.forEach(O=>{this.m.error(this.z(Q,(0,d.localize)(5,null,B?.path,(0,p.$Kp)(O.error))))})},ue=B=>{this.m.error(this.z(Q,(0,d.localize)(6,null,B?.path)))},se=`${te.publisher}.${te.name}`,me=J.translations[se];if(me)try{const B=h.URI.file(me),W=(await this.j.readFile(B)).value.toString(),O=[],j=(0,S.$$m)(W,O);return O.length>0?(ie(B,O),{values:void 0,default:V}):(0,S.$hn)(j)!=="object"?(ue(B),{values:void 0,default:V}):{values:j.contents?j.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let W;try{W=await this.y(Q,J)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const O=(await this.j.readFile(W.localized)).value.toString(),j=[],re=(0,S.$$m)(O,j);return j.length>0?(ie(W.localized,j),{values:void 0,default:W.original}):(0,S.$hn)(re)!=="object"?(ue(W.localized),{values:void 0,default:W.original}):{values:re,default:W.original}}catch{return{values:void 0,default:W.original}}}}async w(Q,te){if(Q)try{const J=(await this.j.readFile(Q)).value.toString();return(0,S.$$m)(J,te)}catch{}}y(Q,te){return new Promise((J,V)=>{const ie=ue=>{const se=(0,f.$Dg)(Q,`package.nls.${ue}.json`);this.j.exists(se).then(me=>{me&&J({localized:se,original:(0,f.$Dg)(Q,"package.nls.json")});const B=ue.lastIndexOf("-");B===-1?J({localized:(0,f.$Dg)(Q,"package.nls.json"),original:null}):(ue=ue.substring(0,B),ie(ue))})};if(te.devMode||te.pseudo||!te.language)return J({localized:(0,f.$Dg)(Q,"package.nls.json"),original:null});ie(te.language)})}z(Q,te){return`[${Q.path}]: ${te}`}};G=Ne([Le(1,C.$Ip),Le(2,k.$Vk),Le(3,i.$lk),Le(4,r.$jj)],G);let ne=class extends G{constructor(Q,te,J,V,ie,ue,se){super(te,V,ie,ue,se),this.G=Q,this.H=J,this.D=this.B(new A.$Zg(3e3)),this.F=this.B(new a.$Sd),this.onDidChangeCache=this.F.event}async scanExtensions(Q){const te=this.M(Q),J=await this.I(te);if(this.C=Q,J&&J.input&&ee.equals(J.input,this.C))return this.m.debug("Using cached extensions scan result",Q.location.toString()),this.D.trigger(()=>this.L()),J.result.map(ie=>(ie.location=h.URI.revive(ie.location),ie));const V=await super.scanExtensions(Q);return await this.J(te,{input:Q,result:V}),V}async I(Q){try{const te=await this.j.readFile(Q),J=JSON.parse(te.value.toString());return{result:J.result,input:(0,b.$yh)(J.input)}}catch(te){this.m.debug("Error while reading the extension cache file:",Q.path,(0,D.$0)(te))}return null}async J(Q,te){try{await this.j.writeFile(Q,P.$ge.fromString(JSON.stringify(te)))}catch(J){this.m.debug("Error while writing the extension cache file:",Q.path,(0,D.$0)(J))}}async L(){if(!this.C)return;const Q=this.M(this.C),te=await this.I(Q);if(!te)return;const J=te.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$mn(V,J))try{this.m.info("Invalidating Cache",J,V),await this.j.del(Q),this.F.fire()}catch(ie){this.m.error(ie)}}M(Q){const te=this.N(Q);return this.h.extUri.joinPath(te.cacheHome,Q.type===0?u.$cm:u.$bm)}N(Q){return Q.type===0?this.H.defaultProfile:Q.profile?this.h.extUri.isEqual(Q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(te=>this.h.extUri.isEqual(Q.location,te.extensionsResource))??this.G:this.H.defaultProfile}};ne=Ne([Le(2,L.$Xk),Le(3,C.$Ip),Le(4,k.$Vk),Le(5,i.$lk),Le(6,r.$jj)],ne);function Z(oe,Q){const te=(0,$.$Qo)(oe.manifest.publisher,oe.manifest.name);return{id:te,identifier:new u.$hm(te),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:Q,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$Pp=Z;class T extends Y{constructor(Q,te,J,V,ie,ue,se,me,B,W,O,j){super(Q,te,(0,f.$Dg)(J,".vscode-oss-dev","extensions","control.json"),V,ie,ue,se,me,B,W,O,j),this.R=(async()=>{if(w.$t)try{const re=await this.w.readFile(h.URI.file(w.$t));return JSON.parse(re.value.toString())}catch{}return Object.create(null)})()}f(Q){return this.R}}e.$Qp=T}),define(we[260],ve([1,0,52,14,40,5,2,12,7,22,13,33]),function(he,e,y,A,s,P,D,S,p,v,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;let w=class extends D.$Sc{constructor(g,c){super(),this.b=g,this.f=c,this.a=new A.$8g(5)}async postUninstall(g){const c=this.g(g,"uninstall");c&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(m)}}));try{await v.Promises.rm(this.m(g))}catch(m){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(m)}}g(g,c){const m=`vscode:${c}`;if(g.location.scheme===S.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[m]=="string"){const h=g.manifest.scripts[m].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${m} should be a node script`),null):{script:(0,p.$jc)(g.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(g,c,m,h,d){return new Promise((l,$)=>{const u=this.j(g,c,m,d);let n;const i=o=>{n&&(clearTimeout(n),n=null),o?$(o):l(void 0)};u.on("error",o=>{i((0,s.$Mi)(o)||"Unknown")}),u.on("exit",(o,r)=>{i(o?`post-${c} process exited with code ${o}`:void 0)}),h&&(n=setTimeout(()=>{n=null,u.kill(),$("timed out")},5e3))})}j(g,c,m,h){const d={silent:!0,execArgv:void 0},l=(0,y.fork)(g,[`--type=extension-post-${c}`,...m],d);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const $=P.Event.fromNodeEventEmitter(l.stdout,"data"),u=P.Event.fromNodeEventEmitter(l.stderr,"data");$(o=>this.f.info(h.identifier.id,h.manifest.version,`post-${c}`,o)),u(o=>this.f.error(h.identifier.id,h.manifest.version,`post-${c}`,o));const n=P.Event.any(P.Event.map($,o=>({data:`%c${o}`,format:[""]})),P.Event.map(u,o=>({data:`%c${o}`,format:["color: red"]})));return P.Event.debounce(n,(o,r)=>o?{data:o.data+r.data,format:[...o.format,...r.format]}:{data:r.data,format:r.format},100)(o=>{console.group(h.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),l}m(g){return(0,p.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$Sp=w,e.$Sp=w=Ne([Le(0,E.$Xk),Le(1,I.$jj)],w)}),define(we[125],ve([1,0,14,15,20,40,11,5,63,2,26,12,7,19,53,8,3,21,22,81,183,83,25,259,30,36,45,58,242,260,213,233,243,82,16,6,13,31,32,34,33]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u,n,i,o,r,t,a,b,C,L,k,R,N,Y,ee,G,ne,Z,T,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=void 0,e.$Wp=(0,ee.$3h)(o.$no);const Q=".vsctmp";let te=class extends i.$Dp{constructor(B,W,O,j,re,X,x,z,q,M,H,_){super(B,W,H,O,M,_),this.fb=re,this.gb=X,this.hb=x,this.ib=q,this.eb=new Map,this.rb=new I.$Bc;const ae=this.B(z.createInstance(C.$Sp));this.bb=this.B(z.createInstance(J,le=>ae.postUninstall(le))),this.cb=this.B(new k.$Up(_,q,H,this,this.F)),this.db=this.B(z.createInstance(b.$Rp));const fe=this.B(new R.$Vp(this,this.fb,_,X,H,q,O));this.B(fe.onDidChangeExtensionsByAnotherSource(le=>this.qb(le))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,r.$Yo)(this.ib,this.F)),this.jb}async zip(B){this.F.trace("ExtensionManagementService#zip",B.identifier.id);const W=await this.pb(B),O=await(0,l.zip)((0,f.$Dg)(this.db.extensionsDownloadDir,(0,h.$mg)()).fsPath,W);return m.URI.file(O)}async unzip(B){return this.F.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:W,cleanup:O}=await this.lb(B),j=w.$kc(W.fsPath);try{return await(0,L.$Tp)(j)}finally{await O()}}getInstalled(B,W=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(B??null,W)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(B){return this.bb.scanUserExtensionAtLocation(B)}async install(B,W={}){this.F.trace("ExtensionManagementService#install",B.toString());const{location:O,cleanup:j}=await this.lb(B);try{const re=await(0,L.$Tp)(w.$kc(O.fsPath)),X=(0,r.$So)(re.publisher,re.name);if(re.engines&&re.engines.vscode&&!(0,N.$6o)(re.engines.vscode,this.G.version,this.G.date))throw new Error($.localize(0,null,X,this.G.version));const z=(await this.I([{manifest:re,extension:O,options:W}])).find(({identifier:q})=>(0,r.$No)(q,{id:X}));if(z?.local)return z.local;throw z?.error?z.error:(0,i.$Fp)(new Error(`Unknown error while installing extension ${X}`))}finally{await j()}}async installFromLocation(B,W){this.F.trace("ExtensionManagementService#installFromLocation",B.toString());const O=await this.bb.scanUserExtensionAtLocation(B);if(!O)throw new Error(`Cannot find a valid extension from the location ${B.toString()}`);return await this.ub([[O,void 0]],W),this.F.info("Successfully installed extension",O.identifier.id,W.toString()),O}async installExtensionsFromProfile(B,W,O){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",B,W.toString(),O.toString());const j=(await this.bb.scanExtensions(1,W)).filter(re=>B.some(X=>(0,r.$No)(X,re.identifier)));if(j.length){const re=await Promise.all(j.map(X=>this.bb.scanMetadata(X,W)));await this.ub(j.map((X,x)=>[X,re[x]]),O),this.F.info("Successfully installed extensions",j.map(X=>X.identifier.id),O.toString())}return j}async updateMetadata(B,W,O=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",B.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),B=await this.bb.updateMetadata(B,W,O),this.cb.invalidate(O),this.w.fire(B),B}async reinstallFromGallery(B){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",B.identifier.id),!this.z.isEnabled())throw new Error($.localize(1,null));const W=await this.getTargetPlatform(),[O]=await this.z.getExtensions([{...B.identifier,preRelease:B.preRelease}],{targetPlatform:W,compatible:!0},s.CancellationToken.None);if(!O)throw new Error($.localize(2,null));await this.bb.setUninstalled(B);try{await this.bb.removeUninstalledExtension(B)}catch(j){throw new Error($.localize(3,null,(0,P.$Mi)(j)))}return this.installFromGallery(O)}ab(B,W,O,j){return this.bb.copyExtension(B,W,O,j)}copyExtensions(B,W){return this.bb.copyExtensions(B,W)}markAsUninstalled(...B){return this.bb.setUninstalled(...B)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(B){this.F.error(B)}}async download(B,W,O){const{location:j}=await this.db.download(B,W,!O);return j}async lb(B){if(B.scheme===E.Schemas.file)return{location:B,async cleanup(){}};this.F.trace("Downloading extension from",B.toString());const W=(0,f.$Dg)(this.db.extensionsDownloadDir,(0,h.$mg)());return await this.hb.download(B,W),this.F.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.ib.del(W)}catch(j){this.F.error(j)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(B,W,O){if(m.URI.isUri(W))return new ue(B,W,O,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const j=r.$Oo.create(W).toString();let re=this.eb.get(j);return re||(this.eb.set(j,re=new ie(B,W,O,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),re.waitUntilTaskIsFinished().finally(()=>this.eb.delete(j))),re}$(B,W){return new se(B,W.profileLocation,this.gb)}async pb(B){const W=async j=>{let re=await d.Promises.readdir(j);re=re.map(z=>w.$jc(j,z));const X=await Promise.all(re.map(z=>d.Promises.stat(z)));let x=Promise.resolve([]);return X.forEach((z,q)=>{const M=re[q];z.isFile()&&(x=x.then(H=>[...H,M])),z.isDirectory()&&(x=x.then(H=>W(M).then(_=>[...H,..._])))}),x};return(await W(B.location.fsPath)).map(j=>({path:`extension/${w.$lc(B.location.fsPath,j)}`,localPath:j}))}async qb({added:B,removed:W}){if(W){const O=B&&this.D.extUri.isEqual(W.profileLocation,B.profileLocation)?W.extensions.filter(j=>B.extensions.every(re=>!(0,r.$No)(re,j))):W.extensions;for(const j of O)this.F.info("Extensions removed from another source",j.id,W.profileLocation.toString()),this.u.fire({identifier:j,profileLocation:W.profileLocation})}if(B){const j=(await this.bb.scanExtensions(1,B.profileLocation)).filter(re=>B.extensions.some(X=>(0,r.$No)(X,re.identifier)));this.s.fire(j.map(re=>(this.F.info("Extensions added from another source",re.identifier.id,B.profileLocation.toString()),{identifier:re.identifier,local:re,profileLocation:B.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(W=>this.rb.add(W)));const B=await this.ib.resolve(this.fb.userExtensionsLocation);for(const W of B.children??[])W.isDirectory&&this.rb.add(W.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(W=>this.tb(W)))}async tb(B){if(!B.affects(this.fb.userExtensionsLocation,1))return;const W=[];for(const O of B.rawAdded){if(this.rb.has(O)||!this.D.extUri.isEqual(this.D.extUri.dirname(O),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(O,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(O).startsWith(".")||!(await this.ib.stat(O)).isDirectory)continue;const j=await this.bb.scanUserExtensionAtLocation(O);j&&j.installedTimestamp===void 0&&(this.rb.add(O),W.push(j))}W.length&&(await this.ub(W.map(O=>[O,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",W.map(O=>O.identifier.id)))}async ub(B,W){const O=B.map(j=>j[0]);await this.vb(O),await this.gb.addExtensionsToProfile(B,W),this.s.fire(O.map(j=>({local:j,identifier:j.identifier,operation:1,profileLocation:W})))}async vb(B){const W=await this.bb.getUninstalledExtensions();for(const O of B){const j=r.$Oo.create(O);W[j.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",j.id),await this.bb.setInstalled(j),this.F.info("Removed the extension from uninstalled list:",j.id))}}};e.$Xp=te,e.$Xp=te=Ne([Le(0,o.$lo),Le(1,Z.$pl),Le(2,G.$jj),Le(3,n.$0h),Le(4,a.$Mp),Le(5,t.$Ip),Le(6,u.$3n),Le(7,ee.$1h),Le(8,Y.$lk),Le(9,ne.$Bj),Le(10,T.$Vk),Le(11,oe.$Xk)],te);let J=class extends v.$Sc{constructor(B,W,O,j,re,X){super(),this.j=B,this.m=W,this.n=O,this.s=j,this.t=re,this.u=X,this.h=this.B(new S.$Sd),this.onExtract=this.h.event,this.c=(0,f.$Dg)(this.n.userExtensionsLocation,".obsolete"),this.g=new y.$9g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(B,W){const O={includeInvalid:!0,profileLocation:W};let j=[];return B===null||B===0?j.push(...await this.n.scanAllExtensions({includeInvalid:!0},O,!1)):B===1&&j.push(...await this.n.scanUserExtensions(O)),j=B!==null?j.filter(re=>re.type===B):j,Promise.all(j.map(re=>this.F(re)))}async scanAllUserExtensions(B){const W=await this.n.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(W.map(O=>this.F(O)))}async scanUserExtensionAtLocation(B){try{const W=await this.n.scanExistingExtension(B,1,{includeInvalid:!0});if(W)return await this.F(W)}catch(W){this.u.error(W)}return null}async extractUserExtension(B,W,O,j,re){const X=B.toString(),x=m.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$mg)()}`)),z=m.URI.file(w.$jc(this.n.userExtensionsLocation.fsPath,X));let q=await this.m.exists(z);if(q&&j){try{await this.y(B.id,z,"removeExisting")}catch{throw new o.$mo($.localize(4,null,z.fsPath,B.id),o.ExtensionManagementErrorCode.Delete)}q=!1}if(!q)try{try{this.u.trace(`Started extracting the extension from ${W} to ${z.fsPath}`),await(0,l.$Bp)(W,x.fsPath,{sourcePath:"extension",overwrite:!0},re),this.u.info(`Extracted extension to ${z}:`,B.id)}catch(M){let H=o.ExtensionManagementErrorCode.Extract;throw M instanceof l.$zp&&(M.type==="CorruptZip"?H=o.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(H=o.ExtensionManagementErrorCode.IncompleteZip)),new o.$mo(M.message,H)}await this.n.updateMetadata(x,O);try{this.u.trace(`Started renaming the extension from ${x.fsPath} to ${z.fsPath}`),await this.C(x.fsPath,z.fsPath),this.u.info("Renamed to",z.fsPath)}catch(M){if(M.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(M)}. Deleted from extracted location`,x),M}this.h.fire(z)}catch(M){try{await this.m.del(x,{recursive:!0})}catch{}throw M}return this.D(z,1)}async scanMetadata(B,W){return W?(await this.w(B,W))?.metadata:this.n.scanMetadata(B.location)}async w(B,W){return(await this.s.scanProfileExtensions(W)).find(j=>(0,r.$No)(j.identifier,B.identifier))}async updateMetadata(B,W,O){return O?await this.s.updateMetadata([[B,W]],O):await this.n.updateMetadata(B.location,W),this.D(B.location,B.type,O)}getUninstalledExtensions(){return this.z()}async setUninstalled(...B){const W=B.map(O=>r.$Oo.create(O));await this.z(O=>W.forEach(j=>{O[j.toString()]=!0,this.u.info("Marked extension as uninstalled",j.toString())}))}async setInstalled(B){await this.z(W=>delete W[B.toString()])}async removeExtension(B,W){if(this.t.extUri.isEqualOrParent(B.location,this.n.userExtensionsLocation))return this.y(B.identifier.id,B.location,W)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.z(W=>delete W[r.$Oo.create(B).toString()])}async copyExtension(B,W,O,j){const re=await this.w(B,W),X=await this.w(B,O);return j={...re?.metadata,...j},X?await this.s.updateMetadata([[B,{...X.metadata,...j}]],O):await this.s.addExtensionsToProfile([[B,j]],O),this.D(B.location,B.type,O)}async copyExtensions(B,W){const O=await this.scanExtensions(1,B),j=await Promise.all(O.filter(re=>!re.isApplicationScoped).map(async re=>[re,await this.scanMetadata(re,B)]));await this.s.addExtensionsToProfile(j,W)}async y(B,W,O){this.u.trace(`Deleting ${O} extension from disk`,B,W.fsPath);const j=this.t.extUri.joinPath(this.t.extUri.dirname(W),`${this.t.extUri.basename(W)}.${(0,p.$Pi)((0,h.$mg)()).toString(16)}${Q}`);await this.C(W.fsPath,j.fsPath),await this.m.del(j,{recursive:!0}),this.u.info(`Deleted ${O} extension from disk`,B,W.fsPath)}async z(B){return this.g.queue(async()=>{let W;try{W=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(j){if((0,Y.$Ck)(j)!==1)throw j}let O={};if(W)try{O=JSON.parse(W)}catch{}return B&&(B(O),Object.keys(O).length?await this.m.writeFile(this.c,A.$ge.fromString(JSON.stringify(O))):await this.m.del(this.c)),O})}async C(B,W){try{await d.Promises.rename(B,W,2*60*1e3)}catch(O){throw new o.$mo(O.message||$.localize(5,null,B,W),O.code||o.ExtensionManagementErrorCode.Rename)}}async D(B,W,O){if(O){const re=(await this.n.scanUserExtensions({profileLocation:O})).find(X=>this.t.extUri.isEqual(X.location,B));if(re)return this.F(re)}else{const j=await this.n.scanExistingExtension(B,W,{includeInvalid:!0});if(j)return this.F(j)}throw new Error($.localize(6,null,B.path))}async F(B){const W=await this.m.resolve(B.location);let O,j;return W.children&&(O=W.children.find(({name:re})=>/^readme(\.txt|\.md|)$/i.test(re))?.resource,j=W.children.find(({name:re})=>/^changelog(\.txt|\.md|)$/i.test(re))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:O,changelogUrl:j,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated,pinned:!!B.metadata?.pinned}}async G(){const B=await this.getUninstalledExtensions();if(Object.keys(B).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(B));const W=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const re of W)B[r.$Oo.create(re).toString()]||O.add(re.identifier.id.toLowerCase());try{const re=(0,r.$To)(W,X=>X.identifier);await y.Promises.settled(re.map(async X=>{const x=X.sort((z,q)=>g.rcompare(z.manifest.version,q.manifest.version))[0];O.has(x.identifier.id.toLowerCase())||await this.j(await this.F(x))}))}catch(re){this.u.error(re)}const j=W.filter(re=>re.metadata&&B[r.$Oo.create(re).toString()]);await Promise.allSettled(j.map(re=>this.removeUninstalledExtension(re)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let B;try{B=await this.m.resolve(this.n.userExtensionsLocation)}catch(W){(0,Y.$Ck)(W)!==1&&this.u.error(W);return}if(B?.children)try{await Promise.allSettled(B.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(Q))){this.u.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.m.del(W.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(O){(0,Y.$Ck)(O)!==1&&this.u.error(O)}}}))}catch{}}};e.$Yp=J,e.$Yp=J=Ne([Le(1,Y.$lk),Le(2,a.$Mp),Le(3,t.$Ip),Le(4,T.$Vk),Le(5,G.$jj)],J);class V extends i.$Gp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,c.$Lf)(this.options.operation)?this.l:this.options.operation}constructor(B,W,O,j,re,X,x,z,q){super(),this.identifier=B,this.source=W,this.options=O,this.m=j,this.n=re,this.o=X,this.p=x,this.q=z,this.s=q,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(B){const[W,O]=await this.x(B);return this.j=W.isBuiltin||W.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[W,O]],this.j),W}async u({zipPath:B,key:W,metadata:O},j,re){let X=await this.v(W);return X||(this.s.trace("Extracting extension...",W.id),X=await this.m.extractUserExtension(W,B,O,j,re),this.s.info("Extracting extension completed.",W.id)),X}async v(B){return await this.w(B)?(this.s.trace("Removing the extension from uninstalled list:",B.id),await this.m.setInstalled(B),this.s.info("Removed the extension from uninstalled list:",B.id),(await this.m.scanAllUserExtensions(!0)).find(j=>r.$Oo.create(j).equals(B))):void 0}async w(B){return!!(await this.m.getUninstalledExtensions())[B.toString()]}}class ie extends V{constructor(B,W,O,j,re,X,x,z,q,M){super(W.identifier,W,O,re,X,x,z,q,M),this.y=W,this.z=j}async x(B){const O=(await this.m.scanExtensions(null,this.options.profileLocation)).find(x=>(0,r.$No)(x.identifier,this.y.identifier));O&&(this.l=3);const j={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??O?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,c.$Kf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.y.version)return[await this.m.updateMetadata(O,j),j];const{location:re,verificationStatus:X}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=X,this.B(re.fsPath),[await this.u({zipPath:re.fsPath,key:r.$Oo.create(this.y),metadata:j},!1,B),j]}catch(x){try{await this.z.delete(re)}catch(z){this.s.warn("Error while deleting the downloaded file",re.toString(),(0,D.$0)(z))}throw x}}async B(B){try{await(0,L.$Tp)(B)}catch(W){throw new o.$mo((0,i.$Ep)(W).message,o.ExtensionManagementErrorCode.Invalid)}}}e.$Zp=ie;class ue extends V{constructor(B,W,O,j,re,X,x,z,q,M){super({id:(0,r.$So)(B.publisher,B.name)},W,O,re,X,x,z,q,M),this.y=B,this.z=W,this.A=j}async h(B){const W=await super.h(B);return this.D(W,B),W}async x(B){const W=new r.$Oo(this.identifier,this.y.version),j=(await this.m.scanExtensions(1,this.options.profileLocation)).find(x=>(0,r.$No)(this.identifier,x.identifier)),re={isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??j?.pinned};if(j)if(this.l=3,W.equals(new r.$Oo(j.identifier,j.manifest.version)))try{await this.m.removeExtension(j,"existing")}catch{throw new Error($.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(j.manifest.version,this.y.version)&&await this.m.setUninstalled(j);else{const x=await this.v(W);if(x)try{await this.m.removeExtension(x,"existing")}catch{throw new Error($.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.$kc(this.z.fsPath),key:W,metadata:re},!0,B),re]}async D(B,W){try{let[O]=await this.A.getExtensions([{id:B.identifier.id,version:B.manifest.version}],W);if(O||([O]=await this.A.getExtensions([{id:B.identifier.id}],W)),O){const j={id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(B,j,this.options.profileLocation)}}catch{}}}class se extends i.$Gp{constructor(B,W,O){super(),this.extension=B,this.j=W,this.k=O}async h(B){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(we[126],ve([1,0,13,33,34,32,45,16,25,3]),function(he,e,y,A,s,P,D,S,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=void 0;let I=class extends D.$Jp{constructor(w,f,g,c,m,h){super(v.URI.file(w.extensionsPath),f,g,c,m,h)}};e.$cO=I,e.$cO=I=Ne([Le(0,p.$0h),Le(1,S.$lk),Le(2,A.$Xk),Le(3,s.$Vk),Le(4,P.$pl),Le(5,y.$jj)],I)}),define(we[261],ve([1,0,14,5,2,41,8,160,6,33]),function(he,e,y,A,s,P,D,S,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hp=e.$gp=e.$fp=void 0,e.$fp="__$__isNewStorageMarker",e.$gp="__$__targetStorageMarker",e.$hp=(0,p.$2h)("storageService");var I;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var E;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var w;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function f(d){const l=d.get(e.$gp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$ip=f;class g extends s.$Sc{constructor(l={flushInterval:g.a}){super(),this.m=l,this.b=this.B(new A.$Vd),this.c=this.B(new A.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new y.$bh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,$,u){return A.Event.filter(this.b.event,n=>n.scope===l&&($===void 0||n.key===$),u)}n(){this.j.value=(0,y.$fh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,$){const{key:u,external:n}=$;if(u===e.$gp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:u,target:this.J(l)[u],external:n})}w(l){this.f.fire({reason:l})}get(l,$,u){return this.P($)?.get(l,u)}getBoolean(l,$,u){return this.P($)?.getBoolean(l,u)}getNumber(l,$,u){return this.P($)?.getNumber(l,u)}getObject(l,$,u){return this.P($)?.getObject(l,u)}storeAll(l,$){this.y(()=>{for(const u of l)this.store(u.key,u.value,u.scope,u.target,$)})}store(l,$,u,n,i=!1){if((0,D.$Nf)($)){this.remove(l,u,i);return}this.y(()=>{this.z(l,u,n),this.P(u)?.set(l,$,i)})}remove(l,$,u=!1){this.y(()=>{this.z(l,$,void 0),this.P($)?.delete(l,u)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,$){const u=[],n=this.J(l);for(const i of Object.keys(n))n[i]===$&&u.push(i);return u}z(l,$,u,n=!1){const i=this.J($);typeof u=="number"?i[l]!==u&&(i[l]=u,this.P($)?.set(e.$gp,JSON.stringify(i),n)):typeof i[l]=="number"&&(delete i[l],this.P($)?.set(e.$gp,JSON.stringify(i),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const $=this.P(l);return $?f($):Object.create(null)}isNew(l){return this.getBoolean(e.$fp,l)===!0}async flush(l=I.NONE){this.f.fire({reason:l});const $=this.P(-1),u=this.P(0),n=this.P(1);switch(l){case I.NONE:await y.Promises.settled([$?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await y.Promises.settled([$?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,$=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return h(l,$,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,$){return this.w(I.NONE),(0,v.$Wk)(l)?this.R(l,$):this.S(l,$)}M(l,$){return!(l.id===$.id||c($)&&c(l))}N(l,$,u){this.y(()=>{const n=new Set;for(const[i,o]of l)n.add(i),$.get(i)!==o&&this.u(u,{key:i,external:!0});for(const[i]of $.items)n.has(i)||this.u(u,{key:i,external:!0})})}}e.$jp=g,g.a=60*1e3;function c(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.$kp=c;class m extends g{constructor(){super(),this.U=this.B(new S.$dp(new S.$ep,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$dp(new S.$ep,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$dp(new S.$ep,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$lp=m;async function h(d,l,$,u,n,i){const o=N=>{try{return JSON.parse(N)}catch{return N}},r=new Map,t=new Map;d.forEach((N,Y)=>{r.set(Y,N),t.set(Y,o(N))});const a=new Map,b=new Map;l.forEach((N,Y)=>{a.set(Y,N),b.set(Y,o(N))});const C=new Map,L=new Map;$.forEach((N,Y)=>{C.set(Y,N),L.set(Y,o(N))}),console.group(u!==n?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const k=[];if(r.forEach((N,Y)=>{k.push({key:Y,value:N})}),console.table(k),console.groupEnd(),console.log(t),u!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const N=[];a.forEach((Y,ee)=>{N.push({key:ee,value:Y})}),console.table(N),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${i})`);const R=[];C.forEach((N,Y)=>{R.push({key:Y,value:N})}),console.table(R),console.groupEnd(),console.log(L)}e.$mp=h}),define(we[127],ve([1,0,18,20,11,4,28,8,3,24,25,30,36,82,16,13,31,44,244,261,32,62]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=void 0;const n=P.$i?"web":(0,E.$ho)(P.$o,D.$ec),i="X-Market-Search-Activity-Id";var o;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function r(...O){return String(O.reduce((j,re)=>j|re,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},b={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},L={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class k{constructor(j=L){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,re=this.d.pageSize){return new k({...this.d,pageNumber:j,pageSize:re})}withFilter(j,...re){const X=[...this.d.criteria,...re.length?re.map(x=>({filterType:j,value:x})):[{filterType:j}]];return new k({...this.d,criteria:X})}withSortBy(j){return new k({...this.d,sortBy:j})}withSortOrder(j){return new k({...this.d,sortOrder:j})}withFlags(...j){return new k({...this.d,flags:j.reduce((re,X)=>re|X,0)})}withAssetTypes(...j){return new k({...this.d,assetTypes:j})}withSource(j){return new k({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:re,pageSize:X,sortBy:x,sortOrder:z,flags:q,assetTypes:M}=this.d;return{filters:[{criteria:j,pageNumber:re,pageSize:X,sortBy:x,sortOrder:z}],assetTypes:M,flags:q}}get searchText(){const j=this.d.criteria.filter(re=>re.filterType===t.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(O,j){const re=(O||[]).filter(X=>X.statisticName===j)[0];return re?re.value:0}function N(O){const j="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(X=>X.assetType.indexOf(j)===0).reduce((X,x)=>{const z=G(O,x.assetType);return z&&X.push([x.assetType.substring(j.length),z]),X},[])}function Y(O){if(O.properties){const j=O.properties.filter(x=>x.key===a.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=j.filter(x=>re.test(x.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return G(O,a.Repository)}function ee(O){return{uri:`${O.fallbackAssetUri}/${a.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${a.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function G(O,j){return O.files.filter(X=>X.assetType===j)[0]?{uri:`${O.assetUri}/${j}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${j}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function ne(O,j){const re=O.properties?O.properties.filter(x=>x.key===j):[],X=re.length>0&&re[0].value;return X?X.split(",").map(x=>(0,w.$Ro)(x)):[]}function Z(O){const j=O.properties?O.properties.filter(re=>re.key===b.Engine):[];return j.length>0&&j[0].value||""}function T(O){const j=O.properties?O.properties.filter(re=>re.key===b.PreRelease):[];return j.length>0&&j[0].value==="true"}function oe(O){const j=O.properties?O.properties.filter(X=>X.key===b.LocalizedLanguages):[],re=j.length>0&&j[0].value||"";return re?re.split(","):[]}function Q(O){return O.properties?.find(j=>j.key===b.SponsorLink)?.value}function te(O){return O.indexOf("preview")!==-1}function J(O){return O.targetPlatform?(0,E.$go)(O.targetPlatform):"undefined"}function V(O){const j=(0,y.$Mb)(O.versions.map(J)),re=!!O.tags?.includes(E.$bo),X=j.indexOf("web");return re?X===-1&&j.push("web"):X!==-1&&j.splice(X,1),j}function ie(O,j){for(let re=0;re<O.length;re++){const X=O[re];if(X.version===O[re-1]?.version){let x=re;if(J(X)===j)for(;x>0&&O[x-1].version===X.version;)x--;x!==re&&(O.splice(re,1),O.splice(x,0,X))}}return O}e.$pp=ie;function ue(O,j,re){O.telemetryData={index:j,querySource:re,queryActivityId:O.queryContext?.[i]}}function se(O,j,re,X){const x=O.versions[0],z={manifest:G(j,a.Manifest),readme:G(j,a.Details),changelog:G(j,a.Changelog),license:G(j,a.License),repository:Y(j),download:ee(j),icon:G(j,a.Icon),signature:G(j,a.Signature),coreTranslations:N(j)};return{identifier:{id:(0,w.$So)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:j.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:Q(x),description:O.shortDescription||"",installCount:R(O.statistics,"install"),rating:R(O.statistics,"averagerating"),ratingCount:R(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:re,assets:z,properties:{dependencies:ne(j,b.Dependency),extensionPack:ne(j,b.ExtensionPack),engine:Z(j),localizedLanguages:oe(j),targetPlatform:J(j),isPreReleaseVersion:T(j)},hasPreReleaseVersion:T(x),hasReleaseVersion:!0,preview:te(O.flags),isSigned:!!z.signature,queryContext:X}}let me=class{constructor(j,re,X,x,z,q,M,H){this.k=re,this.l=X,this.n=x,this.o=z,this.q=q,this.u=M,this.w=H;const _=M.extensionsGallery,ae=_?.servicePPEUrl&&H.getValue("_extensionsGallery.enablePPE");this.d=ae?_.servicePPEUrl:_?.serviceUrl,this.g=ae?void 0:_?.searchUrl,this.h=_?.controlUrl,this.j=(0,d.$op)(M.version,M,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,re,X){const x=A.CancellationToken.isCancellationToken(re)?{}:re,z=A.CancellationToken.isCancellationToken(re)?re:X,q=[],M=[],H=[],_=[];let ae=!0;for(const $e of j){$e.uuid?M.push($e.uuid):q.push($e.id);const ye=!!($e.version||$e.preRelease);H.push({id:$e.id,uuid:$e.uuid,includePreRelease:ye}),$e.version&&_.push({id:$e.id,uuid:$e.uuid,version:$e.version}),ae=ae&&!!$e.hasPreRelease&&!ye}if(!M.length&&!q.length)return[];let fe=new k().withPage(1,j.length);M.length&&(fe=fe.withFilter(t.ExtensionId,...M)),q.length&&(fe=fe.withFilter(t.ExtensionName,...q)),(x.queryAllVersions||ae)&&(fe=fe.withFlags(fe.flags,o.IncludeVersions)),x.source&&(fe=fe.withSource(x.source));const{extensions:le}=await this.z(fe,{targetPlatform:x.targetPlatform??n,includePreRelease:H,versions:_,compatible:!!x.compatible},z);return x.source&&le.forEach(($e,ye)=>ue($e,ye,x.source)),le}async getCompatibleExtension(j,re,X){if((0,E.$io)(j.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(j,re,X))return j;const x=new k().withFlags(o.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,j.identifier.uuid),{extensions:z}=await this.z(x,{targetPlatform:X,compatible:!0,includePreRelease:re},A.CancellationToken.None);return z[0]||null}async isExtensionCompatible(j,re,X){if(!(0,E.$jo)(j.properties.targetPlatform,j.allTargetPlatforms,X)||!re&&j.properties.isPreReleaseVersion)return!1;let x=j.properties.engine;if(!x){const z=await this.getManifest(j,A.CancellationToken.None);if(!z)throw new Error("Manifest was not found");x=z.engines.vscode}return(0,f.$6o)(x,this.u.version,this.u.date)}async y(j,re,X,x,z){if(!(0,E.$jo)(J(j),x,z)||re!=="any"&&T(j)!==(re==="prerelease"))return!1;if(X)try{const q=await this.E(j);if(!(0,f.$6o)(q,this.u.version,this.u.date))return!1}catch(q){return this.l.error(`Error while getting the engine for the version ${j.version}.`,(0,s.$0)(q)),!1}return!0}async query(j,re){let X=j.text||"";const x=j.pageSize??50;let z=new k().withPage(1,x);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,fe,le)=>(z=z.withFilter(t.Category,le||fe),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,fe,le)=>(z=z.withFilter(t.Tag,le||fe),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(t.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),z=z.withFilter(t.SearchText,X)),z=z.withSortBy(0)):j.ids?z=z.withFilter(t.ExtensionId,...j.ids):j.names?z=z.withFilter(t.ExtensionName,...j.names):z=z.withSortBy(4),typeof j.sortBy=="number"&&(z=z.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(z=z.withSortOrder(j.sortOrder)),j.source&&(z=z.withSource(j.source));const q=async(ae,fe)=>{const{extensions:le,total:$e}=await this.z(ae,{targetPlatform:n,compatible:!1,includePreRelease:!!j.includePreRelease},fe);return le.forEach((ye,Ae)=>ue(ye,(ae.pageNumber-1)*ae.pageSize+Ae,j.source)),{extensions:le,total:$e}},{extensions:M,total:H}=await q(z,re),_=async(ae,fe)=>{if(fe.isCancellationRequested)throw new s.$5;const{extensions:le}=await q(z.withPage(ae+1),fe);return le};return{firstPage:M,total:H,pageSize:z.pageSize,getPage:_}}async z(j,re,X){const x=j.flags;j.flags&o.IncludeLatestVersionOnly&&j.flags&o.IncludeVersions&&(j=j.withFlags(j.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(j.flags&o.IncludeLatestVersionOnly)&&!(j.flags&o.IncludeVersions)&&(j=j.withFlags(j.flags,o.IncludeLatestVersionOnly)),re.versions?.length&&(j=j.withFlags(j.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),j=j.withFlags(j.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:z,total:q,context:M}=await this.B(j,X);if(!(j.flags&o.IncludeLatestVersionOnly)){const fe=[];for(const le of z){const $e=await this.A(le,re,M);$e&&fe.push($e)}return{extensions:fe,total:q}}const _=[],ae=new Map;for(let fe=0;fe<z.length;fe++){const le=z[fe],$e={id:(0,w.$So)(le.publisher.publisherName,le.extensionName),uuid:le.extensionId},ye=(0,S.$Kf)(re.includePreRelease)?re.includePreRelease:!!re.includePreRelease.find(Re=>(0,w.$No)(Re,$e))?.includePreRelease;if(re.compatible&&(0,E.$io)(V(le),re.targetPlatform))continue;const Ae=await this.A(le,re,M);!Ae||Ae.properties.isPreReleaseVersion&&(!ye||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==re.targetPlatform&&Ae.hasPreReleaseVersion?ae.set(le.extensionId,fe):_.push([fe,Ae])}if(ae.size){const fe=new u.$Od,le=new k().withFlags(x&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,ae.size).withFilter(t.ExtensionId,...ae.keys()),{extensions:$e}=await this.z(le,re,X);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ae.size});for(const ye of $e){const Ae=ae.get(ye.identifier.uuid);_.push([Ae,ye])}}return{extensions:_.sort((fe,le)=>fe[0]-le[0]).map(([,fe])=>fe),total:q}}async A(j,re,X){const x={id:(0,w.$So)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},z=re.versions?.find(_=>(0,w.$No)(_,x))?.version,q=(0,S.$Kf)(re.includePreRelease)?re.includePreRelease:!!re.includePreRelease.find(_=>(0,w.$No)(_,x))?.includePreRelease,M=V(j),H=ie(j.versions,re.targetPlatform);if(re.compatible&&(0,E.$io)(M,re.targetPlatform))return null;for(let _=0;_<H.length;_++){const ae=H[_];if(!(z&&ae.version!==z)){if(await this.y(ae,q?"any":"release",re.compatible,M,re.targetPlatform))return se(j,ae,M,X);if(z&&ae.version===z)return null}}return z||re.compatible?null:se(j,j.versions[0],M)}async B(j,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,o.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(o.Unpublished));const X=await this.j,x=JSON.stringify(j.raw),z={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},q=new u.$Od;let M,H,_=0;try{if(M=await this.k.request({type:"POST",url:this.g&&j.criteria.some(fe=>fe.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:x,headers:z},re),M.res.statusCode&&M.res.statusCode>=400&&M.res.statusCode<500)return{galleryExtensions:[],total:_};const ae=await(0,h.$ap)(M);if(ae){const fe=ae.results[0],le=fe.extensions,$e=fe.resultMetadata&&fe.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return _=$e&&$e.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:le,total:_,context:{[i]:M.res.headers.activityid}}}return{galleryExtensions:[],total:_}}catch(ae){throw H=ae,ae}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(x.length),duration:q.elapsed(),success:!!M&&(0,h.$9o)(M),responseBodySize:M?.res.headers["Content-Length"],statusCode:M?String(M.res.statusCode):void 0,errorCode:H?(0,s.$4)(H)?"canceled":(0,s.$0)(H).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(_)})}}async reportStatistic(j,re,X,x){if(!this.isEnabled())return;const z=P.$i?this.x(`/itemName/${j}.${re}/version/${X}/statType/${x==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${re}/${X}/stats?statType=${x}`),q=P.$i?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",H={...await this.j,Accept:q};try{await this.k.request({type:"POST",url:z,headers:H},A.CancellationToken.None)}catch{}}async download(j,re,X){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const x=(0,w.$Vo)(j),z=new Date().getTime(),q=fe=>this.o.publicLog("galleryService:downloadVSIX",{...x,duration:fe}),M=X===2?"install":X===3?"update":"",H=M?{uri:`${j.assets.download.uri}${p.URI.parse(j.assets.download.uri).query?"&":"?"}${M}=true`,fallbackUri:`${j.assets.download.fallbackUri}${p.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${M}=true`}:j.assets.download,_=j.queryContext?.[i]?{[i]:j.queryContext[i]}:void 0,ae=await this.D(H,_?{headers:_}:void 0);await this.q.writeFile(re,ae.stream),q(new Date().getTime()-z)}async downloadSignatureArchive(j,re){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const X=await this.D(j.assets.signature);await this.q.writeFile(re,X.stream)}async getReadme(j,re){if(j.assets.readme){const X=await this.D(j.assets.readme,{},re);return await(0,h.$_o)(X)||""}return""}async getManifest(j,re){if(j.assets.manifest){const X=await this.D(j.assets.manifest,{},re),x=await(0,h.$_o)(X);return x?JSON.parse(x):null}return null}async C(j,re){const X=G(j,a.Manifest);if(!X)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},z=await this.D(X,{headers:x});return await(0,h.$ap)(z)}async getCoreTranslation(j,re){const X=j.assets.coreTranslations.filter(x=>x[0]===re.toUpperCase())[0];if(X){const x=await this.D(X[1]),z=await(0,h.$_o)(x);return z?JSON.parse(z):null}return null}async getChangelog(j,re){if(j.assets.changelog){const X=await this.D(j.assets.changelog,{},re);return await(0,h.$_o)(X)||""}return""}async getAllCompatibleVersions(j,re,X){let x=new k().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?x=x.withFilter(t.ExtensionId,j.identifier.uuid):x=x.withFilter(t.ExtensionName,j.identifier.id);const{galleryExtensions:z}=await this.B(x,A.CancellationToken.None);if(!z.length)return[];const q=V(z[0]);if((0,E.$io)(q,X))return[];const M=[];await Promise.all(z[0].versions.map(async ae=>{try{await this.y(ae,re?"any":"release",!0,q,X)&&M.push(ae)}catch{}}));const H=[],_=new Set;for(const ae of ie(M,X))_.has(ae.version)||(_.add(ae.version),H.push({version:ae.version,date:ae.lastUpdated,isPreReleaseVersion:T(ae)}));return H}async D(j,re={},X=A.CancellationToken.None){const x=await this.j,z={type:"GET"},q={...x,...re.headers||{}};re={...re,...z,headers:q};const M=j.uri,H=j.fallbackUri,_={...re,url:M};try{const ae=await this.k.request(_,X);if(ae.res.statusCode===200)return ae;const fe=await(0,h.$_o)(ae);throw new Error(`Expected 200, got back ${ae.res.statusCode} instead.

${fe}`)}catch(ae){if((0,s.$4)(ae))throw ae;const fe=(0,s.$0)(ae);this.o.publicLog2("galleryService:cdnFallback",{url:M,message:fe});const le={...re,url:H};return this.k.request(le,X)}}async E(j){let re=Z(j);if(!re){const X=await this.C(j,A.CancellationToken.None);if(!X)throw new Error("Manifest was not found");re=X.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,h.$ap)(j),X=[],x={},z=[];if(re){for(const q of re.malicious)X.push({id:q});if(re.migrateToPreRelease)for(const[q,M]of Object.entries(re.migrateToPreRelease))(!M.engine||(0,f.$6o)(M.engine,this.u.version,this.u.date))&&(x[q.toLowerCase()]={disallowInstall:!0,extension:{id:M.id,displayName:M.displayName,autoMigrate:{storage:!!M.migrateStorage},preRelease:!0}});if(re.deprecated)for(const[q,M]of Object.entries(re.deprecated))M&&(x[q.toLowerCase()]=(0,S.$Kf)(M)?{}:M);if(re.search)for(const q of re.search)z.push(q)}return{malicious:X,deprecated:x,search:z}}};me=Ne([Le(1,h.$7o),Le(2,c.$jj),Le(3,I.$9h),Le(4,$.$pl),Le(5,g.$lk),Le(6,m.$Bj),Le(7,v.$vi)],me);let B=class extends me{constructor(j,re,X,x,z,q,M,H){super(j,re,X,x,z,q,M,H)}};e.$qp=B,e.$qp=B=Ne([Le(0,l.$hp),Le(1,h.$7o),Le(2,c.$jj),Le(3,I.$9h),Le(4,$.$pl),Le(5,g.$lk),Le(6,m.$Bj),Le(7,v.$vi)],B);let W=class extends me{constructor(j,re,X,x,z,q,M){super(void 0,j,re,X,x,z,q,M)}};e.$rp=W,e.$rp=W=Ne([Le(0,h.$7o),Le(1,c.$jj),Le(2,I.$9h),Le(3,$.$pl),Le(4,g.$lk),Le(5,m.$Bj),Le(6,v.$vi)],W)}),define(we[262],ve([1,0,5,2,33,51]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kO=e.$jO=void 0;class D{constructor(v,I){this.a=v,this.b=I}listen(v,I){const E=this.b(v);switch(I){case"onDidChangeProfiles":return y.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(f=>(0,P.$2m)({...f},E)),added:w.added.map(f=>(0,P.$2m)({...f},E)),removed:w.removed.map(f=>(0,P.$2m)({...f},E)),updated:w.updated.map(f=>(0,P.$2m)({...f},E))}))}throw new Error(`Invalid listen ${I}`)}async call(v,I,E){const w=this.b(v);switch(I){case"createProfile":{const f=await this.a.createProfile(E[0],E[1],E[2]);return(0,P.$2m)({...f},w)}case"updateProfile":{let f=(0,s.$Yk)((0,P.$3m)(E[0],w),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,E[1]),(0,P.$2m)({...f},w)}case"removeProfile":{const f=(0,s.$Yk)((0,P.$3m)(E[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${I}`)}}e.$jO=D;class S extends A.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(v,I,E){super(),this.profilesHome=I,this.f=E,this.a=[],this.b=this.B(new y.$Sd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=v.map(w=>(0,s.$Yk)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const f=w.added.map(m=>(0,s.$Yk)(m,this.profilesHome.scheme)),g=w.removed.map(m=>(0,s.$Yk)(m,this.profilesHome.scheme)),c=w.updated.map(m=>(0,s.$Yk)(m,this.profilesHome.scheme));this.a=w.all.map(m=>(0,s.$Yk)(m,this.profilesHome.scheme)),this.b.fire({added:f,removed:g,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(v){this.c=v}isEnabled(){return this.c}async createNamedProfile(v,I,E){const w=await this.f.call("createNamedProfile",[v,I,E]);return(0,s.$Yk)(w,this.profilesHome.scheme)}async createProfile(v,I,E,w){const f=await this.f.call("createProfile",[v,I,E,w]);return(0,s.$Yk)(f,this.profilesHome.scheme)}async createTransientProfile(v){const I=await this.f.call("createTransientProfile",[v]);return(0,s.$Yk)(I,this.profilesHome.scheme)}async setProfileForWorkspace(v,I){await this.f.call("setProfileForWorkspace",[v,I])}removeProfile(v){return this.f.call("removeProfile",[v])}async updateProfile(v,I){const E=await this.f.call("updateProfile",[v,I]);return(0,s.$Yk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$kO=S}),define(we[128],ve([1,0,3,25,16,13,237,34,33,8,238]),function(he,e,y,A,s,P,D,S,p,v,I){"use strict";var E,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.$aO=e.$_N=void 0;let f=E=class extends p.$1k{constructor(h,d,l,$,u){super(l,$,d,u),this.U=h,this.W=l}O(){return this.U.getItem(E.b,[]).map(d=>({...d,location:(0,v.$Ef)(d.location)?this.w.extUri.joinPath(this.profilesHome,d.location):y.URI.revive(d.location)}))}Q(){const h=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(y.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$_N=f,f.a="profileAssociationsMigration",e.$_N=f=E=Ne([Le(0,D.$7N),Le(1,S.$Vk),Le(2,A.$0h),Le(3,s.$lk),Le(4,P.$jj)],f);let g=w=class extends f{constructor(h,d,l,$,u){super(h,d,l,$,u),this.$=h}P(h){h.length?this.$.setItem(w.b,h.map(d=>({...d,location:this.w.extUri.basename(d.location)}))):this.$.removeItem(w.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(w.c,h):this.$.removeItem(w.c)}Q(){const h="workspaceAndProfileInfo",d=this.$.getItem(h,void 0);if(d){this.$.removeItem(h);const $=d.reduce((u,{workspace:n,profile:i})=>(u[y.URI.revive(n).toString()]=y.URI.revive(i).toString(),u),{});this.$.setItem(w.c,{workspaces:$})}const l=super.Q();return this.$.getItem(w.a,!1)||(this.R(l),this.$.setItem(w.a,!0)),l}};e.$aO=g,e.$aO=g=w=Ne([Le(0,D.$8N),Le(1,S.$Vk),Le(2,A.$0h),Le(3,s.$lk),Le(4,P.$jj)],g);let c=class extends g{constructor(h,d,l,$){super(new I.$$N(0,d,$,l),h,d,l,$)}async init(){return await this.$.init(),super.init()}};e.$bO=c,e.$bO=c=Ne([Le(0,S.$Vk),Le(1,A.$0h),Le(2,s.$lk),Le(3,P.$jj)],c)}),define(we[129],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=void 0,e.$Jm=(0,y.$2h)("extensionHostStatusService");class A{constructor(){this.a=new Map}setExitInfo(P,D){this.a.set(P,D)}getExitInfo(P){return this.a.get(P)||null}}e.$Km=A}),define(we[263],ve([1,0,5,14]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0;function s(D){let S=0,p=0,v=0;D>=1e3&&(v=Math.floor(D/1e3),D-=v*1e3),v>=60&&(p=Math.floor(v/60),v-=p*60),p>=60&&(S=Math.floor(p/60),p-=S*60);const I=S?`${S}h`:"",E=p?`${p}m`:"",w=v?`${v}s`:"",f=D?`${D}ms`:"";return`${I}${E}${w}${f}`}class P{constructor(S,p,v,I){this.i=S,this.j=p,this.a=new y.$Sd,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=v,this.protocol=I,this.e=!1,this.f=new A.$ch(()=>{this.k(`The reconnection grace time of ${s(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new A.$ch(()=>{this.k(`The reconnection short grace time of ${s(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${s(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(S){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${S}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${s(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const S=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),S.end(),this.a.fire(void 0)}acceptReconnection(S,p,v){this.d=S,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(p,v),this.protocol.endAcceptReconnection()}}e.$Sm=P}),define(we[93],ve([1,0,29,12,7,155,55]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.InternalNLSConfiguration=e.$Al=void 0;const S=s.$jc(A.$kg.asFileUri("").fsPath,"nls.metadata.json"),p=new Map;function v(g){return new Promise(c=>y.exists(g,c))}function I(g,c){return v(S).then(m=>{if(!m||!D.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const h=`${g}||${c}`;let d=p.get(h);return d||(d=P.getNLSConfiguration(D.default.commit,c,S,g,g).then(l=>(E.is(l)&&(l._languagePackSupport=!0),l.locale!=="en"&&l.locale!=="en-us"&&Object.keys(l.availableLanguages).length===0&&p.delete(h),l)),p.set(h,d)),d})}e.$Al=I;var E;(function(g){function c(m){const h=m;return h&&typeof h._languagePackId=="string"}g.is=c})(E||(e.InternalNLSConfiguration=E={}));const w=async g=>{try{const c=f(await y.promises.readFile(g,"utf8"));return JSON.parse(c).locale}catch(c){return c.code!=="ENOENT"&&console.warn(c),"en"}};e.$Bl=w;const f=g=>{const c=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return g.replace(c,(m,h,d,l,$)=>{if(l)return"";if($){const u=$.length;return u>2&&$[u-1]===`
`?$[u-2]==="\r"?`\r
`:`
`:""}else return m})}}),define(we[130],ve([1,0,19,3,25,45,58,16,6,13,31,34,33,93]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=void 0;let g=class extends D.$Np{constructor(m,h,d,l,$,u,n,i){super(A.URI.file($.builtinExtensionsPath),A.URI.file($.extensionsPath),(0,y.$Dg)($.userHome,".vscode-oss-dev","extensions","control.json"),m.defaultProfile,m,h,d,l,$,u,n,i),this.R=$}async f(m){const h=await(0,f.$Al)(m,this.R.userDataPath);if(f.InternalNLSConfiguration.is(h))try{const d=await this.w.readFile(A.URI.file(h._translationsConfigFile));return JSON.parse(d.value.toString())}catch{}return Object.create(null)}};e.$1N=g,e.$1N=g=Ne([Le(0,w.$Xk),Le(1,P.$Ip),Le(2,S.$lk),Le(3,v.$jj),Le(4,s.$0h),Le(5,I.$Bj),Le(6,E.$Vk),Le(7,p.$1h)],g)}),define(we[264],ve([1,0,265,29,7,21,12,22]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.ServerConnectionTokenType=void 0;const p=/^[0-9A-Za-z_-]+$/;var v;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(v||(e.ServerConnectionTokenType=v={}));class I{constructor(){this.type=0}validate(h){return!0}}e.$Tm=I;class E{constructor(h){this.value=h,this.type=2}validate(h){return h===this.value}}e.$Um=E;class w{constructor(h){this.message=h}}e.$Vm=w;async function f(m,h){const d=m["without-connection-token"],l=m["connection-token"],$=m["connection-token-file"];if(d)return typeof l<"u"||typeof $<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new I;if(typeof $<"u"){if(typeof l<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let u;try{u=A.readFileSync($).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${$}'.`)}return p.test(u)?new E(u):new w(`The connection token defined in '${$} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof l<"u"?p.test(l)?new E(l):new w(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):new E(await h())}e.$Wm=f;async function g(m){return f(m,async()=>{if(!m["user-data-dir"])return(0,P.$mg)();const d=s.$jc(m["user-data-dir"],"token");try{const u=(await S.Promises.readFile(d)).toString().replace(/\r?\n$/,"");if(p.test(u))return u}catch{}const l=(0,P.$mg)();try{await S.Promises.writeFile(d,l,{mode:384})}catch{}return l})}e.$Xm=g;function c(m,h,d){if(m.validate(d.query[D.$dg]))return!0;const l=y.parse(h.headers.cookie||"");return m.validate(l[D.$cg])}e.$Ym=c}),define(we[46],ve([1,0,200,109,66,6,25,74]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=void 0,e.$Am={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},"disable-file-uploads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":s.$Tl["user-data-dir"],"enable-smoke-test-driver":s.$Tl["enable-smoke-test-driver"],"disable-telemetry":s.$Tl["disable-telemetry"],"disable-workspace-trust":s.$Tl["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:s.$Tl.log,logsPath:s.$Tl.logsPath,"force-disable-user-env":s.$Tl["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":s.$Tl["extensions-dir"],"extensions-download-dir":s.$Tl["extensions-download-dir"],"builtin-extensions-dir":s.$Tl["builtin-extensions-dir"],"install-extension":s.$Tl["install-extension"],"install-builtin-extension":s.$Tl["install-builtin-extension"],"uninstall-extension":s.$Tl["uninstall-extension"],"list-extensions":s.$Tl["list-extensions"],"locate-extension":s.$Tl["locate-extension"],"show-versions":s.$Tl["show-versions"],category:s.$Tl.category,force:s.$Tl.force,"do-not-sync":s.$Tl["do-not-sync"],"pre-release":s.$Tl["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:s.$Tl.help,version:s.$Tl.version,"locate-shell-integration-path":s.$Tl["locate-shell-integration-path"],compatibility:{type:"string"},_:s.$Tl._},e.$Bm=(0,P.$3h)(D.$9h);class p extends A.$xm{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$Cm=p,Ne([S.$th],p.prototype,"userRoamingDataHome",null)}),define(we[266],ve([1,0,303,249,267,27]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;class D extends y.AppInsightsCore{constructor(p){super(),this.a=p}track(p){const v=p.baseData||{};v.properties||(v.properties={}),v.measurements||(v.measurements={});try{const I=P.cpus();v.measurements.cores=I.length,v.properties["common.cpuModel"]=I[0].model}catch{}try{v.measurements.memoryFree=P.freemem(),v.measurements.memoryTotal=P.totalmem()}catch{}try{v.properties["common.shell"]=P.userInfo().shell,v.properties["common.release"]=P.release(),v.properties["common.arch"]=P.arch()}catch{}try{const I=(/^http:/.test(this.a)?s:A).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});I.on("error",()=>{}),I.write(JSON.stringify(v)),I.end()}catch{}}}e.$2N=D}),define(we[268],ve([1,0,29,22,78,87,265,89,39,60,4,13,46,7,12,21,31,44,20,3,15,8,93,57]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.CacheControl=e.$oO=void 0;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function r(Y,ee,G,ne){ee.writeHead(G,{"Content-Type":"text/plain"}),ee.end(ne)}e.$oO=r;var t;(function(Y){Y[Y.NO_CACHING=0]="NO_CACHING",Y[Y.ETAG=1]="ETAG",Y[Y.NO_EXPIRY=2]="NO_EXPIRY"})(t||(e.CacheControl=t={}));async function a(Y,ee,G,ne,Z,T){try{const oe=await A.Promises.stat(Y);if(ee===1){const Q=`W/"${[oe.ino,oe.size,oe.mtime.getTime()].join("-")}"`;if(ne.headers["if-none-match"]===Q)return Z.writeHead(304),void Z.end();T.Etag=Q}else ee===2?T["Cache-Control"]="public, max-age=31536000":ee===0&&(T["Cache-Control"]="no-store");T["Content-Type"]=o[(0,f.$oc)(Y)]||(0,v.$6r)(Y)||"text/plain",Z.writeHead(200,T),(0,y.createReadStream)(Y).pipe(Z)}catch(oe){return oe.code!=="ENOENT"?(G.error(oe),console.error(oe.toString())):console.error(`File not found: ${Y}`),Z.writeHead(404,{"Content-Type":"text/plain"}),void Z.end("Not found")}}e.$pO=a;const b=(0,f.$mc)(g.$kg.asFileUri("").fsPath);let C=class{constructor(ee,G,ne,Z,T){this.f=ee,this.g=G,this.h=ne,this.i=Z,this.j=T,this.a=this.j.extensionsGallery?.resourceUrlTemplate?l.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const oe=(0,i.$0k)(T);this.b=`${oe}/static`,this.c=`${oe}/callback`,this.d="/web-extension-resource"}async handle(ee,G,ne){try{const Z=ne.pathname;return Z.startsWith(this.b)&&Z.charCodeAt(this.b.length)===47?this.k(ee,G,ne):Z==="/"?this.n(ee,G,ne):Z===this.c?this.p(G):Z.startsWith(this.d)&&Z.charCodeAt(this.d.length)===47?this.m(ee,G,ne):r(ee,G,404,"Not found.")}catch(Z){return this.h.error(Z),console.error(Z.toString()),r(ee,G,500,"Internal Server Error.")}}async k(ee,G,ne){const Z=Object.create(null),oe=decodeURIComponent(ne.pathname).substring(this.b.length+1),Q=(0,f.$jc)(b,oe);return(0,p.$4f)(Q,b,!I.$e)?a(Q,this.g.isBuilt?2:1,this.h,ee,G,Z):r(ee,G,400,"Bad request.")}l(ee){const G=ee.authority.indexOf(".");return G!==-1?ee.authority.substring(G+1):void 0}async m(ee,G,ne){if(!this.a)return r(ee,G,500,"No extension gallery service configured.");const Z=decodeURIComponent(ne.pathname),T=(0,f.$hc)(Z.substring(this.d.length+1)),oe=l.URI.parse(T).with({scheme:this.a.scheme,authority:T.substring(0,T.indexOf("/")),path:T.substring(T.indexOf("/")+1)});if(this.l(this.a)!==this.l(oe))return r(ee,G,403,"Request Forbidden");const Q={},te=me=>{const B=ee.headers[me];B&&((0,u.$Ef)(B)||B[0])?Q[me]=(0,u.$Ef)(B)?B:B[0]:me!==me.toLowerCase()&&te(me.toLowerCase())};te("X-Client-Name"),te("X-Client-Version"),te("X-Machine-Id"),te("X-Client-Commit");const J=await this.i.request({type:"GET",url:oe.toString(!0),headers:Q},d.CancellationToken.None),V=J.res.statusCode||500;if(V!==200){let me=null;try{me=await(0,h.$_o)(J)}catch{}return r(ee,G,V,me||`Request failed with status ${V}`)}const ie=Object.create(null),ue=me=>{const B=J.res.headers[me];B?ie[me]=B:me!==me.toLowerCase()&&ue(me.toLowerCase())};ue("Cache-Control"),ue("Content-Type"),G.writeHead(200,ie);const se=await(0,$.$se)(J.stream);return void G.end(se.buffer)}async n(ee,G,ne){const Z=ne.query[g.$dg];if(typeof Z=="string"){const M=Object.create(null);M["Set-Cookie"]=D.serialize(g.$cg,Z,{sameSite:"lax",maxAge:60*60*24*7});const H=Object.create(null);for(const ae in ne.query)ae!==g.$dg&&(H[ae]=ne.query[ae]);const _=P.format({pathname:"/",query:H});return M.Location=_,G.writeHead(302,M),void G.end()}const T=!this.g.isBuilt&&this.g.args["use-test-resolver"],oe=T?"test+test":"remote";if(!oe)return r(ee,G,400,"Bad request.");function Q(M){return JSON.stringify(M).replace(/"/g,"&quot;")}let te;this.g.args["enable-smoke-test-driver"]&&(te=!1);const J=M=>M&&l.URI.file(s.resolve(M)).with({scheme:g.Schemas.vscodeRemote,authority:oe}),V=g.$kg.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,ie=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,c.$mg)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,ue=(0,e.$sO)((0,e.$uO)(ee)),se=(0,e.$tO)((0,e.$uO)(ee)),me={codeServerVersion:this.j.codeServerVersion,rootEndpoint:ue,updateEndpoint:this.g.args["disable-update-check"]?void 0:ue+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?ue+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??ue+"/proxy/{{port}}/",serviceWorker:{scope:se+"/",path:ue+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery};if(!this.g.isBuilt)try{const M=JSON.parse((await A.Promises.readFile((0,f.$jc)(b,"product.overrides.json"))).toString());Object.assign(me,M)}catch{}const B={remoteAuthority:oe,webviewEndpoint:se+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledFileUploads:!this.g.args["disable-file-uploads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:te,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:J(this.g.args["default-folder"]),workspaceUri:J(this.g.args["default-workspace"]),productConfiguration:me,callbackRoute:this.c},W=this.g.args.locale||await(0,n.$Bl)(this.g.argvResource.fsPath),O=await(0,n.$Al)(W,this.g.userDataPath),j=this.j.extensionsGallery?.nlsBaseUrl,re={WORKBENCH_WEB_CONFIGURATION:Q(B),WORKBENCH_AUTH_SESSION:ie?Q(ie):"",WORKBENCH_WEB_BASE_URL:se+this.b,WORKBENCH_NLS_BASE_URL:se+(j?`${j}${j.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:ue,VS_BASE:se,NLS_CONFIGURATION:Q(O)};if(T){const M=[];for(const H of["vscode-test-resolver","github-authentication"]){const _=JSON.parse((await A.Promises.readFile(g.$kg.asFileUri(`${g.$fg}/${H}/package.json`).fsPath)).toString());M.push({extensionPath:H,packageJSON:_})}re.WORKBENCH_BUILTIN_EXTENSIONS=Q(M)}let X;try{X=(await A.Promises.readFile(V)).toString().replace(/\{\{([^}]+)\}\}/g,(H,_)=>re[_]??"undefined")}catch{return G.writeHead(404,{"Content-Type":"text/plain"}),void G.end("Not found")}const x="sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=",q={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(X).join(" ")} '${x}' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(q["Set-Cookie"]=D.serialize(g.$cg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),G.writeHead(200,q),void G.end(X)}o(ee){const G=/<script>([\s\S]+?)<\/script>/img,ne=[];let Z;for(;Z=G.exec(ee);){const T=S.createHash("sha256"),oe=Z[1].replace(/\r\n/g,`
`),Q=T.update(Buffer.from(oe)).digest().toString("base64");ne.push(`'sha256-${Q}'`)}return ne}async p(ee){const G=g.$kg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,ne=(await A.Promises.readFile(G)).toString(),Z=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(ne).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return ee.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":Z}),void ee.end(ne)}};e.$qO=C,e.$qO=C=Ne([Le(1,w.$Bm),Le(2,E.$jj),Le(3,h.$7o),Le(4,m.$Bj)],C);const L=(Y,ee=!1)=>Y.replace(/\/\/+/g,"/").replace(/\/+$/,ee?"/":"");e.$rO=L;const k=Y=>{const ee=(Y.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$rO)("./"+(ee>1?"../".repeat(ee-1):""))};e.$sO=k;const R=Y=>{const ee=Y.split("?",1)[0].split("/");return(0,e.$rO)("./"+ee[ee.length-1])};e.$tO=R;const N=Y=>Y.originalUrl||Y.url;e.$uO=N}),define(we[269],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0,e.$8M=(0,y.$2h)("IExtHostInitDataService")}),define(we[270],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0,e.$RM=(0,y.$2h)("IExtHostRpcService");class A{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$SM=A}),define(we[71],ve([1,0,51]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;function A(P){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:P,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function s(P){return new y.$Zm(A(P))}e.$Or=s}),define(we[271],ve([1,0,4,41,3,71,51,105,241,7,19]),function(he,e,y,A,s,P,D,S,p,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=void 0;class E{constructor(f,g,c,m){this.b=f,this.c=g,this.d=c,this.e=m}async call(f,g,c){switch(g){case"getEnvironmentData":{const m=c,h=(0,P.$Or)(m.remoteAuthority);let d=await this.f(m.profile);return d=(0,D.$2m)(d,h),d}case"getExtensionHostExitInfo":{const m=c;return this.e.getExitInfo(m.reconnectionToken)}case"getDiagnosticInfo":{const m=c,h={machineInfo:(0,p.$Sr)()},d=m.includeProcesses?(0,S.$Qr)(process.pid):Promise.resolve();let l=[];const $={};if(m.folders){const u=(0,P.$Or)("");l=m.folders.map(i=>s.URI.revive(u.transformIncoming(i))).filter(i=>i.scheme==="file").map(i=>(0,p.$Rr)(i.fsPath,["node_modules",".git"]).then(o=>{$[(0,v.$nc)(i.fsPath)]=o}))}return Promise.all([d,...l]).then(([u,n])=>(h.processes=u||void 0,h.workspaceMetadata=m.folders?$:void 0,h))}}throw new Error(`IPC Command ${g} not found`)}listen(f,g,c){throw new Error("Not supported")}async f(f){return f&&!this.d.profiles.some(g=>g.id===f)&&await this.d.createProfile(f,f),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:s.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,I.$Dg)(this.c.logsHome,`exthost${E.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:y.OS,arch:process.arch,marks:A.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(g=>({...g}))}}}}e.$Vr=E,E.a=1}),define(we[272],ve([1,0,3,71,69,7,226]),function(he,e,y,A,s,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0;class S extends D.$Wr{constructor(I,E){super(new s.$oq(I),I),this.N=E,this.M=new Map,this.B(this.a)}c(I){let E=this.M.get(I.remoteAuthority);return E||(E=(0,A.$Or)(I.remoteAuthority),this.M.set(I.remoteAuthority,E)),E}f(I,E,w=!1){if(w&&E.path==="/vscode-resource"&&E.query){const f=JSON.parse(E.query).requestResourcePath;return y.URI.from({scheme:"file",path:f})}return y.URI.revive(I.transformIncoming(E))}L(I,E){return new p(I,E,this.b,this.N)}}e.$Yr=S;class p extends D.$Xr{constructor(I,E,w,f){super(I,E,w,f)}j(I){const E=I.args["file-watcher-polling"];if(E){const w=E.split(P.$tc),f=Number(w[0]);if(f>0)return{usePolling:w.length>1?w.slice(1):!0,pollingInterval:f}}}m(I){if(I.extensionsPath)return[P.$gc.join(I.extensionsPath,"**")]}}}),define(we[94],ve([1,0,203,8,3,2,6,37,16,12,40,164,64]),function(he,e,y,A,s,P,D,S,p,v,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ME=e.$LE=e.$KE=e.EditorsOrder=e.$JE=e.CloseDirection=e.$IE=e.$HE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.EditorInputCapabilities=e.$yE=e.SaveReason=e.Verbosity=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=void 0,e.$lE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$mE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$nE="workbench.editor.sidebysideEditor",e.$oE="workbench.editors.textDiffEditor",e.$pE="workbench.editors.binaryResourceDiffEditor";var f;(function(B){B[B.PROGRAMMATIC=1]="PROGRAMMATIC",B[B.USER=2]="USER",B[B.EDIT=3]="EDIT",B[B.NAVIGATION=4]="NAVIGATION",B[B.JUMP=5]="JUMP"})(f||(e.EditorPaneSelectionChangeReason=f={}));var g;(function(B){B[B.IDENTICAL=1]="IDENTICAL",B[B.SIMILAR=2]="SIMILAR",B[B.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function c(B){const W=B;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}e.$qE=c;function m(B,W,O){for(const j of O.visibleEditorPanes)if(j.group.id===W&&B.matches(j.input))return j.getViewState()}e.$rE=m;function h(B){if(b(B))return!1;const W=B;return s.URI.isUri(W?.resource)}e.$sE=h;function d(B){if(b(B))return!1;const W=B;return W?.original!==void 0&&W.modified!==void 0}e.$tE=d;function l(B){if(b(B))return!1;const W=B;return Array.isArray(W?.resources)}e.$uE=l;function $(B){if(b(B)||d(B))return!1;const W=B;return W?.primary!==void 0&&W.secondary!==void 0}e.$vE=$;function u(B){if(b(B))return!1;const W=B;return W?W.resource===void 0||W.resource.scheme===v.Schemas.untitled||W.forceUntitled===!0:!1}e.$wE=u;function n(B){if(b(B))return!1;const W=B;return s.URI.isUri(W?.base?.resource)&&s.URI.isUri(W?.input1?.resource)&&s.URI.isUri(W?.input2?.resource)&&s.URI.isUri(W?.result?.resource)}e.$xE=n;var i;(function(B){B[B.SHORT=0]="SHORT",B[B.MEDIUM=1]="MEDIUM",B[B.LONG=2]="LONG"})(i||(e.Verbosity=i={}));var o;(function(B){B[B.EXPLICIT=1]="EXPLICIT",B[B.AUTO=2]="AUTO",B[B.FOCUS_CHANGE=3]="FOCUS_CHANGE",B[B.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class r{constructor(){this.a=new Map}registerSource(W,O){let j=this.a.get(W);return j||(j={source:W,label:O},this.a.set(W,j)),j.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$yE=new r;var t;(function(B){B[B.None=0]="None",B[B.Readonly=2]="Readonly",B[B.Untitled=4]="Untitled",B[B.Singleton=8]="Singleton",B[B.RequiresTrust=16]="RequiresTrust",B[B.CanSplitInGroup=32]="CanSplitInGroup",B[B.ForceDescription=64]="ForceDescription",B[B.CanDropIntoEditor=128]="CanDropIntoEditor",B[B.MultipleEditors=256]="MultipleEditors",B[B.Scratchpad=512]="Scratchpad",B[B.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(t||(e.EditorInputCapabilities=t={}));class a extends P.$Sc{}e.$zE=a;function b(B){return B instanceof a}e.$AE=b;function C(B){const W=B;return s.URI.isUri(W?.preferredResource)}function L(B){const W=B;return b(W?.primary)&&b(W?.secondary)}e.$BE=L;function k(B){const W=B;return b(W?.modified)&&b(W?.original)}e.$CE=k;function R(B,W,O,j,re){return me(j,[(0,E.$Li)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const X={...O,limits:{size:Number.MAX_VALUE}};B.openEditor(W,X)}}),(0,E.$Li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>re.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$DE=R;function N(B){return b(B?.editor)}e.$EE=N;function Y(B){const W=B;return N(B)&&W?.group!==void 0}e.$FE=Y;function ee(B){const W=B;return typeof W?.groupId=="number"&&b(W.editor)}e.$GE=ee;var G;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.REPLACE=1]="REPLACE",B[B.MOVE=2]="MOVE",B[B.UNPIN=3]="UNPIN"})(G||(e.EditorCloseContext=G={}));var ne;(function(B){B[B.GROUP_ACTIVE=0]="GROUP_ACTIVE",B[B.GROUP_INDEX=1]="GROUP_INDEX",B[B.GROUP_LABEL=2]="GROUP_LABEL",B[B.GROUP_LOCKED=3]="GROUP_LOCKED",B[B.EDITOR_OPEN=4]="EDITOR_OPEN",B[B.EDITOR_CLOSE=5]="EDITOR_CLOSE",B[B.EDITOR_MOVE=6]="EDITOR_MOVE",B[B.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",B[B.EDITOR_LABEL=8]="EDITOR_LABEL",B[B.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",B[B.EDITOR_PIN=10]="EDITOR_PIN",B[B.EDITOR_STICKY=11]="EDITOR_STICKY",B[B.EDITOR_DIRTY=12]="EDITOR_DIRTY",B[B.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(ne||(e.GroupModelChangeKind=ne={}));var Z;(function(B){B[B.PRIMARY=1]="PRIMARY",B[B.SECONDARY=2]="SECONDARY",B[B.BOTH=3]="BOTH",B[B.ANY=4]="ANY"})(Z||(e.SideBySideEditor=Z={}));class T{getOriginalUri(W,O){if(!W)return;if(n(W))return e.$IE.getOriginalUri(W.result,O);if(O?.supportSideBySide){const{primary:re,secondary:X}=this.a(W);if(re&&X){if(O?.supportSideBySide===Z.BOTH)return{primary:this.getOriginalUri(re,{filterByScheme:O.filterByScheme}),secondary:this.getOriginalUri(X,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===Z.ANY)return this.getOriginalUri(re,{filterByScheme:O.filterByScheme})??this.getOriginalUri(X,{filterByScheme:O.filterByScheme});W=O.supportSideBySide===Z.PRIMARY?re:X}}if(d(W)||l(W)||$(W)||n(W))return;const j=C(W)?W.preferredResource:W.resource;return!j||!O||!O.filterByScheme?j:this.b(j,O.filterByScheme)}a(W){return L(W)||$(W)?{primary:W.primary,secondary:W.secondary}:k(W)||d(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,O){if(!W)return;if(n(W))return e.$IE.getCanonicalUri(W.result,O);if(O?.supportSideBySide){const{primary:re,secondary:X}=this.a(W);if(re&&X){if(O?.supportSideBySide===Z.BOTH)return{primary:this.getCanonicalUri(re,{filterByScheme:O.filterByScheme}),secondary:this.getCanonicalUri(X,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===Z.ANY)return this.getCanonicalUri(re,{filterByScheme:O.filterByScheme})??this.getCanonicalUri(X,{filterByScheme:O.filterByScheme});W=O.supportSideBySide===Z.PRIMARY?re:X}}if(d(W)||l(W)||$(W)||n(W))return;const j=W.resource;return!j||!O||!O.filterByScheme?j:this.b(j,O.filterByScheme)}b(W,O){if(Array.isArray(O)){if(O.some(j=>W.scheme===j))return W}else if(O===W.scheme)return W}}var oe;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.KEYBOARD=1]="KEYBOARD",B[B.MOUSE=2]="MOUSE"})(oe||(e.EditorCloseMethod=oe={}));function Q(B,W,O,j){if(!B.isSticky(W))return!1;switch(j.preventPinnedEditorClose){case"keyboardAndMouse":return O===oe.MOUSE||O===oe.KEYBOARD;case"mouse":return O===oe.MOUSE;case"keyboard":return O===oe.KEYBOARD}return!1}e.$HE=Q,e.$IE=new T;var te;(function(B){B[B.LEFT=0]="LEFT",B[B.RIGHT=1]="RIGHT"})(te||(e.CloseDirection=te={}));class J{constructor(){this.c=new Map,this.d=new Map}start(W){const O=this.a=W.get(D.$1h);for(const[j,re]of this.c)this.e(j,re,O);this.c.clear()}e(W,O,j){const re=j.createInstance(O);this.d.set(W,re)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,A.$Pf)(this.b)}registerEditorSerializer(W,O){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,O,this.a):this.c.set(W,O),(0,P.$Qc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}S.$un.add(e.$lE.EditorFactory,new J);async function V(B,W,O){return!B||!B.length?[]:await Promise.all(B.map(async j=>{const re=s.URI.revive(j.fileUri);if(!re){O.info("Cannot resolve the path because it is not valid.",j);return}if(!await W.canHandleResource(re)){O.info("Cannot resolve the path because it cannot be handled",j);return}let x=j.exists,z=j.type;if(typeof x!="boolean"||typeof z!="number")try{z=(await W.stat(re)).isDirectory?p.FileType.Directory:p.FileType.Unknown,x=!0}catch(M){O.error(M),x=!1}if(!x&&j.openOnlyIfExists){O.info("Cannot resolve the path because it does not exist",j);return}if(z===p.FileType.Directory){O.info("Cannot resolve the path because it is a directory",j);return}const q={...j.options,pinned:!0};return x?{resource:re,options:q}:{resource:re,options:q,forceUntitled:!0}}))}e.$JE=V;var ie;(function(B){B[B.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",B[B.SEQUENTIAL=1]="SEQUENTIAL"})(ie||(e.EditorsOrder=ie={}));function ue(B){const W=B;if(!W)return!1;const O=W;if(O.modified)return ue(O.modified);const j=W;return!!(j.contributionsState&&j.viewState&&Array.isArray(j.cursorState))}e.$KE=ue;function se(B){return(0,I.$Ni)(B)}e.$LE=se;function me(B,W,O){const j=(0,I.$Oi)(B,W);return j.forceMessage=O?.forceMessage,j.forceSeverity=O?.forceSeverity,j.allowDialog=O?.allowDialog,j}e.$ME=me}),define(we[131],ve([1,0,15,77,47,60,12,7,4,68]),function(he,e,y,A,s,P,D,S,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.$SI=e.$RI=e.$QI=e.CellStatusbarAlignment=e.$PI=e.$OI=e.$NI=e.NotebookEditorPriority=e.$MI=e.$LI=e.$KI=e.$JI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$II=e.$HI=e.$GI=e.$FI=e.CellKind=e.$EI=e.$DI=e.$CI=void 0,e.$CI="workbench.editor.notebook",e.$DI="workbench.editor.notebookTextDiffEditor",e.$EI="workbench.editor.interactive";var I;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(I||(e.CellKind=I={})),e.$FI=["application/json","application/javascript","text/html","image/svg+xml",P.$4r.latex,P.$4r.markdown,"image/png","image/jpeg",P.$4r.text],e.$GI=[P.$4r.latex,P.$4r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$4r.text],e.$HI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$II="_notAvailable";var E;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(E||(e.NotebookRunState=E={}));var w;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var f;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var g;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var c;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var m;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(m||(e.NotebookCellsChangeType=m={}));var h;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var d;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var l;(function(T){T.scheme=D.Schemas.vscodeNotebookCell;const oe=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${oe.join("")}]+`),te=7;function J(B,W){const O=W.toString(te),re=`${O.length<oe.length?oe[O.length-1]:"z"}${O}s${(0,y.$Ae)(y.$ge.fromString(B.scheme),!0,!0)}`;return B.with({scheme:T.scheme,fragment:re})}T.generate=J;function V(B){if(B.scheme!==T.scheme)return;const W=B.fragment.indexOf("s");if(W<0)return;const O=parseInt(B.fragment.substring(0,W).replace(Q,""),te),j=(0,y.$ze)(B.fragment.substring(W+1)).toString();if(!isNaN(O))return{handle:O,notebook:B.with({scheme:j,fragment:null})}}T.parse=V;function ie(B,W){return B.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${W??""},${B.scheme!==D.Schemas.file?B.scheme:""}`})}T.generateCellOutputUri=ie;function ue(B){if(B.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const W=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(B.fragment);if(!W)return;const O=W[1]&&W[1]!==""?W[1]:void 0,j=W[2];return{outputId:O,notebook:B.with({scheme:j||D.Schemas.file,fragment:null})}}T.parseCellOutputUri=ue;function se(B,W,O){return T.generate(B,W).with({scheme:O})}T.generateCellPropertyUri=se;function me(B,W){if(B.scheme===W)return T.parse(B.with({scheme:T.scheme}))}T.parseCellPropertyUri=me})(l||(e.CellUri=l={}));const $=T=>p.$c?T.replace(/\//g,"\\"):T;class u{constructor(oe=[],Q=e.$FI){this.e=Q,this.d=[...new Set(oe)].map(te=>({pattern:te,matches:A.$Ij($(te))}))}sort(oe){const Q=new Map(s.Iterable.map(oe,J=>[J,$(J)]));let te=[];for(const{matches:J}of this.d)for(const[V,ie]of Q)if(J(ie)){te.push(V),Q.delete(V);break}return Q.size&&(te=te.concat([...Q.keys()].sort((J,V)=>this.e.indexOf(J)-this.e.indexOf(V)))),te}prioritize(oe,Q){const te=this.f(oe);if(te===-1){this.d.unshift({pattern:oe,matches:A.$Ij($(oe))});return}const J=new Set(Q.map(ie=>this.f(ie,te)));J.delete(-1);const V=Array.from(J).sort();this.d.splice(te+1,0,...V.map(ie=>this.d[ie]));for(let ie=V.length-1;ie>=0;ie--)this.d.splice(V[ie],1)}toArray(){return this.d.map(oe=>oe.pattern)}f(oe,Q=this.d.length){const te=$(oe);for(let J=0;J<Q;J++)if(this.d[J].matches(te))return J;return-1}}e.$JI=u;function n(T,oe,Q,te=(J,V)=>J===V){const J=[];function V(se,me,B){if(me===0&&B.length===0)return;const W=J[J.length-1];W&&W.start+W.deleteCount===se?(W.deleteCount+=me,W.toInsert.push(...B)):J.push({start:se,deleteCount:me,toInsert:B})}let ie=0,ue=0;for(;;){if(ie===T.length){V(ie,0,oe.slice(ue));break}if(ue===oe.length){V(ie,T.length-ie,[]);break}const se=T[ie],me=oe[ue];if(te(se,me)){ie+=1,ue+=1;continue}Q(me)?(V(ie,1,[]),ie+=1):(V(ie,0,[me]),ue+=1)}return J}e.$KI=n,e.$LI=new v.$gj("notebookEditorCursorAtBoundary","none"),e.$MI=new v.$gj("notebookEditorCursorAtLineBoundary","none");var i;(function(T){T.default="default",T.option="option"})(i||(e.NotebookEditorPriority=i={}));function o(T){const oe=T;return!!((typeof oe.include=="string"||A.$Jj(oe.include))&&(typeof oe.exclude=="string"||A.$Jj(oe.exclude)))}e.$NI=o;function r(T,oe,Q){if(Array.isArray(T.viewType)&&T.viewType.indexOf(oe)>=0||T.viewType===oe)return!0;if(T.filenamePattern){const te=o(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,J=o(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(A.$Hj(te,(0,S.$nc)(Q.fsPath).toLowerCase()))return!(J&&A.$Hj(J,(0,S.$nc)(Q.fsPath).toLowerCase()))}return!1}e.$OI=r,e.$PI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var t;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(t||(e.CellStatusbarAlignment=t={}));class a{static create(oe){return`${a.d}${oe}`}static parse(oe){if(oe.startsWith(a.d))return oe.substring(a.d.length)}}e.$QI=a,a.d="notebook/";function b(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$RI=b;const C=new TextDecoder;function L(T){const oe=[];let Q=!1;for(const ie of T)(oe.length===0||Q)&&(oe.push(ie),Q=!0);let te=N(oe);const J=y.$ge.concat(oe.map(ie=>y.$ge.wrap(ie))),V=Z(J);return te=te||V.byteLength!==J.byteLength,{data:V,didCompression:te}}e.$SI=L,e.$TI=`${String.fromCharCode(27)}[A`;const k=e.$TI.split("").map(T=>T.charCodeAt(0)),R=10;function N(T){let oe=!1;return T.forEach((Q,te)=>{if(te===0||Q.length<e.$TI.length)return;const J=T[te-1],V=Q.subarray(0,e.$TI.length);if(V[0]===k[0]&&V[1]===k[1]&&V[2]===k[2]){const ie=J.lastIndexOf(R);if(ie===-1)return;oe=!0,T[te-1]=J.subarray(0,ie),T[te]=Q.subarray(e.$TI.length)}}),oe}function Y(T){let oe=T;do T=oe,oe=T.replace(/[^\n]\x08/gm,"");while(oe.length<T.length);return T}function ee(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const oe=T.match(/^(.*)\r+/m)[1];let Q=T.match(/\r+(.*)$/m)[1];Q=Q+oe.slice(Q.length,oe.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return T}const G="\b".charCodeAt(0),ne="\r".charCodeAt(0);function Z(T){return!T.buffer.includes(G)&&!T.buffer.includes(ne)?T:y.$ge.fromString(ee(Y(C.decode(T.buffer))))}});var Ot=this&&this.__classPrivateFieldSet||function(he,e,y,A,s){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!s)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?he!==e||!s:!e.has(he))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?s.call(he,y):s?s.value=y:e.set(he,y),y},it=this&&this.__classPrivateFieldGet||function(he,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?he!==e||!A:!e.has(he))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(he):A?A.value:e.get(he)};define(we[132],ve([1,0,18,11,101,26,60,17,8,3,21,35,16,118,131]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g){"use strict";var c,m,h,d,l,$,u,n,i,o,r,t,a,b,C,L,k,R,N,Y,ee,G,ne,Z,T;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$GM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$FM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.TestRunProfileKind=e.TestResultState=e.$lM=e.$kM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$jM=e.NotebookVariablesRequestKind=e.$iM=e.$hM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$gM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.ColorThemeKind=e.$aM=e.$_L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$$L=e.DebugConsoleMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$5L=e.$4L=e.FileChangeType=e.$3L=e.$2L=e.$1L=e.$ZL=e.InlineCompletionTriggerKind=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.ConfigurationTarget=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$CL=e.ViewBadge=e.ProgressLocation=e.$BL=e.$AL=e.TaskScope=e.ShellQuoting=e.$zL=e.$yL=e.$xL=e.TaskPanelKind=e.TaskRevealKind=e.$wL=e.TerminalLocation=e.$vL=e.$uL=e.$tL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$sL=e.$rL=e.$qL=e.$pL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$oL=e.StatusBarAlignment=e.ViewColumn=e.$nL=e.$mL=e.$lL=e.$kL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$jL=e.$iL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.LanguageStatusSeverity=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.CodeActionTriggerKind=e.$9K=e.$8K=e.SymbolTag=e.SymbolKind=e.$7K=e.$6K=e.DocumentHighlightKind=e.$5K=e.$4K=e.$3K=e.$2K=e.DiagnosticSeverity=e.DiagnosticTag=e.$1K=e.$ZK=e.FileEditType=e.$YK=e.$XK=e.$WK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function oe(U){return Object.assign(U,{apply:function(...ce){if(ce.length===0)return Reflect.construct(U,[]);{const pe=ce.length===1?[]:ce[1];return Reflect.construct(U,pe,ce[0].constructor)}},call:function(...ce){if(ce.length===0)return Reflect.construct(U,[]);{const[pe,...Be]=ce;return Reflect.construct(U,Be,pe.constructor)}}})}var Q;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(Q||(e.TerminalOutputAnchor=Q={}));var te;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(te||(e.TerminalQuickFixType=te={}));let J=i=class{static from(...F){let ce=F;return new i(function(){if(ce){for(const pe of ce)pe&&typeof pe.dispose=="function"&&pe.dispose();ce=void 0}})}constructor(F){c.set(this,void 0),Ot(this,c,F,"f")}dispose(){typeof it(this,c,"f")=="function"&&(it(this,c,"f").call(this),Ot(this,c,void 0,"f"))}};e.$PK=J,c=new WeakMap,e.$PK=J=i=Ne([oe],J);let V=o=class{static Min(...F){if(F.length===0)throw new TypeError;let ce=F[0];for(let pe=1;pe<F.length;pe++){const Be=F[pe];Be.isBefore(ce)&&(ce=Be)}return ce}static Max(...F){if(F.length===0)throw new TypeError;let ce=F[0];for(let pe=1;pe<F.length;pe++){const Be=F[pe];Be.isAfter(ce)&&(ce=Be)}return ce}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:ce,character:pe}=F;return typeof ce=="number"&&typeof pe=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,ce){if(F<0)throw(0,A.$7)("line must be non-negative");if(ce<0)throw(0,A.$7)("character must be non-negative");this.c=F,this.e=ce}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,ce=0){if(F===null||ce===null)throw(0,A.$7)();let pe;return typeof F>"u"?pe=0:typeof F=="number"?pe=F:(pe=typeof F.lineDelta=="number"?F.lineDelta:0,ce=typeof F.characterDelta=="number"?F.characterDelta:0),pe===0&&ce===0?this:new o(this.line+pe,this.character+ce)}with(F,ce=this.character){if(F===null||ce===null)throw(0,A.$7)();let pe;return typeof F>"u"?pe=this.line:typeof F=="number"?pe=F:(pe=typeof F.line=="number"?F.line:this.line,ce=typeof F.character=="number"?F.character:this.character),pe===this.line&&ce===this.character?this:new o(pe,ce)}toJSON(){return{line:this.line,character:this.character}}};e.$QK=V,e.$QK=V=o=Ne([oe],V);let ie=r=class{static isRange(F){return F instanceof r?!0:F?V.isPosition(F.start)&&V.isPosition(F.end):!1}static of(F){if(F instanceof r)return F;if(this.isRange(F))return new r(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,ce,pe,Be){let Ge,_e;if(typeof F=="number"&&typeof ce=="number"&&typeof pe=="number"&&typeof Be=="number"?(Ge=new V(F,ce),_e=new V(pe,Be)):V.isPosition(F)&&V.isPosition(ce)&&(Ge=V.of(F),_e=V.of(ce)),!Ge||!_e)throw new Error("Invalid arguments");Ge.isBefore(_e)?(this.c=Ge,this.e=_e):(this.c=_e,this.e=Ge)}contains(F){return r.isRange(F)?this.contains(F.start)&&this.contains(F.end):V.isPosition(F)?!(V.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const ce=V.Max(F.start,this.c),pe=V.Min(F.end,this.e);if(!ce.isAfter(pe))return new r(ce,pe)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ce=V.Min(F.start,this.c),pe=V.Max(F.end,this.end);return new r(ce,pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,ce=this.end){if(F===null||ce===null)throw(0,A.$7)();let pe;return F?V.isPosition(F)?pe=F:(pe=F.start||this.start,ce=F.end||this.end):pe=this.start,pe.isEqual(this.c)&&ce.isEqual(this.end)?this:new r(pe,ce)}toJSON(){return[this.start,this.end]}};e.$RK=ie,e.$RK=ie=r=Ne([oe],ie);let ue=t=class extends ie{static isSelection(F){return F instanceof t?!0:F?ie.isRange(F)&&V.isPosition(F.anchor)&&V.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,ce,pe,Be){let Ge,_e;if(typeof F=="number"&&typeof ce=="number"&&typeof pe=="number"&&typeof Be=="number"?(Ge=new V(F,ce),_e=new V(pe,Be)):V.isPosition(F)&&V.isPosition(ce)&&(Ge=V.of(F),_e=V.of(ce)),!Ge||!_e)throw new Error("Invalid arguments");super(Ge,_e),this.f=Ge,this.g=_e}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$SK=ue,e.$SK=ue=t=Ne([oe],ue);const se=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,A.$7)("connectionToken")};class me{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ce,pe){if(typeof F!="string"||F.length===0)throw(0,A.$7)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,A.$7)("port");typeof pe<"u"&&se(pe),this.host=F,this.port=Math.round(ce),this.connectionToken=pe}}e.$TK=me;class B{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ce){this.makeConnection=F,this.connectionToken=ce,typeof ce<"u"&&se(ce)}}e.$UK=B;class W extends Error{static NotAvailable(F,ce){return new W(F,f.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(F){return new W(F,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,ce=f.RemoteAuthorityResolverErrorCode.Unknown,pe){super(F),this._message=F,this._code=ce,this._detail=pe,Object.setPrototypeOf(this,W.prototype)}}e.$VK=W;var O;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(O||(e.EndOfLine=O={}));var j;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(j||(e.EnvironmentVariableMutatorType=j={}));let re=a=class{static isTextEdit(F){return F instanceof a?!0:F?ie.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ce){return new a(F,ce)}static insert(F,ce){return a.replace(new ie(F,F),ce)}static delete(F){return a.replace(F,"")}static setEndOfLine(F){const ce=new a(new ie(new V(0,0),new V(0,0)),"");return ce.newEol=F,ce}get range(){return this.c}set range(F){if(F&&!ie.isRange(F))throw(0,A.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,A.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,A.$7)("newEol");this.f=F}constructor(F,ce){this.c=F,this.e=ce}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$WK=re,e.$WK=re=a=Ne([oe],re);let X=b=class{static isNotebookCellEdit(F){return F instanceof b?!0:F?jt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ce){return new b(F,ce)}static insertCells(F,ce){return new b(new jt(F,F),ce)}static deleteCells(F){return new b(F,[])}static updateCellMetadata(F,ce){const pe=new b(new jt(F,F),[]);return pe.newCellMetadata=ce,pe}static updateNotebookMetadata(F){const ce=new b(new jt(0,0),[]);return ce.newNotebookMetadata=F,ce}constructor(F,ce){this.range=F,this.newCells=ce}};e.$XK=X,e.$XK=X=b=Ne([oe],X);class x{static isSnippetTextEdit(F){return F instanceof x?!0:F?ie.isRange(F.range)&&M.isSnippetString(F.snippet):!1}static replace(F,ce){return new x(F,ce)}static insert(F,ce){return x.replace(new ie(F,F),ce)}constructor(F,ce){this.range=F,this.snippet=ce}}e.$YK=x;var z;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(z||(e.FileEditType=z={}));let q=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,ce,pe,Be){this.c.push({_type:1,from:F,to:ce,options:pe,metadata:Be})}createFile(F,ce,pe){this.c.push({_type:1,from:void 0,to:F,options:ce,metadata:pe})}deleteFile(F,ce,pe){this.c.push({_type:1,from:F,to:void 0,options:ce,metadata:pe})}e(F,ce,pe){this.c.push({_type:3,metadata:pe,uri:F,edit:{editType:5,metadata:ce},notebookMetadata:ce})}f(F,ce,pe,Be){const Ge=ce.start,_e=ce.end;(Ge!==_e||pe.length>0)&&this.c.push({_type:5,uri:F,index:Ge,count:_e-Ge,cells:pe,metadata:Be})}g(F,ce,pe,Be){this.c.push({_type:3,metadata:Be,uri:F,edit:{editType:3,index:ce,metadata:pe}})}replace(F,ce,pe,Be){this.c.push({_type:2,uri:F,edit:new re(ce,pe),metadata:Be})}insert(F,ce,pe,Be){this.replace(F,new ie(ce,ce),pe,Be)}delete(F,ce,pe){this.replace(F,ce,"",pe)}has(F){return this.c.some(ce=>ce._type===2&&ce.uri.toString()===F.toString())}set(F,ce){if(ce)for(const pe of ce){if(!pe)continue;let Be,Ge;Array.isArray(pe)?(Be=pe[0],Ge=pe[1]):Be=pe,X.isNotebookCellEdit(Be)?Be.newCellMetadata?this.g(F,Be.range.start,Be.newCellMetadata,Ge):Be.newNotebookMetadata?this.e(F,Be.newNotebookMetadata,Ge):this.f(F,Be.range,Be.newCells,Ge):x.isSnippetTextEdit(Be)?this.c.push({_type:6,uri:F,range:Be.range,edit:Be.snippet,metadata:Ge}):this.c.push({_type:2,uri:F,edit:Be,metadata:Ge})}else{for(let pe=0;pe<this.c.length;pe++){const Be=this.c[pe];switch(Be._type){case 2:case 6:case 3:case 5:Be.uri.toString()===F.toString()&&(this.c[pe]=void 0);break}}(0,y.$Ib)(this.c)}}get(F){const ce=[];for(const pe of this.c)pe._type===2&&pe.uri.toString()===F.toString()&&ce.push(pe.edit);return ce}entries(){const F=new P.$Ac;for(const ce of this.c)if(ce._type===2){let pe=F.get(ce.uri);pe||(pe=[ce.uri,[]],F.set(ce.uri,pe)),pe[1].push(ce.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$ZK=q,e.$ZK=q=Ne([oe],q);let M=C=class{static isSnippetString(F){return F instanceof C?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=C.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ce=this.e++){if(typeof F=="function"){const pe=new C;pe.e=this.e,F(pe),this.e=pe.e,F=pe.value}else F=C.c(F);return this.value+="${",this.value+=ce,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ce=this.e++){const pe=F.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=pe,this.value+="|}",this}appendVariable(F,ce){if(typeof ce=="function"){const pe=new C;pe.e=this.e,ce(pe),this.e=pe.e,ce=pe.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};e.$1K=M,e.$1K=M=C=Ne([oe],M);var H;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(H||(e.DiagnosticTag=H={}));var _;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let ae=L=class{static isLocation(F){return F instanceof L?!0:F?ie.isRange(F.range)&&v.URI.isUri(F.uri):!1}constructor(F,ce){if(this.uri=F,ce)if(ie.isRange(ce))this.range=ie.of(ce);else if(V.isPosition(ce))this.range=new ie(ce,ce);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$2K=ae,e.$2K=ae=L=Ne([oe],ae);let fe=class{static is(F){return F?typeof F.message=="string"&&F.location&&ie.isRange(F.location.range)&&v.URI.isUri(F.location.uri):!1}constructor(F,ce){this.location=F,this.message=ce}static isEqual(F,ce){return F===ce?!0:!F||!ce?!1:F.message===ce.message&&F.location.range.isEqual(ce.location.range)&&F.location.uri.toString()===ce.location.uri.toString()}};e.$3K=fe,e.$3K=fe=Ne([oe],fe);let le=class{constructor(F,ce,pe=_.Error){if(!ie.isRange(F))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=F,this.message=ce,this.severity=pe}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ce){return F===ce?!0:!F||!ce?!1:F.message===ce.message&&F.severity===ce.severity&&F.code===ce.code&&F.severity===ce.severity&&F.source===ce.source&&F.range.isEqual(ce.range)&&(0,y.$ub)(F.tags,ce.tags)&&(0,y.$ub)(F.relatedInformation,ce.relatedInformation,fe.isEqual)}};e.$4K=le,e.$4K=le=Ne([oe],le);let $e=class{constructor(F,ce){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ce}};e.$5K=$e,e.$5K=$e=Ne([oe],$e);var ye;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(ye||(e.DocumentHighlightKind=ye={}));let Ae=class{constructor(F,ce=ye.Text){this.range=F,this.kind=ce}toJSON(){return{range:this.range,kind:ye[this.kind]}}};e.$6K=Ae,e.$6K=Ae=Ne([oe],Ae);let Re=class{constructor(F,ce){this.uri=F,this.highlights=ce}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$7K=Re,e.$7K=Re=Ne([oe],Re);var ge;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(ge||(e.SymbolKind=ge={}));var ke;(function(U){U[U.Deprecated=1]="Deprecated"})(ke||(e.SymbolTag=ke={}));let De=k=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,ce,pe,Be,Ge){this.name=F,this.kind=ce,this.containerName=Ge,typeof pe=="string"&&(this.containerName=pe),Be instanceof ae?this.location=Be:pe instanceof ie&&(this.location=new ae(Be,pe)),k.validate(this)}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};e.$8K=De,e.$8K=De=k=Ne([oe],De);let Me=R=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(R.validate)}constructor(F,ce,pe,Be,Ge){this.name=F,this.detail=ce,this.kind=pe,this.range=Be,this.selectionRange=Ge,this.children=[],R.validate(this)}};e.$9K=Me,e.$9K=Me=R=Ne([oe],Me);var Te;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let He=class{constructor(F,ce){this.title=F,this.kind=ce}};e.$0K=He,e.$0K=He=Ne([oe],He);let Ue=N=class{constructor(F){this.value=F}append(F){return new N(this.value?this.value+N.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+N.c)}};e.$$K=Ue,Ue.c=".",e.$$K=Ue=N=Ne([oe],Ue),Ue.Empty=new Ue(""),Ue.QuickFix=Ue.Empty.append("quickfix"),Ue.Refactor=Ue.Empty.append("refactor"),Ue.RefactorExtract=Ue.Refactor.append("extract"),Ue.RefactorInline=Ue.Refactor.append("inline"),Ue.RefactorMove=Ue.Refactor.append("move"),Ue.RefactorRewrite=Ue.Refactor.append("rewrite"),Ue.Source=Ue.Empty.append("source"),Ue.SourceOrganizeImports=Ue.Source.append("organizeImports"),Ue.SourceFixAll=Ue.Source.append("fixAll"),Ue.Notebook=Ue.Empty.append("notebook");let Ke=class{constructor(F,ce){if(this.range=F,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$_K=Ke,e.$_K=Ke=Ne([oe],Ke);class tt{constructor(F,ce,pe,Be,Ge,_e){this.kind=F,this.name=ce,this.detail=pe,this.uri=Be,this.range=Ge,this.selectionRange=_e}}e.$aL=tt;class Ze{constructor(F,ce){this.fromRanges=ce,this.from=F}}e.$bL=Ze;class et{constructor(F,ce){this.fromRanges=ce,this.to=F}}e.$cL=et;var be;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(be||(e.LanguageStatusSeverity=be={}));let Ie=class{constructor(F,ce){this.range=F,this.command=ce}get isResolved(){return!!this.command}};e.$dL=Ie,e.$dL=Ie=Ne([oe],Ie);let Ce=Y=class{static isMarkdownString(F){return F instanceof Y?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,ce=!1){m.set(this,void 0),Ot(this,m,new s.$dk(F,{supportThemeIcons:ce}),"f")}get value(){return it(this,m,"f").value}set value(F){it(this,m,"f").value=F}get isTrusted(){return it(this,m,"f").isTrusted}set isTrusted(F){it(this,m,"f").isTrusted=F}get supportThemeIcons(){return it(this,m,"f").supportThemeIcons}set supportThemeIcons(F){it(this,m,"f").supportThemeIcons=F}get supportHtml(){return it(this,m,"f").supportHtml}set supportHtml(F){it(this,m,"f").supportHtml=F}get baseUri(){return it(this,m,"f").baseUri}set baseUri(F){it(this,m,"f").baseUri=F}appendText(F){return it(this,m,"f").appendText(F),this}appendMarkdown(F){return it(this,m,"f").appendMarkdown(F),this}appendCodeblock(F,ce){return it(this,m,"f").appendCodeblock(ce??"",F),this}};e.$eL=Ce,m=new WeakMap,e.$eL=Ce=Y=Ne([oe],Ce);let je=class{constructor(F,ce){this.label=F,this.documentation=ce}};e.$fL=je,e.$fL=je=Ne([oe],je);let Fe=class{constructor(F,ce){this.label=F,this.documentation=ce,this.parameters=[]}};e.$gL=Fe,e.$gL=Fe=Ne([oe],Fe);let qe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$hL=qe,e.$hL=qe=Ne([oe],qe);var Ve;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(Ve||(e.SignatureHelpTriggerKind=Ve={}));var Qe;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Qe||(e.InlayHintKind=Qe={}));let Je=class{constructor(F){this.value=F}};e.$iL=Je,e.$iL=Je=Ne([oe],Je);let xe=class{constructor(F,ce,pe){this.position=F,this.label=ce,this.kind=pe}};e.$jL=xe,e.$jL=xe=Ne([oe],xe);var rt;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt||(e.CompletionTriggerKind=rt={}));var Xe;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Xe||(e.CompletionItemKind=Xe={}));var lt;(function(U){U[U.Deprecated=1]="Deprecated"})(lt||(e.CompletionItemTag=lt={}));let at=class{constructor(F,ce){this.label=F,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&Xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$kL=at,e.$kL=at=Ne([oe],at);let yt=class{constructor(F=[],ce=!1){this.items=F,this.isIncomplete=ce}};e.$lL=yt,e.$lL=yt=Ne([oe],yt);let gt=class{constructor(F,ce,pe){this.insertText=F,this.range=ce,this.command=pe}};e.$mL=gt,e.$mL=gt=Ne([oe],gt);let wt=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$nL=wt,e.$nL=wt=Ne([oe],wt);var Tt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Tt||(e.ViewColumn=Tt={}));var Ut;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ut||(e.StatusBarAlignment=Ut={}));function Bt(U,F){return`${E.$hm.toKey(U)}.${F}`}e.$oL=Bt;var kt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(kt||(e.TextEditorLineNumbersStyle=kt={}));var ut;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ut||(e.TextDocumentSaveReason=ut={}));var It;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(It||(e.TextEditorRevealType=It={}));var Ct;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Ct||(e.TextEditorSelectionChangeKind=Ct={}));var pt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(pt||(e.TextDocumentChangeReason=pt={}));var zt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(zt||(e.DecorationRangeBehavior=zt={})),function(U){function F(ce){switch(ce){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=F}(Ct||(e.TextEditorSelectionChangeKind=Ct={}));var St;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(St||(e.SyntaxTokenType=St={})),function(U){function F(ce){switch(ce){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=F}(St||(e.SyntaxTokenType=St={}));let st=class{constructor(F,ce){if(ce&&!v.URI.isUri(ce))throw(0,A.$7)("target");if(!ie.isRange(F)||F.isEmpty)throw(0,A.$7)("range");this.range=F,this.target=ce}};e.$pL=st,e.$pL=st=Ne([oe],st);let ht=class{constructor(F,ce,pe,Be){this.red=F,this.green=ce,this.blue=pe,this.alpha=Be}};e.$qL=ht,e.$qL=ht=Ne([oe],ht);let $t=class{constructor(F,ce){if(ce&&!(ce instanceof ht))throw(0,A.$7)("color");if(!ie.isRange(F)||F.isEmpty)throw(0,A.$7)("range");this.range=F,this.color=ce}};e.$rL=$t,e.$rL=$t=Ne([oe],$t);let ft=class{constructor(F){if(!F||typeof F!="string")throw(0,A.$7)("label");this.label=F}};e.$sL=ft,e.$sL=ft=Ne([oe],ft);var qt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Ht;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Ht||(e.SourceControlInputBoxValidationType=Ht={}));var At;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(At||(e.TerminalExitReason=At={}));class Nt{constructor(F,ce,pe){if(this.startIndex=F,this.length=ce,this.tooltip=pe,typeof F!="number"||F<0)throw(0,A.$7)("startIndex");if(typeof ce!="number"||ce<1)throw(0,A.$7)("length");if(pe!==void 0&&typeof pe!="string")throw(0,A.$7)("tooltip")}}e.$tL=Nt;class Ft{constructor(F){this.uri=F}}e.$uL=Ft;class Vt{constructor(F){this.terminalCommand=F}}e.$vL=Vt;var Wt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Wt||(e.TerminalLocation=Wt={}));class Mt{constructor(F){if(this.options=F,typeof F!="object")throw(0,A.$7)("options")}}e.$wL=Mt;var Jt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var Ee;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Ee||(e.TaskPanelKind=Ee={}));let Se=ee=class{static from(F){switch(F){case"clean":return ee.Clean;case"build":return ee.Build;case"rebuild":return ee.Rebuild;case"test":return ee.Test;default:return}}constructor(F,ce){if(this.label=ce,typeof F!="string"||typeof ce!="string")throw(0,A.$7)("name");this.c=F}get id(){return this.c}};e.$xL=Se,Se.Clean=new ee("clean","Clean"),Se.Build=new ee("build","Build"),Se.Rebuild=new ee("rebuild","Rebuild"),Se.Test=new ee("test","Test"),e.$xL=Se=ee=Ne([oe],Se);function de(U){let F="";for(let ce=0;ce<U.length;ce++)F+=U[ce].replace(/,/g,",,")+",";return F}let K=class{constructor(F,ce,pe){if(typeof F!="string")throw(0,A.$7)("process");this.e=[],this.c=F,ce!==void 0&&(Array.isArray(ce)?(this.e=ce,this.f=pe):this.f=ce)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,A.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const ce of this.e)F.push(ce);return de(F)}};e.$yL=K,e.$yL=K=Ne([oe],K);let Pe=class{constructor(F,ce,pe){if(this.f=[],Array.isArray(ce)){if(!F)throw(0,A.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,A.$7)("command");this.e=F,this.f=ce,this.g=pe}else{if(typeof F!="string")throw(0,A.$7)("commandLine");this.c=F,this.g=ce}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,A.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,A.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ce of this.f)F.push(typeof ce=="string"?ce:ce.value);return de(F)}};e.$zL=Pe,e.$zL=Pe=Ne([oe],Pe);var Oe;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Oe||(e.ShellQuoting=Oe={}));var We;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(We||(e.TaskScope=We={}));class ze{constructor(F){this.c=F}computeId(){return"customExecution"+(0,I.$mg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$AL=ze;let Ye=G=class{constructor(F,ce,pe,Be,Ge,_e){this.k=!1,this.l=this.definition=F;let nt;typeof ce=="string"?(this.n=this.name=ce,this.u=this.source=pe,this.execution=Be,nt=Ge,this.k=!0):ce===We.Global||ce===We.Workspace?(this.target=ce,this.n=this.name=pe,this.u=this.source=Be,this.execution=Ge,nt=_e):(this.target=ce,this.n=this.name=pe,this.u=this.source=Be,this.execution=Ge,nt=_e),typeof nt=="string"?(this.q=[nt],this.r=!0):Array.isArray(nt)?(this.q=nt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof K?this.l={type:G.e,id:this.o.computeId()}:this.o instanceof Pe?this.l={type:G.f,id:this.o.computeId()}:this.o instanceof ze?this.l={type:G.c,id:this.o.computeId()}:this.l={type:G.g,id:(0,I.$mg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,A.$7)("Kind can't be undefined or null");this.A(),this.l=F}get scope(){return this.m}set target(F){this.A(),this.m=F}get name(){return this.n}set name(F){if(typeof F!="string")throw(0,A.$7)("name");this.A(),this.n=F}get execution(){return this.o}set execution(F){F===null&&(F=void 0),this.A(),this.o=F;const ce=this.l.type;(G.g===ce||G.e===ce||G.f===ce||G.c===ce)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(F){if(Array.isArray(F))this.A(),this.q=F,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.A(),this.t=F}get source(){return this.u}set source(F){if(typeof F!="string"||F.length===0)throw(0,A.$7)("source must be a string of length > 0");this.A(),this.u=F}get group(){return this.w}set group(F){F===null&&(F=void 0),this.A(),this.w=F}get detail(){return this.z}set detail(F){F===null&&(F=void 0),this.z=F}get presentationOptions(){return this.x}set presentationOptions(F){F==null&&(F=Object.create(null)),this.A(),this.x=F}get runOptions(){return this.y}set runOptions(F){F==null&&(F=Object.create(null)),this.A(),this.y=F}};e.$BL=Ye,Ye.c="customExecution",Ye.e="process",Ye.f="shell",Ye.g="$empty",e.$BL=Ye=G=Ne([oe],Ye);var ct;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ct||(e.ProgressLocation=ct={}));var Et;(function(U){function F(ce){const pe=ce;return(0,p.$If)(pe.value)?pe.tooltip&&!(0,p.$Ef)(pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",pe.value),!1)}U.isViewBadge=F})(Et||(e.ViewBadge=Et={}));let bt=ne=class{static isTreeItem(F,ce){const pe=F;if(pe.checkboxState!==void 0){const Be=(0,p.$If)(pe.checkboxState)?pe.checkboxState:(0,p.$Gf)(pe.checkboxState)&&(0,p.$If)(pe.checkboxState.state)?pe.checkboxState.state:void 0,Ge=!(0,p.$If)(pe.checkboxState)&&(0,p.$Gf)(pe.checkboxState)?pe.checkboxState.tooltip:void 0;if(Be===void 0||Be!==dt.Checked&&Be!==dt.Unchecked||Ge!==void 0&&!(0,p.$Ef)(Ge))return console.log("INVALID tree item, invalid checkboxState",pe.checkboxState),!1}if(F instanceof ne)return!0;if(pe.label!==void 0&&!(0,p.$Ef)(pe.label)&&!pe.label?.label)return console.log("INVALID tree item, invalid label",pe.label),!1;if(pe.id!==void 0&&!(0,p.$Ef)(pe.id))return console.log("INVALID tree item, invalid id",pe.id),!1;if(pe.iconPath!==void 0&&!(0,p.$Ef)(pe.iconPath)&&!v.URI.isUri(pe.iconPath)&&(!pe.iconPath||!(0,p.$Ef)(pe.iconPath.id))){const Be=pe.iconPath;if(!Be||!(0,p.$Ef)(Be.light)&&!v.URI.isUri(Be.light)&&!(0,p.$Ef)(Be.dark)&&!v.URI.isUri(Be.dark))return console.log("INVALID tree item, invalid iconPath",pe.iconPath),!1}return pe.description!==void 0&&!(0,p.$Ef)(pe.description)&&typeof pe.description!="boolean"?(console.log("INVALID tree item, invalid description",pe.description),!1):pe.resourceUri!==void 0&&!v.URI.isUri(pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",pe.resourceUri),!1):pe.tooltip!==void 0&&!(0,p.$Ef)(pe.tooltip)&&!(pe.tooltip instanceof Ce)?(console.log("INVALID tree item, invalid tooltip",pe.tooltip),!1):pe.command!==void 0&&!pe.command.command?(console.log("INVALID tree item, invalid command",pe.command),!1):pe.collapsibleState!==void 0&&pe.collapsibleState<ot.None&&pe.collapsibleState>ot.Expanded?(console.log("INVALID tree item, invalid collapsibleState",pe.collapsibleState),!1):pe.contextValue!==void 0&&!(0,p.$Ef)(pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",pe.contextValue),!1):pe.accessibilityInformation!==void 0&&!pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",pe.accessibilityInformation),!1):!0}constructor(F,ce=ot.None){this.collapsibleState=ce,v.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$CL=bt,e.$CL=bt=ne=Ne([oe],bt);var ot;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(ot||(e.TreeItemCollapsibleState=ot={}));var dt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(dt||(e.TreeItemCheckboxState=dt={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$DL=Yt,e.$DL=Yt=Ne([oe],Yt);class Ln extends Yt{}e.$EL=Ln;class $i extends Ln{constructor(F){super(""),h.set(this,void 0),Ot(this,h,F,"f")}asFile(){return it(this,h,"f")}}e.$FL=$i,h=new WeakMap;class bi{constructor(F,ce,pe,Be){this.name=F,this.uri=ce,this._itemId=pe,this.c=Be}data(){return this.c()}}e.$GL=bi;let en=class{constructor(F){d.add(this),l.set(this,new Map);for(const[ce,pe]of F??[]){const Be=it(this,l,"f").get(it(this,d,"m",$).call(this,ce));Be?Be.push(pe):it(this,l,"f").set(it(this,d,"m",$).call(this,ce),[pe])}}get(F){return it(this,l,"f").get(it(this,d,"m",$).call(this,F))?.[0]}set(F,ce){it(this,l,"f").set(it(this,d,"m",$).call(this,F),[ce])}forEach(F,ce){for(const[pe,Be]of it(this,l,"f"))for(const Ge of Be)F.call(ce,Ge,pe,this)}*[(l=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[F,ce]of it(this,l,"f"))for(const pe of ce)yield[F,pe]}};e.$HL=en,$=function(F){return F.toLowerCase()},e.$HL=en=Ne([oe],en);let tn=class{constructor(F){this.insertText=F}};e.$IL=tn,e.$IL=tn=Ne([oe],tn);let nn=class{constructor(F,ce){this.label=ce,this.insertText=F}};e.$JL=nn,e.$JL=nn=Ne([oe],nn);let Lt=class{constructor(F,ce){this.id=F,this.color=ce}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$KL=Lt,e.$KL=Lt=Ne([oe],Lt),Lt.File=new Lt("file"),Lt.Folder=new Lt("folder");let rn=class{constructor(F){this.id=F}};e.$LL=rn,e.$LL=rn=Ne([oe],rn);var Rn;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Rn||(e.ConfigurationTarget=Rn={}));let sn=class{get base(){return this.c}set base(F){this.c=F,this.e=v.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,ce){if(typeof F!="string"&&(!F||!v.URI.isUri(F)&&!v.URI.isUri(F.uri)))throw(0,A.$7)("base");if(typeof ce!="string")throw(0,A.$7)("pattern");typeof F=="string"?this.baseUri=v.URI.file(F):v.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ce}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$ML=sn,e.$ML=sn=Ne([oe],sn);const On=new WeakMap;function wi(U,F){On.set(U,F)}e.$NL=wi;let Gt=class{constructor(F,ce,pe,Be){this.enabled=typeof F=="boolean"?F:!0,typeof ce=="string"&&(this.condition=ce),typeof pe=="string"&&(this.hitCondition=pe),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this.c||(this.c=On.get(this)??(0,I.$mg)()),this.c}};e.$OL=Gt,e.$OL=Gt=Ne([oe],Gt);let on=class extends Gt{constructor(F,ce,pe,Be,Ge){if(super(ce,pe,Be,Ge),F===null)throw(0,A.$7)("location");this.location=F}};e.$PL=on,e.$PL=on=Ne([oe],on);let an=class extends Gt{constructor(F,ce,pe,Be,Ge){super(ce,pe,Be,Ge),this.functionName=F}};e.$QL=an,e.$QL=an=Ne([oe],an);let cn=class extends Gt{constructor(F,ce,pe,Be,Ge,_e,nt){if(super(Be,Ge,_e,nt),!ce)throw(0,A.$7)("dataId");this.label=F,this.dataId=ce,this.canPersist=pe}};e.$RL=cn,e.$RL=cn=Ne([oe],cn);let ln=class{constructor(F,ce,pe){this.command=F,this.args=ce||[],this.options=pe}};e.$SL=ln,e.$SL=ln=Ne([oe],ln);let un=class{constructor(F,ce){this.port=F,this.host=ce}};e.$TL=un,e.$TL=un=Ne([oe],un);let hn=class{constructor(F){this.path=F}};e.$UL=hn,e.$UL=hn=Ne([oe],hn);let fn=class{constructor(F){this.implementation=F}};e.$VL=fn,e.$VL=fn=Ne([oe],fn);let dn=class{constructor(F,ce,pe){this.session=F,this.threadId=ce,this.frameId=pe}};e.$WL=dn,e.$WL=dn=Ne([oe],dn);let mn=class{constructor(F,ce){this.session=F,this.threadId=ce}};e.$XL=mn,e.$XL=mn=Ne([oe],mn);let gn=class{constructor(F,ce){this.range=F,this.expression=ce}};e.$YL=gn,e.$YL=gn=Ne([oe],gn);var Nn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Nn||(e.InlineCompletionTriggerKind=Nn={}));let $n=class{constructor(F,ce){this.range=F,this.text=ce}};e.$ZL=$n,e.$ZL=$n=Ne([oe],$n);let bn=class{constructor(F,ce,pe=!0){this.range=F,this.variableName=ce,this.caseSensitiveLookup=pe}};e.$1L=bn,e.$1L=bn=Ne([oe],bn);let wn=class{constructor(F,ce){this.range=F,this.expression=ce}};e.$2L=wn,e.$2L=wn=Ne([oe],wn);let pn=class{constructor(F,ce){this.frameId=F,this.stoppedLocation=ce}};e.$3L=pn,e.$3L=pn=Ne([oe],pn);var Fn;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Fn||(e.FileChangeType=Fn={}));let vn=Z=class extends Error{static FileExists(F){return new Z(F,w.FileSystemProviderErrorCode.FileExists,Z.FileExists)}static FileNotFound(F){return new Z(F,w.FileSystemProviderErrorCode.FileNotFound,Z.FileNotFound)}static FileNotADirectory(F){return new Z(F,w.FileSystemProviderErrorCode.FileNotADirectory,Z.FileNotADirectory)}static FileIsADirectory(F){return new Z(F,w.FileSystemProviderErrorCode.FileIsADirectory,Z.FileIsADirectory)}static NoPermissions(F){return new Z(F,w.FileSystemProviderErrorCode.NoPermissions,Z.NoPermissions)}static Unavailable(F){return new Z(F,w.FileSystemProviderErrorCode.Unavailable,Z.Unavailable)}constructor(F,ce=w.FileSystemProviderErrorCode.Unknown,pe){super(v.URI.isUri(F)?F.toString(!0):F),this.code=pe?.name??"Unknown",(0,w.$Ak)(this,ce),Object.setPrototypeOf(this,Z.prototype),typeof Error.captureStackTrace=="function"&&typeof pe=="function"&&Error.captureStackTrace(this,pe)}};e.$4L=vn,e.$4L=vn=Z=Ne([oe],vn);let yn=class{constructor(F,ce,pe){this.start=F,this.end=ce,this.kind=pe}};e.$5L=yn,e.$5L=yn=Ne([oe],yn);var Mn;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Mn||(e.FoldingRangeKind=Mn={}));var jn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(jn||(e.CommentThreadCollapsibleState=jn={}));var Tn;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Tn||(e.CommentMode=Tn={}));var Un;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Un||(e.CommentState=Un={}));var Bn;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(Bn||(e.CommentThreadState=Bn={}));class pi{constructor(F,ce=[]){this.tokenTypes=F,this.tokenModifiers=ce}}e.$6L=pi;function vi(U){return typeof U>"u"||(0,p.$Ff)(U)}class En{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let ce=0,pe=F.tokenTypes.length;ce<pe;ce++)this.k.set(F.tokenTypes[ce],ce);for(let ce=0,pe=F.tokenModifiers.length;ce<pe;ce++)this.l.set(F.tokenModifiers[ce],ce)}}push(F,ce,pe,Be,Ge){if(typeof F=="number"&&typeof ce=="number"&&typeof pe=="number"&&typeof Be=="number"&&(typeof Ge=="number"||typeof Ge>"u"))return typeof Ge>"u"&&(Ge=0),this.o(F,ce,pe,Be,Ge);if(ie.isRange(F)&&typeof ce=="string"&&vi(pe))return this.n(F,ce,pe);throw(0,A.$7)()}n(F,ce,pe){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ce))throw new Error("`tokenType` is not in the provided legend");const Be=F.start.line,Ge=F.start.character,_e=F.end.character-F.start.character,nt=this.k.get(ce);let mt=0;if(pe)for(const vt of pe){if(!this.l.has(vt))throw new Error("`tokenModifier` is not in the provided legend");const Dt=this.l.get(vt);mt|=1<<Dt>>>0}this.o(Be,Ge,_e,nt,mt)}o(F,ce,pe,Be,Ge){if(this.f&&(F<this.c||F===this.c&&ce<this.e)){this.f=!1;const mt=this.g.length/5|0;let vt=0,Dt=0;for(let Pt=0;Pt<mt;Pt++){let Rt=this.g[5*Pt],Kt=this.g[5*Pt+1];Rt===0?(Rt=vt,Kt+=Dt):Rt+=vt,this.g[5*Pt]=Rt,this.g[5*Pt+1]=Kt,vt=Rt,Dt=Kt}}let _e=F,nt=ce;this.f&&this.j>0&&(_e-=this.c,_e===0&&(nt-=this.e)),this.g[this.j++]=_e,this.g[this.j++]=nt,this.g[this.j++]=pe,this.g[this.j++]=Be,this.g[this.j++]=Ge,this.c=F,this.e=ce}static q(F){const ce=[],pe=F.length/5|0;for(let nt=0;nt<pe;nt++)ce[nt]=nt;ce.sort((nt,mt)=>{const vt=F[5*nt],Dt=F[5*mt];if(vt===Dt){const Pt=F[5*nt+1],Rt=F[5*mt+1];return Pt-Rt}return vt-Dt});const Be=new Uint32Array(F.length);let Ge=0,_e=0;for(let nt=0;nt<pe;nt++){const mt=5*ce[nt],vt=F[mt+0],Dt=F[mt+1],Pt=F[mt+2],Rt=F[mt+3],Kt=F[mt+4],gi=vt-Ge,Ji=gi===0?Dt-_e:Dt,Qt=5*nt;Be[Qt+0]=gi,Be[Qt+1]=Ji,Be[Qt+2]=Pt,Be[Qt+3]=Rt,Be[Qt+4]=Kt,Ge=vt,_e=Dt}return Be}build(F){return this.f?new Dn(new Uint32Array(this.g),F):new Dn(En.q(this.g),F)}}e.$7L=En;class Dn{constructor(F,ce){this.resultId=ce,this.data=F}}e.$8L=Dn;class yi{constructor(F,ce,pe){this.start=F,this.deleteCount=ce,this.data=pe}}e.$9L=yi;class Ei{constructor(F,ce){this.resultId=ce,this.edits=F}}e.$0L=Ei;var zn;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(zn||(e.DebugConsoleMode=zn={}));let Xt=class{constructor(){}};e.$$L=Xt,Xt.Back={iconPath:new Lt("arrow-left")},e.$$L=Xt=Ne([oe],Xt);var qn;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(qn||(e.QuickPickItemKind=qn={}));var Hn;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Hn||(e.InputBoxValidationSeverity=Hn={}));var Wn;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Wn||(e.ExtensionKind=Wn={}));class Di{static validate(F){if(typeof F.badge=="string"){let ce=(0,S.$ff)(F.badge,0);if(ce<F.badge.length&&(ce+=(0,S.$ff)(F.badge,ce)),F.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Lt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,ce,pe){this.badge=F,this.tooltip=ce,this.color=pe}}e.$_L=Di;let kn=class{constructor(F){this.kind=F}};e.$aM=kn,e.$aM=kn=Ne([oe],kn);var Vn;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Vn||(e.ColorThemeKind=Vn={}));class jt{static isNotebookRange(F){return F instanceof jt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,ce){if(F<0)throw(0,A.$7)("start must be positive");if(ce<0)throw(0,A.$7)("end must be positive");F<=ce?(this.c=F,this.e=ce):(this.c=ce,this.e=F)}with(F){let ce=this.c,pe=this.e;return F.start!==void 0&&(ce=F.start),F.end!==void 0&&(pe=F.end),ce===this.c&&pe===this.e?this:new jt(ce,pe)}}e.$bM=jt;class Zt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ce=>Zt.isNotebookCellData(ce))}static isNotebookCellData(F){return!0}constructor(F,ce,pe,Be,Ge,_e,nt){this.kind=F,this.value=ce,this.languageId=pe,this.mime=Be,this.outputs=Ge??[],this.metadata=_e,this.executionSummary=nt,Zt.validate(this)}}e.$cM=Zt;class ki{constructor(F){this.cells=F}}e.$dM=ki;class Gn{static isNotebookCellOutputItem(F){return F instanceof u?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ce={name:F.name,message:F.message,stack:F.stack};return u.json(ce,"application/vnd.code.notebook.error")}static stdout(F){return u.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return u.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ce="application/octet-stream"){return new u(F,ce)}static text(F,ce=D.$4r.text){const pe=it(u,u,"f",n).encode(String(F));return new u(pe,ce)}static json(F,ce="text/x-json"){const pe=JSON.stringify(F,void 0,"	");return u.text(pe,ce)}constructor(F,ce){this.data=F,this.mime=ce;const pe=(0,D.$8r)(ce,!0);if(!pe)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=pe}}e.$eM=Gn,u=Gn,n={value:new TextEncoder};class xt{static isNotebookCellOutput(F){return F instanceof xt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ce=!1){const pe=new Set,Be=new Set;for(let Ge=0;Ge<F.length;Ge++){const _e=F[Ge],nt=(0,D.$8r)(_e.mime);if(!pe.has(nt)||(0,g.$RI)(nt)){pe.add(nt);continue}Be.add(Ge),ce&&console.warn(`DUPLICATED mime type '${_e.mime}' will be dropped`)}return Be.size===0?F:F.filter((Ge,_e)=>!Be.has(_e))}constructor(F,ce,pe){this.items=xt.ensureUniqueMimeTypes(F,!0),typeof ce=="string"?(this.id=ce,this.metadata=pe):(this.id=(0,I.$mg)(),this.metadata=ce??pe)}}e.$fM=xt;var Jn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Jn||(e.NotebookCellKind=Jn={}));var Kn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Kn||(e.NotebookCellExecutionState=Kn={}));var Qn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Qn||(e.NotebookCellStatusBarAlignment=Qn={}));var Yn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Yn||(e.NotebookEditorRevealType=Yn={}));class Si{constructor(F,ce){this.text=F,this.alignment=ce}}e.$gM=Si;var Xn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Xn||(e.NotebookControllerAffinity=Xn={}));var Zn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(Zn||(e.NotebookControllerAffinity2=Zn={}));class Pi{constructor(F,ce=[]){this.uri=F,this.provides=(0,y.$3b)(ce)}}e.$hM=Pi;class Ii{constructor(F){this.label=F}}e.$iM=Ii;var xn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(xn||(e.NotebookVariablesRequestKind=xn={}));let Sn=class{constructor(F,ce){this.label=F,this.timestamp=ce}};e.$jM=Sn,e.$jM=Sn=Ne([oe],Sn);var _n;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(_n||(e.ExtensionMode=_n={}));var ei;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(ei||(e.ExtensionRuntime=ei={}));var ti;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(ti||(e.StandardTokenType=ti={}));class Ci{constructor(F,ce){this.ranges=F,this.wordPattern=ce}}e.$kM=Ci;class Ai{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$lM=Ai;var ni;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(ni||(e.TestResultState=ni={}));var ii;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(ii||(e.TestRunProfileKind=ii={}));let Pn=class{constructor(F=void 0,ce=void 0,pe=void 0,Be=!1){this.include=F,this.exclude=ce,this.profile=pe,this.continuous=Be}};e.$mM=Pn,e.$mM=Pn=Ne([oe],Pn);let In=T=class{static diff(F,ce,pe){const Be=new T(F);return Be.expectedOutput=ce,Be.actualOutput=pe,Be}constructor(F){this.message=F}};e.$nM=In,e.$nM=In=T=Ne([oe],In);let Cn=class{constructor(F){this.id=F}};e.$oM=Cn,e.$oM=Cn=Ne([oe],Cn);class _t{constructor(F,ce){this.covered=F,this.total=ce}}e.$pM=_t;class An{static fromDetails(F,ce){const pe=new _t(0,0),Be=new _t(0,0),Ge=new _t(0,0);for(const nt of ce)if("branches"in nt){pe.total+=1,pe.covered+=nt.executionCount>0?1:0;for(const mt of nt.branches)Be.total+=1,Be.covered+=mt.executionCount>0?1:0}else Ge.total+=1,Ge.covered+=nt.executionCount>0?1:0;const _e=new An(F,pe,Be.total>0?Be:void 0,Ge.total>0?Ge:void 0);return _e.detailedCoverage=ce,_e}constructor(F,ce,pe,Be){this.uri=F,this.statementCoverage=ce,this.branchCoverage=pe,this.functionCoverage=Be}}e.$qM=An;class Li{constructor(F,ce,pe=[]){this.executionCount=F,this.location=ce,this.branches=pe}}e.$rM=Li;class Ri{constructor(F,ce){this.executionCount=F,this.location=ce}}e.$sM=Ri;class Oi{constructor(F,ce,pe){this.name=F,this.executionCount=ce,this.location=pe}}e.$tM=Oi;var ri;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(ri||(e.ExternalUriOpenerPriority=ri={}));var si;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(si||(e.WorkspaceTrustState=si={}));var oi;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(oi||(e.PortAutoForwardAction=oi={}));class Ni{constructor(F,ce,pe,Be,Ge,_e){this.kind=F,this.name=ce,this.detail=pe,this.uri=Be,this.range=Ge,this.selectionRange=_e}}e.$uM=Ni;class Fi{constructor(F){this.uri=F}}e.$vM=Fi;class Mi{constructor(F,ce){this.original=F,this.modified=ce}}e.$wM=Mi;class ji{constructor(F,ce,pe,Be){this.base=F,this.input1=ce,this.input2=pe,this.result=Be}}e.$xM=ji;class Ti{constructor(F,ce){this.uri=F,this.viewType=ce}}e.$yM=Ti;class Ui{constructor(F){this.viewType=F}}e.$zM=Ui;class Bi{constructor(F,ce){this.uri=F,this.notebookType=ce}}e.$AM=Bi;class zi{constructor(F,ce,pe){this.original=F,this.modified=ce,this.notebookType=pe}}e.$BM=zi;class qi{constructor(){}}e.$CM=qi;class Hi{constructor(F,ce){this.uri=F,this.inputBoxUri=ce}}e.$DM=Hi;class Wi{constructor(F){this.providerId=F}}e.$EM=Wi;var ai;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(ai||(e.InteractiveSessionVoteDirection=ai={}));var ci;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(ci||(e.InteractiveSessionCopyKind=ci={}));var li;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(li||(e.ChatVariableLevel=li={}));class Vi{constructor(F,ce){this.label=F,this.values=ce}}e.$FM=Vi;var ui;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(ui||(e.InteractiveEditorResponseFeedbackKind=ui={}));var hi;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(hi||(e.ChatMessageRole=hi={}));class Gi{constructor(F,ce){this.role=F,this.content=ce}}e.$GM=Gi;var fi;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(fi||(e.ChatAgentResultFeedbackKind=fi={}));var di;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(di||(e.RelatedInformationType=di={}));var mi;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(mi||(e.SpeechToTextStatus=mi={}))}),define(we[273],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0,e.$iN=(0,y.$2h)("environmentVariableService")}),define(we[274],ve([1,0,7,3,61,4,252,8]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=void 0;function p(u,n){if(n)if(P.$c)for(const i in n){let o=i;for(const t in u)if(i.toLowerCase()===t.toLowerCase()){o=t;break}const r=n[i];r!==void 0&&v(u,o,r)}else Object.keys(n).forEach(i=>{const o=n[i];o!==void 0&&v(u,i,o)})}e.$JN=p;function v(u,n,i){typeof i=="string"?u[n]=i:delete u[n]}function I(u,n,i,o){u.TERM_PROGRAM="vscode",n&&(u.TERM_PROGRAM_VERSION=n),f(u,o)&&(u.LANG=g(i)),u.COLORTERM="truecolor"}e.$KN=I;function E(u,n){if(n)for(const i of Object.keys(n)){const o=n[i];o!=null&&(u[i]=o)}}async function w(u,n){return await Promise.all(Object.entries(n).map(async([i,o])=>{if(typeof o=="string")try{n[i]=await u(o)}catch{n[i]=o}})),n}function f(u,n){if(n==="on")return!0;if(n==="auto"){const i=u.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.$LN=f;function g(u){const n=u?u.split("-"):[],i=n.length;if(i===0)return"en_US.UTF-8";if(i===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in o&&n.push(o[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.$MN=g;async function c(u,n,i,o,r,t){if(u.cwd){const b=typeof u.cwd=="object"?u.cwd.fsPath:u.cwd,C=await m(b,i);return(0,D.$HN)(C||b)}let a;return!u.ignoreConfigurationCwd&&r&&(i&&(r=await m(r,i,t)),r&&(y.$ic(r)?a=r:o&&(a=y.$jc(o.fsPath,r)))),a||(a=o?o.fsPath:n||""),(0,D.$HN)(a)}e.$NN=c;async function m(u,n,i){if(n)try{return await n(u)}catch(o){i?.error("Could not resolve terminal cwd",o);return}return u}function h(u,n,i){if(i)return o=>i.resolveWithEnvironment(n,u,o)}e.$ON=h;async function d(u,n,i,o,r,t){const a={};if(u.strictEnv)E(a,u.env);else{E(a,t);const b={...n};i&&(b&&await w(i,b),u.env&&await w(i,u.env)),(0,s.$Nl)(a,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),p(a,b),p(a,u.env),I(a,o,P.$q,r)}return a}e.$PN=d;async function l(u,n,i,o,r,t,a=P.$c){let b;if((0,S.$Ef)(u)?b=u:(b=u.fsPath,a&&t!==1?b=b.replace(/\\/g,"/"):!a&&t===1&&(b=b.replace(/\//g,"\\"))),!n)return b;const C=b.includes(" "),L=b.includes("(")||b.includes(")"),k=y.$nc(n,".exe"),R=k==="pwsh"||i==="pwsh"||k==="powershell"||i==="powershell";if(R&&(C||b.includes("'")))return`& '${b.replace(/'/g,"''")}'`;if(L&&R)return`& '${b}'`;if(t===1){if(o!==void 0)return o==="gitbash"?(0,D.$FN)(b.replace(/\\/g,"/")):o==="wsl"?r?.getWslPath(b,"win-to-unix")||b:C?`"${b}"`:b;const N=n.toLowerCase();return N.includes("wsl")||N.includes("bash.exe")&&!N.toLowerCase().includes("git")?r?.getWslPath(b,"win-to-unix")||b:C?`"${b}"`:b}return(0,D.$FN)(b)}e.$QN=l;function $(u,n,i){const o=typeof u=="string"?A.URI.parse(u):u;let r=o?n.getWorkspaceFolder(o)??void 0:void 0;if(!r){const t=i.getLastActiveWorkspaceRoot();r=t?n.getWorkspaceFolder(t)??void 0:void 0}return r}e.$RN=$}),define(we[72],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(P){P.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var A;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(A||(e.TestPosition=A={}));class s{static fromExtHostTestItem(D,S,p=D.parent){if(D._isRoot)return new s([S]);const v=[D.id];for(let I=p;I&&I.id!==S;I=I.parent)v.push(I.id);return v.push(S),new s(v.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const S=D.indexOf("\0");return S===-1?D:D.slice(0,S)}static fromString(D){return new s(D.split("\0"))}static join(D,S){return new s([...D.path,S])}static joinToString(D,S){return D.toString()+"\0"+S}static parentId(D){const S=D.lastIndexOf("\0");return S===-1?void 0:D.slice(0,S)}static localId(D){const S=D.lastIndexOf("\0");return S===-1?D:D.slice(S+1)}static isChild(D,S){return S.startsWith(D)&&S[D.length]==="\0"}static compare(D,S){return D===S?0:s.isChild(D,S)?2:s.isChild(S,D)?3:1}constructor(D,S=D.length){if(this.path=D,this.d=S,D.length===0||S<1)throw new Error("cannot create test with empty path")}get rootId(){return new s(this.path,1)}get parentId(){return this.d>1?new s(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new s(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new s(this.path,D)}compare(D){if(typeof D=="string")return s.compare(this.toString(),D);for(let S=0;S<D.d&&S<this.d;S++)if(D.path[S]!==this.path[S])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.$FJ=s}),define(we[95],ve([1,0,3,80,43,72]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$MJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$LJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$KJ=e.$JJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$IJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$HJ=e.$GJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var D;(function(Z){Z[Z.Unset=0]="Unset",Z[Z.Queued=1]="Queued",Z[Z.Running=2]="Running",Z[Z.Passed=3]="Passed",Z[Z.Failed=4]="Failed",Z[Z.Skipped=5]="Skipped",Z[Z.Errored=6]="Errored"})(D||(e.TestResultState=D={}));var S;(function(Z){Z[Z.Run=1]="Run",Z[Z.Debug=2]="Debug",Z[Z.Coverage=3]="Coverage"})(S||(e.ExtTestRunProfileKind=S={}));var p;(function(Z){Z[Z.Run=2]="Run",Z[Z.Debug=4]="Debug",Z[Z.Coverage=8]="Coverage",Z[Z.HasNonDefaultProfile=16]="HasNonDefaultProfile",Z[Z.HasConfigurable=32]="HasConfigurable",Z[Z.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$GJ=[2,4,8,16,32,64];const v=Z=>"runId"in Z;e.$HJ=v;var I;(function(Z){Z.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),Z.deserialize=T=>({range:s.$Hs.lift(T.range),uri:y.URI.revive(T.uri)})})(I||(e.IRichLocation=I={}));var E;(function(Z){Z[Z.Error=0]="Error",Z[Z.Output=1]="Output"})(E||(e.TestMessageType=E={}));var w;(function(Z){Z.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&I.serialize(T.location)}),Z.deserialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&I.deserialize(T.location)})})(w||(e.ITestErrorMessage=w={}));const f=(Z,T)=>`${T?"s":"e"}${Z}`;e.$IJ=f;var g;(function(Z){Z.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&I.serialize(T.location)}),Z.deserialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&I.deserialize(T.location)})})(g||(e.ITestOutputMessage=g={}));var c;(function(Z){Z.serialize=T=>T.type===0?w.serialize(T):g.serialize(T),Z.deserialize=T=>T.type===0?w.deserialize(T):g.deserialize(T)})(c||(e.ITestMessage=c={}));var m;(function(Z){Z.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),Z.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(c.serialize)}),Z.deserialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(c.deserialize)})})(m||(e.ITestTaskState=m={}));const h="\0",d=(Z,T)=>Z+h+T;e.$JJ=d;const l=Z=>{const T=Z.indexOf(h);return{ctrlId:Z.slice(0,T),tagId:Z.slice(T+1)}};e.$KJ=l;var $;(function(Z){Z.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),Z.deserialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?y.URI.revive(T.uri):void 0,range:T.range?s.$Hs.lift(T.range):null,description:T.description,error:T.error,sortText:T.sortText})})($||(e.ITestItem=$={}));var u;(function(Z){Z[Z.NotExpandable=0]="NotExpandable",Z[Z.Expandable=1]="Expandable",Z[Z.BusyExpanding=2]="BusyExpanding",Z[Z.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var n;(function(Z){Z.serialize=T=>({expand:T.expand,item:$.serialize(T.item)}),Z.deserialize=T=>({controllerId:P.$FJ.root(T.item.extId),expand:T.expand,item:$.deserialize(T.item)})})(n||(e.InternalTestItem=n={}));var i;(function(Z){Z.serialize=T=>{let oe;return T.item&&(oe={},T.item.label!==void 0&&(oe.label=T.item.label),T.item.tags!==void 0&&(oe.tags=T.item.tags),T.item.busy!==void 0&&(oe.busy=T.item.busy),T.item.uri!==void 0&&(oe.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(oe.range=T.item.range?.toJSON()),T.item.description!==void 0&&(oe.description=T.item.description),T.item.error!==void 0&&(oe.error=T.item.error),T.item.sortText!==void 0&&(oe.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:oe}},Z.deserialize=T=>{let oe;return T.item&&(oe={},T.item.label!==void 0&&(oe.label=T.item.label),T.item.tags!==void 0&&(oe.tags=T.item.tags),T.item.busy!==void 0&&(oe.busy=T.item.busy),T.item.range!==void 0&&(oe.range=T.item.range?s.$Hs.lift(T.item.range):null),T.item.description!==void 0&&(oe.description=T.item.description),T.item.error!==void 0&&(oe.error=T.item.error),T.item.sortText!==void 0&&(oe.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:oe}}})(i||(e.ITestItemUpdate=i={}));const o=(Z,T)=>{T.expand!==void 0&&(Z.expand=T.expand),T.item!==void 0&&(Z.item=Z.item?Object.assign(Z.item,T.item):T.item)};e.$LJ=o;var r;(function(Z){Z.serializeWithoutMessages=T=>({...n.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serializeWithoutMessages)}),Z.serialize=T=>({...n.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serialize)}),Z.deserialize=T=>({...n.deserialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var t;(function(Z){Z.empty=()=>({covered:0,total:0}),Z.sum=(T,oe)=>{T.covered+=oe.covered,T.total+=oe.total}})(t||(e.ICoveredCount=t={}));var a;(function(Z){Z.serialize=T=>({statement:T.statement,branch:T.branch,function:T.function,details:T.details?.map(k.serialize),uri:T.uri.toJSON()}),Z.deserialize=T=>({statement:T.statement,branch:T.branch,function:T.function,details:T.details?.map(k.deserialize),uri:y.URI.from(T.uri)})})(a||(e.IFileCoverage=a={}));function b(Z){return{...Z,location:Z.location?.toJSON()}}function C(Z){return Z.location=Z.location?A.$Gs.isIPosition(Z.location)?A.$Gs.lift(Z.location):s.$Hs.lift(Z.location):void 0,Z}e.$MJ=3;var L;(function(Z){Z[Z.Function=0]="Function",Z[Z.Statement=1]="Statement"})(L||(e.DetailType=L={}));var k;(function(Z){Z.serialize=T=>T.type===0?N.serialize(T):Y.serialize(T),Z.deserialize=T=>T.type===0?N.deserialize(T):Y.deserialize(T)})(k||(e.CoverageDetails=k={}));var R;(function(Z){Z.serialize=b,Z.deserialize=C})(R||(e.IBranchCoverage=R={}));var N;(function(Z){Z.serialize=b,Z.deserialize=C})(N||(e.IFunctionCoverage=N={}));var Y;(function(Z){Z.serialize=T=>({...b(T),branches:T.branches?.map(R.serialize)}),Z.deserialize=T=>({...C(T),branches:T.branches?.map(R.deserialize)})})(Y||(e.IStatementCoverage=Y={}));var ee;(function(Z){Z[Z.Add=0]="Add",Z[Z.Update=1]="Update",Z[Z.DocumentSynced=2]="DocumentSynced",Z[Z.Remove=3]="Remove",Z[Z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",Z[Z.Retire=5]="Retire",Z[Z.AddTag=6]="AddTag",Z[Z.RemoveTag=7]="RemoveTag"})(ee||(e.TestDiffOpType=ee={}));var G;(function(Z){Z.deserialize=T=>T.op===0?{op:T.op,item:n.deserialize(T.item)}:T.op===1?{op:T.op,item:i.deserialize(T.item)}:T.op===2?{op:T.op,uri:y.URI.revive(T.uri),docv:T.docv}:T,Z.serialize=T=>T.op===0?{op:T.op,item:n.serialize(T.item)}:T.op===1?{op:T.op,item:i.serialize(T.item)}:T})(G||(e.TestsDiffOp=G={}));class ne{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(T){const oe=this.o();for(const Q of T)switch(Q.op){case 0:this.j(n.deserialize(Q.item),oe);break;case 1:this.k(i.deserialize(Q.item),oe);break;case 3:this.l(Q.itemId,oe);break;case 5:this.m(Q.itemId);break;case 4:this.updatePendingRoots(Q.amount);break;case 6:this.c.set(Q.tag.id,Q.tag);break;case 7:this.c.delete(Q.id);break}oe.complete?.()}j(T,oe){const Q=P.$FJ.parentId(T.item.extId)?.toString();let te;if(!Q)te=this.p(T),this.f.add(te),this.d.set(T.item.extId,te);else if(this.d.has(Q)){const J=this.d.get(Q);J.children.add(T.item.extId),te=this.p(T,J),this.d.set(T.item.extId,te)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return oe.add?.(te),T.expand===2&&this.g++,te}k(T,oe){const Q=this.d.get(T.extId);if(Q)return T.expand!==void 0&&(Q.expand===2&&this.g--,T.expand===2&&this.g++),(0,e.$LJ)(Q,T),oe.update?.(Q),Q}l(T,oe){const Q=this.d.get(T);if(!Q)return;const te=P.$FJ.parentId(Q.item.extId)?.toString();te?this.d.get(te).children.delete(Q.item.extId):this.f.delete(Q);const J=[[T]];for(;J.length;)for(const V of J.pop()){const ie=this.d.get(V);ie&&(J.push(ie.children),this.d.delete(V),oe.remove?.(ie,ie!==Q),ie.expand===2&&this.g--)}}m(T){}updatePendingRoots(T){this.h+=T}o(){return{}}}e.$NJ=ne}),define(we[133],ve([1,0,14,5,2,97,95,72]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.TestItemEventOp=void 0;var p;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const v=(d,l)=>d===l,E=Object.entries({range:(d,l)=>d===l?!0:!d||!l?!1:d.equalsRange(l),busy:v,label:v,description:v,error:v,sortText:v,tags:(d,l)=>!(d.length!==l.length||d.some($=>!l.includes($)))}),w=(d,l)=>{let $;for(const[u,n]of E)n(d[u],l[u])||($?$[u]=l[u]:$={[u]:l[u]});return $};class f extends s.$Sc{get root(){return this.s.root}constructor(l){super(),this.s=l,this.f=this.B(new y.$bh(()=>this.flushDiff(),200)),this.g=this.B(new A.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(l){this.h=l;for(const $ of this.tree.values())this.I($)}get resolveHandler(){return this.h}collectDiff(){const l=this.m;return this.m=[],l}pushDiff(l){switch(l.op){case 2:{for(const $ of this.m)if($.op===2&&$.uri===l.uri){$.docv=l.docv;return}break}case 1:{const $=this.m[this.m.length-1];if($){if($.op===1&&$.item.extId===l.item.extId){(0,D.$LJ)($.item,l.item);return}if($.op===0&&$.item.item.extId===l.item.extId){(0,D.$LJ)($.item,l.item);return}}break}}this.m.push(l),this.f.isScheduled()||this.f.schedule()}expand(l,$){const u=this.tree.get(l);if(u){if((u.expandLevels===void 0||$>u.expandLevels)&&(u.expandLevels=$),u.expand===1){const n=this.L(u);return n.isOpen()?this.J(u,$-1):n.wait().then(()=>this.J(u,$-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.J(u,$-1)):this.J(u,$-1)}}dispose(){for(const l of this.tree.values())this.s.getApiFor(l.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(l,$){switch($.op){case 3:this.N(S.$FJ.joinToString(l.fullId,$.id));break;case 0:this.y($.item,l);break;case 5:for(const u of $.ops)this.u(l,u);break;case 1:this.z($.new,$.old,l.fullId.toString());break;case 2:this.I(l);break;case 4:this.pushDiff({op:1,item:{extId:l.fullId.toString(),item:$.update}});break;case 6:this.w(l.actual.uri);break;default:(0,P.$5c)($)}}w(l){l&&this.pushDiff({op:2,uri:l,docv:this.s.getDocumentVersion(l)})}y(l,$){const u=S.$FJ.fromExtHostTestItem(l,this.root.id,$?.actual),n=this.s.getApiFor(l);n.parent&&n.parent!==$?.actual&&this.s.getChildren(n.parent).delete(l.id);let i=this.tree.get(u.toString());if(!i){i={fullId:u,actual:l,expandLevels:$?.expandLevels?$.expandLevels-1:void 0,expand:0},l.tags.forEach(this.C,this),this.tree.set(i.fullId.toString(),i),this.F(l,$),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:i.expand,item:this.s.toITestItem(l)}}),this.H(l,i,$);return}if(i.actual===l){this.G(l,i,$);return}if(i.actual.uri?.toString()!==l.uri?.toString())return this.N(u.toString()),this.y(l,$);const o=this.s.getChildren(i.actual),r=i.actual,t=w(this.s.toITestItem(r),this.s.toITestItem(l));this.s.getApiFor(r).listener=void 0,i.actual=l,i.expand=0,t&&(t.hasOwnProperty("tags")&&(this.z(l.tags,r.tags,u.toString()),delete t.tags),this.u(i,{op:4,update:t})),this.H(l,i,$);for(const[a,b]of o)this.s.getChildren(l).get(b.id)||this.N(S.$FJ.joinToString(u,b.id));this.w(i.actual.uri)}z(l,$,u){const n=new Set($.map(i=>i.id));for(const i of l)n.delete(i.id)||this.C(i);this.pushDiff({op:1,item:{extId:u,item:{tags:l.map(i=>(0,D.$JJ)(this.s.controllerId,i.id))}}}),n.forEach(this.D,this)}C(l){const $=this.j.get(l.id);$?$.refCount++:(this.j.set(l.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.$JJ)(this.s.controllerId,l.id)}}))}D(l){const $=this.j.get(l);$&&!--$.refCount&&(this.j.delete(l),this.pushDiff({op:7,id:(0,D.$JJ)(this.s.controllerId,l)}))}F(l,$){this.s.getApiFor(l).parent=$&&$.actual!==this.root?$.actual:void 0}G(l,$,u){this.F(l,u);const n=this.s.getApiFor(l);n.parent=u?.actual,n.listener=i=>this.u($,i),this.I($)}H(l,$,u){this.G(l,$,u);for(const[n,i]of this.s.getChildren(l))this.y(i,$)}I(l){let $;this.h?l.resolveBarrier?$=l.resolveBarrier.isOpen()?3:2:$=l.actual.canResolveChildren?1:0:$=0,$!==l.expand&&(l.expand=$,this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:$}}),$===1&&l.expandLevels!==void 0&&this.L(l))}J(l,$){if($<0)return;const u=[];for(const[n,i]of this.s.getChildren(l.actual)){const o=this.expand(S.$FJ.joinToString(l.fullId,i.id),$);(0,y.$Og)(o)&&u.push(o)}if(u.length)return Promise.all(u).then(()=>{})}L(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this.h){const i=new y.$1g;return i.open(),i}l.expand=2,this.M(l);const $=l.resolveBarrier=new y.$1g,u=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,i)};let n;try{n=this.h(l.actual===this.root?void 0:l.actual)}catch(i){u(i)}return(0,y.$Og)(n)?n.catch(u).then(()=>{$.open(),this.I(l)}):($.open(),this.I(l)),l.resolveBarrier}M(l){this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:l.expand}})}N(l){const $=this.tree.get(l);if(!$)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:l});const u=[$];for(;u.length;){const n=u.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const i of n.actual.tags)this.D(i.id);this.tree.delete(n.fullId.toString());for(const[i,o]of this.s.getChildren(n.actual))u.push(this.tree.get(S.$FJ.joinToString(n.fullId,o.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.g.fire(l)}}e.$HM=f;class g extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.$IM=g;class c extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$JM=c;class m extends Error{constructor(l,$,u){super(`TestItem with ID "${l}" is from controller "${$}" and cannot be added as a child of an item from controller "${u}".`)}}e.$KM=m;const h=(d,l,$)=>{let u=new Map;return{get size(){return u.size},forEach(n,i){for(const o of u.values())n.call(i,o,this)},[Symbol.iterator](){return u.entries()},replace(n){const i=new Map,o=new Set(u.keys()),r={op:5,ops:[]};for(const t of n){if(!(t instanceof $))throw new c(t.id);const a=l(t).controllerId;if(a!==d.controllerId)throw new m(t.id,a,d.controllerId);if(i.has(t.id))throw new g(t.id);i.set(t.id,t),o.delete(t.id),r.ops.push({op:0,item:t})}for(const t of o.keys())r.ops.push({op:3,id:t});d.listener?.(r),u=i},add(n){if(!(n instanceof $))throw new c(n.id);u.set(n.id,n),d.listener?.({op:0,item:n})},delete(n){u.delete(n)&&d.listener?.({op:3,id:n})},get(n){return u.get(n)},toJSON(){return Array.from(u.values())}}};e.$LM=h}),define(we[134],ve([1,0,133]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0;const A=new WeakMap,s=(D,S)=>{const p={controllerId:S};return A.set(D,p),p};e.$MM=s;const P=D=>{const S=A.get(D);if(!S)throw new y.$JM(D?.id||"<unknown>");return S};e.$NM=P}),define(we[275],ve([1,0,24,6]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=e.$ND=e.$MD=e.$LD=e.$KD=e.$JD=e.$ID=e.$HD=void 0,e.$HD=".vscode",e.$ID="settings",e.$JD=`${e.$HD}/${e.$ID}.json`,e.$KD="vscode://schemas/settings/default",e.$LD="vscode://schemas/settings/user",e.$MD="vscode://schemas/settings/profile",e.$ND="vscode://schemas/settings/machine",e.$OD="vscode://schemas/settings/workspace",e.$PD="vscode://schemas/settings/folder",e.$QD="vscode://schemas/launch",e.$RD="vscode://schemas/tasks",e.$SD=[1],e.$TD=[2,3,4,5,6],e.$UD=[3,4,5],e.$VD=[1,...e.$UD],e.$WD=[2,3,4,5,6],e.$XD=[3,4,5,6],e.$YD=[4,5,6],e.$ZD="tasks",e.$1D="launch",e.$2D=Object.create(null),e.$2D[e.$ZD]=`${e.$HD}/${e.$ZD}.json`,e.$2D[e.$1D]=`${e.$HD}/${e.$1D}.json`,e.$3D=Object.create(null),e.$3D[e.$ZD]=`${e.$ZD}.json`,e.$4D=(0,A.$3h)(y.$vi),e.$5D=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$6D="workbench.settings.applyToAllProfiles"}),define(we[135],ve([1,0,6]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.VariableKind=e.$DN=void 0,e.$DN=(0,y.$2h)("configurationResolverService");var A;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(A||(e.VariableKind=A={}));class s extends Error{constructor(D,S){super(S),this.variable=D}}e.$EN=s}),define(we[276],ve([1,0,7,28,8,23,4,153,204,135,17]),function(he,e,y,A,s,P,D,S,p,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=void 0;class E{constructor(f,g,c,m){this.h=new Map,this.a=f,this.b=g,this.g=c,m&&(this.c=m.then(h=>this.i(h)))}i(f){if(D.$c){const g=Object.create(null);return Object.keys(f).forEach(c=>{g[c.toLowerCase()]=f[c]}),g}return f}resolveWithEnvironment(f,g,c){return this.l({env:this.i(f),userHome:void 0},g?g.uri:void 0,c)}async resolveAsync(f,g){const c={env:await this.c,userHome:await this.g};return this.l(c,f?f.uri:void 0,g)}async j(f,g,c,m){const h=P.$in(g);D.$c&&h.windows?Object.keys(h.windows).forEach(l=>h[l]=h.windows[l]):D.$d&&h.osx?Object.keys(h.osx).forEach(l=>h[l]=h.osx[l]):D.$e&&h.linux&&Object.keys(h.linux).forEach(l=>h[l]=h.linux[l]),delete h.windows,delete h.osx,delete h.linux;const d={env:await this.c,userHome:await this.g};return this.l(d,f?f.uri:void 0,h,c,m)}async resolveAnyAsync(f,g,c){return this.j(f,g,c)}async resolveAnyMap(f,g,c){const m=new Map;return{newConfig:await this.j(f,g,c,m),resolvedVariables:m}}resolveWithInteractionReplace(f,g,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(f,g,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(f,g){if(this.h.has(f))throw new Error("Variable "+f+" is contributed twice.");this.h.set(f,g)}async l(f,g,c,m,h){if(s.$Ef(c))return this.m(f,g,c,m,h);if(Array.isArray(c))return Promise.all(c.map(d=>this.l(f,g,d,m,h)));if(s.$Gf(c)){const d=Object.create(null),l=await Promise.all(Object.keys(c).map(async $=>[await this.m(f,g,$,m,h),await this.l(f,g,c[$],m,h)]));for(const[$,u]of l)d[$]=u;return d}return c}m(f,g,c,m,h){return(0,I.$Ze)(c,E.VARIABLE_REGEXP,async(d,l)=>{if(l.includes(E.VARIABLE_LHS))return d;let $=await this.o(f,d,l,g,m);return h?.set(l,$),$!==d&&s.$Ef($)&&$.match(E.VARIABLE_REGEXP)&&($=await this.m(f,g,$,m,h)),$})}n(f){return this.b?this.b.getUriLabel(f,{noPrefix:!0}):f.fsPath}async o(f,g,c,m,h){let d;const l=c.split(":");l.length>1&&(c=l[0],d=l[1]);const $=i=>{const o=this.a.getFilePath();if(o)return(0,S.$Iv)(o);throw new v.$EN(i,(0,p.localize)(0,null,g))},u=i=>{const o=$(i);if(this.a.getWorkspaceFolderPathForFile){const r=this.a.getWorkspaceFolderPathForFile();if(r)return(0,S.$Iv)(r)}throw new v.$EN(i,(0,p.localize)(1,null,g,y.$nc(o)))},n=i=>{if(d){const o=this.a.getFolderUri(d);if(o)return o;throw new v.$EN(i,(0,p.localize)(2,null,g,d))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new v.$EN(i,(0,p.localize)(3,null,g)):new v.$EN(i,(0,p.localize)(4,null,g))};switch(c){case"env":if(d){if(f.env){const i=f.env[D.$c?d.toLowerCase():d];if(s.$Ef(i))return i}return""}throw new v.$EN(v.VariableKind.Env,(0,p.localize)(5,null,g));case"config":if(d){const i=this.a.getConfigurationValue(m,d);if(s.$Nf(i))throw new v.$EN(v.VariableKind.Config,(0,p.localize)(6,null,g,d));if(s.$Gf(i))throw new v.$EN(v.VariableKind.Config,(0,p.localize)(7,null,g,d));return i}throw new v.$EN(v.VariableKind.Config,(0,p.localize)(8,null,g));case"command":return this.p(v.VariableKind.Command,g,d,h,"command");case"input":return this.p(v.VariableKind.Input,g,d,h,"input");case"extensionInstallFolder":if(d){const i=await this.a.getExtension(d);if(!i)throw new v.$EN(v.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,g,d));return this.n(i.extensionLocation)}throw new v.$EN(v.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,g));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,S.$Iv)(this.n(n(v.VariableKind.WorkspaceFolder)));case"cwd":return m||d?(0,S.$Iv)(this.n(n(v.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,S.$Iv)(y.$nc(this.n(n(v.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(f.userHome)return f.userHome;throw new v.$EN(v.VariableKind.UserHome,(0,p.localize)(11,null,g))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new v.$EN(v.VariableKind.LineNumber,(0,p.localize)(12,null,g))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new v.$EN(v.VariableKind.SelectedText,(0,p.localize)(13,null,g))}case"file":return $(v.VariableKind.File);case"fileWorkspaceFolder":return u(v.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$nc(u(v.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||d?y.$lc(this.n(n(v.VariableKind.RelativeFile)),$(v.VariableKind.RelativeFile)):$(v.VariableKind.RelativeFile);case"relativeFileDirname":{const i=y.$mc($(v.VariableKind.RelativeFileDirname));if(m||d){const o=y.$lc(this.n(n(v.VariableKind.RelativeFileDirname)),i);return o.length===0?".":o}return i}case"fileDirname":return y.$mc($(v.VariableKind.FileDirname));case"fileExtname":return y.$oc($(v.VariableKind.FileExtname));case"fileBasename":return y.$nc($(v.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=y.$nc($(v.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-y.$oc(i).length)}case"fileDirnameBasename":return y.$nc(y.$mc($(v.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||g}case"execInstallFolder":{const i=this.a.getAppRoot();return i||g}case"pathSeparator":return y.sep;default:try{const i=d?`${c}:${d}`:c;return this.p(v.VariableKind.Unknown,g,i,h,void 0)}catch{return g}}}}p(f,g,c,m,h){if(c&&m){const d=h===void 0?m[c]:m[h+":"+c];if(typeof d=="string")return d;throw new v.$EN(f,(0,p.localize)(14,null,g))}return g}}e.$SN=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[277],ve([1,0,6,94]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$TC=e.OpenEditorContext=e.GroupsOrder=e.$SC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$RC=void 0,e.$RC=(0,y.$2h)("editorGroupsService");var s;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(s||(e.GroupDirection=s={}));var P;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var D;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(D||(e.GroupLocation=D={}));var S;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(S||(e.GroupsArrangement=S={}));var p;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function v(g){const c=g;return(0,A.$AE)(c?.editor)&&(0,A.$AE)(c?.replacement)}e.$SC=v;var I;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var E;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function w(g){const c=g;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$TC=w;function f(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$UC=f}),define(we[136],ve([1,0,6,277]),function(he,e,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=e.$XC=e.$WC=e.$VC=void 0,e.$VC=(0,y.$2h)("editorService"),e.$WC=-1,e.$XC=-2;function s(P){const D=P;return typeof P=="number"||(0,A.$TC)(D)}e.$YC=s}),define(we[278],ve([1,0,275,118,92,90,135,94,136,12,224,273,91]),function(he,e,y,A,s,P,D,S,p,v,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=e.$UN=void 0,e.$UN="remoteterminal";let f=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(c,m,h,d,l,$,u,n,i,o){this.a=c,this.b=m,this.c=h,this.d=d,this.e=l,this.f=$,this.g=u,this.h=n,this.i=i,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(c,m,h,d,l,$,u,n){await this.c.whenRemoteConfigurationLoaded();const i=Object.create(null),o=h?this.d.getWorkspaceFolder(h)??void 0:void 0;let r;try{r=(await this.e.resolveAnyMap(o,{shellLaunchConfig:c,configuration:m})).resolvedVariables}catch(Y){this.h.error(Y)}if(r)for(const[Y,ee]of r.entries())(/^config:/.test(Y)||Y==="selectedText"||Y==="lineNumber")&&(i[Y]=ee);const t=[];for(const[Y,ee]of this.f.collections.entries())t.push([Y,(0,P.$yr)(ee.map),(0,P.$zr)(ee.descriptionMap)]);const a=await this.g.resolveAuthority(this.a),b=a.options&&a.options.extensionHostEnv,C=this.d.getWorkspace(),L=C.folders,k=h?this.d.getWorkspaceFolder(h):null,R=S.$IE.getOriginalUri(this.i.activeEditor,{supportSideBySide:S.SideBySideEditor.PRIMARY,filterByScheme:[v.Schemas.file,v.Schemas.vscodeUserData,v.Schemas.vscodeRemote]}),N={configuration:m,resolvedVariables:i,envVariableCollections:t,shellLaunchConfig:c,workspaceId:C.id,workspaceName:this.j.getWorkspaceLabel(C),workspaceFolders:L,activeWorkspaceFolder:k,activeFileResource:R,shouldPersistTerminal:l,options:d,cols:$,rows:u,unicodeVersion:n,resolverEnv:b};return await this.b.call("$createProcess",N)}requestDetachInstance(c,m){return this.b.call("$requestDetachInstance",[c,m])}acceptDetachInstanceReply(c,m){return this.b.call("$acceptDetachInstanceReply",[c,m])}attachToProcess(c){return this.b.call("$attachToProcess",[c])}detachFromProcess(c,m){return this.b.call("$detachFromProcess",[c,m])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(c,m){return this.b.call("$processBinary",[c,m])}start(c){return this.b.call("$start",[c])}input(c,m){return this.b.call("$input",[c,m])}acknowledgeDataEvent(c,m){return this.b.call("$acknowledgeDataEvent",[c,m])}setUnicodeVersion(c,m){return this.b.call("$setUnicodeVersion",[c,m])}shutdown(c,m){return this.b.call("$shutdown",[c,m])}resize(c,m,h){return this.b.call("$resize",[c,m,h])}clearBuffer(c){return this.b.call("$clearBuffer",[c])}getInitialCwd(c){return this.b.call("$getInitialCwd",[c])}getCwd(c){return this.b.call("$getCwd",[c])}orphanQuestionReply(c){return this.b.call("$orphanQuestionReply",[c])}sendCommandResult(c,m,h){return this.b.call("$sendCommandResult",[c,m,h])}freePortKillProcess(c){return this.b.call("$freePortKillProcess",[c])}installAutoReply(c,m){return this.b.call("$installAutoReply",[c,m])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(c){return this.b.call("$getDefaultSystemShell",[c])}getProfiles(c,m,h){return this.b.call("$getProfiles",[this.d.getWorkspace().id,c,m,h])}acceptPtyHostResolvedVariables(c,m){return this.b.call("$acceptPtyHostResolvedVariables",[c,m])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(c,m){return this.b.call("$getWslPath",[c,m])}setTerminalLayoutInfo(c){const h={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call("$setTerminalLayoutInfo",h)}updateTitle(c,m,h){return this.b.call("$updateTitle",[c,m,h])}updateIcon(c,m,h,d){return this.b.call("$updateIcon",[c,m,h,d])}refreshProperty(c,m){return this.b.call("$refreshProperty",[c,m])}updateProperty(c,m,h){return this.b.call("$updateProperty",[c,m,h])}getTerminalLayoutInfo(){const m={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",m)}reviveTerminalProcesses(c,m,h){return this.b.call("$reviveTerminalProcesses",[c,m,h])}getRevivedPtyNewId(c){return this.b.call("$getRevivedPtyNewId",[c])}serializeTerminalState(c){return this.b.call("$serializeTerminalState",[c])}};e.$VN=f,e.$VN=f=Ne([Le(2,y.$4D),Le(3,s.$$h),Le(4,D.$DN),Le(5,E.$iN),Le(6,A.$3k),Le(7,w.$lr),Le(8,p.$VC),Le(9,I.$bv)],f)}),define(we[279],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ExtHostConnectionType=void 0;var y;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(y||(e.ExtHostConnectionType=y={}));class A{constructor(E){this.pipeName=E,this.type=1}serialize(E){E[A.ENV_KEY]=this.pipeName}}e.$Lm=A,A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class s{constructor(){this.type=2}serialize(E){E[s.ENV_KEY]="1"}}e.$Mm=s,s.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(E){E[P.ENV_KEY]="1"}}e.$Nm=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function D(I){delete I[A.ENV_KEY],delete I[s.ENV_KEY],delete I[P.ENV_KEY]}function S(I,E){D(E),I.serialize(E)}e.$Om=S;function p(I){if(I[A.ENV_KEY])return v(I,new A(I[A.ENV_KEY]));if(I[s.ENV_KEY])return v(I,new s);if(I[P.ENV_KEY])return v(I,new P);throw new Error("No connection information defined in environment!")}e.$Pm=p;function v(I,E){return D(I),E}}),define(we[280],ve([1,0,15]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$qm=e.$pm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(A||(e.UIKind=A={}));var s;(function(v){v[v.VersionMismatch=55]="VersionMismatch",v[v.UnexpectedError=81]="UnexpectedError"})(s||(e.ExtensionHostExitCode=s={}));var P;(function(v){v[v.Initialized=0]="Initialized",v[v.Ready=1]="Ready",v[v.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function D(v){const I=y.$ge.alloc(1);switch(v){case 0:I.writeUInt8(1,0);break;case 1:I.writeUInt8(2,0);break;case 2:I.writeUInt8(3,0);break}return I}e.$pm=D;function S(v,I){if(v.byteLength!==1)return!1;switch(v.readUInt8(0)){case 1:return I===0;case 2:return I===1;case 3:return I===2;default:return!1}}e.$qm=S;var p;(function(v){v.Start="START_NATIVE_LOG",v.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(we[281],ve([1,0,6,5,13,269,280,57,38,23,3,2,202]),function(he,e,y,A,s,P,D,S,p,v,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.$0M=e.$9M=void 0;let f=class extends E.$Sc{constructor(h,d){super(),this.s=h,this.t=d,this.a=this.B(new A.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=I.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=d.createLogger(this.m,{id:p.$Co,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(d.onDidChangeLogLevel(l=>{(0,s.$lj)(l)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===s.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,d,l){const $=this.getTelemetryDetails(),u=new g(d,l,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}),n=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...n,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(h,d,l){this.f=h,this.g=d,this.c=l??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const d=Object.create(null);switch(d["common.extname"]=`${h.publisher}.${h.name}`,d["common.extversion"]=h.version,d["common.vscodemachineid"]=this.s.telemetryInfo.machineId,d["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,d["common.sqmid"]=this.s.telemetryInfo.sqmId,d["common.vscodeversion"]=this.s.version,d["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),d["common.product"]=this.s.environment.appHost,this.s.uiKind){case D.UIKind.Web:d["common.uikind"]="web";break;case D.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,S.$9k)((0,p.$Jo)(this.s.remote.authority)),d}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const d=this.getTelemetryDetails();this.r.forEach((l,$)=>{const u=l.filter(n=>!n.isDisposed);u.length===0?this.r.delete($):this.r.set($,u)}),this.r.forEach(l=>{for(const $ of l)$.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,d){const $=this.r.get(h.value)?.filter(n=>!n.isDisposed);if(!$)return this.r.delete(h.value),!1;let u=!1;for(const n of $)n.ignoreUnhandledExtHostErrors||(n.logError(d),u=!0);return u}};e.$9M=f,e.$9M=f=Ne([Le(0,P.$8M),Le(1,s.$kj)],f);class g{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,d,l,$,u,n,i){this.g=l,this.h=$,this.i=u,this.j=n,this.a=new A.$Sd,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(h,d){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let d="properties"in h?h.properties??{}:h;return d=(0,p.$Mo)(d,[]),this.c&&(d=(0,v.$ln)(d,this.c)),this.b||(d=(0,v.$ln)(d,this.j)),"properties"in h?h.properties=d:h=d,h}k(h,d){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(h,d),this.h.trace(h,d))}logUsage(h,d){this.d.isUsageEnabled&&this.k(h,d)}logError(h,d){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,d);else{const l={name:h.name,message:h.message,stack:h.stack,cause:h.cause},$=(0,p.$Mo)(l,[]),u=new Error($.message,{cause:$.cause});u.stack=$.stack,u.name=$.name,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f.sendErrorData(u,d),this.h.trace("exception",d)}}get apiTelemetryLogger(){if(!this.e){const h=this,d={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$0M=g;function c(m){const h=Date.now()-new Date(m).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$$M=c,e.$_M=(0,y.$2h)("IExtHostTelemetry")}),define(we[282],ve([1,0,5,3,36,232,35,6]),function(he,e,y,A,s,P,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.ActivationKind=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.ExtensionHostStartup=e.$iF=e.$hF=e.$gF=e.$fF=void 0,e.$fF=Object.freeze({identifier:new D.$hm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$gF="extensions.webWorker",e.$hF=(0,S.$2h)("extensionService");class p{constructor(u){this.dependency=u}}e.$iF=p;var v;(function($){$[$.EagerAutoStart=1]="EagerAutoStart",$[$.EagerManualStart=2]="EagerManualStart",$[$.Lazy=3]="Lazy"})(v||(e.ExtensionHostStartup=v={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,n,i){this.c=u,this.d=n.slice(0),this.e=i.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$3E.createActivationEventsMap(this.d)}}set(u,n,i){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const o=[],r=[],t=[],a=[],b=E(this.d),C=E(n),L=(ee,G)=>ee.extensionLocation.toString()===G.extensionLocation.toString()||ee.isBuiltin===G.isBuiltin||ee.isUserBuiltin===G.isUserBuiltin||ee.isUnderDevelopment===G.isUnderDevelopment;for(const ee of this.d){const G=C.get(ee.identifier);if(!G){o.push(ee.identifier),b.delete(ee.identifier);continue}if(!L(ee,G)){o.push(ee.identifier),b.delete(ee.identifier);continue}}for(const ee of n){const G=b.get(ee.identifier);if(!G){r.push(ee);continue}if(!L(G,ee)){o.push(G.identifier),b.delete(G.identifier);continue}}const k=new D.$im(this.e),R=new D.$im(i);for(const ee of this.e)R.has(ee)||t.push(ee);for(const ee of i)k.has(ee)||a.push(ee);const N=P.$3E.createActivationEventsMap(r),Y={versionId:u,toRemove:o,toAdd:r,addActivationEvents:N,myToRemove:t,myToAdd:a};return this.delta(Y),Y}delta(u){if(this.c>=u.versionId)return null;const{toRemove:n,toAdd:i,myToRemove:o,myToAdd:r}=u,t=new D.$im(n),a=new D.$im(o);for(let b=0;b<this.d.length;b++)t.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)a.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of i)this.d.push(b);for(const b of r)this.e.push(b);return this.f=null,u}containsExtension(u){for(const n of this.e)if(D.$hm.equals(n,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const n of this.d){if(!this.containsExtension(n.identifier))continue;const i=P.$3E.readActivationEvents(n);for(const o of i)u.add(o)}return u}}e.$jF=I;function E($){const u=new D.$jm;for(const n of $)u.set(n.identifier,n);return u}function w($,u){return!0}e.$kF=w;function f($,u){if(!w($,u))throw new Error(`Extension '${$.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${$.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${$.identifier.value}`)}e.$lF=f;class g{constructor(u,n,i,o){this.codeLoadingTime=u,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=o}}e.$mF=g;class c{constructor(u,n){this.description=u,this.value=n}}e.$nF=c;var m;(function($){$[$.Normal=0]="Normal",$[$.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function h($){return{type:$.isBuiltin?0:1,isBuiltin:$.isBuiltin||$.isUserBuiltin,identifier:{id:(0,s.$So)($.publisher,$.name),uuid:$.uuid},manifest:$,location:$.extensionLocation,targetPlatform:$.targetPlatform,validations:[],isValid:!0}}e.$oF=h;function d($,u){return{identifier:new D.$hm((0,s.$Qo)($.manifest.publisher,$.manifest.name)),isBuiltin:$.type===0,isUserBuiltin:$.type===1&&$.isBuiltin,isUnderDevelopment:!!u,extensionLocation:$.location,...$.manifest,uuid:$.identifier.uuid,targetPlatform:$.targetPlatform}}e.$pF=d;class l{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,n){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$qF=l}),define(we[137],ve([1,0,18,15,154,75,101,26,143,50,60,23,8,3,43,172,228,134,94,131,72,95,136,132,282]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u,n,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$QM=e.$PM=e.MarkdownString=e.$OM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ee){function Se(K){const{selectionStartLineNumber:Pe,selectionStartColumn:Oe,positionLineNumber:We,positionColumn:ze}=K,Ye=new i.$QK(Pe-1,Oe-1),ct=new i.$QK(We-1,ze-1);return new i.$SK(Ye,ct)}Ee.to=Se;function de(K){const{anchor:Pe,active:Oe}=K;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}Ee.from=de})(r||(e.Selection=r={}));var t;(function(Ee){function Se(K){if(!K)return;const{start:Pe,end:Oe}=K;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}Ee.from=Se;function de(K){if(!K)return;const{startLineNumber:Pe,startColumn:Oe,endLineNumber:We,endColumn:ze}=K;return new i.$RK(Pe-1,Oe-1,We-1,ze-1)}Ee.to=de})(t||(e.Range=t={}));var a;(function(Ee){function Se(de){switch(de){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Ee.to=Se})(a||(e.TokenType=a={}));var b;(function(Ee){function Se(K){return new i.$QK(K.lineNumber-1,K.column-1)}Ee.to=Se;function de(K){return{lineNumber:K.line+1,column:K.character+1}}Ee.from=de})(b||(e.Position=b={}));var C;(function(Ee){function Se(Pe,Oe,We){return(0,y.$Hb)((0,y.$3b)(Pe).map(ze=>de(ze,Oe,We)))}Ee.from=Se;function de(Pe,Oe,We){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:We?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:K(Pe.scheme,Oe),pattern:Fe.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:We?.isBuiltin}}function K(Pe,Oe){return Oe&&typeof Pe=="string"?Oe.transformOutgoingScheme(Pe):Pe}})(C||(e.DocumentSelector=C={}));var L;(function(Ee){function Se(K){switch(K){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Ee.from=Se;function de(K){switch(K){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Ee.to=de})(L||(e.DiagnosticTag=L={}));var k;(function(Ee){function Se(K){let Pe;return K.code&&((0,w.$Ef)(K.code)||(0,w.$If)(K.code)?Pe=String(K.code):Pe={value:String(K.code.value),target:K.code.target}),{...t.from(K.range),message:K.message,source:K.source,code:Pe,severity:N.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(R.from),tags:Array.isArray(K.tags)?(0,y.$Hb)(K.tags.map(L.from)):void 0}}Ee.from=Se;function de(K){const Pe=new i.$4K(t.to(K),K.message,N.to(K.severity));return Pe.source=K.source,Pe.code=(0,w.$Ef)(K.code)?K.code:K.code?.value,Pe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(R.to),Pe.tags=K.tags&&(0,y.$Hb)(K.tags.map(L.to)),Pe}Ee.to=de})(k||(e.Diagnostic=k={}));var R;(function(Ee){function Se(K){return{...t.from(K.location.range),message:K.message,resource:K.location.uri}}Ee.from=Se;function de(K){return new i.$3K(new i.$2K(K.resource,t.to(K)),K.message)}Ee.to=de})(R||(e.DiagnosticRelatedInformation=R={}));var N;(function(Ee){function Se(K){switch(K){case i.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}Ee.from=Se;function de(K){switch(K){case m.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Ee.to=de})(N||(e.DiagnosticSeverity=N={}));var Y;(function(Ee){function Se(K){return typeof K=="number"&&K>=i.ViewColumn.One?K-1:K===i.ViewColumn.Beside?n.$XC:n.$WC}Ee.from=Se;function de(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=de})(Y||(e.ViewColumn=Y={}));function ee(Ee){return typeof Ee.range<"u"}function G(Ee){return Ee.length===0?!0:!!ee(Ee[0])}e.$OM=G;var ne;(function(Ee){function Se(ze){return ze.map(Ee.from)}Ee.fromMany=Se;function de(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function K(ze){let Ye;if(de(ze)){const{language:ot,value:dt}=ze;Ye={value:"```"+ot+`
`+dt+"\n```\n"}}else i.$eL.isMarkdownString(ze)?Ye={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ye={value:ze}:Ye={value:""};const ct=Object.create(null);Ye.uris=ct;const Et=ot=>{try{let dt=f.URI.parse(ot,!0);dt=dt.with({query:Pe(dt.query,ct)}),ct[ot]=dt}catch{}return""},bt=new p.marked.Renderer;return bt.link=Et,bt.image=ot=>typeof ot=="string"?Et(D.$kk(ot).href):"",(0,p.marked)(Ye.value,{renderer:bt}),Ye}Ee.from=K;function Pe(ze,Ye){if(!ze)return ze;let ct;try{ct=(0,v.$xh)(ze)}catch{}if(!ct)return ze;let Et=!1;return ct=(0,E.$kn)(ct,bt=>{if(f.URI.isUri(bt)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ye[ot]=bt,Et=!0,ot}else return}),Et?JSON.stringify(ct):ze}function Oe(ze){const Ye=new i.$eL(ze.value,ze.supportThemeIcons);return Ye.isTrusted=ze.isTrusted,Ye.supportHtml=ze.supportHtml,Ye.baseUri=ze.baseUri?f.URI.from(ze.baseUri):void 0,Ye}Ee.to=Oe;function We(ze){if(ze)return typeof ze=="string"?ze:Ee.from(ze)}Ee.fromStrict=We})(ne||(e.MarkdownString=ne={}));function Z(Ee){return G(Ee)?Ee.map(Se=>({range:t.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?ne.fromMany(Se.hoverMessage):Se.hoverMessage?ne.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):Ee.map(Se=>({range:t.from(Se)}))}e.$PM=Z;function T(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?f.URI.file(Ee):Ee}e.$QM=T;var oe;(function(Ee){function Se(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?T(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Ee.from=Se})(oe||(e.ThemableDecorationAttachmentRenderOptions=oe={}));var Q;(function(Ee){function Se(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?T(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?oe.from(de.before):void 0,after:de.after?oe.from(de.after):void 0}}Ee.from=Se})(Q||(e.ThemableDecorationRenderOptions=Q={}));var te;(function(Ee){function Se(de){if(typeof de>"u")return de;switch(de){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Se})(te||(e.DecorationRangeBehavior=te={}));var J;(function(Ee){function Se(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?te.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?Q.from(de.light):void 0,dark:de.dark?Q.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?T(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?oe.from(de.before):void 0,after:de.after?oe.from(de.after):void 0}}Ee.from=Se})(J||(e.DecorationRenderOptions=J={}));var V;(function(Ee){function Se(K){return{text:K.newText,eol:K.newEol&&et.from(K.newEol),range:t.from(K.range)}}Ee.from=Se;function de(K){const Pe=new i.$WK(t.to(K.range),K.text);return Pe.newEol=typeof K.eol>"u"?void 0:et.to(K.eol),Pe}Ee.to=de})(V||(e.TextEdit=V={}));var ie;(function(Ee){function Se(K,Pe){const Oe={edits:[]};if(K instanceof i.$ZK){const We=new S.$Bc;for(const ze of K._allEntries())ze._type===1&&f.URI.isUri(ze.to)&&ze.from===void 0&&We.add(ze.to);for(const ze of K._allEntries())if(ze._type===1){let Ye;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?Ye={type:"base64",value:(0,A.$Ae)(A.$ge.wrap(ze.options.contents))}:Ye={type:"dataTransferItem",id:ze.options.contents._itemId}),Oe.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:Ye},metadata:ze.metadata})}else ze._type===2?Oe.edits.push({resource:ze.uri,textEdit:V.from(ze.edit),versionId:We.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Oe.edits.push({resource:ze.uri,textEdit:{range:t.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:We.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Oe.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Oe.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(lt.from)}})}return Oe}Ee.from=Se;function de(K){const Pe=new i.$ZK,Oe=new S.$Ac;for(const We of K.edits)if(We.textEdit){const ze=We,Ye=f.URI.revive(ze.resource),ct=t.to(ze.textEdit.range),Et=ze.textEdit.text,bt=ze.textEdit.insertAsSnippet;let ot;bt?ot=i.$YK.replace(ct,new i.$1K(Et)):ot=i.$WK.replace(ct,Et);const dt=Oe.get(Ye);dt?dt.push(ot):Oe.set(Ye,[ot])}else Pe.renameFile(f.URI.revive(We.oldResource),f.URI.revive(We.newResource),We.options);for(const[We,ze]of Oe)Pe.set(We,ze);return Pe}Ee.to=de})(ie||(e.WorkspaceEdit=ie={}));var ue;(function(Ee){const Se=Object.create(null);Se[i.SymbolKind.File]=0,Se[i.SymbolKind.Module]=1,Se[i.SymbolKind.Namespace]=2,Se[i.SymbolKind.Package]=3,Se[i.SymbolKind.Class]=4,Se[i.SymbolKind.Method]=5,Se[i.SymbolKind.Property]=6,Se[i.SymbolKind.Field]=7,Se[i.SymbolKind.Constructor]=8,Se[i.SymbolKind.Enum]=9,Se[i.SymbolKind.Interface]=10,Se[i.SymbolKind.Function]=11,Se[i.SymbolKind.Variable]=12,Se[i.SymbolKind.Constant]=13,Se[i.SymbolKind.String]=14,Se[i.SymbolKind.Number]=15,Se[i.SymbolKind.Boolean]=16,Se[i.SymbolKind.Array]=17,Se[i.SymbolKind.Object]=18,Se[i.SymbolKind.Key]=19,Se[i.SymbolKind.Null]=20,Se[i.SymbolKind.EnumMember]=21,Se[i.SymbolKind.Struct]=22,Se[i.SymbolKind.Event]=23,Se[i.SymbolKind.Operator]=24,Se[i.SymbolKind.TypeParameter]=25;function de(Pe){return typeof Se[Pe]=="number"?Se[Pe]:6}Ee.from=de;function K(Pe){for(const Oe in Se)if(Se[Oe]===Pe)return Number(Oe);return i.SymbolKind.Property}Ee.to=K})(ue||(e.SymbolKind=ue={}));var se;(function(Ee){function Se(K){switch(K){case i.SymbolTag.Deprecated:return 1}}Ee.from=Se;function de(K){switch(K){case 1:return i.SymbolTag.Deprecated}}Ee.to=de})(se||(e.SymbolTag=se={}));var me;(function(Ee){function Se(K){return{name:K.name,kind:ue.from(K.kind),tags:K.tags&&K.tags.map(se.from),containerName:K.containerName,location:re.from(K.location)}}Ee.from=Se;function de(K){const Pe=new i.$8K(K.name,ue.to(K.kind),K.containerName,re.to(K.location));return Pe.tags=K.tags&&K.tags.map(se.to),Pe}Ee.to=de})(me||(e.WorkspaceSymbol=me={}));var B;(function(Ee){function Se(K){const Pe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:t.from(K.range),selectionRange:t.from(K.selectionRange),kind:ue.from(K.kind),tags:K.tags?.map(se.from)??[]};return K.children&&(Pe.children=K.children.map(Se)),Pe}Ee.from=Se;function de(K){const Pe=new i.$9K(K.name,K.detail,ue.to(K.kind),t.to(K.range),t.to(K.selectionRange));return(0,y.$Lb)(K.tags)&&(Pe.tags=K.tags.map(se.to)),K.children&&(Pe.children=K.children.map(de)),Pe}Ee.to=de})(B||(e.DocumentSymbol=B={}));var W;(function(Ee){function Se(K){const Pe=new i.$aL(ue.to(K.kind),K.name,K.detail||"",f.URI.revive(K.uri),t.to(K.range),t.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}Ee.to=Se;function de(K,Pe,Oe){if(Pe=Pe??K._sessionId,Oe=Oe??K._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,name:K.name,detail:K.detail,kind:ue.from(K.kind),uri:K.uri,range:t.from(K.range),selectionRange:t.from(K.selectionRange),tags:K.tags?.map(se.from)}}Ee.from=de})(W||(e.CallHierarchyItem=W={}));var O;(function(Ee){function Se(de){return new i.$bL(W.to(de.from),de.fromRanges.map(K=>t.to(K)))}Ee.to=Se})(O||(e.CallHierarchyIncomingCall=O={}));var j;(function(Ee){function Se(de){return new i.$cL(W.to(de.to),de.fromRanges.map(K=>t.to(K)))}Ee.to=Se})(j||(e.CallHierarchyOutgoingCall=j={}));var re;(function(Ee){function Se(K){return{range:K.range&&t.from(K.range),uri:K.uri}}Ee.from=Se;function de(K){return new i.$2K(f.URI.revive(K.uri),t.to(K.range))}Ee.to=de})(re||(e.location=re={}));var X;(function(Ee){function Se(K){const Pe=K,Oe=K;return{originSelectionRange:Pe.originSelectionRange?t.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Oe.uri,range:t.from(Pe.targetRange?Pe.targetRange:Oe.range),targetSelectionRange:Pe.targetSelectionRange?t.from(Pe.targetSelectionRange):void 0}}Ee.from=Se;function de(K){return{targetUri:f.URI.revive(K.uri),targetRange:t.to(K.range),targetSelectionRange:K.targetSelectionRange?t.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?t.to(K.originSelectionRange):void 0}}Ee.to=de})(X||(e.DefinitionLink=X={}));var x;(function(Ee){function Se(K){return{range:t.from(K.range),contents:ne.fromMany(K.contents)}}Ee.from=Se;function de(K){return new i.$5K(K.contents.map(ne.to),t.to(K.range))}Ee.to=de})(x||(e.Hover=x={}));var z;(function(Ee){function Se(K){return{range:t.from(K.range),expression:K.expression}}Ee.from=Se;function de(K){return new i.$YL(t.to(K.range),K.expression)}Ee.to=de})(z||(e.EvaluatableExpression=z={}));var q;(function(Ee){function Se(K){if(K instanceof i.$ZL)return{type:"text",range:t.from(K.range),text:K.text};if(K instanceof i.$1L)return{type:"variable",range:t.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof i.$2L)return{type:"expression",range:t.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Se;function de(K){switch(K.type){case"text":return{range:t.to(K.range),text:K.text};case"variable":return{range:t.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:t.to(K.range),expression:K.expression}}}Ee.to=de})(q||(e.InlineValue=q={}));var M;(function(Ee){function Se(K){return{frameId:K.frameId,stoppedLocation:t.from(K.stoppedLocation)}}Ee.from=Se;function de(K){return new i.$3L(K.frameId,t.to(K.stoppedLocation))}Ee.to=de})(M||(e.InlineValueContext=M={}));var H;(function(Ee){function Se(K){return{range:t.from(K.range),kind:K.kind}}Ee.from=Se;function de(K){return new i.$6K(t.to(K.range),K.kind)}Ee.to=de})(H||(e.DocumentHighlight=H={}));var _;(function(Ee){function Se(K){return{uri:K.uri,highlights:K.highlights.map(H.from)}}Ee.from=Se;function de(K){return new i.$7K(f.URI.revive(K.uri),K.highlights.map(H.to))}Ee.to=de})(_||(e.MultiDocumentHighlight=_={}));var ae;(function(Ee){function Se(de){switch(de){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Ee.to=Se})(ae||(e.CompletionTriggerKind=ae={}));var fe;(function(Ee){function Se(de){return{triggerKind:ae.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Ee.to=Se})(fe||(e.CompletionContext=fe={}));var le;(function(Ee){function Se(K){switch(K){case i.CompletionItemTag.Deprecated:return 1}}Ee.from=Se;function de(K){switch(K){case 1:return i.CompletionItemTag.Deprecated}}Ee.to=de})(le||(e.CompletionItemTag=le={}));var $e;(function(Ee){const Se=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function de(Oe){return Se.get(Oe)??9}Ee.from=de;const K=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Pe(Oe){return K.get(Oe)??i.CompletionItemKind.Property}Ee.to=Pe})($e||(e.CompletionItemKind=$e={}));var ye;(function(Ee){function Se(de,K){const Pe=new i.$kL(de.label);return Pe.insertText=de.insertText,Pe.kind=$e.to(de.kind),Pe.tags=de.tags?.map(le.to),Pe.detail=de.detail,Pe.documentation=D.$fk(de.documentation)?ne.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,g.$Hs.isIRange(de.range)?Pe.range=t.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:t.to(de.range.insert),replacing:t.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new i.$1K(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof i.$RK?new i.$WK(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Oe=>V.to(Oe))),Pe.command=K&&de.command?K.fromInternal(de.command):void 0,Pe}Ee.to=Se})(ye||(e.CompletionItem=ye={}));var Ae;(function(Ee){function Se(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ne.fromStrict(K.documentation)}}Ee.from=Se;function de(K){return{label:K.label,documentation:D.$fk(K.documentation)?ne.to(K.documentation):K.documentation}}Ee.to=de})(Ae||(e.ParameterInformation=Ae={}));var Re;(function(Ee){function Se(K){return{label:K.label,documentation:ne.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(Ae.from):[],activeParameter:K.activeParameter}}Ee.from=Se;function de(K){return{label:K.label,documentation:D.$fk(K.documentation)?ne.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Ae.to):[],activeParameter:K.activeParameter}}Ee.to=de})(Re||(e.SignatureInformation=Re={}));var ge;(function(Ee){function Se(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Re.from):[]}}Ee.from=Se;function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Re.to):[]}}Ee.to=de})(ge||(e.SignatureHelp=ge={}));var ke;(function(Ee){function Se(de,K){const Pe=new i.$jL(b.to(K.position),typeof K.label=="string"?K.label:K.label.map(De.to.bind(void 0,de)),K.kind&&Me.to(K.kind));return Pe.textEdits=K.textEdits&&K.textEdits.map(V.to),Pe.tooltip=D.$fk(K.tooltip)?ne.to(K.tooltip):K.tooltip,Pe.paddingLeft=K.paddingLeft,Pe.paddingRight=K.paddingRight,Pe}Ee.to=Se})(ke||(e.InlayHint=ke={}));var De;(function(Ee){function Se(de,K){const Pe=new i.$iL(K.label);return Pe.tooltip=D.$fk(K.tooltip)?ne.to(K.tooltip):K.tooltip,c.Command.is(K.command)&&(Pe.command=de.fromInternal(K.command)),K.location&&(Pe.location=re.to(K.location)),Pe}Ee.to=Se})(De||(e.InlayHintLabelPart=De={}));var Me;(function(Ee){function Se(K){return K}Ee.from=Se;function de(K){return K}Ee.to=de})(Me||(e.InlayHintKind=Me={}));var Te;(function(Ee){function Se(K){return{range:t.from(K.range),url:K.target,tooltip:K.tooltip}}Ee.from=Se;function de(K){let Pe;if(K.url)try{Pe=typeof K.url=="string"?f.URI.parse(K.url,!0):f.URI.revive(K.url)}catch{}return new i.$pL(t.to(K.range),Pe)}Ee.to=de})(Te||(e.DocumentLink=Te={}));var He;(function(Ee){function Se(K){const Pe=new i.$sL(K.label);return K.textEdit&&(Pe.textEdit=V.to(K.textEdit)),K.additionalTextEdits&&(Pe.additionalTextEdits=K.additionalTextEdits.map(Oe=>V.to(Oe))),Pe}Ee.to=Se;function de(K){return{label:K.label,textEdit:K.textEdit?V.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Pe=>V.from(Pe)):void 0}}Ee.from=de})(He||(e.ColorPresentation=He={}));var Ue;(function(Ee){function Se(K){return new i.$qL(K[0],K[1],K[2],K[3])}Ee.to=Se;function de(K){return[K.red,K.green,K.blue,K.alpha]}Ee.from=de})(Ue||(e.Color=Ue={}));var Ke;(function(Ee){function Se(K){return{range:t.from(K.range)}}Ee.from=Se;function de(K){return new i.$_K(t.to(K.range))}Ee.to=de})(Ke||(e.SelectionRange=Ke={}));var tt;(function(Ee){function Se(de){switch(de){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Ee.to=Se})(tt||(e.TextDocumentSaveReason=tt={}));var Ze;(function(Ee){function Se(K){switch(K){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Se;function de(K){switch(K){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Ee.to=de})(Ze||(e.TextEditorLineNumbersStyle=Ze={}));var et;(function(Ee){function Se(K){if(K===i.EndOfLine.CRLF)return 1;if(K===i.EndOfLine.LF)return 0}Ee.from=Se;function de(K){if(K===1)return i.EndOfLine.CRLF;if(K===0)return i.EndOfLine.LF}Ee.to=de})(et||(e.EndOfLine=et={}));var be;(function(Ee){function Se(de){if(typeof de=="object")return de.viewId;switch(de){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Se})(be||(e.ProgressLocation=be={}));var Ie;(function(Ee){function Se(K){const Pe={start:K.start+1,end:K.end+1};return K.kind&&(Pe.kind=Ce.from(K.kind)),Pe}Ee.from=Se;function de(K){const Pe={start:K.start-1,end:K.end-1};return K.kind&&(Pe.kind=Ce.to(K.kind)),Pe}Ee.to=de})(Ie||(e.FoldingRange=Ie={}));var Ce;(function(Ee){function Se(K){if(K)switch(K){case i.FoldingRangeKind.Comment:return c.$xt.Comment;case i.FoldingRangeKind.Imports:return c.$xt.Imports;case i.FoldingRangeKind.Region:return c.$xt.Region}}Ee.from=Se;function de(K){if(K)switch(K.value){case c.$xt.Comment.value:return i.FoldingRangeKind.Comment;case c.$xt.Imports.value:return i.FoldingRangeKind.Imports;case c.$xt.Region.value:return i.FoldingRangeKind.Region}}Ee.to=de})(Ce||(e.FoldingRangeKind=Ce={}));var je;(function(Ee){function Se(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?t.from(de.selection):void 0,override:typeof de.override=="boolean"?d.$mE.id:void 0}}Ee.from=Se})(je||(e.TextEditorOpenOptions=je={}));var Fe;(function(Ee){function Se(Oe){return Oe instanceof i.$ML?Oe.toJSON():typeof Oe=="string"?Oe:de(Oe)||K(Oe)?new i.$ML(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}Ee.from=Se;function de(Oe){const We=Oe;return We?f.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function K(Oe){const We=Oe;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function Pe(Oe){return typeof Oe=="string"?Oe:new i.$ML(f.URI.revive(Oe.baseUri),Oe.pattern)}Ee.to=Pe})(Fe||(e.GlobPattern=Fe={}));var qe;(function(Ee){function Se(de){if(de){if(Array.isArray(de))return de.map(Se);if(typeof de=="string")return de;{const K=de;return{language:K.language,scheme:K.scheme,pattern:Fe.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ee.from=Se})(qe||(e.LanguageSelector=qe={}));var Ve;(function(Ee){function Se(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Oe=>Oe&&typeof Oe=="object"&&"uri"in Oe&&f.URI.isUri(Oe.uri)&&"version"in Oe&&typeof Oe.version=="number"&&"ranges"in Oe&&Array.isArray(Oe.ranges)&&Oe.ranges.every(We=>We instanceof i.$RK)))}Ee.is=Se;function de(K){return{documents:K.documents.map(Pe=>Pe.map(Oe=>({uri:f.URI.from(Oe.uri),version:Oe.version,ranges:Oe.ranges.map(We=>t.from(We))})))}}Ee.from=de})(Ve||(e.MappedEditsContext=Ve={}));var Qe;(function(Ee){function Se(K){return{start:K.start,end:K.end}}Ee.from=Se;function de(K){return new i.$bM(K.start,K.end)}Ee.to=de})(Qe||(e.NotebookRange=Qe={}));var Je;(function(Ee){function Se(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ee.to=Se;function de(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ee.from=de})(Je||(e.NotebookCellExecutionSummary=Je={}));var xe;(function(Ee){function Se(de){if(de===l.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(de===l.NotebookCellExecutionState.Pending)return;if(de===l.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Ee.to=Se})(xe||(e.NotebookCellExecutionState=xe={}));var rt;(function(Ee){function Se(K){switch(K){case i.NotebookCellKind.Markup:return l.CellKind.Markup;case i.NotebookCellKind.Code:default:return l.CellKind.Code}}Ee.from=Se;function de(K){switch(K){case l.CellKind.Markup:return i.NotebookCellKind.Markup;case l.CellKind.Code:default:return i.NotebookCellKind.Code}}Ee.to=de})(rt||(e.NotebookCellKind=rt={}));var Xe;(function(Ee){function Se(K){const Pe={metadata:K.metadata??Object.create(null),cells:[]};for(const Oe of K.cells)i.$cM.validate(Oe),Pe.cells.push(lt.from(Oe));return Pe}Ee.from=Se;function de(K){const Pe=new i.$dM(K.cells.map(lt.to));return(0,w.$Rf)(K.metadata)||(Pe.metadata=K.metadata),Pe}Ee.to=de})(Xe||(e.NotebookData=Xe={}));var lt;(function(Ee){function Se(K){return{cellKind:rt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Je.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(yt.from):[]}}Ee.from=Se;function de(K){return new i.$cM(rt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(yt.to):void 0,K.metadata,K.internalMetadata?Je.to(K.internalMetadata):void 0)}Ee.to=de})(lt||(e.NotebookCellData=lt={}));var at;(function(Ee){function Se(K){return{mime:K.mime,valueBytes:A.$ge.wrap(K.data)}}Ee.from=Se;function de(K){return new i.$eM(K.valueBytes.buffer,K.mime)}Ee.to=de})(at||(e.NotebookCellOutputItem=at={}));var yt;(function(Ee){function Se(K){return{outputId:K.id,items:K.items.map(at.from),metadata:K.metadata}}Ee.from=Se;function de(K){const Pe=K.items.map(at.to);return new i.$fM(Pe,K.outputId,K.metadata)}Ee.to=de})(yt||(e.NotebookCellOutput=yt={}));var gt;(function(Ee){function Se(Pe){return K(Pe)?{include:Fe.from(Pe.include)??void 0,exclude:Fe.from(Pe.exclude)??void 0}:Fe.from(Pe)??void 0}Ee.from=Se;function de(Pe){return K(Pe)?{include:Fe.to(Pe.include),exclude:Fe.to(Pe.exclude)}:Fe.to(Pe)}Ee.to=de;function K(Pe){const Oe=Pe;return Oe?!(0,w.$Nf)(Oe.include)&&!(0,w.$Nf)(Oe.exclude):!1}})(gt||(e.NotebookExclusiveDocumentPattern=gt={}));var wt;(function(Ee){function Se(de,K,Pe){const Oe=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Oe,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Ee.from=Se})(wt||(e.NotebookStatusBarItem=wt={}));var Tt;(function(Ee){function Se(de,K,Pe){const Oe=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:K.toInternal(Oe,Pe),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}Ee.from=Se})(Tt||(e.NotebookKernelSourceAction=Tt={}));var Ut;(function(Ee){function Se(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Ee.from=Se})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var Bt;(function(Ee){function Se(K){return{uri:K.uri,provides:K.provides}}Ee.from=Se;function de(K){return new i.$hM(f.URI.revive(K.uri),K.provides)}Ee.to=de})(Bt||(e.NotebookRendererScript=Bt={}));var kt;(function(Ee){function Se(K){return{message:ne.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:t.from(K.location.range),uri:K.location.uri}}}Ee.from=Se;function de(K){const Pe=new i.$nM(typeof K.message=="string"?K.message:ne.to(K.message));return Pe.actualOutput=K.actual,Pe.expectedOutput=K.expected,Pe.contextValue=K.contextValue,Pe.location=K.location?re.to(K.location):void 0,Pe}Ee.to=de})(kt||(e.TestMessage=kt={}));var ut;(function(Ee){Ee.namespace=u.$JJ,Ee.denamespace=u.$KJ})(ut||(e.TestTag=ut={}));var It;(function(Ee){function Se(K){const Pe=(0,h.$NM)(K).controllerId;return{extId:$.$FJ.fromExtHostTestItem(K,Pe).toString(),label:K.label,uri:f.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Oe=>ut.namespace(Pe,Oe.id)),range:g.$Hs.lift(t.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ne.fromStrict(K.error)||null}}Ee.from=Se;function de(K){return{parent:void 0,error:void 0,id:$.$FJ.fromString(K.extId).localId,label:K.label,uri:f.URI.revive(K.uri),tags:(K.tags||[]).map(Pe=>{const{tagId:Oe}=ut.denamespace(Pe);return new i.$oM(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:t.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ee.toPlain=de})(It||(e.TestItem=It={})),function(Ee){function Se(K){return{id:K.id}}Ee.from=Se;function de(K){return new i.$oM(K.id)}Ee.to=de}(ut||(e.TestTag=ut={}));var Ct;(function(Ee){const Se=(K,Pe)=>{const Oe=[];for(const[ze,Ye]of Pe)$.$FJ.compare(Ye.item.extId,ze)===2&&(Pe.delete(ze),Oe.push(Ye));const We={...It.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ye=>Ye.type===0).map(kt.to)})),children:Oe.map(ze=>Se(ze,Pe))};for(const ze of We.children)ze.parent=We;return We};function de(K){const Pe=[],Oe=new Map;for(const We of K.items){Oe.set(We.item.extId,We);const ze=$.$FJ.root(We.item.extId);K.request.targets.some(Ye=>Ye.controllerId===ze&&Ye.testIds.includes(We.item.extId))&&Pe.push(We)}return{completedAt:K.completedAt,results:Pe.map(We=>Se(We,Oe))}}Ee.to=de})(Ct||(e.TestResults=Ct={}));var pt;(function(Ee){function Se(Oe){return{covered:Oe.covered,total:Oe.total}}function de(Oe){return"line"in Oe?b.from(Oe):t.from(Oe)}function K(Oe){return"branches"in Oe?{count:Oe.executionCount,location:de(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(We=>({count:We.executionCount,location:We.location&&de(We.location)})):void 0}:{type:0,name:Oe.name,count:Oe.executionCount,location:de(Oe.location)}}Ee.fromDetailed=K;function Pe(Oe){return{uri:Oe.uri,statement:Se(Oe.statementCoverage),branch:Oe.branchCoverage&&Se(Oe.branchCoverage),function:Oe.functionCoverage&&Se(Oe.functionCoverage),details:Oe.detailedCoverage?.map(K)}}Ee.fromFile=Pe})(pt||(e.TestCoverage=pt={}));var zt;(function(Ee){function Se(de){switch(de){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Ee.to=Se})(zt||(e.CodeActionTriggerKind=zt={}));var St;(function(Ee){function Se(K){const Pe=new i.$uM(ue.to(K.kind),K.name,K.detail||"",f.URI.revive(K.uri),t.to(K.range),t.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}Ee.to=Se;function de(K,Pe,Oe){if(Pe=Pe??K._sessionId,Oe=Oe??K._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,kind:ue.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:t.from(K.range),selectionRange:t.from(K.selectionRange),tags:K.tags?.map(se.from)}}Ee.from=de})(St||(e.TypeHierarchyItem=St={}));var st;(function(Ee){function Se(de){if(de)return{value:de.value,tooltip:de.tooltip}}Ee.from=Se})(st||(e.ViewBadge=st={}));var ht;(function(Ee){function Se(Oe,We,ze){const Ye=We.fileData;return Ye?new i.$FL(new i.$GL(Ye.name,f.URI.revive(Ye.uri),Ye.id,(0,P.$db)(()=>ze(Ye.id)))):Oe===I.$4r.uriList&&We.uriListData?new i.$EL(Pe(We.uriListData)):new i.$EL(We.asString)}Ee.to=Se;async function de(Oe,We){const ze=await We.asString();if(Oe===I.$4r.uriList)return{asString:ze,fileData:void 0,uriListData:K(ze)};const Ye=We.asFile();return{asString:ze,fileData:Ye?{name:Ye.name,uri:Ye.uri,id:Ye._itemId??Ye.id}:void 0}}Ee.from=de;function K(Oe){return s.$et.split(Oe).map(We=>{if(We.startsWith("#"))return We;try{return f.URI.parse(We)}catch{}return We})}function Pe(Oe){return s.$et.create(Oe.map(We=>typeof We=="string"?We:f.URI.revive(We)))}})(ht||(e.DataTransferItem=ht={}));var $t;(function(Ee){function Se(K,Pe){const Oe=K.items.map(([We,ze])=>[We,ht.to(We,ze,Pe)]);return new i.$HL(Oe)}Ee.toDataTransfer=Se;async function de(K){const Pe={items:[]},Oe=[];for(const[We,ze]of K)Oe.push((async()=>{Pe.items.push([We,await ht.from(We,ze)])})());return await Promise.all(Oe),Pe}Ee.from=de})($t||(e.DataTransfer=$t={}));var ft;(function(Ee){function Se(de){return{kind:"reply",message:de.message,title:de.title,tooltip:de.tooltip}}Ee.from=Se})(ft||(e.ChatReplyFollowup=ft={}));var qt;(function(Ee){function Se(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",when:de.when??"",args:de.args}:ft.from(de)}Ee.from=Se})(qt||(e.ChatFollowup=qt={}));var Ht;(function(Ee){function Se(K){const Pe=new i.$GM(At.to(K.role),K.content);return Pe.name=K.name,Pe}Ee.to=Se;function de(K){return{role:At.from(K.role),content:K.content,name:K.name}}Ee.from=de})(Ht||(e.ChatMessage=Ht={}));var At;(function(Ee){function Se(K){switch(K){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}Ee.to=Se;function de(K){switch(K){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}Ee.from=de})(At||(e.ChatMessageRole=At={}));var Nt;(function(Ee){function Se(Pe){const Oe={};for(const We of Object.keys(Pe))Oe[We]=Pe[We].map(Ee.to);return Oe}Ee.objectTo=Se;function de(Pe){return{level:Ft.to(Pe.level),kind:Pe.kind,value:(0,v.$yh)(Pe.value),description:Pe.description}}Ee.to=de;function K(Pe){return{level:Ft.from(Pe.level),kind:Pe.kind,value:Pe.value,description:Pe.description}}Ee.from=K})(Nt||(e.ChatVariable=Nt={}));var Ft;(function(Ee){function Se(K){switch(K){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}Ee.to=Se;function de(K){switch(K){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}Ee.from=de})(Ft||(e.ChatVariableLevel=Ft={}));var Vt;(function(Ee){function Se(de){switch(de){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return i.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Se})(Vt||(e.InteractiveEditorResponseFeedbackKind=Vt={}));var Wt;(function(Ee){function Se(de,K){return"placeholder"in K&&"resolvedContent"in K?{content:K.placeholder,kind:"asyncContent"}:"markdownContent"in K?((0,o.$lF)(de,"chatAgents2Additions"),{content:ne.from(K.markdownContent),kind:"markdownContent"}):"content"in K?"vulnerabilities"in K&&K.vulnerabilities?((0,o.$lF)(de,"chatAgents2Additions"),{content:K.content,vulnerabilities:K.vulnerabilities,kind:"vulnerability"}):typeof K.content=="string"?{content:K.content,kind:"content"}:((0,o.$lF)(de,"chatAgents2Additions"),{content:ne.from(K.content),kind:"markdownContent"}):"documents"in K?{documents:K.documents.map(Pe=>({uri:Pe.uri,version:Pe.version,ranges:Pe.ranges.map(Oe=>t.from(Oe))})),kind:"usedContext"}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:t.from(K.reference.range)}:K.reference,kind:"reference"}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:t.from(K.inlineReference.range)}:K.inlineReference,name:K.title,kind:"inlineReference"}:"agentName"in K?((0,o.$lF)(de,"chatAgents2Additions"),{agentName:K.agentName,command:K.command,kind:"agentDetection"}):"treeData"in K?{treeData:K.treeData,kind:"treeData"}:"message"in K?{content:K.message,kind:"progressMessage"}:void 0}Ee.from=Se})(Wt||(e.ChatResponseProgress=Wt={}));var Mt;(function(Ee){function Se(de){return{label:de.label,values:de.values.map(Nt.from),insertText:de.insertText,detail:de.detail,documentation:de.documentation}}Ee.from=Se})(Mt||(e.ChatAgentCompletionItem=Mt={}));var Jt;(function(Ee){function Se(de,K,Pe){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:K.toInternal(de,Pe)}Ee.from=Se})(Jt||(e.TerminalQuickFix=Jt={}))}),define(we[283],ve([1,0,43,134,72,133,95,137,3]),function(he,e,y,A,s,P,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=e.$5M=e.$4M=void 0;const v=(l,$,u,n)=>{let i=$;return{enumerable:!0,configurable:!1,get(){return i},set(o){if(!u(i,o)){const r=i;i=o,l.listener?.(n(o,r))}}}},I=(l,$)=>l===$,E={range:(l,$)=>l===$?!0:!l||!$?!1:l.isEqual($),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(l,$)=>!(l.length!==$.length||l.some(u=>!$.find(n=>u.id===n.id)))},w=l=>$=>({op:4,update:l($)}),f=(l,$)=>({range:(()=>{let u;const n=w(i=>({range:y.$Hs.lift(S.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return u},set(i){l.listener?.({op:6}),E.range(u,i)||(u=i,l.listener?.(n(i)))}}})(),label:v(l,$,E.label,w(u=>({label:u}))),description:v(l,void 0,E.description,w(u=>({description:u}))),sortText:v(l,void 0,E.sortText,w(u=>({sortText:u}))),canResolveChildren:v(l,!1,E.canResolveChildren,u=>({op:2,state:u})),busy:v(l,!1,E.busy,w(u=>({busy:u}))),error:v(l,void 0,E.error,w(u=>({error:S.MarkdownString.fromStrict(u)||null}))),tags:v(l,[],E.tags,(u,n)=>({op:1,new:u.map(S.TestTag.from),old:n.map(S.TestTag.from)}))}),g=l=>{const $=s.$FJ.fromString(l.extId),u=new m($.controllerId,$.localId,l.label,p.URI.revive(l.uri)||void 0);return u.range=S.Range.to(l.range||void 0),u.description=l.description||void 0,u.sortText=l.sortText||void 0,u.tags=l.tags.map(n=>S.TestTag.to({id:(0,D.$KJ)(n).tagId})),u},c=l=>{let $;for(const u of l.tests){const n=g(u.item);(0,A.$NM)(n).parent=$,$=n}return $};e.$4M=c;class m{constructor($,u,n,i){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const o=(0,A.$MM)(this,$);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof h?void 0:o.parent}},children:{value:(0,P.$LM)(o,A.$NM,m),enumerable:!0,writable:!1},...f(o,n)})}}e.$5M=m;class h extends m{constructor($,u){super($,$,u,void 0),this._isRoot=!0}}e.$6M=h;class d extends P.$HM{constructor($,u,n){super({controllerId:$,getDocumentVersion:i=>i&&n.getDocument(i)?.version,getApiFor:A.$NM,getChildren:i=>i.children,root:new h($,u),toITestItem:S.TestItem.from})}}e.$7M=d}),define(we[284],ve([1,0,35,205,53]),function(he,e,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eO=void 0;function P(D,S,p,v){const I=new y.$jm;return D.forEach(E=>{const w=I.get(E.identifier);w&&v.warn((0,A.localize)(0,null,w.extensionLocation.fsPath,E.extensionLocation.fsPath)),I.set(E.identifier,E)}),S.forEach(E=>{const w=I.get(E.identifier);if(w)if(w.isBuiltin){if(s.gte(w.version,E.version)){v.warn(`Skipping extension ${E.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}E.isBuiltin=!0}else v.warn((0,A.localize)(1,null,w.extensionLocation.fsPath,E.extensionLocation.fsPath));else if(E.isBuiltin){v.warn(`Skipping obsolete builtin extension ${E.extensionLocation.path}`);return}I.set(E.identifier,E)}),p.forEach(E=>{v.info((0,A.localize)(2,null,E.extensionLocation.fsPath));const w=I.get(E.identifier);w&&w.isBuiltin&&(E.isBuiltin=!0),I.set(E.identifier,E)}),Array.from(I.values())}e.$eO=P}),define(we[285],ve([1,0,7,4,28,3,41,51,68,58,284,12]),function(he,e,y,A,s,P,D,S,p,v,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=e.$hO=void 0;class w{constructor(c,m,h,d,l,$,u){this.c=c,this.d=h,this.f=d,this.g=l,this.h=$,this.i=u,this.a=Promise.resolve(),this.b=Promise.resolve();const n=m.args["install-builtin-extension"];if(n){l.trace("Installing builtin extensions passed via args...");const o={isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]};D.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=c.installExtensions([],this.j(n),o,!!m.args.force).then(()=>{D.mark("code/server/didInstallBuiltinExtensions"),l.trace("Finished installing builtin extensions")},r=>{l.error(r)})}const i=m.args["install-extension"];i&&(l.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>c.installExtensions(this.j(i),[],{isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"],isApplicationScoped:!0},!!m.args.force)).then(()=>{l.trace("Finished installing extensions")},o=>{l.error(o)}))}j(c){return c.map(m=>/\.vsix$/i.test(m)?P.URI.file((0,y.$ic)(m)?m:(0,y.$jc)((0,s.cwd)(),m)):m)}whenExtensionsReady(){return this.b}async scanExtensions(c,m,h,d){D.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${c}`),await this.a;const l=h?h.filter(u=>u.scheme===E.Schemas.file).map(u=>u.fsPath):void 0;m=m??this.d.defaultProfile.extensionsResource;const $=await this.k(m,c??A.$q,l,d);return this.g.trace("Scanned Extensions",$),this.r($),D.mark("code/server/didScanExtensions"),$}async scanSingleExtension(c,m,h){await this.a;const d=c.scheme===E.Schemas.file?c.fsPath:null;if(!d)return null;const l=await this.o(d,m,h??A.$q);return l?(this.r([l]),l):null}async k(c,m,h,d){await this.q(m,d);const[l,$,u]=await Promise.all([this.m(m),this.n(c,m),this.l(m,h)]);return(0,I.$eO)(l,$,u,this.g)}async l(c,m){return m?(await Promise.all(m.map(h=>this.f.scanOneOrMultipleExtensions(P.URI.file((0,y.$kc)(h)),1,{language:c})))).flat().map(h=>(0,v.$Pp)(h,!0)):[]}async m(c){return(await this.f.scanSystemExtensions({language:c,useCache:!0})).map(h=>(0,v.$Pp)(h,!1))}async n(c,m){return(await this.f.scanUserExtensions({profileLocation:c,language:m,useCache:!0})).map(d=>(0,v.$Pp)(d,!1))}async o(c,m,h){const d=P.URI.file((0,y.$kc)(c)),l=m?0:1,$=await this.f.scanExistingExtension(d,l,{language:h});return $?(0,v.$Pp)($,!1):null}async q(c,m){if(!(c===A.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(d=>d.id===c)){this.g.trace(`Language Pack ${c} is already installed. Skipping language pack installation.`);return}}catch(h){this.g.error(h)}if(!m){this.g.trace(`No language pack id provided for language ${c}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${m} for language ${c} is not installed. It will be installed now.`);try{await this.c.installExtensions([m],[],{isMachineScoped:!0},!0)}catch(h){this.g.error(h)}}}r(c){const m=(n,i)=>n.replace(/file/g,"vscode-remote"),h=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(m(n.source,!0),i)},d=new class{mapDefined(n){return p.$5i.create(n)}mapNot(n){return p.$0i.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.$6i.create(n,m(i,!1)):p.$6i.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.$9i.create(n,m(i,!1)):p.$9i.create(n,i)}mapGreater(n,i){return p.$$i.create(n,i)}mapGreaterEquals(n,i){return p.$_i.create(n,i)}mapSmaller(n,i){return p.$aj.create(n,i)}mapSmallerEquals(n,i){return p.$bj.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?p.$cj.create(n,h(i)):p.$cj.create(n,i)}mapIn(n,i){return p.$7i.create(n,i)}mapNotIn(n,i){return p.$8i.create(n,i)}},l=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=p.$Zi.deserialize(n.when);if(!i)return;const o=i.map(d);n.when=o.serialize()},$=n=>{if(Array.isArray(n))for(const i of n)l(i);else l(n)},u=n=>{for(const i in n)$(n[i])};c.forEach(n=>{n.contributes&&(n.contributes.menus&&u(n.contributes.menus),n.contributes.keybindings&&$(n.contributes.keybindings),n.contributes.views&&u(n.contributes.views))})}}e.$hO=w;class f{constructor(c,m){this.a=c,this.b=m}listen(c,m){throw new Error("Invalid listen")}async call(c,m,h){const d=this.b(c);switch(m){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const l=h[0],$=h[1]?P.URI.revive(d.transformIncoming(h[1])):void 0,u=Array.isArray(h[2])?h[2].map(o=>P.URI.revive(d.transformIncoming(o))):void 0,n=h[3];return(await this.a.scanExtensions(l,$,u,n)).map(o=>(0,S.$2m)(o,d))}case"scanSingleExtension":{const l=await this.a.scanSingleExtension(P.URI.revive(d.transformIncoming(h[0])),h[1],h[2]);return l?(0,S.$2m)(l,d):null}}throw new Error("Invalid call")}}e.$iO=f}),define(we[138],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=e.$Cv=void 0;class y{constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++y.count}}e.$Cv=y,y.count=0;const A=[];function s(S){const p=new y(S);return A[p.nid]=p,p}e.$Dv=s;function P(S){return A[S].sid}e.$Ev=P;class D{constructor(p){this.value=p}}e.$Fv=D}),define(we[286],ve([1,0,138]),function(he,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$MK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(A||(e.TextEditorRevealType=A={}));var s;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(s||(e.TabInputKind=s={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var D;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(D||(e.WebviewEditorCapabilities=D={}));var S;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(S||(e.WebviewMessageArrayBufferViewType=S={}));var p;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var v;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(v||(e.NotebookEditorRevealType=v={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(I||(e.CandidatePortSource=I={}));class E{static mixin(m){return m._id=E.a++,m}}e.$MK=E,E.a=0;var w;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var f;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(f||(e.ISuggestResultDtoField=f={}));var g;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$NK={MainThreadAuthentication:(0,y.$Dv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$Dv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$Dv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$Dv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$Dv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$Dv)("MainThreadClipboard"),MainThreadCommands:(0,y.$Dv)("MainThreadCommands"),MainThreadComments:(0,y.$Dv)("MainThreadComments"),MainThreadConfiguration:(0,y.$Dv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$Dv)("MainThreadConsole"),MainThreadDebugService:(0,y.$Dv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$Dv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$Dv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$Dv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$Dv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$Dv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$Dv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$Dv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$Dv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$Dv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$Dv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$Dv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$Dv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$Dv)("MainThreadLanguages"),MainThreadLogger:(0,y.$Dv)("MainThreadLogger"),MainThreadMessageService:(0,y.$Dv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$Dv)("MainThreadOutputService"),MainThreadProgress:(0,y.$Dv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$Dv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$Dv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$Dv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$Dv)("MainThreadSecretState"),MainThreadStorage:(0,y.$Dv)("MainThreadStorage"),MainThreadSpeech:(0,y.$Dv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$Dv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$Dv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$Dv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$Dv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$Dv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$Dv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$Dv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$Dv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$Dv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$Dv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$Dv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$Dv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$Dv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$Dv)("MainThreadSCM"),MainThreadSearch:(0,y.$Dv)("MainThreadSearch"),MainThreadShare:(0,y.$Dv)("MainThreadShare"),MainThreadTask:(0,y.$Dv)("MainThreadTask"),MainThreadWindow:(0,y.$Dv)("MainThreadWindow"),MainThreadLabelService:(0,y.$Dv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$Dv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$Dv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$Dv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$Dv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$Dv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$Dv)("MainThreadInteractive"),MainThreadChat:(0,y.$Dv)("MainThreadChat"),MainThreadInlineChat:(0,y.$Dv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$Dv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$Dv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$Dv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$Dv)("MainThreadTimeline"),MainThreadTesting:(0,y.$Dv)("MainThreadTesting"),MainThreadLocalization:(0,y.$Dv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$Dv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$Dv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$Dv)("MainThreadIssueReporter")},e.$OK={ExtHostCommands:(0,y.$Dv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$Dv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$Dv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$Dv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$Dv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$Dv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$Dv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$Dv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$Dv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$Dv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$Dv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$Dv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$Dv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$Dv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$Dv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$Dv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$Dv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$Dv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$Dv)("ExtHostStatusBar"),ExtHostShare:(0,y.$Dv)("ExtHostShare"),ExtHostExtensionService:(0,y.$Dv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$Dv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$Dv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$Dv)("ExtHostSCM"),ExtHostSearch:(0,y.$Dv)("ExtHostSearch"),ExtHostTask:(0,y.$Dv)("ExtHostTask"),ExtHostWorkspace:(0,y.$Dv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$Dv)("ExtHostWindow"),ExtHostWebviews:(0,y.$Dv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$Dv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$Dv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$Dv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$Dv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$Dv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$Dv)("ExtHostProgress"),ExtHostComments:(0,y.$Dv)("ExtHostComments"),ExtHostSecretState:(0,y.$Dv)("ExtHostSecretState"),ExtHostStorage:(0,y.$Dv)("ExtHostStorage"),ExtHostUrls:(0,y.$Dv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$Dv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$Dv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$Dv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$Dv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$Dv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$Dv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$Dv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$Dv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$Dv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$Dv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$Dv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$Dv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$Dv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$Dv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$Dv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$Dv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$Dv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$Dv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$Dv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$Dv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$Dv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$Dv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$Dv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$Dv)("ExtHostTimeline"),ExtHostTesting:(0,y.$Dv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$Dv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$Dv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$Dv)("ExtHostIssueReporter")}});var Ot=this&&this.__classPrivateFieldSet||function(he,e,y,A,s){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!s)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?he!==e||!s:!e.has(he))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?s.call(he,y):s?s.value=y:e.set(he,y),y},it=this&&this.__classPrivateFieldGet||function(he,e,y,A){if(y==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?he!==e||!A:!e.has(he))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?A:y==="a"?A.call(he):A?A.value:e.get(he)};define(we[287],ve([1,0,8,132,137,23,286,18,13,50,43,80,3,2,6,270,283,15,138,40,62,38,281,21]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u,n,i){"use strict";var o,r,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=void 0;let a=class{constructor(N,Y,ee){o.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),t.set(this,void 0),Ot(this,o,N.getProxy(D.$NK.MainThreadCommands),"f"),this.d=Y,Ot(this,t,ee,"f"),Ot(this,r,N.getProxy(D.$NK.MainThreadTelemetry),"f"),this.converter=new b(this,G=>{const ne=this.c.get(G);return ne?.result===L.Void?ne:void 0},Y),this.f=[{processArgument(G){return(0,v.$yh)(G)}},{processArgument(G){return(0,P.$kn)(G,function(ne){if(I.$Hs.isIRange(ne))return s.Range.to(ne);if(E.$Gs.isIPosition(ne))return s.Position.to(ne);if(I.$Hs.isIRange(ne.range)&&w.URI.isUri(ne.uri))return s.location.to(ne);if(ne instanceof h.$ge)return ne.buffer.buffer;if(!Array.isArray(ne))return ne})}}]}registerArgumentProcessor(N){this.f.push(N)}registerApiCommand(N){const Y=this.registerCommand(!1,N.id,async(...ee)=>{const G=N.args.map((Z,T)=>{if(!Z.validate(ee[T]))throw new Error(`Invalid argument '${Z.name}' when running '${N.id}', received: ${typeof ee[T]=="object"?JSON.stringify(ee[T],null,"	"):ee[T]} `);return Z.convert(ee[T])}),ne=await this.executeCommand(N.internalId,...G);return N.result.convert(ne,ee,this.converter)},void 0,{description:N.description,args:N.args,returns:N.result.description});return this.c.set(N.id,N),new A.$PK(()=>{Y.dispose(),this.c.delete(N.id)})}registerCommand(N,Y,ee,G,ne,Z){if(this.d.trace("ExtHostCommands#registerCommand",Y),!Y.trim().length)throw new Error("invalid id");if(this.b.has(Y))throw new Error(`command '${Y}' already exists`);return this.b.set(Y,{callback:ee,thisArg:G,metadata:ne,extension:Z}),N&&it(this,o,"f").$registerCommand(Y),new A.$PK(()=>{this.b.delete(Y)&&N&&it(this,o,"f").$unregisterCommand(Y)})}executeCommand(N,...Y){return this.d.trace("ExtHostCommands#executeCommand",N),this.g(N,Y,!0)}async g(N,Y,ee){if(this.b.has(N))return it(this,o,"f").$fireCommandActivationEvent(N),this.h(N,Y,!1);{let G=!1;const ne=(0,P.$kn)(Y,function(Z){if(Z instanceof A.$QK)return s.Position.from(Z);if(Z instanceof A.$RK)return s.Range.from(Z);if(Z instanceof A.$2K)return s.location.from(Z);if(A.$bM.isNotebookRange(Z))return s.NotebookRange.from(Z);if(Z instanceof ArrayBuffer)return G=!0,h.$ge.wrap(new Uint8Array(Z));if(Z instanceof Uint8Array)return G=!0,h.$ge.wrap(Z);if(Z instanceof h.$ge)return G=!0,Z;if(!Array.isArray(Z))return Z});try{const Z=await it(this,o,"f").$executeCommand(N,G?new d.$Fv(ne):ne,ee);return(0,v.$yh)(Z)}catch(Z){if(Z instanceof Error&&Z.message==="$executeCommand:retry")return this.g(N,Y,!1);throw Z}}}async h(N,Y,ee){const G=this.b.get(N);if(!G)throw new Error("Unknown command");const{callback:ne,thisArg:Z,metadata:T}=G;if(T?.args)for(let Q=0;Q<T.args.length;Q++)try{(0,y.$Vf)(Y[Q],T.args[Q].constraint)}catch{throw new Error(`Running the contributed command: '${N}' failed. Illegal argument '${T.args[Q].name}' - ${T.args[Q].description}`)}const oe=$.$Od.create();try{return await ne.apply(Z,Y)}catch(Q){if(N===this.converter.delegatingCommandId){const te=this.converter.getActualCommand(...Y);te&&(N=te.command)}if(this.d.error(Q,N,G.extension?.identifier),!ee)throw Q;if(G.extension?.identifier){const te=it(this,t,"f").onExtensionError(G.extension.identifier,Q);this.d.trace("forwarded error to extension?",te,G.extension?.identifier)}throw new class extends Error{constructor(){super((0,l.$Mi)(Q)),this.id=N,this.source=G.extension?.displayName??G.extension?.name}}}finally{this.j(G,N,oe.elapsed())}}j(N,Y,ee){N.extension&&it(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:N.extension.identifier.value,id:new u.$xo(Y),duration:ee})}$executeContributedCommand(N,...Y){this.d.trace("ExtHostCommands#$executeContributedCommand",N);const ee=this.b.get(N);return ee?(Y=Y.map(G=>this.f.reduce((ne,Z)=>Z.processArgument(ne,ee.extension?.identifier),G)),this.h(N,Y,!0)):Promise.reject(new Error(`Contributed command '${N}' does not exist.`))}getCommands(N=!1){return this.d.trace("ExtHostCommands#getCommands",N),it(this,o,"f").$getCommands().then(Y=>(N&&(Y=Y.filter(ee=>ee[0]!=="_")),Y))}$getContributedCommandMetadata(){const N=Object.create(null);for(const[Y,ee]of this.b){const{metadata:G}=ee;G&&(N[Y]=G)}return Promise.resolve(N)}};e.$aN=a,o=new WeakMap,r=new WeakMap,t=new WeakMap,e.$aN=a=Ne([Le(0,c.$RM),Le(1,p.$jj),Le(2,n.$_M)],a),e.$bN=(0,g.$2h)("IExtHostCommands");class b{constructor(N,Y,ee){this.d=N,this.f=Y,this.g=ee,this.delegatingCommandId=`__vsc${(0,i.$mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(N,Y){if(!N)return;const ee={$ident:void 0,id:N.command,title:N.title,tooltip:N.tooltip};if(!N.command)return ee;const G=this.f(N.command);if(G)ee.id=G.internalId,ee.arguments=G.args.map((ne,Z)=>ne.convert(N.arguments&&N.arguments[Z]));else if((0,S.$Lb)(N.arguments)){const ne=`${N.command} /${++this.c}`;this.b.set(ne,N),Y.add((0,f.$Qc)(()=>{this.b.delete(ne),this.g.trace("CommandsConverter#DISPOSE",ne)})),ee.$ident=ne,ee.id=this.delegatingCommandId,ee.arguments=[ne],this.g.trace("CommandsConverter#CREATE",N.command,ne)}return ee}fromInternal(N){return typeof N.$ident=="string"?this.b.get(N.$ident):{command:N.id,title:N.title,arguments:N.arguments}}getActualCommand(...N){return this.b.get(N[0])}h(...N){const Y=this.getActualCommand(...N);return this.g.trace("CommandsConverter#EXECUTE",N[0],Y?Y.command:"MISSING"),Y?this.d.executeCommand(Y.command,...Y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${N[0]}`)}}e.$cN=b;class C{static Arr(N){return new C(`${N.name}_array`,`Array of ${N.name}, ${N.description}`,Y=>Array.isArray(Y)&&Y.every(ee=>N.validate(ee)),Y=>Y.map(ee=>N.convert(ee)))}constructor(N,Y,ee,G){this.name=N,this.description=Y,this.validate=ee,this.convert=G}optional(){return new C(this.name,`(optional) ${this.description}`,N=>N==null||this.validate(N),N=>N===void 0?void 0:N===null?null:this.convert(N))}with(N,Y){return new C(N??this.name,Y??this.description,this.validate,this.convert)}}e.$dN=C,C.Uri=new C("uri","Uri of a text document",R=>w.URI.isUri(R),R=>R),C.Position=new C("position","A position in a text document",R=>A.$QK.isPosition(R),s.Position.from),C.Range=new C("range","A range in a text document",R=>A.$RK.isRange(R),s.Range.from),C.Selection=new C("selection","A selection in a text document",R=>A.$SK.isSelection(R),s.Selection.from),C.Number=new C("number","",R=>typeof R=="number",R=>R),C.String=new C("string","",R=>typeof R=="string",R=>R),C.StringArray=C.Arr(C.String),C.CallHierarchyItem=new C("item","A call hierarchy item",R=>R instanceof A.$aL,s.CallHierarchyItem.from),C.TypeHierarchyItem=new C("item","A type hierarchy item",R=>R instanceof A.$uM,s.TypeHierarchyItem.from),C.TestItem=new C("testItem","A VS Code TestItem",R=>R instanceof m.$5M,s.TestItem.from);class L{constructor(N,Y){this.description=N,this.convert=Y}}e.$eN=L,L.Void=new L("no result",R=>R);class k{constructor(N,Y,ee,G,ne){this.id=N,this.internalId=Y,this.description=ee,this.args=G,this.result=ne}}e.$fN=k}),define(we[288],ve([1,0,11,2,12,219]),function(he,e,y,A,s,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZN=e.$YN=void 0,e.$YN="remoteFilesystem";class D extends P.$XN{static register(p,v,I){const E=p.getConnection();if(!E)return A.$Sc.None;const w=new A.$Rc,f=(async()=>{try{const g=await p.getRawEnvironment();g?v.registerProvider(s.Schemas.vscodeRemote,w.add(new D(g,E))):I.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(g){I.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.$0)(g))}})();return w.add(v.onWillActivateFileSystemProvider(g=>{g.scheme===s.Schemas.vscodeRemote&&g.join(f)})),w}constructor(p,v){super(v.getChannel(e.$YN),{pathCaseSensitive:p.os===3})}}e.$ZN=D}),define(we[73],ve([1,0,89,79,27,289,15,11,5,2,7,4,21,42,107]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;class c{traceSocketEvent(k,R){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,R)}constructor(k,R=""){this.f=!0,this.debugLabel=R,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent("error",{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,S.$1)(N)}},this.socket.on("error",this.a),this.b=N=>{this.traceSocketEvent("close",{hadError:N}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const R=N=>{this.traceSocketEvent("read",N),k(D.$ge.wrap(N))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(k){const R=N=>{k({type:0,hadError:N,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(k){const R=()=>{k()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,S.$1)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,S.$1)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.$Qh=c;var m;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var h;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(h||(h={}));class d extends v.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,R){this.socket.traceSocketEvent(k,R)}constructor(k,R,N,Y){super(),this.f=this.B(new p.$Sd),this.g=this.B(new p.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:N?.byteLength||0,recordInflateBytes:Y}),this.a=this.B(new l(this,R,N,Y,this.f,(ee,G)=>this.m(ee,G))),this.B(this.a.onError(ee=>{console.error(ee),(0,S.$1)(ee),this.g.fire({type:0,hadError:!0,error:ee})})),this.b=new g.$Lh,this.B(this.socket.onData(ee=>this.n(ee))),this.B(this.socket.onClose(async ee=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(ee)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let R=0;for(;R<k.byteLength;)this.a.writeMessage(k.slice(R,Math.min(R+262144,k.byteLength)),{compressed:!0,opcode:2}),R+=262144}m(k,{compressed:R,opcode:N}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let Y=2;k.byteLength<126?Y+=0:k.byteLength<2**16?Y+=2:Y+=8;const ee=D.$ge.alloc(Y),G=R?64:0,ne=N&15;if(ee.writeUInt8(128|G|ne,0),k.byteLength<126)ee.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){ee.writeUInt8(126,1);let Z=1;ee.writeUInt8(k.byteLength>>>8&255,++Z),ee.writeUInt8(k.byteLength>>>0&255,++Z)}else{ee.writeUInt8(127,1);let Z=1;ee.writeUInt8(0,++Z),ee.writeUInt8(0,++Z),ee.writeUInt8(0,++Z),ee.writeUInt8(0,++Z),ee.writeUInt8(k.byteLength>>>24&255,++Z),ee.writeUInt8(k.byteLength>>>16&255,++Z),ee.writeUInt8(k.byteLength>>>8&255,++Z),ee.writeUInt8(k.byteLength>>>0&255,++Z)}this.socket.write(D.$ge.concat([ee,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const R=this.b.peek(this.j.readLen),N=R.readUInt8(0),Y=(N&128)>>>7,ee=(N&64)>>>6,G=N&15,ne=R.readUInt8(1),Z=(ne&128)>>>7,T=ne&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=Y,this.j.firstFrameOfMessage&&(this.j.compressed=!!ee),this.j.firstFrameOfMessage=!!Y,this.j.mask=0,this.j.opcode=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const R=this.b.read(this.j.readLen),N=R.readUInt8(1),Y=(N&128)>>>7;let ee=N&127,G=1;ee===126?ee=R.readUInt8(++G)*2**8+R.readUInt8(++G):ee===127&&(ee=R.readUInt8(++G)*0+R.readUInt8(++G)*0+R.readUInt8(++G)*0+R.readUInt8(++G)*0+R.readUInt8(++G)*2**24+R.readUInt8(++G)*2**16+R.readUInt8(++G)*2**8+R.readUInt8(++G));let ne=0;Y&&(ne=R.readUInt8(++G)*2**24+R.readUInt8(++G)*2**16+R.readUInt8(++G)*2**8+R.readUInt8(++G)),this.j.state=3,this.j.readLen=ee,this.j.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const R=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),n(R,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Rh=d;class l extends v.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$ge.alloc(0)}constructor(k,R,N,Y,ee,G){super(),this.n=k,this.r=ee,this.s=G,this.a=this.B(new p.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new $(this.n,Y,N,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(k,R){this.g.push({data:k,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:R}=this.g.shift();if(this.f&&R.compressed){const N=await this.w(this.f,k);this.s(N,R)}else this.s(k,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,R){return new Promise((N,Y)=>{k.write(R),k.flush(ee=>N(ee))})}acceptFrame(k,R,N){this.h.push({data:k,isCompressed:R,isLastFrameOfMessage:N}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const R=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,R,N){return new Promise((Y,ee)=>{k.write(R),N&&k.write(D.$ge.fromByteArray([0,0,255,255])),k.flush(G=>Y(G))})}}class $ extends v.$Sc{get recordedInflateBytes(){return this.j?D.$ge.concat(this.f):D.$ge.alloc(0)}constructor(k,R,N,Y){super(),this.h=k,this.j=R,this.a=this.B(new p.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(Y),this.b.on("error",ee=>{this.h.traceSocketEvent("zlibInflateError",{message:ee?.message,code:ee?.code}),this.a.fire(ee)}),this.b.on("data",ee=>{this.h.traceSocketEvent("zlibInflateData",ee),this.g.push(D.$ge.wrap(ee))}),N&&(this.h.traceSocketEvent("zlibInflateInitialWrite",N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const R=D.$ge.concat(this.g);this.g.length=0,k(R)})}}class u extends v.$Sc{constructor(k,R){super(),this.g=k,this.a=this.B(new p.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent("zlibDeflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent("zlibDeflateData",N),this.f.push(D.$ge.wrap(N))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let R=D.$ge.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),k(R)})}}function n(L,k){if(k===0)return;const R=L.byteLength>>>2;for(let Z=0;Z<R;Z++){const T=L.readUInt32BE(Z*4);L.writeUInt32BE(T^k,Z*4)}const N=R*4,Y=L.byteLength-N,ee=k>>>24&255,G=k>>>16&255,ne=k>>>8&255;Y>=1&&L.writeUInt8(L.readUInt8(N)^ee,N),Y>=2&&L.writeUInt8(L.readUInt8(N+1)^G,N+1),Y>=3&&L.writeUInt8(L.readUInt8(N+2)^ne,N+2)}e.$Sh=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function o(){const L=(0,w.$mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const k=process.platform!=="darwin"&&e.$Sh?e.$Sh:(0,s.tmpdir)(),R=(0,I.$jc)(k,`vscode-ipc-${L}.sock`);return t(R),R}e.$Th=o;function r(L,k,R){const N=(0,y.createHash)("md5").update(L).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${R}-${k}-sock`;const Y=R.substr(0,4),ee=k.substr(0,6),G=N.substr(0,8);let ne;return process.platform!=="darwin"&&e.$Sh&&!process.env.VSCODE_PORTABLE?ne=(0,I.$jc)(e.$Sh,`vscode-${G}-${Y}-${ee}.sock`):ne=(0,I.$jc)(L,`${Y}-${ee}.sock`),t(ne),ne}e.$Uh=r;function t(L){const k=i[E.$o];typeof k=="number"&&L.length>=k&&console.warn(`WARNING: IPC handle "${L}" is longer than ${k} chars, try a shorter --user-data-dir`)}class a extends f.$Fh{static b(k){const R=p.Event.fromNodeEventEmitter(k,"connection");return p.Event.map(R,N=>({protocol:new g.$Mh(new c(N,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(N,"close"))}))}constructor(k){super(a.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Vh=a;function b(L){return new Promise((k,R)=>{const N=(0,A.createServer)();N.on("error",R),N.listen(L,()=>{N.removeListener("error",R),k(new a(N))})})}e.$Wh=b;function C(L,k){return new Promise((R,N)=>{const Y=(0,A.createConnection)(L,()=>{Y.removeListener("error",N),R(g.$Nh.fromSocket(new c(Y,`ipc-client${k}`),k))});Y.once("error",N)})}e.$Xh=C}),define(we[139],ve([1,0,87,14,15,11,8,24,25,88,13,44,236,289]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;let g=class extends E.$8o{constructor(d,l,$,u){super(u),this.m=d,this.n=l,this.r=$,this.s(),this.B(d.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const d=this.m.getValue("http");this.f=d?.proxy,this.g=!!d?.proxyStrictSSL,this.h=d?.proxyAuthorization}async request(d,l){const{f:$,g:u}=this;let n;try{n=await(0,v.$8l)(this.m,this.r,this.n.args,process.env)}catch(r){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,P.$0)(r)))}const i={...process.env,...n},o=d.agent?d.agent:await(0,w.$_q)(d.url||"",i,{proxyUrl:$,strictSSL:u});return d.agent=o,d.strictSSL=u,this.h&&(d.headers={...d.headers||{},"Proxy-Authorization":this.h}),this.c(d.isChromiumNetwork?"electron":"node",d,()=>m(d,l))}async resolveProxy(d){}async loadCertificates(){return(await new Promise((l,$)=>{he(["@vscode/proxy-agent"],l,$)})).loadSystemCertificates({log:this.r})}};e.$ar=g,e.$ar=g=Ne([Le(0,S.$vi),Le(1,p.$0h),Le(2,I.$jj),Le(3,I.$kj)],g);async function c(h){return((0,y.parse)(h.url).protocol==="https:"?await new Promise(($,u)=>{he(["https"],$,u)}):await new Promise(($,u)=>{he(["http"],$,u)})).request}async function m(h,d){return A.Promises.withAsyncBody(async(l,$)=>{const u=(0,y.parse)(h.url),n=h.getRawRequest?h.getRawRequest(h):await c(h),i={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,D.$Kf)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(i.auth=h.user+":"+h.password);const o=n(i,r=>{const t=(0,D.$If)(h.followRedirects)?h.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&t>0&&r.headers.location)m({...h,url:r.headers.location,followRedirects:t-1},d).then(l,$);else{let a=r;!h.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(a=r.pipe((0,f.createGunzip)())),l({res:r,stream:(0,s.$ve)(a)})}});o.on("error",$),h.timeout&&o.setTimeout(h.timeout),h.isChromiumNetwork&&o.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&o.write(h.data),o.end(),d.onCancellationRequested(()=>{o.abort(),$(new P.$5)})})}e.$br=m}),define(we[140],ve([1,0,52,79,93,12,7,15,5,73,88,13,46,4,61,129,2,279,24]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Qm=void 0;async function l(r={},t,a,b,C,L){const k=await(0,s.$Al)(a,b.userDataPath);let R={};if(t)try{R=await(0,I.$8l)(L,C,b.args,process.env)}catch(Z){C.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",Z)}const Y={...process.env,...R,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(k,void 0,0),...r},ee=b.isBuilt?(0,D.$jc)(b.appRoot,"bin"):(0,D.$jc)(b.appRoot,"resources","server","bin-dev"),G=(0,D.$jc)(ee,"remote-cli");let ne=n(Y,"PATH");return ne?ne=G+D.$tc+ne:ne=G,i(Y,"PATH",ne),b.args["without-browser-env-var"]||(Y.BROWSER=(0,D.$jc)(ee,"helpers",f.$c?"browser.cmd":"browser.sh")),o(Y),Y}e.$Qm=l;class ${constructor(t,a){this.socket=t,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let t,a,b;return this.socket instanceof v.$Qh?(t=!0,a=!1,b=S.$ge.alloc(0)):(t=!1,a=this.socket.permessageDeflate,b=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:t,permessageDeflate:a,inflateBytes:b.buffer.toString("base64")}}}let u=class{constructor(t,a,b,C,L,k,R,N){this.i=t,this.j=L,this.l=k,this.m=R,this.n=N,this.b=new p.$Sd,this.onClose=this.b.event,this.c=!f.$c||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new $(b,C),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(t){this.l.info(`${this.o}${t}`)}q(t){this.l.error(`${this.o}${t}`)}async r(t,a){const b=new m.$Rc;b.add(a.socket),b.add((0,m.$Qc)(()=>{t.destroy()}));const C=()=>{b.dispose()};b.add(a.socket.onEnd(C)),b.add(a.socket.onClose(C)),b.add(p.Event.fromNodeEventEmitter(t,"end")(C)),b.add(p.Event.fromNodeEventEmitter(t,"close")(C)),b.add(p.Event.fromNodeEventEmitter(t,"error")(C)),b.add(a.socket.onData(L=>t.write(L.buffer))),b.add(p.Event.fromNodeEventEmitter(t,"data")(L=>{a.socket.write(S.$ge.wrap(L))})),a.initialDataChunk.byteLength>0&&t.write(a.initialDataChunk.buffer)}async s(t,a){await a.socketDrain();const b=a.toIExtHostSocketMessage();let C;a.socket instanceof v.$Qh?C=a.socket.socket:C=a.socket.socket.socket,t.send(b,C)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const t={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(t)}acceptReconnection(t,a,b){this.f=t,this.p("The client has reconnected.");const C=new $(a,b);if(!this.g){this.h=C;return}this.s(this.g,C)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(t){try{let a=process.execArgv?process.execArgv.filter(G=>!/^--inspect(-brk)?=/.test(G)):[];t.port&&!process.pkg&&(a=[`--inspect${t.break?"-brk":""}=${t.port}`]);const b=await l(t.env,!0,t.language,this.j,this.l,this.n);(0,g.$Ol)(b);let C;if(this.c)(0,h.$Om)(new h.$Mm,b),C=null;else{const{namedPipeServer:G,pipeName:ne}=await this.u();(0,h.$Om)(new h.$Lm(ne),b),C=G}const L={env:b,execArgv:a,silent:!0};L.execArgv.unshift("--dns-result-order=ipv4first");const k=["--type=extensionHost","--transformURIs"],R=this.j.args["use-host-proxy"];k.push(`--useHostProxy=${R?"true":"false"}`),this.g=y.fork(P.$kg.asFileUri("bootstrap-fork").fsPath,k,L);const N=this.g.pid;this.p(`<${N}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const Y=p.Event.fromNodeEventEmitter(this.g.stdout,"data"),ee=p.Event.fromNodeEventEmitter(this.g.stderr,"data");if(Y(G=>this.p(`<${N}> ${G}`)),ee(G=>this.p(`<${N}><stderr> ${G}`)),this.g.on("error",G=>{this.q(`<${N}> Extension Host Process had an error`),this.l.error(G),this.t()}),this.g.on("exit",(G,ne)=>{this.m.setExitInfo(this.i,{code:G,signal:ne}),this.p(`<${N}> Extension Host Process exited with code: ${G}, signal: ${ne}.`),this.t()}),C)C.on("connection",G=>{C.close(),this.r(G,this.h)});else{const G=ne=>{ne.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",G),this.s(this.g,this.h),this.h=null)};this.g.on("message",G)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}u(){return new Promise((t,a)=>{const b=(0,v.$Th)(),C=A.createServer();C.on("error",a),C.listen(b,()=>{C?.removeListener("error",a),t({pipeName:b,namedPipeServer:C})})})}};e.$Rm=u,e.$Rm=u=Ne([Le(4,w.$Bm),Le(5,E.$jj),Le(6,c.$Jm),Le(7,d.$vi)],u);function n(r,t){const a=Object.keys(r).filter(C=>C.toLowerCase()===t.toLowerCase()),b=a.length>0?a[0]:t;return r[b]}function i(r,t,a){const b=Object.keys(r).filter(L=>L.toLowerCase()===t.toLowerCase()),C=b.length>0?b[0]:t;r[C]=a}function o(r){for(const t of Object.keys(r))r[t]===null&&delete r[t]}}),define(we[290],ve([1,0,85,13,67,117,24,44,139,38,32,30,127,125,84,111,55,2,112,69,12,16,31,46,120,86,121,11,3,7,28,234,83,34,124,66,4,58,130,33,45,70,128,126,114,115,199,291]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u,n,i,o,r,t,a,b,C,L,k,R,N,Y,ee,G,ne,Z,T,oe,Q,te,J,V,ie,ue,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class me extends h.$Sc{constructor(j,re){super(),this.a=j,this.b=re,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const j=await this.f();await j.invokeFunction(async re=>{const X=re.get(D.$vi),x=re.get(A.$jj);G.$c&&(X.getValue("security.restrictUNCAccess")===!1?(0,se.disableUNCAccessRestrictions)():(0,se.addUNCHostToAllowlist)(X.getValue("security.allowedUNCHosts")));try{await this.g(j.createInstance(o.$up,new A.$rj(x.getLevel(),!1)))}catch(z){throw x.error(z),console.error((0,a.$0)(z)),z}})}async f(){const j=new y.$Zh,re={_serviceBrand:void 0,...m.default};j.set(n.$Bj,re);const X=new i.$Cm(this.a,re);j.set(i.$Bm,X);const x=new ie.$6N((0,A.$xj)(X),X.logsHome);j.set(A.$kj,x);const z=new V.$dO(this.B(x.createLogger("remoteCLI",{name:(0,ue.localize)(0,null)})));j.set(A.$jj,z),z.trace(`Remote configuration data at ${this.b}`),z.trace("process arguments:",this.a);const q=this.B(new d.$2p(z));j.set(u.$lk,q),q.registerProvider($.Schemas.file,this.B(new l.$oq(z)));const M=new Y.$Nr(q);j.set(N.$Vk,M);const H=this.B(new te.$bO(M,X,q,z));j.set(T.$Xk,H);const _=this.B(new P.$Yn(H.defaultProfile.settingsResource,q,new Q.$yn,z));return j.set(D.$vi,_),await Promise.all([_.initialize(),H.init()]),j.set(S.$7o,new s.$Yh(p.$ar)),j.set(R.$3n,new s.$Yh(k.$wO)),j.set(I.$pl,v.$zo),j.set(E.$lo,new s.$Yh(w.$rp)),j.set(oe.$Ip,new s.$Yh(J.$cO)),j.set(ne.$Mp,new s.$Yh(Z.$1N)),j.set(g.$sp,new s.$Yh(g.$tp)),j.set(f.$Wp,new s.$Yh(f.$Xp)),j.set(r.$7q,new s.$Yh(t.$9q)),new c.$rq(j)}async g(j){if(this.a["list-extensions"])return j.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const re={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return j.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),re,!!this.a.force)}else{if(this.a["uninstall-extension"])return j.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return j.locateExtension(this.a["locate-extension"])}}h(j){return j.map(re=>/\.vsix$/i.test(re)?b.URI.file((0,C.$ic)(re)?re:(0,C.$jc)((0,L.cwd)(),re)):re)}}function B(O){setTimeout(()=>process.exit(O),0)}async function W(O,j,re){if(O.help){const x=m.default.serverApplicationName+(G.$c?".cmd":"");console.log((0,ee.$Wl)(m.default.nameLong,x,m.default.version,re,{noInputFiles:!0,noPipe:!0}));return}if(O.version){console.log((0,ee.$Xl)(m.default.version,m.default.commit));return}const X=new me(O,j);try{await X.run(),B(0)}catch{B(1)}finally{X.dispose()}}e.run=W}),define(we[292],ve([1,0,73,267,29,287,3,13,92]),function(he,e,y,A,s,P,D,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;class v{constructor(w,f,g){this.b=w,this.c=f,this.f=g,this.a=A.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(f.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,f){const g=(m,h)=>{f.writeHead(m,{"content-type":"application/json"}),f.end(JSON.stringify(h||null),d=>d&&this.c.error(d))},c=[];w.setEncoding("utf8"),w.on("data",m=>c.push(m)),w.on("end",async()=>{try{const m=JSON.parse(c.join(""));let h;switch(m.type){case"open":h=await this.i(m);break;case"openExternal":h=await this.j(m);break;case"status":h=await this.l(m);break;case"extensionManagement":h=await this.k(m);break;default:g(404,`Unknown message type: ${m.type}`);break}g(200,h)}catch(m){const h=m instanceof Error?m.message:JSON.stringify(m);g(500,h),this.c.error("Error while processing pipe request",m)}})}async i(w){const{fileURIs:f,folderURIs:g,forceNewWindow:c,diffMode:m,mergeMode:h,addMode:d,forceReuseWindow:l,gotoLineMode:$,waitMarkerFilePath:u,remoteAuthority:n}=w,i=[];if(Array.isArray(g))for(const a of g)try{i.push({folderUri:D.URI.parse(a)})}catch{}if(Array.isArray(f))for(const a of f)try{(0,p.$ui)(a)?i.push({workspaceUri:D.URI.parse(a)}):i.push({fileUri:D.URI.parse(a)})}catch{}const o=u?D.URI.file(u):void 0,t={forceNewWindow:c,diffMode:m,mergeMode:h,addMode:d,gotoLineMode:$,forceReuseWindow:l,preferNewWindow:!l&&!o&&!d,waitMarkerFileURI:o,remoteAuthority:n};this.b.executeCommand("_remoteCLI.windowOpen",i,t)}async j(w){for(const f of w.uris){const g=D.URI.parse(f),c=g.scheme==="file"?g:f;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(w){const f=c=>c?.map(m=>/\.vsix$/i.test(m)?D.URI.parse(m):m),g={list:w.list,install:f(w.install),uninstall:f(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",g)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&s.existsSync(this.f)&&s.unlinkSync(this.f)}}e.$gN=v;let I=class extends v{constructor(w,f){super(w,f,(0,y.$Th)())}};e.$hN=I,e.$hN=I=Ne([Le(0,P.$bN),Le(1,S.$jj)],I)}),define(we[293],ve([1,0,27,5,23,2,7,4,3,73,71,292,123,90,274,276,140]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;class h extends c.$SN{constructor($,u,n,i,o){super({getFolderUri:r=>{const t=u.filter(a=>a.name===r);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(r,t)=>i[`config:${t}`],getExecPath:()=>$.VSCODE_EXEC_PATH,getAppRoot:()=>$.VSCODE_CWD,getFilePath:()=>{if(n)return D.$hc(n.fsPath)},getSelectedText:()=>i.selectedText,getLineNumber:()=>i.lineNumber,getExtension:async r=>{const a=(await o.getInstalled()).find(b=>b.identifier.id===r);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve($))}}class d extends P.$Sc{constructor($,u,n,i,o,r){super(),this.g=$,this.h=u,this.j=n,this.m=i,this.n=o,this.r=r,this.a=0,this.b=new Map,this.c=this.B(new A.$Sd),this.onExecuteCommand=this.c.event}async call($,u,n){switch(u){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,n);case"$createProcess":{const i=(0,I.$Or)($.remoteAuthority);return this.s(i,n)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,n);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,n);case"$listProcesses":return this.j.listProcesses.apply(this.j,n);case"$getLatency":return this.j.getLatency.apply(this.j,n);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,n);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,n);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,n);case"$start":return this.j.start.apply(this.j,n);case"$input":return this.j.input.apply(this.j,n);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,n);case"$shutdown":return this.j.shutdown.apply(this.j,n);case"$resize":return this.j.resize.apply(this.j,n);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,n);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,n);case"$getCwd":return this.j.getCwd.apply(this.j,n);case"$processBinary":return this.j.processBinary.apply(this.j,n);case"$sendCommandResult":return this.u(n[0],n[1],n[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,n);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,n);case"$getDefaultSystemShell":return this.w.apply(this,n);case"$getProfiles":return this.y.apply(this,n);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(n[0],n[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,n);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,n);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,n);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,n);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,n);case"$updateTitle":return this.j.updateTitle.apply(this.j,n);case"$updateProperty":return this.j.updateProperty.apply(this.j,n);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,n);case"$requestDetachInstance":return this.j.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(n[0],n[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,n);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,n)}throw new Error(`IPC Command ${u} not found`)}listen($,u,n){switch(u){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||A.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||A.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||A.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||A.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||A.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||A.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${u} not found`)}async s($,u){const n={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd=="string"||typeof u.shellLaunchConfig.cwd>"u"?u.shellLaunchConfig.cwd:p.URI.revive($.transformIncoming(u.shellLaunchConfig.cwd)),env:u.shellLaunchConfig.env,useShellEnvironment:u.shellLaunchConfig.useShellEnvironment,reconnectionProperties:u.shellLaunchConfig.reconnectionProperties,type:u.shellLaunchConfig.type,isFeatureTerminal:u.shellLaunchConfig.isFeatureTerminal},i=await(0,m.$Qm)(u.resolverEnv,!!u.shellLaunchConfig.useShellEnvironment,S.$q,this.g,this.h,this.r);this.h.trace("baseEnv",i);const o=Z=>({uri:p.URI.revive($.transformIncoming(Z.uri)),name:Z.name,index:Z.index,toResource:()=>{throw new Error("Not implemented")}}),r=u.workspaceFolders.map(o),t=u.activeWorkspaceFolder?o(u.activeWorkspaceFolder):void 0,a=u.activeFileResource?p.URI.revive($.transformIncoming(u.activeFileResource)):void 0,b=new h(i,r,a,u.resolvedVariables,this.n),C=g.$ON(t,process.env,b),L=await g.$NN(n,y.homedir(),C,t?.uri,u.configuration["terminal.integrated.cwd"],this.h);n.cwd=L;const k=S.$c?"terminal.integrated.env.windows":S.$d?"terminal.integrated.env.osx":"terminal.integrated.env.linux",R=u.configuration[k],N=await g.$PN(n,R,C,this.m.version,u.configuration["terminal.integrated.detectLocale"],i);if(!n.strictEnv){const Z=[];for(const[te,J,V]of u.envVariableCollections)Z.push([te,{map:(0,f.$Ar)(J),descriptionMap:(0,f.$Br)(V)}]);const T=new Map(Z),oe=new w.$Er(T),Q=t?t??void 0:void 0;await oe.applyToProcessEnvironment(N,{workspaceFolder:Q},C)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:L,cols:u.cols,rows:u.rows,env:N});const Y=(0,v.$Th)();N.VSCODE_IPC_HOOK_CLI=Y;const ee=await this.j.createProcess(n,L,u.cols,u.rows,u.unicodeVersion,N,i,u.options,u.shouldPersistTerminal,u.workspaceId,u.workspaceName),G={executeCommand:(Z,...T)=>this.t(ee,Z,T,$)},ne=new E.$gN(G,this.h,Y);return this.j.onProcessExit(Z=>Z.id===ee&&ne.dispose()),{persistentTerminalId:ee,resolvedShellLaunchConfig:n}}t($,u,n,i){let o,r;const t=new Promise((C,L)=>{o=C,r=L}),a=++this.a;this.b.set(a,{resolve:o,reject:r,uriTransformer:i});const b=(0,s.$kn)(n,C=>{if(C&&C.$mid===1)return i.transformOutgoing(C);if(C&&C instanceof p.URI)return i.transformOutgoingURI(C)});return this.c.fire({reqId:a,persistentProcessId:$,commandId:u,commandArgs:b}),t}u($,u,n){const i=this.b.get($);if(!i)return;this.b.delete($);const o=(0,s.$kn)(n,r=>{if(r&&r.$mid===1)return i.uriTransformer.transformIncoming(r)});u?i.reject(o):i.resolve(o)}w($){return this.j.getDefaultSystemShell($)}async y($,u,n,i){return this.j.getProfiles($,u,n,i)||[]}z(){return{...process.env}}C($,u){return this.j.getWslPath($,u)}D(){return this.j.reduceConnectionGraceTime()}}e.$TN=d}),define(we[294],ve([1,0,27,5,2,12,7,102,22,42,24,117,207,83,208,25,127,30,84,120,218,125,16,112,69,67,111,85,86,121,13,55,31,44,235,139,119,32,38,250,91,258,34,124,271,272,240,247,293,71,46,278,288,129,58,130,45,33,266,70,248,115,128,126,114,113,201,285,231,262,255]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u,n,i,o,r,t,a,b,C,L,k,R,N,Y,ee,G,ne,Z,T,oe,Q,te,J,V,ie,ue,se,me,B,W,O,j,re,X,x,z,q,M,H,_,ae,fe,le,$e,ye,Ae,Re,ge,ke,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nO=e.$mO=void 0;const Me="monacoworkbench";async function Te(Ie,Ce,je,Fe){const qe=new a.$Zh,Ve=new Ke,Qe={_serviceBrand:void 0,...k.default};qe.set(R.$Bj,Qe);const Je=new W.$Cm(Ce,Qe);qe.set(c.$9h,Je),qe.set(c.$0h,Je);const xe=new ae.$6N((0,L.$xj)(Je),Je.logsHome);qe.set(L.$kj,xe),Ve.registerChannel("logger",new ye.$nr(xe,st=>Ue(st.remoteAuthority)));const rt=xe.createLogger("remoteagent",{name:(0,Ae.localize)(0,null)}),Xe=new $e.$dO(rt,[new tt((0,L.$xj)(Je))]);qe.set(L.$jj,Xe),setTimeout(()=>be(Je.logsHome.with({scheme:P.Schemas.file}).fsPath).then(null,st=>Xe.error(st)),1e4),Xe.onDidChangeLogLevel(st=>(0,L.log)(Xe,st,`Log level changed to ${(0,L.$yj)(Xe.getLevel())}`)),Xe.trace(`Remote configuration data at ${je}`),Xe.trace("process arguments:",Je.args),Array.isArray(Qe.serverGreeting)&&Xe.info(`

${Qe.serverGreeting.join(`
`)}

`),Ve.registerChannel(w.$1n.ChannelName,new w.$1n);const lt=new v.$Jh(st=>st.clientId==="renderer"),at=Fe.add(new i.$2p(Xe));qe.set(n.$lk,at),at.registerProvider(P.Schemas.file,Fe.add(new o.$oq(Xe)));const yt=new J.$Nr(at);qe.set(te.$Vk,yt);const gt=new E.$Yn(Je.machineSettingsResource,at,new H.$yn,Xe);qe.set(I.$vi,gt);const wt=new fe.$bO(yt,Je,at,Xe);qe.set(q.$Xk,wt),Ve.registerChannel("userDataProfiles",new ke.$jO(wt,st=>Ue(st.remoteAuthority)));const[,,Tt,Ut]=await Promise.all([gt.initialize(),wt.init(),(0,S.$7m)(Xe.error.bind(Xe)),(0,S.$8m)(Xe.error.bind(Xe))]),Bt=new re.$Km;qe.set(re.$Jm,Bt);const kt=new ee.$ar(gt,Je,Xe,xe);qe.set(N.$7o,kt);let ut=Z.$Do;const It=(0,Z.$Ko)(Qe,gt);if((0,Z.$Fo)(Qe,Je)){const st=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";st?ut=new _.$4N(kt,!1,Me,null,()=>new M.$2N(st)):!(0,Z.$Go)(Qe,Je)&&Qe.aiConfig?.ariaKey&&(ut=new _.$4N(kt,It,Me,null,Qe.aiConfig.ariaKey),Fe.add((0,s.$Qc)(()=>ut?.flush())));const ht={appenders:[ut],commonProperties:(0,G.$vo)((0,y.release)(),(0,y.hostname)(),process.arch,Qe.commit,Qe.version+"-remote",Tt,Ut,It,"remoteAgent"),piiPaths:(0,Z.$Lo)(Je)},$t=Je.args["telemetry-level"];let ft=3;$t==="all"?ft=3:$t==="error"?ft=2:$t==="crash"?ft=1:$t!==void 0&&(ft=0),qe.set(se.$2r,new r.$Yh(se.$Zr,[ht,ft]))}else qe.set(se.$2r,se.$1r);qe.set(h.$lo,new r.$Yh(m.$rp));const Ct=Ve.getChannel("download",lt);qe.set(f.$3n,new g.$5n(Ct,()=>Ue("renderer"))),qe.set(z.$Ip,new r.$Yh(le.$cO)),qe.set(X.$Mp,new r.$Yh(x.$1N)),qe.set(d.$sp,new r.$Yh(d.$tp)),qe.set(u.$Wp,new r.$Yh(u.$Xp));const pt=new t.$rq(qe);qe.set(b.$7q,pt.createInstance(C.$9q));const zt=pt.createInstance(De.$lO,{graceTime:108e5,shortGraceTime:3e5,scrollback:gt.getValue("terminal.integrated.persistentSessionScrollback")??100}),St=pt.createInstance(Q.$Jr,zt);return qe.set(oe.$ir,St),pt.invokeFunction(st=>{const ht=st.get(u.$Wp),$t=st.get(X.$Mp),ft=st.get(h.$lo),qt=st.get(b.$7q),Ht=new V.$Vr(Ie,Je,wt,Bt);Ve.registerChannel("remoteextensionsenvironment",Ht);const At=new ue.$3r(st.get(se.$2r),ut);Ve.registerChannel("telemetry",At),Ve.registerChannel(O.$UN,new me.$TN(Je,Xe,St,Qe,ht,gt));const Nt=new Re.$hO(pt.createInstance(l.$up,Xe),Je,wt,$t,Xe,ft,qt);Ve.registerChannel(ge.$gO,new Re.$iO(Nt,Mt=>Ue(Mt.remoteAuthority)));const Ft=new ie.$Yr(Xe,Je);Ve.registerChannel(j.$YN,Ft),Ve.registerChannel("request",new Y.$0q(st.get(N.$7o)));const Vt=new $.$vp(ht,Mt=>Ue(Mt.remoteAuthority));Ve.registerChannel("extensions",Vt);const Wt=v.ProxyChannel.fromService(st.get(b.$7q),Fe);return Ve.registerChannel("languagePacks",Wt),Nt.whenExtensionsReady().then(()=>ht.cleanUp()),Fe.add(new T.default(st.get(ne.$pl))),{telemetryService:st.get(ne.$pl)}}),{socketServer:Ve,instantiationService:pt}}e.$mO=Te;const He=Object.create(null);function Ue(Ie){return He[Ie]||(He[Ie]=(0,B.$Or)(Ie)),He[Ie]}class Ke extends v.$Fh{constructor(){const Ce=new A.$Sd;super(Ce.event),this.b=Ce}acceptConnection(Ce,je){this.b.fire({protocol:Ce,onDidClientDisconnect:je})}}e.$nO=Ke;class tt extends L.$oj{constructor(Ce=L.$mj){super(),this.setLevel(Ce),this.g=!!process.stdout.isTTY}trace(Ce,...je){this.f(L.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,Ce,...je):console.log(`[${Ze()}]`,Ce,...je))}debug(Ce,...je){this.f(L.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,Ce,...je):console.log(`[${Ze()}]`,Ce,...je))}info(Ce,...je){this.f(L.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,Ce,...je):console.log(`[${Ze()}]`,Ce,...je))}warn(Ce,...je){this.f(L.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ze()}]\x1B[0m`,Ce,...je):console.warn(`[${Ze()}]`,Ce,...je))}error(Ce,...je){this.f(L.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ze()}]\x1B[0m`,Ce,...je):console.error(`[${Ze()}]`,Ce,...je))}dispose(){}flush(){}}function Ze(){const Ie=new Date;return`${et(Ie.getHours())}:${et(Ie.getMinutes())}:${et(Ie.getSeconds())}`}function et(Ie){return Ie<10?`0${Ie}`:String(Ie)}async function be(Ie){const Ce=D.$nc(Ie),je=D.$mc(Ie),Ve=(await p.Promises.readdir(je)).filter(Je=>/^\d{8}T\d{6}$/.test(Je)).sort().filter(Je=>Je!==Ce),Qe=Ve.slice(0,Math.max(0,Ve.length-9));await Promise.all(Qe.map(Je=>p.Promises.rm(D.$jc(je,Je))))}}),define(we[295],ve([1,0,89,29,79,296,87,96,15,11,39,2,12,7,41,4,17,3,21,157,159,291,107,73,24,6,13,31,57,32,140,263,264,46,294,268]),function(he,e,y,A,s,P,D,S,p,v,I,E,w,f,g,c,m,h,d,l,$,u,n,i,o,r,t,a,b,C,L,k,R,N,Y,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=void 0;const G=5*60*1e3;let ne=class extends E.$Sc{constructor(Q,te,J,V,ie,ue,se,me){super(),this.n=Q,this.r=te,this.s=J,this.t=ie,this.u=ue,this.w=se,this.y=me,this.h=T.create(this.u),this.j=(0,b.$0k)(ue),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=V?this.y.createInstance(ee.$qO,this.r):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(Q,te){if(Q.method!=="GET")return(0,ee.$oO)(Q,te,405,`Unsupported method ${Q.method}`);if(!Q.url)return(0,ee.$oO)(Q,te,400,"Bad request.");const J=D.parse(Q.url,!0);let V=J.pathname;if(!V)return(0,ee.$oO)(Q,te,400,"Bad request.");if(V.startsWith(this.j)&&V.charCodeAt(this.j.length)===47&&(V=V.substring(this.j.length)),V==="/version")return te.writeHead(200,{"Content-Type":"text/plain"}),void te.end(this.u.commit||"");if(V==="/delay-shutdown")return this.N(),te.writeHead(200),void te.end("OK");if(!(0,R.$Ym)(this.r,Q,J))return(0,ee.$oO)(Q,te,403,"Forbidden.");if(V==="/vscode-remote-resource"){const ie=J.query.path;if(typeof ie!="string")return(0,ee.$oO)(Q,te,400,"Bad request.");let ue;try{ue=h.URI.from({scheme:w.Schemas.file,path:ie}).fsPath}catch{return(0,ee.$oO)(Q,te,400,"Bad request.")}const se=Object.create(null);this.t.isBuilt&&((0,I.$4f)(ue,this.t.builtinExtensionsPath,!c.$e)||(0,I.$4f)(ue,this.t.extensionsPath,!c.$e))&&(se["Cache-Control"]="public, max-age=31536000"),se.Vary="Origin";const me=Q.headers.origin;return me&&this.h.matches(me)&&(se["Access-Control-Allow-Origin"]=me),(0,ee.$pO)(ue,1,this.w,Q,te,se)}if(this.g){this.g.handle(Q,te,J);return}return te.writeHead(404,{"Content-Type":"text/plain"}),void te.end("Not found")}handleUpgrade(Q,te){let J=(0,d.$mg)(),V=!1,ie=!1;if(Q.url){const O=D.parse(Q.url,!0).query;typeof O.reconnectionToken=="string"&&(J=O.reconnectionToken),O.reconnection==="true"&&(V=!0),O.skipWebSocketFrames==="true"&&(ie=!0)}if(Q.headers.upgrade===void 0||Q.headers.upgrade.toLowerCase()!=="websocket"){te.end("HTTP/1.1 400 Bad Request");return}const ue=Q.headers["sec-websocket-key"],se=y.createHash("sha1");se.update(ue+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const B=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${se.digest("base64")}`];let W=!1;if(!ie&&!this.t.args["disable-websocket-compression"]&&Q.headers["sec-websocket-extensions"]){const O=Array.isArray(Q.headers["sec-websocket-extensions"])?Q.headers["sec-websocket-extensions"]:[Q.headers["sec-websocket-extensions"]];for(const j of O)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(j)){if(/\b(permessage-deflate)\b/.test(j)){W=!0,B.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(j)){W=!0,B.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}te.write(B.join(`\r
`)+`\r
\r
`),te.setTimeout(0),te.setNoDelay(!0),ie?this.D(new i.$Qh(te,`server-connection-${J}`),V,J):this.D(new i.$Rh(new i.$Qh(te,`server-connection-${J}`),W,null,!0),V,J)}handleServerError(Q){this.w.error("Error occurred in server"),this.w.error(Q)}z(Q){let te;return Q instanceof i.$Qh?te=Q.socket:te=Q.socket.socket,te.remoteAddress||"<unknown>"}async C(Q,te,J){const V=te.getSocket();this.w.error(`${Q} ${J}.`);const ie={type:"error",reason:J};te.sendControl(p.$ge.fromString(JSON.stringify(ie))),te.dispose(),await V.drain(),V.dispose()}D(Q,te,J){const V=this.z(Q),ie=`[${V}][${J.substr(0,8)}]`,ue=new n.$Ph({socket:Q}),se=this.s?new this.s.validator:null,me=this.s?new this.s.signer:null;let B;(function(re){re[re.WaitingForAuth=0]="WaitingForAuth",re[re.WaitingForConnectionType=1]="WaitingForConnectionType",re[re.Done=2]="Done",re[re.Error=3]="Error"})(B||(B={}));let W=0;const O=re=>{W=3,j.dispose(),this.C(ie,ue,re)},j=ue.onControlMessage(re=>{if(W===0){let X;try{X=JSON.parse(re.toString())}catch{return O("Malformed first message")}if(X.type!=="auth")return O("Invalid first message");if(this.r.type===2&&!this.r.validate(X.auth))return O("Unauthorized client refused: auth mismatch");let x=(0,d.$mg)();if(me)try{x=me.sign(X.data)}catch{}let z=(0,d.$mg)();if(se)try{z=se.createNewMessage(z)}catch{}const q={type:"sign",data:z,signedData:x};ue.sendControl(p.$ge.fromString(JSON.stringify(q))),W=1}else if(W===1){let X;try{X=JSON.parse(re.toString())}catch{return O("Malformed second message")}if(X.type!=="connectionType")return O("Invalid second message");if(typeof X.signedData!="string")return O("Invalid second message field type");const x=X.commit,z=this.u.commit;if(x&&z&&x!==z)return O("Client refused: version mismatch");let q=!1;if(!se)q=!0;else if(this.r.validate(X.signedData))q=!0;else try{q=se.validate(X.signedData)==="ok"}catch{}if(!q){if(this.t.isBuilt)return O("Unauthorized client refused");this.w.error(`${ie} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const M in this.b)this.b[M].shortenReconnectionGraceTimeIfNecessary();for(const M in this.a)this.a[M].shortenReconnectionGraceTimeIfNecessary();W=2,j.dispose(),this.F(V,ie,ue,Q,te,J,X)}})}async F(Q,te,J,V,ie,ue,se){const me=se.desiredConnectionType===1?`${te}[ManagementConnection]`:se.desiredConnectionType===2?`${te}[ExtensionHostConnection]`:te;if(se.desiredConnectionType===1)if(ie){if(!this.b[ue])return this.f.has(ue)?this.C(me,J,"Unknown reconnection token (seen before)"):this.C(me,J,"Unknown reconnection token (never seen)");J.sendControl(p.$ge.fromString(JSON.stringify({type:"ok"})));const B=J.readEntireBuffer();J.dispose(),this.b[ue].acceptReconnection(Q,V,B)}else{if(this.b[ue])return this.C(me,J,"Duplicate reconnection token");J.sendControl(p.$ge.fromString(JSON.stringify({type:"ok"})));const B=new k.$Sm(this.w,ue,Q,J);this.n.acceptConnection(B.protocol,B.onClose),this.b[ue]=B,this.f.add(ue),B.onClose(()=>{delete this.b[ue]})}else if(se.desiredConnectionType===2){const B=se.args||{language:"en"},W=await this.I(B);if(W.port&&this.w.trace(`${me} - startParams debug port ${W.port}`),this.w.trace(`${me} - startParams language: ${W.language}`),this.w.trace(`${me} - startParams env: ${JSON.stringify(W.env)}`),ie){if(!this.a[ue])return this.f.has(ue)?this.C(me,J,"Unknown reconnection token (seen before)"):this.C(me,J,"Unknown reconnection token (never seen)");J.sendPause(),J.sendControl(p.$ge.fromString(JSON.stringify(W.port?{debugPort:W.port}:{})));const O=J.readEntireBuffer();J.dispose(),this.a[ue].acceptReconnection(Q,V,O)}else{if(this.a[ue])return this.C(me,J,"Duplicate reconnection token");J.sendPause(),J.sendControl(p.$ge.fromString(JSON.stringify(W.port?{debugPort:W.port}:{})));const O=J.readEntireBuffer();J.dispose();const j=this.y.createInstance(L.$Rm,ue,Q,V,O);this.a[ue]=j,this.f.add(ue),j.onClose(()=>{delete this.a[ue],this.J()}),j.start(W)}}else if(se.desiredConnectionType===3){const B=se.args;this.G(J,B)}else return this.C(me,J,"Unknown initial data received")}async G(Q,te){const J=Q.getSocket().socket,V=Q.readEntireBuffer();Q.dispose(),J.pause();const ie=await this.H(te.host,te.port);V.byteLength>0&&ie.write(V.buffer),ie.on("end",()=>J.end()),ie.on("close",()=>J.end()),ie.on("error",()=>J.destroy()),J.on("end",()=>ie.end()),J.on("close",()=>ie.end()),J.on("error",()=>ie.destroy()),ie.pipe(J),J.pipe(ie)}H(Q,te){return new Promise((J,V)=>{const ie=s.createConnection({host:Q,port:te,autoSelectFamily:!0},()=>{ie.removeListener("error",V),ie.pause(),J(ie)});ie.once("error",V)})}I(Q){return typeof Q.port=="number"?(0,$.$og)(Q.port,10,5e3).then(te=>(Q.port=te,Q)):(Q.debugId=void 0,Q.port=void 0,Q.break=void 0,Promise.resolve(Q))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(Q=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!Q?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},G))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ne=Ne([Le(4,N.$Bm),Le(5,a.$Bj),Le(6,t.$jj),Le(7,r.$1h)],ne);async function Z(oe,Q,te){const J=await(0,R.$Xm)(Q);J instanceof R.$Vm&&(console.warn(J.message),process.exit(1));function V(q){(0,v.setUnexpectedErrorHandler)(M=>{(0,v.$Z)(M)&&M.stack&&/unexpectedErrorHandler/.test(M.stack)||q(M)})}const ie=[];V(q=>{ie.push(q),console.error(q)});let ue=!1;process.on("SIGPIPE",()=>{ue||(ue=!0,(0,v.$1)(new Error("Unexpected SIGPIPE")))});const se=new E.$Rc,{socketServer:me,instantiationService:B}=await(0,Y.$mO)(J,Q,te,se);B.invokeFunction(q=>{const M=q.get(t.$jj);ie.forEach(H=>M.error(H)),ie.length=0,V(H=>M.error(H))}),B.invokeFunction(q=>{const M=q.get(o.$vi);c.$c&&(M.getValue("security.restrictUNCAccess")===!1?(0,u.disableUNCAccessRestrictions)():(0,u.addUNCHostToAllowlist)(M.getValue("security.allowedUNCHosts")))}),B.invokeFunction(q=>{const M=q.get(t.$jj);if(c.$c&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const H=(0,f.$jc)(process.env.HOMEDRIVE,"node_modules"),_=(0,f.$mc)((0,f.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),ae=(0,f.$jc)(_,"node_modules");if(A.existsSync(H)||A.existsSync(ae)){const fe=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${H}
* ${ae}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;M.warn(fe),console.warn(fe),process.exit(0)}}});const W=B.invokeFunction(q=>{const M=q.get(t.$jj);if(A.existsSync((0,f.$jc)(w.$kg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(_){M.error(_)}return null}),O=A.existsSync(w.$kg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(O&&oe&&typeof oe!="string"){const q=J.type!==0?`?${w.$dg}=${J.value}`:"";console.log(`Web UI available at http://localhost${oe.port===80?"":`:${oe.port}`}/${q}`)}const j=B.createInstance(ne,me,J,W,O);g.mark("code/server/ready");const re=P.performance.now(),X=global.vscodeServerStartTime,x=global.vscodeServerListenTime,z=global.vscodeServerCodeLoadedTime;if(B.invokeFunction(async q=>{const M=q.get(C.$pl);if(M.publicLog2("serverStart",{startTime:X,startedTime:x,codeLoadedTime:z,readyTime:re}),c.$e){const H=q.get(t.$jj),_=await(0,l.$ng)(H.error.bind(H));_&&M.publicLog2("serverPlatformInfo",{platformId:_.id,platformVersionId:_.version_id,platformIdLike:_.id_like})}}),Q["print-startup-performance"]){const q=S.$U.get();let M="";M+=`

### Load AMD-module
`,M+=S.$U.toMarkdownTable(["Module","Duration"],q.amdLoad),M+=`

### Load commonjs-module
`,M+=S.$U.toMarkdownTable(["Module","Duration"],q.nodeRequire),M+=`

### Invoke AMD-module factory
`,M+=S.$U.toMarkdownTable(["Module","Duration"],q.amdInvoke),M+=`

### Invoke commonjs-module
`,M+=S.$U.toMarkdownTable(["Module","Duration"],q.nodeEval),M+=`Start-up time: ${x-X}
`,M+=`Code loading time: ${z-X}
`,M+=`Initialized time: ${re-X}
`,M+=`
`,console.log(M)}return j}e.$vO=Z;class T{static create(Q){const te=Q.webEndpointUrlTemplate,J=Q.commit,V=Q.quality;if(!te||!J||!V)return new T(null);const ie=(0,d.$mg)(),se=new URL(te.replace("{{uuid}}",ie).replace("{{commit}}",J).replace("{{quality}}",V)).origin,me=(0,m.$Ke)(se).replace(ie,"[a-zA-Z0-9\\-]+");try{const B=(0,m.$Te)(`^${me}$`,!0,{matchCase:!1});return new T(B)}catch{return new T(null)}}constructor(Q){this.a=Q}matches(Q){return this.a?this.a.test(Q):!1}}}),define(we[304],ve([1,0,27,29,12,290,295,66,7,296,46,55,41]),function(he,e,y,A,s,P,D,S,p,v,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,w.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=v.performance.now();const f={onMultipleValues:(d,l)=>{console.error(`Option '${d}' can only be defined once. Using value ${l}.`)},onEmptyValue:d=>{console.error(`Ignoring option '${d}': Value must not be empty.`)},onUnknownOption:d=>{console.error(`Ignoring option '${d}': not supported for server.`)},onDeprecatedOption:(d,l)=>{console.warn(`Option '${d}' is deprecated: ${l}`)}};function g(){return(0,S.$Ul)(process.argv.slice(2),I.$Am,f)}function c(d){const l=d["server-data-dir"]||d["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,p.$jc)(y.homedir(),E.default.serverDataFolderName||".vscode-remote"),$=d["user-data-dir"]||(0,p.$jc)(l,"data"),u=(0,p.$jc)($,"User"),n=(0,p.$jc)(u,"globalStorage"),i=(0,p.$jc)(u,"History"),o=(0,p.$jc)($,"Machine");d["user-data-dir"]=$;const r=(0,p.$mc)(s.$kg.asFileUri("").fsPath),t=d["builtin-extensions-dir"]||(0,p.$jc)(r,"extensions");return d["builtin-extensions-dir"]=t,d["extensions-dir"]=d["extensions-dir"]||(0,p.$jc)(l,"extensions"),[l,d["extensions-dir"],$,u,o,n,i].forEach(a=>{try{A.existsSync(a)||A.mkdirSync(a,{mode:448})}catch(b){console.error(b)}}),l}function m(d=g()){return(0,P.run)(d,c(d),I.$Am)}e.spawnCli=m;function h(d,l=g()){return(0,D.$vO)(d,l,c(l))}e.createServer=h})}).call(this);

//# sourceMappingURL=server.main.js.map
