"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/platform","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","os","net","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/model","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(ie){for(var e=[],E=0,F=ie.length;E<F;E++)e[E]=Se[ie[E]];return e};define(Se[158],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class E{static get(){const f=new Map,A=new Map,M=new Map,b=new Map;function m(y,D){y.has(D.detail)||y.set(D.detail,-D.timestamp)}function w(y,D){const u=y.get(D.detail);u&&(u>=0||y.set(D.detail,u+D.timestamp))}let L=[];typeof ie=="function"&&typeof ie.getStats=="function"&&(L=ie.getStats().slice(0).sort((y,D)=>y.timestamp-D.timestamp));for(const y of L)switch(y.type){case 10:m(f,y);break;case 11:case 12:w(f,y);break;case 21:m(A,y);break;case 22:w(A,y);break;case 33:m(M,y);break;case 34:w(M,y);break;case 31:m(b,y);break;case 32:w(b,y);break}let I=0;M.forEach(y=>I+=y);function $(y){const D=[];return y.forEach((u,g)=>D.push([g,u])),D}return{amdLoad:$(f),amdInvoke:$(A),nodeRequire:$(M),nodeEval:$(b),nodeRequireTotal:I}}static toMarkdownTable(f,A){let M="";const b=[];return f.forEach((m,w)=>{b[w]=m.length}),A.forEach(m=>{m.forEach((w,L)=>{typeof w>"u"&&(w=m[L]="-");const I=w.toString().length;b[L]=Math.max(I,b[L])})}),f.forEach((m,w)=>{M+=`| ${m+" ".repeat(b[w]-m.toString().length)} `}),M+=`|
`,f.forEach((m,w)=>{M+=`| ${"-".repeat(b[w])} `}),M+=`|
`,A.forEach(m=>{m.forEach((w,L)=>{typeof w<"u"&&(M+=`| ${w+" ".repeat(b[L]-w.toString().length)} `)}),M+=`|
`}),M}}e.$U=E}),define(Se[159],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function E(u,g,o){const n=F(u,g);if(n!==-1)return u[n]}e.$fb=E;function F(u,g,o=u.length-1){for(let n=o;n>=0;n--){const i=u[n];if(g(i))return n}return-1}e.$gb=F;function f(u,g){const o=A(u,g);return o===-1?void 0:u[o]}e.$hb=f;function A(u,g,o=0,n=u.length){let i=o,s=n;for(;i<s;){const a=Math.floor((i+s)/2);g(u[a])?i=a+1:s=a}return i-1}e.$ib=A;function M(u,g){const o=b(u,g);return o===u.length?void 0:u[o]}e.$jb=M;function b(u,g,o=0,n=u.length){let i=o,s=n;for(;i<s;){const a=Math.floor((i+s)/2);g(u[a])?s=a:i=a+1}return i}e.$kb=b;function m(u,g,o=0,n=u.length){const i=b(u,g,o,n);return i===u.length?-1:i}e.$lb=m;class w{constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(w.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!g(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const o=A(this.e,g,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=w,w.assertInvariants=!1;function L(u,g){if(u.length===0)return;let o=u[0];for(let n=1;n<u.length;n++){const i=u[n];g(i,o)>0&&(o=i)}return o}e.$nb=L;function I(u,g){if(u.length===0)return;let o=u[0];for(let n=1;n<u.length;n++){const i=u[n];g(i,o)>=0&&(o=i)}return o}e.$ob=I;function $(u,g){return L(u,(o,n)=>-g(o,n))}e.$pb=$;function y(u,g){if(u.length===0)return-1;let o=0;for(let n=1;n<u.length;n++){const i=u[n];g(i,u[o])>0&&(o=n)}return o}e.$qb=y;function D(u,g){for(const o of u){const n=g(o);if(n!==void 0)return n}}e.$rb=D}),define(Se[73],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=void 0;function E(M,b){const m=Object.create(null);for(const w of M){const L=b(w);let I=m[L];I||(I=m[L]=[]),I.push(w)}return m}e.$E=E;function F(M,b){const m=[],w=[];for(const L of M)b.has(L)||m.push(L);for(const L of b)M.has(L)||w.push(L);return{removed:m,added:w}}e.$F=F;function f(M,b){const m=[],w=[];for(const[L,I]of M)b.has(L)||m.push(I);for(const[L,I]of b)M.has(L)||w.push(I);return{removed:m,added:w}}e.$G=f;function A(M,b){const m=new Set;for(const w of b)M.has(w)&&m.add(w);return m}e.$H=A}),define(Se[59],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function E(M){return(b,m,w)=>{let L=null,I=null;if(typeof w.value=="function"?(L="value",I=w.value):typeof w.get=="function"&&(L="get",I=w.get),!I)throw new Error("not supported");w[L]=M(I,m)}}function F(M,b,m){let w=null,L=null;if(typeof m.value=="function"?(w="value",L=m.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(w="get",L=m.get),!L)throw new Error("not supported");const I=`$memoize$${b}`;m[w]=function(...$){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,$)}),this[I]}}e.$th=F;function f(M,b,m){return E((w,L)=>{const I=`$debounce$${L}`,$=`$debounce$result$${L}`;return function(...y){this[$]||(this[$]=m?m():void 0),clearTimeout(this[I]),b&&(this[$]=b(this[$],...y),y=[this[$]]),this[I]=setTimeout(()=>{w.apply(this,y),this[$]=m?m():void 0},M)}})}e.$uh=f;function A(M,b,m){return E((w,L)=>{const I=`$throttle$timer$${L}`,$=`$throttle$result$${L}`,y=`$throttle$lastRun$${L}`,D=`$throttle$pending$${L}`;return function(...u){if(this[$]||(this[$]=m?m():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[$]=b(this[$],...u)),this[D])return;const g=this[y]+M;g<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[$]]),this[$]=m?m():void 0):(this[D]=!0,this[I]=setTimeout(()=>{this[D]=!1,this[y]=Date.now(),w.apply(this,[this[$]]),this[$]=m?m():void 0},g-Date.now()))}})}e.$vh=A}),define(Se[8],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class E{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=E,e.$X=new E;function F(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=f;function A(a){w(a)||e.$X.onUnexpectedError(a)}e.$1=A;function M(a){w(a)||e.$X.onUnexpectedExternalError(a)}e.$2=M;function b(a){if(a instanceof Error){const{name:t,message:r}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:d,noTelemetry:i.isErrorNoTelemetry(a)}}return a}e.$3=b;const m="Canceled";function w(a){return a instanceof L?!0:a instanceof Error&&a.name===m&&a.message===m}e.$4=w;class L extends Error{constructor(){super(m),this.name=this.message}}e.$5=L;function I(){const a=new Error(m);return a.name=a.message,a}e.$6=I;function $(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=$;function y(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=y;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=D;function u(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=u;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const r=new i;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$cb=s}),define(Se[19],ke([1,0,8,159]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function f(le,de=0){return le[le.length-(1+de)]}e.$sb=f;function A(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}e.$tb=A;function M(le,de,Y=(X,Q)=>X===Q){if(le===de)return!0;if(!le||!de||le.length!==de.length)return!1;for(let X=0,Q=le.length;X<Q;X++)if(!Y(le[X],de[X]))return!1;return!0}e.$ub=M;function b(le,de){const Y=le.length-1;de<Y&&(le[de]=le[Y]),le.pop()}e.$vb=b;function m(le,de,Y){return w(le.length,X=>Y(le[X],de))}e.$wb=m;function w(le,de){let Y=0,X=le-1;for(;Y<=X;){const Q=(Y+X)/2|0,te=de(Q);if(te<0)Y=Q+1;else if(te>0)X=Q-1;else return Q}return-(Y+1)}e.$xb=w;function L(le,de,Y){if(le=le|0,le>=de.length)throw new TypeError("invalid index");const X=de[Math.floor(de.length*Math.random())],Q=[],te=[],$e=[];for(const ve of de){const Le=Y(ve,X);Le<0?Q.push(ve):Le>0?te.push(ve):$e.push(ve)}return le<Q.length?L(le,Q,Y):le<Q.length+$e.length?$e[0]:L(le-(Q.length+$e.length),te,Y)}e.$yb=L;function I(le,de){const Y=[];let X;for(const Q of le.slice(0).sort(de))!X||de(X[0],Q)!==0?(X=[Q],Y.push(X)):X.push(Q);return Y}e.$zb=I;function*$(le,de){let Y,X;for(const Q of le)X!==void 0&&de(X,Q)?Y.push(Q):(Y&&(yield Y),Y=[Q]),X=Q;Y&&(yield Y)}e.$Ab=$;function y(le,de){for(let Y=0;Y<=le.length;Y++)de(Y===0?void 0:le[Y-1],Y===le.length?void 0:le[Y])}e.$Bb=y;function D(le,de){for(let Y=0;Y<le.length;Y++)de(Y===0?void 0:le[Y-1],le[Y],Y+1===le.length?void 0:le[Y+1])}e.$Cb=D;function u(le,de,Y){const X=[];function Q(ve,Le,pe){if(Le===0&&pe.length===0)return;const De=X[X.length-1];De&&De.start+De.deleteCount===ve?(De.deleteCount+=Le,De.toInsert.push(...pe)):X.push({start:ve,deleteCount:Le,toInsert:pe})}let te=0,$e=0;for(;;){if(te===le.length){Q(te,0,de.slice($e));break}if($e===de.length){Q(te,le.length-te,[]);break}const ve=le[te],Le=de[$e],pe=Y(ve,Le);pe===0?(te+=1,$e+=1):pe<0?(Q(te,1,[]),te+=1):pe>0&&(Q(te,0,[Le]),$e+=1)}return X}e.$Db=u;function g(le,de,Y){const X=u(le,de,Y),Q=[],te=[];for(const $e of X)Q.push(...le.slice($e.start,$e.start+$e.deleteCount)),te.push(...$e.toInsert);return{removed:Q,added:te}}e.$Eb=g;function o(le,de,Y){if(Y===0)return[];const X=le.slice(0,Y).sort(de);return i(le,de,X,Y,le.length),X}e.top=o;function n(le,de,Y,X,Q){return Y===0?Promise.resolve([]):new Promise((te,$e)=>{(async()=>{const ve=le.length,Le=le.slice(0,Y).sort(de);for(let pe=Y,De=Math.min(Y+X,ve);pe<ve;pe=De,De=Math.min(De+X,ve)){if(pe>Y&&await new Promise(B=>setTimeout(B)),Q&&Q.isCancellationRequested)throw new E.$5;i(le,de,Le,pe,De)}return Le})().then(te,$e)})}e.$Gb=n;function i(le,de,Y,X,Q){for(const te=Y.length;X<Q;X++){const $e=le[X];if(de($e,Y[te-1])<0){Y.pop();const ve=(0,F.$kb)(Y,Le=>de($e,Le)<0);Y.splice(ve,0,$e)}}}function s(le){return le.filter(de=>!!de)}e.$Hb=s;function a(le){let de=0;for(let Y=0;Y<le.length;Y++)le[Y]&&(le[de]=le[Y],de+=1);le.length=de}e.$Ib=a;function t(le,de,Y){le.splice(Y,0,le.splice(de,1)[0])}e.$Jb=t;function r(le){return!Array.isArray(le)||le.length===0}e.$Kb=r;function d(le){return Array.isArray(le)&&le.length>0}e.$Lb=d;function l(le,de=Y=>Y){const Y=new Set;return le.filter(X=>{const Q=de(X);return Y.has(Q)?!1:(Y.add(Q),!0)})}e.$Mb=l;function h(le){const de=new Set;return Y=>{const X=le(Y);return de.has(X)?!1:(de.add(X),!0)}}e.$Nb=h;function c(le,de){return le.length>0?le[0]:de}e.$Ob=c;function v(le,de){return le.length>0?le[le.length-1]:de}e.$Pb=v;function P(le,de,Y=(X,Q)=>X===Q){let X=0;for(let Q=0,te=Math.min(le.length,de.length);Q<te&&Y(le[Q],de[Q]);Q++)X++;return X}e.$Qb=P;function S(le){return[].concat(...le)}e.$Rb=S;function p(le,de){let Y=typeof de=="number"?le:0;typeof de=="number"?Y=le:(Y=0,de=le);const X=[];if(Y<=de)for(let Q=Y;Q<de;Q++)X.push(Q);else for(let Q=Y;Q>de;Q--)X.push(Q);return X}e.$Sb=p;function k(le,de,Y){return le.reduce((X,Q)=>(X[de(Q)]=Y?Y(Q):Q,X),Object.create(null))}e.$Tb=k;function C(le,de){return le.push(de),()=>j(le,de)}e.$Ub=C;function j(le,de){const Y=le.indexOf(de);if(Y>-1)return le.splice(Y,1),de}e.$Vb=j;function z(le,de,Y){const X=le.slice(0,de),Q=le.slice(de);return X.concat(Y,Q)}e.$Wb=z;function O(le,de){let Y;if(typeof de=="number"){let X=de;Y=()=>{const Q=Math.sin(X++)*179426549;return Q-Math.floor(Q)}}else Y=Math.random;for(let X=le.length-1;X>0;X-=1){const Q=Math.floor(Y()*(X+1)),te=le[X];le[X]=le[Q],le[Q]=te}}e.$Xb=O;function U(le,de){const Y=le.indexOf(de);Y>-1&&(le.splice(Y,1),le.unshift(de))}e.$Yb=U;function N(le,de){const Y=le.indexOf(de);Y>-1&&(le.splice(Y,1),le.push(de))}e.$Zb=N;function R(le,de){for(const Y of de)le.push(Y)}e.$1b=R;function T(le,de){return Array.isArray(le)?le.map(de):de(le)}e.$2b=T;function q(le){return Array.isArray(le)?le:[le]}e.$3b=q;function ee(le){return le[Math.floor(Math.random()*le.length)]}e.$4b=ee;function J(le,de,Y){const X=Z(le,de),Q=le.length,te=Y.length;le.length=Q+te;for(let $e=Q-1;$e>=X;$e--)le[$e+te]=le[$e];for(let $e=0;$e<te;$e++)le[$e+X]=Y[$e]}e.$5b=J;function K(le,de,Y,X){const Q=Z(le,de);let te=le.splice(Q,Y);return te===void 0&&(te=[]),J(le,Q,X),te}e.$6b=K;function Z(le,de){return de<0?Math.max(de+le.length,0):Math.min(de,le.length)}var ae;(function(le){function de(te){return te<0}le.isLessThan=de;function Y(te){return te<=0}le.isLessThanOrEqual=Y;function X(te){return te>0}le.isGreaterThan=X;function Q(te){return te===0}le.isNeitherLessOrGreaterThan=Q,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function _(le,de){return(Y,X)=>de(le(Y),le(X))}e.$7b=_;function ye(...le){return(de,Y)=>{for(const X of le){const Q=X(de,Y);if(!ae.isNeitherLessOrGreaterThan(Q))return Q}return ae.neitherLessOrGreaterThan}}e.$8b=ye;const ge=(le,de)=>le-de;e.$9b=ge;const re=(le,de)=>(0,e.$9b)(le?1:0,de?1:0);e.$0b=re;function W(le){return(de,Y)=>-le(de,Y)}e.$$b=W;class ce{constructor(de){this.g=de,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(de){let Y=this.c;for(;Y<this.g.length&&de(this.g[Y]);)Y++;const X=Y===this.c?null:this.g.slice(this.c,Y);return this.c=Y,X}takeFromEndWhile(de){let Y=this.d;for(;Y>=0&&de(this.g[Y]);)Y--;const X=Y===this.d?null:this.g.slice(Y+1,this.d+1);return this.d=Y,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const de=this.g[this.c];return this.c++,de}removeLast(){const de=this.g[this.d];return this.d--,de}takeCount(de){const Y=this.g.slice(this.c,this.c+de);return this.c+=de,Y}}e.$_b=ce;class me{constructor(de){this.iterate=de}forEach(de){this.iterate(Y=>(de(Y),!0))}toArray(){const de=[];return this.iterate(Y=>(de.push(Y),!0)),de}filter(de){return new me(Y=>this.iterate(X=>de(X)?Y(X):!0))}map(de){return new me(Y=>this.iterate(X=>Y(de(X))))}some(de){let Y=!1;return this.iterate(X=>(Y=de(X),!Y)),Y}findFirst(de){let Y;return this.iterate(X=>de(X)?(Y=X,!1):!0),Y}findLast(de){let Y;return this.iterate(X=>(de(X)&&(Y=X),!0)),Y}findLastMaxBy(de){let Y,X=!0;return this.iterate(Q=>((X||ae.isGreaterThan(de(Q,Y)))&&(X=!1,Y=Q),!0)),Y}}e.$ac=me,me.empty=new me(le=>{})}),define(Se[60],ke([1,0,8]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function F(m,w){if(!m)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=F;function f(m,w="Unreachable"){throw new Error(w)}e.$5c=f;function A(m){if(!m)throw new E.$cb("Assertion Failed")}e.$6c=A;function M(m){if(!m()){debugger;m(),(0,E.$1)(new E.$cb("Assertion Failed"))}}e.$7c=M;function b(m,w){let L=0;for(;L<m.length-1;){const I=m[L],$=m[L+1];if(!w(I,$))return!1;L++}return!0}e.$8c=b}),define(Se[74],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function E(F,f){const A=this;let M=!1,b;return function(){if(M)return b;if(M=!0,f)try{b=F.apply(A,arguments)}finally{f()}else b=F.apply(A,arguments);return b}}e.$db=E}),define(Se[122],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=e.$WM=void 0;class E{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$WM=E,e.$XM=new E("id#")}),define(Se[52],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(F){function f(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}F.is=f;const A=Object.freeze([]);function M(){return A}F.empty=M;function*b(a){yield a}F.single=b;function m(a){return f(a)?a:b(a)}F.wrap=m;function w(a){return a||A}F.from=w;function*L(a){for(let t=a.length-1;t>=0;t--)yield a[t]}F.reverse=L;function I(a){return!a||a[Symbol.iterator]().next().done===!0}F.isEmpty=I;function $(a){return a[Symbol.iterator]().next().value}F.first=$;function y(a,t){for(const r of a)if(t(r))return!0;return!1}F.some=y;function D(a,t){for(const r of a)if(t(r))return r}F.find=D;function*u(a,t){for(const r of a)t(r)&&(yield r)}F.filter=u;function*g(a,t){let r=0;for(const d of a)yield t(d,r++)}F.map=g;function*o(...a){for(const t of a)yield*t}F.concat=o;function n(a,t,r){let d=r;for(const l of a)d=t(d,l);return d}F.reduce=n;function*i(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}F.slice=i;function s(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const d=a[Symbol.iterator]();for(let l=0;l<t;l++){const h=d.next();if(h.done)return[r,F.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return d}}]}F.consume=s})(E||(e.Iterable=E={}))}),define(Se[160],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function M(t,r=!1){let d=0;const l=t.length;let h="",c=0,v=16,P=0;function S(U){let N=0,R=0;for(;N<U;){const T=t.charCodeAt(d);if(T>=48&&T<=57)R=R*16+T-48;else if(T>=65&&T<=70)R=R*16+T-65+10;else if(T>=97&&T<=102)R=R*16+T-97+10;else break;d++,N++}return N<U&&(R=-1),R}function p(U){d=U,h="",c=0,v=16,P=0}function k(){const U=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&w(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&w(t.charCodeAt(d)))for(d++;d<t.length&&w(t.charCodeAt(d));)d++;else return P=3,t.substring(U,d);let N=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&w(t.charCodeAt(d))){for(d++;d<t.length&&w(t.charCodeAt(d));)d++;N=d}else P=3;return t.substring(U,N)}function C(){let U="",N=d;for(;;){if(d>=l){U+=t.substring(N,d),P=2;break}const R=t.charCodeAt(d);if(R===34){U+=t.substring(N,d),d++;break}if(R===92){if(U+=t.substring(N,d),d++,d>=l){P=2;break}switch(t.charCodeAt(d++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const q=S(4);q>=0?U+=String.fromCharCode(q):P=4;break}default:P=5}N=d;continue}if(R>=0&&R<=31)if(m(R)){U+=t.substring(N,d),P=2;break}else P=6;d++}return U}function j(){if(h="",P=0,c=d,d>=l)return c=l,v=17;let U=t.charCodeAt(d);if(b(U)){do d++,h+=String.fromCharCode(U),U=t.charCodeAt(d);while(b(U));return v=15}if(m(U))return d++,h+=String.fromCharCode(U),U===13&&t.charCodeAt(d)===10&&(d++,h+=`
`),v=14;switch(U){case 123:return d++,v=1;case 125:return d++,v=2;case 91:return d++,v=3;case 93:return d++,v=4;case 58:return d++,v=6;case 44:return d++,v=5;case 34:return d++,h=C(),v=10;case 47:{const N=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!m(t.charCodeAt(d));)d++;return h=t.substring(N,d),v=12}if(t.charCodeAt(d+1)===42){d+=2;const R=l-1;let T=!1;for(;d<R;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,T=!0;break}d++}return T||(d++,P=1),h=t.substring(N,d),v=13}return h+=String.fromCharCode(U),d++,v=16}case 45:if(h+=String.fromCharCode(U),d++,d===l||!w(t.charCodeAt(d)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=k(),v=11;default:for(;d<l&&z(U);)d++,U=t.charCodeAt(d);if(c!==d){switch(h=t.substring(c,d),h){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return h+=String.fromCharCode(U),d++,v=16}}function z(U){if(b(U)||m(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let U;do U=j();while(U>=12&&U<=15);return U}return{setPosition:p,getPosition:()=>d,scan:r?O:j,getToken:()=>v,getTokenValue:()=>h,getTokenOffset:()=>c,getTokenLength:()=>d-c,getTokenError:()=>P}}e.$9m=M;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function I(t,r){const d=[],l=new Object;let h;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function P(S,p,k,C){c.value=S,c.offset=p,c.length=k,c.type=C,c.colonOffset=void 0,h=c}try{i(t,{onObjectBegin:(S,p)=>{if(r<=S)throw l;h=void 0,v=r>S,d.push("")},onObjectProperty:(S,p,k)=>{if(r<p||(P(S,p,k,"property"),d[d.length-1]=S,r<=p+k))throw l},onObjectEnd:(S,p)=>{if(r<=S)throw l;h=void 0,d.pop()},onArrayBegin:(S,p)=>{if(r<=S)throw l;h=void 0,d.push(0)},onArrayEnd:(S,p)=>{if(r<=S)throw l;h=void 0,d.pop()},onLiteralValue:(S,p,k)=>{if(r<p||(P(S,p,k,a(S)),r<=p+k))throw l},onSeparator:(S,p,k)=>{if(r<=p)throw l;if(S===":"&&h&&h.type==="property")h.colonOffset=p,v=!1,h=void 0;else if(S===","){const C=d[d.length-1];typeof C=="number"?d[d.length-1]=C+1:(v=!0,d[d.length-1]=""),h=void 0}}})}catch(S){if(S!==l)throw S}return{path:d,previousNode:h,isAtPropertyKey:v,matches:S=>{let p=0;for(let k=0;p<S.length&&k<d.length;k++)if(S[p]===d[k]||S[p]==="*")p++;else if(S[p]!=="**")return!1;return p===S.length}}}e.$0m=I;function $(t,r=[],d=A.DEFAULT){let l=null,h=[];const c=[];function v(S){Array.isArray(h)?h.push(S):l!==null&&(h[l]=S)}return i(t,{onObjectBegin:()=>{const S={};v(S),c.push(h),h=S,l=null},onObjectProperty:S=>{l=S},onObjectEnd:()=>{h=c.pop()},onArrayBegin:()=>{const S=[];v(S),c.push(h),h=S,l=null},onArrayEnd:()=>{h=c.pop()},onLiteralValue:v,onError:(S,p,k)=>{r.push({error:S,offset:p,length:k})}},d),h[0]}e.$$m=$;function y(t,r=[],d=A.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(S){l.type==="property"&&(l.length=S-l.offset,l=l.parent)}function c(S){return l.children.push(S),S}i(t,{onObjectBegin:S=>{l=c({type:"object",offset:S,length:-1,parent:l,children:[]})},onObjectProperty:(S,p,k)=>{l=c({type:"property",offset:p,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:S,offset:p,length:k,parent:l})},onObjectEnd:(S,p)=>{l.length=S+p-l.offset,l=l.parent,h(S+p)},onArrayBegin:(S,p)=>{l=c({type:"array",offset:S,length:-1,parent:l,children:[]})},onArrayEnd:(S,p)=>{l.length=S+p-l.offset,l=l.parent,h(S+p)},onLiteralValue:(S,p,k)=>{c({type:a(S),offset:p,length:k,parent:l,value:S}),h(p+k)},onSeparator:(S,p,k)=>{l.type==="property"&&(S===":"?l.colonOffset=p:S===","&&h(p))},onError:(S,p,k)=>{r.push({error:S,offset:p,length:k})}},d);const P=l.children[0];return P&&delete P.parent,P}e.$_m=y;function D(t,r){if(!t)return;let d=t;for(const l of r)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let h=!1;for(const c of d.children)if(Array.isArray(c.children)&&c.children[0].value===l){d=c.children[1],h=!0;break}if(!h)return}else{const h=l;if(d.type!=="array"||h<0||!Array.isArray(d.children)||h>=d.children.length)return;d=d.children[h]}return d}e.$an=D;function u(t){if(!t.parent||!t.parent.children)return[];const r=u(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;r.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&r.push(d)}return r}e.$bn=u;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const r=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(r[d.children[0].value]=g(l))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$cn=g;function o(t,r,d=!1){return r>=t.offset&&r<t.offset+t.length||d&&r===t.offset+t.length}e.$dn=o;function n(t,r,d=!1){if(o(t,r,d)){const l=t.children;if(Array.isArray(l))for(let h=0;h<l.length&&l[h].offset<=r;h++){const c=n(l[h],r,d);if(c)return c}return t}}e.$en=n;function i(t,r,d=A.DEFAULT){const l=M(t,!1);function h(_){return _?()=>_(l.getTokenOffset(),l.getTokenLength()):()=>!0}function c(_){return _?ye=>_(ye,l.getTokenOffset(),l.getTokenLength()):()=>!0}const v=h(r.onObjectBegin),P=c(r.onObjectProperty),S=h(r.onObjectEnd),p=h(r.onArrayBegin),k=h(r.onArrayEnd),C=c(r.onLiteralValue),j=c(r.onSeparator),z=h(r.onComment),O=c(r.onError),U=d&&d.disallowComments,N=d&&d.allowTrailingComma;function R(){for(;;){const _=l.scan();switch(l.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:U||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(_){case 12:case 13:U?T(10):z();break;case 16:T(1);break;case 15:case 14:break;default:return _}}}function T(_,ye=[],ge=[]){if(O(_),ye.length+ge.length>0){let re=l.getToken();for(;re!==17;){if(ye.indexOf(re)!==-1){R();break}else if(ge.indexOf(re)!==-1)break;re=R()}}}function q(_){const ye=l.getTokenValue();return _?C(ye):P(ye),R(),!0}function ee(){switch(l.getToken()){case 11:{let _=0;try{_=JSON.parse(l.getTokenValue()),typeof _!="number"&&(T(2),_=0)}catch{T(2)}C(_);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return R(),!0}function J(){return l.getToken()!==10?(T(3,[],[2,5]),!1):(q(!1),l.getToken()===6?(j(":"),R(),ae()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function K(){v(),R();let _=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(_||T(4,[],[]),j(","),R(),l.getToken()===2&&N)break}else _&&T(6,[],[]);J()||T(4,[],[2,5]),_=!0}return S(),l.getToken()!==2?T(7,[2],[]):R(),!0}function Z(){p(),R();let _=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(_||T(4,[],[]),j(","),R(),l.getToken()===4&&N)break}else _&&T(6,[],[]);ae()||T(4,[],[4,5]),_=!0}return k(),l.getToken()!==4?T(8,[4],[]):R(),!0}function ae(){switch(l.getToken()){case 3:return Z();case 1:return K();case 10:return q(!0);default:return ee()}}return R(),l.getToken()===17?d.allowEmptyContent?!0:(T(4,[],[]),!1):ae()?(l.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.$fn=i;function s(t,r){const d=M(t),l=[];let h,c=0,v;do switch(v=d.getPosition(),h=d.scan(),h){case 12:case 13:case 17:c!==v&&l.push(t.substring(c,v)),r!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,r)),c=d.getPosition();break}while(h!==17);return l.join("")}e.$gn=s;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$hn=a}),define(Se[43],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class E{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=E}),define(Se[75],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class E{constructor(A){this.element=A,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class F{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let A=this.a;for(;A!==E.Undefined;){const M=A.next;A.prev=E.Undefined,A.next=E.Undefined,A=M}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,M){const b=new E(A);if(this.a===E.Undefined)this.a=b,this.b=b;else if(M){const w=this.b;this.b=b,b.prev=w,w.next=b}else{const w=this.a;this.a=b,b.next=w,w.prev=b}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(b))}}shift(){if(this.a!==E.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==E.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==E.Undefined&&A.next!==E.Undefined){const M=A.prev;M.next=A.next,A.next.prev=M}else A.prev===E.Undefined&&A.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):A.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):A.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==E.Undefined;)yield A.element,A=A.next}}e.$3c=F}),define(Se[28],ke([1,0]),function(ie,e){"use strict";var E,F,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function A(n,i,s){let a=n.get(i);return a===void 0&&(a=s,n.set(i,a)),a}e.$xc=A;function M(n){const i=[];return n.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.$yc=M;function b(n){const i=[];return n.forEach(s=>{i.push(s)}),`Set(${n.size}) {${i.join(", ")}}`}e.$zc=b;class m{constructor(i,s){this.uri=i,this.value=s}}function w(n){return Array.isArray(n)}class L{constructor(i,s){if(this[E]="ResourceMap",i instanceof L)this.b=new Map(i.b),this.c=s??L.a;else if(w(i)){this.b=new Map,this.c=s??L.a;for(const[a,t]of i)this.set(a,t)}else this.b=new Map,this.c=i??L.a}set(i,s){return this.b.set(this.c(i),new m(i,s)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[a,t]of this.b)i(t.value,t.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$Ac=L,L.a=n=>n.toString();class I{constructor(i,s){this[F]="ResourceSet",!i||typeof i=="function"?this.a=new L(i):(this.a=new L(s),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,s){this.a.forEach((a,t)=>i.call(s,t,t,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var $;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})($||(e.Touch=$={}));class y{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,s=0){const a=this.a.get(i);if(a)return s!==0&&this.j(a,s),a.value}set(i,s,a=0){let t=this.a.get(i);if(t)t.value=s,a!==0&&this.j(t,a);else{switch(t={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(i,t),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this.a.get(i);if(s)return this.a.delete(i),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,s){const a=this.e;let t=this.b;for(;t;){if(s?i.bind(s)(t.value,t.key,this):i(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const i=this,s=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(i.e!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const i=this,s=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(i.e!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const i=this,s=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(i.e!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this.b,a=this.size;for(;s&&a>i;)this.a.delete(s.key),s=s.next,a--;this.b=s,this.d=a,s&&(s.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this.e++}j(i,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this.b)return;const a=i.next,t=i.previous;i===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(s===2){if(i===this.c)return;const a=i.next,t=i.previous;i===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.$Cc=y;class D extends y{constructor(i,s=1){super(),this.k=i,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=D;class u{constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let s=this.a.get(i)||0;return s===0?!1:(s--,s===0?this.a.delete(i):this.a.set(i,s),!0)}has(i){return this.a.has(i)}}e.$Ec=u;class g{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[s,a]of i)this.set(s,a)}clear(){this.a.clear(),this.b.clear()}set(i,s){this.a.set(i,s),this.b.set(s,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const s=this.a.get(i);return s===void 0?!1:(this.a.delete(i),this.b.delete(s),!0)}forEach(i,s){this.a.forEach((a,t)=>{i.call(s,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=g;class o{constructor(){this.a=new Map}add(i,s){let a=this.a.get(i);a||(a=new Set,this.a.set(i,a)),a.add(s)}delete(i,s){const a=this.a.get(i);a&&(a.delete(s),a.size===0&&this.a.delete(i))}forEach(i,s){const a=this.a.get(i);a&&a.forEach(s)}get(i){const s=this.a.get(i);return s||new Set}}e.$Gc=o}),define(Se[3],ke([1,0,19,73,28,74,52]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const b=!1;let m=null;class w{constructor(){this.b=new Map}c(C){let j=this.b.get(C);return j||(j={parent:null,source:null,isSingleton:!1,value:C,idx:w.a++},this.b.set(C,j)),j}trackDisposable(C){const j=this.c(C);j.source||(j.source=new Error().stack)}setParent(C,j){const z=this.c(C);z.parent=j}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,j){const z=j.get(C);if(z)return z;const O=C.parent?this.f(this.c(C.parent),j):C;return j.set(C,O),O}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,C).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(C=10,j){let z;if(j)z=j;else{const T=new Map,q=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,T).isSingleton);if(q.length===0)return;const ee=new Set(q.map(J=>J.value));if(z=q.filter(J=>!(J.parent&&ee.has(J.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function O(T){function q(J,K){for(;J.length>0&&K.some(Z=>typeof Z=="string"?Z===J[0]:J[0].match(Z));)J.shift()}const ee=T.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return q(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const U=new f.$Gc;for(const T of z){const q=O(T);for(let ee=0;ee<=q.length;ee++)U.add(q.slice(0,ee).join(`
`),T)}z.sort((0,E.$7b)(T=>T.idx,E.$9b));let N="",R=0;for(const T of z.slice(0,C)){R++;const q=O(T),ee=[];for(let J=0;J<q.length;J++){let K=q[J];K=`(shared with ${U.get(q.slice(0,J+1).join(`
`)).size}/${z.length} leaks) at ${K}`;const ae=U.get(q.slice(0,J).join(`
`)),_=(0,F.$E)([...ae].map(ye=>O(ye)[J]),ye=>ye);delete _[q[J]];for(const[ye,ge]of Object.entries(_))ee.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${ye}`);ee.unshift(K)}N+=`


==================== Leaking disposable ${R}/${z.length}: ${T.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return z.length>C&&(N+=`


... and ${z.length-C} more leaking disposables

`),{leaks:z,details:N}}}e.$Hc=w,w.a=0;function L(k){m=k}if(e.$Ic=L,b){const k="__is_disposable_tracked__";L(new class{trackDisposable(C){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[k]||console.log(j)},3e3)}setParent(C,j){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsSingleton(C){}})}function I(k){return m?.trackDisposable(k),k}e.$Jc=I;function $(k){m?.markAsDisposed(k)}e.$Kc=$;function y(k,C){m?.setParent(k,C)}function D(k,C){if(m)for(const j of k)m.setParent(j,C)}function u(k){return m?.markAsSingleton(k),k}e.$Lc=u;function g(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Mc=g;function o(k){if(M.Iterable.is(k)){const C=[];for(const j of k)if(j)try{j.dispose()}catch(z){C.push(z)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Nc=o;function n(k){for(const C of k)g(C)&&C.dispose();return[]}e.$Oc=n;function i(...k){const C=s(()=>o(k));return D(k,C),C}e.$Pc=i;function s(k){const C=I({dispose:(0,A.$db)(()=>{$(C),k()})});return C}e.$Qc=s;class a{constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return y(C,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),y(C,null))}}e.$Rc=a,a.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new a,I(this),y(this.q,this)}dispose(){$(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Sc=t,t.None=Object.freeze({dispose(){}});class r{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&y(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&y(C,null),C}}e.$Tc=r;class d{constructor(C){this.a=new r,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=d;class l{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=l;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(C){let j=C;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,$(this))},this}}e.$Wc=h;class c{constructor(){this.a=new Map}acquire(C,...j){let z=this.a.get(C);z||(z={counter:0,object:this.b(C,...j)},this.a.set(C,z));const{object:O}=z,U=(0,A.$db)(()=>{--z.counter===0&&(this.c(C,z.object),this.a.delete(C))});return z.counter++,{object:O,dispose:U}}}e.$Xc=c;class v{constructor(C){this.a=C}async acquire(C,...j){const z=this.a.acquire(C,...j);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(O){throw z.dispose(),O}}}e.$Yc=v;class P{constructor(C){this.object=C}dispose(){}}e.$Zc=P;function S(k){const C=new a;try{k(C)}finally{C.dispose()}}e.$1c=S;class p{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,j,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(C)?.dispose(),this.a.set(C,j)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=p}),function(ie,e){typeof define=="function"&&define.amd?define(Se[161],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(de,Y){for(var X=0;X<Y.length;X++){var Q=Y[X];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(de,Q.key,Q)}}function E(de,Y,X){return Y&&e(de.prototype,Y),X&&e(de,X),Object.defineProperty(de,"prototype",{writable:!1}),de}function F(de,Y){if(de){if(typeof de=="string")return f(de,Y);var X=Object.prototype.toString.call(de).slice(8,-1);if(X==="Object"&&de.constructor&&(X=de.constructor.name),X==="Map"||X==="Set")return Array.from(de);if(X==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(X))return f(de,Y)}}function f(de,Y){(Y==null||Y>de.length)&&(Y=de.length);for(var X=0,Q=new Array(Y);X<Y;X++)Q[X]=de[X];return Q}function A(de,Y){var X=typeof Symbol<"u"&&de[Symbol.iterator]||de["@@iterator"];if(X)return(X=X.call(de)).next.bind(X);if(Array.isArray(de)||(X=F(de))||Y&&de&&typeof de.length=="number"){X&&(de=X);var Q=0;return function(){return Q>=de.length?{done:!0}:{done:!1,value:de[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=M();function b(de){ie.defaults=de}var m=/[&<>"']/,w=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(Y){return $[Y]};function D(de,Y){if(Y){if(m.test(de))return de.replace(w,y)}else if(L.test(de))return de.replace(I,y);return de}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(de){return de.replace(u,function(Y,X){return X=X.toLowerCase(),X==="colon"?":":X.charAt(0)==="#"?X.charAt(1)==="x"?String.fromCharCode(parseInt(X.substring(2),16)):String.fromCharCode(+X.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(de,Y){de=typeof de=="string"?de:de.source,Y=Y||"";var X={replace:function(te,$e){return $e=$e.source||$e,$e=$e.replace(o,"$1"),de=de.replace(te,$e),X},getRegex:function(){return new RegExp(de,Y)}};return X}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(de,Y,X){if(de){var Q;try{Q=decodeURIComponent(g(X)).replace(i,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}Y&&!s.test(X)&&(X=h(Y,X));try{X=encodeURI(X).replace(/%25/g,"%")}catch{return null}return X}var t={},r=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(de,Y){t[" "+de]||(r.test(de)?t[" "+de]=de+"/":t[" "+de]=S(de,"/",!0)),de=t[" "+de];var X=de.indexOf(":")===-1;return Y.substring(0,2)==="//"?X?Y:de.replace(d,"$1")+Y:Y.charAt(0)==="/"?X?Y:de.replace(l,"$1")+Y:de+Y}var c={exec:function(){}};function v(de){for(var Y=1,X,Q;Y<arguments.length;Y++){X=arguments[Y];for(Q in X)Object.prototype.hasOwnProperty.call(X,Q)&&(de[Q]=X[Q])}return de}function P(de,Y){var X=de.replace(/\|/g,function($e,ve,Le){for(var pe=!1,De=ve;--De>=0&&Le[De]==="\\";)pe=!pe;return pe?"|":" |"}),Q=X.split(/ \|/),te=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>Y)Q.splice(Y);else for(;Q.length<Y;)Q.push("");for(;te<Q.length;te++)Q[te]=Q[te].trim().replace(/\\\|/g,"|");return Q}function S(de,Y,X){var Q=de.length;if(Q===0)return"";for(var te=0;te<Q;){var $e=de.charAt(Q-te-1);if($e===Y&&!X)te++;else if($e!==Y&&X)te++;else break}return de.slice(0,Q-te)}function p(de,Y){if(de.indexOf(Y[1])===-1)return-1;for(var X=de.length,Q=0,te=0;te<X;te++)if(de[te]==="\\")te++;else if(de[te]===Y[0])Q++;else if(de[te]===Y[1]&&(Q--,Q<0))return te;return-1}function k(de){de&&de.sanitize&&!de.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(de,Y){if(Y<1)return"";for(var X="";Y>1;)Y&1&&(X+=de),Y>>=1,de+=de;return X+de}function j(de,Y,X,Q){var te=Y.href,$e=Y.title?D(Y.title):null,ve=de[1].replace(/\\([\[\]])/g,"$1");if(de[0].charAt(0)!=="!"){Q.state.inLink=!0;var Le={type:"link",raw:X,href:te,title:$e,text:ve,tokens:Q.inlineTokens(ve)};return Q.state.inLink=!1,Le}return{type:"image",raw:X,href:te,title:$e,text:D(ve)}}function z(de,Y){var X=de.match(/^(\s+)(?:```)/);if(X===null)return Y;var Q=X[1];return Y.split(`
`).map(function(te){var $e=te.match(/^\s+/);if($e===null)return te;var ve=$e[0];return ve.length>=Q.length?te.slice(Q.length):te}).join(`
`)}var O=function(){function de(X){this.options=X||ie.defaults}var Y=de.prototype;return Y.space=function(Q){var te=this.rules.block.newline.exec(Q);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},Y.code=function(Q){var te=this.rules.block.code.exec(Q);if(te){var $e=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:S($e,`
`)}}},Y.fences=function(Q){var te=this.rules.block.fences.exec(Q);if(te){var $e=te[0],ve=z($e,te[3]||"");return{type:"code",raw:$e,lang:te[2]?te[2].trim():te[2],text:ve}}},Y.heading=function(Q){var te=this.rules.block.heading.exec(Q);if(te){var $e=te[2].trim();if(/#$/.test($e)){var ve=S($e,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&($e=ve.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:$e,tokens:this.lexer.inline($e)}}},Y.hr=function(Q){var te=this.rules.block.hr.exec(Q);if(te)return{type:"hr",raw:te[0]}},Y.blockquote=function(Q){var te=this.rules.block.blockquote.exec(Q);if(te){var $e=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},Y.list=function(Q){var te=this.rules.block.list.exec(Q);if(te){var $e,ve,Le,pe,De,B,x,se,H,ue,fe,Re,Oe=te[1].trim(),Ge=Oe.length>1,He={type:"list",raw:"",ordered:Ge,start:Ge?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=Ge?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=Ge?Oe:"[*+-]");for(var et=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(Re=!1,!(!(te=et.exec(Q))||this.rules.block.hr.test(Q)));){if($e=te[0],Q=Q.substring($e.length),se=te[2].split(`
`,1)[0],H=Q.split(`
`,1)[0],this.options.pedantic?(pe=2,fe=se.trimLeft()):(pe=te[2].search(/[^ ]/),pe=pe>4?1:pe,fe=se.slice(pe),pe+=te[1].length),B=!1,!se&&/^ *$/.test(H)&&($e+=H+`
`,Q=Q.substring(H.length+1),Re=!0),!Re)for(var lt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),Pe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");Q&&(ue=Q.split(`
`,1)[0],se=ue,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(se)||Pe.test(se)||lt.test(se)||ct.test(Q)));){if(se.search(/[^ ]/)>=pe||!se.trim())fe+=`
`+se.slice(pe);else if(!B)fe+=`
`+se;else break;!B&&!se.trim()&&(B=!0),$e+=ue+`
`,Q=Q.substring(ue.length+1)}He.loose||(x?He.loose=!0:/\n *\n *$/.test($e)&&(x=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(fe),ve&&(Le=ve[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:$e,task:!!ve,checked:Le,loose:!1,text:fe}),He.raw+=$e}He.items[He.items.length-1].raw=$e.trimRight(),He.items[He.items.length-1].text=fe.trimRight(),He.raw=He.raw.trimRight();var Ue=He.items.length;for(De=0;De<Ue;De++){this.lexer.state.top=!1,He.items[De].tokens=this.lexer.blockTokens(He.items[De].text,[]);var Ae=He.items[De].tokens.filter(function(ne){return ne.type==="space"}),Xe=Ae.every(function(ne){for(var he=ne.raw.split(""),Ie=0,Ke=A(he),Ye;!(Ye=Ke()).done;){var it=Ye.value;if(it===`
`&&(Ie+=1),Ie>1)return!0}return!1});!He.loose&&Ae.length&&Xe&&(He.loose=!0,He.items[De].loose=!0)}return He}},Y.html=function(Q){var te=this.rules.block.html.exec(Q);if(te){var $e={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(te[0]):D(te[0]);$e.type="paragraph",$e.text=ve,$e.tokens=this.lexer.inline(ve)}return $e}},Y.def=function(Q){var te=this.rules.block.def.exec(Q);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var $e=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:te[0],href:te[2],title:te[3]}}},Y.table=function(Q){var te=this.rules.block.table.exec(Q);if(te){var $e={type:"table",header:P(te[1]).map(function(x){return{text:x}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=te[0];var ve=$e.align.length,Le,pe,De,B;for(Le=0;Le<ve;Le++)/^ *-+: *$/.test($e.align[Le])?$e.align[Le]="right":/^ *:-+: *$/.test($e.align[Le])?$e.align[Le]="center":/^ *:-+ *$/.test($e.align[Le])?$e.align[Le]="left":$e.align[Le]=null;for(ve=$e.rows.length,Le=0;Le<ve;Le++)$e.rows[Le]=P($e.rows[Le],$e.header.length).map(function(x){return{text:x}});for(ve=$e.header.length,pe=0;pe<ve;pe++)$e.header[pe].tokens=this.lexer.inline($e.header[pe].text);for(ve=$e.rows.length,pe=0;pe<ve;pe++)for(B=$e.rows[pe],De=0;De<B.length;De++)B[De].tokens=this.lexer.inline(B[De].text);return $e}}},Y.lheading=function(Q){var te=this.rules.block.lheading.exec(Q);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},Y.paragraph=function(Q){var te=this.rules.block.paragraph.exec(Q);if(te){var $e=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:$e,tokens:this.lexer.inline($e)}}},Y.text=function(Q){var te=this.rules.block.text.exec(Q);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},Y.escape=function(Q){var te=this.rules.inline.escape.exec(Q);if(te)return{type:"escape",raw:te[0],text:D(te[1])}},Y.tag=function(Q){var te=this.rules.inline.tag.exec(Q);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):D(te[0]):te[0]}},Y.link=function(Q){var te=this.rules.inline.link.exec(Q);if(te){var $e=te[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var ve=S($e.slice(0,-1),"\\");if(($e.length-ve.length)%2===0)return}else{var Le=p(te[2],"()");if(Le>-1){var pe=te[0].indexOf("!")===0?5:4,De=pe+te[1].length+Le;te[2]=te[2].substring(0,Le),te[0]=te[0].substring(0,De).trim(),te[3]=""}}var B=te[2],x="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);se&&(B=se[1],x=se[3])}else x=te[3]?te[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test($e)?B=B.slice(1):B=B.slice(1,-1)),j(te,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:x&&x.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},Y.reflink=function(Q,te){var $e;if(($e=this.rules.inline.reflink.exec(Q))||($e=this.rules.inline.nolink.exec(Q))){var ve=($e[2]||$e[1]).replace(/\s+/g," ");if(ve=te[ve.toLowerCase()],!ve||!ve.href){var Le=$e[0].charAt(0);return{type:"text",raw:Le,text:Le}}return j($e,ve,$e[0],this.lexer)}},Y.emStrong=function(Q,te,$e){$e===void 0&&($e="");var ve=this.rules.inline.emStrong.lDelim.exec(Q);if(ve&&!(ve[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Le=ve[1]||ve[2]||"";if(!Le||Le&&($e===""||this.rules.inline.punctuation.exec($e))){var pe=ve[0].length-1,De,B,x=pe,se=0,H=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,te=te.slice(-1*Q.length+pe);(ve=H.exec(te))!=null;)if(De=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!De){if(B=De.length,ve[3]||ve[4]){x+=B;continue}else if((ve[5]||ve[6])&&pe%3&&!((pe+B)%3)){se+=B;continue}if(x-=B,!(x>0)){if(B=Math.min(B,B+x+se),Math.min(pe,B)%2){var ue=Q.slice(1,pe+ve.index+B);return{type:"em",raw:Q.slice(0,pe+ve.index+B+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}var fe=Q.slice(2,pe+ve.index+B-1);return{type:"strong",raw:Q.slice(0,pe+ve.index+B+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}}}}},Y.codespan=function(Q){var te=this.rules.inline.code.exec(Q);if(te){var $e=te[2].replace(/\n/g," "),ve=/[^ ]/.test($e),Le=/^ /.test($e)&&/ $/.test($e);return ve&&Le&&($e=$e.substring(1,$e.length-1)),$e=D($e,!0),{type:"codespan",raw:te[0],text:$e}}},Y.br=function(Q){var te=this.rules.inline.br.exec(Q);if(te)return{type:"br",raw:te[0]}},Y.del=function(Q){var te=this.rules.inline.del.exec(Q);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},Y.autolink=function(Q,te){var $e=this.rules.inline.autolink.exec(Q);if($e){var ve,Le;return $e[2]==="@"?(ve=D(this.options.mangle?te($e[1]):$e[1]),Le="mailto:"+ve):(ve=D($e[1]),Le=ve),{type:"link",raw:$e[0],text:ve,href:Le,tokens:[{type:"text",raw:ve,text:ve}]}}},Y.url=function(Q,te){var $e;if($e=this.rules.inline.url.exec(Q)){var ve,Le;if($e[2]==="@")ve=D(this.options.mangle?te($e[0]):$e[0]),Le="mailto:"+ve;else{var pe;do pe=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(pe!==$e[0]);ve=D($e[0]),$e[1]==="www."?Le="http://"+ve:Le=ve}return{type:"link",raw:$e[0],text:ve,href:Le,tokens:[{type:"text",raw:ve,text:ve}]}}},Y.inlineText=function(Q,te){var $e=this.rules.inline.text.exec(Q);if($e){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):D($e[0]):$e[0]:ve=D(this.options.smartypants?te($e[0]):$e[0]),{type:"text",raw:$e[0],text:ve}}},de}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=n(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=n(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=n(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=n(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=n(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=v({},U),U.gfm=v({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=n(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=v({},U.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:n(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=n(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=n(U._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=n(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=n(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=n(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=n(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=n(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=n(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=n(N.reflink).replace("label",N._label).replace("ref",U._label).getRegex(),N.nolink=n(N.nolink).replace("ref",U._label).getRegex(),N.reflinkSearch=n(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=v({},N),N.pedantic=v({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=v({},N.normal,{escape:n(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=n(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=v({},N.gfm,{br:n(N.br).replace("{2,}","*").getRegex(),text:n(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function R(de){return de.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function T(de){var Y="",X,Q,te=de.length;for(X=0;X<te;X++)Q=de.charCodeAt(X),Math.random()>.5&&(Q="x"+Q.toString(16)),Y+="&#"+Q+";";return Y}var q=function(){function de(X){this.tokens=[],this.tokens.links=Object.create(null),this.options=X||ie.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:U.normal,inline:N.normal};this.options.pedantic?(Q.block=U.pedantic,Q.inline=N.pedantic):this.options.gfm&&(Q.block=U.gfm,this.options.breaks?Q.inline=N.breaks:Q.inline=N.gfm),this.tokenizer.rules=Q}de.lex=function(Q,te){var $e=new de(te);return $e.lex(Q)},de.lexInline=function(Q,te){var $e=new de(te);return $e.inlineTokens(Q)};var Y=de.prototype;return Y.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},Y.blockTokens=function(Q,te){var $e=this;te===void 0&&(te=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(x,se,H){return se+"    ".repeat(H.length)});for(var ve,Le,pe,De;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(x){return(ve=x.call({lexer:$e},Q,te))?(Q=Q.substring(ve.raw.length),te.push(ve),!0):!1}))){if(ve=this.tokenizer.space(Q)){Q=Q.substring(ve.raw.length),ve.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(ve);continue}if(ve=this.tokenizer.code(Q)){Q=Q.substring(ve.raw.length),Le=te[te.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+ve.raw,Le.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):te.push(ve);continue}if(ve=this.tokenizer.fences(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.heading(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.hr(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.blockquote(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.list(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.html(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.def(Q)){Q=Q.substring(ve.raw.length),Le=te[te.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+ve.raw,Le.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.lheading(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(pe=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var x=1/0,se=Q.slice(1),H=void 0;$e.options.extensions.startBlock.forEach(function(ue){H=ue.call({lexer:this},se),typeof H=="number"&&H>=0&&(x=Math.min(x,H))}),x<1/0&&x>=0&&(pe=Q.substring(0,x+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(pe))){Le=te[te.length-1],De&&Le.type==="paragraph"?(Le.raw+=`
`+ve.raw,Le.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):te.push(ve),De=pe.length!==Q.length,Q=Q.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(Q)){Q=Q.substring(ve.raw.length),Le=te[te.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+ve.raw,Le.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):te.push(ve);continue}if(Q){var B="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,te},Y.inline=function(Q,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:Q,tokens:te}),te},Y.inlineTokens=function(Q,te){var $e=this;te===void 0&&(te=[]);var ve,Le,pe,De=Q,B,x,se;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)H.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,B.index)+"["+C("a",B[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,B.index)+"["+C("a",B[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,B.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(x||(se=""),x=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(ve=fe.call({lexer:$e},Q,te))?(Q=Q.substring(ve.raw.length),te.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.tag(Q)){Q=Q.substring(ve.raw.length),Le=te[te.length-1],Le&&ve.type==="text"&&Le.type==="text"?(Le.raw+=ve.raw,Le.text+=ve.text):te.push(ve);continue}if(ve=this.tokenizer.link(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ve.raw.length),Le=te[te.length-1],Le&&ve.type==="text"&&Le.type==="text"?(Le.raw+=ve.raw,Le.text+=ve.text):te.push(ve);continue}if(ve=this.tokenizer.emStrong(Q,De,se)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.codespan(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.br(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.del(Q)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.autolink(Q,T)){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(Q,T))){Q=Q.substring(ve.raw.length),te.push(ve);continue}if(pe=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,Re=Q.slice(1),Oe=void 0;$e.options.extensions.startInline.forEach(function(Ge){Oe=Ge.call({lexer:this},Re),typeof Oe=="number"&&Oe>=0&&(fe=Math.min(fe,Oe))}),fe<1/0&&fe>=0&&(pe=Q.substring(0,fe+1))}(),ve=this.tokenizer.inlineText(pe,R)){Q=Q.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(se=ve.raw.slice(-1)),x=!0,Le=te[te.length-1],Le&&Le.type==="text"?(Le.raw+=ve.raw,Le.text+=ve.text):te.push(ve);continue}if(Q){var ue="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return te},E(de,null,[{key:"rules",get:function(){return{block:U,inline:N}}}]),de}(),ee=function(){function de(X){this.options=X||ie.defaults}var Y=de.prototype;return Y.code=function(Q,te,$e){var ve=(te||"").match(/\S*/)[0];if(this.options.highlight){var Le=this.options.highlight(Q,ve);Le!=null&&Le!==Q&&($e=!0,Q=Le)}return Q=Q.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+D(ve,!0)+'">'+($e?Q:D(Q,!0))+`</code></pre>
`:"<pre><code>"+($e?Q:D(Q,!0))+`</code></pre>
`},Y.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},Y.html=function(Q){return Q},Y.heading=function(Q,te,$e,ve){if(this.options.headerIds){var Le=this.options.headerPrefix+ve.slug($e);return"<h"+te+' id="'+Le+'">'+Q+"</h"+te+`>
`}return"<h"+te+">"+Q+"</h"+te+`>
`},Y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Y.list=function(Q,te,$e){var ve=te?"ol":"ul",Le=te&&$e!==1?' start="'+$e+'"':"";return"<"+ve+Le+`>
`+Q+"</"+ve+`>
`},Y.listitem=function(Q){return"<li>"+Q+`</li>
`},Y.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Y.paragraph=function(Q){return"<p>"+Q+`</p>
`},Y.table=function(Q,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+te+`</table>
`},Y.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},Y.tablecell=function(Q,te){var $e=te.header?"th":"td",ve=te.align?"<"+$e+' align="'+te.align+'">':"<"+$e+">";return ve+Q+("</"+$e+`>
`)},Y.strong=function(Q){return"<strong>"+Q+"</strong>"},Y.em=function(Q){return"<em>"+Q+"</em>"},Y.codespan=function(Q){return"<code>"+Q+"</code>"},Y.br=function(){return this.options.xhtml?"<br/>":"<br>"},Y.del=function(Q){return"<del>"+Q+"</del>"},Y.link=function(Q,te,$e){if(Q=a(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var ve='<a href="'+D(Q)+'"';return te&&(ve+=' title="'+te+'"'),ve+=">"+$e+"</a>",ve},Y.image=function(Q,te,$e){if(Q=a(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var ve='<img src="'+Q+'" alt="'+$e+'"';return te&&(ve+=' title="'+te+'"'),ve+=this.options.xhtml?"/>":">",ve},Y.text=function(Q){return Q},de}(),J=function(){function de(){}var Y=de.prototype;return Y.strong=function(Q){return Q},Y.em=function(Q){return Q},Y.codespan=function(Q){return Q},Y.del=function(Q){return Q},Y.html=function(Q){return Q},Y.text=function(Q){return Q},Y.link=function(Q,te,$e){return""+$e},Y.image=function(Q,te,$e){return""+$e},Y.br=function(){return""},de}(),K=function(){function de(){this.seen={}}var Y=de.prototype;return Y.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Y.getNextSafeSlug=function(Q,te){var $e=Q,ve=0;if(this.seen.hasOwnProperty($e)){ve=this.seen[Q];do ve++,$e=Q+"-"+ve;while(this.seen.hasOwnProperty($e))}return te||(this.seen[Q]=ve,this.seen[$e]=0),$e},Y.slug=function(Q,te){te===void 0&&(te={});var $e=this.serialize(Q);return this.getNextSafeSlug($e,te.dryrun)},de}(),Z=function(){function de(X){this.options=X||ie.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new K}de.parse=function(Q,te){var $e=new de(te);return $e.parse(Q)},de.parseInline=function(Q,te){var $e=new de(te);return $e.parseInline(Q)};var Y=de.prototype;return Y.parse=function(Q,te){te===void 0&&(te=!0);var $e="",ve,Le,pe,De,B,x,se,H,ue,fe,Re,Oe,Ge,He,et,lt,ct,ot,Pe,Ue=Q.length;for(ve=0;ve<Ue;ve++){if(fe=Q[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Pe=this.options.extensions.renderers[fe.type].call({parser:this},fe),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){$e+=Pe||"";continue}switch(fe.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,g(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(H="",se="",De=fe.header.length,Le=0;Le<De;Le++)se+=this.renderer.tablecell(this.parseInline(fe.header[Le].tokens),{header:!0,align:fe.align[Le]});for(H+=this.renderer.tablerow(se),ue="",De=fe.rows.length,Le=0;Le<De;Le++){for(x=fe.rows[Le],se="",B=x.length,pe=0;pe<B;pe++)se+=this.renderer.tablecell(this.parseInline(x[pe].tokens),{header:!1,align:fe.align[pe]});ue+=this.renderer.tablerow(se)}$e+=this.renderer.table(H,ue);continue}case"blockquote":{ue=this.parse(fe.tokens),$e+=this.renderer.blockquote(ue);continue}case"list":{for(Re=fe.ordered,Oe=fe.start,Ge=fe.loose,De=fe.items.length,ue="",Le=0;Le<De;Le++)et=fe.items[Le],lt=et.checked,ct=et.task,He="",et.task&&(ot=this.renderer.checkbox(lt),Ge?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=ot+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=ot+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:ot}):He+=ot),He+=this.parse(et.tokens,Ge),ue+=this.renderer.listitem(He,ct,lt);$e+=this.renderer.list(ue,Re,Oe);continue}case"html":{$e+=this.renderer.html(fe.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(ue=fe.tokens?this.parseInline(fe.tokens):fe.text;ve+1<Ue&&Q[ve+1].type==="text";)fe=Q[++ve],ue+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);$e+=te?this.renderer.paragraph(ue):ue;continue}default:{var Ae='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return $e},Y.parseInline=function(Q,te){te=te||this.renderer;var $e="",ve,Le,pe,De=Q.length;for(ve=0;ve<De;ve++){if(Le=Q[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Le.type]&&(pe=this.options.extensions.renderers[Le.type].call({parser:this},Le),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Le.type))){$e+=pe||"";continue}switch(Le.type){case"escape":{$e+=te.text(Le.text);break}case"html":{$e+=te.html(Le.text);break}case"link":{$e+=te.link(Le.href,Le.title,this.parseInline(Le.tokens,te));break}case"image":{$e+=te.image(Le.href,Le.title,Le.text);break}case"strong":{$e+=te.strong(this.parseInline(Le.tokens,te));break}case"em":{$e+=te.em(this.parseInline(Le.tokens,te));break}case"codespan":{$e+=te.codespan(Le.text);break}case"br":{$e+=te.br();break}case"del":{$e+=te.del(this.parseInline(Le.tokens,te));break}case"text":{$e+=te.text(Le.text);break}default:{var B='Token with "'+Le.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return $e},de}();function ae(de,Y,X){if(typeof de>"u"||de===null)throw new Error("marked(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");if(typeof Y=="function"&&(X=Y,Y=null),Y=v({},ae.defaults,Y||{}),k(Y),X){var Q=Y.highlight,te;try{te=q.lex(de,Y)}catch(De){return X(De)}var $e=function(B){var x;if(!B)try{Y.walkTokens&&ae.walkTokens(te,Y.walkTokens),x=Z.parse(te,Y)}catch(se){B=se}return Y.highlight=Q,B?X(B):X(null,x)};if(!Q||Q.length<3||(delete Y.highlight,!te.length))return $e();var ve=0;ae.walkTokens(te,function(De){De.type==="code"&&(ve++,setTimeout(function(){Q(De.text,De.lang,function(B,x){if(B)return $e(B);x!=null&&x!==De.text&&(De.text=x,De.escaped=!0),ve--,ve===0&&$e()})},0))}),ve===0&&$e();return}function Le(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+D(De.message+"",!0)+"</pre>";throw De}try{var pe=q.lex(de,Y);if(Y.walkTokens){if(Y.async)return Promise.all(ae.walkTokens(pe,Y.walkTokens)).then(function(){return Z.parse(pe,Y)}).catch(Le);ae.walkTokens(pe,Y.walkTokens)}return Z.parse(pe,Y)}catch(De){Le(De)}}ae.options=ae.setOptions=function(de){return v(ae.defaults,de),b(ae.defaults),ae},ae.getDefaults=M,ae.defaults=ie.defaults,ae.use=function(){for(var de=arguments.length,Y=new Array(de),X=0;X<de;X++)Y[X]=arguments[X];var Q=v.apply(void 0,[{}].concat(Y)),te=ae.defaults.extensions||{renderers:{},childTokens:{}},$e;Y.forEach(function(ve){if(ve.extensions&&($e=!0,ve.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var De=te.renderers?te.renderers[pe.name]:null;De?te.renderers[pe.name]=function(){for(var B=arguments.length,x=new Array(B),se=0;se<B;se++)x[se]=arguments[se];var H=pe.renderer.apply(this,x);return H===!1&&(H=De.apply(this,x)),H}:te.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[pe.level]?te[pe.level].unshift(pe.tokenizer):te[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?te.startBlock?te.startBlock.push(pe.start):te.startBlock=[pe.start]:pe.level==="inline"&&(te.startInline?te.startInline.push(pe.start):te.startInline=[pe.start]))}pe.childTokens&&(te.childTokens[pe.name]=pe.childTokens)})),ve.renderer&&function(){var pe=ae.defaults.renderer||new ee,De=function(se){var H=pe[se];pe[se]=function(){for(var ue=arguments.length,fe=new Array(ue),Re=0;Re<ue;Re++)fe[Re]=arguments[Re];var Oe=ve.renderer[se].apply(pe,fe);return Oe===!1&&(Oe=H.apply(pe,fe)),Oe}};for(var B in ve.renderer)De(B);Q.renderer=pe}(),ve.tokenizer&&function(){var pe=ae.defaults.tokenizer||new O,De=function(se){var H=pe[se];pe[se]=function(){for(var ue=arguments.length,fe=new Array(ue),Re=0;Re<ue;Re++)fe[Re]=arguments[Re];var Oe=ve.tokenizer[se].apply(pe,fe);return Oe===!1&&(Oe=H.apply(pe,fe)),Oe}};for(var B in ve.tokenizer)De(B);Q.tokenizer=pe}(),ve.walkTokens){var Le=ae.defaults.walkTokens;Q.walkTokens=function(pe){var De=[];return De.push(ve.walkTokens.call(this,pe)),Le&&(De=De.concat(Le.call(this,pe))),De}}$e&&(Q.extensions=te),ae.setOptions(Q)})},ae.walkTokens=function(de,Y){for(var X=[],Q=function(){var Le=$e.value;switch(X=X.concat(Y.call(ae,Le)),Le.type){case"table":{for(var pe=A(Le.header),De;!(De=pe()).done;){var B=De.value;X=X.concat(ae.walkTokens(B.tokens,Y))}for(var x=A(Le.rows),se;!(se=x()).done;)for(var H=se.value,ue=A(H),fe;!(fe=ue()).done;){var Re=fe.value;X=X.concat(ae.walkTokens(Re.tokens,Y))}break}case"list":{X=X.concat(ae.walkTokens(Le.items,Y));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[Le.type]?ae.defaults.extensions.childTokens[Le.type].forEach(function(Oe){X=X.concat(ae.walkTokens(Le[Oe],Y))}):Le.tokens&&(X=X.concat(ae.walkTokens(Le.tokens,Y)))}},te=A(de),$e;!($e=te()).done;)Q();return X},ae.parseInline=function(de,Y){if(typeof de>"u"||de===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");Y=v({},ae.defaults,Y||{}),k(Y);try{var X=q.lexInline(de,Y);return Y.walkTokens&&ae.walkTokens(X,Y.walkTokens),Z.parseInline(X,Y)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+D(Q.message+"",!0)+"</pre>";throw Q}},ae.Parser=Z,ae.parser=Z.parse,ae.Renderer=ee,ae.TextRenderer=J,ae.Lexer=q,ae.lexer=q.lex,ae.Tokenizer=O,ae.Slugger=K,ae.parse=ae;var _=ae.options,ye=ae.setOptions,ge=ae.use,re=ae.walkTokens,W=ae.parseInline,ce=ae,me=Z.parse,le=q.lex;ie.Lexer=q,ie.Parser=Z,ie.Renderer=ee,ie.Slugger=K,ie.TextRenderer=J,ie.Tokenizer=O,ie.getDefaults=M,ie.lexer=le,ie.marked=ae,ie.options=_,ie.parse=ce,ie.parseInline=W,ie.parser=me,ie.setOptions=ye,ie.use=ge,ie.walkTokens=re,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Se[162],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0;function E(u){const g=A(u);if(g&&g.length>0)return new Uint32Array(g)}e.$Nj=E;let F=0;const f=new Uint32Array(10);function A(u){if(F=0,M(u,I,4352),F>0||(M(u,$,4449),F>0)||(M(u,y,4520),F>0)||(M(u,D,12593),F))return f.subarray(0,F);if(u>=44032&&u<=55203){const g=u-44032,o=g%588,n=Math.floor(g/588),i=Math.floor(o/28),s=o%28-1;if(n<I.length?M(n,I,0):4352+n-12593<D.length&&M(4352+n,D,12593),i<$.length?M(i,$,0):4449+i-12593<D.length&&M(4449+i-12593,D,12593),s>=0&&(s<y.length?M(s,y,0):4520+s-12593<D.length&&M(4520+s-12593,D,12593)),F>0)return f.subarray(0,F)}}function M(u,g,o){u>=o&&u<o+g.length&&b(g[u-o])}function b(u){u!==0&&(f[F++]=u&255,u>>8&&(f[F++]=u>>8&255),u>>16&&(f[F++]=u>>16&255))}var m;(function(u){u[u.InitialConsonant=4352]="InitialConsonant",u[u.Vowel=4449]="Vowel",u[u.FinalConsonant=4520]="FinalConsonant",u[u.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var w;(function(u){u[u.NUL=0]="NUL",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z"})(w||(w={}));var L;(function(u){u[u.fa=24934]="fa",u[u.fg=26470]="fg",u[u.fq=29030]="fq",u[u.fr=29286]="fr",u[u.ft=29798]="ft",u[u.fv=30310]="fv",u[u.fx=30822]="fx",u[u.hk=27496]="hk",u[u.hl=27752]="hl",u[u.ho=28520]="ho",u[u.ml=27757]="ml",u[u.nj=27246]="nj",u[u.nl=27758]="nl",u[u.np=28782]="np",u[u.qt=29809]="qt",u[u.rt=29810]="rt",u[u.sg=26483]="sg",u[u.sw=30579]="sw"})(L||(L={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),$=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),y=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),D=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[76],ke([1,0,28]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=void 0;const F=new E.$Dc(1e4);function f(w){return m(w,"NFC",F)}e.$Cl=f;const A=new E.$Dc(1e4);function M(w){return m(w,"NFD",A)}e.$Dl=M;const b=/[^\u0000-\u0080]/;function m(w,L,I){if(!w)return w;const $=I.get(w);if($)return $;let y;return b.test(w)?y=w.normalize(L):y=w,I.set(w,y),y}e.$El=function(){const w=/[\u0300-\u036f]/g;return function(L){return M(L).replace(w,"")}}()}),define(Se[123],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.rot=e.$3l=void 0;function E(b,m,w){return Math.min(Math.max(b,m),w)}e.$3l=E;function F(b,m){return(m+b%m)%m}e.rot=F;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$5l=f;class A{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$6l=A;class M{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const w=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$7l=M}),function(){function ie(f){const A=[];typeof f=="number"&&A.push("code/timeOrigin",f);function M(m){A.push(m,Date.now())}function b(){const m=[];for(let w=0;w<A.length;w+=2)m.push({name:A[w],startTime:A[w+1]});return m}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const M of performance.getEntriesByType("mark"))A.push({name:M.name,startTime:Math.round(f+M.startTime)});return A}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function E(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=E(F))}(),define(Se[9],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D=e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.$b=e.Platform=e.$a=void 0,e.$a="en";let E=!1,F=!1,f=!1,A=!1,M=!1,b=!1,m=!1,w=!1,L=!1,I=!1,$,y=e.$a,D=e.$a,u,g;const o=globalThis;let n;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?n=o.vscode.process:typeof process<"u"&&(n=process);const i=typeof n?.versions?.electron=="string",s=i&&n?.type==="renderer";if(typeof navigator=="object"&&!s){g=navigator.userAgent,E=g.indexOf("Windows")>=0,F=g.indexOf("Macintosh")>=0,w=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=g.indexOf("Linux")>=0,I=g?.indexOf("Mobi")>=0,b=!0,$=e.$a,y=$,D=navigator.language;const S=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),p=S&&S.getAttribute("data-settings");if(p)try{const k=JSON.parse(p),C=k.availableLanguages["*"];$=k.locale,D=k.osLocale,y=C||e.$a,u=k._translationsConfigFile}catch{}}else if(typeof n=="object"){E=n.platform==="win32",F=n.platform==="darwin",f=n.platform==="linux",A=f&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,m=i,L=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$a,y=e.$a;const S=n.env.VSCODE_NLS_CONFIG;if(S)try{const p=JSON.parse(S),k=p.availableLanguages["*"];$=p.locale,D=p.osLocale,y=k||e.$a,u=p._translationsConfigFile}catch{}M=!0}else console.error("Unable to resolve platform.");var a;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(a||(e.Platform=a={}));function t(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$b=t;let r=0;F?r=1:E?r=3:f&&(r=2),e.$c=E,e.$d=F,e.$e=f,e.$f=A,e.$g=M,e.$h=m,e.$i=b,e.$j=b&&typeof o.importScripts=="function",e.$k=e.$j?o.origin:void 0,e.$l=w,e.$m=I,e.$n=L,e.$o=r,e.$p=g,e.$q=y;var d;(function(S){function p(){return e.$q}S.value=p;function k(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}S.isDefaultVariant=k;function C(){return e.$q==="en"}S.isDefault=C})(d||(e.Language=d={})),e.$r=$,e.$s=D,e.$t=u,e.$u=typeof o.postMessage=="function"&&!o.importScripts,e.$v=(()=>{if(e.$u){const S=[];o.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let C=0,j=S.length;C<j;C++){const z=S[C];if(z.id===k.data.vscodeScheduleAsyncWork){S.splice(C,1),z.callback();return}}});let p=0;return k=>{const C=++p;S.push({id:C,callback:k}),o.postMessage({vscodeScheduleAsyncWork:C},"*")}}return S=>setTimeout(S)})();var l;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=F||w?2:E?1:3;let h=!0,c=!1;function v(){if(!c){c=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,h=new Uint16Array(S.buffer)[0]===(2<<8)+1}return h}e.$x=v,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function P(S){return parseFloat(S)>=20}e.$D=P}),define(Se[49],ke([1,0,9]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.process<"u"){const A=f.process;F={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return E.$c?"win32":E.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$dc=F.platform,e.$ec=F.arch}),define(Se[16],ke([1,0,49]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const F=65,f=97,A=90,M=122,b=46,m=47,w=92,L=58,I=63;class $ extends Error{constructor(r,d,l){let h;typeof d=="string"&&d.indexOf("not ")===0?(h="must not be",d=d.replace(/^not /,"")):h="must be";const c=r.indexOf(".")!==-1?"property":"argument";let v=`The "${r}" ${c} ${h} of type ${d}`;v+=`. Received type ${typeof l}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,r){if(t===null||typeof t!="object")throw new $(r,"Object",t)}function D(t,r){if(typeof t!="string")throw new $(r,"string",t)}const u=E.$dc==="win32";function g(t){return t===m||t===w}function o(t){return t===m}function n(t){return t>=F&&t<=A||t>=f&&t<=M}function i(t,r,d,l){let h="",c=0,v=-1,P=0,S=0;for(let p=0;p<=t.length;++p){if(p<t.length)S=t.charCodeAt(p);else{if(l(S))break;S=m}if(l(S)){if(!(v===p-1||P===1))if(P===2){if(h.length<2||c!==2||h.charCodeAt(h.length-1)!==b||h.charCodeAt(h.length-2)!==b){if(h.length>2){const k=h.lastIndexOf(d);k===-1?(h="",c=0):(h=h.slice(0,k),c=h.length-1-h.lastIndexOf(d)),v=p,P=0;continue}else if(h.length!==0){h="",c=0,v=p,P=0;continue}}r&&(h+=h.length>0?`${d}..`:"..",c=2)}else h.length>0?h+=`${d}${t.slice(v+1,p)}`:h=t.slice(v+1,p),c=p-v-1;v=p,P=0}else S===b&&P!==-1?++P:P=-1}return h}function s(t,r){y(r,"pathObject");const d=r.dir||r.root,l=r.base||`${r.name||""}${r.ext||""}`;return d?d===r.root?`${d}${l}`:`${d}${t}${l}`:l}e.$fc={resolve(...t){let r="",d="",l=!1;for(let h=t.length-1;h>=-1;h--){let c;if(h>=0){if(c=t[h],D(c,"path"),c.length===0)continue}else r.length===0?c=E.cwd():(c=E.env[`=${r}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===w)&&(c=`${r}\\`));const v=c.length;let P=0,S="",p=!1;const k=c.charCodeAt(0);if(v===1)g(k)&&(P=1,p=!0);else if(g(k))if(p=!0,g(c.charCodeAt(1))){let C=2,j=C;for(;C<v&&!g(c.charCodeAt(C));)C++;if(C<v&&C!==j){const z=c.slice(j,C);for(j=C;C<v&&g(c.charCodeAt(C));)C++;if(C<v&&C!==j){for(j=C;C<v&&!g(c.charCodeAt(C));)C++;(C===v||C!==j)&&(S=`\\\\${z}\\${c.slice(j,C)}`,P=C)}}}else P=1;else n(k)&&c.charCodeAt(1)===L&&(S=c.slice(0,2),P=2,v>2&&g(c.charCodeAt(2))&&(p=!0,P=3));if(S.length>0)if(r.length>0){if(S.toLowerCase()!==r.toLowerCase())continue}else r=S;if(l){if(r.length>0)break}else if(d=`${c.slice(P)}\\${d}`,l=p,p&&r.length>0)break}return d=i(d,!l,"\\",g),l?`${r}\\${d}`:`${r}${d}`||"."},normalize(t){D(t,"path");const r=t.length;if(r===0)return".";let d=0,l,h=!1;const c=t.charCodeAt(0);if(r===1)return o(c)?"\\":t;if(g(c))if(h=!0,g(t.charCodeAt(1))){let P=2,S=P;for(;P<r&&!g(t.charCodeAt(P));)P++;if(P<r&&P!==S){const p=t.slice(S,P);for(S=P;P<r&&g(t.charCodeAt(P));)P++;if(P<r&&P!==S){for(S=P;P<r&&!g(t.charCodeAt(P));)P++;if(P===r)return`\\\\${p}\\${t.slice(S)}\\`;P!==S&&(l=`\\\\${p}\\${t.slice(S,P)}`,d=P)}}}else d=1;else n(c)&&t.charCodeAt(1)===L&&(l=t.slice(0,2),d=2,r>2&&g(t.charCodeAt(2))&&(h=!0,d=3));let v=d<r?i(t.slice(d),!h,"\\",g):"";return v.length===0&&!h&&(v="."),v.length>0&&g(t.charCodeAt(r-1))&&(v+="\\"),l===void 0?h?`\\${v}`:v:h?`${l}\\${v}`:`${l}${v}`},isAbsolute(t){D(t,"path");const r=t.length;if(r===0)return!1;const d=t.charCodeAt(0);return g(d)||r>2&&n(d)&&t.charCodeAt(1)===L&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,d;for(let c=0;c<t.length;++c){const v=t[c];D(v,"path"),v.length>0&&(r===void 0?r=d=v:r+=`\\${v}`)}if(r===void 0)return".";let l=!0,h=0;if(typeof d=="string"&&g(d.charCodeAt(0))){++h;const c=d.length;c>1&&g(d.charCodeAt(1))&&(++h,c>2&&(g(d.charCodeAt(2))?++h:l=!1))}if(l){for(;h<r.length&&g(r.charCodeAt(h));)h++;h>=2&&(r=`\\${r.slice(h)}`)}return e.$fc.normalize(r)},relative(t,r){if(D(t,"from"),D(r,"to"),t===r)return"";const d=e.$fc.resolve(t),l=e.$fc.resolve(r);if(d===l||(t=d.toLowerCase(),r=l.toLowerCase(),t===r))return"";let h=0;for(;h<t.length&&t.charCodeAt(h)===w;)h++;let c=t.length;for(;c-1>h&&t.charCodeAt(c-1)===w;)c--;const v=c-h;let P=0;for(;P<r.length&&r.charCodeAt(P)===w;)P++;let S=r.length;for(;S-1>P&&r.charCodeAt(S-1)===w;)S--;const p=S-P,k=v<p?v:p;let C=-1,j=0;for(;j<k;j++){const O=t.charCodeAt(h+j);if(O!==r.charCodeAt(P+j))break;O===w&&(C=j)}if(j!==k){if(C===-1)return l}else{if(p>k){if(r.charCodeAt(P+j)===w)return l.slice(P+j+1);if(j===2)return l.slice(P+j)}v>k&&(t.charCodeAt(h+j)===w?C=j:j===2&&(C=3)),C===-1&&(C=0)}let z="";for(j=h+C+1;j<=c;++j)(j===c||t.charCodeAt(j)===w)&&(z+=z.length===0?"..":"\\..");return P+=C,z.length>0?`${z}${l.slice(P,S)}`:(l.charCodeAt(P)===w&&++P,l.slice(P,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===w){if(r.charCodeAt(1)===w){const d=r.charCodeAt(2);if(d!==I&&d!==b)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(n(r.charCodeAt(0))&&r.charCodeAt(1)===L&&r.charCodeAt(2)===w)return`\\\\?\\${r}`;return t},dirname(t){D(t,"path");const r=t.length;if(r===0)return".";let d=-1,l=0;const h=t.charCodeAt(0);if(r===1)return g(h)?t:".";if(g(h)){if(d=l=1,g(t.charCodeAt(1))){let P=2,S=P;for(;P<r&&!g(t.charCodeAt(P));)P++;if(P<r&&P!==S){for(S=P;P<r&&g(t.charCodeAt(P));)P++;if(P<r&&P!==S){for(S=P;P<r&&!g(t.charCodeAt(P));)P++;if(P===r)return t;P!==S&&(d=l=P+1)}}}}else n(h)&&t.charCodeAt(1)===L&&(d=r>2&&g(t.charCodeAt(2))?3:2,l=d);let c=-1,v=!0;for(let P=r-1;P>=l;--P)if(g(t.charCodeAt(P))){if(!v){c=P;break}}else v=!1;if(c===-1){if(d===-1)return".";c=d}return t.slice(0,c)},basename(t,r){r!==void 0&&D(r,"ext"),D(t,"path");let d=0,l=-1,h=!0,c;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(d=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let v=r.length-1,P=-1;for(c=t.length-1;c>=d;--c){const S=t.charCodeAt(c);if(g(S)){if(!h){d=c+1;break}}else P===-1&&(h=!1,P=c+1),v>=0&&(S===r.charCodeAt(v)?--v===-1&&(l=c):(v=-1,l=P))}return d===l?l=P:l===-1&&(l=t.length),t.slice(d,l)}for(c=t.length-1;c>=d;--c)if(g(t.charCodeAt(c))){if(!h){d=c+1;break}}else l===-1&&(h=!1,l=c+1);return l===-1?"":t.slice(d,l)},extname(t){D(t,"path");let r=0,d=-1,l=0,h=-1,c=!0,v=0;t.length>=2&&t.charCodeAt(1)===L&&n(t.charCodeAt(0))&&(r=l=2);for(let P=t.length-1;P>=r;--P){const S=t.charCodeAt(P);if(g(S)){if(!c){l=P+1;break}continue}h===-1&&(c=!1,h=P+1),S===b?d===-1?d=P:v!==1&&(v=1):d!==-1&&(v=-1)}return d===-1||h===-1||v===0||v===1&&d===h-1&&d===l+1?"":t.slice(d,h)},format:s.bind(null,"\\"),parse(t){D(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.length;let l=0,h=t.charCodeAt(0);if(d===1)return g(h)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(g(h)){if(l=1,g(t.charCodeAt(1))){let C=2,j=C;for(;C<d&&!g(t.charCodeAt(C));)C++;if(C<d&&C!==j){for(j=C;C<d&&g(t.charCodeAt(C));)C++;if(C<d&&C!==j){for(j=C;C<d&&!g(t.charCodeAt(C));)C++;C===d?l=C:C!==j&&(l=C+1)}}}}else if(n(h)&&t.charCodeAt(1)===L){if(d<=2)return r.root=r.dir=t,r;if(l=2,g(t.charCodeAt(2))){if(d===3)return r.root=r.dir=t,r;l=3}}l>0&&(r.root=t.slice(0,l));let c=-1,v=l,P=-1,S=!0,p=t.length-1,k=0;for(;p>=l;--p){if(h=t.charCodeAt(p),g(h)){if(!S){v=p+1;break}continue}P===-1&&(S=!1,P=p+1),h===b?c===-1?c=p:k!==1&&(k=1):c!==-1&&(k=-1)}return P!==-1&&(c===-1||k===0||k===1&&c===P-1&&c===v+1?r.base=r.name=t.slice(v,P):(r.name=t.slice(v,c),r.base=t.slice(v,P),r.ext=t.slice(c,P))),v>0&&v!==l?r.dir=t.slice(0,v-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(u){const t=/\\/g;return()=>{const r=E.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>E.cwd()})();e.$gc={resolve(...t){let r="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const h=l>=0?t[l]:a();D(h,"path"),h.length!==0&&(r=`${h}/${r}`,d=h.charCodeAt(0)===m)}return r=i(r,!d,"/",o),d?`/${r}`:r.length>0?r:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===m,d=t.charCodeAt(t.length-1)===m;return t=i(t,!r,"/",o),t.length===0?r?"/":d?"./":".":(d&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===m},join(...t){if(t.length===0)return".";let r;for(let d=0;d<t.length;++d){const l=t[d];D(l,"path"),l.length>0&&(r===void 0?r=l:r+=`/${l}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(D(t,"from"),D(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const d=1,l=t.length,h=l-d,c=1,v=r.length-c,P=h<v?h:v;let S=-1,p=0;for(;p<P;p++){const C=t.charCodeAt(d+p);if(C!==r.charCodeAt(c+p))break;C===m&&(S=p)}if(p===P)if(v>P){if(r.charCodeAt(c+p)===m)return r.slice(c+p+1);if(p===0)return r.slice(c+p)}else h>P&&(t.charCodeAt(d+p)===m?S=p:p===0&&(S=0));let k="";for(p=d+S+1;p<=l;++p)(p===l||t.charCodeAt(p)===m)&&(k+=k.length===0?"..":"/..");return`${k}${r.slice(c+S)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===m;let d=-1,l=!0;for(let h=t.length-1;h>=1;--h)if(t.charCodeAt(h)===m){if(!l){d=h;break}}else l=!1;return d===-1?r?"/":".":r&&d===1?"//":t.slice(0,d)},basename(t,r){r!==void 0&&D(r,"ext"),D(t,"path");let d=0,l=-1,h=!0,c;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let v=r.length-1,P=-1;for(c=t.length-1;c>=0;--c){const S=t.charCodeAt(c);if(S===m){if(!h){d=c+1;break}}else P===-1&&(h=!1,P=c+1),v>=0&&(S===r.charCodeAt(v)?--v===-1&&(l=c):(v=-1,l=P))}return d===l?l=P:l===-1&&(l=t.length),t.slice(d,l)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===m){if(!h){d=c+1;break}}else l===-1&&(h=!1,l=c+1);return l===-1?"":t.slice(d,l)},extname(t){D(t,"path");let r=-1,d=0,l=-1,h=!0,c=0;for(let v=t.length-1;v>=0;--v){const P=t.charCodeAt(v);if(P===m){if(!h){d=v+1;break}continue}l===-1&&(h=!1,l=v+1),P===b?r===-1?r=v:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||l===-1||c===0||c===1&&r===l-1&&r===d+1?"":t.slice(r,l)},format:s.bind(null,"/"),parse(t){D(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.charCodeAt(0)===m;let l;d?(r.root="/",l=1):l=0;let h=-1,c=0,v=-1,P=!0,S=t.length-1,p=0;for(;S>=l;--S){const k=t.charCodeAt(S);if(k===m){if(!P){c=S+1;break}continue}v===-1&&(P=!1,v=S+1),k===b?h===-1?h=S:p!==1&&(p=1):h!==-1&&(p=-1)}if(v!==-1){const k=c===0&&d?1:c;h===-1||p===0||p===1&&h===v-1&&h===c+1?r.base=r.name=t.slice(k,v):(r.name=t.slice(k,h),r.base=t.slice(k,v),r.ext=t.slice(h,v))}return c>0?r.dir=t.slice(0,c-1):d&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=u?e.$fc.normalize:e.$gc.normalize,e.$ic=u?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=u?e.$fc.join:e.$gc.join,e.$kc=u?e.$fc.resolve:e.$gc.resolve,e.$lc=u?e.$fc.relative:e.$gc.relative,e.$mc=u?e.$fc.dirname:e.$gc.dirname,e.$nc=u?e.$fc.basename:e.$gc.basename,e.$oc=u?e.$fc.extname:e.$gc.extname,e.$pc=u?e.$fc.format:e.$gc.format,e.$qc=u?e.$fc.parse:e.$gc.parse,e.$rc=u?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=u?e.$fc.sep:e.$gc.sep,e.$tc=u?e.$fc.delimiter:e.$gc.delimiter}),define(Se[124],ke([1,0,43,16]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=void 0;const f=new E.$V(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),A=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(P,S,p=!1){const k=P||"",C=S||"",j=f.value.collator.compare(k,C);return f.value.collatorIsNumeric&&j===0&&k!==C?k<C?-1:1:j}e.$vq=b;function m(P,S){const p=A.value.collator;return P=P||"",S=S||"",s(p,P,S)}e.$wq=m;function w(P,S){const p=A.value.collator;return P=P||"",S=S||"",d(P,S)||s(p,P,S)}e.$xq=w;function L(P,S){const p=A.value.collator;return P=P||"",S=S||"",r(P,S)||s(p,P,S)}e.$yq=L;function I(P,S){return P=P||"",S=S||"",P===S?0:P<S?-1:1}e.$zq=I;function $(P,S){const[p,k]=n(P),[C,j]=n(S);let z=f.value.collator.compare(k,j);if(z===0){if(f.value.collatorIsNumeric&&k!==j)return k<j?-1:1;if(z=f.value.collator.compare(p,C),f.value.collatorIsNumeric&&z===0&&p!==C)return p<C?-1:1}return z}e.$Aq=$;function y(P,S){P=P||"",S=S||"";const p=i(P),k=i(S),C=A.value.collator,j=M.value.collator;return s(j,p,k)||s(C,P,S)}e.$Bq=y;function D(P,S){P=P||"",S=S||"";const p=i(P),k=i(S),C=A.value.collator,j=M.value.collator;return s(j,p,k)||d(P,S)||s(C,P,S)}e.$Cq=D;function u(P,S){P=P||"",S=S||"";const p=i(P),k=i(S),C=A.value.collator,j=M.value.collator;return s(j,p,k)||r(P,S)||s(C,P,S)}e.$Dq=u;function g(P,S){P=P||"",S=S||"";const p=i(P).toLowerCase(),k=i(S).toLowerCase();return p!==k?p<k?-1:1:P!==S?P<S?-1:1:0}e.$Eq=g;const o=/^(.*?)(\.([^.]*))?$/;function n(P,S=!1){const p=P?o.exec(P):[];let k=[p&&p[1]||"",p&&p[3]||""];return S&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function i(P){const S=P?o.exec(P):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function s(P,S,p){const k=P.compare(S,p);return k!==0?k:S.length!==p.length?S.length<p.length?-1:1:0}function a(P){const S=P.charAt(0);return S.toLocaleUpperCase()!==S}function t(P){const S=P.charAt(0);return S.toLocaleLowerCase()!==S}function r(P,S){return a(P)&&t(S)?-1:t(P)&&a(S)?1:0}function d(P,S){return t(P)&&a(S)?-1:a(P)&&t(S)?1:0}function l(P,S,p=!1){return p||(P=P&&P.toLowerCase(),S=S&&S.toLowerCase()),P===S?0:P<S?-1:1}function h(P,S,p=!1){const k=P.split(F.sep),C=S.split(F.sep),j=k.length-1,z=C.length-1;let O,U;for(let N=0;;N++){if(O=j===N,U=z===N,O&&U)return b(k[N],C[N],p);if(O)return-1;if(U)return 1;const R=l(k[N],C[N],p);if(R!==0)return R}}e.$Fq=h;function c(P,S,p){const k=P.toLowerCase(),C=S.toLowerCase(),j=v(P,S,p);if(j)return j;const z=k.endsWith(p),O=C.endsWith(p);if(z!==O)return z?-1:1;const U=b(k,C);return U!==0?U:k.localeCompare(C)}e.$Gq=c;function v(P,S,p){const k=P.toLowerCase(),C=S.toLowerCase(),j=k.startsWith(p),z=C.startsWith(p);if(j!==z)return j?-1:1;if(j&&z){if(k.length<C.length)return-1;if(k.length>C.length)return 1}return 0}e.$Hq=v}),define(Se[98],ke([1,0,16]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=e.$4r=void 0,e.$4r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(L){const I=(0,E.$oc)(L),$=F[I.toLowerCase()];return $!==void 0?$:M(L)}e.$5r=A;function M(L){const I=(0,E.$oc)(L);return f[I.toLowerCase()]}e.$6r=M;function b(L){for(const I in f)if(f[I]===L)return I}e.$7r=b;const m=/^(.+)\/(.+?)(;.+)?$/;function w(L,I){const $=m.exec(L);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:I?void 0:L}e.$8r=w}),define(Se[99],ke([1,0,9]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.TerminateResponseCode=e.Source=void 0;var F;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(F||(e.Source=F={}));var f;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function A(b,...m){const w=m.reduce(($,y)=>($[y]=!0,$),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(b).filter($=>!w[$]).forEach($=>{for(let y=0;y<L.length;y++)if($.search(L[y])!==-1){delete b[$];break}})}e.$Nl=A;function M(b){b&&(delete b.DEBUG,E.$d&&delete b.DYLD_LIBRARY_PATH,E.$e&&delete b.LD_PRELOAD)}e.$Ol=M}),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var F in E)(typeof exports=="object"?exports:ie)[F]=E[F]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function E(F){if(e[F])return e[F].exports;var f=e[F]={i:F,l:!1,exports:{}};return ie[F].call(f.exports,f,f.exports,E),f.l=!0,f.exports}return E.m=ie,E.c=e,E.d=function(F,f,A){E.o(F,f)||Object.defineProperty(F,f,{enumerable:!0,get:A})},E.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},E.t=function(F,f){if(1&f&&(F=E(F)),8&f||4&f&&typeof F=="object"&&F&&F.__esModule)return F;var A=Object.create(null);if(E.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:F}),2&f&&typeof F!="string")for(var M in F)E.d(A,M,function(b){return F[b]}.bind(null,M));return A},E.n=function(F){var f=F&&F.__esModule?function(){return F.default}:function(){return F};return E.d(f,"a",f),f},E.o=function(F,f){return Object.prototype.hasOwnProperty.call(F,f)},E.p="",E(E.s=0)}([function(ie,e,E){(function(F){var f;e=ie.exports=ge,f=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],m=e.src=[],w=0,L=w++;m[L]="0|[1-9]\\d*";var I=w++;m[I]="[0-9]+";var $=w++;m[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=w++;m[y]="("+m[L]+")\\.("+m[L]+")\\.("+m[L]+")";var D=w++;m[D]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var u=w++;m[u]="(?:"+m[L]+"|"+m[$]+")";var g=w++;m[g]="(?:"+m[I]+"|"+m[$]+")";var o=w++;m[o]="(?:-("+m[u]+"(?:\\."+m[u]+")*))";var n=w++;m[n]="(?:-?("+m[g]+"(?:\\."+m[g]+")*))";var i=w++;m[i]="[0-9A-Za-z-]+";var s=w++;m[s]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var a=w++,t="v?"+m[y]+m[o]+"?"+m[s]+"?";m[a]="^"+t+"$";var r="[v=\\s]*"+m[D]+m[n]+"?"+m[s]+"?",d=w++;m[d]="^"+r+"$";var l=w++;m[l]="((?:<|>)?=?)";var h=w++;m[h]=m[I]+"|x|X|\\*";var c=w++;m[c]=m[L]+"|x|X|\\*";var v=w++;m[v]="[v=\\s]*("+m[c]+")(?:\\.("+m[c]+")(?:\\.("+m[c]+")(?:"+m[o]+")?"+m[s]+"?)?)?";var P=w++;m[P]="[v=\\s]*("+m[h]+")(?:\\.("+m[h]+")(?:\\.("+m[h]+")(?:"+m[n]+")?"+m[s]+"?)?)?";var S=w++;m[S]="^"+m[l]+"\\s*"+m[v]+"$";var p=w++;m[p]="^"+m[l]+"\\s*"+m[P]+"$";var k=w++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=w++;m[C]="(?:~>?)";var j=w++;m[j]="(\\s*)"+m[C]+"\\s+",b[j]=new RegExp(m[j],"g");var z=w++;m[z]="^"+m[C]+m[v]+"$";var O=w++;m[O]="^"+m[C]+m[P]+"$";var U=w++;m[U]="(?:\\^)";var N=w++;m[N]="(\\s*)"+m[U]+"\\s+",b[N]=new RegExp(m[N],"g");var R=w++;m[R]="^"+m[U]+m[v]+"$";var T=w++;m[T]="^"+m[U]+m[P]+"$";var q=w++;m[q]="^"+m[l]+"\\s*("+r+")$|^$";var ee=w++;m[ee]="^"+m[l]+"\\s*("+t+")$|^$";var J=w++;m[J]="(\\s*)"+m[l]+"\\s*("+r+"|"+m[v]+")",b[J]=new RegExp(m[J],"g");var K=w++;m[K]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var Z=w++;m[Z]="^\\s*("+m[P]+")\\s+-\\s+("+m[P]+")\\s*$";var ae=w++;m[ae]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)f(_,m[_]),b[_]||(b[_]=new RegExp(m[_]));function ye(H,ue){if(H instanceof ge)return H;if(typeof H!="string"||H.length>A||!(ue?b[d]:b[a]).test(H))return null;try{return new ge(H,ue)}catch{return null}}function ge(H,ue){if(H instanceof ge){if(H.loose===ue)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ge))return new ge(H,ue);f("SemVer",H,ue),this.loose=ue;var fe=H.trim().match(ue?b[d]:b[a]);if(!fe)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var Oe=+Re;if(Oe>=0&&Oe<M)return Oe}return Re}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=ye,e.valid=function(H,ue){var fe=ye(H,ue);return fe?fe.version:null},e.clean=function(H,ue){var fe=ye(H.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=ge,ge.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ge.prototype.toString=function(){return this.version},ge.prototype.compare=function(H){return f("SemVer.compare",this.version,this.loose,H),H instanceof ge||(H=new ge(H,this.loose)),this.compareMain(H)||this.comparePre(H)},ge.prototype.compareMain=function(H){return H instanceof ge||(H=new ge(H,this.loose)),W(this.major,H.major)||W(this.minor,H.minor)||W(this.patch,H.patch)},ge.prototype.comparePre=function(H){if(H instanceof ge||(H=new ge(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],Re=H.prerelease[ue];if(f("prerelease compare",ue,fe,Re),fe===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(fe===void 0)return-1;if(fe!==Re)return W(fe,Re)}while(++ue)},ge.prototype.inc=function(H,ue){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,ue,fe,Re){typeof fe=="string"&&(Re=fe,fe=void 0);try{return new ge(H,fe).inc(ue,Re).version}catch{return null}},e.diff=function(H,ue){if(de(H,ue))return null;var fe=ye(H),Re=ye(ue);if(fe.prerelease.length||Re.prerelease.length){for(var Oe in fe)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&fe[Oe]!==Re[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in fe)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&fe[Oe]!==Re[Oe])return Oe},e.compareIdentifiers=W;var re=/^[0-9]+$/;function W(H,ue){var fe=re.test(H),Re=re.test(ue);return fe&&Re&&(H=+H,ue=+ue),fe&&!Re?-1:Re&&!fe?1:H<ue?-1:H>ue?1:0}function ce(H,ue,fe){return new ge(H,fe).compare(new ge(ue,fe))}function me(H,ue,fe){return ce(H,ue,fe)>0}function le(H,ue,fe){return ce(H,ue,fe)<0}function de(H,ue,fe){return ce(H,ue,fe)===0}function Y(H,ue,fe){return ce(H,ue,fe)!==0}function X(H,ue,fe){return ce(H,ue,fe)>=0}function Q(H,ue,fe){return ce(H,ue,fe)<=0}function te(H,ue,fe,Re){var Oe;switch(ue){case"===":typeof H=="object"&&(H=H.version),typeof fe=="object"&&(fe=fe.version),Oe=H===fe;break;case"!==":typeof H=="object"&&(H=H.version),typeof fe=="object"&&(fe=fe.version),Oe=H!==fe;break;case"":case"=":case"==":Oe=de(H,fe,Re);break;case"!=":Oe=Y(H,fe,Re);break;case">":Oe=me(H,fe,Re);break;case">=":Oe=X(H,fe,Re);break;case"<":Oe=le(H,fe,Re);break;case"<=":Oe=Q(H,fe,Re);break;default:throw new TypeError("Invalid operator: "+ue)}return Oe}function $e(H,ue){if(H instanceof $e){if(H.loose===ue)return H;H=H.value}if(!(this instanceof $e))return new $e(H,ue);f("comparator",H,ue),this.loose=ue,this.parse(H),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(H,ue){return W(ue,H)},e.major=function(H,ue){return new ge(H,ue).major},e.minor=function(H,ue){return new ge(H,ue).minor},e.patch=function(H,ue){return new ge(H,ue).patch},e.compare=ce,e.compareLoose=function(H,ue){return ce(H,ue,!0)},e.rcompare=function(H,ue,fe){return ce(ue,H,fe)},e.sort=function(H,ue){return H.sort(function(fe,Re){return e.compare(fe,Re,ue)})},e.rsort=function(H,ue){return H.sort(function(fe,Re){return e.rcompare(fe,Re,ue)})},e.gt=me,e.lt=le,e.eq=de,e.neq=Y,e.gte=X,e.lte=Q,e.cmp=te,e.Comparator=$e;var ve={};function Le(H,ue){if(H instanceof Le)return H.loose===ue?H:new Le(H.raw,ue);if(H instanceof $e)return new Le(H.value,ue);if(!(this instanceof Le))return new Le(H,ue);if(this.loose=ue,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function pe(H){return!H||H.toLowerCase()==="x"||H==="*"}function De(H,ue,fe,Re,Oe,Ge,He,et,lt,ct,ot,Pe,Ue){return((ue=pe(fe)?"":pe(Re)?">="+fe+".0.0":pe(Oe)?">="+fe+"."+Re+".0":">="+ue)+" "+(et=pe(lt)?"":pe(ct)?"<"+(+lt+1)+".0.0":pe(ot)?"<"+lt+"."+(+ct+1)+".0":Pe?"<="+lt+"."+ct+"."+ot+"-"+Pe:"<="+et)).trim()}function B(H,ue){for(var fe=0;fe<H.length;fe++)if(!H[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<H.length;fe++)if(f(H[fe].semver),H[fe].semver!==ve&&H[fe].semver.prerelease.length>0){var Re=H[fe].semver;if(Re.major===ue.major&&Re.minor===ue.minor&&Re.patch===ue.patch)return!0}return!1}return!0}function x(H,ue,fe){try{ue=new Le(ue,fe)}catch{return!1}return ue.test(H)}function se(H,ue,fe,Re){var Oe,Ge,He,et,lt;switch(H=new ge(H,Re),ue=new Le(ue,Re),fe){case">":Oe=me,Ge=Q,He=le,et=">",lt=">=";break;case"<":Oe=le,Ge=X,He=me,et="<",lt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(x(H,ue,Re))return!1;for(var ct=0;ct<ue.set.length;++ct){var ot=ue.set[ct],Pe=null,Ue=null;if(ot.forEach(function(Ae){Ae.semver===ve&&(Ae=new $e(">=0.0.0")),Pe=Pe||Ae,Ue=Ue||Ae,Oe(Ae.semver,Pe.semver,Re)?Pe=Ae:He(Ae.semver,Ue.semver,Re)&&(Ue=Ae)}),Pe.operator===et||Pe.operator===lt||(!Ue.operator||Ue.operator===et)&&Ge(H,Ue.semver)||Ue.operator===lt&&He(H,Ue.semver))return!1}return!0}$e.prototype.parse=function(H){var ue=this.loose?b[q]:b[ee],fe=H.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+H);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ge(fe[2],this.loose):this.semver=ve},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(H){return f("Comparator.test",H,this.loose),this.semver===ve||(typeof H=="string"&&(H=new ge(H,this.loose)),te(H,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(H,ue){if(!(H instanceof $e))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Le(H.value,ue),x(this.value,fe,ue);if(H.operator==="")return fe=new Le(this.value,ue),x(H.semver,fe,ue);var Re=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Ge=this.semver.version===H.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),et=te(this.semver,"<",H.semver,ue)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),lt=te(this.semver,">",H.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Re||Oe||Ge&&He||et||lt},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(H){var ue=this.loose;H=H.trim(),f("range",H,ue);var fe=ue?b[Z]:b[K];H=H.replace(fe,De),f("hyphen replace",H),H=H.replace(b[J],"$1$2$3"),f("comparator trim",H,b[J]),H=(H=(H=H.replace(b[j],"$1~")).replace(b[N],"$1^")).split(/\s+/).join(" ");var Re=ue?b[q]:b[ee],Oe=H.split(" ").map(function(Ge){return function(He,et){return f("comp",He),He=function(lt,ct){return lt.trim().split(/\s+/).map(function(ot){return function(Pe,Ue){f("caret",Pe,Ue);var Ae=Ue?b[T]:b[R];return Pe.replace(Ae,function(Xe,ne,he,Ie,Ke){var Ye;return f("caret",Pe,Xe,ne,he,Ie,Ke),pe(ne)?Ye="":pe(he)?Ye=">="+ne+".0.0 <"+(+ne+1)+".0.0":pe(Ie)?Ye=ne==="0"?">="+ne+"."+he+".0 <"+ne+"."+(+he+1)+".0":">="+ne+"."+he+".0 <"+(+ne+1)+".0.0":Ke?(f("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ye=ne==="0"?he==="0"?">="+ne+"."+he+"."+Ie+Ke+" <"+ne+"."+he+"."+(+Ie+1):">="+ne+"."+he+"."+Ie+Ke+" <"+ne+"."+(+he+1)+".0":">="+ne+"."+he+"."+Ie+Ke+" <"+(+ne+1)+".0.0"):(f("no pr"),Ye=ne==="0"?he==="0"?">="+ne+"."+he+"."+Ie+" <"+ne+"."+he+"."+(+Ie+1):">="+ne+"."+he+"."+Ie+" <"+ne+"."+(+he+1)+".0":">="+ne+"."+he+"."+Ie+" <"+(+ne+1)+".0.0"),f("caret return",Ye),Ye})}(ot,ct)}).join(" ")}(He,et),f("caret",He),He=function(lt,ct){return lt.trim().split(/\s+/).map(function(ot){return function(Pe,Ue){var Ae=Ue?b[O]:b[z];return Pe.replace(Ae,function(Xe,ne,he,Ie,Ke){var Ye;return f("tilde",Pe,Xe,ne,he,Ie,Ke),pe(ne)?Ye="":pe(he)?Ye=">="+ne+".0.0 <"+(+ne+1)+".0.0":pe(Ie)?Ye=">="+ne+"."+he+".0 <"+ne+"."+(+he+1)+".0":Ke?(f("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ye=">="+ne+"."+he+"."+Ie+Ke+" <"+ne+"."+(+he+1)+".0"):Ye=">="+ne+"."+he+"."+Ie+" <"+ne+"."+(+he+1)+".0",f("tilde return",Ye),Ye})}(ot,ct)}).join(" ")}(He,et),f("tildes",He),He=function(lt,ct){return f("replaceXRanges",lt,ct),lt.split(/\s+/).map(function(ot){return function(Pe,Ue){Pe=Pe.trim();var Ae=Ue?b[p]:b[S];return Pe.replace(Ae,function(Xe,ne,he,Ie,Ke,Ye){f("xRange",Pe,Xe,ne,he,Ie,Ke,Ye);var it=pe(he),at=it||pe(Ie),je=at||pe(Ke);return ne==="="&&je&&(ne=""),it?Xe=ne===">"||ne==="<"?"<0.0.0":"*":ne&&je?(at&&(Ie=0),je&&(Ke=0),ne===">"?(ne=">=",at?(he=+he+1,Ie=0,Ke=0):je&&(Ie=+Ie+1,Ke=0)):ne==="<="&&(ne="<",at?he=+he+1:Ie=+Ie+1),Xe=ne+he+"."+Ie+"."+Ke):at?Xe=">="+he+".0.0 <"+(+he+1)+".0.0":je&&(Xe=">="+he+"."+Ie+".0 <"+he+"."+(+Ie+1)+".0"),f("xRange return",Xe),Xe})}(ot,ct)}).join(" ")}(He,et),f("xrange",He),He=function(lt,ct){return f("replaceStars",lt,ct),lt.trim().replace(b[ae],"")}(He,et),f("stars",He),He}(Ge,ue)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Ge){return!!Ge.match(Re)})),Oe=Oe.map(function(Ge){return new $e(Ge,ue)})},Le.prototype.intersects=function(H,ue){if(!(H instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Re){return H.set.some(function(Oe){return Oe.every(function(Ge){return Re.intersects(Ge,ue)})})})})},e.toComparators=function(H,ue){return new Le(H,ue).set.map(function(fe){return fe.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new ge(H,this.loose));for(var ue=0;ue<this.set.length;ue++)if(B(this.set[ue],H))return!0;return!1},e.satisfies=x,e.maxSatisfying=function(H,ue,fe){var Re=null,Oe=null;try{var Ge=new Le(ue,fe)}catch{return null}return H.forEach(function(He){Ge.test(He)&&(Re&&Oe.compare(He)!==-1||(Oe=new ge(Re=He,fe)))}),Re},e.minSatisfying=function(H,ue,fe){var Re=null,Oe=null;try{var Ge=new Le(ue,fe)}catch{return null}return H.forEach(function(He){Ge.test(He)&&(Re&&Oe.compare(He)!==1||(Oe=new ge(Re=He,fe)))}),Re},e.validRange=function(H,ue){try{return new Le(H,ue).range||"*"}catch{return null}},e.ltr=function(H,ue,fe){return se(H,ue,"<",fe)},e.gtr=function(H,ue,fe){return se(H,ue,">",fe)},e.outside=se,e.prerelease=function(H,ue){var fe=ye(H,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(H,ue,fe){return H=new Le(H,fe),ue=new Le(ue,fe),H.intersects(ue)},e.coerce=function(H){if(H instanceof ge)return H;if(typeof H!="string")return null;var ue=H.match(b[k]);return ue==null?null:ye((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,E(1))},function(ie,e){var E,F,f=ie.exports={};function A(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(g){if(E===setTimeout)return setTimeout(g,0);if((E===A||!E)&&setTimeout)return E=setTimeout,setTimeout(g,0);try{return E(g,0)}catch{try{return E.call(null,g,0)}catch{return E.call(this,g,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:A}catch{E=A}try{F=typeof clearTimeout=="function"?clearTimeout:M}catch{F=M}})();var m,w=[],L=!1,I=-1;function $(){L&&m&&(L=!1,m.length?w=m.concat(w):I=-1,w.length&&y())}function y(){if(!L){var g=b($);L=!0;for(var o=w.length;o;){for(m=w,w=[];++I<o;)m&&m[I].run();I=-1,o=w.length}m=null,L=!1,function(n){if(F===clearTimeout)return clearTimeout(n);if((F===M||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(n);try{F(n)}catch{try{return F.call(null,n)}catch{return F.call(this,n)}}}(g)}}function D(g,o){this.fun=g,this.array=o}function u(){}f.nextTick=function(g){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];w.push(new D(g,o)),w.length!==1||L||b(y)},D.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=u,f.addListener=u,f.once=u,f.off=u,f.removeListener=u,f.removeAllListeners=u,f.emit=u,f.prependListener=u,f.prependOnceListener=u,f.listeners=function(g){return[]},f.binding=function(g){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(g){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(Se[39],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(A){return new F(A)}constructor(A){this.c=E&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=F}),define(Se[4],ke([1,0,8,74,3,75,39]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const b=!1,m=!1;var w;(function(S){S.None=()=>f.$Sc.None;function p(te){if(m){const{onDidAddListener:$e}=te,ve=D.create();let Le=0;te.onDidAddListener=()=>{++Le===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),$e?.()}}}function k(te,$e){return ee(te,()=>{},0,void 0,!0,void 0,$e)}S.defer=k;function C(te){return($e,ve=null,Le)=>{let pe=!1,De;return De=te(B=>{if(!pe)return De?De.dispose():pe=!0,$e.call(ve,B)},null,Le),pe&&De.dispose(),De}}S.once=C;function j(te,$e,ve){return T((Le,pe=null,De)=>te(B=>Le.call(pe,$e(B)),null,De),ve)}S.map=j;function z(te,$e,ve){return T((Le,pe=null,De)=>te(B=>{$e(B),Le.call(pe,B)},null,De),ve)}S.forEach=z;function O(te,$e,ve){return T((Le,pe=null,De)=>te(B=>$e(B)&&Le.call(pe,B),null,De),ve)}S.filter=O;function U(te){return te}S.signal=U;function N(...te){return($e,ve=null,Le)=>{const pe=(0,f.$Pc)(...te.map(De=>De(B=>$e.call(ve,B))));return q(pe,Le)}}S.any=N;function R(te,$e,ve,Le){let pe=ve;return j(te,De=>(pe=$e(pe,De),pe),Le)}S.reduce=R;function T(te,$e){let ve;const Le={onWillAddFirstListener(){ve=te(pe.fire,pe)},onDidRemoveLastListener(){ve?.dispose()}};$e||p(Le);const pe=new i(Le);return $e?.add(pe),pe.event}function q(te,$e){return $e instanceof Array?$e.push(te):$e&&$e.add(te),te}function ee(te,$e,ve=100,Le=!1,pe=!1,De,B){let x,se,H,ue=0,fe;const Re={leakWarningThreshold:De,onWillAddFirstListener(){x=te(Ge=>{ue++,se=$e(se,Ge),Le&&!H&&(Oe.fire(se),se=void 0),fe=()=>{const He=se;se=void 0,H=void 0,(!Le||ue>1)&&Oe.fire(He),ue=0},typeof ve=="number"?(clearTimeout(H),H=setTimeout(fe,ve)):H===void 0&&(H=0,queueMicrotask(fe))})},onWillRemoveListener(){pe&&ue>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,x.dispose()}};B||p(Re);const Oe=new i(Re);return B?.add(Oe),Oe.event}S.debounce=ee;function J(te,$e=0,ve){return S.debounce(te,(Le,pe)=>Le?(Le.push(pe),Le):[pe],$e,void 0,!0,void 0,ve)}S.accumulate=J;function K(te,$e=(Le,pe)=>Le===pe,ve){let Le=!0,pe;return O(te,De=>{const B=Le||!$e(De,pe);return Le=!1,pe=De,B},ve)}S.latch=K;function Z(te,$e,ve){return[S.filter(te,$e,ve),S.filter(te,Le=>!$e(Le),ve)]}S.split=Z;function ae(te,$e=!1,ve=[],Le){let pe=ve.slice(),De=te(se=>{pe?pe.push(se):x.fire(se)});Le&&Le.add(De);const B=()=>{pe?.forEach(se=>x.fire(se)),pe=null},x=new i({onWillAddFirstListener(){De||(De=te(se=>x.fire(se)),Le&&Le.add(De))},onDidAddFirstListener(){pe&&($e?setTimeout(B):B())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Le&&Le.add(x),x.event}S.buffer=ae;function _(te,$e){return(Le,pe,De)=>{const B=$e(new ge);return te(function(x){const se=B.evaluate(x);se!==ye&&Le.call(pe,se)},void 0,De)}}S.chain=_;const ye=Symbol("HaltChainable");class ge{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(ve=>($e(ve),ve)),this}filter($e){return this.f.push(ve=>$e(ve)?ve:ye),this}reduce($e,ve){let Le=ve;return this.f.push(pe=>(Le=$e(Le,pe),Le)),this}latch($e=(ve,Le)=>ve===Le){let ve=!0,Le;return this.f.push(pe=>{const De=ve||!$e(pe,Le);return ve=!1,Le=pe,De?pe:ye}),this}evaluate($e){for(const ve of this.f)if($e=ve($e),$e===ye)break;return $e}}function re(te,$e,ve=Le=>Le){const Le=(...x)=>B.fire(ve(...x)),pe=()=>te.on($e,Le),De=()=>te.removeListener($e,Le),B=new i({onWillAddFirstListener:pe,onDidRemoveLastListener:De});return B.event}S.fromNodeEventEmitter=re;function W(te,$e,ve=Le=>Le){const Le=(...x)=>B.fire(ve(...x)),pe=()=>te.addEventListener($e,Le),De=()=>te.removeEventListener($e,Le),B=new i({onWillAddFirstListener:pe,onDidRemoveLastListener:De});return B.event}S.fromDOMEventEmitter=W;function ce(te){return new Promise($e=>C(te)($e))}S.toPromise=ce;function me(te){const $e=new i;return te.then(ve=>{$e.fire(ve)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}S.fromPromise=me;function le(te,$e,ve){return $e(ve),te(Le=>$e(Le))}S.runAndSubscribe=le;function de(te,$e){let ve=null;function Le(De){ve?.dispose(),ve=new f.$Rc,$e(De,ve)}Le(void 0);const pe=te(De=>Le(De));return(0,f.$Qc)(()=>{pe.dispose(),ve?.dispose()})}S.runAndSubscribeWithStore=de;class Y{constructor($e,ve){this._observable=$e,this.f=0,this.g=!1;const Le={onWillAddFirstListener:()=>{$e.addObserver(this)},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};ve||p(Le),this.emitter=new i(Le),ve&&ve.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,ve){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function X(te,$e){return new Y(te,$e).emitter.event}S.fromObservable=X;function Q(te){return($e,ve,Le)=>{let pe=0,De=!1;const B={beginUpdate(){pe++},endUpdate(){pe--,pe===0&&(te.reportChanges(),De&&(De=!1,$e.call(ve)))},handlePossibleChange(){},handleChange(){De=!0}};te.addObserver(B),te.reportChanges();const x={dispose(){te.removeObserver(B)}};return Le instanceof f.$Rc?Le.add(x):Array.isArray(Le)&&Le.push(x),x}}S.fromObservableLight=Q})(w||(e.Event=w={}));class L{constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${L.f++}`,L.all.add(this)}start(p){this.g=new M.$Od,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Qd=L,L.all=new Set,L.f=0;let I=-1;function $(S){const p=I;return I=S,{dispose(){I=p}}}e.$Rd=$;class y{constructor(p,k=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=k,this.g=0}dispose(){this.f?.clear()}check(p,k){const C=this.threshold;if(C<=0||k<C)return;this.f||(this.f=new Map);const j=this.f.get(p.value)||0;if(this.f.set(p.value,j+1),this.g-=1,this.g<=0){this.g=C*.5;let z,O=0;for(const[U,N]of this.f)(!z||O<N)&&(z=U,O=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${O}):`),console.warn(z)}return()=>{const z=this.f.get(p.value)||0;this.f.set(p.value,z-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class g{constructor(p){this.value=p,this.id=u++}}const o=2,n=(S,p)=>{if(S instanceof g)p(S);else for(let k=0;k<S.length;k++){const C=S[k];C&&p(C)}};class i{constructor(p){this.w=0,this.f=p,this.g=I>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{n(p,k=>k.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(p,k,C)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Sc.None;if(this.m)return f.$Sc.None;k&&(p=p.bind(k));const j=new g(p);let z,O;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(j.stack=D.create(),z=this.g.check(j.stack,this.w+1)),b&&(j.stack=O??D.create()),this.t?this.t instanceof g?(this.u??(this.u=new a),this.t=[this.t,j]):this.t.push(j):(this.f?.onWillAddFirstListener?.(this),this.t=j,this.f?.onDidAddFirstListener?.(this)),this.w++;const U=(0,f.$Qc)(()=>{z?.(),this.x(j)});return C instanceof f.$Rc?C.add(U):Array.isArray(C)&&C.push(U),U}),this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const k=this.t,C=k.indexOf(p);if(C===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,k[C]=void 0;const j=this.u.current===this;if(this.w*o<=k.length){let z=0;for(let O=0;O<k.length;O++)k[O]?k[z++]=k[O]:j&&(this.u.end--,z<this.u.i&&this.u.i--);k.length=z}}y(p,k){if(!p)return;const C=this.f?.onListenerError||E.$1;if(!C){p.value(k);return}try{p.value(k)}catch(j){C(j)}}z(p){const k=p.current.t;for(;p.i<p.end;)this.y(k[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,p);else{const k=this.u;k.enqueue(this,p,this.t.length),this.z(k)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=i;const s=()=>new a;e.$Td=s;class a{constructor(){this.i=-1,this.end=0}enqueue(p,k,C){this.i=0,this.end=C,this.current=p,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends i{async fireAsync(p,k,C){if(this.t)for(this.h||(this.h=new A.$3c),n(this.t,j=>this.h.push([j.value,p]));this.h.size>0&&!k.isCancellationRequested;){const[j,z]=this.h.shift(),O=[],U={...z,token:k,waitUntil:N=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");C&&(N=C(N,j)),O.push(N)}};try{j(U)}catch(N){(0,E.$1)(N);continue}Object.freeze(O),await Promise.allSettled(O).then(N=>{for(const R of N)R.status==="rejected"&&(0,E.$1)(R.reason)})}}}e.$Ud=t;class r extends i{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new A.$3c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Vd=r;class d extends r{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Wd=d;class l extends i{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(k=>super.fire(k)),this.h=[]}))}}e.$Xd=l;class h{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const k={event:p,listener:null};this.h.push(k),this.g&&this.m(k);const C=()=>{this.g&&this.o(k);const j=this.h.indexOf(k);this.h.splice(j,1)};return(0,f.$Qc)((0,F.$db)(C))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(k=>this.f.fire(k))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Yd=h;class c{constructor(p,k,C,j){this.f=new f.$Rc;const z=this.f.add(new h),O=this.f.add(new f.$2c);function U(N){O.set(N,z.add(j(N)))}for(const N of p)U(N);this.f.add(k(N=>{U(N)})),this.f.add(C(N=>{O.deleteAndDispose(N)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Zd=c;class v{constructor(){this.f=[]}wrapEvent(p){return(k,C,j)=>p(z=>{const O=this.f[this.f.length-1];O?O.push(()=>k.call(C,z)):k.call(C,z)},void 0,j)}bufferEvents(p){const k=[];this.f.push(k);const C=p();return this.f.pop(),k.forEach(j=>j()),C}}e.$1d=v;class P{constructor(){this.f=!1,this.g=w.None,this.h=f.$Sc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=P}),define(Se[21],ke([1,0,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const F=Object.freeze(function(b,m){const w=setTimeout(b.bind(m),0);return{dispose(){clearTimeout(w)}}});var f;(function(b){function m(w){return w===b.None||w===b.Cancelled||w instanceof A?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}b.isCancellationToken=m,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(f||(e.CancellationToken=f={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new E.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=f.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=f.None}}e.$3d=M}),define(Se[163],ke([1,0,21]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class F{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new E.$3d,m=this.b(b.token);return this.a={promise:m,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Be=F;class f{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const m=JSON.stringify(b);return this.b!==m&&(this.b=m,this.a=this.c(b)),this.a}}e.$Ce=f;class A{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const m=this.b(b);return this.a.set(b,m),m}}e.$De=A}),define(Se[100],ke([1,0,8,3]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function f(s){const a=s;return a?typeof a.read=="function":!1}e.$4d=f;function A(s){const a=s;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$5d=A;function M(s){const a=s;return a?A(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$6d=M;function b(s,a){return new m(s,a)}e.$7d=b;class m{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,E.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const d=r.indexOf(t);d>=0&&r.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(s,a){const t=[];let r;for(;(r=s.read())!==null;)t.push(r);return a(t)}e.$8d=w;function L(s,a,t){const r=[];let d;for(;(d=s.read())!==null&&r.length<t;)r.push(d);return d===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return s.read()}}}e.$9d=L;function I(s,a){return new Promise((t,r)=>{const d=[];$(s,{onData:l=>{a&&d.push(l)},onError:l=>{a?r(l):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$0d=I;function $(s,a,t){s.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),s.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),s.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.$$d=$;function y(s,a){return new Promise((t,r)=>{const d=new F.$Rc,l=[],h=P=>{if(l.push(P),l.length>a)return d.dispose(),s.pause(),t({stream:s,buffer:l,ended:!1})},c=P=>(d.dispose(),r(P)),v=()=>(d.dispose(),t({stream:s,buffer:l,ended:!0}));d.add((0,F.$Qc)(()=>s.removeListener("error",c))),s.on("error",c),d.add((0,F.$Qc)(()=>s.removeListener("end",v))),s.on("end",v),d.add((0,F.$Qc)(()=>s.removeListener("data",h))),s.on("data",h)})}e.$_d=y;function D(s,a){const t=b(a);return t.end(s),t}e.$ae=D;function u(){const s=b(()=>{throw new Error("not supported")});return s.end(),s}e.$be=u;function g(s){let a=!1;return{read:()=>a?null:(a=!0,s)}}e.$ce=g;function o(s,a,t){const r=b(t);return $(s,{onData:d=>r.write(a.data(d)),onError:d=>r.error(a.error?a.error(d):d),onEnd:()=>r.end()}),r}e.$de=o;function n(s,a,t){let r=!1;return{read:()=>{const d=a.read();return r?d:(r=!0,d!==null?t([s,d]):s)}}}e.$ee=n;function i(s,a,t){let r=!1;const d=b(t);return $(a,{onData:l=>r?d.write(l):(r=!0,d.write(t([s,l]))),onError:l=>d.error(l),onEnd:()=>{r||(r=!0,d.write(s)),d.end()}}),d}e.$fe=i}),define(Se[22],ke([1,0,43,100]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const f=typeof Buffer<"u",A=new E.$V(()=>new Uint8Array(256));let M,b;class m{static alloc(k){return f?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return f&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,C){return!(C?.dontUseNodeBuffer||!1)&&f?new m(Buffer.from(k)):(M||(M=new TextEncoder),new m(M.encode(k)))}static fromByteArray(k){const C=m.alloc(k.length);for(let j=0,z=k.length;j<z;j++)C.buffer[j]=k[j];return C}static concat(k,C){if(typeof C>"u"){C=0;for(let O=0,U=k.length;O<U;O++)C+=k[O].byteLength}const j=m.alloc(C);let z=0;for(let O=0,U=k.length;O<U;O++){const N=k[O];j.set(N,z),z+=N.byteLength}return j}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return f?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(k,C){return new m(this.buffer.subarray(k,C))}set(k,C){if(k instanceof m)this.buffer.set(k.buffer,C);else if(k instanceof Uint8Array)this.buffer.set(k,C);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),C);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return $(this.buffer,k)}writeUInt32BE(k,C){y(this.buffer,k,C)}readUInt32LE(k){return D(this.buffer,k)}writeUInt32LE(k,C){u(this.buffer,k,C)}readUInt8(k){return g(this.buffer,k)}writeUInt8(k,C){o(this.buffer,k,C)}indexOf(k,C=0){return w(this.buffer,k instanceof m?k.buffer:k,C)}}e.$ge=m;function w(p,k,C=0){const j=k.byteLength,z=p.byteLength;if(j===0)return 0;if(j===1)return p.indexOf(k[0]);if(j>z-C)return-1;const O=A.value;O.fill(k.length);for(let T=0;T<k.length;T++)O[k[T]]=k.length-T-1;let U=C+k.length-1,N=U,R=-1;for(;U<z;)if(p[U]===k[N]){if(N===0){R=U;break}U--,N--}else U+=Math.max(k.length-N,O[p[U]]),N=k.length-1;return R}e.$he=w;function L(p,k){return p[k+0]<<0>>>0|p[k+1]<<8>>>0}e.$ie=L;function I(p,k,C){p[C+0]=k&255,k=k>>>8,p[C+1]=k&255}e.$je=I;function $(p,k){return p[k]*2**24+p[k+1]*2**16+p[k+2]*2**8+p[k+3]}e.$ke=$;function y(p,k,C){p[C+3]=k,k=k>>>8,p[C+2]=k,k=k>>>8,p[C+1]=k,k=k>>>8,p[C]=k}e.$le=y;function D(p,k){return p[k+0]<<0>>>0|p[k+1]<<8>>>0|p[k+2]<<16>>>0|p[k+3]<<24>>>0}e.$me=D;function u(p,k,C){p[C+0]=k&255,k=k>>>8,p[C+1]=k&255,k=k>>>8,p[C+2]=k&255,k=k>>>8,p[C+3]=k&255}e.$ne=u;function g(p,k){return p[k]}e.$oe=g;function o(p,k,C){p[C]=k}e.$pe=o;function n(p){return F.$8d(p,k=>m.concat(k))}e.$qe=n;function i(p){return F.$ce(p)}e.$re=i;function s(p){return F.$0d(p,k=>m.concat(k))}e.$se=s;async function a(p){return p.ended?m.concat(p.buffer):m.concat([...p.buffer,await s(p.stream)])}e.$te=a;function t(p){return F.$ae(p,k=>m.concat(k))}e.$ue=t;function r(p){return F.$de(p,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}e.$ve=r;function d(p){return F.$7d(k=>m.concat(k),p)}e.$we=d;function l(p,k){return F.$ee(p,k,C=>m.concat(C))}e.$xe=l;function h(p,k){return F.$fe(p,k,C=>m.concat(C))}e.$ye=h;function c(p){let k=0,C=0,j=0;const z=new Uint8Array(Math.floor(p.length/4*3)),O=N=>{switch(C){case 3:z[j++]=k|N,C=0;break;case 2:z[j++]=k|N>>>2,k=N<<6,C=3;break;case 1:z[j++]=k|N>>>4,k=N<<4,C=2;break;default:k=N<<2,C=1}};for(let N=0;N<p.length;N++){const R=p.charCodeAt(N);if(R>=65&&R<=90)O(R-65);else if(R>=97&&R<=122)O(R-97+26);else if(R>=48&&R<=57)O(R-48+52);else if(R===43||R===45)O(62);else if(R===47||R===95)O(63);else{if(R===61)break;throw new SyntaxError(`Unexpected base64 character ${p[N]}`)}}const U=j;for(;C>0;)O(0);return m.wrap(z).slice(0,U)}e.$ze=c;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:p},k=!0,C=!1){const j=C?P:v;let z="";const O=p.byteLength%3;let U=0;for(;U<p.byteLength-O;U+=3){const N=p[U+0],R=p[U+1],T=p[U+2];z+=j[N>>>2],z+=j[(N<<4|R>>>4)&63],z+=j[(R<<2|T>>>6)&63],z+=j[T&63]}if(O===1){const N=p[U+0];z+=j[N>>>2],z+=j[N<<4&63],k&&(z+="==")}else if(O===2){const N=p[U+0],R=p[U+1];z+=j[N>>>2],z+=j[(N<<4|R>>>4)&63],z+=j[R<<2&63],k&&(z+="=")}return z}e.$Ae=S}),define(Se[13],ke([1,0,163,43]),function(ie,e,E,F){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Df=e.$Cf=e.$Bf=e.$Af=e.GraphemeBreakType=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function A(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$Ge=A;const M=/{(\d+)}/g;function b(Pe,...Ue){return Ue.length===0?Pe:Pe.replace(M,function(Ae,Xe){const ne=parseInt(Xe,10);return isNaN(ne)||ne<0||ne>=Ue.length?Ae:Ue[ne]})}e.$He=b;const m=/{([^}]+)}/g;function w(Pe,Ue){return Object.keys(Ue).length===0?Pe:Pe.replace(m,(Ae,Xe)=>Ue[Xe]??Ae)}e.$Ie=w;function L(Pe){return Pe.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}e.$Je=L;function I(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=I;function $(Pe,Ue){let Ae=0;const Xe=Ue.charCodeAt(0);for(let ne=Pe.length-1;ne>=0;ne--)Pe.charCodeAt(ne)===Xe&&Ae++;return Ae}e.$Le=$;function y(Pe,Ue,Ae="\u2026"){return Pe.length<=Ue?Pe:`${Pe.substr(0,Ue)}${Ae}`}e.$Me=y;function D(Pe,Ue,Ae="\u2026"){if(Pe.length<=Ue)return Pe;const Xe=Math.ceil(Ue/2)-Ae.length/2,ne=Math.floor(Ue/2)-Ae.length/2;return`${Pe.substr(0,Xe)}${Ae}${Pe.substr(Pe.length-ne)}`}e.$Ne=D;function u(Pe,Ue=" "){const Ae=g(Pe,Ue);return o(Ae,Ue)}e.$Oe=u;function g(Pe,Ue){if(!Pe||!Ue)return Pe;const Ae=Ue.length;if(Ae===0||Pe.length===0)return Pe;let Xe=0;for(;Pe.indexOf(Ue,Xe)===Xe;)Xe=Xe+Ae;return Pe.substring(Xe)}e.$Pe=g;function o(Pe,Ue){if(!Pe||!Ue)return Pe;const Ae=Ue.length,Xe=Pe.length;if(Ae===0||Xe===0)return Pe;let ne=Xe,he=-1;for(;he=Pe.lastIndexOf(Ue,ne-1),!(he===-1||he+Ae!==ne);){if(he===0)return"";ne=he}return Pe.substring(0,ne)}e.$Qe=o;function n(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Re=n;function i(Pe){return Pe.replace(/\*/g,"")}e.$Se=i;function s(Pe,Ue,Ae={}){if(!Pe)throw new Error("Cannot create regex from empty string");Ue||(Pe=I(Pe)),Ae.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Xe="";return Ae.global&&(Xe+="g"),Ae.matchCase||(Xe+="i"),Ae.multiline&&(Xe+="m"),Ae.unicode&&(Xe+="u"),new RegExp(Pe,Xe)}e.$Te=s;function a(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$Ue=a;function t(Pe){return Pe.split(/\r\n|\r|\n/)}e.$Ve=t;function r(Pe){for(let Ue=0,Ae=Pe.length;Ue<Ae;Ue++){const Xe=Pe.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.$We=r;function d(Pe,Ue=0,Ae=Pe.length){for(let Xe=Ue;Xe<Ae;Xe++){const ne=Pe.charCodeAt(Xe);if(ne!==32&&ne!==9)return Pe.substring(Ue,Xe)}return Pe.substring(Ue,Ae)}e.$Xe=d;function l(Pe,Ue=Pe.length-1){for(let Ae=Ue;Ae>=0;Ae--){const Xe=Pe.charCodeAt(Ae);if(Xe!==32&&Xe!==9)return Ae}return-1}e.$Ye=l;function h(Pe,Ue,Ae){const Xe=[];let ne=0;for(const he of Pe.matchAll(Ue)){if(Xe.push(Pe.slice(ne,he.index)),he.index===void 0)throw new Error("match.index should be defined");ne=he.index+he[0].length,Xe.push(Ae(he[0],...he.slice(1),he.index,Pe,he.groups))}return Xe.push(Pe.slice(ne)),Promise.all(Xe).then(he=>he.join(""))}e.$Ze=h;function c(Pe,Ue){return Pe<Ue?-1:Pe>Ue?1:0}e.$1e=c;function v(Pe,Ue,Ae=0,Xe=Pe.length,ne=0,he=Ue.length){for(;Ae<Xe&&ne<he;Ae++,ne++){const Ye=Pe.charCodeAt(Ae),it=Ue.charCodeAt(ne);if(Ye<it)return-1;if(Ye>it)return 1}const Ie=Xe-Ae,Ke=he-ne;return Ie<Ke?-1:Ie>Ke?1:0}e.$2e=v;function P(Pe,Ue){return S(Pe,Ue,0,Pe.length,0,Ue.length)}e.$3e=P;function S(Pe,Ue,Ae=0,Xe=Pe.length,ne=0,he=Ue.length){for(;Ae<Xe&&ne<he;Ae++,ne++){let Ye=Pe.charCodeAt(Ae),it=Ue.charCodeAt(ne);if(Ye===it)continue;if(Ye>=128||it>=128)return v(Pe.toLowerCase(),Ue.toLowerCase(),Ae,Xe,ne,he);k(Ye)&&(Ye-=32),k(it)&&(it-=32);const at=Ye-it;if(at!==0)return at}const Ie=Xe-Ae,Ke=he-ne;return Ie<Ke?-1:Ie>Ke?1:0}e.$4e=S;function p(Pe){return Pe>=48&&Pe<=57}e.$5e=p;function k(Pe){return Pe>=97&&Pe<=122}e.$6e=k;function C(Pe){return Pe>=65&&Pe<=90}e.$7e=C;function j(Pe,Ue){return Pe.length===Ue.length&&S(Pe,Ue)===0}e.$8e=j;function z(Pe,Ue){const Ae=Ue.length;return Ue.length>Pe.length?!1:S(Pe,Ue,0,Ae)===0}e.$9e=z;function O(Pe,Ue){const Ae=Math.min(Pe.length,Ue.length);let Xe;for(Xe=0;Xe<Ae;Xe++)if(Pe.charCodeAt(Xe)!==Ue.charCodeAt(Xe))return Xe;return Ae}e.$0e=O;function U(Pe,Ue){const Ae=Math.min(Pe.length,Ue.length);let Xe;const ne=Pe.length-1,he=Ue.length-1;for(Xe=0;Xe<Ae;Xe++)if(Pe.charCodeAt(ne-Xe)!==Ue.charCodeAt(he-Xe))return Xe;return Ae}e.$$e=U;function N(Pe){return 55296<=Pe&&Pe<=56319}e.$_e=N;function R(Pe){return 56320<=Pe&&Pe<=57343}e.$af=R;function T(Pe,Ue){return(Pe-55296<<10)+(Ue-56320)+65536}e.$bf=T;function q(Pe,Ue,Ae){const Xe=Pe.charCodeAt(Ae);if(N(Xe)&&Ae+1<Ue){const ne=Pe.charCodeAt(Ae+1);if(R(ne))return T(Xe,ne)}return Xe}e.$cf=q;function ee(Pe,Ue){const Ae=Pe.charCodeAt(Ue-1);if(R(Ae)&&Ue>1){const Xe=Pe.charCodeAt(Ue-2);if(N(Xe))return T(Xe,Ae)}return Ae}class J{get offset(){return this.e}constructor(Ue,Ae=0){this.c=Ue,this.d=Ue.length,this.e=Ae}setOffset(Ue){this.e=Ue}prevCodePoint(){const Ue=ee(this.c,this.e);return this.e-=Ue>=65536?2:1,Ue}nextCodePoint(){const Ue=q(this.c,this.d,this.e);return this.e+=Ue>=65536?2:1,Ue}eol(){return this.e>=this.d}}e.$df=J;class K{get offset(){return this.c.offset}constructor(Ue,Ae=0){this.c=new J(Ue,Ae)}nextGraphemeLength(){const Ue=Re.getInstance(),Ae=this.c,Xe=Ae.offset;let ne=Ue.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const he=Ae.offset,Ie=Ue.getGraphemeBreakType(Ae.nextCodePoint());if(ue(ne,Ie)){Ae.setOffset(he);break}ne=Ie}return Ae.offset-Xe}prevGraphemeLength(){const Ue=Re.getInstance(),Ae=this.c,Xe=Ae.offset;let ne=Ue.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const he=Ae.offset,Ie=Ue.getGraphemeBreakType(Ae.prevCodePoint());if(ue(Ie,ne)){Ae.setOffset(he);break}ne=Ie}return Xe-Ae.offset}eol(){return this.c.eol()}}e.$ef=K;function Z(Pe,Ue){return new K(Pe,Ue).nextGraphemeLength()}e.$ff=Z;function ae(Pe,Ue){return new K(Pe,Ue).prevGraphemeLength()}e.$gf=ae;function _(Pe,Ue){Ue>0&&R(Pe.charCodeAt(Ue))&&Ue--;const Ae=Ue+Z(Pe,Ue);return[Ae-ae(Pe,Ae),Ae]}e.$hf=_;function ye(Pe){const Ue=new K(Pe);let Ae=0;for(;!Ue.eol();)Ae++,Ue.nextGraphemeLength();return Ae}e.$if=ye;let ge;function re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Pe){return ge||(ge=re()),ge.test(Pe)}e.$jf=W;const ce=/^[\t\n\r\x20-\x7E]*$/;function me(Pe){return ce.test(Pe)}e.$kf=me,e.$lf=/[\u2028\u2029]/;function le(Pe){return e.$lf.test(Pe)}e.$mf=le;function de(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$nf=de;function Y(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$of=Y;function X(Pe,Ue){if(Pe.length<Ue)return Pe;const Ae=/\b/g;let Xe=0;for(;Ae.test(Pe)&&!(Pe.length-Ae.lastIndex<Ue);)Xe=Ae.lastIndex,Ae.lastIndex+=1;return Pe.substring(Xe).replace(/^\s/,"")}e.$pf=X;const Q=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,te=/\x1b\].*?\x07/g;function $e(Pe){return Pe&&(Pe=Pe.replace(Q,"").replace(te,"")),Pe}e.$qf=$e,e.$rf=String.fromCharCode(65279);function ve(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$sf=ve;function Le(Pe){return ve(Pe)?Pe.substr(1):Pe}e.$tf=Le;function pe(Pe,Ue){if(!Pe||!Ue||Pe.length<Ue.length)return!1;const Ae=Ue.length,Xe=Pe.toLowerCase();let ne=0,he=-1;for(;ne<Ae;){const Ie=Xe.indexOf(Ue[ne],he+1);if(Ie<0)return!1;he=Ie,ne++}return!0}e.$uf=pe;function De(Pe,Ue=!1){return Pe?(Ue&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$vf=De;function B(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$wf=B;function x(Pe,Ue=1){if(Ue===0)return"";let Ae=-1;do Ae=Pe.indexOf(`
`,Ae+1),Ue--;while(Ue>0&&Ae>=0);return Ae===-1?Pe:(Pe[Ae-1]==="\r"&&Ae--,Pe.substr(0,Ae))}e.$xf=x;function se(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$yf=se;function H(Pe){return Re.getInstance().getGraphemeBreakType(Pe)}e.$zf=H;function ue(Pe,Ue){return Pe===0?Ue!==5&&Ue!==7:Pe===2&&Ue===3?!1:Pe===4||Pe===2||Pe===3||Ue===4||Ue===2||Ue===3?!0:!(Pe===8&&(Ue===8||Ue===9||Ue===11||Ue===12)||(Pe===11||Pe===9)&&(Ue===9||Ue===10)||(Pe===12||Pe===10)&&Ue===10||Ue===5||Ue===13||Ue===7||Pe===1||Pe===13&&Ue===14||Pe===6&&Ue===6)}var fe;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(fe||(e.GraphemeBreakType=fe={}));class Re{static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Oe()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===10?3:Ue===13?2:4;if(Ue<127)return 0;const Ae=this.d,Xe=Ae.length/3;let ne=1;for(;ne<=Xe;)if(Ue<Ae[3*ne])ne=2*ne;else if(Ue>Ae[3*ne+1])ne=2*ne+1;else return Ae[3*ne+2];return 0}}Re.c=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(Pe,Ue){if(Pe===0)return 0;const Ae=He(Pe,Ue);if(Ae!==void 0)return Ae;const Xe=new J(Ue,Pe);return Xe.prevCodePoint(),Xe.offset}e.$Af=Ge;function He(Pe,Ue){const Ae=new J(Ue,Pe);let Xe=Ae.prevCodePoint();for(;et(Xe)||Xe===65039||Xe===8419;){if(Ae.offset===0)return;Xe=Ae.prevCodePoint()}if(!Y(Xe))return;let ne=Ae.offset;return ne>0&&Ae.prevCodePoint()===8205&&(ne=Ae.offset),ne}function et(Pe){return 127995<=Pe&&Pe<=127999}var lt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(lt||(lt={})),e.$Bf="\xA0";class ct{static getInstance(Ue){return f.d.get(Array.from(Ue))}static getLocales(){return f.e.value}constructor(Ue){this.f=Ue}isAmbiguous(Ue){return this.f.has(Ue)}getPrimaryConfusable(Ue){return this.f.get(Ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Cf=ct,f=ct,ct.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ct.d=new E.$Ce(Pe=>{function Ue(it){const at=new Map;for(let je=0;je<it.length;je+=2)at.set(it[je],it[je+1]);return at}function Ae(it,at){const je=new Map(it);for(const[Et,It]of at)je.set(Et,It);return je}function Xe(it,at){if(!it)return at;const je=new Map;for(const[Et,It]of it)at.has(Et)&&je.set(Et,It);return je}const ne=f.c.value;let he=Pe.filter(it=>!it.startsWith("_")&&it in ne);he.length===0&&(he=["_default"]);let Ie;for(const it of he){const at=Ue(ne[it]);Ie=Xe(Ie,at)}const Ke=Ue(ne._common),Ye=Ae(Ke,Ie);return new f(Ye)}),ct.e=new F.$V(()=>Object.keys(f.c.value).filter(Pe=>!Pe.startsWith("_")));class ot{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ot.c())),this.d}static isInvisibleCharacter(Ue){return ot.e().has(Ue)}static get codePoints(){return ot.e()}}e.$Df=ot,ot.d=void 0}),define(Se[125],ke([1,0,28,162,13]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.FuzzyScore=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.or=void 0;function A(...pe){return function(De,B){for(let x=0,se=pe.length;x<se;x++){const H=pe[x](De,B);if(H)return H}return null}}e.or=A,e.$Pj=M.bind(void 0,!1),e.$Qj=M.bind(void 0,!0);function M(pe,De,B){if(!B||B.length<De.length)return null;let x;return pe?x=f.$9e(B,De):x=B.indexOf(De)===0,x?De.length>0?[{start:0,end:De.length}]:[]:null}function b(pe,De){const B=De.toLowerCase().indexOf(pe.toLowerCase());return B===-1?null:[{start:B,end:B+pe.length}]}e.$Rj=b;function m(pe,De){return w(pe.toLowerCase(),De.toLowerCase(),0,0)}e.$Sj=m;function w(pe,De,B,x){if(B===pe.length)return[];if(x===De.length)return null;if(pe[B]===De[x]){let se=null;return(se=w(pe,De,B+1,x+1))?s({start:x,end:x+1},se):null}return w(pe,De,B,x+1)}function L(pe){return 97<=pe&&pe<=122}function I(pe){return 65<=pe&&pe<=90}e.$Tj=I;function $(pe){return 48<=pe&&pe<=57}function y(pe){return pe===32||pe===9||pe===10||pe===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(pe=>D.add(pe.charCodeAt(0)));function u(pe){return y(pe)||D.has(pe)}function g(pe,De){return pe===De||u(pe)&&u(De)}const o=new Map;function n(pe){if(o.has(pe))return o.get(pe);let De;const B=(0,F.$Nj)(pe);return B&&(De=B),o.set(pe,De),De}function i(pe){return L(pe)||I(pe)||$(pe)}function s(pe,De){return De.length===0?De=[pe]:pe.end===De[0].start?De[0].start=pe.start:De.unshift(pe),De}function a(pe,De){for(let B=De;B<pe.length;B++){const x=pe.charCodeAt(B);if(I(x)||$(x)||B>0&&!i(pe.charCodeAt(B-1)))return B}return pe.length}function t(pe,De,B,x){if(B===pe.length)return[];if(x===De.length)return null;if(pe[B]!==De[x].toLowerCase())return null;{let se=null,H=x+1;for(se=t(pe,De,B+1,x+1);!se&&(H=a(De,H))<De.length;)se=t(pe,De,B+1,H),H++;return se===null?null:s({start:x,end:x+1},se)}}function r(pe){let De=0,B=0,x=0,se=0,H=0;for(let Ge=0;Ge<pe.length;Ge++)H=pe.charCodeAt(Ge),I(H)&&De++,L(H)&&B++,i(H)&&x++,$(H)&&se++;const ue=De/pe.length,fe=B/pe.length,Re=x/pe.length,Oe=se/pe.length;return{upperPercent:ue,lowerPercent:fe,alphaPercent:Re,numericPercent:Oe}}function d(pe){const{upperPercent:De,lowerPercent:B}=pe;return B===0&&De>.6}function l(pe){const{upperPercent:De,lowerPercent:B,alphaPercent:x,numericPercent:se}=pe;return B>.2&&De<.8&&x>.6&&se<.2}function h(pe){let De=0,B=0,x=0,se=0;for(let H=0;H<pe.length;H++)x=pe.charCodeAt(H),I(x)&&De++,L(x)&&B++,y(x)&&se++;return(De===0||B===0)&&se===0?pe.length<=30:De<=5}function c(pe,De){if(!De||(De=De.trim(),De.length===0)||!h(pe)||De.length>60)return null;const B=r(De);if(!l(B)){if(!d(B))return null;De=De.toLowerCase()}let x=null,se=0;for(pe=pe.toLowerCase();se<De.length&&(x=t(pe,De,0,se))===null;)se=a(De,se+1);return x}e.$Uj=c;function v(pe,De,B=!1){if(!De||De.length===0)return null;let x=null,se=0;for(pe=pe.toLowerCase(),De=De.toLowerCase();se<De.length&&(x=P(pe,De,0,se,B),x===null);)se=S(De,se+1);return x}e.$Vj=v;function P(pe,De,B,x,se){let H=0;if(B===pe.length)return[];if(x===De.length)return null;if(!g(pe.charCodeAt(B),De.charCodeAt(x))){const Re=n(pe.charCodeAt(B));if(!Re)return null;for(let Oe=0;Oe<Re.length;Oe++)if(!g(Re[Oe],De.charCodeAt(x+Oe)))return null;H+=Re.length-1}let ue=null,fe=x+H+1;if(ue=P(pe,De,B+1,fe,se),!se)for(;!ue&&(fe=S(De,fe))<De.length;)ue=P(pe,De,B+1,fe,se),fe++;if(!ue)return null;if(pe.charCodeAt(B)!==De.charCodeAt(x)){const Re=n(pe.charCodeAt(B));if(!Re)return ue;for(let Oe=0;Oe<Re.length;Oe++)if(Re[Oe]!==De.charCodeAt(x+Oe))return ue}return s({start:x,end:x+H+1},ue)}function S(pe,De){for(let B=De;B<pe.length;B++)if(u(pe.charCodeAt(B))||B>0&&u(pe.charCodeAt(B-1)))return B;return pe.length}const p=A(e.$Qj,c,b),k=A(e.$Qj,c,m),C=new E.$Dc(1e4);function j(pe,De,B=!1){if(typeof pe!="string"||typeof De!="string")return null;let x=C.get(pe);x||(x=new RegExp(f.$Re(pe),"i"),C.set(pe,x));const se=x.exec(De);return se?[{start:se.index,end:se.index+se[0].length}]:B?k(pe,De):p(pe,De)}e.$Wj=j;function z(pe,De){const B=Y(pe,pe.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?U(B):null}e.$Xj=z;function O(pe,De,B,x,se,H){const ue=Math.min(13,pe.length);for(;B<ue;B++){const fe=Y(pe,De,B,x,se,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,H]}e.$Yj=O;function U(pe){if(typeof pe>"u")return[];const De=[],B=pe[1];for(let x=pe.length-1;x>1;x--){const se=pe[x]+B,H=De[De.length-1];H&&H.end===se?H.end=se+1:De.push({start:se,end:se+1})}return De}e.$Zj=U;const N=128;function R(){const pe=[],De=[];for(let B=0;B<=N;B++)De[B]=0;for(let B=0;B<=N;B++)pe.push(De.slice(0));return pe}function T(pe){const De=[];for(let B=0;B<=pe;B++)De[B]=0;return De}const q=T(2*N),ee=T(2*N),J=R(),K=R(),Z=R(),ae=!1;function _(pe,De,B,x,se){function H(fe,Re,Oe=" "){for(;fe.length<Re;)fe=Oe+fe;return fe}let ue=` |   |${x.split("").map(fe=>H(fe,3)).join("|")}
`;for(let fe=0;fe<=B;fe++)fe===0?ue+=" |":ue+=`${De[fe-1]}|`,ue+=pe[fe].slice(0,se+1).map(Re=>H(Re.toString(),3)).join("|")+`
`;return ue}function ye(pe,De,B,x){pe=pe.substr(De),B=B.substr(x),console.log(_(K,pe,pe.length,B,B.length)),console.log(_(Z,pe,pe.length,B,B.length)),console.log(_(J,pe,pe.length,B,B.length))}function ge(pe,De){if(De<0||De>=pe.length)return!1;const B=pe.codePointAt(De);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!f.$of(B)}}function re(pe,De){if(De<0||De>=pe.length)return!1;switch(pe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function W(pe,De,B){return De[pe]!==B[pe]}function ce(pe,De,B,x,se,H,ue=!1){for(;De<B&&se<H;)pe[De]===x[se]&&(ue&&(q[De]=se),De+=1),se+=1;return De===B}e.$1j=ce;var me;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(me||(me={}));var le;(function(pe){pe.Default=[-100,0];function De(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}pe.isDefault=De})(le||(e.FuzzyScore=le={}));class de{constructor(De,B){this.firstMatchCanBeWeak=De,this.boostFullMatch=B}}e.$2j=de,de.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Y(pe,De,B,x,se,H,ue=de.default){const fe=pe.length>N?N:pe.length,Re=x.length>N?N:x.length;if(B>=fe||H>=Re||fe-B>Re-H||!ce(De,B,fe,se,H,Re,!0))return;X(fe,Re,B,H,De,se);let Oe=1,Ge=1,He=B,et=H;const lt=[!1];for(Oe=1,He=B;He<fe;Oe++,He++){const Ae=q[He],Xe=ee[He],ne=He+1<fe?ee[He+1]:Re;for(Ge=Ae-H+1,et=Ae;et<ne;Ge++,et++){let he=Number.MIN_SAFE_INTEGER,Ie=!1;et<=Xe&&(he=Q(pe,De,He,B,x,se,et,Re,H,J[Oe-1][Ge-1]===0,lt));let Ke=0;he!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ke=he+K[Oe-1][Ge-1]);const Ye=et>Ae,it=Ye?K[Oe][Ge-1]+(J[Oe][Ge-1]>0?-5:0):0,at=et>Ae+1&&J[Oe][Ge-1]>0,je=at?K[Oe][Ge-2]+(J[Oe][Ge-2]>0?-5:0):0;if(at&&(!Ye||je>=it)&&(!Ie||je>=Ke))K[Oe][Ge]=je,Z[Oe][Ge]=3,J[Oe][Ge]=0;else if(Ye&&(!Ie||it>=Ke))K[Oe][Ge]=it,Z[Oe][Ge]=2,J[Oe][Ge]=0;else if(Ie)K[Oe][Ge]=Ke,Z[Oe][Ge]=1,J[Oe][Ge]=J[Oe-1][Ge-1]+1;else throw new Error("not possible")}}if(ae&&ye(pe,B,x,H),!lt[0]&&!ue.firstMatchCanBeWeak)return;Oe--,Ge--;const ct=[K[Oe][Ge],H];let ot=0,Pe=0;for(;Oe>=1;){let Ae=Ge;do{const Xe=Z[Oe][Ae];if(Xe===3)Ae=Ae-2;else if(Xe===2)Ae=Ae-1;else break}while(Ae>=1);ot>1&&De[B+Oe-1]===se[H+Ge-1]&&!W(Ae+H-1,x,se)&&ot+1>J[Oe][Ae]&&(Ae=Ge),Ae===Ge?ot++:ot=1,Pe||(Pe=Ae),Oe--,Ge=Ae-1,ct.push(Ge)}Re===fe&&ue.boostFullMatch&&(ct[0]+=2);const Ue=Pe-fe;return ct[0]-=Ue,ct}e.$3j=Y;function X(pe,De,B,x,se,H){let ue=pe-1,fe=De-1;for(;ue>=B&&fe>=x;)se[ue]===H[fe]&&(ee[ue]=fe,ue--),fe--}function Q(pe,De,B,x,se,H,ue,fe,Re,Oe,Ge){if(De[B]!==H[ue])return Number.MIN_SAFE_INTEGER;let He=1,et=!1;return ue===B-x?He=pe[B]===se[ue]?7:5:W(ue,se,H)&&(ue===0||!W(ue-1,se,H))?(He=pe[B]===se[ue]?7:5,et=!0):ge(H,ue)&&(ue===0||!ge(H,ue-1))?He=5:(ge(H,ue-1)||re(H,ue-1))&&(He=5,et=!0),He>1&&B===x&&(Ge[0]=!0),et||(et=W(ue,se,H)||ge(H,ue-1)||re(H,ue-1)),B===x?ue>Re&&(He-=et?3:5):Oe?He+=et?2:0:He+=et?0:1,ue+1===fe&&(He-=et?3:5),He}function te(pe,De,B,x,se,H,ue){return ve(pe,De,B,x,se,H,!0,ue)}e.$4j=te;function $e(pe,De,B,x,se,H,ue){return ve(pe,De,B,x,se,H,!1,ue)}e.$5j=$e;function ve(pe,De,B,x,se,H,ue,fe){let Re=Y(pe,De,B,x,se,H,fe);if(Re&&!ue)return Re;if(pe.length>=3){const Oe=Math.min(7,pe.length-1);for(let Ge=B+1;Ge<Oe;Ge++){const He=Le(pe,Ge);if(He){const et=Y(He,He.toLowerCase(),B,x,se,H,fe);et&&(et[0]-=3,(!Re||et[0]>Re[0])&&(Re=et))}}}return Re}function Le(pe,De){if(De+1>=pe.length)return;const B=pe[De],x=pe[De+1];if(B!==x)return pe.slice(0,De)+x+B+pe.slice(De+2)}}),define(Se[53],ke([1,0,13]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=void 0;function F(o){return f(o,0)}e.$Pi=F;function f(o,n){switch(typeof o){case"object":return o===null?A(349,n):Array.isArray(o)?m(o,n):w(o,n);case"string":return b(o,n);case"boolean":return M(o,n);case"number":return A(o,n);case"undefined":return A(937,n);default:return A(617,n)}}e.$Qi=f;function A(o,n){return(n<<5)-n+o|0}e.$Ri=A;function M(o,n){return A(o?433:863,n)}function b(o,n){n=A(149417,n);for(let i=0,s=o.length;i<s;i++)n=A(o.charCodeAt(i),n);return n}e.$Si=b;function m(o,n){return n=A(104579,n),o.reduce((i,s)=>f(s,i),n)}function w(o,n){return n=A(181387,n),Object.keys(o).sort().reduce((i,s)=>(i=b(s,i),f(o[s],i)),n)}class L{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=f(n,this.g),this.g}}e.$Ti=L;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function $(o,n,i=32){const s=i-n,a=~((1<<s)-1);return(o<<n|(a&o)>>>s)>>>0}function y(o,n=0,i=o.byteLength,s=0){for(let a=0;a<i;a++)o[n+a]=s}function D(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function u(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):D((o>>>0).toString(16),n/4)}e.$Ui=u;class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const s=this.p;let a=this.r,t=this.u,r,d;for(t!==0?(r=t,d=-1,t=0):(r=n.charCodeAt(0),d=0);;){let l=r;if(E.$_e(r))if(d+1<i){const h=n.charCodeAt(d+1);E.$af(h)?(d++,l=E.$bf(r,h)):l=65533}else{t=r;break}else E.$af(r)&&(l=65533);if(a=this.w(s,a,l),d++,d<i)r=n.charCodeAt(d);else break}this.r=a,this.u=t}w(n,i,s){return s<128?n[i++]=s:s<2048?(n[i++]=192|(s&1984)>>>6,n[i++]=128|(s&63)>>>0):s<65536?(n[i++]=224|(s&61440)>>>12,n[i++]=128|(s&4032)>>>6,n[i++]=128|(s&63)>>>0):(n[i++]=240|(s&1835008)>>>18,n[i++]=128|(s&258048)>>>12,n[i++]=128|(s&4032)>>>6,n[i++]=128|(s&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=g.g,i=this.q;for(let v=0;v<64;v+=4)n.setUint32(v,i.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)n.setUint32(v,$(n.getUint32(v-12,!1)^n.getUint32(v-32,!1)^n.getUint32(v-56,!1)^n.getUint32(v-64,!1),1),!1);let s=this.h,a=this.l,t=this.m,r=this.n,d=this.o,l,h,c;for(let v=0;v<80;v++)v<20?(l=a&t|~a&r,h=1518500249):v<40?(l=a^t^r,h=1859775393):v<60?(l=a&t|a&r|t&r,h=2400959708):(l=a^t^r,h=3395469782),c=$(s,5)+l+d+h+n.getUint32(v*4,!1)&4294967295,d=r,r=t,t=$(a,30),a=s,s=c;this.h=this.h+s&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+d&4294967295}}e.$Vi=g,g.g=new DataView(new ArrayBuffer(320))}),define(Se[126],ke([1,0,124,125,53,16,9,13]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const m=0,w=[m,[]];function L(T,q,ee,J){if(!T||!q)return w;const K=T.length,Z=q.length;if(K<Z)return w;const ae=T.toLowerCase();return I(q,ee,Z,T,ae,K,J)}e.$Iq=L;function I(T,q,ee,J,K,Z,ae){const _=[],ye=[];for(let ce=0;ce<ee;ce++){const me=ce*Z,le=me-Z,de=ce>0,Y=T[ce],X=q[ce];for(let Q=0;Q<Z;Q++){const te=Q>0,$e=me+Q,ve=$e-1,Le=le+Q-1,pe=te?_[ve]:0,De=de&&te?_[Le]:0,B=de&&te?ye[Le]:0;let x;!De&&de?x=0:x=$(Y,X,J,K,Q,B),x&&De+x>=pe&&(ae||de||K.startsWith(q,Q))?(ye[$e]=B+1,_[$e]=De+x):(ye[$e]=m,_[$e]=pe)}}const ge=[];let re=ee-1,W=Z-1;for(;re>=0&&W>=0;){const ce=re*Z+W;ye[ce]===m||(ge.push(W),re--),W--}return[_[ee*Z-1],ge.reverse()]}function $(T,q,ee,J,K,Z){let ae=0;if(!y(q,J[K]))return ae;if(ae+=1,Z>0&&(ae+=Z*5),T===ee[K]&&(ae+=1),K===0)ae+=8;else{const _=D(ee.charCodeAt(K-1));_?ae+=_:(0,F.$Tj)(ee.charCodeAt(K))&&Z===0&&(ae+=2)}return ae}function y(T,q){return T===q?!0:T==="/"||T==="\\"?q==="/"||q==="\\":!1}function D(T){switch(T){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function g(T,q,ee=0,J=0){const K=q;return K.values&&K.values.length>1?o(T,K.values,ee,J):n(T,q,ee,J)}e.$Jq=g;function o(T,q,ee,J){let K=0;const Z=[];for(const ae of q){const[_,ye]=n(T,ae,ee,J);if(typeof _!="number")return u;K+=_,Z.push(...ye)}return[K,P(Z)]}function n(T,q,ee,J){const K=(0,F.$3j)(q.original,q.originalLowercase,ee,T,T.toLowerCase(),J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return K?[K[0],(0,F.$Zj)(K)]:u}const i=Object.freeze({score:0}),s=1<<18,a=1<<17,t=1<<16;function r(T,q,ee,J){const K=J.values?J.values:[J];return(0,f.$Pi)({[J.normalized]:{values:K.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:T,description:q,allowNonContiguousMatches:ee}})}function d(T,q,ee,J,K){if(!T||!q.normalized)return i;const Z=J.getItemLabel(T);if(!Z)return i;const ae=J.getItemDescription(T),_=r(Z,ae,ee,q),ye=K[_];if(ye)return ye;const ge=l(Z,ae,J.getItemPath(T),q,ee);return K[_]=ge,ge}e.$Kq=d;function l(T,q,ee,J,K){const Z=!ee||!J.containsPathSeparator;return ee&&(M.$e?J.pathNormalized===ee:(0,b.$8e)(J.pathNormalized,ee))?{score:s,labelMatch:[{start:0,end:T.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:J.values&&J.values.length>1?h(T,q,ee,J.values,Z,K):c(T,q,ee,J,Z,K)}function h(T,q,ee,J,K,Z){let ae=0;const _=[],ye=[];for(const ge of J){const{score:re,labelMatch:W,descriptionMatch:ce}=c(T,q,ee,ge,K,Z);if(re===m)return i;ae+=re,W&&_.push(...W),ce&&ye.push(...ce)}return{score:ae,labelMatch:P(_),descriptionMatch:P(ye)}}function c(T,q,ee,J,K,Z){if(K||!q){const[ae,_]=L(T,J.normalized,J.normalizedLowercase,Z&&!J.expectContiguousMatch);if(ae){const ye=(0,F.$Qj)(J.normalized,T);let ge;if(ye){ge=a;const re=Math.round(J.normalized.length/T.length*100);ge+=re}else ge=t;return{score:ge+ae,labelMatch:ye||v(_)}}}if(q){let ae=q;ee&&(ae=`${q}${A.sep}`);const _=ae.length,ye=`${ae}${T}`,[ge,re]=L(ye,J.normalized,J.normalizedLowercase,Z&&!J.expectContiguousMatch);if(ge){const W=v(re),ce=[],me=[];return W.forEach(le=>{le.start<_&&le.end>_?(ce.push({start:0,end:le.end-_}),me.push({start:le.start,end:_})):le.start>=_?ce.push({start:le.start-_,end:le.end-_}):me.push(le)}),{score:ge,labelMatch:ce,descriptionMatch:me}}}return i}function v(T){const q=[];if(!T)return q;let ee;for(const J of T)ee&&ee.end===J?ee.end+=1:(ee={start:J,end:J+1},q.push(ee));return q}function P(T){const q=T.sort((K,Z)=>K.start-Z.start),ee=[];let J;for(const K of q)!J||!S(J,K)?(J=K,ee.push(K)):(J.start=Math.min(J.start,K.start),J.end=Math.max(J.end,K.end));return ee}function S(T,q){return!(T.end<q.start||q.end<T.start)}function p(T,q,ee,J,K,Z){const ae=d(T,ee,J,K,Z),_=d(q,ee,J,K,Z),ye=ae.score,ge=_.score;if((ye===s||ge===s)&&ye!==ge)return ye===s?-1:1;if(ye>t||ge>t){if(ye!==ge)return ye>ge?-1:1;if(ye<a&&ge<a){const Y=C(ae.labelMatch,_.labelMatch);if(Y!==0)return Y}const le=K.getItemLabel(T)||"",de=K.getItemLabel(q)||"";if(le.length!==de.length)return le.length-de.length}if(ye!==ge)return ye>ge?-1:1;const re=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,W=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(re&&!W)return-1;if(W&&!re)return 1;const ce=k(T,ae,K),me=k(q,_,K);return ce&&me&&ce!==me?me>ce?-1:1:j(T,q,ee,K)}e.$Lq=p;function k(T,q,ee){let J=-1,K=-1;if(q.descriptionMatch&&q.descriptionMatch.length?J=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(J=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(K=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const Z=ee.getItemDescription(T);Z&&(K+=Z.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(K=q.descriptionMatch[q.descriptionMatch.length-1].end);return K-J}function C(T,q){if(!T&&!q||(!T||!T.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!T||!T.length)return 1;const ee=T[0].start,K=T[T.length-1].end-ee,Z=q[0].start,_=q[q.length-1].end-Z;return K===_?0:_<K?1:-1}function j(T,q,ee,J){const K=J.getItemLabel(T)||"",Z=J.getItemLabel(q)||"",ae=J.getItemDescription(T),_=J.getItemDescription(q),ye=K.length+(ae?ae.length:0),ge=Z.length+(_?_.length:0);if(ye!==ge)return ye-ge;const re=J.getItemPath(T),W=J.getItemPath(q);return re&&W&&re.length!==W.length?re.length-W.length:K!==Z?(0,E.$Gq)(K,Z,ee.normalized):ae&&_&&ae!==_?(0,E.$Gq)(ae,_,ee.normalized):re&&W&&re!==W?(0,E.$Gq)(re,W,ee.normalized):0}function z(T){return T.startsWith('"')&&T.endsWith('"')}const O=" ";function U(T){typeof T!="string"&&(T="");const q=T.toLowerCase(),{pathNormalized:ee,normalized:J,normalizedLowercase:K}=N(T),Z=ee.indexOf(A.sep)>=0,ae=z(T);let _;const ye=T.split(O);if(ye.length>1)for(const ge of ye){const re=z(ge),{pathNormalized:W,normalized:ce,normalizedLowercase:me}=N(ge);ce&&(_||(_=[]),_.push({original:ge,originalLowercase:ge.toLowerCase(),pathNormalized:W,normalized:ce,normalizedLowercase:me,expectContiguousMatch:re}))}return{original:T,originalLowercase:q,pathNormalized:ee,normalized:J,normalizedLowercase:K,values:_,containsPathSeparator:Z,expectContiguousMatch:ae}}e.$Mq=U;function N(T){let q;M.$c?q=T.replace(/\//g,A.sep):q=T.replace(/\\/g,A.sep);const ee=(0,b.$Se)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:ee,normalizedLowercase:ee.toLowerCase()}}function R(T){return Array.isArray(T)?U(T.map(q=>q.original).join(O)):U(T.original)}e.$Nq=R}),define(Se[40],ke([1,0,13]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(F||(F={})),function(f){const A="error",M="warning",b="warn",m="info",w="ignore";function L($){return $?E.$8e(A,$)?f.Error:E.$8e(M,$)||E.$8e(b,$)?f.Warning:E.$8e(m,$)?f.Info:f.Ignore:f.Ignore}f.fromValue=L;function I($){switch($){case f.Error:return A;case f.Warning:return M;case f.Info:return m;default:return w}}f.toString=I}(F||(F={})),e.default=F}),define(Se[164],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Se[77],ke([1,0,19,13]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class f{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const D=y.charCodeAt(0),u=this.b.charCodeAt(this.c);return D-u}value(){return this.b[this.c]}}e.$4h=f;class A{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,F.$2e)(y,this.b,0,y.length,this.c,this.d):(0,F.$4e)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=A;class M{constructor(y=!0,D=!0){this.f=y,this.g=D}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let D=y.length-1;D>=0;D--,this.c--){const u=this.b.charCodeAt(D);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,F.$2e)(y,this.b,0,y.length,this.d,this.e):(0,F.$4e)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=M;var b;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(b||(b={}));class m{constructor(y,D){this.f=y,this.g=D,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,F.$3e)(y,this.c.scheme);if(this.d[this.e]===2)return(0,F.$3e)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,F.$1e)(y,this.c.query);if(this.d[this.e]===5)return(0,F.$1e)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=m;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(L||(L={}));class I{static forUris(y=()=>!1,D=()=>!1){return new I(new m(y,D))}static forPaths(y=!1){return new I(new M(void 0,!y))}static forStrings(){return new I(new f)}static forConfigKeys(){return new I(new A)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,D){if(D){const u=D.slice(0);(0,E.$Xb)(u);for(const g of u)this.set(g,y)}else{const u=y.slice(0);(0,E.$Xb)(u);for(const g of u)this.set(g[0],g[1])}}set(y,D){const u=this.b.reset(y);let g;this.c||(this.c=new w,this.c.segment=u.value());const o=[];for(g=this.c;;){const i=u.cmp(g.segment);if(i>0)g.left||(g.left=new w,g.left.segment=u.value()),o.push([-1,g]),g=g.left;else if(i<0)g.right||(g.right=new w,g.right.segment=u.value()),o.push([1,g]),g=g.right;else if(u.hasNext())u.next(),g.mid||(g.mid=new w,g.mid.segment=u.value()),o.push([0,g]),g=g.mid;else break}const n=g.value;g.value=D,g.key=y;for(let i=o.length-1;i>=0;i--){const s=o[i][1];s.updateHeight();const a=s.balanceFactor();if(a<-1||a>1){const t=o[i][0],r=o[i+1][0];if(t===1&&r===1)o[i][1]=s.rotateLeft();else if(t===-1&&r===-1)o[i][1]=s.rotateRight();else if(t===1&&r===-1)s.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=s.rotateLeft();else if(t===-1&&r===1)s.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=s.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(y){return this.d(y)?.value}d(y){const D=this.b.reset(y);let u=this.c;for(;u;){const g=D.cmp(u.segment);if(g>0)u=u.left;else if(g<0)u=u.right;else if(D.hasNext())D.next(),u=u.mid;else break}return u}has(y){const D=this.d(y);return!(D?.value===void 0&&D?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,D){const u=this.b.reset(y),g=[];let o=this.c;for(;o;){const n=u.cmp(o.segment);if(n>0)g.push([-1,o]),o=o.left;else if(n<0)g.push([1,o]),o=o.right;else if(u.hasNext())u.next(),g.push([0,o]),o=o.mid;else break}if(o){if(D?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:s,segment:a}=n;this.e(n.key,!1),o.key=i,o.value=s,o.segment=a}}else{const n=o.left??o.right;if(g.length>0){const[i,s]=g[g.length-1];switch(i){case-1:s.left=n;break;case 0:s.mid=n;break;case 1:s.right=n;break}}else this.c=n}for(let n=g.length-1;n>=0;n--){const i=g[n][1];i.updateHeight();const s=i.balanceFactor();if(s>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),g[n][1]=i.rotateLeft()):s<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),g[n][1]=i.rotateRight()),n>0)switch(g[n-1][0]){case-1:g[n-1][1].left=g[n][1];break;case 1:g[n-1][1].right=g[n][1];break;case 0:g[n-1][1].mid=g[n][1];break}else this.c=g[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const D=this.b.reset(y);let u=this.c,g;for(;u;){const o=D.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(D.hasNext())D.next(),g=u.value||g,u=u.mid;else break}return u&&u.value||g}findSuperstr(y){return this.g(y,!1)}g(y,D){const u=this.b.reset(y);let g=this.c;for(;g;){const o=u.cmp(g.segment);if(o>0)g=g.left;else if(o<0)g=g.right;else if(u.hasNext())u.next(),g=g.mid;else return g.mid?this.h(g.mid):D?g.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[D,u]of this)y(u,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const D=[];return this.j(y,D),D[Symbol.iterator]()}j(y,D){y&&(y.left&&this.j(y.left,D),y.value&&D.push([y.key,y.value]),y.mid&&this.j(y.mid,D),y.right&&this.j(y.right,D))}_isBalanced(){const y=D=>{if(!D)return!0;const u=D.balanceFactor();return u<-1||u>1?!1:y(D.left)&&y(D.right)};return y(this.c)}}e.$8h=I}),define(Se[18],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=void 0;function E(a){return typeof a=="string"}e.$Ef=E;function F(a){return Array.isArray(a)&&a.every(t=>E(t))}e.$Ff=F;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Gf=f;function A(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Hf=A;function M(a){return typeof a=="number"&&!isNaN(a)}e.$If=M;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Jf=b;function m(a){return a===!0||a===!1}e.$Kf=m;function w(a){return typeof a>"u"}e.$Lf=w;function L(a){return!I(a)}e.$Mf=L;function I(a){return w(a)||a===null}e.$Nf=I;function $(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Of=$;function y(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Pf=y;function D(...a){const t=[];for(let r=0;r<a.length;r++){const d=a[r];if(I(d))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(d)}return t}e.$Qf=D;const u=Object.prototype.hasOwnProperty;function g(a){if(!f(a))return!1;for(const t in a)if(u.call(a,t))return!1;return!0}e.$Rf=g;function o(a){return typeof a=="function"}e.$Sf=o;function n(...a){return a.length>0&&a.every(o)}e.$Tf=n;function i(a,t){const r=Math.min(a.length,t.length);for(let d=0;d<r;d++)s(a[d],t[d])}e.$Uf=i;function s(a,t){if(E(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!I(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Vf=s}),define(Se[78],ke([1,0,18]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=void 0;const F=Object.create(null);function f(b,m){if((0,E.$Ef)(m)){const w=F[m];if(w===void 0)throw new Error(`${b} references an unknown codicon: ${m}`);m=w}return F[b]=m,{id:b}}function A(){return F}e.$6j=A;function M(){return Object.values(e.$8j)}e.$7j=M,e.$8j={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),lightbulbSparkle:f("lightbulb-sparkle",60447),lightbulbSparkleAutofix:f("lightbulb-sparkle-autofix",60447),robot:f("robot",60448),sparkleFilled:f("sparkle-filled",60449),diffSingle:f("diff-single",60450),diffMultiple:f("diff-multiple",60451),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(Se[33],ke([1,0,16,9,13,18]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function M(c){return c===47||c===92}e.$Wf=M;function b(c){return c.replace(/[\\/]/g,E.$gc.sep)}e.$Xf=b;function m(c){return c.indexOf("/")===-1&&(c=b(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$Yf=m;function w(c,v=E.$gc.sep){if(!c)return"";const P=c.length,S=c.charCodeAt(0);if(M(S)){if(M(c.charCodeAt(1))&&!M(c.charCodeAt(2))){let k=3;const C=k;for(;k<P&&!M(c.charCodeAt(k));k++);if(C!==k&&!M(c.charCodeAt(k+1))){for(k+=1;k<P;k++)if(M(c.charCodeAt(k)))return c.slice(0,k+1).replace(/[\\/]/g,v)}}return v}else if(o(S)&&c.charCodeAt(1)===58)return M(c.charCodeAt(2))?c.slice(0,2)+v:c.slice(0,2);let p=c.indexOf("://");if(p!==-1){for(p+=3;p<P;p++)if(M(c.charCodeAt(p)))return c.slice(0,p+1)}return""}e.$Zf=w;function L(c){if(!F.$c||!c||c.length<5)return!1;let v=c.charCodeAt(0);if(v!==92||(v=c.charCodeAt(1),v!==92))return!1;let P=2;const S=P;for(;P<c.length&&(v=c.charCodeAt(P),v!==92);P++);return!(S===P||(v=c.charCodeAt(P+1),isNaN(v)||v===92))}e.$1f=L;const I=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(c,v=F.$c){const P=v?I:$;return!(!c||c.length===0||/^\s+$/.test(c)||(P.lastIndex=0,P.test(c))||v&&y.test(c)||c==="."||c===".."||v&&c[c.length-1]==="."||v&&c.length!==c.trim().length||c.length>255)}e.$2f=D;function u(c,v,P){const S=c===v;return!P||S?S:!c||!v?!1:(0,f.$8e)(c,v)}e.$3f=u;function g(c,v,P,S=E.sep){if(c===v)return!0;if(!c||!v||v.length>c.length)return!1;if(P){if(!(0,f.$9e)(c,v))return!1;if(v.length===c.length)return!0;let k=v.length;return v.charAt(v.length-1)===S&&k--,c.charAt(k)===S}return v.charAt(v.length-1)!==S&&(v+=S),c.indexOf(v)===0}e.$4f=g;function o(c){return c>=65&&c<=90||c>=97&&c<=122}e.$5f=o;function n(c,v){return F.$c&&c.endsWith(":")&&(c+=E.sep),(0,E.$ic)(c)||(c=(0,E.$jc)(v,c)),c=(0,E.$hc)(c),F.$c?(c=(0,f.$Qe)(c,E.sep),c.endsWith(":")&&(c+=E.sep)):(c=(0,f.$Qe)(c,E.sep),c||(c=E.sep)),c}e.$6f=n;function i(c){const v=(0,E.$hc)(c);return F.$c?c.length>3?!1:s(v)&&(c.length===2||v.charCodeAt(2)===92):v===E.$gc.sep}e.$7f=i;function s(c,v=F.$c){return v?o(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$8f=s;function a(c,v=F.$c){return s(c,v)?c[0]:void 0}e.$9f=a;function t(c,v,P){return v.length>c.length?-1:c===v?0:(P&&(c=c.toLowerCase(),v=v.toLowerCase()),c.indexOf(v))}e.$0f=t;function r(c){const v=c.split(":");let P,S,p;for(const k of v){const C=Number(k);(0,A.$If)(C)?S===void 0?S=C:p===void 0&&(p=C):P=P?[P,k].join(":"):k}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:S!==void 0?S:void 0,column:p!==void 0?p:S!==void 0?1:void 0}}e.$$f=r;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function h(c,v,P=8){let S="";for(let k=0;k<P;k++){let C;k===0&&F.$c&&!v&&(P===3||P===4)?C=l:C=d,S+=C.charAt(Math.floor(Math.random()*C.length))}let p;return v?p=`${v}-${S}`:p=S,c?(0,E.$jc)(c,p):p}e.$_f=h}),define(Se[24],ke([1,0,18]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,s])=>{n[i]=s&&typeof s=="object"?F(s):s}),n}e.$in=F;function f(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const s in i)if(A.call(i,s)){const a=i[s];typeof a=="object"&&!Object.isFrozen(a)&&!(0,E.$Hf)(a)&&n.push(a)}}return o}e.$jn=f;const A=Object.prototype.hasOwnProperty;function M(o,n){return b(o,n,new Set)}e.$kn=M;function b(o,n,i){if((0,E.$Nf)(o))return o;const s=n(o);if(typeof s<"u")return s;if(Array.isArray(o)){const a=[];for(const t of o)a.push(b(t,n,i));return a}if((0,E.$Gf)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const a={};for(const t in o)A.call(o,t)&&(a[t]=b(o[t],n,i));return i.delete(o),a}return o}function m(o,n,i=!0){return(0,E.$Gf)(o)?((0,E.$Gf)(n)&&Object.keys(n).forEach(s=>{s in o?i&&((0,E.$Gf)(o[s])&&(0,E.$Gf)(n[s])?m(o[s],n[s],i):o[s]=n[s]):o[s]=n[s]}),o):n}e.$ln=m;function w(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,s;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!w(o[i],n[i]))return!1}else{const a=[];for(s in o)a.push(s);a.sort();const t=[];for(s in n)t.push(s);if(t.sort(),!w(a,t))return!1;for(i=0;i<a.length;i++)if(!w(o[a[i]],n[a[i]]))return!1}return!0}e.$mn=w;function L(o){const n=new Set;return JSON.stringify(o,(i,s)=>{if((0,E.$Gf)(s)||Array.isArray(s)){if(n.has(s))return"[Circular]";n.add(s)}return s})}e.$nn=L;function I(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(a=>{const t=o[a],r=n[a];w(t,r)||(i[a]=r)}),i}e.$on=I;function $(o,n){const i=n.toLowerCase(),s=Object.keys(o).find(a=>a.toLowerCase()===i);return s?o[s]:o[n]}e.$pn=$;function y(o,n){const i=Object.create(null);for(const[s,a]of Object.entries(o))n(s,a)&&(i[s]=a);return i}e.$qn=y;function D(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}e.$rn=D;function u(o){const n=[];for(const i of D(o))typeof o[i]=="function"&&n.push(i);return n}e.$sn=u;function g(o,n){const i=a=>function(){const t=Array.prototype.slice.call(arguments,0);return n(a,t)},s={};for(const a of o)s[a]=i(a);return s}e.$tn=g}),define(Se[61],ke([1,0,78]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$9j=e.ThemeColor=void 0;var F;(function(M){function b(m){return m&&typeof m=="object"&&typeof m.id=="string"}M.isThemeColor=b})(F||(e.ThemeColor=F={}));function f(M){return{id:M}}e.$9j=f;var A;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function m(n){const i=b.exec(n.id);if(!i)return m(E.$8j.error);const[,s,a]=i,t=["codicon","codicon-"+s];return a&&t.push("codicon-modifier-"+a.substring(1)),t}M.asClassNameArray=m;function w(n){return m(n).join(" ")}M.asClassName=w;function L(n){return"."+m(n).join(".")}M.asCSSSelector=L;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||F.isThemeColor(n.color))}M.isThemeIcon=I;const $=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function y(n){const i=$.exec(n);if(!i)return;const[,s]=i;return{id:s}}M.fromString=y;function D(n){return{id:n}}M.fromId=D;function u(n,i){let s=n.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),i&&(s=`${s}~${i}`),{id:s}}M.modify=u;function g(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=g;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=o})(A||(e.ThemeIcon=A={}))}),define(Se[165],ke([1,0,125,13,61]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=void 0;const A="$(",M=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function m(o){return o.replace(b,(n,i)=>i?n:`\\${n}`)}e.$0j=m;const w=new RegExp(`\\\\${M.source}`,"g");function L(o){return o.replace(w,n=>`\\${n}`)}e.$$j=L;const I=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function $(o){return o.indexOf(A)===-1?o:o.replace(I,(n,i,s,a)=>s?n:i||a||"")}e.$_j=$;function y(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}e.$ak=y;const D=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(o){D.lastIndex=0;let n="";const i=[];let s=0;for(;;){const a=D.lastIndex,t=D.exec(o),r=o.substring(a,t?.index);if(r.length>0){n+=r;for(let d=0;d<r.length;d++)i.push(s)}if(!t)break;s+=t[0].length}return{text:n,iconOffsets:i}}e.$bk=u;function g(o,n,i=!1){const{text:s,iconOffsets:a}=n;if(!a||a.length===0)return(0,E.$Wj)(o,s,i);const t=(0,F.$Pe)(s," "),r=s.length-t.length,d=(0,E.$Wj)(o,t,i);if(d)for(const l of d){const h=a[l.start+r]+r;l.start+=h,l.end+=h}return d}e.$ck=g}),define(Se[127],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=e.$Ee=e.Constants=void 0;var E;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E||(e.Constants=E={}));function F(A){return A<0?0:A>255?255:A|0}e.$Ee=F;function f(A){return A<0?0:A>4294967295?4294967295:A|0}e.$Fe=f}),define(Se[2],ke([1,0,16,9]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,A=/^\//,M=/^\/\//;function b(l,h){if(!l.scheme&&h)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!f.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!A.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(l,h){return!l&&!h?"file":l}function w(l,h){switch(l){case"https":case"http":case"file":h?h[0]!==I&&(h=I+h):h=I;break}return h}const L="",I="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(h){return h instanceof y?!0:h?typeof h.authority=="string"&&typeof h.fragment=="string"&&typeof h.path=="string"&&typeof h.query=="string"&&typeof h.scheme=="string"&&typeof h.fsPath=="string"&&typeof h.with=="function"&&typeof h.toString=="function":!1}constructor(h,c,v,P,S,p=!1){typeof h=="object"?(this.scheme=h.scheme||L,this.authority=h.authority||L,this.path=h.path||L,this.query=h.query||L,this.fragment=h.fragment||L):(this.scheme=m(h,p),this.authority=c||L,this.path=w(this.scheme,v||L),this.query=P||L,this.fragment=S||L,b(this,p))}get fsPath(){return s(this,!1)}with(h){if(!h)return this;let{scheme:c,authority:v,path:P,query:S,fragment:p}=h;return c===void 0?c=this.scheme:c===null&&(c=L),v===void 0?v=this.authority:v===null&&(v=L),P===void 0?P=this.path:P===null&&(P=L),S===void 0?S=this.query:S===null&&(S=L),p===void 0?p=this.fragment:p===null&&(p=L),c===this.scheme&&v===this.authority&&P===this.path&&S===this.query&&p===this.fragment?this:new g(c,v,P,S,p)}static parse(h,c=!1){const v=$.exec(h);return v?new g(v[2]||L,d(v[4]||L),d(v[5]||L),d(v[7]||L),d(v[9]||L),c):new g(L,L,L,L,L)}static file(h){let c=L;if(F.$c&&(h=h.replace(/\\/g,I)),h[0]===I&&h[1]===I){const v=h.indexOf(I,2);v===-1?(c=h.substring(2),h=I):(c=h.substring(2,v),h=h.substring(v)||I)}return new g("file",c,h,L,L)}static from(h,c){return new g(h.scheme,h.authority,h.path,h.query,h.fragment,c)}static joinPath(h,...c){if(!h.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return F.$c&&h.scheme==="file"?v=y.file(E.$fc.join(s(h,!0),...c)).path:v=E.$gc.join(h.path,...c),h.with({path:v})}toString(h=!1){return a(this,h)}toJSON(){return this}static revive(h){if(h){if(h instanceof y)return h;{const c=new g(h);return c._formatted=h.external??null,c._fsPath=h._sep===u?h.fsPath??null:null,c}}else return h}}e.URI=y;function D(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}e.$vc=D;const u=F.$c?1:void 0;class g extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(h=!1){return h?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const h={$mid:1};return this._fsPath&&(h.fsPath=this._fsPath,h._sep=u),this._formatted&&(h.external=this._formatted),this.path&&(h.path=this.path),this.scheme&&(h.scheme=this.scheme),this.authority&&(h.authority=this.authority),this.query&&(h.query=this.query),this.fragment&&(h.fragment=this.fragment),h}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(l,h,c){let v,P=-1;for(let S=0;S<l.length;S++){const p=l.charCodeAt(S);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||h&&p===47||c&&p===91||c&&p===93||c&&p===58)P!==-1&&(v+=encodeURIComponent(l.substring(P,S)),P=-1),v!==void 0&&(v+=l.charAt(S));else{v===void 0&&(v=l.substr(0,S));const k=o[p];k!==void 0?(P!==-1&&(v+=encodeURIComponent(l.substring(P,S)),P=-1),v+=k):P===-1&&(P=S)}}return P!==-1&&(v+=encodeURIComponent(l.substring(P))),v!==void 0?v:l}function i(l){let h;for(let c=0;c<l.length;c++){const v=l.charCodeAt(c);v===35||v===63?(h===void 0&&(h=l.substr(0,c)),h+=o[v]):h!==void 0&&(h+=l[c])}return h!==void 0?h:l}function s(l,h){let c;return l.authority&&l.path.length>1&&l.scheme==="file"?c=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?h?c=l.path.substr(1):c=l.path[1].toLowerCase()+l.path.substr(2):c=l.path,F.$c&&(c=c.replace(/\//g,"\\")),c}e.$wc=s;function a(l,h){const c=h?i:n;let v="",{scheme:P,authority:S,path:p,query:k,fragment:C}=l;if(P&&(v+=P,v+=":"),(S||P==="file")&&(v+=I,v+=I),S){let j=S.indexOf("@");if(j!==-1){const z=S.substr(0,j);S=S.substr(j+1),j=z.lastIndexOf(":"),j===-1?v+=c(z,!1,!1):(v+=c(z.substr(0,j),!1,!1),v+=":",v+=c(z.substr(j+1),!1,!0)),v+="@"}S=S.toLowerCase(),j=S.lastIndexOf(":"),j===-1?v+=c(S,!1,!0):(v+=c(S.substr(0,j),!1,!0),v+=S.substr(j))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const j=p.charCodeAt(1);j>=65&&j<=90&&(p=`/${String.fromCharCode(j+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const j=p.charCodeAt(0);j>=65&&j<=90&&(p=`${String.fromCharCode(j+32)}:${p.substr(2)}`)}v+=c(p,!0,!1)}return k&&(v+="?",v+=c(k,!1,!1)),C&&(v+="#",v+=h?C:n(C,!1,!1)),v}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(r)?l.replace(r,h=>t(h)):l}}),define(Se[166],ke([1,0,2]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$bq=e.$aq=e.$_p=void 0;function F(w){const L=w;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$_p=F;function f(w){const L=[];let I;try{const $=JSON.parse(w.arguments),y=$[$.length-1];y&&y.__$stack&&($.pop(),I=y.__$stack),L.push(...$)}catch{L.push("Unable to log remote console arguments",w.arguments)}return{args:L,stack:I}}e.$aq=f;function A(w){if(typeof w!="string")return A(f(w).stack);const L=w;if(L){const I=M(L),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if($&&$.length===4)return{uri:E.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$bq=A;function M(w){if(!w)return w;const L=w.indexOf(`
`);return L===-1?w:w.substring(0,L)}function b(w,L){const{args:I,stack:$}=f(w),y=typeof I[0]=="string"&&I.length===1;let D=M($);D&&(D=`(${D.trim()})`);let u=[];if(typeof I[0]=="string"?D&&y?u=[`%c[${L}] %c${I[0]} %c${D}`,m("blue"),m(""),m("grey")]:u=[`%c[${L}] %c${I[0]}`,m("blue"),m(""),...I.slice(1)]:u=[`%c[${L}]%`,m("blue"),...I],D&&!y&&u.push(D),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,u)}e.log=b;function m(w){return`color: ${w}`}}),define(Se[54],ke([1,0,22,2]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function f(m){return JSON.stringify(m,M)}e.$wh=f;function A(m){let w=JSON.parse(m);return w=b(w),w}e.$xh=A;function M(m,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function b(m,w=0){if(!m||w>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return F.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof E.$ge||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let L=0;L<m.length;++L)m[L]=b(m[L],w+1);else for(const L in m)Object.hasOwnProperty.call(m,L)&&(m[L]=b(m[L],w+1))}return m}e.$yh=b}),define(Se[17],ke([1,0,8,9,13,2]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var M;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={}));function b($,y){return A.URI.isUri($)?(0,f.$8e)($.scheme,y):(0,f.$9e)($,y+":")}e.$ag=b;function m($,...y){return y.some(D=>b($,D))}e.$bg=m,e.$cg="vscode-tkn",e.$dg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y){this.f=`${y}/${M.vscodeRemoteResource}`}set(y,D,u){this.a[y]=D,this.b[y]=u}setConnectionToken(y,D){this.c[y]=D}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)try{return this.e(y)}catch(i){return E.$1(i),y}const D=y.authority;let u=this.a[D];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const g=this.b[D],o=this.c[D];let n=`path=${encodeURIComponent(y.path)}`;return typeof o=="string"&&(n+=`&${e.$dg}=${encodeURIComponent(o)}`),A.URI.from({scheme:F.$i?this.d:M.vscodeRemoteResource,authority:`${u}:${g}`,path:F.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:n})}}e.$eg=new w,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class L{asBrowserUri(y){const D=this.b(y,ie);return this.uriToBrowserUri(D)}uriToBrowserUri(y){return y.scheme===M.vscodeRemote?e.$eg.rewrite(y):y.scheme===M.file&&(F.$g||F.$k===`${M.vscodeFileResource}://${L.a}`)?y.with({scheme:M.vscodeFileResource,authority:y.authority||L.a,query:null,fragment:null}):y}asFileUri(y){const D=this.b(y,ie);return this.uriToFileUri(D)}uriToFileUri(y){return y.scheme===M.vscodeFileResource?y.with({scheme:M.file,authority:y.authority!==L.a?y.authority:null,query:null,fragment:null}):y}b(y,D){return A.URI.isUri(y)?y:A.URI.parse(D.toUrl(y))}}L.a=e.$jg,e.$kg=new L;var I;(function($){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(y.get("3"));const D="vscode-coi";function u(o){let n;typeof o=="string"?n=new URL(o).searchParams:o instanceof URL?n=o.searchParams:A.URI.isUri(o)&&(n=new URL(o.toString(!0)).searchParams);const i=n?.get(D);if(i)return y.get(i)}$.getHeadersFromQuery=u;function g(o,n,i){if(!globalThis.crossOriginIsolated)return;const s=n&&i?"3":i?"2":"1";o instanceof URLSearchParams?o.set(D,s):o[D]=s}$.addSearchParam=g})(I||(e.COI=I={}))}),define(Se[167],ke([1,0,158,17,9,2]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=void 0;class M{constructor($,y,D){this.id=$,this.dependencies=y,this.callback=D}}class b{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,y,D)=>{typeof $!="string"&&(D=y,y=$,$=null),(typeof y!="object"||!Array.isArray(y))&&(D=y,y=null),this.c.push(new M($,y,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const y=await(this.a?this.i($):this.b?this.h($):this.j($));if(!y)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h($){return new Promise((y,D)=>{const u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript");const g=()=>{u.removeEventListener("load",o),u.removeEventListener("error",n)},o=i=>{g(),y(this.c.pop())},n=i=>{g(),D(i)};u.addEventListener("load",o),u.addEventListener("error",n),this.f&&($=this.f.createScriptURL($)),u.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(u)})}i($){return new Promise((y,D)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),y(this.c.pop())}catch(u){D(u)}})}async j($){try{const y=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,u=globalThis._VSCODE_NODE_MODULES.module,g=A.URI.parse($).fsPath,o=y.readFileSync(g).toString(),n=u.wrap(o.replace(/^#!.*/,""));return new D.Script(n).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}b.INSTANCE=new b;const m=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function L(I,$,y){if(E.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[I]&&(I=w[I]);const D=`${I}/${$}`;if(m.has(D))return m.get(D);let u;if(/^\w[\w\d+.-]*:\/\//.test(D))u=D;else{const i=`${y&&!f.$i?F.$hg:F.$gg}/${D}`;u=F.$kg.asBrowserUri(i).toString(!0)}const g=b.INSTANCE.load(u);return m.set(D,g),g}else return await new Promise((D,u)=>{ie([I],D,u)})}e.$ZC=L}),define(Se[23],ke([1,0,33,17,16,9,13,2]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function m(y){return(0,b.$wc)(y,!0)}e.$rg=m;class w{constructor(D){this.a=D}compare(D,u,g=!1){return D===u?0:(0,M.$1e)(this.getComparisonKey(D,g),this.getComparisonKey(u,g))}isEqual(D,u,g=!1){return D===u?!0:!D||!u?!1:this.getComparisonKey(D,g)===this.getComparisonKey(u,g)}getComparisonKey(D,u=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,u,g=!1){if(D.scheme===u.scheme){if(D.scheme===F.Schemas.file)return E.$4f(m(D),m(u),this.a(D))&&D.query===u.query&&(g||D.fragment===u.fragment);if((0,e.$Ig)(D.authority,u.authority))return E.$4f(D.path,u.path,this.a(D),"/")&&D.query===u.query&&(g||D.fragment===u.fragment)}return!1}joinPath(D,...u){return b.URI.joinPath(D,...u)}basenameOrAuthority(D){return(0,e.$Ag)(D)||D.authority}basename(D){return f.$gc.basename(D.path)}extname(D){return f.$gc.extname(D.path)}dirname(D){if(D.path.length===0)return D;let u;return D.scheme===F.Schemas.file?u=b.URI.file(f.$mc(m(D))).path:(u=f.$gc.dirname(D.path),D.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),u="/")),D.with({path:u})}normalizePath(D){if(!D.path.length)return D;let u;return D.scheme===F.Schemas.file?u=b.URI.file(f.$hc(m(D))).path:u=f.$gc.normalize(D.path),D.with({path:u})}relativePath(D,u){if(D.scheme!==u.scheme||!(0,e.$Ig)(D.authority,u.authority))return;if(D.scheme===F.Schemas.file){const n=f.$lc(m(D),m(u));return A.$c?E.$Xf(n):n}let g=D.path||"/";const o=u.path||"/";if(this.a(D)){let n=0;for(const i=Math.min(g.length,o.length);n<i&&!(g.charCodeAt(n)!==o.charCodeAt(n)&&g.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);g=o.substr(0,n)+g.substr(n)}return f.$gc.relative(g,o)}resolvePath(D,u){if(D.scheme===F.Schemas.file){const g=b.URI.file(f.$kc(m(D),u));return D.with({authority:g.authority,path:g.path})}return u=E.$Yf(u),D.with({path:f.$gc.resolve(D.path,u)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,u){return D===u||D!==void 0&&u!==void 0&&(0,M.$8e)(D,u)}hasTrailingPathSeparator(D,u=f.sep){if(D.scheme===F.Schemas.file){const g=m(D);return g.length>E.$Zf(g).length&&g[g.length-1]===u}else{const g=D.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,u=f.sep){return(0,e.$Jg)(D,u)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,u=f.sep){let g=!1;if(D.scheme===F.Schemas.file){const o=m(D);g=o!==void 0&&o.length===E.$Zf(o).length&&o[o.length-1]===u}else{u="/";const o=D.path;g=o.length===1&&o.charCodeAt(o.length-1)===47}return!g&&!(0,e.$Jg)(D,u)?D.with({path:D.path+"/"}):D}}e.$sg=w,e.$tg=new w(()=>!1),e.$ug=new w(y=>y.scheme===F.Schemas.file?!A.$e:!0),e.$vg=new w(y=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function L(y,D){const u=[];for(let g=0;g<y.length;g++){const o=D(y[g]);y.some((n,i)=>i===g?!1:(0,e.$xg)(o,D(n)))||u.push(y[g])}return u}e.$Mg=L;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function D(u){const g=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(i=>{const[s,a]=i.split(":");s&&a&&g.set(s,a)});const n=u.path.substring(0,u.path.indexOf(";"));return n&&g.set(y.META_DATA_MIME,n),g}y.parseMetaData=D})(I||(e.DataUri=I={}));function $(y,D,u){if(D){let g=y.path;return g&&g[0]!==f.$gc.sep&&(g=f.$gc.sep+g),y.with({scheme:u,authority:D,path:g})}return y.with({scheme:u})}e.$Ng=$}),define(Se[10],ke([1,0,21,8,4,3,23,9,164,43]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function L(Y){return!!Y&&typeof Y.then=="function"}e.$Og=L;function I(Y){const X=new E.$3d,Q=Y(X.token),te=new Promise(($e,ve)=>{const Le=X.token.onCancellationRequested(()=>{Le.dispose(),X.dispose(),ve(new F.$5)});Promise.resolve(Q).then(pe=>{Le.dispose(),X.dispose(),$e(pe)},pe=>{Le.dispose(),X.dispose(),ve(pe)})});return new class{cancel(){X.cancel()}then($e,ve){return te.then($e,ve)}catch($e){return this.then(void 0,$e)}finally($e){return te.finally($e)}}}e.$Pg=I;function $(Y,X,Q){return new Promise((te,$e)=>{const ve=X.onCancellationRequested(()=>{ve.dispose(),te(Q)});Y.then(te,$e).finally(()=>ve.dispose())})}e.$Qg=$;function y(Y,X){return new Promise((Q,te)=>{const $e=X.onCancellationRequested(()=>{$e.dispose(),te(new F.$5)});Y.then(Q,te).finally(()=>$e.dispose())})}e.$Rg=y;async function D(Y){let X=-1;const Q=Y.map((te,$e)=>te.then(ve=>(X=$e,ve)));try{return await Promise.race(Q)}finally{Y.forEach((te,$e)=>{$e!==X&&te.cancel()})}}e.$Sg=D;function u(Y,X,Q){let te;const $e=setTimeout(()=>{te?.(void 0),Q?.()},X);return Promise.race([Y.finally(()=>clearTimeout($e)),new Promise(ve=>te=ve)])}e.$Tg=u;function g(Y){return new Promise((X,Q)=>{const te=Y();L(te)?te.then(X,Q):X(te)})}e.$Ug=g;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const Q=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(Q,Q).then(te)})}return new Promise((Q,te)=>{this.b.then(Q,te)})}return this.a=X(),new Promise((Q,te)=>{this.a.then($e=>{this.a=null,Q($e)},$e=>{this.a=null,te($e)})})}dispose(){this.f=!0}}e.$Vg=o;class n{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Wg=n;class i{constructor(){this.a=new Map}queue(X,Q){const $e=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(X)===$e&&this.a.delete(X)});return this.a.set(X,$e),$e}}e.$Xg=i;const s=(Y,X)=>{let Q=!0;const te=setTimeout(()=>{Q=!1,X()},Y);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(te),Q=!1}}},a=Y=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,Y())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class t{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,Q=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise(($e,ve)=>{this.d=$e,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=Q===m.$Pd?a(te):s(Q,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=t;class r{constructor(X){this.a=new t(X),this.b=new o}trigger(X,Q){return this.a.trigger(()=>this.b.queue(X),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=r;class d{constructor(){this.a=!1,this.b=new Promise((X,Q)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=d;class l extends d{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$2g=l;function h(Y,X){return X?new Promise((Q,te)=>{const $e=setTimeout(()=>{ve.dispose(),Q()},Y),ve=X.onCancellationRequested(()=>{clearTimeout($e),ve.dispose(),te(new F.$5)})}):I(Q=>h(Y,Q))}e.$3g=h;function c(Y,X=0,Q){const te=setTimeout(()=>{Y(),Q&&$e.dispose()},X),$e=(0,A.$Qc)(()=>{clearTimeout(te),Q?.deleteAndLeak($e)});return Q?.add($e),$e}e.$4g=c;function v(Y){const X=[];let Q=0;const te=Y.length;function $e(){return Q<te?Y[Q++]():null}function ve(Le){Le!=null&&X.push(Le);const pe=$e();return pe?pe.then(ve):Promise.resolve(X)}return Promise.resolve(null).then(ve)}e.$5g=v;function P(Y,X=te=>!!te,Q=null){let te=0;const $e=Y.length,ve=()=>{if(te>=$e)return Promise.resolve(Q);const Le=Y[te++];return Promise.resolve(Le()).then(De=>X(De)?Promise.resolve(De):ve())};return ve()}e.$6g=P;function S(Y,X=te=>!!te,Q=null){if(Y.length===0)return Promise.resolve(Q);let te=Y.length;const $e=()=>{te=-1;for(const ve of Y)ve.cancel?.()};return new Promise((ve,Le)=>{for(const pe of Y)pe.then(De=>{--te>=0&&X(De)?($e(),ve(De)):te===0&&ve(Q)}).catch(De=>{--te>=0&&($e(),Le(De))})})}e.$7g=S;class p{constructor(X){this.a=0,this.d=X,this.f=[],this.b=0,this.g=new f.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(X){return this.a++,new Promise((Q,te)=>{this.f.push({factory:X,c:Q,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const X=this.f.shift();this.b++;const Q=X.factory();Q.then(X.c,X.e),Q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=p;class k extends p{constructor(){super(1)}}e.$9g=k;class C{constructor(){this.a=new K,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$0g=C;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new _;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueFor(X,Q=M.$tg){const te=Q.getComparisonKey(X);let $e=this.a.get(te);if(!$e){$e=new k;const ve=this.f++,Le=f.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$2c),this.d.set(ve,Le),this.a.set(te,$e)}return $e}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=j;class z{constructor(X,Q){this.a=-1,typeof X=="function"&&typeof Q=="number"&&this.setIfNotSet(X,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},Q)}setIfNotSet(X,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},Q))}}e.$_g=z;class O{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,Q,te=globalThis){this.cancel();const $e=te.setInterval(()=>{X()},Q);this.d=(0,A.$Qc)(()=>{te.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$ah=O;class U{constructor(X,Q){this.b=-1,this.a=X,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=U;class N{constructor(X,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=X,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=N;class R extends U{constructor(X,Q){super(X,Q),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$dh=R;class T extends A.$Sc{constructor(X,Q){super(),this.g=X,this.h=Q,this.a=[],this.b=this.B(new A.$Tc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of X)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=T,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(Y,X)=>{(0,b.$v)(()=>{if(Q)return;const te=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$gh=(Y,X,Q)=>{const te=Y.requestIdleCallback(X,typeof Q=="number"?{timeout:Q}:void 0);let $e=!1;return{dispose(){$e||($e=!0,Y.cancelIdleCallback(te))}}},e.$fh=Y=>(0,e.$gh)(globalThis,Y)}();class q{constructor(X,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$gh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=q;class ee extends q{constructor(X){super(globalThis,X)}}e.$ih=ee;async function J(Y,X,Q){let te;for(let $e=0;$e<Q;$e++)try{return await Y()}catch(ve){te=ve,await h(X)}throw te}e.$jh=J;class K{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,Q,te){return this.a={taskId:X,cancel:()=>te?.(),promise:Q},Q.then(()=>this.d(X),()=>this.d(X)),Q}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{let Q,te;const $e=new Promise((ve,Le)=>{Q=ve,te=Le});this.b={run:X,promise:$e,promiseResolve:Q,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=K;class Z{constructor(X,Q=()=>Date.now()){this.d=X,this.f=Q,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$lh=Z;var ae;(function(Y){Y[Y.Resolved=0]="Resolved",Y[Y.Rejected=1]="Rejected"})(ae||(ae={}));class _{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((X,Q)=>{this.a=X,this.b=Q})}complete(X){return new Promise(Q=>{this.a(X),this.d={outcome:0,value:X},Q()})}error(X){return new Promise(Q=>{this.b(X),this.d={outcome:1,value:X},Q()})}cancel(){return this.error(new F.$5)}}e.$mh=_;var ye;(function(Y){async function X(te){let $e;const ve=await Promise.all(te.map(Le=>Le.then(pe=>pe,pe=>{$e||($e=pe)})));if(typeof $e<"u")throw $e;return ve}Y.settled=X;function Q(te){return new Promise(async($e,ve)=>{try{await te($e,ve)}catch(Le){ve(Le)}})}Y.withAsyncBody=Q})(ye||(e.Promises=ye={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=ge;class re{constructor(X){this.b=X,this.a=new w.$V(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=re;var W;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(W||(W={}));class ce{static fromArray(X){return new ce(Q=>{Q.emitMany(X)})}static fromPromise(X){return new ce(async Q=>{Q.emitMany(await X)})}static fromPromises(X){return new ce(async Q=>{await Promise.all(X.map(async te=>Q.emitOne(await te)))})}static merge(X){return new ce(async Q=>{await Promise.all(X.map(async te=>{for await(const $e of te)Q.emitOne($e)}))})}constructor(X){this.a=0,this.b=[],this.d=null,this.f=new f.$Sd,queueMicrotask(async()=>{const Q={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(X(Q)),this.j()}catch(te){this.k(te)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(X,Q){return new ce(async te=>{for await(const $e of X)te.emitOne(Q($e))})}map(X){return ce.map(this,X)}static filter(X,Q){return new ce(async te=>{for await(const $e of X)Q($e)&&te.emitOne($e)})}filter(X){return ce.filter(this,X)}static coalesce(X){return ce.filter(X,Q=>!!Q)}coalesce(){return ce.coalesce(this)}static async toPromise(X){const Q=[];for await(const te of X)Q.push(te);return Q}toPromise(){return ce.toPromise(this)}g(X){this.a===0&&(this.b.push(X),this.f.fire())}h(X){this.a===0&&(this.b=this.b.concat(X),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(X){this.a===0&&(this.a=2,this.d=X,this.f.fire())}}e.$ph=ce,ce.EMPTY=ce.fromArray([]);class me extends ce{constructor(X,Q){super(Q),this.l=X}cancel(){this.l.cancel()}}e.$qh=me;function le(Y){const X=new E.$3d,Q=Y(X.token);return new me(X,async te=>{const $e=X.token.onCancellationRequested(()=>{$e.dispose(),X.dispose(),te.reject(new F.$5)});try{for await(const ve of Q){if(X.token.isCancellationRequested)return;te.emitOne(ve)}$e.dispose(),X.dispose()}catch(ve){$e.dispose(),X.dispose(),te.reject(ve)}})}e.$rh=le;class de{constructor(){this.a=new _,this.b=new ce(te=>{if(X){te.reject(X);return}return Q&&te.emitMany(Q),this.d=$e=>te.reject($e),this.f=$e=>te.emitOne($e),this.a.p});let X,Q;this.f=te=>{Q||(Q=[]),Q.push(te)},this.d=te=>{X||(X=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$sh=de}),define(Se[34],ke([1,0,19,10,33,28,16,9,13]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function w(){return Object.create(null)}e.$Dj=w,e.$Ej="**",e.$Fj="/";const L="[/\\\\]",I="[^/\\\\]",$=/\//g;function y(ee,J){switch(ee){case 0:return"";case 1:return`${I}*?`;default:return`(?:${L}|${I}+${L}${J?`|${L}${I}+`:""})*?`}}function D(ee,J){if(!ee)return[];const K=[];let Z=!1,ae=!1,_="";for(const ye of ee){switch(ye){case J:if(!Z&&!ae){K.push(_),_="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}_+=ye}return _&&K.push(_),K}e.$Gj=D;function u(ee){if(!ee)return"";let J="";const K=D(ee,e.$Fj);if(K.every(Z=>Z===e.$Ej))J=".*";else{let Z=!1;K.forEach((ae,_)=>{if(ae===e.$Ej){if(Z)return;J+=y(2,_===K.length-1)}else{let ye=!1,ge="",re=!1,W="";for(const ce of ae){if(ce!=="}"&&ye){ge+=ce;continue}if(re&&(ce!=="]"||!W)){let me;ce==="-"?me=ce:(ce==="^"||ce==="!")&&!W?me="^":ce===e.$Fj?me="":me=(0,m.$Ke)(ce),W+=me;continue}switch(ce){case"{":ye=!0;continue;case"[":re=!0;continue;case"}":{const le=`(?:${D(ge,",").map(de=>u(de)).join("|")})`;J+=le,ye=!1,ge="";break}case"]":{J+="["+W+"]",re=!1,W="";break}case"?":J+=I;continue;case"*":J+=y(1);continue;default:J+=(0,m.$Ke)(ce)}}_<K.length-1&&(K[_+1]!==e.$Ej||_+2<K.length)&&(J+=L)}Z=ae===e.$Ej})}return J}const g=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),r=function(){return!1},d=function(){return null};function l(ee,J){if(!ee)return d;let K;typeof ee!="string"?K=ee.pattern:K=ee,K=K.trim();const Z=`${K}_${!!J.trimForExclusions}`;let ae=t.get(Z);if(ae)return h(ae,ee);let _;return g.test(K)?ae=v(K.substr(4),K):(_=o.exec(c(K,J)))?ae=P(_[1],K):(J.trimForExclusions?i:n).test(K)?ae=S(K,J):(_=s.exec(c(K,J)))?ae=p(_[1].substr(1),K,!0):(_=a.exec(c(K,J)))?ae=p(_[1],K,!1):ae=k(K),t.set(Z,ae),h(ae,ee)}function h(ee,J){if(typeof J=="string")return ee;const K=function(Z,ae){return(0,f.$4f)(Z,J.base,!b.$e)?ee((0,m.$Pe)(Z.substr(J.base.length),M.sep),ae):null};return K.allBasenames=ee.allBasenames,K.allPaths=ee.allPaths,K.basenames=ee.basenames,K.patterns=ee.patterns,K}function c(ee,J){return J.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function v(ee,J){return function(K,Z){return typeof K=="string"&&K.endsWith(ee)?J:null}}function P(ee,J){const K=`/${ee}`,Z=`\\${ee}`,ae=function(ye,ge){return typeof ye!="string"?null:ge?ge===ee?J:null:ye===ee||ye.endsWith(K)||ye.endsWith(Z)?J:null},_=[ee];return ae.basenames=_,ae.patterns=[J],ae.allBasenames=_,ae}function S(ee,J){const K=T(ee.slice(1,-1).split(",").map(ge=>l(ge,J)).filter(ge=>ge!==d),ee),Z=K.length;if(!Z)return d;if(Z===1)return K[0];const ae=function(ge,re){for(let W=0,ce=K.length;W<ce;W++)if(K[W](ge,re))return ee;return null},_=K.find(ge=>!!ge.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ye=K.reduce((ge,re)=>re.allPaths?ge.concat(re.allPaths):ge,[]);return ye.length&&(ae.allPaths=ye),ae}function p(ee,J,K){const Z=M.sep===M.$gc.sep,ae=Z?ee:ee.replace($,M.sep),_=M.sep+ae,ye=M.$gc.sep+ee;let ge;return K?ge=function(re,W){return typeof re=="string"&&(re===ae||re.endsWith(_)||!Z&&(re===ee||re.endsWith(ye)))?J:null}:ge=function(re,W){return typeof re=="string"&&(re===ae||!Z&&re===ee)?J:null},ge.allPaths=[(K?"*/":"./")+ee],ge}function k(ee){try{const J=new RegExp(`^${u(ee)}$`);return function(K){return J.lastIndex=0,typeof K=="string"&&J.test(K)?ee:null}}catch{return d}}function C(ee,J,K){return!ee||typeof J!="string"?!1:j(ee)(J,void 0,K)}e.$Hj=C;function j(ee,J={}){if(!ee)return r;if(typeof ee=="string"||z(ee)){const K=l(ee,J);if(K===d)return r;const Z=function(ae,_){return!!K(ae,_)};return K.allBasenames&&(Z.allBasenames=K.allBasenames),K.allPaths&&(Z.allPaths=K.allPaths),Z}return N(ee,J)}e.$Ij=j;function z(ee){const J=ee;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$Jj=z;function O(ee){return ee.allBasenames||[]}e.$Kj=O;function U(ee){return ee.allPaths||[]}e.$Lj=U;function N(ee,J){const K=T(Object.getOwnPropertyNames(ee).map(ge=>R(ge,ee[ge],J)).filter(ge=>ge!==d)),Z=K.length;if(!Z)return d;if(!K.some(ge=>!!ge.requiresSiblings)){if(Z===1)return K[0];const ge=function(ce,me){let le;for(let de=0,Y=K.length;de<Y;de++){const X=K[de](ce,me);if(typeof X=="string")return X;(0,F.$Og)(X)&&(le||(le=[]),le.push(X))}return le?(async()=>{for(const de of le){const Y=await de;if(typeof Y=="string")return Y}return null})():null},re=K.find(ce=>!!ce.allBasenames);re&&(ge.allBasenames=re.allBasenames);const W=K.reduce((ce,me)=>me.allPaths?ce.concat(me.allPaths):ce,[]);return W.length&&(ge.allPaths=W),ge}const ae=function(ge,re,W){let ce,me;for(let le=0,de=K.length;le<de;le++){const Y=K[le];Y.requiresSiblings&&W&&(re||(re=(0,M.$nc)(ge)),ce||(ce=re.substr(0,re.length-(0,M.$oc)(ge).length)));const X=Y(ge,re,ce,W);if(typeof X=="string")return X;(0,F.$Og)(X)&&(me||(me=[]),me.push(X))}return me?(async()=>{for(const le of me){const de=await le;if(typeof de=="string")return de}return null})():null},_=K.find(ge=>!!ge.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ye=K.reduce((ge,re)=>re.allPaths?ge.concat(re.allPaths):ge,[]);return ye.length&&(ae.allPaths=ye),ae}function R(ee,J,K){if(J===!1)return d;const Z=l(ee,K);if(Z===d)return d;if(typeof J=="boolean")return Z;if(J){const ae=J.when;if(typeof ae=="string"){const _=(ye,ge,re,W)=>{if(!W||!Z(ye,ge))return null;const ce=ae.replace("$(basename)",()=>re),me=W(ce);return(0,F.$Og)(me)?me.then(le=>le?ee:null):me?ee:null};return _.requiresSiblings=!0,_}}return Z}function T(ee,J){const K=ee.filter(ge=>!!ge.basenames);if(K.length<2)return ee;const Z=K.reduce((ge,re)=>{const W=re.basenames;return W?ge.concat(W):ge},[]);let ae;if(J){ae=[];for(let ge=0,re=Z.length;ge<re;ge++)ae.push(J)}else ae=K.reduce((ge,re)=>{const W=re.patterns;return W?ge.concat(W):ge},[]);const _=function(ge,re){if(typeof ge!="string")return null;if(!re){let ce;for(ce=ge.length;ce>0;ce--){const me=ge.charCodeAt(ce-1);if(me===47||me===92)break}re=ge.substr(ce)}const W=Z.indexOf(re);return W!==-1?ae[W]:null};_.basenames=Z,_.patterns=ae,_.allBasenames=Z;const ye=ee.filter(ge=>!ge.basenames);return ye.push(_),ye}function q(ee,J){return(0,E.$ub)(ee,J,(K,Z)=>typeof K=="string"&&typeof Z=="string"?K===Z:typeof K!="string"&&typeof Z!="string"?K.base===Z.base&&K.pattern===Z.pattern:!1)}e.$Mj=q}),define(Se[79],ke([1,0,8,165,23,13,2]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class m{constructor(o="",n=!1){if(this.value=o,typeof this.value!="string")throw(0,E.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(o,n=0){return this.value+=$(this.supportThemeIcons?(0,F.$0j)(o):o).replace(/([ \t]+)/g,(i,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,n){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(o,n,i){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(o),")"),i&&(this.value+=` "${this.c(this.c(i,'"'),")")}"`),this.value+=")",this}c(o,n){const i=new RegExp((0,A.$Ke)(n),"g");return o.replace(i,(s,a)=>o.charAt(a-1)!=="\\"?`\\${s}`:s)}}e.$dk=m;function w(g){return L(g)?!g.value:Array.isArray(g)?g.every(w):!0}e.$ek=w;function L(g){return g instanceof m?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||typeof g.isTrusted=="object"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.$fk=L;function I(g,o){return g===o?!0:!g||!o?!1:g.value===o.value&&g.isTrusted===o.isTrusted&&g.supportThemeIcons===o.supportThemeIcons&&g.supportHtml===o.supportHtml&&(g.baseUri===o.baseUri||!!g.baseUri&&!!o.baseUri&&(0,f.$wg)(M.URI.from(g.baseUri),M.URI.from(o.baseUri)))}e.$gk=I;function $(g){return g.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$hk=$;function y(g){return g.replace(/"/g,"&quot;")}e.$ik=y;function D(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$jk=D;function u(g){const o=[],n=g.split("|").map(s=>s.trim());g=n[0];const i=n[1];if(i){const s=/height=(\d+)/.exec(i),a=/width=(\d+)/.exec(i),t=s?s[1]:"",r=a?a[1]:"",d=isFinite(parseInt(r)),l=isFinite(parseInt(t));d&&o.push(`width="${r}"`),l&&o.push(`height="${t}"`)}return{href:g,dimensions:o}}e.$kk=u}),define(Se[101],ke([1,0,19,33,16,9,23,13]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=void 0;function m(l,h){const{os:c,tildify:v,relative:P}=h;if(P){const k=w(l,P,c);if(typeof k=="string")return k}let S=l.fsPath;if(c===1&&!A.$c?S=S.replace(/\//g,"\\"):c!==1&&A.$c&&(S=S.replace(/\\/g,"/")),c!==1&&v?.userHome){const k=v.userHome.fsPath;let C;l.scheme!==v.userHome.scheme&&l.path[0]===f.$gc.sep&&l.path[1]!==f.$gc.sep?C=v.userHome.with({path:l.path}).fsPath:C=S,S=$(C,k,c)}return(c===1?f.$fc:f.$gc).normalize(L(S,c===1))}e.$Hv=m;function w(l,h,c){const v=c===1?f.$fc:f.$gc,P=c===3?M.$tg:M.$vg,S=h.getWorkspace(),p=(0,E.$Ob)(S.folders);if(!p)return;l.scheme!==p.uri.scheme&&l.path[0]===f.$gc.sep&&l.path[1]!==f.$gc.sep&&(l=p.uri.with({path:l.path}));const k=h.getWorkspaceFolder(l);if(!k)return;let C;if(P.isEqual(k.uri,l)?C="":C=P.relativePath(k.uri,l)??"",C&&(C=v.normalize(C)),S.folders.length>1&&!h.noPrefix){const j=k.name?k.name:P.basenameOrAuthority(k.uri);C=C?`${j} \u2022 ${C}`:j}return C}function L(l,h=A.$c){return(0,F.$8f)(l,h)?l.charAt(0).toUpperCase()+l.slice(1):l}e.$Iv=L;let I=Object.create(null);function $(l,h,c=A.OS){if(c===1||!l||!h)return l;let v=I.original===h?I.normalized:void 0;v||(v=h,A.$c&&(v=(0,F.$Xf)(v)),v=`${(0,b.$Qe)(v,f.$gc.sep)}${f.$gc.sep}`,I={original:h,normalized:v});let P=l;return A.$c&&(P=(0,F.$Xf)(P)),(c===3?P.startsWith(v):(0,b.$9e)(P,v))?`~/${P.substr(v.length)}`:l}e.$Jv=$;function y(l,h){return l.replace(/^~($|\/|\\)/,`${h}$1`)}e.$Kv=y;const D="\u2026",u="\\\\",g="~";function o(l,h=f.sep){const c=new Array(l.length);let v=!1;for(let P=0;P<l.length;P++){const S=l[P];if(S===""){c[P]=`.${h}`;continue}if(!S){c[P]=S;continue}v=!0;let p="",k=S;k.indexOf(u)===0?(p=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(h)===0?(p=k.substr(0,k.indexOf(h)+h.length),k=k.substr(k.indexOf(h)+h.length)):k.indexOf(g)===0&&(p=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length));const C=k.split(h);for(let j=1;v&&j<=C.length;j++)for(let z=C.length-j;v&&z>=0;z--){v=!1;let O=C.slice(z,z+j).join(h);for(let U=0;!v&&U<l.length;U++)if(U!==P&&l[U]&&l[U].indexOf(O)>-1){const N=z+j===C.length,R=z>0&&l[U].indexOf(h)>-1?h+O:O,T=l[U].endsWith(R);v=!N||T}if(!v){let U="";(C[0].endsWith(":")||p!=="")&&(z===1&&(z=0,j++,O=C[0]+h+O),z>0&&(U=C[0]+h),U=p+U),z>0&&(U=U+D+h),U=U+O,z+j<C.length&&(U=U+h+D),c[P]=U}}v&&(c[P]=S)}return c}e.$Lv=o;var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,h=Object.create(null)){const c=[];let v=!1,P="";for(const S of l)if(S==="$"||v&&S==="{")P&&c.push({value:P,type:n.TEXT}),P="",v=!0;else if(S==="}"&&v){const p=h[P];if(typeof p=="string")p.length&&c.push({value:p,type:n.VARIABLE});else if(p){const k=c[c.length-1];(!k||k.type!==n.SEPARATOR)&&c.push({value:p.label,type:n.SEPARATOR})}P="",v=!1}else P+=S;return P&&!v&&c.push({value:P,type:n.TEXT}),c.filter((S,p)=>{if(S.type===n.SEPARATOR){const k=c[p-1],C=c[p+1];return[k,C].every(j=>j&&(j.type===n.VARIABLE||j.type===n.TEXT)&&j.value.length>0)}return!0}).map(S=>S.value).join("")}e.$Mv=i;function s(l,h){return A.$d||h?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$d?"&":"&&"):l.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.$Nv=s;function a(l,h){return A.$d||h?l.replace(/\(&&\w\)|&&/g,""):A.$c?l.replace(/&&|&/g,c=>c==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.$Ov=a;function t(l){return l.replace(/&/g,"&&")}e.$Pv=t;function r(l){if(l.endsWith("]")){const h=l.lastIndexOf(" [",l.length-2);if(h!==-1){const c=d(l.substring(0,h));return{name:c.name,parentPath:c.parentPath+l.substring(h)}}}return d(l)}e.$Qv=r;function d(l){const h=l.indexOf("/")!==-1?f.$gc:f.$fc,c=h.basename(l),v=h.dirname(l);return c.length?{name:c,parentPath:v}:{name:v,parentPath:""}}}),define(Se[128],ke([1,0,22,2]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=void 0;function f(I){return I.toJSON()}class A{constructor($){this.a=$}transformIncoming($){const y=this.a.transformIncoming($);return y===$?$:f(F.URI.from(y))}transformOutgoing($){const y=this.a.transformOutgoing($);return y===$?$:f(F.URI.from(y))}transformOutgoingURI($){const y=this.a.transformOutgoing($);return y===$?$:F.URI.from(y)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Zm=A,e.$1m=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function M(I,$,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return $.transformOutgoing(I);for(const D in I)if(Object.hasOwnProperty.call(I,D)){const u=M(I[D],$,y+1);u!==null&&(I[D]=u)}}return null}function b(I,$){const y=M(I,$,0);return y===null?I:y}e.$2m=b;function m(I,$,y,D){if(!I||D>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?F.URI.revive($.transformIncoming(I)):$.transformIncoming(I);if(I instanceof E.$ge)return null;for(const u in I)if(Object.hasOwnProperty.call(I,u)){const g=m(I[u],$,y,D+1);g!==null&&(I[u]=g)}}return null}function w(I,$){const y=m(I,$,!1,0);return y===null?I:y}e.$3m=w;function L(I,$){const y=m(I,$,!0,0);return y===null?I:y}e.$4m=L}),define(Se[30],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(f){return E.test(f)}e.$lg=F,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(b){for(let m=0;m<b.length;m++)b[m]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){f(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let m=0,w="";return w+=M[A[m++]],w+=M[A[m++]],w+=M[A[m++]],w+=M[A[m++]],w+="-",w+=M[A[m++]],w+=M[A[m++]],w+="-",w+=M[A[m++]],w+=M[A[m++]],w+="-",w+=M[A[m++]],w+=M[A[m++]],w+="-",w+=M[A[m++]],w+=M[A[m++]],w+=M[A[m++]],w+=M[A[m++]],w+=M[A[m++]],w+=M[A[m++]],w}}()}),define(Se[168],ke([1,0,19,52,30]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.$at=void 0;function A(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$at=A;function M(I,$,y){const D={id:(0,f.$mg)(),name:I,uri:$,data:y};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$bt=M;class b{constructor(){this.a=new Map}get size(){let $=0;for(const y of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const y=[...this.a.keys()];return F.Iterable.some(this,([D,u])=>u.asFile())&&y.push("files"),L(m($),y)}get($){return this.a.get(this.b($))?.[0]}append($,y){const D=this.a.get($);D?D.push(y):this.a.set(this.b($),[y])}replace($,y){this.a.set(this.b($),[y])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,y]of this.a)for(const D of y)yield[$,D]}b($){return m($)}}e.$ct=b;function m(I){return I.toLowerCase()}function w(I,$){return L(m(I),$.map(m))}e.$dt=w;function L(I,$){if(I==="*/*")return $.length>0;if($.includes(I))return!0;const y=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[D,u,g]=y;return g==="*"?$.some(o=>o.startsWith(u+"/")):!1}e.$et=Object.freeze({create:I=>(0,E.$Mb)(I.map($=>$.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$et.split(I).filter($=>!$.startsWith("#"))})}),define(Se[31],ke([1,0,55,62,384,10,33,76,16,9,23,2]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(R){R[R.UNLINK=0]="UNLINK",R[R.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function y(R,T=$.UNLINK,q){if((0,M.$7f)(R))throw new Error("rimraf - will refuse to recursively delete root");return T===$.UNLINK?u(R):D(R,q)}async function D(R,T=(0,M.$_f)((0,F.tmpdir)())){try{try{await E.promises.rename(R,T)}catch(q){return q.code==="ENOENT"?void 0:u(R)}u(T).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function u(R){return(0,f.promisify)(E.rm)(R,{recursive:!0,force:!0,maxRetries:3})}function g(R){if((0,M.$7f)(R))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(R,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function o(R,T){return s(await(T?n(R):(0,f.promisify)(E.readdir)(R)))}async function n(R){try{return await(0,f.promisify)(E.readdir)(R,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const T=[],q=await o(R);for(const ee of q){let J=!1,K=!1,Z=!1;try{const ae=await e.Promises.lstat((0,m.$jc)(R,ee));J=ae.isFile(),K=ae.isDirectory(),Z=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}T.push({name:ee,isFile:()=>J,isDirectory:()=>K,isSymbolicLink:()=>Z})}return T}function i(R){return s(E.readdirSync(R))}e.readdirSync=i;function s(R){return R.map(T=>typeof T=="string"?w.$d?(0,b.$Cl)(T):T:(T.name=w.$d?(0,b.$Cl)(T.name):T.name,T))}async function a(R){const T=await o(R),q=[];for(const ee of T)await r.existsDirectory((0,m.$jc)(R,ee))&&q.push(ee);return q}function t(R,T=1e3){return new Promise(q=>{let ee=!1;const J=setInterval(()=>{ee||(ee=!0,E.access(R,K=>{ee=!1,K&&(clearInterval(J),q(void 0))}))},T)})}e.whenDeleted=t;var r;(function(R){async function T(J){let K;try{if(K=await e.Promises.lstat(J),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(w.$c&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw ae}throw Z}}R.stat=T;async function q(J){try{const{stat:K,symbolicLink:Z}=await R.stat(J);return K.isFile()&&Z?.dangling!==!0}catch{}return!1}R.existsFile=q;async function ee(J){try{const{stat:K,symbolicLink:Z}=await R.stat(J);return K.isDirectory()&&Z?.dangling!==!0}catch{}return!1}R.existsDirectory=ee})(r||(e.SymlinkSupport=r={}));const d=new A.$$g;function l(R,T,q){return d.queueFor(I.URI.file(R),L.$ug).queue(()=>{const ee=S(q);return new Promise((J,K)=>v(R,T,ee,Z=>Z?K(Z):J()))})}let h=!0;function c(R){h=R}e.configureFlushOnWrite=c;function v(R,T,q,ee){if(!h)return E.writeFile(R,T,{mode:q.mode,flag:q.flag},ee);E.open(R,q.flag,q.mode,(J,K)=>{if(J)return ee(J);E.writeFile(K,T,Z=>{if(Z)return E.close(K,()=>ee(Z));E.fdatasync(K,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),c(!1)),E.close(K,_=>ee(_))))})})}function P(R,T,q){const ee=S(q);if(!h)return E.writeFileSync(R,T,{mode:ee.mode,flag:ee.flag});const J=E.openSync(R,ee.flag,ee.mode);try{E.writeFileSync(J,T);try{E.fdatasyncSync(J)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),c(!1)}}finally{E.closeSync(J)}}e.writeFileSync=P;function S(R){return R?{mode:typeof R.mode=="number"?R.mode:438,flag:typeof R.flag=="string"?R.flag:"w"}:{mode:438,flag:"w"}}async function p(R,T,q=6e4){if(R!==T)try{w.$c&&typeof q=="number"?await k(R,T,Date.now(),q):await(0,f.promisify)(E.rename)(R,T)}catch(ee){if(R.toLowerCase()!==T.toLowerCase()&&ee.code==="EXDEV"||R.endsWith("."))await C(R,T,{preserveSymlinks:!1}),await y(R,$.MOVE);else throw ee}}async function k(R,T,q,ee,J=0){try{return await(0,f.promisify)(E.rename)(R,T)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-q>=ee)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${K}`),K;if(J===0){let Z=!1;try{const{stat:ae}=await r.stat(T);ae.isFile()||(Z=!0)}catch{}if(Z)throw K}return await(0,A.$3g)(Math.min(100,J*10)),k(R,T,q,ee,J+1)}}async function C(R,T,q){return z(R,T,{root:{source:R,target:T},options:q,handledSourcePaths:new Set})}const j=511;async function z(R,T,q){if(q.handledSourcePaths.has(R))return;q.handledSourcePaths.add(R);const{stat:ee,symbolicLink:J}=await r.stat(R);if(J){if(q.options.preserveSymlinks)try{return await N(R,T,q)}catch{}if(J.dangling)return}return ee.isDirectory()?O(R,T,ee.mode&j,q):U(R,T,ee.mode&j)}async function O(R,T,q,ee){await e.Promises.mkdir(T,{recursive:!0,mode:q});const J=await o(R);for(const K of J)await z((0,m.$jc)(R,K),(0,m.$jc)(T,K),ee)}async function U(R,T,q){await e.Promises.copyFile(R,T),await e.Promises.chmod(T,q)}async function N(R,T,q){let ee=await e.Promises.readlink(R);(0,M.$4f)(ee,q.root.source,!w.$e)&&(ee=(0,m.$jc)(q.root.target,ee.substr(q.root.source.length+1))),await e.Promises.symlink(ee,T)}e.Promises=new class{get access(){return(0,f.promisify)(E.access)}get stat(){return(0,f.promisify)(E.stat)}get lstat(){return(0,f.promisify)(E.lstat)}get utimes(){return(0,f.promisify)(E.utimes)}get read(){return(R,T,q,ee,J)=>new Promise((K,Z)=>{E.read(R,T,q,ee,J,(ae,_,ye)=>ae?Z(ae):K({bytesRead:_,buffer:ye}))})}get readFile(){return(0,f.promisify)(E.readFile)}get write(){return(R,T,q,ee,J)=>new Promise((K,Z)=>{E.write(R,T,q,ee,J,(ae,_,ye)=>ae?Z(ae):K({bytesWritten:_,buffer:ye}))})}get appendFile(){return(0,f.promisify)(E.appendFile)}get fdatasync(){return(0,f.promisify)(E.fdatasync)}get truncate(){return(0,f.promisify)(E.truncate)}get copyFile(){return(0,f.promisify)(E.copyFile)}get open(){return(0,f.promisify)(E.open)}get close(){return(0,f.promisify)(E.close)}get symlink(){return(0,f.promisify)(E.symlink)}get readlink(){return(0,f.promisify)(E.readlink)}get chmod(){return(0,f.promisify)(E.chmod)}get mkdir(){return(0,f.promisify)(E.mkdir)}get unlink(){return(0,f.promisify)(E.unlink)}get rmdir(){return(0,f.promisify)(E.rmdir)}get realpath(){return(0,f.promisify)(E.realpath)}async exists(R){try{return await e.Promises.access(R),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return l}get rm(){return y}get rename(){return p}get copy(){return C}}}),define(Se[102],ke([1,0,55,16,9,13,31]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=void 0;function b($){if(f.$e)return $;const y=(0,F.$mc)($);if($===y)return $;const D=((0,F.$nc)($)||$).toLowerCase();try{const g=(0,M.readdirSync)(y).filter(o=>o.toLowerCase()===D);if(g.length===1){const o=b(y);if(o)return(0,F.$jc)(o,g[0])}else if(g.length>1){const o=g.indexOf(D);if(o>=0){const n=b(y);if(n)return(0,F.$jc)(n,g[o])}}}catch{}return null}e.$gq=b;async function m($){if(f.$e)return $;const y=(0,F.$mc)($);if($===y)return $;const D=((0,F.$nc)($)||$).toLowerCase();try{const g=(await M.Promises.readdir(y)).filter(o=>o.toLowerCase()===D);if(g.length===1){const o=await m(y);if(o)return(0,F.$jc)(o,g[0])}else if(g.length>1){const o=g.indexOf(D);if(o>=0){const n=await m(y);if(n)return(0,F.$jc)(n,g[o])}}}catch{}return null}e.$hq=m;async function w($){try{return await M.Promises.realpath($)}catch{const D=I($);return await M.Promises.access(D,E.constants.R_OK),D}}e.$iq=w;function L($){try{return E.realpathSync($)}catch{const D=I($);return E.accessSync(D,E.constants.R_OK),D}}e.$jq=L;function I($){return(0,A.$Qe)((0,F.$hc)($),F.sep)}}),define(Se[169],ke([1,0,63]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=e.$og=void 0;function F(b,m,w,L=1){let I=!1;return new Promise($=>{const y=setTimeout(()=>{if(!I)return I=!0,$(0)},w);f(b,m,L,D=>{if(!I)return I=!0,clearTimeout(y),$(D)})})}e.$og=F;function f(b,m,w,L){if(m===0)return L(0);const I=new E.Socket;I.once("connect",()=>(M(I),f(b+w,m-1,w,L))),I.once("data",()=>{}),I.once("error",$=>(M(I),$.code!=="ECONNREFUSED"?f(b+w,m-1,w,L):L(b))),I.connect(b,"127.0.0.1")}e.$pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(b,m,w,L="127.0.0.1"){let I=!1,$,y=1;const D=E.createServer({pauseOnConnect:!0});function u(g,o){I||(I=!0,D.removeAllListeners(),D.close(),$&&clearTimeout($),o(g))}return new Promise(g=>{$=setTimeout(()=>{u(0,g)},w),D.on("listening",()=>{u(b,g)}),D.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&y<m?(b++,y++,D.listen(b,L)):u(0,g)}),D.on("close",()=>{u(0,g)}),D.listen(b,L)})}e.$qg=A;function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(m){console.error(m)}}}),define(Se[103],ke([1,0,16,9,49,99,18,31]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ql=e.$Pl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function m(I=f.env){return I.comspec||"cmd.exe"}e.$Pl=m;function w(I){let $=[],y=!1;const D=function(u){if(y){$.push(u);return}(!I.send(u,o=>{if(o&&console.error(o),y=!1,$.length>0){const n=$.slice(0);$=[],n.forEach(i=>D(i))}})||F.$c)&&(y=!0)};return{send:D}}e.$Ql=w;var L;(function(I){async function $(y,D,u){if(E.$ic(y))return y;if(D===void 0&&(D=f.cwd()),E.$mc(y)!=="."||(u===void 0&&M.$Ef(f.env.PATH)&&(u=f.env.PATH.split(E.$tc)),u===void 0||u.length===0))return E.$jc(D,y);async function o(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(s){s.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of u){let i;if(E.$ic(n)?i=E.$jc(n,y):i=E.$jc(D,n,y),await o(i))return i;let s=i+".com";if(await o(s)||(s=i+".exe",await o(s)))return s}return E.$jc(D,y)}I.findExecutable=$})(L||(e.win32=L={}))});var Qe=this&&this.__decorate||function(ie,e,E,F){var f=arguments.length,A=f<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,E):F,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,E,F);else for(var b=ie.length-1;b>=0;b--)(M=ie[b])&&(A=(f<3?M(A):f>3?M(e,E,A):M(e,E))||A);return f>3&&A&&Object.defineProperty(e,E,A),A};define(Se[80],ke([1,0,19,10,22,21,59,8,4,3,54,13,18]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.ProxyChannel=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.RequestInitiator=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0;var y;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(y||(y={}));function D(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(u||(u={}));function g(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(o||(o={}));function n(J){let K=0;for(let Z=0;;Z+=7){const ae=J.read(1);if(K|=(ae.buffer[0]&127)<<Z,!(ae.buffer[0]&128))return K}}const i=d(0);function s(J,K){if(K===0){J.write(i);return}let Z=0;for(let _=K;_!==0;_=_>>>7)Z++;const ae=f.$ge.alloc(Z);for(let _=0;K!==0;_++)ae.buffer[_]=K&127,K=K>>>7,K>0&&(ae.buffer[_]|=128);J.write(ae)}class a{constructor(K){this.b=K,this.a=0}read(K){const Z=this.b.slice(this.a,this.a+K);return this.a+=Z.byteLength,Z}}e.$zh=a;class t{constructor(){this.a=[]}get buffer(){return f.$ge.concat(this.a)}write(K){this.a.push(K)}}e.$Ah=t;var r;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(r||(r={}));function d(J){const K=f.$ge.alloc(1);return K.writeUInt8(J,0),K}const l={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},h=typeof Buffer<"u";function c(J,K){if(typeof K>"u")J.write(l.Undefined);else if(typeof K=="string"){const Z=f.$ge.fromString(K);J.write(l.String),s(J,Z.byteLength),J.write(Z)}else if(h&&Buffer.isBuffer(K)){const Z=f.$ge.wrap(K);J.write(l.Buffer),s(J,Z.byteLength),J.write(Z)}else if(K instanceof f.$ge)J.write(l.VSBuffer),s(J,K.byteLength),J.write(K);else if(Array.isArray(K)){J.write(l.Array),s(J,K.length);for(const Z of K)c(J,Z)}else if(typeof K=="number"&&(K|0)===K)J.write(l.Uint),s(J,K);else{const Z=f.$ge.fromString(JSON.stringify(K));J.write(l.Object),s(J,Z.byteLength),J.write(Z)}}e.$Bh=c;function v(J){switch(J.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return J.read(n(J)).toString();case r.Buffer:return J.read(n(J)).buffer;case r.VSBuffer:return J.read(n(J));case r.Array:{const Z=n(J),ae=[];for(let _=0;_<Z;_++)ae.push(v(J));return ae}case r.Object:return JSON.parse(J.read(n(J)).toString());case r.Int:return n(J)}}e.$Ch=v;class P{constructor(K,Z,ae=null,_=1e3){this.h=K,this.j=Z,this.k=ae,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ye=>this.q(ye)),this.m({type:200})}registerChannel(K,Z){this.b.set(K,Z),setTimeout(()=>this.w(K),0)}m(K){switch(K.type){case 200:{const Z=this.o([K.type]);this.k?.logOutgoing(Z,0,1,g(K.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([K.type,K.id],K.data);this.k?.logOutgoing(Z,K.id,1,g(K.type),K.data);return}}}o(K,Z=void 0){const ae=new t;return c(ae,K),c(ae,Z),this.p(ae.buffer)}p(K){try{return this.h.send(K),K.byteLength}catch{return 0}}q(K){const Z=new a(K),ae=v(Z),_=v(Z),ye=ae[0];switch(ye){case 100:return this.k?.logIncoming(K.byteLength,ae[1],1,`${D(ye)}: ${ae[2]}.${ae[3]}`,_),this.s({type:ye,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 102:return this.k?.logIncoming(K.byteLength,ae[1],1,`${D(ye)}: ${ae[2]}.${ae[3]}`,_),this.t({type:ye,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 101:return this.k?.logIncoming(K.byteLength,ae[1],1,`${D(ye)}`),this.u({type:ye,id:ae[1]});case 103:return this.k?.logIncoming(K.byteLength,ae[1],1,`${D(ye)}`),this.u({type:ye,id:ae[1]})}}s(K){const Z=this.b.get(K.channelName);if(!Z){this.v(K);return}const ae=new A.$3d;let _;try{_=Z.call(this.j,K.name,K.arg,ae.token)}catch(re){_=Promise.reject(re)}const ye=K.id;_.then(re=>{this.m({id:ye,data:re,type:201})},re=>{re instanceof Error?this.m({id:ye,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split?re.stack.split(`
`):re.stack:void 0},type:202}):this.m({id:ye,data:re,type:203})}).finally(()=>{ge.dispose(),this.d.delete(K.id)});const ge=(0,w.$Qc)(()=>ae.cancel());this.d.set(K.id,ge)}t(K){const Z=this.b.get(K.channelName);if(!Z){this.v(K);return}const ae=K.id,ye=Z.listen(this.j,K.name,K.arg)(ge=>this.m({id:ae,data:ge,type:204}));this.d.set(K.id,ye)}u(K){const Z=this.d.get(K.id);Z&&(Z.dispose(),this.d.delete(K.id))}v(K){let Z=this.g.get(K.channelName);Z||(Z=[],this.g.set(K.channelName,Z));const ae=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.m({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:K,timeoutTimer:ae})}w(K){const Z=this.g.get(K);if(Z){for(const ae of Z)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(K)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=P;var S;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class p{constructor(K,Z=null){this.l=K,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=Z}getChannel(K){const Z=this;return{call(ae,_,ye){return Z.a?Promise.reject(new b.$5):Z.m(K,ae,_,ye)},listen(ae,_){return Z.a?m.Event.None:Z.o(K,ae,_)}}}m(K,Z,ae,_=A.CancellationToken.None){const ye=this.g++,re={id:ye,type:100,channelName:K,name:Z,arg:ae};if(_.isCancellationRequested)return Promise.reject(new b.$5);let W;return new Promise((me,le)=>{if(_.isCancellationRequested)return le(new b.$5);const de=()=>{const te=$e=>{switch($e.type){case 201:this.f.delete(ye),me($e.data);break;case 202:{this.f.delete(ye);const ve=new Error($e.data.message);ve.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,ve.name=$e.data.name,le(ve);break}case 203:this.f.delete(ye),le($e.data);break}};this.f.set(ye,te),this.p(re)};let Y=null;this.b===o.Idle?de():(Y=(0,F.$Pg)(te=>this.u()),Y.then(()=>{Y=null,de()}));const X=()=>{Y?(Y.cancel(),Y=null):this.p({id:ye,type:101}),le(new b.$5)},Q=_.onCancellationRequested(X);W=(0,w.$Pc)((0,w.$Qc)(X),Q),this.d.add(W)}).finally(()=>{W.dispose(),this.d.delete(W)})}o(K,Z,ae){const _=this.g++,ge={id:_,type:102,channelName:K,name:Z,arg:ae};let re=null;const W=new m.$Sd({onWillAddFirstListener:()=>{re=(0,F.$Pg)(me=>this.u()),re.then(()=>{re=null,this.d.add(W),this.p(ge)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(W),this.p({id:_,type:103}))}}),ce=me=>W.fire(me.data);return this.f.set(_,ce),W.event}p(K){switch(K.type){case 100:case 102:{const Z=this.q([K.type,K.id,K.channelName,K.name],K.arg);this.j?.logOutgoing(Z,K.id,0,`${D(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const Z=this.q([K.type,K.id]);this.j?.logOutgoing(Z,K.id,0,D(K.type));return}}}q(K,Z=void 0){const ae=new t;return c(ae,K),c(ae,Z),this.r(ae.buffer)}r(K){try{return this.l.send(K),K.byteLength}catch{return 0}}s(K){const Z=new a(K),ae=v(Z),_=v(Z),ye=ae[0];switch(ye){case 200:return this.j?.logIncoming(K.byteLength,0,0,g(ye)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(K.byteLength,ae[1],0,g(ye),_),this.t({type:ae[0],id:ae[1],data:_})}}t(K){if(K.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(K.id)?.(K)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=p,Qe([M.$th],p.prototype,"onDidInitializePromise",null);class k{get connections(){const K=[];return this.f.forEach(Z=>K.push(Z)),K}constructor(K){this.a=new Map,this.f=new Set,this.g=new m.$Sd,this.onDidAddConnection=this.g.event,this.h=new m.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new w.$Rc,this.j.add(K(({protocol:Z,onDidClientDisconnect:ae})=>{const _=m.Event.once(Z.onMessage);this.j.add(_(ye=>{const ge=new a(ye),re=v(ge),W=new P(Z,re),ce=new p(Z);this.a.forEach((le,de)=>W.registerChannel(de,le));const me={channelServer:W,channelClient:ce,ctx:re};this.f.add(me),this.g.fire(me),this.j.add(ae(()=>{W.dispose(),ce.dispose(),this.f.delete(me),this.h.fire(me)}))}))}))}getChannel(K,Z){const ae=this;return{call(_,ye,ge){let re;if((0,$.$Sf)(Z)){const ce=(0,E.$4b)(ae.connections.filter(Z));re=ce?Promise.resolve(ce):m.Event.toPromise(m.Event.filter(ae.onDidAddConnection,Z))}else re=Z.routeCall(ae,_,ye);const W=re.then(ce=>ce.channelClient.getChannel(K));return j(W).call(_,ye,ge)},listen(_,ye){if((0,$.$Sf)(Z))return ae.k(K,Z,_,ye);const ge=Z.routeEvent(ae,_,ye).then(re=>re.channelClient.getChannel(K));return j(ge).listen(_,ye)}}}k(K,Z,ae,_){const ye=this;let ge;const re=new m.$Sd({onWillAddFirstListener:()=>{ge=new w.$Rc;const W=new m.$Yd,ce=new Map,me=de=>{const X=de.channelClient.getChannel(K).listen(ae,_),Q=W.add(X);ce.set(de,Q)},le=de=>{const Y=ce.get(de);Y&&(Y.dispose(),ce.delete(de))};ye.connections.filter(Z).forEach(me),m.Event.filter(ye.onDidAddConnection,Z)(me,void 0,ge),ye.onDidRemoveConnection(le,void 0,ge),W.event(re.fire,re,ge),ge.add(W)},onDidRemoveLastListener:()=>{ge?.dispose(),ge=void 0}});return re.event}registerChannel(K,Z){this.a.set(K,Z);for(const ae of this.f)ae.channelServer.registerChannel(K,Z)}dispose(){this.j.dispose();for(const K of this.f)K.channelClient.dispose(),K.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Fh=k;class C{constructor(K,Z,ae=null){const _=new t;c(_,Z),K.send(_.buffer),this.a=new p(K,ae),this.d=new P(K,Z,ae)}getChannel(K){return this.a.getChannel(K)}registerChannel(K,Z){this.d.registerChannel(K,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Gh=C;function j(J){return{call(K,Z,ae){return J.then(_=>_.call(K,Z,ae))},listen(K,Z){const ae=new m.$2d;return J.then(_=>ae.input=_.listen(K,Z)),ae.event}}}e.$Hh=j;function z(J){let K=!1;return{call(Z,ae,_){return K?J.call(Z,ae,_):(0,F.$3g)(0).then(()=>K=!0).then(()=>J.call(Z,ae,_))},listen(Z,ae){if(K)return J.listen(Z,ae);const _=new m.$2d;return(0,F.$3g)(0).then(()=>K=!0).then(()=>_.input=J.listen(Z,ae)),_.event}}}e.$Ih=z;class O{constructor(K){this.a=K}routeCall(K){return this.b(K)}routeEvent(K){return this.b(K)}async b(K){for(const Z of K.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await m.Event.toPromise(K.onDidAddConnection),await this.b(K)}}e.$Jh=O;var U;(function(J){function K(ye,ge,re){const W=ye,ce=re&&re.disableMarshalling,me=new Map;for(const le in W)ae(le)&&me.set(le,m.Event.buffer(W[le],!0,void 0,ge));return new class{listen(le,de,Y){const X=me.get(de);if(X)return X;if(_(de)){const Q=W[de];if(typeof Q=="function")return Q.call(W,Y)}throw new b.$bb(`Event not found: ${de}`)}call(le,de,Y){const X=W[de];if(typeof X=="function"){if(!ce&&Array.isArray(Y))for(let te=0;te<Y.length;te++)Y[te]=(0,L.$yh)(Y[te]);let Q=X.apply(W,Y);return Q instanceof Promise||(Q=Promise.resolve(Q)),Q}throw new b.$bb(`Method not found: ${de}`)}}}J.fromService=K;function Z(ye,ge){const re=ge&&ge.disableMarshalling;return new Proxy({},{get(W,ce){if(typeof ce=="string")return ge?.properties?.has(ce)?ge.properties.get(ce):_(ce)?function(me){return ye.listen(ce,me)}:ae(ce)?ye.listen(ce):async function(...me){let le;ge&&!(0,$.$Nf)(ge.context)?le=[ge.context,...me]:le=me;const de=await ye.call(ce,le);return re?de:(0,L.$yh)(de)};throw new b.$bb(`Property not found: ${String(ce)}`)}})}J.toService=Z;function ae(ye){return ye[0]==="o"&&ye[1]==="n"&&I.$7e(ye.charCodeAt(2))}function _(ye){return/^onDynamic/.test(ye)&&I.$7e(ye.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function R(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const K=J.toString();if(K!=="[object Object]")return K}return J}function T(J){return Array.isArray(J)?J.map(R):R(J)}function q(J,K,Z,ae,_,ye,ge){ge=T(ge);const re=N[_],W=re[ae%re.length];let ce=[`%c[${J}]%c[${String(K).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${ye}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(ye)?(ce=ce.concat(ge),ce.push(")")):ce.push(ge),console.log.apply(console,ce)}class ee{constructor(K,Z){this.d=K,this.f=Z,this.a=0,this.b=0}logOutgoing(K,Z,ae,_,ye){this.b+=K,q(this.d,this.b,K,Z,ae,_,ye)}logIncoming(K,Z,ae,_,ye){this.a+=K,q(this.f,this.a,K,Z,ae,_,ye)}}e.$Kh=ee}),define(Se[81],ke([1,0,22,4,3,80]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.ProtocolConstants=e.$Lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const h=new WeakMap;let c=0;function v(S,p){if(!h.has(S)){const k=String(++c);h.set(S,k)}return h.get(S)}function P(S,p,k,C){if(!l.enableDiagnostics)return;const j=v(S,p);if(C instanceof E.$ge||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const z=E.$ge.alloc(C.byteLength);z.set(C),l.records.push({timestamp:Date.now(),id:j,label:p,type:k,buff:z})}else l.records.push({timestamp:Date.now(),id:j,label:p,type:k,data:C})}l.traceSocketEvent=P})(b||(e.SocketDiagnostics=b={}));var m;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let w=null;function L(){return w||(w=E.$ge.alloc(0)),w}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(h){this.a.push(h),this.b+=h.byteLength}read(h){return this.c(h,!0)}peek(h){return this.c(h,!1)}c(h,c){if(h===0)return L();if(h>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===h){const p=this.a[0];return c&&(this.a.shift(),this.b-=h),p}if(this.a[0].byteLength>h){const p=this.a[0].slice(0,h);return c&&(this.a[0]=this.a[0].slice(h),this.b-=h),p}const v=E.$ge.alloc(h);let P=0,S=0;for(;h>0;){const p=this.a[S];if(p.byteLength>h){const k=p.slice(0,h);v.set(k,P),P+=h,c&&(this.a[S]=p.slice(h),this.b-=h),h-=h}else v.set(p,P),P+=p.byteLength,c?(this.a.shift(),this.b-=p.byteLength):S++,h-=p.byteLength}return v}}e.$Lh=I;var $;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})($||($={}));function y(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class u{constructor(h,c,v,P){this.type=h,this.id=c,this.ack=v,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends f.$Sc{constructor(h){super(),this.f=this.B(new F.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=h,this.b=!1,this.c=new I,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(h){if(!(!h||h.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(h);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,P=this.g.id,S=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new u(v,P,S,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(h){this.k=null,this.a=!1,this.b=!1,this.c=h,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(h){if(this.a)return;h.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=E.$ge.alloc(13);c.writeUInt8(h.type,0),c.writeUInt32BE(h.id,1),c.writeUInt32BE(h.ack,5),c.writeUInt32BE(h.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(h.type),id:h.id,ack:h.ack,messageSize:h.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",h.data),this.j(c,h.data)}g(h,c){const v=this.f===0;return this.d.push(h,c),this.f+=h.byteLength+c.byteLength,v}h(){const h=E.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,h}j(h,c){this.g(h,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const h=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:h.byteLength}),this.c.write(h)}}class n extends f.$Sc{constructor(h){super(),this.f=new F.$Sd,this.onMessage=this.f.event,this.g=new F.$Sd,this.onDidDispose=this.g.event,this.a=h,this.b=this.B(new o(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(h){this.b.write(new u(1,0,0,h))}}e.$Mh=n;class i extends A.$Gh{static fromSocket(h,c){return new i(new n(h),c)}get onDidDispose(){return this.b.onDidDispose}constructor(h,c,v=null){super(h,c,v),this.b=h}dispose(){super.dispose();const h=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),h.end()}}e.$Nh=i;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(h){this.b?this.d.length>0?this.d.push(h):this.a.fire(h):this.d.push(h)}flushBuffer(){this.d=[]}}e.$Oh=s;class a{constructor(h){this.data=h,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let h=0,c=this.a;for(;c;)c=c.next,h++;return h}peek(){return this.a?this.a.data:null}toArray(){const h=[];let c=0,v=this.a;for(;v;)h[c++]=v.data,v=v.next;return h}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(h){const c=new a(h);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const h=Date.now();for(let c=0;c<r.a;c++)this.c[c]=h-1e3*c;setInterval(()=>{for(let c=r.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const h=Date.now(),c=(1+r.a)*1e3;let v=0;for(let P=0;P<r.a;P++)h-this.c[P]<=c&&v++;return 1-v/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class d{get unacknowledgedCount(){return this.c-this.d}constructor(h){this.u=new s,this.onControlMessage=this.u.event,this.v=new s,this.onMessage=this.v.event,this.w=new s,this.onDidDispose=this.w.event,this.x=new s,this.onSocketClose=this.x.event,this.y=new s,this.onSocketTimeout=this.y.event,this.s=h.loadEstimator??r.getInstance(),this.t=h.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Rc,this.o=h.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),h.initialChunk&&this.q.acceptChunk(h.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const h=new u(5,0,0,L());this.p.write(h),this.p.flush()}sendPause(){const h=new u(7,0,0,L());this.p.write(h)}sendResume(){const h=new u(8,0,0,L());this.p.write(h)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(h,c){this.a=!0,this.r.dispose(),this.r=new f.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=h,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const h=new u(3,0,this.h,L());this.p.write(h);const c=this.b.toArray();for(let v=0,P=c.length;v<P;v++)this.p.write(c[v]);this.B()}acceptDisconnect(){this.w.fire()}z(h){if(h.ack>this.d){this.d=h.ack;do{const c=this.b.peek();if(c&&c.id<=h.ack)this.b.pop();else break}while(!0)}switch(h.type){case 0:break;case 1:{if(h.id>this.g)if(h.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new u(6,0,0,L())))}else this.g=h.id,this.j=Date.now(),this.A(),this.v.fire(h.data);break}case 2:{this.u.fire(h.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let v=0,P=c.length;v<P;v++)this.p.write(c[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(h){const c=++this.c;this.h=this.g;const v=new u(1,c,this.h,h);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(h){const c=new u(2,0,0,h);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const h=Date.now()-this.j;if(h>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-h+5)}B(){if(this.c<=this.d||this.f||this.a)return;const h=this.b.peek(),c=Date.now()-h.writtenTime,v=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(c>=2e4&&v>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:v});return}const S=Math.max(2e4-c,2e4-v,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},S)}C(){if(this.g<=this.h)return;this.h=this.g;const h=new u(3,0,this.h,L());this.p.write(h)}D(){this.h=this.g;const h=new u(9,0,this.h,L());this.p.write(h)}}e.$Ph=d}),define(Se[170],ke([1,0,50,10,22,21,166,8,4,3,24,103,99,80]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;class D extends y.$Dh{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",n=>f.$ge.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$dq=D;class u{constructor(o,n){this.i=o,this.j=n,this.c=new Set,this.g=new Map,this.h=new m.$Sd,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new F.$Yg(i),this.d=null,this.f=null}getChannel(o){const n=this;return{call(i,s,a){return n.k(o,i,s,a)},listen(i,s){return n.l(o,i,s)}}}k(o,n,i,s=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const a=this.n(o),t=(0,F.$Pg)(l=>a.call(n,i,l)),r=s.onCancellationRequested(()=>t.cancel()),d=(0,w.$Qc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{r.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,n,i){if(!this.b)return m.Event.None;this.b.cancel();let s;const a=new m.$Sd({onWillAddFirstListener:()=>{s=this.n(o).listen(n,i)(a.fire,a),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,L.$in)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,$.$Ol)(n.env),this.d=(0,E.fork)(this.i,o,n);const i=new m.$Sd;m.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,M.$_p)(h)){(0,M.log)(h,`IPC Library: ${this.j.serverName}`);return}i.fire(f.$ge.wrap(Buffer.from(h,"base64")))});const a=this.j.useQueue?(0,I.$Ql)(this.d):this.d,t=h=>this.d&&this.d.connected&&a.send(h.buffer.toString("base64")),r=i.event,d={send:t,onMessage:r};this.f=new y.$Eh(d);const l=()=>this.o();process.once("exit",l),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,c)=>{process.removeListener("exit",l),this.c.forEach(v=>(0,w.$Nc)(v)),this.c.clear(),h!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:c})})}return this.f}n(o){let n=this.g.get(o);return n||(n=this.m.getChannel(o),this.g.set(o,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$eq=u}),define(Se[171],ke([1,0,10,4,3,54,18]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.StorageState=e.$cp=e.StorageHint=void 0;var b;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function m($){const y=$;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$cp=m;var w;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(w||(e.StorageState=w={}));class L extends f.$Sc{constructor(y,D=Object.create(null)){super(),this.r=y,this.s=D,this.b=this.B(new F.$Vd),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new E.$Zg(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((D,u)=>this.w(u,D)),y.deleted?.forEach(D=>this.w(D,void 0))}finally{this.b.resume()}}w(y,D){if(this.c===w.Closed)return;let u=!1;(0,M.$Nf)(D)?u=this.f.delete(y):this.f.get(y)!==D&&(this.f.set(y,D),u=!0),u&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,D){const u=this.f.get(y);return(0,M.$Nf)(u)?D:u}getBoolean(y,D){const u=this.get(y);return(0,M.$Nf)(u)?D:u==="true"}getNumber(y,D){const u=this.get(y);return(0,M.$Nf)(u)?D:parseInt(u,10)}getObject(y,D){const u=this.get(y);return(0,M.$Nf)(u)?D:(0,A.$xh)(u)}async set(y,D,u=!1){if(this.c===w.Closed)return;if((0,M.$Nf)(D))return this.delete(y,u);const g=(0,M.$Gf)(D)||Array.isArray(D)?(0,A.$wh)(D):String(D);if(this.f.get(y)!==g)return this.f.set(y,g),this.j.set(y,g),this.h.delete(y),this.b.fire({key:y,external:u}),this.D()}async delete(y,D=!1){if(!(this.c===w.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:D}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$dp=L,L.a=100;class I{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((D,u)=>this.a.set(u,D)),y.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$ep=I}),define(Se[129],ke([1,0,127]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=void 0;class F{constructor(b){const m=(0,E.$Ee)(b);this.c=m,this.a=F.d(m),this.b=new Map}static d(b){const m=new Uint8Array(256);return m.fill(b),m}set(b,m){const w=(0,E.$Ee)(m);b>=0&&b<256?this.a[b]=w:this.b.set(b,w)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$5s=F;var f;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(f||(f={}));class A{constructor(){this.a=new F(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$6s=A}),define(Se[172],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.StringEOL=void 0;var E;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function F(f){let A=0,M=0,b=0,m=0;for(let w=0,L=f.length;w<L;w++){const I=f.charCodeAt(w);I===13?(A===0&&(M=w),A++,w+1<L&&f.charCodeAt(w+1)===10?(m|=2,w++):m|=3,b=w+1):I===10&&(m|=1,A===0&&(M=w),A++,b=w+1)}return A===0&&(M=f.length),[A,M,f.length-b,m]}e.$ht=F}),define(Se[51],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class E{constructor(f,A){this.lineNumber=f,this.column=A}with(f=this.lineNumber,A=this.column){return f===this.lineNumber&&A===this.column?this:new E(f,A)}delta(f=0,A=0){return this.with(this.lineNumber+f,this.column+A)}equals(f){return E.equals(this,f)}static equals(f,A){return!f&&!A?!0:!!f&&!!A&&f.lineNumber===A.lineNumber&&f.column===A.column}isBefore(f){return E.isBefore(this,f)}static isBefore(f,A){return f.lineNumber<A.lineNumber?!0:A.lineNumber<f.lineNumber?!1:f.column<A.column}isBeforeOrEqual(f){return E.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,A){return f.lineNumber<A.lineNumber?!0:A.lineNumber<f.lineNumber?!1:f.column<=A.column}static compare(f,A){const M=f.lineNumber|0,b=A.lineNumber|0;if(M===b){const m=f.column|0,w=A.column|0;return m-w}return M-b}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new E(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Gs=E}),define(Se[29],ke([1,0,51]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;class F{constructor(A,M,b,m){A>b||A===b&&M>m?(this.startLineNumber=b,this.startColumn=m,this.endLineNumber=A,this.endColumn=M):(this.startLineNumber=A,this.startColumn=M,this.endLineNumber=b,this.endColumn=m)}isEmpty(){return F.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return F.containsPosition(this,A)}static containsPosition(A,M){return!(M.lineNumber<A.startLineNumber||M.lineNumber>A.endLineNumber||M.lineNumber===A.startLineNumber&&M.column<A.startColumn||M.lineNumber===A.endLineNumber&&M.column>A.endColumn)}static strictContainsPosition(A,M){return!(M.lineNumber<A.startLineNumber||M.lineNumber>A.endLineNumber||M.lineNumber===A.startLineNumber&&M.column<=A.startColumn||M.lineNumber===A.endLineNumber&&M.column>=A.endColumn)}containsRange(A){return F.containsRange(this,A)}static containsRange(A,M){return!(M.startLineNumber<A.startLineNumber||M.endLineNumber<A.startLineNumber||M.startLineNumber>A.endLineNumber||M.endLineNumber>A.endLineNumber||M.startLineNumber===A.startLineNumber&&M.startColumn<A.startColumn||M.endLineNumber===A.endLineNumber&&M.endColumn>A.endColumn)}strictContainsRange(A){return F.strictContainsRange(this,A)}static strictContainsRange(A,M){return!(M.startLineNumber<A.startLineNumber||M.endLineNumber<A.startLineNumber||M.startLineNumber>A.endLineNumber||M.endLineNumber>A.endLineNumber||M.startLineNumber===A.startLineNumber&&M.startColumn<=A.startColumn||M.endLineNumber===A.endLineNumber&&M.endColumn>=A.endColumn)}plusRange(A){return F.plusRange(this,A)}static plusRange(A,M){let b,m,w,L;return M.startLineNumber<A.startLineNumber?(b=M.startLineNumber,m=M.startColumn):M.startLineNumber===A.startLineNumber?(b=M.startLineNumber,m=Math.min(M.startColumn,A.startColumn)):(b=A.startLineNumber,m=A.startColumn),M.endLineNumber>A.endLineNumber?(w=M.endLineNumber,L=M.endColumn):M.endLineNumber===A.endLineNumber?(w=M.endLineNumber,L=Math.max(M.endColumn,A.endColumn)):(w=A.endLineNumber,L=A.endColumn),new F(b,m,w,L)}intersectRanges(A){return F.intersectRanges(this,A)}static intersectRanges(A,M){let b=A.startLineNumber,m=A.startColumn,w=A.endLineNumber,L=A.endColumn;const I=M.startLineNumber,$=M.startColumn,y=M.endLineNumber,D=M.endColumn;return b<I?(b=I,m=$):b===I&&(m=Math.max(m,$)),w>y?(w=y,L=D):w===y&&(L=Math.min(L,D)),b>w||b===w&&m>L?null:new F(b,m,w,L)}equalsRange(A){return F.equalsRange(this,A)}static equalsRange(A,M){return!A&&!M?!0:!!A&&!!M&&A.startLineNumber===M.startLineNumber&&A.startColumn===M.startColumn&&A.endLineNumber===M.endLineNumber&&A.endColumn===M.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(A){return new E.$Gs(A.endLineNumber,A.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(A){return new E.$Gs(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,M){return new F(this.startLineNumber,this.startColumn,A,M)}setStartPosition(A,M){return new F(A,M,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(A){return new F(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(A){return new F(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new F(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,M=A){return new F(A.lineNumber,A.column,M.lineNumber,M.column)}static lift(A){return A?new F(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,M){return!(A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<M.startColumn||M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<A.startColumn)}static areIntersecting(A,M){return!(A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<=M.startColumn||M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,M){if(A&&M){const w=A.startLineNumber|0,L=M.startLineNumber|0;if(w===L){const I=A.startColumn|0,$=M.startColumn|0;if(I===$){const y=A.endLineNumber|0,D=M.endLineNumber|0;if(y===D){const u=A.endColumn|0,g=M.endColumn|0;return u-g}return y-D}return I-$}return w-L}return(A?1:0)-(M?1:0)}static compareRangesUsingEnds(A,M){return A.endLineNumber===M.endLineNumber?A.endColumn===M.endColumn?A.startLineNumber===M.startLineNumber?A.startColumn-M.startColumn:A.startLineNumber-M.startLineNumber:A.endColumn-M.endColumn:A.endLineNumber-M.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$Hs=F}),define(Se[173],ke([1,0,29]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;class F{static insert(A,M){return{range:new E.$Hs(A.lineNumber,A.column,A.lineNumber,A.column),text:M,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,M){return{range:A,text:M}}static replaceMove(A,M){return{range:A,text:M,forceMoveMarkers:!0}}}e.$Is=F}),define(Se[174],ke([1,0,51,29]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=e.SelectionDirection=void 0;var f;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class A extends F.$Hs{constructor(b,m,w,L){super(b,m,w,L),this.selectionStartLineNumber=b,this.selectionStartColumn=m,this.positionLineNumber=w,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return A.selectionsEqual(this,b)}static selectionsEqual(b,m){return b.selectionStartLineNumber===m.selectionStartLineNumber&&b.selectionStartColumn===m.selectionStartColumn&&b.positionLineNumber===m.positionLineNumber&&b.positionColumn===m.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,m){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,b,m):new A(b,m,this.startLineNumber,this.startColumn)}getPosition(){return new E.$Gs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.$Gs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,m){return this.getDirection()===0?new A(b,m,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,b,m)}static fromPositions(b,m=b){return new A(b.lineNumber,b.column,m.lineNumber,m.column)}static fromRange(b,m){return m===0?new A(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new A(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new A(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,m){if(b&&!m||!b&&m)return!1;if(!b&&!m)return!0;if(b.length!==m.length)return!1;for(let w=0,L=b.length;w<L;w++)if(!this.selectionsEqual(b[w],m[w]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,m,w,L,I){return I===0?new A(b,m,w,L):new A(w,L,b,m)}}e.$Js=A}),define(Se[175],ke([1,0,13,9,22]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=e.$Zs=void 0;let A;function M(){return A||(A=new TextDecoder("UTF-16LE")),A}let b;function m(){return b||(b=new TextDecoder("UTF-16BE")),b}let w;function L(){return w||(w=F.$x()?M():m()),w}e.$Zs=L;function I(D,u,g){const o=new Uint16Array(D.buffer,u,g);return g>0&&(o[0]===65279||o[0]===65534)?$(D,u,g):M().decode(o)}e.$1s=I;function $(D,u,g){const o=[];let n=0;for(let i=0;i<g;i++){const s=f.$ie(D,u);u+=2,o[n++]=String.fromCharCode(s)}return o.join("")}class y{constructor(u){this.a=u|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const u=new Uint16Array(this.b.buffer,0,this.d);return L().decode(u)}f(){const u=this.e();this.d=0,this.c===null?this.c=[u]:this.c[this.c.length]=u}appendCharCode(u){const g=this.a-this.d;g<=1&&(g===0||E.$_e(u))&&this.f(),this.b[this.d++]=u}appendASCIICharCode(u){this.d===this.a&&this.f(),this.b[this.d++]=u}appendString(u){const g=u.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=u;return}for(let o=0;o<g;o++)this.b[this.d++]=u.charCodeAt(o)}}e.$2s=y}),define(Se[176],ke([1,0,22,175]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=void 0;function f(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,L,I,$){this.oldPosition=w,this.oldText=L,this.newPosition=I,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,L,I){const $=L.length;E.$le(w,$,I),I+=4;for(let y=0;y<$;y++)E.$je(w,L.charCodeAt(y),I),I+=2;return I}static d(w,L){const I=E.$ke(w,L);return L+=4,(0,F.$1s)(w,L,I)}writeSize(){return 4+4+A.a(this.oldText)+A.a(this.newText)}write(w,L){return E.$le(w,this.oldPosition,L),L+=4,E.$le(w,this.newPosition,L),L+=4,L=A.c(w,this.oldText,L),L=A.c(w,this.newText,L),L}static read(w,L,I){const $=E.$ke(w,L);L+=4;const y=E.$ke(w,L);L+=4;const D=A.d(w,L);L+=A.a(D);const u=A.d(w,L);return L+=A.a(u),I.push(new A($,D,y,u)),L}}e.$3s=A;function M(m,w){return m===null||m.length===0?w:new b(m,w).compress()}e.$4s=M;class b{constructor(w,L){this.a=w,this.c=L,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,L=0,I=this.n(w),$=this.l(L);for(;w<this.f||L<this.h;){if(I===null){this.k($),$=this.l(++L);continue}if($===null){this.m(I),I=this.n(++w);continue}if($.oldEnd<=I.newPosition){this.k($),$=this.l(++L);continue}if(I.newEnd<=$.oldPosition){this.m(I),I=this.n(++w);continue}if($.oldPosition<I.newPosition){const[o,n]=b.r($,I.newPosition-$.oldPosition);this.k(o),$=n;continue}if(I.newPosition<$.oldPosition){const[o,n]=b.q(I,$.oldPosition-I.newPosition);this.m(o),I=n;continue}let u,g;if($.oldEnd===I.newEnd)u=I,g=$,I=this.n(++w),$=this.l(++L);else if($.oldEnd<I.newEnd){const[o,n]=b.q(I,$.oldLength);u=o,g=$,I=n,$=this.l(++L)}else{const[o,n]=b.r($,I.newLength);u=I,g=o,I=this.n(++w),$=n}this.d[this.e++]=new A(u.oldPosition,u.oldText,g.newPosition,g.newText),this.g+=u.newLength-u.oldLength,this.j+=g.newLength-g.oldLength}const y=b.s(this.d);return b.t(y)}k(w){this.d[this.e++]=b.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=b.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,L){return new A(L.oldPosition-w,L.oldText,L.newPosition,L.newText)}static p(w,L){return new A(L.oldPosition,L.oldText,L.newPosition+w,L.newText)}static q(w,L){const I=w.newText.substr(0,L),$=w.newText.substr(L);return[new A(w.oldPosition,w.oldText,w.newPosition,I),new A(w.oldEnd,"",w.newPosition+L,$)]}static r(w,L){const I=w.oldText.substr(0,L),$=w.oldText.substr(L);return[new A(w.oldPosition,I,w.newPosition,w.newText),new A(w.oldPosition+L,$,w.newEnd,"")]}static s(w){if(w.length===0)return w;const L=[];let I=0,$=w[0];for(let y=1;y<w.length;y++){const D=w[y];$.oldEnd===D.oldPosition?$=new A($.oldPosition,$.oldText+D.oldText,$.newPosition,$.newText+D.newText):(L[I++]=$,$=D)}return L[I++]=$,L}static t(w){if(w.length===0)return w;const L=[];let I=0;for(let $=0;$<w.length;$++){const y=w[$];y.oldText!==y.newText&&(L[I++]=y)}return L}}}),define(Se[177],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,e.$es={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[178],ke([1,0,129]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.$7s=e.WordCharacterClass=void 0;var F;(function(M){M[M.Regular=0]="Regular",M[M.Whitespace=1]="Whitespace",M[M.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class f extends E.$5s{constructor(b){super(0);for(let m=0,w=b.length;m<w;m++)this.set(b.charCodeAt(m),2);this.set(32,1),this.set(9,1)}}e.$7s=f;function A(M){const b={};return m=>(b.hasOwnProperty(m)||(b[m]=M(m)),b[m])}e.$8s=A(M=>new f(M))}),define(Se[130],ke([1,0,52,3,75]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(I=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$fs)I.indexOf(y)>=0||($+="\\"+y);return $+="\\s]+)",new RegExp($,"g")}e.$gs=A();function M(I){let $=e.$gs;if(I&&I instanceof RegExp)if(I.global)$=I;else{let y="g";I.ignoreCase&&(y+="i"),I.multiline&&(y+="m"),I.unicode&&(y+="u"),$=new RegExp(I.source,y)}return $.lastIndex=0,$}e.$hs=M;const b=new f.$3c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function m(I){const $=b.unshift(I);return(0,F.$Qc)($)}e.$is=m;function w(I,$,y,D,u){if($=M($),u||(u=E.Iterable.first(b)),y.length>u.maxLen){let s=I-u.maxLen/2;return s<0?s=0:D+=s,y=y.substring(s,I+u.maxLen/2),w(I,$,y,D,u)}const g=Date.now(),o=I-1-D;let n=-1,i=null;for(let s=1;!(Date.now()-g>=u.timeBudget);s++){const a=o-u.windowSize*s;$.lastIndex=Math.max(0,a);const t=L($,y,o,n);if(!t&&i||(i=t,a<=0))break;n=a}if(i){const s={word:i[0],startColumn:D+1+i.index,endColumn:D+1+i.index+i[0].length};return $.lastIndex=0,s}return null}e.$js=w;function L(I,$,y,D){let u;for(;u=I.exec($);){const g=u.index||0;if(g<=y&&I.lastIndex>=y)return u;if(D>0&&g>D)return null}return null}}),define(Se[179],ke([1,0,34,16]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=void 0;function f(A,M,b,m,w,L){if(Array.isArray(A)){let I=0;for(const $ of A){const y=f($,M,b,m,w,L);if(y===10)return y;y>I&&(I=y)}return I}else{if(typeof A=="string")return m?A==="*"?5:A===b?10:0:0;if(A){const{language:I,pattern:$,scheme:y,hasAccessToAllModels:D,notebookType:u}=A;if(!m&&!D)return 0;u&&w&&(M=w);let g=0;if(y)if(y===M.scheme)g=10;else if(y==="*")g=5;else return 0;if(I)if(I===b)g=10;else if(I==="*")g=Math.max(g,5);else return 0;if(u)if(u===L)g=10;else if(u==="*"&&L!==void 0)g=Math.max(g,5);else return 0;if($){let o;if(typeof $=="string"?o=$:o={...$,base:(0,F.$hc)($.base)},o===M.fsPath||(0,E.$Hj)(o,M.fsPath))g=10;else return 0}return g}else return 0}}e.$ot=f}),define(Se[180],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.$Et=e.IndentAction=void 0;var E;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class F{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let m=0,w=b.notIn.length;m<w;m++)switch(b.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,m){if(b.getTokenCount()===0)return!0;const w=b.findTokenIndexAtOffset(m-2),L=b.getStandardTokenType(w);return this.isOK(L)}g(b,m){for(let w=b;w<=m;w++){const L=String.fromCharCode(w);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Et=F;class f{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of b)A(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),A(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),A(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),A(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&A(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$Ft=f;function A(M,b,m){M.has(b)?M.get(b).push(m):M.set(b,[m])}}),define(Se[181],ke([1,0,129]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rZ=e.$qZ=e.$pZ=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class f{constructor(D,u,g){const o=new Uint8Array(D*u);for(let n=0,i=D*u;n<i;n++)o[n]=g;this.a=o,this.rows=D,this.cols=u}get(D,u){return this.a[D*this.cols+u]}set(D,u,g){this.a[D*this.cols+u]=g}}class A{constructor(D){let u=0,g=0;for(let n=0,i=D.length;n<i;n++){const[s,a,t]=D[n];a>u&&(u=a),s>g&&(g=s),t>g&&(g=t)}u++,g++;const o=new f(g,u,0);for(let n=0,i=D.length;n<i;n++){const[s,a,t]=D[n];o.set(s,a,t)}this.a=o,this.b=u}nextState(D,u){return u<0||u>=this.b?0:this.a.get(D,u)}}e.$pZ=A;let M=null;function b(){return M===null&&(M=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var m;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(m||(m={}));let w=null;function L(){if(w===null){w=new E.$5s(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<y.length;u++)w.set(y.charCodeAt(u),1);const D=".,;:";for(let u=0;u<D.length;u++)w.set(D.charCodeAt(u),2)}return w}class I{static a(D,u,g,o,n){let i=n-1;do{const s=u.charCodeAt(i);if(D.get(s)!==2)break;i--}while(i>o);if(o>0){const s=u.charCodeAt(o-1),a=u.charCodeAt(i);(s===40&&a===41||s===91&&a===93||s===123&&a===125)&&i--}return{range:{startLineNumber:g,startColumn:o+1,endLineNumber:g,endColumn:i+2},url:u.substring(o,i+1)}}static computeLinks(D,u=b()){const g=L(),o=[];for(let n=1,i=D.getLineCount();n<=i;n++){const s=D.getLineContent(n),a=s.length;let t=0,r=0,d=0,l=1,h=!1,c=!1,v=!1,P=!1;for(;t<a;){let S=!1;const p=s.charCodeAt(t);if(l===13){let k;switch(p){case 40:h=!0,k=0;break;case 41:k=h?0:1;break;case 91:v=!0,c=!0,k=0;break;case 93:v=!1,k=c?0:1;break;case 123:P=!0,k=0;break;case 125:k=P?0:1;break;case 39:case 34:case 96:d===p?k=1:d===39||d===34||d===96?k=0:k=1;break;case 42:k=d===42?1:0;break;case 124:k=d===124?1:0;break;case 32:k=v?0:1;break;default:k=g.get(p)}k===1&&(o.push(I.a(g,s,n,r,t)),S=!0)}else if(l===12){let k;p===91?(c=!0,k=0):k=g.get(p),k===1?S=!0:l=13}else l=u.nextState(l,p),l===0&&(S=!0);S&&(l=1,h=!1,c=!1,P=!1,r=t+1,d=p),t++}l===13&&o.push(I.a(g,s,n,r,a))}return o}}e.$qZ=I;function $(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:I.computeLinks(y)}e.$rZ=$}),define(Se[82],ke([1,0,24]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.$3u=e.$2u=e.ModelConstants=e.PositionAffinity=e.$1u=e.TrackedRangeStickiness=e.$Zu=e.$Yu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var f;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var A;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var M;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(M||(e.InjectedTextCursorStops=M={}));var b;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var m;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(m||(e.DefaultEndOfLine=m={}));var w;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(w||(e.EndOfLineSequence=w={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,E.$mn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Yu=L;class I{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Zu=I;var $;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function y(s){return s&&typeof s.read=="function"}e.$1u=y;var D;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var u;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u||(e.ModelConstants=u={}));class g{constructor(a,t,r,d,l,h){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=l,this._isTracked=h}}e.$2u=g;class o{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.$3u=o;class n{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$4u=n;function i(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}e.$5u=i}),define(Se[182],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.NodeColor=e.$BB=void 0;class E{constructor(g,o){this.piece=g,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$CB)return f(this.right);let g=this;for(;g.parent!==e.$CB&&g.parent.left!==g;)g=g.parent;return g.parent===e.$CB?e.$CB:g.parent}prev(){if(this.left!==e.$CB)return A(this.left);let g=this;for(;g.parent!==e.$CB&&g.parent.right!==g;)g=g.parent;return g.parent===e.$CB?e.$CB:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$BB=E;var F;(function(u){u[u.Black=0]="Black",u[u.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$CB=new E(null,0),e.$CB.parent=e.$CB,e.$CB.left=e.$CB,e.$CB.right=e.$CB,e.$CB.color=0;function f(u){for(;u.left!==e.$CB;)u=u.left;return u}e.$DB=f;function A(u){for(;u.right!==e.$CB;)u=u.right;return u}e.$EB=A;function M(u){return u===e.$CB?0:u.size_left+u.piece.length+M(u.right)}function b(u){return u===e.$CB?0:u.lf_left+u.piece.lineFeedCnt+b(u.right)}function m(){e.$CB.parent=e.$CB}function w(u,g){const o=g.right;o.size_left+=g.size_left+(g.piece?g.piece.length:0),o.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=o.left,o.left!==e.$CB&&(o.left.parent=g),o.parent=g.parent,g.parent===e.$CB?u.root=o:g.parent.left===g?g.parent.left=o:g.parent.right=o,o.left=g,g.parent=o}e.$FB=w;function L(u,g){const o=g.left;g.left=o.right,o.right!==e.$CB&&(o.right.parent=g),o.parent=g.parent,g.size_left-=o.size_left+(o.piece?o.piece.length:0),g.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),g.parent===e.$CB?u.root=o:g===g.parent.right?g.parent.right=o:g.parent.left=o,o.right=g,g.parent=o}e.$GB=L;function I(u,g){let o,n;if(g.left===e.$CB?(n=g,o=n.right):g.right===e.$CB?(n=g,o=n.left):(n=f(g.right),o=n.right),n===u.root){u.root=o,o.color=0,g.detach(),m(),u.root.parent=e.$CB;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===g?(o.parent=n.parent,D(u,o)):(n.parent===g?o.parent=n:o.parent=n.parent,D(u,o),n.left=g.left,n.right=g.right,n.parent=g.parent,n.color=g.color,g===u.root?u.root=n:g===g.parent.left?g.parent.left=n:g.parent.right=n,n.left!==e.$CB&&(n.left.parent=n),n.right!==e.$CB&&(n.right.parent=n),n.size_left=g.size_left,n.lf_left=g.lf_left,D(u,n)),g.detach(),o.parent.left===o){const a=M(o),t=b(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const r=a-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,y(u,o.parent,r,d)}}if(D(u,o.parent),i){m();return}let s;for(;o!==u.root&&o.color===0;)o===o.parent.left?(s=o.parent.right,s.color===1&&(s.color=0,o.parent.color=1,w(u,o.parent),s=o.parent.right),s.left.color===0&&s.right.color===0?(s.color=1,o=o.parent):(s.right.color===0&&(s.left.color=0,s.color=1,L(u,s),s=o.parent.right),s.color=o.parent.color,o.parent.color=0,s.right.color=0,w(u,o.parent),o=u.root)):(s=o.parent.left,s.color===1&&(s.color=0,o.parent.color=1,L(u,o.parent),s=o.parent.left),s.left.color===0&&s.right.color===0?(s.color=1,o=o.parent):(s.left.color===0&&(s.right.color=0,s.color=1,w(u,s),s=o.parent.left),s.color=o.parent.color,o.parent.color=0,s.left.color=0,L(u,o.parent),o=u.root));o.color=0,m()}e.$HB=I;function $(u,g){for(D(u,g);g!==u.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const o=g.parent.parent.right;o.color===1?(g.parent.color=0,o.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,w(u,g)),g.parent.color=0,g.parent.parent.color=1,L(u,g.parent.parent))}else{const o=g.parent.parent.left;o.color===1?(g.parent.color=0,o.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,L(u,g)),g.parent.color=0,g.parent.parent.color=1,w(u,g.parent.parent))}u.root.color=0}e.$IB=$;function y(u,g,o,n){for(;g!==u.root&&g!==e.$CB;)g.parent.left===g&&(g.parent.size_left+=o,g.parent.lf_left+=n),g=g.parent}e.$JB=y;function D(u,g){let o=0,n=0;if(g!==u.root){for(;g!==u.root&&g===g.parent.right;)g=g.parent;if(g!==u.root)for(g=g.parent,o=M(g.left)-g.size_left,n=b(g.left)-g.lf_left,g.size_left+=o,g.lf_left+=n;g!==u.root&&(o!==0||n!==0);)g.parent.left===g&&(g.parent.size_left+=o,g.parent.lf_left+=n),g=g.parent}}e.$KB=D}),define(Se[183],ke([1,0,19,127]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=e.$9u=e.$8u=void 0;class f{constructor(m){this.a=m,this.b=new Uint32Array(m.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(m,w){m=(0,F.$Fe)(m);const L=this.a,I=this.b,$=w.length;return $===0?!1:(this.a=new Uint32Array(L.length+$),this.a.set(L.subarray(0,m),0),this.a.set(L.subarray(m),m+$),this.a.set(w,m),m-1<this.c[0]&&(this.c[0]=m-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(m,w){return m=(0,F.$Fe)(m),w=(0,F.$Fe)(w),this.a[m]===w?!1:(this.a[m]=w,m-1<this.c[0]&&(this.c[0]=m-1),!0)}removeValues(m,w){m=(0,F.$Fe)(m),w=(0,F.$Fe)(w);const L=this.a,I=this.b;if(m>=L.length)return!1;const $=L.length-m;return w>=$&&(w=$),w===0?!1:(this.a=new Uint32Array(L.length-w),this.a.set(L.subarray(0,m),0),this.a.set(L.subarray(m+w),m),this.b=new Uint32Array(this.a.length),m-1<this.c[0]&&(this.c[0]=m-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(m){return m<0?0:(m=(0,F.$Fe)(m),this.d(m))}d(m){if(m<=this.c[0])return this.b[m];let w=this.c[0]+1;w===0&&(this.b[0]=this.a[0],w++),m>=this.a.length&&(m=this.a.length-1);for(let L=w;L<=m;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],m),this.b[m]}getIndexOf(m){m=Math.floor(m),this.getTotalSum();let w=0,L=this.a.length-1,I=0,$=0,y=0;for(;w<=L;)if(I=w+(L-w)/2|0,$=this.b[I],y=$-this.a[I],m<y)L=I-1;else if(m>=$)w=I+1;else break;return new M(I,m-y)}}e.$8u=f;class A{constructor(m){this.a=m,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(m){return this.g(),m===0?0:this.d[m-1]}getIndexOf(m){this.g();const w=this.e[m],L=w>0?this.d[w-1]:0;return new M(w,m-L)}removeValues(m,w){this.a.splice(m,w),this.f(m)}insertValues(m,w){this.a=(0,E.$Wb)(this.a,m,w),this.f(m)}f(m){this.b=!1,this.c=Math.min(this.c,m-1)}g(){if(!this.b){for(let m=this.c+1,w=this.a.length;m<w;m++){const L=this.a[m],I=m>0?this.d[m-1]:0;this.d[m]=I+L;for(let $=0;$<L;$++)this.e[I+$]=m}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(m,w){this.a[m]!==w&&(this.a[m]=w,this.f(m))}}e.$9u=A;class M{constructor(m,w){this.index=m,this.remainder=w,this._prefixSumIndexOfResultBrand=void 0,this.index=m,this.remainder=w}}e.$0u=M}),define(Se[184],ke([1,0,13,51,183]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$u=void 0;class A{constructor(b,m,w,L){this.d=b,this.f=m,this.g=w,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const m=b.changes;for(const w of m)this.o(w.range),this.p(new F.$Gs(w.range.startLineNumber,w.range.startColumn),w.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,m=this.f.length,w=new Uint32Array(m);for(let L=0;L<m;L++)w[L]=this.f[L].length+b;this.j=new f.$8u(w)}}n(b,m){this.f[b]=m,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,m){if(m.length===0)return;const w=(0,E.$Ve)(m);if(w.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+w[0]+this.f[b.lineNumber-1].substring(b.column-1));return}w[w.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+w[0]);const L=new Uint32Array(w.length-1);for(let I=1;I<w.length;I++)this.f.splice(b.lineNumber+I-1,0,w[I]),L[I-1]=w[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,L)}}e.$$u=A}),define(Se[104],ke([1,0,13,178,51,29,82]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QB=e.$PB=e.$OB=e.$NB=e.$MB=e.$LB=void 0;const b=999;class m{constructor(n,i,s,a){this.searchString=n,this.isRegex=i,this.matchCase=s,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=w(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=E.$Te(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let s=!this.isRegex&&!n;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new M.$3u(i,this.wordSeparators?(0,F.$8s)(this.wordSeparators):null,s?this.searchString:null)}}e.$LB=m;function w(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const s=o.charCodeAt(n);if(s===10)return!0;if(s===92){if(n++,n>=i)break;const a=o.charCodeAt(n);if(a===110||a===114||a===87)return!0}}return!1}e.$MB=w;function L(o,n,i){if(!i)return new M.$Zu(o,null);const s=[];for(let a=0,t=n.length;a<t;a++)s[a]=n[a];return new M.$Zu(o,s)}e.$NB=L;class I{constructor(n){const i=[];let s=0;for(let a=0,t=n.length;a<t;a++)n.charCodeAt(a)===10&&(i[s++]=a);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let s=0,a=i.length-1;if(a===-1||n<=i[0])return 0;for(;s<a;){const t=s+((a-s)/2>>0);i[t]>=n?a=t-1:i[t+1]>=n?(s=t,a=t):s=t+1}return s+1}}class ${static findMatches(n,i,s,a,t){const r=i.parseSearchRequest();return r?r.regex.multiline?this.b(n,s,new g(r.wordSeparators,r.regex),a,t):this.c(n,s,r,a,t):[]}static a(n,i,s,a,t,r){let d,l=0;a?(l=a.findLineFeedCountBeforeOffset(t),d=i+t+l):d=i+t;let h;if(a){const S=a.findLineFeedCountBeforeOffset(t+r.length)-l;h=d+r.length+S}else h=d+r.length;const c=n.getPositionAt(d),v=n.getPositionAt(h);return new A.$Hs(c.lineNumber,c.column,v.lineNumber,v.column)}static b(n,i,s,a,t){const r=n.getOffsetAt(i.getStartPosition()),d=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new I(d):null,h=[];let c=0,v;for(s.reset(0);v=s.next(d);)if(h[c++]=L(this.a(n,r,d,l,v.index,v[0]),v,a),c>=t)return h;return h}static c(n,i,s,a,t){const r=[];let d=0;if(i.startLineNumber===i.endLineNumber){const h=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return d=this.d(s,h,i.startLineNumber,i.startColumn-1,d,r,a,t),r}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);d=this.d(s,l,i.startLineNumber,i.startColumn-1,d,r,a,t);for(let h=i.startLineNumber+1;h<i.endLineNumber&&d<t;h++)d=this.d(s,n.getLineContent(h),h,0,d,r,a,t);if(d<t){const h=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);d=this.d(s,h,i.endLineNumber,0,d,r,a,t)}return r}static d(n,i,s,a,t,r,d,l){const h=n.wordSeparators;if(!d&&n.simpleSearch){const P=n.simpleSearch,S=P.length,p=i.length;let k=-S;for(;(k=i.indexOf(P,k+S))!==-1;)if((!h||u(h,i,p,k,S))&&(r[t++]=new M.$Zu(new A.$Hs(s,k+1+a,s,k+1+S+a),null),t>=l))return t;return t}const c=new g(n.wordSeparators,n.regex);let v;c.reset(0);do if(v=c.next(i),v&&(r[t++]=L(new A.$Hs(s,v.index+1+a,s,v.index+1+v[0].length+a),v,d),t>=l))return t;while(v);return t}static findNextMatch(n,i,s,a){const t=i.parseSearchRequest();if(!t)return null;const r=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,s,r,a):this.f(n,s,r,a)}static e(n,i,s,a){const t=new f.$Gs(i.lineNumber,1),r=n.getOffsetAt(t),d=n.getLineCount(),l=n.getValueInRange(new A.$Hs(t.lineNumber,t.column,d,n.getLineMaxColumn(d)),1),h=n.getEOL()===`\r
`?new I(l):null;s.reset(i.column-1);const c=s.next(l);return c?L(this.a(n,r,l,h,c.index,c[0]),c,a):i.lineNumber!==1||i.column!==1?this.e(n,new f.$Gs(1,1),s,a):null}static f(n,i,s,a){const t=n.getLineCount(),r=i.lineNumber,d=n.getLineContent(r),l=this.g(s,d,r,i.column,a);if(l)return l;for(let h=1;h<=t;h++){const c=(r+h-1)%t,v=n.getLineContent(c+1),P=this.g(s,v,c+1,1,a);if(P)return P}return null}static g(n,i,s,a,t){n.reset(a-1);const r=n.next(i);return r?L(new A.$Hs(s,r.index+1,s,r.index+1+r[0].length),r,t):null}static findPreviousMatch(n,i,s,a){const t=i.parseSearchRequest();if(!t)return null;const r=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,s,r,a):this.j(n,s,r,a)}static h(n,i,s,a){const t=this.b(n,new A.$Hs(1,1,i.lineNumber,i.column),s,a,10*b);if(t.length>0)return t[t.length-1];const r=n.getLineCount();return i.lineNumber!==r||i.column!==n.getLineMaxColumn(r)?this.h(n,new f.$Gs(r,n.getLineMaxColumn(r)),s,a):null}static j(n,i,s,a){const t=n.getLineCount(),r=i.lineNumber,d=n.getLineContent(r).substring(0,i.column-1),l=this.k(s,d,r,a);if(l)return l;for(let h=1;h<=t;h++){const c=(t+r-h-1)%t,v=n.getLineContent(c+1),P=this.k(s,v,c+1,a);if(P)return P}return null}static k(n,i,s,a){let t=null,r;for(n.reset(0);r=n.next(i);)t=L(new A.$Hs(s,r.index+1,s,r.index+1+r[0].length),r,a);return t}}e.$OB=$;function y(o,n,i,s,a){if(s===0)return!0;const t=n.charCodeAt(s-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=n.charCodeAt(s);if(o.get(r)!==0)return!0}return!1}function D(o,n,i,s,a){if(s+a===i)return!0;const t=n.charCodeAt(s+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=n.charCodeAt(s+a-1);if(o.get(r)!==0)return!0}return!1}function u(o,n,i,s,a){return y(o,n,i,s,a)&&D(o,n,i,s,a)}e.$PB=u;class g{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let s;do{if(this.b+this.c===i||(s=this.a.exec(n),!s))return null;const a=s.index,t=s[0].length;if(a===this.b&&t===this.c){if(t===0){E.$cf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||u(this._wordSeparators,n,i,a,t))return s}while(s);return null}}e.$QB=g}),define(Se[131],ke([1,0,51,29,82,182,104]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VB=e.$UB=e.$TB=e.$SB=e.$RB=void 0;const b=65535;function m(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class w{constructor(n,i,s,a,t){this.lineStarts=n,this.cr=i,this.lf=s,this.crlf=a,this.isBasicASCII=t}}function L(o,n=!0){const i=[0];let s=1;for(let a=0,t=o.length;a<t;a++){const r=o.charCodeAt(a);r===13?a+1<t&&o.charCodeAt(a+1)===10?(i[s++]=a+2,a++):i[s++]=a+1:r===10&&(i[s++]=a+1)}return n?m(i):i}e.$RB=L;function I(o,n){o.length=0,o[0]=0;let i=1,s=0,a=0,t=0,r=!0;for(let l=0,h=n.length;l<h;l++){const c=n.charCodeAt(l);c===13?l+1<h&&n.charCodeAt(l+1)===10?(t++,o[i++]=l+2,l++):(s++,o[i++]=l+1):c===10?(a++,o[i++]=l+1):r&&c!==9&&(c<32||c>126)&&(r=!1)}const d=new w(m(o),s,a,t,r);return o.length=0,d}e.$SB=I;class ${constructor(n,i,s,a,t){this.bufferIndex=n,this.start=i,this.end=s,this.lineFeedCnt=a,this.length=t}}e.$TB=$;class y{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$UB=y;class D{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==A.$CB&&n.iterate(n.root,s=>(s!==A.$CB&&this.a.push(s.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class u{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const s=this.b[i];if(s.nodeStartOffset<=n&&s.nodeStartOffset+s.node.piece.length>=n)return s}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const s=this.b[i];if(s.nodeStartLineNumber&&s.nodeStartLineNumber<n&&s.nodeStartLineNumber+s.node.piece.lineFeedCnt>=n)return s}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const s=this.b;for(let a=0;a<s.length;a++){const t=s[a];if(t.node.parent===null||t.nodeStartOffset>=n){s[a]=null,i=!0;continue}}if(i){const a=[];for(const t of s)t!==null&&a.push(t);this.b=a}}}class g{constructor(n,i,s){this.create(n,i,s)}create(n,i,s){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=A.$CB,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=s;let a=null;for(let t=0,r=n.length;t<r;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=L(n[t].buffer));const d=new $(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),a=this.S(a,d)}this.h=new u(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,s=i-Math.floor(i/3),a=s*2;let t="",r=0;const d=[];if(this.iterate(this.root,l=>{const h=this.R(l),c=h.length;if(r<=s||r+c<a)return t+=h,r+=c,!0;const v=t.replace(/\r\n|\r|\n/g,n);return d.push(new y(v,L(v))),t=h,r=c,!0}),r>0){const l=t.replace(/\r\n|\r|\n/g,n);d.push(new y(l,L(l)))}this.create(d,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new D(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,a=>{if(a===A.$CB)return!0;const t=this.R(a),r=t.length,d=n.G(i),l=n.G(i+r),h=n.getValueInRange2(d,l);return i+=r,t===h})}getOffsetAt(n,i){let s=0,a=this.root;for(;a!==A.$CB;)if(a.left!==A.$CB&&a.lf_left+1>=n)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=n){s+=a.size_left;const t=this.B(a,n-a.lf_left-2);return s+=t+i-1}else n-=a.lf_left+a.piece.lineFeedCnt,s+=a.size_left+a.piece.length,a=a.right;return s}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,s=0;const a=n;for(;i!==A.$CB;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(s+=i.lf_left+t.index,t.index===0){const r=this.getOffsetAt(s+1,1),d=a-r;return new E.$Gs(s+1,d+1)}return new E.$Gs(s+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,s+=i.lf_left+i.piece.lineFeedCnt,i.right===A.$CB){const t=this.getOffsetAt(s+1,1),r=a-n-t;return new E.$Gs(s+1,r+1)}else i=i.right;return new E.$Gs(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const s=this.H(n.startLineNumber,n.startColumn),a=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(s,a);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const d=n.node,l=this.a[d.piece.bufferIndex].buffer,h=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(h+n.remainder,h+i.remainder)}let s=n.node;const a=this.a[s.piece.bufferIndex].buffer,t=this.u(s.piece.bufferIndex,s.piece.start);let r=a.substring(t+n.remainder,t+s.piece.length);for(s=s.next();s!==A.$CB;){const d=this.a[s.piece.bufferIndex].buffer,l=this.u(s.piece.bufferIndex,s.piece.start);if(s===i.node){r+=d.substring(l,l+i.remainder);break}else r+=d.substr(l,s.piece.length);s=s.next()}return r}getLinesContent(){const n=[];let i=0,s="",a=!1;return this.iterate(this.root,t=>{if(t===A.$CB)return!0;const r=t.piece;let d=r.length;if(d===0)return!0;const l=this.a[r.bufferIndex].buffer,h=this.a[r.bufferIndex].lineStarts,c=r.start.line,v=r.end.line;let P=h[c]+r.start.column;if(a&&(l.charCodeAt(P)===10&&(P++,d--),n[i++]=s,s="",a=!1,d===0))return!0;if(c===v)return!this.f&&l.charCodeAt(P+d-1)===13?(a=!0,s+=l.substr(P,d-1)):s+=l.substr(P,d),!0;s+=this.f?l.substring(P,Math.max(P,h[c+1]-this.e)):l.substring(P,h[c+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=s;for(let S=c+1;S<v;S++)s=this.f?l.substring(h[S],h[S+1]-this.e):l.substring(h[S],h[S+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=s;return!this.f&&l.charCodeAt(h[v]+r.end.column-1)===13?(a=!0,r.end.column===0?i--:s=l.substr(h[v],r.end.column-1)):s=l.substr(h[v],r.end.column),!0}),a&&(n[i++]=s,s=""),n[i++]=s,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const s=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start);return s.buffer.charCodeAt(a)}else{const i=this.a[n.node.piece.bufferIndex],a=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(a)}}getLineCharCode(n,i){const s=this.H(n,i+1);return this.l(s)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,s,a,t,r,d,l,h,c,v){const P=this.a[n.piece.bufferIndex],S=this.u(n.piece.bufferIndex,n.piece.start),p=this.u(n.piece.bufferIndex,t),k=this.u(n.piece.bufferIndex,r);let C;const j={line:0,column:0};let z,O;i._wordSeparators?(z=P.buffer.substring(p,k),O=U=>U+p,i.reset(0)):(z=P.buffer,O=U=>U,i.reset(p));do if(C=i.next(z),C){if(O(C.index)>=k)return c;this.s(n,O(C.index)-S,j);const U=this.t(n.piece.bufferIndex,t,j),N=j.line===t.line?j.column-t.column+a:j.column+1,R=N+C[0].length;if(v[c++]=(0,M.$NB)(new F.$Hs(s+U,N,s+U,R),C,l),O(C.index)+C[0].length>=k||c>=h)return c}while(C);return c}findMatchesLineByLine(n,i,s,a){const t=[];let r=0;const d=new M.$QB(i.wordSeparators,i.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const h=this.H(n.endLineNumber,n.endColumn);if(h===null)return[];let c=this.s(l.node,l.remainder);const v=this.s(h.node,h.remainder);if(l.node===h.node)return this.findMatchesInNode(l.node,d,n.startLineNumber,n.startColumn,c,v,i,s,a,r,t),t;let P=n.startLineNumber,S=l.node;for(;S!==h.node;){const k=this.t(S.piece.bufferIndex,c,S.piece.end);if(k>=1){const j=this.a[S.piece.bufferIndex].lineStarts,z=this.u(S.piece.bufferIndex,S.piece.start),O=j[c.line+k],U=P===n.startLineNumber?n.startColumn:1;if(r=this.findMatchesInNode(S,d,P,U,c,this.s(S,O-z),i,s,a,r,t),r>=a)return t;P+=k}const C=P===n.startLineNumber?n.startColumn-1:0;if(P===n.endLineNumber){const j=this.getLineContent(P).substring(C,n.endColumn-1);return r=this.n(i,d,j,n.endLineNumber,C,r,t,s,a),t}if(r=this.n(i,d,this.getLineContent(P).substr(C),P,C,r,t,s,a),r>=a)return t;P++,l=this.H(P,1),S=l.node,c=this.s(l.node,l.remainder)}if(P===n.endLineNumber){const k=P===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(P).substring(k,n.endColumn-1);return r=this.n(i,d,C,n.endLineNumber,k,r,t,s,a),t}const p=P===n.startLineNumber?n.startColumn:1;return r=this.findMatchesInNode(h.node,d,P,p,c,v,i,s,a,r,t),t}n(n,i,s,a,t,r,d,l,h){const c=n.wordSeparators;if(!l&&n.simpleSearch){const P=n.simpleSearch,S=P.length,p=s.length;let k=-S;for(;(k=s.indexOf(P,k+S))!==-1;)if((!c||(0,M.$PB)(c,s,p,k,S))&&(d[r++]=new f.$Zu(new F.$Hs(a,k+1+t,a,k+1+S+t),null),r>=h))return r;return r}let v;i.reset(0);do if(v=i.next(s),v&&(d[r++]=(0,M.$NB)(new F.$Hs(a,v.index+1+t,a,v.index+1+v[0].length+t),v,l),r>=h))return r;while(v);return r}insert(n,i,s=!1){if(this.f=this.f&&s,this.j.lineNumber=0,this.j.value="",this.root!==A.$CB){const{node:a,remainder:t,nodeStartOffset:r}=this.G(n),d=a.piece,l=d.bufferIndex,h=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&r+d.length===n&&i.length<b){this.F(a,i),this.y();return}if(r===n)this.o(i,a),this.h.validate(n);else if(r+a.piece.length>n){const c=[];let v=new $(d.bufferIndex,h,d.end,this.t(d.bufferIndex,h,d.end),this.u(l,d.end)-this.u(l,h));if(this.K()&&this.M(i)&&this.I(a,t)===10){const k={line:v.start.line+1,column:0};v=new $(v.bufferIndex,k,v.end,this.t(v.bufferIndex,k,v.end),v.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(a,t-1)===13){const k=this.s(a,t-1);this.C(a,k),i="\r"+i,a.piece.length===0&&c.push(a)}else this.C(a,h);else this.C(a,h);const P=this.w(i);v.length>0&&this.S(a,v);let S=a;for(let p=0;p<P.length;p++)S=this.S(S,P[p]);this.v(c)}else this.q(i,a)}else{const a=this.w(i);let t=this.T(null,a[0]);for(let r=1;r<a.length;r++)t=this.S(t,a[r])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===A.$CB)return;const s=this.G(n),a=this.G(n+i),t=s.node,r=a.node;if(t===r){const P=this.s(t,s.remainder),S=this.s(t,a.remainder);if(s.nodeStartOffset===n){if(i===t.piece.length){const p=t.next();(0,A.$HB)(this,t),this.N(p),this.y();return}this.D(t,S),this.h.validate(n),this.N(t),this.y();return}if(s.nodeStartOffset+t.piece.length===n+i){this.C(t,P),this.O(t),this.y();return}this.E(t,P,S),this.y();return}const d=[],l=this.s(t,s.remainder);this.C(t,l),this.h.validate(n),t.piece.length===0&&d.push(t);const h=this.s(r,a.remainder);this.D(r,h),r.piece.length===0&&d.push(r);const c=t.next();for(let P=c;P!==A.$CB&&P!==r;P=P.next())d.push(P);const v=t.piece.length===0?t.prev():t;this.v(d),this.O(v),this.y()}o(n,i){const s=[];if(this.K()&&this.M(n)&&this.L(i)){const r=i.piece,d={line:r.start.line+1,column:0},l=new $(r.bufferIndex,d,r.end,this.t(r.bufferIndex,d,r.end),r.length-1);i.piece=l,n+=`
`,(0,A.$JB)(this,i,-1,-1),i.piece.length===0&&s.push(i)}const a=this.w(n);let t=this.T(i,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.T(t,a[r]);this.N(t),this.v(s)}q(n,i){this.Q(n,i)&&(n+=`
`);const s=this.w(n),a=this.S(i,s[0]);let t=a;for(let r=1;r<s.length;r++)t=this.S(t,s[r]);this.N(a)}s(n,i,s){const a=n.piece,t=n.piece.bufferIndex,r=this.a[t].lineStarts,l=r[a.start.line]+a.start.column+i;let h=a.start.line,c=a.end.line,v=0,P=0,S=0;for(;h<=c&&(v=h+(c-h)/2|0,S=r[v],v!==c);)if(P=r[v+1],l<S)c=v-1;else if(l>=P)h=v+1;else break;return s?(s.line=v,s.column=l-S,null):{line:v,column:l-S}}t(n,i,s){if(s.column===0)return s.line-i.line;const a=this.a[n].lineStarts;if(s.line===a.length-1)return s.line-i.line;const t=a[s.line+1],r=a[s.line]+s.column;if(t>r+1)return s.line-i.line;const d=r-1;return this.a[n].buffer.charCodeAt(d)===13?s.line-i.line+1:s.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,A.$HB)(this,n[i])}w(n){if(n.length>b){const c=[];for(;n.length>b;){const P=n.charCodeAt(b-1);let S;P===13||P>=55296&&P<=56319?(S=n.substring(0,b-1),n=n.substring(b-1)):(S=n.substring(0,b),n=n.substring(b));const p=L(S);c.push(new $(this.a.length,{line:0,column:0},{line:p.length-1,column:S.length-p[p.length-1]},p.length-1,S.length)),this.a.push(new y(S,p))}const v=L(n);return c.push(new $(this.a.length,{line:0,column:0},{line:v.length-1,column:n.length-v[v.length-1]},v.length-1,n.length)),this.a.push(new y(n,v)),c}let i=this.a[0].buffer.length;const s=L(n,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let c=0;c<s.length;c++)s[c]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let c=0;c<s.length;c++)s[c]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[r],l={line:r,column:d},h=new $(0,a,l,this.t(0,a,l),t-i);return this.g=l,[h]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let s=this.root,a="";const t=this.h.get2(n);if(t){s=t.node;const r=this.B(s,n-t.nodeStartLineNumber-1),d=this.a[s.piece.bufferIndex].buffer,l=this.u(s.piece.bufferIndex,s.piece.start);if(t.nodeStartLineNumber+s.piece.lineFeedCnt===n)a=d.substring(l+r,l+s.piece.length);else{const h=this.B(s,n-t.nodeStartLineNumber);return d.substring(l+r,l+h-i)}}else{let r=0;const d=n;for(;s!==A.$CB;)if(s.left!==A.$CB&&s.lf_left>=n-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>n-1){const l=this.B(s,n-s.lf_left-2),h=this.B(s,n-s.lf_left-1),c=this.a[s.piece.bufferIndex].buffer,v=this.u(s.piece.bufferIndex,s.piece.start);return r+=s.size_left,this.h.set({node:s,nodeStartOffset:r,nodeStartLineNumber:d-(n-1-s.lf_left)}),c.substring(v+l,v+h-i)}else if(s.lf_left+s.piece.lineFeedCnt===n-1){const l=this.B(s,n-s.lf_left-2),h=this.a[s.piece.bufferIndex].buffer,c=this.u(s.piece.bufferIndex,s.piece.start);a=h.substring(c+l,c+s.piece.length);break}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right}for(s=s.next();s!==A.$CB;){const r=this.a[s.piece.bufferIndex].buffer;if(s.piece.lineFeedCnt>0){const d=this.B(s,0),l=this.u(s.piece.bufferIndex,s.piece.start);return a+=r.substring(l,l+d-i),a}else{const d=this.u(s.piece.bufferIndex,s.piece.start);a+=r.substr(d,s.piece.length)}s=s.next()}return a}y(){let n=this.root,i=1,s=0;for(;n!==A.$CB;)i+=n.lf_left+n.piece.lineFeedCnt,s+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=s,this.h.validate(this.c)}A(n,i){const s=n.piece,a=this.s(n,i),t=a.line-s.start.line;if(this.u(s.bufferIndex,s.end)-this.u(s.bufferIndex,s.start)===i){const r=this.t(n.piece.bufferIndex,s.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}B(n,i){if(i<0)return 0;const s=n.piece,a=this.a[s.bufferIndex].lineStarts,t=s.start.line+i+1;return t>s.end.line?a[s.end.line]+s.end.column-a[s.start.line]-s.start.column:a[t]-a[s.start.line]-s.start.column}C(n,i){const s=n.piece,a=s.lineFeedCnt,t=this.u(s.bufferIndex,s.end),r=i,d=this.u(s.bufferIndex,r),l=this.t(s.bufferIndex,s.start,r),h=l-a,c=d-t,v=s.length+c;n.piece=new $(s.bufferIndex,s.start,r,l,v),(0,A.$JB)(this,n,c,h)}D(n,i){const s=n.piece,a=s.lineFeedCnt,t=this.u(s.bufferIndex,s.start),r=i,d=this.t(s.bufferIndex,r,s.end),l=this.u(s.bufferIndex,r),h=d-a,c=t-l,v=s.length+c;n.piece=new $(s.bufferIndex,r,s.end,d,v),(0,A.$JB)(this,n,c,h)}E(n,i,s){const a=n.piece,t=a.start,r=a.end,d=a.length,l=a.lineFeedCnt,h=i,c=this.t(a.bufferIndex,a.start,h),v=this.u(a.bufferIndex,i)-this.u(a.bufferIndex,t);n.piece=new $(a.bufferIndex,a.start,h,c,v),(0,A.$JB)(this,n,v-d,c-l);const P=new $(a.bufferIndex,s,r,this.t(a.bufferIndex,s,r),this.u(a.bufferIndex,r)-this.u(a.bufferIndex,s)),S=this.S(n,P);this.N(S)}F(n,i){this.Q(i,n)&&(i+=`
`);const s=this.K()&&this.L(i)&&this.M(n),a=this.a[0].buffer.length;this.a[0].buffer+=i;const t=L(i,!1);for(let S=0;S<t.length;S++)t[S]+=a;if(s){const S=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-S}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[r],l={line:r,column:d},h=n.piece.length+i.length,c=n.piece.lineFeedCnt,v=this.t(0,n.piece.start,l),P=v-c;n.piece=new $(n.piece.bufferIndex,n.piece.start,l,v,h),this.g=l,(0,A.$JB)(this,n,i.length,P)}G(n){let i=this.root;const s=this.h.get(n);if(s)return{node:s.node,nodeStartOffset:s.nodeStartOffset,remainder:n-s.nodeStartOffset};let a=0;for(;i!==A.$CB;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){a+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:a};return this.h.set(t),t}else n-=i.size_left+i.piece.length,a+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let s=this.root,a=0;for(;s!==A.$CB;)if(s.left!==A.$CB&&s.lf_left>=n-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>n-1){const t=this.B(s,n-s.lf_left-2),r=this.B(s,n-s.lf_left-1);return a+=s.size_left,{node:s,remainder:Math.min(t+i-1,r),nodeStartOffset:a}}else if(s.lf_left+s.piece.lineFeedCnt===n-1){const t=this.B(s,n-s.lf_left-2);if(t+i-1<=s.piece.length)return{node:s,remainder:t+i-1,nodeStartOffset:a};i-=s.piece.length-t;break}else n-=s.lf_left+s.piece.lineFeedCnt,a+=s.size_left+s.piece.length,s=s.right;for(s=s.next();s!==A.$CB;){if(s.piece.lineFeedCnt>0){const t=this.B(s,0),r=this.J(s);return{node:s,remainder:Math.min(i-1,t),nodeStartOffset:r}}else if(s.piece.length>=i-1){const t=this.J(s);return{node:s,remainder:i-1,nodeStartOffset:t}}else i-=s.piece.length;s=s.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const s=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start)+i;return s.buffer.charCodeAt(a)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.$CB||n.piece.lineFeedCnt===0)return!1;const i=n.piece,s=this.a[i.bufferIndex].lineStarts,a=i.start.line,t=s[a]+i.start.column;return a===s.length-1||s[a+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.$CB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const s=[],a=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:a[n.piece.end.line]-a[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const r=n.piece.length-1,d=n.piece.lineFeedCnt-1;n.piece=new $(n.piece.bufferIndex,n.piece.start,t,d,r),(0,A.$JB)(this,n,-1,-1),n.piece.length===0&&s.push(n);const l={line:i.piece.start.line+1,column:0},h=i.piece.length-1,c=this.t(i.piece.bufferIndex,l,i.piece.end);i.piece=new $(i.piece.bufferIndex,l,i.piece.end,c,h),(0,A.$JB)(this,i,-1,-1),i.piece.length===0&&s.push(i);const v=this.w(`\r
`);this.S(n,v[0]);for(let P=0;P<s.length;P++)(0,A.$HB)(this,s[P])}Q(n,i){if(this.K()&&this.M(n)){const s=i.next();if(this.L(s)){if(n+=`
`,s.piece.length===1)(0,A.$HB)(this,s);else{const a=s.piece,t={line:a.start.line+1,column:0},r=a.length-1,d=this.t(a.bufferIndex,t,a.end);s.piece=new $(a.bufferIndex,t,a.end,d,r),(0,A.$JB)(this,s,-1,-1)}return!0}}return!1}iterate(n,i){if(n===A.$CB)return i(A.$CB);const s=this.iterate(n.left,i);return s&&i(n)&&this.iterate(n.right,i)}R(n){if(n===A.$CB)return"";const i=this.a[n.piece.bufferIndex],s=n.piece,a=this.u(s.bufferIndex,s.start),t=this.u(s.bufferIndex,s.end);return i.buffer.substring(a,t)}getPieceContent(n){const i=this.a[n.bufferIndex],s=this.u(n.bufferIndex,n.start),a=this.u(n.bufferIndex,n.end);return i.buffer.substring(s,a)}S(n,i){const s=new A.$BB(i,1);if(s.left=A.$CB,s.right=A.$CB,s.parent=A.$CB,s.size_left=0,s.lf_left=0,this.root===A.$CB)this.root=s,s.color=0;else if(n.right===A.$CB)n.right=s,s.parent=n;else{const t=(0,A.$DB)(n.right);t.left=s,s.parent=t}return(0,A.$IB)(this,s),s}T(n,i){const s=new A.$BB(i,1);if(s.left=A.$CB,s.right=A.$CB,s.parent=A.$CB,s.size_left=0,s.lf_left=0,this.root===A.$CB)this.root=s,s.color=0;else if(n.left===A.$CB)n.left=s,s.parent=n;else{const a=(0,A.$EB)(n.left);a.right=s,s.parent=a}return(0,A.$IB)(this,s),s}U(n){let i="";return this.iterate(n,s=>(i+=this.R(s),!0)),i}}e.$VB=g}),define(Se[185],ke([1,0,4,13,29,82,131,172,176,3]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WB=void 0;class L extends w.$Sc{constructor($,y,D,u,g,o,n){super(),this.m=this.B(new E.$Sd),this.onDidChangeContent=this.m.event,this.f=y,this.j=!o,this.g=u,this.h=g,this.c=new M.$VB($,D,n)}equals($){return!($ instanceof L)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,y){return this.c.getOffsetAt($,y)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,y){const D=$+y,u=this.getPositionAt($),g=this.getPositionAt(D);return new f.$Hs(u.lineNumber,u.column,g.lineNumber,g.column)}getValueInRange($,y=0){if($.isEmpty())return"";const D=this.n(y);return this.c.getValueInRange($,D)}getValueLengthInRange($,y=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const D=this.getOffsetAt($.startLineNumber,$.startColumn),u=this.getOffsetAt($.endLineNumber,$.endColumn);let g=0;const o=this.n(y),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,s=$.endLineNumber-$.startLineNumber;g=i*s}return u-D+g}getCharacterCountInRange($,y=0){if(this.j){let D=0;const u=$.startLineNumber,g=$.endLineNumber;for(let o=u;o<=g;o++){const n=this.getLineContent(o),i=o===u?$.startColumn-1:0,s=o===g?$.endColumn-1:n.length;for(let a=i;a<s;a++)F.$_e(n.charCodeAt(a))?(D=D+1,a=a+1):D=D+1}return D+=this.n(y).length*(g-u),D}return this.getValueLengthInRange($,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,y){return this.c.getLineCharCode($,y)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const y=F.$We(this.getLineContent($));return y===-1?0:y+1}getLineLastNonWhitespaceColumn($){const y=F.$Ye(this.getLineContent($));return y===-1?0:y+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,y,D){let u=this.g,g=this.h,o=this.j,n=!0,i=[];for(let h=0;h<$.length;h++){const c=$[h];n&&c._isTracked&&(n=!1);const v=c.range;if(c.text){let C=!0;o||(C=!F.$kf(c.text),o=C),!u&&C&&(u=F.$jf(c.text)),!g&&C&&(g=F.$mf(c.text))}let P="",S=0,p=0,k=0;if(c.text){let C;[S,p,k,C]=(0,b.$ht)(c.text);const j=this.getEOL();C===0||C===(j===`\r
`?2:1)?P=c.text:P=c.text.replace(/\r\n|\r|\n/g,j)}i[h]={sortIndex:h,identifier:c.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:P,eolCount:S,firstLineLength:p,lastLineLength:k,forceMoveMarkers:!!c.forceMoveMarkers,isAutoWhitespaceEdit:c.isAutoWhitespaceEdit||!1}}i.sort(L.u);let s=!1;for(let h=0,c=i.length-1;h<c;h++){const v=i[h].range.getEndPosition(),P=i[h+1].range.getStartPosition();if(P.isBeforeOrEqual(v)){if(P.isBefore(v))throw new Error("Overlapping ranges are not allowed!");s=!0}}n&&(i=this.s(i));const a=D||y?L._getInverseEditRanges(i):[],t=[];if(y)for(let h=0;h<i.length;h++){const c=i[h],v=a[h];if(c.isAutoWhitespaceEdit&&c.range.isEmpty())for(let P=v.startLineNumber;P<=v.endLineNumber;P++){let S="";P===v.startLineNumber&&(S=this.getLineContent(c.range.startLineNumber),F.$We(S)!==-1)||t.push({lineNumber:P,oldContent:S})}}let r=null;if(D){let h=0;r=[];for(let c=0;c<i.length;c++){const v=i[c],P=a[c],S=this.getValueInRange(v.range),p=v.rangeOffset+h;h+=v.text.length-S.length,r[c]={sortIndex:v.sortIndex,identifier:v.identifier,range:P,text:S,textChange:new m.$3s(v.rangeOffset,S,p,v.text)}}s||r.sort((c,v)=>c.sortIndex-v.sortIndex)}this.g=u,this.h=g,this.j=o;const d=this.t(i);let l=null;if(y&&t.length>0){t.sort((h,c)=>c.lineNumber-h.lineNumber),l=[];for(let h=0,c=t.length;h<c;h++){const v=t[h].lineNumber;if(h>0&&t[h-1].lineNumber===v)continue;const P=t[h].oldContent,S=this.getLineContent(v);S.length===0||S===P||F.$We(S)!==-1||l.push(v)}}return this.m.fire(),new A.$4u(r,d,l)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let y=!1;const D=$[0].range,u=$[$.length-1].range,g=new f.$Hs(D.startLineNumber,D.startColumn,u.endLineNumber,u.endColumn);let o=D.startLineNumber,n=D.startColumn;const i=[];for(let d=0,l=$.length;d<l;d++){const h=$[d],c=h.range;y=y||h.forceMoveMarkers,i.push(this.getValueInRange(new f.$Hs(o,n,c.startLineNumber,c.startColumn))),h.text.length>0&&i.push(h.text),o=c.endLineNumber,n=c.endColumn}const s=i.join(""),[a,t,r]=(0,b.$ht)(s);return{sortIndex:0,identifier:$[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:s,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t($){$.sort(L.w);const y=[];for(let D=0;D<$.length;D++){const u=$[D],g=u.range.startLineNumber,o=u.range.startColumn,n=u.range.endLineNumber,i=u.range.endColumn;if(g===n&&o===i&&u.text.length===0)continue;u.text?(this.c.delete(u.rangeOffset,u.rangeLength),this.c.insert(u.rangeOffset,u.text,!0)):this.c.delete(u.rangeOffset,u.rangeLength);const s=new f.$Hs(g,o,n,i);y.push({range:s,rangeLength:u.rangeLength,text:u.text,rangeOffset:u.rangeOffset,forceMoveMarkers:u.forceMoveMarkers})}return y}findMatchesLineByLine($,y,D,u){return this.c.findMatchesLineByLine($,y,D,u)}getPieceTree(){return this.c}static _getInverseEditRange($,y){const D=$.startLineNumber,u=$.startColumn,[g,o,n]=(0,b.$ht)(y);let i;if(y.length>0){const s=g+1;s===1?i=new f.$Hs(D,u,D,u+o):i=new f.$Hs(D,u,D+s-1,n+1)}else i=new f.$Hs(D,u,D,u);return i}static _getInverseEditRanges($){const y=[];let D=0,u=0,g=null;for(let o=0,n=$.length;o<n;o++){const i=$[o];let s,a;g?g.range.endLineNumber===i.range.startLineNumber?(s=D,a=u+(i.range.startColumn-g.range.endColumn)):(s=D+(i.range.startLineNumber-g.range.endLineNumber),a=i.range.startColumn):(s=i.range.startLineNumber,a=i.range.startColumn);let t;if(i.text.length>0){const r=i.eolCount+1;r===1?t=new f.$Hs(s,a,s,a+i.firstLineLength):t=new f.$Hs(s,a,s+r-1,i.lastLineLength+1)}else t=new f.$Hs(s,a,s,a);D=t.endLineNumber,u=t.endColumn,y.push(t),g=i}return y}static u($,y){const D=f.$Hs.compareRangesUsingEnds($.range,y.range);return D===0?$.sortIndex-y.sortIndex:D}static w($,y){const D=f.$Hs.compareRangesUsingEnds($.range,y.range);return D===0?y.sortIndex-$.sortIndex:-D}}e.$WB=L}),define(Se[186],ke([1,0,13,131,185]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XB=void 0;class A{constructor(m,w,L,I,$,y,D,u,g){this.a=m,this.b=w,this.c=L,this.d=I,this.e=$,this.f=y,this.g=D,this.h=u,this.j=g}k(m){const w=this.c+this.d+this.e,L=this.c+this.e;return w===0?m===1?`
`:`\r
`:L>w/2?`\r
`:`
`}create(m){const w=this.k(m),L=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let $=0,y=L.length;$<y;$++){const D=L[$].buffer.replace(/\r\n|\r|\n/g,w),u=(0,F.$RB)(D);L[$]=new F.$UB(D,u)}const I=new f.$WB(L,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&E.$sf(m)&&(this.b=E.$rf,m=m.substr(1));const w=m.charCodeAt(m.length-1);w===13||w>=55296&&w<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=w):(this.m(m,!1),this.c=!1,this.d=w)}m(m,w){!w&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const w=(0,F.$SB)(this.e,m);this.a.push(new F.$UB(m,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=E.$jf(m)),this.k||(this.k=E.$mf(m)))}finish(m=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const w=(0,F.$RB)(m.buffer);m.lineStarts=w,this.d===13&&this.f++}}}e.$XB=M}),define(Se[132],ke([1,0,22,9]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$=e.$m$=void 0;var f;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(f||(f={}));function A(I){for(let $=0,y=I.length;$<y;$+=4){const D=I[$+0],u=I[$+1],g=I[$+2],o=I[$+3];I[$+0]=o,I[$+1]=g,I[$+2]=u,I[$+3]=D}}function M(I){const $=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.$x()||A($),E.$ge.wrap($)}function b(I){const $=I.buffer;if(F.$x()||A($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const y=new Uint8Array($.byteLength);return y.set($),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function m(I){const $=new Uint32Array(w(I));let y=0;if($[y++]=I.id,I.type==="full")$[y++]=1,$[y++]=I.data.length,$.set(I.data,y),y+=I.data.length;else{$[y++]=2,$[y++]=I.deltas.length;for(const D of I.deltas)$[y++]=D.start,$[y++]=D.deleteCount,D.data?($[y++]=D.data.length,$.set(D.data,y),y+=D.data.length):$[y++]=0}return M($)}e.$m$=m;function w(I){let $=0;if($+=1+1,I.type==="full")$+=1+I.data.length;else{$+=1,$+=(1+1+1)*I.deltas.length;for(const y of I.deltas)y.data&&($+=y.data.length)}return $}function L(I){const $=b(I);let y=0;const D=$[y++];if($[y++]===1){const n=$[y++],i=$.subarray(y,y+n);return y+=n,{id:D,type:"full",data:i}}const g=$[y++],o=[];for(let n=0;n<g;n++){const i=$[y++],s=$[y++],a=$[y++];let t;a>0&&(t=$.subarray(y,y+a),y+=a),o[n]={start:i,deleteCount:s,data:t}}return{id:D,type:"delta",deltas:o}}e.$n$=L}),define(Se[187],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8=e.$d8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const M=this.a.get(A);return this.a.delete(A),M}}addDragOperationTransfer(A,M){this.a.set(A,M)}}e.$d8=E;class F{constructor(A){this.identifier=A}}e.$e8=F}),define(Se[188],ke([1,0,4,3]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new E.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,m){return this.a.set(b,m),this.handleChange([b]),(0,F.$Qc)(()=>{this.a.get(b)===m&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,m){this.b.get(b)?.dispose();const w=new A(this,b,m);return this.b.set(b,w),(0,F.$Qc)(()=>{const L=this.b.get(b);!L||L!==w||(this.b.delete(b),L.dispose())})}async getOrCreate(b){const m=this.get(b);if(m)return m;const w=this.b.get(b);return!w||w.isResolved?null:(await w.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const w=this.b.get(b);return!!(!w||w.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$gt=f;class A extends F.$Sc{get isResolved(){return this.c}constructor(b,m,w){super(),this.f=b,this.g=m,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Se[189],ke([11,12]),function(ie,e){return ie.create("vs/base/common/actions",e)}),define(Se[190],ke([1,0,4,3,189]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class A extends F.$Sc{constructor($,y="",D="",u=!0,g){super(),this.h=this.B(new E.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=y,this.u=D,this.w=u,this.C=g}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,y){this.C&&await this.C($)}}e.$Gi=A;class M extends F.$Sc{constructor(){super(...arguments),this.f=this.B(new E.$Sd),this.onWillRun=this.f.event,this.m=this.B(new E.$Sd),this.onDidRun=this.m.event}async run($,y){if(!$.enabled)return;this.f.fire({action:$});let D;try{await this.u($,y)}catch(u){D=u}this.m.fire({action:$,error:D})}async u($,y){await $.run(y)}}e.$Hi=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let y=[];for(const D of $)D.length&&(y.length?y=[...y,new b,...D]:y=D);return y}async run(){}}e.$Ii=b,b.ID="vs.actions.separator";class m{get actions(){return this.a}constructor($,y,D,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=y,this.class=u,this.a=D}async run(){}}e.$Ji=m;class w extends A{constructor(){super(w.ID,f.localize(0,null),void 0,!1)}}e.$Ki=w,w.ID="vs.actions.empty";function L(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...$)=>I.run(...$),tooltip:I.label}}e.$Li=L}),define(Se[191],ke([11,12]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Se[192],ke([1,0,191]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0;const F=60,f=F*60,A=f*24,M=A*7,b=A*30,m=A*365;function w(I,$,y,D){typeof I!="number"&&(I=I.getTime());const u=Math.round((new Date().getTime()-I)/1e3);if(u<-30)return(0,E.localize)(0,null,w(new Date().getTime()+u*1e3,!1));if(!D&&u<30)return(0,E.localize)(1,null);let g;return u<F?(g=u,$?g===1?y?(0,E.localize)(2,null,g):(0,E.localize)(3,null,g):y?(0,E.localize)(4,null,g):(0,E.localize)(5,null,g):g===1?y?(0,E.localize)(6,null,g):(0,E.localize)(7,null,g):y?(0,E.localize)(8,null,g):(0,E.localize)(9,null,g)):u<f?(g=Math.floor(u/F),$?g===1?y?(0,E.localize)(10,null,g):(0,E.localize)(11,null,g):y?(0,E.localize)(12,null,g):(0,E.localize)(13,null,g):g===1?y?(0,E.localize)(14,null,g):(0,E.localize)(15,null,g):y?(0,E.localize)(16,null,g):(0,E.localize)(17,null,g)):u<A?(g=Math.floor(u/f),$?g===1?y?(0,E.localize)(18,null,g):(0,E.localize)(19,null,g):y?(0,E.localize)(20,null,g):(0,E.localize)(21,null,g):g===1?y?(0,E.localize)(22,null,g):(0,E.localize)(23,null,g):y?(0,E.localize)(24,null,g):(0,E.localize)(25,null,g)):u<M?(g=Math.floor(u/A),$?g===1?(0,E.localize)(26,null,g):(0,E.localize)(27,null,g):g===1?(0,E.localize)(28,null,g):(0,E.localize)(29,null,g)):u<b?(g=Math.floor(u/M),$?g===1?y?(0,E.localize)(30,null,g):(0,E.localize)(31,null,g):y?(0,E.localize)(32,null,g):(0,E.localize)(33,null,g):g===1?y?(0,E.localize)(34,null,g):(0,E.localize)(35,null,g):y?(0,E.localize)(36,null,g):(0,E.localize)(37,null,g)):u<m?(g=Math.floor(u/b),$?g===1?y?(0,E.localize)(38,null,g):(0,E.localize)(39,null,g):y?(0,E.localize)(40,null,g):(0,E.localize)(41,null,g):g===1?y?(0,E.localize)(42,null,g):(0,E.localize)(43,null,g):y?(0,E.localize)(44,null,g):(0,E.localize)(45,null,g)):(g=Math.floor(u/m),$?g===1?y?(0,E.localize)(46,null,g):(0,E.localize)(47,null,g):y?(0,E.localize)(48,null,g):(0,E.localize)(49,null,g):g===1?y?(0,E.localize)(50,null,g):(0,E.localize)(51,null,g):y?(0,E.localize)(52,null,g):(0,E.localize)(53,null,g))}e.$rm=w;function L(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$sm=L}),define(Se[193],ke([11,12]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Se[44],ke([1,0,19,18,193]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function A(I,$){return $&&(I.stack||I.stacktrace)?f.localize(0,null,b(I),M(I.stack)||M(I.stacktrace)):b(I)}function M(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?f.localize(1,null,I.message):I.message||f.localize(2,null)}function m(I=null,$=!1){if(!I)return f.localize(3,null);if(Array.isArray(I)){const y=E.$Hb(I),D=m(y[0],$);return y.length>1?f.localize(4,null,D,y.length):D}if(F.$Ef(I))return I;if(I.detail){const y=I.detail;if(y.error)return A(y.error,$);if(y.exception)return A(y.exception,$)}return I.stack?A(I,$):I.message?I.message:f.localize(5,null)}e.$Mi=m;function w(I){const $=I;return $ instanceof Error&&Array.isArray($.actions)}e.$Ni=w;function L(I,$){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=$,y}e.$Oi=L}),define(Se[194],ke([11,12]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Se[133],ke([1,0,19,24,9,177,130,194]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var m;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(he){this.c=he}hasChanged(he){return this.c[he]}}e.ConfigurationChangedEvent=w;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class I{constructor(he,Ie,Ke,Ye){this.id=he,this.name=Ie,this.defaultValue=Ke,this.schema=Ye}applyUpdate(he,Ie){return y(he,Ie)}compute(he,Ie,Ke){return Ke}}class ${constructor(he,Ie){this.newValue=he,this.didChange=Ie}}e.ApplyUpdateResult=$;function y(ne,he){if(typeof ne!="object"||typeof he!="object"||!ne||!he)return new $(he,ne!==he);if(Array.isArray(ne)||Array.isArray(he)){const Ke=Array.isArray(ne)&&Array.isArray(he)&&E.$ub(ne,he);return new $(he,!Ke)}let Ie=!1;for(const Ke in he)if(he.hasOwnProperty(Ke)){const Ye=y(ne[Ke],he[Ke]);Ye.didChange&&(ne[Ke]=Ye.newValue,Ie=!0)}return new $(ne,Ie)}class D{constructor(he){this.schema=void 0,this.id=he,this.name="_never_",this.defaultValue=void 0}applyUpdate(he,Ie){return y(he,Ie)}validate(he){return this.defaultValue}}class u{constructor(he,Ie,Ke,Ye){this.id=he,this.name=Ie,this.defaultValue=Ke,this.schema=Ye}applyUpdate(he,Ie){return y(he,Ie)}validate(he){return typeof he>"u"?this.defaultValue:he}compute(he,Ie,Ke){return Ke}}function g(ne,he){return typeof ne>"u"?he:ne==="false"?!1:!!ne}e.boolean=g;class o extends u{constructor(he,Ie,Ke,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=Ke),super(he,Ie,Ke,Ye)}validate(he){return g(he,this.defaultValue)}}function n(ne,he,Ie,Ke){if(typeof ne>"u")return he;let Ye=parseInt(ne,10);return isNaN(Ye)?he:(Ye=Math.max(Ie,Ye),Ye=Math.min(Ke,Ye),Ye|0)}e.clampedInt=n;class i extends u{static clampedInt(he,Ie,Ke,Ye){return n(he,Ie,Ke,Ye)}constructor(he,Ie,Ke,Ye,it,at=void 0){typeof at<"u"&&(at.type="integer",at.default=Ke,at.minimum=Ye,at.maximum=it),super(he,Ie,Ke,at),this.minimum=Ye,this.maximum=it}validate(he){return i.clampedInt(he,this.defaultValue,this.minimum,this.maximum)}}function s(ne,he,Ie,Ke){if(typeof ne>"u")return he;const Ye=a.float(ne,he);return a.clamp(Ye,Ie,Ke)}e.clampedFloat=s;class a extends u{static clamp(he,Ie,Ke){return he<Ie?Ie:he>Ke?Ke:he}static float(he,Ie){if(typeof he=="number")return he;if(typeof he>"u")return Ie;const Ke=parseFloat(he);return isNaN(Ke)?Ie:Ke}constructor(he,Ie,Ke,Ye,it){typeof it<"u"&&(it.type="number",it.default=Ke),super(he,Ie,Ke,it),this.validationFn=Ye}validate(he){return this.validationFn(a.float(he,this.defaultValue))}}class t extends u{static string(he,Ie){return typeof he!="string"?Ie:he}constructor(he,Ie,Ke,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=Ke),super(he,Ie,Ke,Ye)}validate(he){return t.string(he,this.defaultValue)}}function r(ne,he,Ie,Ke){return typeof ne!="string"?he:Ke&&ne in Ke?Ke[ne]:Ie.indexOf(ne)===-1?he:ne}e.stringSet=r;class d extends u{constructor(he,Ie,Ke,Ye,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Ye,it.default=Ke),super(he,Ie,Ke,it),this.c=Ye}validate(he){return r(he,this.defaultValue,this.c)}}class l extends I{constructor(he,Ie,Ke,Ye,it,at,je=void 0){typeof je<"u"&&(je.type="string",je.enum=it,je.default=Ye),super(he,Ie,Ke,je),this.c=it,this.d=at}validate(he){return typeof he!="string"?this.defaultValue:this.c.indexOf(he)===-1?this.defaultValue:this.d(he)}}function h(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(he){switch(he){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(he,Ie,Ke){return Ke===0?he.accessibilitySupport:Ke}}class v extends I{constructor(){const he={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",he,{"editor.comments.insertSpace":{type:"boolean",default:he.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:he.ignoreEmptyLines,description:b.localize(5,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{insertSpace:g(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function S(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function k(ne){switch(ne){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function C(ne){switch(ne){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class j extends D{constructor(){super(140)}compute(he,Ie,Ke){const Ye=["monaco-editor"];return Ie.get(39)&&Ye.push(Ie.get(39)),he.extraEditorClassName&&Ye.push(he.extraEditorClassName),Ie.get(73)==="default"?Ye.push("mouse-default"):Ie.get(73)==="copy"&&Ye.push("mouse-copy"),Ie.get(110)&&Ye.push("showUnused"),Ie.get(138)&&Ye.push("showDeprecated"),Ye.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(he,Ie,Ke){return Ke&&he.emptySelectionClipboard}}class O extends I{constructor(){const he={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",he,{"editor.find.cursorMoveOnType":{type:"boolean",default:he.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:he.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:he.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:he.globalFindClipboard,description:b.localize(16,null),included:f.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:he.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:he.loop,description:b.localize(18,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{cursorMoveOnType:g(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof he.seedSearchStringFromSelection=="boolean"?he.seedSearchStringFromSelection?"always":"never":r(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof he.autoFindInSelection=="boolean"?he.autoFindInSelection?"always":"never":r(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ie.loop,this.defaultValue.loop)}}}class U extends I{constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"?U.OFF:he==="true"?U.ON:he:he?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class N extends I{constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"?N.OFF:he==="true"?N.TRANSLATE:he:he?N.TRANSLATE:N.OFF}compute(he,Ie,Ke){return he.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class R extends D{constructor(){super(50)}compute(he,Ie,Ke){return he.fontInfo}}class T extends u{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(he){const Ie=a.float(he,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(he,Ie,Ke){return he.fontInfo.fontSize}}class q extends I{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.d,maximum:q.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(he){return he==="normal"||he==="bold"?he:String(i.clampedInt(he,e.EDITOR_FONT_DEFAULTS.fontWeight,q.d,q.e))}}q.c=["normal","bold","100","200","300","400","500","600","700","800","900"],q.d=1,q.e=1e3;class ee extends I{constructor(){const he={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:he.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",he,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:he.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:he.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:he.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:he.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:he.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{multiple:r(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??r(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??r(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??r(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??r(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??r(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class J extends I{constructor(){const he={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",he,{"editor.hover.enabled":{type:"boolean",default:he.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:he.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:he.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:he.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:he.above,description:b.localize(46,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{enabled:g(Ie.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:g(Ie.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Ie.above,this.defaultValue.above)}}}var K;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(K||(e.RenderMinimap=K={}));class Z extends D{constructor(){super(143)}compute(he,Ie,Ke){return Z.computeLayout(Ie,{memory:he.memory,outerWidth:he.outerWidth,outerHeight:he.outerHeight,isDominatedByLongLines:he.isDominatedByLongLines,lineHeight:he.fontInfo.lineHeight,viewLineCount:he.viewLineCount,lineNumbersDigitCount:he.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:he.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:he.fontInfo.maxDigitWidth,pixelRatio:he.pixelRatio,glyphMarginDecorationLaneCount:he.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(he){const Ie=he.height/he.lineHeight,Ke=Math.floor(he.paddingTop/he.lineHeight);let Ye=Math.floor(he.paddingBottom/he.lineHeight);he.scrollBeyondLastLine&&(Ye=Math.max(Ye,Ie-1));const it=(Ke+he.viewLineCount+Ye)/(he.pixelRatio*he.height),at=Math.floor(he.viewLineCount/it);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ye,desiredRatio:it,minimapLineCount:at}}static c(he,Ie){const Ke=he.outerWidth,Ye=he.outerHeight,it=he.pixelRatio;if(!he.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const at=Ie.stableMinimapLayoutInput,je=at&&he.outerHeight===at.outerHeight&&he.lineHeight===at.lineHeight&&he.typicalHalfwidthCharacterWidth===at.typicalHalfwidthCharacterWidth&&he.pixelRatio===at.pixelRatio&&he.scrollBeyondLastLine===at.scrollBeyondLastLine&&he.paddingTop===at.paddingTop&&he.paddingBottom===at.paddingBottom&&he.minimap.enabled===at.minimap.enabled&&he.minimap.side===at.minimap.side&&he.minimap.size===at.minimap.size&&he.minimap.showSlider===at.minimap.showSlider&&he.minimap.renderCharacters===at.minimap.renderCharacters&&he.minimap.maxColumn===at.minimap.maxColumn&&he.minimap.scale===at.minimap.scale&&he.verticalScrollbarWidth===at.verticalScrollbarWidth&&he.isViewportWrapping===at.isViewportWrapping,Et=he.lineHeight,It=he.typicalHalfwidthCharacterWidth,Ht=he.scrollBeyondLastLine,Kt=he.minimap.renderCharacters;let yt=it>=2?Math.round(he.minimap.scale*2):he.minimap.scale;const Gt=he.minimap.maxColumn,zt=he.minimap.size,ni=he.minimap.side,Jt=he.verticalScrollbarWidth,Ft=he.viewLineCount,tt=he.remainingWidth,Bt=he.isViewportWrapping,Zt=Kt?2:3;let dt=Math.floor(it*Ye);const $t=dt/it;let Nt=!1,Tt=!1,St=Zt*yt,ft=yt/it,Lt=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:pt,extraLinesBeforeFirstLine:Ot,extraLinesBeyondLastLine:Fe,desiredRatio:Ne,minimapLineCount:Ce}=Z.computeContainedMinimapLineCount({viewLineCount:Ft,scrollBeyondLastLine:Ht,paddingTop:he.paddingTop,paddingBottom:he.paddingBottom,height:Ye,lineHeight:Et,pixelRatio:it});if(Ft/Ce>1)Nt=!0,Tt=!0,yt=1,St=1,ft=yt/it;else{let Te=!1,Ve=yt+1;if(zt==="fit"){const _e=Math.ceil((Ot+Ft+Fe)*St);Bt&&je&&tt<=Ie.stableFitRemainingWidth?(Te=!0,Ve=Ie.stableFitMaxMinimapScale):Te=_e>dt}if(zt==="fill"||Te){Nt=!0;const _e=yt;St=Math.min(Et*it,Math.max(1,Math.floor(1/Ne))),Bt&&je&&tt<=Ie.stableFitRemainingWidth&&(Ve=Ie.stableFitMaxMinimapScale),yt=Math.min(Ve,Math.max(1,Math.floor(St/Zt))),yt>_e&&(Lt=Math.min(2,yt/_e)),ft=yt/it/Lt,dt=Math.ceil(Math.max(pt,Ot+Ft+Fe)*St),Bt?(Ie.stableMinimapLayoutInput=he,Ie.stableFitRemainingWidth=tt,Ie.stableFitMaxMinimapScale=yt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const _t=Math.floor(Gt*ft),Pt=Math.min(_t,Math.max(0,Math.floor((tt-Jt-2)*ft/(It+ft)))+e.MINIMAP_GUTTER_WIDTH);let Ze=Math.floor(it*Pt);const Wt=Ze/it;Ze=Math.floor(Ze*Lt);const Xt=Kt?1:2,Yt=ni==="left"?0:Ke-Pt-Jt;return{renderMinimap:Xt,minimapLeft:Yt,minimapWidth:Pt,minimapHeightIsEditorHeight:Nt,minimapIsSampling:Tt,minimapScale:yt,minimapLineHeight:St,minimapCanvasInnerWidth:Ze,minimapCanvasInnerHeight:dt,minimapCanvasOuterWidth:Wt,minimapCanvasOuterHeight:$t}}static computeLayout(he,Ie){const Ke=Ie.outerWidth|0,Ye=Ie.outerHeight|0,it=Ie.lineHeight|0,at=Ie.lineNumbersDigitCount|0,je=Ie.typicalHalfwidthCharacterWidth,Et=Ie.maxDigitWidth,It=Ie.pixelRatio,Ht=Ie.viewLineCount,Kt=he.get(135),yt=Kt==="inherit"?he.get(134):Kt,Gt=yt==="inherit"?he.get(130):yt,zt=he.get(133),ni=Ie.isDominatedByLongLines,Jt=he.get(57),Ft=he.get(67).renderType!==0,tt=he.get(68),Bt=he.get(104),Zt=he.get(83),dt=he.get(72),$t=he.get(102),Nt=$t.verticalScrollbarSize,Tt=$t.verticalHasArrows,St=$t.arrowSize,ft=$t.horizontalScrollbarSize,Lt=he.get(43),_t=he.get(109)!=="never";let Pt=he.get(65);Lt&&_t&&(Pt+=16);let Ze=0;if(Ft){const st=Math.max(at,tt);Ze=Math.round(st*Et)}let Wt=0;Jt&&(Wt=it*Ie.glyphMarginDecorationLaneCount);let Xt=0,Yt=Xt+Wt,pt=Yt+Ze,Ot=pt+Pt;const Fe=Ke-Wt-Ze-Pt;let Ne=!1,Ce=!1,oe=-1;yt==="inherit"&&ni?(Ne=!0,Ce=!0):Gt==="on"||Gt==="bounded"?Ce=!0:Gt==="wordWrapColumn"&&(oe=zt);const Te=Z.c({outerWidth:Ke,outerHeight:Ye,lineHeight:it,typicalHalfwidthCharacterWidth:je,pixelRatio:It,scrollBeyondLastLine:Bt,paddingTop:Zt.top,paddingBottom:Zt.bottom,minimap:dt,verticalScrollbarWidth:Nt,viewLineCount:Ht,remainingWidth:Fe,isViewportWrapping:Ce},Ie.memory||new L);Te.renderMinimap!==0&&Te.minimapLeft===0&&(Xt+=Te.minimapWidth,Yt+=Te.minimapWidth,pt+=Te.minimapWidth,Ot+=Te.minimapWidth);const Ve=Fe-Te.minimapWidth,_e=Math.max(1,Math.floor((Ve-Nt-2)/je)),Je=Tt?St:0;return Ce&&(oe=Math.max(1,_e),Gt==="bounded"&&(oe=Math.min(oe,zt))),{width:Ke,height:Ye,glyphMarginLeft:Xt,glyphMarginWidth:Wt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Yt,lineNumbersWidth:Ze,decorationsLeft:pt,decorationsWidth:Pt,contentLeft:Ot,contentWidth:Ve,minimap:Te,viewportColumn:_e,isWordWrapMinified:Ne,isViewportWrapping:Ce,wrappingColumn:oe,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:ft,overviewRuler:{top:Je,width:Nt,height:Ye-2*Je,right:0}}}}e.EditorLayoutInfoComputer=Z;class ae extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(he){return r(he,"simple",["simple","advanced"])}compute(he,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}var _;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(_||(e.ShowAiIconMode=_={}));class ye extends I{constructor(){const he={enabled:!0,experimental:{showAiIcon:_.Off}};super(64,"lightbulb",he,{"editor.lightbulb.enabled":{type:"boolean",default:he.enabled,description:b.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[_.Off,_.OnCode,_.On],default:he.experimental.showAiIcon,enumDescriptions:[b.localize(51,null),b.localize(52,null),b.localize(53,null)],description:b.localize(54,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{enabled:g(Ie.enabled,this.defaultValue.enabled),experimental:{showAiIcon:r(Ie.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[_.Off,_.OnCode,_.On])}}}}class ge extends I{constructor(){const he={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",he,{"editor.stickyScroll.enabled":{type:"boolean",default:he.enabled,description:b.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:he.maxLineCount,minimum:1,maximum:10,description:b.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:he.defaultModel,description:b.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:he.scrollWithEditor,description:b.localize(58,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{enabled:g(Ie.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends I{constructor(){const he={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",he,{"editor.inlayHints.enabled":{type:"string",default:he.enabled,description:b.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(60,null),b.localize(61,null,f.$d?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null,f.$d?"Ctrl+Option":"Ctrl+Alt"),b.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:he.fontSize,markdownDescription:b.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:he.fontFamily,markdownDescription:b.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:he.padding,description:b.localize(66,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:r(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:g(Ie.padding,this.defaultValue.padding)}}}class W extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(he){return typeof he=="string"&&/^\d+(\.\d+)?ch$/.test(he)?-parseFloat(he.substring(0,he.length-2)):i.clampedInt(he,this.defaultValue,0,1e3)}compute(he,Ie,Ke){return Ke<0?i.clampedInt(-Ke*he.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ce extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,he=>a.clamp(he,0,150),{markdownDescription:b.localize(67,null)})}compute(he,Ie,Ke){return he.fontInfo.lineHeight}}class me extends I{constructor(){const he={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",he,{"editor.minimap.enabled":{type:"boolean",default:he.enabled,description:b.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:he.autohide,description:b.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(70,null),b.localize(71,null),b.localize(72,null)],default:he.size,description:b.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:he.side,description:b.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:he.showSlider,description:b.localize(75,null)},"editor.minimap.scale":{type:"number",default:he.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:he.renderCharacters,description:b.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:he.maxColumn,description:b.localize(78,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{enabled:g(Ie.enabled,this.defaultValue.enabled),autohide:g(Ie.autohide,this.defaultValue.autohide),size:r(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ie.side,this.defaultValue.side,["right","left"]),showSlider:r(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ie.scale,1,1,3),maxColumn:i.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(ne){return ne==="ctrlCmd"?f.$d?"metaKey":"ctrlKey":"altKey"}class de extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(80,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{top:i.clampedInt(Ie.top,0,0,1e3),bottom:i.clampedInt(Ie.bottom,0,0,1e3)}}}class Y extends I{constructor(){const he={enabled:!0,cycle:!0};super(85,"parameterHints",he,{"editor.parameterHints.enabled":{type:"boolean",default:he.enabled,description:b.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:he.cycle,description:b.localize(82,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{enabled:g(Ie.enabled,this.defaultValue.enabled),cycle:g(Ie.cycle,this.defaultValue.cycle)}}}class X extends D{constructor(){super(141)}compute(he,Ie,Ke){return he.pixelRatio}}class Q extends I{constructor(){const he={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(83,null),b.localize(84,null),b.localize(85,null)]}];super(88,"quickSuggestions",he,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:he.strings,description:b.localize(86,null)},comments:{anyOf:Ie,default:he.comments,description:b.localize(87,null)},other:{anyOf:Ie,default:he.other,description:b.localize(88,null)}},default:he,markdownDescription:b.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=he}validate(he){if(typeof he=="boolean"){const It=he?"on":"off";return{comments:It,strings:It,other:It}}if(!he||typeof he!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ye}=he,it=["on","inline","off"];let at,je,Et;return typeof Ie=="boolean"?at=Ie?"on":"off":at=r(Ie,this.defaultValue.other,it),typeof Ke=="boolean"?je=Ke?"on":"off":je=r(Ke,this.defaultValue.comments,it),typeof Ye=="boolean"?Et=Ye?"on":"off":Et=r(Ye,this.defaultValue.strings,it),{other:at,comments:je,strings:Et}}}var te;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class $e extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(90,null),b.localize(91,null),b.localize(92,null),b.localize(93,null)],default:"on",description:b.localize(94,null)})}validate(he){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof he<"u"&&(typeof he=="function"?(Ie=4,Ke=he):he==="interval"?Ie=3:he==="relative"?Ie=2:he==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function ve(ne){const he=ne.get(97);return he==="editable"?ne.get(90):he!=="on"}e.filterValidationDecorations=ve;class Le extends I{constructor(){const he=[],Ie={type:"number",description:b.localize(95,null)};super(101,"rulers",he,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(96,null),format:"color-hex"}}}]},default:he,description:b.localize(97,null)})}validate(he){if(Array.isArray(he)){const Ie=[];for(const Ke of he)if(typeof Ke=="number")Ie.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ye=Ke;Ie.push({column:i.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return Ie.sort((Ke,Ye)=>Ke.column-Ye.column),Ie}return this.defaultValue}}class pe extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(he){return!he||typeof he!="object"?this.defaultValue:he}}function De(ne,he){if(typeof ne!="string")return he;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const he={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",he,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(102,null),b.localize(103,null),b.localize(104,null)],default:"auto",description:b.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:he.verticalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:he.horizontalScrollbarSize,description:b.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:he.scrollByPage,description:b.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:he.ignoreHorizontalScrollbarInContentHeight,description:b.localize(109,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he,Ke=i.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=i.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Ie.vertical,this.defaultValue.vertical),horizontal:De(Ie.horizontal,this.defaultValue.horizontal),useShadows:g(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:i.clampedInt(Ie.verticalSliderSize,Ye,0,1e3),scrollByPage:g(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends I{constructor(){const he={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",he,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.nonBasicASCII,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:he.invisibleCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:he.ambiguousCharacters,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeComments,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeStrings,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:he.allowedCharacters,description:b.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:he.allowedLocales,description:b.localize(116,null)}})}applyUpdate(he,Ie){let Ke=!1;Ie.allowedCharacters&&he&&(F.$mn(he.allowedCharacters,Ie.allowedCharacters)||(he={...he,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&he&&(F.$mn(he.allowedLocales,Ie.allowedLocales)||(he={...he,allowedLocales:Ie.allowedLocales},Ke=!0));const Ye=super.applyUpdate(he,Ie);return Ke?new $(Ye.newValue,!0):Ye}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{nonBasicASCII:fe(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:fe(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:fe(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(he.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(he.allowedLocales,this.defaultValue.allowedLocales)}}c(he,Ie){if(typeof he!="object"||!he)return Ie;const Ke={};for(const[Ye,it]of Object.entries(he))it===!0&&(Ke[Ye]=!0);return Ke}}class se extends I{constructor(){const he={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",he,{"editor.inlineSuggest.enabled":{type:"boolean",default:he.enabled,description:b.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:he.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(118,null),b.localize(119,null),b.localize(120,null)],description:b.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:he.suppressSuggestions,description:b.localize(122,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{enabled:g(Ie.enabled,this.defaultValue.enabled),mode:r(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class H extends I{constructor(){const he={enabled:A.$es.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$es.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",he,{"editor.bracketPairColorization.enabled":{type:"boolean",default:he.enabled,markdownDescription:b.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:he.independentColorPoolPerBracketType,description:b.localize(124,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{enabled:g(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ue extends I{constructor(){const he={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",he,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(125,null),b.localize(126,null),b.localize(127,null)],default:he.bracketPairs,description:b.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(129,null),b.localize(130,null),b.localize(131,null)],default:he.bracketPairsHorizontal,description:b.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:he.highlightActiveBracketPair,description:b.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:he.indentation,description:b.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:he.highlightActiveIndentation,description:b.localize(138,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{bracketPairs:fe(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:fe(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:fe(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function fe(ne,he,Ie){const Ke=Ie.indexOf(ne);return Ke===-1?he:Ie[Ke]}class Re extends I{constructor(){const he={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",he,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(139,null),b.localize(140,null)],default:he.insertMode,description:b.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:he.filterGraceful,description:b.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:he.localityBonus,description:b.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:he.shareSuggestSelections,markdownDescription:b.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null),b.localize(148,null)],default:he.selectionMode,markdownDescription:b.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:he.snippetsPreventQuickSuggestions,description:b.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:he.showIcons,description:b.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:he.showStatusBar,description:b.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:he.preview,description:b.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:he.showInlineDetails,description:b.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{insertMode:r(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ie.preview,this.defaultValue.preview),previewMode:r(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ie.showMethods,this.defaultValue.showMethods),showFunctions:g(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ie.showFields,this.defaultValue.showFields),showVariables:g(Ie.showVariables,this.defaultValue.showVariables),showClasses:g(Ie.showClasses,this.defaultValue.showClasses),showStructs:g(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ie.showModules,this.defaultValue.showModules),showProperties:g(Ie.showProperties,this.defaultValue.showProperties),showEvents:g(Ie.showEvents,this.defaultValue.showEvents),showOperators:g(Ie.showOperators,this.defaultValue.showOperators),showUnits:g(Ie.showUnits,this.defaultValue.showUnits),showValues:g(Ie.showValues,this.defaultValue.showValues),showConstants:g(Ie.showConstants,this.defaultValue.showConstants),showEnums:g(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ie.showKeywords,this.defaultValue.showKeywords),showWords:g(Ie.showWords,this.defaultValue.showWords),showColors:g(Ie.showColors,this.defaultValue.showColors),showFiles:g(Ie.showFiles,this.defaultValue.showFiles),showReferences:g(Ie.showReferences,this.defaultValue.showReferences),showFolders:g(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ie.showUsers,this.defaultValue.showUsers),showIssues:g(Ie.showIssues,this.defaultValue.showIssues)}}}class Oe extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(188,null),default:!0,type:"boolean"}})}validate(he){return!he||typeof he!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(he.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(he.selectSubwords,this.defaultValue.selectSubwords)}}}var Ge;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(Ge||(e.WrappingIndent=Ge={}));class He extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(189,null),b.localize(190,null),b.localize(191,null),b.localize(192,null)],description:b.localize(193,null),default:"same"}})}validate(he){switch(he){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(he,Ie,Ke){return Ie.get(2)===2?0:Ke}}class et extends D{constructor(){super(144)}compute(he,Ie,Ke){const Ye=Ie.get(143);return{isDominatedByLongLines:he.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class lt extends I{constructor(){const he={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",he,{"editor.dropIntoEditor.enabled":{type:"boolean",default:he.enabled,markdownDescription:b.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(196,null),b.localize(197,null)],default:"afterDrop"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{enabled:g(Ie.enabled,this.defaultValue.enabled),showDropSelector:r(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ct extends I{constructor(){const he={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",he,{"editor.pasteAs.enabled":{type:"boolean",default:he.enabled,markdownDescription:b.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(200,null),b.localize(201,null)],default:"afterPaste"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const Ie=he;return{enabled:g(Ie.enabled,this.defaultValue.enabled),showPasteSelector:r(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ot="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$d?Pe:f.$e?Ue:ot,fontWeight:"normal",fontSize:f.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Xe;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.letterSpacing=63]="letterSpacing",ne[ne.lightbulb=64]="lightbulb",ne[ne.lineDecorationsWidth=65]="lineDecorationsWidth",ne[ne.lineHeight=66]="lineHeight",ne[ne.lineNumbers=67]="lineNumbers",ne[ne.lineNumbersMinChars=68]="lineNumbersMinChars",ne[ne.linkedEditing=69]="linkedEditing",ne[ne.links=70]="links",ne[ne.matchBrackets=71]="matchBrackets",ne[ne.minimap=72]="minimap",ne[ne.mouseStyle=73]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=75]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=77]="multiCursorModifier",ne[ne.multiCursorPaste=78]="multiCursorPaste",ne[ne.multiCursorLimit=79]="multiCursorLimit",ne[ne.occurrencesHighlight=80]="occurrencesHighlight",ne[ne.overviewRulerBorder=81]="overviewRulerBorder",ne[ne.overviewRulerLanes=82]="overviewRulerLanes",ne[ne.padding=83]="padding",ne[ne.pasteAs=84]="pasteAs",ne[ne.parameterHints=85]="parameterHints",ne[ne.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=88]="quickSuggestions",ne[ne.quickSuggestionsDelay=89]="quickSuggestionsDelay",ne[ne.readOnly=90]="readOnly",ne[ne.readOnlyMessage=91]="readOnlyMessage",ne[ne.renameOnType=92]="renameOnType",ne[ne.renderControlCharacters=93]="renderControlCharacters",ne[ne.renderFinalNewline=94]="renderFinalNewline",ne[ne.renderLineHighlight=95]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=97]="renderValidationDecorations",ne[ne.renderWhitespace=98]="renderWhitespace",ne[ne.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ne[ne.roundedSelection=100]="roundedSelection",ne[ne.rulers=101]="rulers",ne[ne.scrollbar=102]="scrollbar",ne[ne.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=104]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=105]="scrollPredominantAxis",ne[ne.selectionClipboard=106]="selectionClipboard",ne[ne.selectionHighlight=107]="selectionHighlight",ne[ne.selectOnLineNumbers=108]="selectOnLineNumbers",ne[ne.showFoldingControls=109]="showFoldingControls",ne[ne.showUnused=110]="showUnused",ne[ne.snippetSuggestions=111]="snippetSuggestions",ne[ne.smartSelect=112]="smartSelect",ne[ne.smoothScrolling=113]="smoothScrolling",ne[ne.stickyScroll=114]="stickyScroll",ne[ne.stickyTabStops=115]="stickyTabStops",ne[ne.stopRenderingLineAfter=116]="stopRenderingLineAfter",ne[ne.suggest=117]="suggest",ne[ne.suggestFontSize=118]="suggestFontSize",ne[ne.suggestLineHeight=119]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ne[ne.suggestSelection=121]="suggestSelection",ne[ne.tabCompletion=122]="tabCompletion",ne[ne.tabIndex=123]="tabIndex",ne[ne.unicodeHighlighting=124]="unicodeHighlighting",ne[ne.unusualLineTerminators=125]="unusualLineTerminators",ne[ne.useShadowDOM=126]="useShadowDOM",ne[ne.useTabStops=127]="useTabStops",ne[ne.wordBreak=128]="wordBreak",ne[ne.wordSeparators=129]="wordSeparators",ne[ne.wordWrap=130]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=133]="wordWrapColumn",ne[ne.wordWrapOverride1=134]="wordWrapOverride1",ne[ne.wordWrapOverride2=135]="wordWrapOverride2",ne[ne.wrappingIndent=136]="wrappingIndent",ne[ne.wrappingStrategy=137]="wrappingStrategy",ne[ne.showDeprecated=138]="showDeprecated",ne[ne.inlayHints=139]="inlayHints",ne[ne.editorClassName=140]="editorClassName",ne[ne.pixelRatio=141]="pixelRatio",ne[ne.tabFocusMode=142]="tabFocusMode",ne[ne.layoutInfo=143]="layoutInfo",ne[ne.wrappingInfo=144]="wrappingInfo",ne[ne.defaultColorDecorators=145]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(202,null)})),acceptSuggestionOnEnter:Ae(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(203,null),""],markdownDescription:b.localize(204,null)})),accessibilitySupport:Ae(new c),accessibilityPageSize:Ae(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(205,null),tags:["accessibility"]})),ariaLabel:Ae(new t(4,"ariaLabel",b.localize(206,null))),ariaRequired:Ae(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(208,null),b.localize(209,null),""],description:b.localize(210,null)})),autoClosingComments:Ae(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(211,null),b.localize(212,null),""],description:b.localize(213,null)})),autoClosingDelete:Ae(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(214,null),""],description:b.localize(215,null)})),autoClosingOvertype:Ae(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(216,null),""],description:b.localize(217,null)})),autoClosingQuotes:Ae(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(218,null),b.localize(219,null),""],description:b.localize(220,null)})),autoIndent:Ae(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null),b.localize(224,null),b.localize(225,null)],description:b.localize(226,null)})),automaticLayout:Ae(new o(13,"automaticLayout",!1)),autoSurround:Ae(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(227,null),b.localize(228,null),b.localize(229,null),""],description:b.localize(230,null)})),bracketPairColorization:Ae(new H),bracketPairGuides:Ae(new ue),stickyTabStops:Ae(new o(115,"stickyTabStops",!1,{description:b.localize(231,null)})),codeLens:Ae(new o(17,"codeLens",!0,{description:b.localize(232,null)})),codeLensFontFamily:Ae(new t(18,"codeLensFontFamily","",{description:b.localize(233,null)})),codeLensFontSize:Ae(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(234,null)})),colorDecorators:Ae(new o(20,"colorDecorators",!0,{description:b.localize(235,null)})),colorDecoratorActivatedOn:Ae(new d(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(236,null),b.localize(237,null),b.localize(238,null)],description:b.localize(239,null)})),colorDecoratorsLimit:Ae(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(240,null)})),columnSelection:Ae(new o(22,"columnSelection",!1,{description:b.localize(241,null)})),comments:Ae(new v),contextmenu:Ae(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(242,null)})),cursorBlinking:Ae(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],S,{description:b.localize(243,null)})),cursorSmoothCaretAnimation:Ae(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(244,null),b.localize(245,null),b.localize(246,null)],description:b.localize(247,null)})),cursorStyle:Ae(new l(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(248,null)})),cursorSurroundingLines:Ae(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(249,null)})),cursorSurroundingLinesStyle:Ae(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(250,null),b.localize(251,null)],markdownDescription:b.localize(252,null)})),cursorWidth:Ae(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(253,null)})),disableLayerHinting:Ae(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new o(34,"domReadOnly",!1)),dragAndDrop:Ae(new o(35,"dragAndDrop",!0,{description:b.localize(254,null)})),emptySelectionClipboard:Ae(new z),dropIntoEditor:Ae(new lt),stickyScroll:Ae(new ge),experimentalWhitespaceRendering:Ae(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(255,null),b.localize(256,null),b.localize(257,null)],description:b.localize(258,null)})),extraEditorClassName:Ae(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ae(new a(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:b.localize(259,null)})),find:Ae(new O),fixedOverflowWidgets:Ae(new o(42,"fixedOverflowWidgets",!1)),folding:Ae(new o(43,"folding",!0,{description:b.localize(260,null)})),foldingStrategy:Ae(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(261,null),b.localize(262,null)],description:b.localize(263,null)})),foldingHighlight:Ae(new o(45,"foldingHighlight",!0,{description:b.localize(264,null)})),foldingImportsByDefault:Ae(new o(46,"foldingImportsByDefault",!1,{description:b.localize(265,null)})),foldingMaximumRegions:Ae(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(266,null)})),unfoldOnClickAfterEndOfLine:Ae(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(267,null)})),fontFamily:Ae(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(268,null)})),fontInfo:Ae(new R),fontLigatures2:Ae(new U),fontSize:Ae(new T),fontWeight:Ae(new q),fontVariations:Ae(new N),formatOnPaste:Ae(new o(55,"formatOnPaste",!1,{description:b.localize(269,null)})),formatOnType:Ae(new o(56,"formatOnType",!1,{description:b.localize(270,null)})),glyphMargin:Ae(new o(57,"glyphMargin",!0,{description:b.localize(271,null)})),gotoLocation:Ae(new ee),hideCursorInOverviewRuler:Ae(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(272,null)})),hover:Ae(new J),inDiffEditor:Ae(new o(61,"inDiffEditor",!1)),letterSpacing:Ae(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>a.clamp(ne,-5,20),{description:b.localize(273,null)})),lightbulb:Ae(new ye),lineDecorationsWidth:Ae(new W),lineHeight:Ae(new ce),lineNumbers:Ae(new $e),lineNumbersMinChars:Ae(new i(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new o(69,"linkedEditing",!1,{description:b.localize(274,null)})),links:Ae(new o(70,"links",!0,{description:b.localize(275,null)})),matchBrackets:Ae(new d(71,"matchBrackets","always",["always","near","never"],{description:b.localize(276,null)})),minimap:Ae(new me),mouseStyle:Ae(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new a(74,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:b.localize(277,null)})),mouseWheelZoom:Ae(new o(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(278,null)})),multiCursorMergeOverlapping:Ae(new o(76,"multiCursorMergeOverlapping",!0,{description:b.localize(279,null)})),multiCursorModifier:Ae(new l(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[b.localize(280,null),b.localize(281,null)],markdownDescription:b.localize(282,null)})),multiCursorPaste:Ae(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),multiCursorLimit:Ae(new i(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(286,null)})),occurrencesHighlight:Ae(new d(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(287,null),b.localize(288,null),b.localize(289,null)],markdownDescription:b.localize(290,null)})),overviewRulerBorder:Ae(new o(81,"overviewRulerBorder",!0,{description:b.localize(291,null)})),overviewRulerLanes:Ae(new i(82,"overviewRulerLanes",3,0,3)),padding:Ae(new de),pasteAs:Ae(new ct),parameterHints:Ae(new Y),peekWidgetDefaultFocus:Ae(new d(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(292,null),b.localize(293,null)],description:b.localize(294,null)})),definitionLinkOpensInPeek:Ae(new o(87,"definitionLinkOpensInPeek",!1,{description:b.localize(295,null)})),quickSuggestions:Ae(new Q),quickSuggestionsDelay:Ae(new i(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(296,null)})),readOnly:Ae(new o(90,"readOnly",!1)),readOnlyMessage:Ae(new pe),renameOnType:Ae(new o(92,"renameOnType",!1,{description:b.localize(297,null),markdownDeprecationMessage:b.localize(298,null)})),renderControlCharacters:Ae(new o(93,"renderControlCharacters",!0,{description:b.localize(299,null),restricted:!0})),renderFinalNewline:Ae(new d(94,"renderFinalNewline",f.$e?"dimmed":"on",["off","on","dimmed"],{description:b.localize(300,null)})),renderLineHighlight:Ae(new d(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(301,null)],description:b.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Ae(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(303,null)})),renderValidationDecorations:Ae(new d(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new d(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(304,null),b.localize(305,null),b.localize(306,null),""],description:b.localize(307,null)})),revealHorizontalRightPadding:Ae(new i(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new o(100,"roundedSelection",!0,{description:b.localize(308,null)})),rulers:Ae(new Le),scrollbar:Ae(new B),scrollBeyondLastColumn:Ae(new i(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(309,null)})),scrollBeyondLastLine:Ae(new o(104,"scrollBeyondLastLine",!0,{description:b.localize(310,null)})),scrollPredominantAxis:Ae(new o(105,"scrollPredominantAxis",!0,{description:b.localize(311,null)})),selectionClipboard:Ae(new o(106,"selectionClipboard",!0,{description:b.localize(312,null),included:f.$e})),selectionHighlight:Ae(new o(107,"selectionHighlight",!0,{description:b.localize(313,null)})),selectOnLineNumbers:Ae(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new d(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(314,null),b.localize(315,null),b.localize(316,null)],description:b.localize(317,null)})),showUnused:Ae(new o(110,"showUnused",!0,{description:b.localize(318,null)})),showDeprecated:Ae(new o(138,"showDeprecated",!0,{description:b.localize(319,null)})),inlayHints:Ae(new re),snippetSuggestions:Ae(new d(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(320,null),b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),smartSelect:Ae(new Oe),smoothScrolling:Ae(new o(113,"smoothScrolling",!1,{description:b.localize(325,null)})),stopRenderingLineAfter:Ae(new i(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new Re),inlineSuggest:Ae(new se),inlineCompletionsAccessibilityVerbose:Ae(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(326,null)})),suggestFontSize:Ae(new i(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new i(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new o(120,"suggestOnTriggerCharacters",!0,{description:b.localize(329,null)})),suggestSelection:Ae(new d(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabCompletion:Ae(new d(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),tabIndex:Ae(new i(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new x),unusualLineTerminators:Ae(new d(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),useShadowDOM:Ae(new o(126,"useShadowDOM",!0)),useTabStops:Ae(new o(127,"useTabStops",!0,{description:b.localize(342,null)})),wordBreak:Ae(new d(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null)],description:b.localize(345,null)})),wordSeparators:Ae(new t(129,"wordSeparators",M.$fs,{description:b.localize(346,null)})),wordWrap:Ae(new d(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null),b.localize(350,null)],description:b.localize(351,null)})),wordWrapBreakAfterCharacters:Ae(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new i(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(352,null)})),wordWrapOverride1:Ae(new d(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new d(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new j),defaultColorDecorators:Ae(new o(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(353,null)})),pixelRatio:Ae(new X),tabFocusMode:Ae(new o(142,"tabFocusMode",!1,{markdownDescription:b.localize(354,null)})),layoutInfo:Ae(new Z),wrappingInfo:Ae(new et),wrappingIndent:Ae(new He),wrappingStrategy:Ae(new ae)}}),define(Se[195],ke([11,12]),function(ie,e){return ie.create("vs/editor/common/languages",e)}),define(Se[83],ke([1,0,78,2,173,29,188,195]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$zt=e.$yt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$xt=e.$wt=e.SymbolKinds=e.SymbolTag=e.$vt=e.$ut=e.SymbolKind=e.$tt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$st=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$rt=e.$qt=e.$pt=void 0;class m{constructor(U,N,R){this.offset=U,this.type=N,this.language=R,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$pt=m;class w{constructor(U,N){this.tokens=U,this.endState=N,this._tokenizationResultBrand=void 0}}e.$qt=w;class L{constructor(U,N){this.tokens=U,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$rt=L;var I;(function(O){O[O.Method=0]="Method",O[O.Function=1]="Function",O[O.Constructor=2]="Constructor",O[O.Field=3]="Field",O[O.Variable=4]="Variable",O[O.Class=5]="Class",O[O.Struct=6]="Struct",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Event=10]="Event",O[O.Operator=11]="Operator",O[O.Unit=12]="Unit",O[O.Value=13]="Value",O[O.Constant=14]="Constant",O[O.Enum=15]="Enum",O[O.EnumMember=16]="EnumMember",O[O.Keyword=17]="Keyword",O[O.Text=18]="Text",O[O.Color=19]="Color",O[O.File=20]="File",O[O.Reference=21]="Reference",O[O.Customcolor=22]="Customcolor",O[O.Folder=23]="Folder",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue",O[O.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var $;(function(O){const U=new Map;U.set(0,E.$8j.symbolMethod),U.set(1,E.$8j.symbolFunction),U.set(2,E.$8j.symbolConstructor),U.set(3,E.$8j.symbolField),U.set(4,E.$8j.symbolVariable),U.set(5,E.$8j.symbolClass),U.set(6,E.$8j.symbolStruct),U.set(7,E.$8j.symbolInterface),U.set(8,E.$8j.symbolModule),U.set(9,E.$8j.symbolProperty),U.set(10,E.$8j.symbolEvent),U.set(11,E.$8j.symbolOperator),U.set(12,E.$8j.symbolUnit),U.set(13,E.$8j.symbolValue),U.set(15,E.$8j.symbolEnum),U.set(14,E.$8j.symbolConstant),U.set(15,E.$8j.symbolEnum),U.set(16,E.$8j.symbolEnumMember),U.set(17,E.$8j.symbolKeyword),U.set(27,E.$8j.symbolSnippet),U.set(18,E.$8j.symbolText),U.set(19,E.$8j.symbolColor),U.set(20,E.$8j.symbolFile),U.set(21,E.$8j.symbolReference),U.set(22,E.$8j.symbolCustomColor),U.set(23,E.$8j.symbolFolder),U.set(24,E.$8j.symbolTypeParameter),U.set(25,E.$8j.account),U.set(26,E.$8j.issues);function N(q){let ee=U.get(q);return ee||(console.info("No codicon found for CompletionItemKind "+q),ee=E.$8j.symbolProperty),ee}O.toIcon=N;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function T(q,ee){let J=R.get(q);return typeof J>"u"&&!ee&&(J=9),J}O.fromString=T})($||(e.CompletionItemKinds=$={}));var y;(function(O){O[O.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var D;(function(O){O[O.None=0]="None",O[O.KeepWhitespace=1]="KeepWhitespace",O[O.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var u;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(e.CompletionTriggerKind=u={}));var g;(function(O){O[O.Automatic=0]="Automatic",O[O.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class o{constructor(U,N,R,T){this.range=U,this.text=N,this.completionKind=R,this.isSnippetText=T}equals(U){return A.$Hs.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.$st=o;var n;(function(O){O[O.Invoke=1]="Invoke",O[O.Auto=2]="Auto"})(n||(e.CodeActionTriggerType=n={}));var i;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(i||(e.SignatureHelpTriggerKind=i={}));var s;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function a(O){return O&&F.URI.isUri(O.uri)&&A.$Hs.isIRange(O.range)&&(A.$Hs.isIRange(O.originSelectionRange)||A.$Hs.isIRange(O.targetSelectionRange))}e.$tt=a;var t;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$ut={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function r(O,U){return(0,b.localize)(26,null,O,e.$ut[U])}e.$vt=r;var d;(function(O){O[O.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var l;(function(O){const U=new Map;U.set(0,E.$8j.symbolFile),U.set(1,E.$8j.symbolModule),U.set(2,E.$8j.symbolNamespace),U.set(3,E.$8j.symbolPackage),U.set(4,E.$8j.symbolClass),U.set(5,E.$8j.symbolMethod),U.set(6,E.$8j.symbolProperty),U.set(7,E.$8j.symbolField),U.set(8,E.$8j.symbolConstructor),U.set(9,E.$8j.symbolEnum),U.set(10,E.$8j.symbolInterface),U.set(11,E.$8j.symbolFunction),U.set(12,E.$8j.symbolVariable),U.set(13,E.$8j.symbolConstant),U.set(14,E.$8j.symbolString),U.set(15,E.$8j.symbolNumber),U.set(16,E.$8j.symbolBoolean),U.set(17,E.$8j.symbolArray),U.set(18,E.$8j.symbolObject),U.set(19,E.$8j.symbolKey),U.set(20,E.$8j.symbolNull),U.set(21,E.$8j.symbolEnumMember),U.set(22,E.$8j.symbolStruct),U.set(23,E.$8j.symbolEvent),U.set(24,E.$8j.symbolOperator),U.set(25,E.$8j.symbolTypeParameter);function N(R){let T=U.get(R);return T||(console.info("No codicon found for SymbolKind "+R),T=E.$8j.symbolProperty),T}O.toIcon=N})(l||(e.SymbolKinds=l={}));class h{static asEditOperation(U){return f.$Is.replace(A.$Hs.lift(U.range),U.text)}}e.$wt=h;class c{static fromValue(U){switch(U){case"comment":return c.Comment;case"imports":return c.Imports;case"region":return c.Region}return new c(U)}constructor(U){this.value=U}}e.$xt=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var v;(function(O){function U(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}O.is=U})(v||(e.Command=v={}));var P;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(P||(e.CommentThreadCollapsibleState=P={}));var S;(function(O){O[O.Unresolved=0]="Unresolved",O[O.Resolved=1]="Resolved"})(S||(e.CommentThreadState=S={}));var p;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var k;(function(O){O[O.Published=0]="Published",O[O.Draft=1]="Draft"})(k||(e.CommentState=k={}));var C;(function(O){O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(C||(e.InlayHintKind=C={}));class j{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$yt=j,e.$zt=new M.$gt;var z;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(Se[196],ke([11,12]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[197],ke([11,12]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[198],ke([11,12]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(Se[199],ke([11,12]),function(ie,e){return ie.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[200],ke([11,12]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[201],ke([11,12]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[202],ke([11,12]),function(ie,e){return ie.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[203],ke([11,12]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Se[204],ke([11,12]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(Se[205],ke([11,12]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[206],ke([11,12]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Se[207],ke([11,12]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[208],ke([11,12]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[209],ke([11,12]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Se[210],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[211],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[212],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[213],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[214],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[215],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[216],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[217],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[218],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[219],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[220],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[221],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[222],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[223],ke([11,12]),function(ie,e){return ie.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[224],ke([11,12]),function(ie,e){return ie.create("vs/workbench/common/configuration",e)}),define(Se[225],ke([11,12]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Se[226],ke([11,12]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(Se[227],ke([11,12]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[228],ke([11,12]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[229],ke([11,12]),function(ie,e){return ie.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[230],ke([11,12]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[231],ke([11,12]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[232],ke([11,12]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[233],ke([11,12]),function(ie,e){return ie.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[234],ke([11,12]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[235],ke([11,12]),function(ie,e){return ie.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[236],ke([11,12]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[237],ke([1,0,8,198]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var f;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(f||(e.TokenType=f={}));function A(...w){switch(w.length){case 1:return(0,F.localize)(0,null,w[0]);case 2:return(0,F.localize)(1,null,w[0],w[1]);case 3:return(0,F.localize)(2,null,w[0],w[1],w[2]);default:return}}const M=(0,F.localize)(3,null),b=(0,F.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const I=this.d,$=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:$};this.g.push({offset:I,lexeme:$,additionalInfo:L}),this.f.push(y)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const I=this.c.substring(this.d,this.e),$=m.b.get(I);$?this.k($):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,I=!1,$=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(b);return}const D=this.c.charCodeAt(L);if(I)I=!1;else if(D===47&&!$){L++;break}else D===91?$=!0:D===92?I=!0:D===93&&($=!1);L++}for(;L<this.c.length&&m.a.has(this.c.charCodeAt(L));)L++;this.e=L;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=m,m.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0))),m.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Se[238],ke([1,0,23,40,201,385]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function m(o){return o=o.trim(),o==="*"||M.test(o)}e.$Zo=m;function w(o){if(!m(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$1o=w;function L(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,s=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let r=o.patchMustEqual;o.hasCaret&&(n===0||(a=!1),r=!1);let d=0;if(o.preRelease){const l=b.exec(o.preRelease);if(l){const[,h,c,v]=l;d=Date.UTC(Number(h),Number(c)-1,Number(v))}}return{majorBase:n,majorMustEqual:i,minorBase:s,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:o.hasGreaterEquals,notBefore:d}}e.$2o=L;function I(o,n,i){let s;typeof o=="string"?s=L(w(o)):s=o;let a;n instanceof Date?a=n.getTime():typeof n=="string"&&(a=new Date(n).getTime());let t;if(typeof i=="string"?t=L(w(i)):t=i,!s||!t)return!1;const r=s.majorBase,d=s.minorBase,l=s.patchBase;let h=t.majorBase,c=t.minorBase,v=t.patchBase;const P=t.notBefore;let S=t.majorMustEqual,p=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?r>h?!0:r<h?!1:d>c?!0:d<c||a&&a<P?!1:l>=v:(r===1&&h===0&&(!S||!p||!k)&&(h=1,c=0,v=0,S=!0,p=!1,k=!1),r<h?!1:r>h?!S:d<c?!1:d>c?!p:l<v?!1:l>v?!k:!(a&&a<P))}e.$3o=I;function $(o,n,i,s,a){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([F.default.Error,f.localize(0,null)]),t;if(typeof s.name!="string")return t.push([F.default.Error,f.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([F.default.Error,f.localize(2,null,"version")]),t;if(!s.engines)return t.push([F.default.Error,f.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([F.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!g(s.extensionDependencies))return t.push([F.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!g(s.activationEvents))return t.push([F.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([F.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([F.default.Warning,f.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([F.default.Error,f.localize(9,null,"main")]),t;{const l=(0,E.$Dg)(i,s.main);(0,E.$xg)(l,i)||t.push([F.default.Warning,f.localize(10,null,l.path,i.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([F.default.Error,f.localize(11,null,"browser")]),t;{const l=(0,E.$Dg)(i,s.browser);(0,E.$xg)(l,i)||t.push([F.default.Warning,f.localize(12,null,l.path,i.path)])}}if(!A.valid(s.version))return t.push([F.default.Error,f.localize(13,null)]),t;const r=[];if(!y(o,n,s,a,r))for(const l of r)t.push([F.default.Error,l]);return t}e.$4o=$;function y(o,n,i,s,a){return s||typeof i.main>"u"&&typeof i.browser>"u"?!0:u(o,n,i.engines.vscode,a)}e.$5o=y;function D(o,n,i){return o==="*"||u(n,i,o)}e.$6o=D;function u(o,n,i,s=[]){const a=L(w(i));if(!a)return s.push(f.localize(14,null,i)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return s.push(f.localize(15,null,i)),!1}else if(!a.majorMustEqual)return s.push(f.localize(16,null,i)),!1;return I(o,n,a)?!0:(s.push(f.localize(17,null,o,i)),!1)}function g(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(Se[105],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class E{constructor(f,A=[],M=!1){this.ctor=f,this.staticArguments=A,this.supportsDelayedInstantiation=M}}e.$Yh=E}),define(Se[106],ke([1,0,105]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.InstantiationType=void 0;const F=[];var f;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function A(b,m,w){m instanceof E.$Yh||(m=new E.$Yh(m,[],!!w)),F.push([b,m])}e.$Kr=A;function M(){return F}e.$Lr=M}),define(Se[239],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;class E{constructor(A,M){this.key=A,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$pq=E;class F{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const M of this.a.values())M.outgoing.size===0&&A.push(M);return A}insertEdge(A,M){const b=this.lookupOrInsertNode(A),m=this.lookupOrInsertNode(M);b.outgoing.set(m.key,m),m.incoming.set(b.key,b)}removeNode(A){const M=this.b(A);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(A){const M=this.b(A);let b=this.a.get(M);return b||(b=new E(M,A),this.a.set(M,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[M,b]of this.a)A.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,M]of this.a){const b=new Set([A]),m=this.c(M,b);if(m)return m}}c(A,M){for(const[b,m]of A.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const w=this.c(m,M);if(w)return w;M.delete(b)}}}e.$qq=F}),define(Se[5],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var E;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(m){return m[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(E||(e._util=E={})),e.$1h=f("instantiationService");function F(M,b,m){b[E.DI_TARGET]===b?b[E.DI_DEPENDENCIES].push({id:M,index:m}):(b[E.DI_DEPENDENCIES]=[{id:M,index:m}],b[E.DI_TARGET]=b)}function f(M){if(E.serviceIds.has(M))return E.serviceIds.get(M);const b=function(m,w,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(b,m,L)};return b.toString=()=>M,E.serviceIds.set(M,b),b}e.$2h=f;function A(M){return M}e.$3h=A}),define(Se[45],ke([1,0,18,2,5]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,f.$2h)("configurationService");function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof F.URI)}e.$wi=A;function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof F.URI)}e.$xi=M;var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function m(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=m;function w(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$zi=w;function L(o,n){const i=Object.create(null);for(const s in o)I(i,s,o[s],n);return i}e.$Ai=L;function I(o,n,i,s){const a=n.split("."),t=a.pop();let r=o;for(let d=0;d<a.length;d++){const l=a[d];let h=r[l];switch(typeof h){case"undefined":h=r[l]=Object.create(null);break;case"object":break;default:s(`Ignoring ${n} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(h)}`);return}r=h}if(typeof r=="object"&&r!==null)try{r[t]=i}catch{s(`Ignoring ${n} as ${a.join(".")} is ${JSON.stringify(r)}`)}else s(`Ignoring ${n} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.$Bi=I;function $(o,n){const i=n.split(".");y(o,i)}e.$Ci=$;function y(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const s=o[i];typeof s=="object"&&!Array.isArray(s)&&(y(s,n),Object.keys(s).length===0&&delete o[i])}}function D(o,n,i){function s(r,d){let l=r;for(const h of d){if(typeof l!="object"||l===null)return;l=l[h]}return l}const a=n.split("."),t=s(o,a);return typeof t>"u"?i:t}e.$Di=D;function u(o,n,i){Object.keys(n).forEach(s=>{s!=="__proto__"&&(s in o?E.$Gf(o[s])&&E.$Gf(n[s])?u(o[s],n[s],i):i&&(o[s]=n[s]):o[s]=n[s])})}e.$Ei=u;function g(o){return o.replace(/[\[\]]/g,"")}e.$Fi=g}),define(Se[46],ke([1,0,9,13,237,5,197,8]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",E.$d),m.set("isLinux",E.$e),m.set("isWindows",E.$c),m.set("isWeb",E.$i),m.set("isMacNative",E.$d&&!E.$i),m.set("isEdge",E.$B),m.set("isFirefox",E.$z),m.set("isChrome",E.$y),m.set("isSafari",E.$A);function w(re,W){if(m.get(re)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(re,W)}e.$Xi=w;const L=Object.prototype.hasOwnProperty;var I;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const $={regexParsingWithErrorRecovery:!0},y=(0,M.localize)(0,null),D=(0,M.localize)(1,null),u=(0,M.localize)(2,null),g=(0,M.localize)(3,null),o=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),s=(0,M.localize)(7,null);class a{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=$){this.k=W,this.d=new f.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ce=this.l();if(!this.E()){const me=this.D(),le=me.type===17?n:void 0;throw this.h.push({message:o,offset:me.offset,lexeme:f.$Wi.getLexeme(me),additionalInfo:le}),a.c}return ce}catch(ce){if(ce!==a.c)throw ce;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const ce=this.o();W.push(ce)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const ce=this.s();W.push(ce)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),h.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const ce=this.l();return this.A(1,g),ce?.negate()}case 17:return this.z(),C.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ce=this.l();return this.A(1,g),ce}case 17:{const ce=W.lexeme;if(this.z(),this.y(9)){const le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),le.type!==10)throw this.B("REGEX",le);const de=le.lexeme,Y=de.lastIndexOf("/"),X=Y===de.length-1?void 0:this.w(de.substring(Y+1));let Q;try{Q=new RegExp(de.substring(1,Y),X)}catch{throw this.B("REGEX",le)}return R.create(ce,Q)}switch(le.type){case 10:case 19:{const de=[le.lexeme];this.z();let Y=this.D(),X=0;for(let Le=0;Le<le.lexeme.length;Le++)le.lexeme.charCodeAt(Le)===40?X++:le.lexeme.charCodeAt(Le)===41&&X--;for(;!this.E()&&Y.type!==15&&Y.type!==16;){switch(Y.type){case 0:X++;break;case 1:X--;break;case 10:case 18:for(let Le=0;Le<Y.lexeme.length;Le++)Y.lexeme.charCodeAt(Le)===40?X++:le.lexeme.charCodeAt(Le)===41&&X--}if(X<0)break;de.push(f.$Wi.getLexeme(Y)),this.z(),Y=this.D()}const Q=de.join(""),te=Q.lastIndexOf("/"),$e=te===Q.length-1?void 0:this.w(Q.substring(te+1));let ve;try{ve=new RegExp(Q.substring(1,te),$e)}catch{throw this.B("REGEX",le)}return t.regex(ce,ve)}case 18:{const de=le.lexeme;this.z();let Y=null;if(!(0,F.$Ge)(de)){const X=de.indexOf("/"),Q=de.lastIndexOf("/");if(X!==Q&&X>=0){const te=de.slice(X+1,Q),$e=de[Q+1]==="i"?"i":"";try{Y=new RegExp(te,$e)}catch{throw this.B("REGEX",le)}}}if(Y===null)throw this.B("REGEX",le);return R.create(ce,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,u);const le=this.u();return t.notIn(ce,le)}switch(this.D().type){case 3:{this.z();const le=this.u();if(this.x().type===18)return t.equals(ce,le);switch(le){case"true":return t.has(ce);case"false":return t.not(ce);default:return t.equals(ce,le)}}case 4:{this.z();const le=this.u();if(this.x().type===18)return t.notEquals(ce,le);switch(le){case"true":return t.not(ce);case"false":return t.has(ce);default:return t.notEquals(ce,le)}}case 5:return this.z(),U.create(ce,this.u());case 6:return this.z(),N.create(ce,this.u());case 7:return this.z(),z.create(ce,this.u());case 8:return this.z(),O.create(ce,this.u());case 13:return this.z(),t.in(ce,this.u());default:return t.has(ce)}}case 20:throw this.h.push({message:i,offset:W.offset,lexeme:"",additionalInfo:s}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ce){if(this.C(W))return this.z();throw this.B(ce,this.D())}B(W,ce,me){const le=(0,M.localize)(8,null,W,f.$Wi.getLexeme(ce)),de=ce.offset,Y=f.$Wi.getLexeme(ce);return this.h.push({message:le,offset:de,lexeme:Y,additionalInfo:me}),a.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=a,a.c=new Error;class t{static false(){return h.INSTANCE}static true(){return c.INSTANCE}static has(W){return v.create(W)}static equals(W,ce){return P.create(W,ce)}static notEquals(W,ce){return k.create(W,ce)}static regex(W,ce){return R.create(W,ce)}static in(W,ce){return S.create(W,ce)}static notIn(W,ce){return p.create(W,ce)}static not(W){return C.create(W)}static and(...W){return ee.create(W,null,!0)}static or(...W){return J.create(W,null,!0)}static greater(W,ce){return z.create(W,ce)}static greaterEquals(W,ce){return O.create(W,ce)}static smaller(W,ce){return U.create(W,ce)}static smallerEquals(W,ce){return N.create(W,ce)}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Zi=t,t.c=new a({regexParsingWithErrorRecovery:!1});function r(re){const W=new a({regexParsingWithErrorRecovery:!1});return re.map(ce=>(W.parse(ce),W.lexingErrors.length>0?W.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,M.localize)(9,null,me.additionalInfo):(0,M.localize)(10,null),offset:me.offset,length:me.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.$1i=r;function d(re,W){const ce=re?re.substituteConstants():void 0,me=W?W.substituteConstants():void 0;return!ce&&!me?!0:!ce||!me?!1:ce.equals(me)}e.$2i=d;function l(re,W){return re.cmp(W)}class h{constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return c.INSTANCE}}e.$3i=h,h.INSTANCE=new h;class c{constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return h.INSTANCE}}e.$4i=c,c.INSTANCE=new c;class v{static create(W,ce=null){const me=m.get(W);return typeof me=="boolean"?me?c.INSTANCE:h.INSTANCE:new v(W,ce)}constructor(W,ce){this.key=W,this.c=ce,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:Z(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=m.get(this.key);return typeof W=="boolean"?W?c.INSTANCE:h.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$5i=v;class P{static create(W,ce,me=null){if(typeof ce=="boolean")return ce?v.create(W,me):C.create(W,me);const le=m.get(W);return typeof le=="boolean"?ce===(le?"true":"false")?c.INSTANCE:h.INSTANCE:new P(W,ce,me)}constructor(W,ce,me){this.c=W,this.d=ce,this.f=me,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=m.get(this.c);if(typeof W=="boolean"){const ce=W?"true":"false";return this.d===ce?c.INSTANCE:h.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$6i=P;class S{static create(W,ce){return new S(W,ce)}constructor(W,ce){this.d=W,this.f=ce,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ce=W.getValue(this.f),me=W.getValue(this.d);return Array.isArray(ce)?ce.includes(me):typeof me=="string"&&typeof ce=="object"&&ce!==null?L.call(ce,me):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$7i=S;class p{static create(W,ce){return new p(W,ce)}constructor(W,ce){this.d=W,this.f=ce,this.type=11,this.c=S.create(W,ce)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=p;class k{static create(W,ce,me=null){if(typeof ce=="boolean")return ce?C.create(W,me):v.create(W,me);const le=m.get(W);return typeof le=="boolean"?ce===(le?"true":"false")?h.INSTANCE:c.INSTANCE:new k(W,ce,me)}constructor(W,ce,me){this.c=W,this.d=ce,this.f=me,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=m.get(this.c);if(typeof W=="boolean"){const ce=W?"true":"false";return this.d===ce?h.INSTANCE:c.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$9i=k;class C{static create(W,ce=null){const me=m.get(W);return typeof me=="boolean"?me?h.INSTANCE:c.INSTANCE:new C(W,ce)}constructor(W,ce){this.c=W,this.d=ce,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:Z(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=m.get(this.c);return typeof W=="boolean"?W?h.INSTANCE:c.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$0i=C;function j(re,W){if(typeof re=="string"){const ce=parseFloat(re);isNaN(ce)||(re=ce)}return typeof re=="string"||typeof re=="number"?W(re):h.INSTANCE}class z{static create(W,ce,me=null){return j(ce,le=>new z(W,le,me))}constructor(W,ce,me){this.c=W,this.d=ce,this.f=me,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$$i=z;class O{static create(W,ce,me=null){return j(ce,le=>new O(W,le,me))}constructor(W,ce,me){this.c=W,this.d=ce,this.f=me,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$_i=O;class U{static create(W,ce,me=null){return j(ce,le=>new U(W,le,me))}constructor(W,ce,me){this.c=W,this.d=ce,this.f=me,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$aj=U;class N{static create(W,ce,me=null){return j(ce,le=>new N(W,le,me))}constructor(W,ce,me){this.c=W,this.d=ce,this.f=me,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ae(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$bj=N;class R{static create(W,ce){return new R(W,ce)}constructor(W,ce){this.d=W,this.f=ce,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ce=this.f?this.f.source:"",me=W.f?W.f.source:"";return ce<me?-1:ce>me?1:0}equals(W){if(W.type===this.type){const ce=this.f?this.f.source:"",me=W.f?W.f.source:"";return this.d===W.d&&ce===me}return!1}substituteConstants(){return this}evaluate(W){const ce=W.getValue(this.d);return this.f?this.f.test(ce):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=T.create(this)),this.c}}e.$cj=R;class T{static create(W){return new T(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new T(this.c.map(W))}negate(){return this.c}}e.$dj=T;function q(re){let W=null;for(let ce=0,me=re.length;ce<me;ce++){const le=re[ce].substituteConstants();if(re[ce]!==le&&W===null){W=[];for(let de=0;de<ce;de++)W[de]=re[de]}W!==null&&(W[ce]=le)}return W===null?re:W}class ee{static create(W,ce,me){return ee.d(W,ce,me)}constructor(W,ce){this.expr=W,this.c=ce,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ce=0,me=this.expr.length;ce<me;ce++){const le=l(this.expr[ce],W.expr[ce]);if(le!==0)return le}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ce=0,me=this.expr.length;ce<me;ce++)if(!this.expr[ce].equals(W.expr[ce]))return!1;return!0}return!1}substituteConstants(){const W=q(this.expr);return W===this.expr?this:ee.create(W,this.c,!1)}evaluate(W){for(let ce=0,me=this.expr.length;ce<me;ce++)if(!this.expr[ce].evaluate(W))return!1;return!0}static d(W,ce,me){const le=[];let de=!1;for(const Y of W)if(Y){if(Y.type===1){de=!0;continue}if(Y.type===0)return h.INSTANCE;if(Y.type===6){le.push(...Y.expr);continue}le.push(Y)}if(le.length===0&&de)return c.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(l);for(let Y=1;Y<le.length;Y++)le[Y-1].equals(le[Y])&&(le.splice(Y,1),Y--);if(le.length===1)return le[0];for(;le.length>1;){const Y=le[le.length-1];if(Y.type!==9)break;le.pop();const X=le.pop(),Q=le.length===0,te=J.create(Y.expr.map($e=>ee.create([$e,X],null,me)),null,Q);te&&(le.push(te),le.sort(l))}if(le.length===1)return le[0];if(me){for(let Y=0;Y<le.length;Y++)for(let X=Y+1;X<le.length;X++)if(le[Y].negate().equals(le[X]))return h.INSTANCE;if(le.length===1)return le[0]}return new ee(le,ce)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ce of this.expr)W.push(...ce.keys());return W}map(W){return new ee(this.expr.map(ce=>ce.map(W)),null)}negate(){if(!this.c){const W=[];for(const ce of this.expr)W.push(ce.negate());this.c=J.create(W,this,!0)}return this.c}}e.$ej=ee;class J{static create(W,ce,me){return J.d(W,ce,me)}constructor(W,ce){this.expr=W,this.c=ce,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ce=0,me=this.expr.length;ce<me;ce++){const le=l(this.expr[ce],W.expr[ce]);if(le!==0)return le}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ce=0,me=this.expr.length;ce<me;ce++)if(!this.expr[ce].equals(W.expr[ce]))return!1;return!0}return!1}substituteConstants(){const W=q(this.expr);return W===this.expr?this:J.create(W,this.c,!1)}evaluate(W){for(let ce=0,me=this.expr.length;ce<me;ce++)if(this.expr[ce].evaluate(W))return!0;return!1}static d(W,ce,me){let le=[],de=!1;if(W){for(let Y=0,X=W.length;Y<X;Y++){const Q=W[Y];if(Q){if(Q.type===0){de=!0;continue}if(Q.type===1)return c.INSTANCE;if(Q.type===9){le=le.concat(Q.expr);continue}le.push(Q)}}if(le.length===0&&de)return h.INSTANCE;le.sort(l)}if(le.length!==0){if(le.length===1)return le[0];for(let Y=1;Y<le.length;Y++)le[Y-1].equals(le[Y])&&(le.splice(Y,1),Y--);if(le.length===1)return le[0];if(me){for(let Y=0;Y<le.length;Y++)for(let X=Y+1;X<le.length;X++)if(le[Y].negate().equals(le[X]))return c.INSTANCE;if(le.length===1)return le[0]}return new J(le,ce)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ce of this.expr)W.push(...ce.keys());return W}map(W){return new J(this.expr.map(ce=>ce.map(W)),null)}negate(){if(!this.c){const W=[];for(const ce of this.expr)W.push(ce.negate());for(;W.length>1;){const ce=W.shift(),me=W.shift(),le=[];for(const de of ge(ce))for(const Y of ge(me))le.push(ee.create([de,Y],null,!1));W.unshift(J.create(le,null,!1))}this.c=J.create(W,this,!0)}return this.c}}e.$fj=J;class K extends v{static all(){return K.d.values()}constructor(W,ce,me){super(W,null),this.f=ce,typeof me=="object"?K.d.push({...me,key:W}):me!==!0&&K.d.push({key:W,description:me,type:ce!=null?typeof ce:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return P.create(this.key,W)}notEqualsTo(W){return k.create(this.key,W)}}e.$gj=K,K.d=[],e.$hj=(0,A.$2h)("contextKeyService");function Z(re,W){return re<W?-1:re>W?1:0}function ae(re,W,ce,me){return re<ce?-1:re>ce?1:W<me?-1:W>me?1:0}function _(re,W){if(re.type===0||W.type===1)return!0;if(re.type===9)return W.type===9?ye(re.expr,W.expr):!1;if(W.type===9){for(const ce of W.expr)if(_(re,ce))return!0;return!1}if(re.type===6){if(W.type===6)return ye(W.expr,re.expr);for(const ce of re.expr)if(_(ce,W))return!0;return!1}return re.equals(W)}e.$ij=_;function ye(re,W){let ce=0,me=0;for(;ce<re.length&&me<W.length;){const le=re[ce].cmp(W[me]);if(le<0)return!1;le===0&&ce++,me++}return ce===re.length}function ge(re){return re.type===9?re.expr:[re]}}),define(Se[240],ke([1,0,23,40,199,5,101,9,24]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.ConfirmResult=e.$Tv=e.$Sv=e.$Rv=void 0,e.$Rv=(0,A.$2h)("dialogService");var w;(function(u){u[u.Confirmation=1]="Confirmation",u[u.Prompt=2]="Prompt",u[u.Input=3]="Input"})(w||(w={}));class L{a(g){return this.d(g,w.Confirmation)}b(g){return this.d(g,w.Prompt)}c(g){return this.d(g,w.Input)}d(g,o){const n=[];switch(o){case w.Confirmation:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,f.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,f.localize)(1,null));break}case w.Prompt:{const i=g;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,f.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,f.localize)(3,null))),n.length===0&&n.push((0,f.localize)(4,null));break}case w.Input:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,f.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,f.localize)(6,null));break}}return n}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===F.default.Info?"info":g===F.default.Error?"error":g===F.default.Warning?"warning":"none"}f(g,o,n){const i=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&i.push(g.cancelButton);let s=i[o]?.run({checkboxChecked:n});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:n}}}e.$Sv=L,e.$Tv=(0,A.$2h)("fileDialogService");var I;(function(u){u[u.SAVE=0]="SAVE",u[u.DONT_SAVE=1]="DONT_SAVE",u[u.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const $=10;function y(u){const g=[];return g.push(...u.slice(0,$).map(o=>typeof o=="string"?o:(0,E.$Ag)(o))),u.length>$&&(u.length-$===1?g.push((0,f.localize)(7,null)):g.push((0,f.localize)(8,null,u.length-$))),g.push(""),g.join(`
`)}e.$Uv=y;function D(u,g){const o=(0,m.$in)(u);let n=(o.buttons??[]).map(t=>(0,M.$Ov)(t)),i=(u.buttons||[]).map((t,r)=>r),s=0,a=o.cancelId??n.length-1;if(n.length>1){const t=typeof a=="number"?n[a]:void 0;if(b.$e||b.$d){if(typeof t=="string"&&n.length>1&&a!==1){n.splice(a,1),n.splice(1,0,t);const r=i[a];i.splice(a,1),i.splice(1,0,r),a=1}b.$e&&n.length>1&&(n=n.reverse(),i=i.reverse(),s=n.length-1,typeof t=="string"&&(a=s-1))}else if(b.$c&&typeof t=="string"&&n.length>1&&a!==n.length-1){n.splice(a,1),n.push(t);const r=i[a];i.splice(a,1),i.push(r),a=n.length-1}}return o.buttons=n,o.defaultId=s,o.cancelId=a,o.noLink=!0,o.title=o.title||g.nameLong,{options:o,buttonIndeces:i}}e.$Vv=D}),define(Se[134],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,E.$2h)("environmentService"),e.$0h=(0,E.$3h)(e.$9h)}),define(Se[135],ke([1,0,200,5]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$lo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0,e.$_n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ao=new RegExp(e.$_n),e.$bo="__web_extension",e.$co="skipWalkthrough",e.$do="extensionsSync",e.$eo="dependecyOrPackExtensionInstall";function f(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$fo=f;function A(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$go=A;function M(o,n){switch(o){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$ho=M;function b(o,n){return n==="web"&&!o.includes("web")}e.$io=b;function m(o,n,i){return b(n,i)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===i}e.$jo=m;function w(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$ko=w;var L;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var I;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var $;(function(o){o.Install="install",o.Uninstall="uninstall"})($||(e.StatisticType=$={}));var y;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$lo=(0,F.$2h)("extensionGalleryService");var D;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(D||(e.ExtensionManagementErrorCode=D={}));var u;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class g extends Error{constructor(n,i){super(n),this.code=i,this.name=i}}e.$mo=g,e.$no=(0,F.$2h)("extensionManagementService"),e.$oo="extensionsIdentifiers/disabled",e.$po="extensionsIdentifiers/enabled",e.$qo=(0,F.$2h)("IGlobalExtensionEnablementService"),e.$ro=(0,F.$2h)("IExtensionTipsService"),e.$so=(0,E.localize)(0,null),e.$to={value:e.$so,original:"Extensions"},e.$uo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Se[241],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_1b=e.$$1b=void 0,e.$$1b=(0,E.$2h)("externalTerminal"),e.$_1b="Terminal.app"}),define(Se[242],ke([1,0,50,17,16,9,99,31,103,202,241]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$99b=e.$89b=e.$79b=void 0;const I=w.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await u.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends ${openTerminal(s,a){return this.spawnTerminal(E,s,m.$Pl(),a)}spawnTerminal(s,a,t,r){const d=a.windowsExec||y.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const l=f.$nc(d,".exe").toLowerCase();if(l==="cmder")return s.spawn(d,r?[r]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return d.indexOf(" ")>=0&&h.push('""'),h.push(d),l==="wt"&&h.push("-d ."),new Promise((c,v)=>{const P=g(process),S=s.spawn(t,h,{cwd:r,env:P});S.on("error",v),S.on("exit",()=>c())})}runInTerminal(s,a,t,r,d){const l="windowsExec"in d&&d.windowsExec?d.windowsExec:y.getDefaultTerminalWindows();return new Promise((h,c)=>{const v=`"${a} - ${I}"`,P=`""${t.join('" "')}" & pause"`,S=Object.assign({},g(process),r);Object.keys(S).filter(z=>S[z]===null).forEach(z=>delete S[z]);const p={cwd:a,env:S,windowsVerbatimArguments:!0};let k,C;f.$nc(l,".exe")==="wt"?(k=l,C=["-d",".",y.b,"/c",P]):(k=y.b,C=["/c","start",v,"/wait",l,"/c",P]),E.spawn(k,C,p).on("error",z=>{c(o(z))}),h(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$79b=y,y.b="cmd.exe";class D extends ${openTerminal(s,a){return this.spawnTerminal(E,s,a)}runInTerminal(s,a,t,r,d){const l=d.osxExec||L.$_1b;return new Promise((h,c)=>{if(l===L.$_1b||l==="iTerm.app"){const v=l===L.$_1b?"TerminalHelper":"iTermHelper",S=[F.$kg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",s||I,"-w",a];for(const C of t)S.push("-a"),S.push(C);if(r){const C=Object.assign({},g(process),r);for(const j in C){const z=C[j];z===null?(S.push("-u"),S.push(j)):(S.push("-e"),S.push(`${j}=${z}`))}}let p="";const k=E.spawn(D.b,S);k.on("error",C=>{c(o(C))}),k.stderr.on("data",C=>{p+=C.toString()}),k.on("exit",C=>{if(C===0)h(void 0);else if(p){const j=p.split(`
`,1);c(new Error(j[0]))}else c(new Error(w.localize(1,null,v,C)))})}else c(new Error(w.localize(2,null,l)))})}spawnTerminal(s,a,t){const r=a.osxExec||L.$_1b;return new Promise((d,l)=>{const h=["-a",r];t&&h.push(t);const c=g(process),v=s.spawn("/usr/bin/open",h,{cwd:t,env:c});v.on("error",l),v.on("exit",()=>d())})}}e.$89b=D,D.b="/usr/bin/osascript";class u extends ${openTerminal(s,a){return this.spawnTerminal(E,s,a)}runInTerminal(s,a,t,r,d){const l=d.linuxExec?Promise.resolve(d.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((h,c)=>{const v=[];l.then(P=>{P.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const S=`${n(t)}; echo; read -p "${u.b}" -n1;`;v.push(`''${S}''`);const p=Object.assign({},g(process),r);Object.keys(p).filter(z=>p[z]===null).forEach(z=>delete p[z]);const k={cwd:a,env:p};let C="";const j=E.spawn(P,v,k);j.on("error",z=>{c(o(z))}),j.stderr.on("data",z=>{C+=z.toString()}),j.on("exit",z=>{if(z===0)h(void 0);else if(C){const O=C.split(`
`,1);c(new Error(O[0]))}else c(new Error(w.localize(4,null,P,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!u.d)if(!A.$e)u.d=Promise.resolve("xterm");else{const s=await b.Promises.exists("/etc/debian_version");u.d=new Promise(a=>{s?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return u.d}spawnTerminal(s,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((d,l)=>{r.then(h=>{const c=g(process),v=s.spawn(h,[],{cwd:t,env:c});v.on("error",l),v.on("exit",()=>d())})})}}e.$99b=u,u.b=w.localize(3,null);function g(i){const s={...i.env};return(0,M.$Nl)(s),s}function o(i){return"errno"in i&&i.errno==="ENOENT"&&"path"in i&&typeof i.path=="string"?new Error(w.localize(5,null,i.path)):i}function n(i){let s="";for(const a of i)a.indexOf(" ")>=0?s+='"'+a+'"':s+=a,s+=" ";return s}}),define(Se[32],ke([1,0,77,16,13,18,2,203,5,9,17,43]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileKind=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileOperationResult=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileChangeType=e.$Dk=e.FileOperation=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileSystemProviderErrorCode=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderCapabilities=e.$nk=e.FilePermission=e.FileType=e.$mk=e.$lk=void 0,e.$lk=(0,m.$2h)("fileService");function $(_){return _.create===!0}e.$mk=$;var y;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var D;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(D||(e.FilePermission=D={}));function u(_){const ye=_;return!!ye&&typeof ye.onDidChange=="function"}e.$nk=u;var g;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function o(_){return!!(_.capabilities&2)}e.$ok=o;function n(_){return!!(_.capabilities&8)}e.$pk=n;function i(_){return!!(_.capabilities&131072)}e.$qk=i;function s(_){return!!(_.capabilities&4)}e.$rk=s;function a(_){return!!(_.capabilities&16)}e.$sk=a;function t(_){return o(_)?!!(_.capabilities&16384):!1}e.$tk=t;function r(_){return o(_)?!!(_.capabilities&32768):!1}e.$uk=r;function d(_){return!!(_.capabilities&65536)}e.$vk=d;function l(_){return!!(_.capabilities&2048)}e.$wk=l;var h;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class c extends Error{static create(ye,ge){const re=new c(ye.toString(),ge);return S(re,ge),re}constructor(ye,ge){super(ye),this.code=ge}}e.$xk=c;function v(_,ye){return c.create(_,ye)}e.$yk=v;function P(_){return _||v((0,b.localize)(0,null),h.Unknown)}e.$zk=P;function S(_,ye){return _.name=ye?`${ye} (FileSystemError)`:"FileSystemError",_}e.$Ak=S;function p(_){if(!_)return h.Unknown;if(_ instanceof c)return _.code;const ye=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ye)return h.Unknown;switch(ye[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}e.$Bk=p;function k(_){if(_ instanceof N)return _.fileOperationResult;switch(p(_)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 9;case h.FileWriteLocked:return 5;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileTooLarge:return 7;default:return 10}}e.$Ck=k;var C;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class j{constructor(ye,ge,re){this.resource=ye,this.operation=ge,this.target=re}isOperation(ye){return this.operation===ye}}e.$Dk=j;var z;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class O{constructor(ye,ge){this.c=ge,this.b=void 0,this.d=new I.$V(()=>{const re=E.$8h.forUris(()=>this.c);return re.fill(this.rawAdded.map(W=>[W,!0])),re}),this.f=new I.$V(()=>{const re=E.$8h.forUris(()=>this.c);return re.fill(this.rawUpdated.map(W=>[W,!0])),re}),this.g=new I.$V(()=>{const re=E.$8h.forUris(()=>this.c);return re.fill(this.rawDeleted.map(W=>[W,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of ye){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.b!==O.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=O.a):this.b!==void 0&&(this.b=O.a))}}contains(ye,...ge){return this.h(ye,{includeChildren:!1},...ge)}affects(ye,...ge){return this.h(ye,{includeChildren:!0},...ge)}h(ye,ge,...re){if(!ye)return!1;const W=re.length>0;return!!((!W||re.includes(1))&&(this.d.value.get(ye)||ge.includeChildren&&this.d.value.findSuperstr(ye))||(!W||re.includes(0))&&(this.f.value.get(ye)||ge.includeChildren&&this.f.value.findSuperstr(ye))||(!W||re.includes(2))&&(this.g.value.findSubstr(ye)||ge.includeChildren&&this.g.value.findSuperstr(ye)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ye){return this.b===ye}hasCorrelation(){return typeof this.b=="number"}}e.$Ek=O,O.a=null;function U(_,ye,ge){return!_||!ye||_===ye||ye.length>_.length?!1:(ye.charAt(ye.length-1)!==F.sep&&(ye+=F.sep),ge?(0,f.$9e)(_,ye):_.indexOf(ye)===0)}e.$Fk=U;class N extends Error{constructor(ye,ge,re){super(ye),this.fileOperationResult=ge,this.options=re}}e.$Gk=N;class R extends N{constructor(ye,ge,re,W){super(ye,ge,W),this.fileOperationResult=ge,this.size=re}}e.$Hk=R;class T extends N{constructor(ye,ge,re){super(ye,2,re),this.stat=ge}}e.$Ik=T;var q;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(q||(e.FileOperationResult=q={})),e.$Jk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Kk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Lk="files.associations",e.$Mk="files.exclude",e.$Nk="files.readonlyInclude",e.$Ok="files.readonlyExclude",e.$Pk="files.readonlyFromPermissions";var ee;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$Qk="";function J(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Rk=J;async function K(_,ye){if(!ye.hasProvider(M.URI.from({scheme:_.scheme})))return new Promise(ge=>{const re=ye.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===_.scheme&&W.added&&(re.dispose(),ge())})})}e.$Sk=K;class Z{static formatSize(ye){return(0,A.$If)(ye)||(ye=0),ye<Z.KB?(0,b.localize)(1,null,ye.toFixed(0)):ye<Z.MB?(0,b.localize)(2,null,(ye/Z.KB).toFixed(2)):ye<Z.GB?(0,b.localize)(3,null,(ye/Z.MB).toFixed(2)):ye<Z.TB?(0,b.localize)(4,null,(ye/Z.GB).toFixed(2)):(0,b.localize)(5,null,(ye/Z.TB).toFixed(2))}}e.$Tk=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;function ae(_){const ye=typeof _=="string"||_?.scheme===L.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===L.Schemas.file?1024*Z.MB:ye?10*Z.MB:w.$i?50*Z.MB:1024*Z.MB}e.$Uk=ae}),define(Se[243],ke([1,0,22,8,204,32]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;async function M(L,I,$,y,D,u){let g;try{await b(L,I,$,y,D,u)}catch(o){g=o}finally{g&&D.errorTransformer&&(g=D.errorTransformer(g)),typeof g<"u"&&$.error(g),$.end()}}e.$1p=M;async function b(L,I,$,y,D,u){m(u);const g=await L.open(I,{create:!1});try{m(u);let o=0,n=0,i=D&&typeof D.length=="number"?D.length:void 0,s=E.$ge.alloc(Math.min(D.bufferSize,typeof i=="number"?i:D.bufferSize)),a=D&&typeof D.position=="number"?D.position:0,t=0;do n=await L.read(g,a,s.buffer,t,s.byteLength-t),a+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===s.byteLength&&(await $.write(y(s)),s=E.$ge.alloc(Math.min(D.bufferSize,typeof i=="number"?i:D.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&m(u)&&w(o,D));if(t>0){let r=t;typeof i=="number"&&(r=Math.min(t,i)),$.write(y(s.slice(0,r)))}}catch(o){throw(0,A.$zk)(o)}finally{await L.close(g)}}function m(L){if(L.isCancellationRequested)throw(0,F.$6)();return!0}function w(L,I){if(typeof I?.limits?.size=="number"&&L>I.limits.size)throw(0,A.$yk)((0,f.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],ke([1,0,34,3,16,9,2,32]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=void 0;function m(o){return o.recursive===!0}e.$3p=m;class w extends F.$Sc{constructor(n,i,s,a){super(),this.h=n,this.j=i,this.m=s,this.n=a,this.c=this.B(new F.$Tc),this.f=void 0,this.g=0}s(){const n=new F.$Rc;this.c.value=n,this.b=this.r(n),this.b.setVerboseLogging(this.m),n.add(this.b.onDidChangeFile(i=>this.h(i))),n.add(this.b.onDidLogMessage(i=>this.j(i))),n.add(this.b.onDidError(i=>this.t(i)))}t(n){this.n.restartOnError?this.g<w.a&&this.f?(this.w(`restarting watcher after error: ${n}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${n}`):this.w(n)}u(n){this.g++,this.s(),this.watch(n)}async watch(n){this.f=n,await this.b?.watch(n)}async setVerboseLogging(n){this.m=n,await this.b?.setVerboseLogging(n)}w(n){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${n}`})}y(n){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${n}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4p=w,w.a=5;class L extends w{constructor(n,i,s){super(n,i,s,{type:"node.js",restartOnError:!1})}}e.$5p=L;class I extends w{constructor(n,i,s){super(n,i,s,{type:"universal",restartOnError:!0})}}e.$6p=I;function $(o){return o.map(n=>({type:n.type,resource:M.URI.revive(n.resource),cId:n.cId}))}e.$7p=$;function y(o){const n=new g;for(const i of o)n.processEvent(i);return n.coalesce()}e.$8p=y;function D(o,n){return typeof n=="string"&&!n.startsWith(E.$Ej)&&!(0,f.$ic)(n)?{base:o,pattern:n}:n}e.$9p=D;function u(o,n){const i=[];for(const s of n)i.push((0,E.$Ij)(D(o,s)));return i}e.$0p=u;class g{constructor(){this.a=new Set,this.b=new Map}c(n){return A.$e?n.resource.fsPath:n.resource.fsPath.toLowerCase()}processEvent(n){const i=this.b.get(this.c(n));let s=!1;if(i){const a=i.type,t=n.type;i.resource.fsPath!==n.resource.fsPath&&(n.type===2||n.type===1)?s=!0:a===1&&t===2?(this.b.delete(this.c(n)),this.a.delete(i)):a===2&&t===1?i.type=0:a===1&&t===0||(i.type=t)}else s=!0;s&&(this.a.add(n),this.b.set(this.c(n),n))}coalesce(){const n=[],i=[];return Array.from(this.a).filter(s=>s.type!==2?(n.push(s),!1):!0).sort((s,a)=>s.resource.fsPath.length-a.resource.fsPath.length).filter(s=>i.some(a=>(0,b.$Fk)(s.resource.fsPath,a,!A.$e))?!1:(i.push(s.resource.fsPath),!0)).concat(n)}}}),define(Se[244],ke([1,0,55,10,21,33,3,76,16,9,23,2,102,31,84]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=void 0;class u extends M.$Sc{constructor(n,i,s,a){super(),this.m=n,this.n=i,this.r=s,this.s=a,this.c=this.B(new F.$eh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$dh(t=>this.z(t),u.b)),this.g=(0,D.$0p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,D.$0p)(this.m.path,this.m.includes):void 0,this.j=new f.$3d,this.ready=this.t()}async t(){try{const n=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const i=await y.Promises.stat(n);this.B(await this.w(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.D(n):this.G(n)}}async u(n){let i=n.path;try{i=await y.Promises.realpath(n.path),n.path===i&&(i=await(0,$.$hq)(n.path)??n.path),n.path!==i&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async w(n,i){if(w.$d&&(0,A.$4f)(n,"/Volumes/",!0))return this.D(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.$Sc.None;const s=new f.$3d(this.j.token),a=new M.$Rc;try{const t=I.URI.file(this.m.path),r=(0,m.$nc)(n),d=(0,E.watch)(n);a.add((0,M.$Qc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${n}'`);const l=new Set;if(i)try{for(const c of await y.Promises.readdir(n))l.add(c)}catch(c){this.D(c)}const h=new Map;a.add((0,M.$Qc)(()=>{for(const[,c]of h)c.dispose();h.clear()})),d.on("error",(c,v)=>{this.D(`Failed to watch ${n} for changes using fs.watch() (${c}, ${v})`),this.dispose()}),d.on("change",(c,v)=>{if(s.token.isCancellationRequested)return;this.G(`[raw] ["${c}"] ${v}`);let P="";if(v&&(P=v.toString(),w.$d&&(P=(0,b.$Cl)(P))),!(!P||c!=="change"&&c!=="rename"))if(i)if(c==="rename"){h.get(P)?.dispose();const S=setTimeout(async()=>{if(h.delete(P),P===r&&!await y.Promises.exists(n)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,m.$jc)(n,P));if(s.token.isCancellationRequested)return;let k;p?l.has(P)?k=0:(k=1,l.add(P)):(l.delete(P),k=2),this.y({resource:(0,L.$Dg)(t,P),type:k,cId:this.m.correlationId})},u.a);h.set(P,(0,M.$Qc)(()=>clearTimeout(S)))}else{let S;l.has(P)?S=0:(S=1,l.add(P)),this.y({resource:(0,L.$Dg)(t,P),type:S,cId:this.m.correlationId})}else if(c==="rename"||P!==r){const S=setTimeout(async()=>{const p=await y.Promises.exists(n);s.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(n,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},u.a);a.clear(),a.add((0,M.$Qc)(()=>clearTimeout(S)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(n)&&!s.token.isCancellationRequested&&this.D(`Failed to watch ${n} for changes using fs.watch() (${t.toString()})`)}return(0,M.$Qc)(()=>{s.dispose(!0),a.dispose()})}y(n,i=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(s=>s(n.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(s=>s(n.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}z(n){const i=(0,D.$8p)(n);if(i.length>0){if(this.s)for(const a of i)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(n){if(w.$e)return y.Promises.exists(n);try{const i=(0,m.$nc)(n);return(await y.Promises.readdir((0,m.$mc)(n))).some(a=>a===i)}catch(i){return this.G(i),!1}}setVerboseLogging(n){this.s=n}D(n){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}F(n){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}G(n){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$kq=u,u.a=100,u.b=75;async function g(o,n,i,s,a=512){const t=await y.Promises.open(o,"r"),r=Buffer.allocUnsafe(a),d=new f.$3d(s);let l,h=!1;const c={path:o,excludes:[],recursive:!1},v=new u(c,P=>{(async()=>{for(const{type:S}of P)if(S===0){if(h)return;h=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:p}=await y.Promises.read(t,r,0,a,null);if(!p||d.token.isCancellationRequested)break;n(r.slice(0,p))}}catch(p){l=new Error(p),d.dispose(!0)}finally{h=!1}}})()});return await v.ready,i(),new Promise((P,S)=>{d.token.onCancellationRequested(async()=>{v.dispose();try{await y.Promises.close(t)}catch(p){l=new Error(p)}l?S(l):P()})})}e.$lq=g}),define(Se[245],ke([1,0,4,34,3,9,244]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class b extends f.$Sc{constructor(){super(...arguments),this.a=this.B(new E.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new E.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(w){const L=this.j(w),I=L.filter(y=>{const D=this.c.get(y.path);return D?!(0,F.$Mj)(D.request.excludes,y.excludes)||!(0,F.$Mj)(D.request.includes,y.includes):!0}),$=Array.from(this.c.values()).filter(({request:y})=>!L.find(D=>D.path===y.path&&(0,F.$Mj)(D.excludes,y.excludes)&&(0,F.$Mj)(D.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.m(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const y of $)this.h(y);for(const y of I)this.g(y)}g(w){const L=new M.$kq(w,$=>this.a.fire($),$=>this.b.fire($),this.f),I={request:w,instance:L};this.c.set(w.path,I)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const L=this.c.get(w);L&&(this.c.delete(w),L.instance.dispose())}j(w){const L=new Map;for(const I of w){const $=A.$e?I.path:I.path.toLowerCase();let y=L.get(I.correlationId);y||(y=new Map,L.set(I.correlationId,y)),y.set($,I)}return Array.from(L.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(w){this.f=w;for(const[,L]of this.c)L.instance.setVerboseLogging(w)}m(w){this.f&&this.b.fire({type:"trace",message:this.n(w)})}n(w,L){return L?`[File Watcher (node.js)] ${w} (path: ${L.request.path})`:`[File Watcher (node.js)] ${w}`}}e.$mq=b}),define(Se[246],ke([1,0,84,245]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class f extends E.$5p{constructor(M,b,m){super(M,b,m),this.s()}r(M){return M.add(new F.$mq)}}e.$nq=f}),define(Se[247],ke([1,0,17,80,170,84]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class M extends A.$6p{constructor(m,w,L){super(m,w,L),this.s()}r(m){const w=m.add(new f.$eq(E.$kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(w.onDidProcessExit(({code:L,signal:I})=>this.t(`terminated by itself with code ${L}, signal: ${I}`))),F.ProxyChannel.toService((0,F.$Ih)(w.getChannel("watcher")))}}e.$fq=M}),define(Se[107],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class E{constructor(...f){this.a=new Map;for(const[A,M]of f)this.set(A,M)}set(f,A){const M=this.a.get(f);return this.a.set(f,A),M}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$Zh=E}),define(Se[248],ke([1,0,10,8,3,105,239,5,107,75]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;const L=!1;class I extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class ${constructor(g=new m.$Zh,o=!1,n,i=L){this.f=g,this.g=o,this.h=n,this.i=i,this.o=new Set,this.f.set(b.$1h,this),this._globalGraph=i?n?._globalGraph??new M.$qq(s=>s):void 0}createChild(g){return new $(g,this.g,this,this.i)}invokeFunction(g,...o){const n=D.traceInvocation(this.i,g);let i=!1;try{return g({get:a=>{if(i)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,n);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(g,...o){let n,i;return g instanceof A.$Yh?(n=D.traceCreation(this.i,g.ctor),i=this.j(g.ctor,g.staticArguments.concat(o),n)):(n=D.traceCreation(this.i,g),i=this.j(g,o,n)),n.stop(),i}j(g,o=[],n){const i=b._util.getServiceDependencies(g).sort((t,r)=>t.index-r.index),s=[];for(const t of i){const r=this.m(t.id,n);r||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(r)}const a=i.length>0?i[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${g.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(g,o.concat(s))}k(g,o){if(this.f.get(g)instanceof A.$Yh)this.f.set(g,o);else if(this.h)this.h.k(g,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const o=this.f.get(g);return!o&&this.h?this.h.l(g):o}m(g,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const n=this.l(g);return n instanceof A.$Yh?this.q(g,n,o.branch(g,!0)):(o.branch(g,!1),n)}q(g,o,n){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,o,n)}finally{this.o.delete(g)}}r(g,o,n){const i=new M.$qq(t=>t.id.toString());let s=0;const a=[{id:g,desc:o,_trace:n}];for(;a.length;){const t=a.pop();if(i.lookupOrInsertNode(t),s++>1e3)throw new I(i);for(const r of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(r.id);if(d||this.u(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),d instanceof A.$Yh){const l={id:r.id,desc:d,_trace:t._trace.branch(r.id,!0)};i.insertEdge(t,l),a.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new I(i);break}for(const{data:r}of t){if(this.l(r.id)instanceof A.$Yh){const l=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,l)}i.removeNode(r)}}return this.l(g)}s(g,o,n=[],i,s){if(this.f.get(g)instanceof A.$Yh)return this.t(g,o,n,i,s);if(this.h)return this.h.s(g,o,n,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(g,o,n=[],i,s){if(i){const a=new $(void 0,this.g,this,this.i);a.c=String(g);const t=new Map,r=new E.$ih(()=>{const d=a.j(o,n,s);for(const[l,h]of t){const c=d[l];if(typeof c=="function")for(const v of h)c.apply(d,v)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,l){if(!r.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let v=t.get(l);return v||(v=new w.$3c,t.set(l,v)),(S,p,k)=>{const C=v.push([S,p,k]);return(0,f.$Qc)(C)}}if(l in d)return d[l];const h=r.value;let c=h[l];return typeof c!="function"||(c=c.bind(h),d[l]=c),c},set(d,l,h){return r.value[l]=h,!0},getPrototypeOf(d){return o.prototype}})}else return this.j(o,n,s)}u(g,o){if(o&&console.warn(g),this.g)throw new Error(g)}}e.$rq=$;var y;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(y||(y={}));class D{static traceInvocation(g,o){return g?new D(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(g,o){return g?new D(1,o.name):D.c}constructor(g,o){this.type=g,this.name=o,this.g=Date.now(),this.h=[]}branch(g,o){const n=new D(3,g.toString());return this.h.push([g,o,n]),n}stop(){const g=Date.now()-this.g;D.f+=g;let o=!1;function n(s,a){const t=[],r=new Array(s+1).join("	");for(const[d,l,h]of a.h)if(l&&h){o=!0,t.push(`${r}CREATES -> ${d}`);const c=n(s+1,h);c&&t.push(c)}else t.push(`${r}uses -> ${d}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(g>2||o)&&D.all.add(i.join(`
`))}}e.$sq=D,D.all=new Set,D.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}},D.f=0}),define(Se[14],ke([1,0,44,4,53,3,28,9,23,18,2,46,5]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,$.$2h)("logService"),e.$kj=(0,$.$2h)("loggerService");function y(){return new Date().toISOString()}function D(S){return(0,w.$If)(S)}e.$lj=D;var u;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$mj=u.Info;function g(S,p,k){switch(p){case u.Trace:S.trace(k);break;case u.Debug:S.debug(k);break;case u.Info:S.info(k);break;case u.Warning:S.warn(k);break;case u.Error:S.error(k);break;case u.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=g;function o(S,p=!1){let k="";for(let C=0;C<S.length;C++){let j=S[C];if(j instanceof Error&&(j=(0,E.$Mi)(j,p)),typeof j=="object")try{j=JSON.stringify(j)}catch{}k+=(C>0?" ":"")+j}return k}class n extends A.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new F.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==u.Off&&this.b<=p}}e.$oj=n;class i extends n{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...k){this.f(u.Trace)&&this.g(u.Trace,o([p,...k],!0))}debug(p,...k){this.f(u.Debug)&&this.g(u.Debug,o([p,...k]))}info(p,...k){this.f(u.Info)&&this.g(u.Info,o([p,...k]))}warn(p,...k){this.f(u.Warning)&&this.g(u.Warning,o([p,...k]))}error(p,...k){if(this.f(u.Error))if(p instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=p.stack,this.g(u.Error,o(C))}else this.g(u.Error,o([p,...k]))}flush(){}}e.$pj=i;class s extends n{constructor(p=e.$mj){super(),this.setLevel(p),this.g=!b.$c}trace(p,...k){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,p,...k):console.log(`[main ${y()}]`,p,...k))}debug(p,...k){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,p,...k):console.log(`[main ${y()}]`,p,...k))}info(p,...k){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,p,...k):console.log(`[main ${y()}]`,p,...k))}warn(p,...k){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,p,...k):console.warn(`[main ${y()}]`,p,...k))}error(p,...k){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,p,...k):console.error(`[main ${y()}]`,p,...k))}dispose(){}flush(){}}e.$qj=s;class a extends n{constructor(p=e.$mj,k=!0){super(),this.g=k,this.setLevel(p)}trace(p,...k){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...k):console.log(p,...k))}debug(p,...k){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...k):console.log(p,...k))}info(p,...k){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...k):console.log(p,...k))}warn(p,...k){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...k):console.log(p,...k))}error(p,...k){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...k):console.error(p,...k))}dispose(){}flush(){}}e.$rj=a;class t extends n{constructor(p,k=e.$mj){super(),this.g=p,this.setLevel(k)}trace(p,...k){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(p),...k])}debug(p,...k){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(p),...k])}info(p,...k){this.f(u.Info)&&this.g.log(u.Info,[this.h(p),...k])}warn(p,...k){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(p),...k])}error(p,...k){this.f(u.Error)&&this.g.log(u.Error,[this.h(p),...k])}h(p){return typeof p=="string"?p:(0,E.$Mi)(p,this.f(u.Trace))}dispose(){}flush(){}}e.$sj=t;class r extends n{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const k of this.g)k.setLevel(p);super.setLevel(p)}trace(p,...k){for(const C of this.g)C.trace(p,...k)}debug(p,...k){for(const C of this.g)C.debug(p,...k)}info(p,...k){for(const C of this.g)C.info(p,...k)}warn(p,...k){for(const C of this.g)C.warn(p,...k)}error(p,...k){for(const C of this.g)C.error(p,...k)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$tj=r;class d extends A.$Sc{constructor(p,k,C){if(super(),this.h=p,this.j=k,this.b=new M.$Ac,this.c=this.B(new F.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Sd),this.onDidChangeVisibility=this.g.event,C)for(const j of C)this.b.set(j.resource,{logger:void 0,info:j})}m(p){return(0,w.$Ef)(p)?[...this.b.values()].find(k=>k.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,k){const C=this.n(p),j=(0,w.$Ef)(p)?p:k?.id??(0,f.$Pi)(C.toString()).toString(16);let z=this.b.get(C)?.logger;const O=k?.logLevel==="always"?u.Trace:k?.logLevel;z||(z=this.s(C,O??this.getLogLevel(C)??this.h,{...k,id:j}));const U={logger:z,info:{resource:C,id:j,logLevel:O,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(U.info),this.b.set(C,U),z}n(p){return(0,w.$Ef)(p)?(0,m.$Dg)(this.j,`${p}.log`):p}setLogLevel(p,k){if(L.URI.isUri(p)){const C=p,j=k,z=this.b.get(C);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([C,j]))}else{this.h=p;for(const[C,j]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,k){const C=this.m(p);C&&k!==!C.info.hidden&&(C.info.hidden=!k,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,k]))}getLogLevel(p){let k;return p&&(k=this.b.get(p)?.info.logLevel),k??this.h}registerLogger(p){const k=this.b.get(p.resource);k?k.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const k=this.b.get(p);k&&(k.logger&&k.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=d;class l{constructor(){this.onDidChangeLogLevel=new F.$Sd().event}setLevel(p){}getLevel(){return u.Info}trace(p,...k){}debug(p,...k){}info(p,...k){}warn(p,...k){}error(p,...k){}critical(p,...k){}dispose(){}flush(){}}e.$vj=l;class h extends l{}e.$wj=h;function c(S){if(S.verbose)return u.Trace;if(typeof S.logLevel=="string"){const p=P(S.logLevel.toLowerCase());if(p!==void 0)return p}return e.$mj}e.$xj=c;function v(S){switch(S){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.$yj=v;function P(S){switch(S){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$zj=P,e.$Aj=new I.$gj("logLevel",v(u.Info))}),define(Se[249],ke([1,0,19,10,8,4,3,16,84,14]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class L extends M.$Sc{constructor($,y){super(),this.a=$,this.b=y,this.c=this.B(new A.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Zg(0)),this.w=[],this.y=this.B(new F.$Zg(0))}watch($,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n($,y):this.z($,y)}n($,y){const D={path:this.H($),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},u=(0,E.$Ub)(this.j,D);return this.r(),(0,M.$Qc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,f.$1)($))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,m.$7p)(y)),y=>this.G(y),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const y of this.j)(0,m.$3p)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const y of this.j)(0,m.$3p)(y)&&$.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,y){const D={path:this.H($),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},u=(0,E.$Ub)(this.w,D);return this.C(),(0,M.$Qc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,f.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,m.$7p)($)),$=>this.G($),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,b.$hc)($.fsPath)}}e.$$p=L}),define(Se[250],ke([1,0,55,386,10,28,22,4,33,3,16,9,23,100,31,205,32,243,249,44,247,246]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0,(()=>{try{(0,F.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,i.$Mi)(r)}`)}})();class t extends n.$$p{constructor(d,l){super(d,l),this.onDidChangeCapabilities=b.Event.None,this.N=new A.$Ac(h=>$.$ug.getComparisonKey(h)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$e&&(this.J|=1024)),this.J}async stat(d){try{const{stat:l,symbolicLink:h}=await D.SymlinkSupport.stat(this.H(d));return{type:this.M(l,h),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:g.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await D.Promises.readdir(this.H(d),{withFileTypes:!0}),h=[];return await Promise.all(l.map(async c=>{try{let v;c.isSymbolicLink()?v=(await this.stat((0,$.$Dg)(d,c.name))).type:v=this.M(c),h.push([c.name,v])}catch(v){this.a.trace(v)}})),h}catch(l){throw this.fb(l)}}M(d,l){let h;return l?.dangling?h=g.FileType.Unknown:d.isFile()?h=g.FileType.File:d.isDirectory()?h=g.FileType.Directory:h=g.FileType.Unknown,l&&(h|=g.FileType.SymbolicLink),h}async O(d){const l=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let h;for(;h=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await h.wait();const c=new f.$1g;return this.N.set(d,c),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,w.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(d)===c&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),c.open()})}async readFile(d,l){let h;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),h=await this.O(d));const c=this.H(d);return await D.Promises.readFile(c)}catch(c){throw this.fb(c)}finally{h?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,l,h){const c=(0,y.$7d)(v=>M.$ge.concat(v.map(P=>M.$ge.wrap(P))).buffer);return(0,o.$1p)(this,d,c,v=>v.buffer,{...l,bufferSize:256*1024},h),c}async writeFile(d,l,h){return h?.atomic!==!1&&h?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,$.$Dg)((0,$.$Cg)(d),`${(0,$.$Ag)(d)}${h.atomic.postfix}`),l,h):this.S(d,l,h)}async Q(d){try{const l=this.H(d),{symbolicLink:h}=await D.SymlinkSupport.stat(l);if(h)return!1}catch{}return!0}async R(d,l,h,c){const v=new w.$Rc;try{v.add(await this.O(d)),v.add(await this.O(l)),await this.S(l,h,c,!0);try{await this.rename(l,d,{overwrite:!0})}catch(P){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{v.dispose()}}async S(d,l,h,c){let v;try{const P=this.H(d);if(!h.create||!h.overwrite){if(await D.Promises.exists(P)){if(!h.overwrite)throw(0,g.$yk)((0,u.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,g.$yk)((0,u.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(d,{create:!0,unlock:h.unlock},c),await this.write(v,0,l,0,l.byteLength)}catch(P){throw await this.gb(d,P)}finally{typeof v=="number"&&await this.close(v)}}static configureFlushOnWrite(d){t.Y=d}async open(d,l,h){const c=this.H(d);let v;(0,g.$mk)(l)&&!h&&(v=await this.O(d));let P;try{if((0,g.$mk)(l)&&l.unlock)try{const{stat:p}=await D.SymlinkSupport.stat(c);p.mode&128||await D.Promises.chmod(c,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let S;if((0,g.$mk)(l)){if(I.$c)try{await D.Promises.truncate(c,0),S="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}S||(S="w")}else S="r";P=await D.Promises.open(c,S)}catch(S){throw v?.dispose(),(0,g.$mk)(l)?await this.gb(d,S):this.fb(S)}if(this.U.set(P,0),(0,g.$mk)(l)&&this.X.set(P,d),v){const S=this.W.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${c})`),this.W.set(P,v),S&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${c})`),S.dispose())}return P}async close(d){const l=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await D.Promises.fdatasync(d)}catch(h){t.configureFlushOnWrite(!1),this.a.error(h)}return await D.Promises.close(d)}catch(h){throw this.fb(h)}finally{l&&(this.W.get(d)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,h,c,v){const P=this.Z(d,l);let S=null;try{S=(await D.Promises.read(d,h,c,v,P)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(d,P,S)}return S}Z(d,l){return l===this.U.get(d)?null:l}$(d,l,h){const c=this.U.get(d);typeof c=="number"&&(typeof l=="number"||(typeof h=="number"?this.U.set(d,c+h):this.U.delete(d)))}async write(d,l,h,c,v){return(0,f.$jh)(()=>this.ab(d,l,h,c,v),100,3)}async ab(d,l,h,c,v){const P=this.Z(d,l);let S=null;try{S=(await D.Promises.write(d,h,c,v,P)).bytesWritten}catch(p){throw await this.gb(this.X.get(d),p)}finally{this.$(d,P,S)}return S}async mkdir(d){try{await D.Promises.mkdir(this.H(d))}catch(l){throw this.fb(l)}}async delete(d,l){try{const h=this.H(d);if(l.recursive){let c;l?.atomic!==!1&&l.atomic.postfix&&(c=(0,L.$jc)((0,L.$mc)(h),`${(0,L.$nc)(h)}${l.atomic.postfix}`)),await D.Promises.rm(h,D.RimRafMode.MOVE,c)}else try{await D.Promises.unlink(h)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let v=!1;try{const{stat:P,symbolicLink:S}=await D.SymlinkSupport.stat(h);v=P.isDirectory()&&!S}catch{}if(v)await D.Promises.rmdir(h);else throw c}else throw c}}catch(h){throw this.fb(h)}}async rename(d,l,h){const c=this.H(d),v=this.H(l);if(c!==v)try{await this.bb(d,l,"move",h.overwrite),await D.Promises.rename(c,v)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,u.localize)(2,null,(0,L.$nc)(c),(0,L.$nc)((0,L.$mc)(v)),P.toString()))),this.fb(P)}}async copy(d,l,h){const c=this.H(d),v=this.H(l);if(c!==v)try{await this.bb(d,l,"copy",h.overwrite),await D.Promises.copy(c,v,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,u.localize)(3,null,(0,L.$nc)(c),(0,L.$nc)((0,L.$mc)(v)),P.toString()))),this.fb(P)}}async bb(d,l,h,c){const v=this.H(d),P=this.H(l);let S=!1;if(!!(this.capabilities&1024)||(S=(0,m.$3f)(v,P,!0)),S){if(h==="copy")throw(0,g.$yk)((0,u.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(h==="move")return}const k=await this.L(d);if(!k)throw(0,g.$yk)((0,u.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const C=await this.L(l);if(C){if(!c)throw(0,g.$yk)((0,u.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&C.type&g.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.cb(d,l,!1)}async cb(d,l,h){const c=this.H(d),v=this.H(l),P=!!(this.capabilities&1024);if((0,m.$3f)(c,v,!P))return;const S=new w.$Rc;try{S.add(await this.O(d)),S.add(await this.O(l)),h&&await D.Promises.mkdir((0,L.$mc)(v),{recursive:!0}),await D.Promises.copyFile(c,v)}catch(p){if(p.code==="ENOENT"&&!h)return this.cb(d,l,!0);throw this.fb(p)}finally{S.dispose()}}t(d,l,h){return new s.$fq(c=>d(c),c=>l(c),h)}F(d,l,h){return new a.$nq(c=>d(c),c=>l(c),h)}fb(d){if(d instanceof g.$xk)return d;let l=d,h;switch(d.code){case"ENOENT":h=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":h=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":h=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":h=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":h=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,h=g.FileSystemProviderErrorCode.Unknown;break;default:h=g.FileSystemProviderErrorCode.Unknown}return(0,g.$yk)(l,h)}async gb(d,l){let h=this.fb(l);if(d&&h.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await D.SymlinkSupport.stat(this.H(d));c.mode&128||(h=(0,g.$yk)(l,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return h}}e.$oq=t,t.I=!1,t.Y=!0}),define(Se[251],ke([1,0,3,14]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dO=void 0;class f extends E.$Sc{constructor(M,b=[]){super(),this.a=new F.$tj([M,...b]),this.B(M.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$dO=f}),define(Se[252],ke([1,0,32,14]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5N=void 0;var f;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(f||(f={}));async function A(w,L,I,$,y){try{const D=await new Promise((g,o)=>{ie(["@vscode/spdlog"],g,o)});D.setFlushOn(f.Trace);const u=await D.createAsyncRotatingLogger(w,L,I,$);return y?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(D){console.error(D)}return null}function M(w,L,I){switch(L){case F.LogLevel.Trace:w.trace(I);break;case F.LogLevel.Debug:w.debug(I);break;case F.LogLevel.Info:w.info(I);break;case F.LogLevel.Warning:w.warn(I);break;case F.LogLevel.Error:w.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function b(w,L){switch(L){case F.LogLevel.Trace:w.setLevel(f.Trace);break;case F.LogLevel.Debug:w.setLevel(f.Debug);break;case F.LogLevel.Info:w.setLevel(f.Info);break;case F.LogLevel.Warning:w.setLevel(f.Warning);break;case F.LogLevel.Error:w.setLevel(f.Error);break;case F.LogLevel.Off:w.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class m extends F.$pj{constructor(L,I,$,y,D){super(),this.m=[],this.setLevel(D),this.n=this.s(L,I,$,y),this.B(this.onDidChangeLogLevel(u=>{this.r&&b(this.r,u)}))}async s(L,I,$,y){const D=$?6:1,u=30/D*E.$Tk.MB,g=await A(L,I,u,D,y);if(g){this.r=g,b(this.r,this.getLevel());for(const{level:o,message:n}of this.m)M(this.r,o,n);this.m=[]}}g(L,I){this.r?M(this.r,L,I):this.getLevel()<=L&&this.m.push({level:L,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$5N=m}),define(Se[136],ke([1,0,40,206,5]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var M;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(m){function w(D,u){return u-D}m.compare=w;const L=Object.create(null);L[m.Error]=(0,F.localize)(0,null),L[m.Warning]=(0,F.localize)(1,null),L[m.Info]=(0,F.localize)(2,null);function I(D){return L[D]||""}m.toString=I;function $(D){switch(D){case E.default.Error:return m.Error;case E.default.Warning:return m.Warning;case E.default.Info:return m.Info;case E.default.Ignore:return m.Hint}}m.fromSeverity=$;function y(D){switch(D){case m.Error:return E.default.Error;case m.Warning:return E.default.Warning;case m.Info:return E.default.Info;case m.Hint:return E.default.Ignore}}m.toSeverity=y}(M||(e.MarkerSeverity=M={}));var b;(function(m){const w="";function L($){return I($,!0)}m.makeKey=L;function I($,y){const D=[w];return $.source?D.push($.source.replace("\xA6","\\\xA6")):D.push(w),$.code?typeof $.code=="string"?D.push($.code.replace("\xA6","\\\xA6")):D.push($.code.value.replace("\xA6","\\\xA6")):D.push(w),$.severity!==void 0&&$.severity!==null?D.push(M.toString($.severity)):D.push(w),$.message&&y?D.push($.message.replace("\xA6","\\\xA6")):D.push(w),$.startLineNumber!==void 0&&$.startLineNumber!==null?D.push($.startLineNumber.toString()):D.push(w),$.startColumn!==void 0&&$.startColumn!==null?D.push($.startColumn.toString()):D.push(w),$.endLineNumber!==void 0&&$.endLineNumber!==null?D.push($.endLineNumber.toString()):D.push(w),$.endColumn!==void 0&&$.endColumn!==null?D.push($.endColumn.toString()):D.push(w),D.push(w),D.join("\xA6")}m.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$nt=(0,f.$2h)("markerService")}),define(Se[253],ke([1,0,4,40,5]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ev=e.$dv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$cv=e.Severity=void 0,e.Severity=F.default,e.$cv=(0,f.$2h)("notificationService");var A;(function(L){L[L.DEFAULT=0]="DEFAULT",L[L.SILENT=1]="SILENT",L[L.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var M;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.PROFILE=1]="PROFILE",L[L.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));var b;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class m{constructor(){this.progress=new w,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$dv=m;class w{infinite(){}done(){}total(I){}worked(I){}}e.$ev=w}),define(Se[254],ke([1,0,49]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.context<"u"){const A=f.context.configuration();if(A)F=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(F=globalThis._VSCODE_PRODUCT_JSON,E.env.VSCODE_DEV&&Object.assign(F,{nameShort:`${F.nameShort} Dev`,nameLong:`${F.nameLong} Dev`,dataFolderName:`${F.dataFolderName}-dev`,serverDataFolderName:F.serverDataFolderName?`${F.serverDataFolderName}-dev`:void 0}),!F.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(F,{version:A.version})}Object.assign(F,{extensionsGallery:E.env.EXTENSIONS_GALLERY?JSON.parse(E.env.EXTENSIONS_GALLERY):F.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else F={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.85.0",sha256:"85a97d373a6f92359f5db7bfc5a2fa6c5763b22c6ad07c962dfe32c84a079f3b",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"4.20.0-rc.1",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.85.0",commit:"962283051886d59307d489b67787ae04cbb7a324",date:"2023-12-08T10:20:54.785Z"},Object.keys(F).length===0&&Object.assign(F,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=F}),define(Se[137],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,E.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(ie,e){return function(E,F){e(E,F,ie)}};define(Se[85],ke([1,0,10,21,3,5]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProgressLocation=e.$fv=void 0,e.$fv=(0,A.$2h)("progressService");var M;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$gv=Object.freeze({total(){},worked(){},done(){}});class b{get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$hv=b,b.None=Object.freeze({report(){}});class m{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const y=this.d;this.d=()=>{y?.(),$()}}):Promise.resolve()}}e.$iv=m;let w=class extends f.$Sc{constructor($,y){super(),this.a=new E.$mh,y.withProgress($,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,f.$Qc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$jv=w,e.$jv=w=Qe([qe(1,e.$fv)],w);class L extends f.$Sc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new f.$Rc)}start($){this.stop();const y=++this.a,D=new F.$3d;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,f.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Qc)(()=>D.cancel())),this.b.add((0,f.$Qc)(()=>this.c?this.c.done():void 0)),{id:y,token:D.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$kv=L,e.$lv=(0,A.$2h)("editorProgressService")}),define(Se[37],ke([1,0,60,18]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0;class f{constructor(){this.a=new Map}add(M,b){E.ok(F.$Ef(M)),E.ok(F.$Gf(b)),E.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$un=new f}),define(Se[108],ke([1,0,4,37]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$vn={JSONContribution:"base.contributions.json"};function f(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new E.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,w){this.a[f(m)]=w,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const M=new A;F.$un.add(e.$vn.JSONContribution,M)}),define(Se[86],ke([1,0,19,4,18,196,45,108,37]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.ConfigurationScope=e.$zn=e.EditPresentationTypes=void 0;var w;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$zn={Configuration:"base.contributions.configuration"};var L;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn="vscode://schemas/settings/resourceLanguage",e.$Hn="vscode://schemas/settings/configurationDefaults";const I=m.$un.as(b.$vn.JSONContribution);class ${constructor(){this.h=new Set,this.i=new F.$Sd,this.onDidSchemaChange=this.i.event,this.j=new F.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$Gn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const d=new Set;this.n(t,r,d),I.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const r=new Set;this.o(t,r),I.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const d=new Set;this.o(r,d),this.n(t,!1,d),I.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const d=[];for(const{overrides:l,source:h}of t)for(const c in l)if(r.add(c),e.$Jn.test(c)){const v=this.a.get(c),P=v?.valuesSources??new Map;if(h)for(const C of Object.keys(l[c]))P.set(C,h);const S={...v?.value||{},...l[c]};this.a.set(c,{source:h,value:S,valuesSources:P});const p=(0,M.$Fi)(c),k={type:"object",default:S,description:A.localize(1,null,p),$ref:e.$Gn,defaultDefaultValue:S,source:f.$Ef(h)?void 0:h,defaultValueSource:h};d.push(...u(c)),this.d[c]=k,this.b.properties[c]=k}else{this.a.set(c,{value:l[c],source:h});const v=this.d[c];v&&(this.w(c,v),this.r(c,v))}this.m(d)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:d,source:l}of t)for(const h in d){const c=this.a.get(h),v=f.$Ef(l)?l:l?.id,P=f.$Ef(c?.source)?c?.source:c?.source?.id;if(v===P)if(r.add(h),this.a.delete(h),e.$Jn.test(h))delete this.d[h],delete this.b.properties[h];else{const S=this.d[h];S&&(this.w(h,S),this.r(h,S))}}this.u()}deltaConfiguration(t){let r=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,d){t.forEach(l=>{this.p(l,r,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,r){const d=l=>{if(l.properties)for(const h in l.properties){r.add(h);const c=this.d[h];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[h],this.s(h,l.properties[h])}l.allOf?.forEach(h=>d(h))};for(const l of t){d(l);const h=this.c.indexOf(l);h!==-1&&this.c.splice(h,1)}}p(t,r=!0,d,l,h=3,c){h=f.$Nf(t.scope)?h:t.scope;const v=t.properties;if(v)for(const S in v){const p=v[S];if(r&&i(S,p)){delete v[S];continue}if(p.source=d,p.defaultDefaultValue=v[S].default,this.w(S,p),e.$Jn.test(S)?p.scope=void 0:(p.scope=f.$Nf(p.scope)?h:p.scope,p.restricted=f.$Nf(p.restricted)?!!l?.includes(S):p.restricted),v[S].hasOwnProperty("included")&&!v[S].included){this.f[S]=v[S],delete v[S];continue}else this.d[S]=v[S],v[S].policy?.name&&this.e.set(v[S].policy.name,S);!v[S].deprecationMessage&&v[S].markdownDeprecationMessage&&(v[S].deprecationMessage=v[S].markdownDeprecationMessage),c.add(S)}const P=t.allOf;if(P)for(const S of P)this.p(S,r,d,l,h,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=d=>{const l=d.properties;if(l)for(const c in l)this.r(c,l[c]);d.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$An.properties[t]=r,r.scope){case 1:e.$Bn.properties[t]=r;break;case 2:e.$Cn.properties[t]=r;break;case 6:e.$Dn.properties[t]=r;break;case 3:e.$En.properties[t]=r;break;case 4:e.$Fn.properties[t]=r;break;case 5:e.$Fn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$An.properties[t],r.scope){case 1:delete e.$Bn.properties[t];break;case 2:delete e.$Cn.properties[t];break;case 6:delete e.$Dn.properties[t];break;case 3:delete e.$En.properties[t];break;case 4:case 5:delete e.$Fn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,d={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$Gn};this.w(r,d),e.$An.properties[r]=d,e.$Bn.properties[r]=d,e.$Cn.properties[r]=d,e.$Dn.properties[r]=d,e.$En.properties[r]=d,e.$Fn.properties[r]=d}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$Gn};e.$An.patternProperties[e.$In]=t,e.$Bn.patternProperties[e.$In]=t,e.$Cn.patternProperties[e.$In]=t,e.$Dn.patternProperties[e.$In]=t,e.$En.patternProperties[e.$In]=t,e.$Fn.patternProperties[e.$In]=t,this.i.fire()}w(t,r){const d=this.a.get(t);let l=d?.value,h=d?.source;f.$Lf(l)&&(l=r.defaultDefaultValue,h=void 0),f.$Lf(l)&&(l=o(r.type)),r.default=l,r.defaultValueSource=h}}const y="\\[([^\\]]+)\\]",D=new RegExp(y,"g");e.$In=`^(${y})+$`,e.$Jn=new RegExp(e.$In);function u(a){const t=[];if(e.$Jn.test(a)){let r=D.exec(a);for(;r?.length;){const d=r[1].trim();d&&t.push(d),r=D.exec(a)}}return(0,E.$Mb)(t)}e.$Kn=u;function g(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.$Ln=g;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Mn=o;const n=new $;m.$un.add(e.$zn.Configuration,n);function i(a,t){return a.trim()?e.$Jn.test(a)?A.localize(7,null,a):n.getConfigurationProperties()[a]!==void 0?A.localize(8,null,a):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,a,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$Nn=i;function s(){const a=[],t=n.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$On=s}),define(Se[255],ke([1,0,19,4,160,3,28,24,18,2,45,86,37]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=void 0;function y(r){return Object.isFrozen(r)?r:b.$jn(r)}class D{constructor(d={},l=[],h=[],c){this.b=d,this.c=l,this.d=h,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof D)return l;const h=new u("");return h.parseRaw(l),h.configurationModel});this.f=d.reduce((l,h)=>h===l?h:l.merge(h),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,L.$Di)(this.contents,d):this.contents}inspect(d,l){const h=this.rawConfiguration.getValue(d),c=l?this.rawConfiguration.getOverrideValue(d,l):void 0,v=l?this.rawConfiguration.override(l).getValue(d):h;return{value:h,override:c,merged:v}}getOverrideValue(d,l){const h=this.i(l);return h?d?(0,L.$Di)(h,d):h:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const h of this.overrides)h.identifiers.includes(d)&&l.push(...h.keys);return E.$Mb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return E.$Mb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=b.$in(this.contents),h=b.$in(this.overrides),c=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const P of d)if(v.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(l,P.contents);for(const S of P.overrides){const[p]=h.filter(k=>E.$ub(k.identifiers,S.identifiers));p?(this.h(p.contents,S.contents),p.keys.push(...S.keys),p.keys=E.$Mb(p.keys)):h.push(b.$in(S))}for(const S of P.keys)c.indexOf(S)===-1&&c.push(S)}return new D(l,c,h,v.every(P=>P instanceof D)?void 0:v)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const h={};for(const c of E.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let v=this.contents[c];const P=l[c];P&&(typeof v=="object"&&typeof P=="object"?(v=b.$in(v),this.h(v,P)):v=P),h[c]=v}return new D(h,this.keys,this.overrides)}h(d,l){for(const h of Object.keys(l)){if(h in d&&m.$Gf(d[h])&&m.$Gf(l[h])){this.h(d[h],l[h]);continue}d[h]=b.$in(l[h])}}i(d){let l=null,h=null;const c=v=>{v&&(h?this.h(h,v):h=b.$in(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===d?l=v.contents:v.identifiers.includes(d)&&c(v.contents);return c(l),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,L.$Ci)(this.contents,d),I.$Jn.test(d)&&this.overrides.splice(this.overrides.findIndex(h=>E.$ub(h.identifiers,(0,I.$Kn)(d))),1))}j(d,l,h){(0,L.$Bi)(this.contents,d,l,c=>console.error(c)),h=h||this.keys.indexOf(d)===-1,h&&this.keys.push(d),I.$Jn.test(d)&&this.overrides.push({identifiers:(0,I.$Kn)(d),keys:Object.keys(this.contents[d]),contents:(0,L.$Ai)(this.contents[d],c=>console.error(c))})}}e.$Pn=D;class u{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!m.$Nf(d)){const h=this.g(d);this.parseRaw(h,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:h,keys:c,overrides:v,restricted:P,hasExcludedProperties:S}=this.h(d,l);this.b=new D(h,c,v,S?[d]:void 0),this.c=P||[]}g(d){let l={},h=null,c=[];const v=[],P=[];function S(k){Array.isArray(c)?c.push(k):h!==null&&(c[h]=k)}const p={onObjectBegin:()=>{const k={};S(k),v.push(c),c=k,h=null},onObjectProperty:k=>{h=k},onObjectEnd:()=>{c=v.pop()},onArrayBegin:()=>{const k=[];S(k),v.push(c),c=k,h=null},onArrayEnd:()=>{c=v.pop()},onLiteralValue:S,onError:(k,C,j)=>{P.push({error:k,offset:C,length:j})}};if(d)try{f.$fn(d,p),l=c[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return l}h(d,l){const h=$.$un.as(I.$zn.Configuration).getConfigurationProperties(),c=this.i(d,h,!0,l);d=c.raw;const v=(0,L.$Ai)(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),P=Object.keys(d),S=this.j(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:v,keys:P,overrides:S,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(d,l,h,c){let v=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:v};const P={},S=[];for(const p in d)if(I.$Jn.test(p)&&h){const k=this.i(d[p],l,!1,c);P[p]=k.raw,v=v||k.hasExcludedProperties,S.push(...k.restricted)}else{const k=l[p],C=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&S.push(p),!c.exclude?.includes(p)&&(c.include?.includes(p)||(C===void 0||c.scopes===void 0||c.scopes.includes(C))&&!(c.skipRestricted&&k?.restricted))?P[p]=d[p]:v=!0}return{raw:P,restricted:S,hasExcludedProperties:v}}j(d,l){const h=[];for(const c of Object.keys(d))if(I.$Jn.test(c)){const v={};for(const P in d[c])v[P]=d[c][P];h.push({identifiers:(0,I.$Kn)(c),keys:Object.keys(v),contents:(0,L.$Ai)(v,l)})}return h}}e.$Qn=u;class g extends A.$Sc{constructor(d,l,h,c){super(),this.c=d,this.f=l,this.g=c,this.b=this.B(new F.$Sd),this.onDidChange=this.b.event,this.a=new u(this.c.toString()),this.B(this.g.watch(h.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&h.isEqual(v.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Rn=g;class o{constructor(d,l,h,c,v,P,S,p,k,C,j,z,O){this.a=d,this.b=l,this.c=h,this.overrideIdentifiers=c,this.d=v,this.f=P,this.g=S,this.h=p,this.i=k,this.j=C,this.k=j,this.l=z,this.m=O}get value(){return y(this.c)}n(d,l,h){const c=d.inspect(l,h);return{get value(){return y(c.value)},get override(){return y(c.override)},get merged(){return y(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(d,l,h,c,v=new D,P=new D,S=new M.$Ac,p=new D,k=new M.$Ac){this.c=d,this.d=l,this.f=h,this.g=c,this.h=v,this.i=P,this.j=S,this.l=p,this.m=k,this.a=null,this.b=new M.$Ac,this.n=null}getValue(d,l,h){return this.p(d,l,h).getValue(d)}updateValue(d,l,h={}){let c;h.resource?(c=this.m.get(h.resource),c||(c=new D,this.m.set(h.resource,c))):c=this.l,l===void 0?c.removeValue(d):c.setValue(d,l),h.resource||(this.a=null)}inspect(d,l,h){const c=this.p(d,l,h),v=this.t(l.resource,h),P=l.resource?this.m.get(l.resource)||this.l:this.l,S=new Set;for(const p of c.overrides)for(const k of p.identifiers)c.getOverrideValue(d,k)!==void 0&&S.add(k);return new o(d,l,c.getValue(d),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,h?this.i:void 0,v||void 0,P)}keys(d){const l=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const h=[];if(!l){const{added:c,updated:v,removed:P}=a(this.c,d);l=[...c,...v,...P]}for(const c of l)for(const v of(0,I.$Kn)(c)){const P=this.c.getKeysForOverrideIdentifier(v),S=d.getKeysForOverrideIdentifier(v),p=[...S.filter(k=>P.indexOf(k)===-1),...P.filter(k=>S.indexOf(k)===-1),...P.filter(k=>!b.$mn(this.c.override(v).getValue(k),d.override(v).getValue(k)))];h.push([v,p])}return this.updateDefaultConfiguration(d),{keys:l,overrides:h}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:h,removed:c}=a(this.d,d),v=[...l,...h,...c];return v.length&&this.updatePolicyConfiguration(d),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:h,removed:c,overrides:v}=a(this.applicationConfiguration,d),P=[...l,...h,...c];return P.length&&this.updateApplicationConfiguration(d),{keys:P,overrides:v}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:h,removed:c,overrides:v}=a(this.localUserConfiguration,d),P=[...l,...h,...c];return P.length&&this.updateLocalUserConfiguration(d),{keys:P,overrides:v}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:h,removed:c,overrides:v}=a(this.remoteUserConfiguration,d),P=[...l,...h,...c];return P.length&&this.updateRemoteUserConfiguration(d),{keys:P,overrides:v}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:h,removed:c,overrides:v}=a(this.workspaceConfiguration,d),P=[...l,...h,...c];return P.length&&this.updateWorkspaceConfiguration(d),{keys:P,overrides:v}}compareAndUpdateFolderConfiguration(d,l){const h=this.folderConfigurations.get(d),{added:c,updated:v,removed:P,overrides:S}=a(h,l),p=[...c,...v,...P];return(p.length||!h)&&this.updateFolderConfiguration(d,l),{keys:p,overrides:S}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:h,updated:c,removed:v,overrides:P}=a(l,void 0);return{keys:[...h,...c,...v],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,l,h){let c=this.q(l,h);return l.overrideIdentifier&&(c=c.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(c=c.merge(this.d)),c}q({resource:d},l){let h=this.r();if(l&&d){const c=l.getFolder(d);c&&(h=this.s(c.uri)||h);const v=this.m.get(d);v&&(h=h.merge(v))}return h}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let l=this.b.get(d);if(!l){const h=this.r(),c=this.j.get(d);c?(l=h.merge(c),this.b.set(d,l)):l=h}return l}t(d,l){if(l&&d){const h=l.getFolder(d);if(h)return this.j.get(h.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:h,overrides:c,keys:v}=this.j.get(l);return d.push([l,{contents:h,overrides:c,keys:v}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(h=>d.add(h))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(h=>d.add(h))),[...d.values()]}v(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h)),this.i.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h)),this.j.forEach(h=>h.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c))),[...l.values()]}static parse(d){const l=this.w(d.defaults),h=this.w(d.policy),c=this.w(d.application),v=this.w(d.user),P=this.w(d.workspace),S=d.folders.reduce((p,k)=>(p.set(w.URI.revive(k[0]),this.w(k[1])),p),new M.$Ac);return new n(l,h,c,v,new D,P,S,new D,new M.$Ac)}static w(d){return new D(d.contents,d.keys,d.overrides)}}e.$Sn=n;function i(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,l=new Map;for(const c of r)c.keys.forEach(v=>d.add(v)),c.overrides.forEach(([v,P])=>{const S=(0,M.$xc)(l,v,new Set);P.forEach(p=>S.add(p))});const h=[];return l.forEach((c,v)=>h.push([v,[...c.values()]])),{keys:[...d.values()],overrides:h}}e.$Tn=i;class s{constructor(d,l,h,c){this.change=d,this.f=l,this.g=h,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const v of d.keys)this.affectedKeys.add(v);for(const[,v]of d.overrides)for(const P of v)this.affectedKeys.add(P);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(d,l){const h=this.a+d,c=this.d.indexOf(h);if(c<0)return!1;const v=c+h.length;if(v>=this.d.length)return!1;const P=this.d.charCodeAt(v);if(P!==this.b&&P!==this.c)return!1;if(l){const S=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,p=this.g.getValue(d,l,this.h);return!b.$mn(S,p)}return!0}}e.$Un=s;function a(r,d){const{added:l,removed:h,updated:c}=t(d?.rawConfiguration,r?.rawConfiguration),v=[],P=r?.getAllOverrideIdentifiers()||[],S=d?.getAllOverrideIdentifiers()||[];if(d){const p=S.filter(k=>!P.includes(k));for(const k of p)v.push([k,d.getKeysForOverrideIdentifier(k)])}if(r){const p=P.filter(k=>!S.includes(k));for(const k of p)v.push([k,r.getKeysForOverrideIdentifier(k)])}if(d&&r){for(const p of P)if(S.includes(p)){const k=t({contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)},{contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)});v.push([p,[...k.added,...k.removed,...k.updated]])}}return{added:l,removed:h,updated:c,overrides:v}}function t(r,d){const l=r?d?r.keys.filter(v=>d.keys.indexOf(v)===-1):[...r.keys]:[],h=d?r?d.keys.filter(v=>r.keys.indexOf(v)===-1):[...d.keys]:[],c=[];if(r&&d){for(const v of d.keys)if(r.keys.indexOf(v)!==-1){const P=(0,L.$Di)(d.contents,v),S=(0,L.$Di)(r.contents,v);b.$mn(P,S)||c.push(v)}}return{added:l,removed:h,updated:c}}}),define(Se[256],ke([1,0,22,4,3,81]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lrb=e.$krb=e.$jrb=e.$irb=void 0;const M=(w,L,I)=>{const $=new Uint8Array(16);for(let u=0;u<16;u++)$[u]=Math.round(Math.random()*256);const y=(0,E.$Ae)(E.$ge.wrap($));return[`GET ws://localhost${w}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$irb=M,e.$jrb=E.$ge.fromString(`\r
\r
`);async function b(w,L,I,$,y){w.write(E.$ge.fromString((0,e.$irb)(L,I,$)));const D=new f.$Rc;try{return await new Promise((u,g)=>{let o;D.add(w.onData(n=>{o?o=E.$ge.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.$jrb);if(i===-1)return;u(w),w.pauseData();const s=o.slice(i+e.$jrb.byteLength);s.byteLength&&y.onData.fire(s)})),D.add(w.onClose(n=>g(n??new Error("socket closed")))),D.add(w.onEnd(()=>g(new Error("socket ended"))))})}catch(u){throw w.dispose(),u}finally{D.dispose()}}e.$krb=b;class m extends f.$Sc{constructor(L,I){super(),this.g=L,this.a=this.B(new F.$Vd),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new F.$Sd),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event($=>this.a.fire($))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,I){A.SocketDiagnostics.traceSocketEvent(this,this.g,L,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$lrb=m}),define(Se[64],ke([1,0,8,5]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.RemoteAuthorityResolverErrorCode=e.$5k=e.$4k=e.RemoteConnectionType=e.$3k=void 0,e.$3k=(0,F.$2h)("remoteAuthorityResolverService");var f;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class A{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$4k=A;class M{constructor(I,$){this.host=I,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$5k=M;var b;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class m extends E.$bb{static isNotAvailable(I){return I instanceof m&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof m&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof m&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof m&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof m&&I.isHandled}constructor(I,$=b.Unknown,y){super(I),this._message=I,this._code=$,this._detail=y,this.isHandled=$===b.NotAvailable&&y===!0,Object.setPrototypeOf(this,m.prototype)}}e.$6k=m;function w(L){const I=L.indexOf("+");return I===-1?L:L.substring(0,I)}e.$7k=w}),define(Se[65],ke([1,0,17]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0;function F(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.$8k=F;function f(w){if(!w)return;const L=w.indexOf("+");return L<0?w:w.substr(0,L)}e.$9k=f;function A(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$0k=A;function M(w){const{host:L,port:I}=m(w);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:I}}e.$$k=M;function b(w,L){let{host:I,port:$}=m(w);return typeof $>"u"&&($=L),{host:I,port:$}}e.$_k=b;function m(w){const L=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const I=w.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const $=w.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:w,port:void 0}}}),define(Se[26],ke([1,0,13,5,65]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.TargetPlatform=e.ExtensionType=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=void 0,e.$bm="extensions.user.cache",e.$cm="extensions.builtin.cache",e.$dm="undefined_publisher",e.$em=["ui","workspace","web"];function A(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.$fm=A,e.$gm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(u){u.WIN32_X64="win32-x64",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class m{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,o){if(typeof g>"u"||g===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof g=="string"||typeof o=="string"){const n=typeof g=="string"?g:g.value,i=typeof o=="string"?o:o.value;return E.$8e(n,i)}return g._lower===o._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$hm=m;class w{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const o of g)this.add(o)}add(g){this.c.add(m.toKey(g))}delete(g){return this.c.delete(m.toKey(g))}has(g){return this.c.has(m.toKey(g))}}e.$im=w;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(m.toKey(g))}get(g){return this.c.get(m.toKey(g))}has(g){return this.c.has(m.toKey(g))}set(g,o){this.c.set(m.toKey(g),o)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$jm=L;function I(u){return $(u)}e.$km=I;function $(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.$lm=$;function y(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.$mm=y;function D(u,g){if(g){const o=`onResolveRemoteAuthority:${(0,f.$9k)(g)}`;return!!u.activationEvents?.includes(o)}return!1}e.$nm=D,e.$om=(0,F.$2h)("IBuiltinExtensionsScannerService")}),define(Se[138],ke([1,0,8,26]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const m of M){const w=this.readActivationEvents(m);w.length>0&&(b[F.$hm.toKey(m.identifier)]=w)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let m=0;m<b.length;m++)b[m]==="onUri"&&(b[m]=`onUri:${F.$hm.toKey(M.identifier)}`);if(!M.contributes)return b;for(const m in M.contributes){const w=this.a.get(m);if(!w)continue;const L=M.contributes[m],I=Array.isArray(L)?L:[L];try{w(I,b)}catch($){(0,E.$1)($)}}return b}}e.$2E=f,e.$3E=new f}),define(Se[257],ke([1,0,10,22,21,8,4,3,56,39,30,81,64,65]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.PersistentConnectionEventType=e.$gl=e.$fl=e.$el=e.ConnectionType=void 0;const D=30*1e3;var u;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(u||(e.ConnectionType=u={}));function g(re){switch(re){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(re){const W=new f.$3d;return setTimeout(()=>W.cancel(),re),W.token}function n(re,W){if(re.isCancellationRequested||W.isCancellationRequested)return f.CancellationToken.Cancelled;const ce=new f.$3d;return re.onCancellationRequested(()=>ce.cancel()),W.onCancellationRequested(()=>ce.cancel()),ce.token}class i{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new b.$Rc,this.promise=new Promise((ce,me)=>{this.f=ce,this.g=me}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function s(re,W){const ce=new i(W);return ce.registerDisposable(re.onControlMessage(me=>{const le=JSON.parse(me.toString()),de=K(le);de?ce.reject(de):ce.resolve(le)})),ce.promise}function a(re,W,ce,me,le,de,Y,X){const Q=new i(X),te=w.$Od.create(!1);return re.info(`Creating a socket (${Y})...`),m.mark(`code/willCreateSocket/${de}`),W.connect(ce,me,le,Y).then($e=>{Q.didTimeout?(m.mark(`code/didCreateSocketError/${de}`),re.info(`Creating a socket (${Y}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(m.mark(`code/didCreateSocketOK/${de}`),re.info(`Creating a socket (${Y}) was successful after ${te.elapsed()} ms.`),Q.resolve($e))},$e=>{m.mark(`code/didCreateSocketError/${de}`),re.info(`Creating a socket (${Y}) returned an error after ${te.elapsed()} ms.`),re.error($e),Q.reject($e)}),Q.promise}function t(re,W){const ce=new i(W);return re.then(me=>{ce.didTimeout||ce.resolve(me)},me=>{ce.didTimeout||ce.reject(me)}),ce.promise}async function r(re,W,ce,me){const le=ye(re,W);re.logService.trace(`${le} 1/6. invoking socketFactory.connect().`);let de;try{de=await a(re.logService,re.remoteSocketFactoryService,re.connectTo,(0,y.$0k)(re),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,g(W),`renderer-${g(W)}-${re.reconnectionToken}`,me)}catch($e){throw re.logService.error(`${le} socketFactory.connect() failed or timed out. Error:`),re.logService.error($e),$e}re.logService.trace(`${le} 2/6. socketFactory.connect() was successful.`);let Y,X;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(de,null),Y=re.reconnectionProtocol,X=!1):(Y=new I.$Ph({socket:de}),X=!0),re.logService.trace(`${le} 3/6. sending AuthRequest control message.`);const Q=await t(re.signService.createNewMessage((0,L.$mg)()),me),te={type:"auth",auth:re.connectionToken||"00000000000000000000",data:Q.data};Y.sendControl(F.$ge.fromString(JSON.stringify(te)));try{const $e=await s(Y,n(me,o(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(re.logService.trace(`${le} 4/6. received SignRequest control message.`),!await t(re.signService.validate(Q,$e.signedData),me)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Le=await t(re.signService.sign($e.data),me),pe={type:"connectionType",commit:re.commit,signedData:Le,desiredConnectionType:W};return ce&&(pe.args=ce),re.logService.trace(`${le} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(F.$ge.fromString(JSON.stringify(pe))),{protocol:Y,ownsProtocol:X}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(re.logService.error(`${le} the handshake timed out. Error:`),re.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${le} received error control message when negotiating connection. Error:`),re.logService.error($e)),X&&J(Y),$e}}async function d(re,W,ce,me){const le=Date.now(),de=ye(re,W),{protocol:Y,ownsProtocol:X}=await r(re,W,ce,me),Q=new i(me);return Q.registerDisposable(Y.onControlMessage(te=>{const $e=JSON.parse(te.toString()),ve=K($e);ve?(re.logService.error(`${de} received error control message when negotiating connection. Error:`),re.logService.error(ve),X&&J(Y),Q.reject(ve)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${ge(le)}!`),Q.resolve({protocol:Y,firstMessage:$e}))})),Q.promise}async function l(re,W){const{protocol:ce}=await d(re,1,void 0,W);return{protocol:ce}}async function h(re,W,ce){const{protocol:me,firstMessage:le}=await d(re,2,W,ce),de=le&&le.debugPort;return{protocol:me,debugPort:de}}async function c(re,W,ce){const me=Date.now(),le=ye(re,3),{protocol:de}=await r(re,3,W,ce);return re.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${ge(me)}!`),de}async function v(re,W,ce){const{connectTo:me,connectionToken:le}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:me,connectionToken:le,reconnectionToken:W,reconnectionProtocol:ce,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function P(re,W,ce){return p(re,async me=>{const{protocol:le}=await l(me,f.CancellationToken.None);return new q(re,W,ce,me.reconnectionToken,le)})}e.$el=P;async function S(re,W){return p(re,async ce=>{const{protocol:me,debugPort:le}=await h(ce,W,f.CancellationToken.None);return new ee(re,W,ce.reconnectionToken,me,le)})}e.$fl=S;async function p(re,W){for(let me=1;;me++)try{const le=(0,L.$mg)(),de=await v(re,le,null);return await W(de)}catch(le){if(me<5)re.logService.error(`[remote-connection][attempt ${me}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(le);else throw re.logService.error(`[remote-connection][attempt ${me}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(le),T.triggerPermanentFailure(0,0,$.$6k.isHandled(le)),le}}async function k(re,W,ce){const me=await v(re,(0,L.$mg)(),null);return await c(me,{host:W,port:ce},f.CancellationToken.None)}e.$gl=k;function C(re){return(0,E.$Pg)(W=>new Promise((ce,me)=>{const le=setTimeout(ce,re*1e3);W.onCancellationRequested(()=>{clearTimeout(le),ce()})}))}var j;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(j||(e.PersistentConnectionEventType=j={}));class z{constructor(W,ce){this.reconnectionToken=W,this.millisSinceLastIncomingData=ce,this.type=0}}e.$hl=z;class O{constructor(W,ce,me,le){this.reconnectionToken=W,this.millisSinceLastIncomingData=ce,this.durationSeconds=me,this.c=le,this.type=1}skipWait(){this.c.cancel()}}e.$il=O;class U{constructor(W,ce,me){this.reconnectionToken=W,this.millisSinceLastIncomingData=ce,this.attempt=me,this.type=2}}e.$jl=U;class N{constructor(W,ce,me){this.reconnectionToken=W,this.millisSinceLastIncomingData=ce,this.attempt=me,this.type=4}}e.$kl=N;class R{constructor(W,ce,me,le){this.reconnectionToken=W,this.millisSinceLastIncomingData=ce,this.attempt=me,this.handled=le,this.type=3}}e.$ll=R;class T extends b.$Sc{static triggerPermanentFailure(W,ce,me){this._permanentFailure=!0,this.f=W,this.g=ce,this.h=me,this.j.forEach(le=>le.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(W=>W.y())}static debugPauseSocketWriting(){this.j.forEach(W=>W.F())}get n(){return this.c||T._permanentFailure}constructor(W,ce,me,le,de){super(),this.t=W,this.u=ce,this.reconnectionToken=me,this.protocol=le,this.w=de,this.m=this.B(new M.$Sd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(le.onSocketClose(Y=>{const X=_(this.t,this.reconnectionToken,!0);Y?Y.type===0?(this.u.logService.info(`${X} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.u.logService.error(Y.error)):(this.u.logService.info(`${X} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.u.logService.error(Y.event)):this.u.logService.info(`${X} received socket close event.`),this.y()})),this.B(le.onSocketTimeout(Y=>{const X=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.y()})),T.j.push(this),this.B((0,b.$Qc)(()=>{const Y=T.j.indexOf(this);Y>=0&&T.j.splice(Y,1)})),this.n&&this.D(T.f,T.g,T.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const W=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ce=[0,5,5,10,10,10,10,10,30];let me=-1;do{me++;const le=me<ce.length?ce[me]:ce[ce.length-1];try{if(le>0){const Y=C(le);this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),le,Y)),this.u.logService.info(`${W} waiting for ${le} seconds before reconnecting...`);try{await Y}catch{}}if(this.n){this.u.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1)),this.u.logService.info(`${W} resolving connection...`);const de=await v(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${W} connecting to ${de.connectTo}...`),await this.G(de,o(D)),this.u.logService.info(`${W} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1));break}catch(de){if(de.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if(me>360){this.u.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if($.$6k.isTemporarilyNotAvailable(de)){this.u.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if((de.code==="ETIMEDOUT"||de.code==="ENETUNREACH"||de.code==="ECONNREFUSED"||de.code==="ECONNRESET")&&de.syscall==="connect"){this.u.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if((0,A.$4)(de)){this.u.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if(de instanceof $.$6k){this.u.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,$.$6k.isHandled(de));break}this.u.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}}while(!this.n&&!this.s)}C(W,ce,me){this.w?T.triggerPermanentFailure(W,ce,me):this.D(W,ce,me)}D(W,ce,me){this.m.fire(new R(this.reconnectionToken,W,ce,me)),J(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ml=T,T._permanentFailure=!1,T.f=0,T.g=0,T.h=!1,T.j=[];class q extends T{constructor(W,ce,me,le,de){super(1,W,le,de,!0),this.client=this.B(new I.$Nh(de,{remoteAuthority:ce,clientId:me},W.ipcLogger))}async G(W,ce){await l(W,ce)}}e.$nl=q;class ee extends T{constructor(W,ce,me,le,de){super(2,W,me,le,!1),this.H=ce,this.debugPort=de}async G(W,ce){await h(W,this.H,ce)}}e.$ol=ee;function J(re){try{re.acceptDisconnect();const W=re.getSocket();re.dispose(),W.dispose()}catch(W){(0,A.$1)(W)}}function K(re){if(re&&re.type==="error"){const W=new Error(`Connection error: ${re.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Z(re,W){for(;re.length<W;)re+=" ";return re}function ae(re,W){return`[remote-connection][${Z(g(re),13)}][${W.substr(0,5)}\u2026]`}function _(re,W,ce){return`${ae(re,W)}[${ce?"reconnect":"initial"}]`}function ye(re,W){return`${_(W,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function ge(re){return`${Date.now()-re} ms`}}),define(Se[258],ke([1,0,3,5]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=void 0,e.$al=(0,F.$2h)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(M,b){var m;return(m=this.a)[M]??(m[M]=[]),this.a[M].push(b),(0,E.$Qc)(()=>{const w=this.a[M]?.indexOf(b);typeof w=="number"&&w>=0&&this.a[M]?.splice(w,1)})}b(M){return(this.a[M.type]||[]).find(m=>m.supports(M))}connect(M,b,m,w){const L=this.b(M);if(!L)throw new Error(`No socket factory found for ${M}`);return L.connect(M,b,m,w)}}e.$bl=f}),define(Se[259],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=void 0;class E{constructor(){this.b=new Map}async createNewMessage(f){try{const A=await this.c();if(A){const M=String(E.a++);return this.b.set(M,A),{id:M,data:A.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,A){if(!f.id)return!0;const M=this.b.get(f.id);if(!M)return!1;this.b.delete(f.id);try{return M.validate(A)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$n6b=E,E.a=1}),define(Se[109],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=void 0,e.$cl="signService",e.$dl=(0,E.$2h)(e.$cl)}),define(Se[139],ke([1,0,259]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i$b=void 0;class F extends E.$n6b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(M=>new M.signer().sign(A))}h(){return new Promise((A,M)=>ie(["vsda"],A,M))}}e.$i$b=F}),define(Se[260],ke([1,0,9,49,30]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=void 0;function A(m){if(E.$o===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function M(m,w,L,I,$,y,D,u,g){const o=Object.create(null);o["common.machineId"]=y,o["common.sqmId"]=D,o.sessionID=(0,f.$mg)()+Date.now(),o.commitHash=I,o.version=$,o["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,E.$b)(E.$o),o["common.nodePlatform"]=F.$dc,o["common.nodeArch"]=L,o["common.product"]=g||"desktop",u&&(o["common.msftInternal"]=u);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$f&&(o["common.snap"]="true");const s=A(w);return s&&(o["common.platformDetail"]=s),o}e.$vo=M;function b(m){const w=F.env.USERDNSDOMAIN;if(!w)return!1;const L=w.toLowerCase();return m.some(I=>L===I)}e.$wo=b}),define(Se[261],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=void 0,e.$pl=(0,E.$2h)("telemetryService"),e.$ql=(0,E.$2h)("customEndpointTelemetryService"),e.$rl="telemetry.currentSessionDate",e.$sl="telemetry.firstSessionDate",e.$tl="telemetry.lastSessionDate",e.$ul="telemetry.machineId",e.$vl="telemetry.sqmId",e.$wl="telemetry",e.$xl="telemetry.telemetryLevel",e.$yl="telemetry.enableCrashReporter",e.$zl="telemetry.enableTelemetry";var F;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var f;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(Se[87],ke([1,0,24,18,4,45,65,260,261]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;class w{constructor(h){this.value=h,this.isTrustedTelemetryValue=!0}}e.$xo=w;class L{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yo=L,e.$zo=new L;class I{async publicLog(h,c,v){}async publicLogError(h,c,v){}}e.$Ao=I,e.$Bo="telemetry",e.$Co="extensionTelemetryLog",e.$Do={log:()=>null,flush:()=>Promise.resolve(null)};function $(l,h){return f.Event.debounce(h.onDidChangeConfiguration,(v,P)=>{const S=v?new Set([...v.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:S}},1e3,!0)(v=>{v.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,A.$yi)(v.source),configurationKeys:Array.from(v.affectedKeys)})})}e.$Eo=$;function y(l,h){return!h.isBuilt&&!h.disableTelemetry?!0:!(h.disableTelemetry||!l.enableTelemetry)}e.$Fo=y;function D(l,h){return h.extensionTestsLocationURI?!0:!(h.isBuilt||h.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.$Go=D;function u(l){const h=l.getValue(m.$xl),c=l.getValue(m.$yl);if(l.getValue(m.$zl)===!1||c===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Ho=u;function g(l){const h={},c={},v={};i(l,v);for(let P in v){P=P.length>150?P.substr(P.length-149):P;const S=v[P];typeof S=="number"?c[P]=S:typeof S=="boolean"?c[P]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${S.length}`),h[P]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(h[P]=S)}return{properties:h,measurements:c}}e.$Io=g;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(l){if(!l)return"none";const h=(0,M.$9k)(l);return o.has(h)?h:"other"}e.$Jo=n;function i(l,h,c=0,v){if(l)for(const P of Object.getOwnPropertyNames(l)){const S=l[P],p=v?v+P:P;Array.isArray(S)?h[p]=(0,E.$nn)(S):S instanceof Date?h[p]=S.toISOString():(0,F.$Gf)(S)?c<2?i(S,h,c+1,p+"."):h[p]=(0,E.$nn)(S):h[p]=S}}function s(l,h){const c=l.msftInternalDomains||[],v=h.getValue("telemetry.internalTesting");return(0,b.$wo)(c)||v}e.$Ko=s;function a(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.$Lo=a;function t(l,h){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let c=l;const v=[];for(const k of h)for(;;){const C=k.exec(l);if(!C)break;v.push([C.index,k.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(c="";;){const k=S.exec(l);if(!k)break;const C=v.some(([j,z])=>k.index<z&&j<S.lastIndex);!P.test(k[0])&&!C&&(c+=l.substring(p,k.index)+"<REDACTED: user-file-path>",p=S.lastIndex)}return p<l.length&&(c+=l.substr(p)),c}function r(l){if(!l)return l;const h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of h)if(c.regex.test(l))return`<REDACTED: ${c.label}>`;return l}function d(l,h){return(0,E.$kn)(l,c=>{if(c instanceof w||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let v=c.replaceAll("%20"," ");v=t(v,h);for(const P of h)v=v.replace(P,"");return v=r(v),v}})}e.$Mo=d}),define(Se[262],ke([1,0,13,135,26,9,2,8,49,87]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;function L(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,E.$3e)(d.id,l.id)===0}e.$No=L;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(l){const h=l.manifest?l.manifest.version:l.version,c=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new $(l.identifier,h,c)}static parse(l){const h=I.exec(l);return h&&h[1]&&h[2]?new $({id:h[1]},h[2],h[4]||void 0):null}constructor(l,h,c="undefined"){this.version=h,this.targetPlatform=c,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof $?L(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Oo=$;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(d){const l=y.exec(d);return l&&l[1]?[g(l[1]),l[2]]:[g(d),void 0]}e.$Po=D;function u(d,l){return`${d}.${l}`}e.$Qo=u;function g(d){return d.toLowerCase()}e.$Ro=g;function o(d,l){return g(u(d??f.$dm,l))}e.$So=o;function n(d,l){const h=[],c=v=>{for(const P of h)if(P.some(S=>L(l(S),l(v))))return P;return null};for(const v of d){const P=c(v);P?P.push(v):h.push([v])}return h}e.$To=n;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Uo=i;function s(d){return{id:new w.$xo(d.identifier.id),name:new w.$xo(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Vo=s,e.$Wo=new f.$hm("pprice.better-merge");function a(d,l){const h=[],c=l.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const v=c.shift();if(v&&h.every(P=>!L(P.identifier,{id:v}))){const P=d.filter(S=>L(S.identifier,{id:v}));P.length===1&&(h.push(P[0]),c.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}e.$Xo=a;async function t(d,l){if(!A.$e)return!1;let h;try{h=(await d.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await d.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){l.debug("Error while getting the os-release file.",(0,b.$0)(v))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,l){const h=await t(d,l),c=(0,F.$ho)(h?"alpine":A.$o,m.$ec);return l.debug("ComputeTargetPlatform:",c),c}e.$Yo=r}),define(Se[263],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0;function E(m){return[...m.entries()]}e.$yr=E;function F(m){return m?[...m.entries()]:[]}e.$zr=F;function f(m){return new Map(m)}e.$Ar=f;function A(m){return new Map(m??[])}e.$Br=A;function M(m){return Array.from(m.entries()).map(w=>[w[0],E(w[1].map),F(w[1].descriptionMap)])}e.$Cr=M;function b(m){return new Map(m.map(w=>[w[0],{map:f(w[1]),descriptionMap:A(w[2])}]))}e.$Dr=b}),define(Se[264],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Crb=void 0;class E{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,A,M=5){const b=A(m=>{const w=typeof m=="string"?m:m.data;let L=this.a.get(f);if(L){L.data.push(w);return}const I=setTimeout(()=>this.flushBuffer(f),M);L={data:[w],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(f),b.dispose()}},this.a.set(f,L)});return b}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const A=this.a.get(f);A&&(this.a.delete(f),this.b(f,A.data.join("")))}}e.$Crb=E}),define(Se[265],ke([1,0,10,78,61,4,18,2,207,108,37]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.IconFontDefinition=e.IconContribution=e.$iw=void 0,e.$iw={IconContribution:"base.contributions.icons"};var I;(function(s){function a(t,r){let d=t.defaults;for(;f.ThemeIcon.isThemeIcon(d);){const l=D.getIcon(d.id);if(!l)return;d=l.defaults}return d}s.getDefinition=a})(I||(e.IconContribution=I={}));var $;(function(s){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(d=>({format:d.format,location:d.location.toString()}))}}s.toJSONObject=a;function t(r){const d=l=>(0,M.$Ef)(l)?l:void 0;if(r&&Array.isArray(r.src)&&r.src.every(l=>(0,M.$Ef)(l.format)&&(0,M.$Ef)(l.location)))return{weight:d(r.weight),style:d(r.style),src:r.src.map(l=>({format:l.format,location:b.URI.parse(l.location)}))}}s.fromJSONObject=t})($||(e.IconFontDefinition=$={}));class y{constructor(){this.a=new A.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,m.localize)(0,null)},fontCharacter:{type:"string",description:(0,m.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,r,d){const l=this.b[a];if(l){if(r&&!l.description){l.description=r,this.d.properties[a].markdownDescription=`${r} $(${a})`;const v=this.e.enum.indexOf(a);v!==-1&&(this.e.enumDescriptions[v]=r),this.a.fire()}return l}const h={id:a,description:r,defaults:t,deprecationMessage:d};this.b[a]=h;const c={$ref:"#/definitions/icons"};return d&&(c.deprecationMessage=d),r&&(c.markdownDescription=`${r}: $(${a})`),this.d.properties[a]=c,this.e.enum.push(a),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const r=this.f[a];return r||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(l,h)=>l.id.localeCompare(h.id),t=l=>{for(;f.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(l=>this.b[l]);for(const l of d.filter(h=>!!h.description).sort(a))r.push(`|<i class="${t(l)}"></i>|${l.id}|${f.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const l of d.filter(h=>!f.ThemeIcon.isThemeIcon(h.defaults)).sort(a))r.push(`|<i class="${t(l)}"></i>|${l.id}|`);return r.join(`
`)}}const D=new y;L.$un.add(e.$iw.IconContribution,D);function u(s,a,t,r){return D.registerIcon(s,a,t,r)}e.$jw=u;function g(){return D}e.$kw=g;function o(){const s=(0,F.$6j)();for(const a in s){const t="\\"+s[a].toString(16);D.registerIcon(a,{fontCharacter:t})}}o(),e.$lw="vscode://schemas/icons";const n=L.$un.as(w.$vn.JSONContribution);n.registerSchema(e.$lw,D.getIconSchema());const i=new E.$bh(()=>n.notifySchemaChanged(e.$lw),200);D.onDidChange(()=>{i.isScheduled()||i.schedule()}),e.$mw=u("widget-close",F.$8j.close,(0,m.localize)(2,null)),e.$nw=u("goto-previous-location",F.$8j.arrowUp,(0,m.localize)(3,null)),e.$ow=u("goto-next-location",F.$8j.arrowDown,(0,m.localize)(4,null)),e.$pw=f.ThemeIcon.modify(F.$8j.sync,"spin"),e.$qw=f.ThemeIcon.modify(F.$8j.loading,"spin")}),define(Se[88],ke([1,0,4,45,5,14]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.ProvidedOnAutoForward=e.$ov=e.TunnelPrivacyId=e.TunnelProtocol=e.$nv=e.$mv=void 0,e.$mv=(0,f.$2h)("tunnelService"),e.$nv=(0,f.$2h)("sharedTunnelsService");var M;(function(g){g.Http="http",g.Https="https"})(M||(e.TunnelProtocol=M={}));var b;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(b||(e.TunnelPrivacyId=b={}));function m(g){return!!g.forwardPort}e.$ov=m;var w;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function L(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(o)return{address:o[1],port:+o[2]}}e.$pv=L,e.$qv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(g){return e.$qv.indexOf(g)>=0}e.$rv=I,e.$sv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(g){return e.$sv.indexOf(g)>=0}e.$tv=$;function y(g,o,n,i){if(n===1)return!1;if(n===2&&$(o)){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(s?.length===4&&parseInt(s[1])>=18)return!1}return g<1024}e.$uv=y;class D{constructor(o,n,i){this.remoteAddress=o,this.localAddress=n,this.b=i,this.a=new E.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vv=D;let u=class{constructor(o,n){this.j=o,this.k=n,this.a=new E.$Sd,this.onTunnelOpened=this.a.event,this.b=new E.$Sd,this.onTunnelClosed=this.b.event,this.c=new E.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],n=Array.from(this.e.values());for(const i of n){const s=Array.from(i.values());for(const a of s){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:n}of o.values())await n.then(i=>typeof i!="string"?i?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,n,i,s,a){this.p(o,n,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:n,localAddress:i,privacy:s,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,n){($(o)||I(o))&&(o=e.$qv[0]);const i=this.r(o,n);if(i)return++i.refcount,i.value}openTunnel(o,n,i,s,a,t=!1,r,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${i} on local port ${a}.`);const l=this.f??o;if(!l)return;if(n||(n="localhost"),s||(s=this.l),this.f&&this.i.has(i)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.s(l,n,i,s,a,t,r,d);return h?h.then(c=>{if(c){if(typeof c=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,i),c}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,i);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.n(c);return(c.tunnelRemoteHost!==n||c.tunnelRemotePort!==i)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&c.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const n=this.e.get(o.tunnelRemoteHost);if(n){const i=n.get(o.tunnelRemotePort);i&&(i.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,i))}}}}async o(o,n,i){if(i.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${n}.`);const s=i.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(n),s}}async closeTunnel(o,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${n} `);const i=this.e.get(o);if(i&&i.has(n)){const s=i.get(n);s.refcount=0,await this.o(o,n,s)}}p(o,n,i){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(n,{refcount:1,value:i})}async q(o,n){const i=this.e.get(o);if(i){const s=i.get(n),a=s?await s.value:void 0;(!a||typeof a=="string")&&i.delete(n),i.size===0&&this.e.delete(o)}}r(o,n){const i=[o];I(o)?(i.push(...e.$qv),i.push(...e.$sv)):$(o)&&i.push(...e.$sv);const s=i.map(a=>this.e.get(a));for(const a of s){const t=a?.get(n);if(t)return t}}canTunnel(o){return!!L(o)}t(o,n,i,s,a,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${i} on local port ${s}.`);const d=i;this.i.add(d);const l=s===void 0?i:s,h={elevationRequired:a?this.isPortPrivileged(l):!1},c={remoteAddress:{host:n,port:i},localAddressPort:s,privacy:t,public:t?t!==b.Private:void 0,protocol:r},v=o.forwardPort(c,h);return v?(this.p(n,i,v),v.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),v}};e.$wv=u,e.$wv=u=Qe([qe(0,A.$jj),qe(1,F.$vi)],u)}),define(Se[266],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=void 0,e.$Vk=(0,E.$2h)("IUriIdentityService")}),define(Se[267],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$xv=void 0,e.$xv=(0,E.$2h)("editSessionIdentityService");var F;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Se[268],ke([1,0,17]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=void 0;function F(m){return m.scheme!==E.Schemas.file&&m.scheme!==E.Schemas.vscodeRemote}e.$kK=F;function f(m){if(m.folders.length)return m.folders.every(w=>F(w.uri))?m.folders[0].uri:void 0;if(m.configuration&&F(m.configuration))return m.configuration}e.$lK=f;function A(m){return f(m)?.scheme}e.$mK=A;function M(m){return f(m)?.authority}e.$nK=M;function b(m){return f(m)!==void 0}e.$oK=b}),define(Se[41],ke([1,0,209,16,77,23,2,5,17]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,b.$2h)("contextService");function w(l){const h=l;return typeof h?.id=="string"&&M.URI.isUri(h.uri)}e.$_h=w;function L(l){return typeof l?.id=="string"&&!w(l)&&!$(l)}e.$ai=L,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function I(l,h){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,F.$nc)(l)}:h?e.$bi:e.$ci;const c=l;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.$di=I;function $(l){const h=l;return typeof h?.id=="string"&&M.URI.isUri(h.configPath)}e.$ei=$;function y(l){const h=l;if(h?.uri)return{id:h.id,uri:M.URI.revive(h.uri)};const c=l;if(c?.configPath)return{id:c.id,configPath:M.URI.revive(c.configPath)};if(l?.id)return{id:l.id}}e.$fi=y;var D;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function u(l){const h=l;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.$gi=u;function g(l){const h=l;return!!(h&&typeof h=="object"&&M.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.$hi=g;class o{constructor(h,c,v,P,S){this.h=h,this.j=v,this.k=P,this.l=S,this.c=f.$8h.forUris(this.l,()=>!0),this.folders=c}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=f.$8h.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=o;class n{constructor(h,c){this.raw=c,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,A.$Dg)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=n;function i(l){return new n({uri:l,index:0,name:(0,A.$zg)(l)},{uri:l.toString()})}e.$ki=i,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,E.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function s(l,h){return A.$ug.isEqualOrParent(l,h.untitledWorkspacesHome)}e.$pi=s;function a(l){let h;return M.URI.isUri(l)?h=l:h=l.configuration,h?.scheme===m.Schemas.tmp}e.$qi=a,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$ri}e.$si=t;function r(l,h){return!s(l,h)&&!a(l)}e.$ti=r;function d(l){return(typeof l=="string"?(0,F.$oc)(l):(0,A.$Bg)(l))===e.$mi}e.$ui=d}),define(Se[269],ke([1,0,53,4,3,23,2,208,134,32,5,14,41,28,266,10,30,13,18]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.ProfileResourceType=void 0;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(l){const h=l;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&M.URI.isUri(h.location)&&M.URI.isUri(h.globalStorageHome)&&M.URI.isUri(h.settingsResource)&&M.URI.isUri(h.keybindingsResource)&&M.URI.isUri(h.tasksResource)&&M.URI.isUri(h.snippetsHome)&&M.URI.isUri(h.extensionsResource))}e.$Wk=s,e.$Xk=(0,L.$2h)("IUserDataProfilesService");function a(l,h){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:M.URI.revive(l.location).with({scheme:h}),globalStorageHome:M.URI.revive(l.globalStorageHome).with({scheme:h}),settingsResource:M.URI.revive(l.settingsResource).with({scheme:h}),keybindingsResource:M.URI.revive(l.keybindingsResource).with({scheme:h}),tasksResource:M.URI.revive(l.tasksResource).with({scheme:h}),snippetsHome:M.URI.revive(l.snippetsHome).with({scheme:h}),extensionsResource:M.URI.revive(l.extensionsResource).with({scheme:h}),cacheHome:M.URI.revive(l.cacheHome).with({scheme:h}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}e.$Yk=a;function t(l,h,c,v,P,S){return{id:l,name:h,location:c,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:S&&P?.useDefaultFlags?.globalState?S.globalStorageHome:(0,A.$Dg)(c,"globalStorage"),settingsResource:S&&P?.useDefaultFlags?.settings?S.settingsResource:(0,A.$Dg)(c,"settings.json"),keybindingsResource:S&&P?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,A.$Dg)(c,"keybindings.json"),tasksResource:S&&P?.useDefaultFlags?.tasks?S.tasksResource:(0,A.$Dg)(c,"tasks.json"),snippetsHome:S&&P?.useDefaultFlags?.snippets?S.snippetsHome:(0,A.$Dg)(c,"snippets"),extensionsResource:S&&P?.useDefaultFlags?.extensions?S.extensionsResource:(0,A.$Dg)(c,"extensions.json"),cacheHome:(0,A.$Dg)(v,l),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$Zk=t;let r=class extends f.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,c,v,P){super(),this.t=h,this.u=c,this.w=v,this.y=P,this.f=!0,this.h=this.B(new F.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Dg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Dg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),c=[h];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,n.$Ef)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}c.push(t((0,A.$Ag)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},h))}}catch(S){this.y.error(S)}const v=new y.$Ac,P=new Map;if(c.length)try{const S=this.Q();if(S.workspaces)for(const[p,k]of Object.entries(S.workspaces)){const C=M.URI.parse(p),j=c.find(z=>z.id===k);j&&v.set(C,j)}if(S.emptyWindows)for(const[p,k]of Object.entries(S.emptyWindows)){const C=c.find(j=>j.id===k);C&&P.set(p,C)}}catch(S){this.y.error(S)}this.z={profiles:c,workspaces:v,emptyWindows:P}}return this.z}D(){const h=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const c="Temp",v=new RegExp(`${(0,o.$Ke)(c)}\\s(\\d+)`);let P=0;for(const p of this.profiles){const k=v.exec(p.name),C=k?parseInt(k[1]):0;P=C>P?C:P}const S=`${c} ${P+1}`;return this.createProfile((0,E.$Pi)((0,g.$mg)()).toString(16),S,{transient:!0},h)}async createNamedProfile(h,c,v){return this.createProfile((0,E.$Pi)((0,g.$mg)()).toString(16),h,c,v)}async createProfile(h,c,v,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(h,c,v);return P&&await this.setProfileForWorkspace(P,S),S}async F(h,c,v){if(!(0,n.$Ef)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(c);return P||(P=(async()=>{try{const S=this.profiles.find(C=>C.name===c||C.id===h);if(S)return S;const p=t(h,c,(0,A.$Dg)(this.profilesHome,h),this.g,v,this.defaultProfile);await this.u.createFolder(p.location);const k=[];return this.j.fire({profile:p,join(C){k.push(C)}}),await u.Promises.settled(k),this.I([p],[],[]),p}finally{this.r.delete(c)}})(),this.r.set(c,P)),P}async updateProfile(h,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(P=>P.id===h.id);if(!v)throw new Error(`Profile '${h.name}' does not exist`);return v=t(v.id,c.name??v.name,v.location,this.g,{shortName:c.shortName??v.shortName,icon:c.icon===null?void 0:c.icon??v.icon,transient:c.transient??v.isTransient,useDefaultFlags:c.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(P=>P.id===h.id);if(!c)throw new Error(`Profile '${h.name}' does not exist`);const v=[];this.m.fire({profile:c,join(P){v.push(P)}});try{await Promise.allSettled(v)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(P){(0,w.$Ck)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(h,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(P=>P.id===c.id);if(!v)throw new Error(`Profile '${c.name}' does not exist`);this.L(h,v)}unsetWorkspace(h,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(c=>c.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(h.map(c=>this.removeProfile(c)))}getProfileForWorkspace(h){const c=this.G(h);return M.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(h){return(0,$.$_h)(h)?h.uri:(0,$.$ei)(h)?h.configPath:h.id}H(h){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,h.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,h.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,h.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,h.location)))}I(h,c,v){const P=[...this.profiles,...h],S=[];this.s.profiles=[];for(let p of P)p.isDefault||c.some(k=>p.id===k.id)||(p=v.find(k=>p.id===k.id)??p,p.isTransient?this.s.profiles.push(p):S.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(S),this.z=void 0,this.J(h,c,v)}J(h,c,v){this.h.fire({added:h,removed:c,updated:v,all:this.profiles})}L(h,c,v){v=c?.isTransient?!0:v,v||this.L(h,void 0,!0);const P=this.G(h),S=v?this.s:this.C;M.URI.isUri(P)?(S.workspaces.delete(P),c&&S.workspaces.set(P,c)):(S.emptyWindows.delete(P),c&&S.emptyWindows.set(P,c)),v||this.M()}M(){const h={};for(const[v,P]of this.C.workspaces.entries())h[v.toString()]=P.id;const c={};for(const[v,P]of this.C.emptyWindows.entries())c[v.toString()]=P.id;this.R({workspaces:h,emptyWindows:c}),this.z=void 0}N(h){const c={},v=this.D();if(h.workspaces)for(const[S,p]of Object.entries(h.workspaces)){const k=M.URI.parse(p);c[S]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}const P={};if(h.emptyWindows)for(const[S,p]of Object.entries(h.emptyWindows)){const k=M.URI.parse(p);P[S]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}return{workspaces:c,emptyWindows:P}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$1k=r,r.b="userDataProfiles",r.c="profileAssociations",e.$1k=r=Qe([qe(0,m.$9h),qe(1,w.$lk),qe(2,D.$Vk),qe(3,I.$jj)],r);class d extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$2k=d}),define(Se[270],ke([1,0,10,4,3,56,18,171,5,269]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hp=e.$gp=e.$fp=void 0,e.$fp="__$__isNewStorageMarker",e.$gp="__$__targetStorageMarker",e.$hp=(0,m.$2h)("storageService");var L;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var $;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function y(n){const i=n.get(e.$gp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}e.$ip=y;class D extends f.$Sc{constructor(i={flushInterval:D.a}){super(),this.m=i,this.b=this.B(new F.$Vd),this.c=this.B(new F.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new E.$bh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,a){return F.Event.filter(this.b.event,t=>t.scope===i&&(s===void 0||t.key===s),a)}n(){this.j.value=(0,E.$fh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:a,external:t}=s;if(a===e.$gp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:a,target:this.J(i)[a],external:t})}w(i){this.f.fire({reason:i})}get(i,s,a){return this.P(s)?.get(i,a)}getBoolean(i,s,a){return this.P(s)?.getBoolean(i,a)}getNumber(i,s,a){return this.P(s)?.getNumber(i,a)}getObject(i,s,a){return this.P(s)?.getObject(i,a)}storeAll(i,s){this.y(()=>{for(const a of i)this.store(a.key,a.value,a.scope,a.target,s)})}store(i,s,a,t,r=!1){if((0,M.$Nf)(s)){this.remove(i,a,r);return}this.y(()=>{this.z(i,a,t),this.P(a)?.set(i,s,r)})}remove(i,s,a=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,a)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const a=[],t=this.J(i);for(const r of Object.keys(t))t[r]===s&&a.push(r);return a}z(i,s,a,t=!1){const r=this.J(s);typeof a=="number"?r[i]!==a&&(r[i]=a,this.P(s)?.set(e.$gp,JSON.stringify(r),t)):typeof r[i]=="number"&&(delete r[i],this.P(s)?.set(e.$gp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?y(s):Object.create(null)}isNew(i){return this.getBoolean(e.$fp,i)===!0}async flush(i=L.NONE){this.f.fire({reason:i});const s=this.P(-1),a=this.P(0),t=this.P(1);switch(i){case L.NONE:await E.Promises.settled([s?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await E.Promises.settled([s?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,s=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(i,s,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(L.NONE),(0,w.$Wk)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||u(s)&&u(i))}N(i,s,a){this.y(()=>{const t=new Set;for(const[r,d]of i)t.add(r),s.get(r)!==d&&this.u(a,{key:r,external:!0});for(const[r]of s.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$jp=D,D.a=60*1e3;function u(n){return n.isDefault||!!n.useDefaultFlags?.globalState}e.$kp=u;class g extends D{constructor(){super(),this.U=this.B(new b.$dp(new b.$ep,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$dp(new b.$ep,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$dp(new b.$ep,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$lp=g;async function o(n,i,s,a,t,r){const d=C=>{try{return JSON.parse(C)}catch{return C}},l=new Map,h=new Map;n.forEach((C,j)=>{l.set(j,C),h.set(j,d(C))});const c=new Map,v=new Map;i.forEach((C,j)=>{c.set(j,C),v.set(j,d(C))});const P=new Map,S=new Map;s.forEach((C,j)=>{P.set(j,C),S.set(j,d(C))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const p=[];if(l.forEach((C,j)=>{p.push({key:j,value:C})}),console.table(p),console.groupEnd(),console.log(h),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];c.forEach((j,z)=>{C.push({key:z,value:j})}),console.table(C),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${r})`);const k=[];P.forEach((C,j)=>{k.push({key:j,value:C})}),console.table(k),console.groupEnd(),console.log(S)}e.$mp=o}),define(Se[110],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class E{constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const A=this.c++;return this.b.set(A,f),this.e(),A}get(f,A){return this.b.has(f)?this.b.get(f)[A]:void 0}delete(f){this.b.delete(f),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$afc=E,E.a=!1}),define(Se[57],ke([1,0,17,23,5]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=void 0;class A{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new F.$sg(b=>{const m=this.b.get(b.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(b,m){m===null?this.b.delete(b.scheme):this.b.set(b.scheme,m)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$dfc=A,e.$efc=(0,f.$2h)("IExtHostFileSystemInfo")}),define(Se[27],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0,e.$8M=(0,E.$2h)("IExtHostInitDataService")}),define(Se[271],ke([1,0,214,14,251,27]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;let M=class extends f.$dO{constructor(m,w,L){const I=L.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",$=L.remote.isRemote?(0,E.localize)(0,null):m?(0,E.localize)(1,null):(0,E.localize)(2,null);super(w.createLogger(I,{name:$}))}};e.$khc=M,e.$khc=M=Qe([qe(1,F.$kj),qe(2,A.$8M)],M)}),define(Se[272],ke([1,0,10]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=void 0;class F{constructor(M,b,m){this.h=new Map,this.a=M,this.b=b,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new E.$bh(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of w.values())L.complete()}catch(L){for(const I of w.values())I.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let m=this.f[M];return typeof m>"u"&&(m=b),m}update(M,b){this.f[M]=b;const m=this.h.get(M);if(m!==void 0)return m.p;const w=new E.$mh;return this.h.set(M,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$Yfc=F;class f extends F{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$Zfc=f}),define(Se[273],ke([1,0,4,2]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class f{constructor(M){this.c=M,this.a=new E.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,m,w){const I=this.c.getNotebookDocument(F.URI.revive(M)).acceptModelChanged(b.value,m,w);this.b.fire(I)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(F.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(F.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$Mgc=f}),define(Se[20],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0,e.$RM=(0,E.$2h)("IExtHostRpcService");class F{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$SM=F});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[274],ke([1,0,26,4]),function(ie,e,E,F){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class A{constructor(b,m){f.set(this,void 0),this.b=new F.$Sd,this.onDidChange=this.b.event,this.a=E.$hm.toKey(b.identifier),nt(this,f,m,"f"),We(this,f,"f").onDidChangePassword(w=>{w.extensionId===this.a&&this.b.fire({key:w.key})})}get(b){return We(this,f,"f").get(this.a,b)}store(b,m){return We(this,f,"f").store(this.a,b,m)}delete(b){return We(this,f,"f").delete(this.a,b)}}e.$7fc=A,f=new WeakMap}),define(Se[66],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=void 0,e.$wfc=(0,E.$2h)("IURITransformerService");class F{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$xfc=F}),define(Se[275],ke([1,0,22]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kb=e.$6kb=void 0;class F{constructor(){this.buffers=[]}add(m){let w=this.buffers.indexOf(m);return w<0&&(w=this.buffers.length,this.buffers.push(m)),w}}function f(b,m){if(m.serializeBuffersForPostMessage){const w=new F,I=JSON.stringify(b,(y,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(D)};if(ArrayBuffer.isView(D)){const u=A(D);if(u)return{$$vscode_array_buffer_reference$$:!0,index:w.add(D.buffer),view:{type:u,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),$=w.buffers.map(y=>{const D=new Uint8Array(y);return E.$ge.wrap(D)});return{message:I,buffers:$}}else return{message:JSON.stringify(b),buffers:[]}}e.$6kb=f;function A(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,m){const w=m.map($=>{const y=new ArrayBuffer($.byteLength);return new Uint8Array(y).set($.buffer),y}),L=m.length?($,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const D=y,{index:u}=D,g=w[u];if(D.view)switch(D.view.type){case 1:return new Int8Array(g,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return y}:void 0;return{message:JSON.parse(b,L),arrayBuffers:w}}e.$7kb=M}),define(Se[276],ke([1,0,111,387,388,63,2,14,389]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;const w=!1;function L(i,s,a,t,r,d){const l=d.environment.useHostProxy,h=typeof l=="boolean"?l:!d.remote.isRemote,c={resolveProxy:S=>i.resolveProxy(S),lookupProxyAuthorization:g.bind(void 0,t,r,s,{},d.remote.isRemote),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(s),addCertificatesV2:()=>y(s),log:t,getLogLevel:()=>{const S=t.getLevel();switch(S){case b.LogLevel.Trace:return m.LogLevel.Trace;case b.LogLevel.Debug:return m.LogLevel.Debug;case b.LogLevel.Info:return m.LogLevel.Info;case b.LogLevel.Warning:return m.LogLevel.Warning;case b.LogLevel.Error:return m.LogLevel.Error;case b.LogLevel.Off:return m.LogLevel.Off;default:return p(S)}function p(k){return t.error("Unknown log level",k),m.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:h,loadAdditionalCertificates:async()=>{const S=[];if(d.remote.isRemote&&S.push((0,m.loadSystemCertificates)({log:t})),h){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=i.loadCertificates();p.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),S.push(p)}return(await Promise.all(S)).flat()},env:process.env},v=(0,m.createProxyResolver)(c),P=I(c,v);return u(a,P)}e.$Shc=L;function I(i,s){return{http:Object.assign(E,(0,m.createHttpPatch)(i,E,s)),https:Object.assign(F,(0,m.createHttpPatch)(i,F,s)),net:Object.assign(A,(0,m.createNetPatch)(i,A)),tls:Object.assign(f,(0,m.createTlsPatch)(i,f))}}function $(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",w)&&!!s.get("systemCertificates")}function y(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",w)&&!!s.get("systemCertificates")}const D=new Map;function u(i,s){return i.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(l,h,c){if(l==="net")return s.net;if(l==="tls")return s.tls;if(l!=="http"&&l!=="https")return r.apply(this,arguments);const v=a.findSubstr(M.URI.file(h.filename));let P=D.get(v);if(P||D.set(v,P={}),!P[l]){const S=s[l];P[l]={...S}}return P[l]}})}async function g(i,s,a,t,r,d,l,h){const c=t[d];l&&(t[d]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${c}`);const v=l||c,P=Array.isArray(v)?v:typeof v=="string"?[v]:[];if(n(s,P,r),P.some(S=>/^(Negotiate|Kerberos)( |$)/i.test(S))&&!h.kerberosRequested)try{h.kerberosRequested=!0;const S=await new Promise((z,O)=>{ie(["kerberos"],z,O)}),p=new URL(d),k=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${k}`),"Negotiate "+await(await S.initializeClient(k)).step("")}catch(S){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",S)}}let o=!1;function n(i,s,a){o||!s.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Se[277],ke([1,0,128]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;function F(A){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:A,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function f(A){return new E.$Zm(F(A))}e.$Or=f}),define(Se[140],ke([1,0,225,18,2,3,5,37,32,17,44,190,40]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ME=e.$LE=e.$KE=e.EditorsOrder=e.$JE=e.CloseDirection=e.$IE=e.$HE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.EditorInputCapabilities=e.$yE=e.SaveReason=e.Verbosity=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=void 0,e.$lE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$mE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$nE="workbench.editor.sidebysideEditor",e.$oE="workbench.editors.textDiffEditor",e.$pE="workbench.editors.binaryResourceDiffEditor";var y;(function(ge){ge[ge.PROGRAMMATIC=1]="PROGRAMMATIC",ge[ge.USER=2]="USER",ge[ge.EDIT=3]="EDIT",ge[ge.NAVIGATION=4]="NAVIGATION",ge[ge.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var D;(function(ge){ge[ge.IDENTICAL=1]="IDENTICAL",ge[ge.SIMILAR=2]="SIMILAR",ge[ge.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function u(ge){const re=ge;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}e.$qE=u;function g(ge,re,W){for(const ce of W.visibleEditorPanes)if(ce.group.id===re&&ge.matches(ce.input))return ce.getViewState()}e.$rE=g;function o(ge){if(v(ge))return!1;const re=ge;return f.URI.isUri(re?.resource)}e.$sE=o;function n(ge){if(v(ge))return!1;const re=ge;return re?.original!==void 0&&re.modified!==void 0}e.$tE=n;function i(ge){if(v(ge))return!1;const re=ge;return Array.isArray(re?.resources)}e.$uE=i;function s(ge){if(v(ge)||n(ge))return!1;const re=ge;return re?.primary!==void 0&&re.secondary!==void 0}e.$vE=s;function a(ge){if(v(ge))return!1;const re=ge;return re?re.resource===void 0||re.resource.scheme===w.Schemas.untitled||re.forceUntitled===!0:!1}e.$wE=a;function t(ge){if(v(ge))return!1;const re=ge;return f.URI.isUri(re?.base?.resource)&&f.URI.isUri(re?.input1?.resource)&&f.URI.isUri(re?.input2?.resource)&&f.URI.isUri(re?.result?.resource)}e.$xE=t;var r;(function(ge){ge[ge.SHORT=0]="SHORT",ge[ge.MEDIUM=1]="MEDIUM",ge[ge.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var d;(function(ge){ge[ge.EXPLICIT=1]="EXPLICIT",ge[ge.AUTO=2]="AUTO",ge[ge.FOCUS_CHANGE=3]="FOCUS_CHANGE",ge[ge.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class l{constructor(){this.a=new Map}registerSource(re,W){let ce=this.a.get(re);return ce||(ce={source:re,label:W},this.a.set(re,ce)),ce.source}getSourceLabel(re){return this.a.get(re)?.label??re}}e.$yE=new l;var h;(function(ge){ge[ge.None=0]="None",ge[ge.Readonly=2]="Readonly",ge[ge.Untitled=4]="Untitled",ge[ge.Singleton=8]="Singleton",ge[ge.RequiresTrust=16]="RequiresTrust",ge[ge.CanSplitInGroup=32]="CanSplitInGroup",ge[ge.ForceDescription=64]="ForceDescription",ge[ge.CanDropIntoEditor=128]="CanDropIntoEditor",ge[ge.MultipleEditors=256]="MultipleEditors",ge[ge.Scratchpad=512]="Scratchpad",ge[ge.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(h||(e.EditorInputCapabilities=h={}));class c extends A.$Sc{}e.$zE=c;function v(ge){return ge instanceof c}e.$AE=v;function P(ge){const re=ge;return f.URI.isUri(re?.preferredResource)}function S(ge){const re=ge;return v(re?.primary)&&v(re?.secondary)}e.$BE=S;function p(ge){const re=ge;return v(re?.modified)&&v(re?.original)}e.$CE=p;function k(ge,re,W,ce,me){return ye(ce,[(0,I.$Li)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const le={...W,limits:{size:Number.MAX_VALUE}};ge.openEditor(re,le)}}),(0,I.$Li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>me.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}e.$DE=k;function C(ge){return v(ge?.editor)}e.$EE=C;function j(ge){const re=ge;return C(ge)&&re?.group!==void 0}e.$FE=j;function z(ge){const re=ge;return typeof re?.groupId=="number"&&v(re.editor)}e.$GE=z;var O;(function(ge){ge[ge.UNKNOWN=0]="UNKNOWN",ge[ge.REPLACE=1]="REPLACE",ge[ge.MOVE=2]="MOVE",ge[ge.UNPIN=3]="UNPIN"})(O||(e.EditorCloseContext=O={}));var U;(function(ge){ge[ge.GROUP_ACTIVE=0]="GROUP_ACTIVE",ge[ge.GROUP_INDEX=1]="GROUP_INDEX",ge[ge.GROUP_LABEL=2]="GROUP_LABEL",ge[ge.GROUP_LOCKED=3]="GROUP_LOCKED",ge[ge.EDITOR_OPEN=4]="EDITOR_OPEN",ge[ge.EDITOR_CLOSE=5]="EDITOR_CLOSE",ge[ge.EDITOR_MOVE=6]="EDITOR_MOVE",ge[ge.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ge[ge.EDITOR_LABEL=8]="EDITOR_LABEL",ge[ge.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ge[ge.EDITOR_PIN=10]="EDITOR_PIN",ge[ge.EDITOR_STICKY=11]="EDITOR_STICKY",ge[ge.EDITOR_DIRTY=12]="EDITOR_DIRTY",ge[ge.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var N;(function(ge){ge[ge.PRIMARY=1]="PRIMARY",ge[ge.SECONDARY=2]="SECONDARY",ge[ge.BOTH=3]="BOTH",ge[ge.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class R{getOriginalUri(re,W){if(!re)return;if(t(re))return e.$IE.getOriginalUri(re.result,W);if(W?.supportSideBySide){const{primary:me,secondary:le}=this.a(re);if(me&&le){if(W?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(me,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===N.ANY)return this.getOriginalUri(me,{filterByScheme:W.filterByScheme})??this.getOriginalUri(le,{filterByScheme:W.filterByScheme});re=W.supportSideBySide===N.PRIMARY?me:le}}if(n(re)||i(re)||s(re)||t(re))return;const ce=P(re)?re.preferredResource:re.resource;return!ce||!W||!W.filterByScheme?ce:this.b(ce,W.filterByScheme)}a(re){return S(re)||s(re)?{primary:re.primary,secondary:re.secondary}:p(re)||n(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,W){if(!re)return;if(t(re))return e.$IE.getCanonicalUri(re.result,W);if(W?.supportSideBySide){const{primary:me,secondary:le}=this.a(re);if(me&&le){if(W?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(me,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===N.ANY)return this.getCanonicalUri(me,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:W.filterByScheme});re=W.supportSideBySide===N.PRIMARY?me:le}}if(n(re)||i(re)||s(re)||t(re))return;const ce=re.resource;return!ce||!W||!W.filterByScheme?ce:this.b(ce,W.filterByScheme)}b(re,W){if(Array.isArray(W)){if(W.some(ce=>re.scheme===ce))return re}else if(W===re.scheme)return re}}var T;(function(ge){ge[ge.UNKNOWN=0]="UNKNOWN",ge[ge.KEYBOARD=1]="KEYBOARD",ge[ge.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function q(ge,re,W,ce){if(!ge.isSticky(re))return!1;switch(ce.preventPinnedEditorClose){case"keyboardAndMouse":return W===T.MOUSE||W===T.KEYBOARD;case"mouse":return W===T.MOUSE;case"keyboard":return W===T.KEYBOARD}return!1}e.$HE=q,e.$IE=new R;var ee;(function(ge){ge[ge.LEFT=0]="LEFT",ge[ge.RIGHT=1]="RIGHT"})(ee||(e.CloseDirection=ee={}));class J{constructor(){this.c=new Map,this.d=new Map}start(re){const W=this.a=re.get(M.$1h);for(const[ce,me]of this.c)this.e(ce,me,W);this.c.clear()}e(re,W,ce){const me=ce.createInstance(W);this.d.set(re,me)}registerFileEditorFactory(re){if(this.b)throw new Error("Can only register one file editor factory.");this.b=re}getFileEditorFactory(){return(0,F.$Pf)(this.b)}registerEditorSerializer(re,W){if(this.c.has(re)||this.d.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.a?this.e(re,W,this.a):this.c.set(re,W),(0,A.$Qc)(()=>{this.c.delete(re),this.d.delete(re)})}getEditorSerializer(re){return this.d.get(typeof re=="string"?re:re.typeId)}}b.$un.add(e.$lE.EditorFactory,new J);async function K(ge,re,W){return!ge||!ge.length?[]:await Promise.all(ge.map(async ce=>{const me=f.URI.revive(ce.fileUri);if(!me){W.info("Cannot resolve the path because it is not valid.",ce);return}if(!await re.canHandleResource(me)){W.info("Cannot resolve the path because it cannot be handled",ce);return}let de=ce.exists,Y=ce.type;if(typeof de!="boolean"||typeof Y!="number")try{Y=(await re.stat(me)).isDirectory?m.FileType.Directory:m.FileType.Unknown,de=!0}catch(Q){W.error(Q),de=!1}if(!de&&ce.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",ce);return}if(Y===m.FileType.Directory){W.info("Cannot resolve the path because it is a directory",ce);return}const X={...ce.options,pinned:!0};return de?{resource:me,options:X}:{resource:me,options:X,forceUntitled:!0}}))}e.$JE=K;var Z;(function(ge){ge[ge.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ge[ge.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function ae(ge){const re=ge;if(!re)return!1;const W=re;if(W.modified)return ae(W.modified);const ce=re;return!!(ce.contributionsState&&ce.viewState&&Array.isArray(ce.cursorState))}e.$KE=ae;function _(ge){return(0,L.$Ni)(ge)}e.$LE=_;function ye(ge,re,W){const ce=(0,L.$Oi)(ge,re);return ce.forceMessage=W?.forceMessage,ce.forceSeverity=W?.forceSeverity,ce.allowDialog=W?.allowDialog,ce}e.$ME=ye}),define(Se[278],ke([1,0,4,226,5,3,28,37,19,24,78,265]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$TE=e.$SE=e.ViewContentGroups=e.$RE=e.$QE=e.ViewContainerLocation=e.Extensions=e.$PE=e.$OE=e.$NE=void 0,e.$NE="views",e.$OE=(0,F.localize)(0,null),e.$PE=(0,I.$jw)("default-view-icon",L.$8j.window,(0,F.localize)(1,null));var $;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var y;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$QE=[0,1,2];function D(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$RE=D;class u extends A.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,m.$Rb)([...this.g.values()])}registerViewContainer(d,l,h){const c=this.get(d.id);if(c)return c;const v=d;return v.openCommandActionDescriptor=h?.doNotRegisterOpenCommand?void 0:v.openCommandActionDescriptor??{id:v.id},(0,M.$xc)(this.g,l,[]).push(v),h?.isDefault&&this.h.push(v),this.c.fire({viewContainer:v,viewContainerLocation:l}),v}deregisterViewContainer(d){for(const l of this.g.keys()){const h=this.g.get(l),c=h?.indexOf(d);if(c!==-1){h?.splice(c,1),h.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(h=>h?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}b.$un.add($.ViewContainersRegistry,new u);var g;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(g||(e.ViewContentGroups=g={}));function o(r,d){const l=r.group??g.More,h=d.group??g.More;return l!==h?l.localeCompare(h):(r.order??5)-(d.order??5)}class n extends A.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Gc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:h})=>this.r(l,h)),this.c.fire(d)}deregisterViews(d,l){const h=this.s(d,l);h.length&&this.f.fire({views:h,viewContainer:l})}moveViews(d,l){for(const h of this.m.keys())if(h!==l){const c=this.s(d,h);c.length&&(this.r(c,l),this.g.fire({views:c,from:h,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const h=(this.m.get(l)||[]).filter(c=>c.id===d)[0];if(h)return h}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(c=>c.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,A.$Qc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const h=new Map;for(const[c,v]of l)this.n.add(d,v),h.set(c,(0,A.$Qc)(()=>{this.n.delete(d,v),this.h.fire(d)}));return this.h.fire(d),h}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,h=>l.push(h)),l.sort(o)}r(d,l){let h=this.m.get(l);h||(h=[],this.m.set(l,h),this.j.push(l));for(const c of d){if(this.getView(c.id)!==null)throw new Error((0,F.localize)(2,null,c.id));h.push(c)}}s(d,l){const h=this.m.get(l);if(!h)return[];const c=[],v=[];for(const P of h)d.includes(P)?c.push(P):v.push(P);return c.length&&(v.length?this.m.set(l,v):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),c}}b.$un.add($.ViewsRegistry,new n),e.$SE=(0,f.$2h)("viewsService"),e.$TE=(0,f.$2h)("viewDescriptorService");var i;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var s;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(s||(e.TreeItemCollapsibleState=s={}));class a{constructor(d,l){this.c=!1,this.d=!1,(0,w.$ln)(this,d),this.d=!!l,this.resolve=async h=>{if(l&&!this.c){const c=await l(h);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}h.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$UE=a;class t extends Error{constructor(d){super((0,F.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$VE=t}),define(Se[279],ke([1,0,2,29,5]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$MF=e.$LF=void 0;function A(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof E.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(F.$Hs.isIRange)}e.$LF=A;function M(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(A)}e.$MF=M;var b;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var m;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(m||(e.InteractiveSessionCopyKind=m={})),e.$NF=(0,f.$2h)("IChatService")}),define(Se[141],ke([1,0,4,10,227]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlb=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new E.$Sd,this.n=new E.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,m,w,L){const I={command:b};if(m&&Object.keys(m).length>0&&(I.arguments=m),this.s("request",I),typeof L=="number"){const $=setTimeout(()=>{clearTimeout($);const y=this.f.get(I.seq);if(y){this.f.delete(I.seq);const D={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,f.localize)(0,null,L,b)};y(D)}},L)}return w&&this.f.set(I.seq,w),I.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,m){return b.type!=="event"||m.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,F.$3g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const m=b,w=this.f.get(m.request_seq);w&&(this.f.delete(m.request_seq),w(m));break}}}}s(b,m){m.type=b,m.seq=this.d++,this.sendMessage(m)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((m,w)=>b.set(w,m)),await(0,F.$3g)(500),b.forEach((m,w)=>{m({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$zlb=A}),define(Se[280],ke([1,0,228,46,5]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$wH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$vH=e.MemoryRangeType=e.$uH=e.State=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=void 0,e.$rG="workbench.view.debug",e.$sG="workbench.debug.variablesView",e.$tG="workbench.debug.watchExpressionsView",e.$uG="workbench.debug.callStackView",e.$vG="workbench.debug.loadedScriptsView",e.$wG="workbench.debug.breakPointsView",e.$xG="workbench.debug.disassemblyView",e.$yG="workbench.panel.repl",e.$zG="workbench.panel.repl.view",e.$AG=new F.$gj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$BG=new F.$gj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$CG=new F.$gj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$DG="debugUx",e.$EG=new F.$gj(e.$DG,"default",{type:"string",description:E.localize(3,null)}),e.$FG=new F.$gj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$GG=new F.$gj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$HG=new F.$gj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$IG=new F.$gj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$JG=new F.$gj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$KG=new F.$gj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$LG=new F.$gj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$MG=new F.$gj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$NG=new F.$gj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$OG=new F.$gj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$PG=new F.$gj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$QG=new F.$gj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$RG=new F.$gj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$SG=new F.$gj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$TG=new F.$gj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$UG=new F.$gj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$VG=new F.$gj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$WG=new F.$gj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$XG=new F.$gj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$YG=new F.$gj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$ZG=new F.$gj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$1G=new F.$gj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$2G=new F.$gj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$3G=new F.$gj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$4G=new F.$gj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$5G=new F.$gj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$6G=new F.$gj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$7G=new F.$gj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$8G=new F.$gj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$9G=new F.$gj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$0G=new F.$gj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$$G=new F.$gj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$_G=new F.$gj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$aH=new F.$gj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$bH=new F.$gj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$cH=new F.$gj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$dH=new F.$gj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$eH=new F.$gj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$fH=new F.$gj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$gH=new F.$gj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$hH=new F.$gj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$iH=new F.$gj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$jH=new F.$gj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$kH=new F.$gj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$lH=new F.$gj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$mH=new F.$gj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$nH=new F.$gj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$oH=new F.$gj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const A=$=>E.localize(52,null,$);e.$pH=A,e.$qH="editor.contrib.debug",e.$rH="editor.contrib.breakpoint",e.$sH="debug",e.$tH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var M;(function($){$[$.Inactive=0]="Inactive",$[$.Initializing=1]="Initializing",$[$.Stopped=2]="Stopped",$[$.Running=3]="Running"})(M||(e.State=M={}));function b($){switch($){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$uH=b;var m;(function($){$[$.Valid=0]="Valid",$[$.Unreadable=1]="Unreadable",$[$.Error=2]="Error"})(m||(e.MemoryRangeType=m={})),e.$vH="vscode-debug-memory";var w;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var L;(function($){$.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.$wH=(0,f.$2h)("debugService");var I;(function($){$[$.CONDITION=0]="CONDITION",$[$.HIT_COUNT=1]="HIT_COUNT",$[$.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(Se[281],ke([1,0,13,2,16,24,17,29,21,19]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const L=/{([^}]+)}/g;function I(P,S,p){return P.replace(L,function(k,C){return S&&C.length>0&&C[0]!=="_"?k:p&&p.hasOwnProperty(C)?p[C]:k})}e.$SF=I;function $(P){const S={};for(const p of Object.keys(P))p.startsWith("!")||(S[p]=P[p]);return S}e.$TF=$;function y(P){return P.configuration.request==="attach"&&!D(P)&&(!P.parentSession||y(P.parentSession))}e.$UF=y;function D(P){let S=P.configuration.type;if(S)return S==="vslsShare"&&(S=P.configuration.adapterProxy.configuration.type),(0,E.$8e)(S,"extensionhost")||(0,E.$8e)(S,"pwa-extensionhost")?P:P.parentSession?D(P.parentSession):void 0}e.$VF=D;function u(P){return P.type&&(P.label||P.program||P.runtime)}e.$WF=u;function g(P,S,p){let k,C=0;const j=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=j.exec(P);){const O=z.index+1,U=O+z[0].length;if(O<=S&&U>=p){k=z[0],C=O;break}}if(k){const O=/\w+/g;let U=null;for(;(U=O.exec(k))&&!(U.index+1+C+U[0].length>=p););U&&(k=k.substring(0,O.lastIndex))}return k?{start:C,end:C+k.length-1}:{start:0,end:0}}e.$XF=g;async function o(P,S,p,k){if(P.evaluatableExpressionProvider.has(S)){const C=P.evaluatableExpressionProvider.ordered(S),j=(0,w.$Hb)(await Promise.all(C.map(async z=>{try{return await z.provideEvaluatableExpression(S,p,k??m.CancellationToken.None)}catch{return}})));if(j.length>0){let z=j[0].expression;const O=j[0].range;return z||(z=S.getLineContent(p.lineNumber).substring(O.startColumn-1,O.endColumn-1)),{range:O,matchingExpression:z}}}else{const C=S.getLineContent(p.lineNumber),{start:j,end:z}=g(C,p.column,p.column),O=C.substring(j-1,z);return{matchingExpression:O,range:new b.$Hs(p.lineNumber,j,p.lineNumber,j+O.length)}}return null}e.$YF=o;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(P){return!!(P&&P.match(n))}e.$ZF=i;function s(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(i(P.path))return F.URI.parse(P.path);if((0,f.$ic)(P.path))return F.URI.file(P.path)}return P.path}function a(P){if(typeof P.path=="object"){const S=F.URI.revive(P.path);if(S)return S.scheme===M.Schemas.file?S.fsPath:S.toString()}return P.path}function t(P,S){const p=S?s:a,k=(0,A.$in)(P);return d(k,(C,j)=>{C&&j&&(j.path=p(j))}),k}e.$1F=t;function r(P,S){const p=S?s:a,k=(0,A.$in)(P);return d(k,(C,j)=>{!C&&j&&(j.path=p(j))}),k}e.$2F=r;function d(P,S){switch(P.type){case"event":{const p=P;switch(p.event){case"output":S(!1,p.body.source);break;case"loadedSource":S(!1,p.body.source);break;case"breakpoint":S(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=P;switch(p.command){case"setBreakpoints":S(!0,p.arguments.source);break;case"breakpointLocations":S(!0,p.arguments.source);break;case"source":S(!0,p.arguments.source);break;case"gotoTargets":S(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(k=>S(!1,k));break;default:break}break}case"response":{const p=P;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(k=>S(!1,k.source));break;case"loadedSources":p.body.sources.forEach(k=>S(!1,k));break;case"scopes":p.body.scopes.forEach(k=>S(!1,k.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(k=>S(!1,k.source));break;case"setBreakpoints":p.body.breakpoints.forEach(k=>S(!1,k.source));break;case"disassemble":p.body?.instructions.forEach(C=>S(!1,C.location));break;default:break}break}}}function l(P){return P.filter(S=>!S.presentation?.hidden).sort((S,p)=>S.presentation?p.presentation?S.presentation.group?p.presentation.group?S.presentation.group!==p.presentation.group?S.presentation.group.localeCompare(p.presentation.group):h(S.presentation.order,p.presentation.order):-1:p.presentation.group?1:h(S.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$3F=l;function h(P,S){return typeof P!="number"?typeof S!="number"?0:1:typeof S!="number"?-1:P-S}async function c(P,S){const p=P.getValue("debug.saveBeforeStart",{overrideIdentifier:S.activeTextEditorLanguageId});if(p!=="none"&&(await S.saveAll(),p==="allEditorsInActiveGroup")){const k=S.activeEditorPane;k&&k.input.resource?.scheme===M.Schemas.untitled&&await S.save({editor:k.input,groupId:k.group.id})}await P.reloadConfiguration()}e.$4F=c;const v=(P,S)=>!P||!S?P===S:P.name===S.name&&P.path===S.path&&P.sourceReference===S.sourceReference;e.$5F=v}),define(Se[282],ke([1,0,50,63,24,16,9,13,31,229,141]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=e.$thc=e.$shc=e.$rhc=e.$qhc=void 0;class I extends L.$zlb{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,n){this.p=n,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",i=>this.w(i))}sendMessage(o){if(this.p){const n=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const n=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.m.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.r.indexOf(I.a);if(n!==-1){const s=this.r.toString("utf8",0,n).split(I.b);for(const a of s){const t=a.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(n+I.a.length);continue}}break}}}e.$qhc=I,I.a=`\r
\r
`,I.b=/\r?\n/,I.l=/: */;class $ extends I{startSession(){return new Promise((o,n)=>{let i=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),i=!0}),this.x.on("close",()=>{i?this.m.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",s=>{i?this.m.fire(s):n(s)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$rhc=$;class y extends ${constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$shc=y;class D extends ${constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.path,o)}}e.$thc=D;class u extends I{constructor(o,n){super(),this.y=o,this.z=n}async startSession(){const o=this.y.command,n=this.y.args,i=this.y.options||{};try{if(o)if(A.$ic(o)){if(!await m.Promises.exists(o))throw new Error(w.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(w.localize(1,null,this.z));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=f.$ln(f.$in(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:s,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const r=E.fork(n[0],n.slice(1),t);if(!r.pid)throw new Error(w.localize(2,null,n[0]));this.x=r}else throw new Error(w.localize(3,null));else{const a={env:s};i.cwd&&(a.cwd=i.cwd),this.x=E.spawn(o,n,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(s){this.m.fire(s)}}async stopSession(){return this.x?(await this.u(),M.$c?new Promise((o,n)=>{const i=E.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,a,t){if(s)return n(s)});i.on("exit",o),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=A.$jc(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(A.$ic(o.program)?i.program=o.program:i.program=A.$jc(n,o.program)),o.args&&(i.args=o.args);const s=o;return s.win&&(i.win=u.A(s.win,n)),s.winx86&&(i.winx86=u.A(s.winx86,n)),s.windows&&(i.windows=u.A(s.windows,n)),s.osx&&(i.osx=u.A(s.osx,n)),s.linux&&(i.linux=u.A(s.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const l of o)if(l.contributes){const h=l.contributes.debuggers;h&&h.length>0&&h.filter(c=>typeof c.type=="string"&&b.$8e(c.type,n)).forEach(c=>{const v=u.A(c,l.extensionLocation.fsPath);i=f.$ln(i,v,l.isBuiltin)})}let s;M.$c&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:M.$c?s=i.win||i.windows:M.$d?s=i.osx:M.$e&&(s=i.linux),s=s||i;const a=s.program||i.program,t=s.args||i.args,r=s.runtime||i.runtime,d=s.runtimeArgs||i.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$uhc=u}),define(Se[283],ke([1,0,50,33,9]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=e.$vhc=void 0;function A(w,L){return new Promise((I,$)=>{let y="";const D=E.spawn(w,L);D.pid&&D.stdout.on("data",u=>{y+=u.toString()}),D.on("error",u=>{$(u)}),D.on("close",u=>{I(y)})})}async function M(w){if(w)if(f.$c){const L=await new Promise((I,$)=>{ie(["@vscode/windows-process-tree"],I,$)});return new Promise(I=>{L.getProcessTree(w,$=>{I(!!$&&$.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(w)]).then(L=>{const I=L.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$vhc=M;var b;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(b||(b={}));function m(w,L,I,$,y){w=w.trim().toLowerCase();let D;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?D=1:w.indexOf("cmd.exe")>=0?D=0:w.indexOf("bash")>=0?D=2:f.$c?D=0:D=2;let u,g=" ";switch(D){case 1:if(u=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),$){const o=(0,F.$9f)($);o&&(g+=`${o}:; `),g+=`cd ${u($)}; `}if(y)for(const o in y){const n=y[o];n===null?g+=`Remove-Item env:${o}; `:g+=`\${env:${o}}='${n}'; `}if(L.length>0){const o=L.shift(),n=I?o:u(o);g+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of L)g+=i==="<"||i===">"||I?i:u(i),g+=" "}break;case 0:if(u=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>o.includes(n))||o.length===0?`"${o}"`:o),$){const o=(0,F.$9f)($);o&&(g+=`${o}: && `),g+=`cd ${u($)} && `}if(y){g+='cmd /C "';for(const o in y){let n=y[o];n===null?g+=`set "${o}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),g+=`set "${o}=${n}" && `)}}for(const o of L)g+=o==="<"||o===">"||I?o:u(o),g+=" ";y&&(g+='"');break;case 2:{u=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),n.length===0?'""':n);const o=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if($&&(g+=`cd ${u($)} ; `),y){g+="/usr/bin/env";for(const n in y){const i=y[n];i===null?g+=` -u ${o(n)}`:g+=` ${o(`${n}=${i}`)}`}g+=" "}for(const n of L)g+=n==="<"||n===">"||I?n:u(n),g+=" ";break}}return g}e.$whc=m}),define(Se[112],ke([1,0,22,34,52,98,17,16,9,46]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.$SI=e.$RI=e.$QI=e.CellStatusbarAlignment=e.$PI=e.$OI=e.$NI=e.NotebookEditorPriority=e.$MI=e.$LI=e.$KI=e.$JI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$II=e.$HI=e.$GI=e.$FI=e.CellKind=e.$EI=e.$DI=e.$CI=void 0,e.$CI="workbench.editor.notebook",e.$DI="workbench.editor.notebookTextDiffEditor",e.$EI="workbench.editor.interactive";var L;(function(R){R[R.Markup=1]="Markup",R[R.Code=2]="Code"})(L||(e.CellKind=L={})),e.$FI=["application/json","application/javascript","text/html","image/svg+xml",A.$4r.latex,A.$4r.markdown,"image/png","image/jpeg",A.$4r.text],e.$GI=[A.$4r.latex,A.$4r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$4r.text],e.$HI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$II="_notAvailable";var I;(function(R){R[R.Running=1]="Running",R[R.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var $;(function(R){R[R.Unconfirmed=1]="Unconfirmed",R[R.Pending=2]="Pending",R[R.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var y;(function(R){R[R.Unconfirmed=1]="Unconfirmed",R[R.Pending=2]="Pending",R[R.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var D;(function(R){R[R.WithHardKernelDependency=0]="WithHardKernelDependency",R[R.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",R[R.Pure=2]="Pure",R[R.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var u;(function(R){R.Always="always",R.Never="never",R.Optional="optional"})(u||(e.RendererMessagingSpec=u={}));var g;(function(R){R[R.ModelChange=1]="ModelChange",R[R.Move=2]="Move",R[R.ChangeCellLanguage=5]="ChangeCellLanguage",R[R.Initialize=6]="Initialize",R[R.ChangeCellMetadata=7]="ChangeCellMetadata",R[R.Output=8]="Output",R[R.OutputItem=9]="OutputItem",R[R.ChangeCellContent=10]="ChangeCellContent",R[R.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",R[R.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",R[R.ChangeCellMime=13]="ChangeCellMime",R[R.Unknown=100]="Unknown"})(g||(e.NotebookCellsChangeType=g={}));var o;(function(R){R[R.Handle=0]="Handle",R[R.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var n;(function(R){R[R.Replace=1]="Replace",R[R.Output=2]="Output",R[R.Metadata=3]="Metadata",R[R.CellLanguage=4]="CellLanguage",R[R.DocumentMetadata=5]="DocumentMetadata",R[R.Move=6]="Move",R[R.OutputItems=7]="OutputItems",R[R.PartialMetadata=8]="PartialMetadata",R[R.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var i;(function(R){R.scheme=M.Schemas.vscodeNotebookCell;const T=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${T.join("")}]+`),ee=7;function J(ge,re){const W=re.toString(ee),me=`${W.length<T.length?T[W.length-1]:"z"}${W}s${(0,E.$Ae)(E.$ge.fromString(ge.scheme),!0,!0)}`;return ge.with({scheme:R.scheme,fragment:me})}R.generate=J;function K(ge){if(ge.scheme!==R.scheme)return;const re=ge.fragment.indexOf("s");if(re<0)return;const W=parseInt(ge.fragment.substring(0,re).replace(q,""),ee),ce=(0,E.$ze)(ge.fragment.substring(re+1)).toString();if(!isNaN(W))return{handle:W,notebook:ge.with({scheme:ce,fragment:null})}}R.parse=K;function Z(ge,re){return ge.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${ge.scheme!==M.Schemas.file?ge.scheme:""}`})}R.generateCellOutputUri=Z;function ae(ge){if(ge.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ge.fragment);if(!re)return;const W=re[1]&&re[1]!==""?re[1]:void 0,ce=re[2];return{outputId:W,notebook:ge.with({scheme:ce||M.Schemas.file,fragment:null})}}R.parseCellOutputUri=ae;function _(ge,re,W){return R.generate(ge,re).with({scheme:W})}R.generateCellPropertyUri=_;function ye(ge,re){if(ge.scheme===re)return R.parse(ge.with({scheme:R.scheme}))}R.parseCellPropertyUri=ye})(i||(e.CellUri=i={}));const s=R=>m.$c?R.replace(/\//g,"\\"):R;class a{constructor(T=[],q=e.$FI){this.e=q,this.d=[...new Set(T)].map(ee=>({pattern:ee,matches:F.$Ij(s(ee))}))}sort(T){const q=new Map(f.Iterable.map(T,J=>[J,s(J)]));let ee=[];for(const{matches:J}of this.d)for(const[K,Z]of q)if(J(Z)){ee.push(K),q.delete(K);break}return q.size&&(ee=ee.concat([...q.keys()].sort((J,K)=>this.e.indexOf(J)-this.e.indexOf(K)))),ee}prioritize(T,q){const ee=this.f(T);if(ee===-1){this.d.unshift({pattern:T,matches:F.$Ij(s(T))});return}const J=new Set(q.map(Z=>this.f(Z,ee)));J.delete(-1);const K=Array.from(J).sort();this.d.splice(ee+1,0,...K.map(Z=>this.d[Z]));for(let Z=K.length-1;Z>=0;Z--)this.d.splice(K[Z],1)}toArray(){return this.d.map(T=>T.pattern)}f(T,q=this.d.length){const ee=s(T);for(let J=0;J<q;J++)if(this.d[J].matches(ee))return J;return-1}}e.$JI=a;function t(R,T,q,ee=(J,K)=>J===K){const J=[];function K(_,ye,ge){if(ye===0&&ge.length===0)return;const re=J[J.length-1];re&&re.start+re.deleteCount===_?(re.deleteCount+=ye,re.toInsert.push(...ge)):J.push({start:_,deleteCount:ye,toInsert:ge})}let Z=0,ae=0;for(;;){if(Z===R.length){K(Z,0,T.slice(ae));break}if(ae===T.length){K(Z,R.length-Z,[]);break}const _=R[Z],ye=T[ae];if(ee(_,ye)){Z+=1,ae+=1;continue}q(ye)?(K(Z,1,[]),Z+=1):(K(Z,0,[ye]),ae+=1)}return J}e.$KI=t,e.$LI=new w.$gj("notebookEditorCursorAtBoundary","none"),e.$MI=new w.$gj("notebookEditorCursorAtLineBoundary","none");var r;(function(R){R.default="default",R.option="option"})(r||(e.NotebookEditorPriority=r={}));function d(R){const T=R;return!!((typeof T.include=="string"||F.$Jj(T.include))&&(typeof T.exclude=="string"||F.$Jj(T.exclude)))}e.$NI=d;function l(R,T,q){if(Array.isArray(R.viewType)&&R.viewType.indexOf(T)>=0||R.viewType===T)return!0;if(R.filenamePattern){const ee=d(R.filenamePattern)?R.filenamePattern.include:R.filenamePattern,J=d(R.filenamePattern)?R.filenamePattern.exclude:void 0;if(F.$Hj(ee,(0,b.$nc)(q.fsPath).toLowerCase()))return!(J&&F.$Hj(J,(0,b.$nc)(q.fsPath).toLowerCase()))}return!1}e.$OI=l,e.$PI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var h;(function(R){R[R.Left=1]="Left",R[R.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class c{static create(T){return`${c.d}${T}`}static parse(T){if(T.startsWith(c.d))return T.substring(c.d.length)}}e.$QI=c,c.d="notebook/";function v(R){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(R)}e.$RI=v;const P=new TextDecoder;function S(R){const T=[];let q=!1;for(const Z of R)(T.length===0||q)&&(T.push(Z),q=!0);let ee=C(T);const J=E.$ge.concat(T.map(Z=>E.$ge.wrap(Z))),K=N(J);return ee=ee||K.byteLength!==J.byteLength,{data:K,didCompression:ee}}e.$SI=S,e.$TI=`${String.fromCharCode(27)}[A`;const p=e.$TI.split("").map(R=>R.charCodeAt(0)),k=10;function C(R){let T=!1;return R.forEach((q,ee)=>{if(ee===0||q.length<e.$TI.length)return;const J=R[ee-1],K=q.subarray(0,e.$TI.length);if(K[0]===p[0]&&K[1]===p[1]&&K[2]===p[2]){const Z=J.lastIndexOf(k);if(Z===-1)return;T=!0,R[ee-1]=J.subarray(0,Z),R[ee]=q.subarray(e.$TI.length)}}),T}function j(R){let T=R;do R=T,T=R.replace(/[^\n]\x08/gm,"");while(T.length<R.length);return R}function z(R){for(R=R.replace(/\r+\n/gm,`
`);R.search(/\r[^$]/g)>-1;){const T=R.match(/^(.*)\r+/m)[1];let q=R.match(/\r+(.*)$/m)[1];q=q+T.slice(q.length,T.length),R=R.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return R}const O="\b".charCodeAt(0),U="\r".charCodeAt(0);function N(R){return!R.buffer.includes(O)&&!R.buffer.includes(U)?R:E.$ge.fromString(z(j(P.decode(R.buffer))))}});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[7],ke([1,0,19,8,79,28,98,13,18,2,30,26,32,64,112]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D){"use strict";var u,g,o,n,i,s,a,t,r,d,l,h,c,v,P,S,p,k,C,j,z,O,U,N,R;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$GM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$FM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.TestRunProfileKind=e.TestResultState=e.$lM=e.$kM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$jM=e.NotebookVariablesRequestKind=e.$iM=e.$hM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$gM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.ColorThemeKind=e.$aM=e.$_L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$$L=e.DebugConsoleMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$5L=e.$4L=e.FileChangeType=e.$3L=e.$2L=e.$1L=e.$ZL=e.InlineCompletionTriggerKind=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.ConfigurationTarget=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$CL=e.ViewBadge=e.ProgressLocation=e.$BL=e.$AL=e.TaskScope=e.ShellQuoting=e.$zL=e.$yL=e.$xL=e.TaskPanelKind=e.TaskRevealKind=e.$wL=e.TerminalLocation=e.$vL=e.$uL=e.$tL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$sL=e.$rL=e.$qL=e.$pL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$oL=e.StatusBarAlignment=e.ViewColumn=e.$nL=e.$mL=e.$lL=e.$kL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$jL=e.$iL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.LanguageStatusSeverity=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.CodeActionTriggerKind=e.$9K=e.$8K=e.SymbolTag=e.SymbolKind=e.$7K=e.$6K=e.DocumentHighlightKind=e.$5K=e.$4K=e.$3K=e.$2K=e.DiagnosticSeverity=e.DiagnosticTag=e.$1K=e.$ZK=e.FileEditType=e.$YK=e.$XK=e.$WK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function T(G){return Object.assign(G,{apply:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const Me=we.length===1?[]:we[1];return Reflect.construct(G,Me,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const[Me,...xe]=we;return Reflect.construct(G,xe,Me.constructor)}}})}var q;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(q||(e.TerminalOutputAnchor=q={}));var ee;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(ee||(e.TerminalQuickFixType=ee={}));let J=r=class{static from(...V){let we=V;return new r(function(){if(we){for(const Me of we)Me&&typeof Me.dispose=="function"&&Me.dispose();we=void 0}})}constructor(V){u.set(this,void 0),nt(this,u,V,"f")}dispose(){typeof We(this,u,"f")=="function"&&(We(this,u,"f").call(this),nt(this,u,void 0,"f"))}};e.$PK=J,u=new WeakMap,e.$PK=J=r=Qe([T],J);let K=d=class{static Min(...V){if(V.length===0)throw new TypeError;let we=V[0];for(let Me=1;Me<V.length;Me++){const xe=V[Me];xe.isBefore(we)&&(we=xe)}return we}static Max(...V){if(V.length===0)throw new TypeError;let we=V[0];for(let Me=1;Me<V.length;Me++){const xe=V[Me];xe.isAfter(we)&&(we=xe)}return we}static isPosition(V){if(!V)return!1;if(V instanceof d)return!0;const{line:we,character:Me}=V;return typeof we=="number"&&typeof Me=="number"}static of(V){if(V instanceof d)return V;if(this.isPosition(V))return new d(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,we){if(V<0)throw(0,F.$7)("line must be non-negative");if(we<0)throw(0,F.$7)("character must be non-negative");this.c=V,this.e=we}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,we=0){if(V===null||we===null)throw(0,F.$7)();let Me;return typeof V>"u"?Me=0:typeof V=="number"?Me=V:(Me=typeof V.lineDelta=="number"?V.lineDelta:0,we=typeof V.characterDelta=="number"?V.characterDelta:0),Me===0&&we===0?this:new d(this.line+Me,this.character+we)}with(V,we=this.character){if(V===null||we===null)throw(0,F.$7)();let Me;return typeof V>"u"?Me=this.line:typeof V=="number"?Me=V:(Me=typeof V.line=="number"?V.line:this.line,we=typeof V.character=="number"?V.character:this.character),Me===this.line&&we===this.character?this:new d(Me,we)}toJSON(){return{line:this.line,character:this.character}}};e.$QK=K,e.$QK=K=d=Qe([T],K);let Z=l=class{static isRange(V){return V instanceof l?!0:V?K.isPosition(V.start)&&K.isPosition(V.end):!1}static of(V){if(V instanceof l)return V;if(this.isRange(V))return new l(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,we,Me,xe){let rt,ht;if(typeof V=="number"&&typeof we=="number"&&typeof Me=="number"&&typeof xe=="number"?(rt=new K(V,we),ht=new K(Me,xe)):K.isPosition(V)&&K.isPosition(we)&&(rt=K.of(V),ht=K.of(we)),!rt||!ht)throw new Error("Invalid arguments");rt.isBefore(ht)?(this.c=rt,this.e=ht):(this.c=ht,this.e=rt)}contains(V){return l.isRange(V)?this.contains(V.start)&&this.contains(V.end):K.isPosition(V)?!(K.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const we=K.Max(V.start,this.c),Me=K.Min(V.end,this.e);if(!we.isAfter(Me))return new l(we,Me)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const we=K.Min(V.start,this.c),Me=K.Max(V.end,this.end);return new l(we,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,we=this.end){if(V===null||we===null)throw(0,F.$7)();let Me;return V?K.isPosition(V)?Me=V:(Me=V.start||this.start,we=V.end||this.end):Me=this.start,Me.isEqual(this.c)&&we.isEqual(this.end)?this:new l(Me,we)}toJSON(){return[this.start,this.end]}};e.$RK=Z,e.$RK=Z=l=Qe([T],Z);let ae=h=class extends Z{static isSelection(V){return V instanceof h?!0:V?Z.isRange(V)&&K.isPosition(V.anchor)&&K.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,we,Me,xe){let rt,ht;if(typeof V=="number"&&typeof we=="number"&&typeof Me=="number"&&typeof xe=="number"?(rt=new K(V,we),ht=new K(Me,xe)):K.isPosition(V)&&K.isPosition(we)&&(rt=K.of(V),ht=K.of(we)),!rt||!ht)throw new Error("Invalid arguments");super(rt,ht),this.f=rt,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$SK=ae,e.$SK=ae=h=Qe([T],ae);const _=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,F.$7)("connectionToken")};class ye{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,we,Me){if(typeof V!="string"||V.length===0)throw(0,F.$7)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,F.$7)("port");typeof Me<"u"&&_(Me),this.host=V,this.port=Math.round(we),this.connectionToken=Me}}e.$TK=ye;class ge{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,we){this.makeConnection=V,this.connectionToken=we,typeof we<"u"&&_(we)}}e.$UK=ge;class re extends Error{static NotAvailable(V,we){return new re(V,y.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(V){return new re(V,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,we=y.RemoteAuthorityResolverErrorCode.Unknown,Me){super(V),this._message=V,this._code=we,this._detail=Me,Object.setPrototypeOf(this,re.prototype)}}e.$VK=re;var W;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(W||(e.EndOfLine=W={}));var ce;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(ce||(e.EnvironmentVariableMutatorType=ce={}));let me=c=class{static isTextEdit(V){return V instanceof c?!0:V?Z.isRange(V)&&typeof V.newText=="string":!1}static replace(V,we){return new c(V,we)}static insert(V,we){return c.replace(new Z(V,V),we)}static delete(V){return c.replace(V,"")}static setEndOfLine(V){const we=new c(new Z(new K(0,0),new K(0,0)),"");return we.newEol=V,we}get range(){return this.c}set range(V){if(V&&!Z.isRange(V))throw(0,F.$7)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,F.$7)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,F.$7)("newEol");this.f=V}constructor(V,we){this.c=V,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$WK=me,e.$WK=me=c=Qe([T],me);let le=v=class{static isNotebookCellEdit(V){return V instanceof v?!0:V?Ut.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,we){return new v(V,we)}static insertCells(V,we){return new v(new Ut(V,V),we)}static deleteCells(V){return new v(V,[])}static updateCellMetadata(V,we){const Me=new v(new Ut(V,V),[]);return Me.newCellMetadata=we,Me}static updateNotebookMetadata(V){const we=new v(new Ut(0,0),[]);return we.newNotebookMetadata=V,we}constructor(V,we){this.range=V,this.newCells=we}};e.$XK=le,e.$XK=le=v=Qe([T],le);class de{static isSnippetTextEdit(V){return V instanceof de?!0:V?Z.isRange(V.range)&&Q.isSnippetString(V.snippet):!1}static replace(V,we){return new de(V,we)}static insert(V,we){return de.replace(new Z(V,V),we)}constructor(V,we){this.range=V,this.snippet=we}}e.$YK=de;var Y;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(Y||(e.FileEditType=Y={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,we,Me,xe){this.c.push({_type:1,from:V,to:we,options:Me,metadata:xe})}createFile(V,we,Me){this.c.push({_type:1,from:void 0,to:V,options:we,metadata:Me})}deleteFile(V,we,Me){this.c.push({_type:1,from:V,to:void 0,options:we,metadata:Me})}e(V,we,Me){this.c.push({_type:3,metadata:Me,uri:V,edit:{editType:5,metadata:we},notebookMetadata:we})}f(V,we,Me,xe){const rt=we.start,ht=we.end;(rt!==ht||Me.length>0)&&this.c.push({_type:5,uri:V,index:rt,count:ht-rt,cells:Me,metadata:xe})}g(V,we,Me,xe){this.c.push({_type:3,metadata:xe,uri:V,edit:{editType:3,index:we,metadata:Me}})}replace(V,we,Me,xe){this.c.push({_type:2,uri:V,edit:new me(we,Me),metadata:xe})}insert(V,we,Me,xe){this.replace(V,new Z(we,we),Me,xe)}delete(V,we,Me){this.replace(V,we,"",Me)}has(V){return this.c.some(we=>we._type===2&&we.uri.toString()===V.toString())}set(V,we){if(we)for(const Me of we){if(!Me)continue;let xe,rt;Array.isArray(Me)?(xe=Me[0],rt=Me[1]):xe=Me,le.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(V,xe.range.start,xe.newCellMetadata,rt):xe.newNotebookMetadata?this.e(V,xe.newNotebookMetadata,rt):this.f(V,xe.range,xe.newCells,rt):de.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:V,range:xe.range,edit:xe.snippet,metadata:rt}):this.c.push({_type:2,uri:V,edit:xe,metadata:rt})}else{for(let Me=0;Me<this.c.length;Me++){const xe=this.c[Me];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===V.toString()&&(this.c[Me]=void 0);break}}(0,E.$Ib)(this.c)}}get(V){const we=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===V.toString()&&we.push(Me.edit);return we}entries(){const V=new A.$Ac;for(const we of this.c)if(we._type===2){let Me=V.get(we.uri);Me||(Me=[we.uri,[]],V.set(we.uri,Me)),Me[1].push(we.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$ZK=X,e.$ZK=X=Qe([T],X);let Q=P=class{static isSnippetString(V){return V instanceof P?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=P.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,we=this.e++){if(typeof V=="function"){const Me=new P;Me.e=this.e,V(Me),this.e=Me.e,V=Me.value}else V=P.c(V);return this.value+="${",this.value+=we,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,we=this.e++){const Me=V.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(V,we){if(typeof we=="function"){const Me=new P;Me.e=this.e,we(Me),this.e=Me.e,we=Me.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$1K=Q,e.$1K=Q=P=Qe([T],Q);var te;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(te||(e.DiagnosticTag=te={}));var $e;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})($e||(e.DiagnosticSeverity=$e={}));let ve=S=class{static isLocation(V){return V instanceof S?!0:V?Z.isRange(V.range)&&w.URI.isUri(V.uri):!1}constructor(V,we){if(this.uri=V,we)if(Z.isRange(we))this.range=Z.of(we);else if(K.isPosition(we))this.range=new Z(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$2K=ve,e.$2K=ve=S=Qe([T],ve);let Le=class{static is(V){return V?typeof V.message=="string"&&V.location&&Z.isRange(V.location.range)&&w.URI.isUri(V.location.uri):!1}constructor(V,we){this.location=V,this.message=we}static isEqual(V,we){return V===we?!0:!V||!we?!1:V.message===we.message&&V.location.range.isEqual(we.location.range)&&V.location.uri.toString()===we.location.uri.toString()}};e.$3K=Le,e.$3K=Le=Qe([T],Le);let pe=class{constructor(V,we,Me=$e.Error){if(!Z.isRange(V))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=V,this.message=we,this.severity=Me}toJSON(){return{severity:$e[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,we){return V===we?!0:!V||!we?!1:V.message===we.message&&V.severity===we.severity&&V.code===we.code&&V.severity===we.severity&&V.source===we.source&&V.range.isEqual(we.range)&&(0,E.$ub)(V.tags,we.tags)&&(0,E.$ub)(V.relatedInformation,we.relatedInformation,Le.isEqual)}};e.$4K=pe,e.$4K=pe=Qe([T],pe);let De=class{constructor(V,we){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=we}};e.$5K=De,e.$5K=De=Qe([T],De);var B;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(B||(e.DocumentHighlightKind=B={}));let x=class{constructor(V,we=B.Text){this.range=V,this.kind=we}toJSON(){return{range:this.range,kind:B[this.kind]}}};e.$6K=x,e.$6K=x=Qe([T],x);let se=class{constructor(V,we){this.uri=V,this.highlights=we}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.$7K=se,e.$7K=se=Qe([T],se);var H;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(H||(e.SymbolKind=H={}));var ue;(function(G){G[G.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let fe=p=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,we,Me,xe,rt){this.name=V,this.kind=we,this.containerName=rt,typeof Me=="string"&&(this.containerName=Me),xe instanceof ve?this.location=xe:Me instanceof Z&&(this.location=new ve(xe,Me)),p.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};e.$8K=fe,e.$8K=fe=p=Qe([T],fe);let Re=k=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(k.validate)}constructor(V,we,Me,xe,rt){this.name=V,this.detail=we,this.kind=Me,this.range=xe,this.selectionRange=rt,this.children=[],k.validate(this)}};e.$9K=Re,e.$9K=Re=k=Qe([T],Re);var Oe;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let Ge=class{constructor(V,we){this.title=V,this.kind=we}};e.$0K=Ge,e.$0K=Ge=Qe([T],Ge);let He=C=class{constructor(V){this.value=V}append(V){return new C(this.value?this.value+C.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+C.c)}};e.$$K=He,He.c=".",e.$$K=He=C=Qe([T],He),He.Empty=new He(""),He.QuickFix=He.Empty.append("quickfix"),He.Refactor=He.Empty.append("refactor"),He.RefactorExtract=He.Refactor.append("extract"),He.RefactorInline=He.Refactor.append("inline"),He.RefactorMove=He.Refactor.append("move"),He.RefactorRewrite=He.Refactor.append("rewrite"),He.Source=He.Empty.append("source"),He.SourceOrganizeImports=He.Source.append("organizeImports"),He.SourceFixAll=He.Source.append("fixAll"),He.Notebook=He.Empty.append("notebook");let et=class{constructor(V,we){if(this.range=V,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$_K=et,e.$_K=et=Qe([T],et);class lt{constructor(V,we,Me,xe,rt,ht){this.kind=V,this.name=we,this.detail=Me,this.uri=xe,this.range=rt,this.selectionRange=ht}}e.$aL=lt;class ct{constructor(V,we){this.fromRanges=we,this.from=V}}e.$bL=ct;class ot{constructor(V,we){this.fromRanges=we,this.to=V}}e.$cL=ot;var Pe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Pe||(e.LanguageStatusSeverity=Pe={}));let Ue=class{constructor(V,we){this.range=V,this.command=we}get isResolved(){return!!this.command}};e.$dL=Ue,e.$dL=Ue=Qe([T],Ue);let Ae=j=class{static isMarkdownString(V){return V instanceof j?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,we=!1){g.set(this,void 0),nt(this,g,new f.$dk(V,{supportThemeIcons:we}),"f")}get value(){return We(this,g,"f").value}set value(V){We(this,g,"f").value=V}get isTrusted(){return We(this,g,"f").isTrusted}set isTrusted(V){We(this,g,"f").isTrusted=V}get supportThemeIcons(){return We(this,g,"f").supportThemeIcons}set supportThemeIcons(V){We(this,g,"f").supportThemeIcons=V}get supportHtml(){return We(this,g,"f").supportHtml}set supportHtml(V){We(this,g,"f").supportHtml=V}get baseUri(){return We(this,g,"f").baseUri}set baseUri(V){We(this,g,"f").baseUri=V}appendText(V){return We(this,g,"f").appendText(V),this}appendMarkdown(V){return We(this,g,"f").appendMarkdown(V),this}appendCodeblock(V,we){return We(this,g,"f").appendCodeblock(we??"",V),this}};e.$eL=Ae,g=new WeakMap,e.$eL=Ae=j=Qe([T],Ae);let Xe=class{constructor(V,we){this.label=V,this.documentation=we}};e.$fL=Xe,e.$fL=Xe=Qe([T],Xe);let ne=class{constructor(V,we){this.label=V,this.documentation=we,this.parameters=[]}};e.$gL=ne,e.$gL=ne=Qe([T],ne);let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$hL=he,e.$hL=he=Qe([T],he);var Ie;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(Ie||(e.SignatureHelpTriggerKind=Ie={}));var Ke;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Ke||(e.InlayHintKind=Ke={}));let Ye=class{constructor(V){this.value=V}};e.$iL=Ye,e.$iL=Ye=Qe([T],Ye);let it=class{constructor(V,we,Me){this.position=V,this.label=we,this.kind=Me}};e.$jL=it,e.$jL=it=Qe([T],it);var at;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var je;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(je||(e.CompletionItemKind=je={}));var Et;(function(G){G[G.Deprecated=1]="Deprecated"})(Et||(e.CompletionItemTag=Et={}));let It=class{constructor(V,we){this.label=V,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$kL=It,e.$kL=It=Qe([T],It);let Ht=class{constructor(V=[],we=!1){this.items=V,this.isIncomplete=we}};e.$lL=Ht,e.$lL=Ht=Qe([T],Ht);let Kt=class{constructor(V,we,Me){this.insertText=V,this.range=we,this.command=Me}};e.$mL=Kt,e.$mL=Kt=Qe([T],Kt);let yt=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$nL=yt,e.$nL=yt=Qe([T],yt);var Gt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Gt||(e.ViewColumn=Gt={}));var zt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(zt||(e.StatusBarAlignment=zt={}));function ni(G,V){return`${I.$hm.toKey(G)}.${V}`}e.$oL=ni;var Jt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Jt||(e.TextEditorLineNumbersStyle=Jt={}));var Ft;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Ft||(e.TextDocumentSaveReason=Ft={}));var tt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(tt||(e.TextEditorRevealType=tt={}));var Bt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Zt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var dt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(dt||(e.DecorationRangeBehavior=dt={})),function(G){function V(we){switch(we){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=V}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var $t;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})($t||(e.SyntaxTokenType=$t={})),function(G){function V(we){switch(we){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=V}($t||(e.SyntaxTokenType=$t={}));let Nt=class{constructor(V,we){if(we&&!w.URI.isUri(we))throw(0,F.$7)("target");if(!Z.isRange(V)||V.isEmpty)throw(0,F.$7)("range");this.range=V,this.target=we}};e.$pL=Nt,e.$pL=Nt=Qe([T],Nt);let Tt=class{constructor(V,we,Me,xe){this.red=V,this.green=we,this.blue=Me,this.alpha=xe}};e.$qL=Tt,e.$qL=Tt=Qe([T],Tt);let St=class{constructor(V,we){if(we&&!(we instanceof Tt))throw(0,F.$7)("color");if(!Z.isRange(V)||V.isEmpty)throw(0,F.$7)("range");this.range=V,this.color=we}};e.$rL=St,e.$rL=St=Qe([T],St);let ft=class{constructor(V){if(!V||typeof V!="string")throw(0,F.$7)("label");this.label=V}};e.$sL=ft,e.$sL=ft=Qe([T],ft);var Lt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Lt||(e.ColorFormat=Lt={}));var _t;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(_t||(e.SourceControlInputBoxValidationType=_t={}));var Pt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Pt||(e.TerminalExitReason=Pt={}));class Ze{constructor(V,we,Me){if(this.startIndex=V,this.length=we,this.tooltip=Me,typeof V!="number"||V<0)throw(0,F.$7)("startIndex");if(typeof we!="number"||we<1)throw(0,F.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,F.$7)("tooltip")}}e.$tL=Ze;class Wt{constructor(V){this.uri=V}}e.$uL=Wt;class Xt{constructor(V){this.terminalCommand=V}}e.$vL=Xt;var Yt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Yt||(e.TerminalLocation=Yt={}));class pt{constructor(V){if(this.options=V,typeof V!="object")throw(0,F.$7)("options")}}e.$wL=pt;var Ot;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Ot||(e.TaskRevealKind=Ot={}));var Fe;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Fe||(e.TaskPanelKind=Fe={}));let Ne=z=class{static from(V){switch(V){case"clean":return z.Clean;case"build":return z.Build;case"rebuild":return z.Rebuild;case"test":return z.Test;default:return}}constructor(V,we){if(this.label=we,typeof V!="string"||typeof we!="string")throw(0,F.$7)("name");this.c=V}get id(){return this.c}};e.$xL=Ne,Ne.Clean=new z("clean","Clean"),Ne.Build=new z("build","Build"),Ne.Rebuild=new z("rebuild","Rebuild"),Ne.Test=new z("test","Test"),e.$xL=Ne=z=Qe([T],Ne);function Ce(G){let V="";for(let we=0;we<G.length;we++)V+=G[we].replace(/,/g,",,")+",";return V}let oe=class{constructor(V,we,Me){if(typeof V!="string")throw(0,F.$7)("process");this.e=[],this.c=V,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Me):this.f=we)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,F.$7)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const we of this.e)V.push(we);return Ce(V)}};e.$yL=oe,e.$yL=oe=Qe([T],oe);let Te=class{constructor(V,we,Me){if(this.f=[],Array.isArray(we)){if(!V)throw(0,F.$7)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,F.$7)("command");this.e=V,this.f=we,this.g=Me}else{if(typeof V!="string")throw(0,F.$7)("commandLine");this.c=V,this.g=we}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,F.$7)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,F.$7)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)V.push(typeof we=="string"?we:we.value);return Ce(V)}};e.$zL=Te,e.$zL=Te=Qe([T],Te);var Ve;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Ve||(e.ShellQuoting=Ve={}));var _e;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(_e||(e.TaskScope=_e={}));class Je{constructor(V){this.c=V}computeId(){return"customExecution"+(0,L.$mg)()}set callback(V){this.c=V}get callback(){return this.c}}e.$AL=Je;let st=O=class{constructor(V,we,Me,xe,rt,ht){this.k=!1,this.l=this.definition=V;let mt;typeof we=="string"?(this.n=this.name=we,this.u=this.source=Me,this.execution=xe,mt=rt,this.k=!0):we===_e.Global||we===_e.Workspace?(this.target=we,this.n=this.name=Me,this.u=this.source=xe,this.execution=rt,mt=ht):(this.target=we,this.n=this.name=Me,this.u=this.source=xe,this.execution=rt,mt=ht),typeof mt=="string"?(this.q=[mt],this.r=!0):Array.isArray(mt)?(this.q=mt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(V){this.j=V}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof oe?this.l={type:O.e,id:this.o.computeId()}:this.o instanceof Te?this.l={type:O.f,id:this.o.computeId()}:this.o instanceof Je?this.l={type:O.c,id:this.o.computeId()}:this.l={type:O.g,id:(0,L.$mg)()}}get definition(){return this.l}set definition(V){if(V==null)throw(0,F.$7)("Kind can't be undefined or null");this.A(),this.l=V}get scope(){return this.m}set target(V){this.A(),this.m=V}get name(){return this.n}set name(V){if(typeof V!="string")throw(0,F.$7)("name");this.A(),this.n=V}get execution(){return this.o}set execution(V){V===null&&(V=void 0),this.A(),this.o=V;const we=this.l.type;(O.g===we||O.e===we||O.f===we||O.c===we)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(V){if(Array.isArray(V))this.A(),this.q=V,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.A(),this.t=V}get source(){return this.u}set source(V){if(typeof V!="string"||V.length===0)throw(0,F.$7)("source must be a string of length > 0");this.A(),this.u=V}get group(){return this.w}set group(V){V===null&&(V=void 0),this.A(),this.w=V}get detail(){return this.z}set detail(V){V===null&&(V=void 0),this.z=V}get presentationOptions(){return this.x}set presentationOptions(V){V==null&&(V=Object.create(null)),this.A(),this.x=V}get runOptions(){return this.y}set runOptions(V){V==null&&(V=Object.create(null)),this.A(),this.y=V}};e.$BL=st,st.c="customExecution",st.e="process",st.f="shell",st.g="$empty",e.$BL=st=O=Qe([T],st);var bt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(bt||(e.ProgressLocation=bt={}));var qt;(function(G){function V(we){const Me=we;return(0,m.$If)(Me.value)?Me.tooltip&&!(0,m.$Ef)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}G.isViewBadge=V})(qt||(e.ViewBadge=qt={}));let kt=U=class{static isTreeItem(V,we){const Me=V;if(Me.checkboxState!==void 0){const xe=(0,m.$If)(Me.checkboxState)?Me.checkboxState:(0,m.$Gf)(Me.checkboxState)&&(0,m.$If)(Me.checkboxState.state)?Me.checkboxState.state:void 0,rt=!(0,m.$If)(Me.checkboxState)&&(0,m.$Gf)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(xe===void 0||xe!==At.Checked&&xe!==At.Unchecked||rt!==void 0&&!(0,m.$Ef)(rt))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(V instanceof U)return!0;if(Me.label!==void 0&&!(0,m.$Ef)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,m.$Ef)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,m.$Ef)(Me.iconPath)&&!w.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,m.$Ef)(Me.iconPath.id))){const xe=Me.iconPath;if(!xe||!(0,m.$Ef)(xe.light)&&!w.URI.isUri(xe.light)&&!(0,m.$Ef)(xe.dark)&&!w.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,m.$Ef)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!w.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,m.$Ef)(Me.tooltip)&&!(Me.tooltip instanceof Ae)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<Dt.None&&Me.collapsibleState>Dt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,m.$Ef)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(V,we=Dt.None){this.collapsibleState=we,w.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$CL=kt,e.$CL=kt=U=Qe([T],kt);var Dt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Dt||(e.TreeItemCollapsibleState=Dt={}));var At;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(At||(e.TreeItemCheckboxState=At={}));let hi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$DL=hi,e.$DL=hi=Qe([T],hi);class Rt extends hi{}e.$EL=Rt;class an extends Rt{constructor(V){super(""),o.set(this,void 0),nt(this,o,V,"f")}asFile(){return We(this,o,"f")}}e.$FL=an,o=new WeakMap;class cn{constructor(V,we,Me,xe){this.name=V,this.uri=we,this._itemId=Me,this.c=xe}data(){return this.c()}}e.$GL=cn;let Ct=class{constructor(V){n.add(this),i.set(this,new Map);for(const[we,Me]of V??[]){const xe=We(this,i,"f").get(We(this,n,"m",s).call(this,we));xe?xe.push(Me):We(this,i,"f").set(We(this,n,"m",s).call(this,we),[Me])}}get(V){return We(this,i,"f").get(We(this,n,"m",s).call(this,V))?.[0]}set(V,we){We(this,i,"f").set(We(this,n,"m",s).call(this,V),[we])}forEach(V,we){for(const[Me,xe]of We(this,i,"f"))for(const rt of xe)V.call(we,rt,Me,this)}*[(i=new WeakMap,n=new WeakSet,Symbol.iterator)](){for(const[V,we]of We(this,i,"f"))for(const Me of we)yield[V,Me]}};e.$HL=Ct,s=function(V){return V.toLowerCase()},e.$HL=Ct=Qe([T],Ct);let $i=class{constructor(V){this.insertText=V}};e.$IL=$i,e.$IL=$i=Qe([T],$i);let bi=class{constructor(V,we){this.label=we,this.insertText=V}};e.$JL=bi,e.$JL=bi=Qe([T],bi);let Qt=class{constructor(V,we){this.id=V,this.color=we}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$KL=Qt,e.$KL=Qt=Qe([T],Qt),Qt.File=new Qt("file"),Qt.Folder=new Qt("folder");let Ci=class{constructor(V){this.id=V}};e.$LL=Ci,e.$LL=Ci=Qe([T],Ci);var qi;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(qi||(e.ConfigurationTarget=qi={}));let jt=class{get base(){return this.c}set base(V){this.c=V,this.e=w.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,we){if(typeof V!="string"&&(!V||!w.URI.isUri(V)&&!w.URI.isUri(V.uri)))throw(0,F.$7)("base");if(typeof we!="string")throw(0,F.$7)("pattern");typeof V=="string"?this.baseUri=w.URI.file(V):w.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$ML=jt,e.$ML=jt=Qe([T],jt);const Ii=new WeakMap;function ln(G,V){Ii.set(G,V)}e.$NL=ln;let ei=class{constructor(V,we,Me,xe){this.enabled=typeof V=="boolean"?V:!0,typeof we=="string"&&(this.condition=we),typeof Me=="string"&&(this.hitCondition=Me),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=Ii.get(this)??(0,L.$mg)()),this.c}};e.$OL=ei,e.$OL=ei=Qe([T],ei);let ci=class extends ei{constructor(V,we,Me,xe,rt){if(super(we,Me,xe,rt),V===null)throw(0,F.$7)("location");this.location=V}};e.$PL=ci,e.$PL=ci=Qe([T],ci);let gt=class extends ei{constructor(V,we,Me,xe,rt){super(we,Me,xe,rt),this.functionName=V}};e.$QL=gt,e.$QL=gt=Qe([T],gt);let Pi=class extends ei{constructor(V,we,Me,xe,rt,ht,mt){if(super(xe,rt,ht,mt),!we)throw(0,F.$7)("dataId");this.label=V,this.dataId=we,this.canPersist=Me}};e.$RL=Pi,e.$RL=Pi=Qe([T],Pi);let ti=class{constructor(V,we,Me){this.command=V,this.args=we||[],this.options=Me}};e.$SL=ti,e.$SL=ti=Qe([T],ti);let si=class{constructor(V,we){this.port=V,this.host=we}};e.$TL=si,e.$TL=si=Qe([T],si);let di=class{constructor(V){this.path=V}};e.$UL=di,e.$UL=di=Qe([T],di);let Ai=class{constructor(V){this.implementation=V}};e.$VL=Ai,e.$VL=Ai=Qe([T],Ai);let Li=class{constructor(V,we,Me){this.session=V,this.threadId=we,this.frameId=Me}};e.$WL=Li,e.$WL=Li=Qe([T],Li);let Ri=class{constructor(V,we){this.session=V,this.threadId=we}};e.$XL=Ri,e.$XL=Ri=Qe([T],Ri);let pi=class{constructor(V,we){this.range=V,this.expression=we}};e.$YL=pi,e.$YL=pi=Qe([T],pi);var Vi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let wi=class{constructor(V,we){this.range=V,this.text=we}};e.$ZL=wi,e.$ZL=wi=Qe([T],wi);let oi=class{constructor(V,we,Me=!0){this.range=V,this.variableName=we,this.caseSensitiveLookup=Me}};e.$1L=oi,e.$1L=oi=Qe([T],oi);let Mi=class{constructor(V,we){this.range=V,this.expression=we}};e.$2L=Mi,e.$2L=Mi=Qe([T],Mi);let fi=class{constructor(V,we){this.frameId=V,this.stoppedLocation=we}};e.$3L=fi,e.$3L=fi=Qe([T],fi);var vi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(vi||(e.FileChangeType=vi={}));let Fi=N=class extends Error{static FileExists(V){return new N(V,$.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(V){return new N(V,$.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(V){return new N(V,$.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(V){return new N(V,$.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(V){return new N(V,$.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(V){return new N(V,$.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(V,we=$.FileSystemProviderErrorCode.Unknown,Me){super(w.URI.isUri(V)?V.toString(!0):V),this.code=Me?.name??"Unknown",(0,$.$Ak)(this,we),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$4L=Fi,e.$4L=Fi=N=Qe([T],Fi);let Ni=class{constructor(V,we,Me){this.start=V,this.end=we,this.kind=Me}};e.$5L=Ni,e.$5L=Ni=Qe([T],Ni);var li;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(li||(e.FoldingRangeKind=li={}));var Hi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Hi||(e.CommentThreadCollapsibleState=Hi={}));var Ki;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var Gi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var yi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(yi||(e.CommentThreadState=yi={}));class un{constructor(V,we=[]){this.tokenTypes=V,this.tokenModifiers=we}}e.$6L=un;function hn(G){return typeof G>"u"||(0,m.$Ff)(G)}class ui{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,V){this.m=!0;for(let we=0,Me=V.tokenTypes.length;we<Me;we++)this.k.set(V.tokenTypes[we],we);for(let we=0,Me=V.tokenModifiers.length;we<Me;we++)this.l.set(V.tokenModifiers[we],we)}}push(V,we,Me,xe,rt){if(typeof V=="number"&&typeof we=="number"&&typeof Me=="number"&&typeof xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.o(V,we,Me,xe,rt);if(Z.isRange(V)&&typeof we=="string"&&hn(Me))return this.n(V,we,Me);throw(0,F.$7)()}n(V,we,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(we))throw new Error("`tokenType` is not in the provided legend");const xe=V.start.line,rt=V.start.character,ht=V.end.character-V.start.character,mt=this.k.get(we);let Vt=0;if(Me)for(const xt of Me){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(xt);Vt|=1<<ii>>>0}this.o(xe,rt,ht,mt,Vt)}o(V,we,Me,xe,rt){if(this.f&&(V<this.c||V===this.c&&we<this.e)){this.f=!1;const Vt=this.g.length/5|0;let xt=0,ii=0;for(let ri=0;ri<Vt;ri++){let ai=this.g[5*ri],Bi=this.g[5*ri+1];ai===0?(ai=xt,Bi+=ii):ai+=xt,this.g[5*ri]=ai,this.g[5*ri+1]=Bi,xt=ai,ii=Bi}}let ht=V,mt=we;this.f&&this.j>0&&(ht-=this.c,ht===0&&(mt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=mt,this.g[this.j++]=Me,this.g[this.j++]=xe,this.g[this.j++]=rt,this.c=V,this.e=we}static q(V){const we=[],Me=V.length/5|0;for(let mt=0;mt<Me;mt++)we[mt]=mt;we.sort((mt,Vt)=>{const xt=V[5*mt],ii=V[5*Vt];if(xt===ii){const ri=V[5*mt+1],ai=V[5*Vt+1];return ri-ai}return xt-ii});const xe=new Uint32Array(V.length);let rt=0,ht=0;for(let mt=0;mt<Me;mt++){const Vt=5*we[mt],xt=V[Vt+0],ii=V[Vt+1],ri=V[Vt+2],ai=V[Vt+3],Bi=V[Vt+4],An=xt-rt,Gn=An===0?ii-ht:ii,Wi=5*mt;xe[Wi+0]=An,xe[Wi+1]=Gn,xe[Wi+2]=ri,xe[Wi+3]=ai,xe[Wi+4]=Bi,rt=xt,ht=ii}return xe}build(V){return this.f?new Ei(new Uint32Array(this.g),V):new Ei(ui.q(this.g),V)}}e.$7L=ui;class Ei{constructor(V,we){this.resultId=we,this.data=V}}e.$8L=Ei;class dn{constructor(V,we,Me){this.start=V,this.deleteCount=we,this.data=Me}}e.$9L=dn;class Ji{constructor(V,we){this.resultId=we,this.edits=V}}e.$0L=Ji;var Ti;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Ti||(e.DebugConsoleMode=Ti={}));let Si=class{constructor(){}};e.$$L=Si,Si.Back={iconPath:new Qt("arrow-left")},e.$$L=Si=Qe([T],Si);var Qi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var Yi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Yi||(e.ExtensionKind=Yi={}));class Oi{static validate(V){if(typeof V.badge=="string"){let we=(0,b.$ff)(V.badge,0);if(we<V.badge.length&&(we+=(0,b.$ff)(V.badge,we)),V.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!Qt.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,we,Me){this.badge=V,this.tooltip=we,this.color=Me}}e.$_L=Oi;let ki=class{constructor(V){this.kind=V}};e.$aM=ki,e.$aM=ki=Qe([T],ki);var Be;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Be||(e.ColorThemeKind=Be={}));class Ut{static isNotebookRange(V){return V instanceof Ut?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,we){if(V<0)throw(0,F.$7)("start must be positive");if(we<0)throw(0,F.$7)("end must be positive");V<=we?(this.c=V,this.e=we):(this.c=we,this.e=V)}with(V){let we=this.c,Me=this.e;return V.start!==void 0&&(we=V.start),V.end!==void 0&&(Me=V.end),we===this.c&&Me===this.e?this:new Ut(we,Me)}}e.$bM=Ut;class gi{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(we=>gi.isNotebookCellData(we))}static isNotebookCellData(V){return!0}constructor(V,we,Me,xe,rt,ht,mt){this.kind=V,this.value=we,this.languageId=Me,this.mime=xe,this.outputs=rt??[],this.metadata=ht,this.executionSummary=mt,gi.validate(this)}}e.$cM=gi;class wt{constructor(V){this.cells=V}}e.$dM=wt;class Xi{static isNotebookCellOutputItem(V){return V instanceof a?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const we={name:V.name,message:V.message,stack:V.stack};return a.json(we,"application/vnd.code.notebook.error")}static stdout(V){return a.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return a.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,we="application/octet-stream"){return new a(V,we)}static text(V,we=M.$4r.text){const Me=We(a,a,"f",t).encode(String(V));return new a(Me,we)}static json(V,we="text/x-json"){const Me=JSON.stringify(V,void 0,"	");return a.text(Me,we)}constructor(V,we){this.data=V,this.mime=we;const Me=(0,M.$8r)(we,!0);if(!Me)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$eM=Xi,a=Xi,t={value:new TextEncoder};class Di{static isNotebookCellOutput(V){return V instanceof Di?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,we=!1){const Me=new Set,xe=new Set;for(let rt=0;rt<V.length;rt++){const ht=V[rt],mt=(0,M.$8r)(ht.mime);if(!Me.has(mt)||(0,D.$RI)(mt)){Me.add(mt);continue}xe.add(rt),we&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return xe.size===0?V:V.filter((rt,ht)=>!xe.has(ht))}constructor(V,we,Me){this.items=Di.ensureUniqueMimeTypes(V,!0),typeof we=="string"?(this.id=we,this.metadata=Me):(this.id=(0,L.$mg)(),this.metadata=we??Me)}}e.$fM=Di;var ji;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(ji||(e.NotebookCellKind=ji={}));var xi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var mi;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(mi||(e.NotebookCellStatusBarAlignment=mi={}));var _i;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(_i||(e.NotebookEditorRevealType=_i={}));class fn{constructor(V,we){this.text=V,this.alignment=we}}e.$gM=fn;var en;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(en||(e.NotebookControllerAffinity=en={}));var Ui;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(Ui||(e.NotebookControllerAffinity2=Ui={}));class gn{constructor(V,we=[]){this.uri=V,this.provides=(0,E.$3b)(we)}}e.$hM=gn;class mn{constructor(V){this.label=V}}e.$iM=mn;var tn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(tn||(e.NotebookVariablesRequestKind=tn={}));let zi=class{constructor(V,we){this.label=V,this.timestamp=we}};e.$jM=zi,e.$jM=zi=Qe([T],zi);var nn;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(nn||(e.ExtensionMode=nn={}));var rn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(rn||(e.ExtensionRuntime=rn={}));var sn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(sn||(e.StandardTokenType=sn={}));class $n{constructor(V,we){this.ranges=V,this.wordPattern=we}}e.$kM=$n;class bn{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$lM=bn;var on;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var be;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(be||(e.TestRunProfileKind=be={}));let Ee=class{constructor(V=void 0,we=void 0,Me=void 0,xe=!1){this.include=V,this.exclude=we,this.profile=Me,this.continuous=xe}};e.$mM=Ee,e.$mM=Ee=Qe([T],Ee);let ze=R=class{static diff(V,we,Me){const xe=new R(V);return xe.expectedOutput=we,xe.actualOutput=Me,xe}constructor(V){this.message=V}};e.$nM=ze,e.$nM=ze=R=Qe([T],ze);let ut=class{constructor(V){this.id=V}};e.$oM=ut,e.$oM=ut=Qe([T],ut);class vt{constructor(V,we){this.covered=V,this.total=we}}e.$pM=vt;class Mt{static fromDetails(V,we){const Me=new vt(0,0),xe=new vt(0,0),rt=new vt(0,0);for(const mt of we)if("branches"in mt){Me.total+=1,Me.covered+=mt.executionCount>0?1:0;for(const Vt of mt.branches)xe.total+=1,xe.covered+=Vt.executionCount>0?1:0}else rt.total+=1,rt.covered+=mt.executionCount>0?1:0;const ht=new Mt(V,Me,xe.total>0?xe:void 0,rt.total>0?rt:void 0);return ht.detailedCoverage=we,ht}constructor(V,we,Me,xe){this.uri=V,this.statementCoverage=we,this.branchCoverage=Me,this.functionCoverage=xe}}e.$qM=Mt;class Ln{constructor(V,we,Me=[]){this.executionCount=V,this.location=we,this.branches=Me}}e.$rM=Ln;class Rn{constructor(V,we){this.executionCount=V,this.location=we}}e.$sM=Rn;class Mn{constructor(V,we,Me){this.name=V,this.executionCount=we,this.location=Me}}e.$tM=Mn;var pn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(pn||(e.ExternalUriOpenerPriority=pn={}));var wn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var vn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class Fn{constructor(V,we,Me,xe,rt,ht){this.kind=V,this.name=we,this.detail=Me,this.uri=xe,this.range=rt,this.selectionRange=ht}}e.$uM=Fn;class Nn{constructor(V){this.uri=V}}e.$vM=Nn;class Tn{constructor(V,we){this.original=V,this.modified=we}}e.$wM=Tn;class On{constructor(V,we,Me,xe){this.base=V,this.input1=we,this.input2=Me,this.result=xe}}e.$xM=On;class jn{constructor(V,we){this.uri=V,this.viewType=we}}e.$yM=jn;class Un{constructor(V){this.viewType=V}}e.$zM=Un;class zn{constructor(V,we){this.uri=V,this.notebookType=we}}e.$AM=zn;class Bn{constructor(V,we,Me){this.original=V,this.modified=we,this.notebookType=Me}}e.$BM=Bn;class Wn{constructor(){}}e.$CM=Wn;class qn{constructor(V,we){this.uri=V,this.inputBoxUri=we}}e.$DM=qn;class Vn{constructor(V){this.providerId=V}}e.$EM=Vn;var yn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var En;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(En||(e.InteractiveSessionCopyKind=En={}));var Sn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Hn{constructor(V,we){this.label=V,this.values=we}}e.$FM=Hn;var kn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(kn||(e.InteractiveEditorResponseFeedbackKind=kn={}));var Dn;(function(G){G[G.System=0]="System",G[G.User=1]="User",G[G.Assistant=2]="Assistant",G[G.Function=3]="Function"})(Dn||(e.ChatMessageRole=Dn={}));class Kn{constructor(V,we){this.role=V,this.content=we}}e.$GM=Kn;var Cn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Cn||(e.ChatAgentResultFeedbackKind=Cn={}));var In;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(In||(e.RelatedInformationType=In={}));var Pn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(Pn||(e.SpeechToTextStatus=Pn={}))}),define(Se[142],ke([1,0,60,17,13,184,130,7,19]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=void 0;const w=new Map;function L(D,u){u?w.set(D,u):w.delete(D)}e.$TM=L;function I(D){return w.get(D)}class $ extends A.$$u{constructor(u,g,o,n,i,s,a,t){super(g,o,n,i),this.c=u,this.m=s,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,m.$ub)(this.f,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.d},get fileName(){return u.d.fsPath},get isUntitled(){return u.d.scheme===F.Schemas.untitled},get languageId(){return u.m},get version(){return u.h},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(g){return g?u.s(g):u.getText()},get eol(){return u.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return u.f.length},lineAt(g){return u.t(g)},offsetAt(g){return u.u(g)},positionAt(g){return u.v(g)},validateRange(g){return u.w(g)},validatePosition(g){return u.x(g)},getWordRangeAtPosition(g,o){return u.y(g,o)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,E.ok)(!this.b),this.m=u}_acceptIsDirty(u){(0,E.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(u){const g=this.w(u);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const o=this.g,n=g.start.line,i=g.end.line,s=[];s.push(this.f[n].substring(g.start.character));for(let a=n+1;a<i;a++)s.push(this.f[a]);return s.push(this.f[i].substring(0,g.end.character)),s.join(o)}t(u){let g;if(u instanceof b.$QK?g=u.line:typeof u=="number"&&(g=u),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new y(g,this.f[g],g===this.f.length-1)}u(u){return u=this.x(u),this.l(),this.j.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.l();const g=this.j.getIndexOf(u),o=this.f[g.index].length;return new b.$QK(g.index,Math.min(g.remainder,o))}w(u){if(!(u instanceof b.$RK))throw new Error("Invalid argument");const g=this.x(u.start),o=this.x(u.end);return g===u.start&&o===u.end?u:new b.$RK(g.line,g.character,o.line,o.character)}x(u){if(!(u instanceof b.$QK))throw new Error("Invalid argument");if(this.f.length===0)return u.with(0,0);let{line:g,character:o}=u,n=!1;if(g<0)g=0,o=0,n=!0;else if(g>=this.f.length)g=this.f.length-1,o=this.f[g].length,n=!0;else{const i=this.f[g].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new b.$QK(g,o):u}y(u,g){const o=this.x(u);if(!g)g=I(this.m);else if((0,f.$Ue)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const n=(0,M.$js)(o.character+1,(0,M.$hs)(g),this.f[o.line],0);if(n)return new b.$RK(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$UM=$;class y{constructor(u,g,o){this.a=u,this.b=g,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$RK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$RK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$VM=y}),define(Se[284],ke([1,0,7,20,4]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;let A=class{constructor(b){this.a=new E.$aM(E.ColorThemeKind.Dark),this.b=new f.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let m;switch(b){case"light":m=E.ColorThemeKind.Light;break;case"hcDark":m=E.ColorThemeKind.HighContrast;break;case"hcLight":m=E.ColorThemeKind.HighContrastLight;break;default:m=E.ColorThemeKind.Dark}this.a=new E.$aM(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$$gc=A,e.$$gc=A=Qe([qe(0,F.$RM)],A)}),define(Se[285],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.CellExecutionUpdateType=void 0;var F;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$VI=(0,E.$2h)("INotebookExecutionService")}),define(Se[286],ke([1,0,3,29,186,104]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQb=void 0;class M extends E.$Sc{constructor(m,w,L){super(),this._source=m,this.b=w,this.c=L,this.a=void 0}f(m){const w=m.getLineCount();return new F.$Hs(1,1,w,this.g(m,w))}g(m,w){if(w<1||w>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const m=new f.$XB;m.acceptChunk(this._source);const w=m.finish(!0),{textBuffer:L,disposable:I}=w.create(1);this.b=L,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const w=new f.$XB;w.acceptChunk(m);const L=w.finish(!0),{textBuffer:I,disposable:$}=L.create(1);return this.B($),I})),this.a}findInInputs(m){const L=new A.$LB(m,!1,!1,null).parseSearchRequest();if(!L)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,L,!0,5e3)}findInOutputs(m){const L=new A.$LB(m,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(I=>{const $=I.findMatchesLineByLine(this.f(I),L,!0,5e3);if($.length!==0)return{textBuffer:I,matches:$}}).filter(I=>!!I):[]}}e.$aQb=M}),define(Se[67],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(A){A.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var F;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class f{static fromExtHostTestItem(M,b,m=M.parent){if(M._isRoot)return new f([b]);const w=[M.id];for(let L=m;L&&L.id!==b;L=L.parent)w.push(L.id);return w.push(b),new f(w.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new f(M.split("\0"))}static join(M,b){return new f([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:f.isChild(M,b)?2:f.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new f(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new f(this.path,M)}compare(M){if(typeof M=="string")return f.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$FJ=f}),define(Se[89],ke([1,0,2,51,29,67]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$MJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$LJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$KJ=e.$JJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$IJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$HJ=e.$GJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var b;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var m;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$GJ=[2,4,8,16,32,64];const w=N=>"runId"in N;e.$HJ=w;var L;(function(N){N.serialize=R=>({range:R.range.toJSON(),uri:R.uri.toJSON()}),N.deserialize=R=>({range:f.$Hs.lift(R.range),uri:E.URI.revive(R.uri)})})(L||(e.IRichLocation=L={}));var I;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(I||(e.TestMessageType=I={}));var $;(function(N){N.serialize=R=>({message:R.message,type:0,expected:R.expected,actual:R.actual,contextValue:R.contextValue,location:R.location&&L.serialize(R.location)}),N.deserialize=R=>({message:R.message,type:0,expected:R.expected,actual:R.actual,contextValue:R.contextValue,location:R.location&&L.deserialize(R.location)})})($||(e.ITestErrorMessage=$={}));const y=(N,R)=>`${R?"s":"e"}${N}`;e.$IJ=y;var D;(function(N){N.serialize=R=>({message:R.message,type:1,offset:R.offset,length:R.length,location:R.location&&L.serialize(R.location)}),N.deserialize=R=>({message:R.message,type:1,offset:R.offset,length:R.length,location:R.location&&L.deserialize(R.location)})})(D||(e.ITestOutputMessage=D={}));var u;(function(N){N.serialize=R=>R.type===0?$.serialize(R):D.serialize(R),N.deserialize=R=>R.type===0?$.deserialize(R):D.deserialize(R)})(u||(e.ITestMessage=u={}));var g;(function(N){N.serializeWithoutMessages=R=>({state:R.state,duration:R.duration,messages:[]}),N.serialize=R=>({state:R.state,duration:R.duration,messages:R.messages.map(u.serialize)}),N.deserialize=R=>({state:R.state,duration:R.duration,messages:R.messages.map(u.deserialize)})})(g||(e.ITestTaskState=g={}));const o="\0",n=(N,R)=>N+o+R;e.$JJ=n;const i=N=>{const R=N.indexOf(o);return{ctrlId:N.slice(0,R),tagId:N.slice(R+1)}};e.$KJ=i;var s;(function(N){N.serialize=R=>({extId:R.extId,label:R.label,tags:R.tags,busy:R.busy,children:void 0,uri:R.uri?.toJSON(),range:R.range?.toJSON()||null,description:R.description,error:R.error,sortText:R.sortText}),N.deserialize=R=>({extId:R.extId,label:R.label,tags:R.tags,busy:R.busy,children:void 0,uri:R.uri?E.URI.revive(R.uri):void 0,range:R.range?f.$Hs.lift(R.range):null,description:R.description,error:R.error,sortText:R.sortText})})(s||(e.ITestItem=s={}));var a;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(N){N.serialize=R=>({expand:R.expand,item:s.serialize(R.item)}),N.deserialize=R=>({controllerId:A.$FJ.root(R.item.extId),expand:R.expand,item:s.deserialize(R.item)})})(t||(e.InternalTestItem=t={}));var r;(function(N){N.serialize=R=>{let T;return R.item&&(T={},R.item.label!==void 0&&(T.label=R.item.label),R.item.tags!==void 0&&(T.tags=R.item.tags),R.item.busy!==void 0&&(T.busy=R.item.busy),R.item.uri!==void 0&&(T.uri=R.item.uri?.toJSON()),R.item.range!==void 0&&(T.range=R.item.range?.toJSON()),R.item.description!==void 0&&(T.description=R.item.description),R.item.error!==void 0&&(T.error=R.item.error),R.item.sortText!==void 0&&(T.sortText=R.item.sortText)),{extId:R.extId,expand:R.expand,item:T}},N.deserialize=R=>{let T;return R.item&&(T={},R.item.label!==void 0&&(T.label=R.item.label),R.item.tags!==void 0&&(T.tags=R.item.tags),R.item.busy!==void 0&&(T.busy=R.item.busy),R.item.range!==void 0&&(T.range=R.item.range?f.$Hs.lift(R.item.range):null),R.item.description!==void 0&&(T.description=R.item.description),R.item.error!==void 0&&(T.error=R.item.error),R.item.sortText!==void 0&&(T.sortText=R.item.sortText)),{extId:R.extId,expand:R.expand,item:T}}})(r||(e.ITestItemUpdate=r={}));const d=(N,R)=>{R.expand!==void 0&&(N.expand=R.expand),R.item!==void 0&&(N.item=N.item?Object.assign(N.item,R.item):R.item)};e.$LJ=d;var l;(function(N){N.serializeWithoutMessages=R=>({...t.serialize(R),ownComputedState:R.ownComputedState,computedState:R.computedState,tasks:R.tasks.map(g.serializeWithoutMessages)}),N.serialize=R=>({...t.serialize(R),ownComputedState:R.ownComputedState,computedState:R.computedState,tasks:R.tasks.map(g.serialize)}),N.deserialize=R=>({...t.deserialize(R),ownComputedState:R.ownComputedState,computedState:R.computedState,tasks:R.tasks.map(g.deserialize),retired:!0})})(l||(e.TestResultItem=l={}));var h;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(R,T)=>{R.covered+=T.covered,R.total+=T.total}})(h||(e.ICoveredCount=h={}));var c;(function(N){N.serialize=R=>({statement:R.statement,branch:R.branch,function:R.function,details:R.details?.map(p.serialize),uri:R.uri.toJSON()}),N.deserialize=R=>({statement:R.statement,branch:R.branch,function:R.function,details:R.details?.map(p.deserialize),uri:E.URI.from(R.uri)})})(c||(e.IFileCoverage=c={}));function v(N){return{...N,location:N.location?.toJSON()}}function P(N){return N.location=N.location?F.$Gs.isIPosition(N.location)?F.$Gs.lift(N.location):f.$Hs.lift(N.location):void 0,N}e.$MJ=3;var S;(function(N){N[N.Function=0]="Function",N[N.Statement=1]="Statement"})(S||(e.DetailType=S={}));var p;(function(N){N.serialize=R=>R.type===0?C.serialize(R):j.serialize(R),N.deserialize=R=>R.type===0?C.deserialize(R):j.deserialize(R)})(p||(e.CoverageDetails=p={}));var k;(function(N){N.serialize=v,N.deserialize=P})(k||(e.IBranchCoverage=k={}));var C;(function(N){N.serialize=v,N.deserialize=P})(C||(e.IFunctionCoverage=C={}));var j;(function(N){N.serialize=R=>({...v(R),branches:R.branches?.map(k.serialize)}),N.deserialize=R=>({...P(R),branches:R.branches?.map(k.deserialize)})})(j||(e.IStatementCoverage=j={}));var z;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var O;(function(N){N.deserialize=R=>R.op===0?{op:R.op,item:t.deserialize(R.item)}:R.op===1?{op:R.op,item:r.deserialize(R.item)}:R.op===2?{op:R.op,uri:E.URI.revive(R.uri),docv:R.docv}:R,N.serialize=R=>R.op===0?{op:R.op,item:t.serialize(R.item)}:R.op===1?{op:R.op,item:r.serialize(R.item)}:R})(O||(e.TestsDiffOp=O={}));class U{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(R){const T=this.o();for(const q of R)switch(q.op){case 0:this.j(t.deserialize(q.item),T);break;case 1:this.k(r.deserialize(q.item),T);break;case 3:this.l(q.itemId,T);break;case 5:this.m(q.itemId);break;case 4:this.updatePendingRoots(q.amount);break;case 6:this.c.set(q.tag.id,q.tag);break;case 7:this.c.delete(q.id);break}T.complete?.()}j(R,T){const q=A.$FJ.parentId(R.item.extId)?.toString();let ee;if(!q)ee=this.p(R),this.f.add(ee),this.d.set(R.item.extId,ee);else if(this.d.has(q)){const J=this.d.get(q);J.children.add(R.item.extId),ee=this.p(R,J),this.d.set(R.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(R)}`);return}return T.add?.(ee),R.expand===2&&this.g++,ee}k(R,T){const q=this.d.get(R.extId);if(q)return R.expand!==void 0&&(q.expand===2&&this.g--,R.expand===2&&this.g++),(0,e.$LJ)(q,R),T.update?.(q),q}l(R,T){const q=this.d.get(R);if(!q)return;const ee=A.$FJ.parentId(q.item.extId)?.toString();ee?this.d.get(ee).children.delete(q.item.extId):this.f.delete(q);const J=[[R]];for(;J.length;)for(const K of J.pop()){const Z=this.d.get(K);Z&&(J.push(Z.children),this.d.delete(K),T.remove?.(Z,Z!==q),Z.expand===2&&this.g--)}}m(R){}updatePendingRoots(R){this.h+=R}o(){return{}}}e.$NJ=U}),define(Se[113],ke([1,0,10,4,3,60,89,67]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const w=(n,i)=>n===i,I=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,i)=>!(n.length!==i.length||n.some(s=>!i.includes(s)))}),$=(n,i)=>{let s;for(const[a,t]of I)t(n[a],i[a])||(s?s[a]=i[a]:s={[a]:i[a]});return s};class y extends f.$Sc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new E.$bh(()=>this.flushDiff(),200)),this.g=this.B(new F.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.I(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const s of this.m)if(s.op===2&&s.uri===i.uri){s.docv=i.docv;return}break}case 1:{const s=this.m[this.m.length-1];if(s){if(s.op===1&&s.item.extId===i.item.extId){(0,M.$LJ)(s.item,i.item);return}if(s.op===0&&s.item.item.extId===i.item.extId){(0,M.$LJ)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const a=this.tree.get(i);if(a){if((a.expandLevels===void 0||s>a.expandLevels)&&(a.expandLevels=s),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,s-1):t.wait().then(()=>this.J(a,s-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,s-1)):this.J(a,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(i,s){switch(s.op){case 3:this.N(b.$FJ.joinToString(i.fullId,s.id));break;case 0:this.y(s.item,i);break;case 5:for(const a of s.ops)this.u(i,a);break;case 1:this.z(s.new,s.old,i.fullId.toString());break;case 2:this.I(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:s.update}});break;case 6:this.w(i.actual.uri);break;default:(0,A.$5c)(s)}}w(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}y(i,s){const a=b.$FJ.fromExtHostTestItem(i,this.root.id,s?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(i.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:0},i.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(i,s),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(i)}}),this.H(i,r,s);return}if(r.actual===i){this.G(i,r,s);return}if(r.actual.uri?.toString()!==i.uri?.toString())return this.N(a.toString()),this.y(i,s);const d=this.s.getChildren(r.actual),l=r.actual,h=$(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,r.actual=i,r.expand=0,h&&(h.hasOwnProperty("tags")&&(this.z(i.tags,l.tags,a.toString()),delete h.tags),this.u(r,{op:4,update:h})),this.H(i,r,s);for(const[c,v]of d)this.s.getChildren(i).get(v.id)||this.N(b.$FJ.joinToString(a,v.id));this.w(r.actual.uri)}z(i,s,a){const t=new Set(s.map(r=>r.id));for(const r of i)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:a,item:{tags:i.map(r=>(0,M.$JJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$JJ)(this.s.controllerId,i.id)}}))}D(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$JJ)(this.s.controllerId,i)}))}F(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}G(i,s,a){this.F(i,a);const t=this.s.getApiFor(i);t.parent=a?.actual,t.listener=r=>this.u(s,r),this.I(s)}H(i,s,a){this.G(i,s,a);for(const[t,r]of this.s.getChildren(i))this.y(r,s)}I(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?3:2:s=i.actual.canResolveChildren?1:0:s=0,s!==i.expand&&(i.expand=s,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:s}}),s===1&&i.expandLevels!==void 0&&this.L(i))}J(i,s){if(s<0)return;const a=[];for(const[t,r]of this.s.getChildren(i.actual)){const d=this.expand(b.$FJ.joinToString(i.fullId,r.id),s);(0,E.$Og)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const r=new E.$1g;return r.open(),r}i.expand=2,this.M(i);const s=i.resolveBarrier=new E.$1g,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(r){a(r)}return(0,E.$Og)(t)?t.catch(a).then(()=>{s.open(),this.I(i)}):(s.open(),this.I(i)),i.resolveBarrier}M(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}N(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const a=[s];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,d]of this.s.getChildren(t.actual))a.push(this.tree.get(b.$FJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$HM=y;class D extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$IM=D;class u extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$JM=u;class g extends Error{constructor(i,s,a){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${a}".`)}}e.$KM=g;const o=(n,i,s)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const d of a.values())t.call(r,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,d=new Set(a.keys()),l={op:5,ops:[]};for(const h of t){if(!(h instanceof s))throw new u(h.id);const c=i(h).controllerId;if(c!==n.controllerId)throw new g(h.id,c,n.controllerId);if(r.has(h.id))throw new D(h.id);r.set(h.id,h),d.delete(h.id),l.ops.push({op:0,item:h})}for(const h of d.keys())l.ops.push({op:3,id:h});n.listener?.(l),a=r},add(t){if(!(t instanceof s))throw new u(t.id);a.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){a.delete(t)&&n.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$LM=o}),define(Se[143],ke([1,0,113]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0;const F=new WeakMap,f=(M,b)=>{const m={controllerId:b};return F.set(M,m),m};e.$MM=f;const A=M=>{const b=F.get(M);if(!b)throw new E.$JM(M?.id||"<unknown>");return b};e.$NM=A}),define(Se[114],ke([1,0,17,2]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pvb=e.$ovb=e.$nvb=e.$mvb=e.$lvb=void 0,e.$lvb="vscode-cdn.net",e.$mvb=`vscode-resource.${e.$lvb}`,e.$nvb=`'self' https://*.${e.$lvb}`;function f(b,m){return b.scheme===E.Schemas.http||b.scheme===E.Schemas.https?b:(m&&m.authority&&m.isRemote&&b.scheme===E.Schemas.file&&(b=F.URI.from({scheme:E.Schemas.vscodeRemote,authority:m.authority,path:b.path})),F.URI.from({scheme:E.Schemas.https,authority:`${b.scheme}+${A(b.authority)}.${e.$mvb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$ovb=f;function A(b){return b.replace(/./g,m=>{const w=m.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?m:"-"+w.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,(m,w)=>String.fromCharCode(parseInt(w,16)))}e.$pvb=M}),define(Se[287],ke([1,0,4,3,114]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class A{constructor(b,m,w){this.d=b,this.e=m,this.f=w,this.a=0,this.b=new F.$Rc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const L=m.getVisibleTextEditors();for(const I of this.c.values())L.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,m,w,L,I){let $;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){$=i;break}if(!$)throw new Error("not a visible editor");const y=this,D=this.a++,u=new E.$Sd,g=new E.$Sd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,f.$ovb)(i,y.f)}get cspSource(){return f.$nvb}set options(i){this.b=i,y.d.$setOptions(D,i)}get options(){return this.b}set html(i){this.a=i,y.d.$setHtml(D,i)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(i){return y.d.$postMessage(D,i)}},n=new class{constructor(){this.editor=b,this.line=m,this.height=w,this.webview=o,this.onDidDispose=g.event}dispose(){y.c.has(D)&&(y.c.delete(D),y.d.$disposeEditorInset(D),g.fire(),g.dispose(),u.dispose())}};return this.d.$createEditorInset(D,$.id,$.value.document.uri,m+1,w,L||{},I.identifier,I.extensionLocation),this.c.set(D,{editor:b,inset:n,onDidReceiveMessage:u}),n}$onDidDispose(b){const m=this.c.get(b);m&&m.inset.dispose()}$onDidReceiveMessage(b,m){this.c.get(b)?.onDidReceiveMessage.fire(m)}}e.$ufc=A}),define(Se[288],ke([1,0,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.VariableKind=e.$DN=void 0,e.$DN=(0,E.$2h)("configurationResolverService");var F;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class f extends Error{constructor(M,b){super(b),this.variable=M}}e.$EN=f}),define(Se[289],ke([1,0,16,49,18,24,9,101,232,288,13]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=void 0;class I{constructor(y,D,u,g){this.h=new Map,this.a=y,this.b=D,this.g=u,g&&(this.c=g.then(o=>this.i(o)))}i(y){if(M.$c){const D=Object.create(null);return Object.keys(y).forEach(u=>{D[u.toLowerCase()]=y[u]}),D}return y}resolveWithEnvironment(y,D,u){return this.l({env:this.i(y),userHome:void 0},D?D.uri:void 0,u)}async resolveAsync(y,D){const u={env:await this.c,userHome:await this.g};return this.l(u,y?y.uri:void 0,D)}async j(y,D,u,g){const o=A.$in(D);M.$c&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):M.$d&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):M.$e&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,y?y.uri:void 0,o,u,g)}async resolveAnyAsync(y,D,u){return this.j(y,D,u)}async resolveAnyMap(y,D,u){const g=new Map;return{newConfig:await this.j(y,D,u,g),resolvedVariables:g}}resolveWithInteractionReplace(y,D,u,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,D,u,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,D){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,D)}async l(y,D,u,g,o){if(f.$Ef(u))return this.m(y,D,u,g,o);if(Array.isArray(u))return Promise.all(u.map(n=>this.l(y,D,n,g,o)));if(f.$Gf(u)){const n=Object.create(null),i=await Promise.all(Object.keys(u).map(async s=>[await this.m(y,D,s,g,o),await this.l(y,D,u[s],g,o)]));for(const[s,a]of i)n[s]=a;return n}return u}m(y,D,u,g,o){return(0,L.$Ze)(u,I.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(I.VARIABLE_LHS))return n;let s=await this.o(y,n,i,D,g);return o?.set(i,s),s!==n&&f.$Ef(s)&&s.match(I.VARIABLE_REGEXP)&&(s=await this.m(y,D,s,g,o)),s})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,D,u,g,o){let n;const i=u.split(":");i.length>1&&(u=i[0],n=i[1]);const s=r=>{const d=this.a.getFilePath();if(d)return(0,b.$Iv)(d);throw new w.$EN(r,(0,m.localize)(0,null,D))},a=r=>{const d=s(r);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$Iv)(l)}throw new w.$EN(r,(0,m.localize)(1,null,D,E.$nc(d)))},t=r=>{if(n){const d=this.a.getFolderUri(n);if(d)return d;throw new w.$EN(r,(0,m.localize)(2,null,D,n))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new w.$EN(r,(0,m.localize)(3,null,D)):new w.$EN(r,(0,m.localize)(4,null,D))};switch(u){case"env":if(n){if(y.env){const r=y.env[M.$c?n.toLowerCase():n];if(f.$Ef(r))return r}return""}throw new w.$EN(w.VariableKind.Env,(0,m.localize)(5,null,D));case"config":if(n){const r=this.a.getConfigurationValue(g,n);if(f.$Nf(r))throw new w.$EN(w.VariableKind.Config,(0,m.localize)(6,null,D,n));if(f.$Gf(r))throw new w.$EN(w.VariableKind.Config,(0,m.localize)(7,null,D,n));return r}throw new w.$EN(w.VariableKind.Config,(0,m.localize)(8,null,D));case"command":return this.p(w.VariableKind.Command,D,n,o,"command");case"input":return this.p(w.VariableKind.Input,D,n,o,"input");case"extensionInstallFolder":if(n){const r=await this.a.getExtension(n);if(!r)throw new w.$EN(w.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,D,n));return this.n(r.extensionLocation)}throw new w.$EN(w.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,D));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,b.$Iv)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return g||n?(0,b.$Iv)(this.n(t(w.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Iv)(E.$nc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new w.$EN(w.VariableKind.UserHome,(0,m.localize)(11,null,D))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new w.$EN(w.VariableKind.LineNumber,(0,m.localize)(12,null,D))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new w.$EN(w.VariableKind.SelectedText,(0,m.localize)(13,null,D))}case"file":return s(w.VariableKind.File);case"fileWorkspaceFolder":return a(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(a(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||n?E.$lc(this.n(t(w.VariableKind.RelativeFile)),s(w.VariableKind.RelativeFile)):s(w.VariableKind.RelativeFile);case"relativeFileDirname":{const r=E.$mc(s(w.VariableKind.RelativeFileDirname));if(g||n){const d=E.$lc(this.n(t(w.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return E.$mc(s(w.VariableKind.FileDirname));case"fileExtname":return E.$oc(s(w.VariableKind.FileExtname));case"fileBasename":return E.$nc(s(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=E.$nc(s(w.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-E.$oc(r).length)}case"fileDirnameBasename":return E.$nc(E.$mc(s(w.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||D}case"execInstallFolder":{const r=this.a.getAppRoot();return r||D}case"pathSeparator":return E.sep;default:try{const r=n?`${u}:${n}`:u;return this.p(w.VariableKind.Unknown,D,r,o,void 0)}catch{return D}}}}p(y,D,u,g,o){if(u&&g){const n=o===void 0?g[u]:g[o+":"+u];if(typeof n=="string")return n;throw new w.$EN(y,(0,m.localize)(14,null,D))}return D}}e.$SN=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[144],ke([1,0,5,140]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$TC=e.OpenEditorContext=e.GroupsOrder=e.$SC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$RC=void 0,e.$RC=(0,E.$2h)("editorGroupsService");var f;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var A;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var M;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EXPAND=1]="EXPAND",D[D.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var m;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function w(D){const u=D;return(0,F.$AE)(u?.editor)&&(0,F.$AE)(u?.replacement)}e.$SC=w;var L;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var I;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function $(D){const u=D;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.$TC=$;function y(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$UC=y}),define(Se[290],ke([1,0,5,144]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=e.$XC=e.$WC=e.$VC=void 0,e.$VC=(0,E.$2h)("editorService"),e.$WC=-1,e.$XC=-2;function f(A){const M=A;return typeof A=="number"||(0,F.$TC)(M)}e.$YC=f}),define(Se[145],ke([1,0,5,134]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=void 0,e.$$J=(0,E.$3h)(F.$9h)}),define(Se[146],ke([1,0,26,4,16,3]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=e.$q7b=e.$p7b=e.$o7b=e.$n7b=void 0;class M{constructor(o,n){this.versionId=o,this.removedDueToLooping=n}}e.$n7b=M;class b{static isHostExtension(o,n,i){if(n.getExtensionDescription(o))return!1;const s=i.getExtensionDescription(o);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(o,n){this.j=o,this.c=new F.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(D),this.f=new E.$jm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const n=this.j.readActivationEvents(o);for(const i of n)this.h.has(i)||this.h.set(i,[]),this.h.get(i).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,n){this.e=u(this.e,n),this.e=this.e.concat(o);const i=b.l(this.e);return this.e=u(this.e,i.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new M(this.d,i)}static l(o){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,d){this.addNode(r),this.addNode(d),this.c.has(r)?this.c.get(r).push(d):this.c.set(r,[d])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,d){const l=n.getArcs(r);for(let h=0;h<l.length;h++)if(!d.has(l[h]))return!1;return!0}getNodes(){return this.e}},i=new E.$jm;for(const r of o)if(i.set(r.identifier,r),r.extensionDependencies)for(const d of r.extensionDependencies)n.addArc(E.$hm.toKey(r.identifier),E.$hm.toKey(d));const s=new Set;n.getNodes().filter(r=>n.getArcs(r).length===0).forEach(r=>s.add(r));const a=n.getNodes().filter(r=>!s.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const d=a[r];n.hasOnlyGoodArcs(d,s)&&(a.splice(r,1),r--,s.add(d),t=!0)}}while(t);return a.map(r=>i.get(r))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const n=this.h.get(o);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new m(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const n=this.f.get(o);return n||void 0}getExtensionDescriptionByUUID(o){for(const n of this.g)if(n.uuid===o)return n}getExtensionDescriptionByIdOrUUID(o,n){return this.getExtensionDescription(o)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$o7b=b;class m{constructor(o,n){this.versionId=o,this.extensions=n}}e.$p7b=m;class w{constructor(o){this.d=new $,this.c=new b(o,[])}async acquireLock(o){const n=await this.d.acquire(o);return new L(this,n)}deltaExtensions(o,n,i){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,i)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,n){return this.c.getExtensionDescriptionByIdOrUUID(o,n)}}e.$q7b=w;class L extends A.$Sc{constructor(o,n){super(),this.f=o,this.c=!1,this.B(n)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$r7b=L;class I{constructor(o){this.name=o,this.promise=new Promise((n,i)=>{this.c=n})}resolve(o){this.c(o)}}class ${constructor(){this.c=[],this.d=!1}async acquire(o){const n=new I(o);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let n=!0;const i=setTimeout(()=>{n&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{n&&(clearTimeout(i),n=!1,this.d=!1,this.e())};o.resolve((0,A.$Qc)(s))}}var y;(function(g){g[g.Builtin=0]="Builtin",g[g.User=1]="User",g[g.Dev=2]="Dev"})(y||(y={}));function D(g,o){const n=g.isBuiltin?0:g.isUnderDevelopment?2:1,i=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(n!==i)return n-i;const s=f.$gc.basename(g.extensionLocation.path),a=f.$gc.basename(o.extensionLocation.path);return s<a?-1:s>a?1:0}function u(g,o){const n=new E.$im(o);return g.filter(i=>!n.has(i.identifier))}}),define(Se[291],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ExtHostConnectionType=void 0;var E;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(E||(e.ExtHostConnectionType=E={}));class F{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.$Lm=F,F.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class f{constructor(){this.type=2}serialize(I){I[f.ENV_KEY]="1"}}e.$Mm=f,f.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(I){I[A.ENV_KEY]="1"}}e.$Nm=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function M(L){delete L[F.ENV_KEY],delete L[f.ENV_KEY],delete L[A.ENV_KEY]}function b(L,I){M(I),L.serialize(I)}e.$Om=b;function m(L){if(L[F.ENV_KEY])return w(L,new F(L[F.ENV_KEY]));if(L[f.ENV_KEY])return w(L,new f);if(L[A.ENV_KEY])return w(L,new A);throw new Error("No connection information defined in environment!")}e.$Pm=m;function w(L,I){return M(L),I}}),define(Se[115],ke([1,0,22]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$qm=e.$pm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(F||(e.UIKind=F={}));var f;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var A;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function M(w){const L=E.$ge.alloc(1);switch(w){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$pm=M;function b(w,L){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$qm=b;var m;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Se[90],ke([1,0,5,4,14,27,115,65,87,24,2,3,218]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.$0M=e.$9M=void 0;let y=class extends I.$Sc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new F.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$Co,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(i=>{(0,f.$lj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const s=this.getTelemetryDetails(),a=new D(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=u(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$9k)((0,m.$Jo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,s)=>{const a=i.filter(t=>!t.isDisposed);a.length===0?this.r.delete(s):this.r.set(s,a)}),this.r.forEach(i=>{for(const s of i)s.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const s=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!s)return this.r.delete(o.value),!1;let a=!1;for(const t of s)t.ignoreUnhandledExtHostErrors||(t.logError(n),a=!0);return a}};e.$9M=y,e.$9M=y=Qe([qe(0,A.$8M),qe(1,f.$kj)],y);class D{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,s,a,t,r){this.g=i,this.h=s,this.i=a,this.j=t,this.a=new F.$Sd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,m.$Mo)(n,[]),this.c&&(n=(0,w.$ln)(n,this.c)),this.b||(n=(0,w.$ln)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},s=(0,m.$Mo)(i,[]),a=new Error(s.message,{cause:s.cause});a.stack=s.stack,a.name=s.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(a,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$0M=D;function u(g){const o=Date.now()-new Date(g).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$$M=u,e.$_M=(0,E.$2h)("IExtHostTelemetry")}),define(Se[25],ke([1,0,4,2,262,138,26,5]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.ActivationKind=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.ExtensionHostStartup=e.$iF=e.$hF=e.$gF=e.$fF=void 0,e.$fF=Object.freeze({identifier:new M.$hm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$gF="extensions.webWorker",e.$hF=(0,b.$2h)("extensionService");class m{constructor(a){this.dependency=a}}e.$iF=m;var w;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,r){this.c=a,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$3E.createActivationEventsMap(this.d)}}set(a,t,r){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],l=[],h=[],c=[],v=I(this.d),P=I(t),S=(z,O)=>z.extensionLocation.toString()===O.extensionLocation.toString()||z.isBuiltin===O.isBuiltin||z.isUserBuiltin===O.isUserBuiltin||z.isUnderDevelopment===O.isUnderDevelopment;for(const z of this.d){const O=P.get(z.identifier);if(!O){d.push(z.identifier),v.delete(z.identifier);continue}if(!S(z,O)){d.push(z.identifier),v.delete(z.identifier);continue}}for(const z of t){const O=v.get(z.identifier);if(!O){l.push(z);continue}if(!S(O,z)){d.push(O.identifier),v.delete(O.identifier);continue}}const p=new M.$im(this.e),k=new M.$im(r);for(const z of this.e)k.has(z)||h.push(z);for(const z of r)p.has(z)||c.push(z);const C=A.$3E.createActivationEventsMap(l),j={versionId:a,toRemove:d,toAdd:l,addActivationEvents:C,myToRemove:h,myToAdd:c};return this.delta(j),j}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:d,myToAdd:l}=a,h=new M.$im(t),c=new M.$im(d);for(let v=0;v<this.d.length;v++)h.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)c.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of r)this.d.push(v);for(const v of l)this.e.push(v);return this.f=null,a}containsExtension(a){for(const t of this.e)if(M.$hm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=A.$3E.readActivationEvents(t);for(const d of r)a.add(d)}return a}}e.$jF=L;function I(s){const a=new M.$jm;for(const t of s)a.set(t.identifier,t);return a}function $(s,a){return!0}e.$kF=$;function y(s,a){if(!$(s,a))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.$lF=y;class D{constructor(a,t,r,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=d}}e.$mF=D;class u{constructor(a,t){this.description=a,this.value=t}}e.$nF=u;var g;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function o(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,f.$So)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.$oF=o;function n(s,a){return{identifier:new M.$hm((0,f.$Qo)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform}}e.$pF=n;class i{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$qF=i}),define(Se[292],ke([1,0,8,146,26,25,14,10]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=e.$Ufc=e.$Tfc=e.$Sfc=e.$Rfc=e.$Qfc=void 0;class m{constructor(o,n,i,s){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=s}}e.$Qfc=m,m.NONE=new m(!1,-1,-1,-1);class w{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Rfc=w;class L{constructor(o,n,i,s,a,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=s,this.exports=a,this.subscriptions=t}}e.$Sfc=L;class I extends L{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Tfc=I;class $ extends L{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ufc=$;class y extends L{constructor(o){super(!0,o,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(o,n,i,s){this.g=s,this.a=o,this.b=n,this.c=i,this.d=new f.$jm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(s=>({id:s.identifier,reason:{startup:n,extensionId:s.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new y(a));return this.c.onExtensionActivationError(o.id,a,new A.$iF(o.id.value)),t}const i=[],s=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const a of s){if(this.m(a))continue;const t=this.d.get(a);if(t){i.push(t);continue}if(this.l(a)){i.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const r=this.a.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;i.push(this.j({id:r.identifier,reason:o.reason}));continue}const d=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),h=this.k(o,n.displayName,[],new y(l));return this.c.onExtensionActivationError(n.identifier,l,new A.$iF(a)),h}return this.k(o,n.displayName,i,null)}k(o,n,i,s){const a=new u(o.id,n,o.reason,i,s,this.c,this.g);return this.d.set(o.id,a),a}l(o){return F.$o7b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$Vfc=D,e.$Vfc=D=Qe([qe(3,M.$jj)],D);let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,s,a,t,r){this.c=o,this.d=n,this.f=i,this.g=s,this.h=a,this.j=t,this.k=r,this.a=new b.$1g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new y(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new y(n),this.b&&E.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};u=Qe([qe(6,M.$jj)],u)}),define(Se[15],ke([1,0,19,22,168,74,79,28,161,54,98,24,18,2,29,83,136,143,140,112,67,89,290,7,25]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$QM=e.$PM=e.MarkdownString=e.$OM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Fe){function Ne(oe){const{selectionStartLineNumber:Te,selectionStartColumn:Ve,positionLineNumber:_e,positionColumn:Je}=oe,st=new r.$QK(Te-1,Ve-1),bt=new r.$QK(_e-1,Je-1);return new r.$SK(st,bt)}Fe.to=Ne;function Ce(oe){const{anchor:Te,active:Ve}=oe;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Fe.from=Ce})(l||(e.Selection=l={}));var h;(function(Fe){function Ne(oe){if(!oe)return;const{start:Te,end:Ve}=oe;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Fe.from=Ne;function Ce(oe){if(!oe)return;const{startLineNumber:Te,startColumn:Ve,endLineNumber:_e,endColumn:Je}=oe;return new r.$RK(Te-1,Ve-1,_e-1,Je-1)}Fe.to=Ce})(h||(e.Range=h={}));var c;(function(Fe){function Ne(Ce){switch(Ce){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Fe.to=Ne})(c||(e.TokenType=c={}));var v;(function(Fe){function Ne(oe){return new r.$QK(oe.lineNumber-1,oe.column-1)}Fe.to=Ne;function Ce(oe){return{lineNumber:oe.line+1,column:oe.character+1}}Fe.from=Ce})(v||(e.Position=v={}));var P;(function(Fe){function Ne(Te,Ve,_e){return(0,E.$Hb)((0,E.$3b)(Te).map(Je=>Ce(Je,Ve,_e)))}Fe.from=Ne;function Ce(Te,Ve,_e){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:_e?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:oe(Te.scheme,Ve),pattern:ne.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:_e?.isBuiltin}}function oe(Te,Ve){return Ve&&typeof Te=="string"?Ve.transformOutgoingScheme(Te):Te}})(P||(e.DocumentSelector=P={}));var S;(function(Fe){function Ne(oe){switch(oe){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Fe.from=Ne;function Ce(oe){switch(oe){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Fe.to=Ce})(S||(e.DiagnosticTag=S={}));var p;(function(Fe){function Ne(oe){let Te;return oe.code&&((0,$.$Ef)(oe.code)||(0,$.$If)(oe.code)?Te=String(oe.code):Te={value:String(oe.code.value),target:oe.code.target}),{...h.from(oe.range),message:oe.message,source:oe.source,code:Te,severity:C.from(oe.severity),relatedInformation:oe.relatedInformation&&oe.relatedInformation.map(k.from),tags:Array.isArray(oe.tags)?(0,E.$Hb)(oe.tags.map(S.from)):void 0}}Fe.from=Ne;function Ce(oe){const Te=new r.$4K(h.to(oe),oe.message,C.to(oe.severity));return Te.source=oe.source,Te.code=(0,$.$Ef)(oe.code)?oe.code:oe.code?.value,Te.relatedInformation=oe.relatedInformation&&oe.relatedInformation.map(k.to),Te.tags=oe.tags&&(0,E.$Hb)(oe.tags.map(S.to)),Te}Fe.to=Ce})(p||(e.Diagnostic=p={}));var k;(function(Fe){function Ne(oe){return{...h.from(oe.location.range),message:oe.message,resource:oe.location.uri}}Fe.from=Ne;function Ce(oe){return new r.$3K(new r.$2K(oe.resource,h.to(oe)),oe.message)}Fe.to=Ce})(k||(e.DiagnosticRelatedInformation=k={}));var C;(function(Fe){function Ne(oe){switch(oe){case r.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Fe.from=Ne;function Ce(oe){switch(oe){case g.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Fe.to=Ce})(C||(e.DiagnosticSeverity=C={}));var j;(function(Fe){function Ne(oe){return typeof oe=="number"&&oe>=r.ViewColumn.One?oe-1:oe===r.ViewColumn.Beside?t.$XC:t.$WC}Fe.from=Ne;function Ce(oe){if(typeof oe=="number"&&oe>=0)return oe+1;throw new Error("invalid 'EditorGroupColumn'")}Fe.to=Ce})(j||(e.ViewColumn=j={}));function z(Fe){return typeof Fe.range<"u"}function O(Fe){return Fe.length===0?!0:!!z(Fe[0])}e.$OM=O;var U;(function(Fe){function Ne(Je){return Je.map(Fe.from)}Fe.fromMany=Ne;function Ce(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function oe(Je){let st;if(Ce(Je)){const{language:Dt,value:At}=Je;st={value:"```"+Dt+`
`+At+"\n```\n"}}else r.$eL.isMarkdownString(Je)?st={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?st={value:Je}:st={value:""};const bt=Object.create(null);st.uris=bt;const qt=Dt=>{try{let At=y.URI.parse(Dt,!0);At=At.with({query:Te(At.query,bt)}),bt[Dt]=At}catch{}return""},kt=new m.marked.Renderer;return kt.link=qt,kt.image=Dt=>typeof Dt=="string"?qt(M.$kk(Dt).href):"",(0,m.marked)(st.value,{renderer:kt}),st}Fe.from=oe;function Te(Je,st){if(!Je)return Je;let bt;try{bt=(0,w.$xh)(Je)}catch{}if(!bt)return Je;let qt=!1;return bt=(0,I.$kn)(bt,kt=>{if(y.URI.isUri(kt)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[Dt]=kt,qt=!0,Dt}else return}),qt?JSON.stringify(bt):Je}function Ve(Je){const st=new r.$eL(Je.value,Je.supportThemeIcons);return st.isTrusted=Je.isTrusted,st.supportHtml=Je.supportHtml,st.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,st}Fe.to=Ve;function _e(Je){if(Je)return typeof Je=="string"?Je:Fe.from(Je)}Fe.fromStrict=_e})(U||(e.MarkdownString=U={}));function N(Fe){return O(Fe)?Fe.map(Ne=>({range:h.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?U.fromMany(Ne.hoverMessage):Ne.hoverMessage?U.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Fe.map(Ne=>({range:h.from(Ne)}))}e.$PM=N;function R(Fe){return typeof Fe>"u"?Fe:typeof Fe=="string"?y.URI.file(Fe):Fe}e.$QM=R;var T;(function(Fe){function Ne(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?R(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Fe.from=Ne})(T||(e.ThemableDecorationAttachmentRenderOptions=T={}));var q;(function(Fe){function Ne(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?R(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?T.from(Ce.before):void 0,after:Ce.after?T.from(Ce.after):void 0}}Fe.from=Ne})(q||(e.ThemableDecorationRenderOptions=q={}));var ee;(function(Fe){function Ne(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Fe.from=Ne})(ee||(e.DecorationRangeBehavior=ee={}));var J;(function(Fe){function Ne(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?ee.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?q.from(Ce.light):void 0,dark:Ce.dark?q.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?R(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?T.from(Ce.before):void 0,after:Ce.after?T.from(Ce.after):void 0}}Fe.from=Ne})(J||(e.DecorationRenderOptions=J={}));var K;(function(Fe){function Ne(oe){return{text:oe.newText,eol:oe.newEol&&ot.from(oe.newEol),range:h.from(oe.range)}}Fe.from=Ne;function Ce(oe){const Te=new r.$WK(h.to(oe.range),oe.text);return Te.newEol=typeof oe.eol>"u"?void 0:ot.to(oe.eol),Te}Fe.to=Ce})(K||(e.TextEdit=K={}));var Z;(function(Fe){function Ne(oe,Te){const Ve={edits:[]};if(oe instanceof r.$ZK){const _e=new b.$Bc;for(const Je of oe._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&_e.add(Je.to);for(const Je of oe._allEntries())if(Je._type===1){let st;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?st={type:"base64",value:(0,F.$Ae)(F.$ge.wrap(Je.options.contents))}:st={type:"dataTransferItem",id:Je.options.contents._itemId}),Ve.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:st},metadata:Je.metadata})}else Je._type===2?Ve.edits.push({resource:Je.uri,textEdit:K.from(Je.edit),versionId:_e.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ve.edits.push({resource:Je.uri,textEdit:{range:h.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:_e.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ve.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ve.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(Et.from)}})}return Ve}Fe.from=Ne;function Ce(oe){const Te=new r.$ZK,Ve=new b.$Ac;for(const _e of oe.edits)if(_e.textEdit){const Je=_e,st=y.URI.revive(Je.resource),bt=h.to(Je.textEdit.range),qt=Je.textEdit.text,kt=Je.textEdit.insertAsSnippet;let Dt;kt?Dt=r.$YK.replace(bt,new r.$1K(qt)):Dt=r.$WK.replace(bt,qt);const At=Ve.get(st);At?At.push(Dt):Ve.set(st,[Dt])}else Te.renameFile(y.URI.revive(_e.oldResource),y.URI.revive(_e.newResource),_e.options);for(const[_e,Je]of Ve)Te.set(_e,Je);return Te}Fe.to=Ce})(Z||(e.WorkspaceEdit=Z={}));var ae;(function(Fe){const Ne=Object.create(null);Ne[r.SymbolKind.File]=0,Ne[r.SymbolKind.Module]=1,Ne[r.SymbolKind.Namespace]=2,Ne[r.SymbolKind.Package]=3,Ne[r.SymbolKind.Class]=4,Ne[r.SymbolKind.Method]=5,Ne[r.SymbolKind.Property]=6,Ne[r.SymbolKind.Field]=7,Ne[r.SymbolKind.Constructor]=8,Ne[r.SymbolKind.Enum]=9,Ne[r.SymbolKind.Interface]=10,Ne[r.SymbolKind.Function]=11,Ne[r.SymbolKind.Variable]=12,Ne[r.SymbolKind.Constant]=13,Ne[r.SymbolKind.String]=14,Ne[r.SymbolKind.Number]=15,Ne[r.SymbolKind.Boolean]=16,Ne[r.SymbolKind.Array]=17,Ne[r.SymbolKind.Object]=18,Ne[r.SymbolKind.Key]=19,Ne[r.SymbolKind.Null]=20,Ne[r.SymbolKind.EnumMember]=21,Ne[r.SymbolKind.Struct]=22,Ne[r.SymbolKind.Event]=23,Ne[r.SymbolKind.Operator]=24,Ne[r.SymbolKind.TypeParameter]=25;function Ce(Te){return typeof Ne[Te]=="number"?Ne[Te]:6}Fe.from=Ce;function oe(Te){for(const Ve in Ne)if(Ne[Ve]===Te)return Number(Ve);return r.SymbolKind.Property}Fe.to=oe})(ae||(e.SymbolKind=ae={}));var _;(function(Fe){function Ne(oe){switch(oe){case r.SymbolTag.Deprecated:return 1}}Fe.from=Ne;function Ce(oe){switch(oe){case 1:return r.SymbolTag.Deprecated}}Fe.to=Ce})(_||(e.SymbolTag=_={}));var ye;(function(Fe){function Ne(oe){return{name:oe.name,kind:ae.from(oe.kind),tags:oe.tags&&oe.tags.map(_.from),containerName:oe.containerName,location:me.from(oe.location)}}Fe.from=Ne;function Ce(oe){const Te=new r.$8K(oe.name,ae.to(oe.kind),oe.containerName,me.to(oe.location));return Te.tags=oe.tags&&oe.tags.map(_.to),Te}Fe.to=Ce})(ye||(e.WorkspaceSymbol=ye={}));var ge;(function(Fe){function Ne(oe){const Te={name:oe.name||"!!MISSING: name!!",detail:oe.detail,range:h.from(oe.range),selectionRange:h.from(oe.selectionRange),kind:ae.from(oe.kind),tags:oe.tags?.map(_.from)??[]};return oe.children&&(Te.children=oe.children.map(Ne)),Te}Fe.from=Ne;function Ce(oe){const Te=new r.$9K(oe.name,oe.detail,ae.to(oe.kind),h.to(oe.range),h.to(oe.selectionRange));return(0,E.$Lb)(oe.tags)&&(Te.tags=oe.tags.map(_.to)),oe.children&&(Te.children=oe.children.map(Ce)),Te}Fe.to=Ce})(ge||(e.DocumentSymbol=ge={}));var re;(function(Fe){function Ne(oe){const Te=new r.$aL(ae.to(oe.kind),oe.name,oe.detail||"",y.URI.revive(oe.uri),h.to(oe.range),h.to(oe.selectionRange));return Te._sessionId=oe._sessionId,Te._itemId=oe._itemId,Te}Fe.to=Ne;function Ce(oe,Te,Ve){if(Te=Te??oe._sessionId,Ve=Ve??oe._itemId,Te===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Ve,name:oe.name,detail:oe.detail,kind:ae.from(oe.kind),uri:oe.uri,range:h.from(oe.range),selectionRange:h.from(oe.selectionRange),tags:oe.tags?.map(_.from)}}Fe.from=Ce})(re||(e.CallHierarchyItem=re={}));var W;(function(Fe){function Ne(Ce){return new r.$bL(re.to(Ce.from),Ce.fromRanges.map(oe=>h.to(oe)))}Fe.to=Ne})(W||(e.CallHierarchyIncomingCall=W={}));var ce;(function(Fe){function Ne(Ce){return new r.$cL(re.to(Ce.to),Ce.fromRanges.map(oe=>h.to(oe)))}Fe.to=Ne})(ce||(e.CallHierarchyOutgoingCall=ce={}));var me;(function(Fe){function Ne(oe){return{range:oe.range&&h.from(oe.range),uri:oe.uri}}Fe.from=Ne;function Ce(oe){return new r.$2K(y.URI.revive(oe.uri),h.to(oe.range))}Fe.to=Ce})(me||(e.location=me={}));var le;(function(Fe){function Ne(oe){const Te=oe,Ve=oe;return{originSelectionRange:Te.originSelectionRange?h.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Ve.uri,range:h.from(Te.targetRange?Te.targetRange:Ve.range),targetSelectionRange:Te.targetSelectionRange?h.from(Te.targetSelectionRange):void 0}}Fe.from=Ne;function Ce(oe){return{targetUri:y.URI.revive(oe.uri),targetRange:h.to(oe.range),targetSelectionRange:oe.targetSelectionRange?h.to(oe.targetSelectionRange):void 0,originSelectionRange:oe.originSelectionRange?h.to(oe.originSelectionRange):void 0}}Fe.to=Ce})(le||(e.DefinitionLink=le={}));var de;(function(Fe){function Ne(oe){return{range:h.from(oe.range),contents:U.fromMany(oe.contents)}}Fe.from=Ne;function Ce(oe){return new r.$5K(oe.contents.map(U.to),h.to(oe.range))}Fe.to=Ce})(de||(e.Hover=de={}));var Y;(function(Fe){function Ne(oe){return{range:h.from(oe.range),expression:oe.expression}}Fe.from=Ne;function Ce(oe){return new r.$YL(h.to(oe.range),oe.expression)}Fe.to=Ce})(Y||(e.EvaluatableExpression=Y={}));var X;(function(Fe){function Ne(oe){if(oe instanceof r.$ZL)return{type:"text",range:h.from(oe.range),text:oe.text};if(oe instanceof r.$1L)return{type:"variable",range:h.from(oe.range),variableName:oe.variableName,caseSensitiveLookup:oe.caseSensitiveLookup};if(oe instanceof r.$2L)return{type:"expression",range:h.from(oe.range),expression:oe.expression};throw new Error("Unknown 'InlineValue' type")}Fe.from=Ne;function Ce(oe){switch(oe.type){case"text":return{range:h.to(oe.range),text:oe.text};case"variable":return{range:h.to(oe.range),variableName:oe.variableName,caseSensitiveLookup:oe.caseSensitiveLookup};case"expression":return{range:h.to(oe.range),expression:oe.expression}}}Fe.to=Ce})(X||(e.InlineValue=X={}));var Q;(function(Fe){function Ne(oe){return{frameId:oe.frameId,stoppedLocation:h.from(oe.stoppedLocation)}}Fe.from=Ne;function Ce(oe){return new r.$3L(oe.frameId,h.to(oe.stoppedLocation))}Fe.to=Ce})(Q||(e.InlineValueContext=Q={}));var te;(function(Fe){function Ne(oe){return{range:h.from(oe.range),kind:oe.kind}}Fe.from=Ne;function Ce(oe){return new r.$6K(h.to(oe.range),oe.kind)}Fe.to=Ce})(te||(e.DocumentHighlight=te={}));var $e;(function(Fe){function Ne(oe){return{uri:oe.uri,highlights:oe.highlights.map(te.from)}}Fe.from=Ne;function Ce(oe){return new r.$7K(y.URI.revive(oe.uri),oe.highlights.map(te.to))}Fe.to=Ce})($e||(e.MultiDocumentHighlight=$e={}));var ve;(function(Fe){function Ne(Ce){switch(Ce){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Fe.to=Ne})(ve||(e.CompletionTriggerKind=ve={}));var Le;(function(Fe){function Ne(Ce){return{triggerKind:ve.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Fe.to=Ne})(Le||(e.CompletionContext=Le={}));var pe;(function(Fe){function Ne(oe){switch(oe){case r.CompletionItemTag.Deprecated:return 1}}Fe.from=Ne;function Ce(oe){switch(oe){case 1:return r.CompletionItemTag.Deprecated}}Fe.to=Ce})(pe||(e.CompletionItemTag=pe={}));var De;(function(Fe){const Ne=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ce(Ve){return Ne.get(Ve)??9}Fe.from=Ce;const oe=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Te(Ve){return oe.get(Ve)??r.CompletionItemKind.Property}Fe.to=Te})(De||(e.CompletionItemKind=De={}));var B;(function(Fe){function Ne(Ce,oe){const Te=new r.$kL(Ce.label);return Te.insertText=Ce.insertText,Te.kind=De.to(Ce.kind),Te.tags=Ce.tags?.map(pe.to),Te.detail=Ce.detail,Te.documentation=M.$fk(Ce.documentation)?U.to(Ce.documentation):Ce.documentation,Te.sortText=Ce.sortText,Te.filterText=Ce.filterText,Te.preselect=Ce.preselect,Te.commitCharacters=Ce.commitCharacters,D.$Hs.isIRange(Ce.range)?Te.range=h.to(Ce.range):typeof Ce.range=="object"&&(Te.range={inserting:h.to(Ce.range.insert),replacing:h.to(Ce.range.replace)}),Te.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Te.insertText=new r.$1K(Ce.insertText):(Te.insertText=Ce.insertText,Te.textEdit=Te.range instanceof r.$RK?new r.$WK(Te.range,Te.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ce.additionalTextEdits.map(Ve=>K.to(Ve))),Te.command=oe&&Ce.command?oe.fromInternal(Ce.command):void 0,Te}Fe.to=Ne})(B||(e.CompletionItem=B={}));var x;(function(Fe){function Ne(oe){if(typeof oe.label!="string"&&!Array.isArray(oe.label))throw new TypeError("Invalid label");return{label:oe.label,documentation:U.fromStrict(oe.documentation)}}Fe.from=Ne;function Ce(oe){return{label:oe.label,documentation:M.$fk(oe.documentation)?U.to(oe.documentation):oe.documentation}}Fe.to=Ce})(x||(e.ParameterInformation=x={}));var se;(function(Fe){function Ne(oe){return{label:oe.label,documentation:U.fromStrict(oe.documentation),parameters:Array.isArray(oe.parameters)?oe.parameters.map(x.from):[],activeParameter:oe.activeParameter}}Fe.from=Ne;function Ce(oe){return{label:oe.label,documentation:M.$fk(oe.documentation)?U.to(oe.documentation):oe.documentation,parameters:Array.isArray(oe.parameters)?oe.parameters.map(x.to):[],activeParameter:oe.activeParameter}}Fe.to=Ce})(se||(e.SignatureInformation=se={}));var H;(function(Fe){function Ne(oe){return{activeSignature:oe.activeSignature,activeParameter:oe.activeParameter,signatures:Array.isArray(oe.signatures)?oe.signatures.map(se.from):[]}}Fe.from=Ne;function Ce(oe){return{activeSignature:oe.activeSignature,activeParameter:oe.activeParameter,signatures:Array.isArray(oe.signatures)?oe.signatures.map(se.to):[]}}Fe.to=Ce})(H||(e.SignatureHelp=H={}));var ue;(function(Fe){function Ne(Ce,oe){const Te=new r.$jL(v.to(oe.position),typeof oe.label=="string"?oe.label:oe.label.map(fe.to.bind(void 0,Ce)),oe.kind&&Re.to(oe.kind));return Te.textEdits=oe.textEdits&&oe.textEdits.map(K.to),Te.tooltip=M.$fk(oe.tooltip)?U.to(oe.tooltip):oe.tooltip,Te.paddingLeft=oe.paddingLeft,Te.paddingRight=oe.paddingRight,Te}Fe.to=Ne})(ue||(e.InlayHint=ue={}));var fe;(function(Fe){function Ne(Ce,oe){const Te=new r.$iL(oe.label);return Te.tooltip=M.$fk(oe.tooltip)?U.to(oe.tooltip):oe.tooltip,u.Command.is(oe.command)&&(Te.command=Ce.fromInternal(oe.command)),oe.location&&(Te.location=me.to(oe.location)),Te}Fe.to=Ne})(fe||(e.InlayHintLabelPart=fe={}));var Re;(function(Fe){function Ne(oe){return oe}Fe.from=Ne;function Ce(oe){return oe}Fe.to=Ce})(Re||(e.InlayHintKind=Re={}));var Oe;(function(Fe){function Ne(oe){return{range:h.from(oe.range),url:oe.target,tooltip:oe.tooltip}}Fe.from=Ne;function Ce(oe){let Te;if(oe.url)try{Te=typeof oe.url=="string"?y.URI.parse(oe.url,!0):y.URI.revive(oe.url)}catch{}return new r.$pL(h.to(oe.range),Te)}Fe.to=Ce})(Oe||(e.DocumentLink=Oe={}));var Ge;(function(Fe){function Ne(oe){const Te=new r.$sL(oe.label);return oe.textEdit&&(Te.textEdit=K.to(oe.textEdit)),oe.additionalTextEdits&&(Te.additionalTextEdits=oe.additionalTextEdits.map(Ve=>K.to(Ve))),Te}Fe.to=Ne;function Ce(oe){return{label:oe.label,textEdit:oe.textEdit?K.from(oe.textEdit):void 0,additionalTextEdits:oe.additionalTextEdits?oe.additionalTextEdits.map(Te=>K.from(Te)):void 0}}Fe.from=Ce})(Ge||(e.ColorPresentation=Ge={}));var He;(function(Fe){function Ne(oe){return new r.$qL(oe[0],oe[1],oe[2],oe[3])}Fe.to=Ne;function Ce(oe){return[oe.red,oe.green,oe.blue,oe.alpha]}Fe.from=Ce})(He||(e.Color=He={}));var et;(function(Fe){function Ne(oe){return{range:h.from(oe.range)}}Fe.from=Ne;function Ce(oe){return new r.$_K(h.to(oe.range))}Fe.to=Ce})(et||(e.SelectionRange=et={}));var lt;(function(Fe){function Ne(Ce){switch(Ce){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Fe.to=Ne})(lt||(e.TextDocumentSaveReason=lt={}));var ct;(function(Fe){function Ne(oe){switch(oe){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Fe.from=Ne;function Ce(oe){switch(oe){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Fe.to=Ce})(ct||(e.TextEditorLineNumbersStyle=ct={}));var ot;(function(Fe){function Ne(oe){if(oe===r.EndOfLine.CRLF)return 1;if(oe===r.EndOfLine.LF)return 0}Fe.from=Ne;function Ce(oe){if(oe===1)return r.EndOfLine.CRLF;if(oe===0)return r.EndOfLine.LF}Fe.to=Ce})(ot||(e.EndOfLine=ot={}));var Pe;(function(Fe){function Ne(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Fe.from=Ne})(Pe||(e.ProgressLocation=Pe={}));var Ue;(function(Fe){function Ne(oe){const Te={start:oe.start+1,end:oe.end+1};return oe.kind&&(Te.kind=Ae.from(oe.kind)),Te}Fe.from=Ne;function Ce(oe){const Te={start:oe.start-1,end:oe.end-1};return oe.kind&&(Te.kind=Ae.to(oe.kind)),Te}Fe.to=Ce})(Ue||(e.FoldingRange=Ue={}));var Ae;(function(Fe){function Ne(oe){if(oe)switch(oe){case r.FoldingRangeKind.Comment:return u.$xt.Comment;case r.FoldingRangeKind.Imports:return u.$xt.Imports;case r.FoldingRangeKind.Region:return u.$xt.Region}}Fe.from=Ne;function Ce(oe){if(oe)switch(oe.value){case u.$xt.Comment.value:return r.FoldingRangeKind.Comment;case u.$xt.Imports.value:return r.FoldingRangeKind.Imports;case u.$xt.Region.value:return r.FoldingRangeKind.Region}}Fe.to=Ce})(Ae||(e.FoldingRangeKind=Ae={}));var Xe;(function(Fe){function Ne(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?h.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?n.$mE.id:void 0}}Fe.from=Ne})(Xe||(e.TextEditorOpenOptions=Xe={}));var ne;(function(Fe){function Ne(Ve){return Ve instanceof r.$ML?Ve.toJSON():typeof Ve=="string"?Ve:Ce(Ve)||oe(Ve)?new r.$ML(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Fe.from=Ne;function Ce(Ve){const _e=Ve;return _e?y.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function oe(Ve){const _e=Ve;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Te(Ve){return typeof Ve=="string"?Ve:new r.$ML(y.URI.revive(Ve.baseUri),Ve.pattern)}Fe.to=Te})(ne||(e.GlobPattern=ne={}));var he;(function(Fe){function Ne(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Ne);if(typeof Ce=="string")return Ce;{const oe=Ce;return{language:oe.language,scheme:oe.scheme,pattern:ne.from(oe.pattern),exclusive:oe.exclusive,notebookType:oe.notebookType}}}else return}Fe.from=Ne})(he||(e.LanguageSelector=he={}));var Ie;(function(Fe){function Ne(oe){return!!oe&&typeof oe=="object"&&"documents"in oe&&Array.isArray(oe.documents)&&oe.documents.every(Te=>Array.isArray(Te)&&Te.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&y.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(_e=>_e instanceof r.$RK)))}Fe.is=Ne;function Ce(oe){return{documents:oe.documents.map(Te=>Te.map(Ve=>({uri:y.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(_e=>h.from(_e))})))}}Fe.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Fe){function Ne(oe){return{start:oe.start,end:oe.end}}Fe.from=Ne;function Ce(oe){return new r.$bM(oe.start,oe.end)}Fe.to=Ce})(Ke||(e.NotebookRange=Ke={}));var Ye;(function(Fe){function Ne(oe){return{timing:typeof oe.runStartTime=="number"&&typeof oe.runEndTime=="number"?{startTime:oe.runStartTime,endTime:oe.runEndTime}:void 0,executionOrder:oe.executionOrder,success:oe.lastRunSuccess}}Fe.to=Ne;function Ce(oe){return{lastRunSuccess:oe.success,runStartTime:oe.timing?.startTime,runEndTime:oe.timing?.endTime,executionOrder:oe.executionOrder}}Fe.from=Ce})(Ye||(e.NotebookCellExecutionSummary=Ye={}));var it;(function(Fe){function Ne(Ce){if(Ce===i.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ce===i.NotebookCellExecutionState.Pending)return;if(Ce===i.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Fe.to=Ne})(it||(e.NotebookCellExecutionState=it={}));var at;(function(Fe){function Ne(oe){switch(oe){case r.NotebookCellKind.Markup:return i.CellKind.Markup;case r.NotebookCellKind.Code:default:return i.CellKind.Code}}Fe.from=Ne;function Ce(oe){switch(oe){case i.CellKind.Markup:return r.NotebookCellKind.Markup;case i.CellKind.Code:default:return r.NotebookCellKind.Code}}Fe.to=Ce})(at||(e.NotebookCellKind=at={}));var je;(function(Fe){function Ne(oe){const Te={metadata:oe.metadata??Object.create(null),cells:[]};for(const Ve of oe.cells)r.$cM.validate(Ve),Te.cells.push(Et.from(Ve));return Te}Fe.from=Ne;function Ce(oe){const Te=new r.$dM(oe.cells.map(Et.to));return(0,$.$Rf)(oe.metadata)||(Te.metadata=oe.metadata),Te}Fe.to=Ce})(je||(e.NotebookData=je={}));var Et;(function(Fe){function Ne(oe){return{cellKind:at.from(oe.kind),language:oe.languageId,mime:oe.mime,source:oe.value,metadata:oe.metadata,internalMetadata:Ye.from(oe.executionSummary??{}),outputs:oe.outputs?oe.outputs.map(Ht.from):[]}}Fe.from=Ne;function Ce(oe){return new r.$cM(at.to(oe.cellKind),oe.source,oe.language,oe.mime,oe.outputs?oe.outputs.map(Ht.to):void 0,oe.metadata,oe.internalMetadata?Ye.to(oe.internalMetadata):void 0)}Fe.to=Ce})(Et||(e.NotebookCellData=Et={}));var It;(function(Fe){function Ne(oe){return{mime:oe.mime,valueBytes:F.$ge.wrap(oe.data)}}Fe.from=Ne;function Ce(oe){return new r.$eM(oe.valueBytes.buffer,oe.mime)}Fe.to=Ce})(It||(e.NotebookCellOutputItem=It={}));var Ht;(function(Fe){function Ne(oe){return{outputId:oe.id,items:oe.items.map(It.from),metadata:oe.metadata}}Fe.from=Ne;function Ce(oe){const Te=oe.items.map(It.to);return new r.$fM(Te,oe.outputId,oe.metadata)}Fe.to=Ce})(Ht||(e.NotebookCellOutput=Ht={}));var Kt;(function(Fe){function Ne(Te){return oe(Te)?{include:ne.from(Te.include)??void 0,exclude:ne.from(Te.exclude)??void 0}:ne.from(Te)??void 0}Fe.from=Ne;function Ce(Te){return oe(Te)?{include:ne.to(Te.include),exclude:ne.to(Te.exclude)}:ne.to(Te)}Fe.to=Ce;function oe(Te){const Ve=Te;return Ve?!(0,$.$Nf)(Ve.include)&&!(0,$.$Nf)(Ve.exclude):!1}})(Kt||(e.NotebookExclusiveDocumentPattern=Kt={}));var yt;(function(Fe){function Ne(Ce,oe,Te){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:oe.toInternal(Ve,Te),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Fe.from=Ne})(yt||(e.NotebookStatusBarItem=yt={}));var Gt;(function(Fe){function Ne(Ce,oe,Te){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:oe.toInternal(Ve,Te),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Fe.from=Ne})(Gt||(e.NotebookKernelSourceAction=Gt={}));var zt;(function(Fe){function Ne(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Fe.from=Ne})(zt||(e.NotebookDocumentContentOptions=zt={}));var ni;(function(Fe){function Ne(oe){return{uri:oe.uri,provides:oe.provides}}Fe.from=Ne;function Ce(oe){return new r.$hM(y.URI.revive(oe.uri),oe.provides)}Fe.to=Ce})(ni||(e.NotebookRendererScript=ni={}));var Jt;(function(Fe){function Ne(oe){return{message:U.fromStrict(oe.message)||"",type:0,expected:oe.expectedOutput,actual:oe.actualOutput,contextValue:oe.contextValue,location:oe.location&&{range:h.from(oe.location.range),uri:oe.location.uri}}}Fe.from=Ne;function Ce(oe){const Te=new r.$nM(typeof oe.message=="string"?oe.message:U.to(oe.message));return Te.actualOutput=oe.actual,Te.expectedOutput=oe.expected,Te.contextValue=oe.contextValue,Te.location=oe.location?me.to(oe.location):void 0,Te}Fe.to=Ce})(Jt||(e.TestMessage=Jt={}));var Ft;(function(Fe){Fe.namespace=a.$JJ,Fe.denamespace=a.$KJ})(Ft||(e.TestTag=Ft={}));var tt;(function(Fe){function Ne(oe){const Te=(0,o.$NM)(oe).controllerId;return{extId:s.$FJ.fromExtHostTestItem(oe,Te).toString(),label:oe.label,uri:y.URI.revive(oe.uri),busy:oe.busy,tags:oe.tags.map(Ve=>Ft.namespace(Te,Ve.id)),range:D.$Hs.lift(h.from(oe.range)),description:oe.description||null,sortText:oe.sortText||null,error:oe.error&&U.fromStrict(oe.error)||null}}Fe.from=Ne;function Ce(oe){return{parent:void 0,error:void 0,id:s.$FJ.fromString(oe.extId).localId,label:oe.label,uri:y.URI.revive(oe.uri),tags:(oe.tags||[]).map(Te=>{const{tagId:Ve}=Ft.denamespace(Te);return new r.$oM(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(oe.range||void 0),canResolveChildren:!1,busy:oe.busy,description:oe.description||void 0,sortText:oe.sortText||void 0}}Fe.toPlain=Ce})(tt||(e.TestItem=tt={})),function(Fe){function Ne(oe){return{id:oe.id}}Fe.from=Ne;function Ce(oe){return new r.$oM(oe.id)}Fe.to=Ce}(Ft||(e.TestTag=Ft={}));var Bt;(function(Fe){const Ne=(oe,Te)=>{const Ve=[];for(const[Je,st]of Te)s.$FJ.compare(st.item.extId,Je)===2&&(Te.delete(Je),Ve.push(st));const _e={...tt.toPlain(oe.item),parent:void 0,taskStates:oe.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(st=>st.type===0).map(Jt.to)})),children:Ve.map(Je=>Ne(Je,Te))};for(const Je of _e.children)Je.parent=_e;return _e};function Ce(oe){const Te=[],Ve=new Map;for(const _e of oe.items){Ve.set(_e.item.extId,_e);const Je=s.$FJ.root(_e.item.extId);oe.request.targets.some(st=>st.controllerId===Je&&st.testIds.includes(_e.item.extId))&&Te.push(_e)}return{completedAt:oe.completedAt,results:Te.map(_e=>Ne(_e,Ve))}}Fe.to=Ce})(Bt||(e.TestResults=Bt={}));var Zt;(function(Fe){function Ne(Ve){return{covered:Ve.covered,total:Ve.total}}function Ce(Ve){return"line"in Ve?v.from(Ve):h.from(Ve)}function oe(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ce(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Ce(_e.location)})):void 0}:{type:0,name:Ve.name,count:Ve.executionCount,location:Ce(Ve.location)}}Fe.fromDetailed=oe;function Te(Ve){return{uri:Ve.uri,statement:Ne(Ve.statementCoverage),branch:Ve.branchCoverage&&Ne(Ve.branchCoverage),function:Ve.functionCoverage&&Ne(Ve.functionCoverage),details:Ve.detailedCoverage?.map(oe)}}Fe.fromFile=Te})(Zt||(e.TestCoverage=Zt={}));var dt;(function(Fe){function Ne(Ce){switch(Ce){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Fe.to=Ne})(dt||(e.CodeActionTriggerKind=dt={}));var $t;(function(Fe){function Ne(oe){const Te=new r.$uM(ae.to(oe.kind),oe.name,oe.detail||"",y.URI.revive(oe.uri),h.to(oe.range),h.to(oe.selectionRange));return Te._sessionId=oe._sessionId,Te._itemId=oe._itemId,Te}Fe.to=Ne;function Ce(oe,Te,Ve){if(Te=Te??oe._sessionId,Ve=Ve??oe._itemId,Te===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Ve,kind:ae.from(oe.kind),name:oe.name,detail:oe.detail??"",uri:oe.uri,range:h.from(oe.range),selectionRange:h.from(oe.selectionRange),tags:oe.tags?.map(_.from)}}Fe.from=Ce})($t||(e.TypeHierarchyItem=$t={}));var Nt;(function(Fe){function Ne(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Fe.from=Ne})(Nt||(e.ViewBadge=Nt={}));var Tt;(function(Fe){function Ne(Ve,_e,Je){const st=_e.fileData;return st?new r.$FL(new r.$GL(st.name,y.URI.revive(st.uri),st.id,(0,A.$db)(()=>Je(st.id)))):Ve===L.$4r.uriList&&_e.uriListData?new r.$EL(Te(_e.uriListData)):new r.$EL(_e.asString)}Fe.to=Ne;async function Ce(Ve,_e){const Je=await _e.asString();if(Ve===L.$4r.uriList)return{asString:Je,fileData:void 0,uriListData:oe(Je)};const st=_e.asFile();return{asString:Je,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}Fe.from=Ce;function oe(Ve){return f.$et.split(Ve).map(_e=>{if(_e.startsWith("#"))return _e;try{return y.URI.parse(_e)}catch{}return _e})}function Te(Ve){return f.$et.create(Ve.map(_e=>typeof _e=="string"?_e:y.URI.revive(_e)))}})(Tt||(e.DataTransferItem=Tt={}));var St;(function(Fe){function Ne(oe,Te){const Ve=oe.items.map(([_e,Je])=>[_e,Tt.to(_e,Je,Te)]);return new r.$HL(Ve)}Fe.toDataTransfer=Ne;async function Ce(oe){const Te={items:[]},Ve=[];for(const[_e,Je]of oe)Ve.push((async()=>{Te.items.push([_e,await Tt.from(_e,Je)])})());return await Promise.all(Ve),Te}Fe.from=Ce})(St||(e.DataTransfer=St={}));var ft;(function(Fe){function Ne(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Fe.from=Ne})(ft||(e.ChatReplyFollowup=ft={}));var Lt;(function(Fe){function Ne(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:ft.from(Ce)}Fe.from=Ne})(Lt||(e.ChatFollowup=Lt={}));var _t;(function(Fe){function Ne(oe){const Te=new r.$GM(Pt.to(oe.role),oe.content);return Te.name=oe.name,Te}Fe.to=Ne;function Ce(oe){return{role:Pt.from(oe.role),content:oe.content,name:oe.name}}Fe.from=Ce})(_t||(e.ChatMessage=_t={}));var Pt;(function(Fe){function Ne(oe){switch(oe){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Fe.to=Ne;function Ce(oe){switch(oe){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Fe.from=Ce})(Pt||(e.ChatMessageRole=Pt={}));var Ze;(function(Fe){function Ne(Te){const Ve={};for(const _e of Object.keys(Te))Ve[_e]=Te[_e].map(Fe.to);return Ve}Fe.objectTo=Ne;function Ce(Te){return{level:Wt.to(Te.level),kind:Te.kind,value:(0,w.$yh)(Te.value),description:Te.description}}Fe.to=Ce;function oe(Te){return{level:Wt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Fe.from=oe})(Ze||(e.ChatVariable=Ze={}));var Wt;(function(Fe){function Ne(oe){switch(oe){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Fe.to=Ne;function Ce(oe){switch(oe){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Fe.from=Ce})(Wt||(e.ChatVariableLevel=Wt={}));var Xt;(function(Fe){function Ne(Ce){switch(Ce){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Fe.to=Ne})(Xt||(e.InteractiveEditorResponseFeedbackKind=Xt={}));var Yt;(function(Fe){function Ne(Ce,oe){return"placeholder"in oe&&"resolvedContent"in oe?{content:oe.placeholder,kind:"asyncContent"}:"markdownContent"in oe?((0,d.$lF)(Ce,"chatAgents2Additions"),{content:U.from(oe.markdownContent),kind:"markdownContent"}):"content"in oe?"vulnerabilities"in oe&&oe.vulnerabilities?((0,d.$lF)(Ce,"chatAgents2Additions"),{content:oe.content,vulnerabilities:oe.vulnerabilities,kind:"vulnerability"}):typeof oe.content=="string"?{content:oe.content,kind:"content"}:((0,d.$lF)(Ce,"chatAgents2Additions"),{content:U.from(oe.content),kind:"markdownContent"}):"documents"in oe?{documents:oe.documents.map(Te=>({uri:Te.uri,version:Te.version,ranges:Te.ranges.map(Ve=>h.from(Ve))})),kind:"usedContext"}:"reference"in oe?{reference:"uri"in oe.reference?{uri:oe.reference.uri,range:h.from(oe.reference.range)}:oe.reference,kind:"reference"}:"inlineReference"in oe?{inlineReference:"uri"in oe.inlineReference?{uri:oe.inlineReference.uri,range:h.from(oe.inlineReference.range)}:oe.inlineReference,name:oe.title,kind:"inlineReference"}:"agentName"in oe?((0,d.$lF)(Ce,"chatAgents2Additions"),{agentName:oe.agentName,command:oe.command,kind:"agentDetection"}):"treeData"in oe?{treeData:oe.treeData,kind:"treeData"}:"message"in oe?{content:oe.message,kind:"progressMessage"}:void 0}Fe.from=Ne})(Yt||(e.ChatResponseProgress=Yt={}));var pt;(function(Fe){function Ne(Ce){return{label:Ce.label,values:Ce.values.map(Ze.from),insertText:Ce.insertText,detail:Ce.detail,documentation:Ce.documentation}}Fe.from=Ne})(pt||(e.ChatAgentCompletionItem=pt={}));var Ot;(function(Fe){function Ne(Ce,oe,Te){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand,shouldExecute:Ce.shouldExecute}:"uri"in Ce?{uri:Ce.uri}:oe.toInternal(Ce,Te)}Fe.from=Ne})(Ot||(e.TerminalQuickFix=Ot={}))}),define(Se[293],ke([1,0,2,8,7,15,75]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class b{constructor(w,L,I,$={timeout:1500,errors:3}){this.c=w,this.d=L,this.f=I,this.g=$,this.a=new M.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(L,I,$)=>{const D={dispose:this.a.push([L,I,w])};return Array.isArray($)&&$.push(D),D}}async $participateInSave(w,L){const I=E.URI.revive(w);let $=!1;const y=setTimeout(()=>$=!0,this.g.timeout),D=[];try{for(const u of[...this.a]){if($)break;const g=this.d.getDocument(I),o=await this.h(u,{document:g,reason:A.TextDocumentSaveReason.to(L)});D.push(o)}}finally{clearTimeout(y)}return D}h([w,L,I],$){const y=this.b.get(w);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(I,w,L,$).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const u=this.b.get(w);this.b.set(w,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,L,I,$){const y=[],D=Date.now(),{document:u,reason:g}=$,{version:o}=u,n=Object.freeze({document:u,reason:g,waitUntil(i){if(Object.isFrozen(y))throw(0,F.$8)("waitUntil can not be called async");y.push(Promise.resolve(i))}});try{L.apply(I,[n])}catch(i){return Promise.reject(i)}return Object.freeze(y),new Promise((i,s)=>{const a=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(a),i(t)}).catch(t=>{clearTimeout(a),s(t)})}).then(i=>{const s={edits:[]};for(const a of i)if(Array.isArray(a)&&a.every(t=>t instanceof f.$WK))for(const{newText:t,newEol:r,range:d}of a)s.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:d&&A.Range.from(d),text:t,eol:r&&A.EndOfLine.from(r)}});if(s.edits.length!==0)return o===u.version?this.f.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.$pgc=b}),define(Se[294],ke([1,0,17,2,15,7,112]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0;class b{constructor(I,$,y,D){this.start=I,this.deletedCount=$,this.deletedItems=y,this.items=D}asApiEvent(){return{range:new A.$bM(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(I,$){return{EOL:$.eol,lines:$.source,languageId:$.language,uri:$.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,$,y){this.notebook=I,this.h=$,this.j=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(f.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return I.g},set mime(D){I.g=D},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(y)}return this.f}setOutputs(I){this.a=I.map(f.NotebookCellOutput.to)}setOutputItems(I,$,y){const D=y.map(f.NotebookCellOutputItem.to),u=this.a.find(g=>g.id===I);if(u&&($||(u.items.length=0),u.items.push(...D),u.items.length>1&&u.items.every(g=>M.$RI(g.mime)))){const g=new Map,o=[];u.items.forEach(n=>{let i;g.has(n.mime)?i=g.get(n.mime):(i=[],g.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),u.items.length=0,o.forEach(n=>{const i=M.$SI(g.get(n));u.items.push({mime:n,data:i.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$ugc=m;class w{constructor(I,$,y,D,u){this.k=I,this.l=$,this.m=y,this.uri=D,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,$={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===E.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(y){return y=I.n(y),I.b[y].apiCell},getCells(y){return(y?I.p(y):I.b).map(u=>u.apiCell)},save(){return I.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,$,y){this.g=I.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:y});const D={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},u=[];for(const o of I.rawEvents)o.kind===M.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,D.contentChanges):o.kind===M.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,D.contentChanges):o.kind===M.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===M.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),u.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),u.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const g=new Map;for(let o=0;o<u.length;o++){const n=u[o],i=g.get(n.cell);if(i===void 0){const s=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});g.set(n.cell,s-1)}else D.cellChanges[i]={...D.cellChanges[i],...n}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let $=I.start|0,y=I.end|0;return $<0&&($=0),y>this.b.length&&(y=this.b.length),I.with({start:$,end:y})}p(I){I=this.o(I);const $=[];for(let y=I.start;y<I.end;y++)$.push(this.b[y]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,$,y){if(this.j)return;const D=[],u=[],g=[];if(I.reverse().forEach(o=>{const i=o[2].map(t=>{const r=new m(this,this.l,t);return $||u.push(m.asModelAddData(this.apiNotebook,t)),r}),s=new b(o[0],o[1],[],i),a=this.b.splice(o[0],o[1],...i);for(const t of a)g.push(t.uri),s.deletedItems.push(t.apiCell);D.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:g}),y)for(const o of D)y.push(o.asApiEvent())}s(I,$,y,D){const u=this.b.splice(I,$);this.b.splice(y,0,...u);const g=[new b(I,$,u.map(o=>o.apiCell),[]),new b(y,0,[],u)];for(const o of g)D.push(o.asApiEvent())}t(I,$){this.b[I].setOutputs($)}u(I,$,y,D){this.b[I].setOutputItems($,y,D)}v(I,$){const y=this.b[I];y.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(y.uri,$)}w(I,$){const y=this.b[I];y.apiCell.mime=$}x(I,$){this.b[I].setMetadata($)}y(I,$){this.b[I].setInternalMetadata($)}getCellFromApiCell(I){return this.b.find($=>$.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find($=>$.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$vgc=w,w.a=0}),define(Se[295],ke([1,0,4,2,15,7]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class M{constructor(m,w,L,I={timeout:1500,errors:3}){this.b=m,this.c=w,this.d=L,this.f=I,this.a=new E.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent(m){return(w,L,I)=>{const $=function(D){w.call(L,D)};return $.extension=m,this.a.event($,void 0,I)}}async $participateInSave(m,w,L){const I=F.URI.revive(m),$=this.c.getNotebookDocument(I);if(!$)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:$.apiNotebook,reason:f.TextDocumentSaveReason.to(w)},L,async(u,g)=>{const o=Date.now(),n=await await Promise.resolve(u);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier),!L.isCancellationRequested&&n&&(n instanceof A.$ZK?y.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(y.length===0)return!0;const D={edits:[]};for(const u of y){const{edits:g}=f.WorkspaceEdit.from(u);D.edits=D.edits.concat(g)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$Lgc=M}),define(Se[147],ke([1,0,8,15,7]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class A{constructor(b,m,w,L,I,$){this.id=b,this.f=m,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=L,this.c=$}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(m){this.selections=[m]},get selections(){return b.a},set selections(m){if(!Array.isArray(m)||!m.every(f.$bM.isNotebookRange))throw(0,E.$7)("selections");b.a=m,b.g(m)},get visibleRanges(){return b.b},revealRange(m,w){b.f.$tryRevealRange(b.id,F.NotebookRange.from(m),w??f.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(F.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$wgc=A,A.apiEditorsToExtHost=new WeakMap}),define(Se[296],ke([1,0,8,4,14,15]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;let M=class{constructor(m,w){this.c=m,this.d=w,this.a=new F.$Sd({onListenerError:E.$2}),this.b=new F.$Sd({onListenerError:E.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,w);const L=this.d.getEditorById(m);w.visibleRanges&&L._acceptVisibleRanges(w.visibleRanges.ranges.map(A.NotebookRange.to)),w.selections&&L._acceptSelections(w.selections.selections.map(A.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const w in m)this.d.getEditorById(w)._acceptViewColumn(A.ViewColumn.to(m[w]))}};e.$Ngc=M,e.$Ngc=M=Qe([qe(0,f.$jj)],M)}),define(Se[297],ke([1,0,15,85,216,21,59,8]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class m{constructor($){this.b=0,this.c=new Map,this.a=$}async withProgress($,y,D){const u=this.b++,{title:g,location:o,cancellable:n}=y,i={label:(0,f.localize)(0,null,$.displayName||$.name),id:$.identifier.value};return this.a.$startProgress(u,{location:E.ProgressLocation.from(o),title:g,source:i,cancellable:n},$.isUnderDevelopment?void 0:$.identifier.value).catch(b.$2),this.d(u,D,!!n)}d($,y,D){let u;D&&(u=new A.$3d,this.c.set($,u));const g=n=>{this.a.$progressEnd(n),this.c.delete(n),u?.dispose()};let o;try{o=y(new L(this.a,$),D&&u?u.token:A.CancellationToken.None)}catch(n){throw g($),n}return o.then(n=>g($),n=>g($)),o}$acceptProgressCanceled($){const y=this.c.get($);y&&(y.cancel(),this.c.delete($))}}e.$Ugc=m;function w(I,$){return I.message=$.message,typeof $.increment=="number"&&(typeof I.increment=="number"?I.increment+=$.increment:I.increment=$.increment),I}class L extends F.$hv{constructor($,y){super(D=>this.throttledReport(D)),this.c=$,this.d=y}throttledReport($){this.c.$progressReport(this.d,$)}}Qe([(0,M.$vh)(100,(I,$)=>w(I,$),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Se[148],ke([1,0,29,143,67,113,89,15,2]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=e.$5M=e.$4M=void 0;const w=(i,s,a,t)=>{let r=s;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!a(r,d)){const l=r;r=d,i.listener?.(t(d,l))}}}},L=(i,s)=>i===s,I={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(i,s)=>!(i.length!==s.length||i.some(a=>!s.find(t=>a.id===t.id)))},$=i=>s=>({op:4,update:i(s)}),y=(i,s)=>({range:(()=>{let a;const t=$(r=>({range:E.$Hs.lift(b.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){i.listener?.({op:6}),I.range(a,r)||(a=r,i.listener?.(t(r)))}}})(),label:w(i,s,I.label,$(a=>({label:a}))),description:w(i,void 0,I.description,$(a=>({description:a}))),sortText:w(i,void 0,I.sortText,$(a=>({sortText:a}))),canResolveChildren:w(i,!1,I.canResolveChildren,a=>({op:2,state:a})),busy:w(i,!1,I.busy,$(a=>({busy:a}))),error:w(i,void 0,I.error,$(a=>({error:b.MarkdownString.fromStrict(a)||null}))),tags:w(i,[],I.tags,(a,t)=>({op:1,new:a.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),D=i=>{const s=f.$FJ.fromString(i.extId),a=new g(s.controllerId,s.localId,i.label,m.URI.revive(i.uri)||void 0);return a.range=b.Range.to(i.range||void 0),a.description=i.description||void 0,a.sortText=i.sortText||void 0,a.tags=i.tags.map(t=>b.TestTag.to({id:(0,M.$KJ)(t).tagId})),a},u=i=>{let s;for(const a of i.tests){const t=D(a.item);(0,F.$NM)(t).parent=s,s=t}return s};e.$4M=u;class g{constructor(s,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,F.$MM)(this,s);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,A.$LM)(d,F.$NM,g),enumerable:!0,writable:!1},...y(d,t)})}}e.$5M=g;class o extends g{constructor(s,a){super(s,s,a,void 0),this._isRoot=!0}}e.$6M=o;class n extends A.$HM{constructor(s,a,t){super({controllerId:s,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:F.$NM,getChildren:r=>r.children,root:new o(s,a),toITestItem:b.TestItem.from})}}e.$7M=n}),define(Se[149],ke([1,0,60,8,122,15,7]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=e.$YM=void 0;class b{constructor($,y,D){const u=b.c.nextId();$.$registerTextEditorDecorationType(y.identifier,u,A.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:u,dispose(){$.$removeTextEditorDecorationType(u)}})}}e.$YM=b,b.c=new f.$WM("TextEditorDecorationType");class m{constructor($,y){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,y){this.k();let D=null;if($ instanceof M.$QK)D=new M.$RK($,$);else if($ instanceof M.$RK)D=$;else throw new Error("Unrecognized location");this.l(D,y,!1)}insert($,y){this.k(),this.l(new M.$RK($,$),y,!0)}delete($){this.k();let y=null;if($ instanceof M.$RK)y=$;else throw new Error("Unrecognized location");this.l(y,null,!0)}l($,y,D){const u=this.c.validateRange($);this.g.push({range:u,text:y,forceMoveMarkers:D})}setEndOfLine($){if(this.k(),$!==M.EndOfLine.LF&&$!==M.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=$}}class w{constructor($,y,D,u){this.c=$,this.d=y,this._accept(D),this.e=u;const g=this;this.value={get tabSize(){return g.f},set tabSize(o){g.m(o)},get indentSize(){return g.g},set indentSize(o){g.o(o)},get insertSpaces(){return g.h},set insertSpaces(o){g.q(o)},get cursorStyle(){return g.j},set cursorStyle(o){g.s(o)},get lineNumbers(){return g.k},set lineNumbers(o){g.t(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.insertSpaces,this.j=$.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to($.lineNumbers)}l($){if($==="auto")return"auto";if(typeof $=="number"){const y=Math.floor($);return y>0?y:null}if(typeof $=="string"){const y=parseInt($,10);return isNaN(y)?null:y>0?y:null}return null}m($){const y=this.l($);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const y=Math.floor($);return y>0?y:null}if(typeof $=="string"){const y=parseInt($,10);return isNaN(y)?null:y>0?y:null}return null}o($){const y=this.n($);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p($){return $==="auto"?"auto":$==="false"?!1:!!$}q($){const y=this.p($);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s($){this.j!==$&&(this.j=$,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}t($){this.k!==$&&(this.k=$,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from($)})))}assign($){const y={};let D=!1;if(typeof $.tabSize<"u"){const u=this.l($.tabSize);u==="auto"?(D=!0,y.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,D=!0,y.tabSize=u)}if(typeof $.indentSize<"u"){const u=this.n($.indentSize);u==="tabSize"?(D=!0,y.indentSize=u):typeof u=="number"&&this.g!==u&&(this.g=u,D=!0,y.indentSize=u)}if(typeof $.insertSpaces<"u"){const u=this.p($.insertSpaces);u==="auto"?(D=!0,y.insertSpaces=u):this.h!==u&&(this.h=u,D=!0,y.insertSpaces=u)}typeof $.cursorStyle<"u"&&this.j!==$.cursorStyle&&(this.j=$.cursorStyle,D=!0,y.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.k!==$.lineNumbers&&(this.k=$.lineNumbers,D=!0,y.lineNumbers=A.TextEditorLineNumbersStyle.from($.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u($,y){y.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(D)})}}e.$ZM=w;class L{constructor($,y,D,u,g,o,n,i){this.id=$,this.j=y,this.k=D,this.g=!1,this.h=new Set,this.c=g,this.d=new w(this.j,this.id,o,D),this.e=n,this.f=i;const s=this;this.value=Object.freeze({get document(){return u.value},set document(a){throw new F.$9("document")},get selection(){return s.c&&s.c[0]},set selection(a){if(!(a instanceof M.$SK))throw(0,F.$7)("selection");s.c=[a],s.l()},get selections(){return s.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof M.$SK)))throw(0,F.$7)("selections");s.c=a,s.l()},get visibleRanges(){return s.e},set visibleRanges(a){throw new F.$9("visibleRanges")},get options(){return s.d.value},set options(a){s.g||s.d.assign(a)},get viewColumn(){return s.f},set viewColumn(a){throw new F.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new m(u.value,t);return a(r),s.m(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=s.c.map(l=>A.Range.from(l));else if(t instanceof M.$QK){const{lineNumber:l,column:h}=A.Position.from(t);d=[{startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h}]}else if(t instanceof M.$RK)d=[A.Range.from(t)];else{d=[];for(const l of t)if(l instanceof M.$RK)d.push(A.Range.from(l));else{const{lineNumber:h,column:c}=A.Position.from(l);d.push({startLineNumber:h,startColumn:c,endLineNumber:h,endColumn:c})}}return y.$tryInsertSnippet($,u.value.version,a.value,d,r)},setDecorations(a,t){const r=t.length===0;r&&!s.h.has(a.key)||(r?s.h.delete(a.key):s.h.add(a.key),s.n(()=>{if(A.$OM(t))return y.$trySetDecorations($,a.key,A.$PM(t));{const d=new Array(4*t.length);for(let l=0,h=t.length;l<h;l++){const c=t[l];d[4*l]=c.start.line+1,d[4*l+1]=c.start.character+1,d[4*l+2]=c.end.line+1,d[4*l+3]=c.end.character+1}return y.$trySetDecorationsFast($,a.key,d)}}))},revealRange(a,t){s.n(()=>y.$tryRevealRange($,A.Range.from(a),t||M.TextEditorRevealType.Default))},show(a){y.$tryShowEditor($,A.ViewColumn.from(a))},hide(){y.$tryHideEditor($)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions($){(0,E.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,E.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,E.ok)(!this.g),this.f=$}_acceptSelections($){(0,E.ok)(!this.g),this.c=$}async l(){const $=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const y=$.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const D=y.edits.map(g=>g.range);D.sort((g,o)=>g.end.line===o.end.line?g.end.character===o.end.character?g.start.line===o.start.line?g.start.character-o.start.character:g.start.line-o.start.line:g.end.character-o.end.character:g.end.line-o.end.line);for(let g=0,o=D.length-1;g<o;g++){const n=D[g].end;if(D[g+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=y.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,u,{setEndOfLine:typeof y.setEndOfLine=="number"?A.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$1M=L}),define(Se[298],ke([1,0,220,23,2,4,3,278,10,7,18,19,15,79,21,187,25]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;function o(s,a){if((0,L.$Ef)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class n extends M.$Sc{constructor(a,t,r){super(),this.f=a,this.g=t,this.h=r,this.a=new Map,this.b=new u.$d8;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(h=>d(h)?this.r(h):h):l})}registerTreeDataProvider(a,t,r){const d=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>d.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],h=!!t.dragAndDropController?.handleDrag,c=!!t.dragAndDropController?.handleDrop,v=this.m(a,t,r),P={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:h,hasHandleDrop:c,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},S=this.f.$registerTreeViewDataProvider(a,P),p={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,g.$lF)(r,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,g.$lF)(r,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(k){(0,y.$fk)(k)&&(0,g.$lF)(r,"treeViewMarkdownMessage"),v.message=k},get title(){return v.title},set title(k){v.title=k},get description(){return v.description},set description(k){v.description=k},get badge(){return v.badge},set badge(k){k!==void 0&&w.ViewBadge.isViewBadge(k)?v.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(v.badge=void 0)},reveal:(k,C)=>v.reveal(k,C),dispose:async()=>{await S,this.a.delete(a),v.dispose()}};return this.B(p),p}$getChildren(a,t){const r=this.a.get(a);return r?r.getChildren(t):Promise.reject(new b.$VE(a))}async $handleDrop(a,t,r,d,l,h,c,v){const P=this.a.get(a);if(!P)return Promise.reject(new b.$VE(a));const S=$.DataTransfer.toDataTransfer(r,async p=>(await this.f.$resolveDropFileData(a,t,p)).buffer);return c===a&&v&&await this.j(S,P,v,l,h),P.onDrop(S,d,l)}async j(a,t,r,d,l){const h=this.b.removeDragOperationTransfer(l);if(h)(await h)?.forEach((c,v)=>{c&&a.set(v,c)});else if(l&&t.handleDrag){const c=t.handleDrag(r,a,d);this.b.addDragOperationTransfer(l,c),await c}return a}async $handleDrag(a,t,r,d){const l=this.a.get(a);if(!l)return Promise.reject(new b.$VE(a));const h=await this.j(new w.$HL,l,t,d,r);if(!(!h||d.isCancellationRequested))return $.DataTransfer.from(h)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new b.$VE(a);return t.hasResolve}$resolve(a,t,r){const d=this.a.get(a);if(!d)throw new b.$VE(a);return d.resolveTreeItem(t,r)}$setExpanded(a,t,r){const d=this.a.get(a);if(!d)throw new b.$VE(a);d.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const d=this.a.get(a);if(!d)throw new b.$VE(a);d.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.a.get(a);if(!r){if(!t)return;throw new b.$VE(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.a.get(a);if(!r)throw new b.$VE(a);r.setCheckboxState(t)}m(a,t,r){const d=this.B(new i(a,t,this.f,this.g.converter,this.h,r));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$bhc=n;class i extends M.$Sc{get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.$Nf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,r,d,l,h){if(super(),this.I=a,this.J=r,this.L=d,this.M=l,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new D.$3d,h.contributes&&h.contributes.views)for(const S in h.contributes.views)for(const p of h.contributes.views[S])p.id===a&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(S=>this.F.fire({message:!1,element:S})));let c,v;const P=A.Event.debounce(this.F.event,(S,p)=>(S||(S={message:!1,elements:[]}),p.element!==!1&&(c||(c=new Promise(k=>v=k),this.G=this.G.then(()=>c)),Array.isArray(p.element)?S.elements.push(...p.element):S.elements.push(p.element)),p.message&&(S.message=!0),S),200,!0);this.B(P(({message:S,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const k=v;return c=null,this.$(p).then(()=>k())})),S&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.X(a);return r||(r=await this.Y(t)),r?r.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,L.$Nf)(t.select)?!0:t.select,d=(0,L.$Nf)(t.focus)?!1:t.focus,l=(0,L.$Nf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(h=>this.W(a,h[h.length-1]).then(c=>this.J.$reveal(this.I,{item:c.item,parentChain:h.map(v=>v.item)},{select:r,focus:d,expand:l})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:r,focus:d,expand:l})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=$.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,I.$ub)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:r.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const d=[];for(const l of a){const h=this.getExtensionElement(l);h&&d.push(h)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,r){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,m.$Ug)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(a);if(r){const d=this.m.get(r);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,r,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$Ug)(()=>this.f.getParent(a))}W(a,t){const r=this.m.get(a);return r?Promise.resolve(r):(0,m.$Ug)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const h=this.m.get(l);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.m.get(r):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new D.$3d(this.Z.token);try{const r=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,I.$Hb)(d||[]).map(async h=>{const c=await this.f.getTreeItem(h);return c&&!t.token.isCancellationRequested?this.db(h,c,r):null}));return t.token.isCancellationRequested?void 0:(0,I.$Hb)(l)}finally{t.dispose()}}$(a){if(a.some(r=>!r))return this.Z.dispose(!0),this.Z=new D.$3d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(a);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(a){const t=new Set,r=a.map(l=>this.m.get(l));for(const l of r)if(l&&!t.has(l.item.handle)){let h=l;for(;h&&h.parent&&r.findIndex(c=>h&&h.parent&&c&&c.item.handle===h.parent.item.handle)===-1;){const c=this.j.get(h.parent.item.handle);h=c?this.m.get(c):void 0}h&&!h.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const h=this.j.get(l);if(h){const c=this.m.get(h);c&&(!c.parent||!t.has(c.parent.item.handle))&&d.push(l)}}),d}bb(a){const t={};return Promise.all(a.map(r=>this.cb(r).then(d=>{d&&(t[r]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,m.$Ug)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,r.parent);return this.pb(t,l,r,r.parent),r.dispose(),l}return null})}return Promise.resolve(null)}db(a,t,r){const d=this.ib(a,t,r);if(t.id&&this.j.has(d.item.handle))throw new Error((0,E.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,r),d}eb(a){return w.$eL.isMarkdownString(a)?$.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,r,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===w.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}hb(a){if(!w.$CL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,r){this.hb(t);const d=this.B(new M.$Rc),l=this.kb(a,t,r),h=this.lb(t);return{item:{handle:l,parentHandle:r?r.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:h,iconDark:this.mb(t)||h,themeIcon:this.jb(t),collapsibleState:(0,L.$Nf)(t.collapsibleState)?w.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof w.$KL?a.iconPath:void 0}kb(a,{id:t,label:r,resourceUri:d},l,h){if(t)return`${i.b}/${t}`;const c=o(r,this.N),v=l?l.item.handle:i.a;let P=c?c.label:d?(0,F.$Ag)(d):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const S=this.m.has(a)?this.m.get(a).item.handle:void 0,p=this.X(l)||[];let k,C=0;do{if(k=`${v}/${C}:${P}`,h||!this.j.has(k)||S===k)break;C++}while(C<=p.length);return k}lb(a){if(a.iconPath&&!(a.iconPath instanceof w.$KL))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof w.$KL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return f.URI.isUri(a)?a:f.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,r,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(a,t);const l=this.X(d)||[],h=l.filter(c=>c.item.handle===r.item.handle)[0];h&&l.splice(l.indexOf(h),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}i.a="0",i.b="1"}),define(Se[299],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[300],ke([1,0,234,8,40,135,108,37,26,299,137,138]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=void 0;const $=b.$un.as(M.$vn.JSONContribution);class y{constructor(a,t,r){this.a=a,this.b=t,this.c=r}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(f.default.Error,a)}warn(a){this.d(f.default.Warning,a)}info(a){this.d(f.default.Info,a)}}e.$_E=y;class D{static a(a){const t=new m.$im;for(let r=0,d=a.length;r<d;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new D(t,[]);if(!t||!t.length)return new D([],a);const r=this.a(a),d=this.a(t),l=t.filter(c=>!r.has(c.description.identifier)),h=a.filter(c=>!d.has(c.description.identifier));return new D(l,h)}constructor(a,t){this.added=a,this.removed=t}}e.$aF=D;class u{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=D.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,F.$1)(a)}}}e.$bF=u;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$cF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$gm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$_n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$_n}},extensionKind:{description:E.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new u(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&I.$3E.register(a.extensionPoint,a.activationEventsGenerator),e.$cF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,$.registerSchema(o,e.$cF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$dF=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$un.add(i.ExtensionsRegistry,new n),e.$eF=b.$un.as(i.ExtensionsRegistry),$.registerSchema(o,e.$cF),$.registerSchema(L.$Cj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Se[301],ke([1,0,230,18,24,300,46,4]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gG=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var w;(function($){function y(D,u,g){if(!D)return;const o=F.$Ef(D.type)?D.type:void 0;if(!o||o.length===0){g.error(E.localize(3,null));return}const n=[];if(Array.isArray(D.required))for(const i of D.required)F.$Ef(i)&&n.push(i);return{extensionId:u.value,taskType:o,required:n,properties:D.properties?f.$in(D.properties):{},when:D.when?M.$Zi.deserialize(D.when):void 0}}$.from=y})(w||(w={}));const L=A.$eF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,y)=>{for(const D of $)D.type&&y.push(`onTaskType:${D.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:m}});class I{constructor(){this.d=new b.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,D)=>{L.setHandler((u,g)=>{this.c=void 0;try{for(const o of g.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of g.added){const n=o.value;for(const i of n){const s=w.from(i,o.description.identifier,o.collector);s&&(this.a[s.taskType]=s)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const D of this.all()){const u={type:"object",additionalProperties:!1};D.required.length>0&&(u.required=D.required.slice(0)),D.properties!==void 0?u.properties=f.$in(D.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[D.taskType]},y.push(u)}this.c={oneOf:y}}return this.c}}e.$gG=new I}),define(Se[302],ke([1,0,231,18,23,24,46,301]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$qG=e.JsonSchemaVersion=e.ExecutionEngine=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$kG=e.ShellQuoting=e.$jG=e.$iG=e.$hG=void 0,e.$hG="settings",e.$iG=new M.$gj("taskRunning",!1,E.localize(0,null)),e.$jG={value:E.localize(1,null),original:"Tasks"};var m;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$kG="$customized",function(N){function R(T){if(!T)return N.Strong;switch(T.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=R}(m||(e.ShellQuoting=m={}));var w;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var L;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(L||(e.RevealKind=L={})),function(N){function R(T){switch(T.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=R}(L||(e.RevealKind=L={}));var I;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(N){function R(T){switch(T.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=R}(I||(e.RevealProblemKind=I={}));var $;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})($||(e.PanelKind=$={})),function(N){function R(T){switch(T.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=R}($||(e.PanelKind=$={}));var y;(function(N){N.defaults={echo:!0,reveal:L.Always,revealProblems:I.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var D;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(N){function R(q){switch(q.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=R;function T(q){switch(q){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=T}(D||(e.RuntimeType=D={}));var u;(function(N){function R(T){return F.$Ef(T)?T:T.value}N.value=R})(u||(e.CommandString=u={}));var g;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function R(q){return q===N.Clean._id||q===N.Build._id||q===N.Rebuild._id||q===N.Test._id}N.is=R;function T(q){if(q!==void 0)return F.$Ef(q)?R(q)?{_id:q,isDefault:!1}:void 0:q}N.from=T})(g||(e.TaskGroup=g={}));var o;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function R(T){switch(T){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=R})(n||(e.TaskSourceKind=n={}));var i;(function(N){N.parallel="parallel",N.sequence="sequence"})(i||(e.DependsOrder=i={}));var s;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(s||(e.RunOnOptions=s={}));var a;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:s.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(R,T,q,ee,J,K){this._label="",this._id=R,T&&(this._label=T),q&&(this.type=q),this.runOptions=ee,this.configurationProperties=J,this._source=K}getDefinition(R){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const R={folder:this.d(),id:this._id};return JSON.stringify(R)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(R,T=!1){if(R===void 0)return!1;if(F.$Ef(R))return R===this._label||R===this.configurationProperties.identifier||T&&R===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===R._key}getQualifiedLabel(){const R=this.getWorkspaceFolder();return R?`${this._label} (${R.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(R){this.c===void 0&&(this.c=[]),R&&(this.c=this.c.concat(R))}get taskLoadMessages(){return this.c}}e.$lG=t;class r extends t{constructor(R,T,q,ee,J,K,Z,ae){super(R,q,void 0,Z,ae,T),this.command={},this._source=T,this.hasDefinedMatchers=K,J&&(this.command=J)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(R=!1){if(R&&this._source.customizes!==void 0)return this._source.customizes;{let T;switch(this.command?this.command.runtime:void 0){case D.Shell:T="shell";break;case D.Process:T="process";break;case D.CustomExecution:T="customExecution";break;case void 0:T="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:T,_key:this._id,id:this._id}}}static is(R){return R instanceof r}getMapKey(){const R=this._source.config.workspaceFolder;return R?`${R.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$hG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const R=this.d();if(!R)return;let T=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(T+=this._source.kind);const q={type:e.$kG,folder:R,id:T};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Ag(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(R){return new r(R._id,R._source,R._label,R.type,R.command,R.hasDefinedMatchers,R.runOptions,R.configurationProperties)}}e.$mG=r;class d extends t{constructor(R,T,q,ee,J,K,Z){super(R,q,ee,K,Z,T),this._source=T,this.configures=J}static is(R){return R instanceof d}f(R){return R}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Ag(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$hG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const R=this.d();if(!R)return;let T=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(T+=this._source.kind);const q={type:e.$kG,folder:R,id:T};return JSON.stringify(q)}}e.$nG=d;class l extends t{constructor(R,T,q,ee,J,K,Z,ae,_){super(R,q,ee,ae,_,T),this.defines=J,this.hasDefinedMatchers=Z,this.command=K,this.icon=_.icon,this.hide=_.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(R){return R instanceof l}getMapKey(){const R=this._source.workspaceFolder;return R?`${this._source.scope.toString()}|${R.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const R={type:"contributed",scope:this._source.scope,id:this._id};return R.folder=this.d(),JSON.stringify(R)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(R){return new l(R._id,R._source,R._label,R.type,R.defines,R.command,R.hasDefinedMatchers,R.runOptions,R.configurationProperties)}}e.$oG=l;class h extends t{constructor(R,T,q,ee,J,K){super(R,q,ee,J,K,T),this._source=T}clone(){return new h(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(R){return R instanceof h}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(R){return new h(R._id,R._source,R._label,R.type,R.runOptions,R.configurationProperties)}}e.$pG=h;var c;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(c||(e.ExecutionEngine=c={})),function(N){N._default=N.Terminal}(c||(e.ExecutionEngine=c={}));var v;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class P{constructor(R){this.c=new Map;for(let T=0;T<R.length;T++)this.c.set(R[T].uri.toString(),T)}compare(R,T){const q=R.getWorkspaceFolder(),ee=T.getWorkspaceFolder();if(q&&ee){let J=this.c.get(q.uri.toString());J=J===void 0?0:J+1;let K=this.c.get(ee.uri.toString());return K=K===void 0?0:K+1,J===K?R._label.localeCompare(T._label):J-K}else return!q&&ee?-1:q&&!ee?1:0}}e.$qG=P;var S;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(S||(e.TaskEventKind=S={}));var p;(function(N){N.SingleRun="singleRun",N.Background="background"})(p||(e.TaskRunType=p={}));var k;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var C;(function(N){function R(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function T(ae,_,ye){return{...R(ae),kind:"start",terminalId:_,resolvedVariables:ye}}N.start=T;function q(ae,_,ye){return{...R(ae),kind:"processStarted",terminalId:_,processId:ye}}N.processStarted=q;function ee(ae,_,ye){return{...R(ae),kind:"processEnded",terminalId:_,exitCode:ye}}N.processEnded=ee;function J(ae,_,ye){return{...R(ae),kind:"terminated",exitReason:ye,terminalId:_}}N.terminated=J;function K(ae,_,ye){return{...R(_),kind:ae,terminalId:ye}}N.general=K;function Z(){return{kind:"changed"}}N.changed=Z})(C||(e.TaskEvent=C={}));var j;(function(N){function R(q){const ee=Object.keys(q).sort();let J="";for(const K of ee){let Z=q[K];Z instanceof Object?Z=R(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),J+=K+","+Z+","}return J}function T(q){const J={_key:R(q),type:q.taskType};return Object.assign(J,q),J}N.create=T})(j||(e.KeyedTaskIdentifier=j={}));var z;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var O;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(O||(e.TasksSchemaProperties=O={}));var U;(function(N){function R(T,q){const ee=b.$gG.get(T.type);if(ee===void 0){const ae=A.$in(T);return delete ae._key,j.create(ae)}const J=Object.create(null);J.type=ee.taskType;const K=new Set;ee.required.forEach(ae=>K.add(ae));const Z=ee.properties;for(const ae of Object.keys(Z)){const _=T[ae];if(_!=null)J[ae]=_;else if(K.has(ae)){const ye=Z[ae];if(ye.default!==void 0)J[ae]=A.$in(ye.default);else switch(ye.type){case"boolean":J[ae]=!1;break;case"number":case"integer":J[ae]=0;break;case"string":J[ae]="";break;default:q.error(E.localize(2,null,JSON.stringify(T,void 0,0),ae));return}}}return j.create(J)}N.createTaskIdentifier=R})(U||(e.TaskDefinition=U={}))}),define(Se[303],ke([1,0,8]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=e.$s7b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,E.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$s7b=F;class f extends F{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$t7b=f}),define(Se[68],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=e.$Cv=void 0;class E{constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++E.count}}e.$Cv=E,E.count=0;const F=[];function f(b){const m=new E(b);return F[m.nid]=m,m}e.$Dv=f;function A(b){return F[b].sid}e.$Ev=A;class M{constructor(m){this.value=m}}e.$Fv=M}),define(Se[6],ke([1,0,68]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$MK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var f;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput",u[u.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var A;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var M;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var m;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var w;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var L;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class I{static mixin(g){return g._id=I.a++,g}}e.$MK=I,I.a=0;var $;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var y;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var D;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$NK={MainThreadAuthentication:(0,E.$Dv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Dv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Dv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Dv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Dv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Dv)("MainThreadClipboard"),MainThreadCommands:(0,E.$Dv)("MainThreadCommands"),MainThreadComments:(0,E.$Dv)("MainThreadComments"),MainThreadConfiguration:(0,E.$Dv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Dv)("MainThreadConsole"),MainThreadDebugService:(0,E.$Dv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Dv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Dv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Dv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Dv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Dv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Dv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Dv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Dv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Dv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Dv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Dv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Dv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Dv)("MainThreadLanguages"),MainThreadLogger:(0,E.$Dv)("MainThreadLogger"),MainThreadMessageService:(0,E.$Dv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Dv)("MainThreadOutputService"),MainThreadProgress:(0,E.$Dv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Dv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Dv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Dv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Dv)("MainThreadSecretState"),MainThreadStorage:(0,E.$Dv)("MainThreadStorage"),MainThreadSpeech:(0,E.$Dv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Dv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Dv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Dv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Dv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Dv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Dv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Dv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Dv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Dv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Dv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Dv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Dv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Dv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Dv)("MainThreadSCM"),MainThreadSearch:(0,E.$Dv)("MainThreadSearch"),MainThreadShare:(0,E.$Dv)("MainThreadShare"),MainThreadTask:(0,E.$Dv)("MainThreadTask"),MainThreadWindow:(0,E.$Dv)("MainThreadWindow"),MainThreadLabelService:(0,E.$Dv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Dv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Dv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Dv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Dv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Dv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Dv)("MainThreadInteractive"),MainThreadChat:(0,E.$Dv)("MainThreadChat"),MainThreadInlineChat:(0,E.$Dv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Dv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Dv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Dv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Dv)("MainThreadTimeline"),MainThreadTesting:(0,E.$Dv)("MainThreadTesting"),MainThreadLocalization:(0,E.$Dv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Dv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Dv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Dv)("MainThreadIssueReporter")},e.$OK={ExtHostCommands:(0,E.$Dv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Dv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Dv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Dv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Dv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Dv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Dv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Dv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Dv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Dv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Dv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Dv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Dv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Dv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Dv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Dv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Dv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Dv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Dv)("ExtHostStatusBar"),ExtHostShare:(0,E.$Dv)("ExtHostShare"),ExtHostExtensionService:(0,E.$Dv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Dv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Dv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Dv)("ExtHostSCM"),ExtHostSearch:(0,E.$Dv)("ExtHostSearch"),ExtHostTask:(0,E.$Dv)("ExtHostTask"),ExtHostWorkspace:(0,E.$Dv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Dv)("ExtHostWindow"),ExtHostWebviews:(0,E.$Dv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Dv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Dv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Dv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Dv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Dv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Dv)("ExtHostProgress"),ExtHostComments:(0,E.$Dv)("ExtHostComments"),ExtHostSecretState:(0,E.$Dv)("ExtHostSecretState"),ExtHostStorage:(0,E.$Dv)("ExtHostStorage"),ExtHostUrls:(0,E.$Dv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Dv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Dv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Dv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$Dv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Dv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Dv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Dv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Dv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Dv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Dv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Dv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Dv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Dv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Dv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Dv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Dv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Dv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Dv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Dv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Dv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Dv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Dv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Dv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Dv)("ExtHostTimeline"),ExtHostTesting:(0,E.$Dv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Dv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Dv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Dv)("ExtHostIssueReporter")}}),define(Se[304],ke([1,0,6,7]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class f{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(E.$NK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,m){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(M);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(b,m)??[]}getRelatedInformation(M,b,m){return this.c.$getAiRelatedInformation(b,m)}registerRelatedInformationProvider(M,b,m){const w=this.b;return this.b++,this.a.set(w,m),this.c.$registerAiRelatedInformationProvider(w,b),new F.$PK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$bfc=f}),define(Se[91],ke([1,0,5,14,6,20]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=e.$hfc=void 0,e.$hfc=(0,E.$2h)("IExtHostApiDeprecationService");let M=class{constructor(m,w){this.c=w,this.a=new Set,this.b=m.getProxy(f.$NK.MainThreadTelemetry)}report(m,w,L){const I=this.d(m,w);this.a.has(I)||(this.a.add(I),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:m}))}d(m,w){return`${m}-${w.identifier.value}`}};e.$ifc=M,e.$ifc=M=Qe([qe(0,A.$RM),qe(1,F.$jj)],M),e.$jfc=Object.freeze(new class{report(b,m,w){}})}),define(Se[305],ke([1,0,4,6,7,26]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class M{constructor(w){this.b=new Map,this.c=[],this.d=new E.$Sd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=w.getProxy(F.$NK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,L,I,$={}){const y=A.$hm.toKey(w.identifier),D=[...I].sort().join(" ");return await this.f.getOrCreate(`${y} ${L} ${D}`,async()=>{await this.a.$ensureProvider(L);const u=w.displayName||w.name;return this.a.$getSession(L,I,y,u,$)})}async getSessions(w,L,I){const $=A.$hm.toKey(w.identifier),y=[...I].sort().join(" ");return await this.g.getOrCreate(`${$} ${y}`,async()=>{await this.a.$ensureProvider(L);const D=w.displayName||w.name;return this.a.$getSessions(L,I,$,D)})}async removeSession(w,L){const I=this.b.get(w);return I?I.provider.removeSession(L):this.a.$removeSession(w,L)}registerAuthenticationProvider(w,L,I,$){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:L,provider:I,options:$??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===w)||this.c.push({id:w,label:L});const y=I.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(w,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(w,L,$?.supportsMultipleAccounts??!1),new f.$PK(()=>{y.dispose(),this.b.delete(w);const D=this.c.findIndex(u=>u.id===w);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,L,I){const $=this.b.get(w);if($)return Promise.resolve($.provider.createSession(L,I));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,L){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,L){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,L){return this.d.fire({provider:{id:w,label:L}}),Promise.resolve()}}e.$mfc=M;class b{constructor(){this.a=new Map}getOrCreate(w,L){const I=this.a.get(w);if(I)return I;const $=L().finally(()=>this.a.delete(w));return this.a.set(w,$),$}}}),define(Se[306],ke([1,0,6,20,15]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;let A=class{constructor(b,m){this.a=b.getProxy(E.$NK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>m.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,m,w){const L=f.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,w?.isRefactoring??!1)}};e.$nfc=A,e.$nfc=A=Qe([qe(0,F.$RM)],A)}),define(Se[307],ke([1,0,4,52,3,6,15]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class b{constructor(L,I){this.extension=L,this.provider=I,this.handle=b.a++}}b.a=0;class m{constructor(L){this.b=new Map,this.c=new Map,this.d=new E.$Sd,this.onDidPerformUserAction=this.d.event,this.e=L.getProxy(A.$NK.MainThreadChat)}registerChatProvider(L,I,$){const y=new b(L,$);return this.b.set(y.handle,y),this.e.$registerChatProvider(y.handle,I),(0,f.$Qc)(()=>{this.e.$unregisterChatProvider(y.handle),this.b.delete(y.handle)})}transferChatSession(L,I){const $=F.Iterable.find(this.c.keys(),y=>this.c.get(y)===L)??0;typeof $=="number"&&this.e.$transferChatSession($,I)}sendInteractiveRequestToProvider(L,I){this.e.$sendRequestToProvider(L,I)}async $prepareChat(L,I){const $=this.b.get(L);if(!$)return;const y=await $.provider.prepareSession(I);if(!y)return;const D=m.a++;return this.c.set(D,y),{id:D,requesterUsername:y.requester?.name,requesterAvatarIconUri:y.requester?.icon,responderUsername:y.responder?.name,responderAvatarIconUri:y.responder?.icon,inputPlaceholder:y.inputPlaceholder}}async $provideWelcomeMessage(L,I){const $=this.b.get(L);if(!$||!$.provider.provideWelcomeMessage)return;const y=await $.provider.provideWelcomeMessage(I);if(y)return y.map(D=>typeof D=="string"?D:Array.isArray(D)?D.map(u=>M.ChatReplyFollowup.from(u)):M.MarkdownString.from(D))}async $provideSampleQuestions(L,I){const $=this.b.get(L);if(!$||!$.provider.provideSampleQuestions)return;const y=await $.provider.provideSampleQuestions(I);if(y)return y?.map(D=>M.ChatReplyFollowup.from(D))}$releaseSession(L){this.c.delete(L)}async $onDidPerformUserAction(L){this.d.fire(L)}}e.$ofc=m,m.a=0}),define(Se[308],ke([1,0,10,21,44,4,39,18,2,210,85,6,15,7,279,25]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class g{constructor(i,s,a){this.i=s,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=i.getProxy(I.$NK.MainThreadChatAgents2)}createChatAgent(i,s,a){const t=g.a++,r=new o(i,s,this.d,t,a);return this.b.set(t,r),this.d.$registerAgent(t,s,{}),r.apiAgent}async $invokeAgent(i,s,a,t,r,d){this.g.delete(s);const l=this.b.get(i);if(!l)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let h=!1;function c(){if(h)throw new Error("Only valid while executing the command")}const v=new E.$mh;d.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),10*1e3),this.i.allowListExtensionWhile(l.extension.identifier,v.p);const P=t.command?await l.validateSlashCommand(t.command):void 0,S=M.$Od.create(!1);let p;try{const k=l.invoke({prompt:t.message,variables:$.ChatVariable.objectTo(t.variables),slashCommand:P},{history:r.history.map($.ChatMessage.to)},new L.$hv(C=>{c(),typeof p>"u"&&"content"in C&&(p=S.elapsed());const j=$.ChatResponseProgress.from(l.extension,C);if(!j){this.j.error("Unknown progress type: "+JSON.stringify(C));return}if("placeholder"in C&&"resolvedContent"in C){const z=Promise.all([this.d.$handleProgressChunk(a,j),C.resolvedContent]);(0,E.$Qg)(z,d).then(O=>{if(!O)return;const[U,N]=O,R=$.ChatResponseProgress.from(l.extension,N);if(!R){this.j.error("Unknown progress type: "+JSON.stringify(N));return}this.d.$handleProgressChunk(a,R,U??void 0)})}else this.d.$handleProgressChunk(a,j)}),d);return await(0,E.$Qg)(Promise.resolve(k).then(C=>{if(C){this.g.set(s,C);let j=this.h.get(s);j||(j=new Map,this.h.set(s,j)),j.set(a,C);const z={firstProgress:p,totalElapsed:S.elapsed()};return{errorDetails:C.errorDetails,timings:z}}else this.g.delete(s)}),d)}catch(k){return this.j.error(k,l.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,f.$Mi)(k)),responseIsIncomplete:!0}}}finally{h=!0,v.complete()}}$releaseSession(i){this.g.delete(i),this.h.delete(i)}async $provideSlashCommands(i,s){const a=this.b.get(i);return a?a.provideSlashCommand(s):[]}$provideFollowups(i,s,a){const t=this.b.get(i);if(!t)return Promise.resolve([]);const r=this.g.get(s);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(i,s,a,t,r){const d=this.b.get(i);if(!d)return;const l=this.h.get(s)?.get(a);if(!l)return;let h;switch(t){case D.InteractiveSessionVoteDirection.Down:h=y.ChatAgentResultFeedbackKind.Unhelpful;break;case D.InteractiveSessionVoteDirection.Up:h=y.ChatAgentResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(r?{result:l,kind:h,reportIssue:r}:{result:l,kind:h}))}$acceptAction(i,s,a,t){const r=this.b.get(i);if(!r)return;const d=this.h.get(s)?.get(a);d&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:d}))}async $invokeCompletionProvider(i,s,a){const t=this.b.get(i);return t?(await t.invokeCompletionProvider(s,a)).map($.ChatAgentCompletionItem.from):[]}}e.$qfc=g,g.a=0;class o{constructor(i,s,a,t,r){this.extension=i,this.t=s,this.u=a,this.w=t,this.x=r,this.o=new A.$Sd,this.q=new A.$Sd}acceptFeedback(i){this.o.fire(i)}acceptAction(i){this.q.fire(i)}async invokeCompletionProvider(i,s){return this.s?await this.s.provider.provideCompletionItems(i,s)??[]:[]}async validateSlashCommand(i){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,b.$Of)(this.b));const s=this.b.find(a=>a.name===i);if(!s)throw new Error(`Unknown slashCommand: ${i}`);return s}async provideSlashCommand(i){if(!this.a)return[];const s=await this.a.provideSlashCommands(i);return s?(this.b=s,s.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(i,s){if(!this.d)return[];const a=await this.d.provideFollowups(i,s);return a?a.map(t=>$.ChatFollowup.from(t)):[]}get apiAgent(){let i=!1,s=!1;const a=()=>{i||s||(s=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof m.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof y.$KL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:$.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:$.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),s=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(r){t.g=r,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,a()},get iconPath(){return t.i},set iconPath(r){t.i=r,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,a()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,a()},get isDefault(){return(0,u.$lF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,u.$lF)(t.extension,"defaultChatAgent"),t.j=r,a()},get helpTextPrefix(){return(0,u.$lF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(r){if((0,u.$lF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=r,a()},get helpTextPostfix(){return(0,u.$lF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(r){if((0,u.$lF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=r,a()},get isSecondary(){return(0,u.$lF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(r){(0,u.$lF)(t.extension,"defaultChatAgent"),t.n=r,a()},get sampleRequest(){return t.m},set sampleRequest(r){t.m=r,a()},get supportIssueReporting(){return(0,u.$lF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(r){(0,u.$lF)(t.extension,"chatAgents2Additions"),t.r=r,a()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(r){if(t.s=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,r.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,u.$kF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){i=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(i,s,a,t){return this.x(i,s,a,t)}}}),define(Se[309],ke([1,0,21,3,6,15,85,26,10,4]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class L{constructor(D,u){this.stream=new m.$sh,this.stream=u??new m.$sh;const g=this;this.apiObj={option:D,response:g.stream.asyncIterable}}}class I{constructor(D,u){this.a=new w.$Sd,this.b=new Map,this.c=new m.$sh,this.d=!1;const g=this;this.apiObject={result:D,response:g.c.asyncIterable,onDidStartResponseStream:g.a.event,cancel(){u.cancel()}},D.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(D){if(this.d)return;let u=this.b.get(D.index);u||(this.b.size===0?u=new L(D.index,this.c):u=new L(D.index),this.b.set(D.index,u),this.a.fire(u.apiObj)),u.stream.emitOne(D.part)}}class ${constructor(D,u){this.d=u,this.c=new Map,this.e=new Map,this.f=new b.$jm,this.b=D.getProxy(f.$NK.MainThreadChatProvider)}registerProvider(D,u,g,o){const n=$.a++;return this.c.set(n,{extension:D,provider:g}),this.b.$registerProvider(n,u,{extension:D,model:o.name??""}),(0,F.$Qc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(D,u,g,o,n){const i=this.c.get(D);if(!i)return;const s=new M.$hv(async a=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${i.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(u,{index:a.index,part:a.part})});return i.provider.provideChatResponse(g.map(A.ChatMessage.to),o,s,n)}allowListExtensionWhile(D,u){this.f.set(D,u),u.finally(()=>this.f.delete(D))}async requestChatResponseProvider(D,u){if(!this.f.has(D))throw new Error("Extension is NOT allowed to make chat requests");const g=await this.b.$prepareChatAccess(u);if(!g)throw new Error(`ChatAccess '${u}' NOT found`);const o=this;return{get model(){return g.model},get isRevoked(){return!o.f.has(D)},makeRequest(n,i,s){if(!o.f.has(D))throw new Error("Access to chat has been revoked");const a=new E.$3d(s),t=Math.random()*1e6|0,r=o.b.$fetchResponse(D,u,t,n.map(A.ChatMessage.from),i??{},a.token),d=new I(r,a);return o.e.set(t,{res:d}),r.finally(()=>{o.e.delete(t)}),d.apiObject}}}async $handleResponseFragment(D,u){const g=this.e.get(D);g&&g.res.handleFragment(u)}}e.$pfc=$,$.a=1}),define(Se[310],ke([1,0,3,6,8,15]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class M{constructor(m){this.b=new Map,this.c=m.getProxy(F.$NK.MainThreadChatVariables)}async $resolveVariable(m,w,L){const I=this.b.get(m);if(I)try{const $=await I.resolver.resolve(I.data.name,{message:w},L);if($)return $.map(A.ChatVariable.from)}catch($){(0,f.$2)($)}}registerVariableResolver(m,w,L,I){const $=M.a++;return this.b.set($,{extension:m.identifier,data:{name:w,description:L},resolver:I}),this.c.$registerVariable($,{name:w,description:L}),(0,E.$Qc)(()=>{this.b.delete($),this.c.$unregisterVariable($)})}}e.$rfc=M,M.a=0}),define(Se[311],ke([1,0,6]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class F{constructor(A){const M=A.getProxy(E.$NK.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$sfc=F});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[35],ke([1,0,18,7,15,24,6,19,14,54,29,51,2,3,5,20,148,22,68,44,39,87,90,30]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a,t,r){"use strict";var d,l,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=void 0;let c=class{constructor(C,j,z){d.set(this,void 0),this.b=new Map,this.c=new Map,l.set(this,void 0),h.set(this,void 0),nt(this,d,C.getProxy(M.$NK.MainThreadCommands),"f"),this.d=j,nt(this,h,z,"f"),nt(this,l,C.getProxy(M.$NK.MainThreadTelemetry),"f"),this.converter=new v(this,O=>{const U=this.c.get(O);return U?.result===S.Void?U:void 0},j),this.f=[{processArgument(O){return(0,w.$yh)(O)}},{processArgument(O){return(0,A.$kn)(O,function(U){if(L.$Hs.isIRange(U))return f.Range.to(U);if(I.$Gs.isIPosition(U))return f.Position.to(U);if(L.$Hs.isIRange(U.range)&&$.URI.isUri(U.uri))return f.location.to(U);if(U instanceof o.$ge)return U.buffer.buffer;if(!Array.isArray(U))return U})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const j=this.registerCommand(!1,C.id,async(...z)=>{const O=C.args.map((N,R)=>{if(!N.validate(z[R]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof z[R]=="object"?JSON.stringify(z[R],null,"	"):z[R]} `);return N.convert(z[R])}),U=await this.executeCommand(C.internalId,...O);return C.result.convert(U,z,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new F.$PK(()=>{j.dispose(),this.c.delete(C.id)})}registerCommand(C,j,z,O,U,N){if(this.d.trace("ExtHostCommands#registerCommand",j),!j.trim().length)throw new Error("invalid id");if(this.b.has(j))throw new Error(`command '${j}' already exists`);return this.b.set(j,{callback:z,thisArg:O,metadata:U,extension:N}),C&&We(this,d,"f").$registerCommand(j),new F.$PK(()=>{this.b.delete(j)&&C&&We(this,d,"f").$unregisterCommand(j)})}executeCommand(C,...j){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,j,!0)}async g(C,j,z){if(this.b.has(C))return We(this,d,"f").$fireCommandActivationEvent(C),this.h(C,j,!1);{let O=!1;const U=(0,A.$kn)(j,function(N){if(N instanceof F.$QK)return f.Position.from(N);if(N instanceof F.$RK)return f.Range.from(N);if(N instanceof F.$2K)return f.location.from(N);if(F.$bM.isNotebookRange(N))return f.NotebookRange.from(N);if(N instanceof ArrayBuffer)return O=!0,o.$ge.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return O=!0,o.$ge.wrap(N);if(N instanceof o.$ge)return O=!0,N;if(!Array.isArray(N))return N});try{const N=await We(this,d,"f").$executeCommand(C,O?new n.$Fv(U):U,z);return(0,w.$yh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,j,!1);throw N}}}async h(C,j,z){const O=this.b.get(C);if(!O)throw new Error("Unknown command");const{callback:U,thisArg:N,metadata:R}=O;if(R?.args)for(let q=0;q<R.args.length;q++)try{(0,E.$Vf)(j[q],R.args[q].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${R.args[q].name}' - ${R.args[q].description}`)}const T=s.$Od.create();try{return await U.apply(N,j)}catch(q){if(C===this.converter.delegatingCommandId){const ee=this.converter.getActualCommand(...j);ee&&(C=ee.command)}if(this.d.error(q,C,O.extension?.identifier),!z)throw q;if(O.extension?.identifier){const ee=We(this,h,"f").onExtensionError(O.extension.identifier,q);this.d.trace("forwarded error to extension?",ee,O.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$Mi)(q)),this.id=C,this.source=O.extension?.displayName??O.extension?.name}}}finally{this.j(O,C,T.elapsed())}}j(C,j,z){C.extension&&We(this,l,"f").$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new a.$xo(j),duration:z})}$executeContributedCommand(C,...j){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const z=this.b.get(C);return z?(j=j.map(O=>this.f.reduce((U,N)=>N.processArgument(U,z.extension?.identifier),O)),this.h(C,j,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),We(this,d,"f").$getCommands().then(j=>(C&&(j=j.filter(z=>z[0]!=="_")),j))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[j,z]of this.b){const{metadata:O}=z;O&&(C[j]=O)}return Promise.resolve(C)}};e.$aN=c,d=new WeakMap,l=new WeakMap,h=new WeakMap,e.$aN=c=Qe([qe(0,u.$RM),qe(1,m.$jj),qe(2,t.$_M)],c),e.$bN=(0,D.$2h)("IExtHostCommands");class v{constructor(C,j,z){this.d=C,this.f=j,this.g=z,this.delegatingCommandId=`__vsc${(0,r.$mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,j){if(!C)return;const z={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return z;const O=this.f(C.command);if(O)z.id=O.internalId,z.arguments=O.args.map((U,N)=>U.convert(C.arguments&&C.arguments[N]));else if((0,b.$Lb)(C.arguments)){const U=`${C.command} /${++this.c}`;this.b.set(U,C),j.add((0,y.$Qc)(()=>{this.b.delete(U),this.g.trace("CommandsConverter#DISPOSE",U)})),z.$ident=U,z.id=this.delegatingCommandId,z.arguments=[U],this.g.trace("CommandsConverter#CREATE",C.command,U)}return z}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const j=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],j?j.command:"MISSING"),j?this.d.executeCommand(j.command,...j.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$cN=v;class P{static Arr(C){return new P(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,j=>Array.isArray(j)&&j.every(z=>C.validate(z)),j=>j.map(z=>C.convert(z)))}constructor(C,j,z,O){this.name=C,this.description=j,this.validate=z,this.convert=O}optional(){return new P(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,j){return new P(C??this.name,j??this.description,this.validate,this.convert)}}e.$dN=P,P.Uri=new P("uri","Uri of a text document",k=>$.URI.isUri(k),k=>k),P.Position=new P("position","A position in a text document",k=>F.$QK.isPosition(k),f.Position.from),P.Range=new P("range","A range in a text document",k=>F.$RK.isRange(k),f.Range.from),P.Selection=new P("selection","A selection in a text document",k=>F.$SK.isSelection(k),f.Selection.from),P.Number=new P("number","",k=>typeof k=="number",k=>k),P.String=new P("string","",k=>typeof k=="string",k=>k),P.StringArray=P.Arr(P.String),P.CallHierarchyItem=new P("item","A call hierarchy item",k=>k instanceof F.$aL,f.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",k=>k instanceof F.$uM,f.TypeHierarchyItem.from),P.TestItem=new P("testItem","A VS Code TestItem",k=>k instanceof g.$5M,f.TestItem.from);class S{constructor(C,j){this.description=C,this.convert=j}}e.$eN=S,S.Void=new S("no result",k=>k);class p{constructor(C,j,z,O,U){this.id=C,this.internalId=j,this.description=z,this.args=O,this.result=U}}e.$fN=p}),define(Se[312],ke([1,0,19,17,2,83,132,46,35,15,7]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;const I=[new m.$fN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to an array of DocumentHighlight-instances.",y(w.DocumentHighlight.to))),new m.$fN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$dN.Uri],new m.$eN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,g)=>{if((0,E.$Kb)(u))return;class o extends L.$8K{static to(i){const s=new o(i.name,w.SymbolKind.to(i.kind),i.containerName||"",new L.$2K(g[0],w.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=w.Range.to(i.selectionRange),s.children=i.children?i.children.map(o.to):[],s}}return u.map(o.to)})),new m.$fN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$dN.Uri,new m.$dN("options","Formatting options",u=>!0,u=>u)],new m.$eN("A promise that resolves to an array of TextEdits.",y(w.TextEdit.to))),new m.$fN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$dN.Uri,m.$dN.Range,new m.$dN("options","Formatting options",u=>!0,u=>u)],new m.$eN("A promise that resolves to an array of TextEdits.",y(w.TextEdit.to))),new m.$fN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$dN.Uri,m.$dN.Position,new m.$dN("ch","Trigger character",u=>typeof u=="string",u=>u),new m.$dN("options","Formatting options",u=>!0,u=>u)],new m.$eN("A promise that resolves to an array of TextEdits.",y(w.TextEdit.to))),new m.$fN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to an array of Location or LocationLink instances.",D)),new m.$fN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to an array of Location or LocationLink instances.",D)),new m.$fN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to an array of Location or LocationLink instances.",D)),new m.$fN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to an array of Location or LocationLink instances.",D)),new m.$fN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to an array of Location-instances.",y(w.location.to))),new m.$fN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to an array of Hover-instances.",y(w.Hover.to))),new m.$fN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$dN.Uri,new m.$dN("position","A position in a text document",u=>Array.isArray(u)&&u.every(g=>L.$QK.isPosition(g)),u=>u.map(w.Position.from))],new m.$eN("A promise that resolves to an array of ranges.",u=>u.map(g=>{let o;for(const n of g.reverse())o=new L.$_K(w.Range.to(n),o);return o}))),new m.$fN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$dN.String.with("query","Search string")],new m.$eN("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(w.WorkspaceSymbol.to))),new m.$fN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(w.CallHierarchyItem.to))),new m.$fN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$dN.CallHierarchyItem],new m.$eN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(w.CallHierarchyIncomingCall.to))),new m.$fN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$dN.CallHierarchyItem],new m.$eN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(w.CallHierarchyOutgoingCall.to))),new m.$fN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:w.Range.to(u.range),placeholder:u.text}})),new m.$fN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$dN.Uri,m.$dN.Position,m.$dN.String.with("newName","The new symbol name")],new m.$eN("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return w.WorkspaceEdit.to(u)}})),new m.$fN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$dN.Uri,m.$dN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$eN("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(w.DocumentLink.to))),new m.$fN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$dN.Uri],new m.$eN("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new L.$6L(u.tokenTypes,u.tokenModifiers)})),new m.$fN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$dN.Uri],new m.$eN("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const g=(0,M.$n$)(u);if(g.type==="full")return new L.$8L(g.data,void 0)})),new m.$fN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$dN.Uri,m.$dN.Range.optional()],new m.$eN("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new L.$6L(u.tokenTypes,u.tokenModifiers)})),new m.$fN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$dN.Uri,m.$dN.Range],new m.$eN("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const g=(0,M.$n$)(u);if(g.type==="full")return new L.$8L(g.data,void 0)})),new m.$fN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$dN.Uri,m.$dN.Position,m.$dN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$dN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$eN("A promise that resolves to a CompletionList-instance.",(u,g,o)=>{if(!u)return new L.$lL([]);const n=u.suggestions.map(i=>w.CompletionItem.to(i,o));return new L.$lL(n,u.incomplete)})),new m.$fN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$dN.Uri,m.$dN.Position,m.$dN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$eN("A promise that resolves to SignatureHelp.",u=>{if(u)return w.SignatureHelp.to(u)})),new m.$fN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$dN.Uri,m.$dN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$eN("A promise that resolves to an array of CodeLens-instances.",(u,g,o)=>y(n=>new L.$dL(w.Range.to(n.range),n.command&&o.fromInternal(n.command)))(u))),new m.$fN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$dN.Uri,new m.$dN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>L.$RK.isRange(u),u=>L.$SK.isSelection(u)?w.Selection.from(u):w.Range.from(u)),m.$dN.String.with("kind","Code action kind to return code actions for").optional(),m.$dN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$eN("A promise that resolves to an array of Command-instances.",(u,g,o)=>y(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new L.$0K(n.title,n.kind?new L.$$K(n.kind):void 0);return n.edit&&(i.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(u))),new m.$fN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$dN.Uri],new m.$eN("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(g=>new L.$rL(w.Range.to(g.range),w.Color.to(g.color))):[])),new m.$fN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$dN("color","The color to show and insert",u=>u instanceof L.$qL,w.Color.from),new m.$dN("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:w.Range.from(u.range)}))],new m.$eN("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(w.ColorPresentation.to):[])),new m.$fN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$dN.Uri,m.$dN.Range],new m.$eN("A promise that resolves to an array of Inlay objects",(u,g,o)=>u.map(w.InlayHint.to.bind(void 0,o)))),new m.$fN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$dN.Uri],new m.$eN("A promise that resolves to an array of FoldingRange objects",(u,g)=>{if(u)return u.map(w.FoldingRange.to)})),new m.$fN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$eN("A promise that resolves to an array of NotebookContentProvider static info objects.",y(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(g=>w.NotebookExclusiveDocumentPattern.to(g))})))),new m.$fN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$dN.Uri,m.$dN.Range,new m.$dN("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof L.$RK,u=>w.InlineValueContext.from(u))],new m.$eN("A promise that resolves to an array of InlineValue objects",u=>u.map(w.InlineValue.to))),new m.$fN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$dN("uriOrString","Uri-instance or string (only http/https)",u=>f.URI.isUri(u)||typeof u=="string"&&(0,F.$bg)(u,F.Schemas.http,F.Schemas.https),u=>u),new m.$dN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[w.ViewColumn.from(u),void 0]:[w.ViewColumn.from(u.viewColumn),w.TextEditorOpenOptions.from(u)])).optional(),m.$dN.String.with("label","").optional()],m.$eN.Void),new m.$fN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$dN.Uri.with("resource","Resource to open"),m.$dN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$dN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[w.ViewColumn.from(u),void 0]:[w.ViewColumn.from(u.viewColumn),w.TextEditorOpenOptions.from(u)])).optional()],m.$eN.Void),new m.$fN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$dN.Uri.with("left","Left-hand side resource of the diff editor"),m.$dN.Uri.with("right","Right-hand side resource of the diff editor"),m.$dN.String.with("title","Human readable title for the diff editor").optional(),new m.$dN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[w.ViewColumn.from(u.viewColumn),w.TextEditorOpenOptions.from(u)]).optional()],m.$eN.Void),new m.$fN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$dN.String.with("title","Human readable title for the changes editor"),new m.$dN("resourceList","List of resources to compare",u=>{for(const g of u){if(g.length!==3)return!1;const[o,n,i]=g;if(!f.URI.isUri(o)||!f.URI.isUri(n)&&n!==void 0&&n!==null||!f.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},u=>u)],m.$eN.Void),new m.$fN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$dN.Uri,m.$dN.Position],new m.$eN("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(w.TypeHierarchyItem.to))),new m.$fN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$dN.TypeHierarchyItem],new m.$eN("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(w.TypeHierarchyItem.to))),new m.$fN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$dN.TypeHierarchyItem],new m.$eN("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(w.TypeHierarchyItem.to))),new m.$fN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$dN.TestItem],m.$eN.Void),new m.$fN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$dN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$eN.Void),new m.$fN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$dN.String.with("name","The context key name"),new m.$dN("value","The context key value",()=>!0,u=>u)],m.$eN.Void),new m.$fN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$dN.Uri,m.$dN.StringArray,new m.$dN("MappedEditsContext","Mapped Edits Context",u=>w.MappedEditsContext.is(u),u=>w.MappedEditsContext.from(u))],new m.$eN("A promise that resolves to a workspace edit or null",u=>u?w.WorkspaceEdit.to(u):null))];class ${static register(g){I.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",b.$1i)}}e.$lfc=$;function y(u){return g=>{if(Array.isArray(g))return g.map(u)}}function D(u){if(!Array.isArray(u))return;const g=[];for(const o of u)A.$tt(o)?g.push(w.DefinitionLink.to(o)):g.push(w.location.to(o));return g}}),define(Se[313],ke([1,0,10,59,4,3,2,83,26,15,7,6,25]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;function y(D,u,g){const o=D.getProxy(I.$NK.MainThreadComments);class n{constructor(){this.b=new Map,this.c=new m.$jm,u.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const v=this.b.get(c.handle);return v?v.value:c}else if(c&&c.$mid===7){const v=this.b.get(c.commentControlHandle);if(!v)return c;const P=v.getCommentThread(c.commentThreadHandle);return P?P.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const v=this.b.get(c.thread.commentControlHandle);if(!v)return c;const P=v.getCommentThread(c.thread.commentThreadHandle);return P?c.$mid===8?P.value:{thread:P.value,text:c.text}:c}else if(c&&c.$mid===10){const v=this.b.get(c.thread.commentControlHandle);if(!v)return c;const P=v.getCommentThread(c.thread.commentThreadHandle);if(!P)return c;const S=c.commentUniqueId,p=P.getCommentByUniqueId(S);return p||c}else if(c&&c.$mid===11){const v=this.b.get(c.thread.commentControlHandle);if(!v)return c;const P=v.getCommentThread(c.thread.commentThreadHandle);if(!P)return c;const S=c.text,p=c.commentUniqueId,k=P.getCommentByUniqueId(p);return k?(typeof k.body=="string"?k.body=S:k.body=new L.$eL(S),k):c}return c}})}createCommentController(c,v,P){const S=n.a++,p=new s(c,S,v,P);this.b.set(p.handle,p);const k=this.c.get(c.identifier)||[];return k.push(p),this.c.set(c.identifier,k),p.value}async $createCommentThreadTemplate(c,v,P){const S=this.b.get(c);S&&S.$createCommentThreadTemplate(v,P)}async $updateCommentThreadTemplate(c,v,P){const S=this.b.get(c);S&&S.$updateCommentThreadTemplate(v,P)}$deleteCommentThread(c,v){this.b.get(c)?.$deleteCommentThread(v)}$provideCommentingRanges(c,v,P){const S=this.b.get(c);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const p=g.getDocument(M.URI.revive(v));return(0,E.$Ug)(async()=>{const k=await S.commentingRangeProvider.provideCommentingRanges(p,P);let C;return Array.isArray(k)?C={ranges:k,fileComments:!1}:k?C={ranges:k.ranges||[],fileComments:k.fileComments||!1}:C=k??void 0,C}).then(k=>{let C;return k&&(C={ranges:k.ranges.map(j=>w.Range.from(j)),fileComments:k.fileComments}),C})}$toggleReaction(c,v,P,S,p){const k=this.b.get(c);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,E.$Ug)(()=>{const C=k.getCommentThread(v);if(C){const j=C.getCommentByUniqueId(S.uniqueIdInThread);if(k!==void 0&&j&&k.reactionHandler)return k.reactionHandler(j,r(p))}return Promise.resolve(void 0)})}}n.a=0;class i{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){(c===void 0!=(this.p===void 0)||!c||!this.p||!c.isEqual(this.p))&&(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return this.h}set state(c){this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,v,P,S,p,k,C,j){this.m=v,this.n=P,this.o=S,this.p=p,this.q=k,this.extensionDescription=C,this.r=j,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Tc,this.l.value=new A.$Rc,this.n===void 0&&(this.n=`${c}.${this.handle}`),o.$createCommentThread(v,this.handle,this.n,this.o,w.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{o.$deleteCommentThread(v,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(O){z.range=O},get comments(){return z.comments},set comments(O){z.comments=O},get collapsibleState(){return z.collapsibleState},set collapsibleState(O){z.collapsibleState=O},get canReply(){return z.canReply},set canReply(O){z.canReply=O},get contextValue(){return z.contextValue},set contextValue(O){z.contextValue=O},get label(){return z.label},set label(O){z.label=O},get state(){return z.state},set state(O){z.state=O},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Rc);const c=P=>Object.prototype.hasOwnProperty.call(this.b,P),v={};c("range")&&(v.range=w.Range.from(this.p)),c("label")&&(v.label=this.label),c("contextValue")&&(v.contextValue=this.contextValue??null),c("comments")&&(v.comments=this.q.map(P=>a(this,P,this.k,this.extensionDescription))),c("collapsibleState")&&(v.collapseState=d(this.g)),c("canReply")&&(v.canReply=this.canReply),c("state")&&(v.state=l(this.h)),c("isTemplate")&&(v.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(c){for(const v of this.k){const P=v[0],S=v[1];if(c===S)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}i.a=0,Qe([(0,F.$uh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class s{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,v,P,S){this.f=c,this.g=v,this.h=P,this.i=S,this.a=new Map,o.$registerCommentController(this.handle,P,S,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(k){p.options=k},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(k){p.commentingRangeProvider=k},get reactionHandler(){return p.reactionHandler},set reactionHandler(k){p.reactionHandler=k},createCommentThread(k,C,j){return p.createCommentThread(k,C,j).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(c,v,P){v===void 0&&(0,$.$lF)(this.f,"fileComments");const S=new i(this.id,this.handle,void 0,c,v,P,this.f,!1);return this.a.set(S.handle,S),S}$createCommentThreadTemplate(c,v){const P=new i(this.id,this.handle,void 0,M.URI.revive(c),w.Range.to(v),[],this.f,!0);return P.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(c,v){const P=this.a.get(c);P&&(P.range=w.Range.to(v))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function a(h,c,v,P){let S=v.get(c);return S||(S=++h.commentHandle,v.set(c,S)),c.state!==void 0&&(0,$.$lF)(P,"commentsDraftState"),{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:S,body:typeof c.body=="string"?c.body:w.MarkdownString.from(c.body),userName:c.author.name,userIconPath:c.author.iconPath,label:c.label,commentReactions:c.reactions?c.reactions.map(p=>t(p)):void 0,state:c.state,timestamp:c.timestamp?.toJSON()}}function t(h){return{label:h.label,iconPath:h.iconPath?w.$QM(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted}}function r(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?M.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1}}function d(h){if(h!==void 0)switch(h){case L.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(h){if(h!==void 0)switch(h){case L.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new n}e.$vfc=y}),define(Se[314],ke([1,0,24,6,27,20]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;let M=class{constructor(L,I){this.a=L.getProxy(F.$NK.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,I){const $=this,y=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){$.e(L,I,y,arguments)}})}e(L,I,$,y){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:m(y,this.b)}),this.c&&this.f(L,$,y)}};e.$jhc=M,e.$jhc=M=Qe([qe(0,A.$RM),qe(1,f.$8M)],M);const b=1e5;function m(w,L){const I=[];if(w.length)for(let $=0;$<w.length;$++){let y=w[$];if(typeof y>"u")y="undefined";else if(y instanceof Error){const D=y;D.stack?y=D.stack:y=D.toString()}I.push(y)}if(L){const $=new Error().stack;$&&I.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,E.$nn)(I);return $.length>b?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(Se[150],ke([1,0,2,6,7,5,20,14,19,13,16,25]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=e.$lgc=void 0;let y=$=class{constructor(u,g){this.h=g,this.f=new Map,this.g=u.getProxy(F.$NK.MainThreadDecorations)}registerFileDecorationProvider(u,g){const o=$.c++;this.f.set(o,{provider:u,extensionDescription:g}),this.g.$registerDecorationProvider(o,g.identifier.value);const n=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const s=(0,m.$3b)(i);if(s.length<=$.d){this.g.$onDidChange(o,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,s.length);const a=s.map(d=>({uri:d,rank:(0,w.$Le)(d.path,"/")})),t=(0,m.$zb)(a,(d,l)=>d.rank-l.rank||(0,w.$1e)(d.uri.path,l.uri.path)),r=[];e:for(const d of t){let l;for(const h of d){const c=(0,L.$mc)(h.uri.path);if(l!==c&&(l=c,r.push(h.uri)>=$.d))break e}}this.g.$onDidChange(o,r)});return new f.$PK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(u,g,o){if(!this.f.has(u))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(u);return await Promise.all(g.map(async a=>{try{const{uri:t,id:r}=a,d=await Promise.resolve(i.provideFileDecoration(E.URI.revive(t),o));if(!d)return;try{f.$_L.validate(d),d.badge&&typeof d.badge!="string"&&(0,I.$lF)(s,"codiconDecoration"),n[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),n}};e.$lgc=y,y.c=0,y.d=250,e.$lgc=y=$=Qe([qe(0,M.$RM),qe(1,b.$jj)],y),e.$mgc=(0,A.$2h)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[315],ke([1,0,211,136,2,6,7,15,4,14,28,57]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";var $,y,D,u;Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0;class g{constructor(i,s,a,t,r,d,l,h){this.d=i,this.e=s,this.f=a,this.g=t,this.h=r,$.set(this,void 0),y.set(this,void 0),D.set(this,void 0),this.c=!1,this.f=Math.max(t,a),nt(this,D,new L.$Ac(c=>d.getComparisonKey(c)),"f"),nt(this,$,l,"f"),nt(this,y,h,"f")}dispose(){this.c||(We(this,y,"f").fire([...We(this,D,"f").keys()]),We(this,$,"f")?.$clear(this.e),We(this,D,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(i,s){if(!i){this.clear();return}this.j();let a=[];if(f.URI.isUri(i)){if(!s){this.delete(i);return}We(this,D,"f").set(i,s.slice()),a=[i]}else if(Array.isArray(i)){a=[];let d;i=[...i].sort(g.k);for(const l of i){const[h,c]=l;if((!d||h.toString()!==d.toString())&&(d&&We(this,D,"f").get(d).length===0&&We(this,D,"f").delete(d),d=h,a.push(h),We(this,D,"f").set(h,[])),c)We(this,D,"f").get(h)?.push(...c);else{const v=We(this,D,"f").get(h);v&&(v.length=0)}}}if(We(this,y,"f").fire(a),!We(this,$,"f"))return;const t=[];let r=0;for(const d of a){let l=[];const h=We(this,D,"f").get(d);if(h)if(h.length>this.g){l=[];const c=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(const P of h)if(P.severity===c[v]&&l.push({...b.Diagnostic.from(P),modelVersionId:this.h(d)})===this.g)break e;l.push({severity:F.MarkerSeverity.Info,message:(0,E.localize)(0,null,h.length-this.g),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=h.map(c=>({...b.Diagnostic.from(c),modelVersionId:this.h(d)}));if(t.push([d,l]),r+=l.length,r>this.f)break}We(this,$,"f").$changeMany(this.e,t)}delete(i){this.j(),We(this,y,"f").fire([i]),We(this,D,"f").delete(i),We(this,$,"f")?.$changeMany(this.e,[[i,void 0]])}clear(){this.j(),We(this,y,"f").fire([...We(this,D,"f").keys()]),We(this,D,"f").clear(),We(this,$,"f")?.$clear(this.e)}forEach(i,s){this.j();for(const[a,t]of this)i.call(s,a,t,this)}*[($=new WeakMap,y=new WeakMap,D=new WeakMap,Symbol.iterator)](){this.j();for(const i of We(this,D,"f").keys())yield[i,this.get(i)]}get(i){this.j();const s=We(this,D,"f").get(i);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(i){return this.j(),Array.isArray(We(this,D,"f").get(i))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(i,s){return i[0].toString()<s[0].toString()?-1:i[0].toString()>s[0].toString()?1:0}}e.$ffc=g;let o=u=class{static _mapper(i){const s=new L.$Ac;for(const a of i)s.set(a,a);return{uris:Object.freeze(Array.from(s.values()))}}constructor(i,s,a,t){this.j=s,this.k=a,this.l=t,this.g=new Map,this.h=new m.$Wd({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,u._mapper),this.f=i.getProxy(A.$NK.MainThreadDiagnostics)}createDiagnosticCollection(i,s){const{g:a,f:t,h:r,j:d,k:l,l:h}=this,c=new class{$changeMany(S,p){t.$changeMany(S,p),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,S,p.length===0?"CLEARING":p)}$clear(S){t.$clear(S),d.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,S)}dispose(){t.dispose()}};let v;if(!s)s="_generated_diagnostic_collection_name_#"+u.c++,v=s;else if(!a.has(s))v=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do v=s+u.c++;while(a.has(v))}return new class extends g{constructor(){super(s,v,u.e,u.d,S=>h.getDocument(S)?.version,l.extUri,c,r),a.set(v,this)}dispose(){super.dispose(),a.delete(v)}}}getDiagnostics(i){if(i)return this.m(i);{const s=new Map,a=[];for(const t of this.g.values())t.forEach((r,d)=>{let l=s.get(r.toString());typeof l>"u"&&(l=a.length,s.set(r.toString(),l),a.push([r,[]])),a[l][1]=a[l][1].concat(...d)});return a}}m(i){let s=[];for(const a of this.g.values())a.has(i)&&(s=s.concat(a.get(i)));return s}$acceptMarkersChange(i){if(!this.n){const s="_generated_mirror",a=new g(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(s,a),this.n=a}for(const[s,a]of i)this.n.set(f.URI.revive(s),a.map(b.Diagnostic.to))}};e.$gfc=o,o.c=0,o.d=1e3,o.e=1.1*u.d,e.$gfc=o=u=Qe([qe(1,w.$jj),qe(2,I.$efc)],o)}),define(Se[316],ke([1,0,2,6,25]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class A{constructor(b){this.a=b.getProxy(F.$NK.MainThreadDialogs)}showOpenDialog(b,m){return m?.allowUIResources&&(0,f.$lF)(b,"showLocal"),this.a.$showOpenDialog(m).then(w=>w?w.map(L=>E.URI.revive(L)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(m=>m?E.URI.revive(m):void 0)}}e.$ngc=A}),define(Se[317],ke([1,0,8,2,7,6,17,21,13]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class w{constructor(I,$,y){this.d=$,this.e=y,this.b=new Map,this.c=I.getProxy(A.$NK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,$){if(Object.keys(M.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const y=w.a++;this.b.set(y,$),this.c.$registerTextContentProvider(y,I);let D;return typeof $.onDidChange=="function"&&(D=$.onDidChange(u=>{if(u.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this.d.getDocument(u)&&this.$provideTextDocumentContent(y,u).then(g=>{if(!g&&typeof g!="string")return;const o=this.d.getDocument(u);if(!o)return;const n=(0,m.$Ve)(g);if(!o.equalLines(n))return this.c.$onVirtualDocumentChange(u,g)},E.$1)})),new f.$PK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(I,$){const y=this.b.get(I);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive($),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$ogc=w,w.a=0}),define(Se[318],ke([1,0,4,3,2,6,142,15,18,24,7,8]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class ${constructor(D,u){this.a=new E.$Sd({onListenerError:I.$2}),this.b=new E.$Sd({onListenerError:I.$2}),this.c=new E.$Sd({onListenerError:I.$2}),this.d=new E.$Sd({onListenerError:I.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Rc,this.h=new Map,this.f=D.getProxy(A.$NK.MainThreadDocuments),this.g=u,this.g.onDidRemoveDocuments(g=>{for(const o of g)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(g=>{for(const o of g)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const u=this.g.getDocument(D);if(u)return u}getDocument(D){const u=this.getDocumentData(D);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return u.document}ensureDocumentData(D){const u=this.g.getDocument(D);if(u)return Promise.resolve(u);let g=this.h.get(D.toString());return g||(g=this.f.$tryOpenDocument(D).then(o=>{this.h.delete(D.toString());const n=f.URI.revive(o);return(0,m.$Pf)(this.g.getDocument(n))},o=>(this.h.delete(D.toString()),Promise.reject(o))),this.h.set(D.toString(),g)),g}createDocumentData(D){return this.f.$tryCreateDocument(D).then(u=>f.URI.revive(u))}$acceptModelLanguageChanged(D,u){const g=f.URI.revive(D),o=this.g.getDocument(g);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(u),this.a.fire(o.document)}$acceptModelSaved(D){const u=f.URI.revive(D),g=this.g.getDocument(u);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(g.document)}$acceptDirtyStateChanged(D,u){const g=f.URI.revive(D),o=this.g.getDocument(g);if(!o)throw new Error("unknown document");o._acceptIsDirty(u),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,u,g){const o=f.URI.revive(D),n=this.g.getDocument(o);if(!n)throw new Error("unknown document");n._acceptIsDirty(g),n.onEvents(u);let i;u.isUndoing?i=L.TextDocumentChangeReason.Undo:u.isRedoing&&(i=L.TextDocumentChangeReason.Redo),this.c.fire((0,w.$jn)({document:n.document,contentChanges:u.changes.map(s=>({range:b.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:i}))}setWordDefinitionFor(D,u){(0,M.$TM)(D,u)}}e.$cfc=$}),define(Se[69],ke([1,0,60,4,3,2,5,6,142,20,149,15,14,28,17,52,43]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.$2M=void 0;class o{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(s,a){this.h=s,this.i=a,this.a=null,this.b=new Map,this.c=new y.$Ac,this.d=new F.$Sd,this.e=new F.$Sd,this.f=new F.$Sd,this.g=new F.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const a=[],t=[],r=[];if(s.removedDocuments)for(const d of s.removedDocuments){const l=A.URI.revive(d),h=this.c.get(l);h?.unref()&&(this.c.delete(l),a.push(h.value))}if(s.addedDocuments)for(const d of s.addedDocuments){const l=A.URI.revive(d.uri);let h=this.c.get(l);if(h&&l.scheme!==D.Schemas.vscodeNotebookCell&&l.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);h||(h=new o(new m.$UM(this.h.getProxy(b.$NK.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(l,h),t.push(h.value)),h.ref()}if(s.removedEditors)for(const d of s.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&r.push(l)}if(s.addedEditors)for(const d of s.addedEditors){const l=A.URI.revive(d.documentUri);E.ok(this.c.has(l),`document '${l}' does not exist`),E.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const h=this.c.get(l).value,c=new L.$1M(d.id,this.h.getProxy(b.$NK.MainThreadTextEditors),this.i,new g.$V(()=>h.document),d.selections.map(I.Selection.to),d.options,d.visibleRanges.map(v=>I.Range.to(v)),typeof d.editorPosition=="number"?I.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,c)}s.newActiveEditor!==void 0&&(E.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,f.$Nc)(a),(0,f.$Nc)(r),s.removedDocuments&&this.e.fire(a),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return u.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const a=this.b.get(this.a);return s?a:a?.value}allEditors(){return[...this.b.values()]}};e.$2M=n,e.$2M=n=Qe([qe(0,w.$RM),qe(1,$.$jj)],n),e.$3M=(0,M.$2h)("IExtHostDocumentsAndEditors")}),define(Se[70],ke([1,0,73,4,18,2,5,6,20,15,7]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=void 0,e.$Ofc=(0,M.$2h)("IExtHostEditorTabs");class I{constructor(g,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,o={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new L.$vM(A.URI.revive(this.b.input.uri));case 2:return new L.$wM(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new L.$xM(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new L.$yM(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new L.$zM(this.b.input.viewType);case 4:return new L.$AM(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new L.$BM(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new L.$CM;case 9:return new L.$DM(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new L.$EM(this.b.input.providerId);default:return}}}class ${constructor(g,o){this.c=[],this.d="",this.b=g,this.e=o;for(const n of g.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,o={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return w.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(n=>n.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const n=new I(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,n),g.tabDto.isActive&&(this.d=n.tabId),n}else if(g.kind===1){const n=this.c.splice(g.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(g.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,n),n}const o=this.c.find(n=>n.tabId===g.tabDto.id);if(!o)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(g.tabDto),o}activeTabId(){return this.d}}let y=class{constructor(g){this.b=new F.$Sd,this.c=new F.$Sd,this.e=[],this.a=g.getProxy(b.$NK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,o={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(n=>n.apiObject))},get activeTabGroup(){const n=g.d;return(0,f.$Pf)(g.e.find(s=>s.groupId===n)?.apiObject)},close:async(n,i)=>{const s=Array.isArray(n)?n:[n];return s.length?D(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(g){const o=new Set(this.e.map(d=>d.groupId)),n=new Set(g.map(d=>d.groupId)),i=(0,E.$F)(o,n),s=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=g.map(d=>{const l=new $(d,()=>this.d);return i.added.includes(l.groupId)?a.push(l.apiObject):t.push(l.apiObject),l});const r=(0,f.$Pf)(g.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:a,closed:s,changed:t}))}$acceptTabGroupUpdate(g){const o=this.e.find(n=>n.groupId===g.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const o=this.e.find(i=>i.groupId===g.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(g){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===g)return n}h(g){return this.e.find(o=>o.apiObject===g)}async i(g,o){const n=[];for(const i of g){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");n.push(s.tabId)}return this.a.$closeTab(n,o)}async j(g,o){const n=[];for(const i of g){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");n.push(s.groupId)}return this.a.$closeGroup(n,o)}};e.$Pfc=y,e.$Pfc=y=Qe([qe(0,m.$RM)],y);function D(u){return u.tabs!==void 0}}),define(Se[319],ke([1,0,6,7]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class f{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(E.$NK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(M);if(!w)throw new Error("Embedding vector provider not found");const L=await w.provideEmbeddingVector(b,m);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(M,b,m){const w=this.b;return this.b++,this.a.set(w,m),this.c.$registerAiEmbeddingVectorProvider(b,w),new F.$PK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$qgc=f}),define(Se[320],ke([1,0,2,6,3,7,15,181,13,22,25,79]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class ${constructor(){this.a=[]}add(u){this.b=void 0,this.a.push(u)}delete(u){const g=this.a.indexOf(u);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const u=this.a.sort(),g=[];let o,n,i=14,s=14;for(const a of u){let t=o?(0,m.$0e)(o,a):0;for(t===0?n=1:n=s;t<a.length;t++)t+1===a.length?(i=s,s=9):s+=1,g.push([n,a.toUpperCase().charCodeAt(t),s]),g.push([n,a.toLowerCase().charCodeAt(t),s]),n=s;o=a,s=i}g.push([9,58,10]),g.push([10,47,12]),this.b=new b.$pZ(g)}}provideDocumentLinks(u){this.c();const g=[],o=b.$qZ.computeLinks({getLineContent(n){return u.lineAt(n-1).text},getLineCount(){return u.lineCount}},this.b);for(const n of o){const i=M.DocumentLink.to(n);i.target&&g.push(i)}return g}}class y{constructor(u,g){this.i=g,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=u.getProxy(F.$NK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(u,g,o,n={}){if(y.j(o),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(u,"*",this.b));const i=this.h++;this.b.add(g),this.d.add(g),this.c.set(i,o);let s=2;n.isCaseSensitive&&(s+=1024),n.isReadonly&&(s+=2048),typeof o.copy=="function"&&(s+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,L.$lF)(u,"fsChunks"),s+=4);let a;n.isReadonly&&(0,I.$fk)(n.isReadonly)&&((0,L.$lF)(u,"readonlyMessage"),a={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,g,s,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${u.identifier.value}-extension for the scheme ${g}`),console.error(r)});const t=o.onDidChangeFile(r=>{const d=[];for(const l of r){const{uri:h,type:c}=l;if(h.scheme!==g)continue;let v;switch(c){case A.FileChangeType.Changed:v=0;break;case A.FileChangeType.Created:v=1;break;case A.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:h,type:v})}this.a.$onFileSystemChange(i,d)});return(0,f.$Qc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(u){if(!u)throw new Error("MISSING provider");if(typeof u.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof u.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof u.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof u.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof u.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof u.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof u.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof u.rename!="function")throw new Error("Provider does NOT implement rename")}static k(u){const{type:g,ctime:o,mtime:n,size:i,permissions:s}=u;return{type:g,ctime:o,mtime:n,size:i,permissions:s}}$stat(u,g){return Promise.resolve(this.l(u).stat(E.URI.revive(g))).then(o=>y.k(o))}$readdir(u,g){return Promise.resolve(this.l(u).readDirectory(E.URI.revive(g)))}$readFile(u,g){return Promise.resolve(this.l(u).readFile(E.URI.revive(g))).then(o=>w.$ge.wrap(o))}$writeFile(u,g,o,n){return Promise.resolve(this.l(u).writeFile(E.URI.revive(g),o.buffer,n))}$delete(u,g,o){return Promise.resolve(this.l(u).delete(E.URI.revive(g),o))}$rename(u,g,o,n){return Promise.resolve(this.l(u).rename(E.URI.revive(g),E.URI.revive(o),n))}$copy(u,g,o,n){const i=this.l(u);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(E.URI.revive(g),E.URI.revive(o),n))}$mkdir(u,g){return Promise.resolve(this.l(u).createDirectory(E.URI.revive(g)))}$watch(u,g,o,n){const i=this.l(u).watch(E.URI.revive(o),n);this.f.set(g,i)}$unwatch(u,g){const o=this.f.get(g);o&&(o.dispose(),this.f.delete(g))}$open(u,g,o){const n=this.l(u);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(g),o))}$close(u,g){const o=this.l(u);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(g))}$read(u,g,o,n){const i=this.l(u);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const s=w.$ge.alloc(n);return Promise.resolve(i.read(g,o,s.buffer,0,n)).then(a=>s.slice(0,a))}$write(u,g,o,n){const i=this.l(u);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(g,o,n.buffer,0,n.byteLength))}l(u){const g=this.c.get(u);if(!g){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return g}}e.$rgc=y}),define(Se[71],ke([1,0,6,32,7,22,5,20,57,3,10,23,17]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=void 0;let D=y=class{constructor(g,o){this.b=new Map,this.c=new L.$$g,this.a=g.getProxy(E.$NK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let s;const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),s=await a.impl.stat(i)):s=await n.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===F.FilePermission.Readonly?1:void 0}}catch(s){y.e(s)}},async readDirectory(i){try{const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(s){return y.e(s)}},async createDirectory(i){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,i)):await n.a.$mkdir(i)}catch(s){return y.e(s)}},async readFile(i){try{const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(s){return y.e(s)}},async writeFile(i,s){try{const a=n.b.get(i.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(a.impl,a.extUri,a.extUri.dirname(i)),await n.c.queueFor(i).queue(()=>Promise.resolve(a.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,A.$ge.wrap(s))}catch(a){return y.e(a)}},async delete(i,s){try{const a=n.b.get(i.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(i.scheme),await a.impl.delete(i,{recursive:!1,...s})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(a){return y.e(a)}},async rename(i,s,a){try{return await n.a.$rename(i,s,{overwrite:!1,...a})}catch(t){return y.e(t)}},async copy(i,s,a){try{return await n.a.$copy(i,s,{overwrite:!1,...a})}catch(t){return y.e(t)}},isWritableFileSystem(i){const s=o.getCapabilities(i);if(typeof s=="number")return!(s&2048)}})}async d(g,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await g.stat(n)).type&F.FileType.Directory))throw f.$4L.FileExists(`Unable to create folder '${n.scheme===$.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(F.$Bk(s)!==F.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(o.basename(n)),n=o.dirname(n)}for(let s=i.length-1;s>=0;s--){n=o.joinPath(n,i[s]);try{await g.createDirectory(n)}catch(a){if(F.$Bk(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static e(g){if(g instanceof f.$4L)throw g;if(g instanceof F.$xk)switch(g.code){case F.FileSystemProviderErrorCode.FileExists:throw f.$4L.FileExists(g.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$4L.FileNotFound(g.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$4L.FileNotADirectory(g.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$4L.FileIsADirectory(g.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$4L.NoPermissions(g.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$4L.Unavailable(g.message);default:throw new f.$4L(g.message,g.name)}if(!(g instanceof Error))throw new f.$4L(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw f.$4L.Unavailable(g.message);switch(g.name){case F.FileSystemProviderErrorCode.FileExists:throw f.$4L.FileExists(g.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$4L.FileNotFound(g.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$4L.FileNotADirectory(g.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$4L.FileIsADirectory(g.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$4L.NoPermissions(g.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$4L.Unavailable(g.message);default:throw new f.$4L(g.message,g.name)}}addFileSystemProvider(g,o,n){return this.b.set(g,{impl:o,extUri:n?.isCaseSensitive?I.$tg:I.$vg,isReadonly:!!n?.isReadonly}),(0,w.$Qc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??I.$tg}};e.$Dfc=D,e.$Dfc=D=y=Qe([qe(0,b.$RM),qe(1,m.$efc)],D),e.$Efc=(0,M.$2h)("IExtHostConsumerFileSystem")}),define(Se[321],ke([1,0,4,34,2,6,15,7,43]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,D,u,g,o,n){this.a=Math.random(),this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,F.$Ij)(o),s=typeof o=="string",a=n?.correlate,t=g(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(a&&typeof r.session>"u")){if(!n?.ignoreCreateEvents)for(const d of r.created){const l=f.URI.revive(d);i(l.fsPath)&&(!s||D.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const d of r.changed){const l=f.URI.revive(d);i(l.fsPath)&&(!s||D.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const d of r.deleted){const l=f.URI.revive(d);i(l.fsPath)&&(!s||D.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$PK.from(this.i(y,u,o,n,n?.correlate),this.b,this.c,this.d,t)}i(y,D,u,g,o){const n=b.$PK.from();if(typeof u=="string")return n;const i=y.getProxy(A.$NK.MainThreadFileSystemEventService);let s=!1;return(u.pattern.includes(F.$Ej)||u.pattern.includes(F.$Fj))&&(s=!0),i.$watch(D.identifier.value,this.a,u.baseUri,{recursive:s,excludes:g?.excludes??[]},!!o),b.$PK.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(y){this.a=y,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(f.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(f.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(y,D,u){this.j=y,this.k=D,this.l=u,this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.g=new E.$Ud,this.h=new E.$Ud,this.i=new E.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,D,u,g){return new w(this.j,y,D,this.a.event,M.GlobPattern.from(u),g)}$onFileEvent(y){this.a.fire(new L(y))}$onDidRunFileOperation(y,D){switch(y){case 2:this.b.fire(Object.freeze({files:D.map(u=>({oldUri:f.URI.revive(u.source),newUri:f.URI.revive(u.target)}))}));break;case 1:this.d.fire(Object.freeze({files:D.map(u=>f.URI.revive(u.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:D.map(u=>f.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,D){return(u,g,o)=>{const n=function(s){u.call(g,s)};return n.extension=y,D.event(n,void 0,o)}}async $onWillRunFileOperation(y,D,u,g){switch(y){case 2:return await this.n(this.g,{files:D.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},u,g);case 1:return await this.n(this.i,{files:D.map(o=>f.URI.revive(o.target))},u,g);case 0:case 3:return await this.n(this.h,{files:D.map(o=>f.URI.revive(o.target))},u,g)}}async n(y,D,u,g){const o=new Set,n=[];if(await y.fireAsync(D,g,async(s,a)=>{const t=Date.now(),r=await Promise.resolve(s);r instanceof b.$ZK&&(n.push([a.extension,r]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>u&&this.k.warn("SLOW file-participant",a.extension.identifier)}),g.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,s]of n){const{edits:a}=M.WorkspaceEdit.from(s,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(a)}return{edit:i,extensionNames:Array.from(o)}}}e.$sgc=I}),define(Se[322],ke([1,0,3,2,6,15,7,35,10]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class w{constructor(y,D){this.extension=y,this.provider=D,this.handle=w.a++}}w.a=0;class L{constructor(y){this.session=y,this.responses=[]}}class I{constructor(y,D,u,g){this.f=u,this.g=g,this.b=new Map,this.d=new Map,this.e=y.getProxy(f.$NK.MainThreadInlineChat),D.registerApiCommand(new b.$fN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$dN("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?A.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?A.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?A.Position.from(o.position):void 0}})],b.$eN.Void))}registerProvider(y,D,u){const g=new w(y,D);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,u?.label??y.displayName??y.name,y.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function",typeof D.provideFollowups=="function",u?.supportReportIssue??!1),(0,E.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(y,D,u,g){const o=this.b.get(y);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(F.URI.revive(D)),i=A.Selection.to(u),s=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},g);if(!s)return;if(s.wholeRange&&!s.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=I.a++;return this.d.set(a,new L(s)),{id:a,placeholder:s.placeholder,input:s.input,slashCommands:s.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:A.Range.from(s.wholeRange),message:s.message}}async $provideResponse(y,D,u,g){const o=this.b.get(y);if(!o)return;const n=this.d.get(D.id);if(!n)return;const i={prompt:u.prompt,selection:A.Selection.to(u.selection),wholeRange:A.Range.to(u.wholeRange),attempt:u.attempt,live:u.live};let s=!1;const a={report:async h=>{if(!u.live&&h.edits?.length)throw new Error("Progress reporting is only supported for live sessions");s||g.isCancellationRequested||await this.e.$handleProgressChunk(u.requestId,{message:h.message,edits:h.edits?.map(A.TextEdit.from),editsShouldBeInstant:h.editsShouldBeInstant,slashCommand:h.slashCommand?.command,markdownFragment:M.$eL.isMarkdownString(h.content)?h.content.value:h.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,a,g));let r;try{r=await(0,m.$Qg)(t,g)}finally{s=!0}if(!r)return;const d=n.responses.push(r)-1,l={wholeRange:A.Range.from(r.wholeRange),placeholder:r.placeholder};if(I.h(r)){const{edits:h,contents:c}=r,v=c!==void 0?A.MarkdownString.from(c):void 0;return h instanceof M.$ZK?{...l,id:d,type:"bulkEdit",edits:A.WorkspaceEdit.from(h),message:v}:{...l,id:d,type:"editorEdit",edits:h.map(A.TextEdit.from),message:v}}return{...l,id:d,type:"message",message:A.MarkdownString.from(r.contents)}}async $provideFollowups(y,D,u,g){const o=this.b.get(y),n=this.d.get(D),i=n?.responses[u];if(o&&i&&o.provider.provideFollowups){const s=Promise.resolve(o.provider.provideFollowups(n.session,i,g));return(await(0,m.$Qg)(s,g))?.map(A.ChatReplyFollowup.from)}}$handleFeedback(y,D,u,g){const o=this.b.get(y),n=this.d.get(D),i=n?.responses[u];if(o&&i){const s=A.InteractiveEditorResponseFeedbackKind.to(g);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,s)}}$releaseSession(y,D){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$tgc=I,I.a=0}),define(Se[323],ke([1,0,2,35]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;class f{constructor(M,b,m,w,L){this.a=b,this.b=m,this.c=w;const I=new F.$fN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$dN("showOptions","Show Options",$=>!0,$=>$),new F.$dN("resource","Interactive resource Uri",$=>!0,$=>$),new F.$dN("controllerId","Notebook controller Id",$=>!0,$=>$),new F.$dN("title","Interactive editor title",$=>!0,$=>$)],new F.$eN("Notebook and input URI",$=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const y=this.a.getEditorById($.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:E.URI.revive($.notebookUri),inputUri:E.URI.revive($.inputUri),notebookEditor:y.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:E.URI.revive($.notebookUri),inputUri:E.URI.revive($.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(M,b,m,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:m,uri:M,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Ggc=f}),define(Se[324],ke([1,0,6,7]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class f{constructor(M){this.a=new Map,this.b=new Map,this.c=M.getProxy(E.$NK.MainThreadIssueReporter)}async $getIssueReporterUri(M,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const m=this.a.get(M);if(!m)throw new Error("Issue request handler not found");const w=await m.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(M,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const m=this.b.get(M);if(!m)throw new Error("Issue data provider not found");const w=await m.provideIssueData(b);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(M,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const m=this.b.get(M);if(!m)throw new Error("Issue data provider not found");const w=await m.provideIssueTemplate(b);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(M,b){const m=M.identifier.value;return this.a.set(m,b),this.c.$registerIssueUriRequestHandler(m),new F.$PK(()=>{this.c.$unregisterIssueUriRequestHandler(m),this.a.delete(m)})}registerIssueDataProvider(M,b){const m=M.identifier.value;return this.b.set(m,b),this.c.$registerIssueDataProvider(m),new F.$PK(()=>{this.c.$unregisterIssueDataProvider(m),this.b.delete(m)})}}e.$Hgc=f}),define(Se[325],ke([1,0,3,6]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;class f{constructor(M){this.b=0,this.a=M.getProxy(F.$NK.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,E.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Igc=f}),define(Se[326],ke([1,0,2,24,15,7,83,6,13,29,19,18,174,21,26,3,132,122,110,39,8,10,25,213]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class d{constructor(B,x){this.d=B,this.e=x}async provideDocumentSymbols(B,x){const se=this.d.getDocument(B),H=await this.e.provideDocumentSymbols(se,x);if(!(0,L.$Kb)(H))return H[0]instanceof A.$9K?H.map(f.DocumentSymbol.from):d.f(H)}static f(B){B=B.slice(0).sort((H,ue)=>{let fe=H.location.range.start.compareTo(ue.location.range.start);return fe===0&&(fe=ue.location.range.end.compareTo(H.location.range.end)),fe});const x=[],se=[];for(const H of B){const ue={name:H.name||"!!MISSING: name!!",kind:f.SymbolKind.from(H.kind),tags:H.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:f.Range.from(H.location.range),selectionRange:f.Range.from(H.location.range),children:[]};for(;;){if(se.length===0){se.push(ue),x.push(ue);break}const fe=se[se.length-1];if(w.$Hs.containsRange(fe.range,ue.range)&&!w.$Hs.equalsRange(fe.range,ue.range)){fe.children?.push(ue),se.push(ue);break}se.pop()}}return x}}class l{constructor(B,x,se){this.g=B,this.h=x,this.j=se,this.e=new n.$afc("CodeLens"),this.f=new Map}async provideCodeLenses(B,x){const se=this.g.getDocument(B),H=await this.j.provideCodeLenses(se,x);if(!H||x.isCancellationRequested)return;const ue=this.e.add(H),fe=new u.$Rc;this.f.set(ue,fe);const Re={cacheId:ue,lenses:[]};for(let Oe=0;Oe<H.length;Oe++)Re.lenses.push({cacheId:[ue,Oe],range:f.Range.from(H[Oe].range),command:this.h.toInternal(H[Oe].command,fe)});return Re}async resolveCodeLens(B,x){const se=B.cacheId&&this.e.get(...B.cacheId);if(!se)return;let H;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?H=se:H=await this.j.resolveCodeLens(se,x),H||(H=se),x.isCancellationRequested)return;const ue=B.cacheId&&this.f.get(B.cacheId[0]);if(ue)return B.command=this.h.toInternal(H.command??l.d,ue),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}l.d={command:"missing",title:"!!MISSING: command!!"};function h(De){return Array.isArray(De)?De.map(f.DefinitionLink.from):De?[f.DefinitionLink.from(De)]:[]}class c{constructor(B,x){this.d=B,this.e=x}async provideDefinition(B,x,se){const H=this.d.getDocument(B),ue=f.Position.to(x),fe=await this.e.provideDefinition(H,ue,se);return h(fe)}}class v{constructor(B,x){this.d=B,this.e=x}async provideDeclaration(B,x,se){const H=this.d.getDocument(B),ue=f.Position.to(x),fe=await this.e.provideDeclaration(H,ue,se);return h(fe)}}class P{constructor(B,x){this.d=B,this.e=x}async provideImplementation(B,x,se){const H=this.d.getDocument(B),ue=f.Position.to(x),fe=await this.e.provideImplementation(H,ue,se);return h(fe)}}class S{constructor(B,x){this.d=B,this.e=x}async provideTypeDefinition(B,x,se){const H=this.d.getDocument(B),ue=f.Position.to(x),fe=await this.e.provideTypeDefinition(H,ue,se);return h(fe)}}class p{constructor(B,x){this.d=B,this.e=x}async provideHover(B,x,se){const H=this.d.getDocument(B),ue=f.Position.to(x),fe=await this.e.provideHover(H,ue,se);if(!(!fe||(0,L.$Kb)(fe.contents)))return fe.range||(fe.range=H.getWordRangeAtPosition(ue)),fe.range||(fe.range=new A.$RK(ue,ue)),f.Hover.from(fe)}}class k{constructor(B,x){this.d=B,this.e=x}async provideEvaluatableExpression(B,x,se){const H=this.d.getDocument(B),ue=f.Position.to(x),fe=await this.e.provideEvaluatableExpression(H,ue,se);if(fe)return f.EvaluatableExpression.from(fe)}}class C{constructor(B,x){this.d=B,this.e=x}async provideInlineValues(B,x,se,H){const ue=this.d.getDocument(B),fe=await this.e.provideInlineValues(ue,f.Range.to(x),f.InlineValueContext.to(se),H);if(Array.isArray(fe))return fe.map(Re=>f.InlineValue.from(Re))}}class j{constructor(B,x){this.d=B,this.e=x}async provideDocumentHighlights(B,x,se){const H=this.d.getDocument(B),ue=f.Position.to(x),fe=await this.e.provideDocumentHighlights(H,ue,se);if(Array.isArray(fe))return fe.map(f.DocumentHighlight.from)}}class z{constructor(B,x){this.d=B,this.e=x}async provideMultiDocumentHighlights(B,x,se,H){const ue=this.d.getDocument(B),fe=se.map(Ge=>this.d.getDocument(Ge)),Re=f.Position.to(x),Oe=await this.e.provideMultiDocumentHighlights(ue,Re,fe,H);if(Array.isArray(Oe))return Oe.map(f.MultiDocumentHighlight.from)}}class O{constructor(B,x){this.d=B,this.e=x}async provideLinkedEditingRanges(B,x,se){const H=this.d.getDocument(B),ue=f.Position.to(x),fe=await this.e.provideLinkedEditingRanges(H,ue,se);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,L.$Hb)(fe.ranges.map(f.Range.from)),wordPattern:fe.wordPattern}}}class U{constructor(B,x){this.d=B,this.e=x}async provideReferences(B,x,se,H){const ue=this.d.getDocument(B),fe=f.Position.to(x),Re=await this.e.provideReferences(ue,fe,se,H);if(Array.isArray(Re))return Re.map(f.location.from)}}class N{constructor(B,x,se,H,ue,fe,Re){this.g=B,this.h=x,this.j=se,this.k=H,this.l=ue,this.m=fe,this.n=Re,this.e=new n.$afc("CodeAction"),this.f=new Map}async provideCodeActions(B,x,se,H){const ue=this.g.getDocument(B),fe=$.$Js.isISelection(x)?f.Selection.to(x):f.Range.to(x),Re=[];for(const ct of this.j.getDiagnostics(B))if(fe.intersection(ct.range)&&Re.push(ct)>N.d)break;const Oe={diagnostics:Re,only:se.only?new A.$$K(se.only):void 0,triggerKind:f.CodeActionTriggerKind.to(se.trigger)},Ge=await this.k.provideCodeActions(ue,fe,Oe,H);if(!(0,L.$Lb)(Ge)||H.isCancellationRequested)return;const He=this.e.add(Ge),et=new u.$Rc;this.f.set(He,et);const lt=[];for(let ct=0;ct<Ge.length;ct++){const ot=Ge[ct];ot&&(N.o(ot)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:ot.title,command:this.h.toInternal(ot,et)})):(Oe.only&&(ot.kind?Oe.only.contains(ot.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${ot.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),lt.push({cacheId:[He,ct],title:ot.title,command:ot.command&&this.h.toInternal(ot.command,et),diagnostics:ot.diagnostics&&ot.diagnostics.map(f.Diagnostic.from),edit:ot.edit&&f.WorkspaceEdit.from(ot.edit,void 0),kind:ot.kind&&ot.kind.value,isPreferred:ot.isPreferred,isAI:(0,t.$kF)(this.m,"codeActionAI")?ot.isAI:!1,disabled:ot.disabled?.reason})))}return{cacheId:He,actions:lt}}async resolveCodeAction(B,x){const[se,H]=B,ue=this.e.get(se,H);if(!ue||N.o(ue))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ue,x)??ue;let Re;fe.edit&&(Re=f.WorkspaceEdit.from(fe.edit,void 0));let Oe;if(fe.command){const Ge=this.f.get(se);Ge&&(Oe=this.h.toInternal(fe.command,Ge))}return{edit:Re,command:Oe}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}N.d=1e3;class R{static toInternalProviderId(B,x){return B+"."+x}constructor(B,x,se,H,ue){this.d=B,this.e=x,this.f=se,this.g=H,this.h=ue}async prepareDocumentPaste(B,x,se,H){if(!this.f.prepareDocumentPaste)return;const ue=this.e.getDocument(B),fe=x.map(Ge=>f.Range.to(Ge)),Re=f.DataTransfer.toDataTransfer(se,()=>{throw new s.$$});if(await this.f.prepareDocumentPaste(ue,fe,Re,H),H.isCancellationRequested)return;const Oe=Array.from(Re).filter(([,Ge])=>!(Ge instanceof A.$EL));return f.DataTransfer.from(Oe)}async providePasteEdits(B,x,se,H,ue){if(!this.f.provideDocumentPasteEdits)return;const fe=this.e.getDocument(x),Re=se.map(He=>f.Range.to(He)),Oe=f.DataTransfer.toDataTransfer(H,async He=>(await this.d.$resolvePasteFileData(this.g,B,He)).buffer),Ge=await this.f.provideDocumentPasteEdits(fe,Re,Oe,ue);if(Ge)return{label:Ge.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ge.yieldTo?.map(He=>"mimeType"in He?He:{providerId:R.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?f.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class T{constructor(B,x){this.d=B,this.e=x}async provideDocumentFormattingEdits(B,x,se){const H=this.d.getDocument(B),ue=await this.e.provideDocumentFormattingEdits(H,x,se);if(Array.isArray(ue))return ue.map(f.TextEdit.from)}}class q{constructor(B,x){this.d=B,this.e=x}async provideDocumentRangeFormattingEdits(B,x,se,H){const ue=this.d.getDocument(B),fe=f.Range.to(x),Re=await this.e.provideDocumentRangeFormattingEdits(ue,fe,se,H);if(Array.isArray(Re))return Re.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,x,se,H){(0,I.$Of)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ue=this.d.getDocument(B),fe=x.map(f.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ue,fe,se,H);if(Array.isArray(Re))return Re.map(f.TextEdit.from)}}class ee{constructor(B,x){this.d=B,this.e=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,x,se,H,ue){const fe=this.d.getDocument(B),Re=f.Position.to(x),Oe=await this.e.provideOnTypeFormattingEdits(fe,Re,se,H,ue);if(Array.isArray(Oe))return Oe.map(f.TextEdit.from)}}class J{constructor(B,x){this.e=B,this.f=x,this.d=new n.$afc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,x){const se=await this.e.provideWorkspaceSymbols(B,x);if(!(0,L.$Lb)(se))return{symbols:[]};const H=this.d.add(se),ue={cacheId:H,symbols:[]};for(let fe=0;fe<se.length;fe++){const Re=se[fe];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ue.symbols.push({...f.WorkspaceSymbol.from(Re),cacheId:[H,fe]})}return ue}async resolveWorkspaceSymbol(B,x){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const se=this.d.get(...B.cacheId);if(se){const H=await this.e.resolveWorkspaceSymbol(se,x);return H&&(0,F.$ln)(B,f.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class K{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,x,se){this.d=B,this.e=x,this.f=se}async provideRenameEdits(B,x,se,H){const ue=this.d.getDocument(B),fe=f.Position.to(x);try{const Re=await this.e.provideRenameEdits(ue,fe,se,H);return Re?f.WorkspaceEdit.from(Re):void 0}catch(Re){const Oe=K.g(Re);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(B,x,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(B),ue=f.Position.to(x);try{const fe=await this.e.prepareRename(H,ue,se);let Re,Oe;if(A.$RK.isRange(fe)?(Re=fe,Oe=H.getText(fe)):(0,I.$Gf)(fe)&&(Re=fe.range,Oe=fe.placeholder),!Re||!Oe)return;if(Re.start.line>ue.line||Re.end.line<ue.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(Re),text:Oe}}catch(fe){const Re=K.g(fe);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(fe)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Z{constructor(B,x){this.resultId=B,this.tokens=x}}class ae{constructor(B,x){this.f=B,this.g=x,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,x,se){const H=this.f.getDocument(B),ue=x!==0?this.d.get(x):null;let fe=typeof ue?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ue.resultId,se):await this.g.provideDocumentSemanticTokens(H,se);return ue&&this.d.delete(x),fe?(fe=ae.h(fe),this.o(ae.n(ue,fe),fe)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return ae.j(B)?ae.k(B)?B:new A.$8L(new Uint32Array(B.data),B.resultId):ae.l(B)?ae.m(B)?B:new A.$0L(B.edits.map(x=>new A.$9L(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const x of B.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static n(B,x){if(!ae.j(x)||!B||!B.tokens)return x;const se=B.tokens,H=se.length,ue=x.data,fe=ue.length;let Re=0;const Oe=Math.min(H,fe);for(;Re<Oe&&se[Re]===ue[Re];)Re++;if(Re===H&&Re===fe)return new A.$0L([],x.resultId);let Ge=0;const He=Oe-Re;for(;Ge<He&&se[H-Ge-1]===ue[fe-Ge-1];)Ge++;return new A.$0L([{start:Re,deleteCount:H-Re-Ge,data:ue.subarray(Re,fe-Ge)}],x.resultId)}o(B,x){if(ae.j(B)){const se=this.e++;return this.d.set(se,new Z(B.resultId,B.data)),(0,g.$m$)({id:se,type:"full",data:B.data})}if(ae.l(B)){const se=this.e++;return ae.j(x)?this.d.set(se,new Z(x.resultId,x.data)):this.d.set(se,new Z(B.resultId)),(0,g.$m$)({id:se,type:"delta",deltas:(B.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class _{constructor(B,x){this.d=B,this.e=x}async provideDocumentRangeSemanticTokens(B,x,se){const H=this.d.getDocument(B),ue=await this.e.provideDocumentRangeSemanticTokens(H,f.Range.to(x),se);return ue?this.f(ue):null}f(B){return(0,g.$m$)({id:0,type:"full",data:B.data})}}class ye{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,x,se,H,ue){this.f=B,this.g=x,this.h=se,this.j=H,this.k=ue,this.d=new n.$afc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,x,se,H){const ue=this.f.getDocument(B),fe=f.Position.to(x),Re=ue.getWordRangeAtPosition(fe)||new A.$RK(fe,fe),Oe=Re.with({end:fe}),Ge=new i.$Od,He=await this.h.provideCompletionItems(ue,fe,H,f.CompletionContext.to(se));if(!He||H.isCancellationRequested)return;const et=Array.isArray(He)?new A.$lL(He):He,lt=ye.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),ct=new u.$Rc;this.e.set(lt,ct);const ot=[],Pe={x:lt,b:ot,a:{replace:f.Range.from(Re),insert:f.Range.from(Oe)},c:et.isIncomplete||void 0,d:Ge.elapsed()};for(let Ue=0;Ue<et.items.length;Ue++){const Ae=et.items[Ue],Xe=this.l(Ae,[lt,Ue],Oe,Re);ot.push(Xe)}return Pe}async resolveCompletionItem(B,x){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...B);if(!se)return;const H=this.l(se,B),ue=await this.h.resolveCompletionItem(se,x);if(!ue)return;const fe=this.l(ue,B);return(H.h!==fe.h||H.i!==fe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==fe.n||H.o!==fe.o||!(0,F.$mn)(H.p,fe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:fe.d,c:fe.c,l:fe.l,h:fe.h,i:fe.i,n:fe.n,o:fe.o,p:fe.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,x,se,H){const ue=this.e.get(x[0]);if(!ue)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(B.command,ue),Re={x,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=B.textEdit.newText):typeof B.insertText=="string"?Re.h=B.insertText:B.insertText instanceof A.$1K&&(Re.h=B.insertText.value,Re.i|=4);let Oe;return B.textEdit?Oe=B.textEdit.range:B.range&&(Oe=B.range),A.$RK.isRange(Oe)?Re.j=f.Range.from(Oe):Oe&&(!se?.isEqual(Oe.inserting)||!H?.isEqual(Oe.replacing))&&(Re.j={insert:f.Range.from(Oe.inserting),replace:f.Range.from(Oe.replacing)}),Re}}class ge{async provideInlineCompletions(B,x,se,H){}disposeCompletions(B){}handleDidShowCompletionItem(B,x,se){}handlePartialAccept(B,x,se){}}class re extends ge{constructor(B,x,se,H){super(),this.f=B,this.g=x,this.h=se,this.j=H,this.d=new W,this.e=(0,t.$kF)(this.f,"inlineCompletionsAdditions"),this.k={[M.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[M.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$kF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,x,se,H){const ue=this.g.getDocument(B),fe=f.Position.to(x),Re=await this.h.provideInlineCompletionItems(ue,fe,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:f.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},H);if(!Re||H.isCancellationRequested)return;const Oe=Array.isArray(Re)?Re:Re.items,Ge=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],He=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Oe}),items:Oe.map((ct,ot)=>{let Pe;ct.command&&(et||(et=new u.$Rc),Pe=this.j.toInternal(ct.command,et));const Ue=ct.insertText;return{insertText:typeof Ue=="string"?Ue:{snippet:Ue.value},filterText:ct.filterText,range:ct.range?f.Range.from(ct.range):void 0,command:Pe,idx:ot,completeBracketPairs:this.e?ct.completeBracketPairs:!1}}),commands:Ge.map(ct=>(et||(et=new u.$Rc),this.j.toInternal(ct,et))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,x,se){const H=this.d.get(B)?.items[x];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,se)}handlePartialAccept(B,x,se){const H=this.d.get(B)?.items[x];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,se)}}class W{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const x=this.e++;return this.d.set(x,B),x}disposeReferenceId(B){const x=this.d.get(B);return this.d.delete(B),x}get(B){return this.d.get(B)}}class ce{constructor(B,x){this.e=B,this.f=x,this.d=new n.$afc("SignatureHelp")}async provideSignatureHelp(B,x,se,H){const ue=this.e.getDocument(B),fe=f.Position.to(x),Re=this.g(se),Oe=await this.f.provideSignatureHelp(ue,fe,H,Re);if(Oe){const Ge=this.d.add([Oe]);return{...f.SignatureHelp.from(Oe),id:Ge}}}g(B){let x;if(B.activeSignatureHelp){const se=f.SignatureHelp.to(B.activeSignatureHelp),H=this.d.get(B.activeSignatureHelp.id,0);H?(x=H,x.activeSignature=se.activeSignature,x.activeParameter=se.activeParameter):x=se}return{...B,activeSignatureHelp:x}}releaseSignatureHelp(B){this.d.delete(B)}}class me{constructor(B,x,se,H,ue){this.f=B,this.g=x,this.h=se,this.j=H,this.k=ue,this.d=new n.$afc("InlayHints"),this.e=new Map}async provideInlayHints(B,x,se){const H=this.f.getDocument(B),ue=f.Range.to(x),fe=await this.h.provideInlayHints(H,ue,se);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(x)}`);return}if(se.isCancellationRequested)return;const Re=this.d.add(fe);this.e.set(Re,new u.$Rc);const Oe={hints:[],cacheId:Re};for(let Ge=0;Ge<fe.length;Ge++)this.l(fe[Ge],ue)&&Oe.hints.push(this.m(fe[Ge],[Re,Ge]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(x)}`),Oe}async resolveInlayHint(B,x){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...B);if(!se)return;const H=await this.h.resolveInlayHint(se,x);if(H&&this.l(H))return this.m(H,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,x){return B.label.length===0||Array.isArray(B.label)&&B.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(x&&!x.contains(B.position))}m(B,x){const se=this.e.get(x[0]);if(!se)throw Error("DisposableStore is missing...");const H={label:"",cacheId:x,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?H.label=B.label:H.label=B.label.map(ue=>{const fe={label:ue.value};return fe.tooltip=f.MarkdownString.fromStrict(ue.tooltip),A.$2K.isLocation(ue.location)&&(fe.location=f.location.from(ue.location)),ue.command&&(fe.command=this.g.toInternal(ue.command,se)),fe}),H}}class le{constructor(B,x){this.e=B,this.f=x,this.d=new n.$afc("DocumentLink")}async provideLinks(B,x){const se=this.e.getDocument(B),H=await this.f.provideDocumentLinks(se,x);if(!(!Array.isArray(H)||H.length===0)&&!x.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(le.g).map(f.DocumentLink.from)};{const ue=this.d.add(H),fe={links:[],cacheId:ue};for(let Re=0;Re<H.length;Re++){if(!le.g(H[Re]))continue;const Oe=f.DocumentLink.from(H[Re]);Oe.cacheId=[ue,Re],fe.links.push(Oe)}return fe}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,x){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...B);if(!se)return;const H=await this.f.resolveDocumentLink(se,x);if(!(!H||!le.g(H)))return f.DocumentLink.from(H)}releaseLinks(B){this.d.delete(B)}}class de{constructor(B,x){this.d=B,this.e=x}async provideColors(B,x){const se=this.d.getDocument(B),H=await this.e.provideDocumentColors(se,x);return Array.isArray(H)?H.map(fe=>({color:f.Color.from(fe.color),range:f.Range.from(fe.range)})):[]}async provideColorPresentations(B,x,se){const H=this.d.getDocument(B),ue=f.Range.to(x.range),fe=f.Color.to(x.color),Re=await this.e.provideColorPresentations(fe,{document:H,range:ue},se);if(Array.isArray(Re))return Re.map(f.ColorPresentation.from)}}class Y{constructor(B,x){this.d=B,this.e=x}async provideFoldingRanges(B,x,se){const H=this.d.getDocument(B),ue=await this.e.provideFoldingRanges(H,x,se);if(Array.isArray(ue))return ue.map(f.FoldingRange.from)}}class X{constructor(B,x,se){this.d=B,this.e=x,this.f=se}async provideSelectionRanges(B,x,se){const H=this.d.getDocument(B),ue=x.map(f.Position.to),fe=await this.e.provideSelectionRanges(H,ue,se);if(!(0,L.$Lb)(fe))return[];if(fe.length!==ue.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Oe=0;Oe<ue.length;Oe++){const Ge=[];Re.push(Ge);let He=ue[Oe],et=fe[Oe];for(;;){if(!et.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(f.SelectionRange.from(et)),!et.parent)break;He=et.range,et=et.parent}}return Re}}class Q{constructor(B,x){this.f=B,this.g=x,this.d=new o.$WM(""),this.e=new Map}async prepareSession(B,x,se){const H=this.f.getDocument(B),ue=f.Position.to(x),fe=await this.g.prepareCallHierarchy(H,ue,se);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Oe=>this.h(Re,Oe)):[this.h(Re,fe)]}async provideCallsTo(B,x,se){const H=this.j(B,x);if(!H)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyIncomingCalls(H,se);if(ue)return ue.map(fe=>({from:this.h(B,fe.from),fromRanges:fe.fromRanges.map(Re=>f.Range.from(Re))}))}async provideCallsFrom(B,x,se){const H=this.j(B,x);if(!H)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyOutgoingCalls(H,se);if(ue)return ue.map(fe=>({to:this.h(B,fe.to),fromRanges:fe.fromRanges.map(Re=>f.Range.from(Re))}))}releaseSession(B){this.e.delete(B)}h(B,x){const se=this.e.get(B),H=f.CallHierarchyItem.from(x,B,se.size.toString(36));return se.set(H._itemId,x),H}j(B,x){return this.e.get(B)?.get(x)}}class te{constructor(B,x){this.f=B,this.g=x,this.d=new o.$WM(""),this.e=new Map}async prepareSession(B,x,se){const H=this.f.getDocument(B),ue=f.Position.to(x),fe=await this.g.prepareTypeHierarchy(H,ue,se);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Oe=>this.h(Re,Oe)):[this.h(Re,fe)]}async provideSupertypes(B,x,se){const H=this.j(B,x);if(!H)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySupertypes(H,se);if(ue)return ue.map(fe=>this.h(B,fe))}async provideSubtypes(B,x,se){const H=this.j(B,x);if(!H)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySubtypes(H,se);if(ue)return ue.map(fe=>this.h(B,fe))}releaseSession(B){this.e.delete(B)}h(B,x){const se=this.e.get(B),H=f.TypeHierarchyItem.from(x,B,se.size.toString(36));return se.set(H._itemId,x),H}j(B,x){return this.e.get(B)?.get(x)}}class $e{static toInternalProviderId(B,x){return B+"."+x}constructor(B,x,se,H,ue){this.d=B,this.e=x,this.f=se,this.g=H,this.h=ue}async provideDocumentOnDropEdits(B,x,se,H,ue){const fe=this.e.getDocument(x),Re=f.Position.to(se),Oe=f.DataTransfer.toDataTransfer(H,async He=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,He)).buffer),Ge=await this.f.provideDocumentDropEdits(fe,Re,Oe,ue);if(Ge)return{label:Ge.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ge.yieldTo?.map(He=>"mimeType"in He?He:{providerId:$e.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?f.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class ve{constructor(B,x){this.d=B,this.e=x}async provideMappedEdits(B,x,se,H){const ue=E.URI.revive(B),fe=this.d.getDocument(ue),Re=se.documents.map(He=>He.map(et=>({uri:E.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(lt=>f.Range.to(lt))}))),Oe={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(fe,x,Oe,H);return Ge?f.WorkspaceEdit.from(Ge):null}}class Le{constructor(B,x){this.adapter=B,this.extension=x}}class pe{constructor(B,x,se,H,ue,fe,Re,Oe){this.g=x,this.h=se,this.j=H,this.k=ue,this.l=fe,this.m=Re,this.n=Oe,this.f=new Map,this.e=B.getProxy(b.$NK.MainThreadLanguageFeatures)}o(B,x){return f.DocumentSelector.from(B,this.g,x)}p(B){return new A.$PK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return pe.d++}async s(B,x,se,H,ue,fe=!1){const Re=this.f.get(B);if(!Re||!(Re.adapter instanceof x))return H;const Oe=Date.now();fe||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const Ge=se(Re.adapter,Re.extension);return Promise.resolve(Ge).catch(He=>{(0,s.$4)(He)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(Re.extension.identifier,He))}).finally(()=>{fe||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),y.CancellationToken.isCancellationToken(ue)?(0,a.$Rg)(Ge,ue):Ge}t(B,x){const se=this.q();return this.f.set(se,new Le(B,x)),se}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,x,se,H){const ue=this.t(new d(this.h,se),B),fe=H&&H.label||pe.u(B);return this.e.$registerDocumentSymbolProvider(ue,this.o(x,B),fe),this.p(ue)}$provideDocumentSymbols(B,x,se){return this.s(B,d,H=>H.provideDocumentSymbols(E.URI.revive(x),se),void 0,se)}registerCodeLensProvider(B,x,se){const H=this.q(),ue=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Le(new l(this.h,this.j.converter,se),B)),this.e.$registerCodeLensSupport(H,this.o(x,B),ue);let fe=this.p(H);if(ue!==void 0){const Re=se.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(ue));fe=A.$PK.from(fe,Re)}return fe}$provideCodeLenses(B,x,se){return this.s(B,l,H=>H.provideCodeLenses(E.URI.revive(x),se),void 0,se)}$resolveCodeLens(B,x,se){return this.s(B,l,H=>H.resolveCodeLens(x,se),void 0,void 0)}$releaseCodeLenses(B,x){this.s(B,l,se=>Promise.resolve(se.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(B,x,se){const H=this.t(new c(this.h,se),B);return this.e.$registerDefinitionSupport(H,this.o(x,B)),this.p(H)}$provideDefinition(B,x,se,H){return this.s(B,c,ue=>ue.provideDefinition(E.URI.revive(x),se,H),[],H)}registerDeclarationProvider(B,x,se){const H=this.t(new v(this.h,se),B);return this.e.$registerDeclarationSupport(H,this.o(x,B)),this.p(H)}$provideDeclaration(B,x,se,H){return this.s(B,v,ue=>ue.provideDeclaration(E.URI.revive(x),se,H),[],H)}registerImplementationProvider(B,x,se){const H=this.t(new P(this.h,se),B);return this.e.$registerImplementationSupport(H,this.o(x,B)),this.p(H)}$provideImplementation(B,x,se,H){return this.s(B,P,ue=>ue.provideImplementation(E.URI.revive(x),se,H),[],H)}registerTypeDefinitionProvider(B,x,se){const H=this.t(new S(this.h,se),B);return this.e.$registerTypeDefinitionSupport(H,this.o(x,B)),this.p(H)}$provideTypeDefinition(B,x,se,H){return this.s(B,S,ue=>ue.provideTypeDefinition(E.URI.revive(x),se,H),[],H)}registerHoverProvider(B,x,se,H){const ue=this.t(new p(this.h,se),B);return this.e.$registerHoverProvider(ue,this.o(x,B)),this.p(ue)}$provideHover(B,x,se,H){return this.s(B,p,ue=>ue.provideHover(E.URI.revive(x),se,H),void 0,H)}registerEvaluatableExpressionProvider(B,x,se,H){const ue=this.t(new k(this.h,se),B);return this.e.$registerEvaluatableExpressionProvider(ue,this.o(x,B)),this.p(ue)}$provideEvaluatableExpression(B,x,se,H){return this.s(B,k,ue=>ue.provideEvaluatableExpression(E.URI.revive(x),se,H),void 0,H)}registerInlineValuesProvider(B,x,se,H){const ue=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new C(this.h,se),B);this.e.$registerInlineValuesProvider(fe,this.o(x,B),ue);let Re=this.p(fe);if(ue!==void 0){const Oe=se.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(ue));Re=A.$PK.from(Re,Oe)}return Re}$provideInlineValues(B,x,se,H,ue){return this.s(B,C,fe=>fe.provideInlineValues(E.URI.revive(x),se,H,ue),void 0,ue)}registerDocumentHighlightProvider(B,x,se){const H=this.t(new j(this.h,se),B);return this.e.$registerDocumentHighlightProvider(H,this.o(x,B)),this.p(H)}registerMultiDocumentHighlightProvider(B,x,se){const H=this.t(new z(this.h,se),B);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(x,B)),this.p(H)}$provideDocumentHighlights(B,x,se,H){return this.s(B,j,ue=>ue.provideDocumentHighlights(E.URI.revive(x),se,H),void 0,H)}$provideMultiDocumentHighlights(B,x,se,H,ue){return this.s(B,z,fe=>fe.provideMultiDocumentHighlights(E.URI.revive(x),se,H.map(Re=>E.URI.revive(Re)),ue),void 0,ue)}registerLinkedEditingRangeProvider(B,x,se){const H=this.t(new O(this.h,se),B);return this.e.$registerLinkedEditingRangeProvider(H,this.o(x,B)),this.p(H)}$provideLinkedEditingRanges(B,x,se,H){return this.s(B,O,async ue=>{const fe=await ue.provideLinkedEditingRanges(E.URI.revive(x),se,H);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?pe.w(fe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(B,x,se){const H=this.t(new U(this.h,se),B);return this.e.$registerReferenceSupport(H,this.o(x,B)),this.p(H)}$provideReferences(B,x,se,H,ue){return this.s(B,U,fe=>fe.provideReferences(E.URI.revive(x),se,H,ue),void 0,ue)}registerCodeActionProvider(B,x,se,H){const ue=new u.$Rc,fe=this.t(new N(this.h,this.j.converter,this.k,se,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(fe,this.o(x,B),{providedKinds:H?.providedCodeActionKinds?.map(Re=>Re.value),documentation:H?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ue)}))},pe.u(B),!!se.resolveCodeAction),ue.add(this.p(fe)),ue}$provideCodeActions(B,x,se,H,ue){return this.s(B,N,fe=>fe.provideCodeActions(E.URI.revive(x),se,H,ue),void 0,ue)}$resolveCodeAction(B,x,se){return this.s(B,N,H=>H.resolveCodeAction(x,se),{},void 0)}$releaseCodeActions(B,x){this.s(B,N,se=>Promise.resolve(se.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(B,x,se){const H=this.t(new T(this.h,se),B);return this.e.$registerDocumentFormattingSupport(H,this.o(x,B),B.identifier,B.displayName||B.name),this.p(H)}$provideDocumentFormattingEdits(B,x,se,H){return this.s(B,T,ue=>ue.provideDocumentFormattingEdits(E.URI.revive(x),se,H),void 0,H)}registerDocumentRangeFormattingEditProvider(B,x,se){const H=typeof se.provideDocumentRangesFormattingEdits=="function",ue=this.t(new q(this.h,se),B);return this.e.$registerRangeFormattingSupport(ue,this.o(x,B),B.identifier,B.displayName||B.name,H),this.p(ue)}$provideDocumentRangeFormattingEdits(B,x,se,H,ue){return this.s(B,q,fe=>fe.provideDocumentRangeFormattingEdits(E.URI.revive(x),se,H,ue),void 0,ue)}$provideDocumentRangesFormattingEdits(B,x,se,H,ue){return this.s(B,q,fe=>fe.provideDocumentRangesFormattingEdits(E.URI.revive(x),se,H,ue),void 0,ue)}registerOnTypeFormattingEditProvider(B,x,se,H){const ue=this.t(new ee(this.h,se),B);return this.e.$registerOnTypeFormattingSupport(ue,this.o(x,B),H,B.identifier),this.p(ue)}$provideOnTypeFormattingEdits(B,x,se,H,ue,fe){return this.s(B,ee,Re=>Re.provideOnTypeFormattingEdits(E.URI.revive(x),se,H,ue,fe),void 0,fe)}registerWorkspaceSymbolProvider(B,x){const se=this.t(new J(x,this.l),B);return this.e.$registerNavigateTypeSupport(se,typeof x.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(B,x,se){return this.s(B,J,H=>H.provideWorkspaceSymbols(x,se),{symbols:[]},se)}$resolveWorkspaceSymbol(B,x,se){return this.s(B,J,H=>H.resolveWorkspaceSymbol(x,se),void 0,void 0)}$releaseWorkspaceSymbols(B,x){this.s(B,J,se=>se.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(B,x,se){const H=this.t(new K(this.h,se,this.l),B);return this.e.$registerRenameSupport(H,this.o(x,B),K.supportsResolving(se)),this.p(H)}$provideRenameEdits(B,x,se,H,ue){return this.s(B,K,fe=>fe.provideRenameEdits(E.URI.revive(x),se,H,ue),void 0,ue)}$resolveRenameLocation(B,x,se,H){return this.s(B,K,ue=>ue.resolveRenameLocation(E.URI.revive(x),se,H),void 0,H)}registerDocumentSemanticTokensProvider(B,x,se,H){const ue=this.t(new ae(this.h,se),B),fe=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ue,this.o(x,B),H,fe);let Re=this.p(ue);if(fe){const Oe=se.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(fe));Re=A.$PK.from(Re,Oe)}return Re}$provideDocumentSemanticTokens(B,x,se,H){return this.s(B,ae,ue=>ue.provideDocumentSemanticTokens(E.URI.revive(x),se,H),null,H)}$releaseDocumentSemanticTokens(B,x){this.s(B,ae,se=>se.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,x,se,H){const ue=this.t(new _(this.h,se),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ue,this.o(x,B),H),this.p(ue)}$provideDocumentRangeSemanticTokens(B,x,se,H){return this.s(B,_,ue=>ue.provideDocumentRangeSemanticTokens(E.URI.revive(x),se,H),null,H)}registerCompletionItemProvider(B,x,se,H){const ue=this.t(new ye(this.h,this.j.converter,se,this.m,B),B);return this.e.$registerCompletionsProvider(ue,this.o(x,B),H,ye.supportsResolving(se),B.identifier),this.p(ue)}$provideCompletionItems(B,x,se,H,ue){return this.s(B,ye,fe=>fe.provideCompletionItems(E.URI.revive(x),se,H,ue),void 0,ue)}$resolveCompletionItem(B,x,se){return this.s(B,ye,H=>H.resolveCompletionItem(x,se),void 0,se)}$releaseCompletionItems(B,x){this.s(B,ye,se=>se.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(B,x,se,H){const ue=new re(B,this.h,se,this.j.converter),fe=this.t(ue,B);return this.e.$registerInlineCompletionsSupport(fe,this.o(x,B),ue.supportsHandleEvents,D.$hm.toKey(B.identifier.value),H?.yieldTo?.map(Re=>D.$hm.toKey(Re))||[]),this.p(fe)}$provideInlineCompletions(B,x,se,H,ue){return this.s(B,ge,fe=>fe.provideInlineCompletions(E.URI.revive(x),se,H,ue),void 0,ue)}$handleInlineCompletionDidShow(B,x,se,H){this.s(B,ge,async ue=>{ue.handleDidShowCompletionItem(x,se,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,x,se,H){this.s(B,ge,async ue=>{ue.handlePartialAccept(x,se,H)},void 0,void 0)}$freeInlineCompletionsList(B,x){this.s(B,ge,async se=>{se.disposeCompletions(x)},void 0,void 0)}registerSignatureHelpProvider(B,x,se,H){const ue=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,fe=this.t(new ce(this.h,se),B);return this.e.$registerSignatureHelpProvider(fe,this.o(x,B),ue),this.p(fe)}$provideSignatureHelp(B,x,se,H,ue){return this.s(B,ce,fe=>fe.provideSignatureHelp(E.URI.revive(x),se,H,ue),void 0,ue)}$releaseSignatureHelp(B,x){this.s(B,ce,se=>se.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(B,x,se){const H=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,ue=this.t(new me(this.h,this.j.converter,se,this.l,B),B);this.e.$registerInlayHintsProvider(ue,this.o(x,B),typeof se.resolveInlayHint=="function",H,pe.u(B));let fe=this.p(ue);if(H!==void 0){const Re=se.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(H));fe=A.$PK.from(fe,Re)}return fe}$provideInlayHints(B,x,se,H){return this.s(B,me,ue=>ue.provideInlayHints(E.URI.revive(x),se,H),void 0,H)}$resolveInlayHint(B,x,se){return this.s(B,me,H=>H.resolveInlayHint(x,se),void 0,se)}$releaseInlayHints(B,x){this.s(B,me,se=>se.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(B,x,se){const H=this.t(new le(this.h,se),B);return this.e.$registerDocumentLinkProvider(H,this.o(x,B),typeof se.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(B,x,se){return this.s(B,le,H=>H.provideLinks(E.URI.revive(x),se),void 0,se,x.scheme==="output")}$resolveDocumentLink(B,x,se){return this.s(B,le,H=>H.resolveLink(x,se),void 0,void 0,!0)}$releaseDocumentLinks(B,x){this.s(B,le,se=>se.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(B,x,se){const H=this.t(new de(this.h,se),B);return this.e.$registerDocumentColorProvider(H,this.o(x,B)),this.p(H)}$provideDocumentColors(B,x,se){return this.s(B,de,H=>H.provideColors(E.URI.revive(x),se),[],se)}$provideColorPresentations(B,x,se,H){return this.s(B,de,ue=>ue.provideColorPresentations(E.URI.revive(x),se,H),void 0,H)}registerFoldingRangeProvider(B,x,se){const H=this.q(),ue=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Le(new Y(this.h,se),B)),this.e.$registerFoldingRangeProvider(H,this.o(x,B),B.identifier,ue);let fe=this.p(H);if(ue!==void 0){const Re=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ue));fe=A.$PK.from(fe,Re)}return fe}$provideFoldingRanges(B,x,se,H){return this.s(B,Y,ue=>ue.provideFoldingRanges(E.URI.revive(x),se,H),void 0,H)}registerSelectionRangeProvider(B,x,se){const H=this.t(new X(this.h,se,this.l),B);return this.e.$registerSelectionRangeProvider(H,this.o(x,B)),this.p(H)}$provideSelectionRanges(B,x,se,H){return this.s(B,X,ue=>ue.provideSelectionRanges(E.URI.revive(x),se,H),[],H)}registerCallHierarchyProvider(B,x,se){const H=this.t(new Q(this.h,se),B);return this.e.$registerCallHierarchyProvider(H,this.o(x,B)),this.p(H)}$prepareCallHierarchy(B,x,se,H){return this.s(B,Q,ue=>Promise.resolve(ue.prepareSession(E.URI.revive(x),se,H)),void 0,H)}$provideCallHierarchyIncomingCalls(B,x,se,H){return this.s(B,Q,ue=>ue.provideCallsTo(x,se,H),void 0,H)}$provideCallHierarchyOutgoingCalls(B,x,se,H){return this.s(B,Q,ue=>ue.provideCallsFrom(x,se,H),void 0,H)}$releaseCallHierarchy(B,x){this.s(B,Q,se=>Promise.resolve(se.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(B,x,se){const H=this.t(new te(this.h,se),B);return this.e.$registerTypeHierarchyProvider(H,this.o(x,B)),this.p(H)}$prepareTypeHierarchy(B,x,se,H){return this.s(B,te,ue=>Promise.resolve(ue.prepareSession(E.URI.revive(x),se,H)),void 0,H)}$provideTypeHierarchySupertypes(B,x,se,H){return this.s(B,te,ue=>ue.provideSupertypes(x,se,H),void 0,H)}$provideTypeHierarchySubtypes(B,x,se,H){return this.s(B,te,ue=>ue.provideSubtypes(x,se,H),void 0,H)}$releaseTypeHierarchy(B,x){this.s(B,te,se=>Promise.resolve(se.releaseSession(x)),void 0,void 0)}registerDocumentOnDropEditProvider(B,x,se,H){const ue=this.q();this.f.set(ue,new Le(new $e(this.e,this.h,se,ue,B),B));const fe=(0,t.$kF)(B,"dropMetadata")&&H?$e.toInternalProviderId(B.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ue,this.o(x,B),fe,(0,t.$kF)(B,"dropMetadata")?H:void 0),this.p(ue)}$provideDocumentOnDropEdits(B,x,se,H,ue,fe){return this.s(B,$e,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(x,E.URI.revive(se),H,ue,fe)),void 0,void 0)}registerMappedEditsProvider(B,x,se){const H=this.t(new ve(this.h,se),B);return this.e.$registerMappedEditsProvider(H,this.o(x,B)),this.p(H)}$provideMappedEdits(B,x,se,H,ue){return this.s(B,ve,fe=>Promise.resolve(fe.provideMappedEdits(x,se,H,ue)),null,ue)}registerDocumentPasteEditProvider(B,x,se,H){const ue=this.q();this.f.set(ue,new Le(new R(this.e,this.h,se,ue,B),B));const fe=R.toInternalProviderId(B.identifier.value,H.id);return this.e.$registerPasteEditProvider(ue,this.o(x,B),fe,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ue)}$prepareDocumentPaste(B,x,se,H,ue){return this.s(B,R,fe=>fe.prepareDocumentPaste(E.URI.revive(x),se,H,ue),void 0,ue)}$providePasteEdits(B,x,se,H,ue,fe){return this.s(B,R,Re=>Re.providePasteEdits(x,E.URI.revive(se),H,ue,fe),void 0,fe)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:pe.w(B.decreaseIndentPattern),increaseIndentPattern:pe.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?pe.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?pe.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:pe.w(B.beforeText),afterText:B.afterText?pe.w(B.afterText):void 0,previousLineText:B.previousLineText?pe.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(pe.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(x=>A.SyntaxTokenType.toString(x)):void 0}}static D(B){return B.map(pe.C)}setLanguageConfiguration(B,x,se){const{wordPattern:H}=se;if(H&&(0,m.$Ue)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(x,H):this.h.setWordDefinitionFor(x,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ue=this.q(),fe={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?pe.w(se.wordPattern):void 0,indentationRules:se.indentationRules?pe.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?pe.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?pe.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ue,x,fe),this.p(ue)}$setWordDefinitions(B){for(const x of B)this.h.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.$kfc=pe,pe.d=0}),define(Se[327],ke([1,0,6,15,7,40,10,3,25]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class w{constructor(I,$,y,D){this.c=$,this.d=y,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(E.$NK.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,$){await this.a.$changeLanguage(I,$);const y=this.c.getDocumentData(I);if(!y)throw new Error(`document '${I.toString()}' NOT found`);return y.document}async tokenAtPosition(I,$){const y=I.version,D=F.Position.from($),u=await this.a.$tokensAtPosition(I.uri,D),g={type:f.StandardTokenType.Other,range:I.getWordRangeAtPosition($)??new f.$RK($.line,$.character,$.line,$.character)};if(!u)return g;const o={range:F.Range.to(u.range),type:F.TokenType.to(u.type)};return!o.range.contains($)||y!==I.version?g:o}createLanguageStatusItem(I,$,y){const D=this.f++,u=this.a,g=this.g,o=`${I.identifier.value}/${$}`;if(g.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);g.add(o);const n={selector:y,id:$,name:I.displayName??I.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new b.$Rc,a=()=>{if(i?.dispose(),!g.has(o)){console.warn(`LanguageStatusItem (${$}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$4g)(()=>{s.clear(),this.a.$setLanguageStatus(D,{id:o,name:n.name??I.displayName??I.name,source:I.displayName??I.name,selector:F.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===f.LanguageStatusSeverity.Error?A.default.Error:n.severity===f.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:n.command&&this.d.toInternal(n.command,s),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){s.dispose(),i?.dispose(),u.$removeLanguageStatus(D),g.delete(o)},get id(){return n.id},get name(){return n.name},set name(r){n.name=r,a()},get selector(){return n.selector},set selector(r){n.selector=r,a()},get text(){return n.text},set text(r){n.text=r,a()},set text2(r){(0,m.$lF)(I,"languageStatusText"),n.text=r,a()},get text2(){return(0,m.$lF)(I,"languageStatusText"),n.text},get detail(){return n.detail},set detail(r){n.detail=r,a()},get severity(){return n.severity},set severity(r){n.severity=r,a()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(r){n.accessibilityInformation=r,a()},get command(){return n.command},set command(r){n.command=r,a()},get busy(){return n.busy},set busy(r){n.busy=r,a()}};return a(),t}}e.$Jgc=w}),define(Se[116],ke([1,0,9,13,2,5,14,6,27,20]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;let L=class{constructor($,y,D){this.f=D,this.d=new Map,this.a=y.getProxy(b.$NK.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===E.$a}getMessage($,y){const{message:D,args:u,comment:g}=y;if(this.c)return(0,F.$Ie)(D,u??{});let o=D;g&&g.length>0&&(o+=`/${Array.isArray(g)?g.join(""):g}`);const n=this.d.get($)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,F.$Ie)(n??D,u??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let y;const D=await this.g($);if(!D){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents(D),g=JSON.parse(u);y=$.isBuiltin?g.contents?.bundle:g}catch(u){this.f.error(`Failed to load translations for ${$.identifier.value} from ${D}: ${u.message}`);return}y&&this.d.set($.identifier.value,{contents:y,uri:D})}async g($){if($.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return f.URI.revive(y)}return $.l10n?f.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$8fc=L,e.$8fc=L=Qe([qe(0,m.$8M),qe(1,w.$RM),qe(2,M.$jj)],L),e.$9fc=(0,A.$2h)("IExtHostLocalizationService")}),define(Se[151],ke([1,0,14,6,27,20,2,54]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;let m=class extends E.$uj{constructor(I,$){super($.logLevel,$.logsLocation,$.loggers.map(y=>(0,b.$yh)(y))),this.r=I.getProxy(F.$NK.MainThreadLogger)}$setLogLevel(I,$){$?this.setLogLevel(M.URI.revive($),I):this.setLogLevel(I)}setVisibility(I,$){super.setVisibility(I,$),this.r.$setVisibility(I,$)}s(I,$,y){return new w(this.r,I,$,y)}};e.$ihc=m,e.$ihc=m=Qe([qe(0,A.$RM),qe(1,f.$8M)],m);class w extends E.$pj{constructor(I,$,y,D){super(D?.logLevel==="always"),this.r=I,this.s=$,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger($,D).then(()=>{this.u(this.n),this.m=!0})}g(I,$){const y=[[I,$]];this.m?this.u(y):this.n.push(...y)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(Se[117],ke([1,0,6,5,3,20,22]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0,e.$0fc=(0,F.$2h)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(E.$NK.MainThreadManagedSockets)}setFactory(I,$){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(I,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const $=++this.b,y=await this.c.makeConnection(),D=new f.$Rc;return this.d.set($,new w($,y,D)),D.add((0,f.$Qc)(()=>this.d.delete($))),D.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),D.dispose()})),D.add(y.onDidClose(u=>{this.a.$onDidManagedSocketClose($,u?.stack??u?.message),D.dispose()})),D.add(y.onDidReceiveMessage(u=>this.a.$onDidManagedSocketHaveData($,M.$ge.wrap(u)))),$}$remoteSocketWrite(I,$){this.d.get(I)?.actual.send($.buffer)}$remoteSocketEnd(I){const $=this.d.get(I);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$$fc=b,e.$$fc=b=Qe([qe(0,A.$RM)],b);class m{constructor(I,$){this.socketFactoryId=I,this.makeConnection=$}}class w extends f.$Sc{constructor(I,$,y){super(),this.socketId=I,this.actual=$,this.B(y)}}}),define(Se[328],ke([1,0,6,14,25]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;function A(b){return b&&b.title}let M=class{constructor(m,w){this.b=w,this.a=m.getProxy(E.$NK.MainThreadMessageService)}showMessage(m,w,L,I,$){const y={source:{identifier:m.identifier,label:m.displayName||m.name}};let D;typeof I=="string"||A(I)?D=[I,...$]:(y.modal=I?.modal,y.useCustom=I?.useCustom,y.detail=I?.detail,D=$),y.useCustom&&(0,f.$lF)(m,"resolvers");const u=[];for(let g=0;g<D.length;g++){const o=D[g];if(typeof o=="string")u.push({title:o,handle:g,isCloseAffordance:!1});else if(typeof o=="object"){const{title:n,isCloseAffordance:i}=o;u.push({title:n,isCloseAffordance:!!i,handle:g})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(w,L,y,u).then(g=>{if(typeof g=="number")return D[g]})}};e.$Kgc=M,e.$Kgc=M=Qe([qe(1,F.$jj)],M)}),define(Se[329],ke([1,0,19,10,21,4,3,28,2,26,14,6,35,15,7,114,285,25,68]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0;let i=class{constructor(c,v,P,S,p){this.m=v,this.n=P,this.o=S,this.q=p,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=c.getProxy(I.$NK.MainThreadNotebookKernels);const k=new $.$fN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$dN("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const j=this.n.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:j}}else if(C&&"notebookEditor"in C){const j=this.n.getIdByEditor(C.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return C})],$.$eN.Void);this.o.registerApiCommand(k)}createNotebookController(c,v,P,S,p,k){for(const _ of this.j.values())if(_.controller.id===v&&w.$hm.equals(c.identifier,_.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const C=this.k++,j=this;this.q.trace(`NotebookController[${C}], CREATED by ${c.identifier.value}, ${v}`);const z=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${c.identifier}'`);let O=!1;const U=new A.$Sd,N=new A.$Sd,R={id:l(c.identifier,v),notebookType:P,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:S||c.identifier.value,preloads:k?k.map(y.NotebookRendererScript.from):[]};let T=p??z,q,ee;this.a.$addKernel(C,R).catch(_=>{console.log(_),O=!0});let J=0;const K=()=>{if(O)return;const _=++J;Promise.resolve().then(()=>{_===J&&this.a.$updateKernel(C,R)})},Z=new b.$Ac,ae={get id(){return v},get notebookType(){return R.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return R.label},set label(_){R.label=_??c.displayName??c.name,K()},get detail(){return R.detail??""},set detail(_){R.detail=_,K()},get description(){return R.description??""},set description(_){R.description=_,K()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(_){R.supportedLanguages=_,K()},get supportsExecutionOrder(){return R.supportsExecutionOrder??!1},set supportsExecutionOrder(_){R.supportsExecutionOrder=_,K()},get rendererScripts(){return R.preloads?R.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return T},set executeHandler(_){T=_??z},get interruptHandler(){return q},set interruptHandler(_){q=_,R.supportsInterrupt=!!_,K()},set variableProvider(_){(0,o.$lF)(c,"notebookVariableProvider"),ee=_,R.hasVariableProvider=!!_,_?.onDidChangeVariables(ye=>j.a.$variablesUpdated(ye.uri)),K()},get variableProvider(){return ee},createNotebookCellExecution(_){if(O)throw new Error("notebook controller is DISPOSED");if(!Z.has(_.notebook.uri))throw j.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.notebook.uri.toString()}`);return j._createNotebookCellExecution(_,l(c.identifier,this.id))},createNotebookExecution(_){if((0,o.$lF)(c,"notebookExecution"),O)throw new Error("notebook controller is DISPOSED");if(!Z.has(_.uri))throw j.q.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.uri.toString()}`);return j._createNotebookExecution(_,l(c.identifier,this.id))},dispose:()=>{O||(this.q.trace(`NotebookController[${C}], DISPOSED`),O=!0,this.j.delete(C),U.dispose(),N.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(_,ye){ye===D.NotebookControllerAffinity2.Hidden&&(0,o.$lF)(c,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(C,_.uri,ye)},onDidReceiveMessage:N.event,postMessage(_,ye){return(0,o.$lF)(c,"notebookMessaging"),j.a.$postMessage(C,ye&&j.n.getIdByEditor(ye),_)},asWebviewUri(_){return(0,o.$lF)(c,"notebookMessaging"),(0,u.$ovb)(_,j.m.remote)}};return this.j.set(C,{extensionId:c.identifier,controller:ae,onDidReceiveMessage:N,onDidChangeSelection:U,associatedNotebooks:Z}),ae}getIdByController(c){for(const[v,P]of this.j)if(P.controller===c)return l(P.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,v){const P=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(P,v);const p={dispose:()=>{this.f.delete(P),S.a.$removeKernelDetectionTask(P)}};return this.f.set(P,p),p}registerKernelSourceActionProvider(c,v,P){const S=this.i++,p=typeof P.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,k=this;this.h.set(S,P),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,v);let C;return p!==void 0&&(C=P.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(S),k.a.$removeKernelSourceActionProvider(S,S),C?.dispose()}}}async $provideKernelSourceActions(c,v){const P=this.h.get(c);if(P){const S=new M.$Rc;return(await P.provideNotebookKernelSourceActions(v)??[]).map(k=>y.NotebookKernelSourceAction.from(k,this.o.converter,S))}return[]}$acceptNotebookAssociation(c,v,P){const S=this.j.get(c);if(S){const p=this.n.getNotebookDocument(m.URI.revive(v));P?S.associatedNotebooks.set(p.uri,!0):S.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${c}] ASSOCIATE notebook`,p.uri.toString(),P),S.onDidChangeSelection.fire({selected:P,notebook:p.apiNotebook})}}async $executeCells(c,v,P){const S=this.j.get(c);if(!S)return;const p=this.n.getNotebookDocument(m.URI.revive(v)),k=[];for(const C of P){const j=p.getCell(C);j&&k.push(j.apiCell)}try{this.q.trace(`NotebookController[${c}] EXECUTE cells`,p.uri.toString(),k.length),await S.controller.executeHandler.call(S.controller,k,p.apiNotebook,S.controller)}catch(C){this.q.error(`NotebookController[${c}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(c,v,P){const S=this.j.get(c);if(!S)return;const p=this.n.getNotebookDocument(m.URI.revive(v));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,p.apiNotebook);else for(const k of P){const C=p.getCell(k);C&&this.b.get(C.uri)?.cancel()}if(S.controller.interruptHandler){const k=this.c.get(p.uri);P.length&&Array.isArray(k)&&k.length&&k.forEach(C=>C.dispose())}}async $provideVariables(c,v,P,S,p,k,C){const j=this.j.get(c);if(!j)return;const z=this.n.getNotebookDocument(m.URI.revive(P)),O=j.controller.variableProvider;if(!O)return;const U=S?{name:S,value:""}:void 0,N=p==="named"?D.NotebookVariablesRequestKind.Named:D.NotebookVariablesRequestKind.Indexed,R=O.provideVariables(z.apiNotebook,U,N,k,C);for await(const T of R){if(C.isCancellationRequested)return;this.a.$receiveVariable(v,T)}}$acceptKernelMessageFromRenderer(c,v,P){const S=this.j.get(c);if(!S)return;const p=this.n.getEditorById(v);S.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:P}))}$cellExecutionChanged(c,v,P){const p=this.n.getNotebookDocument(m.URI.revive(c)).getCell(v);if(p){const k=P?y.NotebookCellExecutionState.to(P):D.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:p.apiCell,state:k})}}_createNotebookCellExecution(c,v){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const p=new a(v,S,this.a);this.b.set(S.uri,p);const k=p.onDidChangeState(()=>{p.state===s.Resolved&&(p.dispose(),k.dispose(),this.b.delete(S.uri))});return p.asApiObject()}_createNotebookExecution(c,v){const P=this.n.getNotebookDocument(c.uri),S=c.getCells().find(C=>{const j=P.getCellFromApiCell(C);return j&&this.b.has(j.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const p=new r(v,P,this.a),k=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),k.dispose(),this.c.delete(P.uri))});return this.c.set(P.uri,[p,k]),p.asApiObject()}};e.$Ogc=i,e.$Ogc=i=Qe([qe(4,L.$jj)],i);var s;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(s||(s={}));class a extends M.$Sc{get state(){return this.f}constructor(c,v,P){super(),this.m=v,this.n=P,this.b=a.a++,this.c=new A.$Sd,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new f.$3d),this.h=new d(10,S=>this.s(S)),this.j=v.internalMetadata.executionOrder,this.n.$createExecution(this.b,c,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(c){await this.h.addItem(c)}async s(c){const v=Array.isArray(c)?c:[c];return this.n.$updateExecution(this.b,new n.$Fv(v))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(c){let v=this.m;if(c&&(v=this.m.notebook.getCellFromApiCell(c)),!v)throw new Error("INVALID cell");return v.handle}y(c){return c.map(v=>{const P=D.$fM.ensureUniqueMimeTypes(v.items,!0);return P===v.items?y.NotebookCellOutput.from(v):y.NotebookCellOutput.from({items:P,id:v.id,metadata:v.metadata})})}async z(c,v,P){const S=this.w(v),p=this.y((0,E.$3b)(c));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:S,append:P,outputs:p})}async C(c,v,P){return c=D.$fM.ensureUniqueMimeTypes((0,E.$3b)(c),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:c.map(y.NotebookCellOutputItem.from),outputId:v.id,append:P})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.m.apiCell},get executionOrder(){return c.j},set executionOrder(P){c.j=P,c.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:c.j}])},start(P){if(c.f===s.Resolved||c.f===s.Started)throw new Error("Cannot call start again");c.f=s.Started,c.c.fire(),c.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,S){if(c.f===s.Resolved)throw new Error("Cannot call resolve twice");c.f=s.Resolved,c.c.fire(),c.h.flush(),c.n.$completeExecution(c.b,new n.$Fv({runEndTime:S,lastRunSuccess:P}))},clearOutput(P){return c.t(),c.z([],P,!1)},appendOutput(P,S){return c.t(),c.z(P,S,!0)},replaceOutput(P,S){return c.t(),c.z(P,S,!1)},appendOutputItems(P,S){return c.t(),c.C(P,S,!0)},replaceOutputItems(P,S){return c.t(),c.C(P,S,!1)}})}}a.a=0;var t;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(t||(t={}));class r extends M.$Sc{get state(){return this.f}constructor(c,v,P){super(),this.h=v,this.j=P,this.b=r.a++,this.c=new A.$Sd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new f.$3d),this.j.$createNotebookExecution(this.b,c,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}r.a=0;class d{constructor(c,v){this.f=c,this.g=v,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new F.$mh,this.b=Date.now(),(0,F.$3g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const v=this.a;return this.a=[],this.g(v).finally(()=>c.complete())}}function l(h,c){return`${h.value}/${c}`}e.$Pgc=l}),define(Se[330],ke([1,0,4,6,147]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;class A{constructor(b,m){this.c=m,this.a=new Map,this.b=b.getProxy(F.$NK.MainThreadNotebookRenderers)}$postRendererMessage(b,m,w){const L=this.c.getEditorById(b);this.a.get(m)?.fire({editor:L.apiEditor,message:w})}createRendererMessaging(b,m){if(!b.contributes?.notebookRenderer?.some(L=>L.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(L,I,$)=>this.d(m).event(L,I,$),postMessage:(L,I)=>{f.$wgc.apiEditorsToExtHost.has(L)&&([L,I]=[I,L]);const $=I&&f.$wgc.apiEditorsToExtHost.get(I);return this.b.$postMessage($?.id,m,L)}}}d(b){let m=this.a.get(b);return m||(m=new E.$Sd({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(b)}}),this.a.set(b,m),m)}}e.$Qgc=A}),define(Se[331],ke([1,0,3,18,2,25,6]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class b{constructor(w){this.b=new Map,this.a=w.getProxy(M.$NK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,L,I){if((0,A.$lF)(w,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,I),this.a.$registerProfileContentHandler(L,I.name,I.description,w.identifier.value),(0,E.$Qc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(w,L,I,$){const y=this.b.get(w);if(!y)throw new Error(`Unknown handler with id: ${w}`);return y.saveProfile(L,I,$)}async $readProfile(w,L,I){const $=this.b.get(w);if(!$)throw new Error(`Unknown handler with id: ${w}`);return $.readProfile((0,F.$Ef)(L)?L:f.URI.revive(L),I)}}e.$Tgc=b}),define(Se[332],ke([1,0,2,6,10,15]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;class M{constructor(m,w){this.d=w,this.c=new Map,this.b=m.getProxy(F.$NK.MainThreadQuickDiff)}$provideOriginalResource(m,w,L){const I=E.URI.revive(w),$=this.c.get(m);return $?(0,f.$Ug)(()=>$.provideOriginalResource(I,L)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(m,w,L,I){const $=M.a++;return this.c.set($,w),this.b.$registerQuickDiffProvider($,A.DocumentSelector.from(m,this.d),L,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$Vgc=M,M.a=0}),define(Se[333],ke([1,0,21,4,3,6,2,7,8,19,40,61,25,15]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;function D(u,g,o){const n=u.getProxy(A.$NK.MainThreadQuickOpen);class i{constructor(v,P){this.e=new Map,this.f=0,this.a=v,this.b=P}showQuickPick(v,P,S,p=E.CancellationToken.None){this.c=void 0;const k=Promise.resolve(P),C=++this.f,j=n.$show(C,{title:S?.title,placeHolder:S?.placeHolder,matchOnDescription:S?.matchOnDescription,matchOnDetail:S?.matchOnDetail,ignoreFocusLost:S?.ignoreFocusOut,canPickMany:S?.canPickMany},p),z={},O=j.then(()=>z);return Promise.race([O,k]).then(U=>{if(U===z)return;const N=(0,$.$kF)(v,"quickPickItemTooltip");return k.then(R=>{const T=[];for(let q=0;q<R.length;q++){const ee=R[q];if(typeof ee=="string")T.push({label:ee,handle:q});else if(ee.kind===b.QuickPickItemKind.Separator)T.push({type:"separator",label:ee.label});else{ee.tooltip&&!N&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const J=ee.iconPath?d(ee.iconPath):void 0;T.push({label:ee.label,iconPath:J?.iconPath,iconClass:J?.iconClass,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:N?y.MarkdownString.fromStrict(ee.tooltip):void 0,handle:q})}}return S&&typeof S.onDidSelectItem=="function"&&(this.c=q=>{S.onDidSelectItem(R[q])}),n.$setItems(C,T),j.then(q=>{if(typeof q=="number")return R[q];if(Array.isArray(q))return q.map(ee=>R[ee])})})}).then(void 0,U=>{if(!(0,m.$4)(U))return n.$setError(C,U),Promise.reject(U)})}$onItemSelected(v){this.c?.(v)}showInput(v,P=E.CancellationToken.None){return this.d=v?.validateInput,n.$input(v,typeof this.d=="function",P).then(void 0,S=>{if(!(0,m.$4)(S))return Promise.reject(S)})}async $validateInput(v){if(!this.d)return;const P=await this.d(v);if(!P||typeof P=="string")return P;let S;switch(P.severity){case b.InputBoxValidationSeverity.Info:S=L.default.Info;break;case b.InputBoxValidationSeverity.Warning:S=L.default.Warning;break;case b.InputBoxValidationSeverity.Error:S=L.default.Error;break;default:S=P.message?L.default.Error:L.default.Ignore;break}return{content:P.message,severity:S}}async showWorkspaceFolderPick(v,P=E.CancellationToken.None){const S=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!S)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(k=>k.uri.toString()===S.uri.toString())}createQuickPick(v){const P=new l(v,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(v){const P=new h(v,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(v,P){this.e.get(v)?._fireDidChangeValue(P)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,P){const S=this.e.get(v);S instanceof l&&S._fireDidChangeActive(P)}$onDidChangeSelection(v,P){const S=this.e.get(v);S instanceof l&&S._fireDidChangeSelection(P)}$onDidTriggerButton(v,P){this.e.get(v)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(v,P,S){const p=this.e.get(v);p instanceof l&&p._fireDidTriggerItemButton(P,S)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class s{constructor(v,P){this.x=v,this.y=P,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Sd,this.q=new F.$Sd,this.r=new F.$Sd,this.s=new F.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((P,S)=>{const p=P===b.$$L.Back?-1:S;this.o.set(p,P)}),this.z({buttons:v.map((P,S)=>({...d(P.iconPath),tooltip:P.tooltip,handle:P===b.$$L.Back?-1:S}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const P=this.o.get(v);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(v){if(!this.v){for(const P of Object.keys(v)){const S=v[P];this.u[P]=S===void 0?null:S}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}s.a=1;function a(c){if(c instanceof b.$KL)return{id:c.id};const v=r(c),P=t(c);return{dark:typeof v=="string"?M.URI.file(v):v,light:typeof P=="string"?M.URI.file(P):P}}function t(c){return typeof c=="object"&&"light"in c?c.light:c}function r(c){return typeof c=="object"&&"dark"in c?c.dark:c}function d(c){const v=a(c);let P,S;return"id"in v?S=I.ThemeIcon.asClassName(v):P=v,{iconPath:P,iconClass:S}}class l extends s{constructor(v,P){super(v.identifier,P),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Sd,this.L=[],this.M=new F.$Sd,this.N=new F.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((p,k)=>{this.C.set(k,p),this.D.set(p,k)});const P=(0,$.$kF)(this.O,"quickPickItemTooltip"),S=[];for(let p=0;p<v.length;p++){const k=v[p];if(k.kind===b.QuickPickItemKind.Separator)S.push({type:"separator",label:k.label});else{k.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=k.iconPath?d(k.iconPath):void 0;S.push({handle:p,label:k.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:P?y.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((j,z)=>({...d(j.iconPath),tooltip:j.tooltip,handle:z}))})}}this.z({items:S})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(v){const P=(0,w.$Hb)(v.map(S=>this.C.get(S)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(v){const P=(0,w.$Hb)(v.map(S=>this.C.get(S)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(v,P){const S=this.C.get(v);if(!S||!S.buttons||!S.buttons.length)return;const p=S.buttons[P];p&&this.N.fire({button:p,item:S})}}class h extends s{constructor(v,P){super(v.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:L.default.Error}):this.z({validationMessage:v.message,severity:v.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new i(g,o)}e.$Wgc=D});var We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)},nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E};define(Se[334],ke([1,0,2,4,59,3,10,6,19,124,14,26,61,15,25,17,9]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g){"use strict";var o,n,i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0;function a(N){return N instanceof E.URI}function t(N,R){return N.scheme===u.Schemas.file&&R.scheme===u.Schemas.file&&g.$e?N.toString()===R.toString():N.toString().toLowerCase()===R.toString().toLowerCase()}function r(N){if(N)return typeof N.iconPath=="string"?E.URI.file(N.iconPath):E.URI.isUri(N.iconPath)||$.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function d(N){if(N?.icon){if(E.URI.isUri(N.icon))return N.icon;if($.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function l(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if($.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function h(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if($.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function c(N,R){if(!N.iconPath&&!R.iconPath)return 0;if(N.iconPath){if(!R.iconPath)return 1}else return-1;const T=typeof N.iconPath=="string"?N.iconPath:E.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,q=typeof R.iconPath=="string"?R.iconPath:E.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id;return(0,w.$Fq)(T,q)}function v(N,R){let T=0;if(N.strikeThrough!==R.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==R.faded)return N.faded?1:-1;if(N.tooltip!==R.tooltip)return(N.tooltip||"").localeCompare(R.tooltip||"");if(T=c(N,R),T!==0)return T;if(N.light&&R.light)T=c(N.light,R.light);else{if(N.light)return 1;if(R.light)return-1}if(T!==0)return T;if(N.dark&&R.dark)T=c(N.dark,R.dark);else{if(N.dark)return 1;if(R.dark)return-1}return T}function P(N,R){if(N.command!==R.command)return N.command<R.command?-1:1;if(N.title!==R.title)return N.title<R.title?-1:1;if(N.tooltip!==R.tooltip){if(N.tooltip!==void 0&&R.tooltip!==void 0)return N.tooltip<R.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(R.tooltip!==void 0)return-1}if(N.arguments===R.arguments)return 0;if(N.arguments)if(R.arguments){if(N.arguments.length!==R.arguments.length)return N.arguments.length-R.arguments.length}else return 1;else return-1;for(let T=0;T<N.arguments.length;T++){const q=N.arguments[T],ee=R.arguments[T];if(q!==ee&&!(a(q)&&a(ee)&&t(q,ee)))return q<ee?-1:1}return 0}function S(N,R){let T=(0,w.$Fq)(N.resourceUri.fsPath,R.resourceUri.fsPath,!0);if(T!==0)return T;if(N.command&&R.command)T=P(N.command,R.command);else{if(N.command)return 1;if(R.command)return-1}if(T!==0)return T;if(N.decorations&&R.decorations)T=v(N.decorations,R.decorations);else{if(N.decorations)return 1;if(R.decorations)return-1}return T}function p(N,R){for(let T=0;T<N.length;T++)if(N[T]!==R[T])return!1;return!0}function k(N,R){return N.command===R.command&&N.title===R.title&&N.tooltip===R.tooltip&&(N.arguments&&R.arguments?p(N.arguments,R.arguments):N.arguments===R.arguments)}function C(N,R){return(0,m.$ub)(N,R,k)}class j{get value(){return this.d}set value(R){R=R??"",We(this,o,"f").$setInputBoxValue(this.o,R),this.q(R)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(R){We(this,o,"f").$setInputBoxPlaceholder(this.o,R),this.f=R}get validateInput(){return(0,D.$lF)(this.m,"scmValidation"),this.g}set validateInput(R){if((0,D.$lF)(this.m,"scmValidation"),R&&typeof R!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=R,We(this,o,"f").$setValidationProviderIsEnabled(this.o,!!R)}get enabled(){return this.h}set enabled(R){R=!!R,this.h!==R&&(this.h=R,We(this,o,"f").$setInputBoxEnablement(this.o,R))}get visible(){return this.j}set visible(R){R=!!R,this.j!==R&&(this.j=R,We(this,o,"f").$setInputBoxVisibility(this.o,R))}get actionButton(){return(0,D.$lF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(R){(0,D.$lF)(this.m,"scmInputBoxActionButton"),this.l.value=new A.$Rc,this.k=R;const T=R!==void 0?{command:this.n.converter.toInternal(R.command,this.l.value),icon:d(R),enabled:R.enabled}:void 0;We(this,o,"f").$setInputBoxActionButton(this.o,T??null)}get document(){return(0,D.$lF)(this.m,"scmTextDocument"),We(this,n,"f").getDocument(this.p)}constructor(R,T,q,ee,J,K){this.m=R,this.n=T,this.o=J,this.p=K,o.set(this,void 0),n.set(this,void 0),this.d="",this.e=new F.$Sd,this.f="",this.h=!0,this.j=!0,this.l=new A.$Tc,nt(this,n,q,"f"),nt(this,o,ee,"f")}showValidationMessage(R,T){(0,D.$lF)(this.m,"scmValidation"),We(this,o,"f").$showValidationMessage(this.o,R,T)}$onInputBoxValueChange(R){this.q(R)}q(R){this.d=R,this.e.fire(R)}}e.$Xgc=j,o=new WeakMap,n=new WeakMap;class z{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(R){this.v=R,this.q.$updateGroupLabel(this.t,this.handle,R)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(R){this.p=R,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(R){this.f=[...R],this.k.fire()}constructor(R,T,q,ee,J){this.q=R,this.s=T,this.t=q,this.u=ee,this.v=J,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=z.d++}getResourceState(R){return this.g.get(R)}$executeResourceCommand(R,T){const q=this.h.get(R);return q?(0,M.$Ug)(()=>this.s.executeCommand(q.command,...q.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const R=[...this.f].sort(S),q=(0,m.$Db)(this.o,R,S).map(K=>{const Z=K.toInsert.map(ae=>{const _=this.e++;this.g.set(_,ae);const ye=ae.resourceUri;let ge;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const te=new A.$Rc;ge=this.s.converter.toInternal(ae.command,te),this.j.set(_,te)}else this.h.set(_,ae.command);const re=r(ae.decorations),W=ae.decorations&&r(ae.decorations.light)||re,ce=ae.decorations&&r(ae.decorations.dark)||re,me=[W,ce],le=ae.decorations&&ae.decorations.tooltip||"",de=ae.decorations&&!!ae.decorations.strikeThrough,Y=ae.decorations&&!!ae.decorations.faded,X=ae.contextValue||"";return{rawResource:[_,ye,me,le,de,Y,X,ge],handle:_}});return{start:K.start,deleteCount:K.deleteCount,toInsert:Z}}),ee=q.map(({start:K,deleteCount:Z,toInsert:ae})=>[K,Z,ae.map(_=>_.rawResource)]),J=q.reverse();for(const{start:K,deleteCount:Z,toInsert:ae}of J){const _=ae.map(ge=>ge.handle),ye=this.n.splice(K,Z,..._);for(const ge of ye)this.g.delete(ge),this.h.delete(ge),this.j.get(ge)?.dispose(),this.j.delete(ge)}return this.o=R,ee}dispose(){this.l=!0,this.m.fire()}}z.d=0;class O{get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(R){this.g!==R&&(this.g=R,We(this,i,"f").$updateSourceControl(this.x,{count:R}))}get quickDiffProvider(){return this.h}set quickDiffProvider(R){this.h=R;let T;(0,D.$kF)(this.y,"quickDiffProvider")&&(T=R?.label),We(this,i,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!R,quickDiffLabel:T})}get historyProvider(){return(0,D.$lF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(R){(0,D.$lF)(this.y,"scmHistoryProvider"),this.j=R,this.k.value=new A.$Rc,We(this,i,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!R}),R&&(this.k.value.add(R.onDidChangeCurrentHistoryItemGroup(()=>{this.l=R?.currentHistoryItemGroup,We(this,i,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(R.onDidChangeActionButton(()=>{(0,D.$lF)(this.y,"scmActionButton"),this.m.value=new A.$Rc;const T=R.actionButton!==void 0?{command:this.z.converter.toInternal(R.actionButton.command,this.m.value),description:R.actionButton.description,enabled:R.actionButton.enabled}:void 0;We(this,i,"f").$onDidChangeHistoryProviderActionButton(this.x,T??null)})))}get commitTemplate(){return this.n}set commitTemplate(R){R!==this.n&&(this.n=R,We(this,i,"f").$updateSourceControl(this.x,{commitTemplate:R}))}get acceptInputCommand(){return this.p}set acceptInputCommand(R){this.o.value=new A.$Rc,this.p=R;const T=this.z.converter.toInternal(R,this.o.value);We(this,i,"f").$updateSourceControl(this.x,{acceptInputCommand:T})}get actionButton(){return(0,D.$lF)(this.y,"scmActionButton"),this.s}set actionButton(R){(0,D.$lF)(this.y,"scmActionButton"),this.q.value=new A.$Rc,this.s=R;const T=R!==void 0?{command:this.z.converter.toInternal(R.command,this.q.value),secondaryCommands:R.secondaryCommands?.map(q=>q.map(ee=>this.z.converter.toInternal(ee,this.q.value))),description:R.description,enabled:R.enabled}:void 0;We(this,i,"f").$updateSourceControl(this.x,{actionButton:T??null})}get statusBarCommands(){return this.u}set statusBarCommands(R){if(this.u&&R&&C(this.u,R))return;this.t.value=new A.$Rc,this.u=R;const T=(R||[]).map(q=>this.z.converter.toInternal(q,this.t.value));We(this,i,"f").$updateSourceControl(this.x,{statusBarCommands:T})}get selected(){return this.v}constructor(R,T,q,ee,J,K,Z){this.y=R,this.z=ee,this.A=J,this.B=K,this.C=Z,i.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Tc,this.m=new A.$Tc,this.n=void 0,this.o=new A.$Tc,this.p=void 0,this.q=new A.$Tc,this.t=new A.$Tc,this.u=void 0,this.v=!1,this.w=new F.$Sd,this.onDidChangeSelection=this.w.event,this.x=O.d++,this.D=new Map,this.E=new Set,nt(this,i,q,"f");const ae=E.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${J}/scm${this.x}/input`,query:Z?`rootUri=${encodeURIComponent(Z.toString())}`:void 0});this.f=new j(R,ee,T,We(this,i,"f"),this.x,ae),We(this,i,"f").$registerSourceControl(this.x,J,K,Z,ae)}createResourceGroup(R,T){const q=new z(We(this,i,"f"),this.z,this.x,R,T),ee=F.Event.once(q.onDidDispose)(()=>this.D.delete(q));return this.D.set(q,ee),this.eventuallyAddResourceGroups(),q}eventuallyAddResourceGroups(){const R=[],T=[];for(const[q,ee]of this.D){ee.dispose();const J=q.onDidUpdateResourceStates(()=>{this.E.add(q),this.eventuallyUpdateResourceStates()});F.Event.once(q.onDidDispose)(()=>{this.E.delete(q),J.dispose(),this.e.delete(q.handle),We(this,i,"f").$unregisterGroup(this.x,q.handle)}),R.push([q.handle,q.id,q.label,q.features]);const K=q._takeResourceStateSnapshot();K.length>0&&T.push([q.handle,K]),this.e.set(q.handle,q)}We(this,i,"f").$registerGroups(this.x,R,T),this.D.clear()}eventuallyUpdateResourceStates(){const R=[];this.E.forEach(T=>{const q=T._takeResourceStateSnapshot();q.length!==0&&R.push([T.handle,q])}),R.length>0&&We(this,i,"f").$spliceResourceStates(this.x,R),this.E.clear()}getResourceGroup(R){return this.e.get(R)}setSelectionState(R){this.v=R,this.w.fire(R)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(R=>R.dispose()),We(this,i,"f").$unregisterSourceControl(this.x)}}i=new WeakMap,O.d=0,Qe([(0,f.$uh)(100)],O.prototype,"eventuallyAddResourceGroups",null),Qe([(0,f.$uh)(100)],O.prototype,"eventuallyUpdateResourceStates",null);let U=s=class{get onDidChangeActiveProvider(){return this.k.event}constructor(R,T,q,ee){this.n=T,this.o=q,this.p=ee,this.h=new Map,this.j=new I.$jm,this.k=new F.$Sd,this.l=new Map,this.f=R.getProxy(b.$NK.MainThreadSCM),this.g=R.getProxy(b.$NK.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:J=>{if(J&&J.$mid===3){const K=this.h.get(J.sourceControlHandle);if(!K)return J;const Z=K.getResourceGroup(J.groupHandle);return Z?Z.getResourceState(J.handle):J}else if(J&&J.$mid===4){const K=this.h.get(J.sourceControlHandle);return K?K.getResourceGroup(J.groupHandle):J}else if(J&&J.$mid===5){const K=this.h.get(J.handle);return K||J}return J}})}createSourceControl(R,T,q,ee){this.p.trace("ExtHostSCM#createSourceControl",R.identifier.value,T,q,ee),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:R.identifier.value});const J=s.d++,K=new O(R,this.o,this.f,this.n,T,q,ee);this.h.set(J,K);const Z=this.j.get(R.identifier)||[];return Z.push(K),this.j.set(R.identifier,Z),K}registerSourceControlInputBoxValueProvider(R,T,q){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",R.identifier.value,q.label);const ee=s.e++;return this.l.set(ee,q),this.f.$registerSourceControlInputBoxValueProvider(ee,T,q.label,h(q)),(0,A.$Qc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(ee),this.l.delete(ee)})}async $provideInputBoxValue(R,T,q,ee){const J=this.l.get(R);if(J)return await J.provideValue(E.URI.revive(T),q,ee)??void 0}getLastInputBox(R){this.p.trace("ExtHostSCM#getLastInputBox",R.identifier.value);const T=this.j.get(R.identifier),q=T&&T[T.length-1];return q&&q.inputBox}$provideOriginalResource(R,T,q){const ee=E.URI.revive(T);this.p.trace("ExtHostSCM#$provideOriginalResource",R,ee.toString());const J=this.h.get(R);return!J||!J.quickDiffProvider||!J.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$Ug)(()=>J.quickDiffProvider.provideOriginalResource(ee,q)).then(K=>K||null)}$onInputBoxValueChange(R,T){this.p.trace("ExtHostSCM#$onInputBoxValueChange",R);const q=this.h.get(R);return q&&q.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(R,T,q,ee){this.p.trace("ExtHostSCM#$executeResourceCommand",R,T,q);const J=this.h.get(R);if(!J)return Promise.resolve(void 0);const K=J.getResourceGroup(T);return K?K.$executeResourceCommand(q,ee):Promise.resolve(void 0)}$validateInput(R,T,q){this.p.trace("ExtHostSCM#$validateInput",R);const ee=this.h.get(R);return!ee||!ee.inputBox.validateInput?Promise.resolve(void 0):(0,M.$Ug)(()=>ee.inputBox.validateInput(T,q)).then(J=>{if(!J)return Promise.resolve(void 0);const K=y.MarkdownString.fromStrict(J.message);return K?Promise.resolve([K,J.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(R){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",R),R!==void 0&&this.h.get(R)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=R,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(R,T,q){return await this.h.get(R)?.historyProvider?.resolveHistoryItemGroupBase(T,q)??void 0}async $resolveHistoryItemGroupCommonAncestor(R,T,q,ee){return await this.h.get(R)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,q,ee)??void 0}async $provideHistoryItems(R,T,q,ee){return(await this.h.get(R)?.historyProvider?.provideHistoryItems(T,q,ee))?.map(Z=>({...Z,icon:l(Z)}))??void 0}async $provideHistoryItemChanges(R,T,q){return await this.h.get(R)?.historyProvider?.provideHistoryItemChanges(T,q)??void 0}};e.$Ygc=U,U.d=0,U.e=0,e.$Ygc=U=s=Qe([qe(3,L.$jj)],U)}),define(Se[118],ke([1,0,6,4,5]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=e.$5fc=void 0;class A{constructor(b){this.b=new F.$Sd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(E.$NK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,m){return this.a.$getPassword(b,m)}store(b,m,w){return this.a.$setPassword(b,m,w)}delete(b,m){return this.a.$deletePassword(b,m)}}e.$5fc=A,e.$6fc=(0,f.$2h)("IExtHostSecretState")}),define(Se[335],ke([1,0,6,15,2]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class A{constructor(b,m){this.d=m,this.c=new Map,this.b=b.getProxy(E.$NK.MainThreadShare)}async $provideShare(b,m,w){return await this.c.get(b)?.provideShare({selection:F.Range.to(m.selection),resourceUri:f.URI.revive(m.resourceUri)},w)??void 0}registerShareProvider(b,m){const w=A.a++;return this.c.set(w,m),this.b.$registerShareProvider(w,F.DocumentSelector.from(b,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Zgc=A,A.a=0}),define(Se[336],ke([1,0,21,3,6]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0;class A{constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(f.$NK.MainThreadSpeech)}async $createSpeechToTextSession(b,m){const w=this.c.get(b);if(!w)return;const L=new F.$Rc,I=new E.$3d;this.d.set(m,I);const $=L.add(w.provideSpeechToTextSession(I.token));L.add($.onDidChange(y=>{I.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,y)})),L.add(I.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,m,w){const L=A.a++;return this.c.set(L,w),this.b.$registerProvider(L,m,{extension:b,displayName:b.value}),(0,F.$Qc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$1gc=A,A.a=1});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[337],ke([1,0,7,6,217,3,15,18]),function(ie,e,E,F,f,A,M,b){"use strict";var m,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=e.$2gc=void 0;class L{constructor(D,u,g,o,n,i=E.StatusBarAlignment.Left,s){if(m.set(this,void 0),w.set(this,void 0),this.i=!1,this.k="",this.q=new A.$Rc,nt(this,m,D,"f"),nt(this,w,u,"f"),n&&o){this.c=(0,E.$oL)(o.identifier,n);const a=g.get(this.c);a&&(i=a.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,s=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(L.a++);this.e=o,this.f=n,this.g=i,this.h=this.u(s)}u(D){if((0,b.$If)(D))return D===Number.POSITIVE_INFINITY?Number.MAX_VALUE:D===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:D}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(D){this.k=D,this.v()}set name(D){this.m=D,this.v()}set tooltip(D){this.l=D,this.v()}set color(D){this.n=D,this.v()}set backgroundColor(D){D&&!L.b.has(D.id)&&(D=void 0),this.o=D,this.v()}set command(D){this.r?.fromApi!==D&&(this.p&&this.q.add(this.p),this.p=new A.$Rc,typeof D=="string"?this.r={fromApi:D,internal:We(this,w,"f").toInternal({title:"",command:D},this.p)}:D?this.r={fromApi:D,internal:We(this,w,"f").toInternal(D,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(D){this.t=D,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,We(this,m,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let D;this.e?this.f?D=`${this.e.identifier.value}.${this.f}`:D=this.e.identifier.value:D=this.f;let u;this.m?u=this.m:u=(0,f.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=L.b.get(this.o.id));const o=M.MarkdownString.fromStrict(this.l);We(this,m,"f").$setEntry(this.c,D,this.e?.identifier.value,u,this.k,o,this.r?.internal,g,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$2gc=L,m=new WeakMap,w=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new E.$LL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$LL("statusBarItem.warningForeground")]]);class I{constructor(D){this.b=[],this.a=D.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(D){const u={message:D};return this.b.unshift(u),this.c(),new E.$PK(()=>{const g=this.b.indexOf(u);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class ${constructor(D,u){this.e=new Map,this.a=D.getProxy(F.$NK.MainThreadStatusBar),this.b=u,this.c=new I(this)}$acceptStaticEntries(D){for(const u of D)this.e.set(u.entryId,u)}createStatusBarEntry(D,u,g,o){return new L(this.a,this.b,this.e,D,u,g,o)}setStatusBarMessage(D,u){const g=this.c.setMessage(D);let o;return typeof u=="number"?o=setTimeout(()=>g.dispose(),u):typeof u<"u"&&u.then(()=>g.dispose(),()=>g.dispose()),new E.$PK(()=>{g.dispose(),clearTimeout(o)})}}e.$3gc=$}),define(Se[119],ke([1,0,6,4,5]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0;class A{constructor(b,m){this.c=m,this.b=new F.$Sd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(E.$NK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,m){this.a.$registerExtensionStorageKeysToSync(b,m)}async initializeExtensionStorage(b,m,w){const L=await this.a.$initializeExtensionStorage(b,m);let I;return L&&(I=this.d(b,m,L)),I||w}setValue(b,m,w){return this.a.$setValue(b,m,w)}$acceptValue(b,m,w){const L=this.d(b,m,w);L&&this.b.fire({shared:b,key:m,value:L})}d(b,m,w){try{return JSON.parse(w)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${b}): ${L}`)}}}e.$Wfc=A,e.$Xfc=(0,f.$2h)("IExtHostStorage")}),define(Se[92],ke([1,0,5,27,14,71,2]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=void 0,e.$Ffc=(0,E.$2h)("IExtensionStoragePaths");let b=class{constructor(w,L,I){this.d=L,this.f=I,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then($=>this.c=$)}async g(w){return M.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,L=await this.g(w);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(M.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(w){if(this.c)return M.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return M.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Gfc=b,e.$Gfc=b=Qe([qe(0,F.$8M),qe(1,f.$jj),qe(2,A.$Efc)],b)}),define(Se[47],ke([1,0,4,6,5,2,20,3,7,219,8,263,21,30,264,61,10,15,35]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=e.$2fc=e.$1fc=void 0,e.$1fc=(0,f.$2h)("IExtHostTerminalService");class i{constructor(S,p,k,C){this.l=S,this._id=p,this.m=k,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const j=this;this.value={get name(){return j.n||""},get processId(){return j.b},get creationOptions(){return j.m},get exitStatus(){return j.h},get state(){return j.j},get selection(){return j.k},sendText(z,O=!0){j.q(),j.l.$sendText(j._id,z,O)},show(z){j.q(),j.l.$show(j._id,z)},hide(){j.q(),j.l.$hide(j._id)},dispose(){j.a||(j.a=!0,j.l.$dispose(j._id))},get dimensions(){if(!(j.d===void 0||j.g===void 0))return{columns:j.d,rows:j.g}}}}async create(S,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:S.name,shellPath:S.shellPath??void 0,shellArgs:S.shellArgs??void 0,cwd:S.cwd??p?.cwd??void 0,env:S.env??void 0,icon:h(S.iconPath)??void 0,color:u.ThemeColor.isThemeColor(S.color)?S.color.id:void 0,initialText:S.message??void 0,strictEnv:S.strictEnv??void 0,hideFromUser:S.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(S.location,p?.resolvedExtHostIdentifier),isTransient:S.isTransient??void 0})}async createExtensionTerminal(S,p,k,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:k,color:u.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o(S,p),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(S,p){return typeof S=="object"?"parentTerminal"in S&&S.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in S?{viewColumn:o.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus}:void 0:S}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(S){this.n=S}setExitStatus(S,p){this.h=Object.freeze({code:S,reason:p})}setDimensions(S,p){return S===this.d&&p===this.g||S===0||p===0?!1:(this.d=S,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(S){this.k=S}_setProcessId(S){this.f?(this.f(S),this.f=void 0):this.b.then(p=>{p!==S&&(this.b=Promise.resolve(S))})}}e.$2fc=i;class s{get onProcessReady(){return this.b.event}constructor(S){this.g=S,this.id=0,this.shouldPersist=!1,this.a=new E.$Sd,this.onProcessData=this.a.event,this.b=new E.$Sd,this.d=new E.$Sd,this.onDidChangeProperty=this.d.event,this.f=new E.$Sd,this.onProcessExit=this.f.event}refreshProperty(S){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${S}`)}updateProperty(S,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${S}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(S){this.g.handleInput?.(S)}resize(S,p){this.g.setDimensions?.({columns:S,rows:p})}clearBuffer(){}async processBinary(S){}acknowledgeDataEvent(S){}async setUnicodeVersion(S){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(S){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(S||void 0),S&&this.g.setDimensions?.(S),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends b.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(S=>S.value)}constructor(S,p,k){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Sd,this.onDidChangeShell=this.N.event,this.O=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(F.$NK.MainThreadTerminalService),this.y=new D.$Crb(this.a.$sendProcessData),this.a.$registerProcessSupport(S),this.Q.registerArgumentProcessor({processArgument:C=>{const j=z=>{const O=z;return this.W(O.instanceId)?.value};switch(C?.$mid){case 15:return j(C);default:{if(Array.isArray(C))for(let z=0;z<C.length&&C[z].$mid===15;z++)C[z]=j(C[z]);return C}}}}),this.B({dispose:()=>{for(const[C,j]of this.g)j.shutdown(!0)}})}getDefaultShell(S){return(S?this.u:this.s)?.path||""}getDefaultShellArgs(S){return(S?this.u:this.s)?.args||[]}createExtensionTerminal(S,p){const k=new i(this.a,(0,y.$mg)(),S,S.name),C=new s(S.pty);return k.createExtensionTerminal(S.location,this.R(S,p).resolvedExtHostIdentifier,h(S.iconPath),c(S.color)).then(j=>{const z=this.S(j,C);this.h[j]=z}),this.f.push(k),k.value}R(S,p){if(p=p||{},S.location&&typeof S.location=="object"&&"parentTerminal"in S.location){const k=S.location.parentTerminal;if(k){const C=this.f.find(j=>j.value===k);C&&(p.resolvedExtHostIdentifier=C._id)}}else S.location&&typeof S.location!="object"?p.location=S.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(S,p){if(!this.W(S))throw new Error(`Cannot resolve terminal with id ${S} for virtual process`);const C=new s(p),j=this.S(S,C);this.h[S]=j}async $acceptActiveTerminalChanged(S){const p=this.b;if(S===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const k=this.W(S);k&&(this.b=k,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(S,p){const k=this.W(S);k&&this.O.fire({terminal:k.value,data:p})}async $acceptTerminalDimensions(S,p,k){const C=this.W(S);C&&C.setDimensions(p,k)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(S,p){const k=this.W(S);k&&this.P.fire({terminal:k.value,...p})}async $acceptTerminalMaximumDimensions(S,p,k){this.g.get(S)?.resize(p,k)}async $acceptTerminalTitleChange(S,p){const k=this.W(S);k&&(k.name=p)}async $acceptTerminalClosed(S,p,k){const C=this.Y(this.f,S);if(C!==null){const j=this.f.splice(C,1)[0];j.setExitStatus(p,k),this.H.fire(j.value)}}$acceptTerminalOpened(S,p,k,C){if(p){const O=this.Y(this.f,p);if(O!==null){this.f[O]._id=S,this.I.fire(this.terminals[O]),this.f[O].isOpen=!0;return}}const j={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:A.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},z=new i(this.a,S,j,k);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(S,p){this.W(S)?._setProcessId(p)}async $startExtensionTerminal(S,p){const k=this.W(S);if(!k)return{message:(0,w.localize)(0,null,S)};k.isOpen||await new Promise(j=>{const z=this.onDidOpenTerminal(async O=>{O===k.value&&(z.dispose(),j())})});const C=this.g.get(S);C?C.startSendingEvents(p):this.j[S]={initialDimensions:p}}S(S,p){const k=new b.$Rc;k.add(p.onProcessReady(j=>this.a.$sendProcessReady(S,j.pid,j.cwd,j.windowsPty))),k.add(p.onDidChangeProperty(j=>this.a.$sendProcessProperty(S,j))),this.y.startBuffering(S,p.onProcessData),k.add(p.onProcessExit(j=>this.U(S,j))),this.g.set(S,p);const C=this.j[S];return C&&p instanceof s&&(p.startSendingEvents(C.initialDimensions),delete this.j[S]),k}$acceptProcessAckDataEvent(S,p){this.g.get(S)?.acknowledgeDataEvent(p)}$acceptProcessInput(S,p){this.g.get(S)?.input(p)}$acceptTerminalInteraction(S){const p=this.W(S);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(S,p){this.W(S)?.setSelection(p)}$acceptProcessResize(S,p,k){try{this.g.get(S)?.resize(p,k)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(S,p){this.g.get(S)?.shutdown(p)}$acceptProcessRequestInitialCwd(S){this.g.get(S)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(S,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(S){this.g.get(S)?.getCwd().then(p=>this.a.$sendProcessProperty(S,{type:"cwd",value:p}))}$acceptProcessRequestLatency(S){return Promise.resolve(S)}registerLinkProvider(S){return this.z.add(S),this.z.size===1&&this.a.$startLinkProvider(),new m.$PK(()=>{this.z.delete(S),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(S,p,k){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,k),this.a.$registerProfileProvider(p,S.identifier.value),new m.$PK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(S,p,k){if(this.D.has(S))throw new Error(`Terminal quick fix provider "${S}" is already registered`);return this.D.set(S,k),this.a.$registerQuickFixProvider(S,p),new m.$PK(()=>{this.D.delete(S),this.a.$unregisterQuickFixProvider(S)})}async $provideTerminalQuickFixes(S,p){const k=new $.$3d().token;if(k.isCancellationRequested)return;const C=this.D.get(S);if(!C)return;const j=await C.provideTerminalQuickFixes(p,k);if(j===null||Array.isArray(j)&&j.length===0)return;const z=new b.$Rc;if(this.w.value=z,!Array.isArray(j))return j?o.TerminalQuickFix.from(j,this.Q.converter,z):void 0;const O=[];for(const U of j){const N=o.TerminalQuickFix.from(U,this.Q.converter,z);N&&O.push(N)}return O}async $createContributedProfileTerminal(S,p){const k=new $.$3d().token;let C=await this.C.get(S)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${S}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,p);return}this.createTerminalFromOptions(C.options,p)}}async $provideLinks(S,p){const k=this.W(S);if(!k)return[];this.F.delete(S),this.G.get(S)?.dispose(!0);const j=new $.$3d;this.G.set(S,j);const z=[],O={terminal:k.value,line:p},U=[];for(const T of this.z)U.push(g.Promises.withAsyncBody(async q=>{j.token.onCancellationRequested(()=>q({provider:T,links:[]}));const ee=await T.provideTerminalLinks(O,j.token)||[];j.token.isCancellationRequested||q({provider:T,links:ee})}));const N=await Promise.all(U);if(j.token.isCancellationRequested)return[];const R=new Map;for(const T of N)T&&T.links.length>0&&z.push(...T.links.map(q=>{const ee={id:a++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return R.set(ee.id,{provider:T.provider,link:q}),ee}));return this.F.set(S,R),z}$activateLink(S,p){const k=this.F.get(S)?.get(p);k&&k.provider.handleTerminalLink(k.link)}U(S,p){this.y.stopBuffering(S),this.g.delete(S),delete this.j[S];const k=this.h[S];k&&(k.dispose(),delete this.h[S]),this.a.$sendProcessExit(S,p)}W(S){return this.X(this.f,S)}X(S,p){const k=this.Y(S,p);return k!==null?S[k]:null}Y(S,p){const k=S.findIndex(C=>C._id===p);return k===-1?null:k}getEnvironmentVariableCollection(S){let p=this.n.get(S.identifier.value);return p||(p=new r,this.$(S.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(S,p){const k=(0,I.$yr)(p.map),C=(0,I.$zr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(S,p.persistent,k.length===0?void 0:k,C)}$initEnvironmentVariableCollections(S){S.forEach(p=>{const k=p[0],C=new r(p[1]);this.$(k,C)})}$acceptDefaultProfile(S,p){const k=this.s;this.s=S,this.u=p,k?.path!==S.path&&this.N.fire(S.path)}$(S,p){this.n.set(S,p),p.onDidChangeCollection(()=>{this.Z(S,p)})}};e.$3fc=t,e.$3fc=t=Qe([qe(1,n.$bN),qe(2,M.$RM)],t);class r{get persistent(){return this.b}set persistent(S){this.b=S,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(S){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Sd,this.map=new Map(S)}getScopedEnvironmentVariableCollection(S){const p=this.h(S);let k=this.a.get(p);return k||(k=new d(this,S),this.a.set(p,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(S,p,k,C){this.f(S,{value:p,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:C})}append(S,p,k,C){this.f(S,{value:p,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:C})}prepend(S,p,k,C){this.f(S,{value:p,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:C})}f(S,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(S,p.scope),C=this.map.get(k),j=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==p.value||C.type!==p.type||C.options?.applyAtProcessCreation!==j.applyAtProcessCreation||C.options?.applyAtShellIntegration!==j.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const z=this.g(S,p.scope),O={variable:S,...p,options:j};this.map.set(z,O),this.d.fire()}}get(S,p){const k=this.g(S,p),C=this.map.get(k);return C?v(C):void 0}g(S,p){const k=this.h(p);return k.length?`${S}:::${k}`:S}h(S){return this.j(S?.workspaceFolder)??""}j(S){return S?S.uri.toString():void 0}getVariableMap(S){const p=new Map;for(const[k,C]of this.map)this.h(C.scope)===this.h(S)&&p.set(C.variable,v(C));return p}delete(S,p){const k=this.g(S,p);this.map.delete(k),this.d.fire()}clear(S){if(S?.workspaceFolder){for(const[p,k]of this.map)k.scope?.workspaceFolder?.index===S.workspaceFolder.index&&this.map.delete(p);this.k(S)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(S,p){const k=this.h(p),C=this.descriptionMap.get(k);if(!C||C.description!==S){let j;typeof S=="string"?j=S:j=S?.value.split(`

`)[0];const z={description:j,scope:p};this.descriptionMap.set(k,z),this.d.fire()}}getDescription(S){const p=this.h(S);return this.descriptionMap.get(p)?.description}k(S){const p=this.h(S);this.descriptionMap.delete(p)}}class d{get persistent(){return this.b.persistent}set persistent(S){this.b.persistent=S}get onDidChangeCollection(){return this.a&&this.a.event}constructor(S,p){this.b=S,this.d=p,this.a=new E.$Sd}getScoped(S){return this.b.getScopedEnvironmentVariableCollection(S)}replace(S,p,k){this.b.replace(S,p,k,this.d)}append(S,p,k){this.b.append(S,p,k,this.d)}prepend(S,p,k){this.b.prepend(S,p,k,this.d)}get(S){return this.b.get(S,this.d)}forEach(S,p){this.b.getVariableMap(this.d).forEach((k,C)=>S.call(p,C,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(S){this.b.delete(S,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(S){this.b.setDescription(S,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(S,p){super(!1,S,p)}createTerminal(S,p,k){throw new L.$_}createTerminalFromOptions(S,p){throw new L.$_}};e.$4fc=l,e.$4fc=l=Qe([qe(0,n.$bN),qe(1,M.$RM)],l);function h(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function c(P){return u.ThemeColor.isThemeColor(P)?P:void 0}function v(P){const S={...P};return delete S.scope,S.options=S.options??void 0,delete S.variable,S}});var We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)},nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E};define(Se[338],ke([1,0,10,22,21,4,74,53,3,24,18,30,6,20,148,15,7,67,113,89,25]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s){"use strict";var a,t,r,d,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=e.$8gc=e.$7gc=void 0;let h=class extends m.$Sc{constructor(T,q,ee){super(),this.u=ee,this.f=this.B(new A.$Sd),this.g=new Map,this.s=this.B(new A.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=T.getProxy($.$NK.MainThreadTesting),this.m=new O(this.h),this.j=new S(this.h),q.registerArgumentProcessor({processArgument:J=>{switch(J?.$mid){case 16:{const K=J,Z=K.tests[K.tests.length-1].item.extId;return this.g.get(o.$FJ.root(Z))?.collection.tree.get(Z)?.actual??(0,D.$4M)(J)}case 18:{const{extId:K,message:Z}=J;return{test:this.g.get(o.$FJ.root(K))?.collection.tree.get(K)?.actual,message:u.TestMessage.to(Z)}}default:return J}}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const J=await q.executeCommand("_testing.getExplorerSelection"),K=Z=>{const ae=this.g.get(o.$FJ.root(Z));if(ae)return o.$FJ.isRoot(Z)?ae.controller:ae.collection.tree.get(Z)?.actual};return{include:J?.include.map(K).filter(L.$Mf)||[],exclude:J?.exclude.map(K).filter(L.$Mf)||[]}})}createTestController(T,q,ee,J){if(this.g.has(q))throw new Error(`Attempt to insert a duplicate controller with ID "${q}"`);const K=new m.$Rc,Z=K.add(new D.$7M(q,ee,this.u));Z.root.label=ee;const ae=new Map,_=new Set,ye=this.h,ge={items:Z.root.children,get label(){return ee},set label(W){ee=W,Z.root.label=W,ye.$updateController(q,{label:ee})},get refreshHandler(){return J},set refreshHandler(W){J=W,ye.$updateController(q,{canRefresh:!!W})},get id(){return q},createRunProfile:(W,ce,me,le,de,Y)=>{let X=(0,b.$Pi)(W);for(;ae.has(X);)X++;return new U(this.h,ae,T,_,this.s.event,q,X,W,ce,me,le,de,Y)},createTestItem(W,ce,me){return new D.$5M(q,W,ce,me)},createTestRun:(W,ce,me=!0)=>this.j.createTestRun(T,q,Z,W,ce,me),invalidateTestResults:W=>{if(W===void 0)this.h.$markTestRetired(void 0);else{const ce=W instanceof Array?W:[W];this.h.$markTestRetired(ce.map(me=>o.$FJ.fromExtHostTestItem(me,q).toString()))}},set resolveHandler(W){Z.resolveHandler=W},get resolveHandler(){return Z.resolveHandler},dispose:()=>{K.dispose()}};ye.$registerTestController(q,ee,!!J),K.add((0,m.$Qc)(()=>ye.$unregisterTestController(q)));const re={controller:ge,collection:Z,profiles:ae,extension:T,activeProfiles:_};return this.g.set(q,re),K.add((0,m.$Qc)(()=>this.g.delete(q))),K.add(Z.onDidGenerateDiff(W=>ye.$publishDiff(q,W.map(i.TestsDiffOp.serialize)))),ge}createTestObserver(){return this.m.checkout()}async runTests(T,q=f.CancellationToken.None){const ee=p(T);if(!ee)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const J=this.g.get(ee.controllerId);if(!J)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(K=>o.$FJ.fromExtHostTestItem(K,J.collection.root.id).toString())??[J.collection.root.id],profileGroup:N[ee.kind],profileId:ee.profileId,controllerId:ee.controllerId}],exclude:T.exclude?.map(K=>K.id)},q)}$syncTests(){for(const{collection:T}of this.g.values())T.flushDiff();return Promise.resolve()}async $provideFileCoverage(T,q,ee){return await this.j.getCoverageReport(T,q)?.provideFileCoverage(ee)??[]}async $resolveFileCoverage(T,q,ee,J){return await this.j.getCoverageReport(T,q)?.resolveFileCoverage(ee,J)??[]}$configureRunProfile(T,q){this.g.get(T)?.profiles.get(q)?.configureHandler?.()}$setActiveRunProfiles(T){const q=new Map;for(const[ee,J]of Object.entries(T)){const K=this.g.get(ee);if(!K)continue;const Z=new Map,ae=J.filter(ye=>!K.activeProfiles.has(ye)),_=[...K.activeProfiles].filter(ye=>!J.includes(ye));for(const ye of ae)Z.set(ye,!0),K.activeProfiles.add(ye);for(const ye of _)Z.set(ye,!1),K.activeProfiles.delete(ye);Z.size&&q.set(ee,Z)}this.s.fire(q)}async $refreshTests(T,q){await this.g.get(T)?.controller.refreshHandler?.(q)}$publishTestResults(T){this.results=Object.freeze(T.map(q=>(0,w.$jn)(u.TestResults.to(q))).concat(this.results).sort((q,ee)=>ee.completedAt-q.completedAt).slice(0,32)),this.f.fire()}async $expandTest(T,q){const ee=this.g.get(o.$FJ.fromString(T).controllerId)?.collection;ee&&(await ee.expand(T,q<0?1/0:q),ee.flushDiff())}$acceptDiff(T){this.m.applyDiff(T.map(i.TestsDiffOp.deserialize))}async $runControllerTests(T,q){return Promise.all(T.map(ee=>this.w(ee,!1,q)))}async $startContinuousRun(T,q){const ee=new f.$3d(q),J=await Promise.all(T.map(K=>this.w(K,!0,ee.token)));return!q.isCancellationRequested&&!J.some(K=>K.error)&&await new Promise(K=>q.onCancellationRequested(K)),ee.dispose(!0),J}async w(T,q,ee){const J=this.g.get(T.controllerId);if(!J)return{};const{collection:K,profiles:Z,extension:ae}=J,_=Z.get(T.profileId);if(!_)return{};const ye=T.testIds.map(ce=>K.tree.get(ce)).filter(L.$Mf),ge=T.excludeExtIds.map(ce=>J.collection.tree.get(ce)).filter(L.$Mf).filter(ce=>ye.some(me=>me.fullId.compare(ce.fullId)===2));if(!ye.length)return{};const re=new g.$mM(ye.some(ce=>ce.actual instanceof D.$6M)?void 0:ye.map(ce=>ce.actual),ge.map(ce=>ce.actual),_,q),W=(0,i.$HJ)(T)&&this.j.prepareForMainThreadTestRun(re,k.fromInternal(T,J.collection),ae,ee);try{return await _.runHandler(re,ee),{}}catch(ce){return{error:String(ce)}}finally{W&&(W.hasRunningTasks&&!ee.isCancellationRequested&&await A.Event.toPromise(W.onEnd),W.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.j.cancelAllRuns():this.j.cancelRunById(T)}};e.$7gc=h,e.$7gc=h=Qe([qe(0,y.$RM)],h);const c=1e4;var v;(function(R){R[R.Running=0]="Running",R[R.Cancelling=1]="Cancelling",R[R.Ended=2]="Ended"})(v||(v={}));class P extends m.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(T,q,ee,J){super(),this.s=T,this.u=q,this.w=ee,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Sd),this.m=this.B(new A.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new f.$3d(J));const K=this.B(new E.$bh(()=>this.y(),c));this.B(this.h.token.onCancellationRequested(()=>K.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(T){const q=this.s.id,ee=this.s.controllerId,J=(0,I.$mg)(),K=this.w,Z=this.m;let ae;const _=W=>(ce,...me)=>{if(ge){console.warn(`Setting the state of test "${ce.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ce)&&(this.C(ce),W(ce,...me))},ye=(W,ce)=>{const me=ce instanceof Array?ce.map(u.TestMessage.from):[u.TestMessage.from(ce)];if(W.uri&&W.range){const le={range:u.Range.from(W.range),uri:W.uri};for(const de of me)de.location=de.location||le}this.u.$appendTestMessagesInRun(q,J,o.$FJ.fromExtHostTestItem(W,ee).toString(),me)};let ge=!1;const re={isPersisted:this.s.isPersisted,token:this.h.token,name:T,get coverageProvider(){return ae?.provider},set coverageProvider(W){(0,s.$lF)(K,"testCoverage"),ae=W&&new C(W),Z.fire({taskId:J,runId:q,coverage:ae})},enqueued:_(W=>{this.u.$updateTestStateInRun(q,J,o.$FJ.fromExtHostTestItem(W,ee).toString(),1)}),skipped:_(W=>{this.u.$updateTestStateInRun(q,J,o.$FJ.fromExtHostTestItem(W,ee).toString(),5)}),started:_(W=>{this.u.$updateTestStateInRun(q,J,o.$FJ.fromExtHostTestItem(W,ee).toString(),2)}),errored:_((W,ce,me)=>{ye(W,ce),this.u.$updateTestStateInRun(q,J,o.$FJ.fromExtHostTestItem(W,ee).toString(),6,me)}),failed:_((W,ce,me)=>{ye(W,ce),this.u.$updateTestStateInRun(q,J,o.$FJ.fromExtHostTestItem(W,ee).toString(),4,me)}),passed:_((W,ce)=>{this.u.$updateTestStateInRun(q,J,o.$FJ.fromExtHostTestItem(W,this.s.controllerId).toString(),3,ce)}),appendOutput:(W,ce,me)=>{ge||(me&&(this.s.isIncluded(me)?this.C(me):me=void 0),this.u.$appendOutputToRun(q,J,F.$ge.fromString(W),ce&&u.location.from(ce),me&&o.$FJ.fromExtHostTestItem(me,ee).toString()))},end:()=>{ge||(ge=!0,this.u.$finishedTestRunTask(q,J),this.f.delete(J),this.f.size||this.z())}};return this.f.set(J,{run:re}),this.u.$startedTestRunTask(q,{id:J,name:T,running:!0}),re}y(){for(const{run:T}of this.f.values())T.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(T){if(!(T instanceof D.$5M))throw new n.$JM(T.id);if(this.g.has(o.$FJ.fromExtHostTestItem(T,this.s.controllerId).toString()))return;const q=[],ee=this.s.colllection.root;for(;;){const J=u.TestItem.from(T);if(q.unshift(J),this.g.has(J.extId)||(this.g.add(J.extId),T===ee))break;T=T.parent||ee}this.u.$addTestsToRun(this.s.controllerId,this.s.id,q)}dispose(){this.z(),super.dispose()}}class S{get trackers(){return this.c.values()}constructor(T){this.f=T,this.c=new Map,this.d=[]}getCoverageReport(T,q){return this.d.find(ee=>ee.runId===T)?.coverage.get(q)}prepareForMainThreadTestRun(T,q,ee,J){return this.g(T,q,ee,J)}cancelRunById(T){for(const q of this.c.values())if(q.id===T){q.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,q,ee,J,K,Z){const ae=this.c.get(J);if(ae)return ae.createRun(K);const _=k.fromPublic(q,ee,J,Z),ye=p(J);this.f.$startedExtensionTestRun({controllerId:q,continuous:!!J.continuous,profile:ye&&{group:N[ye.kind],id:ye.profileId},exclude:J.exclude?.map(re=>o.$FJ.fromExtHostTestItem(re,ee.root.id).toString())??[],id:_.id,include:J.include?.map(re=>o.$FJ.fromExtHostTestItem(re,ee.root.id).toString())??[ee.root.id],persist:Z});const ge=this.g(J,_,T);return A.Event.once(ge.onEnd)(()=>{this.f.$finishedExtensionTestRun(_.id),ge.dispose()}),ge.createRun(K)}g(T,q,ee,J){const K=new P(q,this.f,ee,J);this.c.set(T,K);let Z;const ae=K.onDidCoverage(({runId:_,taskId:ye,coverage:ge})=>{Z||(Z={runId:_,coverage:new Map},this.d.unshift(Z),this.d.length>i.$MJ&&this.d.pop()),Z.coverage.set(ye,ge),this.f.$signalCoverageAvailable(_,ye,!!ge)});return A.Event.once(K.onEnd)(()=>{this.c.delete(T),ae.dispose()}),K}}e.$8gc=S;const p=R=>{if(R.profile){if(!(R.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class k{static fromPublic(T,q,ee,J){return new k(T,(0,I.$mg)(),ee.include?.map(K=>o.$FJ.fromExtHostTestItem(K,T).toString())??[T],ee.exclude?.map(K=>o.$FJ.fromExtHostTestItem(K,T).toString())??[],J,q)}static fromInternal(T,q){return new k(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,q)}constructor(T,q,ee,J,K,Z){this.controllerId=T,this.id=q,this.isPersisted=K,this.colllection=Z,this.c=ee.map(ae=>ae+"\0"),this.d=J.map(ae=>ae+"\0")}isIncluded(T){const q=o.$FJ.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const ee of this.d)if(q===ee||q.startsWith(ee))return!1;for(const ee of this.c)if(q===ee||q.startsWith(ee))return!0;return!1}}e.$9gc=k;class C{constructor(T){this.provider=T}async provideFileCoverage(T){this.c||(this.c=(async()=>this.provider.provideFileCoverage(T))());try{return(await this.c)?.map(u.TestCoverage.fromFile)??[]}catch(q){throw this.c=void 0,q}}async resolveFileCoverage(T,q){const ee=await this.c;let J=ee?.[T];return!this.provider||!ee||!J?[]:(J.detailedCoverage||(J=ee[T]=await this.provider.resolveFileCoverage?.(J,q)??J),J.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class j{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(T){this.h=T,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,u.TestItem.toPlain(T.item)),this.c.has(T)||this.d.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.d.delete(T);const q=o.$FJ.parentId(T.item.extId);if(q&&this.g.has(q.toString())){this.g.add(T.item.extId);return}this.f.add(T)}getChangeEvent(){const{c:T,d:q,f:ee}=this;return{get added(){return[...T].map(J=>J.revived)},get updated(){return[...q].map(J=>J.revived)},get removed(){return[...ee].map(J=>J.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class z extends i.$NJ{constructor(){super(...arguments),this.q=new A.$Sd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(T){return this.d.get(T)}getMirroredTestDataByReference(T){return this.d.get(T.id)}p(T,q){return{...T,revived:u.TestItem.toPlain(T.item),depth:q?q.depth+1:0,children:new Set}}o(){return new j(this.q)}}class O{constructor(T){this.d=T}checkout(){this.c||(this.c=this.f());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(q=>q.revived)},dispose:(0,M.$db)(()=>{--T.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}f(){const T=new z;return this.d.$subscribeToDiffs(),{observers:0,tests:T}}}class U{get label(){return this.d}set label(T){T!==this.d&&(this.d=T,We(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,We(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.f}set isDefault(T){T!==this.f&&(this.f=T,We(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,We(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?u.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,We(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}get isSelected(){return(0,s.$lF)(We(this,t,"f"),"testingActiveProfile"),We(this,r,"f").has(this.profileId)}get onDidChangeSelected(){return(0,s.$lF)(We(this,t,"f"),"testingActiveProfile"),A.Event.chain(We(this,d,"f"),T=>T.map(q=>q.get(this.controllerId)?.get(this.profileId)).filter(L.$Mf))}constructor(T,q,ee,J,K,Z,ae,_,ye,ge,re=!1,W=void 0,ce=!1){this.controllerId=Z,this.profileId=ae,this.d=_,this.kind=ye,this.runHandler=ge,this.f=re,this._tag=W,this.g=ce,a.set(this,void 0),t.set(this,void 0),r.set(this,void 0),d.set(this,void 0),l.set(this,void 0),nt(this,a,T,"f"),nt(this,l,q,"f"),nt(this,t,ee,"f"),nt(this,r,J,"f"),nt(this,d,K,"f"),q.set(ae,this);const me=N[ye];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${ye}`);We(this,a,"f").$publishTestRunProfile({profileId:ae,controllerId:Z,tag:W?u.TestTag.namespace(this.controllerId,W.id):null,label:_,group:me,isDefault:re,hasConfigurationHandler:!1,supportsContinuousRun:ce})}dispose(){We(this,l,"f")?.delete(this.profileId)&&(nt(this,l,void 0,"f"),We(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.$0gc=U,a=new WeakMap,t=new WeakMap,r=new WeakMap,d=new WeakMap,l=new WeakMap;const N={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(Se[339],ke([1,0,19,8,4,6,149,15,7]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class w{constructor(I,$){this.i=$,this.a=new f.$Sd({onListenerError:F.$2}),this.b=new f.$Sd({onListenerError:F.$2}),this.c=new f.$Sd({onListenerError:F.$2}),this.d=new f.$Sd({onListenerError:F.$2}),this.f=new f.$Sd({onListenerError:F.$2}),this.g=new f.$Sd({onListenerError:F.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(A.$NK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const $=this.i.allEditors();return I?$:$.map(y=>y.value)}async showTextDocument(I,$,y){let D;typeof $=="number"?D={position:b.ViewColumn.from($),preserveFocus:y}:typeof $=="object"?D={position:b.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selection:typeof $.selection=="object"?b.Range.from($.selection):void 0,pinned:typeof $.preview=="boolean"?!$.preview:void 0}:D={preserveFocus:!1};const u=await this.h.$tryShowTextDocument(I.uri,D),g=u&&this.i.getEditor(u);if(g)return g.value;throw u?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,$){return new M.$YM(this.h,I,$).value}$acceptEditorPropertiesChanged(I,$){const y=this.i.getEditor(I);if(!y)throw new Error("unknown text editor");if($.options&&y._acceptOptions($.options),$.selections){const D=$.selections.selections.map(b.Selection.to);y._acceptSelections(D)}if($.visibleRanges){const D=E.$Hb($.visibleRanges.map(b.Range.to));y._acceptVisibleRanges(D)}if($.options&&this.b.fire({textEditor:y.value,options:{...$.options,lineNumbers:b.TextEditorLineNumbersStyle.to($.options.lineNumbers)}}),$.selections){const D=m.TextEditorSelectionChangeKind.fromValue($.selections.source),u=$.selections.selections.map(b.Selection.to);this.a.fire({textEditor:y.value,selections:u,kind:D})}if($.visibleRanges){const D=E.$Hb($.visibleRanges.map(b.Range.to));this.c.fire({textEditor:y.value,visibleRanges:D})}}$acceptEditorPositionData(I){for(const $ in I){const y=this.i.getEditor($);if(!y)throw new Error("Unknown text editor");const D=b.ViewColumn.to(I[$]);y.value.viewColumn!==D&&(y._acceptViewColumn(D),this.d.fire({textEditor:y.value,viewColumn:D}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$tfc=w}),define(Se[340],ke([1,0,2,5,6,3,7,15,26,18]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=e.$_gc=void 0,e.$_gc=(0,F.$2h)("IExtHostTimeline");class L{constructor(y,D){this.b=new Map,this.c=new Map,this.a=y.getProxy(f.$NK.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(u,g)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&m.$hm.equals(g,this.b.get(u.source)?.extension)){const o=u.uri===void 0?void 0:E.URI.revive(u.uri);return this.c.get(u.source)?.get(I(o))?.get(u.handle)}else return;return u}})}async $getTimeline(y,D,u,g){return this.b.get(y)?.provider.provideTimeline(E.URI.revive(D),u,g)}registerTimelineProvider(y,D,u,g){const o=new A.$Rc,n=this.d(D.id,g,o).bind(this);let i;D.onDidChange&&(i=D.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:D.id}),this));const s=this.c;return this.f({...D,scheme:y,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(o.clear(),s.get(D.id)?.clear());const d=await D.provideTimeline(a,t,r);if(d==null)return;const l=n(a,t);return{...d,source:D.id,items:d.items.map(l)}},dispose(){for(const a of s.values())a.get(D.id)?.clear();i?.dispose(),o.dispose()}},u)}d(y,D,u){return(g,o)=>{let n;if(o?.cacheResults){let i=this.c.get(y);i===void 0&&(i=new Map,this.c.set(y,i));const s=I(g);n=i.get(s),n===void 0&&(n=new Map,i.set(s,n))}return i=>{const{iconPath:s,...a}=i,t=`${y}|${i.id??i.timestamp}`;n?.set(t,i);let r,d,l;i.iconPath&&(s instanceof M.$KL?l={id:s.id,color:s.color}:E.URI.isUri(s)?(r=s,d=s):{light:r,dark:d}=s);let h;return M.$eL.isMarkdownString(a.tooltip)?h=b.MarkdownString.from(a.tooltip):(0,w.$Ef)(a.tooltip)?h=a.tooltip:M.$eL.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=b.MarkdownString.from(a.detail)):(0,w.$Ef)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=a.detail),{...a,id:a.id??void 0,handle:t,source:y,command:i.command?D.toInternal(i.command,u):void 0,icon:r,iconDark:d,themeIcon:l,tooltip:h,accessibilityInformation:i.accessibilityInformation}}}}f(y,D){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:D}),(0,A.$Qc)(()=>{for(const g of this.c.values())g.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$ahc=L;function I($){return $?.toString()}}),define(Se[72],ke([1,0,21,4,3,221,5,14,88,6,27,20,7]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gyb=e.$fyb=e.TunnelDtoConverter=void 0;class y extends m.$vv{}var D;(function(g){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}g.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}g.fromServiceTunnel=n})(D||(e.TunnelDtoConverter=D={})),e.$fyb=(0,M.$2h)("IExtHostTunnelService");let u=class extends f.$Sc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(w.$NK.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const s=new y(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new $.$PK(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,s,a){const t=[];for(const d of o){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(n.map(async h=>{let c;try{c=await l.provider.providePortAttributes({port:h,pid:i,commandLine:s},a)}catch{c=await l.provider.providePortAttributes(h,i,s,a)}return{providedAttributes:c,port:h}})))}const r=t.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,a)=>await o.provideTunnel(s,a,new E.$3d().token)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,f.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let s=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:s}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,f.$Qc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:s,disposeListener:a}),D.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(s=>this.f(s.host,s.port,s.detail??""))),i=o.filter((s,a)=>n[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$gyb=u,e.$gyb=u=Qe([qe(0,I.$RM),qe(1,L.$8M),qe(2,b.$jj)],u)}),define(Se[341],ke([1,0,3,17,2,6]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class M{constructor(m){this.c=new Map,this.b=m.getProxy(A.$NK.MainThreadUriOpeners)}registerExternalUriOpener(m,w,L,I){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const $=I.schemes.find(y=>!M.a.has(y));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(w,L),this.b.$registerUriOpener(w,I.schemes,m,I.label),(0,E.$Qc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(m,w,L){const I=this.c.get(m);if(!I)throw new Error(`Unknown opener with id: ${m}`);const $=f.URI.revive(w);return I.canOpenExternalUri($,L)}async $openUri(m,w,L){const I=this.c.get(m);if(!I)throw new Error(`Unknown opener id: '${m}'`);return I.openExternalUri(f.URI.revive(w.resolvedUri),{sourceUri:f.URI.revive(w.sourceUri)},L)}}e.$chc=M,M.a=new Set([F.Schemas.http,F.Schemas.https])}),define(Se[342],ke([1,0,6,2,3,8,26]),function(ie,e,E,F,f,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class b{constructor(w){this.c=new M.$im,this.d=new Map,this.b=w.getProxy(E.$NK.MainThreadUrls)}registerUriHandler(w,L){const I=w.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const $=b.a++;return this.c.add(I),this.d.set($,L),this.b.$registerUriHandler($,I,w.displayName||w.name),(0,f.$Qc)(()=>{this.c.delete(I),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(w,L){const I=this.d.get(w);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(L))}catch($){(0,A.$1)($)}return Promise.resolve(void 0)}async createAppUri(w){return F.URI.revive(await this.b.$createAppUri(w))}}e.$dhc=b,b.a=0});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[93],ke([1,0,4,3,17,24,2,238,275,114,6]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";var I,$,y,D,u,g,o,n,i,s,a,t,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=e.$Kfc=e.$Jfc=e.$Ifc=e.$Hfc=void 0;class d{constructor(C,j,z,O,U,N,R){I.set(this,void 0),$.set(this,void 0),y.set(this,void 0),D.set(this,void 0),u.set(this,void 0),g.set(this,void 0),o.set(this,""),n.set(this,void 0),i.set(this,!1),s.set(this,!1),a.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new E.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new E.$Sd),this._onDidDispose=We(this,r,"f").event,nt(this,I,C,"f"),nt(this,$,j,"f"),nt(this,n,z,"f"),nt(this,D,O,"f"),nt(this,u,U,"f"),nt(this,g,N,"f"),nt(this,a,l(N),"f"),nt(this,t,h(N),"f"),nt(this,y,R,"f")}dispose(){nt(this,i,!0,"f"),We(this,r,"f").fire(),We(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(C){return nt(this,s,!0,"f"),(0,w.$ovb)(C,We(this,D,"f"))}get cspSource(){const C=We(this,g,"f").extensionLocation;if(C.scheme===f.Schemas.https||C.scheme===f.Schemas.http){let j=C.toString();return j.endsWith("/")||(j+="/"),j+" "+w.$nvb}return w.$nvb}get html(){return this.a(),We(this,o,"f")}set html(C){this.a(),We(this,o,"f")!==C&&(nt(this,o,C,"f"),We(this,t,"f")&&!We(this,s,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(C)&&(nt(this,s,!0,"f"),We(this,y,"f").report("Webview vscode-resource: uris",We(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),We(this,$,"f").$setHtml(We(this,I,"f"),this.b(C)))}get options(){return this.a(),We(this,n,"f")}set options(C){this.a(),A.$mn(We(this,n,"f"),C)||We(this,$,"f").$setOptions(We(this,I,"f"),P(We(this,g,"f"),We(this,u,"f"),C)),nt(this,n,C,"f")}async postMessage(C){if(We(this,i,"f"))return!1;const j=(0,m.$6kb)(C,{serializeBuffersForPostMessage:We(this,a,"f")});return We(this,$,"f").$postMessage(We(this,I,"f"),j.message,...j.buffers)}a(){if(We(this,i,"f"))throw new Error("Webview is disposed")}b(C){if(!We(this,t,"f"))return C;const j=We(this,g,"f").extensionLocation?.scheme===f.Schemas.vscodeRemote,z=We(this,g,"f").extensionLocation.scheme===f.Schemas.vscodeRemote?We(this,g,"f").extensionLocation.authority:void 0;return C.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(O,U,N,R,T,q)=>{const ee=M.URI.from({scheme:R||"file",path:decodeURIComponent(T)}),J=(0,w.$ovb)(ee,{isRemote:j,authority:z}).toString();return`${U}${J}${q}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(O,U,N,R,T,q)=>{const ee=M.URI.from({scheme:R||"file",path:decodeURIComponent(T)}),J=(0,w.$ovb)(ee,{isRemote:j,authority:z}).toString();return`${U}${J}${q}`})}}e.$Hfc=d,I=new WeakMap,$=new WeakMap,y=new WeakMap,D=new WeakMap,u=new WeakMap,g=new WeakMap,o=new WeakMap,n=new WeakMap,i=new WeakMap,s=new WeakMap,a=new WeakMap,t=new WeakMap,r=new WeakMap;function l(k){try{const C=(0,b.$2o)((0,b.$1o)(k.engines.vscode));return!!C&&C.majorBase>=1&&C.minorBase>=57}catch{return!1}}e.$Ifc=l;function h(k){try{const C=(0,b.$2o)((0,b.$1o)(k.engines.vscode));return C?C.majorBase<1||C.majorBase===1&&C.minorBase<60:!1}catch{return!1}}class c extends F.$Sc{constructor(C,j,z,O,U){super(),this.c=j,this.f=z,this.g=O,this.h=U,this.b=new Map,this.a=C.getProxy(L.$NK.MainThreadWebviews)}dispose(){super.dispose();for(const C of this.b.values())C.dispose();this.b.clear()}$onMessage(C,j,z){const O=this.j(C);if(O){const{message:U}=(0,m.$7kb)(j,z.value);O._onMessageEmitter.fire(U)}}$onMissingCsp(C,j){this.g.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(C,j,z){const O=new d(C,this.a,S(j),this.c,this.f,z,this.h);this.b.set(C,O);const U=O._onDidDispose(()=>{U.dispose(),this.deleteWebview(C)});return O}deleteWebview(C){this.b.delete(C)}j(C){return this.b.get(C)}}e.$Jfc=c;function v(k){return{id:k.identifier,location:k.extensionLocation}}e.$Kfc=v;function P(k,C,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||p(k,C)}}e.$Lfc=P;function S(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(C=>M.URI.from(C))}}function p(k,C){return[...(C?.getWorkspaceFolders()||[]).map(j=>j.uri),k.extensionLocation]}}),define(Se[343],ke([1,0,21,53,3,17,23,2,15,93,110,6,7]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;class y{constructor(r,d){this.document=r,this.b=d,this.a=1,this.c=new L.$afc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,d){await this.f(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.f(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this.a++;return(0,M.$Dg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const d=this.c.get(r,0);if(!d)throw new Error("No edit found");return d}}class D{constructor(){this.a=new Map}get(r,d){return this.a.get(this.b(r,d))}add(r,d,l){const h=this.b(r,d.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const c=new y(d,l);return this.a.set(h,c),c}delete(r,d){const l=this.b(r,d.uri);this.a.delete(l)}b(r,d){return`${r}@@@${d}`}}var u;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(u||(u={}));class g{constructor(){this.a=new Map}addTextProvider(r,d,l){return this.b(0,r,d,l)}addCustomProvider(r,d,l){return this.b(1,r,d,l)}get(r){return this.a.get(r)}b(r,d,l,h){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:r,extension:l,provider:h}),new $.$PK(()=>this.a.delete(d))}}class o{constructor(r,d,l,h,c){this.d=d,this.f=l,this.g=h,this.h=c,this.b=new g,this.c=new D,this.a=r.getProxy(I.$NK.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,l,h){const c=new f.$Rc;return i(l)?(c.add(this.b.addTextProvider(d,r,l)),this.a.$registerTextEditorProvider((0,w.$Kfc)(r),d,h.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,w.$Ifc)(r))):(c.add(this.b.addCustomProvider(d,r,l)),n(l)&&c.add(l.onDidChangeCustomDocument(v=>{const P=this.i(d,v.document.uri);if(s(v)){const S=P.addEdit(v);this.a.$onDidEdit(v.document.uri,d,S,v.label)}else this.a.$onContentChange(v.document.uri,d)})),this.a.$registerCustomEditorProvider((0,w.$Kfc)(r),d,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,w.$Ifc)(r))),$.$PK.from(c,new $.$PK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,l,h,c){const v=this.b.get(d);if(!v)throw new Error(`No provider found for '${d}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${d}'`);const P=b.URI.revive(r),S=await v.provider.openCustomDocument(P,{backupId:l,untitledDocumentData:h?.buffer},c);let p;return n(v.provider)&&this.f&&(p=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(d,S,p),{editable:n(v.provider)}}async $disposeCustomDocument(r,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const h=b.URI.revive(r),{document:c}=this.i(d,h);this.c.delete(d,c),c.dispose()}async $resolveCustomEditor(r,d,l,h,c,v){const P=this.b.get(l);if(!P)throw new Error(`No provider found for '${l}'`);const S=m.ViewColumn.to(c),p=this.g.createNewWebview(d,h.contentOptions,P.extension),k=this.h.createNewWebviewPanel(d,l,h.title,S,h.options,p,h.active),C=b.URI.revive(r);switch(P.type){case 1:{const{document:j}=this.i(l,C);return P.provider.resolveCustomEditor(j,k,v)}case 0:{const j=this.d.getDocument(C);return P.provider.resolveCustomTextEditor(j,k,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,l){this.i(d,r).disposeEdits(l)}async $onMoveCustomEditor(r,d,l){const h=this.b.get(l);if(!h)throw new Error(`No provider found for '${l}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const c=this.h.getWebviewPanel(r);if(!c)throw new Error("No webview found");const v=b.URI.revive(d),P=this.d.getDocument(v);await h.provider.moveCustomTextEditor(P,c,E.CancellationToken.None)}async $undo(r,d,l,h){return this.i(d,r).undo(l,h)}async $redo(r,d,l,h){return this.i(d,r).redo(l,h)}async $revert(r,d,l){const h=this.i(d,r);await this.j(d).revertCustomDocument(h.document,l),h.disposeBackup()}async $onSave(r,d,l){const h=this.i(d,r);await this.j(d).saveCustomDocument(h.document,l),h.disposeBackup()}async $onSaveAs(r,d,l,h){const c=this.i(d,r);return this.j(d).saveCustomDocumentAs(c.document,b.URI.revive(l),h)}async $backup(r,d,l){const h=this.i(d,r),v=await this.j(d).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},l);return h.updateBackup(v),v.id}i(r,d){const l=this.c.get(r,b.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(r){const l=this.b.get(r)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$Nfc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Pi)(r)+""}});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[344],ke([1,0,4,3,2,30,15,93,6,7]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";var L,I,$,y,D,u,g,o,n,i,s,a,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class r extends F.$Sc{constructor(c,v,P,S){super(),L.set(this,void 0),I.set(this,void 0),$.set(this,void 0),y.set(this,void 0),D.set(this,void 0),u.set(this,void 0),g.set(this,void 0),o.set(this,void 0),n.set(this,!0),i.set(this,void 0),s.set(this,!1),a.set(this,this.B(new E.$Sd)),this.onDidDispose=We(this,a,"f").event,t.set(this,this.B(new E.$Sd)),this.onDidChangeViewState=We(this,t,"f").event,nt(this,L,c,"f"),nt(this,I,v,"f"),nt(this,y,P,"f"),nt(this,$,S.viewType,"f"),nt(this,D,S.panelOptions,"f"),nt(this,o,S.viewColumn,"f"),nt(this,u,S.title,"f"),nt(this,i,S.active,"f")}dispose(){We(this,s,"f")||(nt(this,s,!0,"f"),We(this,a,"f").fire(),We(this,I,"f").$disposeWebview(We(this,L,"f")),We(this,y,"f").dispose(),super.dispose())}get webview(){return this.c(),We(this,y,"f")}get viewType(){return this.c(),We(this,$,"f")}get title(){return this.c(),We(this,u,"f")}set title(c){this.c(),We(this,u,"f")!==c&&(nt(this,u,c,"f"),We(this,I,"f").$setTitle(We(this,L,"f"),c))}get iconPath(){return this.c(),We(this,g,"f")}set iconPath(c){this.c(),We(this,g,"f")!==c&&(nt(this,g,c,"f"),We(this,I,"f").$setIconPath(We(this,L,"f"),f.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return We(this,D,"f")}get viewColumn(){if(this.c(),!(typeof We(this,o,"f")=="number"&&We(this,o,"f")<0))return We(this,o,"f")}get active(){return this.c(),We(this,i,"f")}get visible(){return this.c(),We(this,n,"f")}_updateViewState(c){We(this,s,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(nt(this,i,c.active,"f"),nt(this,n,c.visible,"f"),nt(this,o,c.viewColumn,"f"),We(this,t,"f").fire({webviewPanel:this}))}reveal(c,v){this.c(),We(this,I,"f").$reveal(We(this,L,"f"),{viewColumn:typeof c>"u"?void 0:M.ViewColumn.from(c),preserveFocus:!!v})}c(){if(We(this,s,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,I=new WeakMap,$=new WeakMap,y=new WeakMap,D=new WeakMap,u=new WeakMap,g=new WeakMap,o=new WeakMap,n=new WeakMap,i=new WeakMap,s=new WeakMap,a=new WeakMap,t=new WeakMap;class d extends F.$Sc{static c(){return(0,A.$mg)()}constructor(c,v,P){super(),this.j=v,this.m=P,this.g=new Map,this.h=new Map,this.f=c.getProxy(m.$NK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(c=>c.dispose()),this.g.clear()}createWebviewPanel(c,v,P,S,p={}){const k=typeof S=="object"?S.viewColumn:S,C={viewColumn:M.ViewColumn.from(k),preserveFocus:typeof S=="object"&&!!S.preserveFocus},j=(0,b.$Ifc)(c),z=d.c();this.f.$createWebviewPanel((0,b.$Kfc)(c),z,v,{title:P,panelOptions:l(p),webviewOptions:(0,b.$Lfc)(c,this.m,p),serializeBuffersForPostMessage:j},C);const O=this.j.createNewWebview(z,p,c);return this.createNewWebviewPanel(z,v,P,k,p,O,!0)}$onDidChangeWebviewPanelViewStates(c){const v=Object.keys(c);v.sort((P,S)=>{const p=c[P],k=c[S];return p.active?1:k.active?-1:+p.visible-+k.visible});for(const P of v){const S=this.getWebviewPanel(P);if(!S)continue;const p=c[P];S._updateViewState({active:p.active,visible:p.visible,viewColumn:M.ViewColumn.to(p.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this.g.delete(c),this.j.deleteWebview(c)}registerWebviewPanelSerializer(c,v,P){if(this.h.has(v))throw new Error(`Serializer for '${v}' already registered`);return this.h.set(v,{serializer:P,extension:c}),this.f.$registerSerializer(v,{serializeBuffersForPostMessage:(0,b.$Ifc)(c)}),new w.$PK(()=>{this.h.delete(v),this.f.$unregisterSerializer(v)})}async $deserializeWebviewPanel(c,v,P,S){const p=this.h.get(v);if(!p)throw new Error(`No serializer found for '${v}'`);const{serializer:k,extension:C}=p,j=this.j.createNewWebview(c,P.webviewOptions,C),z=this.createNewWebviewPanel(c,v,P.title,S,P.panelOptions,j,P.active);await k.deserializeWebviewPanel(z,P.state)}createNewWebviewPanel(c,v,P,S,p,k,C){const j=new r(c,this.f,k,{viewType:v,title:P,viewColumn:S,panelOptions:p,active:C});return this.g.set(c,j),j}getWebviewPanel(c){return this.g.get(c)}}e.$Mfc=d;function l(h){return{enableFindWidget:h.enableFindWidget,retainContextWhenHidden:h.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[345],ke([1,0,4,3,93,15,6,7]),function(ie,e,E,F,f,A,M,b){"use strict";var m,w,L,I,$,y,D,u,g,o,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class i extends F.$Sc{constructor(t,r,d,l,h,c){super(),m.set(this,void 0),w.set(this,void 0),L.set(this,void 0),I.set(this,void 0),$.set(this,!1),y.set(this,void 0),D.set(this,void 0),u.set(this,void 0),g.set(this,void 0),o.set(this,this.B(new E.$Sd)),this.onDidChangeVisibility=We(this,o,"f").event,n.set(this,this.B(new E.$Sd)),this.onDidDispose=We(this,n,"f").event,nt(this,L,d,"f"),nt(this,D,l,"f"),nt(this,m,t,"f"),nt(this,w,r,"f"),nt(this,I,h,"f"),nt(this,y,c,"f")}dispose(){We(this,$,"f")||(nt(this,$,!0,"f"),We(this,n,"f").fire(),We(this,I,"f").dispose(),super.dispose())}get title(){return this.a(),We(this,D,"f")}set title(t){this.a(),We(this,D,"f")!==t&&(nt(this,D,t,"f"),We(this,w,"f").$setWebviewViewTitle(We(this,m,"f"),t))}get description(){return this.a(),We(this,u,"f")}set description(t){this.a(),We(this,u,"f")!==t&&(nt(this,u,t,"f"),We(this,w,"f").$setWebviewViewDescription(We(this,m,"f"),t))}get visible(){return We(this,y,"f")}get webview(){return We(this,I,"f")}get viewType(){return We(this,L,"f")}_setVisible(t){t===We(this,y,"f")||We(this,$,"f")||(nt(this,y,t,"f"),We(this,o,"f").fire())}get badge(){return this.a(),We(this,g,"f")}set badge(t){this.a(),!(t?.value===We(this,g,"f")?.value&&t?.tooltip===We(this,g,"f")?.tooltip)&&(nt(this,g,A.ViewBadge.from(t),"f"),We(this,w,"f").$setWebviewViewBadge(We(this,m,"f"),t))}show(t){this.a(),We(this,w,"f").$show(We(this,m,"f"),!!t)}a(){if(We(this,$,"f"))throw new Error("Webview is disposed")}}m=new WeakMap,w=new WeakMap,L=new WeakMap,I=new WeakMap,$=new WeakMap,y=new WeakMap,D=new WeakMap,u=new WeakMap,g=new WeakMap,o=new WeakMap,n=new WeakMap;class s{constructor(t,r){this.d=r,this.b=new Map,this.c=new Map,this.a=t.getProxy(M.$NK.MainThreadWebviewViews)}registerWebviewViewProvider(t,r,d,l){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:d,extension:t}),this.a.$registerWebviewViewProvider((0,f.$Kfc)(t),r,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$Ifc)(t)}),new b.$PK(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(t,r,d,l,h){const c=this.b.get(r);if(!c)throw new Error(`No view provider found for '${r}'`);const{provider:v,extension:P}=c,S=this.d.createNewWebview(t,{},P),p=new i(t,this.a,r,d,S,!0);this.c.set(t,p),await v.resolveWebviewView(p,{state:l},h)}async $onDidChangeWebviewViewVisibility(t,r){this.e(t)._setVisible(r)}async $disposeWebviewView(t){const r=this.e(t);this.c.delete(t),r.dispose(),this.d.deleteWebview(t)}e(t){const r=this.c.get(t);if(!r)throw new Error("No webview found");return r}}e.$ehc=s}),define(Se[152],ke([1,0,4,6,2,17,13,5,20,25]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=void 0;let I=L=class{getState(y){const D=this.d;return{get focused(){return D.focused},get active(){return(0,w.$lF)(y,"windowActivity"),D.active}}}constructor(y){this.c=new E.$Sd,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=y.getProxy(F.$NK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:u})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",u)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,D){D!==this.d[y]&&(this.d={...this.d,[y]:D},this.c.fire(this.d))}openUri(y,D){let u;if(typeof y=="string"){u=y;try{y=f.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,M.$Ge)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,u,D)}async asExternalUri(y,D){if((0,M.$Ge)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this.b.$asExternalUri(y,D);return f.URI.from(u)}};e.$fhc=I,I.a={focused:!0,active:!0},e.$fhc=I=L=Qe([qe(0,m.$RM)],I),e.$ghc=(0,b.$2h)("IExtHostWindow")}),define(Se[346],ke([1,0,314,27,20]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;const A=1024*1024;let M=class extends E.$jhc{constructor(m,w){super(m,w),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(m,w,L){const I=m==="error"||m==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),w.apply(console,L),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(m,w){const L=process[m],I=L.write;let $="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(y,D,u)=>{if(!this.g){$+=y.toString(D);const g=$.length>A?$.length:$.lastIndexOf(`
`);g!==-1&&(console[w]($.slice(0,g)),$=$.slice(g+1))}I.call(L,y,D,u)}})}};e.$Uhc=M,e.$Uhc=M=Qe([qe(0,f.$RM),qe(1,F.$8M)],M)}),define(Se[347],ke([1,0,71,17,14,250,32,9]),function(ie,e,E,F,f,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;let m=class{constructor(I,$){I.addFileSystemProvider(F.Schemas.file,new w($),{isCaseSensitive:b.$e})}};e.$Vhc=m,e.$Vhc=m=Qe([qe(0,E.$Efc),qe(1,f.$jj)],m);class w{constructor(I){this.b=I,this.a=new A.$oq(this.b)}async stat(I){const $=await this.a.stat(I);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,$,y){return this.a.writeFile(I,$,{...y,unlock:!1,atomic:!1})}delete(I,$){return this.a.delete(I,{...$,useTrash:!1,atomic:!1})}rename(I,$,y){return this.a.rename(I,$,y)}copy(I,$,y){return this.a.copy(I,$,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,$){throw new Error("Method not implemented.")}}}),define(Se[348],ke([1,0,16,62,30,35,3,6,2,20]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;let L=class extends M.$Sc{constructor($,y){super();const D=$.getProxy(b.$NK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async u=>{const g=m.URI.file((0,E.$jc)((0,F.tmpdir)(),(0,f.$mg)()));return await D.$download(u,g),g})}};e.$Thc=L,e.$Thc=L=Qe([qe(0,w.$RM),qe(1,A.$bN)],L)}),define(Se[349],ke([1,0,151,17,252,30]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class M extends E.$ihc{s(m,w,L){return m.scheme===F.Schemas.file?new f.$5N(L?.name||(0,A.$mg)(),m.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,w):super.s(m,w,L)}registerLogger(m){super.registerLogger(m),this.r.$registerLogger(m)}deregisterLogger(m){super.deregisterLogger(m),this.r.$deregisterLogger(m)}}e.$7hc=M}),define(Se[350],ke([1,0,55,16,2,92,3,17,10,31]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class L extends A.$Gfc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==b.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let l=0;do{let h;l===0?h=d:h=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await I(h);const c=F.$jc(h,"vscode.lock"),v=await u(this.d,c,!1);if(v)return this.i=v,process.on("exit",()=>{v.dispose()}),f.URI.file(h);l++}while(l<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$6hc=L;async function I(a){try{await w.Promises.stat(a);return}catch{}try{await w.Promises.mkdir(a,{recursive:!0})}catch{}}const $=1e3,y=10*60*1e3;class D extends M.$Sc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new m.$ah),this.a.cancelAndSet(async()=>{const d=await g(t,r);(!d||d.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await w.Promises.utimes(r,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${r}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{E.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await w.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function u(a,t,r){try{const l={pid:process.pid,willReleaseAt:0};await w.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){a.error(l)}const d=await g(a,t);return!d||d.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new D(a,t))}async function g(a,t){let r;try{r=await w.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(r))}catch(d){return a.error(d),null}}async function o(a,t){let r;try{r=await w.Promises.stat(t)}catch(d){return a.error(d),0}return r.mtime.getTime()}function n(a){try{return process.kill(a,0),!0}catch{return!1}}async function i(a,t){const r=await g(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),s(a,t);if(r.willReleaseAt){let v=r.willReleaseAt-Date.now();if(v<5e3){for(v>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${v} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);v>0;){if(await(0,m.$3g)(Math.min(100,v)),await o(a,t)===0)return s(a,t);v=r.willReleaseAt-Date.now()}return s(a,t)}}if(!n(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),s(a,t);const d=await o(a,t),l=Date.now()-d;if(l<=y)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,m.$3g)(2e3);const h=await o(a,t),c=Date.now()-h;return c<=y?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),s(a,t))}async function s(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await w.Promises.unlink(t)}catch{}return u(a,t,!0)}}),define(Se[351],ke([1,0,30,20,47,35]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;let M=class extends f.$3fc{constructor(m,w){super(!0,m,w)}createTerminal(m,w,L){return this.createTerminalFromOptions({name:m,shellPath:w,shellArgs:L})}createTerminalFromOptions(m,w){const L=new f.$2fc(this.a,(0,E.$mg)(),m,m.name);return this.f.push(L),L.create(m,this.R(m,w)),L.value}};e.$ohc=M,e.$ohc=M=Qe([qe(0,A.$bN),qe(1,F.$RM)],M)}),define(Se[352],ke([1,0,10,22,21,8,4,3,128,303,68]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=e.ResponsiveState=e.RequestInitiator=e.$v7b=e.$u7b=void 0;function $(k,C){try{return JSON.stringify(k,C)}catch{return"null"}}const y="$$ref$$",D={[y]:-1};class u{constructor(C,j){this.jsonString=C,this.referencedBuffers=j}}function g(k,C=null,j=!1){const z=[];return{jsonString:(j?$:JSON.stringify)(k,(U,N)=>{if(typeof N>"u")return D;if(typeof N=="object"){if(N instanceof F.$ge){const R=z.push(N)-1;return{[y]:R}}if(C)return C(U,N)}return N}),referencedBuffers:z}}e.$u7b=g;function o(k,C,j){return JSON.parse(k,(z,O)=>{if(O){const U=O[y];if(typeof U=="number")return C[U];if(j&&O.$mid===1)return j.transformIncoming(O)}return O})}e.$v7b=o;function n(k,C){return JSON.stringify(k,C)}function i(k){return k?(C,j)=>j&&j.$mid===1?k.transformOutgoing(j):j:null}var s;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(s||(e.RequestInitiator=s={}));var a;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends b.$Sc{constructor(C,j=null,z=null){super(),this[I]=!0,this.b=this.B(new M.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=j,this.g=z,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let O=0,U=L.$Cv.count;O<U;O++)this.m[O]=null,this.s[O]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$bh(()=>this.H(),1e3)),this.c.onMessage(O=>this.L(O))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const j=this.w[C];delete this.w[C],j.resolveErr(A.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,m.$3m)(C,this.g):C}getProxy(C){const{nid:j,sid:z}=C;return this.s[j]||(this.s[j]=this.J(j,z)),this.s[j]}J(C,j){const z={get:(O,U)=>(typeof U=="string"&&!O[U]&&U.charCodeAt(0)===36&&(O[U]=(...N)=>this.U(C,U,N)),U===d?j:O[U])};return new Proxy(Object.create(null),z)}set(C,j){return this.m[C.nid]=j,j}assertRegistered(C){for(let j=0,z=C.length;j<z;j++){const O=C[j];if(!this.m[O.nid])throw new Error(`Missing proxy instance ${O.sid}`)}}L(C){if(this.j)return;const j=C.byteLength,z=c.read(C,0),O=z.readUInt8(),U=z.readUInt32();switch(O){case 1:case 2:{let{rpcId:N,method:R,args:T}=P.deserializeRequestJSONArgs(z);this.g&&(T=(0,m.$3m)(T,this.g)),this.M(j,U,N,R,T,O===2);break}case 3:case 4:{let{rpcId:N,method:R,args:T}=P.deserializeRequestMixedArgs(z);this.g&&(T=(0,m.$3m)(T,this.g)),this.M(j,U,N,R,T,O===4);break}case 5:{this.f?.logIncoming(j,U,0,"ack"),this.G(U);break}case 6:{this.N(j,U);break}case 7:{this.O(j,U,void 0);break}case 9:{let N=P.deserializeReplyOKJSON(z);this.g&&(N=(0,m.$3m)(N,this.g)),this.O(j,U,N);break}case 10:{const N=P.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(j,U,N);break}case 8:{const N=P.deserializeReplyOKVSBuffer(z);this.O(j,U,N);break}case 11:{let N=P.deserializeReplyErrError(z);this.g&&(N=(0,m.$3m)(N,this.g)),this.P(j,U,N);break}case 12:{this.P(j,U,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,j,z,O,U,N){this.f?.logIncoming(C,j,1,`receiveRequest ${(0,L.$Ev)(z)}.${O}(`,U);const R=String(j);let T,q;if(N){const J=new f.$3d;U.push(J.token),T=this.Q(z,O,U),q=()=>J.cancel()}else T=this.Q(z,O,U),q=t;this.u[R]=q;const ee=P.serializeAcknowledged(j);this.f?.logOutgoing(ee.byteLength,j,1,"ack"),this.c.send(ee),T.then(J=>{delete this.u[R];const K=P.serializeReplyOK(j,J,this.h);this.f?.logOutgoing(K.byteLength,j,1,"reply:",J),this.c.send(K)},J=>{delete this.u[R];const K=P.serializeReplyErr(j,J);this.f?.logOutgoing(K.byteLength,j,1,"replyErr:",J),this.c.send(K)})}N(C,j){this.f?.logIncoming(C,j,1,"receiveCancel");const z=String(j);this.u[z]?.()}O(C,j,z){this.f?.logIncoming(C,j,0,"receiveReply:",z);const O=String(j);if(!this.w.hasOwnProperty(O))return;const U=this.w[O];delete this.w[O],U.resolveOk(z)}P(C,j,z){this.f?.logIncoming(C,j,0,"receiveReplyErr:",z);const O=String(j);if(!this.w.hasOwnProperty(O))return;const U=this.w[O];delete this.w[O];let N;z&&(z.$isError?(N=new Error,N.name=z.name,N.message=z.message,N.stack=z.stack):N=z),U.resolveErr(N)}Q(C,j,z){try{return Promise.resolve(this.S(C,j,z))}catch(O){return Promise.reject(O)}}S(C,j,z){const O=this.m[C];if(!O)throw new Error("Unknown actor "+(0,L.$Ev)(C));const U=O[j];if(typeof U!="function")throw new Error("Unknown method "+j+" on actor "+(0,L.$Ev)(C));return U.apply(O,z)}U(C,j,z){if(this.j)return new w.$t7b;let O=null;if(z.length>0&&f.CancellationToken.isCancellationToken(z[z.length-1])&&(O=z.pop()),O&&O.isCancellationRequested)return Promise.reject(A.$6());const U=P.serializeRequestArguments(z,this.h),N=++this.t,R=String(N),T=new w.$s7b,q=new b.$Rc;O&&q.add(O.onCancellationRequested(()=>{const J=P.serializeCancel(N);this.f?.logOutgoing(J.byteLength,N,0,"cancel"),this.c.send(P.serializeCancel(N))})),this.w[R]=new h(T,q),this.F(N);const ee=P.serializeRequest(N,C,j,U,!!O);return this.f?.logOutgoing(ee.byteLength,N,0,`request: ${(0,L.$Ev)(C)}.${j}(`,z),this.c.send(ee),T}}e.$w7b=l,I=r,l.a=3*1e3;class h{constructor(C,j){this.a=C,this.b=j}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class c{static alloc(C,j,z){const O=new c(F.$ge.alloc(z+1+4),0);return O.writeUInt8(C),O.writeUInt32(j),O}static read(C,j){return new c(C,j)}get buffer(){return this.a}constructor(C,j){this.a=C,this.b=j}static sizeUInt8(){return 1}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+C);return this.b+=C,j}static sizeMixedArray(C){let j=0;j+=1;for(let z=0,O=C.length;z<O;z++){const U=C[z];switch(j+=1,U.type){case 1:j+=this.sizeLongString(U.value);break;case 2:j+=this.sizeVSBuffer(U.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(U.value);for(let N=0;N<U.buffers.length;++N)j+=this.sizeVSBuffer(U.buffers[N]);break;case 4:break}}return j}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let j=0,z=C.length;j<z;j++){const O=C[j];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let U=0;U<O.buffers.length;++U)this.writeBuffer(O.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const j=new Array(C);for(let z=0;z<C;z++)switch(this.readUInt8()){case 1:j[z]=this.readLongString();break;case 2:j[z]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),N=this.readLongString(),R=[];for(let T=0;T<U;++T)R.push(this.readVSBuffer());j[z]=new L.$Fv(o(N,R,null));break}case 4:j[z]=void 0;break}return j}}c.sizeUInt32=4;var v;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(v||(v={}));class P{static a(C){for(let j=0,z=C.length;j<z;j++)if(C[j]instanceof F.$ge||C[j]instanceof L.$Fv||typeof C[j]>"u")return!0;return!1}static serializeRequestArguments(C,j){if(this.a(C)){const z=[];for(let O=0,U=C.length;O<U;O++){const N=C[O];if(N instanceof F.$ge)z[O]={type:2,value:N};else if(typeof N>"u")z[O]={type:4};else if(N instanceof L.$Fv){const{jsonString:R,referencedBuffers:T}=g(N.value,j);z[O]={type:3,value:F.$ge.fromString(R),buffers:T}}else z[O]={type:1,value:F.$ge.fromString(n(N,j))}}return{type:1,args:z}}return{type:0,args:n(C,j)}}static serializeRequest(C,j,z,O,U){switch(O.type){case 0:return this.b(C,j,z,O.args,U);case 1:return this.c(C,j,z,O.args,U)}}static b(C,j,z,O,U){const N=F.$ge.fromString(z),R=F.$ge.fromString(O);let T=0;T+=c.sizeUInt8(),T+=c.sizeShortString(N),T+=c.sizeLongString(R);const q=c.alloc(U?2:1,C,T);return q.writeUInt8(j),q.writeShortString(N),q.writeLongString(R),q.buffer}static deserializeRequestJSONArgs(C){const j=C.readUInt8(),z=C.readShortString(),O=C.readLongString();return{rpcId:j,method:z,args:JSON.parse(O)}}static c(C,j,z,O,U){const N=F.$ge.fromString(z);let R=0;R+=c.sizeUInt8(),R+=c.sizeShortString(N),R+=c.sizeMixedArray(O);const T=c.alloc(U?4:3,C,R);return T.writeUInt8(j),T.writeShortString(N),T.writeMixedArray(O),T.buffer}static deserializeRequestMixedArgs(C){const j=C.readUInt8(),z=C.readShortString(),O=C.readMixedArray(),U=new Array(O.length);for(let N=0,R=O.length;N<R;N++){const T=O[N];typeof T=="string"?U[N]=JSON.parse(T):U[N]=T}return{rpcId:j,method:z,args:U}}static serializeAcknowledged(C){return c.alloc(5,C,0).buffer}static serializeCancel(C){return c.alloc(6,C,0).buffer}static serializeReplyOK(C,j,z){if(typeof j>"u")return this.d(C);if(j instanceof F.$ge)return this.e(C,j);if(j instanceof L.$Fv){const{jsonString:O,referencedBuffers:U}=g(j.value,z,!0);return this.g(C,O,U)}else return this.f(C,$(j,z))}static d(C){return c.alloc(7,C,0).buffer}static e(C,j){let z=0;z+=c.sizeVSBuffer(j);const O=c.alloc(8,C,z);return O.writeVSBuffer(j),O.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,j){const z=F.$ge.fromString(j);let O=0;O+=c.sizeLongString(z);const U=c.alloc(9,C,O);return U.writeLongString(z),U.buffer}static g(C,j,z){const O=F.$ge.fromString(j);let U=0;U+=c.sizeUInt32,U+=c.sizeLongString(O);for(const R of z)U+=c.sizeVSBuffer(R);const N=c.alloc(10,C,U);N.writeUInt32(z.length),N.writeLongString(O);for(const R of z)N.writeBuffer(R);return N.buffer}static deserializeReplyOKJSON(C){const j=C.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(C,j){const z=C.readUInt32(),O=C.readLongString(),U=[];for(let N=0;N<z;++N)U.push(C.readVSBuffer());return new L.$Fv(o(O,U,j))}static serializeReplyErr(C,j){const z=j?$(A.$3(j),null):void 0;if(typeof z!="string")return this.h(C);const O=F.$ge.fromString(z);let U=0;U+=c.sizeLongString(O);const N=c.alloc(11,C,U);return N.writeLongString(O),N.buffer}static deserializeReplyErrError(C){const j=C.readLongString();return JSON.parse(j)}static h(C){return c.alloc(12,C,0).buffer}}var S;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(S||(S={}));var p;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[353],ke([1,0,4,37,46,5]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.OutputChannelUpdateMode=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=void 0,e.$YJ="text/x-code-output",e.$ZJ="output",e.$1J="Log",e.$2J="text/x-code-log-output",e.$3J="log",e.$4J="workbench.panel.output",e.$5J=new f.$gj("inOutput",!1),e.$6J=new f.$gj("activeLogOutput",!1),e.$7J=new f.$gj("outputView.scrollLock",!1),e.$8J=(0,A.$2h)("outputService");var M;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$9J={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new E.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(L=>w.push(L)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}F.$un.add(e.$9J.OutputChannels,new b),e.$0J=new f.$gj("activeOutputChannel","")}),define(Se[153],ke([1,0,6,5,20,26,14,353,71,27,57,192,22,18,32,4,3]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=void 0;class o extends M.$pj{get disposed(){return this.n}constructor(a,t,r,d,l){super(),this.id=a,this.name=t,this.r=r,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=$.$ge.fromString(t).byteLength,(0,M.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(a){this.append(a)}}let i=class{constructor(a,t,r,d,l,h){this.i=t,this.j=r,this.k=d,this.l=l,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(E.$NK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$sm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,y.$Ef)(t)?t:void 0;if((0,y.$Ef)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const c=this.i.environment.extensionLogLevel?.find(([P])=>A.$hm.equals(r.identifier,P))?.[1];c&&(h=(0,M.$zj)(c));const v=d?this.o(a,h,r):this.n(a,l,r);return v.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),d?this.r(a,h??this.m.getLevel(),v):this.q(a,v)}async n(a,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),c=await this.a.$register(a,l,t,r.identifier.value);return new o(c,a,h,this.a,r)}async o(a,t,r){const d=await this.p(r),l=a.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(d,`${l}.log`),c=`${r.identifier.value}.${l}`,v=this.l.createLogger(h,{id:c,name:a,logLevel:t,extensionId:r.identifier.value});return new n(c,a,v,this.a,r)}p(a){let t=this.d.get(a.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(d){if((0,D.$Bk)(d)!==D.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return t}q(a,t){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(l){d(),t.then(h=>h.append(l))},appendLine(l){d(),t.then(h=>h.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(h=>h.replace(l))},show(l,h){d(),t.then(c=>c.show(l,h))},hide(){d(),t.then(l=>l.hide())},dispose(){r=!0,t.then(l=>l.dispose())}}}r(a,t,r){const d=new g.$Rc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},h=d.add(new u.$Sd);function c(v){t=v,h.fire(v)}return r.then(v=>{d.add(v),v.logLevel!==t&&c(v.logLevel),d.add(v.onDidChangeLogLevel(P=>c(P)))}),{...this.q(a,r),get logLevel(){return t},onDidChangeLogLevel:h.event,trace(v,...P){l(),r.then(S=>S.trace(v,...P))},debug(v,...P){l(),r.then(S=>S.debug(v,...P))},info(v,...P){l(),r.then(S=>S.info(v,...P))},warn(v,...P){l(),r.then(S=>S.warn(v,...P))},error(v,...P){l(),r.then(S=>S.error(v,...P))},dispose(){d.dispose()}}}};e.$Rgc=i,e.$Rgc=i=Qe([qe(0,f.$RM),qe(1,w.$8M),qe(2,m.$Efc),qe(3,L.$efc),qe(4,M.$kj),qe(5,M.$jj)],i),e.$Sgc=(0,F.$2h)("IExtHostOutputService")}),define(Se[154],ke([1,0,5,10]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=(0,E.$2h)("remoteAgentService"),e.$Im=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let A=1/0;for(let b=0;b<this.maxSampleCount;b++){const m=await f.getRoundTripTime();if(m===void 0)return;A=Math.min(A,m/2),await(0,F.$3g)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(A):M=this.initial.reduce((b,m)=>b+m,0)/this.initial.length,this.lastMeasurement={initial:M,current:A,average:this.average.reduce((b,m)=>b+m,0)/this.average.length,high:(()=>typeof M>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>M*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[354],ke([1,0,224,86,37,41,45,3,4,154,9,24]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=void 0,e.$AH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$BH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$CH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$DH={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new m.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const y=new $;f.$un.add(e.$DH.ConfigurationMigration,y);let D=class extends b.$Sc{constructor(o,n){super(),this.a=o,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async i=>{for(const s of i.added)await this.f(s,y.migrations)})),this.c(y.migrations),this.B(y.onDidRegisterConfigurationMigration(i=>this.c(i)))}async c(o){await this.f(void 0,o);for(const n of this.b.getWorkspace().folders)await this.f(n,o)}async f(o,n){await Promise.all([n.map(i=>this.g(i,o?.uri))])}async g(o,n){const i=this.a.inspect(o.key,{resource:n}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[a,t]of s){const r=[];for(const l of i.overrideIdentifiers??[]){const h=await this.h(o,{resource:n,overrideIdentifier:l},a);for(const c of h??[]){let v=r.find(([[P,S]])=>P===c[0]&&(0,I.$mn)(S.value,c[1].value));v||r.push(v=[c,[]]),v[1].push(l)}}const d=await this.h(o,{resource:n},a,i);for(const l of d??[])r.push([l,[]]);r.length&&await Promise.allSettled(r.map(async([[l,h],c])=>this.a.updateValue(l,h.value,{resource:n,overrideIdentifiers:c},t)))}}async h(o,n,i,s){const a=l=>t(this.a.inspect(l,n)),t=l=>{const h=l[i];return n.overrideIdentifier?h?.override:h?.value},r=s?t(s):a(o.key);if(r===void 0)return;const d=await o.migrateFn(r,a);return Array.isArray(d)?d:[[o.key,d]]}};e.$EH=D,e.$EH=D=Qe([qe(0,M.$vi),qe(1,A.$$h)],D);let u=class extends b.$Sc{constructor(o){super(),(async()=>{if(!L.$c&&(await o.getEnvironment())?.os!==1)return;f.$un.as(F.$zn.Configuration).registerConfiguration({...e.$CH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$FH=u,e.$FH=u=Qe([qe(0,w.$Hm)],u)}),define(Se[355],ke([1,0,34,17,16,23,233,354,86,5,37]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cb=e.$0cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$9cb=e.$8cb=void 0,e.$8cb=(0,w.$2h)("editorResolverService"),e.$9cb="workbench.editorAssociations";const I=L.$un.as(m.$zn.Configuration),$={...b.$BH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration($);var y;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(y||(e.RegisteredEditorPriority=y={}));var D;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(D||(e.ResolvedStatus=D={}));function u(o){switch(o){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}e.$0cb=u;function g(o,n){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(n.scheme))return!1;const a=typeof o=="string"&&o.indexOf(f.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,A.$Ag)(n);return E.$Hj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$$cb=g}),define(Se[356],ke([1,0,33,17,16,9,23,2,5,268,41,145,154]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.$pK=void 0,e.$pK=(0,m.$2h)("pathService");let D=y=class{constructor(g,o,n,i){this.d=g,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??g})()}hasValidBasename(g,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(g,i,o)):this.h(g,o,n)}h(g,o,n){return g.scheme===F.Schemas.file||g.scheme===F.Schemas.vscodeRemote?(0,E.$2f)(n??(0,M.$Ag)(g),o===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,o){if(g.remoteAuthority)return F.Schemas.vscodeRemote;const n=(0,w.$mK)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=o.getWorkspace().configuration;return s?s.scheme:F.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?f.$fc:f.$gc)}async fileURI(g){let o="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const i=g.indexOf("/",2);i===-1?(o=g.substring(2),g="/"):(o=g.substring(2,i),g=g.substring(i)||"/")}return b.URI.from({scheme:F.Schemas.file,authority:o,path:g,query:"",fragment:""})}};e.$qK=D,e.$qK=D=y=Qe([qe(1,$.$Hm),qe(2,I.$$J),qe(3,L.$$h)],D)}),define(Se[357],ke([1,0,235,19,59,4,53,3,2,45,240,14,64,270,88,41,145,25,21,18,24,46]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jK=e.$iK=e.$hK=e.OnPortForward=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.TunnelSource=e.TunnelCloseReason=e.$bK=e.$aK=e.$_J=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$_J="onTunnel",e.$aK=new a.$gj("forwardedPortsViewEnabled",!1,E.localize(0,null));function d(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$bK=d;var l;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(l||(e.TunnelCloseReason=l={}));var h;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(h||(e.TunnelSource=h={})),e.$cK={source:h.User,description:E.localize(1,null)},e.$dK={source:h.Auto,description:E.localize(2,null)};function c(j,z,O){const U=j.get(P(z,O));if(U)return U;if((0,D.$rv)(z))for(const N of D.$qv){const R=P(N,O);if(j.has(R))return j.get(R)}else if((0,D.$tv)(z))for(const N of D.$sv){const R=P(N,O);if(j.has(R))return j.get(R)}}e.$eK=c;function v(j,z,O){const U=c(j,z,O);if(U)return U;const N=(0,D.$tv)(z)?"localhost":(0,D.$rv)(z)?"0.0.0.0":void 0;if(N)return c(j,N,O)}e.$fK=v;function P(j,z){return j+":"+z}e.$gK=P;var S;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(S||(e.OnPortForward=S={}));function p(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}e.$hK=p;class k extends b.$Sc{constructor(z){super(),this.r=z,this.j=[],this.n=new A.$Sd,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(O=>{(O.affectsConfiguration(k.c)||O.affectsConfiguration(k.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,O,U){let N=this.w(z,O,U,this.j,0);const R={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;N>=0;){const T=this.j[N];T.key===z?(R.onAutoForward=T.onAutoForward??R.onAutoForward,R.elevateIfNeeded=T.elevateIfNeeded!==void 0?T.elevateIfNeeded:R.elevateIfNeeded,R.label=T.label??R.label,R.requireLocalPort=T.requireLocalPort,R.protocol=T.protocol):(R.onAutoForward=R.onAutoForward??T.onAutoForward,R.elevateIfNeeded=R.elevateIfNeeded!==void 0?R.elevateIfNeeded:T.elevateIfNeeded,R.label=R.label??T.label,R.requireLocalPort=R.requireLocalPort!==void 0?R.requireLocalPort:void 0,R.protocol=R.protocol??T.protocol),N=this.w(z,O,U,this.j,N+1)}return R.onAutoForward!==void 0||R.elevateIfNeeded!==void 0||R.label!==void 0||R.requireLocalPort!==void 0||R.protocol!==void 0?R:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,i.$Ef)(z.host)&&(0,i.$If)(z.port)}w(z,O,U,N,R){if(R>=N.length)return-1;const T=!(0,D.$rv)(O)&&!(0,D.$tv)(O),ee=N.slice(R).findIndex(J=>(0,i.$If)(J.key)?T?!1:J.key===z:this.t(J.key)?T?!1:z>=J.key.start&&z<=J.key.end:this.u(J.key)?z===J.key.port&&O===J.key.host:U?J.key.test(U):!1);return ee>=0?ee+R:-1}y(){const z=this.r.getValue(k.c);if(!z||!(0,i.$Gf)(z))return[];const O=[];for(const N in z){if(N===void 0)continue;const R=z[N];let T;if(Number(N))T=Number(N);else if((0,i.$Ef)(N))if(k.g.test(N)){const q=N.match(k.g);T={start:Number(q[1]),end:Number(q[2])}}else if(k.h.test(N)){const q=N.match(k.h);T={host:q[1],port:Number(q[2])}}else{let q;try{q=RegExp(N)}catch{}q&&(T=q)}T&&O.push({key:T,elevateIfNeeded:R.elevateIfNeeded,onAutoForward:R.onAutoForward,label:R.label,requireLocalPort:R.requireLocalPort,protocol:R.protocol})}const U=this.r.getValue(k.f);return U&&(this.m={elevateIfNeeded:U.elevateIfNeeded,label:U.label,onAutoForward:U.onAutoForward,requireLocalPort:U.requireLocalPort,protocol:U.protocol}),this.z(O)}z(z){function O(U,N){return(0,i.$If)(U.key)?U.key:N.t(U.key)?U.key.start:N.u(U.key)?U.key.port:Number.MAX_VALUE}return z.sort((U,N)=>O(U,this)-O(N,this))}C(){return this.m}static providedActionToAction(z){switch(z){case D.ProvidedOnAutoForward.Notify:return S.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return S.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return S.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return S.OpenPreview;case D.ProvidedOnAutoForward.Silent:return S.Silent;case D.ProvidedOnAutoForward.Ignore:return S.Ignore;default:return}}async addAttributes(z,O,U){const R=this.r.inspect(k.c).userRemoteValue;let T;!R||!(0,i.$Gf)(R)?T={}:T=(0,s.$in)(R),T[`${z}`]||(T[`${z}`]={});for(const q in O)T[`${z}`][q]=O[q];return this.r.updateValue(k.c,T,U)}}e.$iK=k,k.c="remote.portsAttributes",k.f="remote.otherPortsAttributes",k.g=/^(\d+)\-(\d+)$/,k.h=/^([a-z0-9\-]+):(\d{1,5})$/;let C=class extends b.$Sc{constructor(z,O,U,N,R,T,q,ee,J,K){super(),this.H=z,this.I=O,this.J=U,this.L=N,this.M=R,this.N=T,this.O=q,this.P=ee,this.Q=J,this.R=K,this.c=new Map,this.g=new A.$Sd,this.onForwardPort=this.g.event,this.h=new A.$Sd,this.onClosePort=this.h.event,this.j=new A.$Sd,this.onPortName=this.j.event,this.n=new A.$Sd,this.onCandidatesChanged=this.n.event,this.t=new A.$Sd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$Sd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new k(U),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Z=>{const ae=await this.getAttributes(Z.map(_=>({port:_.tunnelRemotePort,host:_.tunnelRemoteHost})));for(const _ of Z)if(_.localAddress){const ye=P(_.tunnelRemoteHost,_.tunnelRemotePort),ge=v(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort);this.forwarded.set(ye,{remotePort:_.tunnelRemotePort,remoteHost:_.tunnelRemoteHost,localAddress:_.localAddress,protocol:ae?.get(_.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.X(_.localAddress,ae?.get(_.tunnelRemotePort)),localPort:_.tunnelLocalPort,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:_.privacy,source:e.$cK}),this.f.set(ye,_)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Z=>{const ae=P(Z.tunnelRemoteHost,Z.tunnelRemotePort);if(!v(this.forwarded,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!v(this.detected,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!v(this.c,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&Z.localAddress){const _=v(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort),ye=(await this.getAttributes([{port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost}]))?.get(Z.tunnelRemotePort);this.forwarded.set(ae,{remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localAddress:Z.localAddress,protocol:ye?.protocol??D.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,ye),localPort:Z.tunnelLocalPort,closeable:!0,runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,privacy:Z.privacy,source:e.$cK})}await this.$(),this.f.set(ae,Z),this.g.fire(this.forwarded.get(ae))})),this.B(this.H.onTunnelClosed(Z=>this.W(Z,l.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$_J))?(this.R.createKey(e.$aK.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,O){const U=P(z.host,z.port);this.forwarded.has(U)&&(this.forwarded.delete(U),await this.$(),this.h.fire(z))}X(z,O){if(z.startsWith("http"))return m.URI.parse(z);const U=O?.protocol??"http";return m.URI.parse(`${U}://${z}`)}async Y(){const z=this.N.getWorkspace(),O=z.configuration?(0,M.$Pi)(z.configuration.path):z.folders.length>0?(0,M.$Pi)(z.folders[0].uri.path):void 0;if(O===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${O}`}async Z(){const z=this.I.get(r,1);if(z)return this.I.remove(r,1),await this.$(),z;const O=await this.Y();if(O)return this.I.get(O,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const O=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${O.map(U=>U.remotePort).join(", ")}`);for(const U of O){const N=v(this.detected,U.remoteHost,U.remotePort);U.source.source!==h.Extension&&!N||U.source.source===h.Extension&&N?await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,privacy:U.privacy,elevateIfNeeded:!0,source:U.source}):U.source.source===h.Extension&&!N&&this.D.set(P(U.remoteHost,U.remotePort),U)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new b.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async O=>{O.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const O=await this.Y();O&&this.I.store(O,this.y,0,0)}}}async bb(z,O,U){if(!z.tunnelLocalPort||!U?.requireLocalPort||z.tunnelLocalPort===O)return;const N=new Date;if(this.ab.getTime()+t>N.getTime())return;this.ab=N;const R=E.localize(3,null,O,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(R)}async forward(z,O){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.cb(z,O)}async cb(z,O){await this.Q.activateByEvent(e.$_J);const U=v(this.forwarded,z.remote.host,z.remote.port);O=O??(O!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const N=z.local!==void 0?z.local:z.remote.port;let R;if(U)return this.eb(U,z,O);{const T=this.L.remoteAuthority,q=T?{getAddress:async()=>(await this.M.resolveAuthority(T)).authority}:void 0,ee=P(z.remote.host,z.remote.port);this.c.set(ee,!0),z=this.db(ee,z);const J=await this.H.openTunnel(q,z.remote.host,z.remote.port,void 0,N,z.elevateIfNeeded?z.elevateIfNeeded:O?.elevateIfNeeded,z.privacy,O?.protocol);if(typeof J=="string")R=J;else if(J&&J.localAddress){const K=v(this.m??new Map,z.remote.host,z.remote.port),Z=J.protocol?J.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:O?.protocol??D.TunnelProtocol.Http,ae={remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localPort:J.tunnelLocalPort,name:O?.label??z.name,closeable:!0,localAddress:J.localAddress,protocol:Z,localUri:await this.X(J.localAddress,O),runningProcess:K?.detail,hasRunningProcess:!!K,pid:K?.pid,source:z.source??e.$cK,privacy:J.privacy};return this.forwarded.set(ee,ae),this.f.set(ee,J),this.c.delete(ee),await this.$(),await this.bb(J,N,O),this.g.fire(ae),J}this.c.delete(ee)}return R}db(z,O){const U=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(U){const N=U.get(z);U.delete(z),N&&(O.name=N.name??O.name,O.local=("local"in N?N.local:"localPort"in N?N.localPort:void 0)??O.local,O.privacy=N.privacy??O.privacy)}return O}async eb(z,O,U){const N=U?.label??O.name;let R;(function(q){q[q.None=0]="None",q[q.Fire=1]="Fire",q[q.Reopen=2]="Reopen"})(R||(R={}));let T=R.None;switch(N!==z.name&&(z.name=N,T=R.Fire),(U?.protocol||z.protocol!==D.TunnelProtocol.Http)&&U?.protocol!==z.protocol&&(O.source=z.source,T=R.Reopen),O.privacy&&z.privacy!==O.privacy&&(T=R.Reopen),T){case R.Fire:{this.g.fire();break}case R.Reopen:await this.close(z.remoteHost,z.remotePort,l.User),await this.cb(O,U)}return v(this.f,O.remote.host,O.remote.port)}async name(z,O,U){const N=v(this.forwarded,z,O),R=P(z,O);if(N){N.name=U,await this.$(),this.j.fire({host:z,port:O});return}else this.detected.has(R)&&(this.detected.get(R).name=U,this.j.fire({host:z,port:O}))}async close(z,O,U){const N=P(z,O),R=this.forwarded.get(N);return U===l.AutoForwardEnd&&R&&R.source.source===h.Auto&&this.F.set(N,{local:R.localPort,name:R.name,privacy:R.privacy}),await this.H.closeTunnel(z,O),this.W({host:z,port:O},U)}address(z,O){const U=P(z,O);return(this.forwarded.get(U)||this.detected.get(U))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const O of z){const U=v(this.m??new Map,O.remoteAddress.host,O.remoteAddress.port),N=typeof O.localAddress=="string"?O.localAddress:P(O.localAddress.host,O.localAddress.port);this.detected.set(P(O.remoteAddress.host,O.remoteAddress.port),{remoteHost:O.remoteAddress.host,remotePort:O.remoteAddress.port,localAddress:N,protocol:D.TunnelProtocol.Http,localUri:this.X(N),closeable:!1,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:h.Extension,description:E.localize(4,null)}}),this.H.setEnvironmentTunnel(O.remoteAddress.host,O.remoteAddress.port,N,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let O=z;this.r&&(O=await this.r(z));const U=this.fb(O);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(U.values()).map(N=>N.port).join(", ")}`),this.n.fire(U)}fb(z){const O=this.m??new Map,U=new Map;return this.m=U,z.forEach(N=>{const R=P(N.host,N.port);U.set(R,{host:N.host,port:N.port,detail:N.detail,pid:N.pid}),O.has(R)&&O.delete(R);const T=v(this.forwarded,N.host,N.port);T&&(T.runningProcess=N.detail,T.hasRunningProcess=!0,T.pid=N.pid)}),O.forEach((N,R)=>{const T=d(R);if(!T)return;const q=v(this.forwarded,T.host,T.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0);const ee=v(this.detected,T.host,T.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0)}),O}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),O=await this.getAttributes(z.map(U=>({port:U.remotePort,host:U.remoteHost})),!1);if(O)for(const U of z){const N=O.get(U.remotePort);(N?.protocol||U.protocol!==D.TunnelProtocol.Http)&&N?.protocol!==U.protocol&&await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,source:U.source},N),N&&N.label&&N.label!==U.name&&await this.name(U.remoteHost,U.remotePort,N.label)}}async getAttributes(z,O=!0){const U=new Map,N=new Map;z.forEach(J=>{const K=v(this.m??new Map,D.$qv[0],J.port)??J;if(K){U.set(J.port,K);const Z=p(K)?K.pid:void 0;N.has(Z)||N.set(Z,[]),N.get(Z)?.push(J.port)}});const R=new Map;if(z.forEach(J=>{const K=this.configPortsAttributes.getAttributes(J.port,J.host,U.get(J.port)?.detail);K&&R.set(J.port,K)}),this.G.length===0||!O)return R.size>0?R:void 0;const T=await Promise.all((0,F.$Rb)(this.G.map(J=>Array.from(N.entries()).map(K=>{const Z=K[1],ae=U.get(Z[0]);return J.providePortAttributes(Z,ae?.pid,ae?.detail,new n.$3d().token)})))),q=new Map;if(T.forEach(J=>J.forEach(K=>{K&&q.set(K.port,K)})),!R&&!q)return;const ee=new Map;return z.forEach(J=>{const K=R.get(J.port),Z=q.get(J.port);ee.set(J.port,{elevateIfNeeded:K?.elevateIfNeeded,label:K?.label,onAutoForward:K?.onAutoForward??k.providedActionToAction(Z?.autoForwardAction),requireLocalPort:K?.requireLocalPort,protocol:K?.protocol})}),ee}addAttributesProvider(z){this.G.push(z)}};e.$jK=C,Qe([(0,f.$uh)(1e3)],C.prototype,"$",null),e.$jK=C=Qe([qe(0,D.$mv),qe(1,y.$hp),qe(2,w.$vi),qe(3,g.$$J),qe(4,$.$3k),qe(5,u.$$h),qe(6,I.$jj),qe(7,L.$Rv),qe(8,o.$hF),qe(9,a.$hj)],C)}),define(Se[94],ke([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$5I=e.$4I=void 0;class E{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new E(0,0)}with(M){return new E(0,0)}}e.$4I=E;class F{constructor(M,b,m,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(M,b),this.end=new E(m,w)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new F(0,0,0,0)}with(M){return new F(0,0,0,0)}}e.$5I=F;var f;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(Se[36],ke([1,0,19,34,24,33,13,5,16,8,94,10]),function(ie,e,E,F,f,A,M,b,m,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.SearchErrorCode=e.$hJ=e.$gJ=e.SearchSortOrder=e.ViewMode=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.SearchCompletionExitCode=e.$bJ=e.$aJ=e.$_I=e.QueryType=e.SearchProviderType=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$6I="workbench.view.search",e.$7I="workbench.panel.search",e.$8I="workbench.view.search",e.$9I="search-result",e.$0I="search.exclude";const $="\u27EA ",y=" characters skipped \u27EB",D=($.length+y.length+5)*2;e.$$I=(0,b.$2h)("searchService");var u;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(u||(e.SearchProviderType=u={}));var g;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(g||(e.QueryType=g={}));function o(Z){return!!Z.preview}e.$_I=o;function n(Z){return!!Z.resource}e.$aJ=n;function i(Z){return!!Z.message}e.$bJ=i;var s;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class a{constructor(ae){this.resource=ae,this.results=[]}}e.$cJ=a;class t{constructor(ae,_,ye,ge){this.ranges=_,this.webviewIndex=ge;const re=Array.isArray(_)?_:[_];if(ye&&ye.matchLines===1&&r(re)){ae=(0,M.$xf)(ae,ye.matchLines);let W="",ce=0,me=0;const le=Math.floor(ye.charsPerLine/5),de=[];for(const Y of re){const X=Math.max(Y.startColumn-le,0),Q=Y.startColumn+ye.charsPerLine;if(X>me+le+D){const te=$+(X-me)+y;W+=te+ae.slice(X,Q),ce+=X-(me+te.length)}else W+=ae.slice(me,Q);de.push(new l(0,Y.startColumn-ce,Y.endColumn-ce)),me=Q}this.preview={text:W,matches:Array.isArray(this.ranges)?de:de[0]}}else{const W=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:ae,matches:(0,E.$2b)(_,ce=>new d(ce.startLineNumber-W,ce.startColumn,ce.endLineNumber-W,ce.endColumn))}}}}e.$dJ=t;function r(Z){const ae=Z[0].startLineNumber;for(const _ of Z)if(_.startLineNumber!==ae||_.endLineNumber!==ae)return!1;return!0}class d{constructor(ae,_,ye,ge){this.startLineNumber=ae,this.startColumn=_,this.endLineNumber=ye,this.endColumn=ge}}e.$eJ=d;class l extends d{constructor(ae,_,ye){super(ae,_,ae,ye)}}e.$fJ=l;var h;(function(Z){Z.List="list",Z.Tree="tree"})(h||(e.ViewMode=h={}));var c;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(c||(e.SearchSortOrder=c={}));function v(Z,ae=!0){const _=Z&&Z.files&&Z.files.exclude,ye=ae&&Z&&Z.search&&Z.search.exclude;if(!_&&!ye)return;if(!_||!ye)return _||ye;let ge=Object.create(null);return ge=f.$ln(ge,f.$in(_)),ge=f.$ln(ge,f.$in(ye),!0),ge}e.$gJ=v;function P(Z,ae){return Z.excludePattern&&F.$Hj(Z.excludePattern,ae)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&F.$Hj(Z.includePattern,ae)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(_=>{const ye=_.folder.fsPath;if(A.$4f(ae,ye)){const ge=m.$lc(ye,ae);return!_.includePattern||!!F.$Hj(_.includePattern,ge)}else return!1}):!1:!0}e.$hJ=P;var S;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(S||(e.SearchErrorCode=S={}));class p extends Error{constructor(ae,_){super(ae),this.code=_}}e.$iJ=p;function k(Z){const ae=Z.message;if((0,w.$4)(Z))return new p(ae,S.canceled);try{const _=JSON.parse(ae);return new p(_.message,_.code)}catch{return new p(ae,S.other)}}e.$jJ=k;function C(Z){const ae={message:Z.message,code:Z.code};return new Error(JSON.stringify(ae))}e.$kJ=C;function j(Z){return Z.type==="error"?!0:Z.type==="success"}e.$lJ=j;function z(Z){return Z.type==="success"}e.$mJ=z;function O(Z){return!!Z.path}e.$nJ=O;function U(Z,ae){const _=Z.searchPath?Z.searchPath:Z.relativePath;return(0,M.$uf)(_,ae)}e.$oJ=U;class N{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$pJ=N;function R(Z,ae){const _={...Z||{},...ae||{}};return Object.keys(_).filter(ye=>{const ge=_[ye];return typeof ge=="boolean"&&ge})}e.$qJ=R;class T{constructor(ae,_){this.c=null,this.a={...ae.excludePattern||{},..._.excludePattern||{}},this.b=F.$Ij(this.a);let ye=ae.includePattern;_.includePattern&&(ye?ye={...ye,..._.includePattern}:ye=_.includePattern),ye&&(this.c=F.$Ij(ye))}matchesExcludesSync(ae,_,ye){return!!(this.b&&this.b(ae,_,ye))}includedInQuerySync(ae,_,ye){return!(this.b&&this.b(ae,_,ye)||this.c&&!this.c(ae,_,ye))}includedInQuery(ae,_,ye){const ge=this.b(ae,_,ye),re=()=>this.c?!!this.c(ae,_,ye):!0;return(0,I.$Og)(ge)?ge.then(W=>W?!1:re()):re()}hasSiblingExcludeClauses(){return q(this.a)}}e.$rJ=T;function q(Z){for(const ae in Z)if(typeof Z[ae]!="boolean")return!0;return!1}function ee(Z){if(!Z)return;let ae;return _=>(ae||(ae=(Z()||Promise.resolve([])).then(ye=>ye?K(ye):{})),ae.then(ye=>!!ye[_]))}e.$sJ=ee;function J(Z){if(!Z)return;let ae;return _=>{if(!ae){const ye=Z();ae=ye?K(ye):{}}return!!ae[_]}}e.$tJ=J;function K(Z){const ae={};for(const _ of Z)ae[_]=!0;return ae}}),define(Se[38],ke([1,0,19,10,21,4,3,77,17,123,23,13,2,222,5,14,253,41,57,27,20,15,7,66,36,6,54]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a,t,r,d,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=e.$yfc=void 0;function c(z,O,U){return new L.$sg(N=>p(N,U)).isEqual(z,O)}function v(z,O,U){return c(z.uri,O.uri,U)?0:(0,I.$1e)(z.uri.toString(),O.uri.toString())}function P(z,O,U){return z.index!==O.index?z.index<O.index?-1:1:c(z.uri,O.uri,U)?(0,I.$1e)(z.name,O.name):(0,I.$1e)(z.uri.toString(),O.uri.toString())}function S(z,O,U,N){const R=z.slice(0).sort((q,ee)=>U(q,ee,N)),T=O.slice(0).sort((q,ee)=>U(q,ee,N));return(0,E.$Eb)(R,T,(q,ee)=>U(q,ee,N))}function p(z,O){const U=O.getCapabilities(z.scheme);return!(U&&U&1024)}class k extends o.$ii{static toExtHostWorkspace(O,U,N,R){if(!O)return{workspace:null,added:[],removed:[]};const{id:T,name:q,folders:ee,configuration:J,transient:K,isUntitled:Z}=O,ae=[],_=U;U?ee.forEach((W,ce)=>{const me=$.URI.revive(W.uri),le=k.o(N||U,me,R);le?(le.name=W.name,le.index=W.index,ae.push(le)):ae.push({uri:me,name:W.name,index:ce})}):ae.push(...ee.map(({uri:W,name:ce,index:me})=>({uri:$.URI.revive(W),name:ce,index:me}))),ae.sort((W,ce)=>W.index<ce.index?-1:1);const ye=new k(T,q,ae,!!K,J?$.URI.revive(J):null,!!Z,W=>p(W,R)),{added:ge,removed:re}=S(_?_.workspaceFolders:[],ye.workspaceFolders,v,R);return{workspace:ye,added:ge,removed:re}}static o(O,U,N){for(let R=0;R<O.folders.length;R++){const T=O.workspaceFolders[R];if(c(T.uri,U,N))return T}}constructor(O,U,N,R,T,q,ee){super(O,N.map(J=>new o.$ji(J)),R,T,ee),this.t=U,this.u=q,this.q=[],this.s=b.$8h.forUris(ee),N.forEach(J=>{this.q.push(J),this.s.set(J.uri,J)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(O,U){return U&&this.s.get(O)&&(O=(0,L.$Cg)(O)),this.s.findSubstr(O)}resolveWorkspaceFolder(O){return this.s.get(O)}}let C=class{constructor(O,U,N,R,T){this.c=new A.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new A.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new A.$Ud,this.B=new Map,this.h=R,this.s=N,this.t=T,this.j=new w.$5l,this.k=new F.$1g,this.o=O.getProxy(l.$NK.MainThreadWorkspace),this.q=O.getProxy(l.$NK.MainThreadMessageService);const q=U.workspace;this.l=q?new k(q.id,q.name,[],!!q.transient,q.configuration?$.URI.revive(q.configuration):null,!!q.isUntitled,ee=>p(ee,N)):void 0}$initializeWorkspace(O,U){this.v=U,this.$acceptWorkspaceData(O),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:m.Schemas.untitled,path:(0,L.$Ag)((0,L.$Cg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(O,U,N,...R){const T=[];if(Array.isArray(R)&&R.forEach(Z=>{$.URI.isUri(Z.uri)&&!T.some(ae=>c(ae.uri,Z.uri,this.s))&&T.push({uri:Z.uri,name:Z.name||(0,L.$zg)(Z.uri)})}),this.n||[U,N].some(Z=>typeof Z!="number"||Z<0)||N===0&&T.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(U+N>q.length)return!1;const ee=q.slice(0);ee.splice(U,N,...T.map(Z=>({uri:Z.uri,name:Z.name||(0,L.$zg)(Z.uri),index:void 0})));for(let Z=0;Z<ee.length;Z++){const ae=ee[Z];if(ee.some((_,ye)=>ye!==Z&&c(ae.uri,_.uri,this.s)))return!1}ee.forEach((Z,ae)=>Z.index=ae);const{added:J,removed:K}=S(q,ee,P,this.s);if(J.length===0&&K.length===0)return!1;if(this.o){const Z=O.displayName||O.name;this.o.$updateWorkspaceFolders(Z,U,N,T).then(void 0,ae=>{this.n=void 0;const _={source:{identifier:O.identifier,label:O.displayName||O.name}};this.q.$showMessage(g.Severity.Error,(0,y.localize)(0,null,Z,ae.toString()),_,[])})}return this.y(ee),!0}getWorkspaceFolder(O,U){if(this.x)return this.x.getWorkspaceFolder(O,U)}async getWorkspaceFolder2(O,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(O,U)}async resolveWorkspaceFolder(O){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(O)}getPath(){if(!this.x)return;const{folders:O}=this.x;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,U){let N,R="";if(typeof O=="string"?(N=$.URI.file(O),R=O):typeof O<"u"&&(N=O,R=O.fsPath),!N)return R;const T=this.getWorkspaceFolder(N,!0);if(!T)return R;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let q=(0,L.$Fg)(T.uri,N);return U&&T.name&&(q=`${T.name}/${q}`),q}y(O){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:O,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:U,added:N,removed:R}=k.toExtHostWorkspace(O,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:R}))}findFiles(O,U,N,R,T=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${R.value}, entryPoint: findFiles`);let q;if(U===null?q=!1:U&&(typeof U=="string"?q=U:q=U.pattern),T&&T.isCancellationRequested)return Promise.resolve([]);const{includePattern:ee,folder:J}=j(a.GlobPattern.from(O));return this.o.$startFileSearch(ee??null,J??null,q??null,N??null,T).then(K=>Array.isArray(K)?K.map(Z=>$.URI.revive(Z)):[])}async findTextInFiles(O,U,N,R,T=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${R.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),ee=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:J,folder:K}=j(a.GlobPattern.from(U.include)),Z=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ae={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ee,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:J,excludePattern:Z},_=!1;if(this.u[q]=ye=>{if(_)return;const ge=$.URI.revive(ye.resource);ye.results.forEach(re=>{const W=(0,h.$yh)(re);(0,d.$_I)(W)?N({uri:ge,preview:{text:W.preview.text,matches:(0,E.$2b)(W.preview.matches,ce=>new t.$RK(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))},ranges:(0,E.$2b)(W.ranges,ce=>new t.$RK(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))}):N({uri:ge,text:W.text,lineNumber:W.lineNumber})})},T.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(O,K??null,ae,q,T);return delete this.u[q],ye||{}}catch(ye){throw delete this.u[q],ye}}$handleTextSearchResult(O,U){this.u[U]?.(O)}async save(O){const U=await this.o.$save(O,{saveAs:!1});return $.URI.revive(U)}async saveAs(O){const U=await this.o.$save(O,{saveAs:!0});return $.URI.revive(U)}saveAll(O){return this.o.$saveAll(O)}resolveProxy(O){return this.o.$resolveProxy(O)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(O){return this.o.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(O,U){if(this.w.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.w.set(O,U);const N=this.t.transformOutgoingScheme(O),R=this.z++;return this.o.$registerEditSessionIdentityProvider(R,N),(0,M.$Qc)(()=>{this.w.delete(O),this.o.$unregisterEditSessionIdentityProvider(R)})}async $getEditSessionIdentifier(O,U){this.h.info("Getting edit session identifier for workspaceFolder",O);const N=await this.resolveWorkspaceFolder($.URI.revive(O));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const R=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!R),!R)return;const T=await R.provideEditSessionIdentity(N,U);if(this.h.info("Provider returned edit session identifier: ",T),!!T)return T}async $provideEditSessionIdentityMatch(O,U,N,R){this.h.info("Getting edit session identifier for workspaceFolder",O);const T=await this.resolveWorkspaceFolder($.URI.revive(O));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const q=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!q),!q)return;const ee=await q.provideEditSessionIdentityMatch?.(U,N,R);if(this.h.info("Provider returned edit session identifier match result: ",ee),!!ee)return ee}getOnWillCreateEditSessionIdentityEvent(O){return(U,N,R)=>{const T=function(ee){U.call(N,ee)};return T.extension=O,this.A.event(T,void 0,R)}}async $onWillCreateEditSessionIdentity(O,U,N){const R=await this.resolveWorkspaceFolder($.URI.revive(O));if(R===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:R},U,async(T,q)=>{const ee=Date.now();await Promise.resolve(T),Date.now()-ee>N&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(O,U){if(this.B.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.B.set(O,U);const N=this.t.transformOutgoingScheme(O),R=this.z++;return this.o.$registerCanonicalUriProvider(R,N),(0,M.$Qc)(()=>{this.B.delete(O),this.o.$unregisterCanonicalUriProvider(R)})}async provideCanonicalUri(O,U,N){const R=this.B.get(O.scheme);if(!R)return;const T=await R.provideCanonicalUri?.($.URI.revive(O),U,N);if(T)return T}async $provideCanonicalUri(O,U,N){return this.provideCanonicalUri($.URI.revive(O),{targetScheme:U},N)}};e.$yfc=C,e.$yfc=C=Qe([qe(0,s.$RM),qe(1,i.$8M),qe(2,n.$efc),qe(3,u.$jj),qe(4,r.$wfc)],C),e.$zfc=(0,D.$2h)("IExtHostWorkspace");function j(z){let O,U;return z&&(typeof z=="string"?O=z:(O=z.pattern,U=$.URI.revive(z.baseUri))),{includePattern:O,folder:U}}}),define(Se[42],ke([1,0,24,4,38,6,7,255,86,18,10,5,20,14,2]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=e.$Afc=void 0;function u(r,d){if(d){const l=d.split(".");let h=r;for(let c=0;h&&c<l.length;c++)h=h[l[c]];return h}}function g(r){return r instanceof D.URI}function o(r){return r&&r.uri instanceof D.URI&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&r.uri instanceof D.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function s(r){if(g(r))return{resource:r};if(o(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(n(r))return{overrideIdentifier:r.languageId};if(i(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(d,l,h){this.a=d.getProxy(A.$NK.MainThreadConfiguration),this.c=l,this.b=h,this.d=new L.$1g,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(d,l))}};e.$Afc=a,e.$Afc=a=Qe([qe(0,$.$RM),qe(1,f.$zfc),qe(2,y.$jj)],a);class t{constructor(d,l,h,c){this.a=new F.$Sd,this.b=d,this.f=c,this.c=l,this.e=b.$Sn.parse(h),this.d=this.k(h.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const h={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Sn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,h))}getConfiguration(d,l,h){const c=s(l)||{},v=this.g(d?u(this.e.getValue(void 0,c,this.c.workspace),d):this.e.getValue(void 0,c,this.c.workspace));d&&this.h(d,c,h?.identifier);function P(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const S={has(p){return typeof u(v,p)<"u"},get:(p,k)=>{this.h(d?`${d}.${p}`:p,c,h?.identifier);let C=u(v,p);if(typeof C>"u")C=k;else{let j;const z=(O,U)=>{if((0,w.$Gf)(O)){let N;const R=()=>{j=j||(0,E.$in)(v),N=N||u(j,U)};return new Proxy(O,{get:(T,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return R(),()=>N;if(j)return N=N||u(j,U),N[q];const ee=T[q];return typeof q=="string"?z(ee,`${U}.${q}`):ee},set:(T,q,ee)=>(R(),N&&(N[q]=ee),!0),deleteProperty:(T,q)=>(R(),N&&delete N[q],!0),defineProperty:(T,q,ee)=>(R(),N&&Object.defineProperty(N,q,ee),!0)})}return Array.isArray(O)?(0,E.$in)(O):O};C=z(C,p)}return C},update:(p,k,C,j)=>{p=d?`${d}.${p}`:p;const z=P(C);return k!==void 0?this.b.$updateConfigurationOption(z,p,k,c,j):this.b.$removeConfigurationOption(z,p,c,j)},inspect:p=>{p=d?`${d}.${p}`:p;const k=this.e.inspect(p,c,this.c.workspace);if(k)return{key:p,defaultValue:(0,E.$in)(k.policy?.value??k.default?.value),globalValue:(0,E.$in)(k.user?.value??k.application?.value),workspaceValue:(0,E.$in)(k.workspace?.value),workspaceFolderValue:(0,E.$in)(k.workspaceFolder?.value),defaultLanguageValue:(0,E.$in)(k.default?.override),globalLanguageValue:(0,E.$in)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,E.$in)(k.workspace?.override),workspaceFolderLanguageValue:(0,E.$in)(k.workspaceFolder?.override),languageIds:(0,E.$in)(k.overrideIdentifiers)}}};return typeof v=="object"&&(0,E.$ln)(S,v,!1),Object.freeze(S)}g(d){const l=h=>(0,w.$Gf)(h)?new Proxy(h,{get:(c,v)=>l(c[v]),set:(c,v,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(c,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(c,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return l(d)}h(d,l,h){const c=m.$Jn.test(d)?4:this.d.get(d),v=h?`[${h.value}] `:"";if(c===4){typeof l?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){l?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const h=new b.$Un(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(c,v)=>h.affectsConfiguration(c,s(v))})}k(d){return d.reduce((l,h)=>(l.set(h[0],h[1]),l),new Map)}}e.$Bfc=t,e.$Cfc=(0,I.$2h)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[95],ke([1,0,2,10,4,6,7,38,69,42,21,47,20,27,5,17,9,14,91,302,8]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=e.$4gc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(O){function U(R){if(R!=null)return R}O.from=U;function N(R){if(R!=null)return R}O.to=N})(t||(t={}));var r;(function(O){function U(R){if(R!=null)return R}O.from=U;function N(R){if(R!=null)return R}O.to=N})(r||(r={}));var d;(function(O){function U(R){if(R!=null)return R}O.from=U;function N(R){if(R!=null)return R}O.to=N})(d||(d={}));var l;(function(O){function U(T){if(T){const q=T;return q&&!!q.process}else return!1}O.is=U;function N(T){if(T==null)return;const q={process:T.process,args:T.args};return T.options&&(q.options=d.from(T.options)),q}O.from=N;function R(T){if(T!=null)return new M.$yL(T.process,T.args,T.options)}O.to=R})(l||(l={}));var h;(function(O){function U(R){if(R!=null)return R}O.from=U;function N(R){if(R!=null)return R}O.to=N})(h||(h={}));var c;(function(O){function U(T){if(T){const q=T;return q&&(!!q.commandLine||!!q.command)}else return!1}O.is=U;function N(T){if(T==null)return;const q={};return T.commandLine!==void 0?q.commandLine=T.commandLine:(q.command=T.command,q.args=T.args),T.options&&(q.options=h.from(T.options)),q}O.from=N;function R(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new M.$zL(T.commandLine,T.options):new M.$zL(T.command,T.args?T.args:[],T.options)}O.to=R})(c||(c={}));var v;(function(O){function U(T){if(T){const q=T;return q&&q.customExecution==="customExecution"}else return!1}O.is=U;function N(T){return{customExecution:"customExecution"}}O.from=N;function R(T,q){return q.get(T)}O.to=R})(v||(e.CustomExecutionDTO=v={}));var P;(function(O){function U(N,R){let T;return N.scope!==void 0&&typeof N.scope!="number"?T=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===M.TaskScope.Workspace&&R&&R.workspaceFile?T=R.workspaceFile:T=i.$hG),{id:N._id,workspaceFolder:T}}O.from=U})(P||(e.TaskHandleDTO=P={}));var S;(function(O){function U(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}O.from=U})(S||(S={}));var p;(function(O){function U(T,q){if(T==null)return[];const ee=[];for(const J of T){const K=N(J,q);K&&ee.push(K)}return ee}O.fromMany=U;function N(T,q){if(T==null)return;let ee;T.execution instanceof M.$yL?ee=l.from(T.execution):T.execution instanceof M.$zL?ee=c.from(T.execution):T.execution&&T.execution instanceof M.$AL&&(ee=v.from(T.execution));const J=t.from(T.definition);let K;return T.scope?typeof T.scope=="number"?K=T.scope:K=T.scope.uri:K=M.TaskScope.Workspace,!J||!K?void 0:{_id:T._id,definition:J,name:T.name,source:{extensionId:q.identifier.value,label:T.source,scope:K},execution:ee,isBackground:T.isBackground,group:S.from(T.group),presentationOptions:r.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}O.from=N;async function R(T,q,ee){if(T==null)return;let J;l.is(T.execution)?J=l.to(T.execution):c.is(T.execution)?J=c.to(T.execution):v.is(T.execution)&&(J=v.to(T._id,ee));const K=t.to(T.definition);let Z;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Z=T.source.scope:Z=await q.resolveWorkspaceFolder(E.URI.revive(T.source.scope)):Z=M.TaskScope.Workspace),!K||!Z)return;const ae=new M.$BL(K,Z,T.name,T.source.label,J,T.problemMatchers);return T.isBackground!==void 0&&(ae.isBackground=T.isBackground),T.group!==void 0&&(ae.group=M.$xL.from(T.group._id),ae.group&&T.group.isDefault&&(ae.group=new M.$xL(ae.group.id,ae.group.label),T.group.isDefault===!0&&(ae.group.isDefault=T.group.isDefault))),T.presentationOptions&&(ae.presentationOptions=r.to(T.presentationOptions)),T._id&&(ae._id=T._id),T.detail&&(ae.detail=T.detail),ae}O.to=R})(p||(e.TaskDTO=p={}));var k;(function(O){function U(R){return R}O.from=U;function N(R){if(R)return Object.assign(Object.create(null),R)}O.to=N})(k||(k={}));class C{constructor(U,N,R){this._id=N,this.a=R,a.set(this,void 0),nt(this,a,U,"f")}get task(){return this.a}terminate(){We(this,a,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}a=new WeakMap;let j=class{constructor(U,N,R,T,q,ee,J,K){this.q=new f.$Sd,this.r=new f.$Sd,this.s=new f.$Sd,this.t=new f.$Sd,this.a=U.getProxy(A.$NK.MainThreadTask),this.b=R,this.c=T,this.d=q,this.e=ee,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=J,this.g=K,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,N,R){if(!R)return new M.$PK(()=>{});const T=this.w();return this.j.set(T,{type:N,provider:R,extension:U}),this.a.$registerTaskProvider(T,N),new M.$PK(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(U,N){this.a.$registerTaskSystem(U,N)}fetchTasks(U){return this.a.$fetchTasks(k.from(U)).then(async N=>{const R=[];for(const T of N){const q=await p.to(T,this.b,this.m);q&&R.push(q)}return R})}get taskExecutions(){const U=[];return this.k.forEach(N=>U.push(N)),U}terminateTask(U){if(!(U instanceof C))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,N,R){const T=this.m.get(U.id);T&&(this.o.set(U.id,T),this.e.attachPtyToTerminal(N,await T.callback(R))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const N=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const N=await this.y(U.id);this.s.fire({execution:N,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const N=await this.y(U.id);this.t.fire({execution:N,exitCode:U.exitCode})}$provideTasks(U,N){const R=this.j.get(U);if(!R)return Promise.reject(new Error("no handler found"));const T=[],q=(0,F.$Ug)(()=>R.provider.provideTasks(L.CancellationToken.None)).then(ee=>this.u(N,T,R,ee));return new Promise(ee=>{q.then(J=>{Promise.all(T).then(()=>{ee(J)})})})}async $resolveTask(U,N){const R=this.j.get(U);if(!R)return Promise.reject(new Error("no handler found"));if(N.definition.type!==R.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${R.type}].`);const T=await p.to(N,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const q=await R.provider.resolveTask(T,L.CancellationToken.None);if(!q)return;this.z(q,R);const ee=p.from(q,R.extension);if(!ee)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(ee.execution)&&await this.x(ee,q,!0),await this.v(ee)}w(){return this.h++}async x(U,N,R){const T=await this.a.$createTaskId(U);!R&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,N.execution)),this.m.set(T,N.execution)}async y(U,N){if(typeof U=="string"){const q=this.l.get(U);if(!q)throw new s.$bb("Unexpected: The specified task is missing an execution");return q}const R=this.l.get(U.id);if(R)return R;const T=new Promise((q,ee)=>{function J(K,Z,ae){ae?q(new C(K,Z.id,ae)):ee("Unexpected: Task does not exist.")}N?J(this,U,N):p.to(U.task,this.b,this.m).then(K=>J(this,U,K))});return this.l.set(U.id,T),T.then(q=>(this.k.set(U.id,q),q),q=>Promise.reject(q))}z(U,N){U._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const R=this.n.values();let T=R.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=R.next()}};e.$4gc=j,e.$4gc=j=Qe([qe(0,$.$RM),qe(1,y.$8M),qe(2,b.$zfc),qe(3,m.$3M),qe(4,w.$Cfc),qe(5,I.$1fc),qe(6,o.$jj),qe(7,n.$hfc)],j);let z=class extends j{constructor(U,N,R,T,q,ee,J,K){super(U,N,R,T,q,ee,J,K),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:g.$b(0)})}async executeTask(U,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const R=p.from(N,U);if(R===void 0)throw new Error("Task is not valid");if(v.is(R.execution))await this.x(R,N,!1);else throw new s.$_;const T=await this.y(await this.a.$getTaskExecution(R),N);return this.a.$executeTask(R).catch(q=>{throw new Error(q)}),T}u(U,N,R,T){const q=[];if(T)for(const ee of T){if(this.z(ee,R),!ee.definition||!U[ee.definition.type]){const K=ee.source?ee.source:"No task source";this.f.warn(`The task [${K}, ${ee.name}] uses an undefined task type. The task will be ignored in the future.`)}const J=p.from(ee,R.extension);J&&v.is(J.execution)?(q.push(J),N.push(this.x(J,ee,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:R.extension}}async v(U){if(v.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,N,R){}};e.$5gc=z,e.$5gc=z=Qe([qe(0,$.$RM),qe(1,y.$8M),qe(2,b.$zfc),qe(3,m.$3M),qe(4,w.$Cfc),qe(5,I.$1fc),qe(6,o.$jj),qe(7,n.$hfc)],z),e.$6gc=(0,D.$2h)("IExtHostTask")}),define(Se[358],ke([1,0,36,29]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BJ=e.$AJ=e.$zJ=void 0;function f(M){return"cellResults"in M}e.$zJ=f,e.$AJ="rawCell#";function A(M,b){let m=-1;const w=[];let L=[];return M.forEach($=>{$.range.startLineNumber!==m&&L.length>0&&(w.push([...L]),L=[]),L.push($),m=$.range.endLineNumber}),L.length>0&&w.push([...L]),w.map($=>{const y=[],D=$[0].range.startLineNumber,u=$[$.length-1].range.endLineNumber;for(let g=D;g<=u;g++)y.push(b.getLineContent(g));return new E.$dJ(y.join(`
`)+`
`,$.map(g=>new F.$Hs(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}e.$BJ=A}),define(Se[359],ke([1,0,215,22,4,3,28,13,18,2,32,110,6,35,15,7,68,294,147,8,24,17,286,358,355]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,v,P,S,p,k){this.q=P,this.r=S,this.s=p,this.t=k,this.f=new Map,this.g=new M.$Ac,this.h=new Map,this.j=new f.$Sd({onListenerError:i.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Sd({onListenerError:i.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Sd({onListenerError:i.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Sd({onListenerError:i.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$afc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=c.getProxy($.$NK.MainThreadNotebook),this.c=c.getProxy($.$NK.MainThreadNotebookDocuments),this.d=c.getProxy($.$NK.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const j=C.notebookEditor?.notebookUri,z=C.cell.handle,U=this.g.get(j)?.getCell(z);if(U)return U.apiCell}if(C&&C.$mid===14){const j=C.uri,z=this.g.get(j);if(z)return z.apiNotebook}return C}}),l.B(v)}getEditorById(c){const v=this.h.get(c);if(!v)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(c){for(const[v,P]of this.h)if(P.apiEditor===c)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,v){const P=this.g.get(c);if(!P&&!v)throw new Error(`NO notebook document for '${c}'`);return P}static u(c,v){if(!v)return;const P=v.filenamePattern.map(S=>D.NotebookExclusiveDocumentPattern.from(S)).filter(S=>S!==void 0);if(v.filenamePattern&&!P){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:v.displayName,filenamePattern:P,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,v,P){const S=l.a++,p=typeof P.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(S,P),this.b.$registerNotebookCellStatusBarItemProvider(S,p,v);let k;return p!==void 0&&(k=P.onDidChangeCellStatusBarItems(C=>this.b.$emitCellStatusBarEvent(p))),new u.$PK(()=>{this.f.delete(S),this.b.$unregisterNotebookCellStatusBarItemProvider(S,p),k?.dispose()})}async createNotebookDocument(c){const v=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&D.NotebookData.from(c.content)});return w.URI.revive(v)}async openNotebookDocument(c){const v=this.g.get(c);if(v)return v.apiNotebook;const P=await this.c.$tryOpenNotebook(c),S=this.g.get(w.URI.revive(P));return(0,m.$Pf)(S?.apiNotebook)}async showNotebookDocument(c,v){w.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let P;typeof v=="object"?P={position:D.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(D.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:P={preserveFocus:!1};const S=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,P),p=S&&this.h.get(S)?.apiEditor;if(p)return p;throw S?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,v,P,S){const p=this.f.get(c),k=w.URI.revive(v),C=this.g.get(k);if(!C||!p)return;const j=C.getCellFromIndex(P);if(!j)return;const z=await p.provideCellStatusBarItems(j.apiCell,S);if(!z)return;const O=new A.$Rc,U=this.p.add([O]),R=(Array.isArray(z)?z:[z]).map(T=>D.NotebookStatusBarItem.from(T,this.i,O));return{cacheId:U,items:R}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,v,P,S,p){if((0,b.$Ge)(v))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:v,serializer:P,options:S}),this.b.$registerNotebookSerializer(k,{id:c.identifier,location:c.extensionLocation},v,D.NotebookDocumentContentOptions.from(S),l.u(c,p)),(0,A.$Qc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(c,v,P){const S=this.x.get(c);if(!S)throw new Error("NO serializer found");const p=await S.serializer.deserializeNotebook(v.buffer,P);return new g.$Fv(D.NotebookData.from(p))}async $notebookToData(c,v,P){const S=this.x.get(c);if(!S)throw new Error("NO serializer found");const p=await S.serializer.serializeNotebook(D.NotebookData.to(v.value),P);return F.$ge.wrap(p)}async $saveNotebook(c,v,P,S,p){const k=w.URI.revive(v),C=this.x.get(c);if(!C)throw new Error("NO serializer found");const j=this.g.get(k);if(!j)throw new Error("Document NOT found");if(j.versionId!==P)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new L.$Gk((0,E.localize)(0,null,this.z(k)),6);await this.y(k,S);const z={metadata:(0,s.$qn)(j.apiNotebook.metadata,T=>!(C.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of j.apiNotebook.getCells()){const q=new u.$cM(T.kind,T.document.getText(),T.document.languageId,T.mime,C.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);q.metadata=(0,s.$qn)(T.metadata,ee=>!(C.options?.transientCellMetadata??{})[ee]),z.cells.push(q)}const O=await C.serializer.serializeNotebook(z,p);await this.s.value.writeFile(k,O);const U=this.s.getFileSystemProviderExtUri(k.scheme),N=await this.s.value.stat(k);return{name:U.basename(k),isFile:(N.type&L.FileType.File)!==0,isDirectory:(N.type&L.FileType.Directory)!==0,isSymbolicLink:(N.type&L.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((N.permissions??0)&L.FilePermission.Locked),etag:L.$Rk({mtime:N.mtime,size:N.size}),children:void 0}}async $searchInNotebooks(c,v,P,S,p){const k=this.x.get(c)?.serializer;if(!k)return{limitHit:!1,results:[]};const C=new M.$Bc;await(async(N,R,T)=>{await Promise.all(N.map(async q=>await Promise.all(q.filenamePatterns.map(ee=>{const J={...T,type:1,filePattern:ee};return this.t.doInternalFileSearchWithCustomCallback(J,R,K=>{K.forEach(Z=>{C.has(Z)||S.some(_=>q.isFromSettings&&!_.isFromSettings?!1:_.filenamePatterns.some(ye=>(0,d.$$cb)(ye,Z)))||C.add(Z)})})}))))})(P,p,v);const z=new M.$Ac;let O=!1;const U=Array.from(C).map(async N=>{const R=[];try{if(p.isCancellationRequested)return;if(v.maxResults&&[...z.values()].reduce((J,K)=>J+K.cellResults.length,0)>v.maxResults){O=!0;return}const T=[],q=this.g.get(N);if(q)q.apiNotebook.getCells().forEach(K=>T.push({input:K.document.getText(),outputs:K.outputs.flatMap(Z=>Z.items.map(ae=>ae.data.toString()))}));else{const J=await this.s.value.readFile(N),K=F.$ge.fromString(J.toString()),Z=await k.deserializeNotebook(K.buffer,p);if(p.isCancellationRequested)return;D.NotebookData.from(Z).cells.forEach(_=>T.push({input:_.source,outputs:_.outputs.flatMap(ye=>ye.items.map(ge=>ge.valueBytes.toString()))}))}if(p.isCancellationRequested)return;T.forEach((J,K)=>{const Z=v.contentPattern.pattern,ae=new t.$aQb(J.input,void 0,J.outputs),_=ae.findInInputs(Z),ye=ae.findInOutputs(Z),ge=ye.flatMap(re=>(0,r.$BJ)(re.matches,re.textBuffer)).map((re,W)=>(re.webviewIndex=W,re));if(_.length>0||ye.length>0){const re={index:K,contentResults:(0,r.$BJ)(_,ae.inputTextBuffer),webviewResults:ge};R.push(re)}});const ee={resource:N,cellResults:R};z.set(N,ee);return}catch{return}});return await Promise.all(U),{limitHit:O,results:[...z.values()]}}async y(c,v){const P=await this.s.value.stat(c);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==L.$Qk&&typeof P.mtime=="number"&&typeof P.size=="number"&&v.mtime<P.mtime&&v.etag!==L.$Rk({mtime:v.mtime,size:P.size}))throw new L.$Gk((0,E.localize)(1,null),3,v)}z(c){return c.scheme===a.Schemas.file?c.fsPath:c.toString()}A(c,v,P){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const S=new n.$wgc(v,this.d,c,P.visibleRanges.map(D.NotebookRange.to),P.selections.map(D.NotebookRange.to),typeof P.viewColumn=="number"?D.ViewColumn.to(P.viewColumn):void 0);this.h.set(v,S)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const P of c.value.removedDocuments){const S=w.URI.revive(P),p=this.g.get(S);p&&(p.dispose(),this.g.delete(S),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(p.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===S.toString()&&this.h.delete(k.id)}if(c.value.addedDocuments){const P=[];for(const S of c.value.addedDocuments){const p=w.URI.revive(S.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const k=new o.$vgc(this.c,this.q,this.r,p,S);P.push(...S.cells.map(C=>o.$ugc.asModelAddData(k.apiNotebook,C))),this.g.get(p)?.dispose(),this.g.set(p,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:P}),this.m.fire(k.apiNotebook)}}if(c.value.addedEditors)for(const P of c.value.addedEditors){if(this.h.has(P.id))return;const S=w.URI.revive(P.documentUri),p=this.g.get(S);p&&this.A(p,P.id,P)}const v=[];if(c.value.removedEditors)for(const P of c.value.removedEditors){const S=this.h.get(P);S&&(this.h.delete(P),this.k?.id===S.id&&(this.k=void 0),v.push(S))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(S=>this.h.get(S)).filter(S=>!!S);const P=new Set;this.l.forEach(S=>P.add(S.id));for(const S of this.h.values()){const p=P.has(S.id);S._acceptVisibility(p)}this.l=[...this.h.values()].map(S=>S).filter(S=>S.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(c){const v=y.$dN.String.with("notebookType","A notebook type"),P=new y.$fN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new y.$dN("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>F.$ge.wrap(p))],new y.$eN("Notebook Data",p=>D.NotebookData.to(p.value))),S=new y.$fN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new y.$dN("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new g.$Fv(D.NotebookData.from(p)))],new y.$eN("Bytes",p=>p.buffer));c.registerApiCommand(P),c.registerApiCommand(S)}}e.$Fgc=l,l.a=0}),define(Se[360],ke([1,0,16,21,44,34,23,39,36]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;class w{constructor($,y,D){this.k=$,this.l=y,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&A.$Ij($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&A.$Ij($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const y=this.k.folderQueries||[];return new Promise((D,u)=>{const g=o=>{this.f++,$(o)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=E.$nc(n);this.j&&this.j(n,i)||this.v(g,{base:o,basename:i})}),Promise.all(y.map(o=>this.p(o,g))).then(o=>{D({limitHit:this.e,stats:o[0]||void 0})},o=>{u(new Error((0,f.$Mi)(o)))})})}async p($,y){const D=new F.$3d,u=this.q($),g=this.r(),o=new m.$rJ(this.k,$),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(D),i=b.$Od.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,D.token),a=i.elapsed(),t=b.$Od.create();return this.g&&!this.e||(s&&s.forEach(r=>{const d=E.$gc.relative($.folder.path,r.path);if(n){const l=E.$nc(r.path);this.v(y,{base:$.folder,relativePath:d,basename:l});return}this.s(g,$.folder,d,y)}),this.g&&!this.e)?null:(this.u(g,o,y),{providerTime:a,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q($){const y=(0,m.$qJ)(this.k.includePattern,$.includePattern),D=(0,m.$qJ)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:D,includes:y,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},y,D,u){if(D===this.a){const o=E.$nc(this.a);this.v(u,{base:y,relativePath:this.a,basename:o})}function g(o){const n=E.$nc(o),i=E.$mc(o);let s=$[i];s||(s=$[i]=[],g(i)),s.push({base:y,relativePath:o,basename:n})}g(D)}u({rootEntries:$,pathToEntries:y},D,u){const g=this,o=this.a;function n(i){const s=(0,m.$tJ)(()=>i.map(a=>a.basename));for(let a=0,t=i.length;a<t;a++){const r=i[a],{relativePath:d,basename:l}=r;if(D.matchesExcludesSync(d,l,o!==l?s:void 0))continue;const h=y[d];if(h)n(h);else{if(d===o)continue;g.v(u,r)}if(g.e)break}}n($)}v($,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(y))}}class L{constructor(){this.b=new Map}fileSearch($,y,D,u){const g=this.c($.cacheKey),o=new w($,y,g&&g.token);let n=0;const i=s=>{n+=s.length,D(s.map(a=>this.d(a)))};return this.e(o,L.a,i,u).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:s.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new F.$3d),this.b.get($)}d($){return $.relativePath?{resource:M.$Dg($.base,$.relativePath)}:{resource:$.base}}e($,y,D,u){const g=u.onCancellationRequested(()=>{$.cancel()}),o=i=>{i&&(n.push(i),y>0&&n.length>=y&&(D(n),n=[]))};let n=[];return $.search(o).then(i=>(n.length&&D(n),g.dispose(),i),i=>(n.length&&D(n),g.dispose(),Promise.reject(i)))}}e.$xgc=L,L.a=512}),define(Se[361],ke([1,0,19,73,34,101,28,17,16,23,13,18,2,104,236,45,14,41,144,356,36]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.$rK=void 0;let a=class{constructor(p,k,C,j,z){this.a=p,this.b=k,this.c=C,this.d=j,this.e=z}text(p,k,C={}){p=this.f(p,C);const j=this.a.getValue(),z=k&&k.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(k?.map(o.$ki),C),type:2,contentPattern:p,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:j.search.usePCRE2||z||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(p,k){const C=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const j={...p,wordSeparators:C.editor.wordSeparators};return this.j(p,k)&&(j.isCaseSensitive=!0),this.k(p)&&(j.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),j}file(p,k={}){return{...this.h(p,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(p,k){return p?(p=Array.isArray(p)?p.map(h):h(p),k?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],k={}){const C=this.g(k.includePattern,k.expandPatterns),j=this.g(k.excludePattern,k.expandPatterns),z=p.length>1,O=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(R=>this.q(R,k,j)):p.map(R=>this.r(R,k,j,z))).filter(R=>!!R),U={_reason:k._reason,folderQueries:O,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:j.pattern,includePattern:C.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const R=E.$Hb(E.$Rb(this.c.groups.map(ee=>ee.editors.map(J=>J.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(R));const T=R.filter(ee=>(0,s.$hJ)(U,ee.fsPath)),q=this.i(T);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...U,...q}}const N=k.extraFileResources&&k.extraFileResources.filter(R=>(0,s.$hJ)(U,R.fsPath));return U.extraFileResources=N&&N.length?N:void 0,U}i(p){const k=[],C=new M.$Ac,j={};let z=!1;return p.forEach(O=>{if(O.scheme===b.Schemas.walkThrough)return;if((0,w.$Hg)(O)){const N=this.b.getWorkspaceFolder(O)?.uri??O.with({path:m.$mc(O.fsPath)});let R=C.get(N);R||(z=!0,R={folder:N,includePattern:{}},k.push(R),C.set(N,R));const T=m.$lc(N.fsPath,O.fsPath);(0,I.$Pf)(R.includePattern)[T.replace(/\\/g,"/")]=!0}else O.fsPath&&(z=!0,j[O.fsPath]=!0)}),{folderQueries:k,includePattern:j,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(p,k){if(k.isSmartCase){if(p.isRegExp){if(L.$vf(p.pattern,!0))return!0}else if(L.$vf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,y.$MB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const k=q=>m.$ic(q)||/^\.\.?([\/\\]|$)/.test(q),j=(Array.isArray(p)?p:d(p)).map(q=>{const ee=this.e.resolvedUserHome;return ee?(0,A.$Kv)(q,ee.scheme===b.Schemas.file?ee.fsPath:ee.path):q}),z=F.$E(j,q=>k(q)?"searchPaths":"exprSegments"),O=(z.exprSegments||[]).map(q=>L.$Qe(q,"/")).map(q=>L.$Qe(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),l(q))),U={},N=this.m(z.searchPaths||[]);N&&N.length&&(U.searchPaths=N);const R=E.$Rb(O),T=r(...R);return T&&(U.pattern=T),U}l(p,k){return k.disregardExcludeSettings?void 0:(0,s.$gJ)(p,!k.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const k=p.flatMap(j=>{let{pathPortion:z,globPortion:O}=t(j);return O&&(O=c(O)),this.n(z).flatMap(N=>this.o(N,O))}),C=new Map;return k.forEach(j=>{const z=j.searchPath.toString(),O=C.get(z);O?j.pattern&&(O.pattern=O.pattern||{},O.pattern[j.pattern]=!0):C.set(z,{searchPath:j.searchPath,pattern:j.pattern?r(j.pattern):void 0})}),Array.from(C.values())}n(p){if(m.$ic(p)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==b.Schemas.file?[{searchPath:k[0].uri.with({path:p})}]:[{searchPath:$.URI.file(m.$hc(p))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(p=h(p),p.startsWith("../")||p===".."){const j=m.$gc.resolve(k.path,p);return[{searchPath:k.with({path:j})}]}const C=c(p);return[{searchPath:k,pattern:C}]}else{if(p==="./"||p===".\\")return[];{const k=p.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(z=>{const O=k.match(new RegExp(`^${L.$Ke(z.name)}(?:/(.*)|$)`));return O?{match:O,folder:z}:null}).filter(I.$Mf);if(j.length)return j.map(z=>{const O=z.match[1];return{searchPath:z.folder.uri,pattern:O&&c(O)}});{const z=p.match(/\.[\/\\](.+)[\/\\]?/),O=z?z[1]:p,U=D.localize(0,null,O);throw new Error(U)}}}}o(p,k){const C=p.pattern&&k?`${p.pattern}/${k}`:p.pattern||k,j=[{searchPath:p.searchPath,pattern:C}];return C&&!C.endsWith("**")&&j.push({searchPath:p.searchPath,pattern:C+"/**"}),j}q(p,k,C){const j=this.r((0,o.$ki)(p.searchPath),k,C,!1);return j?{...j,includePattern:p.pattern}:null}r(p,k,C,j){let z;const O=$.URI.isUri(p)?p:p.uri;if(C.searchPaths){const q=C.searchPaths.filter(ee=>(0,w.$wg)(ee.searchPath,O))[0];if(q&&!q.pattern)return null;q&&(z=q.pattern)}const U=this.a.getValue({resource:O}),R={...this.l(U,k)||{},...z||{}},T=$.URI.isUri(p)?(0,w.$Ag)(p):p.name;return{folder:O,folderName:j?T:void 0,excludePattern:Object.keys(R).length>0?R:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!U.search.followSymlinks}}};e.$rK=a,e.$rK=a=Qe([qe(0,u.$vi),qe(1,o.$$h),qe(2,n.$RC),qe(3,g.$jj),qe(4,i.$pK)],a);function t(S){const p=S.match(/[\*\{\}\(\)\[\]\?]/);if(p){const k=p.index,C=S.substr(0,k).match(/[/|\\][^/\\]*$/);if(C){let j=S.substr(0,C.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:S.substr((C.index||0)+1)}}}return{pathPortion:S}}function r(...S){return S.length?S.reduce((p,k)=>(p[k]=!0,p),Object.create(null)):void 0}function d(S){return f.$Gj(S,",").map(p=>p.trim()).filter(p=>!!p.length)}function l(S){return[`**/${S}/**`,`**/${S}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function h(S){return S.replace(/\\/g,"/")}function c(S){return h(S).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(S){return S.replace(/([?*[\]])/g,"[$1]")}function P(S,p){S=E.$Mb(S,j=>j.toString());const k=[],C=p.getWorkspace();return S&&S.forEach(j=>{let z;if(p.getWorkbenchState()===2)z=(0,w.$Fg)(C.folders[0].uri,j),z&&z!=="."&&(z="./"+z);else{const O=p.getWorkspaceFolder(j);if(O){const U=O.name;if(C.folders.filter(R=>R.name===U).length===1){const R=(0,w.$Fg)(O.uri,j);R===""?z=`./${O.name}`:z=`./${O.name}/${R}`}else z=j.fsPath}}z&&k.push(v(z))}),k}e.$sK=P}),define(Se[362],ke([1,0,23,2,21,8,5,361,36,41]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jsb=e.$isb=void 0;const L=7e3;function I(u,g){const o=g.activationEvents;if(!o)return Promise.resolve(void 0);const n=[],i=[];for(const l of o)if(/^workspaceContains:/.test(l)){const h=l.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||u.forceUsingSearch?i.push(h):n.push(h)}if(n.length===0&&i.length===0)return Promise.resolve(void 0);let s;const a=new Promise((l,h)=>{s=l}),t=l=>s({activationEvent:l}),r=Promise.all(n.map(l=>$(u,l,t))).then(()=>{}),d=y(u,g.identifier,i,t);return Promise.all([r,d]).then(()=>{s(void 0)}),a}e.$isb=I;async function $(u,g,o){for(const n of u.folders)if(await u.exists(E.$Dg(F.URI.revive(n),g))){o(`workspaceContains:${g}`);return}}async function y(u,g,o,n){if(o.length===0)return Promise.resolve(void 0);const i=new f.$3d,s=u.checkExists(u.folders,o,i.token),a=setTimeout(async()=>{i.cancel(),u.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},L);let t=!1;try{t=await s}catch(r){A.$4(r)||A.$1(r)}i.dispose(),clearTimeout(a),t&&n(`workspaceContains:${o.join(",")}`)}function D(u,g,o,n){const i=u.get(M.$1h),s=u.get(m.$$I),t=i.createInstance(b.$rK).file(g.map(r=>(0,w.$ki)(F.URI.revive(r))),{_reason:"checkExists",includePattern:o,exists:!0});return s.fileSearch(t,n).then(r=>!!r.limitHit,r=>A.$4(r)?!1:Promise.reject(r))}e.$jsb=D});var nt=this&&this.__classPrivateFieldSet||function(ie,e,E,F,f){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!f)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!f:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?f.call(ie,E):f?f.value=E:e.set(ie,E),E},We=this&&this.__classPrivateFieldGet||function(ie,e,E,F){if(E==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!F:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?F:E==="a"?F.call(ie):F?F.value:e.get(ie)};define(Se[48],ke([1,0,212,16,56,23,10,3,77,2,14,6,42,292,119,38,25,146,8,26,22,272,7,64,5,27,92,20,107,72,47,4,362,118,274,17,116,39,9,117]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a,t,r,d,l,h,c,v,P,S,p,k,C,j,z,O,U,N,R){"use strict";var T,q,ee,J;Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=e.$bgc=e.$agc=e.$_fc=void 0,e.$_fc=(0,d.$2h)("IHostUtils");let K=J=class extends b.$Sc{constructor(me,le,de,Y,X,Q,te,$e,ve,Le,pe,De){super(),this.X=De,this.a=this.B(new p.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=le,this.g=de,this.f=te,this.j=Y,this.m=X,this.s=Q,this.t=ve,this.u=Le,this.w=pe,this.y=this.g.getProxy(I.$NK.MainThreadWorkspace),this.z=this.g.getProxy(I.$NK.MainThreadTelemetry),this.C=this.g.getProxy(I.$NK.MainThreadExtensionService),this.D=new M.$1g,this.F=new M.$1g,this.G=new M.$1g,this.H=new M.$1g,this.I=new W(this.f.extensions.activationEvents),this.L=new o.$o7b(this.I,this.f.extensions.allExtensions);const B=new i.$im(this.f.extensions.myExtensions);this.J=new o.$o7b(this.I,ge(this.L,B)),N.$n&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new D.$Wfc(this.g,this.s),this.N=new C.$5fc(this.g),this.O=$e,this.h=me.createChild(new v.$Zh([D.$Xfc,this.M],[C.$6fc,this.N])),this.P=this.B(new y.$Vfc(this.J,this.L,{onExtensionActivationError:(x,se,H)=>{this.C.$onExtensionActivationError(x,n.$3(se),H)},actualActivateExtension:async(x,se)=>{if(o.$o7b.isHostExtension(x,this.J,this.L))return await this.C.$activateExtension(x,se),new y.$Ufc;const H=this.J.getExtensionDescription(x);return this.db(H,se)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(me){n.$1(me)}}async Y(){this.O.onWillDeactivateAll();let me=[];try{me=this.J.getAllExtensionDescriptions().map(X=>X.identifier).filter(X=>this.isActivated(X)).map(X=>this.cb(X))}catch{}await Promise.all(me)}terminate(me,le=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${me}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Y=>{this.s.error(Y)}),this.g.dispose();const de=this.Y();Promise.race([(0,M.$3g)(5e3),de]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${le}`):this.s.info(`Extension host exiting with code ${le}`),this.s.flush(),this.s.dispose(),this.c.exit(le)})}isActivated(me){return this.G.isOpen()?this.P.isActivated(me):!1}async getExtension(me){const le=await this.C.$getExtension(me);return le&&{...le,identifier:new i.$hm(le.identifier.value),extensionLocation:w.URI.revive(le.extensionLocation)}}Z(me,le){return this.P.activateByEvent(me,le)}$(me,le){return this.P.activateById(me,le)}activateByIdWithErrors(me,le){return this.$(me,le).then(()=>{const de=this.P.getActivatedExtension(me);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(me=>this.J)}getExtensionExports(me){if(this.G.isOpen())return this.P.getActivatedExtension(me).exports;try{return this.P.getActivatedExtension(me).exports}catch{return null}}async ab(me){if(me.scheme===z.Schemas.file&&this.c.fsRealpath){const le=await this.c.fsRealpath(me.fsPath);return w.URI.file(le)}return me}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(me=>new re(me))),this.Q}async bb(me){const le=m.$8h.forUris(de=>A.$ug.ignorePathCasing(de));return await Promise.all(me.map(async de=>{if(this.ub(de)){const Y=await this.ab(de.extensionLocation);le.set(Y,de)}})),le}cb(me){let le=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(me))return le;const de=this.P.getActivatedExtension(me);if(!de)return le;try{typeof de.module.deactivate=="function"&&(le=Promise.resolve(de.module.deactivate()).then(void 0,Y=>(this.s.error(Y),Promise.resolve(void 0))))}catch(Y){this.s.error(`An error occurred when deactivating the extension '${me.value}':`),this.s.error(Y)}try{(0,b.$Nc)(de.subscriptions)}catch(Y){this.s.error(`An error occurred when deactivating the subscriptions for extension '${me.value}':`),this.s.error(Y)}return le}async db(me,le){return this.f.remote.isRemote?this.C.$onWillActivateExtension(me.identifier):await this.C.$onWillActivateExtension(me.identifier),this.fb(me,le).then(de=>{const Y=de.activationTimes;return this.C.$onDidActivateExtension(me.identifier,Y.codeLoadingTime,Y.activateCallTime,Y.activateResolvedTime,le),this.eb(me,le,"success",Y),de},de=>{throw this.eb(me,le,"failure"),de})}eb(me,le,de,Y){const X=ae(me,le);this.z.$publicLog2("extensionActivationTimes",{...X,...Y||{},outcome:de})}fb(me,le){const de=ae(me,le);this.z.$publicLog2("activatePlugin",de);const Y=this.ub(me);if(!Y)return Promise.resolve(new y.$Tfc(y.$Qfc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${me.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${me.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this.s.flush();const X=new y.$Rfc(le.startup);return Promise.all([this.vb(me,(0,A.$Dg)(me.extensionLocation,Y),X),this.gb(me)]).then(Q=>(f.mark(`code/extHost/willActivateExtension/${me.identifier.value}`),J.hb(this.s,me.identifier,Q[0],Q[1],X))).then(Q=>(f.mark(`code/extHost/didActivateExtension/${me.identifier.value}`),Q))}gb(me){const le=new a.$Zfc(me,this.M),de=new a.$Yfc(me.identifier.value,!1,this.M),Y=new j.$7fc(me,this.N),X=me.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Q=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${me.identifier.value}`),Promise.all([le.whenReady,de.whenReady,this.O.whenReady]).then(()=>{const te=this;let $e,ve;const Le=(0,g.$kF)(me,"ipc")?this.f.messagePorts?.get(i.$hm.toKey(me.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:de,secrets:Y,subscriptions:[],get extensionUri(){return me.extensionLocation},get extensionPath(){return me.extensionLocation.fsPath},asAbsolutePath(pe){return F.$jc(me.extensionLocation.fsPath,pe)},get storagePath(){return te.O.workspaceValue(me)?.fsPath},get globalStoragePath(){return te.O.globalValue(me).fsPath},get logPath(){return F.$jc(te.f.logsLocation.fsPath,me.identifier.value)},get logUri(){return w.URI.joinPath(te.f.logsLocation,me.identifier.value)},get storageUri(){return te.O.workspaceValue(me)},get globalStorageUri(){return te.O.globalValue(me)},get extensionMode(){return X},get extension(){return $e===void 0&&($e=new ye(te,me.identifier,me,Q,!1)),$e},get extensionRuntime(){return(0,g.$lF)(me,"extensionRuntime"),te.extensionRuntime},get environmentVariableCollection(){return te.u.getEnvironmentVariableCollection(me)},get messagePassingProtocol(){if(!ve){if(!Le)return;const pe=p.Event.buffer(p.Event.fromDOMEventEmitter(Le,"message",De=>De.data));Le.start(),ve={onDidReceiveMessage:pe,postMessage:Le.postMessage.bind(Le)}}return ve}})})}static hb(me,le,de,Y,X){return de=de||{activate:void 0,deactivate:void 0},this.ib(me,le,de,Y,X).then(Q=>new y.$Sfc(!1,null,X.build(),de,Q,Y.subscriptions))}static ib(me,le,de,Y,X){if(typeof de.activate=="function")try{X.activateCallStart(),me.trace(`ExtensionService#_callActivateOptional ${le.value}`);const Q=typeof global=="object"?global:self,te=de.activate.apply(Q,[Y]);return X.activateCallStop(),X.activateResolveStart(),Promise.resolve(te).then($e=>(X.activateResolveStop(),$e))}catch(Q){return Promise.reject(Q)}else return Promise.resolve(de)}jb(me,le){this.$(me.identifier,{startup:!1,extensionId:me.identifier,activationEvent:le}).then(void 0,de=>{this.s.error(de)})}kb(me,le=0){const Y=Date.now();(0,N.$v)(()=>{for(let X=le;X<me.length;X+=1){const Q=me[X];for(const te of Q.activationEvents??[])if(te==="onStartupFinished")if(Date.now()-Y>50){this.kb(me,X);break}else this.jb(Q,te)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(me=>{const le=me.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),de=this.J.getAllExtensionDescriptions();if(le)this.kb(de);else for(const Y of de)if(Y.activationEvents)for(const X of Y.activationEvents)X==="onStartupFinished"&&this.jb(Y,X)})}mb(){const me=this.Z("*",!0).then(void 0,Q=>{this.s.error(Q)});this.B(this.j.onDidChangeWorkspace(Q=>this.nb(Q.added)));const le=this.j.workspace?this.j.workspace.folders:[],de=this.nb(le),Y=this.pb(),X=Promise.all([Y,me,de]).then(()=>{});return Promise.race([X,(0,M.$3g)(1e4)]).then(()=>{this.lb()}),X}nb(me){return me.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(le=>this.ob(me,le))).then(()=>{})}async ob(me,le){if(this.isActivated(le.identifier))return;const de=!this.f.remote.isRemote&&!!this.f.remote.authority,Y={logService:this.s,folders:me.map(Q=>Q.uri),forceUsingSearch:de||!this.c.fsExists,exists:Q=>this.c.fsExists(Q.fsPath),checkExists:(Q,te,$e)=>this.y.$checkExists(Q,te,$e)},X=await(0,k.$isb)(Y,le);if(X)return this.$(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:X.activationEvent}).then(void 0,Q=>this.s.error(Q))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(me){throw console.error(me),me}}async qb(){const{extensionDevelopmentLocationURI:me,extensionTestsLocationURI:le}=this.f.environment;if(!me||!le)throw new Error(E.localize(0,null));const de=await this.vb(null,le,new y.$Rfc(!1));if(!de||typeof de.run!="function")throw new Error(E.localize(1,null,le.toString()));return new Promise((Y,X)=>{const Q=(ve,Le)=>{ve?(N.$n&&this.s.error("Test runner called back with error",ve),X(ve)):(N.$n&&(Le?this.s.info(`Test runner called back with ${Le} failures.`):this.s.info("Test runner called back with successful outcome.")),Y(typeof Le=="number"&&Le>0?1:0))},te=(0,A.$rg)(le),$e=de.run(te,Q);$e&&$e.then&&$e.then(()=>{N.$n&&this.s.info("Test runner finished successfully."),Y(0)}).catch(ve=>{N.$n&&this.s.error("Test runner finished with error",ve),X(ve instanceof Error&&ve.stack?ve.stack:String(ve))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$3g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(me,le){return this.R[me]=le,(0,b.$Qc)(()=>{delete this.R[me]})}async getRemoteExecServer(me){const{resolver:le}=await this.sb(me);return le?.resolveExecServer?.(me,{resolveAttempt:0})}async sb(me){const le=me.indexOf("+");if(le===-1)throw new t.$VK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const de=me.substr(0,le);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this.R[de]}}async $resolveAuthority(me,le){const de=U.$Od.create(!1),Y=()=>`[resolveAuthority(${(0,r.$7k)(me)},${le})][${de.elapsed()}ms] `,X=fe=>this.s.info(`${Y()}${fe}`),Q=fe=>this.s.warn(`${Y()}${fe}`),te=(fe,Re=void 0)=>this.s.error(`${Y()}${fe}`,Re),$e=fe=>{if(fe instanceof t.$VK)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe},ve=async fe=>{X(`activating resolver for ${fe}...`);const{resolver:Re,authorityPrefix:Oe}=await this.sb(fe);if(!Re)throw te(`no resolver for ${Oe}`),new t.$VK(`No remote extension installed to resolve ${Oe}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Re,authorityPrefix:Oe,remoteAuthority:fe}},Le=me.split(/@|%40/g).reverse();X(`activating remote resolvers ${Le.join(" -> ")}`);let pe;try{pe=await Promise.all(Le.map(ve)).catch(async fe=>{if(!(fe instanceof t.$VK)||fe._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw fe;return Q(`resolving nested authorities failed: ${fe.message}`),[await ve(me)]})}catch(fe){return $e(fe)}const De=new M.$ah;De.cancelAndSet(()=>X("waiting..."),1e3);let B,x;for(const[fe,{authorityPrefix:Re,resolver:Oe,remoteAuthority:Ge}]of pe.entries())try{if(fe===pe.length-1)X("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${Re}`),B=await Oe.resolve(Ge,{resolveAttempt:le,execServer:x}),f.mark(`code/extHost/didResolveAuthorityOK/${Re}`),X("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Oe,t.$UK.isManagedResolvedAuthority(B)?B:void 0));else{if(X(`invoking resolveExecServer() for ${Ge}`),f.mark(`code/extHost/willResolveExecServer/${Re}`),x=await Oe.resolveExecServer?.(Ge,{resolveAttempt:le,execServer:x}),!x)throw new t.$VK(`Exec server was not available for ${Ge}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${Re}`)}}catch(He){return f.mark(`code/extHost/didResolveAuthorityError/${Re}`),te("returned an error",He),De.dispose(),$e(He)}De.dispose();const se={environmentTunnels:B.environmentTunnels,features:B.tunnelFeatures},H={extensionHostEnv:B.extensionHostEnv,isTrusted:B.isTrusted,authenticationSession:B.authenticationSessionForInitializingExtensions?{id:B.authenticationSessionForInitializingExtensions.id,providerId:B.authenticationSessionForInitializingExtensions.providerId}:void 0};X(`returned ${t.$UK.isManagedResolvedAuthority(B)?"managed authority":`${B.host}:${B.port}`}`);let ue;if(t.$UK.isManagedResolvedAuthority(B)){const fe=le;this.X.setFactory(fe,B.makeConnection),ue={authority:me,connectTo:new r.$4k(fe),connectionToken:B.connectionToken}}else ue={authority:me,connectTo:new r.$5k(B.host,B.port),connectionToken:B.connectionToken};return{type:"ok",value:{authority:ue,options:H,tunnelInformation:se}}}async $getCanonicalURI(me,le){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$7k)(me)})`);const{resolver:de}=await this.sb(me);if(!de)return null;const Y=w.URI.revive(le);if(typeof de.getCanonicalURI>"u")return Y;const X=await(0,M.$Ug)(()=>de.getCanonicalURI(Y));return X||Y}$startExtensionHost(me){me.toAdd.forEach(Y=>Y.extensionLocation=w.URI.revive(Y.extensionLocation));const{globalRegistry:le,myExtensions:de}=Z(this.I,this.L,this.J,me);return this.L.set(le.getAllExtensionDescriptions()),this.J.set(de),N.$n&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.rb()}$activateByEvent(me,le){return le===1?this.D.wait().then(de=>this.Z(me,!1)):this.G.wait().then(de=>this.Z(me,!1))}async $activate(me,le){return await this.G.wait(),this.J.getExtensionDescription(me)?(await this.$(me,le),!0):!1}async $deltaExtensions(me){me.toAdd.forEach(Q=>Q.extensionLocation=w.URI.revive(Q.extensionLocation));const{globalRegistry:le,myExtensions:de}=Z(this.I,this.L,this.J,me),Y=await this.bb(de);return(await this.getExtensionPathIndex()).setSearchTree(Y),this.L.set(le.getAllExtensionDescriptions()),this.J.set(de),N.$n&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(me){return me}async $test_up(me){return me.byteLength}async $test_down(me){const le=s.$ge.alloc(me),de=Math.random()%256;for(let Y=0;Y<me;Y++)le.writeUInt8(de,Y);return le}async $updateRemoteConnectionData(me){this.W=me,this.a.fire()}};e.$agc=K,e.$agc=K=J=Qe([qe(0,d.$1h),qe(1,e.$_fc),qe(2,c.$RM),qe(3,u.$zfc),qe(4,$.$Cfc),qe(5,L.$jj),qe(6,l.$8M),qe(7,h.$Ffc),qe(8,P.$fyb),qe(9,S.$1fc),qe(10,O.$9fc),qe(11,R.$0fc)],K);function Z(ce,me,le,de){ce.addActivationEvents(de.addActivationEvents);const Y=new o.$o7b(ce,me.getAllExtensionDescriptions());Y.deltaExtensions(de.toAdd,de.toRemove);const X=new i.$im(le.getAllExtensionDescriptions().map(te=>te.identifier));for(const te of de.myToRemove)X.delete(te);for(const te of de.myToAdd)X.add(te);const Q=ge(Y,X);return{globalRegistry:Y,myExtensions:Q}}function ae(ce,me){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:me.activationEvent,reasonId:me.extensionId.value}}function _(ce){return ce.getAllExtensionDescriptions().map(me=>me.identifier.value).join(",")}e.$bgc=(0,d.$2h)("IExtHostExtensionService");class ye{constructor(me,le,de,Y,X){T.set(this,void 0),q.set(this,void 0),ee.set(this,void 0),nt(this,T,me,"f"),nt(this,q,le,"f"),nt(this,ee,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=F.$hc((0,A.$rg)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=Y,this.isFromDifferentExtensionHost=X}get isActive(){return We(this,T,"f").isActivated(We(this,ee,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return We(this,T,"f").getExtensionExports(We(this,ee,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await We(this,T,"f").activateByIdWithErrors(We(this,ee,"f"),{startup:!1,extensionId:We(this,q,"f"),activationEvent:"api"}),this.exports}}e.$cgc=ye,T=new WeakMap,q=new WeakMap,ee=new WeakMap;function ge(ce,me){return ce.getAllExtensionDescriptions().filter(le=>me.has(le.identifier))}class re{constructor(me){this.a=me}setSearchTree(me){this.a=me}findSubstr(me){return this.a.findSubstr(me)}forEach(me){return this.a.forEach(me)}}e.$dgc=re;class W{constructor(me){this.a=new i.$jm,this.addActivationEvents(me)}readActivationEvents(me){return this.a.get(me.identifier)??[]}addActivationEvents(me){for(const le of Object.keys(me))this.a.set(le,me[le])}}}),define(Se[363],ke([1,0,56,2,6,42,25,26,20,27,5,48,14,13]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;let u=class{constructor(s,a,t,r,d,l,h){this.c=s,this.d=a,this.f=t,this.g=r,this.h=d,this.i=l,this.j=h,this.a=new Map,this.b=[]}async install(){this.k(),E.mark("code/extHost/willWaitForConfig");const s=await this.g.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const a=await this.h.getExtensionPathIndex();this.register(new o(this.c,a,this.d,s,this.j)),this.register(this.f.createInstance(g)),this.i.remote.isRemote&&this.register(this.f.createInstance(n,a,this.i.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const a of s.nodeModuleName)this.a.set(a,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(a=>s.alternativeModuleName(a))}};e.$lhc=u,e.$lhc=u=Qe([qe(2,L.$1h),qe(3,A.$Cfc),qe(4,I.$bgc),qe(5,w.$8M),qe(6,$.$jj)],u);let g=D=class{constructor(s){if(s.environment.appRoot&&D.a.size){const a=(0,y.$Ke)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const a=this.b.exec(this.c(s));if(!a)return;const[,t,r,d]=a,l=D.a.get(r);if(l!==void 0)return console.warn(`${r} as been renamed to ${l}, please update your imports`),t+l+d}c(s){return s.replace(/\\/g,"/")}};g.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=D=Qe([qe(0,w.$8M)],g);class o{constructor(s,a,t,r,d){this.c=s,this.d=a,this.e=t,this.f=r,this.g=d,this.nodeModuleName="vscode",this.a=new b.$jm}load(s,a){const t=this.d.findSubstr(a);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((d,l)=>r+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this.b=this.c(M.$fF,this.e,this.f)}return this.b}}let n=class{constructor(s,a,t){this.e=s,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$NK.MainThreadTelemetry);const r=t.getProxy(f.$NK.MainThreadWindow);this.c=(d,l)=>{const h=F.URI.parse(d);return l?this.g(d,l):h.scheme==="http"||h.scheme==="https"?r.$openUri(h,d,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?r.$openUri(h,d,{}):this.g(d,l)}}load(s,a,t){const r=this.e.findSubstr(a);return r&&(this.a=r.identifier.value,this.h()),this.b=t(s),this.c}g(s,a){return this.i(),this.b(s,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Qe([qe(2,m.$RM)],n)}),define(Se[58],ke([1,0,43,3,16,49,5,69,70,48,7,38,289,42]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0,e.$egc=(0,M.$2h)("IExtHostVariableResolverProvider");class D extends $.$SN{constructor(o,n,i,s,a,t,r){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const h=s.tabGroups.all.find(c=>c.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof L.$wM||h.input instanceof L.$BM)return h.input.modified;if(h.input instanceof L.$vM||h.input instanceof L.$AM||h.input instanceof L.$yM)return h.input.uri}}}super({getFolderUri:l=>{const h=t.folders.filter(c=>c.name===l);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,h)=>a.getConfiguration(void 0,l).get(h),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return f.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=d();if(l){const h=n.getWorkspaceFolder(l);if(h)return f.$hc(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(A.env))}}let u=class extends F.$Sc{constructor(o,n,i,s,a){super(),this.b=o,this.c=n,this.g=i,this.h=s,this.j=a,this.a=new E.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$fgc=u,e.$fgc=u=Qe([qe(0,w.$bgc),qe(1,I.$zfc),qe(2,b.$3M),qe(3,y.$Cfc),qe(4,m.$Ofc)],u)}),define(Se[96],ke([1,0,10,4,2,5,6,70,48,20,7,38,141,281,42,58]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=e.$igc=e.$hgc=e.$ggc=void 0,e.$ggc=(0,A.$2h)("IExtHostDebugService");let g=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,d,l,h,c,v){this.E=d,this.F=l,this.G=h,this.H=c,this.I=v,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Sd,this.n=new F.$Sd,this.o=new F.$Sd,this.u=new F.$Sd,this.k=r.getProxy(M.$NK.MainThreadDebugService),this.y=new F.$Sd,this.A=new F.$Sd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(P=>{P.onDidChange(S=>{this.J(P)}),this.J(P)})}asDebugSourceUri(r,d){const l=r;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let h=`debug:${encodeURIComponent(l.path||"")}`,c="?";return d&&(h+=`${c}session=${encodeURIComponent(d.id)}`,c="&"),h+=`${c}ref=${l.sourceReference}`,f.URI.parse(h)}else{if(l.path)return f.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const d=[];for(const l of r.getAllExtensionDescriptions())if(l.contributes){const h=l.contributes.debuggers;if(h&&h.length>0)for(const c of h)(0,y.$WF)(c)&&d.push(c.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(d=>r.push(d)),r}addBreakpoints(r){const d=r.filter(c=>{const v=c.id;return this.w.has(v)?!1:(this.w.set(v,c),!0)});this.U(d,[],[]);const l=[],h=new Map;for(const c of d)if(c instanceof L.$PL){let v=h.get(c.location.uri.toString());v||(v={type:"sourceMulti",uri:c.location.uri,lines:[]},h.set(c.location.uri.toString(),v),l.push(v)),v.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof L.$QL&&l.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(r){const d=r.filter(v=>this.w.delete(v.id));this.U([],d,[]);const l=d.filter(v=>v instanceof L.$PL).map(v=>v.id),h=d.filter(v=>v instanceof L.$QL).map(v=>v.id),c=d.filter(v=>v instanceof L.$RL).map(v=>v.id);return this.k.$unregisterBreakpoints(l,h,c)}startDebugging(r,d,l){return this.k.$startDebugging(r?r.uri:void 0,d,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===L.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,d,l){if(!d)return new L.$PK(()=>{});const h=this.d++;return this.f.push({type:r,handle:h,provider:d}),this.k.$registerDebugConfigurationProvider(r,l,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,h),new L.$PK(()=>{this.f=this.f.filter(c=>c.provider!==d),this.k.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(r,d,l){if(!l)return new L.$PK(()=>{});if(!this.Q(r,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this.g++;return this.h.push({type:d,handle:h,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(d,h),new L.$PK(()=>{this.h=this.h.filter(c=>c.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(r,d){if(!d)return new L.$PK(()=>{});const l=this.i++;return this.j.push({type:r,handle:l,factory:d}),new L.$PK(()=>{this.j=this.j.filter(h=>h.factory!==d)})}async $runInTerminal(r,d){return Promise.resolve(void 0)}async $substituteVariables(r,d){let l;const h=await this.W(r);return h&&(l={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(l,d)}K(r,d){if(r.type==="implementation")return new s(r.implementation)}L(){}async $startDASession(r,d){const l=this,h=await this.V(d);return this.S(this.N(h.type),h).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const v=this.M(c),P=this.K(v,h);if(!P)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const S=P;return this.B.set(r,S),this.R(h).then(p=>(p&&this.C.set(r,p),S.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const C=k,j={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const z=await this.D.sign(C.arguments.value);j.body={signature:z},S.sendResponse(j)}else throw new Error("no signer")}catch(z){j.success=!1,j.message=z.message,S.sendResponse(j)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(k),k=(0,y.$2F)(k,!0),l.k.$acceptDAMessage(r,k)}),S.onError(k=>{p&&p.onError&&p.onError(k),this.k.$acceptDAError(r,k.name,k.message,k.stack)}),S.onExit(k=>{p&&p.onExit&&p.onExit(k??void 0,void 0),this.k.$acceptDAExit(r,k??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),S.startSession()))})}$sendDAMessage(r,d){d=(0,y.$1F)(d,!1);const l=this.C.get(r);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(d),this.B.get(r)?.sendMessage(d)}$stopDASession(r){const d=this.C.get(r);this.C.delete(r),d&&d.onWillStopSession&&d.onWillStopSession();const l=this.B.get(r);return this.B.delete(r),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const d=[],l=[],h=[];if(r.added)for(const c of r.added){const v=c.id;if(v&&!this.w.has(v)){let P;if(c.type==="function")P=new L.$QL(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")P=new L.$RL(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const S=f.URI.revive(c.uri);P=new L.$PL(new L.$2K(S,new L.$QK(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,L.$NL)(P,v),this.w.set(v,P),d.push(P)}}if(r.removed)for(const c of r.removed){const v=this.w.get(c);v&&(this.w.delete(c),l.push(v))}if(r.changed){for(const c of r.changed)if(c.id){const v=this.w.get(c.id);if(v){if(v instanceof L.$QL&&c.type==="function"){const P=v;P.enabled=c.enabled,P.condition=c.condition,P.hitCondition=c.hitCondition,P.logMessage=c.logMessage,P.functionName=c.functionName}else if(v instanceof L.$PL&&c.type==="source"){const P=v;P.enabled=c.enabled,P.condition=c.condition,P.hitCondition=c.hitCondition,P.logMessage=c.logMessage,P.location=new L.$2K(f.URI.revive(c.uri),new L.$QK(c.line,c.character))}h.push(v)}}}this.U(d,l,h)}async $acceptStackFrameFocus(r){let d;const l=r.sessionId?await this.V(r.sessionId):void 0;if(!l)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?d=new L.$XL(l,r.threadId):d=new L.$WL(l,r.threadId,r.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(r,d,l){return(0,E.$Ug)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.W(d);return h.provideDebugConfigurations(c,l)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(r,d,l,h){return(0,E.$Ug)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const v=await this.W(d);return c.resolveDebugConfiguration(v,l,h)})}$resolveDebugConfigurationWithSubstitutedVariables(r,d,l,h){return(0,E.$Ug)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const v=await this.W(d);return c.resolveDebugConfigurationWithSubstitutedVariables(v,l,h)})}async $provideDebugAdapter(r,d){const l=this.O(r);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.V(d);return this.S(l,h).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.M(c)})}async $acceptDebugSessionStarted(r){const d=await this.V(r);this.m.fire(d)}async $acceptDebugSessionTerminated(r){const d=await this.V(r);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,d){(await this.V(r))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(r,d){const h={session:await this.V(r),event:d.event,body:d.body};this.u.fire(h)}M(r){if(r instanceof L.$SL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof L.$TL)return{type:"server",port:r.port,host:r.host};if(r instanceof L.$UL)return{type:"pipeServer",path:r.path};if(r instanceof L.$VL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const d=this.h.filter(l=>l.type===r);if(d.length>0)return d[0].factory}O(r){const d=this.h.filter(l=>l.handle===r);if(d.length>0)return d[0].factory}P(r){const d=this.f.filter(l=>l.handle===r);if(d.length>0)return d[0].provider}Q(r,d){if(r.contributes){const l=r.contributes.debuggers;if(l&&l.length>0){for(const h of l)if(h.label&&h.type&&h.type===d)return!0}}return!1}R(r){const l=r.configuration.type,h=this.j.filter(c=>c.type===l||c.type==="*").map(c=>(0,E.$Ug)(()=>c.factory.createDebugAdapterTracker(r)).then(v=>v,v=>null));return Promise.race([Promise.all(h).then(c=>{const v=c.filter(P=>!!P);if(v.length>0)return new i(v)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async S(r,d){const l=d.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new L.$TL(l));if(r){const c=await this.F.getExtensionRegistry();return(0,E.$Ug)(()=>r.createDebugAdapterDescriptor(d,this.T(d,c))).then(v=>{if(v)return v})}const h=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,h))}T(r,d){}U(r,d,l){(r.length>0||d.length>0||l.length>0)&&this.y.fire(Object.freeze({added:r,removed:d,changed:l}))}async V(r){if(r)if(typeof r=="string"){const d=this.l.get(r);if(d)return d}else{let d=this.l.get(r.id);if(!d){const l=await this.W(r.folderUri),h=r.parent?this.l.get(r.parent):void 0;d=new o(this.k,r.id,r.type,r.name,l,r.configuration,h),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(r){if(r){const d=f.URI.revive(r);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$hgc=g,e.$hgc=g=Qe([qe(0,w.$RM),qe(1,I.$zfc),qe(2,m.$bgc),qe(3,D.$Cfc),qe(4,b.$Ofc),qe(5,u.$egc)],g);class o{constructor(r,d,l,h,c,v,P){this.d=r,this.f=d,this.g=l,this.h=h,this.i=c,this.j=v,this.k=P}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,d){return this.d.$customDebugAdapterRequest(this.f,r,d)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$igc=o;class n{constructor(r){this.value=Object.freeze({append(d){r.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$jgc=n;class i{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(d=>d.onError?d.onError(r):void 0)}onExit(r,d){this.d.forEach(l=>l.onExit?l.onExit(r,d):void 0)}}class s extends $.$zlb{constructor(r){super(),this.h=r,r.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends g{constructor(r,d,l,h,c,v){super(r,d,l,h,c,v)}};e.$kgc=a,e.$kgc=a=Qe([qe(0,w.$RM),qe(1,I.$zfc),qe(2,m.$bgc),qe(3,D.$Cfc),qe(4,b.$Ofc),qe(5,u.$egc)],a)}),define(Se[364],ke([1,0,8,56,2,6,352,14,106,107,27,248,20,66,48,90]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=void 0;class g{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(b.$jj),t=i.get($.$RM).getProxy(A.$NK.MainThreadErrors);E.setUnexpectedErrorHandler(r=>{s.error(r);const d=E.$3(r);t.$onUnexpectedError(d)})}static async installFullHandler(i){const s=i.get(b.$jj),a=i.get($.$RM),t=i.get(D.$bgc),r=i.get(u.$_M),d=a.getProxy(A.$NK.MainThreadExtensionService),l=a.getProxy(A.$NK.MainThreadErrors),h=await t.getExtensionPathIndex(),c=new WeakMap;function v(p,k){if(c.has(p))return c.get(p).stack;let C="",j,z;for(const U of k)C+=`
	at ${U.toString()}`,z=U.getFileName(),!j&&z&&(j=h.findSubstr(f.URI.file(z)));const O=`${p.name||"Error"}: ${p.message||""}${C}`;return c.set(p,{extensionIdentifier:j?.identifier,stack:O}),O}const P=Symbol("prepareStackTrace wrapped");let S=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return S},set(p){if(p===v||!p||p[P]){S=p||v;return}S=function(k,C){return v(k,C),p.call(Error,k,C)},Object.assign(S,{[P]:!0})}}),E.setUnexpectedErrorHandler(p=>{s.error(p);const k=E.$3(p),C=c.get(p);if(!C?.extensionIdentifier){l.$onUnexpectedError(k);return}d.$onExtensionRuntimeError(C.extensionIdentifier,k);const j=r.onExtensionError(C.extensionIdentifier,p);s.trace("forwarded error to extension?",j,C)})}}e.$mhc=g;class o{constructor(i,s,a,t,r){this.a=a,this.b=new M.$w7b(i,null,t),s=o.e(s,this.b);const d=new w.$Zh(...(0,m.$Lr)());d.set(L.$8M,{_serviceBrand:void 0,...s,messagePorts:r}),d.set($.$RM,new $.$SM(this.b)),d.set(y.$wfc,new y.$xfc(t)),d.set(D.$_fc,a);const l=new I.$rq(d,!0);l.invokeFunction(g.installEarlyHandler),this.d=l.invokeFunction(h=>h.get(b.$jj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction(h=>h.get(D.$bgc)),this.c.initialize(),l.invokeFunction(g.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(A.$NK.MainThreadExtensionService);return f.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=f.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const a=i.environment.extensionDevelopmentLocationURI;return a&&(i.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(s.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=f.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=f.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=f.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=f.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=f.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=f.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$nhc=o}),define(Se[365],ke([1,0,10,9,223,242,139,96,70,48,20,47,7,58,38,282,283,42]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;let n=class extends b.$hgc{constructor(r,d,l,h,c,v,P){super(r,d,l,h,v,P),this.Z=c,this.X=new a}K(r,d){switch(r.type){case"server":return new u.$shc(r);case"pipeServer":return new u.$thc(r);case"executable":return new u.$uhc(r,d.type)}return super.K(r,d)}T(r,d){const l=u.$uhc.platformAdapterExecutable(d.getAllExtensionDescriptions(),r.type);if(l)return new $.$SL(l.command,l.args,l.options)}L(){return new M.$i$b}async $runInTerminal(r,d){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(O=>{this.X.onTerminalClosed(O)}));const l=await this.G.getConfigProvider(),h=this.Z.getDefaultShell(!0),c=this.Z.getDefaultShellArgs(!0),v=r.title||f.localize(0,null),P=JSON.stringify({shell:h,shellArgs:c});let S=await this.X.checkout(P,v),p,k=!1;if(S)p=r.cwd;else{const O={shellPath:h,shellArgs:c,cwd:r.cwd,name:v,iconPath:new $.$KL("debug")};k=!0,S=this.Z.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(S,P)}S.show(!0);const C=await S.processId;k?await new Promise(O=>setTimeout(O,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(h.indexOf("powershell")>=0||h.indexOf("pwsh")>=0||h.indexOf("cmd.exe")>=0?S.sendText("cls"):h.indexOf("bash")>=0?S.sendText("clear"):F.$c?S.sendText("cls"):S.sendText("clear"));const j=(0,g.$whc)(h,r.args,!!r.argsCanBeInterpretedByShell,p,r.env);S.sendText(j);const z=this.onDidTerminateDebugSession(O=>{O.id===d&&(this.X.free(S),z.dispose())});return C}else if(r.kind==="external")return s(r,await this.G.getConfigProvider());return super.$runInTerminal(r,d)}};e.$xhc=n,e.$xhc=n=Qe([qe(0,L.$RM),qe(1,D.$zfc),qe(2,w.$bgc),qe(3,o.$Cfc),qe(4,I.$1fc),qe(5,m.$Ofc),qe(6,y.$egc)],n);let i;function s(t,r){if(!i)if(F.$c)i=new A.$79b;else if(F.$d)i=new A.$89b;else if(F.$e)i=new A.$99b;else throw new Error("external terminals not supported on this platform");const d=r.getConfiguration("terminal");return i.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}async checkout(r,d){const h=[...this.b.entries()].map(([c,v])=>(0,E.$Pg)(async P=>{if(c.name!==d||v.lastUsedAt!==-1&&await(0,g.$vhc)(await c.processId))return null;const S=Date.now();return v.lastUsedAt+a.a>S||P.isCancellationRequested||v.config!==r?null:(v.lastUsedAt=S,c)}));return await(0,E.$7g)(h,c=>!!c)}insert(r,d){this.b.set(r,{lastUsedAt:Date.now(),config:d})}free(r){const d=this.b.get(r);d&&(d.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}a.a=1e3}),define(Se[366],ke([1,0,16,2,103,38,69,42,41,47,20,27,95,17,14,91,23,62,58]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;let i=class extends $.$4gc{constructor(a,t,r,d,l,h,c,v,P){super(a,t,r,d,l,h,c,v),this.B=r,this.C=P,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=$.TaskHandleDTO.from(r,this.B),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const h=await this.y(l,t);return this.a.$executeTask(d).catch(()=>{}),h}else{const d=$.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const l=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}u(a,t,r,d){const l=[];if(d)for(const h of d){this.z(h,r),(!h.definition||!a[h.definition.type])&&this.f.warn(`The task [${h.source}, ${h.name}] uses an undefined task type. The task will be ignored in the future.`);const c=$.TaskDTO.from(h,r.extension);c&&(l.push(c),$.CustomExecutionDTO.is(c.execution)&&t.push(this.x(c,h,!0)))}return{tasks:l,extension:r.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=F.URI.file((0,o.homedir)());t=new m.$ji({uri:r,name:g.$Ag(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=F.URI.revive(a),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(r),h=await this.b.getWorkspaceFolders2()??[],c=await this.C.getResolver(),v=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(h);for(const P of t.variables)d.variables[P]=await c.resolveAsync(v,P);if(t.process!==void 0){let P;if(t.process.path!==void 0){P=t.process.path.split(E.$tc);for(let S=0;S<P.length;S++)P[S]=await c.resolveAsync(v,P[S])}d.process=await f.win32.findExecutable(await c.resolveAsync(v,t.process.name),t.process.cwd!==void 0?await c.resolveAsync(v,t.process.cwd):void 0,P)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return f.win32.findExecutable(a,t,r)}};e.$phc=i,e.$phc=i=Qe([qe(0,L.$RM),qe(1,I.$8M),qe(2,A.$zfc),qe(3,M.$3M),qe(4,b.$Cfc),qe(5,w.$1fc),qe(6,D.$jj),qe(7,u.$hfc),qe(8,n.$egc)],i)}),define(Se[367],ke([1,0,62,58]),function(ie,e,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class f extends F.$fgc{m(){return(0,E.homedir)()}}e.$8hc=f}),define(Se[155],ke([1,0,19,10,21,44,17,16,23,2,36]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=e.$Agc=e.$zgc=e.$ygc=void 0;class I{constructor(n,i,s,a){this.d=n,this.e=i,this.f=s,this.g=a,this.a=null,this.b=!1,this.c=0}search(n,i){const s=this.d.folderQueries||[],a=new f.$3d(i);return new Promise((t,r)=>{this.a=new y(n);let d=!1;const l=(h,c)=>{if(!d&&!this.b){const v=this.h(h);u(h)&&typeof this.d.maxResults=="number"&&this.c+v>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),h=this.j(h,this.d.maxResults-this.c));const P=this.h(h);this.c+=P,(P>0||!u(h))&&this.a.add(h,c)}};Promise.all(s.map((h,c)=>this.k(h,v=>l(v,c),a.token))).then(h=>{a.dispose(),this.a.flush();const c=h.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||c,messages:(0,E.$Rb)(h.map(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[])),stats:{type:this.g}})},h=>{a.dispose();const c=(0,A.$Mi)(h);r(new Error(c))})})}h(n){return u(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const s=Array.isArray(n.ranges)?n.ranges:[n.ranges],a=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:s.slice(0,i),preview:{matches:a.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,s){const a=new L.$rJ(this.d,n),t=[],r={report:h=>{if(!this.l(h))return;const c=n.folder.scheme===M.Schemas.file?(0,L.$sJ)(()=>this.f.readdir(m.$Cg(h.uri))):void 0,v=m.$Fg(n.folder,h.uri);if(v){const P=a.includedInQuery(v,b.$nc(v),c);(0,F.$Og)(P)?t.push(P.then(S=>{S&&i(h)})):P&&i(h)}}},d=this.n(n),l=await this.e.provideTextSearchResults($(this.d.contentPattern),d,r,s);return t.length&&await Promise.all(t),l}l(n){if(u(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,L.$qJ)(this.d.includePattern,n.includePattern),s=(0,L.$qJ)(this.d.excludePattern,n.excludePattern),a={folder:w.URI.from(n.folder),excludes:s,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$ygc=I;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class y{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new g(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!m.$wg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(D(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$zgc=y;function D(o){return u(o)?{preview:{matches:(0,E.$2b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,E.$2b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function u(o){return!!o.preview}e.$Agc=u;class g{constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Bgc=g,g.a=4e3,g.b=50}),define(Se[97],ke([1,0,3,6,5,360,20,66,14,2,155]),function(ie,e,E,F,f,A,M,b,m,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=e.$Cgc=void 0,e.$Cgc=(0,f.$2h)("IExtHostSearch");let I=class{constructor(u,g,o){this.k=u,this.l=g,this.n=o,this.c=this.k.getProxy(F.$NK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.$xgc}o(u){return this.l.transformOutgoingScheme(u)}registerTextSearchProvider(u,g){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const o=this.d++;return this.e.set(o,g),this.c.$registerTextSearchProvider(o,this.o(u)),(0,E.$Qc)(()=>{this.g.delete(u),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(u,g){if(this.i.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.i.add(u);const o=this.d++;return this.h.set(o,g),this.c.$registerFileSearchProvider(o,this.o(u)),(0,E.$Qc)(()=>{this.i.delete(u),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(u,g,o,n){const i=$(o),s=this.h.get(u);if(s)return this.j.fileSearch(i,s,a=>{this.c.$handleFileMatch(u,g,a.map(t=>t.resource))},n);throw new Error("unknown provider: "+u)}async doInternalFileSearchWithCustomCallback(u,g,o){return{messages:[]}}$clearCache(u){return this.j.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,g,o,n){const i=this.e.get(u);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const s=$(o);return this.q(s,i).search(t=>this.c.$handleTextMatch(u,g,t),n)}$enableExtensionHostSearch(){}q(u,g){return new L.$ygc(u,g,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$Dgc=I,e.$Dgc=I=Qe([qe(0,M.$RM),qe(1,b.$wfc),qe(2,m.$jj)],I);function $(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(y),extraFileResources:D.extraFileResources&&D.extraFileResources.map(u=>w.URI.revive(u))}}e.$Egc=$;function y(D){return{...D,folder:w.URI.revive(D.folder)}}}),define(Se[368],ke([1,0,21,8,4,3,17,40,2,133,179,180,82,26,32,14,65,87,267,6,304,312,91,305,306,307,308,309,310,311,287,35,313,42,343,96,150,315,316,317,293,318,69,70,319,48,320,71,321,57,27,322,323,324,325,326,327,116,117,328,359,295,273,296,329,330,153,331,297,332,333,20,334,97,118,335,336,337,119,92,95,90,47,338,339,284,340,298,72,15,7,341,66,342,93,344,345,152,38,280,115,25,94]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a,t,r,d,l,h,c,v,P,S,p,k,C,j,z,O,U,N,R,T,q,ee,J,K,Z,ae,_,ye,ge,re,W,ce,me,le,de,Y,X,Q,te,$e,ve,Le,pe,De,B,x,se,H,ue,fe,Re,Oe,Ge,He,et,lt,ct,ot,Pe,Ue,Ae,Xe,ne,he,Ie,Ke,Ye,it,at,je,Et,It,Ht,Kt,yt,Gt,zt,ni,Jt,Ft,tt,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;function Zt(dt){const $t=dt.get(re.$8M),Nt=dt.get(ge.$efc),Tt=dt.get(_.$Efc),St=dt.get(Z.$bgc),ft=dt.get(ni.$zfc),Lt=dt.get(Ae.$_M),_t=dt.get(C.$Cfc),Pt=dt.get(It.$wfc),Ze=dt.get(Re.$RM),Wt=dt.get(ot.$Xfc),Xt=dt.get(Pe.$Ffc),Yt=dt.get(u.$kj),pt=dt.get(u.$jj),Ot=dt.get(it.$fyb),Fe=dt.get(t.$hfc),Ne=dt.get(zt.$ghc),Ce=dt.get(He.$6fc),oe=dt.get(J.$Ofc),Te=dt.get(Q.$0fc);Ze.set(i.$OK.ExtHostFileSystemInfo,Nt),Ze.set(i.$OK.ExtHostLogLevelServiceShape,Yt),Ze.set(i.$OK.ExtHostWorkspace,ft),Ze.set(i.$OK.ExtHostConfiguration,_t),Ze.set(i.$OK.ExtHostExtensionService,St),Ze.set(i.$OK.ExtHostStorage,Wt),Ze.set(i.$OK.ExtHostTunnelService,Ot),Ze.set(i.$OK.ExtHostWindow,Ne),Ze.set(i.$OK.ExtHostSecretState,Ce),Ze.set(i.$OK.ExtHostTelemetry,Lt),Ze.set(i.$OK.ExtHostEditorTabs,oe),Ze.set(i.$OK.ExtHostManagedSockets,Te);const Ve=Ze.set(i.$OK.ExtHostDecorations,dt.get(O.$mgc)),_e=Ze.set(i.$OK.ExtHostDocumentsAndEditors,dt.get(ee.$3M)),Je=Ze.set(i.$OK.ExtHostCommands,dt.get(p.$bN)),st=Ze.set(i.$OK.ExtHostTerminalService,dt.get(Xe.$1fc)),bt=Ze.set(i.$OK.ExtHostDebugService,dt.get(z.$ggc)),qt=Ze.set(i.$OK.ExtHostSearch,dt.get(Ge.$Cgc)),kt=Ze.set(i.$OK.ExtHostTask,dt.get(Ue.$6gc)),Dt=Ze.set(i.$OK.ExtHostOutputService,dt.get(x.$Sgc)),At=Ze.set(i.$OK.ExtHostLocalization,dt.get(X.$9fc)),hi=Ze.set(i.$OK.ExtHostUrls,new Ht.$dhc(Ze)),Rt=Ze.set(i.$OK.ExtHostDocuments,new q.$cfc(Ze,_e)),an=Ze.set(i.$OK.ExtHostDocumentContentProviders,new R.$ogc(Ze,_e,pt)),cn=Ze.set(i.$OK.ExtHostDocumentSaveParticipant,new T.$pgc(pt,Rt,Ze.getProxy(i.$NK.MainThreadBulkEdits))),Ct=Ze.set(i.$OK.ExtHostNotebook,new $e.$Fgc(Ze,Je,_e,Rt,Tt,qt)),$i=Ze.set(i.$OK.ExtHostNotebookDocuments,new Le.$Mgc(Ct)),bi=Ze.set(i.$OK.ExtHostNotebookEditors,new pe.$Ngc(pt,Ct)),Qt=Ze.set(i.$OK.ExtHostNotebookKernels,new De.$Ogc(Ze,$t,Ct,Je,pt)),Ci=Ze.set(i.$OK.ExtHostNotebookRenderers,new B.$Qgc(Ze,Ct)),qi=Ze.set(i.$OK.ExtHostNotebookDocumentSaveParticipant,new ve.$Lgc(pt,Ct,Ze.getProxy(i.$NK.MainThreadBulkEdits))),jt=Ze.set(i.$OK.ExtHostEditors,new he.$tfc(Ze,_e)),Ii=Ze.set(i.$OK.ExtHostTreeViews,new Ye.$bhc(Ze.getProxy(i.$NK.MainThreadTreeViews),Je,pt)),ln=Ze.set(i.$OK.ExtHostEditorInsets,new S.$ufc(Ze.getProxy(i.$NK.MainThreadEditorInsets),jt,$t.remote)),ei=Ze.set(i.$OK.ExtHostDiagnostics,new U.$gfc(Ze,pt,Nt,_e)),ci=Ze.set(i.$OK.ExtHostLanguages,new Y.$Jgc(Ze,Rt,Je.converter,Pt)),gt=Ze.set(i.$OK.ExtHostLanguageFeatures,new de.$kfc(Ze,Pt,Rt,Je,ei,pt,Fe,Lt)),Pi=Ze.set(i.$OK.ExtHostFileSystem,new ae.$rgc(Ze,gt)),ti=Ze.set(i.$OK.ExtHostFileSystemEventService,new ye.$sgc(Ze,pt,_e)),si=Ze.set(i.$OK.ExtHostQuickOpen,(0,fe.$Wgc)(Ze,ft,Je)),di=Ze.set(i.$OK.ExtHostSCM,new Oe.$Ygc(Ze,Je,Rt,pt)),Ai=Ze.set(i.$OK.ExtHostQuickDiff,new ue.$Vgc(Ze,Pt)),Li=Ze.set(i.$OK.ExtHostShare,new et.$Zgc(Ze,Pt)),Ri=Ze.set(i.$OK.ExtHostComments,(0,k.$vfc)(Ze,Je,Rt)),pi=Ze.set(i.$OK.ExtHostProgress,new H.$Ugc(Ze.getProxy(i.$NK.MainThreadProgress))),Vi=Ze.set(i.$OK.ExtHosLabelService,new le.$Igc(Ze)),wi=Ze.set(i.$OK.ExtHostTheming,new Ie.$$gc(Ze)),oi=Ze.set(i.$OK.ExtHostAuthentication,new r.$mfc(Ze)),Mi=Ze.set(i.$OK.ExtHostTimeline,new Ke.$ahc(Ze,Je)),fi=Ze.set(i.$OK.ExtHostWebviews,new Kt.$Jfc(Ze,$t.remote,ft,pt,Fe)),vi=Ze.set(i.$OK.ExtHostWebviewPanels,new yt.$Mfc(Ze,fi,ft)),Fi=Ze.set(i.$OK.ExtHostCustomEditors,new j.$Nfc(Ze,Rt,Xt,fi,vi)),Ni=Ze.set(i.$OK.ExtHostWebviewViews,new Gt.$ehc(Ze,fi)),li=Ze.set(i.$OK.ExtHostTesting,new ne.$7gc(Ze,Je,_e)),Hi=Ze.set(i.$OK.ExtHostUriOpeners,new Et.$chc(Ze)),Ki=Ze.set(i.$OK.ExtHostProfileContentHandlers,new se.$Tgc(Ze));Ze.set(i.$OK.ExtHostInteractive,new ce.$Ggc(Ze,Ct,_e,Je,pt));const Gi=Ze.set(i.$OK.ExtHostInlineChat,new W.$tgc(Ze,Je,Rt,pt)),yi=Ze.set(i.$OK.ExtHostChatProvider,new c.$pfc(Ze,pt)),un=Ze.set(i.$OK.ExtHostChatAgents2,new h.$qfc(Ze,yi,pt)),hn=Ze.set(i.$OK.ExtHostChatVariables,new v.$rfc(Ze)),ui=Ze.set(i.$OK.ExtHostChat,new l.$ofc(Ze)),Ei=Ze.set(i.$OK.ExtHostAiRelatedInformation,new s.$bfc(Ze)),dn=Ze.set(i.$OK.ExtHostAiEmbeddingVector,new K.$qgc(Ze)),Ji=Ze.set(i.$OK.ExtHostIssueReporter,new me.$Hgc(Ze)),Ti=Ze.set(i.$OK.ExtHostStatusBar,new ct.$3gc(Ze,Je.converter)),Si=Ze.set(i.$OK.ExtHostSpeech,new lt.$1gc(Ze)),Qi=Object.values(i.$OK);Ze.assertRegistered(Qi);const Zi=new d.$nfc(Ze,_e),Yi=new P.$sfc(Ze),Oi=new te.$Kgc(Ze,pt),ki=new N.$ngc(Ze);return a.$lfc.register(Je),function(Be,Ut,gi){const wt=function(){let be=!Be.isUnderDevelopment;function Ee(){be||(pt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function ze(ut){if(Array.isArray(ut))ut.forEach(ze);else if(typeof ut=="string")Ee();else{const vt=ut;typeof vt.scheme>"u"&&Ee(),typeof vt.exclusive=="boolean"&&(0,tt.$lF)(Be,"documentFiltersExclusive")}return ut}}(),Xi={getSession(be,Ee,ze){return oi.getSession(Be,be,Ee,ze)},getSessions(be,Ee){return(0,tt.$lF)(Be,"authGetSessions"),oi.getSessions(Be,be,Ee)},async hasSession(be,Ee){return(0,tt.$lF)(Be,"authSession"),!!await oi.getSession(Be,be,Ee,{silent:!0})},get onDidChangeSessions(){return oi.onDidChangeSessions},registerAuthenticationProvider(be,Ee,ze,ut){return oi.registerAuthenticationProvider(be,Ee,ze,ut)}},Di={registerCommand(be,Ee,ze){return Je.registerCommand(!0,be,Ee,ze,void 0,Be)},registerTextEditorCommand(be,Ee,ze){return Je.registerCommand(!0,be,(...ut)=>{const vt=jt.getActiveTextEditor();if(!vt){pt.warn("Cannot execute "+be+" because there is no active text editor.");return}return vt.edit(Mt=>{Ee.apply(ze,[vt,Mt,...ut])}).then(Mt=>{Mt||pt.warn("Edits from command "+be+" were not applied.")},Mt=>{pt.warn("An error occurred while running command "+be,Mt)})},void 0,void 0,Be)},registerDiffInformationCommand:(be,Ee,ze)=>((0,tt.$lF)(Be,"diffCommand"),Je.registerCommand(!0,be,async(...ut)=>{const vt=_e.activeEditor(!0);if(!vt){pt.warn("Cannot execute "+be+" because there is no active text editor.");return}const Mt=await jt.getDiffInformation(vt.id);Ee.apply(ze,[Mt,...ut])},void 0,void 0,Be)),executeCommand(be,...Ee){return Je.executeCommand(be,...Ee)},getCommands(be=!1){return Je.getCommands(be)}},ji={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return st.getDefaultShell(!1)},get onDidChangeShell(){return st.onDidChangeShell},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Lt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.$lF)(Be,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$lF)(Be,"telemetry"),Lt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ae.$$M)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,Ee){return Ae.$0M.validateSender(be),Lt.instantiateLogger(Be,be,Ee)},openExternal(be,Ee){return Ne.openUri(be,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===$t.environment.appUriScheme)return hi.createAppUri(be);try{return await Ne.asExternalUri(be,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,M.$ag)(be,M.Schemas.http)||(0,M.$ag)(be,M.Schemas.https))return be;throw Ee}},get remoteName(){return(0,g.$9k)($t.remote.authority)},get remoteAuthority(){return(0,tt.$lF)(Be,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return pt.onDidChangeLogLevel},registerIssueUriRequestHandler(be){return(0,tt.$lF)(Be,"handleIssueUri"),Ji.registerIssueUriRequestHandler(Be,be)},registerIssueDataProvider(be){return(0,tt.$lF)(Be,"handleIssueUri"),Ji.registerIssueDataProvider(Be,be)},get appQuality(){return(0,tt.$lF)(Be,"resolvers"),$t.quality},get appCommit(){return(0,tt.$lF)(Be,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(ji);const xi={createTestController(be,Ee,ze){return li.createTestController(Be,be,Ee,ze)},createTestObserver(){return(0,tt.$lF)(Be,"testObserver"),li.createTestObserver()},runTests(be){return(0,tt.$lF)(Be,"testObserver"),li.runTests(be)},get onDidChangeTestResults(){return(0,tt.$lF)(Be,"testObserver"),li.onResultsChanged},get testResults(){return(0,tt.$lF)(Be,"testObserver"),li.results}},mi=$t.remote.isRemote?je.ExtensionKind.Workspace:je.ExtensionKind.UI,_i={getExtension(be,Ee){(0,tt.$kF)(Be,"extensionsAny")||(Ee=!1);const ze=Ut.mine.getExtensionDescription(be);if(ze)return new Z.$cgc(St,Be.identifier,ze,mi,!1);if(Ee){const ut=Ut.all.getExtensionDescription(be);if(ut)return new Z.$cgc(St,Be.identifier,ut,mi,!0)}},get all(){const be=[];for(const Ee of Ut.mine.getAllExtensionDescriptions())be.push(new Z.$cgc(St,Be.identifier,Ee,mi,!1));return be},get allAcrossExtensionHosts(){(0,tt.$lF)(Be,"extensionsAny");const be=new y.$im(Ut.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of Ut.all.getAllExtensionDescriptions()){const ut=!be.has(ze.identifier);Ee.push(new Z.$cgc(St,Be.identifier,ze,mi,ut))}return Ee},get onDidChange(){return(0,tt.$kF)(Be,"extensionsAny")?f.Event.any(Ut.mine.onDidChange,Ut.all.onDidChange):Ut.mine.onDidChange}},fn={createDiagnosticCollection(be){return ei.createDiagnosticCollection(Be.identifier,be)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:be=>ei.getDiagnostics(be),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(be,Ee){return ci.changeLanguage(be.uri,Ee)},match(be,Ee){const ze=Rt.getDocumentData(Ee.uri)?.notebook;return(0,L.$ot)(at.LanguageSelector.from(be),Ee.uri,Ee.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(be,Ee,ze){return gt.registerCodeActionProvider(Be,wt(be),Ee,ze)},registerDocumentPasteEditProvider(be,Ee,ze){return(0,tt.$lF)(Be,"documentPaste"),gt.registerDocumentPasteEditProvider(Be,wt(be),Ee,ze)},registerCodeLensProvider(be,Ee){return gt.registerCodeLensProvider(Be,wt(be),Ee)},registerDefinitionProvider(be,Ee){return gt.registerDefinitionProvider(Be,wt(be),Ee)},registerDeclarationProvider(be,Ee){return gt.registerDeclarationProvider(Be,wt(be),Ee)},registerImplementationProvider(be,Ee){return gt.registerImplementationProvider(Be,wt(be),Ee)},registerTypeDefinitionProvider(be,Ee){return gt.registerTypeDefinitionProvider(Be,wt(be),Ee)},registerHoverProvider(be,Ee){return gt.registerHoverProvider(Be,wt(be),Ee,Be.identifier)},registerEvaluatableExpressionProvider(be,Ee){return gt.registerEvaluatableExpressionProvider(Be,wt(be),Ee,Be.identifier)},registerInlineValuesProvider(be,Ee){return gt.registerInlineValuesProvider(Be,wt(be),Ee,Be.identifier)},registerDocumentHighlightProvider(be,Ee){return gt.registerDocumentHighlightProvider(Be,wt(be),Ee)},registerMultiDocumentHighlightProvider(be,Ee){return gt.registerMultiDocumentHighlightProvider(Be,wt(be),Ee)},registerLinkedEditingRangeProvider(be,Ee){return gt.registerLinkedEditingRangeProvider(Be,wt(be),Ee)},registerReferenceProvider(be,Ee){return gt.registerReferenceProvider(Be,wt(be),Ee)},registerRenameProvider(be,Ee){return gt.registerRenameProvider(Be,wt(be),Ee)},registerDocumentSymbolProvider(be,Ee,ze){return gt.registerDocumentSymbolProvider(Be,wt(be),Ee,ze)},registerWorkspaceSymbolProvider(be){return gt.registerWorkspaceSymbolProvider(Be,be)},registerDocumentFormattingEditProvider(be,Ee){return gt.registerDocumentFormattingEditProvider(Be,wt(be),Ee)},registerDocumentRangeFormattingEditProvider(be,Ee){return gt.registerDocumentRangeFormattingEditProvider(Be,wt(be),Ee)},registerOnTypeFormattingEditProvider(be,Ee,ze,...ut){return gt.registerOnTypeFormattingEditProvider(Be,wt(be),Ee,[ze].concat(ut))},registerDocumentSemanticTokensProvider(be,Ee,ze){return gt.registerDocumentSemanticTokensProvider(Be,wt(be),Ee,ze)},registerDocumentRangeSemanticTokensProvider(be,Ee,ze){return gt.registerDocumentRangeSemanticTokensProvider(Be,wt(be),Ee,ze)},registerSignatureHelpProvider(be,Ee,ze,...ut){return typeof ze=="object"?gt.registerSignatureHelpProvider(Be,wt(be),Ee,ze):gt.registerSignatureHelpProvider(Be,wt(be),Ee,typeof ze>"u"?[]:[ze,...ut])},registerCompletionItemProvider(be,Ee,...ze){return gt.registerCompletionItemProvider(Be,wt(be),Ee,ze)},registerInlineCompletionItemProvider(be,Ee,ze){return Ee.handleDidShowCompletionItem&&(0,tt.$lF)(Be,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,tt.$lF)(Be,"inlineCompletionsAdditions"),ze&&(0,tt.$lF)(Be,"inlineCompletionsAdditions"),gt.registerInlineCompletionsProvider(Be,wt(be),Ee,ze)},registerDocumentLinkProvider(be,Ee){return gt.registerDocumentLinkProvider(Be,wt(be),Ee)},registerColorProvider(be,Ee){return gt.registerColorProvider(Be,wt(be),Ee)},registerFoldingRangeProvider(be,Ee){return gt.registerFoldingRangeProvider(Be,wt(be),Ee)},registerSelectionRangeProvider(be,Ee){return gt.registerSelectionRangeProvider(Be,be,Ee)},registerCallHierarchyProvider(be,Ee){return gt.registerCallHierarchyProvider(Be,be,Ee)},registerTypeHierarchyProvider(be,Ee){return gt.registerTypeHierarchyProvider(Be,be,Ee)},setLanguageConfiguration:(be,Ee)=>gt.setLanguageConfiguration(Be,be,Ee),getTokenInformationAtPosition(be,Ee){return(0,tt.$lF)(Be,"tokenInformation"),ci.tokenAtPosition(be,Ee)},registerInlayHintsProvider(be,Ee){return gt.registerInlayHintsProvider(Be,be,Ee)},createLanguageStatusItem(be,Ee){return ci.createLanguageStatusItem(Be,be,Ee)},registerDocumentDropEditProvider(be,Ee,ze){return gt.registerDocumentOnDropEditProvider(Be,be,Ee,(0,tt.$kF)(Be,"dropMetadata")?ze:void 0)}},en={get activeTextEditor(){return jt.getActiveTextEditor()},get visibleTextEditors(){return jt.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument(be,Ee,ze){const ut=await(m.URI.isUri(be)?Promise.resolve(Ui.openTextDocument(be)):Promise.resolve(be));return jt.showTextDocument(ut,Ee,ze)},createTextEditorDecorationType(be){return jt.createTextEditorDecorationType(Be,be)},onDidChangeActiveTextEditor(be,Ee,ze){return jt.onDidChangeActiveTextEditor(be,Ee,ze)},onDidChangeVisibleTextEditors(be,Ee,ze){return jt.onDidChangeVisibleTextEditors(be,Ee,ze)},onDidChangeTextEditorSelection(be,Ee,ze){return jt.onDidChangeTextEditorSelection(be,Ee,ze)},onDidChangeTextEditorOptions(be,Ee,ze){return jt.onDidChangeTextEditorOptions(be,Ee,ze)},onDidChangeTextEditorVisibleRanges(be,Ee,ze){return jt.onDidChangeTextEditorVisibleRanges(be,Ee,ze)},onDidChangeTextEditorViewColumn(be,Ee,ze){return jt.onDidChangeTextEditorViewColumn(be,Ee,ze)},onDidCloseTerminal(be,Ee,ze){return st.onDidCloseTerminal(be,Ee,ze)},onDidOpenTerminal(be,Ee,ze){return st.onDidOpenTerminal(be,Ee,ze)},onDidChangeActiveTerminal(be,Ee,ze){return st.onDidChangeActiveTerminal(be,Ee,ze)},onDidChangeTerminalDimensions(be,Ee,ze){return(0,tt.$lF)(Be,"terminalDimensions"),st.onDidChangeTerminalDimensions(be,Ee,ze)},onDidChangeTerminalState(be,Ee,ze){return st.onDidChangeTerminalState(be,Ee,ze)},onDidWriteTerminalData(be,Ee,ze){return(0,tt.$lF)(Be,"terminalDataWriteEvent"),st.onDidWriteTerminalData(be,Ee,ze)},onDidExecuteTerminalCommand(be,Ee,ze){return(0,tt.$lF)(Be,"terminalExecuteCommandEvent"),st.onDidExecuteTerminalCommand(be,Ee,ze)},get state(){return Ne.getState(Be)},onDidChangeWindowState(be,Ee,ze){return Ne.onDidChangeWindowState(be,Ee,ze)},showInformationMessage(be,...Ee){return Oi.showMessage(Be,b.default.Info,be,Ee[0],Ee.slice(1))},showWarningMessage(be,...Ee){return Oi.showMessage(Be,b.default.Warning,be,Ee[0],Ee.slice(1))},showErrorMessage(be,...Ee){return Oi.showMessage(Be,b.default.Error,be,Ee[0],Ee.slice(1))},showQuickPick(be,Ee,ze){return si.showQuickPick(Be,be,Ee,ze)},showWorkspaceFolderPick(be){return si.showWorkspaceFolderPick(be)},showInputBox(be,Ee){return si.showInput(be,Ee)},showOpenDialog(be){return ki.showOpenDialog(Be,be)},showSaveDialog(be){return ki.showSaveDialog(be)},createStatusBarItem(be,Ee,ze){let ut,vt,Mt;return typeof be=="string"?(ut=be,vt=Ee,Mt=ze):(vt=be,Mt=Ee),Ti.createStatusBarEntry(Be,ut,vt,Mt)},setStatusBarMessage(be,Ee){return Ti.setStatusBarMessage(be,Ee)},withScmProgress(be){return Fe.report("window.withScmProgress",Be,"Use 'withProgress' instead."),pi.withProgress(Be,{location:je.ProgressLocation.SourceControl},(Ee,ze)=>be({report(ut){}}))},withProgress(be,Ee){return pi.withProgress(Be,be,Ee)},createOutputChannel(be,Ee){return Dt.createOutputChannel(be,Ee,Be)},createWebviewPanel(be,Ee,ze,ut){return vi.createWebviewPanel(Be,be,Ee,ze,ut)},createWebviewTextEditorInset(be,Ee,ze,ut){return(0,tt.$lF)(Be,"editorInsets"),ln.createWebviewEditorInset(be,Ee,ze,ut,Be)},createTerminal(be,Ee,ze){return typeof be=="object"?"pty"in be?st.createExtensionTerminal(be):st.createTerminalFromOptions(be):st.createTerminal(be,Ee,ze)},registerTerminalLinkProvider(be){return st.registerLinkProvider(be)},registerTerminalProfileProvider(be,Ee){return st.registerProfileProvider(Be,be,Ee)},registerTerminalQuickFixProvider(be,Ee){return(0,tt.$lF)(Be,"terminalQuickFixProvider"),st.registerTerminalQuickFixProvider(be,Be.identifier.value,Ee)},registerTreeDataProvider(be,Ee){return Ii.registerTreeDataProvider(be,Ee,Be)},createTreeView(be,Ee){return Ii.createTreeView(be,Ee,Be)},registerWebviewPanelSerializer:(be,Ee)=>vi.registerWebviewPanelSerializer(Be,be,Ee),registerCustomEditorProvider:(be,Ee,ze={})=>Fi.registerCustomEditorProvider(Be,be,Ee,ze),registerFileDecorationProvider(be){return Ve.registerFileDecorationProvider(be,Be)},registerUriHandler(be){return hi.registerUriHandler(Be,be)},createQuickPick(){return si.createQuickPick(Be)},createInputBox(){return si.createInputBox(Be)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(be,Ee,ze){return wi.onDidChangeActiveColorTheme(be,Ee,ze)},registerWebviewViewProvider(be,Ee,ze){return Ni.registerWebviewViewProvider(Be,be,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,Ee,ze){return Ct.onDidChangeActiveNotebookEditor(be,Ee,ze)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(be,Ee,ze){return bi.onDidChangeNotebookEditorSelection(be,Ee,ze)},onDidChangeNotebookEditorVisibleRanges(be,Ee,ze){return bi.onDidChangeNotebookEditorVisibleRanges(be,Ee,ze)},showNotebookDocument(be,Ee){return Ct.showNotebookDocument(be,Ee)},registerExternalUriOpener(be,Ee,ze){return(0,tt.$lF)(Be,"externalUriOpener"),Hi.registerExternalUriOpener(Be.identifier,be,Ee,ze)},registerProfileContentHandler(be,Ee){return(0,tt.$lF)(Be,"profileContentHandlers"),Ki.registrProfileContentHandler(Be,be,Ee)},registerQuickDiffProvider(be,Ee,ze,ut){return(0,tt.$lF)(Be,"quickDiffProvider"),Ai.registerQuickDiffProvider(wt(be),Ee,ze,ut)},get tabGroups(){return oe.tabGroups},registerShareProvider(be,Ee){return(0,tt.$lF)(Be,"shareProvider"),Li.registerShareProvider(wt(be),Ee)}},Ui={get rootPath(){return Fe.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(be){throw new F.$9("rootPath")},getWorkspaceFolder(be){return ft.getWorkspaceFolder(be)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(be){throw new F.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(be){throw new F.$9("workspaceFile")},updateWorkspaceFolders:(be,Ee,...ze)=>ft.updateWorkspaceFolders(Be,be,Ee||0,...ze),onDidChangeWorkspaceFolders:function(be,Ee,ze){return ft.onDidChangeWorkspace(be,Ee,ze)},asRelativePath:(be,Ee)=>ft.getRelativePath(be,Ee),findFiles:(be,Ee,ze,ut)=>ft.findFiles(be,Ee,ze,Be.identifier,ut),findTextInFiles:(be,Ee,ze,ut)=>{(0,tt.$lF)(Be,"findTextInFiles");let vt,Mt;return typeof Ee=="object"?(vt=Ee,Mt=ze):(vt={},Mt=Ee,ut=ze),ft.findTextInFiles(be,vt||{},Mt,Be.identifier,ut)},save:be=>((0,tt.$lF)(Be,"saveEditor"),ft.save(be)),saveAs:be=>((0,tt.$lF)(Be,"saveEditor"),ft.saveAs(be)),saveAll:be=>ft.saveAll(be),applyEdit(be,Ee){return Zi.applyWorkspaceEdit(be,Be,Ee)},createFileSystemWatcher:(be,Ee,ze,ut)=>{let vt;return typeof Ee=="boolean"?vt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,tt.$lF)(Be,"createFileSystemWatcher"),vt={...Ee,correlate:!0}),ti.createFileSystemWatcher(ft,Be,be,vt)},get textDocuments(){return Rt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw new F.$9("textDocuments")},openTextDocument(be){let Ee;const ze=be;if(typeof be=="string")Ee=Promise.resolve(m.URI.file(be));else if(m.URI.isUri(be))Ee=Promise.resolve(be);else if(!ze||typeof ze=="object")Ee=Rt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>Rt.ensureDocumentData(ut).then(vt=>vt.document))},onDidOpenTextDocument:(be,Ee,ze)=>Rt.onDidAddDocument(be,Ee,ze),onDidCloseTextDocument:(be,Ee,ze)=>Rt.onDidRemoveDocument(be,Ee,ze),onDidChangeTextDocument:(be,Ee,ze)=>Rt.onDidChangeDocument(be,Ee,ze),onDidSaveTextDocument:(be,Ee,ze)=>Rt.onDidSaveDocument(be,Ee,ze),onWillSaveTextDocument:(be,Ee,ze)=>cn.getOnWillSaveTextDocumentEvent(Be)(be,Ee,ze),get notebookDocuments(){return Ct.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,Ee){let ze;if(m.URI.isUri(be))ze=be,await Ct.openNotebookDocument(be);else if(typeof be=="string")ze=m.URI.revive(await Ct.createNotebookDocument({viewType:be,content:Ee}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(be,Ee,ze){return $i.onDidSaveNotebookDocument(be,Ee,ze)},onDidChangeNotebookDocument(be,Ee,ze){return $i.onDidChangeNotebookDocument(be,Ee,ze)},onWillSaveNotebookDocument(be,Ee,ze){return qi.getOnWillSaveNotebookDocumentEvent(Be)(be,Ee,ze)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(be,Ee,ze,ut){return Ct.registerNotebookSerializer(Be,be,Ee,ze,(0,tt.$kF)(Be,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(be,Ee,ze)=>gi.onDidChangeConfiguration(be,Ee,ze),getConfiguration(be,Ee){return Ee=arguments.length===1?void 0:Ee,gi.getConfiguration(be,Ee,Be)},registerTextDocumentContentProvider(be,Ee){return an.registerTextDocumentContentProvider(be,Ee)},registerTaskProvider:(be,Ee)=>(Fe.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Be,be,Ee)),registerFileSystemProvider(be,Ee,ze){return(0,A.$Pc)(Pi.registerFileSystemProvider(Be,be,Ee,ze),Tt.addFileSystemProvider(be,Ee,ze))},get fs(){return Tt.value},registerFileSearchProvider:(be,Ee)=>((0,tt.$lF)(Be,"fileSearchProvider"),qt.registerFileSearchProvider(be,Ee)),registerTextSearchProvider:(be,Ee)=>((0,tt.$lF)(Be,"textSearchProvider"),qt.registerTextSearchProvider(be,Ee)),registerRemoteAuthorityResolver:(be,Ee)=>((0,tt.$lF)(Be,"resolvers"),St.registerRemoteAuthorityResolver(be,Ee)),registerResourceLabelFormatter:be=>((0,tt.$lF)(Be,"resolvers"),Vi.$registerResourceLabelFormatter(be)),getRemoteExecServer:be=>((0,tt.$lF)(Be,"resolvers"),St.getRemoteExecServer(be)),onDidCreateFiles:(be,Ee,ze)=>ti.onDidCreateFile(be,Ee,ze),onDidDeleteFiles:(be,Ee,ze)=>ti.onDidDeleteFile(be,Ee,ze),onDidRenameFiles:(be,Ee,ze)=>ti.onDidRenameFile(be,Ee,ze),onWillCreateFiles:(be,Ee,ze)=>ti.getOnWillCreateFileEvent(Be)(be,Ee,ze),onWillDeleteFiles:(be,Ee,ze)=>ti.getOnWillDeleteFileEvent(Be)(be,Ee,ze),onWillRenameFiles:(be,Ee,ze)=>ti.getOnWillRenameFileEvent(Be)(be,Ee,ze),openTunnel:be=>((0,tt.$lF)(Be,"tunnels"),Ot.openTunnel(Be,be).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,tt.$lF)(Be,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(be,Ee,ze)=>((0,tt.$lF)(Be,"tunnels"),Ot.onDidChangeTunnels(be,Ee,ze)),registerPortAttributesProvider:(be,Ee)=>((0,tt.$lF)(Be,"portsAttributes"),Ot.registerPortsAttributesProvider(be,Ee)),registerTunnelProvider:(be,Ee)=>((0,tt.$lF)(Be,"tunnelFactory"),Ot.registerTunnelProvider(be,Ee)),registerTimelineProvider:(be,Ee)=>((0,tt.$lF)(Be,"timeline"),Mi.registerTimelineProvider(be,Ee,Be.identifier,Je.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:be=>((0,tt.$lF)(Be,"workspaceTrust"),ft.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,Ee,ze)=>ft.onDidGrantWorkspaceTrust(be,Ee,ze),registerEditSessionIdentityProvider:(be,Ee)=>((0,tt.$lF)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(be,Ee)),onWillCreateEditSessionIdentity:(be,Ee,ze)=>((0,tt.$lF)(Be,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Be)(be,Ee,ze)),registerCanonicalUriProvider:(be,Ee)=>((0,tt.$lF)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider(be,Ee)),getCanonicalUri:(be,Ee,ze)=>((0,tt.$lF)(Be,"canonicalUriProvider"),ft.provideCanonicalUri(be,Ee,ze))},gn={get inputBox(){return Fe.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Be)},createSourceControl(be,Ee,ze){return di.createSourceControl(Be,be,Ee,ze)},registerSourceControlInputBoxValueProvider(be,Ee){return(0,tt.$lF)(Be,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Be,be,Ee)}},mn={createCommentController(be,Ee){return Ri.createCommentController(Be,be,Ee)}},tn={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},get stackFrameFocus(){return bt.stackFrameFocus},onDidStartDebugSession(be,Ee,ze){return bt.onDidStartDebugSession(be,Ee,ze)},onDidTerminateDebugSession(be,Ee,ze){return bt.onDidTerminateDebugSession(be,Ee,ze)},onDidChangeActiveDebugSession(be,Ee,ze){return bt.onDidChangeActiveDebugSession(be,Ee,ze)},onDidReceiveDebugSessionCustomEvent(be,Ee,ze){return bt.onDidReceiveDebugSessionCustomEvent(be,Ee,ze)},onDidChangeBreakpoints(be,Ee,ze){return bt.onDidChangeBreakpoints(be,Ee,ze)},onDidChangeStackFrameFocus(be,Ee,ze){return(0,tt.$lF)(Be,"debugFocus"),bt.onDidChangeStackFrameFocus(be,Ee,ze)},registerDebugConfigurationProvider(be,Ee,ze){return bt.registerDebugConfigurationProvider(be,Ee,ze||Jt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,Ee){return bt.registerDebugAdapterDescriptorFactory(Be,be,Ee)},registerDebugAdapterTrackerFactory(be,Ee){return bt.registerDebugAdapterTrackerFactory(be,Ee)},startDebugging(be,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?bt.startDebugging(be,Ee,{parentSession:ze}):bt.startDebugging(be,Ee,ze||{})},stopDebugging(be){return bt.stopDebugging(be)},addBreakpoints(be){return bt.addBreakpoints(be)},removeBreakpoints(be){return bt.removeBreakpoints(be)},asDebugSourceUri(be,Ee){return bt.asDebugSourceUri(be,Ee)}},zi={registerTaskProvider:(be,Ee)=>kt.registerTaskProvider(Be,be,Ee),fetchTasks:be=>kt.fetchTasks(be),executeTask:be=>kt.executeTask(Be,be),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(be,Ee,ze)=>kt.onDidStartTask(be,Ee,ze),onDidEndTask:(be,Ee,ze)=>kt.onDidEndTask(be,Ee,ze),onDidStartTaskProcess:(be,Ee,ze)=>kt.onDidStartTaskProcess(be,Ee,ze),onDidEndTaskProcess:(be,Ee,ze)=>kt.onDidEndTaskProcess(be,Ee,ze)},nn={createNotebookController(be,Ee,ze,ut,vt){return Qt.createNotebookController(Be,be,Ee,ze,ut,(0,tt.$kF)(Be,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(be,Ee)=>Ct.registerNotebookCellStatusBarItemProvider(Be,be,Ee),createRendererMessaging(be){return Ci.createRendererMessaging(Be,be)},createNotebookControllerDetectionTask(be){return(0,tt.$lF)(Be,"notebookKernelSource"),Qt.createNotebookControllerDetectionTask(Be,be)},registerKernelSourceActionProvider(be,Ee){return(0,tt.$lF)(Be,"notebookKernelSource"),Qt.registerKernelSourceActionProvider(Be,be,Ee)},onDidChangeNotebookCellExecutionState(be,Ee,ze){return(0,tt.$lF)(Be,"notebookCellExecutionState"),Qt.onDidChangeNotebookCellExecutionState(be,Ee,ze)}},rn={t(...be){if(typeof be[0]=="string"){const Ee=be.shift(),ze=!be||typeof be[0]!="object"?be:be[0];return At.getMessage(Be.identifier.value,{message:Ee,args:ze})}return At.getMessage(Be.identifier.value,be[0])},get bundle(){return At.getBundle(Be.identifier.value)},get uri(){return At.getBundleUri(Be.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(be,Ee){return(0,tt.$lF)(Be,"interactive"),Gi.registerProvider(Be,be,Ee)},registerInteractiveSessionProvider(be,Ee){return(0,tt.$lF)(Be,"interactive"),ui.registerChatProvider(Be,be,Ee)},sendInteractiveRequestToProvider(be,Ee){return(0,tt.$lF)(Be,"interactive"),ui.sendInteractiveRequestToProvider(be,Ee)},get onDidPerformUserAction(){return(0,tt.$lF)(Be,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(be,Ee){return(0,tt.$lF)(Be,"interactive"),ui.transferChatSession(be,Ee)}},$n={getRelatedInformation(be,Ee){return(0,tt.$lF)(Be,"aiRelatedInformation"),Ei.getRelatedInformation(Be,be,Ee)},registerRelatedInformationProvider(be,Ee){return(0,tt.$lF)(Be,"aiRelatedInformation"),Ei.registerRelatedInformationProvider(Be,be,Ee)},registerEmbeddingVectorProvider(be,Ee){return(0,tt.$lF)(Be,"aiRelatedInformation"),dn.registerEmbeddingVectorProvider(Be,be,Ee)}},bn={registerChatResponseProvider(be,Ee,ze){return(0,tt.$lF)(Be,"chatProvider"),yi.registerProvider(Be.identifier,be,Ee,ze)},requestChatAccess(be){return(0,tt.$lF)(Be,"chatRequestAccess"),yi.requestChatResponseProvider(Be.identifier,be)},registerVariable(be,Ee,ze){return(0,tt.$lF)(Be,"chatVariables"),hn.registerVariableResolver(Be,be,Ee,ze)},registerMappedEditsProvider(be,Ee){return(0,tt.$lF)(Be,"mappedEditsProvider"),gt.registerMappedEditsProvider(Be,be,Ee)},createChatAgent(be,Ee){return(0,tt.$lF)(Be,"chatAgents2"),un.createChatAgent(Be,be,Ee)}},on={registerSpeechProvider(be,Ee){return(0,tt.$lF)(Be,"speech"),Si.registerProvider(Be.identifier,be,Ee)}};return{version:$t.version,ai:$n,authentication:Xi,commands:Di,comments:mn,chat:bn,debug:tn,env:ji,extensions:_i,interactive:sn,l10n:rn,languages:fn,notebooks:nn,scm:gn,speech:on,tasks:zi,tests:xi,window:en,workspace:Ui,Breakpoint:je.$OL,TerminalOutputAnchor:je.TerminalOutputAnchor,ChatAgentResultFeedbackKind:je.ChatAgentResultFeedbackKind,ChatMessage:je.$GM,ChatMessageRole:je.ChatMessageRole,ChatVariableLevel:je.ChatVariableLevel,ChatAgentCompletionItem:je.$FM,CallHierarchyIncomingCall:je.$bL,CallHierarchyItem:je.$aL,CallHierarchyOutgoingCall:je.$cL,CancellationError:F.$5,CancellationTokenSource:E.$3d,CandidatePortSource:i.CandidatePortSource,CodeAction:je.$0K,CodeActionKind:je.$$K,CodeActionTriggerKind:je.CodeActionTriggerKind,CodeLens:je.$dL,Color:je.$qL,ColorInformation:je.$rL,ColorPresentation:je.$sL,ColorThemeKind:je.ColorThemeKind,CommentMode:je.CommentMode,CommentState:je.CommentState,CommentThreadCollapsibleState:je.CommentThreadCollapsibleState,CommentThreadState:je.CommentThreadState,CompletionItem:je.$kL,CompletionItemKind:je.CompletionItemKind,CompletionItemTag:je.CompletionItemTag,CompletionList:je.$lL,CompletionTriggerKind:je.CompletionTriggerKind,ConfigurationTarget:je.ConfigurationTarget,CustomExecution:je.$AL,DebugAdapterExecutable:je.$SL,DebugAdapterInlineImplementation:je.$VL,DebugAdapterNamedPipeServer:je.$UL,DebugAdapterServer:je.$TL,DebugConfigurationProviderTriggerKind:Jt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:je.DebugConsoleMode,DecorationRangeBehavior:je.DecorationRangeBehavior,Diagnostic:je.$4K,DiagnosticRelatedInformation:je.$3K,DiagnosticSeverity:je.DiagnosticSeverity,DiagnosticTag:je.DiagnosticTag,Disposable:je.$PK,DocumentHighlight:je.$6K,DocumentHighlightKind:je.DocumentHighlightKind,MultiDocumentHighlight:je.$7K,DocumentLink:je.$pL,DocumentSymbol:je.$9K,EndOfLine:je.EndOfLine,EnvironmentVariableMutatorType:je.EnvironmentVariableMutatorType,EvaluatableExpression:je.$YL,InlineValueText:je.$ZL,InlineValueVariableLookup:je.$1L,InlineValueEvaluatableExpression:je.$2L,InlineCompletionTriggerKind:je.InlineCompletionTriggerKind,EventEmitter:f.$Sd,ExtensionKind:je.ExtensionKind,ExtensionMode:je.ExtensionMode,ExternalUriOpenerPriority:je.ExternalUriOpenerPriority,FileChangeType:je.FileChangeType,FileDecoration:je.$_L,FileDecoration2:je.$_L,FileSystemError:je.$4L,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:je.$5L,FoldingRangeKind:je.FoldingRangeKind,FunctionBreakpoint:je.$QL,InlineCompletionItem:je.$mL,InlineCompletionList:je.$nL,Hover:je.$5K,IndentAction:I.IndentAction,Location:je.$2K,MarkdownString:je.$eL,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:je.$fL,PortAutoForwardAction:je.PortAutoForwardAction,Position:je.$QK,ProcessExecution:je.$yL,ProgressLocation:je.ProgressLocation,QuickInputButtons:je.$$L,Range:je.$RK,RelativePattern:je.$ML,Selection:je.$SK,SelectionRange:je.$_K,SemanticTokens:je.$8L,SemanticTokensBuilder:je.$7L,SemanticTokensEdit:je.$9L,SemanticTokensEdits:je.$0L,SemanticTokensLegend:je.$6L,ShellExecution:je.$zL,ShellQuoting:je.ShellQuoting,SignatureHelp:je.$hL,SignatureHelpTriggerKind:je.SignatureHelpTriggerKind,SignatureInformation:je.$gL,SnippetString:je.$1K,SourceBreakpoint:je.$PL,StandardTokenType:je.StandardTokenType,StatusBarAlignment:je.StatusBarAlignment,SymbolInformation:je.$8K,SymbolKind:je.SymbolKind,SymbolTag:je.SymbolTag,Task:je.$BL,TaskGroup:je.$xL,TaskPanelKind:je.TaskPanelKind,TaskRevealKind:je.TaskRevealKind,TaskScope:je.TaskScope,TerminalLink:je.$tL,TerminalQuickFixTerminalCommand:je.$vL,TerminalQuickFixOpener:je.$uL,TerminalLocation:je.TerminalLocation,TerminalProfile:je.$wL,TerminalExitReason:je.TerminalExitReason,TextDocumentSaveReason:je.TextDocumentSaveReason,TextEdit:je.$WK,SnippetTextEdit:je.$YK,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:je.TextEditorLineNumbersStyle,TextEditorRevealType:je.TextEditorRevealType,TextEditorSelectionChangeKind:je.TextEditorSelectionChangeKind,SyntaxTokenType:je.SyntaxTokenType,TextDocumentChangeReason:je.TextDocumentChangeReason,ThemeColor:je.$LL,ThemeIcon:je.$KL,TreeItem:je.$CL,TreeItemCheckboxState:je.TreeItemCheckboxState,TreeItemCollapsibleState:je.TreeItemCollapsibleState,TypeHierarchyItem:je.$uM,UIKind:Ft.UIKind,Uri:m.URI,ViewColumn:je.ViewColumn,WorkspaceEdit:je.$ZK,DocumentDropEdit:je.$IL,DocumentPasteEdit:je.$JL,InlayHint:je.$jL,InlayHintLabelPart:je.$iL,InlayHintKind:je.InlayHintKind,RemoteAuthorityResolverError:je.$VK,ResolvedAuthority:je.$TK,ManagedResolvedAuthority:je.$UK,SourceControlInputBoxValidationType:je.SourceControlInputBoxValidationType,ExtensionRuntime:je.ExtensionRuntime,TimelineItem:je.$jM,NotebookRange:je.$bM,NotebookCellKind:je.NotebookCellKind,NotebookCellExecutionState:je.NotebookCellExecutionState,NotebookCellData:je.$cM,NotebookData:je.$dM,NotebookRendererScript:je.$hM,NotebookCellStatusBarAlignment:je.NotebookCellStatusBarAlignment,NotebookEditorRevealType:je.NotebookEditorRevealType,NotebookCellOutput:je.$fM,NotebookCellOutputItem:je.$eM,NotebookCellStatusBarItem:je.$gM,NotebookControllerAffinity:je.NotebookControllerAffinity,NotebookControllerAffinity2:je.NotebookControllerAffinity2,NotebookEdit:je.$XK,NotebookKernelSourceAction:je.$iM,NotebookVariablesRequestKind:je.NotebookVariablesRequestKind,PortAttributes:je.$lM,LinkedEditingRanges:je.$kM,TestResultState:je.TestResultState,TestRunRequest:je.$mM,TestMessage:je.$nM,TestMessage2:je.$nM,TestTag:je.$oM,TestRunProfileKind:je.TestRunProfileKind,TextSearchCompleteMessageType:Bt.TextSearchCompleteMessageType,DataTransfer:je.$HL,DataTransferItem:je.$DL,CoveredCount:je.$pM,FileCoverage:je.$qM,StatementCoverage:je.$rM,BranchCoverage:je.$sM,FunctionCoverage:je.$tM,WorkspaceTrustState:je.WorkspaceTrustState,LanguageStatusSeverity:je.LanguageStatusSeverity,QuickPickItemKind:je.QuickPickItemKind,InputBoxValidationSeverity:je.InputBoxValidationSeverity,TabInputText:je.$vM,TabInputTextDiff:je.$wM,TabInputTextMerge:je.$xM,TabInputCustom:je.$yM,TabInputNotebook:je.$AM,TabInputNotebookDiff:je.$BM,TabInputWebview:je.$zM,TabInputTerminal:je.$CM,TabInputInteractiveWindow:je.$DM,TabInputChat:je.$EM,TelemetryTrustedValue:o.$xo,LogLevel:u.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:je.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:je.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:je.InteractiveEditorResponseFeedbackKind,StackFrameFocus:je.$WL,ThreadFocus:je.$XL,RelatedInformationType:je.RelatedInformationType,SpeechToTextStatus:je.SpeechToTextStatus}}}e.$hhc=Zt}),define(Se[369],ke([1,0,106,153,38,150,42,35,69,47,95,96,97,119,72,91,152,71,57,118,90,70,151,14,58,116,117]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a,t,r,d,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Kr)(l.$9fc,l.$8fc,1),(0,E.$Kr)(r.$kj,t.$ihc,1),(0,E.$Kr)(u.$hfc,u.$ifc,1),(0,E.$Kr)(b.$bN,b.$aN,0),(0,E.$Kr)(M.$Cfc,M.$Afc,0),(0,E.$Kr)(o.$Efc,o.$Dfc,0),(0,E.$Kr)(I.$ggc,I.$kgc,0),(0,E.$Kr)(A.$mgc,A.$lgc,0),(0,E.$Kr)(m.$3M,m.$2M,0),(0,E.$Kr)(h.$0fc,h.$$fc,0),(0,E.$Kr)(n.$efc,n.$dfc,0),(0,E.$Kr)(F.$Sgc,F.$Rgc,1),(0,E.$Kr)($.$Cgc,$.$Dgc,0),(0,E.$Kr)(y.$Xfc,y.$Wfc,0),(0,E.$Kr)(L.$6gc,L.$5gc,0),(0,E.$Kr)(w.$1fc,w.$4fc,0),(0,E.$Kr)(D.$fyb,D.$gyb,0),(0,E.$Kr)(g.$ghc,g.$fhc,0),(0,E.$Kr)(f.$zfc,f.$yfc,0),(0,E.$Kr)(i.$6fc,i.$5fc,0),(0,E.$Kr)(s.$_M,s.$9M,0),(0,E.$Kr)(a.$Ofc,a.$Pfc,0),(0,E.$Kr)(d.$egc,d.$fgc,0)}),define(Se[120],ke([1,0,19,14,36,94]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=e.$zhc=e.$yhc=void 0;function M(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$yhc=M;function b(I,$,y,D){const u=(0,E.$2b)(y,m),g=new f.$dJ($,u,D),o=g.preview.matches;return{ranges:(0,E.$2b)(u,w),uri:I,preview:{text:g.preview.text,matches:(0,E.$2b)(o,w)}}}e.$zhc=b;function m(I){return new f.$eJ(I.start.line,I.start.character,I.end.line,I.end.character)}function w(I){return new A.$5I(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let L=class{constructor($,y){this.a=$,this.b=y}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$Ahc=L,e.$Ahc=L=Qe([qe(1,F.$jj)],L)}),define(Se[370],ke([1,0,50,16,76,33,9,13,120,371]),function(ie,e,E,F,f,A,M,b,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=e.$Bhc=void 0;const L=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(i,s,a,t){const r=$(i,s,a,t),d=s.folder.fsPath;return{cmd:E.spawn(L,r.args,{cwd:d}),rgDiskPath:L,siblingClauses:r.siblingClauses,rgArgs:r,cwd:d}}e.$Bhc=I;function $(i,s,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];D([s],a,!1).forEach(l=>{const h=(0,m.$yhc)(l);if(r.push("-g",h),M.$d){const c=(0,f.$Dl)(h);c!==h&&r.push("-g",c)}});const d=y([s],t,void 0,!1);return d.globArgs.forEach(l=>{const h=`!${(0,m.$yhc)(l)}`;if(r.push("-g",h),M.$d){const c=(0,f.$Dl)(h);c!==h&&r.push("-g",c)}}),s.disregardIgnoreFiles!==!1?r.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),s.ignoreSymlinks||r.push("--follow"),i.exists&&r.push("--quiet"),r.push("--no-config"),s.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:d.siblingClauses}}function y(i,s,a,t=!0){const r=[];let d={};return i.forEach(l=>{const h=Object.assign({},l.excludePattern||{},s||{}),c=u(h,t?l.folder.fsPath:void 0,a);r.push(...c.globArgs),c.siblingClauses&&(d=Object.assign(d,c.siblingClauses))}),{globArgs:r,siblingClauses:d}}function D(i,s,a=!0){const t=[];return i.forEach(r=>{const d=Object.assign({},s||{},r.includePattern||{}),l=u(d,a?r.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function u(i,s,a){const t=[],r={};return Object.keys(i).forEach(d=>{if(a&&a.has(d)||!d)return;const l=i[d];d=o(s?g(s,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(n(d))):l&&l.when&&(r[d]=l)}),{globArgs:t,siblingClauses:r}}function g(i,s){return F.$ic(s)?s:F.$jc(i,s)}e.$Chc=g;function o(i){return i=b.$Qe(i,"\\"),b.$Qe(i,"/")}function n(i){return A.$Zf(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}e.$Dhc=n}),define(Se[372],ke([1,0,50,55,16,373,19,44,34,76,33,9,39,13,18,31,36,370,126]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class s{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&m.$Ij(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,n.$Mq)(this.b).normalizedLowercase),this.u=l.excludePattern&&m.$Ij(l.excludePattern),this.t=new Map,l.folderQueries.forEach(h=>{const c=Object.assign({},h.excludePattern||{},this.a.excludePattern||{}),v=h.folder.fsPath;l.folderQueries.map(P=>P.folder.fsPath).filter(P=>P!==v).forEach(P=>{(0,L.$4f)(P,v)&&(c[f.$lc(v,P)]=!0)}),this.t.set(v,new t(c,v))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,h,c,v,P){if(this.m=$.$Od.create(!1),this.l)return P(null,this.j);h.forEach(S=>{const p=f.$nc(S.fsPath);this.u&&this.u(S.fsPath,p)||this.J(c,{relativePath:S.fsPath,searchPath:void 0})}),this.r=$.$Od.create(!1),this.w(l,(S,p)=>{this.x(this.y,this,S,c,v,k=>{if(k){const C=(0,b.$Mi)(k);console.error(C),this.q.push(C),p(k,void 0)}else p(null,void 0)})},(S,p)=>{this.m.stop();const k=S?M.$Hb(S)[0]:null;P(k,this.j)})}w(l,h,c){const v=new Array(l.length),P=new Array(l.length);let S=!1,p=0;if(l.length===0)return c(null,[]);l.forEach((k,C)=>{h(k,(j,z)=>{if(j?(S=!0,v[C]=null,P[C]=j):(v[C]=z,P[C]=null),++p===l.length)return c(S?P:null,v)})})}x(l,h,...c){try{l.apply(h,c)}catch(v){c[c.length-1](v)}}y(l,h,c,v){const P=l.folder.fsPath,S=I.$d,p=()=>O&&O.kill();i.add(p);let k=T=>{i.delete(p),k=()=>{},v(T)},C="";const j=this.D(),z=(0,o.$Bhc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),O=z.cmd,U=!Object.keys(z.siblingClauses).length,N=z.rgArgs.args.map(T=>T.match(/^-/)?T:`'${T}'`).join(" ");let R=`${z.rgDiskPath} ${N}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(R+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),c({message:R}),this.s=0,this.z(O,"utf8",c,(T,q,ee)=>{if(T){k(T);return}if(this.j){k();return}const K=(C+(S?w.$Cl(q||""):q)).split(`
`);if(ee){const Z=K.length;K[Z-1]=K[Z-1].trim(),K[Z-1]||K.pop()}else C=K.pop()||"";if(K.length&&K[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=K.length,U){for(const Z of K)if(this.J(h,{base:P,relativePath:Z,searchPath:this.N(l,Z)}),this.j){p();break}(ee||this.j)&&k();return}this.G(l,j,P,K,h),ee&&(this.H(j,P,h),k())})}spawnFindCmd(l){const h=this.t.get(l.folder.fsPath),c=h.getBasenameTerms(),v=h.getPathTerms(),P=["-L","."];if(c.length||v.length){P.push("-not","(","(");for(const S of c)P.push("-name",S),P.push("-o");for(const S of v)P.push("-path",S),P.push("-o");P.pop(),P.push(")","-prune",")")}return P.push("-type","f"),E.spawn("find",P,{cwd:l.folder.fsPath})}readStdout(l,h,c){let v="";this.z(l,h,()=>{},(P,S,p)=>{if(P){c(P);return}v+=S,p&&c(null,v)})}z(l,h,c,v){let P=(k,C,j)=>{(k||j)&&(P=()=>{},this.r?.stop()),v(k,C,j)},S=!1;l.stdout?(this.A(l.stdout,h,P),l.stdout.once("data",()=>S=!0)):c({message:"stdout is null"});let p;l.stderr?p=this.B(l.stderr):c({message:"stderr is null"}),l.on("error",k=>{P(k)}),l.on("close",k=>{let C;!S&&(C=this.C(p,h))&&r(C)?P(new Error(`command failed with error code ${k}: ${this.C(p,h)}`)):(this.g&&k===0&&(this.j=!0),P(null,"",!0))})}A(l,h,c){const v=new A.StringDecoder(h);return l.on("data",P=>{c(null,v.write(P))}),v}B(l){const h=[];return l.on("data",c=>{h.push(c)}),h}C(l,h){const c=new A.StringDecoder(h);return l.map(v=>c.write(v)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:h},c,v,P){v.indexOf(this.b)!==-1&&this.J(P,{base:c,relativePath:this.b,searchPath:this.N(l,this.b)});const S=p=>{const k=f.$nc(p),C=f.$mc(p);let j=h[C];j||(j=h[C]=[],S(C)),j.push({base:c,relativePath:p,basename:k,searchPath:this.N(l,p)})};v.forEach(S)}H({rootEntries:l,pathToEntries:h},c,v){const P=this,S=this.t.get(c),p=this.b;function k(C){P.o++;const j=(0,g.$tJ)(()=>C.map(z=>z.basename));for(let z=0,O=C.length;z<O;z++){const U=C[z],{relativePath:N,basename:R}=U;if(S.test(N,R,p!==R?j:void 0))continue;const T=h[N];if(T)k(T);else{if(P.p++,N===p)continue;P.J(v,U)}if(P.j)break}}k(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,h,c,v,P){const S=l.folder,p=(0,g.$tJ)(()=>c);this.w(c,(k,C)=>{if(this.l||this.j)return C(null);const j=h?[h,k].join(f.sep):k;if(this.t.get(l.folder.fsPath).test(j,k,this.a.filePattern!==k?p:void 0))return C(null);const z=[S.fsPath,j].join(f.sep);F.lstat(z,(O,U)=>{if(O||this.l||this.j)return C(null);this.L(z,U,(N,R)=>N||this.l||this.j?C(null):R.isDirectory()?(this.o++,this.M(z,U,(T,q)=>T||this.l||this.j||(q=q||"",this.v[q])?C(null):(this.v[q]=!0,u.Promises.readdir(z).then(ee=>{if(this.l||this.j)return C(null);this.I(l,j,ee,v,J=>C(J||null))},ee=>{C(null)})))):(this.p++,j===this.b||this.h&&D.$If(R.size)&&R.size>this.h||this.J(v,{base:S.fsPath,relativePath:j,searchPath:this.N(l,j)}),C(null,void 0)))})},k=>{const C=k&&M.$Hb(k);return P(C&&C.length>0?C[0]:void 0)})}J(l,h){this.K(h)&&(!this.d||this.d(h.relativePath,f.$nc(h.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(h))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$oJ)(l,this.c)}return!0}L(l,h,c){return h.isSymbolicLink()?F.stat(l,c):c(null,h)}M(l,h,c){return h.isSymbolicLink()?F.realpath(l,(v,P)=>v?c(v):c(null,P)):c(null,l)}N(l,h){return l.folderName?f.$jc(l.folderName,h):h}}e.$Ehc=s;class a{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new s(l)}search(l,h,c){this.c.walk(this.a,this.b,l,h,(v,P)=>{c(v,{limitHit:P,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Fhc=a;class t{constructor(l,h){this.expression=l,this.c=h,this.d(l)}d(l){let h,c;Object.keys(l).filter(v=>l[v]).forEach(v=>{f.$ic(v)?(h=h||m.$Dj(),h[v]=l[v]):(c=c||m.$Dj(),c[v]=l[v])}),this.a=h&&m.$Ij(h,{trimForExclusions:!0}),this.b=c&&m.$Ij(c,{trimForExclusions:!0})}test(l,h,c){return this.b&&this.b(l,h,c)||this.a&&this.a(f.$jc(this.c,l),h,c)}getBasenameTerms(){const l=[];return this.a&&l.push(...m.$Kj(this.a)),this.b&&l.push(...m.$Kj(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...m.$Lj(this.a)),this.b&&l.push(...m.$Lj(this.b)),l}}function r(d){const l=d.trim().split(`
`),h=l[0].trim();if(h.startsWith("Error parsing regex"))return h;if(h.startsWith("regex parse error"))return y.$wf(l[l.length-1].trim());if(h.startsWith("error parsing glob")||h.startsWith("unsupported encoding"))return h.charAt(0).toUpperCase()+h.substr(1);if(h==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(h.startsWith("Literal "))return h}}),define(Se[374],ke([1,0,100,22,167,21]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.$9C=e.DecodeStreamErrorKind=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=void 0,e.$1C="utf8",e.$2C="utf8bom",e.$3C="utf16be",e.$4C="utf16le";function M(h){return[e.$1C,e.$2C,e.$3C,e.$4C].some(c=>c===h)}e.$5C=M,e.$6C=[254,255],e.$7C=[255,254],e.$8C=[239,187,191];const b=512,m=512,w=512*8,L=512*128;var I;(function(h){h[h.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class $ extends Error{constructor(c,v){super(c),this.decodeStreamErrorKind=v}}e.$9C=$;class y{static async create(c){let v;if(c!==e.$1C)v=(await(0,f.$ZC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(c));else{const P=new TextDecoder;v={write(S){return P.decode(S,{stream:!0})},end(){return P.decode()}}}return new y(v)}constructor(c){this.a=c}write(c){return this.a.write(c)}end(){return this.a.end()}}function D(h,c){const v=c.minBytesRequiredForDetection??c.guessEncoding?w:m;return new Promise((P,S)=>{const p=(0,E.$7d)(U=>U.join("")),k=[];let C=0,j;const z=new A.$3d,O=async()=>{try{const U=await l({buffer:F.$ge.concat(k),bytesRead:C},c.guessEncoding);if(U.seemsBinary&&c.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);U.encoding=await c.overwriteEncoding(U.encoding),j=await y.create(U.encoding);const N=j.write(F.$ge.concat(k).buffer);p.write(N),k.length=0,C=0,P({stream:p,detected:U})}catch(U){z.cancel(),p.destroy(),S(U)}};(0,E.$$d)(h,{onData:async U=>{j?p.write(j.write(U.buffer)):(k.push(U),C+=U.byteLength,C>=v&&(h.pause(),await O(),setTimeout(()=>h.resume())))},onError:U=>p.error(U),onEnd:async()=>{j||await O(),p.end(j?.end())}},z.token)})}e.$0C=D;async function u(h,c,v){const S=(await(0,f.$ZC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(c),v);let p=!1,k=!1;return{read(){if(k)return null;const C=h.read();if(typeof C!="string"){if(k=!0,!p&&v?.addBOM)switch(c){case e.$1C:case e.$2C:return F.$ge.wrap(Uint8Array.from(e.$8C));case e.$3C:return F.$ge.wrap(Uint8Array.from(e.$6C));case e.$4C:return F.$ge.wrap(Uint8Array.from(e.$7C))}const j=S.end();return j&&j.length>0?(p=!0,F.$ge.wrap(j)):null}return p=!0,F.$ge.wrap(S.write(C))}}}e.$$C=u;async function g(h){return(await(0,f.$ZC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(h))}e.$_C=g;function o(h){return h===e.$2C||h===null?e.$1C:h}e.$aD=o;function n(h,c){if(!h||c<e.$6C.length)return null;const v=h.readUInt8(0),P=h.readUInt8(1);if(v===e.$6C[0]&&P===e.$6C[1])return e.$3C;if(v===e.$7C[0]&&P===e.$7C[1])return e.$4C;if(c<e.$8C.length)return null;const S=h.readUInt8(2);return v===e.$8C[0]&&P===e.$8C[1]&&S===e.$8C[2]?e.$2C:null}e.$bD=n;const i=["ascii","utf-16","utf-32"];async function s(h){const c=await(0,f.$ZC)("jschardet","dist/jschardet.min.js"),v=h.slice(0,L),P=r(v.buffer),S=c.detect(P);if(!S||!S.encoding)return null;const p=S.encoding.toLowerCase();return 0<=i.indexOf(p)?null:t(S.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(h){const c=h.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[c]||c}function r(h){let c="";for(let v=0;v<h.length;v++)c+=String.fromCharCode(h[v]);return c}function d(h){switch(h){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const c=h.match(/windows(\d+)/);return c?"windows-"+c[1]:h}}}e.$cD=d;function l({buffer:h,bytesRead:c},v){let P=n(h,c),S=!1;if(P!==e.$3C&&P!==e.$4C&&h){let p=!0,k=!0,C=!1;for(let j=0;j<c&&j<b;j++){const z=j%2===1,O=h.readUInt8(j)===0;if(O&&(C=!0),p&&(z&&!O||!z&&O)&&(p=!1),k&&(z&&O||!z&&!O)&&(k=!1),O&&!p&&!k)break}C&&(p?P=e.$4C:k?P=e.$3C:S=!0)}return v&&!S&&!P&&h?s(h.slice(0,c)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:S,encoding:P}}e.$dD=l,e.$eD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[156],ke([1,0,374,31,155]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;class A extends f.$ygc{constructor(b,m,w=F,L="searchProcess"){super(b,m,{readdir:I=>w.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,E.$cD)(I)},L)}}e.$Nhc=A}),define(Se[157],ke([1,0,50,390,373,19,73,34,16,13,2,36,94,391,371,120]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=e.$Lhc=e.$Khc=e.$Jhc=e.$Ihc=e.$Hhc=e.$Ghc=void 0;const g=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(k){this.a=k}provideTextSearchResults(k,C,j,z){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((O,U)=>{z.onCancellationRequested(()=>Z());const N=r(k,C),R=C.folder.fsPath,T=N.map(re=>re.match(/^-/)?re:`'${re}'`).join(" ");this.a.appendLine(`${g} ${T}
 - cwd: ${R}`);let q=E.spawn(g,N,{cwd:R});q.on("error",re=>{console.error(re),this.a.appendLine("Error: "+(re&&re.message)),U((0,I.$kJ)(new I.$iJ(re&&re.message,I.SearchErrorCode.rgProcessError)))});let ee=!1;const J=new s(C.maxResults,R,C.previewOptions);J.on("result",re=>{ee=!0,_="",j.report(re)});let K=!1;const Z=()=>{K=!0,q?.kill(),J?.cancel()};let ae=!1;J.on("hitLimit",()=>{ae=!0,Z()});let _="";q.stdout.on("data",re=>{J.handleData(re),ee||(_+=re)});let ye=!1;q.stdout.once("data",()=>ye=!0);let ge="";q.stderr.on("data",re=>{const W=re.toString();this.a.appendLine(W),ge.length+W.length<1e6&&(ge+=W)}),q.on("close",()=>{if(this.a.appendLine(ye?"Got data from stdout":"No data from stdout"),this.a.appendLine(ee?"Got result from parser":"No result from parser"),_&&this.a.appendLine(`Got data without result: ${_}`),this.a.appendLine(""),K)O({limitHit:ae});else{J.flush(),q=null;let re;ge&&!ye&&(re=n(ge))?U((0,I.$kJ)(new I.$iJ(re.message,re.code))):O({limitHit:ae})}})})}}e.$Ghc=o;function n(p){const k=p.split(`
`),C=k[0].trim();if(k.some(z=>z.startsWith("regex parse error")))return new I.$iJ(i(k),I.SearchErrorCode.regexParseError);const j=C.match(/grep config error: unknown encoding: (.*)/);if(j)return new I.$iJ(`Unknown encoding: ${j[1]}`,I.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new I.$iJ(C.charAt(0).toUpperCase()+C.substr(1),I.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new I.$iJ(C.charAt(0).toUpperCase()+C.substr(1),I.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new I.$iJ(C,I.SearchErrorCode.regexParseError)}function i(p){const k=["Regex parse error"],C=p.filter(j=>j.startsWith("PCRE2:"));if(C.length>=1){const j=C[0].replace("PCRE2:","");if(j.indexOf(":")!==-1&&j.split(":").length>=2){const z=j.split(":")[1];k.push(":"+z)}}return k.join("")}class s extends F.EventEmitter{constructor(k,C,j){super(),this.g=k,this.h=C,this.j=j,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,C){return super.on(k,C),this}handleData(k){if(this.b)return;const C=typeof k=="string"?k:this.d.write(k);this.k(C)}k(k){let C=k.indexOf(`
`);const j=this.a+k;if(C>=0)C+=this.a.length;else{this.a=j;return}let z=0;for(;C>=0;)this.m(j.substring(z,C).trim()),z=C+1,C=j.indexOf(`
`,z);this.a=j.substring(z)}m(k){if(this.b||!k)return;let C;try{C=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(C.type==="match"){const j=a(C.data.path),z=L.URI.file(m.$jc(this.h,j)),O=this.n(C.data,z);this.p(O),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const j=a(C.data.path),z=L.URI.file(m.$jc(this.h,j));this.o(C.data,z).forEach(U=>this.p(U))}}n(k,C){const j=k.line_number-1,z=a(k.lines),O=Buffer.from(z);let U=0,N=0,R=j;k.submatches.length===0&&k.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const T=(0,A.$Hb)(k.submatches.map((q,ee)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const J=a(q.match),K=O.slice(U,q.start).toString(),Z=t(K),ae=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+N,_=t(J),ye=Z.numLines+R,ge=_.numLines+ye,re=_.numLines>0?_.lastLineLength:_.lastLineLength+ae;return U=q.end,N=re,R=ge,new $.$5I(ye,ae,ge,re)}));return(0,u.$zhc)(C,z,T,this.j)}o(k,C){const j=a(k.lines),z=k.line_number;return j.replace(/\r?\n$/,"").split(`
`).map((O,U)=>({text:O,uri:C,lineNumber:z+U}))}p(k){this.emit("result",k)}}e.$Hhc=s;function a(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const k=/\n/g;let C=0,j=-1,z;for(;z=k.exec(p);)C++,j=z.index;const O=j>=0?p.length-j-1:p.length;return{numLines:C,lastLineLength:O}}function r(p,k){const C=["--hidden","--no-require-git"];C.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:j,otherIncludes:z}=(0,M.$E)(k.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(z&&z.length){const U=new Set;z.forEach(N=>{U.add(N)}),C.push("-g","!*"),U.forEach(N=>{d(N).map(u.$yhc).forEach(R=>{C.push("-g",R)})})}j&&j.length&&j.forEach(U=>{C.push("-g",U)}),k.excludes.map(u.$yhc).forEach(U=>C.push("-g",`!${U}`)),k.maxFileSize&&C.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),k.followSymlinks&&C.push("--follow"),k.encoding&&k.encoding!=="utf8"&&C.push("--encoding",k.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,w.$Ke)(p.pattern),p.isRegExp=!0),k.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),p.isRegExp&&(p.pattern=l(p.pattern),C.push("--engine","auto"));let O;if(p.isWordMatch){const N=(0,w.$Te)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",N)}else if(p.isRegExp){let U=c(p.pattern);U=v(U),C.push("--regexp",U)}else O=p.pattern,C.push("--fixed-strings");return C.push("--no-config"),k.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),p.isMultiline&&C.push("--multiline"),k.beforeContext&&C.push("--before-context",k.beforeContext+""),k.afterContext&&C.push("--after-context",k.afterContext+""),C.push("--"),O&&C.push(O),C.push("."),C}e.$Ihc=r;function d(p){return S(p).flatMap(C=>{const j=(0,b.$Gj)(C,"/");return j.map((z,O)=>j.slice(0,O+1).join("/"))})}function l(p){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(k);)p=p.replace(k,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(C);)p=p.replace(C,"$1\\x{$2}");return p}e.$Jhc=l;const h=p=>p.type==="Assertion"&&p.kind==="lookbehind";function c(p){let k;try{k=new y.RegExpParser().parsePattern(p)}catch{return p}let C="",j=0;const z=(N,R,T)=>{C+=p.slice(j,N)+T,j=R},O=[];return new y.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const R=O[0];if(!R)z(N.start,N.end,"\\r?\\n");else if(!O.some(h))if(R.type==="CharacterClass")if(R.negate){const T=p.slice(R.start+2,N.start)+p.slice(N.end,R.end-1);R.parent?.type==="Quantifier"?z(R.start,R.end,T?`[^${T}]`:"."):z(R.start,R.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=p.slice(R.start+1,N.start)+p.slice(N.end,R.end-1);z(R.start,R.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else R.type==="Quantifier"&&z(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){O.unshift(N)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(N){O.unshift(N)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(N){O.unshift(N)},onCharacterClassLeave(){O.shift()},onAssertionEnter(N){h(N)&&O.push(N)},onAssertionLeave(N){O[0]===N&&O.shift()}}).visit(k),C+=p.slice(j),C}e.$Khc=c;function v(p){return p.replace(/\n/g,"\\r?\\n")}e.$Lhc=v;function P(p){let k=!1,C=!1,j="",z="";for(let O=0;O<p.length;O++){const U=p[O];switch(U){case"\\":C?(k?z+="\\"+U:j+="\\"+U,C=!1):C=!0;break;case"{":if(C)k?z+=U:j+=U,C=!1;else{if(k)return{strInBraces:j+"{"+z+"{"+p.substring(O+1)};k=!0}break;case"}":if(C)k?z+=U:j+=U,C=!1;else{if(k)return{fixedStart:j,strInBraces:z,fixedEnd:p.substring(O+1)};j+=U}break;default:k?z+=(C?"\\":"")+U:j+=(C?"\\":"")+U,C=!1;break}}return{strInBraces:j+(k?"{"+z:"")}}function S(p){const{fixedStart:k,strInBraces:C,fixedEnd:j}=P(p);if(k===void 0||j===void 0)return[C];let z=(0,b.$Gj)(C,",");z.length||(z=[""]);const O=S(j);return z.flatMap(U=>{const N=k+U;return O.map(R=>N+R)})}e.$Mhc=S}),define(Se[375],ke([1,0,21,157,85,17]),function(ie,e,E,F,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class M{constructor(w){this.b=w,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(w,L,I,$){const y=new F.$Ghc(this.b);if(L.folder.scheme===A.Schemas.vscodeUserData){const D={...L,folder:L.folder.with({scheme:A.Schemas.file})},u=new f.$hv(g=>I.report({...g,uri:g.uri.with({scheme:L.folder.scheme})}));return this.c($,g=>y.provideTextSearchResults(w,D,u,g))}else return this.c($,D=>y.provideTextSearchResults(w,L,I,D))}async c(w,L){const I=b(w);this.a.add(I);const $=await L(I.token);return this.a.delete(I),$}d(){this.a.forEach(w=>w.cancel())}}e.$Qhc=M;function b(m){const w=new E.$3d;return m.onCancellationRequested(()=>w.cancel()),w}}),define(Se[376],ke([1,0,31,157,156]),function(ie,e,E,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class A{constructor(m){this.a=m}search(m,w,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(y){L({message:y})}},$=new f.$Nhc(this.a,new F.$Ghc(I),E);return new Promise((y,D)=>$.search(u=>{w(u.map(M))},m).then(u=>y({limitHit:u.limitHit,type:"success",stats:u.stats}),D))}}e.$Ohc=A;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((m,w)=>{if(w.ranges){const L=w;return m+(Array.isArray(L.ranges)?L.ranges.length:1)}else return m+1},0)}}}),define(Se[377],ke([1,0,19,10,8,4,126,16,39,2,32,36,372,376]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class D{constructor(s="searchProcess"){this.d=s,this.b=Object.create(null)}fileSearch(s){let a;const t=o(s),r=new A.$Sd({onDidAddFirstListener:()=>{a=(0,F.$Pg)(d=>this.doFileSearchWithEngine($.$Fhc,t,l=>r.fire(l),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(s){let a;const t=o(s),r=new A.$Sd({onDidAddFirstListener:()=>{a=(0,F.$Pg)(d=>this.f(t,l=>r.fire(l),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}f(s,a,t){return s.maxFileSize=this.g().maxFileSize,new y.$Ohc(s).search(t,a,a)}g(){return{maxFileSize:16*L.$Tk.GB}}doFileSearch(s,a,t){return this.doFileSearchWithEngine($.$Fhc,s,a,t)}doFileSearchWithEngine(s,a,t,r,d=D.a){let l=0;const h=v=>{Array.isArray(v)?(l+=v.length,t(v.map(P=>this.h(P)))):v.relativePath?(l++,t(this.h(v))):t(v)};if(a.sortByScore){let v=this.l(a,h,r);if(!v){const P=a.maxResults?Object.assign({},a,{maxResults:null}):a,S=new s(P);v=this.j(S,a,t,h,r)}return new Promise((P,S)=>{v.then(([p,k])=>{const C=k.map(j=>this.h(j));this.o(C,t,d),P(p)},S)})}const c=new s(a);return this.r(c,h,d,r).then(v=>({limitHit:v.limitHit,type:"success",stats:{detailStats:v.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(s){return{path:s.base?(0,b.$jc)(s.base,s.relativePath):s.relativePath}}j(s,a,t,r,d){const l=new A.$Sd;let h=(0,F.$Pg)(v=>{let P=[];const S=p=>{Array.isArray(p)?P=p:(r(p),l.fire(p))};return this.r(s,S,-1,v).then(p=>[p,P])}),c;if(a.cacheKey){c=this.k(a.cacheKey);const v={promise:h,event:l.event,resolved:!1};c.resultsToSearchCache[a.filePattern||""]=v,h.then(()=>{v.resolved=!0},P=>{delete c.resultsToSearchCache[a.filePattern||""]}),h=this.s(h)}return h.then(([v,P])=>{const S=c?c.scorerCache:Object.create(null),p=(typeof a.maxResults!="number"||a.maxResults>0)&&m.$Od.create(!1);return this.n(a,P,S,d).then(k=>{const C=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:v.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:k.length},messages:v.messages,limitHit:v.limitHit||typeof a.maxResults=="number"&&P.length>a.maxResults},k]})})}k(s){const a=this.b[s];return a||(this.b[s]=new u)}l(s,a,t){const r=s.cacheKey&&this.b[s.cacheKey];if(!r)return;const d=this.q(r,s.filePattern||"",a,t);if(d)return d.then(([l,h,c])=>{const v=m.$Od.create(!1);return this.n(s,h,r.scorerCache,t).then(P=>{const S=v.elapsed(),p={fromCache:!0,detailStats:c,type:this.d,resultCount:h.length,sortingTime:S};return[{type:"success",limitHit:l.limitHit||typeof s.maxResults=="number"&&h.length>s.maxResults,stats:p},P]})})}n(s,a,t,r){const d=(0,M.$Mq)(s.filePattern||""),l=(c,v)=>(0,M.$Lq)(c,v,d,!0,g,t),h=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return E.$Gb(a,l,h,1e4,r)}o(s,a,t){if(t&&t>0)for(let r=0;r<s.length;r+=t)a(s.slice(r,r+t));else a(s)}q(s,a,t,r){const d=m.$Od.create(!1),l=a.indexOf(b.sep)>=0;let h;for(const S in s.resultsToSearchCache)if(a.startsWith(S)){if(l&&S.indexOf(b.sep)<0&&S!=="")continue;const p=s.resultsToSearchCache[S];h={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!h)return null;const c=d.elapsed(),v=m.$Od.create(!1),P=h.event(t);return r&&r.onCancellationRequested(()=>{P.dispose()}),h.promise.then(([S,p])=>{if(r&&r.isCancellationRequested)throw(0,f.$6)();const k=[],C=(0,M.$Mq)(a).normalizedLowercase;for(const j of p)(0,I.$oJ)(j,C)&&k.push(j);return[S,k,{cacheWasResolved:h.resolved,cacheLookupTime:c,cacheFilterTime:v.elapsed(),cacheEntryCount:p.length}]})}r(s,a,t,r){return new Promise((d,l)=>{let h=[];r?.onCancellationRequested(()=>s.cancel()),s.search(c=>{c&&(t?(h.push(c),t>0&&h.length>=t&&(a(h),h=[])):a(c))},c=>{a(c)},(c,v)=>{h.length&&a(h),c?l(c):d(v)})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}s(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return s.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return s.finally(a)}}}}e.$Phc=D,D.a=512;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(i){return(0,b.$nc)(i.relativePath)}getItemDescription(i){return(0,b.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>w.URI.revive(s))}}function n(i){return{...i,folder:w.URI.revive(i.folder)}}}),define(Se[378],ke([1,0,3,17,2,31,14,27,20,97,66,36,377,375,120,156]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;let g=class extends w.$Dgc{constructor(n,i,s,a){super(n,s,a),this.s=A,this.t=-1,this.v=null,this.w=!1,this.x=new E.$Rc;const t=new D.$Ahc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.$Qhc(t))),i.remote.isRemote&&i.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const n=new D.$Ahc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new y.$Qhc(n))),this.x.add(this.z(F.Schemas.file,new $.$Phc("fileSearchProvider")))}z(n,i){const s=this.d++;return this.v=i,this.t=s,this.c.$registerFileSearchProvider(s,this.o(n)),(0,E.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,i,s,a){const t=(0,w.$Egc)(s);return n===this.t?this.A(n,i,t,a):super.$provideFileSearchResults(n,i,s,a)}doInternalFileSearchWithCustomCallback(n,i,s){const a=t=>{if((0,I.$nJ)(t)&&(t=[t]),Array.isArray(t)){s(t.map(r=>f.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(n,a,i)}async A(n,i,s,a){return this.doInternalFileSearchWithCustomCallback(s,a,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.v?.clearCache(n),super.$clearCache(n)}q(n,i){return new u.$Nhc(n,i,void 0,"textSearchProvider")}};e.$Rhc=g,e.$Rhc=g=Qe([qe(0,m.$RM),qe(1,b.$8M),qe(2,L.$wfc),qe(3,M.$jj)],g)}),define(Se[121],ke([1,0,392,63,62,393,22,8,4,3,16,9,30,80,81]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;class u{traceSocketEvent(p,k){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,k)}constructor(p,k=""){this.f=!0,this.debugLabel=k,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const k=C=>{this.traceSocketEvent("read",C),p(M.$ge.wrap(C))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(p){const k=C=>{p({type:0,hadError:C,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(p){const k=()=>{p()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,b.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,b.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$Qh=u;var g;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var o;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(o||(o={}));class n extends w.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,k){this.socket.traceSocketEvent(p,k)}constructor(p,k,C,j){super(),this.f=this.B(new m.$Sd),this.g=this.B(new m.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:C?.byteLength||0,recordInflateBytes:j}),this.a=this.B(new i(this,k,C,j,this.f,(z,O)=>this.m(z,O))),this.B(this.a.onError(z=>{console.error(z),(0,b.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new D.$Lh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let k=0;for(;k<p.byteLength;)this.a.writeMessage(p.slice(k,Math.min(k+262144,p.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(p,{compressed:k,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let j=2;p.byteLength<126?j+=0:p.byteLength<2**16?j+=2:j+=8;const z=M.$ge.alloc(j),O=k?64:0,U=C&15;if(z.writeUInt8(128|O|U,0),p.byteLength<126)z.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){z.writeUInt8(126,1);let N=1;z.writeUInt8(p.byteLength>>>8&255,++N),z.writeUInt8(p.byteLength>>>0&255,++N)}else{z.writeUInt8(127,1);let N=1;z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(p.byteLength>>>24&255,++N),z.writeUInt8(p.byteLength>>>16&255,++N),z.writeUInt8(p.byteLength>>>8&255,++N),z.writeUInt8(p.byteLength>>>0&255,++N)}this.socket.write(M.$ge.concat([z,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),C=k.readUInt8(0),j=(C&128)>>>7,z=(C&64)>>>6,O=C&15,U=k.readUInt8(1),N=(U&128)>>>7,R=U&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(R===126?2:0)+(R===127?8:0),this.j.fin=j,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!j,this.j.mask=0,this.j.opcode=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),C=k.readUInt8(1),j=(C&128)>>>7;let z=C&127,O=1;z===126?z=k.readUInt8(++O)*2**8+k.readUInt8(++O):z===127&&(z=k.readUInt8(++O)*0+k.readUInt8(++O)*0+k.readUInt8(++O)*0+k.readUInt8(++O)*0+k.readUInt8(++O)*2**24+k.readUInt8(++O)*2**16+k.readUInt8(++O)*2**8+k.readUInt8(++O));let U=0;j&&(U=k.readUInt8(++O)*2**24+k.readUInt8(++O)*2**16+k.readUInt8(++O)*2**8+k.readUInt8(++O)),this.j.state=3,this.j.readLen=z,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Rh=n;class i extends w.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$ge.alloc(0)}constructor(p,k,C,j,z,O){super(),this.n=p,this.r=z,this.s=O,this.a=this.B(new m.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new m.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new m.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new s(this.n,j,C,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(p,k){this.g.push({data:p,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:k}=this.g.shift();if(this.f&&k.compressed){const C=await this.w(this.f,p);this.s(C,k)}else this.s(p,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,k){return new Promise((C,j)=>{p.write(k),p.flush(z=>C(z))})}acceptFrame(p,k,C){this.h.push({data:p,isCompressed:k,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const k=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,k,C){return new Promise((j,z)=>{p.write(k),C&&p.write(M.$ge.fromByteArray([0,0,255,255])),p.flush(O=>j(O))})}}class s extends w.$Sc{get recordedInflateBytes(){return this.j?M.$ge.concat(this.f):M.$ge.alloc(0)}constructor(p,k,C,j){super(),this.h=p,this.j=k,this.a=this.B(new m.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(j),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(M.$ge.wrap(z))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=M.$ge.concat(this.g);this.g.length=0,p(k)})}}class a extends w.$Sc{constructor(p,k){super(),this.g=p,this.a=this.B(new m.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(M.$ge.wrap(C))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=M.$ge.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),p(k)})}}function t(S,p){if(p===0)return;const k=S.byteLength>>>2;for(let N=0;N<k;N++){const R=S.readUInt32BE(N*4);S.writeUInt32BE(R^p,N*4)}const C=k*4,j=S.byteLength-C,z=p>>>24&255,O=p>>>16&255,U=p>>>8&255;j>=1&&S.writeUInt8(S.readUInt8(C)^z,C),j>=2&&S.writeUInt8(S.readUInt8(C+1)^O,C+1),j>=3&&S.writeUInt8(S.readUInt8(C+2)^U,C+2)}e.$Sh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function d(){const S=(0,$.$mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const p=process.platform!=="darwin"&&e.$Sh?e.$Sh:(0,f.tmpdir)(),k=(0,L.$jc)(p,`vscode-ipc-${S}.sock`);return h(k),k}e.$Th=d;function l(S,p,k){const C=(0,E.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${k}-${p}-sock`;const j=k.substr(0,4),z=p.substr(0,6),O=C.substr(0,8);let U;return process.platform!=="darwin"&&e.$Sh&&!process.env.VSCODE_PORTABLE?U=(0,L.$jc)(e.$Sh,`vscode-${O}-${j}-${z}.sock`):U=(0,L.$jc)(S,`${j}-${z}.sock`),h(U),U}e.$Uh=l;function h(S){const p=r[I.$o];typeof p=="number"&&S.length>=p&&console.warn(`WARNING: IPC handle "${S}" is longer than ${p} chars, try a shorter --user-data-dir`)}class c extends y.$Fh{static b(p){const k=m.Event.fromNodeEventEmitter(p,"connection");return m.Event.map(k,C=>({protocol:new D.$Mh(new u(C,"ipc-server-connection")),onDidClientDisconnect:m.Event.once(m.Event.fromNodeEventEmitter(C,"close"))}))}constructor(p){super(c.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Vh=c;function v(S){return new Promise((p,k)=>{const C=(0,F.createServer)();C.on("error",k),C.listen(S,()=>{C.removeListener("error",k),p(new c(C))})})}e.$Wh=v;function P(S,p){return new Promise((k,C)=>{const j=(0,F.createConnection)(S,()=>{j.removeListener("error",C),k(D.$Nh.fromSocket(new u(j,`ipc-client${p}`),p))});j.once("error",C)})}e.$Xh=P}),define(Se[379],ke([1,0,63,62,169,121,10,3,9,45,14,137,257,258,109,88,22]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g$b=e.$f$b=e.$e$b=e.$d$b=void 0;async function o(t,r,d,l,h){let c;for(let v=3;v&&(c?.dispose(),c=await new n(t,r,d,l,h).waitForReady(),!(h&&f.$pg[h]||!f.$pg[c.tunnelLocalPort]));v--);return c}class n extends b.$Sc{constructor(r,d,l,h,c){super(),this.m=d,this.n=c,this.privacy=u.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=E.createServer(),this.c=new M.$1g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=v=>this.r(v),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=h,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,d=(0,u.$tv)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,f.$qg)(r,2,1e3,d),h=null;return this.b.listen(l,this.m),await this.c.wait(),h=this.b.address(),h||(l=0,this.b.listen(l,this.m),await this.c.wait(),h=this.b.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async r(r){r.pause();const d=(0,u.$rv)(this.tunnelRemoteHost)||(0,u.$tv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,$.$gl)(this.a,d,this.tunnelRemotePort),h=l.getSocket(),c=l.readEntireBuffer();l.dispose(),c.byteLength>0&&r.write(c.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),h.end()}),r.on("close",()=>h.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),h instanceof A.$Qh?h.socket.destroy():h.end()}),h instanceof A.$Qh?this.t(r,h):this.s(r,h),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),h.end()})}s(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(l=>r.write(l.buffer)),r.on("data",l=>d.write(g.$ge.wrap(l))),r.resume()}t(r,d){const l=d.socket;l.on("end",()=>r.end()),l.on("close",()=>r.end()),l.on("error",()=>{r.destroy()}),l.pipe(r),r.pipe(l)}}e.$d$b=n;let i=class extends u.$wv{constructor(r,d,l,h,c){super(d,c),this.u=r,this.v=l,this.w=h}isPortPrivileged(r){return(0,u.$uv)(r,this.l,m.OS,F.release())}s(r,d,l,h,c,v,P,S){const p=this.r(d,l);if(p)return++p.refcount,p.value;if((0,u.$ov)(r))return this.t(r,d,l,c,v,P,S);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${c}.`);const k={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},C=o(k,h,d,l,c);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,l,C),C}}};e.$e$b=i,e.$e$b=i=Qe([qe(0,y.$al),qe(1,L.$jj),qe(2,D.$dl),qe(3,I.$Bj),qe(4,w.$vi)],i);let s=class extends i{constructor(r,d,l,h,c){super(r,d,l,h,c)}};e.$f$b=s,e.$f$b=s=Qe([qe(0,y.$al),qe(1,L.$jj),qe(2,D.$dl),qe(3,I.$Bj),qe(4,w.$vi)],s);let a=class extends b.$Sc{constructor(r,d,l,h,c){super(),this.b=r,this.c=d,this.f=l,this.g=h,this.h=c,this.a=new Map}async openTunnel(r,d,l,h,c,v,P,S,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${h} on local port ${v}.`),!this.a.has(r)){const k=new s(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(r,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(d,l,h,c,v,P,S,p)}};e.$g$b=a,e.$g$b=a=Qe([qe(0,y.$al),qe(1,L.$jj),qe(2,I.$Bj),qe(3,D.$dl),qe(4,w.$vi)],a)}),define(Se[380],ke([1,0,121,111,55,35,2,14,41]),function(ie,e,E,F,f,A,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;class w{constructor($,y,D){this.b=$,this.c=y,this.f=D,this.a=F.createServer((u,g)=>this.h(u,g)),this.g().catch(u=>(y.error(u),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,y){const D=(g,o)=>{y.writeHead(g,{"content-type":"application/json"}),y.end(JSON.stringify(o||null),n=>n&&this.c.error(n))},u=[];$.setEncoding("utf8"),$.on("data",g=>u.push(g)),$.on("end",async()=>{try{const g=JSON.parse(u.join(""));let o;switch(g.type){case"open":o=await this.i(g);break;case"openExternal":o=await this.j(g);break;case"status":o=await this.l(g);break;case"extensionManagement":o=await this.k(g);break;default:D(404,`Unknown message type: ${g.type}`);break}D(200,o)}catch(g){const o=g instanceof Error?g.message:JSON.stringify(g);D(500,o),this.c.error("Error while processing pipe request",g)}})}async i($){const{fileURIs:y,folderURIs:D,forceNewWindow:u,diffMode:g,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:a,remoteAuthority:t}=$,r=[];if(Array.isArray(D))for(const c of D)try{r.push({folderUri:M.URI.parse(c)})}catch{}if(Array.isArray(y))for(const c of y)try{(0,m.$ui)(c)?r.push({workspaceUri:M.URI.parse(c)}):r.push({fileUri:M.URI.parse(c)})}catch{}const d=a?M.URI.file(a):void 0,h={forceNewWindow:u,diffMode:g,mergeMode:o,addMode:n,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!d&&!n,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,h)}async j($){for(const y of $.uris){const D=M.URI.parse(y),u=D.scheme==="file"?D:y;await this.b.executeCommand("_remoteCLI.openExternal",u)}}async k($){const y=u=>u?.map(g=>/\.vsix$/i.test(g)?M.URI.parse(g):g),D={list:$.list,install:y($.install),uninstall:y($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$gN=w;let L=class extends w{constructor($,y){super($,y,(0,E.$Th)())}};e.$hN=L,e.$hN=L=Qe([qe(0,A.$bN),qe(1,b.$jj)],L)}),define(Se[381],ke([1,0,111,56,368,363,276,48,348,2,17,7,380,102,346,38,347]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class o extends A.$lhc{k(){const s=this,a=globalThis._VSCODE_NODE_MODULES.module,t=a._load;a._load=function(h,c,v){return h=d(h),s.a.has(h)?s.a.get(h).load(h,w.URI.file((0,y.$jq)(c.filename)),P=>t.apply(this,[P,c,v])):t.apply(this,arguments)};const r=a._resolveLookupPaths;a._resolveLookupPaths=(l,h)=>r.call(this,d(l),h);const d=l=>{for(const h of s.b){const c=h(l);if(c){l=c;break}}return l}}}class n extends b.$agc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async tb(){this.h.createInstance(D.$Uhc);const s=this.h.invokeFunction(f.$hhc);if(this.h.createInstance(m.$Thc),this.f.remote.isRemote&&this.f.remote.authority){const r=this.h.createInstance($.$hN);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}this.h.createInstance(g.$Vhc),await this.h.createInstance(o,s,{mine:this.J,all:this.L}).install(),F.mark("code/extHost/didInitAPI"),(async()=>{const r=process.env.VSCODE_IPC_HOOK_CLI,d=process.env.CODE_SERVER_SESSION_SOCKET;if(!r||!d)return;const h={workspace:this.h.invokeFunction(v=>v.get(u.$zfc).workspace),socketPath:r},c=JSON.stringify({entry:h});await new Promise((v,P)=>{const S={path:"/add-session",socketPath:d,method:"POST",headers:{"content-type":"application/json"}},p=E.request(S,k=>{k.on("error",P),k.on("end",()=>{try{k.statusCode===200?v():P(new Error("Unexpected status code: "+k.statusCode))}catch(C){P(C)}})});p.on("error",P),p.write(c),p.end()})})().catch(r=>{this.s.error(r)});const t=await this.m.getConfigProvider();await(0,M.$Shc)(this.j,t,this,this.s,this.z,this.f),F.mark("code/extHost/didInitProxyResolver")}ub(s){return s.main}async vb(s,a,t){if(a.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${a}', must be of file-scheme`);let r=null;t.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${a.toString(!0)}`),this.s.flush();const d=s?.identifier.value;s&&await this.w.initializeLocalizedMessages(s);try{d&&F.mark(`code/extHost/willLoadExtensionCode/${d}`),r=ie.__$__nodeRequire(a.fsPath)}finally{d&&F.mark(`code/extHost/didLoadExtensionCode/${d}`),t.codeLoadingStop()}return r}async $setRemoteEnvironment(s){if(this.f.remote.isRemote)for(const a in s){const t=s[a];t===null?delete process.env[a]:process.env[a]=t}}}e.$Whc=n}),define(Se[382],ke([1,0,50,22,4,3,123,9,23,2,31,14,256,64,109,88,379,27,20,72,357]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=e.$3hc=e.$2hc=e.$1hc=e.$Zhc=e.$Yhc=e.$Xhc=void 0;function a(p){const k=p.trim().split(`
`),C=[];return k.forEach(z=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);O&&O.length>=3&&C.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),C.reduce((z,O)=>(z[O.socket]=O,z),{})}e.$Xhc=a;function t(...p){const k=[].concat(...p.map(d));return[...new Map(k.filter(C=>C.st==="0A").map(C=>{const j=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:r(j[0]),port:parseInt(j[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}e.$Yhc=t;function r(p){let k="";if(p.length===8)for(let C=p.length-2;C>=0;C-=2)k+=parseInt(p.substr(C,2),16),C!==0&&(k+=".");else for(let C=0;C<p.length;C+=8){const j=p.substring(C,C+8);let z="";for(let O=8;O>=2;O-=2)z+=j.substring(O-2,O),(O===6||O===2)&&(z=parseInt(z,16).toString(16),k+=`${z}`,z="",C+O!==p.length-6&&(k+=":"))}return k}e.$Zhc=r;function d(p){const k=p.trim().split(`
`),C=k.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return k.map(z=>z.trim().split(/\s+/).reduce((O,U,N)=>(O[C[N]||N]=U,O),{}))}e.$1hc=d;function l(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function h(p){const k=p.trim().split(`
`),C=[];return k.forEach(j=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(j);z&&z.length>=4&&C.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),C}e.$2hc=h;async function c(p,k,C){const j=C.reduce((O,U)=>(O[U.pid]=U,O),{}),z=[];return p.forEach(({socket:O,ip:U,port:N})=>{const R=k[O]?k[O].pid:void 0,T=R?j[R]?.cmd:void 0;R&&T&&!l(T)&&z.push({host:U,port:N,detail:T,pid:R})}),z}e.$3hc=c;function v(p,k,C){const j=new Map,z=h(k);for(const O of p){const U=C.get(O.port);if(U){j.set(O.port,U);continue}const N=z.find(R=>R.cmd.includes(`${O.port}`));if(N){let R=N,T;do T=z.find(q=>q.ppid===R.pid),T&&(R=T);while(T);j.set(O.port,{host:O.ip,port:O.port,pid:R.pid,detail:R.cmd,ppid:R.ppid})}else j.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return j}e.$4hc=v;let P=class extends i.$gyb{constructor(k,C,j,z){super(k,C,j),this.D=C,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,b.$e&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const j=new M.$6l;let z=0;for(;this.C;){const O=new Date().getTime(),U=(await this.I()).filter(T=>(0,u.$rv)(T.host)||(0,u.$tv)(T.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(T=>T.port).join(", ")}`);const N=new Date().getTime()-O;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),z++>3&&j.update(N),(!C||JSON.stringify(C)!==JSON.stringify(U))&&(C=U,await this.a.$onFoundNewCandidates(C));const R=this.G(j.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${R} ms.`),await new Promise(T=>setTimeout(()=>T(),R))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",C="";try{k=await L.Promises.readFile("/proc/net/tcp","utf8"),C=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const j=t(k,C),z=await new Promise(J=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(K,Z,ae)=>{J(Z)})}),O=a(z),U=await L.Promises.readdir("/proc"),N=[];for(const J of U)try{const K=Number(J),Z=m.$Dg(w.URI.file("/proc"),J);if((await L.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(K)){const _=await L.Promises.readlink(m.$Dg(Z,"cwd").fsPath),ye=await L.Promises.readFile(m.$Dg(Z,"cmdline").fsPath,"utf8");N.push({pid:K,cwd:_,cmd:ye})}}catch{}const R=[],T=j.filter(J=>{const K=O[J.socket];return K||R.push(J),K}),q=c(T,O,N);let ee;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${R.length}`),R.length>0){const J=await new Promise(K=>{(0,E.exec)("ps -F -A -l | grep root",(Z,ae,_)=>{K(ae)})});this.z=v(R,J,this.z),ee=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ee.map(K=>K.port).join(", ")}`)}return q.then(J=>ee?J.concat(ee):J)}w(k){return async C=>{const j=new g.$d$b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(O,U,N,R){const T=await k.makeConnection();return S.connect(T,U,N,R)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$4k(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await j.waitForReady();const z=new f.$Sd;return{localAddress:(0,s.$bK)(j.localAddress)??j.localAddress,remoteAddress:{port:j.tunnelRemotePort,host:j.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{j.dispose(),z.fire(),z.dispose()}}}}};e.$5hc=P,e.$5hc=P=Qe([qe(0,n.$RM),qe(1,o.$8M),qe(2,I.$jj),qe(3,D.$dl)],P);class S extends $.$lrb{static connect(k,C,j,z){const O=new A.$Rc,U={onClose:O.add(new f.$Sd),onData:O.add(new f.$Sd),onEnd:O.add(new f.$Sd)};O.add(k.onDidReceiveMessage(R=>U.onData.fire(F.$ge.wrap(R)))),O.add(k.onDidEnd(()=>U.onEnd.fire())),O.add(k.onDidClose(R=>U.onClose.fire({type:0,error:R,hadError:!!R})));const N=new S(k,z,U);return N.B(O),(0,$.$krb)(N,C,j,z,U)}constructor(k,C,j){super(C,j),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[383],ke([1,0,106,351,366,365,378,381,382,96,48,97,95,47,72,92,350,349,14,367,58,271,105,109,139]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n,i,s,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Kr)(L.$bgc,b.$Whc,0),(0,E.$Kr)(n.$kj,o.$7hc,1),(0,E.$Kr)(n.$jj,new t.$Yh(a.$khc,[!1],!0)),(0,E.$Kr)(r.$dl,d.$i$b,1),(0,E.$Kr)(u.$Ffc,g.$6hc,0),(0,E.$Kr)(w.$ggc,A.$xhc,0),(0,E.$Kr)(I.$Cgc,M.$Rhc,0),(0,E.$Kr)($.$6gc,f.$phc,0),(0,E.$Kr)(y.$1fc,F.$ohc,0),(0,E.$Kr)(D.$fyb,m.$5hc,0),(0,E.$Kr)(s.$egc,i.$8hc,0)}),define(Se[394],ke([1,0,111,63,395,56,8,81,121,254,115,364,22,31,102,10,133,277,291,369,383]),function(ie,e,E,F,f,A,M,b,m,w,L,I,$,y,D,u,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let v=0;v<process.execArgv.length;v++)process.execArgv[v]==="--inspect-port=0"&&(process.execArgv.splice(v,1),v--)}();const i=f(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,v=c._load;c._load=function(P){if(P==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return v.apply(this,arguments)}})();const s=process.exit.bind(process);function a(c){process.exit=function(v){if(c)s(v);else{const P=new Error("An extension called process.exit() and this was prevented.");console.warn(P.stack)}},process.crash=function(){const v=new Error("An extension called process.crash() and this was prevented.");console.warn(v.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let t=function(c){s()};function r(){const c=(0,n.$Pm)(process.env);if(c.type===3)return new Promise((v,P)=>{const S=p=>{const k=p[0],C=new b.$Oh;k.on("message",j=>C.fire($.$ge.wrap(j.data))),k.on("close",()=>{t("renderer closed the MessagePort")}),k.start(),v({onMessage:C.event,send:j=>k.postMessage(j.buffer)})};process.parentPort.on("message",p=>S(p.ports))});if(c.type===2)return new Promise((v,P)=>{let S=null;const p=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),k=108e5,C=3e5,j=new u.$ch(()=>t("renderer disconnected for too long (1)"),k),z=new u.$ch(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(U,N)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const R=$.$ge.wrap(Buffer.from(U.initialDataChunk,"base64"));let T;if(U.skipWebSocketFrames)T=new m.$Qh(N,"extHost-socket");else{const q=$.$ge.wrap(Buffer.from(U.inflateBytes,"base64"));T=new m.$Rh(new m.$Qh(N,"extHost-socket"),U.permessageDeflate,q,!1)}S?(j.cancel(),z.cancel(),S.beginAcceptReconnection(T,R),S.endAcceptReconnection(),S.sendResume()):(clearTimeout(p),S=new b.$Ph({socket:T,initialChunk:R}),S.sendResume(),S.onDidDispose(()=>t("renderer disconnected")),v(S),S.onSocketClose(()=>{j.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;j.isScheduled()&&z.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const v=c.pipeName;return new Promise((P,S)=>{const p=F.createConnection(v,()=>{p.removeListener("error",S);const k=new b.$Ph({socket:new m.$Qh(p,"extHost-renderer")});k.sendResume(),P(k)});p.once("error",S),p.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const c=await r();return new class{constructor(){this.a=new b.$Oh,this.onMessage=this.a.event,this.b=!1,c.onMessage(v=>{(0,L.$qm)(v,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(v)})}send(v){this.b||c.send(v)}async drain(){if(c.drain)return c.drain()}}}function l(c){return new Promise(v=>{const P=c.onMessage(S=>{P.dispose();const p=JSON.parse(S.toString()),k=p.commit,C=w.default.commit;if(k&&C&&k!==C&&s(55),p.parentPid){let j=0;setInterval(function(){try{process.kill(p.parentPid,0),j=0}catch(O){O&&O.code==="EPERM"?(j++,j>=3&&t(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):t(`parent process ${p.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(p.parentPid)}catch(O){(0,M.$1)(O)}}c.send((0,L.$pm)(0)),v({protocol:c,initData:p})});c.send((0,L.$pm)(1))})}async function h(){const c=[];process.on("unhandledRejection",(j,z)=>{c.push(z),setTimeout(()=>{const O=c.indexOf(z);O>=0&&z.catch(U=>{c.splice(O,1),(0,M.$4)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),j&&(0,M.$1)(j))})},1e3)}),process.on("rejectionHandled",j=>{const z=c.indexOf(j);z>=0&&c.splice(z,1)}),process.on("uncaughtException",function(j){(0,M.$Z)(j)||(0,M.$1)(j)}),A.mark("code/extHost/willConnectToRenderer");const v=await d();A.mark("code/extHost/didConnectToRenderer");const P=await l(v);A.mark("code/extHost/didWaitForInitData");const{initData:S}=P;a(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,g.boolean)(i.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(z){s(z)}fsExists(z){return y.Promises.exists(z)}fsRealpath(z){return(0,D.$iq)(z)}};let k=null;S.remote.authority&&i.transformURIs&&(k=(0,o.$Or)(S.remote.authority));const C=new I.$nhc(P.protocol,S,p,k);t=j=>{C.terminate(j);const z=process.env.VSCODE_IPC_HOOK_CLI,O=process.env.CODE_SERVER_SESSION_SOCKET;if(!z||!O)return;const U=JSON.stringify({socketPath:z}),N={path:"/delete-session",socketPath:O,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},R=E.request(N);R.write(U),R.end()}}h().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
