"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/base/common/uuid","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/themables","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/base/common/iterator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ie){for(var e=[],$=0,P=ie.length;$<P;$++)e[$]=Re[ie[$]];return e};define(Re[66],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function $(M){return(m,g,b)=>{let A=null,C=null;if(typeof b.value=="function"?(A="value",C=b.value):typeof b.get=="function"&&(A="get",C=b.get),!C)throw new Error("not supported");b[A]=M(C,g)}}function P(M,m,g){let b=null,A=null;if(typeof g.value=="function"?(b="value",A=g.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(b="get",A=g.get),!A)throw new Error("not supported");const C=`$memoize$${m}`;g[b]=function(...l){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[C]}}e.$th=P;function I(M,m,g){return $((b,A)=>{const C=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...p){this[l]||(this[l]=g?g():void 0),clearTimeout(this[C]),m&&(this[l]=m(this[l],...p),p=[this[l]]),this[C]=setTimeout(()=>{b.apply(this,p),this[l]=g?g():void 0},M)}})}e.$uh=I;function T(M,m,g){return $((b,A)=>{const C=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...n){if(this[l]||(this[l]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...n)),this[v])return;const o=this[p]+M;o<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[l]]),this[l]=g?g():void 0):(this[v]=!0,this[C]=setTimeout(()=>{this[v]=!1,this[p]=Date.now(),b.apply(this,[this[l]]),this[l]=g?g():void 0},o-Date.now()))}})}e.$vh=T}),define(Re[89],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=e.$WM=void 0;class ${constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$WM=$,e.$XM=new $("id#")}),define(Re[119],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var $;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})($||(e.ScanError=$={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function M(t,r=!1){let c=0;const f=t.length;let w="",d=0,D=16,L=0;function y(V){let R=0,S=0;for(;R<V;){const O=t.charCodeAt(c);if(O>=48&&O<=57)S=S*16+O-48;else if(O>=65&&O<=70)S=S*16+O-65+10;else if(O>=97&&O<=102)S=S*16+O-97+10;else break;c++,R++}return R<V&&(S=-1),S}function E(V){c=V,w="",d=0,D=16,L=0}function k(){const V=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&b(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&b(t.charCodeAt(c)))for(c++;c<t.length&&b(t.charCodeAt(c));)c++;else return L=3,t.substring(V,c);let R=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&b(t.charCodeAt(c))){for(c++;c<t.length&&b(t.charCodeAt(c));)c++;R=c}else L=3;return t.substring(V,R)}function F(){let V="",R=c;for(;;){if(c>=f){V+=t.substring(R,c),L=2;break}const S=t.charCodeAt(c);if(S===34){V+=t.substring(R,c),c++;break}if(S===92){if(V+=t.substring(R,c),c++,c>=f){L=2;break}switch(t.charCodeAt(c++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const Q=y(4);Q>=0?V+=String.fromCharCode(Q):L=4;break}default:L=5}R=c;continue}if(S>=0&&S<=31)if(g(S)){V+=t.substring(R,c),L=2;break}else L=6;c++}return V}function B(){if(w="",L=0,d=c,c>=f)return d=f,D=17;let V=t.charCodeAt(c);if(m(V)){do c++,w+=String.fromCharCode(V),V=t.charCodeAt(c);while(m(V));return D=15}if(g(V))return c++,w+=String.fromCharCode(V),V===13&&t.charCodeAt(c)===10&&(c++,w+=`
`),D=14;switch(V){case 123:return c++,D=1;case 125:return c++,D=2;case 91:return c++,D=3;case 93:return c++,D=4;case 58:return c++,D=6;case 44:return c++,D=5;case 34:return c++,w=F(),D=10;case 47:{const R=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<f&&!g(t.charCodeAt(c));)c++;return w=t.substring(R,c),D=12}if(t.charCodeAt(c+1)===42){c+=2;const S=f-1;let O=!1;for(;c<S;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,O=!0;break}c++}return O||(c++,L=1),w=t.substring(R,c),D=13}return w+=String.fromCharCode(V),c++,D=16}case 45:if(w+=String.fromCharCode(V),c++,c===f||!b(t.charCodeAt(c)))return D=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=k(),D=11;default:for(;c<f&&ee(V);)c++,V=t.charCodeAt(c);if(d!==c){switch(w=t.substring(d,c),w){case"true":return D=8;case"false":return D=9;case"null":return D=7}return D=16}return w+=String.fromCharCode(V),c++,D=16}}function ee(V){if(m(V)||g(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let V;do V=B();while(V>=12&&V<=15);return V}return{setPosition:E,getPosition:()=>c,scan:r?J:B,getToken:()=>D,getTokenValue:()=>w,getTokenOffset:()=>d,getTokenLength:()=>c-d,getTokenError:()=>L}}e.$9m=M;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,r){const c=[],f=new Object;let w;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function L(y,E,k,F){d.value=y,d.offset=E,d.length=k,d.type=F,d.colonOffset=void 0,w=d}try{a(t,{onObjectBegin:(y,E)=>{if(r<=y)throw f;w=void 0,D=r>y,c.push("")},onObjectProperty:(y,E,k)=>{if(r<E||(L(y,E,k,"property"),c[c.length-1]=y,r<=E+k))throw f},onObjectEnd:(y,E)=>{if(r<=y)throw f;w=void 0,c.pop()},onArrayBegin:(y,E)=>{if(r<=y)throw f;w=void 0,c.push(0)},onArrayEnd:(y,E)=>{if(r<=y)throw f;w=void 0,c.pop()},onLiteralValue:(y,E,k)=>{if(r<E||(L(y,E,k,h(y)),r<=E+k))throw f},onSeparator:(y,E,k)=>{if(r<=E)throw f;if(y===":"&&w&&w.type==="property")w.colonOffset=E,D=!1,w=void 0;else if(y===","){const F=c[c.length-1];typeof F=="number"?c[c.length-1]=F+1:(D=!0,c[c.length-1]=""),w=void 0}}})}catch(y){if(y!==f)throw y}return{path:c,previousNode:w,isAtPropertyKey:D,matches:y=>{let E=0;for(let k=0;E<y.length&&k<c.length;k++)if(y[E]===c[k]||y[E]==="*")E++;else if(y[E]!=="**")return!1;return E===y.length}}}e.$0m=C;function l(t,r=[],c=T.DEFAULT){let f=null,w=[];const d=[];function D(y){Array.isArray(w)?w.push(y):f!==null&&(w[f]=y)}return a(t,{onObjectBegin:()=>{const y={};D(y),d.push(w),w=y,f=null},onObjectProperty:y=>{f=y},onObjectEnd:()=>{w=d.pop()},onArrayBegin:()=>{const y=[];D(y),d.push(w),w=y,f=null},onArrayEnd:()=>{w=d.pop()},onLiteralValue:D,onError:(y,E,k)=>{r.push({error:y,offset:E,length:k})}},c),w[0]}e.$$m=l;function p(t,r=[],c=T.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(y){f.type==="property"&&(f.length=y-f.offset,f=f.parent)}function d(y){return f.children.push(y),y}a(t,{onObjectBegin:y=>{f=d({type:"object",offset:y,length:-1,parent:f,children:[]})},onObjectProperty:(y,E,k)=>{f=d({type:"property",offset:E,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:y,offset:E,length:k,parent:f})},onObjectEnd:(y,E)=>{f.length=y+E-f.offset,f=f.parent,w(y+E)},onArrayBegin:(y,E)=>{f=d({type:"array",offset:y,length:-1,parent:f,children:[]})},onArrayEnd:(y,E)=>{f.length=y+E-f.offset,f=f.parent,w(y+E)},onLiteralValue:(y,E,k)=>{d({type:h(y),offset:E,length:k,parent:f,value:y}),w(E+k)},onSeparator:(y,E,k)=>{f.type==="property"&&(y===":"?f.colonOffset=E:y===","&&w(E))},onError:(y,E,k)=>{r.push({error:y,offset:E,length:k})}},c);const L=f.children[0];return L&&delete L.parent,L}e.$_m=p;function v(t,r){if(!t)return;let c=t;for(const f of r)if(typeof f=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let w=!1;for(const d of c.children)if(Array.isArray(d.children)&&d.children[0].value===f){c=d.children[1],w=!0;break}if(!w)return}else{const w=f;if(c.type!=="array"||w<0||!Array.isArray(c.children)||w>=c.children.length)return;c=c.children[w]}return c}e.$an=v;function n(t){if(!t.parent||!t.parent.children)return[];const r=n(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;r.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&r.push(c)}return r}e.$bn=n;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const r=Object.create(null);for(const c of t.children){const f=c.children[1];f&&(r[c.children[0].value]=o(f))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$cn=o;function i(t,r,c=!1){return r>=t.offset&&r<t.offset+t.length||c&&r===t.offset+t.length}e.$dn=i;function s(t,r,c=!1){if(i(t,r,c)){const f=t.children;if(Array.isArray(f))for(let w=0;w<f.length&&f[w].offset<=r;w++){const d=s(f[w],r,c);if(d)return d}return t}}e.$en=s;function a(t,r,c=T.DEFAULT){const f=M(t,!1);function w(ne){return ne?()=>ne(f.getTokenOffset(),f.getTokenLength()):()=>!0}function d(ne){return ne?Pe=>ne(Pe,f.getTokenOffset(),f.getTokenLength()):()=>!0}const D=w(r.onObjectBegin),L=d(r.onObjectProperty),y=w(r.onObjectEnd),E=w(r.onArrayBegin),k=w(r.onArrayEnd),F=d(r.onLiteralValue),B=d(r.onSeparator),ee=w(r.onComment),J=d(r.onError),V=c&&c.disallowComments,R=c&&c.allowTrailingComma;function S(){for(;;){const ne=f.scan();switch(f.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:V||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(ne){case 12:case 13:V?O(10):ee();break;case 16:O(1);break;case 15:case 14:break;default:return ne}}}function O(ne,Pe=[],le=[]){if(J(ne),Pe.length+le.length>0){let me=f.getToken();for(;me!==17;){if(Pe.indexOf(me)!==-1){S();break}else if(le.indexOf(me)!==-1)break;me=S()}}}function Q(ne){const Pe=f.getTokenValue();return ne?F(Pe):L(Pe),S(),!0}function re(){switch(f.getToken()){case 11:{let ne=0;try{ne=JSON.parse(f.getTokenValue()),typeof ne!="number"&&(O(2),ne=0)}catch{O(2)}F(ne);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return S(),!0}function he(){return f.getToken()!==10?(O(3,[],[2,5]),!1):(Q(!1),f.getToken()===6?(B(":"),S(),$e()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function fe(){D(),S();let ne=!1;for(;f.getToken()!==2&&f.getToken()!==17;){if(f.getToken()===5){if(ne||O(4,[],[]),B(","),S(),f.getToken()===2&&R)break}else ne&&O(6,[],[]);he()||O(4,[],[2,5]),ne=!0}return y(),f.getToken()!==2?O(7,[2],[]):S(),!0}function ue(){E(),S();let ne=!1;for(;f.getToken()!==4&&f.getToken()!==17;){if(f.getToken()===5){if(ne||O(4,[],[]),B(","),S(),f.getToken()===4&&R)break}else ne&&O(6,[],[]);$e()||O(4,[],[4,5]),ne=!0}return k(),f.getToken()!==4?O(8,[4],[]):S(),!0}function $e(){switch(f.getToken()){case 3:return ue();case 1:return fe();case 10:return Q(!0);default:return re()}}return S(),f.getToken()===17?c.allowEmptyContent?!0:(O(4,[],[]),!1):$e()?(f.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.$fn=a;function u(t,r){const c=M(t),f=[];let w,d=0,D;do switch(D=c.getPosition(),w=c.scan(),w){case 12:case 13:case 17:d!==D&&f.push(t.substring(d,D)),r!==void 0&&f.push(c.getTokenValue().replace(/[^\r\n]/g,r)),d=c.getPosition();break}while(w!==17);return f.join("")}e.$gn=u;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$hn=h}),function(ie,e){typeof define=="function"&&define.amd?define(Re[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(Ee,ce){for(var _=0;_<ce.length;_++){var H=ce[_];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(Ee,H.key,H)}}function $(Ee,ce,_){return ce&&e(Ee.prototype,ce),_&&e(Ee,_),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function P(Ee,ce){if(Ee){if(typeof Ee=="string")return I(Ee,ce);var _=Object.prototype.toString.call(Ee).slice(8,-1);if(_==="Object"&&Ee.constructor&&(_=Ee.constructor.name),_==="Map"||_==="Set")return Array.from(Ee);if(_==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_))return I(Ee,ce)}}function I(Ee,ce){(ce==null||ce>Ee.length)&&(ce=Ee.length);for(var _=0,H=new Array(ce);_<ce;_++)H[_]=Ee[_];return H}function T(Ee,ce){var _=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(_)return(_=_.call(Ee)).next.bind(_);if(Array.isArray(Ee)||(_=P(Ee))||ce&&Ee&&typeof Ee.length=="number"){_&&(Ee=_);var H=0;return function(){return H>=Ee.length?{done:!0}:{done:!1,value:Ee[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=M();function m(Ee){ie.defaults=Ee}var g=/[&<>"']/,b=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return l[ce]};function v(Ee,ce){if(ce){if(g.test(Ee))return Ee.replace(b,p)}else if(A.test(Ee))return Ee.replace(C,p);return Ee}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ee){return Ee.replace(n,function(ce,_){return _=_.toLowerCase(),_==="colon"?":":_.charAt(0)==="#"?_.charAt(1)==="x"?String.fromCharCode(parseInt(_.substring(2),16)):String.fromCharCode(+_.substring(1)):""})}var i=/(^|[^\[])\^/g;function s(Ee,ce){Ee=typeof Ee=="string"?Ee:Ee.source,ce=ce||"";var _={replace:function(te,we){return we=we.source||we,we=we.replace(i,"$1"),Ee=Ee.replace(te,we),_},getRegex:function(){return new RegExp(Ee,ce)}};return _}var a=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ee,ce,_){if(Ee){var H;try{H=decodeURIComponent(o(_)).replace(a,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}ce&&!u.test(_)&&(_=w(ce,_));try{_=encodeURI(_).replace(/%25/g,"%")}catch{return null}return _}var t={},r=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,f=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(Ee,ce){t[" "+Ee]||(r.test(Ee)?t[" "+Ee]=Ee+"/":t[" "+Ee]=y(Ee,"/",!0)),Ee=t[" "+Ee];var _=Ee.indexOf(":")===-1;return ce.substring(0,2)==="//"?_?ce:Ee.replace(c,"$1")+ce:ce.charAt(0)==="/"?_?ce:Ee.replace(f,"$1")+ce:Ee+ce}var d={exec:function(){}};function D(Ee){for(var ce=1,_,H;ce<arguments.length;ce++){_=arguments[ce];for(H in _)Object.prototype.hasOwnProperty.call(_,H)&&(Ee[H]=_[H])}return Ee}function L(Ee,ce){var _=Ee.replace(/\|/g,function(we,be,Fe){for(var pe=!1,Se=be;--Se>=0&&Fe[Se]==="\\";)pe=!pe;return pe?"|":" |"}),H=_.split(/ \|/),te=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>ce)H.splice(ce);else for(;H.length<ce;)H.push("");for(;te<H.length;te++)H[te]=H[te].trim().replace(/\\\|/g,"|");return H}function y(Ee,ce,_){var H=Ee.length;if(H===0)return"";for(var te=0;te<H;){var we=Ee.charAt(H-te-1);if(we===ce&&!_)te++;else if(we!==ce&&_)te++;else break}return Ee.slice(0,H-te)}function E(Ee,ce){if(Ee.indexOf(ce[1])===-1)return-1;for(var _=Ee.length,H=0,te=0;te<_;te++)if(Ee[te]==="\\")te++;else if(Ee[te]===ce[0])H++;else if(Ee[te]===ce[1]&&(H--,H<0))return te;return-1}function k(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Ee,ce){if(ce<1)return"";for(var _="";ce>1;)ce&1&&(_+=Ee),ce>>=1,Ee+=Ee;return _+Ee}function B(Ee,ce,_,H){var te=ce.href,we=ce.title?v(ce.title):null,be=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){H.state.inLink=!0;var Fe={type:"link",raw:_,href:te,title:we,text:be,tokens:H.inlineTokens(be)};return H.state.inLink=!1,Fe}return{type:"image",raw:_,href:te,title:we,text:v(be)}}function ee(Ee,ce){var _=Ee.match(/^(\s+)(?:```)/);if(_===null)return ce;var H=_[1];return ce.split(`
`).map(function(te){var we=te.match(/^\s+/);if(we===null)return te;var be=we[0];return be.length>=H.length?te.slice(H.length):te}).join(`
`)}var J=function(){function Ee(_){this.options=_||ie.defaults}var ce=Ee.prototype;return ce.space=function(H){var te=this.rules.block.newline.exec(H);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ce.code=function(H){var te=this.rules.block.code.exec(H);if(te){var we=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?we:y(we,`
`)}}},ce.fences=function(H){var te=this.rules.block.fences.exec(H);if(te){var we=te[0],be=ee(we,te[3]||"");return{type:"code",raw:we,lang:te[2]?te[2].trim():te[2],text:be}}},ce.heading=function(H){var te=this.rules.block.heading.exec(H);if(te){var we=te[2].trim();if(/#$/.test(we)){var be=y(we,"#");(this.options.pedantic||!be||/ $/.test(be))&&(we=be.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:we,tokens:this.lexer.inline(we)}}},ce.hr=function(H){var te=this.rules.block.hr.exec(H);if(te)return{type:"hr",raw:te[0]}},ce.blockquote=function(H){var te=this.rules.block.blockquote.exec(H);if(te){var we=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},ce.list=function(H){var te=this.rules.block.list.exec(H);if(te){var we,be,Fe,pe,Se,N,q,G,z,Z,X,De,Te=te[1].trim(),qe=Te.length>1,We={type:"list",raw:"",ordered:qe,start:qe?+Te.slice(0,-1):"",loose:!1,items:[]};Te=qe?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=qe?Te:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(De=!1,!(!(te=Ye.exec(H))||this.rules.block.hr.test(H)));){if(we=te[0],H=H.substring(we.length),G=te[2].split(`
`,1)[0],z=H.split(`
`,1)[0],this.options.pedantic?(pe=2,X=G.trimLeft()):(pe=te[2].search(/[^ ]/),pe=pe>4?1:pe,X=G.slice(pe),pe+=te[1].length),N=!1,!G&&/^ *$/.test(z)&&(we+=z+`
`,H=H.substring(z.length+1),De=!0),!De)for(var ot=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),ct=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");H&&(Z=H.split(`
`,1)[0],G=Z,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(G)||ct.test(G)||ot.test(G)||rt.test(H)));){if(G.search(/[^ ]/)>=pe||!G.trim())X+=`
`+G.slice(pe);else if(!N)X+=`
`+G;else break;!N&&!G.trim()&&(N=!0),we+=Z+`
`,H=H.substring(Z.length+1)}We.loose||(q?We.loose=!0:/\n *\n *$/.test(we)&&(q=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(X),be&&(Fe=be[0]!=="[ ] ",X=X.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:we,task:!!be,checked:Fe,loose:!1,text:X}),We.raw+=we}We.items[We.items.length-1].raw=we.trimRight(),We.items[We.items.length-1].text=X.trimRight(),We.raw=We.raw.trimRight();var ut=We.items.length;for(Se=0;Se<ut;Se++){this.lexer.state.top=!1,We.items[Se].tokens=this.lexer.blockTokens(We.items[Se].text,[]);var Ue=We.items[Se].tokens.filter(function(Y){return Y.type==="space"}),vt=Ue.every(function(Y){for(var x=Y.raw.split(""),ye=0,Ve=T(x),Ze;!(Ze=Ve()).done;){var nt=Ze.value;if(nt===`
`&&(ye+=1),ye>1)return!0}return!1});!We.loose&&Ue.length&&vt&&(We.loose=!0,We.items[Se].loose=!0)}return We}},ce.html=function(H){var te=this.rules.block.html.exec(H);if(te){var we={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]);we.type="paragraph",we.text=be,we.tokens=this.lexer.inline(be)}return we}},ce.def=function(H){var te=this.rules.block.def.exec(H);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var we=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:te[0],href:te[2],title:te[3]}}},ce.table=function(H){var te=this.rules.block.table.exec(H);if(te){var we={type:"table",header:L(te[1]).map(function(q){return{text:q}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=te[0];var be=we.align.length,Fe,pe,Se,N;for(Fe=0;Fe<be;Fe++)/^ *-+: *$/.test(we.align[Fe])?we.align[Fe]="right":/^ *:-+: *$/.test(we.align[Fe])?we.align[Fe]="center":/^ *:-+ *$/.test(we.align[Fe])?we.align[Fe]="left":we.align[Fe]=null;for(be=we.rows.length,Fe=0;Fe<be;Fe++)we.rows[Fe]=L(we.rows[Fe],we.header.length).map(function(q){return{text:q}});for(be=we.header.length,pe=0;pe<be;pe++)we.header[pe].tokens=this.lexer.inline(we.header[pe].text);for(be=we.rows.length,pe=0;pe<be;pe++)for(N=we.rows[pe],Se=0;Se<N.length;Se++)N[Se].tokens=this.lexer.inline(N[Se].text);return we}}},ce.lheading=function(H){var te=this.rules.block.lheading.exec(H);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ce.paragraph=function(H){var te=this.rules.block.paragraph.exec(H);if(te){var we=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:we,tokens:this.lexer.inline(we)}}},ce.text=function(H){var te=this.rules.block.text.exec(H);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ce.escape=function(H){var te=this.rules.inline.escape.exec(H);if(te)return{type:"escape",raw:te[0],text:v(te[1])}},ce.tag=function(H){var te=this.rules.inline.tag.exec(H);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]):te[0]}},ce.link=function(H){var te=this.rules.inline.link.exec(H);if(te){var we=te[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var be=y(we.slice(0,-1),"\\");if((we.length-be.length)%2===0)return}else{var Fe=E(te[2],"()");if(Fe>-1){var pe=te[0].indexOf("!")===0?5:4,Se=pe+te[1].length+Fe;te[2]=te[2].substring(0,Fe),te[0]=te[0].substring(0,Se).trim(),te[3]=""}}var N=te[2],q="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(N);G&&(N=G[1],q=G[3])}else q=te[3]?te[3].slice(1,-1):"";return N=N.trim(),/^</.test(N)&&(this.options.pedantic&&!/>$/.test(we)?N=N.slice(1):N=N.slice(1,-1)),B(te,{href:N&&N.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ce.reflink=function(H,te){var we;if((we=this.rules.inline.reflink.exec(H))||(we=this.rules.inline.nolink.exec(H))){var be=(we[2]||we[1]).replace(/\s+/g," ");if(be=te[be.toLowerCase()],!be||!be.href){var Fe=we[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return B(we,be,we[0],this.lexer)}},ce.emStrong=function(H,te,we){we===void 0&&(we="");var be=this.rules.inline.emStrong.lDelim.exec(H);if(be&&!(be[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=be[1]||be[2]||"";if(!Fe||Fe&&(we===""||this.rules.inline.punctuation.exec(we))){var pe=be[0].length-1,Se,N,q=pe,G=0,z=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,te=te.slice(-1*H.length+pe);(be=z.exec(te))!=null;)if(Se=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Se){if(N=Se.length,be[3]||be[4]){q+=N;continue}else if((be[5]||be[6])&&pe%3&&!((pe+N)%3)){G+=N;continue}if(q-=N,!(q>0)){if(N=Math.min(N,N+q+G),Math.min(pe,N)%2){var Z=H.slice(1,pe+be.index+N);return{type:"em",raw:H.slice(0,pe+be.index+N+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}var X=H.slice(2,pe+be.index+N-1);return{type:"strong",raw:H.slice(0,pe+be.index+N+1),text:X,tokens:this.lexer.inlineTokens(X)}}}}}},ce.codespan=function(H){var te=this.rules.inline.code.exec(H);if(te){var we=te[2].replace(/\n/g," "),be=/[^ ]/.test(we),Fe=/^ /.test(we)&&/ $/.test(we);return be&&Fe&&(we=we.substring(1,we.length-1)),we=v(we,!0),{type:"codespan",raw:te[0],text:we}}},ce.br=function(H){var te=this.rules.inline.br.exec(H);if(te)return{type:"br",raw:te[0]}},ce.del=function(H){var te=this.rules.inline.del.exec(H);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ce.autolink=function(H,te){var we=this.rules.inline.autolink.exec(H);if(we){var be,Fe;return we[2]==="@"?(be=v(this.options.mangle?te(we[1]):we[1]),Fe="mailto:"+be):(be=v(we[1]),Fe=be),{type:"link",raw:we[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},ce.url=function(H,te){var we;if(we=this.rules.inline.url.exec(H)){var be,Fe;if(we[2]==="@")be=v(this.options.mangle?te(we[0]):we[0]),Fe="mailto:"+be;else{var pe;do pe=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(pe!==we[0]);be=v(we[0]),we[1]==="www."?Fe="http://"+be:Fe=be}return{type:"link",raw:we[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},ce.inlineText=function(H,te){var we=this.rules.inline.text.exec(H);if(we){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):v(we[0]):we[0]:be=v(this.options.smartypants?te(we[0]):we[0]),{type:"text",raw:we[0],text:be}}},Ee}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=s(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=s(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=s(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=s(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=s(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=s(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=D({},V),V.gfm=D({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=s(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=s(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=D({},V.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:s(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=s(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=s(V._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=s(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=s(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=s(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=s(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=s(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=s(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=s(R.reflink).replace("label",R._label).replace("ref",V._label).getRegex(),R.nolink=s(R.nolink).replace("ref",V._label).getRegex(),R.reflinkSearch=s(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=D({},R),R.pedantic=D({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=D({},R.normal,{escape:s(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=s(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=D({},R.gfm,{br:s(R.br).replace("{2,}","*").getRegex(),text:s(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function S(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function O(Ee){var ce="",_,H,te=Ee.length;for(_=0;_<te;_++)H=Ee.charCodeAt(_),Math.random()>.5&&(H="x"+H.toString(16)),ce+="&#"+H+";";return ce}var Q=function(){function Ee(_){this.tokens=[],this.tokens.links=Object.create(null),this.options=_||ie.defaults,this.options.tokenizer=this.options.tokenizer||new J,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:V.normal,inline:R.normal};this.options.pedantic?(H.block=V.pedantic,H.inline=R.pedantic):this.options.gfm&&(H.block=V.gfm,this.options.breaks?H.inline=R.breaks:H.inline=R.gfm),this.tokenizer.rules=H}Ee.lex=function(H,te){var we=new Ee(te);return we.lex(H)},Ee.lexInline=function(H,te){var we=new Ee(te);return we.inlineTokens(H)};var ce=Ee.prototype;return ce.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ce.blockTokens=function(H,te){var we=this;te===void 0&&(te=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(q,G,z){return G+"    ".repeat(z.length)});for(var be,Fe,pe,Se;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(be=q.call({lexer:we},H,te))?(H=H.substring(be.raw.length),te.push(be),!0):!1}))){if(be=this.tokenizer.space(H)){H=H.substring(be.raw.length),be.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(be);continue}if(be=this.tokenizer.code(H)){H=H.substring(be.raw.length),Fe=te[te.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):te.push(be);continue}if(be=this.tokenizer.fences(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.heading(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.hr(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.blockquote(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.list(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.html(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.def(H)){H=H.substring(be.raw.length),Fe=te[te.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.lheading(H)){H=H.substring(be.raw.length),te.push(be);continue}if(pe=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,G=H.slice(1),z=void 0;we.options.extensions.startBlock.forEach(function(Z){z=Z.call({lexer:this},G),typeof z=="number"&&z>=0&&(q=Math.min(q,z))}),q<1/0&&q>=0&&(pe=H.substring(0,q+1))}(),this.state.top&&(be=this.tokenizer.paragraph(pe))){Fe=te[te.length-1],Se&&Fe.type==="paragraph"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):te.push(be),Se=pe.length!==H.length,H=H.substring(be.raw.length);continue}if(be=this.tokenizer.text(H)){H=H.substring(be.raw.length),Fe=te[te.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):te.push(be);continue}if(H){var N="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(N);break}else throw new Error(N)}}return this.state.top=!0,te},ce.inline=function(H,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:H,tokens:te}),te},ce.inlineTokens=function(H,te){var we=this;te===void 0&&(te=[]);var be,Fe,pe,Se=H,N,q,G;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(N=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)z.includes(N[0].slice(N[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,N.index)+"["+F("a",N[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(N=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,N.index)+"["+F("a",N[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(N=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,N.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(q||(G=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(be=X.call({lexer:we},H,te))?(H=H.substring(be.raw.length),te.push(be),!0):!1}))){if(be=this.tokenizer.escape(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.tag(H)){H=H.substring(be.raw.length),Fe=te[te.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):te.push(be);continue}if(be=this.tokenizer.link(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(be.raw.length),Fe=te[te.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):te.push(be);continue}if(be=this.tokenizer.emStrong(H,Se,G)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.codespan(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.br(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.del(H)){H=H.substring(be.raw.length),te.push(be);continue}if(be=this.tokenizer.autolink(H,O)){H=H.substring(be.raw.length),te.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(H,O))){H=H.substring(be.raw.length),te.push(be);continue}if(pe=H,this.options.extensions&&this.options.extensions.startInline&&function(){var X=1/0,De=H.slice(1),Te=void 0;we.options.extensions.startInline.forEach(function(qe){Te=qe.call({lexer:this},De),typeof Te=="number"&&Te>=0&&(X=Math.min(X,Te))}),X<1/0&&X>=0&&(pe=H.substring(0,X+1))}(),be=this.tokenizer.inlineText(pe,S)){H=H.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(G=be.raw.slice(-1)),q=!0,Fe=te[te.length-1],Fe&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):te.push(be);continue}if(H){var Z="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return te},$(Ee,null,[{key:"rules",get:function(){return{block:V,inline:R}}}]),Ee}(),re=function(){function Ee(_){this.options=_||ie.defaults}var ce=Ee.prototype;return ce.code=function(H,te,we){var be=(te||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(H,be);Fe!=null&&Fe!==H&&(we=!0,H=Fe)}return H=H.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+v(be,!0)+'">'+(we?H:v(H,!0))+`</code></pre>
`:"<pre><code>"+(we?H:v(H,!0))+`</code></pre>
`},ce.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},ce.html=function(H){return H},ce.heading=function(H,te,we,be){if(this.options.headerIds){var Fe=this.options.headerPrefix+be.slug(we);return"<h"+te+' id="'+Fe+'">'+H+"</h"+te+`>
`}return"<h"+te+">"+H+"</h"+te+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(H,te,we){var be=te?"ol":"ul",Fe=te&&we!==1?' start="'+we+'"':"";return"<"+be+Fe+`>
`+H+"</"+be+`>
`},ce.listitem=function(H){return"<li>"+H+`</li>
`},ce.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(H){return"<p>"+H+`</p>
`},ce.table=function(H,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+te+`</table>
`},ce.tablerow=function(H){return`<tr>
`+H+`</tr>
`},ce.tablecell=function(H,te){var we=te.header?"th":"td",be=te.align?"<"+we+' align="'+te.align+'">':"<"+we+">";return be+H+("</"+we+`>
`)},ce.strong=function(H){return"<strong>"+H+"</strong>"},ce.em=function(H){return"<em>"+H+"</em>"},ce.codespan=function(H){return"<code>"+H+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(H){return"<del>"+H+"</del>"},ce.link=function(H,te,we){if(H=h(this.options.sanitize,this.options.baseUrl,H),H===null)return we;var be='<a href="'+v(H)+'"';return te&&(be+=' title="'+te+'"'),be+=">"+we+"</a>",be},ce.image=function(H,te,we){if(H=h(this.options.sanitize,this.options.baseUrl,H),H===null)return we;var be='<img src="'+H+'" alt="'+we+'"';return te&&(be+=' title="'+te+'"'),be+=this.options.xhtml?"/>":">",be},ce.text=function(H){return H},Ee}(),he=function(){function Ee(){}var ce=Ee.prototype;return ce.strong=function(H){return H},ce.em=function(H){return H},ce.codespan=function(H){return H},ce.del=function(H){return H},ce.html=function(H){return H},ce.text=function(H){return H},ce.link=function(H,te,we){return""+we},ce.image=function(H,te,we){return""+we},ce.br=function(){return""},Ee}(),fe=function(){function Ee(){this.seen={}}var ce=Ee.prototype;return ce.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(H,te){var we=H,be=0;if(this.seen.hasOwnProperty(we)){be=this.seen[H];do be++,we=H+"-"+be;while(this.seen.hasOwnProperty(we))}return te||(this.seen[H]=be,this.seen[we]=0),we},ce.slug=function(H,te){te===void 0&&(te={});var we=this.serialize(H);return this.getNextSafeSlug(we,te.dryrun)},Ee}(),ue=function(){function Ee(_){this.options=_||ie.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new he,this.slugger=new fe}Ee.parse=function(H,te){var we=new Ee(te);return we.parse(H)},Ee.parseInline=function(H,te){var we=new Ee(te);return we.parseInline(H)};var ce=Ee.prototype;return ce.parse=function(H,te){te===void 0&&(te=!0);var we="",be,Fe,pe,Se,N,q,G,z,Z,X,De,Te,qe,We,Ye,ot,rt,it,ct,ut=H.length;for(be=0;be<ut;be++){if(X=H[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(ct=this.options.extensions.renderers[X.type].call({parser:this},X),ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){we+=ct||"";continue}switch(X.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(X.tokens),X.depth,o(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(z="",G="",Se=X.header.length,Fe=0;Fe<Se;Fe++)G+=this.renderer.tablecell(this.parseInline(X.header[Fe].tokens),{header:!0,align:X.align[Fe]});for(z+=this.renderer.tablerow(G),Z="",Se=X.rows.length,Fe=0;Fe<Se;Fe++){for(q=X.rows[Fe],G="",N=q.length,pe=0;pe<N;pe++)G+=this.renderer.tablecell(this.parseInline(q[pe].tokens),{header:!1,align:X.align[pe]});Z+=this.renderer.tablerow(G)}we+=this.renderer.table(z,Z);continue}case"blockquote":{Z=this.parse(X.tokens),we+=this.renderer.blockquote(Z);continue}case"list":{for(De=X.ordered,Te=X.start,qe=X.loose,Se=X.items.length,Z="",Fe=0;Fe<Se;Fe++)Ye=X.items[Fe],ot=Ye.checked,rt=Ye.task,We="",Ye.task&&(it=this.renderer.checkbox(ot),qe?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=it+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=it+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:it}):We+=it),We+=this.parse(Ye.tokens,qe),Z+=this.renderer.listitem(We,rt,ot);we+=this.renderer.list(Z,De,Te);continue}case"html":{we+=this.renderer.html(X.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(Z=X.tokens?this.parseInline(X.tokens):X.text;be+1<ut&&H[be+1].type==="text";)X=H[++be],Z+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);we+=te?this.renderer.paragraph(Z):Z;continue}default:{var Ue='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(Ue);return}else throw new Error(Ue)}}}return we},ce.parseInline=function(H,te){te=te||this.renderer;var we="",be,Fe,pe,Se=H.length;for(be=0;be<Se;be++){if(Fe=H[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(pe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){we+=pe||"";continue}switch(Fe.type){case"escape":{we+=te.text(Fe.text);break}case"html":{we+=te.html(Fe.text);break}case"link":{we+=te.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,te));break}case"image":{we+=te.image(Fe.href,Fe.title,Fe.text);break}case"strong":{we+=te.strong(this.parseInline(Fe.tokens,te));break}case"em":{we+=te.em(this.parseInline(Fe.tokens,te));break}case"codespan":{we+=te.codespan(Fe.text);break}case"br":{we+=te.br();break}case"del":{we+=te.del(this.parseInline(Fe.tokens,te));break}case"text":{we+=te.text(Fe.text);break}default:{var N='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(N);return}else throw new Error(N)}}}return we},Ee}();function $e(Ee,ce,_){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof ce=="function"&&(_=ce,ce=null),ce=D({},$e.defaults,ce||{}),k(ce),_){var H=ce.highlight,te;try{te=Q.lex(Ee,ce)}catch(Se){return _(Se)}var we=function(N){var q;if(!N)try{ce.walkTokens&&$e.walkTokens(te,ce.walkTokens),q=ue.parse(te,ce)}catch(G){N=G}return ce.highlight=H,N?_(N):_(null,q)};if(!H||H.length<3||(delete ce.highlight,!te.length))return we();var be=0;$e.walkTokens(te,function(Se){Se.type==="code"&&(be++,setTimeout(function(){H(Se.text,Se.lang,function(N,q){if(N)return we(N);q!=null&&q!==Se.text&&(Se.text=q,Se.escaped=!0),be--,be===0&&we()})},0))}),be===0&&we();return}function Fe(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(Se.message+"",!0)+"</pre>";throw Se}try{var pe=Q.lex(Ee,ce);if(ce.walkTokens){if(ce.async)return Promise.all($e.walkTokens(pe,ce.walkTokens)).then(function(){return ue.parse(pe,ce)}).catch(Fe);$e.walkTokens(pe,ce.walkTokens)}return ue.parse(pe,ce)}catch(Se){Fe(Se)}}$e.options=$e.setOptions=function(Ee){return D($e.defaults,Ee),m($e.defaults),$e},$e.getDefaults=M,$e.defaults=ie.defaults,$e.use=function(){for(var Ee=arguments.length,ce=new Array(Ee),_=0;_<Ee;_++)ce[_]=arguments[_];var H=D.apply(void 0,[{}].concat(ce)),te=$e.defaults.extensions||{renderers:{},childTokens:{}},we;ce.forEach(function(be){if(be.extensions&&(we=!0,be.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Se=te.renderers?te.renderers[pe.name]:null;Se?te.renderers[pe.name]=function(){for(var N=arguments.length,q=new Array(N),G=0;G<N;G++)q[G]=arguments[G];var z=pe.renderer.apply(this,q);return z===!1&&(z=Se.apply(this,q)),z}:te.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[pe.level]?te[pe.level].unshift(pe.tokenizer):te[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?te.startBlock?te.startBlock.push(pe.start):te.startBlock=[pe.start]:pe.level==="inline"&&(te.startInline?te.startInline.push(pe.start):te.startInline=[pe.start]))}pe.childTokens&&(te.childTokens[pe.name]=pe.childTokens)})),be.renderer&&function(){var pe=$e.defaults.renderer||new re,Se=function(G){var z=pe[G];pe[G]=function(){for(var Z=arguments.length,X=new Array(Z),De=0;De<Z;De++)X[De]=arguments[De];var Te=be.renderer[G].apply(pe,X);return Te===!1&&(Te=z.apply(pe,X)),Te}};for(var N in be.renderer)Se(N);H.renderer=pe}(),be.tokenizer&&function(){var pe=$e.defaults.tokenizer||new J,Se=function(G){var z=pe[G];pe[G]=function(){for(var Z=arguments.length,X=new Array(Z),De=0;De<Z;De++)X[De]=arguments[De];var Te=be.tokenizer[G].apply(pe,X);return Te===!1&&(Te=z.apply(pe,X)),Te}};for(var N in be.tokenizer)Se(N);H.tokenizer=pe}(),be.walkTokens){var Fe=$e.defaults.walkTokens;H.walkTokens=function(pe){var Se=[];return Se.push(be.walkTokens.call(this,pe)),Fe&&(Se=Se.concat(Fe.call(this,pe))),Se}}we&&(H.extensions=te),$e.setOptions(H)})},$e.walkTokens=function(Ee,ce){for(var _=[],H=function(){var Fe=we.value;switch(_=_.concat(ce.call($e,Fe)),Fe.type){case"table":{for(var pe=T(Fe.header),Se;!(Se=pe()).done;){var N=Se.value;_=_.concat($e.walkTokens(N.tokens,ce))}for(var q=T(Fe.rows),G;!(G=q()).done;)for(var z=G.value,Z=T(z),X;!(X=Z()).done;){var De=X.value;_=_.concat($e.walkTokens(De.tokens,ce))}break}case"list":{_=_.concat($e.walkTokens(Fe.items,ce));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Fe.type]?$e.defaults.extensions.childTokens[Fe.type].forEach(function(Te){_=_.concat($e.walkTokens(Fe[Te],ce))}):Fe.tokens&&(_=_.concat($e.walkTokens(Fe.tokens,ce)))}},te=T(Ee),we;!(we=te()).done;)H();return _},$e.parseInline=function(Ee,ce){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");ce=D({},$e.defaults,ce||{}),k(ce);try{var _=Q.lexInline(Ee,ce);return ce.walkTokens&&$e.walkTokens(_,ce.walkTokens),ue.parseInline(_,ce)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(H.message+"",!0)+"</pre>";throw H}},$e.Parser=ue,$e.parser=ue.parse,$e.Renderer=re,$e.TextRenderer=he,$e.Lexer=Q,$e.lexer=Q.lex,$e.Tokenizer=J,$e.Slugger=fe,$e.parse=$e;var ne=$e.options,Pe=$e.setOptions,le=$e.use,me=$e.walkTokens,W=$e.parseInline,ae=$e,de=ue.parse,ke=Q.lex;ie.Lexer=Q,ie.Parser=ue,ie.Renderer=re,ie.Slugger=fe,ie.TextRenderer=he,ie.Tokenizer=J,ie.getDefaults=M,ie.lexer=ke,ie.marked=$e,ie.options=ne,ie.parse=ae,ie.parseInline=W,ie.parser=de,ie.setOptions=Pe,ie.use=le,ie.walkTokens=me,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Re[121],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0;function $(n){const o=T(n);if(o&&o.length>0)return new Uint32Array(o)}e.$Nj=$;let P=0;const I=new Uint32Array(10);function T(n){if(P=0,M(n,C,4352),P>0||(M(n,l,4449),P>0)||(M(n,p,4520),P>0)||(M(n,v,12593),P))return I.subarray(0,P);if(n>=44032&&n<=55203){const o=n-44032,i=o%588,s=Math.floor(o/588),a=Math.floor(i/28),u=i%28-1;if(s<C.length?M(s,C,0):4352+s-12593<v.length&&M(4352+s,v,12593),a<l.length?M(a,l,0):4449+a-12593<v.length&&M(4449+a-12593,v,12593),u>=0&&(u<p.length?M(u,p,0):4520+u-12593<v.length&&M(4520+u-12593,v,12593)),P>0)return I.subarray(0,P)}}function M(n,o,i){n>=i&&n<i+o.length&&m(o[n-i])}function m(n){n!==0&&(I[P++]=n&255,n>>8&&(I[P++]=n>>8&255),n>>16&&(I[P++]=n>>16&255))}var g;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var b;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(b||(b={}));var A;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(A||(A={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[122],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.rot=e.$3l=void 0;function $(m,g,b){return Math.min(Math.max(m,g),b)}e.$3l=$;function P(m,g){return(g+m%g)%g}e.rot=P;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$5l=I;class T{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$6l=T;class M{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const b=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$7l=M}),function(){function ie(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function M(g){T.push(g,Date.now())}function m(){const g=[];for(let b=0;b<T.length;b+=2)g.push({name:T[b],startTime:T[b+1]});return g}return{mark:M,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const M of performance.getEntriesByType("mark"))T.push({name:M.name,startTime:Math.round(I+M.startTime)});return T}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function $(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return $(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=$(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=$(P))}(),define(Re[123],Ae([1,0,39,19]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=void 0;const I=new $.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),T=new $.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new $.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(L,y,E=!1){const k=L||"",F=y||"",B=I.value.collator.compare(k,F);return I.value.collatorIsNumeric&&B===0&&k!==F?k<F?-1:1:B}e.$vq=m;function g(L,y){const E=T.value.collator;return L=L||"",y=y||"",u(E,L,y)}e.$wq=g;function b(L,y){const E=T.value.collator;return L=L||"",y=y||"",c(L,y)||u(E,L,y)}e.$xq=b;function A(L,y){const E=T.value.collator;return L=L||"",y=y||"",r(L,y)||u(E,L,y)}e.$yq=A;function C(L,y){return L=L||"",y=y||"",L===y?0:L<y?-1:1}e.$zq=C;function l(L,y){const[E,k]=s(L),[F,B]=s(y);let ee=I.value.collator.compare(k,B);if(ee===0){if(I.value.collatorIsNumeric&&k!==B)return k<B?-1:1;if(ee=I.value.collator.compare(E,F),I.value.collatorIsNumeric&&ee===0&&E!==F)return E<F?-1:1}return ee}e.$Aq=l;function p(L,y){L=L||"",y=y||"";const E=a(L),k=a(y),F=T.value.collator,B=M.value.collator;return u(B,E,k)||u(F,L,y)}e.$Bq=p;function v(L,y){L=L||"",y=y||"";const E=a(L),k=a(y),F=T.value.collator,B=M.value.collator;return u(B,E,k)||c(L,y)||u(F,L,y)}e.$Cq=v;function n(L,y){L=L||"",y=y||"";const E=a(L),k=a(y),F=T.value.collator,B=M.value.collator;return u(B,E,k)||r(L,y)||u(F,L,y)}e.$Dq=n;function o(L,y){L=L||"",y=y||"";const E=a(L).toLowerCase(),k=a(y).toLowerCase();return E!==k?E<k?-1:1:L!==y?L<y?-1:1:0}e.$Eq=o;const i=/^(.*?)(\.([^.]*))?$/;function s(L,y=!1){const E=L?i.exec(L):[];let k=[E&&E[1]||"",E&&E[3]||""];return y&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function a(L){const y=L?i.exec(L):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function u(L,y,E){const k=L.compare(y,E);return k!==0?k:y.length!==E.length?y.length<E.length?-1:1:0}function h(L){const y=L.charAt(0);return y.toLocaleUpperCase()!==y}function t(L){const y=L.charAt(0);return y.toLocaleLowerCase()!==y}function r(L,y){return h(L)&&t(y)?-1:t(L)&&h(y)?1:0}function c(L,y){return t(L)&&h(y)?-1:h(L)&&t(y)?1:0}function f(L,y,E=!1){return E||(L=L&&L.toLowerCase(),y=y&&y.toLowerCase()),L===y?0:L<y?-1:1}function w(L,y,E=!1){const k=L.split(P.sep),F=y.split(P.sep),B=k.length-1,ee=F.length-1;let J,V;for(let R=0;;R++){if(J=B===R,V=ee===R,J&&V)return m(k[R],F[R],E);if(J)return-1;if(V)return 1;const S=f(k[R],F[R],E);if(S!==0)return S}}e.$Fq=w;function d(L,y,E){const k=L.toLowerCase(),F=y.toLowerCase(),B=D(L,y,E);if(B)return B;const ee=k.endsWith(E),J=F.endsWith(E);if(ee!==J)return ee?-1:1;const V=m(k,F);return V!==0?V:k.localeCompare(F)}e.$Gq=d;function D(L,y,E){const k=L.toLowerCase(),F=y.toLowerCase(),B=k.startsWith(E),ee=F.startsWith(E);if(B!==ee)return B?-1:1;if(B&&ee){if(k.length<F.length)return-1;if(k.length>F.length)return 1}return 0}e.$Hq=D}),define(Re[67],Ae([1,0,19]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=e.$4r=void 0,e.$4r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(A){const C=(0,$.$oc)(A),l=P[C.toLowerCase()];return l!==void 0?l:M(A)}e.$5r=T;function M(A){const C=(0,$.$oc)(A);return I[C.toLowerCase()]}e.$6r=M;function m(A){for(const C in I)if(I[C]===A)return C}e.$7r=m;const g=/^(.+)\/(.+?)(;.+)?$/;function b(A,C){const l=g.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:C?void 0:A}e.$8r=b}),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var $=e();for(var P in $)(typeof exports=="object"?exports:ie)[P]=$[P]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function $(P){if(e[P])return e[P].exports;var I=e[P]={i:P,l:!1,exports:{}};return ie[P].call(I.exports,I,I.exports,$),I.l=!0,I.exports}return $.m=ie,$.c=e,$.d=function(P,I,T){$.o(P,I)||Object.defineProperty(P,I,{enumerable:!0,get:T})},$.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},$.t=function(P,I){if(1&I&&(P=$(P)),8&I||4&I&&typeof P=="object"&&P&&P.__esModule)return P;var T=Object.create(null);if($.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:P}),2&I&&typeof P!="string")for(var M in P)$.d(T,M,function(m){return P[m]}.bind(null,M));return T},$.n=function(P){var I=P&&P.__esModule?function(){return P.default}:function(){return P};return $.d(I,"a",I),I},$.o=function(P,I){return Object.prototype.hasOwnProperty.call(P,I)},$.p="",$($.s=0)}([function(ie,e,$){(function(P){var I;e=ie.exports=le,I=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],g=e.src=[],b=0,A=b++;g[A]="0|[1-9]\\d*";var C=b++;g[C]="[0-9]+";var l=b++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=b++;g[p]="("+g[A]+")\\.("+g[A]+")\\.("+g[A]+")";var v=b++;g[v]="("+g[C]+")\\.("+g[C]+")\\.("+g[C]+")";var n=b++;g[n]="(?:"+g[A]+"|"+g[l]+")";var o=b++;g[o]="(?:"+g[C]+"|"+g[l]+")";var i=b++;g[i]="(?:-("+g[n]+"(?:\\."+g[n]+")*))";var s=b++;g[s]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var a=b++;g[a]="[0-9A-Za-z-]+";var u=b++;g[u]="(?:\\+("+g[a]+"(?:\\."+g[a]+")*))";var h=b++,t="v?"+g[p]+g[i]+"?"+g[u]+"?";g[h]="^"+t+"$";var r="[v=\\s]*"+g[v]+g[s]+"?"+g[u]+"?",c=b++;g[c]="^"+r+"$";var f=b++;g[f]="((?:<|>)?=?)";var w=b++;g[w]=g[C]+"|x|X|\\*";var d=b++;g[d]=g[A]+"|x|X|\\*";var D=b++;g[D]="[v=\\s]*("+g[d]+")(?:\\.("+g[d]+")(?:\\.("+g[d]+")(?:"+g[i]+")?"+g[u]+"?)?)?";var L=b++;g[L]="[v=\\s]*("+g[w]+")(?:\\.("+g[w]+")(?:\\.("+g[w]+")(?:"+g[s]+")?"+g[u]+"?)?)?";var y=b++;g[y]="^"+g[f]+"\\s*"+g[D]+"$";var E=b++;g[E]="^"+g[f]+"\\s*"+g[L]+"$";var k=b++;g[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=b++;g[F]="(?:~>?)";var B=b++;g[B]="(\\s*)"+g[F]+"\\s+",m[B]=new RegExp(g[B],"g");var ee=b++;g[ee]="^"+g[F]+g[D]+"$";var J=b++;g[J]="^"+g[F]+g[L]+"$";var V=b++;g[V]="(?:\\^)";var R=b++;g[R]="(\\s*)"+g[V]+"\\s+",m[R]=new RegExp(g[R],"g");var S=b++;g[S]="^"+g[V]+g[D]+"$";var O=b++;g[O]="^"+g[V]+g[L]+"$";var Q=b++;g[Q]="^"+g[f]+"\\s*("+r+")$|^$";var re=b++;g[re]="^"+g[f]+"\\s*("+t+")$|^$";var he=b++;g[he]="(\\s*)"+g[f]+"\\s*("+r+"|"+g[D]+")",m[he]=new RegExp(g[he],"g");var fe=b++;g[fe]="^\\s*("+g[D]+")\\s+-\\s+("+g[D]+")\\s*$";var ue=b++;g[ue]="^\\s*("+g[L]+")\\s+-\\s+("+g[L]+")\\s*$";var $e=b++;g[$e]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)I(ne,g[ne]),m[ne]||(m[ne]=new RegExp(g[ne]));function Pe(z,Z){if(z instanceof le)return z;if(typeof z!="string"||z.length>T||!(Z?m[c]:m[h]).test(z))return null;try{return new le(z,Z)}catch{return null}}function le(z,Z){if(z instanceof le){if(z.loose===Z)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof le))return new le(z,Z);I("SemVer",z,Z),this.loose=Z;var X=z.trim().match(Z?m[c]:m[h]);if(!X)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(De){if(/^[0-9]+$/.test(De)){var Te=+De;if(Te>=0&&Te<M)return Te}return De}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=Pe,e.valid=function(z,Z){var X=Pe(z,Z);return X?X.version:null},e.clean=function(z,Z){var X=Pe(z.trim().replace(/^[=v]+/,""),Z);return X?X.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(z){return I("SemVer.compare",this.version,this.loose,z),z instanceof le||(z=new le(z,this.loose)),this.compareMain(z)||this.comparePre(z)},le.prototype.compareMain=function(z){return z instanceof le||(z=new le(z,this.loose)),W(this.major,z.major)||W(this.minor,z.minor)||W(this.patch,z.patch)},le.prototype.comparePre=function(z){if(z instanceof le||(z=new le(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var Z=0;do{var X=this.prerelease[Z],De=z.prerelease[Z];if(I("prerelease compare",Z,X,De),X===void 0&&De===void 0)return 0;if(De===void 0)return 1;if(X===void 0)return-1;if(X!==De)return W(X,De)}while(++Z)},le.prototype.inc=function(z,Z){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,Z,X,De){typeof X=="string"&&(De=X,X=void 0);try{return new le(z,X).inc(Z,De).version}catch{return null}},e.diff=function(z,Z){if(Ee(z,Z))return null;var X=Pe(z),De=Pe(Z);if(X.prerelease.length||De.prerelease.length){for(var Te in X)if((Te==="major"||Te==="minor"||Te==="patch")&&X[Te]!==De[Te])return"pre"+Te;return"prerelease"}for(var Te in X)if((Te==="major"||Te==="minor"||Te==="patch")&&X[Te]!==De[Te])return Te},e.compareIdentifiers=W;var me=/^[0-9]+$/;function W(z,Z){var X=me.test(z),De=me.test(Z);return X&&De&&(z=+z,Z=+Z),X&&!De?-1:De&&!X?1:z<Z?-1:z>Z?1:0}function ae(z,Z,X){return new le(z,X).compare(new le(Z,X))}function de(z,Z,X){return ae(z,Z,X)>0}function ke(z,Z,X){return ae(z,Z,X)<0}function Ee(z,Z,X){return ae(z,Z,X)===0}function ce(z,Z,X){return ae(z,Z,X)!==0}function _(z,Z,X){return ae(z,Z,X)>=0}function H(z,Z,X){return ae(z,Z,X)<=0}function te(z,Z,X,De){var Te;switch(Z){case"===":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),Te=z===X;break;case"!==":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),Te=z!==X;break;case"":case"=":case"==":Te=Ee(z,X,De);break;case"!=":Te=ce(z,X,De);break;case">":Te=de(z,X,De);break;case">=":Te=_(z,X,De);break;case"<":Te=ke(z,X,De);break;case"<=":Te=H(z,X,De);break;default:throw new TypeError("Invalid operator: "+Z)}return Te}function we(z,Z){if(z instanceof we){if(z.loose===Z)return z;z=z.value}if(!(this instanceof we))return new we(z,Z);I("comparator",z,Z),this.loose=Z,this.parse(z),this.semver===be?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(z,Z){return W(Z,z)},e.major=function(z,Z){return new le(z,Z).major},e.minor=function(z,Z){return new le(z,Z).minor},e.patch=function(z,Z){return new le(z,Z).patch},e.compare=ae,e.compareLoose=function(z,Z){return ae(z,Z,!0)},e.rcompare=function(z,Z,X){return ae(Z,z,X)},e.sort=function(z,Z){return z.sort(function(X,De){return e.compare(X,De,Z)})},e.rsort=function(z,Z){return z.sort(function(X,De){return e.rcompare(X,De,Z)})},e.gt=de,e.lt=ke,e.eq=Ee,e.neq=ce,e.gte=_,e.lte=H,e.cmp=te,e.Comparator=we;var be={};function Fe(z,Z){if(z instanceof Fe)return z.loose===Z?z:new Fe(z.raw,Z);if(z instanceof we)return new Fe(z.value,Z);if(!(this instanceof Fe))return new Fe(z,Z);if(this.loose=Z,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function pe(z){return!z||z.toLowerCase()==="x"||z==="*"}function Se(z,Z,X,De,Te,qe,We,Ye,ot,rt,it,ct,ut){return((Z=pe(X)?"":pe(De)?">="+X+".0.0":pe(Te)?">="+X+"."+De+".0":">="+Z)+" "+(Ye=pe(ot)?"":pe(rt)?"<"+(+ot+1)+".0.0":pe(it)?"<"+ot+"."+(+rt+1)+".0":ct?"<="+ot+"."+rt+"."+it+"-"+ct:"<="+Ye)).trim()}function N(z,Z){for(var X=0;X<z.length;X++)if(!z[X].test(Z))return!1;if(Z.prerelease.length){for(X=0;X<z.length;X++)if(I(z[X].semver),z[X].semver!==be&&z[X].semver.prerelease.length>0){var De=z[X].semver;if(De.major===Z.major&&De.minor===Z.minor&&De.patch===Z.patch)return!0}return!1}return!0}function q(z,Z,X){try{Z=new Fe(Z,X)}catch{return!1}return Z.test(z)}function G(z,Z,X,De){var Te,qe,We,Ye,ot;switch(z=new le(z,De),Z=new Fe(Z,De),X){case">":Te=de,qe=H,We=ke,Ye=">",ot=">=";break;case"<":Te=ke,qe=_,We=de,Ye="<",ot="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(z,Z,De))return!1;for(var rt=0;rt<Z.set.length;++rt){var it=Z.set[rt],ct=null,ut=null;if(it.forEach(function(Ue){Ue.semver===be&&(Ue=new we(">=0.0.0")),ct=ct||Ue,ut=ut||Ue,Te(Ue.semver,ct.semver,De)?ct=Ue:We(Ue.semver,ut.semver,De)&&(ut=Ue)}),ct.operator===Ye||ct.operator===ot||(!ut.operator||ut.operator===Ye)&&qe(z,ut.semver)||ut.operator===ot&&We(z,ut.semver))return!1}return!0}we.prototype.parse=function(z){var Z=this.loose?m[Q]:m[re],X=z.match(Z);if(!X)throw new TypeError("Invalid comparator: "+z);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new le(X[2],this.loose):this.semver=be},we.prototype.toString=function(){return this.value},we.prototype.test=function(z){return I("Comparator.test",z,this.loose),this.semver===be||(typeof z=="string"&&(z=new le(z,this.loose)),te(z,this.operator,this.semver,this.loose))},we.prototype.intersects=function(z,Z){if(!(z instanceof we))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new Fe(z.value,Z),q(this.value,X,Z);if(z.operator==="")return X=new Fe(this.value,Z),q(z.semver,X,Z);var De=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),qe=this.semver.version===z.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ye=te(this.semver,"<",z.semver,Z)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),ot=te(this.semver,">",z.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return De||Te||qe&&We||Ye||ot},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(z){var Z=this.loose;z=z.trim(),I("range",z,Z);var X=Z?m[ue]:m[fe];z=z.replace(X,Se),I("hyphen replace",z),z=z.replace(m[he],"$1$2$3"),I("comparator trim",z,m[he]),z=(z=(z=z.replace(m[B],"$1~")).replace(m[R],"$1^")).split(/\s+/).join(" ");var De=Z?m[Q]:m[re],Te=z.split(" ").map(function(qe){return function(We,Ye){return I("comp",We),We=function(ot,rt){return ot.trim().split(/\s+/).map(function(it){return function(ct,ut){I("caret",ct,ut);var Ue=ut?m[O]:m[S];return ct.replace(Ue,function(vt,Y,x,ye,Ve){var Ze;return I("caret",ct,vt,Y,x,ye,Ve),pe(Y)?Ze="":pe(x)?Ze=">="+Y+".0.0 <"+(+Y+1)+".0.0":pe(ye)?Ze=Y==="0"?">="+Y+"."+x+".0 <"+Y+"."+(+x+1)+".0":">="+Y+"."+x+".0 <"+(+Y+1)+".0.0":Ve?(I("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=Y==="0"?x==="0"?">="+Y+"."+x+"."+ye+Ve+" <"+Y+"."+x+"."+(+ye+1):">="+Y+"."+x+"."+ye+Ve+" <"+Y+"."+(+x+1)+".0":">="+Y+"."+x+"."+ye+Ve+" <"+(+Y+1)+".0.0"):(I("no pr"),Ze=Y==="0"?x==="0"?">="+Y+"."+x+"."+ye+" <"+Y+"."+x+"."+(+ye+1):">="+Y+"."+x+"."+ye+" <"+Y+"."+(+x+1)+".0":">="+Y+"."+x+"."+ye+" <"+(+Y+1)+".0.0"),I("caret return",Ze),Ze})}(it,rt)}).join(" ")}(We,Ye),I("caret",We),We=function(ot,rt){return ot.trim().split(/\s+/).map(function(it){return function(ct,ut){var Ue=ut?m[J]:m[ee];return ct.replace(Ue,function(vt,Y,x,ye,Ve){var Ze;return I("tilde",ct,vt,Y,x,ye,Ve),pe(Y)?Ze="":pe(x)?Ze=">="+Y+".0.0 <"+(+Y+1)+".0.0":pe(ye)?Ze=">="+Y+"."+x+".0 <"+Y+"."+(+x+1)+".0":Ve?(I("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=">="+Y+"."+x+"."+ye+Ve+" <"+Y+"."+(+x+1)+".0"):Ze=">="+Y+"."+x+"."+ye+" <"+Y+"."+(+x+1)+".0",I("tilde return",Ze),Ze})}(it,rt)}).join(" ")}(We,Ye),I("tildes",We),We=function(ot,rt){return I("replaceXRanges",ot,rt),ot.split(/\s+/).map(function(it){return function(ct,ut){ct=ct.trim();var Ue=ut?m[E]:m[y];return ct.replace(Ue,function(vt,Y,x,ye,Ve,Ze){I("xRange",ct,vt,Y,x,ye,Ve,Ze);var nt=pe(x),st=nt||pe(ye),Ne=st||pe(Ve);return Y==="="&&Ne&&(Y=""),nt?vt=Y===">"||Y==="<"?"<0.0.0":"*":Y&&Ne?(st&&(ye=0),Ne&&(Ve=0),Y===">"?(Y=">=",st?(x=+x+1,ye=0,Ve=0):Ne&&(ye=+ye+1,Ve=0)):Y==="<="&&(Y="<",st?x=+x+1:ye=+ye+1),vt=Y+x+"."+ye+"."+Ve):st?vt=">="+x+".0.0 <"+(+x+1)+".0.0":Ne&&(vt=">="+x+"."+ye+".0 <"+x+"."+(+ye+1)+".0"),I("xRange return",vt),vt})}(it,rt)}).join(" ")}(We,Ye),I("xrange",We),We=function(ot,rt){return I("replaceStars",ot,rt),ot.trim().replace(m[$e],"")}(We,Ye),I("stars",We),We}(qe,Z)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(qe){return!!qe.match(De)})),Te=Te.map(function(qe){return new we(qe,Z)})},Fe.prototype.intersects=function(z,Z){if(!(z instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(De){return z.set.some(function(Te){return Te.every(function(qe){return De.intersects(qe,Z)})})})})},e.toComparators=function(z,Z){return new Fe(z,Z).set.map(function(X){return X.map(function(De){return De.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new le(z,this.loose));for(var Z=0;Z<this.set.length;Z++)if(N(this.set[Z],z))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(z,Z,X){var De=null,Te=null;try{var qe=new Fe(Z,X)}catch{return null}return z.forEach(function(We){qe.test(We)&&(De&&Te.compare(We)!==-1||(Te=new le(De=We,X)))}),De},e.minSatisfying=function(z,Z,X){var De=null,Te=null;try{var qe=new Fe(Z,X)}catch{return null}return z.forEach(function(We){qe.test(We)&&(De&&Te.compare(We)!==1||(Te=new le(De=We,X)))}),De},e.validRange=function(z,Z){try{return new Fe(z,Z).range||"*"}catch{return null}},e.ltr=function(z,Z,X){return G(z,Z,"<",X)},e.gtr=function(z,Z,X){return G(z,Z,">",X)},e.outside=G,e.prerelease=function(z,Z){var X=Pe(z,Z);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(z,Z,X){return z=new Fe(z,X),Z=new Fe(Z,X),z.intersects(Z)},e.coerce=function(z){if(z instanceof le)return z;if(typeof z!="string")return null;var Z=z.match(m[k]);return Z==null?null:Pe((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,$(1))},function(ie,e){var $,P,I=ie.exports={};function T(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function m(o){if($===setTimeout)return setTimeout(o,0);if(($===T||!$)&&setTimeout)return $=setTimeout,setTimeout(o,0);try{return $(o,0)}catch{try{return $.call(null,o,0)}catch{return $.call(this,o,0)}}}(function(){try{$=typeof setTimeout=="function"?setTimeout:T}catch{$=T}try{P=typeof clearTimeout=="function"?clearTimeout:M}catch{P=M}})();var g,b=[],A=!1,C=-1;function l(){A&&g&&(A=!1,g.length?b=g.concat(b):C=-1,b.length&&p())}function p(){if(!A){var o=m(l);A=!0;for(var i=b.length;i;){for(g=b,b=[];++C<i;)g&&g[C].run();C=-1,i=b.length}g=null,A=!1,function(s){if(P===clearTimeout)return clearTimeout(s);if((P===M||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(s);try{P(s)}catch{try{return P.call(null,s)}catch{return P.call(this,s)}}}(o)}}function v(o,i){this.fun=o,this.array=i}function n(){}I.nextTick=function(o){var i=new Array(arguments.length-1);if(arguments.length>1)for(var s=1;s<arguments.length;s++)i[s-1]=arguments[s];b.push(new v(o,i)),b.length!==1||A||m(p)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=n,I.addListener=n,I.once=n,I.off=n,I.removeListener=n,I.removeAllListeners=n,I.emit=n,I.prependListener=n,I.prependOnceListener=n,I.listeners=function(o){return[]},I.binding=function(o){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(o){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Re[124],Ae([1,0,11,6]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function I(u){const h=u;return h?typeof h.read=="function":!1}e.$4d=I;function T(u){const h=u;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$5d=T;function M(u){const h=u;return h?T(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$6d=M;function m(u,h){return new g(u,h)}e.$7d=m;class g{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,$.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let r;switch(h){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const c=r.indexOf(t);c>=0&&r.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(u,h){const t=[];let r;for(;(r=u.read())!==null;)t.push(r);return h(t)}e.$8d=b;function A(u,h,t){const r=[];let c;for(;(c=u.read())!==null&&r.length<t;)r.push(c);return c===null&&r.length>0?h(r):{read:()=>{if(r.length>0)return r.shift();if(typeof c<"u"){const f=c;return c=void 0,f}return u.read()}}}e.$9d=A;function C(u,h){return new Promise((t,r)=>{const c=[];l(u,{onData:f=>{h&&c.push(f)},onError:f=>{h?r(f):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}e.$0d=C;function l(u,h,t){u.on("error",r=>{t?.isCancellationRequested||h.onError(r)}),u.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),u.on("data",r=>{t?.isCancellationRequested||h.onData(r)})}e.$$d=l;function p(u,h){return new Promise((t,r)=>{const c=new P.$Rc,f=[],w=L=>{if(f.push(L),f.length>h)return c.dispose(),u.pause(),t({stream:u,buffer:f,ended:!1})},d=L=>(c.dispose(),r(L)),D=()=>(c.dispose(),t({stream:u,buffer:f,ended:!0}));c.add((0,P.$Qc)(()=>u.removeListener("error",d))),u.on("error",d),c.add((0,P.$Qc)(()=>u.removeListener("end",D))),u.on("end",D),c.add((0,P.$Qc)(()=>u.removeListener("data",w))),u.on("data",w)})}e.$_d=p;function v(u,h){const t=m(h);return t.end(u),t}e.$ae=v;function n(){const u=m(()=>{throw new Error("not supported")});return u.end(),u}e.$be=n;function o(u){let h=!1;return{read:()=>h?null:(h=!0,u)}}e.$ce=o;function i(u,h,t){const r=m(t);return l(u,{onData:c=>r.write(h.data(c)),onError:c=>r.error(h.error?h.error(c):c),onEnd:()=>r.end()}),r}e.$de=i;function s(u,h,t){let r=!1;return{read:()=>{const c=h.read();return r?c:(r=!0,c!==null?t([u,c]):u)}}}e.$ee=s;function a(u,h,t){let r=!1;const c=m(t);return l(h,{onData:f=>r?c.write(f):(r=!0,c.write(t([u,f]))),onError:f=>c.error(f),onEnd:()=>{r||(r=!0,c.write(u)),c.end()}}),c}e.$fe=a}),define(Re[24],Ae([1,0,39,124]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const I=typeof Buffer<"u",T=new $.$V(()=>new Uint8Array(256));let M,m;class g{static alloc(k){return I?new g(Buffer.allocUnsafe(k)):new g(new Uint8Array(k))}static wrap(k){return I&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new g(k)}static fromString(k,F){return!(F?.dontUseNodeBuffer||!1)&&I?new g(Buffer.from(k)):(M||(M=new TextEncoder),new g(M.encode(k)))}static fromByteArray(k){const F=g.alloc(k.length);for(let B=0,ee=k.length;B<ee;B++)F.buffer[B]=k[B];return F}static concat(k,F){if(typeof F>"u"){F=0;for(let J=0,V=k.length;J<V;J++)F+=k[J].byteLength}const B=g.alloc(F);let ee=0;for(let J=0,V=k.length;J<V;J++){const R=k[J];B.set(R,ee),ee+=R.byteLength}return B}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=g.alloc(this.byteLength);return k.set(this),k}toString(){return I?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(k,F){return new g(this.buffer.subarray(k,F))}set(k,F){if(k instanceof g)this.buffer.set(k.buffer,F);else if(k instanceof Uint8Array)this.buffer.set(k,F);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),F);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,F){p(this.buffer,k,F)}readUInt32LE(k){return v(this.buffer,k)}writeUInt32LE(k,F){n(this.buffer,k,F)}readUInt8(k){return o(this.buffer,k)}writeUInt8(k,F){i(this.buffer,k,F)}indexOf(k,F=0){return b(this.buffer,k instanceof g?k.buffer:k,F)}}e.$ge=g;function b(E,k,F=0){const B=k.byteLength,ee=E.byteLength;if(B===0)return 0;if(B===1)return E.indexOf(k[0]);if(B>ee-F)return-1;const J=T.value;J.fill(k.length);for(let O=0;O<k.length;O++)J[k[O]]=k.length-O-1;let V=F+k.length-1,R=V,S=-1;for(;V<ee;)if(E[V]===k[R]){if(R===0){S=V;break}V--,R--}else V+=Math.max(k.length-R,J[E[V]]),R=k.length-1;return S}e.$he=b;function A(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0}e.$ie=A;function C(E,k,F){E[F+0]=k&255,k=k>>>8,E[F+1]=k&255}e.$je=C;function l(E,k){return E[k]*2**24+E[k+1]*2**16+E[k+2]*2**8+E[k+3]}e.$ke=l;function p(E,k,F){E[F+3]=k,k=k>>>8,E[F+2]=k,k=k>>>8,E[F+1]=k,k=k>>>8,E[F]=k}e.$le=p;function v(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0|E[k+2]<<16>>>0|E[k+3]<<24>>>0}e.$me=v;function n(E,k,F){E[F+0]=k&255,k=k>>>8,E[F+1]=k&255,k=k>>>8,E[F+2]=k&255,k=k>>>8,E[F+3]=k&255}e.$ne=n;function o(E,k){return E[k]}e.$oe=o;function i(E,k,F){E[F]=k}e.$pe=i;function s(E){return P.$8d(E,k=>g.concat(k))}e.$qe=s;function a(E){return P.$ce(E)}e.$re=a;function u(E){return P.$0d(E,k=>g.concat(k))}e.$se=u;async function h(E){return E.ended?g.concat(E.buffer):g.concat([...E.buffer,await u(E.stream)])}e.$te=h;function t(E){return P.$ae(E,k=>g.concat(k))}e.$ue=t;function r(E){return P.$de(E,{data:k=>typeof k=="string"?g.fromString(k):g.wrap(k)},k=>g.concat(k))}e.$ve=r;function c(E){return P.$7d(k=>g.concat(k),E)}e.$we=c;function f(E,k){return P.$ee(E,k,F=>g.concat(F))}e.$xe=f;function w(E,k){return P.$fe(E,k,F=>g.concat(F))}e.$ye=w;function d(E){let k=0,F=0,B=0;const ee=new Uint8Array(Math.floor(E.length/4*3)),J=R=>{switch(F){case 3:ee[B++]=k|R,F=0;break;case 2:ee[B++]=k|R>>>2,k=R<<6,F=3;break;case 1:ee[B++]=k|R>>>4,k=R<<4,F=2;break;default:k=R<<2,F=1}};for(let R=0;R<E.length;R++){const S=E.charCodeAt(R);if(S>=65&&S<=90)J(S-65);else if(S>=97&&S<=122)J(S-97+26);else if(S>=48&&S<=57)J(S-48+52);else if(S===43||S===45)J(62);else if(S===47||S===95)J(63);else{if(S===61)break;throw new SyntaxError(`Unexpected base64 character ${E[R]}`)}}const V=B;for(;F>0;)J(0);return g.wrap(ee).slice(0,V)}e.$ze=d;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:E},k=!0,F=!1){const B=F?L:D;let ee="";const J=E.byteLength%3;let V=0;for(;V<E.byteLength-J;V+=3){const R=E[V+0],S=E[V+1],O=E[V+2];ee+=B[R>>>2],ee+=B[(R<<4|S>>>4)&63],ee+=B[(S<<2|O>>>6)&63],ee+=B[O&63]}if(J===1){const R=E[V+0];ee+=B[R>>>2],ee+=B[R<<4&63],k&&(ee+="==")}else if(J===2){const R=E[V+0],S=E[V+1];ee+=B[R>>>2],ee+=B[(R<<4|S>>>4)&63],ee+=B[S<<2&63],k&&(ee+="=")}return ee}e.$Ae=y}),define(Re[125],Ae([1,0,28,121,12]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.FuzzyScore=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.or=void 0;function T(...pe){return function(Se,N){for(let q=0,G=pe.length;q<G;q++){const z=pe[q](Se,N);if(z)return z}return null}}e.or=T,e.$Pj=M.bind(void 0,!1),e.$Qj=M.bind(void 0,!0);function M(pe,Se,N){if(!N||N.length<Se.length)return null;let q;return pe?q=I.$9e(N,Se):q=N.indexOf(Se)===0,q?Se.length>0?[{start:0,end:Se.length}]:[]:null}function m(pe,Se){const N=Se.toLowerCase().indexOf(pe.toLowerCase());return N===-1?null:[{start:N,end:N+pe.length}]}e.$Rj=m;function g(pe,Se){return b(pe.toLowerCase(),Se.toLowerCase(),0,0)}e.$Sj=g;function b(pe,Se,N,q){if(N===pe.length)return[];if(q===Se.length)return null;if(pe[N]===Se[q]){let G=null;return(G=b(pe,Se,N+1,q+1))?u({start:q,end:q+1},G):null}return b(pe,Se,N,q+1)}function A(pe){return 97<=pe&&pe<=122}function C(pe){return 65<=pe&&pe<=90}e.$Tj=C;function l(pe){return 48<=pe&&pe<=57}function p(pe){return pe===32||pe===9||pe===10||pe===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(pe=>v.add(pe.charCodeAt(0)));function n(pe){return p(pe)||v.has(pe)}function o(pe,Se){return pe===Se||n(pe)&&n(Se)}const i=new Map;function s(pe){if(i.has(pe))return i.get(pe);let Se;const N=(0,P.$Nj)(pe);return N&&(Se=N),i.set(pe,Se),Se}function a(pe){return A(pe)||C(pe)||l(pe)}function u(pe,Se){return Se.length===0?Se=[pe]:pe.end===Se[0].start?Se[0].start=pe.start:Se.unshift(pe),Se}function h(pe,Se){for(let N=Se;N<pe.length;N++){const q=pe.charCodeAt(N);if(C(q)||l(q)||N>0&&!a(pe.charCodeAt(N-1)))return N}return pe.length}function t(pe,Se,N,q){if(N===pe.length)return[];if(q===Se.length)return null;if(pe[N]!==Se[q].toLowerCase())return null;{let G=null,z=q+1;for(G=t(pe,Se,N+1,q+1);!G&&(z=h(Se,z))<Se.length;)G=t(pe,Se,N+1,z),z++;return G===null?null:u({start:q,end:q+1},G)}}function r(pe){let Se=0,N=0,q=0,G=0,z=0;for(let qe=0;qe<pe.length;qe++)z=pe.charCodeAt(qe),C(z)&&Se++,A(z)&&N++,a(z)&&q++,l(z)&&G++;const Z=Se/pe.length,X=N/pe.length,De=q/pe.length,Te=G/pe.length;return{upperPercent:Z,lowerPercent:X,alphaPercent:De,numericPercent:Te}}function c(pe){const{upperPercent:Se,lowerPercent:N}=pe;return N===0&&Se>.6}function f(pe){const{upperPercent:Se,lowerPercent:N,alphaPercent:q,numericPercent:G}=pe;return N>.2&&Se<.8&&q>.6&&G<.2}function w(pe){let Se=0,N=0,q=0,G=0;for(let z=0;z<pe.length;z++)q=pe.charCodeAt(z),C(q)&&Se++,A(q)&&N++,p(q)&&G++;return(Se===0||N===0)&&G===0?pe.length<=30:Se<=5}function d(pe,Se){if(!Se||(Se=Se.trim(),Se.length===0)||!w(pe)||Se.length>60)return null;const N=r(Se);if(!f(N)){if(!c(N))return null;Se=Se.toLowerCase()}let q=null,G=0;for(pe=pe.toLowerCase();G<Se.length&&(q=t(pe,Se,0,G))===null;)G=h(Se,G+1);return q}e.$Uj=d;function D(pe,Se,N=!1){if(!Se||Se.length===0)return null;let q=null,G=0;for(pe=pe.toLowerCase(),Se=Se.toLowerCase();G<Se.length&&(q=L(pe,Se,0,G,N),q===null);)G=y(Se,G+1);return q}e.$Vj=D;function L(pe,Se,N,q,G){let z=0;if(N===pe.length)return[];if(q===Se.length)return null;if(!o(pe.charCodeAt(N),Se.charCodeAt(q))){const De=s(pe.charCodeAt(N));if(!De)return null;for(let Te=0;Te<De.length;Te++)if(!o(De[Te],Se.charCodeAt(q+Te)))return null;z+=De.length-1}let Z=null,X=q+z+1;if(Z=L(pe,Se,N+1,X,G),!G)for(;!Z&&(X=y(Se,X))<Se.length;)Z=L(pe,Se,N+1,X,G),X++;if(!Z)return null;if(pe.charCodeAt(N)!==Se.charCodeAt(q)){const De=s(pe.charCodeAt(N));if(!De)return Z;for(let Te=0;Te<De.length;Te++)if(De[Te]!==Se.charCodeAt(q+Te))return Z}return u({start:q,end:q+z+1},Z)}function y(pe,Se){for(let N=Se;N<pe.length;N++)if(n(pe.charCodeAt(N))||N>0&&n(pe.charCodeAt(N-1)))return N;return pe.length}const E=T(e.$Qj,d,m),k=T(e.$Qj,d,g),F=new $.$Dc(1e4);function B(pe,Se,N=!1){if(typeof pe!="string"||typeof Se!="string")return null;let q=F.get(pe);q||(q=new RegExp(I.$Re(pe),"i"),F.set(pe,q));const G=q.exec(Se);return G?[{start:G.index,end:G.index+G[0].length}]:N?k(pe,Se):E(pe,Se)}e.$Wj=B;function ee(pe,Se){const N=ce(pe,pe.toLowerCase(),0,Se,Se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?V(N):null}e.$Xj=ee;function J(pe,Se,N,q,G,z){const Z=Math.min(13,pe.length);for(;N<Z;N++){const X=ce(pe,Se,N,q,G,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,z]}e.$Yj=J;function V(pe){if(typeof pe>"u")return[];const Se=[],N=pe[1];for(let q=pe.length-1;q>1;q--){const G=pe[q]+N,z=Se[Se.length-1];z&&z.end===G?z.end=G+1:Se.push({start:G,end:G+1})}return Se}e.$Zj=V;const R=128;function S(){const pe=[],Se=[];for(let N=0;N<=R;N++)Se[N]=0;for(let N=0;N<=R;N++)pe.push(Se.slice(0));return pe}function O(pe){const Se=[];for(let N=0;N<=pe;N++)Se[N]=0;return Se}const Q=O(2*R),re=O(2*R),he=S(),fe=S(),ue=S(),$e=!1;function ne(pe,Se,N,q,G){function z(X,De,Te=" "){for(;X.length<De;)X=Te+X;return X}let Z=` |   |${q.split("").map(X=>z(X,3)).join("|")}
`;for(let X=0;X<=N;X++)X===0?Z+=" |":Z+=`${Se[X-1]}|`,Z+=pe[X].slice(0,G+1).map(De=>z(De.toString(),3)).join("|")+`
`;return Z}function Pe(pe,Se,N,q){pe=pe.substr(Se),N=N.substr(q),console.log(ne(fe,pe,pe.length,N,N.length)),console.log(ne(ue,pe,pe.length,N,N.length)),console.log(ne(he,pe,pe.length,N,N.length))}function le(pe,Se){if(Se<0||Se>=pe.length)return!1;const N=pe.codePointAt(Se);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$of(N)}}function me(pe,Se){if(Se<0||Se>=pe.length)return!1;switch(pe.charCodeAt(Se)){case 32:case 9:return!0;default:return!1}}function W(pe,Se,N){return Se[pe]!==N[pe]}function ae(pe,Se,N,q,G,z,Z=!1){for(;Se<N&&G<z;)pe[Se]===q[G]&&(Z&&(Q[Se]=G),Se+=1),G+=1;return Se===N}e.$1j=ae;var de;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(de||(de={}));var ke;(function(pe){pe.Default=[-100,0];function Se(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}pe.isDefault=Se})(ke||(e.FuzzyScore=ke={}));class Ee{constructor(Se,N){this.firstMatchCanBeWeak=Se,this.boostFullMatch=N}}e.$2j=Ee,Ee.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ce(pe,Se,N,q,G,z,Z=Ee.default){const X=pe.length>R?R:pe.length,De=q.length>R?R:q.length;if(N>=X||z>=De||X-N>De-z||!ae(Se,N,X,G,z,De,!0))return;_(X,De,N,z,Se,G);let Te=1,qe=1,We=N,Ye=z;const ot=[!1];for(Te=1,We=N;We<X;Te++,We++){const Ue=Q[We],vt=re[We],Y=We+1<X?re[We+1]:De;for(qe=Ue-z+1,Ye=Ue;Ye<Y;qe++,Ye++){let x=Number.MIN_SAFE_INTEGER,ye=!1;Ye<=vt&&(x=H(pe,Se,We,N,q,G,Ye,De,z,he[Te-1][qe-1]===0,ot));let Ve=0;x!==Number.MAX_SAFE_INTEGER&&(ye=!0,Ve=x+fe[Te-1][qe-1]);const Ze=Ye>Ue,nt=Ze?fe[Te][qe-1]+(he[Te][qe-1]>0?-5:0):0,st=Ye>Ue+1&&he[Te][qe-1]>0,Ne=st?fe[Te][qe-2]+(he[Te][qe-2]>0?-5:0):0;if(st&&(!Ze||Ne>=nt)&&(!ye||Ne>=Ve))fe[Te][qe]=Ne,ue[Te][qe]=3,he[Te][qe]=0;else if(Ze&&(!ye||nt>=Ve))fe[Te][qe]=nt,ue[Te][qe]=2,he[Te][qe]=0;else if(ye)fe[Te][qe]=Ve,ue[Te][qe]=1,he[Te][qe]=he[Te-1][qe-1]+1;else throw new Error("not possible")}}if($e&&Pe(pe,N,q,z),!ot[0]&&!Z.firstMatchCanBeWeak)return;Te--,qe--;const rt=[fe[Te][qe],z];let it=0,ct=0;for(;Te>=1;){let Ue=qe;do{const vt=ue[Te][Ue];if(vt===3)Ue=Ue-2;else if(vt===2)Ue=Ue-1;else break}while(Ue>=1);it>1&&Se[N+Te-1]===G[z+qe-1]&&!W(Ue+z-1,q,G)&&it+1>he[Te][Ue]&&(Ue=qe),Ue===qe?it++:it=1,ct||(ct=Ue),Te--,qe=Ue-1,rt.push(qe)}De===X&&Z.boostFullMatch&&(rt[0]+=2);const ut=ct-X;return rt[0]-=ut,rt}e.$3j=ce;function _(pe,Se,N,q,G,z){let Z=pe-1,X=Se-1;for(;Z>=N&&X>=q;)G[Z]===z[X]&&(re[Z]=X,Z--),X--}function H(pe,Se,N,q,G,z,Z,X,De,Te,qe){if(Se[N]!==z[Z])return Number.MIN_SAFE_INTEGER;let We=1,Ye=!1;return Z===N-q?We=pe[N]===G[Z]?7:5:W(Z,G,z)&&(Z===0||!W(Z-1,G,z))?(We=pe[N]===G[Z]?7:5,Ye=!0):le(z,Z)&&(Z===0||!le(z,Z-1))?We=5:(le(z,Z-1)||me(z,Z-1))&&(We=5,Ye=!0),We>1&&N===q&&(qe[0]=!0),Ye||(Ye=W(Z,G,z)||le(z,Z-1)||me(z,Z-1)),N===q?Z>De&&(We-=Ye?3:5):Te?We+=Ye?2:0:We+=Ye?0:1,Z+1===X&&(We-=Ye?3:5),We}function te(pe,Se,N,q,G,z,Z){return be(pe,Se,N,q,G,z,!0,Z)}e.$4j=te;function we(pe,Se,N,q,G,z,Z){return be(pe,Se,N,q,G,z,!1,Z)}e.$5j=we;function be(pe,Se,N,q,G,z,Z,X){let De=ce(pe,Se,N,q,G,z,X);if(De&&!Z)return De;if(pe.length>=3){const Te=Math.min(7,pe.length-1);for(let qe=N+1;qe<Te;qe++){const We=Fe(pe,qe);if(We){const Ye=ce(We,We.toLowerCase(),N,q,G,z,X);Ye&&(Ye[0]-=3,(!De||Ye[0]>De[0])&&(De=Ye))}}}return De}function Fe(pe,Se){if(Se+1>=pe.length)return;const N=pe[Se],q=pe[Se+1];if(N!==q)return pe.slice(0,Se)+q+N+pe.slice(Se+2)}}),define(Re[31],Ae([1,0,12]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(P||(P={})),function(I){const T="error",M="warning",m="warn",g="info",b="ignore";function A(l){return l?$.$8e(T,l)?I.Error:$.$8e(M,l)||$.$8e(m,l)?I.Warning:$.$8e(g,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function C(l){switch(l){case I.Error:return T;case I.Warning:return M;case I.Info:return g;default:return b}}I.toString=C}(P||(P={})),e.default=P}),define(Re[126],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Re[50],Ae([1,0,18,12]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class I{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const v=p.charCodeAt(0),n=this.b.charCodeAt(this.c);return v-n}value(){return this.b[this.c]}}e.$4h=I;class T{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,P.$2e)(p,this.b,0,p.length,this.c,this.d):(0,P.$4e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=T;class M{constructor(p=!0,v=!0){this.f=p,this.g=v}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let v=p.length-1;v>=0;v--,this.c--){const n=this.b.charCodeAt(v);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,P.$2e)(p,this.b,0,p.length,this.d,this.e):(0,P.$4e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=M;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class g{constructor(p,v){this.f=p,this.g=v,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,P.$3e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,P.$3e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,P.$1e)(p,this.c.query);if(this.d[this.e]===5)return(0,P.$1e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=g;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class C{static forUris(p=()=>!1,v=()=>!1){return new C(new g(p,v))}static forPaths(p=!1){return new C(new M(void 0,!p))}static forStrings(){return new C(new I)}static forConfigKeys(){return new C(new T)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,v){if(v){const n=v.slice(0);(0,$.$Xb)(n);for(const o of n)this.set(o,p)}else{const n=p.slice(0);(0,$.$Xb)(n);for(const o of n)this.set(o[0],o[1])}}set(p,v){const n=this.b.reset(p);let o;this.c||(this.c=new b,this.c.segment=n.value());const i=[];for(o=this.c;;){const a=n.cmp(o.segment);if(a>0)o.left||(o.left=new b,o.left.segment=n.value()),i.push([-1,o]),o=o.left;else if(a<0)o.right||(o.right=new b,o.right.segment=n.value()),i.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new b,o.mid.segment=n.value()),i.push([0,o]),o=o.mid;else break}const s=o.value;o.value=v,o.key=p;for(let a=i.length-1;a>=0;a--){const u=i[a][1];u.updateHeight();const h=u.balanceFactor();if(h<-1||h>1){const t=i[a][0],r=i[a+1][0];if(t===1&&r===1)i[a][1]=u.rotateLeft();else if(t===-1&&r===-1)i[a][1]=u.rotateRight();else if(t===1&&r===-1)u.right=i[a+1][1]=i[a+1][1].rotateRight(),i[a][1]=u.rotateLeft();else if(t===-1&&r===1)u.left=i[a+1][1]=i[a+1][1].rotateLeft(),i[a][1]=u.rotateRight();else throw new Error;if(a>0)switch(i[a-1][0]){case-1:i[a-1][1].left=i[a][1];break;case 1:i[a-1][1].right=i[a][1];break;case 0:i[a-1][1].mid=i[a][1];break}else this.c=i[0][1]}}return s}get(p){return this.d(p)?.value}d(p){const v=this.b.reset(p);let n=this.c;for(;n;){const o=v.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(v.hasNext())v.next(),n=n.mid;else break}return n}has(p){const v=this.d(p);return!(v?.value===void 0&&v?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,v){const n=this.b.reset(p),o=[];let i=this.c;for(;i;){const s=n.cmp(i.segment);if(s>0)o.push([-1,i]),i=i.left;else if(s<0)o.push([1,i]),i=i.right;else if(n.hasNext())n.next(),o.push([0,i]),i=i.mid;else break}if(i){if(v?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const s=this.f(i.right);if(s.key){const{key:a,value:u,segment:h}=s;this.e(s.key,!1),i.key=a,i.value=u,i.segment=h}}else{const s=i.left??i.right;if(o.length>0){const[a,u]=o[o.length-1];switch(a){case-1:u.left=s;break;case 0:u.mid=s;break;case 1:u.right=s;break}}else this.c=s}for(let s=o.length-1;s>=0;s--){const a=o[s][1];a.updateHeight();const u=a.balanceFactor();if(u>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),o[s][1]=a.rotateLeft()):u<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),o[s][1]=a.rotateRight()),s>0)switch(o[s-1][0]){case-1:o[s-1][1].left=o[s][1];break;case 1:o[s-1][1].right=o[s][1];break;case 0:o[s-1][1].mid=o[s][1];break}else this.c=o[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const v=this.b.reset(p);let n=this.c,o;for(;n;){const i=v.cmp(n.segment);if(i>0)n=n.left;else if(i<0)n=n.right;else if(v.hasNext())v.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(p){return this.g(p,!1)}g(p,v){const n=this.b.reset(p);let o=this.c;for(;o;){const i=n.cmp(o.segment);if(i>0)o=o.left;else if(i<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):v?o.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[v,n]of this)p(n,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const v=[];return this.j(p,v),v[Symbol.iterator]()}j(p,v){p&&(p.left&&this.j(p.left,v),p.value&&v.push([p.key,p.value]),p.mid&&this.j(p.mid,v),p.right&&this.j(p.right,v))}_isBalanced(){const p=v=>{if(!v)return!0;const n=v.balanceFactor();return n<-1||n>1?!1:p(v.left)&&p(v.right)};return p(this.c)}}e.$8h=C}),define(Re[45],Ae([1,0,19,21,12,16]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function M(d){return d===47||d===92}e.$Wf=M;function m(d){return d.replace(/[\\/]/g,$.$gc.sep)}e.$Xf=m;function g(d){return d.indexOf("/")===-1&&(d=m(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$Yf=g;function b(d,D=$.$gc.sep){if(!d)return"";const L=d.length,y=d.charCodeAt(0);if(M(y)){if(M(d.charCodeAt(1))&&!M(d.charCodeAt(2))){let k=3;const F=k;for(;k<L&&!M(d.charCodeAt(k));k++);if(F!==k&&!M(d.charCodeAt(k+1))){for(k+=1;k<L;k++)if(M(d.charCodeAt(k)))return d.slice(0,k+1).replace(/[\\/]/g,D)}}return D}else if(i(y)&&d.charCodeAt(1)===58)return M(d.charCodeAt(2))?d.slice(0,2)+D:d.slice(0,2);let E=d.indexOf("://");if(E!==-1){for(E+=3;E<L;E++)if(M(d.charCodeAt(E)))return d.slice(0,E+1)}return""}e.$Zf=b;function A(d){if(!P.$c||!d||d.length<5)return!1;let D=d.charCodeAt(0);if(D!==92||(D=d.charCodeAt(1),D!==92))return!1;let L=2;const y=L;for(;L<d.length&&(D=d.charCodeAt(L),D!==92);L++);return!(y===L||(D=d.charCodeAt(L+1),isNaN(D)||D===92))}e.$1f=A;const C=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(d,D=P.$c){const L=D?C:l;return!(!d||d.length===0||/^\s+$/.test(d)||(L.lastIndex=0,L.test(d))||D&&p.test(d)||d==="."||d===".."||D&&d[d.length-1]==="."||D&&d.length!==d.trim().length||d.length>255)}e.$2f=v;function n(d,D,L){const y=d===D;return!L||y?y:!d||!D?!1:(0,I.$8e)(d,D)}e.$3f=n;function o(d,D,L,y=$.sep){if(d===D)return!0;if(!d||!D||D.length>d.length)return!1;if(L){if(!(0,I.$9e)(d,D))return!1;if(D.length===d.length)return!0;let k=D.length;return D.charAt(D.length-1)===y&&k--,d.charAt(k)===y}return D.charAt(D.length-1)!==y&&(D+=y),d.indexOf(D)===0}e.$4f=o;function i(d){return d>=65&&d<=90||d>=97&&d<=122}e.$5f=i;function s(d,D){return P.$c&&d.endsWith(":")&&(d+=$.sep),(0,$.$ic)(d)||(d=(0,$.$jc)(D,d)),d=(0,$.$hc)(d),P.$c?(d=(0,I.$Qe)(d,$.sep),d.endsWith(":")&&(d+=$.sep)):(d=(0,I.$Qe)(d,$.sep),d||(d=$.sep)),d}e.$6f=s;function a(d){const D=(0,$.$hc)(d);return P.$c?d.length>3?!1:u(D)&&(d.length===2||D.charCodeAt(2)===92):D===$.$gc.sep}e.$7f=a;function u(d,D=P.$c){return D?i(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$8f=u;function h(d,D=P.$c){return u(d,D)?d[0]:void 0}e.$9f=h;function t(d,D,L){return D.length>d.length?-1:d===D?0:(L&&(d=d.toLowerCase(),D=D.toLowerCase()),d.indexOf(D))}e.$0f=t;function r(d){const D=d.split(":");let L,y,E;for(const k of D){const F=Number(k);(0,T.$If)(F)?y===void 0?y=F:E===void 0&&(E=F):L=L?[L,k].join(":"):k}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:y!==void 0?y:void 0,column:E!==void 0?E:y!==void 0?1:void 0}}e.$$f=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(d,D,L=8){let y="";for(let k=0;k<L;k++){let F;k===0&&P.$c&&!D&&(L===3||L===4)?F=f:F=c,y+=F.charAt(Math.floor(Math.random()*F.length))}let E;return D?E=`${D}-${y}`:E=y,d?(0,$.$jc)(d,E):E}e.$_f=w}),define(Re[46],Ae([1,0,90]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$9j=e.ThemeColor=void 0;var P;(function(M){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}M.isThemeColor=m})(P||(e.ThemeColor=P={}));function I(M){return{id:M}}e.$9j=I;var T;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(s){const a=m.exec(s.id);if(!a)return g($.$8j.error);const[,u,h]=a,t=["codicon","codicon-"+u];return h&&t.push("codicon-modifier-"+h.substring(1)),t}M.asClassNameArray=g;function b(s){return g(s).join(" ")}M.asClassName=b;function A(s){return"."+g(s).join(".")}M.asCSSSelector=A;function C(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||P.isThemeColor(s.color))}M.isThemeIcon=C;const l=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function p(s){const a=l.exec(s);if(!a)return;const[,u]=a;return{id:u}}M.fromString=p;function v(s){return{id:s}}M.fromId=v;function n(s,a){let u=s.id;const h=u.lastIndexOf("~");return h!==-1&&(u=u.substring(0,h)),a&&(u=`${u}~${a}`),{id:u}}M.modify=n;function o(s){const a=s.id.lastIndexOf("~");if(a!==-1)return s.id.substring(a+1)}M.getModifier=o;function i(s,a){return s.id===a.id&&s.color?.id===a.color?.id}M.isEqual=i})(T||(e.ThemeIcon=T={}))}),define(Re[127],Ae([1,0,125,12,46]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=void 0;const T="$(",M=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${M.source}`,"g");function g(i){return i.replace(m,(s,a)=>a?s:`\\${s}`)}e.$0j=g;const b=new RegExp(`\\\\${M.source}`,"g");function A(i){return i.replace(b,s=>`\\${s}`)}e.$$j=A;const C=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function l(i){return i.indexOf(T)===-1?i:i.replace(C,(s,a,u,h)=>u?s:a||h||"")}e.$_j=l;function p(i){return i?i.replace(/\$\((.*?)\)/g,(s,a)=>` ${a} `).trim():""}e.$ak=p;const v=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(i){v.lastIndex=0;let s="";const a=[];let u=0;for(;;){const h=v.lastIndex,t=v.exec(i),r=i.substring(h,t?.index);if(r.length>0){s+=r;for(let c=0;c<r.length;c++)a.push(u)}if(!t)break;u+=t[0].length}return{text:s,iconOffsets:a}}e.$bk=n;function o(i,s,a=!1){const{text:u,iconOffsets:h}=s;if(!h||h.length===0)return(0,$.$Wj)(i,u,a);const t=(0,P.$Pe)(u," "),r=u.length-t.length,c=(0,$.$Wj)(i,t,a);if(c)for(const f of c){const w=h[f.start+r]+r;f.start+=w,f.end+=w}return c}e.$ck=o}),define(Re[51],Ae([1,0,24,2]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function I(g){return JSON.stringify(g,M)}e.$wh=I;function T(g){let b=JSON.parse(g);return b=m(b),b}e.$xh=T;function M(g,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function m(g,b=0){if(!g||b>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return P.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof $.$ge||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let A=0;A<g.length;++A)g[A]=m(g[A],b+1);else for(const A in g)Object.hasOwnProperty.call(g,A)&&(g[A]=m(g[A],b+1))}return g}e.$yh=m}),define(Re[13],Ae([1,0,11,21,12,2]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var M;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={}));function m(l,p){return T.URI.isUri(l)?(0,I.$8e)(l.scheme,p):(0,I.$9e)(l,p+":")}e.$ag=m;function g(l,...p){return p.some(v=>m(l,v))}e.$bg=g,e.$cg="vscode-tkn",e.$dg="tkn";class b{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${M.vscodeRemoteResource}`}set(p,v,n){this.a[p]=v,this.b[p]=n}setConnectionToken(p,v){this.c[p]=v}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(a){return $.$1(a),p}const v=p.authority;let n=this.a[v];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const o=this.b[v],i=this.c[v];let s=`path=${encodeURIComponent(p.path)}`;return typeof i=="string"&&(s+=`&${e.$dg}=${encodeURIComponent(i)}`),T.URI.from({scheme:P.$i?this.d:M.vscodeRemoteResource,authority:`${n}:${o}`,path:P.$i?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:s})}}e.$eg=new b,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class A{asBrowserUri(p){const v=this.b(p,ie);return this.uriToBrowserUri(v)}uriToBrowserUri(p){return p.scheme===M.vscodeRemote?e.$eg.rewrite(p):p.scheme===M.file&&(P.$g||P.$k===`${M.vscodeFileResource}://${A.a}`)?p.with({scheme:M.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const v=this.b(p,ie);return this.uriToFileUri(v)}uriToFileUri(p){return p.scheme===M.vscodeFileResource?p.with({scheme:M.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,v){return T.URI.isUri(p)?p:T.URI.parse(v.toUrl(p))}}A.a=e.$jg,e.$kg=new A;var C;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const v="vscode-coi";function n(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:T.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const a=s?.get(v);if(a)return p.get(a)}l.getHeadersFromQuery=n;function o(i,s,a){if(!globalThis.crossOriginIsolated)return;const u=s&&a?"3":a?"2":"1";i instanceof URLSearchParams?i.set(v,u):i[v]=u}l.addSearchParam=o})(C||(e.COI=C={}))}),define(Re[25],Ae([1,0,45,13,19,21,12,2]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function g(p){return(0,m.$wc)(p,!0)}e.$rg=g;class b{constructor(v){this.a=v}compare(v,n,o=!1){return v===n?0:(0,M.$1e)(this.getComparisonKey(v,o),this.getComparisonKey(n,o))}isEqual(v,n,o=!1){return v===n?!0:!v||!n?!1:this.getComparisonKey(v,o)===this.getComparisonKey(n,o)}getComparisonKey(v,n=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,n,o=!1){if(v.scheme===n.scheme){if(v.scheme===P.Schemas.file)return $.$4f(g(v),g(n),this.a(v))&&v.query===n.query&&(o||v.fragment===n.fragment);if((0,e.$Ig)(v.authority,n.authority))return $.$4f(v.path,n.path,this.a(v),"/")&&v.query===n.query&&(o||v.fragment===n.fragment)}return!1}joinPath(v,...n){return m.URI.joinPath(v,...n)}basenameOrAuthority(v){return(0,e.$Ag)(v)||v.authority}basename(v){return I.$gc.basename(v.path)}extname(v){return I.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let n;return v.scheme===P.Schemas.file?n=m.URI.file(I.$mc(g(v))).path:(n=I.$gc.dirname(v.path),v.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),n="/")),v.with({path:n})}normalizePath(v){if(!v.path.length)return v;let n;return v.scheme===P.Schemas.file?n=m.URI.file(I.$hc(g(v))).path:n=I.$gc.normalize(v.path),v.with({path:n})}relativePath(v,n){if(v.scheme!==n.scheme||!(0,e.$Ig)(v.authority,n.authority))return;if(v.scheme===P.Schemas.file){const s=I.$lc(g(v),g(n));return T.$c?$.$Xf(s):s}let o=v.path||"/";const i=n.path||"/";if(this.a(v)){let s=0;for(const a=Math.min(o.length,i.length);s<a&&!(o.charCodeAt(s)!==i.charCodeAt(s)&&o.charAt(s).toLowerCase()!==i.charAt(s).toLowerCase());s++);o=i.substr(0,s)+o.substr(s)}return I.$gc.relative(o,i)}resolvePath(v,n){if(v.scheme===P.Schemas.file){const o=m.URI.file(I.$kc(g(v),n));return v.with({authority:o.authority,path:o.path})}return n=$.$Yf(n),v.with({path:I.$gc.resolve(v.path,n)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,n){return v===n||v!==void 0&&n!==void 0&&(0,M.$8e)(v,n)}hasTrailingPathSeparator(v,n=I.sep){if(v.scheme===P.Schemas.file){const o=g(v);return o.length>$.$Zf(o).length&&o[o.length-1]===n}else{const o=v.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,n=I.sep){return(0,e.$Jg)(v,n)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,n=I.sep){let o=!1;if(v.scheme===P.Schemas.file){const i=g(v);o=i!==void 0&&i.length===$.$Zf(i).length&&i[i.length-1]===n}else{n="/";const i=v.path;o=i.length===1&&i.charCodeAt(i.length-1)===47}return!o&&!(0,e.$Jg)(v,n)?v.with({path:v.path+"/"}):v}}e.$sg=b,e.$tg=new b(()=>!1),e.$ug=new b(p=>p.scheme===P.Schemas.file?!T.$e:!0),e.$vg=new b(p=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function A(p,v){const n=[];for(let o=0;o<p.length;o++){const i=v(p[o]);p.some((s,a)=>a===o?!1:(0,e.$xg)(i,v(s)))||n.push(p[o])}return n}e.$Mg=A;var C;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function v(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(a=>{const[u,h]=a.split(":");u&&h&&o.set(u,h)});const s=n.path.substring(0,n.path.indexOf(";"));return s&&o.set(p.META_DATA_MIME,s),o}p.parseMetaData=v})(C||(e.DataUri=C={}));function l(p,v,n){if(v){let o=p.path;return o&&o[0]!==I.$gc.sep&&(o=I.$gc.sep+o),p.with({scheme:n,authority:v,path:o})}return p.with({scheme:n})}e.$Ng=l}),define(Re[14],Ae([1,0,20,11,5,6,25,21,126,39]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function A(ce){return!!ce&&typeof ce.then=="function"}e.$Og=A;function C(ce){const _=new $.$3d,H=ce(_.token),te=new Promise((we,be)=>{const Fe=_.token.onCancellationRequested(()=>{Fe.dispose(),_.dispose(),be(new P.$5)});Promise.resolve(H).then(pe=>{Fe.dispose(),_.dispose(),we(pe)},pe=>{Fe.dispose(),_.dispose(),be(pe)})});return new class{cancel(){_.cancel()}then(we,be){return te.then(we,be)}catch(we){return this.then(void 0,we)}finally(we){return te.finally(we)}}}e.$Pg=C;function l(ce,_,H){return new Promise((te,we)=>{const be=_.onCancellationRequested(()=>{be.dispose(),te(H)});ce.then(te,we).finally(()=>be.dispose())})}e.$Qg=l;function p(ce,_){return new Promise((H,te)=>{const we=_.onCancellationRequested(()=>{we.dispose(),te(new P.$5)});ce.then(H,te).finally(()=>we.dispose())})}e.$Rg=p;async function v(ce){let _=-1;const H=ce.map((te,we)=>te.then(be=>(_=we,be)));try{return await Promise.race(H)}finally{ce.forEach((te,we)=>{we!==_&&te.cancel()})}}e.$Sg=v;function n(ce,_,H){let te;const we=setTimeout(()=>{te?.(void 0),H?.()},_);return Promise.race([ce.finally(()=>clearTimeout(we)),new Promise(be=>te=be)])}e.$Tg=n;function o(ce){return new Promise((_,H)=>{const te=ce();A(te)?te.then(_,H):_(te)})}e.$Ug=o;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(_){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=_,!this.b){const H=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(H,H).then(te)})}return new Promise((H,te)=>{this.b.then(H,te)})}return this.a=_(),new Promise((H,te)=>{this.a.then(we=>{this.a=null,H(we)},we=>{this.a=null,te(we)})})}dispose(){this.f=!0}}e.$Vg=i;class s{constructor(){this.a=Promise.resolve(null)}queue(_){return this.a=this.a.then(()=>_(),()=>_())}}e.$Wg=s;class a{constructor(){this.a=new Map}queue(_,H){const we=(this.a.get(_)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(_)===we&&this.a.delete(_)});return this.a.set(_,we),we}}e.$Xg=a;const u=(ce,_)=>{let H=!0;const te=setTimeout(()=>{H=!1,_()},ce);return{isTriggered:()=>H,dispose:()=>{clearTimeout(te),H=!1}}},h=ce=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,ce())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};class t{constructor(_){this.defaultDelay=_,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(_,H=this.defaultDelay){this.g=_,this.h(),this.b||(this.b=new Promise((we,be)=>{this.d=we,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=H===g.$Pd?h(te):u(H,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=t;class r{constructor(_){this.a=new t(_),this.b=new i}trigger(_,H){return this.a.trigger(()=>this.b.queue(_),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=r;class c{constructor(){this.a=!1,this.b=new Promise((_,H)=>{this.d=_})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=c;class f extends c{constructor(_){super(),this.f=setTimeout(()=>this.open(),_)}open(){clearTimeout(this.f),super.open()}}e.$2g=f;function w(ce,_){return _?new Promise((H,te)=>{const we=setTimeout(()=>{be.dispose(),H()},ce),be=_.onCancellationRequested(()=>{clearTimeout(we),be.dispose(),te(new P.$5)})}):C(H=>w(ce,H))}e.$3g=w;function d(ce,_=0,H){const te=setTimeout(()=>{ce(),H&&we.dispose()},_),we=(0,T.$Qc)(()=>{clearTimeout(te),H?.deleteAndLeak(we)});return H?.add(we),we}e.$4g=d;function D(ce){const _=[];let H=0;const te=ce.length;function we(){return H<te?ce[H++]():null}function be(Fe){Fe!=null&&_.push(Fe);const pe=we();return pe?pe.then(be):Promise.resolve(_)}return Promise.resolve(null).then(be)}e.$5g=D;function L(ce,_=te=>!!te,H=null){let te=0;const we=ce.length,be=()=>{if(te>=we)return Promise.resolve(H);const Fe=ce[te++];return Promise.resolve(Fe()).then(Se=>_(Se)?Promise.resolve(Se):be())};return be()}e.$6g=L;function y(ce,_=te=>!!te,H=null){if(ce.length===0)return Promise.resolve(H);let te=ce.length;const we=()=>{te=-1;for(const be of ce)be.cancel?.()};return new Promise((be,Fe)=>{for(const pe of ce)pe.then(Se=>{--te>=0&&_(Se)?(we(),be(Se)):te===0&&be(H)}).catch(Se=>{--te>=0&&(we(),Fe(Se))})})}e.$7g=y;class E{constructor(_){this.a=0,this.d=_,this.f=[],this.b=0,this.g=new I.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(_){return this.a++,new Promise((H,te)=>{this.f.push({factory:_,c:H,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const _=this.f.shift();this.b++;const H=_.factory();H.then(_.c,_.e),H.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=E;class k extends E{constructor(){super(1)}}e.$9g=k;class F{constructor(){this.a=new fe,this.b=0}queue(_){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,_())):this.a.run(this.b++,_())}}e.$0g=F;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const _=new ne;return this.b.add(_),_.p}g(){for(const[,_]of this.a)if(_.size>0)return!1;return!0}queueFor(_,H=M.$tg){const te=H.getComparisonKey(_);let we=this.a.get(te);if(!we){we=new k;const be=this.f++,Fe=I.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$2c),this.d.set(be,Fe),this.a.set(te,we)}return we}h(){this.g()&&this.j()}j(){for(const _ of this.b)_.complete();this.b.clear()}dispose(){for(const[,_]of this.a)_.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=B;class ee{constructor(_,H){this.a=-1,typeof _=="function"&&typeof H=="number"&&this.setIfNotSet(_,H)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(_,H){this.cancel(),this.a=setTimeout(()=>{this.a=-1,_()},H)}setIfNotSet(_,H){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,_()},H))}}e.$_g=ee;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(_,H,te=globalThis){this.cancel();const we=te.setInterval(()=>{_()},H);this.d=(0,T.$Qc)(()=>{te.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$ah=J;class V{constructor(_,H){this.b=-1,this.a=_,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(_=this.d){this.cancel(),this.b=setTimeout(this.f,_)}get delay(){return this.d}set delay(_){this.d=_}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=V;class R{constructor(_,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=_,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(_=this.b){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(_/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=R;class S extends V{constructor(_,H){super(_,H),this.j=[]}work(_){this.j.push(_),this.isScheduled()||this.schedule()}h(){const _=this.j;this.j=[],this.a?.(_)}dispose(){this.j=[],super.dispose()}}e.$dh=S;class O extends T.$Sc{constructor(_,H){super(),this.g=_,this.h=H,this.a=[],this.b=this.B(new T.$Tc),this.f=!1}get pending(){return this.a.length}work(_){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+_.length>this.g.maxBufferedWork)return!1}else if(this.pending+_.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of _)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(ce,_)=>{(0,m.$v)(()=>{if(H)return;const te=Date.now()+15;_(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$gh=(ce,_,H)=>{const te=ce.requestIdleCallback(_,typeof H=="number"?{timeout:H}:void 0);let we=!1;return{dispose(){we||(we=!0,ce.cancelIdleCallback(te))}}},e.$fh=ce=>(0,e.$gh)(globalThis,ce)}();class Q{constructor(_,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$gh)(_,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=Q;class re extends Q{constructor(_){super(globalThis,_)}}e.$ih=re;async function he(ce,_,H){let te;for(let we=0;we<H;we++)try{return await ce()}catch(be){te=be,await w(_)}throw te}e.$jh=he;class fe{isRunning(_){return typeof _=="number"?this.a?.taskId===_:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(_,H,te){return this.a={taskId:_,cancel:()=>te?.(),promise:H},H.then(()=>this.d(_),()=>this.d(_)),H}d(_){this.a&&_===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const _=this.b;this.b=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}queue(_){if(this.b)this.b.run=_;else{let H,te;const we=new Promise((be,Fe)=>{H=be,te=Fe});this.b={run:_,promise:we,promiseResolve:H,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=fe;class ue{constructor(_,H=()=>Date.now()){this.d=_,this.f=H,this.a=0,this.b=0}increment(){const _=this.f();return _-this.a>this.d&&(this.a=_,this.b=0),this.b++,this.b}}e.$lh=ue;var $e;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})($e||($e={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((_,H)=>{this.a=_,this.b=H})}complete(_){return new Promise(H=>{this.a(_),this.d={outcome:0,value:_},H()})}error(_){return new Promise(H=>{this.b(_),this.d={outcome:1,value:_},H()})}cancel(){return this.error(new P.$5)}}e.$mh=ne;var Pe;(function(ce){async function _(te){let we;const be=await Promise.all(te.map(Fe=>Fe.then(pe=>pe,pe=>{we||(we=pe)})));if(typeof we<"u")throw we;return be}ce.settled=_;function H(te){return new Promise(async(we,be)=>{try{await te(we,be)}catch(Fe){be(Fe)}})}ce.withAsyncBody=H})(Pe||(e.Promises=Pe={}));class le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(_){this.a=void 0,this.b=void 0,this.d=!1,this.promise=_.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new P.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=le;class me{constructor(_){this.b=_,this.a=new b.$V(()=>new le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=me;var W;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(W||(W={}));class ae{static fromArray(_){return new ae(H=>{H.emitMany(_)})}static fromPromise(_){return new ae(async H=>{H.emitMany(await _)})}static fromPromises(_){return new ae(async H=>{await Promise.all(_.map(async te=>H.emitOne(await te)))})}static merge(_){return new ae(async H=>{await Promise.all(_.map(async te=>{for await(const we of te)H.emitOne(we)}))})}constructor(_){this.a=0,this.b=[],this.d=null,this.f=new I.$Sd,queueMicrotask(async()=>{const H={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(_(H)),this.j()}catch(te){this.k(te)}finally{H.emitOne=void 0,H.emitMany=void 0,H.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(_<this.b.length)return{done:!1,value:this.b[_++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(_,H){return new ae(async te=>{for await(const we of _)te.emitOne(H(we))})}map(_){return ae.map(this,_)}static filter(_,H){return new ae(async te=>{for await(const we of _)H(we)&&te.emitOne(we)})}filter(_){return ae.filter(this,_)}static coalesce(_){return ae.filter(_,H=>!!H)}coalesce(){return ae.coalesce(this)}static async toPromise(_){const H=[];for await(const te of _)H.push(te);return H}toPromise(){return ae.toPromise(this)}g(_){this.a===0&&(this.b.push(_),this.f.fire())}h(_){this.a===0&&(this.b=this.b.concat(_),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(_){this.a===0&&(this.a=2,this.d=_,this.f.fire())}}e.$ph=ae,ae.EMPTY=ae.fromArray([]);class de extends ae{constructor(_,H){super(H),this.l=_}cancel(){this.l.cancel()}}e.$qh=de;function ke(ce){const _=new $.$3d,H=ce(_.token);return new de(_,async te=>{const we=_.token.onCancellationRequested(()=>{we.dispose(),_.dispose(),te.reject(new P.$5)});try{for await(const be of H){if(_.token.isCancellationRequested)return;te.emitOne(be)}we.dispose(),_.dispose()}catch(be){we.dispose(),_.dispose(),te.reject(be)}})}e.$rh=ke;class Ee{constructor(){this.a=new ne,this.b=new ae(te=>{if(_){te.reject(_);return}return H&&te.emitMany(H),this.d=we=>te.reject(we),this.f=we=>te.emitOne(we),this.a.p});let _,H;this.f=te=>{H||(H=[]),H.push(te)},this.d=te=>{_||(_=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(_){this.d(_),this.a.complete()}emitOne(_){this.f(_)}}e.$sh=Ee}),define(Re[33],Ae([1,0,18,14,45,28,19,21,12]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function b(){return Object.create(null)}e.$Dj=b,e.$Ej="**",e.$Fj="/";const A="[/\\\\]",C="[^/\\\\]",l=/\//g;function p(re,he){switch(re){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}${he?`|${A}${C}+`:""})*?`}}function v(re,he){if(!re)return[];const fe=[];let ue=!1,$e=!1,ne="";for(const Pe of re){switch(Pe){case he:if(!ue&&!$e){fe.push(ne),ne="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}ne+=Pe}return ne&&fe.push(ne),fe}e.$Gj=v;function n(re){if(!re)return"";let he="";const fe=v(re,e.$Fj);if(fe.every(ue=>ue===e.$Ej))he=".*";else{let ue=!1;fe.forEach(($e,ne)=>{if($e===e.$Ej){if(ue)return;he+=p(2,ne===fe.length-1)}else{let Pe=!1,le="",me=!1,W="";for(const ae of $e){if(ae!=="}"&&Pe){le+=ae;continue}if(me&&(ae!=="]"||!W)){let de;ae==="-"?de=ae:(ae==="^"||ae==="!")&&!W?de="^":ae===e.$Fj?de="":de=(0,g.$Ke)(ae),W+=de;continue}switch(ae){case"{":Pe=!0;continue;case"[":me=!0;continue;case"}":{const ke=`(?:${v(le,",").map(Ee=>n(Ee)).join("|")})`;he+=ke,Pe=!1,le="";break}case"]":{he+="["+W+"]",me=!1,W="";break}case"?":he+=C;continue;case"*":he+=p(1);continue;default:he+=(0,g.$Ke)(ae)}}ne<fe.length-1&&(fe[ne+1]!==e.$Ej||ne+2<fe.length)&&(he+=A)}ue=$e===e.$Ej})}return he}const o=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,s=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.$Dc(1e4),r=function(){return!1},c=function(){return null};function f(re,he){if(!re)return c;let fe;typeof re!="string"?fe=re.pattern:fe=re,fe=fe.trim();const ue=`${fe}_${!!he.trimForExclusions}`;let $e=t.get(ue);if($e)return w($e,re);let ne;return o.test(fe)?$e=D(fe.substr(4),fe):(ne=i.exec(d(fe,he)))?$e=L(ne[1],fe):(he.trimForExclusions?a:s).test(fe)?$e=y(fe,he):(ne=u.exec(d(fe,he)))?$e=E(ne[1].substr(1),fe,!0):(ne=h.exec(d(fe,he)))?$e=E(ne[1],fe,!1):$e=k(fe),t.set(ue,$e),w($e,re)}function w(re,he){if(typeof he=="string")return re;const fe=function(ue,$e){return(0,I.$4f)(ue,he.base,!m.$e)?re((0,g.$Pe)(ue.substr(he.base.length),M.sep),$e):null};return fe.allBasenames=re.allBasenames,fe.allPaths=re.allPaths,fe.basenames=re.basenames,fe.patterns=re.patterns,fe}function d(re,he){return he.trimForExclusions&&re.endsWith("/**")?re.substr(0,re.length-2):re}function D(re,he){return function(fe,ue){return typeof fe=="string"&&fe.endsWith(re)?he:null}}function L(re,he){const fe=`/${re}`,ue=`\\${re}`,$e=function(Pe,le){return typeof Pe!="string"?null:le?le===re?he:null:Pe===re||Pe.endsWith(fe)||Pe.endsWith(ue)?he:null},ne=[re];return $e.basenames=ne,$e.patterns=[he],$e.allBasenames=ne,$e}function y(re,he){const fe=O(re.slice(1,-1).split(",").map(le=>f(le,he)).filter(le=>le!==c),re),ue=fe.length;if(!ue)return c;if(ue===1)return fe[0];const $e=function(le,me){for(let W=0,ae=fe.length;W<ae;W++)if(fe[W](le,me))return re;return null},ne=fe.find(le=>!!le.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const Pe=fe.reduce((le,me)=>me.allPaths?le.concat(me.allPaths):le,[]);return Pe.length&&($e.allPaths=Pe),$e}function E(re,he,fe){const ue=M.sep===M.$gc.sep,$e=ue?re:re.replace(l,M.sep),ne=M.sep+$e,Pe=M.$gc.sep+re;let le;return fe?le=function(me,W){return typeof me=="string"&&(me===$e||me.endsWith(ne)||!ue&&(me===re||me.endsWith(Pe)))?he:null}:le=function(me,W){return typeof me=="string"&&(me===$e||!ue&&me===re)?he:null},le.allPaths=[(fe?"*/":"./")+re],le}function k(re){try{const he=new RegExp(`^${n(re)}$`);return function(fe){return he.lastIndex=0,typeof fe=="string"&&he.test(fe)?re:null}}catch{return c}}function F(re,he,fe){return!re||typeof he!="string"?!1:B(re)(he,void 0,fe)}e.$Hj=F;function B(re,he={}){if(!re)return r;if(typeof re=="string"||ee(re)){const fe=f(re,he);if(fe===c)return r;const ue=function($e,ne){return!!fe($e,ne)};return fe.allBasenames&&(ue.allBasenames=fe.allBasenames),fe.allPaths&&(ue.allPaths=fe.allPaths),ue}return R(re,he)}e.$Ij=B;function ee(re){const he=re;return he?typeof he.base=="string"&&typeof he.pattern=="string":!1}e.$Jj=ee;function J(re){return re.allBasenames||[]}e.$Kj=J;function V(re){return re.allPaths||[]}e.$Lj=V;function R(re,he){const fe=O(Object.getOwnPropertyNames(re).map(le=>S(le,re[le],he)).filter(le=>le!==c)),ue=fe.length;if(!ue)return c;if(!fe.some(le=>!!le.requiresSiblings)){if(ue===1)return fe[0];const le=function(ae,de){let ke;for(let Ee=0,ce=fe.length;Ee<ce;Ee++){const _=fe[Ee](ae,de);if(typeof _=="string")return _;(0,P.$Og)(_)&&(ke||(ke=[]),ke.push(_))}return ke?(async()=>{for(const Ee of ke){const ce=await Ee;if(typeof ce=="string")return ce}return null})():null},me=fe.find(ae=>!!ae.allBasenames);me&&(le.allBasenames=me.allBasenames);const W=fe.reduce((ae,de)=>de.allPaths?ae.concat(de.allPaths):ae,[]);return W.length&&(le.allPaths=W),le}const $e=function(le,me,W){let ae,de;for(let ke=0,Ee=fe.length;ke<Ee;ke++){const ce=fe[ke];ce.requiresSiblings&&W&&(me||(me=(0,M.$nc)(le)),ae||(ae=me.substr(0,me.length-(0,M.$oc)(le).length)));const _=ce(le,me,ae,W);if(typeof _=="string")return _;(0,P.$Og)(_)&&(de||(de=[]),de.push(_))}return de?(async()=>{for(const ke of de){const Ee=await ke;if(typeof Ee=="string")return Ee}return null})():null},ne=fe.find(le=>!!le.allBasenames);ne&&($e.allBasenames=ne.allBasenames);const Pe=fe.reduce((le,me)=>me.allPaths?le.concat(me.allPaths):le,[]);return Pe.length&&($e.allPaths=Pe),$e}function S(re,he,fe){if(he===!1)return c;const ue=f(re,fe);if(ue===c)return c;if(typeof he=="boolean")return ue;if(he){const $e=he.when;if(typeof $e=="string"){const ne=(Pe,le,me,W)=>{if(!W||!ue(Pe,le))return null;const ae=$e.replace("$(basename)",()=>me),de=W(ae);return(0,P.$Og)(de)?de.then(ke=>ke?re:null):de?re:null};return ne.requiresSiblings=!0,ne}}return ue}function O(re,he){const fe=re.filter(le=>!!le.basenames);if(fe.length<2)return re;const ue=fe.reduce((le,me)=>{const W=me.basenames;return W?le.concat(W):le},[]);let $e;if(he){$e=[];for(let le=0,me=ue.length;le<me;le++)$e.push(he)}else $e=fe.reduce((le,me)=>{const W=me.patterns;return W?le.concat(W):le},[]);const ne=function(le,me){if(typeof le!="string")return null;if(!me){let ae;for(ae=le.length;ae>0;ae--){const de=le.charCodeAt(ae-1);if(de===47||de===92)break}me=le.substr(ae)}const W=ue.indexOf(me);return W!==-1?$e[W]:null};ne.basenames=ue,ne.patterns=$e,ne.allBasenames=ue;const Pe=re.filter(le=>!le.basenames);return Pe.push(ne),Pe}function Q(re,he){return(0,$.$ub)(re,he,(fe,ue)=>typeof fe=="string"&&typeof ue=="string"?fe===ue:typeof fe!="string"&&typeof ue!="string"?fe.base===ue.base&&fe.pattern===ue.pattern:!1)}e.$Mj=Q}),define(Re[52],Ae([1,0,11,127,25,12,2]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class g{constructor(i="",s=!1){if(this.value=i,typeof this.value!="string")throw(0,$.$7)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(i,s=0){return this.value+=l(this.supportThemeIcons?(0,P.$0j)(i):i).replace(/([ \t]+)/g,(a,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,s){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(i,s,a){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(i),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(i,s){const a=new RegExp((0,T.$Ke)(s),"g");return i.replace(a,(u,h)=>i.charAt(h-1)!=="\\"?`\\${u}`:u)}}e.$dk=g;function b(o){return A(o)?!o.value:Array.isArray(o)?o.every(b):!0}e.$ek=b;function A(o){return o instanceof g?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$fk=A;function C(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,I.$wg)(M.URI.from(o.baseUri),M.URI.from(i.baseUri)))}e.$gk=C;function l(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$hk=l;function p(o){return o.replace(/"/g,"&quot;")}e.$ik=p;function v(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$jk=v;function n(o){const i=[],s=o.split("|").map(u=>u.trim());o=s[0];const a=s[1];if(a){const u=/height=(\d+)/.exec(a),h=/width=(\d+)/.exec(a),t=u?u[1]:"",r=h?h[1]:"",c=isFinite(parseInt(r)),f=isFinite(parseInt(t));c&&i.push(`width="${r}"`),f&&i.push(`height="${t}"`)}return{href:o,dimensions:i}}e.$kk=n}),define(Re[91],Ae([1,0,18,45,19,21,25,12]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=void 0;function g(f,w){const{os:d,tildify:D,relative:L}=w;if(L){const k=b(f,L,d);if(typeof k=="string")return k}let y=f.fsPath;if(d===1&&!T.$c?y=y.replace(/\//g,"\\"):d!==1&&T.$c&&(y=y.replace(/\\/g,"/")),d!==1&&D?.userHome){const k=D.userHome.fsPath;let F;f.scheme!==D.userHome.scheme&&f.path[0]===I.$gc.sep&&f.path[1]!==I.$gc.sep?F=D.userHome.with({path:f.path}).fsPath:F=y,y=l(F,k,d)}return(d===1?I.$fc:I.$gc).normalize(A(y,d===1))}e.$Hv=g;function b(f,w,d){const D=d===1?I.$fc:I.$gc,L=d===3?M.$tg:M.$vg,y=w.getWorkspace(),E=(0,$.$Ob)(y.folders);if(!E)return;f.scheme!==E.uri.scheme&&f.path[0]===I.$gc.sep&&f.path[1]!==I.$gc.sep&&(f=E.uri.with({path:f.path}));const k=w.getWorkspaceFolder(f);if(!k)return;let F;if(L.isEqual(k.uri,f)?F="":F=L.relativePath(k.uri,f)??"",F&&(F=D.normalize(F)),y.folders.length>1&&!w.noPrefix){const B=k.name?k.name:L.basenameOrAuthority(k.uri);F=F?`${B} \u2022 ${F}`:B}return F}function A(f,w=T.$c){return(0,P.$8f)(f,w)?f.charAt(0).toUpperCase()+f.slice(1):f}e.$Iv=A;let C=Object.create(null);function l(f,w,d=T.OS){if(d===1||!f||!w)return f;let D=C.original===w?C.normalized:void 0;D||(D=w,T.$c&&(D=(0,P.$Xf)(D)),D=`${(0,m.$Qe)(D,I.$gc.sep)}${I.$gc.sep}`,C={original:w,normalized:D});let L=f;return T.$c&&(L=(0,P.$Xf)(L)),(d===3?L.startsWith(D):(0,m.$9e)(L,D))?`~/${L.substr(D.length)}`:f}e.$Jv=l;function p(f,w){return f.replace(/^~($|\/|\\)/,`${w}$1`)}e.$Kv=p;const v="\u2026",n="\\\\",o="~";function i(f,w=I.sep){const d=new Array(f.length);let D=!1;for(let L=0;L<f.length;L++){const y=f[L];if(y===""){d[L]=`.${w}`;continue}if(!y){d[L]=y;continue}D=!0;let E="",k=y;k.indexOf(n)===0?(E=k.substr(0,k.indexOf(n)+n.length),k=k.substr(k.indexOf(n)+n.length)):k.indexOf(w)===0?(E=k.substr(0,k.indexOf(w)+w.length),k=k.substr(k.indexOf(w)+w.length)):k.indexOf(o)===0&&(E=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length));const F=k.split(w);for(let B=1;D&&B<=F.length;B++)for(let ee=F.length-B;D&&ee>=0;ee--){D=!1;let J=F.slice(ee,ee+B).join(w);for(let V=0;!D&&V<f.length;V++)if(V!==L&&f[V]&&f[V].indexOf(J)>-1){const R=ee+B===F.length,S=ee>0&&f[V].indexOf(w)>-1?w+J:J,O=f[V].endsWith(S);D=!R||O}if(!D){let V="";(F[0].endsWith(":")||E!=="")&&(ee===1&&(ee=0,B++,J=F[0]+w+J),ee>0&&(V=F[0]+w),V=E+V),ee>0&&(V=V+v+w),V=V+J,ee+B<F.length&&(V=V+w+v),d[L]=V}}D&&(d[L]=y)}return d}e.$Lv=i;var s;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function a(f,w=Object.create(null)){const d=[];let D=!1,L="";for(const y of f)if(y==="$"||D&&y==="{")L&&d.push({value:L,type:s.TEXT}),L="",D=!0;else if(y==="}"&&D){const E=w[L];if(typeof E=="string")E.length&&d.push({value:E,type:s.VARIABLE});else if(E){const k=d[d.length-1];(!k||k.type!==s.SEPARATOR)&&d.push({value:E.label,type:s.SEPARATOR})}L="",D=!1}else L+=y;return L&&!D&&d.push({value:L,type:s.TEXT}),d.filter((y,E)=>{if(y.type===s.SEPARATOR){const k=d[E-1],F=d[E+1];return[k,F].every(B=>B&&(B.type===s.VARIABLE||B.type===s.TEXT)&&B.value.length>0)}return!0}).map(y=>y.value).join("")}e.$Mv=a;function u(f,w){return T.$d||w?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$d?"&":"&&"):f.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$Nv=u;function h(f,w){return T.$d||w?f.replace(/\(&&\w\)|&&/g,""):T.$c?f.replace(/&&|&/g,d=>d==="&"?"&&":"&"):f.replace(/&&/g,"_")}e.$Ov=h;function t(f){return f.replace(/&/g,"&&")}e.$Pv=t;function r(f){if(f.endsWith("]")){const w=f.lastIndexOf(" [",f.length-2);if(w!==-1){const d=c(f.substring(0,w));return{name:d.name,parentPath:d.parentPath+f.substring(w)}}}return c(f)}e.$Qv=r;function c(f){const w=f.indexOf("/")!==-1?I.$gc:I.$fc,d=w.basename(f),D=w.dirname(f);return d.length?{name:d,parentPath:D}:{name:D,parentPath:""}}}),define(Re[128],Ae([1,0,24,2]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=void 0;function I(C){return C.toJSON()}class T{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:I(P.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:I(P.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:P.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Zm=T,e.$1m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function M(C,l,p){if(!C||p>200)return null;if(typeof C=="object"){if(C instanceof P.URI)return l.transformOutgoing(C);for(const v in C)if(Object.hasOwnProperty.call(C,v)){const n=M(C[v],l,p+1);n!==null&&(C[v]=n)}}return null}function m(C,l){const p=M(C,l,0);return p===null?C:p}e.$2m=m;function g(C,l,p,v){if(!C||v>200)return null;if(typeof C=="object"){if(C.$mid===1)return p?P.URI.revive(l.transformIncoming(C)):l.transformIncoming(C);if(C instanceof $.$ge)return null;for(const n in C)if(Object.hasOwnProperty.call(C,n)){const o=g(C[n],l,p,v+1);o!==null&&(C[n]=o)}}return null}function b(C,l){const p=g(C,l,!1,0);return p===null?C:p}e.$3m=b;function A(C,l){const p=g(C,l,!0,0);return p===null?C:p}e.$4m=A}),define(Re[34],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const $=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(I){return $.test(I)}e.$lg=P,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(m){for(let g=0;g<m.length;g++)m[g]=Math.floor(Math.random()*256);return m};const T=new Uint8Array(16),M=[];for(let m=0;m<256;m++)M.push(m.toString(16).padStart(2,"0"));return function(){I(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let g=0,b="";return b+=M[T[g++]],b+=M[T[g++]],b+=M[T[g++]],b+=M[T[g++]],b+="-",b+=M[T[g++]],b+=M[T[g++]],b+="-",b+=M[T[g++]],b+=M[T[g++]],b+="-",b+=M[T[g++]],b+=M[T[g++]],b+="-",b+=M[T[g++]],b+=M[T[g++]],b+=M[T[g++]],b+=M[T[g++]],b+=M[T[g++]],b+=M[T[g++]],b}}()}),define(Re[129],Ae([1,0,18,68,34]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.$at=void 0;function T(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$at=T;function M(C,l,p){const v={id:(0,I.$mg)(),name:C,uri:l,data:p};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$bt=M;class m{constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return P.Iterable.some(this,([v,n])=>n.asFile())&&p.push("files"),A(g(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const v=this.a.get(l);v?v.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const v of p)yield[l,v]}b(l){return g(l)}}e.$ct=m;function g(C){return C.toLowerCase()}function b(C,l){return A(g(C),l.map(g))}e.$dt=b;function A(C,l){if(C==="*/*")return l.length>0;if(l.includes(C))return!0;const p=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[v,n,o]=p;return o==="*"?l.some(i=>i.startsWith(n+"/")):!1}e.$et=Object.freeze({create:C=>(0,$.$Mb)(C.map(l=>l.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$et.split(C).filter(l=>!l.startsWith("#"))})}),define(Re[130],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.StringEOL=void 0;var $;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})($||(e.StringEOL=$={}));function P(I){let T=0,M=0,m=0,g=0;for(let b=0,A=I.length;b<A;b++){const C=I.charCodeAt(b);C===13?(T===0&&(M=b),T++,b+1<A&&I.charCodeAt(b+1)===10?(g|=2,b++):g|=3,m=b+1):C===10&&(g|=1,T===0&&(M=b),T++,m=b+1)}return T===0&&(M=I.length),[T,M,I.length-m,g]}e.$ht=P}),define(Re[131],Ae([1,0,12,21,24]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=e.$Zs=void 0;let T;function M(){return T||(T=new TextDecoder("UTF-16LE")),T}let m;function g(){return m||(m=new TextDecoder("UTF-16BE")),m}let b;function A(){return b||(b=P.$x()?M():g()),b}e.$Zs=A;function C(v,n,o){const i=new Uint16Array(v.buffer,n,o);return o>0&&(i[0]===65279||i[0]===65534)?l(v,n,o):M().decode(i)}e.$1s=C;function l(v,n,o){const i=[];let s=0;for(let a=0;a<o;a++){const u=I.$ie(v,n);n+=2,i[s++]=String.fromCharCode(u)}return i.join("")}class p{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return A().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||$.$_e(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let i=0;i<o;i++)this.b[this.d++]=n.charCodeAt(i)}}e.$2s=p}),define(Re[132],Ae([1,0,24,131]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=void 0;function I(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(b,A,C,l){this.oldPosition=b,this.oldText=A,this.newPosition=C,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(b){return 4+2*b.length}static c(b,A,C){const l=A.length;$.$le(b,l,C),C+=4;for(let p=0;p<l;p++)$.$je(b,A.charCodeAt(p),C),C+=2;return C}static d(b,A){const C=$.$ke(b,A);return A+=4,(0,P.$1s)(b,A,C)}writeSize(){return 4+4+T.a(this.oldText)+T.a(this.newText)}write(b,A){return $.$le(b,this.oldPosition,A),A+=4,$.$le(b,this.newPosition,A),A+=4,A=T.c(b,this.oldText,A),A=T.c(b,this.newText,A),A}static read(b,A,C){const l=$.$ke(b,A);A+=4;const p=$.$ke(b,A);A+=4;const v=T.d(b,A);A+=T.a(v);const n=T.d(b,A);return A+=T.a(n),C.push(new T(l,v,p,n)),A}}e.$3s=T;function M(g,b){return g===null||g.length===0?b:new m(g,b).compress()}e.$4s=M;class m{constructor(b,A){this.a=b,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let b=0,A=0,C=this.n(b),l=this.l(A);for(;b<this.f||A<this.h;){if(C===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(C),C=this.n(++b);continue}if(l.oldEnd<=C.newPosition){this.k(l),l=this.l(++A);continue}if(C.newEnd<=l.oldPosition){this.m(C),C=this.n(++b);continue}if(l.oldPosition<C.newPosition){const[i,s]=m.r(l,C.newPosition-l.oldPosition);this.k(i),l=s;continue}if(C.newPosition<l.oldPosition){const[i,s]=m.q(C,l.oldPosition-C.newPosition);this.m(i),C=s;continue}let n,o;if(l.oldEnd===C.newEnd)n=C,o=l,C=this.n(++b),l=this.l(++A);else if(l.oldEnd<C.newEnd){const[i,s]=m.q(C,l.oldLength);n=i,o=l,C=s,l=this.l(++A)}else{const[i,s]=m.r(l,C.newLength);n=C,o=i,C=this.n(++b),l=s}this.d[this.e++]=new T(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const p=m.s(this.d);return m.t(p)}k(b){this.d[this.e++]=m.o(this.g,b),this.j+=b.newLength-b.oldLength}l(b){return b<this.h?this.c[b]:null}m(b){this.d[this.e++]=m.p(this.j,b),this.g+=b.newLength-b.oldLength}n(b){return b<this.f?this.a[b]:null}static o(b,A){return new T(A.oldPosition-b,A.oldText,A.newPosition,A.newText)}static p(b,A){return new T(A.oldPosition,A.oldText,A.newPosition+b,A.newText)}static q(b,A){const C=b.newText.substr(0,A),l=b.newText.substr(A);return[new T(b.oldPosition,b.oldText,b.newPosition,C),new T(b.oldEnd,"",b.newPosition+A,l)]}static r(b,A){const C=b.oldText.substr(0,A),l=b.oldText.substr(A);return[new T(b.oldPosition,C,b.newPosition,b.newText),new T(b.oldPosition+A,l,b.newEnd,"")]}static s(b){if(b.length===0)return b;const A=[];let C=0,l=b[0];for(let p=1;p<b.length;p++){const v=b[p];l.oldEnd===v.oldPosition?l=new T(l.oldPosition,l.oldText+v.oldText,l.newPosition,l.newText+v.newText):(A[C++]=l,l=v)}return A[C++]=l,A}static t(b){if(b.length===0)return b;const A=[];let C=0;for(let l=0;l<b.length;l++){const p=b[l];p.oldText!==p.newText&&(A[C++]=p)}return A}}}),define(Re[133],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,e.$es={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[134],Ae([1,0,33,19]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=void 0;function I(T,M,m,g,b,A){if(Array.isArray(T)){let C=0;for(const l of T){const p=I(l,M,m,g,b,A);if(p===10)return p;p>C&&(C=p)}return C}else{if(typeof T=="string")return g?T==="*"?5:T===m?10:0:0;if(T){const{language:C,pattern:l,scheme:p,hasAccessToAllModels:v,notebookType:n}=T;if(!g&&!v)return 0;n&&b&&(M=b);let o=0;if(p)if(p===M.scheme)o=10;else if(p==="*")o=5;else return 0;if(C)if(C===m)o=10;else if(C==="*")o=Math.max(o,5);else return 0;if(n)if(n===A)o=10;else if(n==="*"&&A!==void 0)o=Math.max(o,5);else return 0;if(l){let i;if(typeof l=="string"?i=l:i={...l,base:(0,P.$hc)(l.base)},i===M.fsPath||(0,$.$Hj)(i,M.fsPath))o=10;else return 0}return o}else return 0}}e.$ot=I}),define(Re[135],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.$Et=e.IndentAction=void 0;var $;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})($||(e.IndentAction=$={}));class P{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let g=0,b=m.notIn.length;g<b;g++)switch(m.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,g){if(m.getTokenCount()===0)return!0;const b=m.findTokenIndexAtOffset(g-2),A=m.getStandardTokenType(b);return this.isOK(A)}g(m,g){for(let b=m;b<=g;b++){const A=String.fromCharCode(b);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Et=P;class I{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of m)T(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),T(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),T(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),T(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&T(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Ft=I;function T(M,m,g){M.has(m)?M.get(m).push(g):M.set(m,[g])}}),define(Re[136],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.NodeColor=e.$BB=void 0;class ${constructor(o,i){this.piece=o,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$CB)return I(this.right);let o=this;for(;o.parent!==e.$CB&&o.parent.left!==o;)o=o.parent;return o.parent===e.$CB?e.$CB:o.parent}prev(){if(this.left!==e.$CB)return T(this.left);let o=this;for(;o.parent!==e.$CB&&o.parent.right!==o;)o=o.parent;return o.parent===e.$CB?e.$CB:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$BB=$;var P;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(P||(e.NodeColor=P={})),e.$CB=new $(null,0),e.$CB.parent=e.$CB,e.$CB.left=e.$CB,e.$CB.right=e.$CB,e.$CB.color=0;function I(n){for(;n.left!==e.$CB;)n=n.left;return n}e.$DB=I;function T(n){for(;n.right!==e.$CB;)n=n.right;return n}e.$EB=T;function M(n){return n===e.$CB?0:n.size_left+n.piece.length+M(n.right)}function m(n){return n===e.$CB?0:n.lf_left+n.piece.lineFeedCnt+m(n.right)}function g(){e.$CB.parent=e.$CB}function b(n,o){const i=o.right;i.size_left+=o.size_left+(o.piece?o.piece.length:0),i.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=i.left,i.left!==e.$CB&&(i.left.parent=o),i.parent=o.parent,o.parent===e.$CB?n.root=i:o.parent.left===o?o.parent.left=i:o.parent.right=i,i.left=o,o.parent=i}e.$FB=b;function A(n,o){const i=o.left;o.left=i.right,i.right!==e.$CB&&(i.right.parent=o),i.parent=o.parent,o.size_left-=i.size_left+(i.piece?i.piece.length:0),o.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),o.parent===e.$CB?n.root=i:o===o.parent.right?o.parent.right=i:o.parent.left=i,i.right=o,o.parent=i}e.$GB=A;function C(n,o){let i,s;if(o.left===e.$CB?(s=o,i=s.right):o.right===e.$CB?(s=o,i=s.left):(s=I(o.right),i=s.right),s===n.root){n.root=i,i.color=0,o.detach(),g(),n.root.parent=e.$CB;return}const a=s.color===1;if(s===s.parent.left?s.parent.left=i:s.parent.right=i,s===o?(i.parent=s.parent,v(n,i)):(s.parent===o?i.parent=s:i.parent=s.parent,v(n,i),s.left=o.left,s.right=o.right,s.parent=o.parent,s.color=o.color,o===n.root?n.root=s:o===o.parent.left?o.parent.left=s:o.parent.right=s,s.left!==e.$CB&&(s.left.parent=s),s.right!==e.$CB&&(s.right.parent=s),s.size_left=o.size_left,s.lf_left=o.lf_left,v(n,s)),o.detach(),i.parent.left===i){const h=M(i),t=m(i);if(h!==i.parent.size_left||t!==i.parent.lf_left){const r=h-i.parent.size_left,c=t-i.parent.lf_left;i.parent.size_left=h,i.parent.lf_left=t,p(n,i.parent,r,c)}}if(v(n,i.parent),a){g();return}let u;for(;i!==n.root&&i.color===0;)i===i.parent.left?(u=i.parent.right,u.color===1&&(u.color=0,i.parent.color=1,b(n,i.parent),u=i.parent.right),u.left.color===0&&u.right.color===0?(u.color=1,i=i.parent):(u.right.color===0&&(u.left.color=0,u.color=1,A(n,u),u=i.parent.right),u.color=i.parent.color,i.parent.color=0,u.right.color=0,b(n,i.parent),i=n.root)):(u=i.parent.left,u.color===1&&(u.color=0,i.parent.color=1,A(n,i.parent),u=i.parent.left),u.left.color===0&&u.right.color===0?(u.color=1,i=i.parent):(u.left.color===0&&(u.right.color=0,u.color=1,b(n,u),u=i.parent.left),u.color=i.parent.color,i.parent.color=0,u.left.color=0,A(n,i.parent),i=n.root));i.color=0,g()}e.$HB=C;function l(n,o){for(v(n,o);o!==n.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const i=o.parent.parent.right;i.color===1?(o.parent.color=0,i.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,b(n,o)),o.parent.color=0,o.parent.parent.color=1,A(n,o.parent.parent))}else{const i=o.parent.parent.left;i.color===1?(o.parent.color=0,i.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(n,o)),o.parent.color=0,o.parent.parent.color=1,b(n,o.parent.parent))}n.root.color=0}e.$IB=l;function p(n,o,i,s){for(;o!==n.root&&o!==e.$CB;)o.parent.left===o&&(o.parent.size_left+=i,o.parent.lf_left+=s),o=o.parent}e.$JB=p;function v(n,o){let i=0,s=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,i=M(o.left)-o.size_left,s=m(o.left)-o.lf_left,o.size_left+=i,o.lf_left+=s;o!==n.root&&(i!==0||s!==0);)o.parent.left===o&&(o.parent.size_left+=i,o.parent.lf_left+=s),o=o.parent}}e.$KB=v}),define(Re[92],Ae([1,0,93,29,94,136,95]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VB=e.$UB=e.$TB=e.$SB=e.$RB=void 0;const m=65535;function g(i){let s;return i[i.length-1]<65536?s=new Uint16Array(i.length):s=new Uint32Array(i.length),s.set(i,0),s}class b{constructor(s,a,u,h,t){this.lineStarts=s,this.cr=a,this.lf=u,this.crlf=h,this.isBasicASCII=t}}function A(i,s=!0){const a=[0];let u=1;for(let h=0,t=i.length;h<t;h++){const r=i.charCodeAt(h);r===13?h+1<t&&i.charCodeAt(h+1)===10?(a[u++]=h+2,h++):a[u++]=h+1:r===10&&(a[u++]=h+1)}return s?g(a):a}e.$RB=A;function C(i,s){i.length=0,i[0]=0;let a=1,u=0,h=0,t=0,r=!0;for(let f=0,w=s.length;f<w;f++){const d=s.charCodeAt(f);d===13?f+1<w&&s.charCodeAt(f+1)===10?(t++,i[a++]=f+2,f++):(u++,i[a++]=f+1):d===10?(h++,i[a++]=f+1):r&&d!==9&&(d<32||d>126)&&(r=!1)}const c=new b(g(i),u,h,t,r);return i.length=0,c}e.$SB=C;class l{constructor(s,a,u,h,t){this.bufferIndex=s,this.start=a,this.end=u,this.lineFeedCnt=h,this.length=t}}e.$TB=l;class p{constructor(s,a){this.buffer=s,this.lineStarts=a}}e.$UB=p;class v{constructor(s,a){this.a=[],this.c=s,this.d=a,this.b=0,s.root!==T.$CB&&s.iterate(s.root,u=>(u!==T.$CB&&this.a.push(u.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class n{constructor(s){this.a=s,this.b=[]}get(s){for(let a=this.b.length-1;a>=0;a--){const u=this.b[a];if(u.nodeStartOffset<=s&&u.nodeStartOffset+u.node.piece.length>=s)return u}return null}get2(s){for(let a=this.b.length-1;a>=0;a--){const u=this.b[a];if(u.nodeStartLineNumber&&u.nodeStartLineNumber<s&&u.nodeStartLineNumber+u.node.piece.lineFeedCnt>=s)return u}return null}set(s){this.b.length>=this.a&&this.b.shift(),this.b.push(s)}validate(s){let a=!1;const u=this.b;for(let h=0;h<u.length;h++){const t=u[h];if(t.node.parent===null||t.nodeStartOffset>=s){u[h]=null,a=!0;continue}}if(a){const h=[];for(const t of u)t!==null&&h.push(t);this.b=h}}}class o{constructor(s,a,u){this.create(s,a,u)}create(s,a,u){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=T.$CB,this.b=1,this.c=0,this.d=a,this.e=a.length,this.f=u;let h=null;for(let t=0,r=s.length;t<r;t++)if(s[t].buffer.length>0){s[t].lineStarts||(s[t].lineStarts=A(s[t].buffer));const c=new l(t+1,{line:0,column:0},{line:s[t].lineStarts.length-1,column:s[t].buffer.length-s[t].lineStarts[s[t].lineStarts.length-1]},s[t].lineStarts.length-1,s[t].buffer.length);this.a.push(s[t]),h=this.S(h,c)}this.h=new n(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(s){const a=m,u=a-Math.floor(a/3),h=u*2;let t="",r=0;const c=[];if(this.iterate(this.root,f=>{const w=this.R(f),d=w.length;if(r<=u||r+d<h)return t+=w,r+=d,!0;const D=t.replace(/\r\n|\r|\n/g,s);return c.push(new p(D,A(D))),t=w,r=d,!0}),r>0){const f=t.replace(/\r\n|\r|\n/g,s);c.push(new p(f,A(f)))}this.create(c,s,!0)}getEOL(){return this.d}setEOL(s){this.d=s,this.e=this.d.length,this.normalizeEOL(s)}createSnapshot(s){return new v(this,s)}equal(s){if(this.getLength()!==s.getLength()||this.getLineCount()!==s.getLineCount())return!1;let a=0;return this.iterate(this.root,h=>{if(h===T.$CB)return!0;const t=this.R(h),r=t.length,c=s.G(a),f=s.G(a+r),w=s.getValueInRange2(c,f);return a+=r,t===w})}getOffsetAt(s,a){let u=0,h=this.root;for(;h!==T.$CB;)if(h.left!==T.$CB&&h.lf_left+1>=s)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=s){u+=h.size_left;const t=this.B(h,s-h.lf_left-2);return u+=t+a-1}else s-=h.lf_left+h.piece.lineFeedCnt,u+=h.size_left+h.piece.length,h=h.right;return u}getPositionAt(s){s=Math.floor(s),s=Math.max(0,s);let a=this.root,u=0;const h=s;for(;a!==T.$CB;)if(a.size_left!==0&&a.size_left>=s)a=a.left;else if(a.size_left+a.piece.length>=s){const t=this.A(a,s-a.size_left);if(u+=a.lf_left+t.index,t.index===0){const r=this.getOffsetAt(u+1,1),c=h-r;return new $.$Gs(u+1,c+1)}return new $.$Gs(u+1,t.remainder+1)}else if(s-=a.size_left+a.piece.length,u+=a.lf_left+a.piece.lineFeedCnt,a.right===T.$CB){const t=this.getOffsetAt(u+1,1),r=h-s-t;return new $.$Gs(u+1,r+1)}else a=a.right;return new $.$Gs(1,1)}getValueInRange(s,a){if(s.startLineNumber===s.endLineNumber&&s.startColumn===s.endColumn)return"";const u=this.H(s.startLineNumber,s.startColumn),h=this.H(s.endLineNumber,s.endColumn),t=this.getValueInRange2(u,h);return a?a!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,a):t}getValueInRange2(s,a){if(s.node===a.node){const c=s.node,f=this.a[c.piece.bufferIndex].buffer,w=this.u(c.piece.bufferIndex,c.piece.start);return f.substring(w+s.remainder,w+a.remainder)}let u=s.node;const h=this.a[u.piece.bufferIndex].buffer,t=this.u(u.piece.bufferIndex,u.piece.start);let r=h.substring(t+s.remainder,t+u.piece.length);for(u=u.next();u!==T.$CB;){const c=this.a[u.piece.bufferIndex].buffer,f=this.u(u.piece.bufferIndex,u.piece.start);if(u===a.node){r+=c.substring(f,f+a.remainder);break}else r+=c.substr(f,u.piece.length);u=u.next()}return r}getLinesContent(){const s=[];let a=0,u="",h=!1;return this.iterate(this.root,t=>{if(t===T.$CB)return!0;const r=t.piece;let c=r.length;if(c===0)return!0;const f=this.a[r.bufferIndex].buffer,w=this.a[r.bufferIndex].lineStarts,d=r.start.line,D=r.end.line;let L=w[d]+r.start.column;if(h&&(f.charCodeAt(L)===10&&(L++,c--),s[a++]=u,u="",h=!1,c===0))return!0;if(d===D)return!this.f&&f.charCodeAt(L+c-1)===13?(h=!0,u+=f.substr(L,c-1)):u+=f.substr(L,c),!0;u+=this.f?f.substring(L,Math.max(L,w[d+1]-this.e)):f.substring(L,w[d+1]).replace(/(\r\n|\r|\n)$/,""),s[a++]=u;for(let y=d+1;y<D;y++)u=this.f?f.substring(w[y],w[y+1]-this.e):f.substring(w[y],w[y+1]).replace(/(\r\n|\r|\n)$/,""),s[a++]=u;return!this.f&&f.charCodeAt(w[D]+r.end.column-1)===13?(h=!0,r.end.column===0?a--:u=f.substr(w[D],r.end.column-1)):u=f.substr(w[D],r.end.column),!0}),h&&(s[a++]=u,u=""),s[a++]=u,s}getLength(){return this.c}getLineCount(){return this.b}getLineContent(s){return this.j.lineNumber===s?this.j.value:(this.j.lineNumber=s,s===this.b?this.j.value=this.getLineRawContent(s):this.f?this.j.value=this.getLineRawContent(s,this.e):this.j.value=this.getLineRawContent(s).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(s){if(s.remainder===s.node.piece.length){const a=s.node.next();if(!a)return 0;const u=this.a[a.piece.bufferIndex],h=this.u(a.piece.bufferIndex,a.piece.start);return u.buffer.charCodeAt(h)}else{const a=this.a[s.node.piece.bufferIndex],h=this.u(s.node.piece.bufferIndex,s.node.piece.start)+s.remainder;return a.buffer.charCodeAt(h)}}getLineCharCode(s,a){const u=this.H(s,a+1);return this.l(u)}getLineLength(s){if(s===this.getLineCount()){const a=this.getOffsetAt(s,1);return this.getLength()-a}return this.getOffsetAt(s+1,1)-this.getOffsetAt(s,1)-this.e}getCharCode(s){const a=this.G(s);return this.l(a)}findMatchesInNode(s,a,u,h,t,r,c,f,w,d,D){const L=this.a[s.piece.bufferIndex],y=this.u(s.piece.bufferIndex,s.piece.start),E=this.u(s.piece.bufferIndex,t),k=this.u(s.piece.bufferIndex,r);let F;const B={line:0,column:0};let ee,J;a._wordSeparators?(ee=L.buffer.substring(E,k),J=V=>V+E,a.reset(0)):(ee=L.buffer,J=V=>V,a.reset(E));do if(F=a.next(ee),F){if(J(F.index)>=k)return d;this.s(s,J(F.index)-y,B);const V=this.t(s.piece.bufferIndex,t,B),R=B.line===t.line?B.column-t.column+h:B.column+1,S=R+F[0].length;if(D[d++]=(0,M.$NB)(new P.$Hs(u+V,R,u+V,S),F,f),J(F.index)+F[0].length>=k||d>=w)return d}while(F);return d}findMatchesLineByLine(s,a,u,h){const t=[];let r=0;const c=new M.$QB(a.wordSeparators,a.regex);let f=this.H(s.startLineNumber,s.startColumn);if(f===null)return[];const w=this.H(s.endLineNumber,s.endColumn);if(w===null)return[];let d=this.s(f.node,f.remainder);const D=this.s(w.node,w.remainder);if(f.node===w.node)return this.findMatchesInNode(f.node,c,s.startLineNumber,s.startColumn,d,D,a,u,h,r,t),t;let L=s.startLineNumber,y=f.node;for(;y!==w.node;){const k=this.t(y.piece.bufferIndex,d,y.piece.end);if(k>=1){const B=this.a[y.piece.bufferIndex].lineStarts,ee=this.u(y.piece.bufferIndex,y.piece.start),J=B[d.line+k],V=L===s.startLineNumber?s.startColumn:1;if(r=this.findMatchesInNode(y,c,L,V,d,this.s(y,J-ee),a,u,h,r,t),r>=h)return t;L+=k}const F=L===s.startLineNumber?s.startColumn-1:0;if(L===s.endLineNumber){const B=this.getLineContent(L).substring(F,s.endColumn-1);return r=this.n(a,c,B,s.endLineNumber,F,r,t,u,h),t}if(r=this.n(a,c,this.getLineContent(L).substr(F),L,F,r,t,u,h),r>=h)return t;L++,f=this.H(L,1),y=f.node,d=this.s(f.node,f.remainder)}if(L===s.endLineNumber){const k=L===s.startLineNumber?s.startColumn-1:0,F=this.getLineContent(L).substring(k,s.endColumn-1);return r=this.n(a,c,F,s.endLineNumber,k,r,t,u,h),t}const E=L===s.startLineNumber?s.startColumn:1;return r=this.findMatchesInNode(w.node,c,L,E,d,D,a,u,h,r,t),t}n(s,a,u,h,t,r,c,f,w){const d=s.wordSeparators;if(!f&&s.simpleSearch){const L=s.simpleSearch,y=L.length,E=u.length;let k=-y;for(;(k=u.indexOf(L,k+y))!==-1;)if((!d||(0,M.$PB)(d,u,E,k,y))&&(c[r++]=new I.$Zu(new P.$Hs(h,k+1+t,h,k+1+y+t),null),r>=w))return r;return r}let D;a.reset(0);do if(D=a.next(u),D&&(c[r++]=(0,M.$NB)(new P.$Hs(h,D.index+1+t,h,D.index+1+D[0].length+t),D,f),r>=w))return r;while(D);return r}insert(s,a,u=!1){if(this.f=this.f&&u,this.j.lineNumber=0,this.j.value="",this.root!==T.$CB){const{node:h,remainder:t,nodeStartOffset:r}=this.G(s),c=h.piece,f=c.bufferIndex,w=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&r+c.length===s&&a.length<m){this.F(h,a),this.y();return}if(r===s)this.o(a,h),this.h.validate(s);else if(r+h.piece.length>s){const d=[];let D=new l(c.bufferIndex,w,c.end,this.t(c.bufferIndex,w,c.end),this.u(f,c.end)-this.u(f,w));if(this.K()&&this.M(a)&&this.I(h,t)===10){const k={line:D.start.line+1,column:0};D=new l(D.bufferIndex,k,D.end,this.t(D.bufferIndex,k,D.end),D.length-1),a+=`
`}if(this.K()&&this.L(a))if(this.I(h,t-1)===13){const k=this.s(h,t-1);this.C(h,k),a="\r"+a,h.piece.length===0&&d.push(h)}else this.C(h,w);else this.C(h,w);const L=this.w(a);D.length>0&&this.S(h,D);let y=h;for(let E=0;E<L.length;E++)y=this.S(y,L[E]);this.v(d)}else this.q(a,h)}else{const h=this.w(a);let t=this.T(null,h[0]);for(let r=1;r<h.length;r++)t=this.S(t,h[r])}this.y()}delete(s,a){if(this.j.lineNumber=0,this.j.value="",a<=0||this.root===T.$CB)return;const u=this.G(s),h=this.G(s+a),t=u.node,r=h.node;if(t===r){const L=this.s(t,u.remainder),y=this.s(t,h.remainder);if(u.nodeStartOffset===s){if(a===t.piece.length){const E=t.next();(0,T.$HB)(this,t),this.N(E),this.y();return}this.D(t,y),this.h.validate(s),this.N(t),this.y();return}if(u.nodeStartOffset+t.piece.length===s+a){this.C(t,L),this.O(t),this.y();return}this.E(t,L,y),this.y();return}const c=[],f=this.s(t,u.remainder);this.C(t,f),this.h.validate(s),t.piece.length===0&&c.push(t);const w=this.s(r,h.remainder);this.D(r,w),r.piece.length===0&&c.push(r);const d=t.next();for(let L=d;L!==T.$CB&&L!==r;L=L.next())c.push(L);const D=t.piece.length===0?t.prev():t;this.v(c),this.O(D),this.y()}o(s,a){const u=[];if(this.K()&&this.M(s)&&this.L(a)){const r=a.piece,c={line:r.start.line+1,column:0},f=new l(r.bufferIndex,c,r.end,this.t(r.bufferIndex,c,r.end),r.length-1);a.piece=f,s+=`
`,(0,T.$JB)(this,a,-1,-1),a.piece.length===0&&u.push(a)}const h=this.w(s);let t=this.T(a,h[h.length-1]);for(let r=h.length-2;r>=0;r--)t=this.T(t,h[r]);this.N(t),this.v(u)}q(s,a){this.Q(s,a)&&(s+=`
`);const u=this.w(s),h=this.S(a,u[0]);let t=h;for(let r=1;r<u.length;r++)t=this.S(t,u[r]);this.N(h)}s(s,a,u){const h=s.piece,t=s.piece.bufferIndex,r=this.a[t].lineStarts,f=r[h.start.line]+h.start.column+a;let w=h.start.line,d=h.end.line,D=0,L=0,y=0;for(;w<=d&&(D=w+(d-w)/2|0,y=r[D],D!==d);)if(L=r[D+1],f<y)d=D-1;else if(f>=L)w=D+1;else break;return u?(u.line=D,u.column=f-y,null):{line:D,column:f-y}}t(s,a,u){if(u.column===0)return u.line-a.line;const h=this.a[s].lineStarts;if(u.line===h.length-1)return u.line-a.line;const t=h[u.line+1],r=h[u.line]+u.column;if(t>r+1)return u.line-a.line;const c=r-1;return this.a[s].buffer.charCodeAt(c)===13?u.line-a.line+1:u.line-a.line}u(s,a){return this.a[s].lineStarts[a.line]+a.column}v(s){for(let a=0;a<s.length;a++)(0,T.$HB)(this,s[a])}w(s){if(s.length>m){const d=[];for(;s.length>m;){const L=s.charCodeAt(m-1);let y;L===13||L>=55296&&L<=56319?(y=s.substring(0,m-1),s=s.substring(m-1)):(y=s.substring(0,m),s=s.substring(m));const E=A(y);d.push(new l(this.a.length,{line:0,column:0},{line:E.length-1,column:y.length-E[E.length-1]},E.length-1,y.length)),this.a.push(new p(y,E))}const D=A(s);return d.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:s.length-D[D.length-1]},D.length-1,s.length)),this.a.push(new p(s,D)),d}let a=this.a[0].buffer.length;const u=A(s,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===a&&a!==0&&this.L(s)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let d=0;d<u.length;d++)u[d]+=a+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+="_"+s,a+=1}else{if(a!==0)for(let d=0;d<u.length;d++)u[d]+=a;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+=s}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[r],f={line:r,column:c},w=new l(0,h,f,this.t(0,h,f),t-a);return this.g=f,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(s,a=0){let u=this.root,h="";const t=this.h.get2(s);if(t){u=t.node;const r=this.B(u,s-t.nodeStartLineNumber-1),c=this.a[u.piece.bufferIndex].buffer,f=this.u(u.piece.bufferIndex,u.piece.start);if(t.nodeStartLineNumber+u.piece.lineFeedCnt===s)h=c.substring(f+r,f+u.piece.length);else{const w=this.B(u,s-t.nodeStartLineNumber);return c.substring(f+r,f+w-a)}}else{let r=0;const c=s;for(;u!==T.$CB;)if(u.left!==T.$CB&&u.lf_left>=s-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>s-1){const f=this.B(u,s-u.lf_left-2),w=this.B(u,s-u.lf_left-1),d=this.a[u.piece.bufferIndex].buffer,D=this.u(u.piece.bufferIndex,u.piece.start);return r+=u.size_left,this.h.set({node:u,nodeStartOffset:r,nodeStartLineNumber:c-(s-1-u.lf_left)}),d.substring(D+f,D+w-a)}else if(u.lf_left+u.piece.lineFeedCnt===s-1){const f=this.B(u,s-u.lf_left-2),w=this.a[u.piece.bufferIndex].buffer,d=this.u(u.piece.bufferIndex,u.piece.start);h=w.substring(d+f,d+u.piece.length);break}else s-=u.lf_left+u.piece.lineFeedCnt,r+=u.size_left+u.piece.length,u=u.right}for(u=u.next();u!==T.$CB;){const r=this.a[u.piece.bufferIndex].buffer;if(u.piece.lineFeedCnt>0){const c=this.B(u,0),f=this.u(u.piece.bufferIndex,u.piece.start);return h+=r.substring(f,f+c-a),h}else{const c=this.u(u.piece.bufferIndex,u.piece.start);h+=r.substr(c,u.piece.length)}u=u.next()}return h}y(){let s=this.root,a=1,u=0;for(;s!==T.$CB;)a+=s.lf_left+s.piece.lineFeedCnt,u+=s.size_left+s.piece.length,s=s.right;this.b=a,this.c=u,this.h.validate(this.c)}A(s,a){const u=s.piece,h=this.s(s,a),t=h.line-u.start.line;if(this.u(u.bufferIndex,u.end)-this.u(u.bufferIndex,u.start)===a){const r=this.t(s.piece.bufferIndex,u.start,h);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:h.column}}B(s,a){if(a<0)return 0;const u=s.piece,h=this.a[u.bufferIndex].lineStarts,t=u.start.line+a+1;return t>u.end.line?h[u.end.line]+u.end.column-h[u.start.line]-u.start.column:h[t]-h[u.start.line]-u.start.column}C(s,a){const u=s.piece,h=u.lineFeedCnt,t=this.u(u.bufferIndex,u.end),r=a,c=this.u(u.bufferIndex,r),f=this.t(u.bufferIndex,u.start,r),w=f-h,d=c-t,D=u.length+d;s.piece=new l(u.bufferIndex,u.start,r,f,D),(0,T.$JB)(this,s,d,w)}D(s,a){const u=s.piece,h=u.lineFeedCnt,t=this.u(u.bufferIndex,u.start),r=a,c=this.t(u.bufferIndex,r,u.end),f=this.u(u.bufferIndex,r),w=c-h,d=t-f,D=u.length+d;s.piece=new l(u.bufferIndex,r,u.end,c,D),(0,T.$JB)(this,s,d,w)}E(s,a,u){const h=s.piece,t=h.start,r=h.end,c=h.length,f=h.lineFeedCnt,w=a,d=this.t(h.bufferIndex,h.start,w),D=this.u(h.bufferIndex,a)-this.u(h.bufferIndex,t);s.piece=new l(h.bufferIndex,h.start,w,d,D),(0,T.$JB)(this,s,D-c,d-f);const L=new l(h.bufferIndex,u,r,this.t(h.bufferIndex,u,r),this.u(h.bufferIndex,r)-this.u(h.bufferIndex,u)),y=this.S(s,L);this.N(y)}F(s,a){this.Q(a,s)&&(a+=`
`);const u=this.K()&&this.L(a)&&this.M(s),h=this.a[0].buffer.length;this.a[0].buffer+=a;const t=A(a,!1);for(let y=0;y<t.length;y++)t[y]+=h;if(u){const y=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-y}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[r],f={line:r,column:c},w=s.piece.length+a.length,d=s.piece.lineFeedCnt,D=this.t(0,s.piece.start,f),L=D-d;s.piece=new l(s.piece.bufferIndex,s.piece.start,f,D,w),this.g=f,(0,T.$JB)(this,s,a.length,L)}G(s){let a=this.root;const u=this.h.get(s);if(u)return{node:u.node,nodeStartOffset:u.nodeStartOffset,remainder:s-u.nodeStartOffset};let h=0;for(;a!==T.$CB;)if(a.size_left>s)a=a.left;else if(a.size_left+a.piece.length>=s){h+=a.size_left;const t={node:a,remainder:s-a.size_left,nodeStartOffset:h};return this.h.set(t),t}else s-=a.size_left+a.piece.length,h+=a.size_left+a.piece.length,a=a.right;return null}H(s,a){let u=this.root,h=0;for(;u!==T.$CB;)if(u.left!==T.$CB&&u.lf_left>=s-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>s-1){const t=this.B(u,s-u.lf_left-2),r=this.B(u,s-u.lf_left-1);return h+=u.size_left,{node:u,remainder:Math.min(t+a-1,r),nodeStartOffset:h}}else if(u.lf_left+u.piece.lineFeedCnt===s-1){const t=this.B(u,s-u.lf_left-2);if(t+a-1<=u.piece.length)return{node:u,remainder:t+a-1,nodeStartOffset:h};a-=u.piece.length-t;break}else s-=u.lf_left+u.piece.lineFeedCnt,h+=u.size_left+u.piece.length,u=u.right;for(u=u.next();u!==T.$CB;){if(u.piece.lineFeedCnt>0){const t=this.B(u,0),r=this.J(u);return{node:u,remainder:Math.min(a-1,t),nodeStartOffset:r}}else if(u.piece.length>=a-1){const t=this.J(u);return{node:u,remainder:a-1,nodeStartOffset:t}}else a-=u.piece.length;u=u.next()}return null}I(s,a){if(s.piece.lineFeedCnt<1)return-1;const u=this.a[s.piece.bufferIndex],h=this.u(s.piece.bufferIndex,s.piece.start)+a;return u.buffer.charCodeAt(h)}J(s){if(!s)return 0;let a=s.size_left;for(;s!==this.root;)s.parent.right===s&&(a+=s.parent.size_left+s.parent.piece.length),s=s.parent;return a}K(){return!(this.f&&this.d===`
`)}L(s){if(typeof s=="string")return s.charCodeAt(0)===10;if(s===T.$CB||s.piece.lineFeedCnt===0)return!1;const a=s.piece,u=this.a[a.bufferIndex].lineStarts,h=a.start.line,t=u[h]+a.start.column;return h===u.length-1||u[h+1]>t+1?!1:this.a[a.bufferIndex].buffer.charCodeAt(t)===10}M(s){return typeof s=="string"?s.charCodeAt(s.length-1)===13:s===T.$CB||s.piece.lineFeedCnt===0?!1:this.I(s,s.piece.length-1)===13}N(s){if(this.K()&&this.L(s)){const a=s.prev();this.M(a)&&this.P(a,s)}}O(s){if(this.K()&&this.M(s)){const a=s.next();this.L(a)&&this.P(s,a)}}P(s,a){const u=[],h=this.a[s.piece.bufferIndex].lineStarts;let t;s.piece.end.column===0?t={line:s.piece.end.line-1,column:h[s.piece.end.line]-h[s.piece.end.line-1]-1}:t={line:s.piece.end.line,column:s.piece.end.column-1};const r=s.piece.length-1,c=s.piece.lineFeedCnt-1;s.piece=new l(s.piece.bufferIndex,s.piece.start,t,c,r),(0,T.$JB)(this,s,-1,-1),s.piece.length===0&&u.push(s);const f={line:a.piece.start.line+1,column:0},w=a.piece.length-1,d=this.t(a.piece.bufferIndex,f,a.piece.end);a.piece=new l(a.piece.bufferIndex,f,a.piece.end,d,w),(0,T.$JB)(this,a,-1,-1),a.piece.length===0&&u.push(a);const D=this.w(`\r
`);this.S(s,D[0]);for(let L=0;L<u.length;L++)(0,T.$HB)(this,u[L])}Q(s,a){if(this.K()&&this.M(s)){const u=a.next();if(this.L(u)){if(s+=`
`,u.piece.length===1)(0,T.$HB)(this,u);else{const h=u.piece,t={line:h.start.line+1,column:0},r=h.length-1,c=this.t(h.bufferIndex,t,h.end);u.piece=new l(h.bufferIndex,t,h.end,c,r),(0,T.$JB)(this,u,-1,-1)}return!0}}return!1}iterate(s,a){if(s===T.$CB)return a(T.$CB);const u=this.iterate(s.left,a);return u&&a(s)&&this.iterate(s.right,a)}R(s){if(s===T.$CB)return"";const a=this.a[s.piece.bufferIndex],u=s.piece,h=this.u(u.bufferIndex,u.start),t=this.u(u.bufferIndex,u.end);return a.buffer.substring(h,t)}getPieceContent(s){const a=this.a[s.bufferIndex],u=this.u(s.bufferIndex,s.start),h=this.u(s.bufferIndex,s.end);return a.buffer.substring(u,h)}S(s,a){const u=new T.$BB(a,1);if(u.left=T.$CB,u.right=T.$CB,u.parent=T.$CB,u.size_left=0,u.lf_left=0,this.root===T.$CB)this.root=u,u.color=0;else if(s.right===T.$CB)s.right=u,u.parent=s;else{const t=(0,T.$DB)(s.right);t.left=u,u.parent=t}return(0,T.$IB)(this,u),u}T(s,a){const u=new T.$BB(a,1);if(u.left=T.$CB,u.right=T.$CB,u.parent=T.$CB,u.size_left=0,u.lf_left=0,this.root===T.$CB)this.root=u,u.color=0;else if(s.left===T.$CB)s.left=u,u.parent=s;else{const h=(0,T.$EB)(s.left);h.right=u,u.parent=h}return(0,T.$IB)(this,u),u}U(s){let a="";return this.iterate(s,u=>(a+=this.R(u),!0)),a}}e.$VB=o}),define(Re[137],Ae([1,0,5,12,29,94,92,130,132,6]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WB=void 0;class A extends b.$Sc{constructor(l,p,v,n,o,i,s){super(),this.m=this.B(new $.$Sd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!i,this.g=n,this.h=o,this.c=new M.$VB(l,v,s)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const v=l+p,n=this.getPositionAt(l),o=this.getPositionAt(v);return new I.$Hs(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const v=this.n(p);return this.c.getValueInRange(l,v)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const v=this.getOffsetAt(l.startLineNumber,l.startColumn),n=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const i=this.n(p),s=this.getEOL();if(i.length!==s.length){const a=i.length-s.length,u=l.endLineNumber-l.startLineNumber;o=a*u}return n-v+o}getCharacterCountInRange(l,p=0){if(this.j){let v=0;const n=l.startLineNumber,o=l.endLineNumber;for(let i=n;i<=o;i++){const s=this.getLineContent(i),a=i===n?l.startColumn-1:0,u=i===o?l.endColumn-1:s.length;for(let h=a;h<u;h++)P.$_e(s.charCodeAt(h))?(v=v+1,h=h+1):v=v+1}return v+=this.n(p).length*(o-n),v}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=P.$We(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=P.$Ye(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,v){let n=this.g,o=this.h,i=this.j,s=!0,a=[];for(let w=0;w<l.length;w++){const d=l[w];s&&d._isTracked&&(s=!1);const D=d.range;if(d.text){let F=!0;i||(F=!P.$kf(d.text),i=F),!n&&F&&(n=P.$jf(d.text)),!o&&F&&(o=P.$mf(d.text))}let L="",y=0,E=0,k=0;if(d.text){let F;[y,E,k,F]=(0,m.$ht)(d.text);const B=this.getEOL();F===0||F===(B===`\r
`?2:1)?L=d.text:L=d.text.replace(/\r\n|\r|\n/g,B)}a[w]={sortIndex:w,identifier:d.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:L,eolCount:y,firstLineLength:E,lastLineLength:k,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}a.sort(A.u);let u=!1;for(let w=0,d=a.length-1;w<d;w++){const D=a[w].range.getEndPosition(),L=a[w+1].range.getStartPosition();if(L.isBeforeOrEqual(D)){if(L.isBefore(D))throw new Error("Overlapping ranges are not allowed!");u=!0}}s&&(a=this.s(a));const h=v||p?A._getInverseEditRanges(a):[],t=[];if(p)for(let w=0;w<a.length;w++){const d=a[w],D=h[w];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let L=D.startLineNumber;L<=D.endLineNumber;L++){let y="";L===D.startLineNumber&&(y=this.getLineContent(d.range.startLineNumber),P.$We(y)!==-1)||t.push({lineNumber:L,oldContent:y})}}let r=null;if(v){let w=0;r=[];for(let d=0;d<a.length;d++){const D=a[d],L=h[d],y=this.getValueInRange(D.range),E=D.rangeOffset+w;w+=D.text.length-y.length,r[d]={sortIndex:D.sortIndex,identifier:D.identifier,range:L,text:y,textChange:new g.$3s(D.rangeOffset,y,E,D.text)}}u||r.sort((d,D)=>d.sortIndex-D.sortIndex)}this.g=n,this.h=o,this.j=i;const c=this.t(a);let f=null;if(p&&t.length>0){t.sort((w,d)=>d.lineNumber-w.lineNumber),f=[];for(let w=0,d=t.length;w<d;w++){const D=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===D)continue;const L=t[w].oldContent,y=this.getLineContent(D);y.length===0||y===L||P.$We(y)!==-1||f.push(D)}}return this.m.fire(),new T.$4u(r,c,f)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const v=l[0].range,n=l[l.length-1].range,o=new I.$Hs(v.startLineNumber,v.startColumn,n.endLineNumber,n.endColumn);let i=v.startLineNumber,s=v.startColumn;const a=[];for(let c=0,f=l.length;c<f;c++){const w=l[c],d=w.range;p=p||w.forceMoveMarkers,a.push(this.getValueInRange(new I.$Hs(i,s,d.startLineNumber,d.startColumn))),w.text.length>0&&a.push(w.text),i=d.endLineNumber,s=d.endColumn}const u=a.join(""),[h,t,r]=(0,m.$ht)(u);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:u,eolCount:h,firstLineLength:t,lastLineLength:r,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const p=[];for(let v=0;v<l.length;v++){const n=l[v],o=n.range.startLineNumber,i=n.range.startColumn,s=n.range.endLineNumber,a=n.range.endColumn;if(o===s&&i===a&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const u=new I.$Hs(o,i,s,a);p.push({range:u,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,v,n){return this.c.findMatchesLineByLine(l,p,v,n)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const v=l.startLineNumber,n=l.startColumn,[o,i,s]=(0,m.$ht)(p);let a;if(p.length>0){const u=o+1;u===1?a=new I.$Hs(v,n,v,n+i):a=new I.$Hs(v,n,v+u-1,s+1)}else a=new I.$Hs(v,n,v,n);return a}static _getInverseEditRanges(l){const p=[];let v=0,n=0,o=null;for(let i=0,s=l.length;i<s;i++){const a=l[i];let u,h;o?o.range.endLineNumber===a.range.startLineNumber?(u=v,h=n+(a.range.startColumn-o.range.endColumn)):(u=v+(a.range.startLineNumber-o.range.endLineNumber),h=a.range.startColumn):(u=a.range.startLineNumber,h=a.range.startColumn);let t;if(a.text.length>0){const r=a.eolCount+1;r===1?t=new I.$Hs(u,h,u,h+a.firstLineLength):t=new I.$Hs(u,h,u+r-1,a.lastLineLength+1)}else t=new I.$Hs(u,h,u,h);v=t.endLineNumber,n=t.endColumn,p.push(t),o=a}return p}static u(l,p){const v=I.$Hs.compareRangesUsingEnds(l.range,p.range);return v===0?l.sortIndex-p.sortIndex:v}static w(l,p){const v=I.$Hs.compareRangesUsingEnds(l.range,p.range);return v===0?p.sortIndex-l.sortIndex:-v}}e.$WB=A}),define(Re[138],Ae([1,0,12,92,137]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XB=void 0;class T{constructor(g,b,A,C,l,p,v,n,o){this.a=g,this.b=b,this.c=A,this.d=C,this.e=l,this.f=p,this.g=v,this.h=n,this.j=o}k(g){const b=this.c+this.d+this.e,A=this.c+this.e;return b===0?g===1?`
`:`\r
`:A>b/2?`\r
`:`
`}create(g){const b=this.k(g),A=this.a;if(this.j&&(b===`\r
`&&(this.c>0||this.d>0)||b===`
`&&(this.c>0||this.e>0)))for(let l=0,p=A.length;l<p;l++){const v=A[l].buffer.replace(/\r\n|\r|\n/g,b),n=(0,P.$RB)(v);A[l]=new P.$UB(v,n)}const C=new I.$WB(A,this.b,b,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&$.$sf(g)&&(this.b=$.$rf,g=g.substr(1));const b=g.charCodeAt(g.length-1);b===13||b>=55296&&b<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=b):(this.m(g,!1),this.c=!1,this.d=b)}m(g,b){!b&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const b=(0,P.$SB)(this.e,g);this.a.push(new P.$UB(g,b.lineStarts)),this.f+=b.cr,this.g+=b.lf,this.h+=b.crlf,b.isBasicASCII||(this.l=!1,this.j||(this.j=$.$jf(g)),this.k||(this.k=$.$mf(g)))}finish(g=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const b=(0,P.$RB)(g.buffer);g.lineStarts=b,this.d===13&&this.f++}}}e.$XB=M}),define(Re[96],Ae([1,0,24,21]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$=e.$m$=void 0;var I;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(I||(I={}));function T(C){for(let l=0,p=C.length;l<p;l+=4){const v=C[l+0],n=C[l+1],o=C[l+2],i=C[l+3];C[l+0]=i,C[l+1]=o,C[l+2]=n,C[l+3]=v}}function M(C){const l=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return P.$x()||T(l),$.$ge.wrap(l)}function m(C){const l=C.buffer;if(P.$x()||T(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function g(C){const l=new Uint32Array(b(C));let p=0;if(l[p++]=C.id,C.type==="full")l[p++]=1,l[p++]=C.data.length,l.set(C.data,p),p+=C.data.length;else{l[p++]=2,l[p++]=C.deltas.length;for(const v of C.deltas)l[p++]=v.start,l[p++]=v.deleteCount,v.data?(l[p++]=v.data.length,l.set(v.data,p),p+=v.data.length):l[p++]=0}return M(l)}e.$m$=g;function b(C){let l=0;if(l+=1+1,C.type==="full")l+=1+C.data.length;else{l+=1,l+=(1+1+1)*C.deltas.length;for(const p of C.deltas)p.data&&(l+=p.data.length)}return l}function A(C){const l=m(C);let p=0;const v=l[p++];if(l[p++]===1){const s=l[p++],a=l.subarray(p,p+s);return p+=s,{id:v,type:"full",data:a}}const o=l[p++],i=[];for(let s=0;s<o;s++){const a=l[p++],u=l[p++],h=l[p++];let t;h>0&&(t=l.subarray(p,p+h),p+=h),i[s]={start:a,deleteCount:u,data:t}}return{id:v,type:"delta",deltas:i}}e.$n$=A}),define(Re[139],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8=e.$d8=void 0;class ${constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const M=this.a.get(T);return this.a.delete(T),M}}addDragOperationTransfer(T,M){this.a.set(T,M)}}e.$d8=$;class P{constructor(T){this.identifier=T}}e.$e8=P}),define(Re[140],Ae([9,10]),function(ie,e){return ie.create("vs/base/common/actions",e)}),define(Re[141],Ae([1,0,5,6,140]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class T extends P.$Sc{constructor(l,p="",v="",n=!0,o){super(),this.h=this.B(new $.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=v,this.w=n,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Gi=T;class M extends P.$Sc{constructor(){super(...arguments),this.f=this.B(new $.$Sd),this.onWillRun=this.f.event,this.m=this.B(new $.$Sd),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let v;try{await this.u(l,p)}catch(n){v=n}this.m.fire({action:l,error:v})}async u(l,p){await l.run(p)}}e.$Hi=M;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const v of l)v.length&&(p.length?p=[...p,new m,...v]:p=v);return p}async run(){}}e.$Ii=m,m.ID="vs.actions.separator";class g{get actions(){return this.a}constructor(l,p,v,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=n,this.a=v}async run(){}}e.$Ji=g;class b extends T{constructor(){super(b.ID,I.localize(0,null),void 0,!1)}}e.$Ki=b,b.ID="vs.actions.empty";function A(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...l)=>C.run(...l),tooltip:C.label}}e.$Li=A}),define(Re[142],Ae([9,10]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Re[143],Ae([1,0,142]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0;const P=60,I=P*60,T=I*24,M=T*7,m=T*30,g=T*365;function b(C,l,p,v){typeof C!="number"&&(C=C.getTime());const n=Math.round((new Date().getTime()-C)/1e3);if(n<-30)return(0,$.localize)(0,null,b(new Date().getTime()+n*1e3,!1));if(!v&&n<30)return(0,$.localize)(1,null);let o;return n<P?(o=n,l?o===1?p?(0,$.localize)(2,null,o):(0,$.localize)(3,null,o):p?(0,$.localize)(4,null,o):(0,$.localize)(5,null,o):o===1?p?(0,$.localize)(6,null,o):(0,$.localize)(7,null,o):p?(0,$.localize)(8,null,o):(0,$.localize)(9,null,o)):n<I?(o=Math.floor(n/P),l?o===1?p?(0,$.localize)(10,null,o):(0,$.localize)(11,null,o):p?(0,$.localize)(12,null,o):(0,$.localize)(13,null,o):o===1?p?(0,$.localize)(14,null,o):(0,$.localize)(15,null,o):p?(0,$.localize)(16,null,o):(0,$.localize)(17,null,o)):n<T?(o=Math.floor(n/I),l?o===1?p?(0,$.localize)(18,null,o):(0,$.localize)(19,null,o):p?(0,$.localize)(20,null,o):(0,$.localize)(21,null,o):o===1?p?(0,$.localize)(22,null,o):(0,$.localize)(23,null,o):p?(0,$.localize)(24,null,o):(0,$.localize)(25,null,o)):n<M?(o=Math.floor(n/T),l?o===1?(0,$.localize)(26,null,o):(0,$.localize)(27,null,o):o===1?(0,$.localize)(28,null,o):(0,$.localize)(29,null,o)):n<m?(o=Math.floor(n/M),l?o===1?p?(0,$.localize)(30,null,o):(0,$.localize)(31,null,o):p?(0,$.localize)(32,null,o):(0,$.localize)(33,null,o):o===1?p?(0,$.localize)(34,null,o):(0,$.localize)(35,null,o):p?(0,$.localize)(36,null,o):(0,$.localize)(37,null,o)):n<g?(o=Math.floor(n/m),l?o===1?p?(0,$.localize)(38,null,o):(0,$.localize)(39,null,o):p?(0,$.localize)(40,null,o):(0,$.localize)(41,null,o):o===1?p?(0,$.localize)(42,null,o):(0,$.localize)(43,null,o):p?(0,$.localize)(44,null,o):(0,$.localize)(45,null,o)):(o=Math.floor(n/g),l?o===1?p?(0,$.localize)(46,null,o):(0,$.localize)(47,null,o):p?(0,$.localize)(48,null,o):(0,$.localize)(49,null,o):o===1?p?(0,$.localize)(50,null,o):(0,$.localize)(51,null,o):p?(0,$.localize)(52,null,o):(0,$.localize)(53,null,o))}e.$rm=b;function A(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$sm=A}),define(Re[144],Ae([9,10]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Re[40],Ae([1,0,18,16,144]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function T(C,l){return l&&(C.stack||C.stacktrace)?I.localize(0,null,m(C),M(C.stack)||M(C.stacktrace)):m(C)}function M(C){return Array.isArray(C)?C.join(`
`):C}function m(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?I.localize(1,null,C.message):C.message||I.localize(2,null)}function g(C=null,l=!1){if(!C)return I.localize(3,null);if(Array.isArray(C)){const p=$.$Hb(C),v=g(p[0],l);return p.length>1?I.localize(4,null,v,p.length):v}if(P.$Ef(C))return C;if(C.detail){const p=C.detail;if(p.error)return T(p.error,l);if(p.exception)return T(p.exception,l)}return C.stack?T(C,l):C.message?C.message:I.localize(5,null)}e.$Mi=g;function b(C){const l=C;return l instanceof Error&&Array.isArray(l.actions)}e.$Ni=b;function A(C,l){let p;return typeof C=="string"?p=new Error(C):p=C,p.actions=l,p}e.$Oi=A}),define(Re[145],Ae([9,10]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Re[146],Ae([1,0,18,26,21,133,147,145]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=b;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class C{constructor(x,ye,Ve,Ze){this.id=x,this.name=ye,this.defaultValue=Ve,this.schema=Ze}applyUpdate(x,ye){return p(x,ye)}compute(x,ye,Ve){return Ve}}class l{constructor(x,ye){this.newValue=x,this.didChange=ye}}e.ApplyUpdateResult=l;function p(Y,x){if(typeof Y!="object"||typeof x!="object"||!Y||!x)return new l(x,Y!==x);if(Array.isArray(Y)||Array.isArray(x)){const Ve=Array.isArray(Y)&&Array.isArray(x)&&$.$ub(Y,x);return new l(x,!Ve)}let ye=!1;for(const Ve in x)if(x.hasOwnProperty(Ve)){const Ze=p(Y[Ve],x[Ve]);Ze.didChange&&(Y[Ve]=Ze.newValue,ye=!0)}return new l(Y,ye)}class v{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,ye){return p(x,ye)}validate(x){return this.defaultValue}}class n{constructor(x,ye,Ve,Ze){this.id=x,this.name=ye,this.defaultValue=Ve,this.schema=Ze}applyUpdate(x,ye){return p(x,ye)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,ye,Ve){return Ve}}function o(Y,x){return typeof Y>"u"?x:Y==="false"?!1:!!Y}e.boolean=o;class i extends n{constructor(x,ye,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=Ve),super(x,ye,Ve,Ze)}validate(x){return o(x,this.defaultValue)}}function s(Y,x,ye,Ve){if(typeof Y>"u")return x;let Ze=parseInt(Y,10);return isNaN(Ze)?x:(Ze=Math.max(ye,Ze),Ze=Math.min(Ve,Ze),Ze|0)}e.clampedInt=s;class a extends n{static clampedInt(x,ye,Ve,Ze){return s(x,ye,Ve,Ze)}constructor(x,ye,Ve,Ze,nt,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ve,st.minimum=Ze,st.maximum=nt),super(x,ye,Ve,st),this.minimum=Ze,this.maximum=nt}validate(x){return a.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function u(Y,x,ye,Ve){if(typeof Y>"u")return x;const Ze=h.float(Y,x);return h.clamp(Ze,ye,Ve)}e.clampedFloat=u;class h extends n{static clamp(x,ye,Ve){return x<ye?ye:x>Ve?Ve:x}static float(x,ye){if(typeof x=="number")return x;if(typeof x>"u")return ye;const Ve=parseFloat(x);return isNaN(Ve)?ye:Ve}constructor(x,ye,Ve,Ze,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ve),super(x,ye,Ve,nt),this.validationFn=Ze}validate(x){return this.validationFn(h.float(x,this.defaultValue))}}class t extends n{static string(x,ye){return typeof x!="string"?ye:x}constructor(x,ye,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=Ve),super(x,ye,Ve,Ze)}validate(x){return t.string(x,this.defaultValue)}}function r(Y,x,ye,Ve){return typeof Y!="string"?x:Ve&&Y in Ve?Ve[Y]:ye.indexOf(Y)===-1?x:Y}e.stringSet=r;class c extends n{constructor(x,ye,Ve,Ze,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ze,nt.default=Ve),super(x,ye,Ve,nt),this.c=Ze}validate(x){return r(x,this.defaultValue,this.c)}}class f extends C{constructor(x,ye,Ve,Ze,nt,st,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=nt,Ne.default=Ze),super(x,ye,Ve,Ne),this.c=nt,this.d=st}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function w(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(x){switch(x){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(x,ye,Ve){return Ve===0?x.accessibilitySupport:Ve}}class D extends C{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:m.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{insertSpace:o(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function y(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function k(Y){switch(Y){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function F(Y){switch(Y){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class B extends v{constructor(){super(140)}compute(x,ye,Ve){const Ze=["monaco-editor"];return ye.get(39)&&Ze.push(ye.get(39)),x.extraEditorClassName&&Ze.push(x.extraEditorClassName),ye.get(73)==="default"?Ze.push("mouse-default"):ye.get(73)==="copy"&&Ze.push("mouse-copy"),ye.get(110)&&Ze.push("showUnused"),ye.get(138)&&Ze.push("showDeprecated"),Ze.join(" ")}}class ee extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(x,ye,Ve){return Ve&&x.emptySelectionClipboard}}class J extends C{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:m.localize(16,null),included:I.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:m.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{cursorMoveOnType:o(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":r(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":r(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ye.loop,this.defaultValue.loop)}}}class V extends C{constructor(){super(51,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?V.OFF:x==="true"?V.ON:x:x?V.ON:V.OFF}}e.EditorFontLigatures=V,V.OFF='"liga" off, "calt" off',V.ON='"liga" on, "calt" on';class R extends C{constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?R.OFF:x==="true"?R.TRANSLATE:x:x?R.TRANSLATE:R.OFF}compute(x,ye,Ve){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=R,R.OFF="normal",R.TRANSLATE="translate";class S extends v{constructor(){super(50)}compute(x,ye,Ve){return x.fontInfo}}class O extends n{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(x){const ye=h.float(x,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ye,6,100)}compute(x,ye,Ve){return x.fontInfo.fontSize}}class Q extends C{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Q.d,maximum:Q.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(a.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,Q.d,Q.e))}}Q.c=["normal","bold","100","200","300","400","500","600","700","800","900"],Q.d=1,Q.e=1e3;class re extends C{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Ve,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Ve,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Ve,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Ve,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Ve,description:m.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{multiple:r(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??r(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??r(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??r(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??r(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??r(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends C{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:m.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{enabled:o(ye.enabled,this.defaultValue.enabled),delay:a.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:o(ye.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt(ye.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(ye.above,this.defaultValue.above)}}}var fe;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(fe||(e.RenderMinimap=fe={}));class ue extends v{constructor(){super(143)}compute(x,ye,Ve){return ue.computeLayout(ye,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const ye=x.height/x.lineHeight,Ve=Math.floor(x.paddingTop/x.lineHeight);let Ze=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Ze=Math.max(Ze,ye-1));const nt=(Ve+x.viewLineCount+Ze)/(x.pixelRatio*x.height),st=Math.floor(x.viewLineCount/nt);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ze,desiredRatio:nt,minimapLineCount:st}}static c(x,ye){const Ve=x.outerWidth,Ze=x.outerHeight,nt=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const st=ye.stableMinimapLayoutInput,Ne=st&&x.outerHeight===st.outerHeight&&x.lineHeight===st.lineHeight&&x.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&x.pixelRatio===st.pixelRatio&&x.scrollBeyondLastLine===st.scrollBeyondLastLine&&x.paddingTop===st.paddingTop&&x.paddingBottom===st.paddingBottom&&x.minimap.enabled===st.minimap.enabled&&x.minimap.side===st.minimap.side&&x.minimap.size===st.minimap.size&&x.minimap.showSlider===st.minimap.showSlider&&x.minimap.renderCharacters===st.minimap.renderCharacters&&x.minimap.maxColumn===st.minimap.maxColumn&&x.minimap.scale===st.minimap.scale&&x.verticalScrollbarWidth===st.verticalScrollbarWidth&&x.isViewportWrapping===st.isViewportWrapping,Pt=x.lineHeight,Mt=x.typicalHalfwidthCharacterWidth,Kt=x.scrollBeyondLastLine,Ht=x.minimap.renderCharacters;let yt=nt>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Gt=x.minimap.maxColumn,Ut=x.minimap.size,ni=x.minimap.side,Jt=x.verticalScrollbarWidth,Ft=x.viewLineCount,_e=x.remainingWidth,Bt=x.isViewportWrapping,Zt=Ht?2:3;let ht=Math.floor(nt*Ze);const mt=ht/nt;let Tt=!1,Nt=!1,Et=Zt*yt,dt=yt/nt,Rt=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:pt,extraLinesBeforeFirstLine:Ot,extraLinesBeyondLastLine:Ce,desiredRatio:Le,minimapLineCount:ve}=ue.computeContainedMinimapLineCount({viewLineCount:Ft,scrollBeyondLastLine:Kt,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Ze,lineHeight:Pt,pixelRatio:nt});if(Ft/ve>1)Tt=!0,Nt=!0,yt=1,Et=1,dt=yt/nt;else{let Me=!1,Be=yt+1;if(Ut==="fit"){const Xe=Math.ceil((Ot+Ft+Ce)*Et);Bt&&Ne&&_e<=ye.stableFitRemainingWidth?(Me=!0,Be=ye.stableFitMaxMinimapScale):Me=Xe>ht}if(Ut==="fill"||Me){Tt=!0;const Xe=yt;Et=Math.min(Pt*nt,Math.max(1,Math.floor(1/Le))),Bt&&Ne&&_e<=ye.stableFitRemainingWidth&&(Be=ye.stableFitMaxMinimapScale),yt=Math.min(Be,Math.max(1,Math.floor(Et/Zt))),yt>Xe&&(Rt=Math.min(2,yt/Xe)),dt=yt/nt/Rt,ht=Math.ceil(Math.max(pt,Ot+Ft+Ce)*Et),Bt?(ye.stableMinimapLayoutInput=x,ye.stableFitRemainingWidth=_e,ye.stableFitMaxMinimapScale=yt):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const xt=Math.floor(Gt*dt),It=Math.min(xt,Math.max(0,Math.floor((_e-Jt-2)*dt/(Mt+dt)))+e.MINIMAP_GUTTER_WIDTH);let He=Math.floor(nt*It);const Wt=He/nt;He=Math.floor(He*Rt);const Yt=Ht?1:2,Xt=ni==="left"?0:Ve-It-Jt;return{renderMinimap:Yt,minimapLeft:Xt,minimapWidth:It,minimapHeightIsEditorHeight:Tt,minimapIsSampling:Nt,minimapScale:yt,minimapLineHeight:Et,minimapCanvasInnerWidth:He,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Wt,minimapCanvasOuterHeight:mt}}static computeLayout(x,ye){const Ve=ye.outerWidth|0,Ze=ye.outerHeight|0,nt=ye.lineHeight|0,st=ye.lineNumbersDigitCount|0,Ne=ye.typicalHalfwidthCharacterWidth,Pt=ye.maxDigitWidth,Mt=ye.pixelRatio,Kt=ye.viewLineCount,Ht=x.get(135),yt=Ht==="inherit"?x.get(134):Ht,Gt=yt==="inherit"?x.get(130):yt,Ut=x.get(133),ni=ye.isDominatedByLongLines,Jt=x.get(57),Ft=x.get(67).renderType!==0,_e=x.get(68),Bt=x.get(104),Zt=x.get(83),ht=x.get(72),mt=x.get(102),Tt=mt.verticalScrollbarSize,Nt=mt.verticalHasArrows,Et=mt.arrowSize,dt=mt.horizontalScrollbarSize,Rt=x.get(43),xt=x.get(109)!=="never";let It=x.get(65);Rt&&xt&&(It+=16);let He=0;if(Ft){const tt=Math.max(st,_e);He=Math.round(tt*Pt)}let Wt=0;Jt&&(Wt=nt*ye.glyphMarginDecorationLaneCount);let Yt=0,Xt=Yt+Wt,pt=Xt+He,Ot=pt+It;const Ce=Ve-Wt-He-It;let Le=!1,ve=!1,K=-1;yt==="inherit"&&ni?(Le=!0,ve=!0):Gt==="on"||Gt==="bounded"?ve=!0:Gt==="wordWrapColumn"&&(K=Ut);const Me=ue.c({outerWidth:Ve,outerHeight:Ze,lineHeight:nt,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Mt,scrollBeyondLastLine:Bt,paddingTop:Zt.top,paddingBottom:Zt.bottom,minimap:ht,verticalScrollbarWidth:Tt,viewLineCount:Kt,remainingWidth:Ce,isViewportWrapping:ve},ye.memory||new A);Me.renderMinimap!==0&&Me.minimapLeft===0&&(Yt+=Me.minimapWidth,Xt+=Me.minimapWidth,pt+=Me.minimapWidth,Ot+=Me.minimapWidth);const Be=Ce-Me.minimapWidth,Xe=Math.max(1,Math.floor((Be-Tt-2)/Ne)),Ke=Nt?Et:0;return ve&&(K=Math.max(1,Xe),Gt==="bounded"&&(K=Math.min(K,Ut))),{width:Ve,height:Ze,glyphMarginLeft:Yt,glyphMarginWidth:Wt,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:Xt,lineNumbersWidth:He,decorationsLeft:pt,decorationsWidth:It,contentLeft:Ot,contentWidth:Be,minimap:Me,viewportColumn:Xe,isWordWrapMinified:Le,isViewportWrapping:ve,wrappingColumn:K,verticalScrollbarWidth:Tt,horizontalScrollbarHeight:dt,overviewRuler:{top:Ke,width:Tt,height:Ze-2*Ke,right:0}}}}e.EditorLayoutInfoComputer=ue;class $e extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(x){return r(x,"simple",["simple","advanced"])}compute(x,ye,Ve){return ye.get(2)===2?"advanced":Ve}}var ne;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(ne||(e.ShowAiIconMode=ne={}));class Pe extends C{constructor(){const x={enabled:!0,experimental:{showAiIcon:ne.Off}};super(64,"lightbulb",x,{"editor.lightbulb.enabled":{type:"boolean",default:x.enabled,description:m.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[ne.Off,ne.OnCode,ne.On],default:x.experimental.showAiIcon,enumDescriptions:[m.localize(51,null),m.localize(52,null),m.localize(53,null)],description:m.localize(54,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{enabled:o(ye.enabled,this.defaultValue.enabled),experimental:{showAiIcon:r(ye.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[ne.Off,ne.OnCode,ne.On])}}}}class le extends C{constructor(){const x={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:m.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:10,description:m.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:m.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:m.localize(58,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{enabled:o(ye.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(ye.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class me extends C{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:m.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(60,null),m.localize(61,null,I.$d?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null,I.$d?"Ctrl+Option":"Ctrl+Alt"),m.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:m.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:m.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:m.localize(66,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:r(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ye.fontFamily,this.defaultValue.fontFamily),padding:o(ye.padding,this.defaultValue.padding)}}}class W extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):a.clampedInt(x,this.defaultValue,0,1e3)}compute(x,ye,Ve){return Ve<0?a.clampedInt(-Ve*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class ae extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>h.clamp(x,0,150),{markdownDescription:m.localize(67,null)})}compute(x,ye,Ve){return x.fontInfo.lineHeight}}class de extends C{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:m.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:m.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(70,null),m.localize(71,null),m.localize(72,null)],default:x.size,description:m.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:m.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:m.localize(75,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:m.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:m.localize(78,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{enabled:o(ye.enabled,this.defaultValue.enabled),autohide:o(ye.autohide,this.defaultValue.autohide),size:r(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ye.side,this.defaultValue.side,["right","left"]),showSlider:r(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ye.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(ye.scale,1,1,3),maxColumn:a.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ke(Y){return Y==="ctrlCmd"?I.$d?"metaKey":"ctrlKey":"altKey"}class Ee extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(80,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{top:a.clampedInt(ye.top,0,0,1e3),bottom:a.clampedInt(ye.bottom,0,0,1e3)}}}class ce extends C{constructor(){const x={enabled:!0,cycle:!0};super(85,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:m.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:m.localize(82,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{enabled:o(ye.enabled,this.defaultValue.enabled),cycle:o(ye.cycle,this.defaultValue.cycle)}}}class _ extends v{constructor(){super(141)}compute(x,ye,Ve){return x.pixelRatio}}class H extends C{constructor(){const x={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(83,null),m.localize(84,null),m.localize(85,null)]}];super(88,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:x.strings,description:m.localize(86,null)},comments:{anyOf:ye,default:x.comments,description:m.localize(87,null)},other:{anyOf:ye,default:x.other,description:m.localize(88,null)}},default:x,markdownDescription:m.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Mt=x?"on":"off";return{comments:Mt,strings:Mt,other:Mt}}if(!x||typeof x!="object")return this.defaultValue;const{other:ye,comments:Ve,strings:Ze}=x,nt=["on","inline","off"];let st,Ne,Pt;return typeof ye=="boolean"?st=ye?"on":"off":st=r(ye,this.defaultValue.other,nt),typeof Ve=="boolean"?Ne=Ve?"on":"off":Ne=r(Ve,this.defaultValue.comments,nt),typeof Ze=="boolean"?Pt=Ze?"on":"off":Pt=r(Ze,this.defaultValue.strings,nt),{other:st,comments:Ne,strings:Pt}}}var te;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class we extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(90,null),m.localize(91,null),m.localize(92,null),m.localize(93,null)],default:"on",description:m.localize(94,null)})}validate(x){let ye=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(ye=4,Ve=x):x==="interval"?ye=3:x==="relative"?ye=2:x==="on"?ye=1:ye=0),{renderType:ye,renderFn:Ve}}}function be(Y){const x=Y.get(97);return x==="editable"?Y.get(90):x!=="on"}e.filterValidationDecorations=be;class Fe extends C{constructor(){const x=[],ye={type:"number",description:m.localize(95,null)};super(101,"rulers",x,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:m.localize(96,null),format:"color-hex"}}}]},default:x,description:m.localize(97,null)})}validate(x){if(Array.isArray(x)){const ye=[];for(const Ve of x)if(typeof Ve=="number")ye.push({column:a.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ze=Ve;ye.push({column:a.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return ye.sort((Ve,Ze)=>Ve.column-Ze.column),ye}return this.defaultValue}}class pe extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function Se(Y,x){if(typeof Y!="string")return x;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class N extends C{constructor(){const x={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(102,null),m.localize(103,null),m.localize(104,null)],default:"auto",description:m.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:m.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:m.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:m.localize(109,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x,Ve=a.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=a.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se(ye.vertical,this.defaultValue.vertical),horizontal:Se(ye.horizontal,this.defaultValue.horizontal),useShadows:o(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:a.clampedInt(ye.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:a.clampedInt(ye.verticalSliderSize,Ze,0,1e3),scrollByPage:o(ye.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(ye.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends C{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:m.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:m.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:m.localize(116,null)}})}applyUpdate(x,ye){let Ve=!1;ye.allowedCharacters&&x&&(P.$mn(x.allowedCharacters,ye.allowedCharacters)||(x={...x,allowedCharacters:ye.allowedCharacters},Ve=!0)),ye.allowedLocales&&x&&(P.$mn(x.allowedLocales,ye.allowedLocales)||(x={...x,allowedLocales:ye.allowedLocales},Ve=!0));const Ze=super.applyUpdate(x,ye);return Ve?new l(Ze.newValue,!0):Ze}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{nonBasicASCII:X(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:X(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:X(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,ye){if(typeof x!="object"||!x)return ye;const Ve={};for(const[Ze,nt]of Object.entries(x))nt===!0&&(Ve[Ze]=!0);return Ve}}class G extends C{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:m.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(118,null),m.localize(119,null),m.localize(120,null)],description:m.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:m.localize(122,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{enabled:o(ye.enabled,this.defaultValue.enabled),mode:r(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(ye.keepOnBlur,this.defaultValue.keepOnBlur)}}}class z extends C{constructor(){const x={enabled:T.$es.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$es.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:m.localize(124,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{enabled:o(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends C{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:x.bracketPairs,description:m.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:x.bracketPairsHorizontal,description:m.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:m.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:m.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:x.highlightActiveIndentation,description:m.localize(138,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{bracketPairs:X(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:X(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:X(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function X(Y,x,ye){const Ve=ye.indexOf(Y);return Ve===-1?x:ye[Ve]}class De extends C{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(139,null),m.localize(140,null)],default:x.insertMode,description:m.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:m.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:m.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:m.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],default:x.selectionMode,markdownDescription:m.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:m.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:m.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:m.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:m.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:m.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{insertMode:r(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ye.showIcons,this.defaultValue.showIcons),showStatusBar:o(ye.showStatusBar,this.defaultValue.showStatusBar),preview:o(ye.preview,this.defaultValue.preview),previewMode:r(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ye.showMethods,this.defaultValue.showMethods),showFunctions:o(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ye.showFields,this.defaultValue.showFields),showVariables:o(ye.showVariables,this.defaultValue.showVariables),showClasses:o(ye.showClasses,this.defaultValue.showClasses),showStructs:o(ye.showStructs,this.defaultValue.showStructs),showInterfaces:o(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ye.showModules,this.defaultValue.showModules),showProperties:o(ye.showProperties,this.defaultValue.showProperties),showEvents:o(ye.showEvents,this.defaultValue.showEvents),showOperators:o(ye.showOperators,this.defaultValue.showOperators),showUnits:o(ye.showUnits,this.defaultValue.showUnits),showValues:o(ye.showValues,this.defaultValue.showValues),showConstants:o(ye.showConstants,this.defaultValue.showConstants),showEnums:o(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ye.showKeywords,this.defaultValue.showKeywords),showWords:o(ye.showWords,this.defaultValue.showWords),showColors:o(ye.showColors,this.defaultValue.showColors),showFiles:o(ye.showFiles,this.defaultValue.showFiles),showReferences:o(ye.showReferences,this.defaultValue.showReferences),showFolders:o(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ye.showSnippets,this.defaultValue.showSnippets),showUsers:o(ye.showUsers,this.defaultValue.showUsers),showIssues:o(ye.showIssues,this.defaultValue.showIssues)}}}class Te extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(188,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(x.selectSubwords,this.defaultValue.selectSubwords)}}}var qe;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(qe||(e.WrappingIndent=qe={}));class We extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(189,null),m.localize(190,null),m.localize(191,null),m.localize(192,null)],description:m.localize(193,null),default:"same"}})}validate(x){switch(x){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(x,ye,Ve){return ye.get(2)===2?0:Ve}}class Ye extends v{constructor(){super(144)}compute(x,ye,Ve){const Ze=ye.get(143);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class ot extends C{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{enabled:o(ye.enabled,this.defaultValue.enabled),showDropSelector:r(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class rt extends C{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(200,null),m.localize(201,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const ye=x;return{enabled:o(ye.enabled,this.defaultValue.enabled),showPasteSelector:r(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",ut="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$d?ct:I.$e?ut:it,fontWeight:"normal",fontSize:I.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var vt;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(202,null)})),acceptSuggestionOnEnter:Ue(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(203,null),""],markdownDescription:m.localize(204,null)})),accessibilitySupport:Ue(new d),accessibilityPageSize:Ue(new a(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(205,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",m.localize(206,null))),ariaRequired:Ue(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(208,null),m.localize(209,null),""],description:m.localize(210,null)})),autoClosingComments:Ue(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(211,null),m.localize(212,null),""],description:m.localize(213,null)})),autoClosingDelete:Ue(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(214,null),""],description:m.localize(215,null)})),autoClosingOvertype:Ue(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(216,null),""],description:m.localize(217,null)})),autoClosingQuotes:Ue(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoIndent:Ue(new f(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null),m.localize(225,null)],description:m.localize(226,null)})),automaticLayout:Ue(new i(13,"automaticLayout",!1)),autoSurround:Ue(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),bracketPairColorization:Ue(new z),bracketPairGuides:Ue(new Z),stickyTabStops:Ue(new i(115,"stickyTabStops",!1,{description:m.localize(231,null)})),codeLens:Ue(new i(17,"codeLens",!0,{description:m.localize(232,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:m.localize(233,null)})),codeLensFontSize:Ue(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(234,null)})),colorDecorators:Ue(new i(20,"colorDecorators",!0,{description:m.localize(235,null)})),colorDecoratorActivatedOn:Ue(new c(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),colorDecoratorsLimit:Ue(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(240,null)})),columnSelection:Ue(new i(22,"columnSelection",!1,{description:m.localize(241,null)})),comments:Ue(new D),contextmenu:Ue(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new i(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(242,null)})),cursorBlinking:Ue(new f(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],y,{description:m.localize(243,null)})),cursorSmoothCaretAnimation:Ue(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),cursorStyle:Ue(new f(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:m.localize(248,null)})),cursorSurroundingLines:Ue(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(249,null)})),cursorSurroundingLinesStyle:Ue(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],markdownDescription:m.localize(252,null)})),cursorWidth:Ue(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(253,null)})),disableLayerHinting:Ue(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new i(34,"domReadOnly",!1)),dragAndDrop:Ue(new i(35,"dragAndDrop",!0,{description:m.localize(254,null)})),emptySelectionClipboard:Ue(new ee),dropIntoEditor:Ue(new ot),stickyScroll:Ue(new le),experimentalWhitespaceRendering:Ue(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:m.localize(259,null)})),find:Ue(new J),fixedOverflowWidgets:Ue(new i(42,"fixedOverflowWidgets",!1)),folding:Ue(new i(43,"folding",!0,{description:m.localize(260,null)})),foldingStrategy:Ue(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),foldingHighlight:Ue(new i(45,"foldingHighlight",!0,{description:m.localize(264,null)})),foldingImportsByDefault:Ue(new i(46,"foldingImportsByDefault",!1,{description:m.localize(265,null)})),foldingMaximumRegions:Ue(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(266,null)})),unfoldOnClickAfterEndOfLine:Ue(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(267,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(268,null)})),fontInfo:Ue(new S),fontLigatures2:Ue(new V),fontSize:Ue(new O),fontWeight:Ue(new Q),fontVariations:Ue(new R),formatOnPaste:Ue(new i(55,"formatOnPaste",!1,{description:m.localize(269,null)})),formatOnType:Ue(new i(56,"formatOnType",!1,{description:m.localize(270,null)})),glyphMargin:Ue(new i(57,"glyphMargin",!0,{description:m.localize(271,null)})),gotoLocation:Ue(new re),hideCursorInOverviewRuler:Ue(new i(59,"hideCursorInOverviewRuler",!1,{description:m.localize(272,null)})),hover:Ue(new he),inDiffEditor:Ue(new i(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>h.clamp(Y,-5,20),{description:m.localize(273,null)})),lightbulb:Ue(new Pe),lineDecorationsWidth:Ue(new W),lineHeight:Ue(new ae),lineNumbers:Ue(new we),lineNumbersMinChars:Ue(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new i(69,"linkedEditing",!1,{description:m.localize(274,null)})),links:Ue(new i(70,"links",!0,{description:m.localize(275,null)})),matchBrackets:Ue(new c(71,"matchBrackets","always",["always","near","never"],{description:m.localize(276,null)})),minimap:Ue(new de),mouseStyle:Ue(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:m.localize(277,null)})),mouseWheelZoom:Ue(new i(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(278,null)})),multiCursorMergeOverlapping:Ue(new i(76,"multiCursorMergeOverlapping",!0,{description:m.localize(279,null)})),multiCursorModifier:Ue(new f(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ke,{markdownEnumDescriptions:[m.localize(280,null),m.localize(281,null)],markdownDescription:m.localize(282,null)})),multiCursorPaste:Ue(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(283,null),m.localize(284,null)],markdownDescription:m.localize(285,null)})),multiCursorLimit:Ue(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(286,null)})),occurrencesHighlight:Ue(new c(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(287,null),m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),overviewRulerBorder:Ue(new i(81,"overviewRulerBorder",!0,{description:m.localize(291,null)})),overviewRulerLanes:Ue(new a(82,"overviewRulerLanes",3,0,3)),padding:Ue(new Ee),pasteAs:Ue(new rt),parameterHints:Ue(new ce),peekWidgetDefaultFocus:Ue(new c(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(292,null),m.localize(293,null)],description:m.localize(294,null)})),definitionLinkOpensInPeek:Ue(new i(87,"definitionLinkOpensInPeek",!1,{description:m.localize(295,null)})),quickSuggestions:Ue(new H),quickSuggestionsDelay:Ue(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(296,null)})),readOnly:Ue(new i(90,"readOnly",!1)),readOnlyMessage:Ue(new pe),renameOnType:Ue(new i(92,"renameOnType",!1,{description:m.localize(297,null),markdownDeprecationMessage:m.localize(298,null)})),renderControlCharacters:Ue(new i(93,"renderControlCharacters",!0,{description:m.localize(299,null),restricted:!0})),renderFinalNewline:Ue(new c(94,"renderFinalNewline",I.$e?"dimmed":"on",["off","on","dimmed"],{description:m.localize(300,null)})),renderLineHighlight:Ue(new c(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(301,null)],description:m.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Ue(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(303,null)})),renderValidationDecorations:Ue(new c(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new c(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(304,null),m.localize(305,null),m.localize(306,null),""],description:m.localize(307,null)})),revealHorizontalRightPadding:Ue(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new i(100,"roundedSelection",!0,{description:m.localize(308,null)})),rulers:Ue(new Fe),scrollbar:Ue(new N),scrollBeyondLastColumn:Ue(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(309,null)})),scrollBeyondLastLine:Ue(new i(104,"scrollBeyondLastLine",!0,{description:m.localize(310,null)})),scrollPredominantAxis:Ue(new i(105,"scrollPredominantAxis",!0,{description:m.localize(311,null)})),selectionClipboard:Ue(new i(106,"selectionClipboard",!0,{description:m.localize(312,null),included:I.$e})),selectionHighlight:Ue(new i(107,"selectionHighlight",!0,{description:m.localize(313,null)})),selectOnLineNumbers:Ue(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new c(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(314,null),m.localize(315,null),m.localize(316,null)],description:m.localize(317,null)})),showUnused:Ue(new i(110,"showUnused",!0,{description:m.localize(318,null)})),showDeprecated:Ue(new i(138,"showDeprecated",!0,{description:m.localize(319,null)})),inlayHints:Ue(new me),snippetSuggestions:Ue(new c(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(320,null),m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),smartSelect:Ue(new Te),smoothScrolling:Ue(new i(113,"smoothScrolling",!1,{description:m.localize(325,null)})),stopRenderingLineAfter:Ue(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new De),inlineSuggest:Ue(new G),inlineCompletionsAccessibilityVerbose:Ue(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(326,null)})),suggestFontSize:Ue(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new i(120,"suggestOnTriggerCharacters",!0,{description:m.localize(329,null)})),suggestSelection:Ue(new c(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null)],description:m.localize(333,null)})),tabCompletion:Ue(new c(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),tabIndex:Ue(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new q),unusualLineTerminators:Ue(new c(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),useShadowDOM:Ue(new i(126,"useShadowDOM",!0)),useTabStops:Ue(new i(127,"useTabStops",!0,{description:m.localize(342,null)})),wordBreak:Ue(new c(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),wordSeparators:Ue(new t(129,"wordSeparators",M.$fs,{description:m.localize(346,null)})),wordWrap:Ue(new c(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null),m.localize(350,null)],description:m.localize(351,null)})),wordWrapBreakAfterCharacters:Ue(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(352,null)})),wordWrapOverride1:Ue(new c(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new c(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new B),defaultColorDecorators:Ue(new i(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(353,null)})),pixelRatio:Ue(new _),tabFocusMode:Ue(new i(142,"tabFocusMode",!1,{markdownDescription:m.localize(354,null)})),layoutInfo:Ue(new ue),wrappingInfo:Ue(new Ye),wrappingIndent:Ue(new We),wrappingStrategy:Ue(new $e)}}),define(Re[148],Ae([9,10]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[149],Ae([9,10]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[150],Ae([9,10]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(Re[151],Ae([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[152],Ae([9,10]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[153],Ae([9,10]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Re[154],Ae([9,10]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Re[155],Ae([9,10]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[156],Ae([9,10]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Re[157],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Re[158],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[159],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[160],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[161],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[162],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[163],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(Re[164],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[165],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[166],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[167],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[168],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[169],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[170],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/common/configuration",e)}),define(Re[171],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Re[172],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(Re[173],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[174],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[175],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[176],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[177],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[178],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[179],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[180],Ae([9,10]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[181],Ae([1,0,11,150]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var I;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(I||(e.TokenType=I={}));function T(...b){switch(b.length){case 1:return(0,P.localize)(0,null,b[0]);case 2:return(0,P.localize)(1,null,b[0],b[1]);case 3:return(0,P.localize)(2,null,b[0],b[1],b[2]);default:return}}const M=(0,P.localize)(3,null),m=(0,P.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,$.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const C=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:C,lexeme:l,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const C=this.c.substring(this.d,this.e),l=g.b.get(C);l?this.k(l):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,C=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(m);return}const v=this.c.charCodeAt(A);if(C)C=!1;else if(v===47&&!l){A++;break}else v===91?l=!0:v===92?C=!0:v===93&&(l=!1);A++}for(;A<this.c.length&&g.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=g,g.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0))),g.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Re[182],Ae([1,0,25,31,152,294]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function g(i){return i=i.trim(),i==="*"||M.test(i)}e.$Zo=g;function b(i){if(!g(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=i.match(M);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}e.$1o=b;function A(i){if(!i)return null;const s=i.majorBase,a=i.majorMustEqual,u=i.minorBase;let h=i.minorMustEqual;const t=i.patchBase;let r=i.patchMustEqual;i.hasCaret&&(s===0||(h=!1),r=!1);let c=0;if(i.preRelease){const f=m.exec(i.preRelease);if(f){const[,w,d,D]=f;c=Date.UTC(Number(w),Number(d)-1,Number(D))}}return{majorBase:s,majorMustEqual:a,minorBase:u,minorMustEqual:h,patchBase:t,patchMustEqual:r,isMinimum:i.hasGreaterEquals,notBefore:c}}e.$2o=A;function C(i,s,a){let u;typeof i=="string"?u=A(b(i)):u=i;let h;s instanceof Date?h=s.getTime():typeof s=="string"&&(h=new Date(s).getTime());let t;if(typeof a=="string"?t=A(b(a)):t=a,!u||!t)return!1;const r=u.majorBase,c=u.minorBase,f=u.patchBase;let w=t.majorBase,d=t.minorBase,D=t.patchBase;const L=t.notBefore;let y=t.majorMustEqual,E=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?r>w?!0:r<w?!1:c>d?!0:c<d||h&&h<L?!1:f>=D:(r===1&&w===0&&(!y||!E||!k)&&(w=1,d=0,D=0,y=!0,E=!1,k=!1),r<w?!1:r>w?!y:c<d?!1:c>d?!E:f<D?!1:f>D?!k:!(h&&h<L))}e.$3o=C;function l(i,s,a,u,h){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([P.default.Error,I.localize(0,null)]),t;if(typeof u.name!="string")return t.push([P.default.Error,I.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([P.default.Error,I.localize(2,null,"version")]),t;if(!u.engines)return t.push([P.default.Error,I.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([P.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!o(u.extensionDependencies))return t.push([P.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!o(u.activationEvents))return t.push([P.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([P.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([P.default.Warning,I.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([P.default.Error,I.localize(9,null,"main")]),t;{const f=(0,$.$Dg)(a,u.main);(0,$.$xg)(f,a)||t.push([P.default.Warning,I.localize(10,null,f.path,a.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([P.default.Error,I.localize(11,null,"browser")]),t;{const f=(0,$.$Dg)(a,u.browser);(0,$.$xg)(f,a)||t.push([P.default.Warning,I.localize(12,null,f.path,a.path)])}}if(!T.valid(u.version))return t.push([P.default.Error,I.localize(13,null)]),t;const r=[];if(!p(i,s,u,h,r))for(const f of r)t.push([P.default.Error,f]);return t}e.$4o=l;function p(i,s,a,u,h){return u||typeof a.main>"u"&&typeof a.browser>"u"?!0:n(i,s,a.engines.vscode,h)}e.$5o=p;function v(i,s,a){return i==="*"||n(s,a,i)}e.$6o=v;function n(i,s,a,u=[]){const h=A(b(a));if(!h)return u.push(I.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return u.push(I.localize(15,null,a)),!1}else if(!h.majorMustEqual)return u.push(I.localize(16,null,a)),!1;return C(i,s,h)?!0:(u.push(I.localize(17,null,i,a)),!1)}function o(i){if(!Array.isArray(i))return!1;for(let s=0,a=i.length;s<a;s++)if(typeof i[s]!="string")return!1;return!0}}),define(Re[69],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class ${constructor(I,T=[],M=!1){this.ctor=I,this.staticArguments=T,this.supportsDelayedInstantiation=M}}e.$Yh=$}),define(Re[70],Ae([1,0,69]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.InstantiationType=void 0;const P=[];var I;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function T(m,g,b){g instanceof $.$Yh||(g=new $.$Yh(g,[],!!b)),P.push([m,g])}e.$Kr=T;function M(){return P}e.$Lr=M}),define(Re[183],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;class ${constructor(T,M){this.key=T,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$pq=$;class P{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const M of this.a.values())M.outgoing.size===0&&T.push(M);return T}insertEdge(T,M){const m=this.lookupOrInsertNode(T),g=this.lookupOrInsertNode(M);m.outgoing.set(g.key,g),g.incoming.set(m.key,m)}removeNode(T){const M=this.b(T);this.a.delete(M);for(const m of this.a.values())m.outgoing.delete(M),m.incoming.delete(M)}lookupOrInsertNode(T){const M=this.b(T);let m=this.a.get(M);return m||(m=new $(M,T),this.a.set(M,m)),m}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[M,m]of this.a)T.push(`${M}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,M]of this.a){const m=new Set([T]),g=this.c(M,m);if(g)return g}}c(T,M){for(const[m,g]of T.outgoing){if(M.has(m))return[...M,m].join(" -> ");M.add(m);const b=this.c(g,M);if(b)return b;M.delete(m)}}}e.$qq=P}),define(Re[4],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var $;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function m(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=m})($||(e._util=$={})),e.$1h=I("instantiationService");function P(M,m,g){m[$.DI_TARGET]===m?m[$.DI_DEPENDENCIES].push({id:M,index:g}):(m[$.DI_DEPENDENCIES]=[{id:M,index:g}],m[$.DI_TARGET]=m)}function I(M){if($.serviceIds.has(M))return $.serviceIds.get(M);const m=function(g,b,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(m,g,A)};return m.toString=()=>M,$.serviceIds.set(M,m),m}e.$2h=I;function T(M){return M}e.$3h=T}),define(Re[41],Ae([1,0,16,2,4]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,I.$2h)("configurationService");function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof P.URI)}e.$wi=T;function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof P.URI)}e.$xi=M;var m;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function g(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=g;function b(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$zi=b;function A(i,s){const a=Object.create(null);for(const u in i)C(a,u,i[u],s);return a}e.$Ai=A;function C(i,s,a,u){const h=s.split("."),t=h.pop();let r=i;for(let c=0;c<h.length;c++){const f=h[c];let w=r[f];switch(typeof w){case"undefined":w=r[f]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(w)}`);return}r=w}if(typeof r=="object"&&r!==null)try{r[t]=a}catch{u(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(r)}`)}e.$Bi=C;function l(i,s){const a=s.split(".");p(i,a)}e.$Ci=l;function p(i,s){const a=s.shift();if(s.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const u=i[a];typeof u=="object"&&!Array.isArray(u)&&(p(u,s),Object.keys(u).length===0&&delete i[a])}}function v(i,s,a){function u(r,c){let f=r;for(const w of c){if(typeof f!="object"||f===null)return;f=f[w]}return f}const h=s.split("."),t=u(i,h);return typeof t>"u"?a:t}e.$Di=v;function n(i,s,a){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in i?$.$Gf(i[u])&&$.$Gf(s[u])?n(i[u],s[u],a):a&&(i[u]=s[u]):i[u]=s[u])})}e.$Ei=n;function o(i){return i.replace(/[\[\]]/g,"")}e.$Fi=o}),define(Re[35],Ae([1,0,21,12,181,4,149,11]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",$.$d),g.set("isLinux",$.$e),g.set("isWindows",$.$c),g.set("isWeb",$.$i),g.set("isMacNative",$.$d&&!$.$i),g.set("isEdge",$.$B),g.set("isFirefox",$.$z),g.set("isChrome",$.$y),g.set("isSafari",$.$A);function b(me,W){if(g.get(me)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(me,W)}e.$Xi=b;const A=Object.prototype.hasOwnProperty;var C;(function(me){me[me.False=0]="False",me[me.True=1]="True",me[me.Defined=2]="Defined",me[me.Not=3]="Not",me[me.Equals=4]="Equals",me[me.NotEquals=5]="NotEquals",me[me.And=6]="And",me[me.Regex=7]="Regex",me[me.NotRegex=8]="NotRegex",me[me.Or=9]="Or",me[me.In=10]="In",me[me.NotIn=11]="NotIn",me[me.Greater=12]="Greater",me[me.GreaterEquals=13]="GreaterEquals",me[me.Smaller=14]="Smaller",me[me.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const l={regexParsingWithErrorRecovery:!0},p=(0,M.localize)(0,null),v=(0,M.localize)(1,null),n=(0,M.localize)(2,null),o=(0,M.localize)(3,null),i=(0,M.localize)(4,null),s=(0,M.localize)(5,null),a=(0,M.localize)(6,null),u=(0,M.localize)(7,null);class h{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=l){this.k=W,this.d=new I.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ae=this.l();if(!this.E()){const de=this.D(),ke=de.type===17?s:void 0;throw this.h.push({message:i,offset:de.offset,lexeme:I.$Wi.getLexeme(de),additionalInfo:ke}),h.c}return ae}catch(ae){if(ae!==h.c)throw ae;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const ae=this.o();W.push(ae)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const ae=this.s();W.push(ae)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ae=this.l();return this.A(1,o),ae?.negate()}case 17:return this.z(),F.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ae=this.l();return this.A(1,o),ae}case 17:{const ae=W.lexeme;if(this.z(),this.y(9)){const ke=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ke.type!==10)throw this.B("REGEX",ke);const Ee=ke.lexeme,ce=Ee.lastIndexOf("/"),_=ce===Ee.length-1?void 0:this.w(Ee.substring(ce+1));let H;try{H=new RegExp(Ee.substring(1,ce),_)}catch{throw this.B("REGEX",ke)}return S.create(ae,H)}switch(ke.type){case 10:case 19:{const Ee=[ke.lexeme];this.z();let ce=this.D(),_=0;for(let Fe=0;Fe<ke.lexeme.length;Fe++)ke.lexeme.charCodeAt(Fe)===40?_++:ke.lexeme.charCodeAt(Fe)===41&&_--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let Fe=0;Fe<ce.lexeme.length;Fe++)ce.lexeme.charCodeAt(Fe)===40?_++:ke.lexeme.charCodeAt(Fe)===41&&_--}if(_<0)break;Ee.push(I.$Wi.getLexeme(ce)),this.z(),ce=this.D()}const H=Ee.join(""),te=H.lastIndexOf("/"),we=te===H.length-1?void 0:this.w(H.substring(te+1));let be;try{be=new RegExp(H.substring(1,te),we)}catch{throw this.B("REGEX",ke)}return t.regex(ae,be)}case 18:{const Ee=ke.lexeme;this.z();let ce=null;if(!(0,P.$Ge)(Ee)){const _=Ee.indexOf("/"),H=Ee.lastIndexOf("/");if(_!==H&&_>=0){const te=Ee.slice(_+1,H),we=Ee[H+1]==="i"?"i":"";try{ce=new RegExp(te,we)}catch{throw this.B("REGEX",ke)}}}if(ce===null)throw this.B("REGEX",ke);return S.create(ae,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,n);const ke=this.u();return t.notIn(ae,ke)}switch(this.D().type){case 3:{this.z();const ke=this.u();if(this.x().type===18)return t.equals(ae,ke);switch(ke){case"true":return t.has(ae);case"false":return t.not(ae);default:return t.equals(ae,ke)}}case 4:{this.z();const ke=this.u();if(this.x().type===18)return t.notEquals(ae,ke);switch(ke){case"true":return t.not(ae);case"false":return t.has(ae);default:return t.notEquals(ae,ke)}}case 5:return this.z(),V.create(ae,this.u());case 6:return this.z(),R.create(ae,this.u());case 7:return this.z(),ee.create(ae,this.u());case 8:return this.z(),J.create(ae,this.u());case 13:return this.z(),t.in(ae,this.u());default:return t.has(ae)}}case 20:throw this.h.push({message:a,offset:W.offset,lexeme:"",additionalInfo:u}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ae){if(this.C(W))return this.z();throw this.B(ae,this.D())}B(W,ae,de){const ke=(0,M.localize)(8,null,W,I.$Wi.getLexeme(ae)),Ee=ae.offset,ce=I.$Wi.getLexeme(ae);return this.h.push({message:ke,offset:Ee,lexeme:ce,additionalInfo:de}),h.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=h,h.c=new Error;class t{static false(){return w.INSTANCE}static true(){return d.INSTANCE}static has(W){return D.create(W)}static equals(W,ae){return L.create(W,ae)}static notEquals(W,ae){return k.create(W,ae)}static regex(W,ae){return S.create(W,ae)}static in(W,ae){return y.create(W,ae)}static notIn(W,ae){return E.create(W,ae)}static not(W){return F.create(W)}static and(...W){return re.create(W,null,!0)}static or(...W){return he.create(W,null,!0)}static greater(W,ae){return ee.create(W,ae)}static greaterEquals(W,ae){return J.create(W,ae)}static smaller(W,ae){return V.create(W,ae)}static smallerEquals(W,ae){return R.create(W,ae)}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Zi=t,t.c=new h({regexParsingWithErrorRecovery:!1});function r(me){const W=new h({regexParsingWithErrorRecovery:!1});return me.map(ae=>(W.parse(ae),W.lexingErrors.length>0?W.lexingErrors.map(de=>({errorMessage:de.additionalInfo?(0,M.localize)(9,null,de.additionalInfo):(0,M.localize)(10,null),offset:de.offset,length:de.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(de=>({errorMessage:de.additionalInfo?`${de.message}. ${de.additionalInfo}`:de.message,offset:de.offset,length:de.lexeme.length})):[]))}e.$1i=r;function c(me,W){const ae=me?me.substituteConstants():void 0,de=W?W.substituteConstants():void 0;return!ae&&!de?!0:!ae||!de?!1:ae.equals(de)}e.$2i=c;function f(me,W){return me.cmp(W)}class w{constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return d.INSTANCE}}e.$3i=w,w.INSTANCE=new w;class d{constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return w.INSTANCE}}e.$4i=d,d.INSTANCE=new d;class D{static create(W,ae=null){const de=g.get(W);return typeof de=="boolean"?de?d.INSTANCE:w.INSTANCE:new D(W,ae)}constructor(W,ae){this.key=W,this.c=ae,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=g.get(this.key);return typeof W=="boolean"?W?d.INSTANCE:w.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$5i=D;class L{static create(W,ae,de=null){if(typeof ae=="boolean")return ae?D.create(W,de):F.create(W,de);const ke=g.get(W);return typeof ke=="boolean"?ae===(ke?"true":"false")?d.INSTANCE:w.INSTANCE:new L(W,ae,de)}constructor(W,ae,de){this.c=W,this.d=ae,this.f=de,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=g.get(this.c);if(typeof W=="boolean"){const ae=W?"true":"false";return this.d===ae?d.INSTANCE:w.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$6i=L;class y{static create(W,ae){return new y(W,ae)}constructor(W,ae){this.d=W,this.f=ae,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ae=W.getValue(this.f),de=W.getValue(this.d);return Array.isArray(ae)?ae.includes(de):typeof de=="string"&&typeof ae=="object"&&ae!==null?A.call(ae,de):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$7i=y;class E{static create(W,ae){return new E(W,ae)}constructor(W,ae){this.d=W,this.f=ae,this.type=11,this.c=y.create(W,ae)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=E;class k{static create(W,ae,de=null){if(typeof ae=="boolean")return ae?F.create(W,de):D.create(W,de);const ke=g.get(W);return typeof ke=="boolean"?ae===(ke?"true":"false")?w.INSTANCE:d.INSTANCE:new k(W,ae,de)}constructor(W,ae,de){this.c=W,this.d=ae,this.f=de,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=g.get(this.c);if(typeof W=="boolean"){const ae=W?"true":"false";return this.d===ae?w.INSTANCE:d.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$9i=k;class F{static create(W,ae=null){const de=g.get(W);return typeof de=="boolean"?de?w.INSTANCE:d.INSTANCE:new F(W,ae)}constructor(W,ae){this.c=W,this.d=ae,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=g.get(this.c);return typeof W=="boolean"?W?w.INSTANCE:d.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$0i=F;function B(me,W){if(typeof me=="string"){const ae=parseFloat(me);isNaN(ae)||(me=ae)}return typeof me=="string"||typeof me=="number"?W(me):w.INSTANCE}class ee{static create(W,ae,de=null){return B(ae,ke=>new ee(W,ke,de))}constructor(W,ae,de){this.c=W,this.d=ae,this.f=de,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$$i=ee;class J{static create(W,ae,de=null){return B(ae,ke=>new J(W,ke,de))}constructor(W,ae,de){this.c=W,this.d=ae,this.f=de,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$_i=J;class V{static create(W,ae,de=null){return B(ae,ke=>new V(W,ke,de))}constructor(W,ae,de){this.c=W,this.d=ae,this.f=de,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$aj=V;class R{static create(W,ae,de=null){return B(ae,ke=>new R(W,ke,de))}constructor(W,ae,de){this.c=W,this.d=ae,this.f=de,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$bj=R;class S{static create(W,ae){return new S(W,ae)}constructor(W,ae){this.d=W,this.f=ae,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ae=this.f?this.f.source:"",de=W.f?W.f.source:"";return ae<de?-1:ae>de?1:0}equals(W){if(W.type===this.type){const ae=this.f?this.f.source:"",de=W.f?W.f.source:"";return this.d===W.d&&ae===de}return!1}substituteConstants(){return this}evaluate(W){const ae=W.getValue(this.d);return this.f?this.f.test(ae):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=O.create(this)),this.c}}e.$cj=S;class O{static create(W){return new O(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new O(this.c.map(W))}negate(){return this.c}}e.$dj=O;function Q(me){let W=null;for(let ae=0,de=me.length;ae<de;ae++){const ke=me[ae].substituteConstants();if(me[ae]!==ke&&W===null){W=[];for(let Ee=0;Ee<ae;Ee++)W[Ee]=me[Ee]}W!==null&&(W[ae]=ke)}return W===null?me:W}class re{static create(W,ae,de){return re.d(W,ae,de)}constructor(W,ae){this.expr=W,this.c=ae,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ae=0,de=this.expr.length;ae<de;ae++){const ke=f(this.expr[ae],W.expr[ae]);if(ke!==0)return ke}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ae=0,de=this.expr.length;ae<de;ae++)if(!this.expr[ae].equals(W.expr[ae]))return!1;return!0}return!1}substituteConstants(){const W=Q(this.expr);return W===this.expr?this:re.create(W,this.c,!1)}evaluate(W){for(let ae=0,de=this.expr.length;ae<de;ae++)if(!this.expr[ae].evaluate(W))return!1;return!0}static d(W,ae,de){const ke=[];let Ee=!1;for(const ce of W)if(ce){if(ce.type===1){Ee=!0;continue}if(ce.type===0)return w.INSTANCE;if(ce.type===6){ke.push(...ce.expr);continue}ke.push(ce)}if(ke.length===0&&Ee)return d.INSTANCE;if(ke.length!==0){if(ke.length===1)return ke[0];ke.sort(f);for(let ce=1;ce<ke.length;ce++)ke[ce-1].equals(ke[ce])&&(ke.splice(ce,1),ce--);if(ke.length===1)return ke[0];for(;ke.length>1;){const ce=ke[ke.length-1];if(ce.type!==9)break;ke.pop();const _=ke.pop(),H=ke.length===0,te=he.create(ce.expr.map(we=>re.create([we,_],null,de)),null,H);te&&(ke.push(te),ke.sort(f))}if(ke.length===1)return ke[0];if(de){for(let ce=0;ce<ke.length;ce++)for(let _=ce+1;_<ke.length;_++)if(ke[ce].negate().equals(ke[_]))return w.INSTANCE;if(ke.length===1)return ke[0]}return new re(ke,ae)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ae of this.expr)W.push(...ae.keys());return W}map(W){return new re(this.expr.map(ae=>ae.map(W)),null)}negate(){if(!this.c){const W=[];for(const ae of this.expr)W.push(ae.negate());this.c=he.create(W,this,!0)}return this.c}}e.$ej=re;class he{static create(W,ae,de){return he.d(W,ae,de)}constructor(W,ae){this.expr=W,this.c=ae,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ae=0,de=this.expr.length;ae<de;ae++){const ke=f(this.expr[ae],W.expr[ae]);if(ke!==0)return ke}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ae=0,de=this.expr.length;ae<de;ae++)if(!this.expr[ae].equals(W.expr[ae]))return!1;return!0}return!1}substituteConstants(){const W=Q(this.expr);return W===this.expr?this:he.create(W,this.c,!1)}evaluate(W){for(let ae=0,de=this.expr.length;ae<de;ae++)if(this.expr[ae].evaluate(W))return!0;return!1}static d(W,ae,de){let ke=[],Ee=!1;if(W){for(let ce=0,_=W.length;ce<_;ce++){const H=W[ce];if(H){if(H.type===0){Ee=!0;continue}if(H.type===1)return d.INSTANCE;if(H.type===9){ke=ke.concat(H.expr);continue}ke.push(H)}}if(ke.length===0&&Ee)return w.INSTANCE;ke.sort(f)}if(ke.length!==0){if(ke.length===1)return ke[0];for(let ce=1;ce<ke.length;ce++)ke[ce-1].equals(ke[ce])&&(ke.splice(ce,1),ce--);if(ke.length===1)return ke[0];if(de){for(let ce=0;ce<ke.length;ce++)for(let _=ce+1;_<ke.length;_++)if(ke[ce].negate().equals(ke[_]))return d.INSTANCE;if(ke.length===1)return ke[0]}return new he(ke,ae)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ae of this.expr)W.push(...ae.keys());return W}map(W){return new he(this.expr.map(ae=>ae.map(W)),null)}negate(){if(!this.c){const W=[];for(const ae of this.expr)W.push(ae.negate());for(;W.length>1;){const ae=W.shift(),de=W.shift(),ke=[];for(const Ee of le(ae))for(const ce of le(de))ke.push(re.create([Ee,ce],null,!1));W.unshift(he.create(ke,null,!1))}this.c=he.create(W,this,!0)}return this.c}}e.$fj=he;class fe extends D{static all(){return fe.d.values()}constructor(W,ae,de){super(W,null),this.f=ae,typeof de=="object"?fe.d.push({...de,key:W}):de!==!0&&fe.d.push({key:W,description:de,type:ae!=null?typeof ae:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return L.create(this.key,W)}notEqualsTo(W){return k.create(this.key,W)}}e.$gj=fe,fe.d=[],e.$hj=(0,T.$2h)("contextKeyService");function ue(me,W){return me<W?-1:me>W?1:0}function $e(me,W,ae,de){return me<ae?-1:me>ae?1:W<de?-1:W>de?1:0}function ne(me,W){if(me.type===0||W.type===1)return!0;if(me.type===9)return W.type===9?Pe(me.expr,W.expr):!1;if(W.type===9){for(const ae of W.expr)if(ne(me,ae))return!0;return!1}if(me.type===6){if(W.type===6)return Pe(W.expr,me.expr);for(const ae of me.expr)if(ne(ae,W))return!0;return!1}return me.equals(W)}e.$ij=ne;function Pe(me,W){let ae=0,de=0;for(;ae<me.length&&de<W.length;){const ke=me[ae].cmp(W[de]);if(ke<0)return!1;ke===0&&ae++,de++}return ae===me.length}function le(me){return me.type===9?me.expr:[me]}}),define(Re[184],Ae([1,0,4]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,$.$2h)("environmentService"),e.$0h=(0,$.$3h)(e.$9h)}),define(Re[97],Ae([1,0,151,4]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$lo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0,e.$_n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ao=new RegExp(e.$_n),e.$bo="__web_extension",e.$co="skipWalkthrough",e.$do="extensionsSync",e.$eo="dependecyOrPackExtensionInstall";function I(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$fo=I;function T(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$go=T;function M(i,s){switch(i){case 3:return s==="x64"?"win32-x64":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$ho=M;function m(i,s){return s==="web"&&!i.includes("web")}e.$io=m;function g(i,s,a){return m(s,a)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===a}e.$jo=g;function b(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$ko=b;var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var C;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var l;(function(i){i.Install="install",i.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$lo=(0,P.$2h)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var n;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(s,a){super(s),this.code=a,this.name=a}}e.$mo=o,e.$no=(0,P.$2h)("extensionManagementService"),e.$oo="extensionsIdentifiers/disabled",e.$po="extensionsIdentifiers/enabled",e.$qo=(0,P.$2h)("IGlobalExtensionEnablementService"),e.$ro=(0,P.$2h)("IExtensionTipsService"),e.$so=(0,$.localize)(0,null),e.$to={value:e.$so,original:"Extensions"},e.$uo={value:(0,$.localize)(1,null),original:"Preferences"}}),define(Re[42],Ae([1,0,50,19,12,16,2,153,4,21,13,39]),function(ie,e,$,P,I,T,M,m,g,b,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileKind=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileOperationResult=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileChangeType=e.$Dk=e.FileOperation=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileSystemProviderErrorCode=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderCapabilities=e.$nk=e.FilePermission=e.FileType=e.$mk=e.$lk=void 0,e.$lk=(0,g.$2h)("fileService");function l(ne){return ne.create===!0}e.$mk=l;var p;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var v;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function n(ne){const Pe=ne;return!!Pe&&typeof Pe.onDidChange=="function"}e.$nk=n;var o;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function i(ne){return!!(ne.capabilities&2)}e.$ok=i;function s(ne){return!!(ne.capabilities&8)}e.$pk=s;function a(ne){return!!(ne.capabilities&131072)}e.$qk=a;function u(ne){return!!(ne.capabilities&4)}e.$rk=u;function h(ne){return!!(ne.capabilities&16)}e.$sk=h;function t(ne){return i(ne)?!!(ne.capabilities&16384):!1}e.$tk=t;function r(ne){return i(ne)?!!(ne.capabilities&32768):!1}e.$uk=r;function c(ne){return!!(ne.capabilities&65536)}e.$vk=c;function f(ne){return!!(ne.capabilities&2048)}e.$wk=f;var w;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class d extends Error{static create(Pe,le){const me=new d(Pe.toString(),le);return y(me,le),me}constructor(Pe,le){super(Pe),this.code=le}}e.$xk=d;function D(ne,Pe){return d.create(ne,Pe)}e.$yk=D;function L(ne){return ne||D((0,m.localize)(0,null),w.Unknown)}e.$zk=L;function y(ne,Pe){return ne.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",ne}e.$Ak=y;function E(ne){if(!ne)return w.Unknown;if(ne instanceof d)return ne.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!Pe)return w.Unknown;switch(Pe[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.$Bk=E;function k(ne){if(ne instanceof R)return ne.fileOperationResult;switch(E(ne)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}e.$Ck=k;var F;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class B{constructor(Pe,le,me){this.resource=Pe,this.operation=le,this.target=me}isOperation(Pe){return this.operation===Pe}}e.$Dk=B;var ee;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(ee||(e.FileChangeType=ee={}));class J{constructor(Pe,le){this.c=le,this.b=void 0,this.d=new C.$V(()=>{const me=$.$8h.forUris(()=>this.c);return me.fill(this.rawAdded.map(W=>[W,!0])),me}),this.f=new C.$V(()=>{const me=$.$8h.forUris(()=>this.c);return me.fill(this.rawUpdated.map(W=>[W,!0])),me}),this.g=new C.$V(()=>{const me=$.$8h.forUris(()=>this.c);return me.fill(this.rawDeleted.map(W=>[W,!0])),me}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const me of Pe){switch(me.type){case 1:this.rawAdded.push(me.resource);break;case 0:this.rawUpdated.push(me.resource);break;case 2:this.rawDeleted.push(me.resource);break}this.b!==J.a&&(typeof me.cId=="number"?this.b===void 0?this.b=me.cId:this.b!==me.cId&&(this.b=J.a):this.b!==void 0&&(this.b=J.a))}}contains(Pe,...le){return this.h(Pe,{includeChildren:!1},...le)}affects(Pe,...le){return this.h(Pe,{includeChildren:!0},...le)}h(Pe,le,...me){if(!Pe)return!1;const W=me.length>0;return!!((!W||me.includes(1))&&(this.d.value.get(Pe)||le.includeChildren&&this.d.value.findSuperstr(Pe))||(!W||me.includes(0))&&(this.f.value.get(Pe)||le.includeChildren&&this.f.value.findSuperstr(Pe))||(!W||me.includes(2))&&(this.g.value.findSubstr(Pe)||le.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$Ek=J,J.a=null;function V(ne,Pe,le){return!ne||!Pe||ne===Pe||Pe.length>ne.length?!1:(Pe.charAt(Pe.length-1)!==P.sep&&(Pe+=P.sep),le?(0,I.$9e)(ne,Pe):ne.indexOf(Pe)===0)}e.$Fk=V;class R extends Error{constructor(Pe,le,me){super(Pe),this.fileOperationResult=le,this.options=me}}e.$Gk=R;class S extends R{constructor(Pe,le,me,W){super(Pe,le,W),this.fileOperationResult=le,this.size=me}}e.$Hk=S;class O extends R{constructor(Pe,le,me){super(Pe,2,me),this.stat=le}}e.$Ik=O;var Q;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$Jk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Kk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Lk="files.associations",e.$Mk="files.exclude",e.$Nk="files.readonlyInclude",e.$Ok="files.readonlyExclude",e.$Pk="files.readonlyFromPermissions";var re;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(re||(e.FileKind=re={})),e.$Qk="";function he(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}e.$Rk=he;async function fe(ne,Pe){if(!Pe.hasProvider(M.URI.from({scheme:ne.scheme})))return new Promise(le=>{const me=Pe.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(me.dispose(),le())})})}e.$Sk=fe;class ue{static formatSize(Pe){return(0,T.$If)(Pe)||(Pe=0),Pe<ue.KB?(0,m.localize)(1,null,Pe.toFixed(0)):Pe<ue.MB?(0,m.localize)(2,null,(Pe/ue.KB).toFixed(2)):Pe<ue.GB?(0,m.localize)(3,null,(Pe/ue.MB).toFixed(2)):Pe<ue.TB?(0,m.localize)(4,null,(Pe/ue.GB).toFixed(2)):(0,m.localize)(5,null,(Pe/ue.TB).toFixed(2))}}e.$Tk=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;function $e(ne){const Pe=typeof ne=="string"||ne?.scheme===A.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===A.Schemas.file?1024*ue.MB:Pe?10*ue.MB:b.$i?50*ue.MB:1024*ue.MB}e.$Uk=$e}),define(Re[71],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class ${constructor(...I){this.a=new Map;for(const[T,M]of I)this.set(T,M)}set(I,T){const M=this.a.get(I);return this.a.set(I,T),M}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Zh=$}),define(Re[185],Ae([1,0,14,11,6,69,183,4,71,186]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;const A=!1;class C extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new g.$Zh,i=!1,s,a=A){this.f=o,this.g=i,this.h=s,this.i=a,this.o=new Set,this.f.set(m.$1h,this),this._globalGraph=a?s?._globalGraph??new M.$qq(u=>u):void 0}createChild(o){return new l(o,this.g,this,this.i)}invokeFunction(o,...i){const s=v.traceInvocation(this.i,o);let a=!1;try{return o({get:h=>{if(a)throw(0,P.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,s);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...i)}finally{a=!0,s.stop()}}createInstance(o,...i){let s,a;return o instanceof T.$Yh?(s=v.traceCreation(this.i,o.ctor),a=this.j(o.ctor,o.staticArguments.concat(i),s)):(s=v.traceCreation(this.i,o),a=this.j(o,i,s)),s.stop(),a}j(o,i=[],s){const a=m._util.getServiceDependencies(o).sort((t,r)=>t.index-r.index),u=[];for(const t of a){const r=this.m(t.id,s);r||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(r)}const h=a.length>0?a[0].index:i.length;if(i.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${i.length} static arguments`);const t=h-i.length;t>0?i=i.concat(new Array(t)):i=i.slice(0,h)}return Reflect.construct(o,i.concat(u))}k(o,i){if(this.f.get(o)instanceof T.$Yh)this.f.set(o,i);else if(this.h)this.h.k(o,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const i=this.f.get(o);return!i&&this.h?this.h.l(o):i}m(o,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const s=this.l(o);return s instanceof T.$Yh?this.q(o,s,i.branch(o,!0)):(i.branch(o,!1),s)}q(o,i,s){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,i,s)}finally{this.o.delete(o)}}r(o,i,s){const a=new M.$qq(t=>t.id.toString());let u=0;const h=[{id:o,desc:i,_trace:s}];for(;h.length;){const t=h.pop();if(a.lookupOrInsertNode(t),u++>1e3)throw new C(a);for(const r of m._util.getServiceDependencies(t.desc.ctor)){const c=this.l(r.id);if(c||this.u(`[createInstance] ${o} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),c instanceof T.$Yh){const f={id:r.id,desc:c,_trace:t._trace.branch(r.id,!0)};a.insertEdge(t,f),h.push(f)}}}for(;;){const t=a.roots();if(t.length===0){if(!a.isEmpty())throw new C(a);break}for(const{data:r}of t){if(this.l(r.id)instanceof T.$Yh){const f=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,f)}a.removeNode(r)}}return this.l(o)}s(o,i,s=[],a,u){if(this.f.get(o)instanceof T.$Yh)return this.t(o,i,s,a,u);if(this.h)return this.h.s(o,i,s,a,u);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(o,i,s=[],a,u){if(a){const h=new l(void 0,this.g,this,this.i);h.c=String(o);const t=new Map,r=new $.$ih(()=>{const c=h.j(i,s,u);for(const[f,w]of t){const d=c[f];if(typeof d=="function")for(const D of w)d.apply(c,D)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,f){if(!r.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let D=t.get(f);return D||(D=new b.$3c,t.set(f,D)),(y,E,k)=>{const F=D.push([y,E,k]);return(0,I.$Qc)(F)}}if(f in c)return c[f];const w=r.value;let d=w[f];return typeof d!="function"||(d=d.bind(w),c[f]=d),d},set(c,f,w){return r.value[f]=w,!0},getPrototypeOf(c){return i.prototype}})}else return this.j(i,s,u)}u(o,i){if(i&&console.warn(o),this.g)throw new Error(o)}}e.$rq=l;var p;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(p||(p={}));class v{static traceInvocation(o,i){return o?new v(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(o,i){return o?new v(1,i.name):v.c}constructor(o,i){this.type=o,this.name=i,this.g=Date.now(),this.h=[]}branch(o,i){const s=new v(3,o.toString());return this.h.push([o,i,s]),s}stop(){const o=Date.now()-this.g;v.f+=o;let i=!1;function s(u,h){const t=[],r=new Array(u+1).join("	");for(const[c,f,w]of h.h)if(f&&w){i=!0,t.push(`${r}CREATES -> ${c}`);const d=s(u+1,w);d&&t.push(d)}else t.push(`${r}uses -> ${c}`);return t.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${s(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(o>2||i)&&v.all.add(a.join(`
`))}}e.$sq=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0}),define(Re[15],Ae([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,l.$2h)("logService"),e.$kj=(0,l.$2h)("loggerService");function p(){return new Date().toISOString()}function v(y){return(0,b.$If)(y)}e.$lj=v;var n;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(n||(e.LogLevel=n={})),e.$mj=n.Info;function o(y,E,k){switch(E){case n.Trace:y.trace(k);break;case n.Debug:y.debug(k);break;case n.Info:y.info(k);break;case n.Warning:y.warn(k);break;case n.Error:y.error(k);break;case n.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=o;function i(y,E=!1){let k="";for(let F=0;F<y.length;F++){let B=y[F];if(B instanceof Error&&(B=(0,$.$Mi)(B,E)),typeof B=="object")try{B=JSON.stringify(B)}catch{}k+=(F>0?" ":"")+B}return k}class s extends T.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new P.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==n.Off&&this.b<=E}}e.$oj=s;class a extends s{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...k){this.f(n.Trace)&&this.g(n.Trace,i([E,...k],!0))}debug(E,...k){this.f(n.Debug)&&this.g(n.Debug,i([E,...k]))}info(E,...k){this.f(n.Info)&&this.g(n.Info,i([E,...k]))}warn(E,...k){this.f(n.Warning)&&this.g(n.Warning,i([E,...k]))}error(E,...k){if(this.f(n.Error))if(E instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=E.stack,this.g(n.Error,i(F))}else this.g(n.Error,i([E,...k]))}flush(){}}e.$pj=a;class u extends s{constructor(E=e.$mj){super(),this.setLevel(E),this.g=!m.$c}trace(E,...k){this.f(n.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...k):console.log(`[main ${p()}]`,E,...k))}debug(E,...k){this.f(n.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...k):console.log(`[main ${p()}]`,E,...k))}info(E,...k){this.f(n.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,E,...k):console.log(`[main ${p()}]`,E,...k))}warn(E,...k){this.f(n.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,E,...k):console.warn(`[main ${p()}]`,E,...k))}error(E,...k){this.f(n.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,E,...k):console.error(`[main ${p()}]`,E,...k))}dispose(){}flush(){}}e.$qj=u;class h extends s{constructor(E=e.$mj,k=!0){super(),this.g=k,this.setLevel(E)}trace(E,...k){this.f(n.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...k):console.log(E,...k))}debug(E,...k){this.f(n.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...k):console.log(E,...k))}info(E,...k){this.f(n.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...k):console.log(E,...k))}warn(E,...k){this.f(n.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...k):console.log(E,...k))}error(E,...k){this.f(n.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...k):console.error(E,...k))}dispose(){}flush(){}}e.$rj=h;class t extends s{constructor(E,k=e.$mj){super(),this.g=E,this.setLevel(k)}trace(E,...k){this.f(n.Trace)&&this.g.log(n.Trace,[this.h(E),...k])}debug(E,...k){this.f(n.Debug)&&this.g.log(n.Debug,[this.h(E),...k])}info(E,...k){this.f(n.Info)&&this.g.log(n.Info,[this.h(E),...k])}warn(E,...k){this.f(n.Warning)&&this.g.log(n.Warning,[this.h(E),...k])}error(E,...k){this.f(n.Error)&&this.g.log(n.Error,[this.h(E),...k])}h(E){return typeof E=="string"?E:(0,$.$Mi)(E,this.f(n.Trace))}dispose(){}flush(){}}e.$sj=t;class r extends s{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const k of this.g)k.setLevel(E);super.setLevel(E)}trace(E,...k){for(const F of this.g)F.trace(E,...k)}debug(E,...k){for(const F of this.g)F.debug(E,...k)}info(E,...k){for(const F of this.g)F.info(E,...k)}warn(E,...k){for(const F of this.g)F.warn(E,...k)}error(E,...k){for(const F of this.g)F.error(E,...k)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$tj=r;class c extends T.$Sc{constructor(E,k,F){if(super(),this.h=E,this.j=k,this.b=new M.$Ac,this.c=this.B(new P.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$Sd),this.onDidChangeVisibility=this.g.event,F)for(const B of F)this.b.set(B.resource,{logger:void 0,info:B})}m(E){return(0,b.$Ef)(E)?[...this.b.values()].find(k=>k.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,k){const F=this.n(E),B=(0,b.$Ef)(E)?E:k?.id??(0,I.$Pi)(F.toString()).toString(16);let ee=this.b.get(F)?.logger;const J=k?.logLevel==="always"?n.Trace:k?.logLevel;ee||(ee=this.s(F,J??this.getLogLevel(F)??this.h,{...k,id:B}));const V={logger:ee,info:{resource:F,id:B,logLevel:J,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(V.info),this.b.set(F,V),ee}n(E){return(0,b.$Ef)(E)?(0,g.$Dg)(this.j,`${E}.log`):E}setLogLevel(E,k){if(A.URI.isUri(E)){const F=E,B=k,ee=this.b.get(F);ee&&B!==ee.info.logLevel&&(ee.info.logLevel=B===this.h?void 0:B,ee.logger?.setLevel(B),this.b.set(ee.info.resource,ee),this.f.fire([F,B]))}else{this.h=E;for(const[F,B]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,k){const F=this.m(E);F&&k!==!F.info.hidden&&(F.info.hidden=!k,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,k]))}getLogLevel(E){let k;return E&&(k=this.b.get(E)?.info.logLevel),k??this.h}registerLogger(E){const k=this.b.get(E.resource);k?k.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const k=this.b.get(E);k&&(k.logger&&k.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=c;class f{constructor(){this.onDidChangeLogLevel=new P.$Sd().event}setLevel(E){}getLevel(){return n.Info}trace(E,...k){}debug(E,...k){}info(E,...k){}warn(E,...k){}error(E,...k){}critical(E,...k){}dispose(){}flush(){}}e.$vj=f;class w extends f{}e.$wj=w;function d(y){if(y.verbose)return n.Trace;if(typeof y.logLevel=="string"){const E=L(y.logLevel.toLowerCase());if(E!==void 0)return E}return e.$mj}e.$xj=d;function D(y){switch(y){case n.Trace:return"trace";case n.Debug:return"debug";case n.Info:return"info";case n.Warning:return"warn";case n.Error:return"error";case n.Off:return"off"}}e.$yj=D;function L(y){switch(y){case"trace":return n.Trace;case"debug":return n.Debug;case"info":return n.Info;case"warn":return n.Warning;case"error":return n.Error;case"critical":return n.Error;case"off":return n.Off}}e.$zj=L,e.$Aj=new C.$gj("logLevel",D(n.Info))}),define(Re[187],Ae([1,0,6,15]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dO=void 0;class I extends $.$Sc{constructor(M,m=[]){super(),this.a=new P.$tj([M,...m]),this.B(M.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...m){this.a.trace(M,...m)}debug(M,...m){this.a.debug(M,...m)}info(M,...m){this.a.info(M,...m)}warn(M,...m){this.a.warn(M,...m)}error(M,...m){this.a.error(M,...m)}flush(){this.a.flush()}}e.$dO=I}),define(Re[99],Ae([1,0,31,154,4]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var M;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(g){function b(v,n){return n-v}g.compare=b;const A=Object.create(null);A[g.Error]=(0,P.localize)(0,null),A[g.Warning]=(0,P.localize)(1,null),A[g.Info]=(0,P.localize)(2,null);function C(v){return A[v]||""}g.toString=C;function l(v){switch(v){case $.default.Error:return g.Error;case $.default.Warning:return g.Warning;case $.default.Info:return g.Info;case $.default.Ignore:return g.Hint}}g.fromSeverity=l;function p(v){switch(v){case g.Error:return $.default.Error;case g.Warning:return $.default.Warning;case g.Info:return $.default.Info;case g.Hint:return $.default.Ignore}}g.toSeverity=p}(M||(e.MarkerSeverity=M={}));var m;(function(g){const b="";function A(l){return C(l,!0)}g.makeKey=A;function C(l,p){const v=[b];return l.source?v.push(l.source.replace("\xA6","\\\xA6")):v.push(b),l.code?typeof l.code=="string"?v.push(l.code.replace("\xA6","\\\xA6")):v.push(l.code.value.replace("\xA6","\\\xA6")):v.push(b),l.severity!==void 0&&l.severity!==null?v.push(M.toString(l.severity)):v.push(b),l.message&&p?v.push(l.message.replace("\xA6","\\\xA6")):v.push(b),l.startLineNumber!==void 0&&l.startLineNumber!==null?v.push(l.startLineNumber.toString()):v.push(b),l.startColumn!==void 0&&l.startColumn!==null?v.push(l.startColumn.toString()):v.push(b),l.endLineNumber!==void 0&&l.endLineNumber!==null?v.push(l.endLineNumber.toString()):v.push(b),l.endColumn!==void 0&&l.endColumn!==null?v.push(l.endColumn.toString()):v.push(b),v.push(b),v.join("\xA6")}g.makeKeyOptionalMessage=C})(m||(e.IMarkerData=m={})),e.$nt=(0,I.$2h)("markerService")}),define(Re[188],Ae([1,0,5,31,4]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ev=e.$dv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$cv=e.Severity=void 0,e.Severity=P.default,e.$cv=(0,I.$2h)("notificationService");var T;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var M;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));var m;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class g{constructor(){this.progress=new b,this.onDidClose=$.Event.None,this.onDidChangeVisibility=$.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.$dv=g;class b{infinite(){}done(){}total(C){}worked(C){}}e.$ev=b}),define(Re[189],Ae([1,0,4]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,$.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ie,e,$,P){var I=arguments.length,T=I<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,$):P,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ie,e,$,P);else for(var m=ie.length-1;m>=0;m--)(M=ie[m])&&(T=(I<3?M(T):I>3?M(e,$,T):M(e,$))||T);return I>3&&T&&Object.defineProperty(e,$,T),T},Ge=this&&this.__param||function(ie,e){return function($,P){e($,P,ie)}};define(Re[72],Ae([1,0,14,20,6,4]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProgressLocation=e.$fv=void 0,e.$fv=(0,T.$2h)("progressService");var M;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$gv=Object.freeze({total(){},worked(){},done(){}});class m{get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$hv=m,m.None=Object.freeze({report(){}});class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$iv=g;let b=class extends I.$Sc{constructor(l,p){super(),this.a=new $.$mh,p.withProgress(l,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,I.$Qc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$jv=b,e.$jv=b=Je([Ge(1,e.$fv)],b);class A extends I.$Sc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Rc)}start(l){this.stop();const p=++this.a,v=new P.$3d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Qc)(()=>v.cancel())),this.b.add((0,I.$Qc)(()=>this.c?this.c.done():void 0)),{id:p,token:v.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$kv=A,e.$lv=(0,T.$2h)("editorProgressService")}),define(Re[30],Ae([1,0,53,16]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0;class I{constructor(){this.a=new Map}add(M,m){$.ok(P.$Ef(M)),$.ok(P.$Gf(m)),$.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,m)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$un=new I}),define(Re[73],Ae([1,0,5,30]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$vn={JSONContribution:"base.contributions.json"};function I(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class T{constructor(){this.b=new $.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,b){this.a[I(g)]=b,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const M=new T;P.$un.add(e.$vn.JSONContribution,M)}),define(Re[54],Ae([1,0,18,5,16,148,41,73,30]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.ConfigurationScope=e.$zn=e.EditPresentationTypes=void 0;var b;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$zn={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn="vscode://schemas/settings/resourceLanguage",e.$Hn="vscode://schemas/settings/configurationDefaults";const C=g.$un.as(m.$vn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new P.$Sd,this.onDidSchemaChange=this.i.event,this.j=new P.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Gn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const c=new Set;this.n(t,r,c),C.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const r=new Set;this.o(t,r),C.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const c=new Set;this.o(r,c),this.n(t,!1,c),C.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const c=[];for(const{overrides:f,source:w}of t)for(const d in f)if(r.add(d),e.$Jn.test(d)){const D=this.a.get(d),L=D?.valuesSources??new Map;if(w)for(const F of Object.keys(f[d]))L.set(F,w);const y={...D?.value||{},...f[d]};this.a.set(d,{source:w,value:y,valuesSources:L});const E=(0,M.$Fi)(d),k={type:"object",default:y,description:T.localize(1,null,E),$ref:e.$Gn,defaultDefaultValue:y,source:I.$Ef(w)?void 0:w,defaultValueSource:w};c.push(...n(d)),this.d[d]=k,this.b.properties[d]=k}else{this.a.set(d,{value:f[d],source:w});const D=this.d[d];D&&(this.w(d,D),this.r(d,D))}this.m(c)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:c,source:f}of t)for(const w in c){const d=this.a.get(w),D=I.$Ef(f)?f:f?.id,L=I.$Ef(d?.source)?d?.source:d?.source?.id;if(D===L)if(r.add(w),this.a.delete(w),e.$Jn.test(w))delete this.d[w],delete this.b.properties[w];else{const y=this.d[w];y&&(this.w(w,y),this.r(w,y))}}this.u()}deltaConfiguration(t){let r=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,c){t.forEach(f=>{this.p(f,r,f.extensionInfo,f.restrictedProperties,void 0,c),this.c.push(f),this.q(f)})}o(t,r){const c=f=>{if(f.properties)for(const w in f.properties){r.add(w);const d=this.d[w];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[w],this.s(w,f.properties[w])}f.allOf?.forEach(w=>c(w))};for(const f of t){c(f);const w=this.c.indexOf(f);w!==-1&&this.c.splice(w,1)}}p(t,r=!0,c,f,w=3,d){w=I.$Nf(t.scope)?w:t.scope;const D=t.properties;if(D)for(const y in D){const E=D[y];if(r&&a(y,E)){delete D[y];continue}if(E.source=c,E.defaultDefaultValue=D[y].default,this.w(y,E),e.$Jn.test(y)?E.scope=void 0:(E.scope=I.$Nf(E.scope)?w:E.scope,E.restricted=I.$Nf(E.restricted)?!!f?.includes(y):E.restricted),D[y].hasOwnProperty("included")&&!D[y].included){this.f[y]=D[y],delete D[y];continue}else this.d[y]=D[y],D[y].policy?.name&&this.e.set(D[y].policy.name,y);!D[y].deprecationMessage&&D[y].markdownDeprecationMessage&&(D[y].deprecationMessage=D[y].markdownDeprecationMessage),d.add(y)}const L=t.allOf;if(L)for(const y of L)this.p(y,r,c,f,w,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=c=>{const f=c.properties;if(f)for(const d in f)this.r(d,f[d]);c.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$An.properties[t]=r,r.scope){case 1:e.$Bn.properties[t]=r;break;case 2:e.$Cn.properties[t]=r;break;case 6:e.$Dn.properties[t]=r;break;case 3:e.$En.properties[t]=r;break;case 4:e.$Fn.properties[t]=r;break;case 5:e.$Fn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$An.properties[t],r.scope){case 1:delete e.$Bn.properties[t];break;case 2:delete e.$Cn.properties[t];break;case 6:delete e.$Dn.properties[t];break;case 3:delete e.$En.properties[t];break;case 4:case 5:delete e.$Fn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,c={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$Gn};this.w(r,c),e.$An.properties[r]=c,e.$Bn.properties[r]=c,e.$Cn.properties[r]=c,e.$Dn.properties[r]=c,e.$En.properties[r]=c,e.$Fn.properties[r]=c}}v(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$Gn};e.$An.patternProperties[e.$In]=t,e.$Bn.patternProperties[e.$In]=t,e.$Cn.patternProperties[e.$In]=t,e.$Dn.patternProperties[e.$In]=t,e.$En.patternProperties[e.$In]=t,e.$Fn.patternProperties[e.$In]=t,this.i.fire()}w(t,r){const c=this.a.get(t);let f=c?.value,w=c?.source;I.$Lf(f)&&(f=r.defaultDefaultValue,w=void 0),I.$Lf(f)&&(f=i(r.type)),r.default=f,r.defaultValueSource=w}}const p="\\[([^\\]]+)\\]",v=new RegExp(p,"g");e.$In=`^(${p})+$`,e.$Jn=new RegExp(e.$In);function n(h){const t=[];if(e.$Jn.test(h)){let r=v.exec(h);for(;r?.length;){const c=r[1].trim();c&&t.push(c),r=v.exec(h)}}return(0,$.$Mb)(t)}e.$Kn=n;function o(h){return h.reduce((t,r)=>`${t}[${r}]`,"")}e.$Ln=o;function i(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Mn=i;const s=new l;g.$un.add(e.$zn.Configuration,s);function a(h,t){return h.trim()?e.$Jn.test(h)?T.localize(7,null,h):s.getConfigurationProperties()[h]!==void 0?T.localize(8,null,h):t.policy?.name&&s.getPolicyConfigurations().get(t.policy?.name)!==void 0?T.localize(9,null,h,t.policy?.name,s.getPolicyConfigurations().get(t.policy?.name)):null:T.localize(6,null)}e.$Nn=a;function u(){const h=[],t=s.getConfigurationProperties();for(const r of Object.keys(t))h.push([r,t[r].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$On=u}),define(Re[190],Ae([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=void 0;function p(r){return Object.isFrozen(r)?r:m.$jn(r)}class v{constructor(c={},f=[],w=[],d){this.b=c,this.c=f,this.d=w,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(f=>{if(f instanceof v)return f;const w=new n("");return w.parseRaw(f),w.configurationModel});this.f=c.reduce((f,w)=>w===f?w:f.merge(w),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,A.$Di)(this.contents,c):this.contents}inspect(c,f){const w=this.rawConfiguration.getValue(c),d=f?this.rawConfiguration.getOverrideValue(c,f):void 0,D=f?this.rawConfiguration.override(f).getValue(c):w;return{value:w,override:d,merged:D}}getOverrideValue(c,f){const w=this.i(f);return w?c?(0,A.$Di)(w,c):w:void 0}getKeysForOverrideIdentifier(c){const f=[];for(const w of this.overrides)w.identifiers.includes(c)&&f.push(...w.keys);return $.$Mb(f)}getAllOverrideIdentifiers(){const c=[];for(const f of this.overrides)c.push(...f.identifiers);return $.$Mb(c)}override(c){let f=this.a.get(c);return f||(f=this.g(c),this.a.set(c,f)),f}merge(...c){const f=m.$in(this.contents),w=m.$in(this.overrides),d=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const L of c)if(D.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(f,L.contents);for(const y of L.overrides){const[E]=w.filter(k=>$.$ub(k.identifiers,y.identifiers));E?(this.h(E.contents,y.contents),E.keys.push(...y.keys),E.keys=$.$Mb(E.keys)):w.push(m.$in(y))}for(const y of L.keys)d.indexOf(y)===-1&&d.push(y)}return new v(f,d,w,D.every(L=>L instanceof v)?void 0:D)}g(c){const f=this.i(c);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const w={};for(const d of $.$Mb([...Object.keys(this.contents),...Object.keys(f)])){let D=this.contents[d];const L=f[d];L&&(typeof D=="object"&&typeof L=="object"?(D=m.$in(D),this.h(D,L)):D=L),w[d]=D}return new v(w,this.keys,this.overrides)}h(c,f){for(const w of Object.keys(f)){if(w in c&&g.$Gf(c[w])&&g.$Gf(f[w])){this.h(c[w],f[w]);continue}c[w]=m.$in(f[w])}}i(c){let f=null,w=null;const d=D=>{D&&(w?this.h(w,D):w=m.$in(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===c?f=D.contents:D.identifiers.includes(c)&&d(D.contents);return d(f),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,f){this.j(c,f,!0)}setValue(c,f){this.j(c,f,!1)}removeValue(c){const f=this.keys.indexOf(c);f!==-1&&(this.keys.splice(f,1),(0,A.$Ci)(this.contents,c),C.$Jn.test(c)&&this.overrides.splice(this.overrides.findIndex(w=>$.$ub(w.identifiers,(0,C.$Kn)(c))),1))}j(c,f,w){(0,A.$Bi)(this.contents,c,f,d=>console.error(d)),w=w||this.keys.indexOf(c)===-1,w&&this.keys.push(c),C.$Jn.test(c)&&this.overrides.push({identifiers:(0,C.$Kn)(c),keys:Object.keys(this.contents[c]),contents:(0,A.$Ai)(this.contents[c],d=>console.error(d))})}}e.$Pn=v;class n{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,f){if(!g.$Nf(c)){const w=this.g(c);this.parseRaw(w,f)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,f){this.a=c;const{contents:w,keys:d,overrides:D,restricted:L,hasExcludedProperties:y}=this.h(c,f);this.b=new v(w,d,D,y?[c]:void 0),this.c=L||[]}g(c){let f={},w=null,d=[];const D=[],L=[];function y(k){Array.isArray(d)?d.push(k):w!==null&&(d[w]=k)}const E={onObjectBegin:()=>{const k={};y(k),D.push(d),d=k,w=null},onObjectProperty:k=>{w=k},onObjectEnd:()=>{d=D.pop()},onArrayBegin:()=>{const k=[];y(k),D.push(d),d=k,w=null},onArrayEnd:()=>{d=D.pop()},onLiteralValue:y,onError:(k,F,B)=>{L.push({error:k,offset:F,length:B})}};if(c)try{I.$fn(c,E),f=d[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return f}h(c,f){const w=l.$un.as(C.$zn.Configuration).getConfigurationProperties(),d=this.i(c,w,!0,f);c=d.raw;const D=(0,A.$Ai)(c,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),L=Object.keys(c),y=this.j(c,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:D,keys:L,overrides:y,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(c,f,w,d){let D=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:D};const L={},y=[];for(const E in c)if(C.$Jn.test(E)&&w){const k=this.i(c[E],f,!1,d);L[E]=k.raw,D=D||k.hasExcludedProperties,y.push(...k.restricted)}else{const k=f[E],F=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&y.push(E),!d.exclude?.includes(E)&&(d.include?.includes(E)||(F===void 0||d.scopes===void 0||d.scopes.includes(F))&&!(d.skipRestricted&&k?.restricted))?L[E]=c[E]:D=!0}return{raw:L,restricted:y,hasExcludedProperties:D}}j(c,f){const w=[];for(const d of Object.keys(c))if(C.$Jn.test(d)){const D={};for(const L in c[d])D[L]=c[d][L];w.push({identifiers:(0,C.$Kn)(d),keys:Object.keys(D),contents:(0,A.$Ai)(D,f)})}return w}}e.$Qn=n;class o extends T.$Sc{constructor(c,f,w,d){super(),this.c=c,this.f=f,this.g=d,this.b=this.B(new P.$Sd),this.onDidChange=this.b.event,this.a=new n(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&w.isEqual(D.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Rn=o;class i{constructor(c,f,w,d,D,L,y,E,k,F,B,ee,J){this.a=c,this.b=f,this.c=w,this.overrideIdentifiers=d,this.d=D,this.f=L,this.g=y,this.h=E,this.i=k,this.j=F,this.k=B,this.l=ee,this.m=J}get value(){return p(this.c)}n(c,f,w){const d=c.inspect(f,w);return{get value(){return p(d.value)},get override(){return p(d.override)},get merged(){return p(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class s{constructor(c,f,w,d,D=new v,L=new v,y=new M.$Ac,E=new v,k=new M.$Ac){this.c=c,this.d=f,this.f=w,this.g=d,this.h=D,this.i=L,this.j=y,this.l=E,this.m=k,this.a=null,this.b=new M.$Ac,this.n=null}getValue(c,f,w){return this.p(c,f,w).getValue(c)}updateValue(c,f,w={}){let d;w.resource?(d=this.m.get(w.resource),d||(d=new v,this.m.set(w.resource,d))):d=this.l,f===void 0?d.removeValue(c):d.setValue(c,f),w.resource||(this.a=null)}inspect(c,f,w){const d=this.p(c,f,w),D=this.t(f.resource,w),L=f.resource?this.m.get(f.resource)||this.l:this.l,y=new Set;for(const E of d.overrides)for(const k of E.identifiers)d.getOverrideValue(c,k)!==void 0&&y.add(k);return new i(c,f,d.getValue(c),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,D||void 0,L)}keys(c){const f=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,f){this.j.set(c,f),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,f){const w=[];if(!f){const{added:d,updated:D,removed:L}=h(this.c,c);f=[...d,...D,...L]}for(const d of f)for(const D of(0,C.$Kn)(d)){const L=this.c.getKeysForOverrideIdentifier(D),y=c.getKeysForOverrideIdentifier(D),E=[...y.filter(k=>L.indexOf(k)===-1),...L.filter(k=>y.indexOf(k)===-1),...L.filter(k=>!m.$mn(this.c.override(D).getValue(k),c.override(D).getValue(k)))];w.push([D,E])}return this.updateDefaultConfiguration(c),{keys:f,overrides:w}}compareAndUpdatePolicyConfiguration(c){const{added:f,updated:w,removed:d}=h(this.d,c),D=[...f,...w,...d];return D.length&&this.updatePolicyConfiguration(c),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:f,updated:w,removed:d,overrides:D}=h(this.applicationConfiguration,c),L=[...f,...w,...d];return L.length&&this.updateApplicationConfiguration(c),{keys:L,overrides:D}}compareAndUpdateLocalUserConfiguration(c){const{added:f,updated:w,removed:d,overrides:D}=h(this.localUserConfiguration,c),L=[...f,...w,...d];return L.length&&this.updateLocalUserConfiguration(c),{keys:L,overrides:D}}compareAndUpdateRemoteUserConfiguration(c){const{added:f,updated:w,removed:d,overrides:D}=h(this.remoteUserConfiguration,c),L=[...f,...w,...d];return L.length&&this.updateRemoteUserConfiguration(c),{keys:L,overrides:D}}compareAndUpdateWorkspaceConfiguration(c){const{added:f,updated:w,removed:d,overrides:D}=h(this.workspaceConfiguration,c),L=[...f,...w,...d];return L.length&&this.updateWorkspaceConfiguration(c),{keys:L,overrides:D}}compareAndUpdateFolderConfiguration(c,f){const w=this.folderConfigurations.get(c),{added:d,updated:D,removed:L,overrides:y}=h(w,f),E=[...d,...D,...L];return(E.length||!w)&&this.updateFolderConfiguration(c,f),{keys:E,overrides:y}}compareAndDeleteFolderConfiguration(c){const f=this.folderConfigurations.get(c);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:w,updated:d,removed:D,overrides:L}=h(f,void 0);return{keys:[...w,...d,...D],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,f,w){let d=this.q(f,w);return f.overrideIdentifier&&(d=d.override(f.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(d=d.merge(this.d)),d}q({resource:c},f){let w=this.r();if(f&&c){const d=f.getFolder(c);d&&(w=this.s(d.uri)||w);const D=this.m.get(c);D&&(w=w.merge(D))}return w}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let f=this.b.get(c);if(!f){const w=this.r(),d=this.j.get(c);d?(f=w.merge(d),this.b.set(c,f)):f=w}return f}t(c,f){if(f&&c){const w=f.getFolder(c);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,f)=>{const{contents:w,overrides:d,keys:D}=this.j.get(f);return c.push([f,{contents:w,overrides:d,keys:D}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(f=>c.add(f)),this.userConfiguration.keys.forEach(f=>c.add(f)),this.i.keys.forEach(f=>c.add(f)),this.j.forEach(f=>f.keys.forEach(w=>c.add(w))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(f=>c.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>c.add(f)),this.i.getAllOverrideIdentifiers().forEach(f=>c.add(f)),this.j.forEach(f=>f.getAllOverrideIdentifiers().forEach(w=>c.add(w))),[...c.values()]}v(c){const f=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(w=>f.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>f.add(w)),this.i.getKeysForOverrideIdentifier(c).forEach(w=>f.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(c).forEach(d=>f.add(d))),[...f.values()]}static parse(c){const f=this.w(c.defaults),w=this.w(c.policy),d=this.w(c.application),D=this.w(c.user),L=this.w(c.workspace),y=c.folders.reduce((E,k)=>(E.set(b.URI.revive(k[0]),this.w(k[1])),E),new M.$Ac);return new s(f,w,d,D,new v,L,y,new v,new M.$Ac)}static w(c){return new v(c.contents,c.keys,c.overrides)}}e.$Sn=s;function a(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const c=new Set,f=new Map;for(const d of r)d.keys.forEach(D=>c.add(D)),d.overrides.forEach(([D,L])=>{const y=(0,M.$xc)(f,D,new Set);L.forEach(E=>y.add(E))});const w=[];return f.forEach((d,D)=>w.push([D,[...d.values()]])),{keys:[...c.values()],overrides:w}}e.$Tn=a;class u{constructor(c,f,w,d){this.change=c,this.f=f,this.g=w,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const D of c.keys)this.affectedKeys.add(D);for(const[,D]of c.overrides)for(const L of D)this.affectedKeys.add(L);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=s.parse(this.f.data)),this.i}affectsConfiguration(c,f){const w=this.a+c,d=this.d.indexOf(w);if(d<0)return!1;const D=d+w.length;if(D>=this.d.length)return!1;const L=this.d.charCodeAt(D);if(L!==this.b&&L!==this.c)return!1;if(f){const y=this.previousConfiguration?this.previousConfiguration.getValue(c,f,this.f?.workspace):void 0,E=this.g.getValue(c,f,this.h);return!m.$mn(y,E)}return!0}}e.$Un=u;function h(r,c){const{added:f,removed:w,updated:d}=t(c?.rawConfiguration,r?.rawConfiguration),D=[],L=r?.getAllOverrideIdentifiers()||[],y=c?.getAllOverrideIdentifiers()||[];if(c){const E=y.filter(k=>!L.includes(k));for(const k of E)D.push([k,c.getKeysForOverrideIdentifier(k)])}if(r){const E=L.filter(k=>!y.includes(k));for(const k of E)D.push([k,r.getKeysForOverrideIdentifier(k)])}if(c&&r){for(const E of L)if(y.includes(E)){const k=t({contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)},{contents:c.getOverrideValue(void 0,E)||{},keys:c.getKeysForOverrideIdentifier(E)});D.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:f,removed:w,updated:d,overrides:D}}function t(r,c){const f=r?c?r.keys.filter(D=>c.keys.indexOf(D)===-1):[...r.keys]:[],w=c?r?c.keys.filter(D=>r.keys.indexOf(D)===-1):[...c.keys]:[],d=[];if(r&&c){for(const D of c.keys)if(r.keys.indexOf(D)!==-1){const L=(0,A.$Di)(c.contents,D),y=(0,A.$Di)(r.contents,D);m.$mn(L,y)||d.push(D)}}return{added:f,removed:w,updated:d}}}),define(Re[100],Ae([1,0,11,4]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.RemoteAuthorityResolverErrorCode=e.$5k=e.$4k=e.RemoteConnectionType=e.$3k=void 0,e.$3k=(0,P.$2h)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class T{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$4k=T;class M{constructor(C,l){this.host=C,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$5k=M;var m;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class g extends $.$bb{static isNotAvailable(C){return C instanceof g&&C._code===m.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof g&&C._code===m.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof g&&C._code===m.NoResolverFound}static isInvalidAuthority(C){return C instanceof g&&C._code===m.InvalidAuthority}static isHandled(C){return C instanceof g&&C.isHandled}constructor(C,l=m.Unknown,p){super(C),this._message=C,this._code=l,this._detail=p,this.isHandled=l===m.NotAvailable&&p===!0,Object.setPrototypeOf(this,g.prototype)}}e.$6k=g;function b(A){const C=A.indexOf("+");return C===-1?A:A.substring(0,C)}e.$7k=b}),define(Re[55],Ae([1,0,13]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0;function P(b){return b.scheme===$.Schemas.vscodeRemote?b.authority:void 0}e.$8k=P;function I(b){if(!b)return;const A=b.indexOf("+");return A<0?b:b.substr(0,A)}e.$9k=I;function T(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$0k=T;function M(b){const{host:A,port:C}=g(b);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:C}}e.$$k=M;function m(b,A){let{host:C,port:l}=g(b);return typeof l>"u"&&(l=A),{host:C,port:l}}e.$_k=m;function g(b){const A=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const C=b.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const l=b.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:b,port:void 0}}}),define(Re[22],Ae([1,0,12,4,55]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.TargetPlatform=e.ExtensionType=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=void 0,e.$bm="extensions.user.cache",e.$cm="extensions.builtin.cache",e.$dm="undefined_publisher",e.$em=["ui","workspace","web"];function T(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.$fm=T,e.$gm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(M||(e.ExtensionType=M={}));var m;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,i){if(typeof o>"u"||o===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof o=="string"||typeof i=="string"){const s=typeof o=="string"?o:o.value,a=typeof i=="string"?i:i.value;return $.$8e(s,a)}return o._lower===i._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$hm=g;class b{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const i of o)this.add(i)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$im=b;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,i){this.c.set(g.toKey(o),i)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$jm=A;function C(n){return l(n)}e.$km=C;function l(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.$lm=l;function p(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.$mm=p;function v(n,o){if(o){const i=`onResolveRemoteAuthority:${(0,I.$9k)(o)}`;return!!n.activationEvents?.includes(i)}return!1}e.$nm=v,e.$om=(0,P.$2h)("IBuiltinExtensionsScannerService")}),define(Re[101],Ae([1,0,11,22]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(M,m){this.a.set(M,m)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const m=Object.create(null);for(const g of M){const b=this.readActivationEvents(g);b.length>0&&(m[P.$hm.toKey(g.identifier)]=b)}return m}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const m=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let g=0;g<m.length;g++)m[g]==="onUri"&&(m[g]=`onUri:${P.$hm.toKey(M.identifier)}`);if(!M.contributes)return m;for(const g in M.contributes){const b=this.a.get(g);if(!b)continue;const A=M.contributes[g],C=Array.isArray(A)?A:[A];try{b(C,m)}catch(l){(0,$.$1)(l)}}return m}}e.$2E=I,e.$3E=new I}),define(Re[191],Ae([1,0,21,74,34]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=void 0;function T(g){if($.$o===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function M(g,b,A,C,l,p,v,n,o){const i=Object.create(null);i["common.machineId"]=p,i["common.sqmId"]=v,i.sessionID=(0,I.$mg)()+Date.now(),i.commitHash=C,i.version=l,i["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,$.$b)($.$o),i["common.nodePlatform"]=P.$dc,i["common.nodeArch"]=A,i["common.product"]=o||"desktop",n&&(i["common.msftInternal"]=n);let s=0;const a=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),$.$f&&(i["common.snap"]="true");const u=T(b);return u&&(i["common.platformDetail"]=u),i}e.$vo=M;function m(g){const b=P.env.USERDNSDOMAIN;if(!b)return!1;const A=b.toLowerCase();return g.some(C=>A===C)}e.$wo=m}),define(Re[192],Ae([1,0,4]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=void 0,e.$pl=(0,$.$2h)("telemetryService"),e.$ql=(0,$.$2h)("customEndpointTelemetryService"),e.$rl="telemetry.currentSessionDate",e.$sl="telemetry.firstSessionDate",e.$tl="telemetry.lastSessionDate",e.$ul="telemetry.machineId",e.$vl="telemetry.sqmId",e.$wl="telemetry",e.$xl="telemetry.telemetryLevel",e.$yl="telemetry.enableCrashReporter",e.$zl="telemetry.enableTelemetry";var P;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var I;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Re[56],Ae([1,0,26,16,5,41,55,191,192]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;class b{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$xo=b;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yo=A,e.$zo=new A;class C{async publicLog(w,d,D){}async publicLogError(w,d,D){}}e.$Ao=C,e.$Bo="telemetry",e.$Co="extensionTelemetryLog",e.$Do={log:()=>null,flush:()=>Promise.resolve(null)};function l(f,w){return I.Event.debounce(w.onDidChangeConfiguration,(D,L)=>{const y=D?new Set([...D.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:y}},1e3,!0)(D=>{D.source!==7&&f.publicLog2("updateConfiguration",{configurationSource:(0,T.$yi)(D.source),configurationKeys:Array.from(D.affectedKeys)})})}e.$Eo=l;function p(f,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!f.enableTelemetry)}e.$Fo=p;function v(f,w){return w.extensionTestsLocationURI?!0:!(w.isBuilt||w.disableTelemetry||f.enableTelemetry&&f.aiConfig?.ariaKey)}e.$Go=v;function n(f){const w=f.getValue(g.$xl),d=f.getValue(g.$yl);if(f.getValue(g.$zl)===!1||d===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Ho=n;function o(f){const w={},d={},D={};a(f,D);for(let L in D){L=L.length>150?L.substr(L.length-149):L;const y=D[L];typeof y=="number"?d[L]=y:typeof y=="boolean"?d[L]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${y.length}`),w[L]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(w[L]=y)}return{properties:w,measurements:d}}e.$Io=o;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(f){if(!f)return"none";const w=(0,M.$9k)(f);return i.has(w)?w:"other"}e.$Jo=s;function a(f,w,d=0,D){if(f)for(const L of Object.getOwnPropertyNames(f)){const y=f[L],E=D?D+L:L;Array.isArray(y)?w[E]=(0,$.$nn)(y):y instanceof Date?w[E]=y.toISOString():(0,P.$Gf)(y)?d<2?a(y,w,d+1,E+"."):w[E]=(0,$.$nn)(y):w[E]=y}}function u(f,w){const d=f.msftInternalDomains||[],D=w.getValue("telemetry.internalTesting");return(0,m.$wo)(d)||D}e.$Ko=u;function h(f){return[f.appRoot,f.extensionsPath,f.userHome.fsPath,f.tmpDir.fsPath,f.userDataPath]}e.$Lo=h;function t(f,w){if(!f||!f.includes("/")&&!f.includes("\\"))return f;let d=f;const D=[];for(const k of w)for(;;){const F=k.exec(f);if(!F)break;D.push([F.index,k.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(d="";;){const k=y.exec(f);if(!k)break;const F=D.some(([B,ee])=>k.index<ee&&B<y.lastIndex);!L.test(k[0])&&!F&&(d+=f.substring(E,k.index)+"<REDACTED: user-file-path>",E=y.lastIndex)}return E<f.length&&(d+=f.substr(E)),d}function r(f){if(!f)return f;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of w)if(d.regex.test(f))return`<REDACTED: ${d.label}>`;return f}function c(f,w){return(0,$.$kn)(f,d=>{if(d instanceof b||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let D=d.replaceAll("%20"," ");D=t(D,w);for(const L of w)D=D.replace(L,"");return D=r(D),D}})}e.$Mo=c}),define(Re[193],Ae([1,0,12,97,22,21,2,11,74,56]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;function A(c,f){return c.uuid&&f.uuid?c.uuid===f.uuid:c.id===f.id?!0:(0,$.$3e)(c.id,f.id)===0}e.$No=A;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(f){const w=f.manifest?f.manifest.version:f.version,d=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new l(f.identifier,w,d)}static parse(f){const w=C.exec(f);return w&&w[1]&&w[2]?new l({id:w[1]},w[2],w[4]||void 0):null}constructor(f,w,d="undefined"){this.version=w,this.targetPlatform=d,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof l?A(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$Oo=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(c){const f=p.exec(c);return f&&f[1]?[o(f[1]),f[2]]:[o(c),void 0]}e.$Po=v;function n(c,f){return`${c}.${f}`}e.$Qo=n;function o(c){return c.toLowerCase()}e.$Ro=o;function i(c,f){return o(n(c??I.$dm,f))}e.$So=i;function s(c,f){const w=[],d=D=>{for(const L of w)if(L.some(y=>A(f(y),f(D))))return L;return null};for(const D of c){const L=d(D);L?L.push(D):w.push([D])}return w}e.$To=s;function a(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$Uo=a;function u(c){return{id:new b.$xo(c.identifier.id),name:new b.$xo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Vo=u,e.$Wo=new I.$hm("pprice.better-merge");function h(c,f){const w=[],d=f.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const D=d.shift();if(D&&w.every(L=>!A(L.identifier,{id:D}))){const L=c.filter(y=>A(y.identifier,{id:D}));L.length===1&&(w.push(L[0]),d.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$Xo=h;async function t(c,f){if(!T.$e)return!1;let w;try{w=(await c.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await c.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){f.debug("Error while getting the os-release file.",(0,m.$0)(D))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(c,f){const w=await t(c,f),d=(0,P.$ho)(w?"alpine":T.$o,g.$ec);return f.debug("ComputeTargetPlatform:",d),d}e.$Yo=r}),define(Re[194],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0;function $(g){return[...g.entries()]}e.$yr=$;function P(g){return g?[...g.entries()]:[]}e.$zr=P;function I(g){return new Map(g)}e.$Ar=I;function T(g){return new Map(g??[])}e.$Br=T;function M(g){return Array.from(g.entries()).map(b=>[b[0],$(b[1].map),P(b[1].descriptionMap)])}e.$Cr=M;function m(g){return new Map(g.map(b=>[b[0],{map:I(b[1]),descriptionMap:T(b[2])}]))}e.$Dr=m}),define(Re[195],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Crb=void 0;class ${constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,T,M=5){const m=T(g=>{const b=typeof g=="string"?g:g.data;let A=this.a.get(I);if(A){A.data.push(b);return}const C=setTimeout(()=>this.flushBuffer(I),M);A={data:[b],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(I),m.dispose()}},this.a.set(I,A)});return m}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const T=this.a.get(I);T&&(this.a.delete(I),this.b(I,T.data.join("")))}}e.$Crb=$}),define(Re[196],Ae([1,0,14,90,46,5,16,2,155,73,30]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.IconFontDefinition=e.IconContribution=e.$iw=void 0,e.$iw={IconContribution:"base.contributions.icons"};var C;(function(u){function h(t,r){let c=t.defaults;for(;I.ThemeIcon.isThemeIcon(c);){const f=v.getIcon(c.id);if(!f)return;c=f.defaults}return c}u.getDefinition=h})(C||(e.IconContribution=C={}));var l;(function(u){function h(r){return{weight:r.weight,style:r.style,src:r.src.map(c=>({format:c.format,location:c.location.toString()}))}}u.toJSONObject=h;function t(r){const c=f=>(0,M.$Ef)(f)?f:void 0;if(r&&Array.isArray(r.src)&&r.src.every(f=>(0,M.$Ef)(f.format)&&(0,M.$Ef)(f.location)))return{weight:c(r.weight),style:c(r.style),src:r.src.map(f=>({format:f.format,location:m.URI.parse(f.location)}))}}u.fromJSONObject=t})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new T.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,r,c){const f=this.b[h];if(f){if(r&&!f.description){f.description=r,this.d.properties[h].markdownDescription=`${r} $(${h})`;const D=this.e.enum.indexOf(h);D!==-1&&(this.e.enumDescriptions[D]=r),this.a.fire()}return f}const w={id:h,description:r,defaults:t,deprecationMessage:c};this.b[h]=w;const d={$ref:"#/definitions/icons"};return c&&(d.deprecationMessage=c),r&&(d.markdownDescription=`${r}: $(${h})`),this.d.properties[h]=d,this.e.enum.push(h),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const r=this.f[h];return r||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(f,w)=>f.id.localeCompare(w.id),t=f=>{for(;I.ThemeIcon.isThemeIcon(f.defaults);)f=this.b[f.defaults.id];return`codicon codicon-${f?f.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(f=>this.b[f]);for(const f of c.filter(w=>!!w.description).sort(h))r.push(`|<i class="${t(f)}"></i>|${f.id}|${I.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const f of c.filter(w=>!I.ThemeIcon.isThemeIcon(w.defaults)).sort(h))r.push(`|<i class="${t(f)}"></i>|${f.id}|`);return r.join(`
`)}}const v=new p;A.$un.add(e.$iw.IconContribution,v);function n(u,h,t,r){return v.registerIcon(u,h,t,r)}e.$jw=n;function o(){return v}e.$kw=o;function i(){const u=(0,P.$6j)();for(const h in u){const t="\\"+u[h].toString(16);v.registerIcon(h,{fontCharacter:t})}}i(),e.$lw="vscode://schemas/icons";const s=A.$un.as(b.$vn.JSONContribution);s.registerSchema(e.$lw,v.getIconSchema());const a=new $.$bh(()=>s.notifySchemaChanged(e.$lw),200);v.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$mw=n("widget-close",P.$8j.close,(0,g.localize)(2,null)),e.$nw=n("goto-previous-location",P.$8j.arrowUp,(0,g.localize)(3,null)),e.$ow=n("goto-next-location",P.$8j.arrowDown,(0,g.localize)(4,null)),e.$pw=I.ThemeIcon.modify(P.$8j.sync,"spin"),e.$qw=I.ThemeIcon.modify(P.$8j.loading,"spin")}),define(Re[197],Ae([1,0,5,41,4,15]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.ProvidedOnAutoForward=e.$ov=e.TunnelPrivacyId=e.TunnelProtocol=e.$nv=e.$mv=void 0,e.$mv=(0,I.$2h)("tunnelService"),e.$nv=(0,I.$2h)("sharedTunnelsService");var M;(function(o){o.Http="http",o.Https="https"})(M||(e.TunnelProtocol=M={}));var m;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(m||(e.TunnelPrivacyId=m={}));function g(o){return!!o.forwardPort}e.$ov=g;var b;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(i)return{address:i[1],port:+i[2]}}e.$pv=A,e.$qv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(o){return e.$qv.indexOf(o)>=0}e.$rv=C,e.$sv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(o){return e.$sv.indexOf(o)>=0}e.$tv=l;function p(o,i,s,a){if(s===1)return!1;if(s===2&&l(i)){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(u?.length===4&&parseInt(u[1])>=18)return!1}return o<1024}e.$uv=p;class v{constructor(i,s,a){this.remoteAddress=i,this.localAddress=s,this.b=a,this.a=new $.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vv=v;let n=class{constructor(i,s){this.j=i,this.k=s,this.a=new $.$Sd,this.onTunnelOpened=this.a.event,this.b=new $.$Sd,this.onTunnelClosed=this.b.event,this.c=new $.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],s=Array.from(this.e.values());for(const a of s){const u=Array.from(a.values());for(const h of u){const t=await h.value;t&&typeof t!="string"&&i.push(t)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:s}of i.values())await s.then(a=>typeof a!="string"?a?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,s,a,u,h){this.p(i,s,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:s,localAddress:a,privacy:u,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,s){(l(i)||C(i))&&(i=e.$qv[0]);const a=this.r(i,s);if(a)return++a.refcount,a.value}openTunnel(i,s,a,u,h,t=!1,r,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${a} on local port ${h}.`);const f=this.f??i;if(!f)return;if(s||(s="localhost"),u||(u=this.l),this.f&&this.i.has(a)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(f,s,a,u,h,t,r,c);return w?w.then(d=>{if(d){if(typeof d=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(s,a),d}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(s,a);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.n(d);return(d.tunnelRemoteHost!==s||d.tunnelRemotePort!==a)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&d.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const s=this.e.get(i.tunnelRemoteHost);if(s){const a=s.get(i.tunnelRemotePort);a&&(a.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,a))}}}}async o(i,s,a){if(a.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${s}.`);const u=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(s),u}}async closeTunnel(i,s){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${s} `);const a=this.e.get(i);if(a&&a.has(s)){const u=a.get(s);u.refcount=0,await this.o(i,s,u)}}p(i,s,a){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(s,{refcount:1,value:a})}async q(i,s){const a=this.e.get(i);if(a){const u=a.get(s),h=u?await u.value:void 0;(!h||typeof h=="string")&&a.delete(s),a.size===0&&this.e.delete(i)}}r(i,s){const a=[i];C(i)?(a.push(...e.$qv),a.push(...e.$sv)):l(i)&&a.push(...e.$sv);const u=a.map(h=>this.e.get(h));for(const h of u){const t=h?.get(s);if(t)return t}}canTunnel(i){return!!A(i)}t(i,s,a,u,h,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${a} on local port ${u}.`);const c=a;this.i.add(c);const f=u===void 0?a:u,w={elevationRequired:h?this.isPortPrivileged(f):!1},d={remoteAddress:{host:s,port:a},localAddressPort:u,privacy:t,public:t?t!==m.Private:void 0,protocol:r},D=i.forwardPort(d,w);return D?(this.p(s,a,D),D.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),D}};e.$wv=n,e.$wv=n=Je([Ge(0,T.$jj),Ge(1,P.$vi)],n)}),define(Re[198],Ae([1,0,4]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$xv=void 0,e.$xv=(0,$.$2h)("editSessionIdentityService");var P;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(P||(e.EditSessionIdentityMatch=P={}))}),define(Re[199],Ae([1,0,13]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=void 0;function P(g){return g.scheme!==$.Schemas.file&&g.scheme!==$.Schemas.vscodeRemote}e.$kK=P;function I(g){if(g.folders.length)return g.folders.every(b=>P(b.uri))?g.folders[0].uri:void 0;if(g.configuration&&P(g.configuration))return g.configuration}e.$lK=I;function T(g){return I(g)?.scheme}e.$mK=T;function M(g){return I(g)?.authority}e.$nK=M;function m(g){return I(g)!==void 0}e.$oK=m}),define(Re[47],Ae([1,0,156,19,50,25,2,4,13]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,m.$2h)("contextService");function b(f){const w=f;return typeof w?.id=="string"&&M.URI.isUri(w.uri)}e.$_h=b;function A(f){return typeof f?.id=="string"&&!b(f)&&!l(f)}e.$ai=A,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function C(f,w){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,P.$nc)(f)}:w?e.$bi:e.$ci;const d=f;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$di=C;function l(f){const w=f;return typeof w?.id=="string"&&M.URI.isUri(w.configPath)}e.$ei=l;function p(f){const w=f;if(w?.uri)return{id:w.id,uri:M.URI.revive(w.uri)};const d=f;if(d?.configPath)return{id:d.id,configPath:M.URI.revive(d.configPath)};if(f?.id)return{id:f.id}}e.$fi=p;var v;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function n(f){const w=f;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$gi=n;function o(f){const w=f;return!!(w&&typeof w=="object"&&M.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$hi=o;class i{constructor(w,d,D,L,y){this.h=w,this.j=D,this.k=L,this.l=y,this.c=I.$8h.forUris(this.l,()=>!0),this.folders=d}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=I.$8h.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=i;class s{constructor(w,d){this.raw=d,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,T.$Dg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=s;function a(f){return new s({uri:f,index:0,name:(0,T.$zg)(f)},{uri:f.toString()})}e.$ki=a,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,$.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function u(f,w){return T.$ug.isEqualOrParent(f,w.untitledWorkspacesHome)}e.$pi=u;function h(f){let w;return M.URI.isUri(f)?w=f:w=f.configuration,w?.scheme===g.Schemas.tmp}e.$qi=h,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(f){return f.id===e.$ri}e.$si=t;function r(f,w){return!u(f,w)&&!h(f)}e.$ti=r;function c(f){return(typeof f=="string"?(0,P.$oc)(f):(0,T.$Bg)(f))===e.$mi}e.$ui=c}),define(Re[75],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class ${constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const T=this.c++;return this.b.set(T,I),this.e(),T}get(I,T){return this.b.has(I)?this.b.get(I)[T]:void 0}delete(I){this.b.delete(I),this.e()}e(){$.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$afc=$,$.a=!1}),define(Re[43],Ae([1,0,13,25,4]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=void 0;class T{constructor(){this.a=new Set(Object.keys($.Schemas)),this.b=new Map,this.extUri=new P.$sg(m=>{const g=this.b.get(m.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(m,g){g===null?this.b.delete(m.scheme):this.b.set(m.scheme,g)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$dfc=T,e.$efc=(0,I.$2h)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,4]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0,e.$8M=(0,$.$2h)("IExtHostInitDataService")}),define(Re[200],Ae([1,0,161,15,187,27]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;let M=class extends I.$dO{constructor(g,b,A){const C=A.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=A.remote.isRemote?(0,$.localize)(0,null):g?(0,$.localize)(1,null):(0,$.localize)(2,null);super(b.createLogger(C,{name:l}))}};e.$khc=M,e.$khc=M=Je([Ge(1,P.$kj),Ge(2,T.$8M)],M)}),define(Re[201],Ae([1,0,14]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=void 0;class P{constructor(M,m,g){this.h=new Map,this.a=M,this.b=m,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new $.$bh(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of b.values())A.complete()}catch(A){for(const C of b.values())C.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,m){let g=this.f[M];return typeof g>"u"&&(g=m),g}update(M,m){this.f[M]=m;const g=this.h.get(M);if(g!==void 0)return g.p;const b=new $.$mh;return this.h.set(M,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$Yfc=P;class I extends P{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,m){super(M.identifier.value,!0,m),this.j=M}}e.$Zfc=I}),define(Re[202],Ae([1,0,5,2]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class I{constructor(M){this.c=M,this.a=new $.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new $.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,m,g,b){const C=this.c.getNotebookDocument(P.URI.revive(M)).acceptModelChanged(m.value,g,b);this.b.fire(C)}$acceptDirtyStateChanged(M,m){this.c.getNotebookDocument(P.URI.revive(M)).acceptDirty(m)}$acceptModelSaved(M){const m=this.c.getNotebookDocument(P.URI.revive(M));this.a.fire(m.apiNotebook)}}e.$Mgc=I}),define(Re[17],Ae([1,0,4]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0,e.$RM=(0,$.$2h)("IExtHostRpcService");class P{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$SM=P});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[203],Ae([1,0,22,5]),function(ie,e,$,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class T{constructor(m,g){I.set(this,void 0),this.b=new P.$Sd,this.onDidChange=this.b.event,this.a=$.$hm.toKey(m.identifier),xe(this,I,g,"f"),ze(this,I,"f").onDidChangePassword(b=>{b.extensionId===this.a&&this.b.fire({key:b.key})})}get(m){return ze(this,I,"f").get(this.a,m)}store(m,g){return ze(this,I,"f").store(this.a,m,g)}delete(m){return ze(this,I,"f").delete(this.a,m)}}e.$7fc=T,I=new WeakMap}),define(Re[57],Ae([1,0,4]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=void 0,e.$wfc=(0,$.$2h)("IURITransformerService");class P{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$xfc=P}),define(Re[204],Ae([1,0,24]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kb=e.$6kb=void 0;class P{constructor(){this.buffers=[]}add(g){let b=this.buffers.indexOf(g);return b<0&&(b=this.buffers.length,this.buffers.push(g)),b}}function I(m,g){if(g.serializeBuffersForPostMessage){const b=new P,C=JSON.stringify(m,(p,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(v)};if(ArrayBuffer.isView(v)){const n=T(v);if(n)return{$$vscode_array_buffer_reference$$:!0,index:b.add(v.buffer),view:{type:n,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),l=b.buffers.map(p=>{const v=new Uint8Array(p);return $.$ge.wrap(v)});return{message:C,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$6kb=I;function T(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(m,g){const b=g.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),A=g.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const v=p,{index:n}=v,o=b[n];if(v.view)switch(v.view.type){case 1:return new Int8Array(o,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return p}:void 0;return{message:JSON.parse(m,A),arrayBuffers:b}}e.$7kb=M}),define(Re[102],Ae([1,0,171,16,2,6,4,30,42,13,40,141,31]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ME=e.$LE=e.$KE=e.EditorsOrder=e.$JE=e.CloseDirection=e.$IE=e.$HE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.EditorInputCapabilities=e.$yE=e.SaveReason=e.Verbosity=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=void 0,e.$lE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$mE={id:"default",displayName:(0,$.localize)(0,null),providerDisplayName:(0,$.localize)(1,null)},e.$nE="workbench.editor.sidebysideEditor",e.$oE="workbench.editors.textDiffEditor",e.$pE="workbench.editors.binaryResourceDiffEditor";var p;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var v;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function n(le){const me=le;return!!me&&typeof me.getSelection=="function"&&!!me.onDidChangeSelection}e.$qE=n;function o(le,me,W){for(const ae of W.visibleEditorPanes)if(ae.group.id===me&&le.matches(ae.input))return ae.getViewState()}e.$rE=o;function i(le){if(D(le))return!1;const me=le;return I.URI.isUri(me?.resource)}e.$sE=i;function s(le){if(D(le))return!1;const me=le;return me?.original!==void 0&&me.modified!==void 0}e.$tE=s;function a(le){if(D(le))return!1;const me=le;return Array.isArray(me?.resources)}e.$uE=a;function u(le){if(D(le)||s(le))return!1;const me=le;return me?.primary!==void 0&&me.secondary!==void 0}e.$vE=u;function h(le){if(D(le))return!1;const me=le;return me?me.resource===void 0||me.resource.scheme===b.Schemas.untitled||me.forceUntitled===!0:!1}e.$wE=h;function t(le){if(D(le))return!1;const me=le;return I.URI.isUri(me?.base?.resource)&&I.URI.isUri(me?.input1?.resource)&&I.URI.isUri(me?.input2?.resource)&&I.URI.isUri(me?.result?.resource)}e.$xE=t;var r;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var c;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class f{constructor(){this.a=new Map}registerSource(me,W){let ae=this.a.get(me);return ae||(ae={source:me,label:W},this.a.set(me,ae)),ae.source}getSourceLabel(me){return this.a.get(me)?.label??me}}e.$yE=new f;var w;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors",le[le.Scratchpad=512]="Scratchpad",le[le.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(w||(e.EditorInputCapabilities=w={}));class d extends T.$Sc{}e.$zE=d;function D(le){return le instanceof d}e.$AE=D;function L(le){const me=le;return I.URI.isUri(me?.preferredResource)}function y(le){const me=le;return D(me?.primary)&&D(me?.secondary)}e.$BE=y;function E(le){const me=le;return D(me?.modified)&&D(me?.original)}e.$CE=E;function k(le,me,W,ae,de){return Pe(ae,[(0,C.$Li)({id:"workbench.action.openLargeFile",label:(0,$.localize)(2,null),run:()=>{const ke={...W,limits:{size:Number.MAX_VALUE}};le.openEditor(me,ke)}}),(0,C.$Li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,$.localize)(3,null),run:()=>de.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$DE=k;function F(le){return D(le?.editor)}e.$EE=F;function B(le){const me=le;return F(le)&&me?.group!==void 0}e.$FE=B;function ee(le){const me=le;return typeof me?.groupId=="number"&&D(me.editor)}e.$GE=ee;var J;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(J||(e.EditorCloseContext=J={}));var V;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LABEL=2]="GROUP_LABEL",le[le.GROUP_LOCKED=3]="GROUP_LOCKED",le[le.EDITOR_OPEN=4]="EDITOR_OPEN",le[le.EDITOR_CLOSE=5]="EDITOR_CLOSE",le[le.EDITOR_MOVE=6]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=8]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=10]="EDITOR_PIN",le[le.EDITOR_STICKY=11]="EDITOR_STICKY",le[le.EDITOR_DIRTY=12]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(V||(e.GroupModelChangeKind=V={}));var R;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})(R||(e.SideBySideEditor=R={}));class S{getOriginalUri(me,W){if(!me)return;if(t(me))return e.$IE.getOriginalUri(me.result,W);if(W?.supportSideBySide){const{primary:de,secondary:ke}=this.a(me);if(de&&ke){if(W?.supportSideBySide===R.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===R.ANY)return this.getOriginalUri(de,{filterByScheme:W.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:W.filterByScheme});me=W.supportSideBySide===R.PRIMARY?de:ke}}if(s(me)||a(me)||u(me)||t(me))return;const ae=L(me)?me.preferredResource:me.resource;return!ae||!W||!W.filterByScheme?ae:this.b(ae,W.filterByScheme)}a(me){return y(me)||u(me)?{primary:me.primary,secondary:me.secondary}:E(me)||s(me)?{primary:me.modified,secondary:me.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(me,W){if(!me)return;if(t(me))return e.$IE.getCanonicalUri(me.result,W);if(W?.supportSideBySide){const{primary:de,secondary:ke}=this.a(me);if(de&&ke){if(W?.supportSideBySide===R.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===R.ANY)return this.getCanonicalUri(de,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:W.filterByScheme});me=W.supportSideBySide===R.PRIMARY?de:ke}}if(s(me)||a(me)||u(me)||t(me))return;const ae=me.resource;return!ae||!W||!W.filterByScheme?ae:this.b(ae,W.filterByScheme)}b(me,W){if(Array.isArray(W)){if(W.some(ae=>me.scheme===ae))return me}else if(W===me.scheme)return me}}var O;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.KEYBOARD=1]="KEYBOARD",le[le.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function Q(le,me,W,ae){if(!le.isSticky(me))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return W===O.MOUSE||W===O.KEYBOARD;case"mouse":return W===O.MOUSE;case"keyboard":return W===O.KEYBOARD}return!1}e.$HE=Q,e.$IE=new S;var re;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(re||(e.CloseDirection=re={}));class he{constructor(){this.c=new Map,this.d=new Map}start(me){const W=this.a=me.get(M.$1h);for(const[ae,de]of this.c)this.e(ae,de,W);this.c.clear()}e(me,W,ae){const de=ae.createInstance(W);this.d.set(me,de)}registerFileEditorFactory(me){if(this.b)throw new Error("Can only register one file editor factory.");this.b=me}getFileEditorFactory(){return(0,P.$Pf)(this.b)}registerEditorSerializer(me,W){if(this.c.has(me)||this.d.has(me))throw new Error(`A editor serializer with type ID '${me}' was already registered.`);return this.a?this.e(me,W,this.a):this.c.set(me,W),(0,T.$Qc)(()=>{this.c.delete(me),this.d.delete(me)})}getEditorSerializer(me){return this.d.get(typeof me=="string"?me:me.typeId)}}m.$un.add(e.$lE.EditorFactory,new he);async function fe(le,me,W){return!le||!le.length?[]:await Promise.all(le.map(async ae=>{const de=I.URI.revive(ae.fileUri);if(!de){W.info("Cannot resolve the path because it is not valid.",ae);return}if(!await me.canHandleResource(de)){W.info("Cannot resolve the path because it cannot be handled",ae);return}let Ee=ae.exists,ce=ae.type;if(typeof Ee!="boolean"||typeof ce!="number")try{ce=(await me.stat(de)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Ee=!0}catch(H){W.error(H),Ee=!1}if(!Ee&&ae.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",ae);return}if(ce===g.FileType.Directory){W.info("Cannot resolve the path because it is a directory",ae);return}const _={...ae.options,pinned:!0};return Ee?{resource:de,options:_}:{resource:de,options:_,forceUntitled:!0}}))}e.$JE=fe;var ue;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function $e(le){const me=le;if(!me)return!1;const W=me;if(W.modified)return $e(W.modified);const ae=me;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}e.$KE=$e;function ne(le){return(0,A.$Ni)(le)}e.$LE=ne;function Pe(le,me,W){const ae=(0,A.$Oi)(le,me);return ae.forceMessage=W?.forceMessage,ae.forceSeverity=W?.forceSeverity,ae.allowDialog=W?.allowDialog,ae}e.$ME=Pe}),define(Re[205],Ae([1,0,5,172,4,6,28,30,18,26,90,196]),function(ie,e,$,P,I,T,M,m,g,b,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$TE=e.$SE=e.ViewContentGroups=e.$RE=e.$QE=e.ViewContainerLocation=e.Extensions=e.$PE=e.$OE=e.$NE=void 0,e.$NE="views",e.$OE=(0,P.localize)(0,null),e.$PE=(0,C.$jw)("default-view-icon",A.$8j.window,(0,P.localize)(1,null));var l;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$QE=[0,1,2];function v(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$RE=v;class n extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new $.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new $.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(c,f,w){const d=this.get(c.id);if(d)return d;const D=c;return D.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:D.openCommandActionDescriptor??{id:D.id},(0,M.$xc)(this.g,f,[]).push(D),w?.isDefault&&this.h.push(D),this.c.fire({viewContainer:D,viewContainerLocation:f}),D}deregisterViewContainer(c){for(const f of this.g.keys()){const w=this.g.get(f),d=w?.indexOf(c);if(d!==-1){w?.splice(d,1),w.length===0&&this.g.delete(f),this.f.fire({viewContainer:c,viewContainerLocation:f});return}}}get(c){return this.all.filter(f=>f.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(w=>w?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(f=>this.getViewContainerLocation(f)===c)}}m.$un.add(l.ViewContainersRegistry,new n);var o;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(o||(e.ViewContentGroups=o={}));function i(r,c){const f=r.group??o.More,w=c.group??o.More;return f!==w?f.localeCompare(w):(r.order??5)-(c.order??5)}class s extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new $.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new $.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new $.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new $.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Gc}registerViews(c,f){this.registerViews2([{views:c,viewContainer:f}])}registerViews2(c){c.forEach(({views:f,viewContainer:w})=>this.r(f,w)),this.c.fire(c)}deregisterViews(c,f){const w=this.s(c,f);w.length&&this.f.fire({views:w,viewContainer:f})}moveViews(c,f){for(const w of this.m.keys())if(w!==f){const d=this.s(c,w);d.length&&(this.r(d,f),this.g.fire({views:d,from:w,to:f}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const f of this.j){const w=(this.m.get(f)||[]).filter(d=>d.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const f of this.j)if((this.m.get(f)||[]).filter(d=>d.id===c)[0])return f;return null}registerViewWelcomeContent(c,f){return this.n.add(c,f),this.h.fire(c),(0,T.$Qc)(()=>{this.n.delete(c,f),this.h.fire(c)})}registerViewWelcomeContent2(c,f){const w=new Map;for(const[d,D]of f)this.n.add(c,D),w.set(d,(0,T.$Qc)(()=>{this.n.delete(c,D),this.h.fire(c)}));return this.h.fire(c),w}getViewWelcomeContent(c){const f=[];return this.n.forEach(c,w=>f.push(w)),f.sort(i)}r(c,f){let w=this.m.get(f);w||(w=[],this.m.set(f,w),this.j.push(f));for(const d of c){if(this.getView(d.id)!==null)throw new Error((0,P.localize)(2,null,d.id));w.push(d)}}s(c,f){const w=this.m.get(f);if(!w)return[];const d=[],D=[];for(const L of w)c.includes(L)?d.push(L):D.push(L);return d.length&&(D.length?this.m.set(f,D):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),d}}m.$un.add(l.ViewsRegistry,new s),e.$SE=(0,I.$2h)("viewsService"),e.$TE=(0,I.$2h)("viewDescriptorService");var a;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var u;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(u||(e.TreeItemCollapsibleState=u={}));class h{constructor(c,f){this.c=!1,this.d=!1,(0,b.$ln)(this,c),this.d=!!f,this.resolve=async w=>{if(f&&!this.c){const d=await f(w);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$UE=h;class t extends Error{constructor(c){super((0,P.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$VE=t}),define(Re[206],Ae([1,0,2,29,4]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$MF=e.$LF=void 0;function T(b){return!!b&&typeof b=="object"&&"uri"in b&&b.uri instanceof $.URI&&"version"in b&&typeof b.version=="number"&&"ranges"in b&&Array.isArray(b.ranges)&&b.ranges.every(P.$Hs.isIRange)}e.$LF=T;function M(b){return!!b&&typeof b=="object"&&"documents"in b&&Array.isArray(b.documents)&&b.documents.every(T)}e.$MF=M;var m;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var g;(function(b){b[b.Action=1]="Action",b[b.Toolbar=2]="Toolbar"})(g||(e.InteractiveSessionCopyKind=g={})),e.$NF=(0,I.$2h)("IChatService")}),define(Re[207],Ae([1,0,5,14,173]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlb=void 0;class T{constructor(){this.f=new Map,this.k=[],this.m=new $.$Sd,this.n=new $.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,g,b,A){const C={command:m};if(g&&Object.keys(g).length>0&&(C.arguments=g),this.s("request",C),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(C.seq);if(p){this.f.delete(C.seq);const v={type:"response",seq:0,request_seq:C.seq,success:!1,command:m,message:(0,I.localize)(0,null,A,m)};p(v)}},A)}return b&&this.f.set(C.seq,b),C.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,g){return m.type!=="event"||g.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,P.$3g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const g=m,b=this.f.get(g.request_seq);b&&(this.f.delete(g.request_seq),b(g));break}}}}s(m,g){g.type=m,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((g,b)=>m.set(b,g)),await(0,P.$3g)(500),m.forEach((g,b)=>{g({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$zlb=T}),define(Re[208],Ae([1,0,174,35,4]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$wH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$vH=e.MemoryRangeType=e.$uH=e.State=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=void 0,e.$rG="workbench.view.debug",e.$sG="workbench.debug.variablesView",e.$tG="workbench.debug.watchExpressionsView",e.$uG="workbench.debug.callStackView",e.$vG="workbench.debug.loadedScriptsView",e.$wG="workbench.debug.breakPointsView",e.$xG="workbench.debug.disassemblyView",e.$yG="workbench.panel.repl",e.$zG="workbench.panel.repl.view",e.$AG=new P.$gj("debugType",void 0,{type:"string",description:$.localize(0,null)}),e.$BG=new P.$gj("debugConfigurationType",void 0,{type:"string",description:$.localize(1,null)}),e.$CG=new P.$gj("debugState","inactive",{type:"string",description:$.localize(2,null)}),e.$DG="debugUx",e.$EG=new P.$gj(e.$DG,"default",{type:"string",description:$.localize(3,null)}),e.$FG=new P.$gj("hasDebugged",!1,{type:"boolean",description:$.localize(4,null)}),e.$GG=new P.$gj("inDebugMode",!1,{type:"boolean",description:$.localize(5,null)}),e.$HG=new P.$gj("inDebugRepl",!1,{type:"boolean",description:$.localize(6,null)}),e.$IG=new P.$gj("breakpointWidgetVisible",!1,{type:"boolean",description:$.localize(7,null)}),e.$JG=new P.$gj("inBreakpointWidget",!1,{type:"boolean",description:$.localize(8,null)}),e.$KG=new P.$gj("breakpointsFocused",!0,{type:"boolean",description:$.localize(9,null)}),e.$LG=new P.$gj("watchExpressionsFocused",!0,{type:"boolean",description:$.localize(10,null)}),e.$MG=new P.$gj("watchExpressionsExist",!1,{type:"boolean",description:$.localize(11,null)}),e.$NG=new P.$gj("variablesFocused",!0,{type:"boolean",description:$.localize(12,null)}),e.$OG=new P.$gj("expressionSelected",!1,{type:"boolean",description:$.localize(13,null)}),e.$PG=new P.$gj("breakpointInputFocused",!1,{type:"boolean",description:$.localize(14,null)}),e.$QG=new P.$gj("callStackItemType",void 0,{type:"string",description:$.localize(15,null)}),e.$RG=new P.$gj("callStackSessionIsAttach",!1,{type:"boolean",description:$.localize(16,null)}),e.$SG=new P.$gj("callStackItemStopped",!1,{type:"boolean",description:$.localize(17,null)}),e.$TG=new P.$gj("callStackSessionHasOneThread",!1,{type:"boolean",description:$.localize(18,null)}),e.$UG=new P.$gj("watchItemType",void 0,{type:"string",description:$.localize(19,null)}),e.$VG=new P.$gj("canViewMemory",void 0,{type:"boolean",description:$.localize(20,null)}),e.$WG=new P.$gj("breakpointItemType",void 0,{type:"string",description:$.localize(21,null)}),e.$XG=new P.$gj("breakpointSupportsCondition",!1,{type:"boolean",description:$.localize(22,null)}),e.$YG=new P.$gj("loadedScriptsSupported",!1,{type:"boolean",description:$.localize(23,null)}),e.$ZG=new P.$gj("loadedScriptsItemType",void 0,{type:"string",description:$.localize(24,null)}),e.$1G=new P.$gj("focusedSessionIsAttach",!1,{type:"boolean",description:$.localize(25,null)}),e.$2G=new P.$gj("focusedSessionIsNoDebug",!1,{type:"boolean",description:$.localize(26,null)}),e.$3G=new P.$gj("stepBackSupported",!1,{type:"boolean",description:$.localize(27,null)}),e.$4G=new P.$gj("restartFrameSupported",!1,{type:"boolean",description:$.localize(28,null)}),e.$5G=new P.$gj("stackFrameSupportsRestart",!1,{type:"boolean",description:$.localize(29,null)}),e.$6G=new P.$gj("jumpToCursorSupported",!1,{type:"boolean",description:$.localize(30,null)}),e.$7G=new P.$gj("stepIntoTargetsSupported",!1,{type:"boolean",description:$.localize(31,null)}),e.$8G=new P.$gj("breakpointsExist",!1,{type:"boolean",description:$.localize(32,null)}),e.$9G=new P.$gj("debuggersAvailable",!1,{type:"boolean",description:$.localize(33,null)}),e.$0G=new P.$gj("debugExtensionAvailable",!0,{type:"boolean",description:$.localize(34,null)}),e.$$G=new P.$gj("debugProtocolVariableMenuContext",void 0,{type:"string",description:$.localize(35,null)}),e.$_G=new P.$gj("debugSetVariableSupported",!1,{type:"boolean",description:$.localize(36,null)}),e.$aH=new P.$gj("debugSetExpressionSupported",!1,{type:"boolean",description:$.localize(37,null)}),e.$bH=new P.$gj("breakWhenValueChangesSupported",!1,{type:"boolean",description:$.localize(38,null)}),e.$cH=new P.$gj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:$.localize(39,null)}),e.$dH=new P.$gj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:$.localize(40,null)}),e.$eH=new P.$gj("terminateDebuggeeSupported",!1,{type:"boolean",description:$.localize(41,null)}),e.$fH=new P.$gj("suspendDebuggeeSupported",!1,{type:"boolean",description:$.localize(42,null)}),e.$gH=new P.$gj("variableEvaluateNamePresent",!1,{type:"boolean",description:$.localize(43,null)}),e.$hH=new P.$gj("variableIsReadonly",!1,{type:"boolean",description:$.localize(44,null)}),e.$iH=new P.$gj("exceptionWidgetVisible",!1,{type:"boolean",description:$.localize(45,null)}),e.$jH=new P.$gj("multiSessionRepl",!1,{type:"boolean",description:$.localize(46,null)}),e.$kH=new P.$gj("multiSessionDebug",!1,{type:"boolean",description:$.localize(47,null)}),e.$lH=new P.$gj("disassembleRequestSupported",!1,{type:"boolean",description:$.localize(48,null)}),e.$mH=new P.$gj("disassemblyViewFocus",!1,{type:"boolean",description:$.localize(49,null)}),e.$nH=new P.$gj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:$.localize(50,null)}),e.$oH=new P.$gj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:$.localize(51,null)});const T=l=>$.localize(52,null,l);e.$pH=T,e.$qH="editor.contrib.debug",e.$rH="editor.contrib.breakpoint",e.$sH="debug",e.$tH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:$.localize(53,null)};var M;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(M||(e.State=M={}));function m(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$uH=m;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$vH="vscode-debug-memory";var b;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var A;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$wH=(0,I.$2h)("debugService");var C;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(C||(e.BreakpointWidgetContext=C={}))}),define(Re[209],Ae([1,0,12,2,19,26,13,29,20,18]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const A=/{([^}]+)}/g;function C(L,y,E){return L.replace(A,function(k,F){return y&&F.length>0&&F[0]!=="_"?k:E&&E.hasOwnProperty(F)?E[F]:k})}e.$SF=C;function l(L){const y={};for(const E of Object.keys(L))E.startsWith("!")||(y[E]=L[E]);return y}e.$TF=l;function p(L){return L.configuration.request==="attach"&&!v(L)&&(!L.parentSession||p(L.parentSession))}e.$UF=p;function v(L){let y=L.configuration.type;if(y)return y==="vslsShare"&&(y=L.configuration.adapterProxy.configuration.type),(0,$.$8e)(y,"extensionhost")||(0,$.$8e)(y,"pwa-extensionhost")?L:L.parentSession?v(L.parentSession):void 0}e.$VF=v;function n(L){return L.type&&(L.label||L.program||L.runtime)}e.$WF=n;function o(L,y,E){let k,F=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let ee=null;for(;ee=B.exec(L);){const J=ee.index+1,V=J+ee[0].length;if(J<=y&&V>=E){k=ee[0],F=J;break}}if(k){const J=/\w+/g;let V=null;for(;(V=J.exec(k))&&!(V.index+1+F+V[0].length>=E););V&&(k=k.substring(0,J.lastIndex))}return k?{start:F,end:F+k.length-1}:{start:0,end:0}}e.$XF=o;async function i(L,y,E,k){if(L.evaluatableExpressionProvider.has(y)){const F=L.evaluatableExpressionProvider.ordered(y),B=(0,b.$Hb)(await Promise.all(F.map(async ee=>{try{return await ee.provideEvaluatableExpression(y,E,k??g.CancellationToken.None)}catch{return}})));if(B.length>0){let ee=B[0].expression;const J=B[0].range;return ee||(ee=y.getLineContent(E.lineNumber).substring(J.startColumn-1,J.endColumn-1)),{range:J,matchingExpression:ee}}}else{const F=y.getLineContent(E.lineNumber),{start:B,end:ee}=o(F,E.column,E.column),J=F.substring(B-1,ee);return{matchingExpression:J,range:new m.$Hs(E.lineNumber,B,E.lineNumber,B+J.length)}}return null}e.$YF=i;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(L){return!!(L&&L.match(s))}e.$ZF=a;function u(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(a(L.path))return P.URI.parse(L.path);if((0,I.$ic)(L.path))return P.URI.file(L.path)}return L.path}function h(L){if(typeof L.path=="object"){const y=P.URI.revive(L.path);if(y)return y.scheme===M.Schemas.file?y.fsPath:y.toString()}return L.path}function t(L,y){const E=y?u:h,k=(0,T.$in)(L);return c(k,(F,B)=>{F&&B&&(B.path=E(B))}),k}e.$1F=t;function r(L,y){const E=y?u:h,k=(0,T.$in)(L);return c(k,(F,B)=>{!F&&B&&(B.path=E(B))}),k}e.$2F=r;function c(L,y){switch(L.type){case"event":{const E=L;switch(E.event){case"output":y(!1,E.body.source);break;case"loadedSource":y(!1,E.body.source);break;case"breakpoint":y(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=L;switch(E.command){case"setBreakpoints":y(!0,E.arguments.source);break;case"breakpointLocations":y(!0,E.arguments.source);break;case"source":y(!0,E.arguments.source);break;case"gotoTargets":y(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(k=>y(!1,k));break;default:break}break}case"response":{const E=L;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(k=>y(!1,k.source));break;case"loadedSources":E.body.sources.forEach(k=>y(!1,k));break;case"scopes":E.body.scopes.forEach(k=>y(!1,k.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(k=>y(!1,k.source));break;case"setBreakpoints":E.body.breakpoints.forEach(k=>y(!1,k.source));break;case"disassemble":E.body?.instructions.forEach(F=>y(!1,F.location));break;default:break}break}}}function f(L){return L.filter(y=>!y.presentation?.hidden).sort((y,E)=>y.presentation?E.presentation?y.presentation.group?E.presentation.group?y.presentation.group!==E.presentation.group?y.presentation.group.localeCompare(E.presentation.group):w(y.presentation.order,E.presentation.order):-1:E.presentation.group?1:w(y.presentation.order,E.presentation.order):-1:E.presentation?1:0)}e.$3F=f;function w(L,y){return typeof L!="number"?typeof y!="number"?0:1:typeof y!="number"?-1:L-y}async function d(L,y){const E=L.getValue("debug.saveBeforeStart",{overrideIdentifier:y.activeTextEditorLanguageId});if(E!=="none"&&(await y.saveAll(),E==="allEditorsInActiveGroup")){const k=y.activeEditorPane;k&&k.input.resource?.scheme===M.Schemas.untitled&&await y.save({editor:k.input,groupId:k.group.id})}await L.reloadConfiguration()}e.$4F=d;const D=(L,y)=>!L||!y?L===y:L.name===y.name&&L.path===y.path&&L.sourceReference===y.sourceReference;e.$5F=D}),define(Re[76],Ae([1,0,24,33,68,67,13,19,21,35]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.$SI=e.$RI=e.$QI=e.CellStatusbarAlignment=e.$PI=e.$OI=e.$NI=e.NotebookEditorPriority=e.$MI=e.$LI=e.$KI=e.$JI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$II=e.$HI=e.$GI=e.$FI=e.CellKind=e.$EI=e.$DI=e.$CI=void 0,e.$CI="workbench.editor.notebook",e.$DI="workbench.editor.notebookTextDiffEditor",e.$EI="workbench.editor.interactive";var A;(function(S){S[S.Markup=1]="Markup",S[S.Code=2]="Code"})(A||(e.CellKind=A={})),e.$FI=["application/json","application/javascript","text/html","image/svg+xml",T.$4r.latex,T.$4r.markdown,"image/png","image/jpeg",T.$4r.text],e.$GI=[T.$4r.latex,T.$4r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$4r.text],e.$HI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$II="_notAvailable";var C;(function(S){S[S.Running=1]="Running",S[S.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var l;(function(S){S[S.Unconfirmed=1]="Unconfirmed",S[S.Pending=2]="Pending",S[S.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var p;(function(S){S[S.Unconfirmed=1]="Unconfirmed",S[S.Pending=2]="Pending",S[S.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var v;(function(S){S[S.WithHardKernelDependency=0]="WithHardKernelDependency",S[S.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",S[S.Pure=2]="Pure",S[S.Never=3]="Never"})(v||(e.NotebookRendererMatch=v={}));var n;(function(S){S.Always="always",S.Never="never",S.Optional="optional"})(n||(e.RendererMessagingSpec=n={}));var o;(function(S){S[S.ModelChange=1]="ModelChange",S[S.Move=2]="Move",S[S.ChangeCellLanguage=5]="ChangeCellLanguage",S[S.Initialize=6]="Initialize",S[S.ChangeCellMetadata=7]="ChangeCellMetadata",S[S.Output=8]="Output",S[S.OutputItem=9]="OutputItem",S[S.ChangeCellContent=10]="ChangeCellContent",S[S.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",S[S.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",S[S.ChangeCellMime=13]="ChangeCellMime",S[S.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(S){S[S.Handle=0]="Handle",S[S.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var s;(function(S){S[S.Replace=1]="Replace",S[S.Output=2]="Output",S[S.Metadata=3]="Metadata",S[S.CellLanguage=4]="CellLanguage",S[S.DocumentMetadata=5]="DocumentMetadata",S[S.Move=6]="Move",S[S.OutputItems=7]="OutputItems",S[S.PartialMetadata=8]="PartialMetadata",S[S.PartialInternalMetadata=9]="PartialInternalMetadata"})(s||(e.CellEditType=s={}));var a;(function(S){S.scheme=M.Schemas.vscodeNotebookCell;const O=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${O.join("")}]+`),re=7;function he(le,me){const W=me.toString(re),de=`${W.length<O.length?O[W.length-1]:"z"}${W}s${(0,$.$Ae)($.$ge.fromString(le.scheme),!0,!0)}`;return le.with({scheme:S.scheme,fragment:de})}S.generate=he;function fe(le){if(le.scheme!==S.scheme)return;const me=le.fragment.indexOf("s");if(me<0)return;const W=parseInt(le.fragment.substring(0,me).replace(Q,""),re),ae=(0,$.$ze)(le.fragment.substring(me+1)).toString();if(!isNaN(W))return{handle:W,notebook:le.with({scheme:ae,fragment:null})}}S.parse=fe;function ue(le,me){return le.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${le.scheme!==M.Schemas.file?le.scheme:""}`})}S.generateCellOutputUri=ue;function $e(le){if(le.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(le.fragment);if(!me)return;const W=me[1]&&me[1]!==""?me[1]:void 0,ae=me[2];return{outputId:W,notebook:le.with({scheme:ae||M.Schemas.file,fragment:null})}}S.parseCellOutputUri=$e;function ne(le,me,W){return S.generate(le,me).with({scheme:W})}S.generateCellPropertyUri=ne;function Pe(le,me){if(le.scheme===me)return S.parse(le.with({scheme:S.scheme}))}S.parseCellPropertyUri=Pe})(a||(e.CellUri=a={}));const u=S=>g.$c?S.replace(/\//g,"\\"):S;class h{constructor(O=[],Q=e.$FI){this.e=Q,this.d=[...new Set(O)].map(re=>({pattern:re,matches:P.$Ij(u(re))}))}sort(O){const Q=new Map(I.Iterable.map(O,he=>[he,u(he)]));let re=[];for(const{matches:he}of this.d)for(const[fe,ue]of Q)if(he(ue)){re.push(fe),Q.delete(fe);break}return Q.size&&(re=re.concat([...Q.keys()].sort((he,fe)=>this.e.indexOf(he)-this.e.indexOf(fe)))),re}prioritize(O,Q){const re=this.f(O);if(re===-1){this.d.unshift({pattern:O,matches:P.$Ij(u(O))});return}const he=new Set(Q.map(ue=>this.f(ue,re)));he.delete(-1);const fe=Array.from(he).sort();this.d.splice(re+1,0,...fe.map(ue=>this.d[ue]));for(let ue=fe.length-1;ue>=0;ue--)this.d.splice(fe[ue],1)}toArray(){return this.d.map(O=>O.pattern)}f(O,Q=this.d.length){const re=u(O);for(let he=0;he<Q;he++)if(this.d[he].matches(re))return he;return-1}}e.$JI=h;function t(S,O,Q,re=(he,fe)=>he===fe){const he=[];function fe(ne,Pe,le){if(Pe===0&&le.length===0)return;const me=he[he.length-1];me&&me.start+me.deleteCount===ne?(me.deleteCount+=Pe,me.toInsert.push(...le)):he.push({start:ne,deleteCount:Pe,toInsert:le})}let ue=0,$e=0;for(;;){if(ue===S.length){fe(ue,0,O.slice($e));break}if($e===O.length){fe(ue,S.length-ue,[]);break}const ne=S[ue],Pe=O[$e];if(re(ne,Pe)){ue+=1,$e+=1;continue}Q(Pe)?(fe(ue,1,[]),ue+=1):(fe(ue,0,[Pe]),$e+=1)}return he}e.$KI=t,e.$LI=new b.$gj("notebookEditorCursorAtBoundary","none"),e.$MI=new b.$gj("notebookEditorCursorAtLineBoundary","none");var r;(function(S){S.default="default",S.option="option"})(r||(e.NotebookEditorPriority=r={}));function c(S){const O=S;return!!((typeof O.include=="string"||P.$Jj(O.include))&&(typeof O.exclude=="string"||P.$Jj(O.exclude)))}e.$NI=c;function f(S,O,Q){if(Array.isArray(S.viewType)&&S.viewType.indexOf(O)>=0||S.viewType===O)return!0;if(S.filenamePattern){const re=c(S.filenamePattern)?S.filenamePattern.include:S.filenamePattern,he=c(S.filenamePattern)?S.filenamePattern.exclude:void 0;if(P.$Hj(re,(0,m.$nc)(Q.fsPath).toLowerCase()))return!(he&&P.$Hj(he,(0,m.$nc)(Q.fsPath).toLowerCase()))}return!1}e.$OI=f,e.$PI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var w;(function(S){S[S.Left=1]="Left",S[S.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class d{static create(O){return`${d.d}${O}`}static parse(O){if(O.startsWith(d.d))return O.substring(d.d.length)}}e.$QI=d,d.d="notebook/";function D(S){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(S)}e.$RI=D;const L=new TextDecoder;function y(S){const O=[];let Q=!1;for(const ue of S)(O.length===0||Q)&&(O.push(ue),Q=!0);let re=F(O);const he=$.$ge.concat(O.map(ue=>$.$ge.wrap(ue))),fe=R(he);return re=re||fe.byteLength!==he.byteLength,{data:fe,didCompression:re}}e.$SI=y,e.$TI=`${String.fromCharCode(27)}[A`;const E=e.$TI.split("").map(S=>S.charCodeAt(0)),k=10;function F(S){let O=!1;return S.forEach((Q,re)=>{if(re===0||Q.length<e.$TI.length)return;const he=S[re-1],fe=Q.subarray(0,e.$TI.length);if(fe[0]===E[0]&&fe[1]===E[1]&&fe[2]===E[2]){const ue=he.lastIndexOf(k);if(ue===-1)return;O=!0,S[re-1]=he.subarray(0,ue),S[re]=Q.subarray(e.$TI.length)}}),O}function B(S){let O=S;do S=O,O=S.replace(/[^\n]\x08/gm,"");while(O.length<S.length);return S}function ee(S){for(S=S.replace(/\r+\n/gm,`
`);S.search(/\r[^$]/g)>-1;){const O=S.match(/^(.*)\r+/m)[1];let Q=S.match(/\r+(.*)$/m)[1];Q=Q+O.slice(Q.length,O.length),S=S.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return S}const J="\b".charCodeAt(0),V="\r".charCodeAt(0);function R(S){return!S.buffer.includes(J)&&!S.buffer.includes(V)?S:$.$ge.fromString(ee(B(L.decode(S.buffer))))}});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[7],Ae([1,0,18,11,52,28,67,12,16,2,34,22,42,100,76]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v){"use strict";var n,o,i,s,a,u,h,t,r,c,f,w,d,D,L,y,E,k,F,B,ee,J,V,R,S;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$GM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$FM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.TestRunProfileKind=e.TestResultState=e.$lM=e.$kM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$jM=e.NotebookVariablesRequestKind=e.$iM=e.$hM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$gM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.ColorThemeKind=e.$aM=e.$_L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$$L=e.DebugConsoleMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$5L=e.$4L=e.FileChangeType=e.$3L=e.$2L=e.$1L=e.$ZL=e.InlineCompletionTriggerKind=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.ConfigurationTarget=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$CL=e.ViewBadge=e.ProgressLocation=e.$BL=e.$AL=e.TaskScope=e.ShellQuoting=e.$zL=e.$yL=e.$xL=e.TaskPanelKind=e.TaskRevealKind=e.$wL=e.TerminalLocation=e.$vL=e.$uL=e.$tL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$sL=e.$rL=e.$qL=e.$pL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$oL=e.StatusBarAlignment=e.ViewColumn=e.$nL=e.$mL=e.$lL=e.$kL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$jL=e.$iL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.LanguageStatusSeverity=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.CodeActionTriggerKind=e.$9K=e.$8K=e.SymbolTag=e.SymbolKind=e.$7K=e.$6K=e.DocumentHighlightKind=e.$5K=e.$4K=e.$3K=e.$2K=e.DiagnosticSeverity=e.DiagnosticTag=e.$1K=e.$ZK=e.FileEditType=e.$YK=e.$XK=e.$WK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(U){return Object.assign(U,{apply:function(...oe){if(oe.length===0)return Reflect.construct(U,[]);{const Ie=oe.length===1?[]:oe[1];return Reflect.construct(U,Ie,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(U,[]);{const[Ie,...Qe]=oe;return Reflect.construct(U,Qe,Ie.constructor)}}})}var Q;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(Q||(e.TerminalOutputAnchor=Q={}));var re;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(re||(e.TerminalQuickFixType=re={}));let he=r=class{static from(...j){let oe=j;return new r(function(){if(oe){for(const Ie of oe)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();oe=void 0}})}constructor(j){n.set(this,void 0),xe(this,n,j,"f")}dispose(){typeof ze(this,n,"f")=="function"&&(ze(this,n,"f").call(this),xe(this,n,void 0,"f"))}};e.$PK=he,n=new WeakMap,e.$PK=he=r=Je([O],he);let fe=c=class{static Min(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let Ie=1;Ie<j.length;Ie++){const Qe=j[Ie];Qe.isBefore(oe)&&(oe=Qe)}return oe}static Max(...j){if(j.length===0)throw new TypeError;let oe=j[0];for(let Ie=1;Ie<j.length;Ie++){const Qe=j[Ie];Qe.isAfter(oe)&&(oe=Qe)}return oe}static isPosition(j){if(!j)return!1;if(j instanceof c)return!0;const{line:oe,character:Ie}=j;return typeof oe=="number"&&typeof Ie=="number"}static of(j){if(j instanceof c)return j;if(this.isPosition(j))return new c(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,oe){if(j<0)throw(0,P.$7)("line must be non-negative");if(oe<0)throw(0,P.$7)("character must be non-negative");this.c=j,this.e=oe}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,oe=0){if(j===null||oe===null)throw(0,P.$7)();let Ie;return typeof j>"u"?Ie=0:typeof j=="number"?Ie=j:(Ie=typeof j.lineDelta=="number"?j.lineDelta:0,oe=typeof j.characterDelta=="number"?j.characterDelta:0),Ie===0&&oe===0?this:new c(this.line+Ie,this.character+oe)}with(j,oe=this.character){if(j===null||oe===null)throw(0,P.$7)();let Ie;return typeof j>"u"?Ie=this.line:typeof j=="number"?Ie=j:(Ie=typeof j.line=="number"?j.line:this.line,oe=typeof j.character=="number"?j.character:this.character),Ie===this.line&&oe===this.character?this:new c(Ie,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$QK=fe,e.$QK=fe=c=Je([O],fe);let ue=f=class{static isRange(j){return j instanceof f?!0:j?fe.isPosition(j.start)&&fe.isPosition(j.end):!1}static of(j){if(j instanceof f)return j;if(this.isRange(j))return new f(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,oe,Ie,Qe){let et,lt;if(typeof j=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Qe=="number"?(et=new fe(j,oe),lt=new fe(Ie,Qe)):fe.isPosition(j)&&fe.isPosition(oe)&&(et=fe.of(j),lt=fe.of(oe)),!et||!lt)throw new Error("Invalid arguments");et.isBefore(lt)?(this.c=et,this.e=lt):(this.c=lt,this.e=et)}contains(j){return f.isRange(j)?this.contains(j.start)&&this.contains(j.end):fe.isPosition(j)?!(fe.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const oe=fe.Max(j.start,this.c),Ie=fe.Min(j.end,this.e);if(!oe.isAfter(Ie))return new f(oe,Ie)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const oe=fe.Min(j.start,this.c),Ie=fe.Max(j.end,this.end);return new f(oe,Ie)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,oe=this.end){if(j===null||oe===null)throw(0,P.$7)();let Ie;return j?fe.isPosition(j)?Ie=j:(Ie=j.start||this.start,oe=j.end||this.end):Ie=this.start,Ie.isEqual(this.c)&&oe.isEqual(this.end)?this:new f(Ie,oe)}toJSON(){return[this.start,this.end]}};e.$RK=ue,e.$RK=ue=f=Je([O],ue);let $e=w=class extends ue{static isSelection(j){return j instanceof w?!0:j?ue.isRange(j)&&fe.isPosition(j.anchor)&&fe.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,oe,Ie,Qe){let et,lt;if(typeof j=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Qe=="number"?(et=new fe(j,oe),lt=new fe(Ie,Qe)):fe.isPosition(j)&&fe.isPosition(oe)&&(et=fe.of(j),lt=fe.of(oe)),!et||!lt)throw new Error("Invalid arguments");super(et,lt),this.f=et,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$SK=$e,e.$SK=$e=w=Je([O],$e);const ne=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,P.$7)("connectionToken")};class Pe{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe,Ie){if(typeof j!="string"||j.length===0)throw(0,P.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,P.$7)("port");typeof Ie<"u"&&ne(Ie),this.host=j,this.port=Math.round(oe),this.connectionToken=Ie}}e.$TK=Pe;class le{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,oe){this.makeConnection=j,this.connectionToken=oe,typeof oe<"u"&&ne(oe)}}e.$UK=le;class me extends Error{static NotAvailable(j,oe){return new me(j,p.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(j){return new me(j,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,oe=p.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(j),this._message=j,this._code=oe,this._detail=Ie,Object.setPrototypeOf(this,me.prototype)}}e.$VK=me;var W;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(W||(e.EndOfLine=W={}));var ae;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(ae||(e.EnvironmentVariableMutatorType=ae={}));let de=d=class{static isTextEdit(j){return j instanceof d?!0:j?ue.isRange(j)&&typeof j.newText=="string":!1}static replace(j,oe){return new d(j,oe)}static insert(j,oe){return d.replace(new ue(j,j),oe)}static delete(j){return d.replace(j,"")}static setEndOfLine(j){const oe=new d(new ue(new fe(0,0),new fe(0,0)),"");return oe.newEol=j,oe}get range(){return this.c}set range(j){if(j&&!ue.isRange(j))throw(0,P.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,P.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,P.$7)("newEol");this.f=j}constructor(j,oe){this.c=j,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$WK=de,e.$WK=de=d=Je([O],de);let ke=D=class{static isNotebookCellEdit(j){return j instanceof D?!0:j?zt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,oe){return new D(j,oe)}static insertCells(j,oe){return new D(new zt(j,j),oe)}static deleteCells(j){return new D(j,[])}static updateCellMetadata(j,oe){const Ie=new D(new zt(j,j),[]);return Ie.newCellMetadata=oe,Ie}static updateNotebookMetadata(j){const oe=new D(new zt(0,0),[]);return oe.newNotebookMetadata=j,oe}constructor(j,oe){this.range=j,this.newCells=oe}};e.$XK=ke,e.$XK=ke=D=Je([O],ke);class Ee{static isSnippetTextEdit(j){return j instanceof Ee?!0:j?ue.isRange(j.range)&&H.isSnippetString(j.snippet):!1}static replace(j,oe){return new Ee(j,oe)}static insert(j,oe){return Ee.replace(new ue(j,j),oe)}constructor(j,oe){this.range=j,this.snippet=oe}}e.$YK=Ee;var ce;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(ce||(e.FileEditType=ce={}));let _=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,oe,Ie,Qe){this.c.push({_type:1,from:j,to:oe,options:Ie,metadata:Qe})}createFile(j,oe,Ie){this.c.push({_type:1,from:void 0,to:j,options:oe,metadata:Ie})}deleteFile(j,oe,Ie){this.c.push({_type:1,from:j,to:void 0,options:oe,metadata:Ie})}e(j,oe,Ie){this.c.push({_type:3,metadata:Ie,uri:j,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(j,oe,Ie,Qe){const et=oe.start,lt=oe.end;(et!==lt||Ie.length>0)&&this.c.push({_type:5,uri:j,index:et,count:lt-et,cells:Ie,metadata:Qe})}g(j,oe,Ie,Qe){this.c.push({_type:3,metadata:Qe,uri:j,edit:{editType:3,index:oe,metadata:Ie}})}replace(j,oe,Ie,Qe){this.c.push({_type:2,uri:j,edit:new de(oe,Ie),metadata:Qe})}insert(j,oe,Ie,Qe){this.replace(j,new ue(oe,oe),Ie,Qe)}delete(j,oe,Ie){this.replace(j,oe,"",Ie)}has(j){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===j.toString())}set(j,oe){if(oe)for(const Ie of oe){if(!Ie)continue;let Qe,et;Array.isArray(Ie)?(Qe=Ie[0],et=Ie[1]):Qe=Ie,ke.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(j,Qe.range.start,Qe.newCellMetadata,et):Qe.newNotebookMetadata?this.e(j,Qe.newNotebookMetadata,et):this.f(j,Qe.range,Qe.newCells,et):Ee.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:j,range:Qe.range,edit:Qe.snippet,metadata:et}):this.c.push({_type:2,uri:j,edit:Qe,metadata:et})}else{for(let Ie=0;Ie<this.c.length;Ie++){const Qe=this.c[Ie];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===j.toString()&&(this.c[Ie]=void 0);break}}(0,$.$Ib)(this.c)}}get(j){const oe=[];for(const Ie of this.c)Ie._type===2&&Ie.uri.toString()===j.toString()&&oe.push(Ie.edit);return oe}entries(){const j=new T.$Ac;for(const oe of this.c)if(oe._type===2){let Ie=j.get(oe.uri);Ie||(Ie=[oe.uri,[]],j.set(oe.uri,Ie)),Ie[1].push(oe.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$ZK=_,e.$ZK=_=Je([O],_);let H=L=class{static isSnippetString(j){return j instanceof L?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=L.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,oe=this.e++){if(typeof j=="function"){const Ie=new L;Ie.e=this.e,j(Ie),this.e=Ie.e,j=Ie.value}else j=L.c(j);return this.value+="${",this.value+=oe,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,oe=this.e++){const Ie=j.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(j,oe){if(typeof oe=="function"){const Ie=new L;Ie.e=this.e,oe(Ie),this.e=Ie.e,oe=Ie.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$1K=H,e.$1K=H=L=Je([O],H);var te;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(te||(e.DiagnosticTag=te={}));var we;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(we||(e.DiagnosticSeverity=we={}));let be=y=class{static isLocation(j){return j instanceof y?!0:j?ue.isRange(j.range)&&b.URI.isUri(j.uri):!1}constructor(j,oe){if(this.uri=j,oe)if(ue.isRange(oe))this.range=ue.of(oe);else if(fe.isPosition(oe))this.range=new ue(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$2K=be,e.$2K=be=y=Je([O],be);let Fe=class{static is(j){return j?typeof j.message=="string"&&j.location&&ue.isRange(j.location.range)&&b.URI.isUri(j.location.uri):!1}constructor(j,oe){this.location=j,this.message=oe}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.location.range.isEqual(oe.location.range)&&j.location.uri.toString()===oe.location.uri.toString()}};e.$3K=Fe,e.$3K=Fe=Je([O],Fe);let pe=class{constructor(j,oe,Ie=we.Error){if(!ue.isRange(j))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=j,this.message=oe,this.severity=Ie}toJSON(){return{severity:we[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,oe){return j===oe?!0:!j||!oe?!1:j.message===oe.message&&j.severity===oe.severity&&j.code===oe.code&&j.severity===oe.severity&&j.source===oe.source&&j.range.isEqual(oe.range)&&(0,$.$ub)(j.tags,oe.tags)&&(0,$.$ub)(j.relatedInformation,oe.relatedInformation,Fe.isEqual)}};e.$4K=pe,e.$4K=pe=Je([O],pe);let Se=class{constructor(j,oe){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=oe}};e.$5K=Se,e.$5K=Se=Je([O],Se);var N;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(N||(e.DocumentHighlightKind=N={}));let q=class{constructor(j,oe=N.Text){this.range=j,this.kind=oe}toJSON(){return{range:this.range,kind:N[this.kind]}}};e.$6K=q,e.$6K=q=Je([O],q);let G=class{constructor(j,oe){this.uri=j,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$7K=G,e.$7K=G=Je([O],G);var z;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(z||(e.SymbolKind=z={}));var Z;(function(U){U[U.Deprecated=1]="Deprecated"})(Z||(e.SymbolTag=Z={}));let X=E=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,oe,Ie,Qe,et){this.name=j,this.kind=oe,this.containerName=et,typeof Ie=="string"&&(this.containerName=Ie),Qe instanceof be?this.location=Qe:Ie instanceof ue&&(this.location=new be(Qe,Ie)),E.validate(this)}toJSON(){return{name:this.name,kind:z[this.kind],location:this.location,containerName:this.containerName}}};e.$8K=X,e.$8K=X=E=Je([O],X);let De=k=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(k.validate)}constructor(j,oe,Ie,Qe,et){this.name=j,this.detail=oe,this.kind=Ie,this.range=Qe,this.selectionRange=et,this.children=[],k.validate(this)}};e.$9K=De,e.$9K=De=k=Je([O],De);var Te;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let qe=class{constructor(j,oe){this.title=j,this.kind=oe}};e.$0K=qe,e.$0K=qe=Je([O],qe);let We=F=class{constructor(j){this.value=j}append(j){return new F(this.value?this.value+F.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+F.c)}};e.$$K=We,We.c=".",e.$$K=We=F=Je([O],We),We.Empty=new We(""),We.QuickFix=We.Empty.append("quickfix"),We.Refactor=We.Empty.append("refactor"),We.RefactorExtract=We.Refactor.append("extract"),We.RefactorInline=We.Refactor.append("inline"),We.RefactorMove=We.Refactor.append("move"),We.RefactorRewrite=We.Refactor.append("rewrite"),We.Source=We.Empty.append("source"),We.SourceOrganizeImports=We.Source.append("organizeImports"),We.SourceFixAll=We.Source.append("fixAll"),We.Notebook=We.Empty.append("notebook");let Ye=class{constructor(j,oe){if(this.range=j,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$_K=Ye,e.$_K=Ye=Je([O],Ye);class ot{constructor(j,oe,Ie,Qe,et,lt){this.kind=j,this.name=oe,this.detail=Ie,this.uri=Qe,this.range=et,this.selectionRange=lt}}e.$aL=ot;class rt{constructor(j,oe){this.fromRanges=oe,this.from=j}}e.$bL=rt;class it{constructor(j,oe){this.fromRanges=oe,this.to=j}}e.$cL=it;var ct;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(ct||(e.LanguageStatusSeverity=ct={}));let ut=class{constructor(j,oe){this.range=j,this.command=oe}get isResolved(){return!!this.command}};e.$dL=ut,e.$dL=ut=Je([O],ut);let Ue=B=class{static isMarkdownString(j){return j instanceof B?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,oe=!1){o.set(this,void 0),xe(this,o,new I.$dk(j,{supportThemeIcons:oe}),"f")}get value(){return ze(this,o,"f").value}set value(j){ze(this,o,"f").value=j}get isTrusted(){return ze(this,o,"f").isTrusted}set isTrusted(j){ze(this,o,"f").isTrusted=j}get supportThemeIcons(){return ze(this,o,"f").supportThemeIcons}set supportThemeIcons(j){ze(this,o,"f").supportThemeIcons=j}get supportHtml(){return ze(this,o,"f").supportHtml}set supportHtml(j){ze(this,o,"f").supportHtml=j}get baseUri(){return ze(this,o,"f").baseUri}set baseUri(j){ze(this,o,"f").baseUri=j}appendText(j){return ze(this,o,"f").appendText(j),this}appendMarkdown(j){return ze(this,o,"f").appendMarkdown(j),this}appendCodeblock(j,oe){return ze(this,o,"f").appendCodeblock(oe??"",j),this}};e.$eL=Ue,o=new WeakMap,e.$eL=Ue=B=Je([O],Ue);let vt=class{constructor(j,oe){this.label=j,this.documentation=oe}};e.$fL=vt,e.$fL=vt=Je([O],vt);let Y=class{constructor(j,oe){this.label=j,this.documentation=oe,this.parameters=[]}};e.$gL=Y,e.$gL=Y=Je([O],Y);let x=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$hL=x,e.$hL=x=Je([O],x);var ye;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(ye||(e.SignatureHelpTriggerKind=ye={}));var Ve;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Ve||(e.InlayHintKind=Ve={}));let Ze=class{constructor(j){this.value=j}};e.$iL=Ze,e.$iL=Ze=Je([O],Ze);let nt=class{constructor(j,oe,Ie){this.position=j,this.label=oe,this.kind=Ie}};e.$jL=nt,e.$jL=nt=Je([O],nt);var st;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Ne;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Ne||(e.CompletionItemKind=Ne={}));var Pt;(function(U){U[U.Deprecated=1]="Deprecated"})(Pt||(e.CompletionItemTag=Pt={}));let Mt=class{constructor(j,oe){this.label=j,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$kL=Mt,e.$kL=Mt=Je([O],Mt);let Kt=class{constructor(j=[],oe=!1){this.items=j,this.isIncomplete=oe}};e.$lL=Kt,e.$lL=Kt=Je([O],Kt);let Ht=class{constructor(j,oe,Ie){this.insertText=j,this.range=oe,this.command=Ie}};e.$mL=Ht,e.$mL=Ht=Je([O],Ht);let yt=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$nL=yt,e.$nL=yt=Je([O],yt);var Gt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Gt||(e.ViewColumn=Gt={}));var Ut;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ut||(e.StatusBarAlignment=Ut={}));function ni(U,j){return`${C.$hm.toKey(U)}.${j}`}e.$oL=ni;var Jt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Jt||(e.TextEditorLineNumbersStyle=Jt={}));var Ft;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Ft||(e.TextDocumentSaveReason=Ft={}));var _e;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(_e||(e.TextEditorRevealType=_e={}));var Bt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Zt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var ht;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(ht||(e.DecorationRangeBehavior=ht={})),function(U){function j(oe){switch(oe){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=j}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var mt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(mt||(e.SyntaxTokenType=mt={})),function(U){function j(oe){switch(oe){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=j}(mt||(e.SyntaxTokenType=mt={}));let Tt=class{constructor(j,oe){if(oe&&!b.URI.isUri(oe))throw(0,P.$7)("target");if(!ue.isRange(j)||j.isEmpty)throw(0,P.$7)("range");this.range=j,this.target=oe}};e.$pL=Tt,e.$pL=Tt=Je([O],Tt);let Nt=class{constructor(j,oe,Ie,Qe){this.red=j,this.green=oe,this.blue=Ie,this.alpha=Qe}};e.$qL=Nt,e.$qL=Nt=Je([O],Nt);let Et=class{constructor(j,oe){if(oe&&!(oe instanceof Nt))throw(0,P.$7)("color");if(!ue.isRange(j)||j.isEmpty)throw(0,P.$7)("range");this.range=j,this.color=oe}};e.$rL=Et,e.$rL=Et=Je([O],Et);let dt=class{constructor(j){if(!j||typeof j!="string")throw(0,P.$7)("label");this.label=j}};e.$sL=dt,e.$sL=dt=Je([O],dt);var Rt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Rt||(e.ColorFormat=Rt={}));var xt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(xt||(e.SourceControlInputBoxValidationType=xt={}));var It;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(It||(e.TerminalExitReason=It={}));class He{constructor(j,oe,Ie){if(this.startIndex=j,this.length=oe,this.tooltip=Ie,typeof j!="number"||j<0)throw(0,P.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,P.$7)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,P.$7)("tooltip")}}e.$tL=He;class Wt{constructor(j){this.uri=j}}e.$uL=Wt;class Yt{constructor(j){this.terminalCommand=j}}e.$vL=Yt;var Xt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Xt||(e.TerminalLocation=Xt={}));class pt{constructor(j){if(this.options=j,typeof j!="object")throw(0,P.$7)("options")}}e.$wL=pt;var Ot;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Ot||(e.TaskRevealKind=Ot={}));var Ce;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Ce||(e.TaskPanelKind=Ce={}));let Le=ee=class{static from(j){switch(j){case"clean":return ee.Clean;case"build":return ee.Build;case"rebuild":return ee.Rebuild;case"test":return ee.Test;default:return}}constructor(j,oe){if(this.label=oe,typeof j!="string"||typeof oe!="string")throw(0,P.$7)("name");this.c=j}get id(){return this.c}};e.$xL=Le,Le.Clean=new ee("clean","Clean"),Le.Build=new ee("build","Build"),Le.Rebuild=new ee("rebuild","Rebuild"),Le.Test=new ee("test","Test"),e.$xL=Le=ee=Je([O],Le);function ve(U){let j="";for(let oe=0;oe<U.length;oe++)j+=U[oe].replace(/,/g,",,")+",";return j}let K=class{constructor(j,oe,Ie){if(typeof j!="string")throw(0,P.$7)("process");this.e=[],this.c=j,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=Ie):this.f=oe)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,P.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)j.push(oe);return ve(j)}};e.$yL=K,e.$yL=K=Je([O],K);let Me=class{constructor(j,oe,Ie){if(this.f=[],Array.isArray(oe)){if(!j)throw(0,P.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,P.$7)("command");this.e=j,this.f=oe,this.g=Ie}else{if(typeof j!="string")throw(0,P.$7)("commandLine");this.c=j,this.g=oe}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,P.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,P.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)j.push(typeof oe=="string"?oe:oe.value);return ve(j)}};e.$zL=Me,e.$zL=Me=Je([O],Me);var Be;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Be||(e.ShellQuoting=Be={}));var Xe;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Xe||(e.TaskScope=Xe={}));class Ke{constructor(j){this.c=j}computeId(){return"customExecution"+(0,A.$mg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$AL=Ke;let tt=J=class{constructor(j,oe,Ie,Qe,et,lt){this.k=!1,this.l=this.definition=j;let gt;typeof oe=="string"?(this.n=this.name=oe,this.u=this.source=Ie,this.execution=Qe,gt=et,this.k=!0):oe===Xe.Global||oe===Xe.Workspace?(this.target=oe,this.n=this.name=Ie,this.u=this.source=Qe,this.execution=et,gt=lt):(this.target=oe,this.n=this.name=Ie,this.u=this.source=Qe,this.execution=et,gt=lt),typeof gt=="string"?(this.q=[gt],this.r=!0):Array.isArray(gt)?(this.q=gt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof K?this.l={type:J.e,id:this.o.computeId()}:this.o instanceof Me?this.l={type:J.f,id:this.o.computeId()}:this.o instanceof Ke?this.l={type:J.c,id:this.o.computeId()}:this.l={type:J.g,id:(0,A.$mg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,P.$7)("Kind can't be undefined or null");this.A(),this.l=j}get scope(){return this.m}set target(j){this.A(),this.m=j}get name(){return this.n}set name(j){if(typeof j!="string")throw(0,P.$7)("name");this.A(),this.n=j}get execution(){return this.o}set execution(j){j===null&&(j=void 0),this.A(),this.o=j;const oe=this.l.type;(J.g===oe||J.e===oe||J.f===oe||J.c===oe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(j){if(Array.isArray(j))this.A(),this.q=j,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.A(),this.t=j}get source(){return this.u}set source(j){if(typeof j!="string"||j.length===0)throw(0,P.$7)("source must be a string of length > 0");this.A(),this.u=j}get group(){return this.w}set group(j){j===null&&(j=void 0),this.A(),this.w=j}get detail(){return this.z}set detail(j){j===null&&(j=void 0),this.z=j}get presentationOptions(){return this.x}set presentationOptions(j){j==null&&(j=Object.create(null)),this.A(),this.x=j}get runOptions(){return this.y}set runOptions(j){j==null&&(j=Object.create(null)),this.A(),this.y=j}};e.$BL=tt,tt.c="customExecution",tt.e="process",tt.f="shell",tt.g="$empty",e.$BL=tt=J=Je([O],tt);var $t;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})($t||(e.ProgressLocation=$t={}));var Vt;(function(U){function j(oe){const Ie=oe;return(0,g.$If)(Ie.value)?Ie.tooltip&&!(0,g.$Ef)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}U.isViewBadge=j})(Vt||(e.ViewBadge=Vt={}));let Dt=V=class{static isTreeItem(j,oe){const Ie=j;if(Ie.checkboxState!==void 0){const Qe=(0,g.$If)(Ie.checkboxState)?Ie.checkboxState:(0,g.$Gf)(Ie.checkboxState)&&(0,g.$If)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,et=!(0,g.$If)(Ie.checkboxState)&&(0,g.$Gf)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Ct.Checked&&Qe!==Ct.Unchecked||et!==void 0&&!(0,g.$Ef)(et))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(j instanceof V)return!0;if(Ie.label!==void 0&&!(0,g.$Ef)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,g.$Ef)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,g.$Ef)(Ie.iconPath)&&!b.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,g.$Ef)(Ie.iconPath.id))){const Qe=Ie.iconPath;if(!Qe||!(0,g.$Ef)(Qe.light)&&!b.URI.isUri(Qe.light)&&!(0,g.$Ef)(Qe.dark)&&!b.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,g.$Ef)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!b.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,g.$Ef)(Ie.tooltip)&&!(Ie.tooltip instanceof Ue)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<kt.None&&Ie.collapsibleState>kt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,g.$Ef)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(j,oe=kt.None){this.collapsibleState=oe,b.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$CL=Dt,e.$CL=Dt=V=Je([O],Dt);var kt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(kt||(e.TreeItemCollapsibleState=kt={}));var Ct;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Ct||(e.TreeItemCheckboxState=Ct={}));let hi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$DL=hi,e.$DL=hi=Je([O],hi);class At extends hi{}e.$EL=At;class an extends At{constructor(j){super(""),i.set(this,void 0),xe(this,i,j,"f")}asFile(){return ze(this,i,"f")}}e.$FL=an,i=new WeakMap;class cn{constructor(j,oe,Ie,Qe){this.name=j,this.uri=oe,this._itemId=Ie,this.c=Qe}data(){return this.c()}}e.$GL=cn;let St=class{constructor(j){s.add(this),a.set(this,new Map);for(const[oe,Ie]of j??[]){const Qe=ze(this,a,"f").get(ze(this,s,"m",u).call(this,oe));Qe?Qe.push(Ie):ze(this,a,"f").set(ze(this,s,"m",u).call(this,oe),[Ie])}}get(j){return ze(this,a,"f").get(ze(this,s,"m",u).call(this,j))?.[0]}set(j,oe){ze(this,a,"f").set(ze(this,s,"m",u).call(this,j),[oe])}forEach(j,oe){for(const[Ie,Qe]of ze(this,a,"f"))for(const et of Qe)j.call(oe,et,Ie,this)}*[(a=new WeakMap,s=new WeakSet,Symbol.iterator)](){for(const[j,oe]of ze(this,a,"f"))for(const Ie of oe)yield[j,Ie]}};e.$HL=St,u=function(j){return j.toLowerCase()},e.$HL=St=Je([O],St);let $i=class{constructor(j){this.insertText=j}};e.$IL=$i,e.$IL=$i=Je([O],$i);let pi=class{constructor(j,oe){this.label=oe,this.insertText=j}};e.$JL=pi,e.$JL=pi=Je([O],pi);let Qt=class{constructor(j,oe){this.id=j,this.color=oe}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$KL=Qt,e.$KL=Qt=Je([O],Qt),Qt.File=new Qt("file"),Qt.Folder=new Qt("folder");let Ii=class{constructor(j){this.id=j}};e.$LL=Ii,e.$LL=Ii=Je([O],Ii);var Vi;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Vi||(e.ConfigurationTarget=Vi={}));let jt=class{get base(){return this.c}set base(j){this.c=j,this.e=b.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,oe){if(typeof j!="string"&&(!j||!b.URI.isUri(j)&&!b.URI.isUri(j.uri)))throw(0,P.$7)("base");if(typeof oe!="string")throw(0,P.$7)("pattern");typeof j=="string"?this.baseUri=b.URI.file(j):b.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$ML=jt,e.$ML=jt=Je([O],jt);const Ci=new WeakMap;function un(U,j){Ci.set(U,j)}e.$NL=un;let ei=class{constructor(j,oe,Ie,Qe){this.enabled=typeof j=="boolean"?j:!0,typeof oe=="string"&&(this.condition=oe),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=Ci.get(this)??(0,A.$mg)()),this.c}};e.$OL=ei,e.$OL=ei=Je([O],ei);let ci=class extends ei{constructor(j,oe,Ie,Qe,et){if(super(oe,Ie,Qe,et),j===null)throw(0,P.$7)("location");this.location=j}};e.$PL=ci,e.$PL=ci=Je([O],ci);let ft=class extends ei{constructor(j,oe,Ie,Qe,et){super(oe,Ie,Qe,et),this.functionName=j}};e.$QL=ft,e.$QL=ft=Je([O],ft);let Pi=class extends ei{constructor(j,oe,Ie,Qe,et,lt,gt){if(super(Qe,et,lt,gt),!oe)throw(0,P.$7)("dataId");this.label=j,this.dataId=oe,this.canPersist=Ie}};e.$RL=Pi,e.$RL=Pi=Je([O],Pi);let ti=class{constructor(j,oe,Ie){this.command=j,this.args=oe||[],this.options=Ie}};e.$SL=ti,e.$SL=ti=Je([O],ti);let si=class{constructor(j,oe){this.port=j,this.host=oe}};e.$TL=si,e.$TL=si=Je([O],si);let di=class{constructor(j){this.path=j}};e.$UL=di,e.$UL=di=Je([O],di);let Ri=class{constructor(j){this.implementation=j}};e.$VL=Ri,e.$VL=Ri=Je([O],Ri);let Ai=class{constructor(j,oe,Ie){this.session=j,this.threadId=oe,this.frameId=Ie}};e.$WL=Ai,e.$WL=Ai=Je([O],Ai);let Li=class{constructor(j,oe){this.session=j,this.threadId=oe}};e.$XL=Li,e.$XL=Li=Je([O],Li);let vi=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$YL=vi,e.$YL=vi=Je([O],vi);var qi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let wi=class{constructor(j,oe){this.range=j,this.text=oe}};e.$ZL=wi,e.$ZL=wi=Je([O],wi);let oi=class{constructor(j,oe,Ie=!0){this.range=j,this.variableName=oe,this.caseSensitiveLookup=Ie}};e.$1L=oi,e.$1L=oi=Je([O],oi);let Mi=class{constructor(j,oe){this.range=j,this.expression=oe}};e.$2L=Mi,e.$2L=Mi=Je([O],Mi);let fi=class{constructor(j,oe){this.frameId=j,this.stoppedLocation=oe}};e.$3L=fi,e.$3L=fi=Je([O],fi);var bi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(bi||(e.FileChangeType=bi={}));let Fi=R=class extends Error{static FileExists(j){return new R(j,l.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(j){return new R(j,l.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(j){return new R(j,l.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(j){return new R(j,l.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(j){return new R(j,l.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(j){return new R(j,l.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}constructor(j,oe=l.FileSystemProviderErrorCode.Unknown,Ie){super(b.URI.isUri(j)?j.toString(!0):j),this.code=Ie?.name??"Unknown",(0,l.$Ak)(this,oe),Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.$4L=Fi,e.$4L=Fi=R=Je([O],Fi);let Ti=class{constructor(j,oe,Ie){this.start=j,this.end=oe,this.kind=Ie}};e.$5L=Ti,e.$5L=Ti=Je([O],Ti);var ui;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(ui||(e.FoldingRangeKind=ui={}));var Ki;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ki||(e.CommentThreadCollapsibleState=Ki={}));var Hi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Hi||(e.CommentMode=Hi={}));var Gi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var yi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(yi||(e.CommentThreadState=yi={}));class ln{constructor(j,oe=[]){this.tokenTypes=j,this.tokenModifiers=oe}}e.$6L=ln;function hn(U){return typeof U>"u"||(0,g.$Ff)(U)}class li{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let oe=0,Ie=j.tokenTypes.length;oe<Ie;oe++)this.k.set(j.tokenTypes[oe],oe);for(let oe=0,Ie=j.tokenModifiers.length;oe<Ie;oe++)this.l.set(j.tokenModifiers[oe],oe)}}push(j,oe,Ie,Qe,et){if(typeof j=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Qe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.o(j,oe,Ie,Qe,et);if(ue.isRange(j)&&typeof oe=="string"&&hn(Ie))return this.n(j,oe,Ie);throw(0,P.$7)()}n(j,oe,Ie){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Qe=j.start.line,et=j.start.character,lt=j.end.character-j.start.character,gt=this.k.get(oe);let qt=0;if(Ie)for(const _t of Ie){if(!this.l.has(_t))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(_t);qt|=1<<ii>>>0}this.o(Qe,et,lt,gt,qt)}o(j,oe,Ie,Qe,et){if(this.f&&(j<this.c||j===this.c&&oe<this.e)){this.f=!1;const qt=this.g.length/5|0;let _t=0,ii=0;for(let ri=0;ri<qt;ri++){let ai=this.g[5*ri],Bi=this.g[5*ri+1];ai===0?(ai=_t,Bi+=ii):ai+=_t,this.g[5*ri]=ai,this.g[5*ri+1]=Bi,_t=ai,ii=Bi}}let lt=j,gt=oe;this.f&&this.j>0&&(lt-=this.c,lt===0&&(gt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=gt,this.g[this.j++]=Ie,this.g[this.j++]=Qe,this.g[this.j++]=et,this.c=j,this.e=oe}static q(j){const oe=[],Ie=j.length/5|0;for(let gt=0;gt<Ie;gt++)oe[gt]=gt;oe.sort((gt,qt)=>{const _t=j[5*gt],ii=j[5*qt];if(_t===ii){const ri=j[5*gt+1],ai=j[5*qt+1];return ri-ai}return _t-ii});const Qe=new Uint32Array(j.length);let et=0,lt=0;for(let gt=0;gt<Ie;gt++){const qt=5*oe[gt],_t=j[qt+0],ii=j[qt+1],ri=j[qt+2],ai=j[qt+3],Bi=j[qt+4],Rn=_t-et,Gn=Rn===0?ii-lt:ii,Wi=5*gt;Qe[Wi+0]=Rn,Qe[Wi+1]=Gn,Qe[Wi+2]=ri,Qe[Wi+3]=ai,Qe[Wi+4]=Bi,et=_t,lt=ii}return Qe}build(j){return this.f?new Ei(new Uint32Array(this.g),j):new Ei(li.q(this.g),j)}}e.$7L=li;class Ei{constructor(j,oe){this.resultId=oe,this.data=j}}e.$8L=Ei;class dn{constructor(j,oe,Ie){this.start=j,this.deleteCount=oe,this.data=Ie}}e.$9L=dn;class Ji{constructor(j,oe){this.resultId=oe,this.edits=j}}e.$0L=Ji;var Ni;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Ni||(e.DebugConsoleMode=Ni={}));let Di=class{constructor(){}};e.$$L=Di,Di.Back={iconPath:new Qt("arrow-left")},e.$$L=Di=Je([O],Di);var Qi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var Xi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Xi||(e.ExtensionKind=Xi={}));class Oi{static validate(j){if(typeof j.badge=="string"){let oe=(0,m.$ff)(j.badge,0);if(oe<j.badge.length&&(oe+=(0,m.$ff)(j.badge,oe)),j.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Qt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,oe,Ie){this.badge=j,this.tooltip=oe,this.color=Ie}}e.$_L=Oi;let ki=class{constructor(j){this.kind=j}};e.$aM=ki,e.$aM=ki=Je([O],ki);var je;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(je||(e.ColorThemeKind=je={}));class zt{static isNotebookRange(j){return j instanceof zt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,oe){if(j<0)throw(0,P.$7)("start must be positive");if(oe<0)throw(0,P.$7)("end must be positive");j<=oe?(this.c=j,this.e=oe):(this.c=oe,this.e=j)}with(j){let oe=this.c,Ie=this.e;return j.start!==void 0&&(oe=j.start),j.end!==void 0&&(Ie=j.end),oe===this.c&&Ie===this.e?this:new zt(oe,Ie)}}e.$bM=zt;class gi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(oe=>gi.isNotebookCellData(oe))}static isNotebookCellData(j){return!0}constructor(j,oe,Ie,Qe,et,lt,gt){this.kind=j,this.value=oe,this.languageId=Ie,this.mime=Qe,this.outputs=et??[],this.metadata=lt,this.executionSummary=gt,gi.validate(this)}}e.$cM=gi;class wt{constructor(j){this.cells=j}}e.$dM=wt;class Yi{static isNotebookCellOutputItem(j){return j instanceof h?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const oe={name:j.name,message:j.message,stack:j.stack};return h.json(oe,"application/vnd.code.notebook.error")}static stdout(j){return h.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return h.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,oe="application/octet-stream"){return new h(j,oe)}static text(j,oe=M.$4r.text){const Ie=ze(h,h,"f",t).encode(String(j));return new h(Ie,oe)}static json(j,oe="text/x-json"){const Ie=JSON.stringify(j,void 0,"	");return h.text(Ie,oe)}constructor(j,oe){this.data=j,this.mime=oe;const Ie=(0,M.$8r)(oe,!0);if(!Ie)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.$eM=Yi,h=Yi,t={value:new TextEncoder};class Si{static isNotebookCellOutput(j){return j instanceof Si?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,oe=!1){const Ie=new Set,Qe=new Set;for(let et=0;et<j.length;et++){const lt=j[et],gt=(0,M.$8r)(lt.mime);if(!Ie.has(gt)||(0,v.$RI)(gt)){Ie.add(gt);continue}Qe.add(et),oe&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Qe.size===0?j:j.filter((et,lt)=>!Qe.has(lt))}constructor(j,oe,Ie){this.items=Si.ensureUniqueMimeTypes(j,!0),typeof oe=="string"?(this.id=oe,this.metadata=Ie):(this.id=(0,A.$mg)(),this.metadata=oe??Ie)}}e.$fM=Si;var ji;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(ji||(e.NotebookCellKind=ji={}));var _i;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(_i||(e.NotebookCellExecutionState=_i={}));var mi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(mi||(e.NotebookCellStatusBarAlignment=mi={}));var xi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(xi||(e.NotebookEditorRevealType=xi={}));class fn{constructor(j,oe){this.text=j,this.alignment=oe}}e.$gM=fn;var en;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(en||(e.NotebookControllerAffinity=en={}));var zi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(zi||(e.NotebookControllerAffinity2=zi={}));class gn{constructor(j,oe=[]){this.uri=j,this.provides=(0,$.$3b)(oe)}}e.$hM=gn;class mn{constructor(j){this.label=j}}e.$iM=mn;var tn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(tn||(e.NotebookVariablesRequestKind=tn={}));let Ui=class{constructor(j,oe){this.label=j,this.timestamp=oe}};e.$jM=Ui,e.$jM=Ui=Je([O],Ui);var nn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(nn||(e.ExtensionMode=nn={}));var rn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(rn||(e.ExtensionRuntime=rn={}));var sn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(sn||(e.StandardTokenType=sn={}));class $n{constructor(j,oe){this.ranges=j,this.wordPattern=oe}}e.$kM=$n;class pn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$lM=pn;var on;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var se;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(se||(e.TestRunProfileKind=se={}));let ge=class{constructor(j=void 0,oe=void 0,Ie=void 0,Qe=!1){this.include=j,this.exclude=oe,this.profile=Ie,this.continuous=Qe}};e.$mM=ge,e.$mM=ge=Je([O],ge);let Oe=S=class{static diff(j,oe,Ie){const Qe=new S(j);return Qe.expectedOutput=oe,Qe.actualOutput=Ie,Qe}constructor(j){this.message=j}};e.$nM=Oe,e.$nM=Oe=S=Je([O],Oe);let at=class{constructor(j){this.id=j}};e.$oM=at,e.$oM=at=Je([O],at);class bt{constructor(j,oe){this.covered=j,this.total=oe}}e.$pM=bt;class Lt{static fromDetails(j,oe){const Ie=new bt(0,0),Qe=new bt(0,0),et=new bt(0,0);for(const gt of oe)if("branches"in gt){Ie.total+=1,Ie.covered+=gt.executionCount>0?1:0;for(const qt of gt.branches)Qe.total+=1,Qe.covered+=qt.executionCount>0?1:0}else et.total+=1,et.covered+=gt.executionCount>0?1:0;const lt=new Lt(j,Ie,Qe.total>0?Qe:void 0,et.total>0?et:void 0);return lt.detailedCoverage=oe,lt}constructor(j,oe,Ie,Qe){this.uri=j,this.statementCoverage=oe,this.branchCoverage=Ie,this.functionCoverage=Qe}}e.$qM=Lt;class An{constructor(j,oe,Ie=[]){this.executionCount=j,this.location=oe,this.branches=Ie}}e.$rM=An;class Ln{constructor(j,oe){this.executionCount=j,this.location=oe}}e.$sM=Ln;class Mn{constructor(j,oe,Ie){this.name=j,this.executionCount=oe,this.location=Ie}}e.$tM=Mn;var vn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var wn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var bn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn||(e.PortAutoForwardAction=bn={}));class Fn{constructor(j,oe,Ie,Qe,et,lt){this.kind=j,this.name=oe,this.detail=Ie,this.uri=Qe,this.range=et,this.selectionRange=lt}}e.$uM=Fn;class Tn{constructor(j){this.uri=j}}e.$vM=Tn;class Nn{constructor(j,oe){this.original=j,this.modified=oe}}e.$wM=Nn;class On{constructor(j,oe,Ie,Qe){this.base=j,this.input1=oe,this.input2=Ie,this.result=Qe}}e.$xM=On;class jn{constructor(j,oe){this.uri=j,this.viewType=oe}}e.$yM=jn;class zn{constructor(j){this.viewType=j}}e.$zM=zn;class Un{constructor(j,oe){this.uri=j,this.notebookType=oe}}e.$AM=Un;class Bn{constructor(j,oe,Ie){this.original=j,this.modified=oe,this.notebookType=Ie}}e.$BM=Bn;class Wn{constructor(){}}e.$CM=Wn;class Vn{constructor(j,oe){this.uri=j,this.inputBoxUri=oe}}e.$DM=Vn;class qn{constructor(j){this.providerId=j}}e.$EM=qn;var yn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var En;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(En||(e.InteractiveSessionCopyKind=En={}));var Dn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Kn{constructor(j,oe){this.label=j,this.values=oe}}e.$FM=Kn;var kn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(kn||(e.InteractiveEditorResponseFeedbackKind=kn={}));var Sn;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(Sn||(e.ChatMessageRole=Sn={}));class Hn{constructor(j,oe){this.role=j,this.content=oe}}e.$GM=Hn;var In;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(In||(e.ChatAgentResultFeedbackKind=In={}));var Cn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var Pn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(Pn||(e.SpeechToTextStatus=Pn={}))}),define(Re[103],Ae([1,0,53,13,12,295,147,7,18]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=void 0;const b=new Map;function A(v,n){n?b.set(v,n):b.delete(v)}e.$TM=A;function C(v){return b.get(v)}class l extends T.$$u{constructor(n,o,i,s,a,u,h,t){super(o,i,s,a),this.c=n,this.m=u,this.q=h,this.notebook=t,this.b=!1}dispose(){(0,$.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,g.$ub)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===P.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,i){return n.y(o,i)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,$.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,$.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const i=this.g,s=o.start.line,a=o.end.line,u=[];u.push(this.f[s].substring(o.start.character));for(let h=s+1;h<a;h++)u.push(this.f[h]);return u.push(this.f[a].substring(0,o.end.character)),u.join(i)}t(n){let o;if(n instanceof m.$QK?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new p(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),i=this.f[o.index].length;return new m.$QK(o.index,Math.min(o.remainder,i))}w(n){if(!(n instanceof m.$RK))throw new Error("Invalid argument");const o=this.x(n.start),i=this.x(n.end);return o===n.start&&i===n.end?n:new m.$RK(o.line,o.character,i.line,i.character)}x(n){if(!(n instanceof m.$QK))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:i}=n,s=!1;if(o<0)o=0,i=0,s=!0;else if(o>=this.f.length)o=this.f.length-1,i=this.f[o].length,s=!0;else{const a=this.f[o].length;i<0?(i=0,s=!0):i>a&&(i=a,s=!0)}return s?new m.$QK(o,i):n}y(n,o){const i=this.x(n);if(!o)o=C(this.m);else if((0,I.$Ue)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const s=(0,M.$js)(i.character+1,(0,M.$hs)(o),this.f[i.line],0);if(s)return new m.$RK(i.line,s.startColumn-1,i.line,s.endColumn-1)}}e.$UM=l;class p{constructor(n,o,i){this.a=n,this.b=o,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$RK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$RK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$VM=p}),define(Re[210],Ae([1,0,7,17,5]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;let T=class{constructor(m){this.a=new $.$aM($.ColorThemeKind.Dark),this.b=new I.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let g;switch(m){case"light":g=$.ColorThemeKind.Light;break;case"hcDark":g=$.ColorThemeKind.HighContrast;break;case"hcLight":g=$.ColorThemeKind.HighContrastLight;break;default:g=$.ColorThemeKind.Dark}this.a=new $.$aM(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$$gc=T,e.$$gc=T=Je([Ge(0,P.$RM)],T)}),define(Re[211],Ae([1,0,4]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.CellExecutionUpdateType=void 0;var P;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(P||(e.CellExecutionUpdateType=P={})),e.$VI=(0,$.$2h)("INotebookExecutionService")}),define(Re[212],Ae([1,0,6,29,138,95]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQb=void 0;class M extends $.$Sc{constructor(g,b,A){super(),this._source=g,this.b=b,this.c=A,this.a=void 0}f(g){const b=g.getLineCount();return new P.$Hs(1,1,b,this.g(g,b))}g(g,b){if(b<1||b>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(b)+1}get inputTextBuffer(){if(!this.b){const g=new I.$XB;g.acceptChunk(this._source);const b=g.finish(!0),{textBuffer:A,disposable:C}=b.create(1);this.b=A,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const b=new I.$XB;b.acceptChunk(g);const A=b.finish(!0),{textBuffer:C,disposable:l}=A.create(1);return this.B(l),C})),this.a}findInInputs(g){const A=new T.$LB(g,!1,!1,null).parseSearchRequest();if(!A)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,A,!0,5e3)}findInOutputs(g){const A=new T.$LB(g,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(C=>{const l=C.findMatchesLineByLine(this.f(C),A,!0,5e3);if(l.length!==0)return{textBuffer:C,matches:l}}).filter(C=>!!C):[]}}e.$aQb=M}),define(Re[48],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FJ=e.TestPosition=e.TestIdPathParts=void 0;var $;(function(T){T.Delimiter="\0"})($||(e.TestIdPathParts=$={}));var P;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(P||(e.TestPosition=P={}));class I{static fromExtHostTestItem(M,m,g=M.parent){if(M._isRoot)return new I([m]);const b=[M.id];for(let A=g;A&&A.id!==m;A=A.parent)b.push(A.id);return b.push(m),new I(b.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const m=M.indexOf("\0");return m===-1?M:M.slice(0,m)}static fromString(M){return new I(M.split("\0"))}static join(M,m){return new I([...M.path,m])}static joinToString(M,m){return M.toString()+"\0"+m}static parentId(M){const m=M.lastIndexOf("\0");return m===-1?void 0:M.slice(0,m)}static localId(M){const m=M.lastIndexOf("\0");return m===-1?M:M.slice(m+1)}static isChild(M,m){return m.startsWith(M)&&m[M.length]==="\0"}static compare(M,m){return M===m?0:I.isChild(M,m)?2:I.isChild(m,M)?3:1}constructor(M,m=M.length){if(this.path=M,this.d=m,M.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new I(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new I(this.path,M)}compare(M){if(typeof M=="string")return I.compare(this.toString(),M);for(let m=0;m<M.d&&m<this.d;m++)if(M.path[m]!==this.path[m])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$FJ=I}),define(Re[58],Ae([1,0,2,93,29,48]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$MJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$LJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$KJ=e.$JJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$IJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$HJ=e.$GJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var m;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var g;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$GJ=[2,4,8,16,32,64];const b=R=>"runId"in R;e.$HJ=b;var A;(function(R){R.serialize=S=>({range:S.range.toJSON(),uri:S.uri.toJSON()}),R.deserialize=S=>({range:I.$Hs.lift(S.range),uri:$.URI.revive(S.uri)})})(A||(e.IRichLocation=A={}));var C;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(C||(e.TestMessageType=C={}));var l;(function(R){R.serialize=S=>({message:S.message,type:0,expected:S.expected,actual:S.actual,contextValue:S.contextValue,location:S.location&&A.serialize(S.location)}),R.deserialize=S=>({message:S.message,type:0,expected:S.expected,actual:S.actual,contextValue:S.contextValue,location:S.location&&A.deserialize(S.location)})})(l||(e.ITestErrorMessage=l={}));const p=(R,S)=>`${S?"s":"e"}${R}`;e.$IJ=p;var v;(function(R){R.serialize=S=>({message:S.message,type:1,offset:S.offset,length:S.length,location:S.location&&A.serialize(S.location)}),R.deserialize=S=>({message:S.message,type:1,offset:S.offset,length:S.length,location:S.location&&A.deserialize(S.location)})})(v||(e.ITestOutputMessage=v={}));var n;(function(R){R.serialize=S=>S.type===0?l.serialize(S):v.serialize(S),R.deserialize=S=>S.type===0?l.deserialize(S):v.deserialize(S)})(n||(e.ITestMessage=n={}));var o;(function(R){R.serializeWithoutMessages=S=>({state:S.state,duration:S.duration,messages:[]}),R.serialize=S=>({state:S.state,duration:S.duration,messages:S.messages.map(n.serialize)}),R.deserialize=S=>({state:S.state,duration:S.duration,messages:S.messages.map(n.deserialize)})})(o||(e.ITestTaskState=o={}));const i="\0",s=(R,S)=>R+i+S;e.$JJ=s;const a=R=>{const S=R.indexOf(i);return{ctrlId:R.slice(0,S),tagId:R.slice(S+1)}};e.$KJ=a;var u;(function(R){R.serialize=S=>({extId:S.extId,label:S.label,tags:S.tags,busy:S.busy,children:void 0,uri:S.uri?.toJSON(),range:S.range?.toJSON()||null,description:S.description,error:S.error,sortText:S.sortText}),R.deserialize=S=>({extId:S.extId,label:S.label,tags:S.tags,busy:S.busy,children:void 0,uri:S.uri?$.URI.revive(S.uri):void 0,range:S.range?I.$Hs.lift(S.range):null,description:S.description,error:S.error,sortText:S.sortText})})(u||(e.ITestItem=u={}));var h;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(R){R.serialize=S=>({expand:S.expand,item:u.serialize(S.item)}),R.deserialize=S=>({controllerId:T.$FJ.root(S.item.extId),expand:S.expand,item:u.deserialize(S.item)})})(t||(e.InternalTestItem=t={}));var r;(function(R){R.serialize=S=>{let O;return S.item&&(O={},S.item.label!==void 0&&(O.label=S.item.label),S.item.tags!==void 0&&(O.tags=S.item.tags),S.item.busy!==void 0&&(O.busy=S.item.busy),S.item.uri!==void 0&&(O.uri=S.item.uri?.toJSON()),S.item.range!==void 0&&(O.range=S.item.range?.toJSON()),S.item.description!==void 0&&(O.description=S.item.description),S.item.error!==void 0&&(O.error=S.item.error),S.item.sortText!==void 0&&(O.sortText=S.item.sortText)),{extId:S.extId,expand:S.expand,item:O}},R.deserialize=S=>{let O;return S.item&&(O={},S.item.label!==void 0&&(O.label=S.item.label),S.item.tags!==void 0&&(O.tags=S.item.tags),S.item.busy!==void 0&&(O.busy=S.item.busy),S.item.range!==void 0&&(O.range=S.item.range?I.$Hs.lift(S.item.range):null),S.item.description!==void 0&&(O.description=S.item.description),S.item.error!==void 0&&(O.error=S.item.error),S.item.sortText!==void 0&&(O.sortText=S.item.sortText)),{extId:S.extId,expand:S.expand,item:O}}})(r||(e.ITestItemUpdate=r={}));const c=(R,S)=>{S.expand!==void 0&&(R.expand=S.expand),S.item!==void 0&&(R.item=R.item?Object.assign(R.item,S.item):S.item)};e.$LJ=c;var f;(function(R){R.serializeWithoutMessages=S=>({...t.serialize(S),ownComputedState:S.ownComputedState,computedState:S.computedState,tasks:S.tasks.map(o.serializeWithoutMessages)}),R.serialize=S=>({...t.serialize(S),ownComputedState:S.ownComputedState,computedState:S.computedState,tasks:S.tasks.map(o.serialize)}),R.deserialize=S=>({...t.deserialize(S),ownComputedState:S.ownComputedState,computedState:S.computedState,tasks:S.tasks.map(o.deserialize),retired:!0})})(f||(e.TestResultItem=f={}));var w;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(S,O)=>{S.covered+=O.covered,S.total+=O.total}})(w||(e.ICoveredCount=w={}));var d;(function(R){R.serialize=S=>({statement:S.statement,branch:S.branch,function:S.function,details:S.details?.map(E.serialize),uri:S.uri.toJSON()}),R.deserialize=S=>({statement:S.statement,branch:S.branch,function:S.function,details:S.details?.map(E.deserialize),uri:$.URI.from(S.uri)})})(d||(e.IFileCoverage=d={}));function D(R){return{...R,location:R.location?.toJSON()}}function L(R){return R.location=R.location?P.$Gs.isIPosition(R.location)?P.$Gs.lift(R.location):I.$Hs.lift(R.location):void 0,R}e.$MJ=3;var y;(function(R){R[R.Function=0]="Function",R[R.Statement=1]="Statement"})(y||(e.DetailType=y={}));var E;(function(R){R.serialize=S=>S.type===0?F.serialize(S):B.serialize(S),R.deserialize=S=>S.type===0?F.deserialize(S):B.deserialize(S)})(E||(e.CoverageDetails=E={}));var k;(function(R){R.serialize=D,R.deserialize=L})(k||(e.IBranchCoverage=k={}));var F;(function(R){R.serialize=D,R.deserialize=L})(F||(e.IFunctionCoverage=F={}));var B;(function(R){R.serialize=S=>({...D(S),branches:S.branches?.map(k.serialize)}),R.deserialize=S=>({...L(S),branches:S.branches?.map(k.deserialize)})})(B||(e.IStatementCoverage=B={}));var ee;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(ee||(e.TestDiffOpType=ee={}));var J;(function(R){R.deserialize=S=>S.op===0?{op:S.op,item:t.deserialize(S.item)}:S.op===1?{op:S.op,item:r.deserialize(S.item)}:S.op===2?{op:S.op,uri:$.URI.revive(S.uri),docv:S.docv}:S,R.serialize=S=>S.op===0?{op:S.op,item:t.serialize(S.item)}:S.op===1?{op:S.op,item:r.serialize(S.item)}:S})(J||(e.TestsDiffOp=J={}));class V{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(S){const O=this.o();for(const Q of S)switch(Q.op){case 0:this.j(t.deserialize(Q.item),O);break;case 1:this.k(r.deserialize(Q.item),O);break;case 3:this.l(Q.itemId,O);break;case 5:this.m(Q.itemId);break;case 4:this.updatePendingRoots(Q.amount);break;case 6:this.c.set(Q.tag.id,Q.tag);break;case 7:this.c.delete(Q.id);break}O.complete?.()}j(S,O){const Q=T.$FJ.parentId(S.item.extId)?.toString();let re;if(!Q)re=this.p(S),this.f.add(re),this.d.set(S.item.extId,re);else if(this.d.has(Q)){const he=this.d.get(Q);he.children.add(S.item.extId),re=this.p(S,he),this.d.set(S.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(S)}`);return}return O.add?.(re),S.expand===2&&this.g++,re}k(S,O){const Q=this.d.get(S.extId);if(Q)return S.expand!==void 0&&(Q.expand===2&&this.g--,S.expand===2&&this.g++),(0,e.$LJ)(Q,S),O.update?.(Q),Q}l(S,O){const Q=this.d.get(S);if(!Q)return;const re=T.$FJ.parentId(Q.item.extId)?.toString();re?this.d.get(re).children.delete(Q.item.extId):this.f.delete(Q);const he=[[S]];for(;he.length;)for(const fe of he.pop()){const ue=this.d.get(fe);ue&&(he.push(ue.children),this.d.delete(fe),O.remove?.(ue,ue!==Q),ue.expand===2&&this.g--)}}m(S){}updatePendingRoots(S){this.h+=S}o(){return{}}}e.$NJ=V}),define(Re[77],Ae([1,0,14,5,6,53,58,48]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.TestItemEventOp=void 0;var g;(function(s){s[s.Upsert=0]="Upsert",s[s.SetTags=1]="SetTags",s[s.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",s[s.RemoveChild=3]="RemoveChild",s[s.SetProp=4]="SetProp",s[s.Bulk=5]="Bulk",s[s.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const b=(s,a)=>s===a,C=Object.entries({range:(s,a)=>s===a?!0:!s||!a?!1:s.equalsRange(a),busy:b,label:b,description:b,error:b,sortText:b,tags:(s,a)=>!(s.length!==a.length||s.some(u=>!a.includes(u)))}),l=(s,a)=>{let u;for(const[h,t]of C)t(s[h],a[h])||(u?u[h]=a[h]:u={[h]:a[h]});return u};class p extends I.$Sc{get root(){return this.s.root}constructor(a){super(),this.s=a,this.f=this.B(new $.$bh(()=>this.flushDiff(),200)),this.g=this.B(new P.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(a){this.h=a;for(const u of this.tree.values())this.I(u)}get resolveHandler(){return this.h}collectDiff(){const a=this.m;return this.m=[],a}pushDiff(a){switch(a.op){case 2:{for(const u of this.m)if(u.op===2&&u.uri===a.uri){u.docv=a.docv;return}break}case 1:{const u=this.m[this.m.length-1];if(u){if(u.op===1&&u.item.extId===a.item.extId){(0,M.$LJ)(u.item,a.item);return}if(u.op===0&&u.item.item.extId===a.item.extId){(0,M.$LJ)(u.item,a.item);return}}break}}this.m.push(a),this.f.isScheduled()||this.f.schedule()}expand(a,u){const h=this.tree.get(a);if(h){if((h.expandLevels===void 0||u>h.expandLevels)&&(h.expandLevels=u),h.expand===1){const t=this.L(h);return t.isOpen()?this.J(h,u-1):t.wait().then(()=>this.J(h,u-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,u-1)):this.J(h,u-1)}}dispose(){for(const a of this.tree.values())this.s.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(a,u){switch(u.op){case 3:this.N(m.$FJ.joinToString(a.fullId,u.id));break;case 0:this.y(u.item,a);break;case 5:for(const h of u.ops)this.u(a,h);break;case 1:this.z(u.new,u.old,a.fullId.toString());break;case 2:this.I(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:u.update}});break;case 6:this.w(a.actual.uri);break;default:(0,T.$5c)(u)}}w(a){a&&this.pushDiff({op:2,uri:a,docv:this.s.getDocumentVersion(a)})}y(a,u){const h=m.$FJ.fromExtHostTestItem(a,this.root.id,u?.actual),t=this.s.getApiFor(a);t.parent&&t.parent!==u?.actual&&this.s.getChildren(t.parent).delete(a.id);let r=this.tree.get(h.toString());if(!r){r={fullId:h,actual:a,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},a.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(a,u),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(a)}}),this.H(a,r,u);return}if(r.actual===a){this.G(a,r,u);return}if(r.actual.uri?.toString()!==a.uri?.toString())return this.N(h.toString()),this.y(a,u);const c=this.s.getChildren(r.actual),f=r.actual,w=l(this.s.toITestItem(f),this.s.toITestItem(a));this.s.getApiFor(f).listener=void 0,r.actual=a,r.expand=0,w&&(w.hasOwnProperty("tags")&&(this.z(a.tags,f.tags,h.toString()),delete w.tags),this.u(r,{op:4,update:w})),this.H(a,r,u);for(const[d,D]of c)this.s.getChildren(a).get(D.id)||this.N(m.$FJ.joinToString(h,D.id));this.w(r.actual.uri)}z(a,u,h){const t=new Set(u.map(r=>r.id));for(const r of a)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:h,item:{tags:a.map(r=>(0,M.$JJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(a){const u=this.j.get(a.id);u?u.refCount++:(this.j.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$JJ)(this.s.controllerId,a.id)}}))}D(a){const u=this.j.get(a);u&&!--u.refCount&&(this.j.delete(a),this.pushDiff({op:7,id:(0,M.$JJ)(this.s.controllerId,a)}))}F(a,u){this.s.getApiFor(a).parent=u&&u.actual!==this.root?u.actual:void 0}G(a,u,h){this.F(a,h);const t=this.s.getApiFor(a);t.parent=h?.actual,t.listener=r=>this.u(u,r),this.I(u)}H(a,u,h){this.G(a,u,h);for(const[t,r]of this.s.getChildren(a))this.y(r,u)}I(a){let u;this.h?a.resolveBarrier?u=a.resolveBarrier.isOpen()?3:2:u=a.actual.canResolveChildren?1:0:u=0,u!==a.expand&&(a.expand=u,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:u}}),u===1&&a.expandLevels!==void 0&&this.L(a))}J(a,u){if(u<0)return;const h=[];for(const[t,r]of this.s.getChildren(a.actual)){const c=this.expand(m.$FJ.joinToString(a.fullId,r.id),u);(0,$.$Og)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}L(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this.h){const r=new $.$1g;return r.open(),r}a.expand=2,this.M(a);const u=a.resolveBarrier=new $.$1g,h=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(a.actual===this.root?void 0:a.actual)}catch(r){h(r)}return(0,$.$Og)(t)?t.catch(h).then(()=>{u.open(),this.I(a)}):(u.open(),this.I(a)),a.resolveBarrier}M(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}N(a){const u=this.tree.get(a);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const h=[u];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,c]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$FJ.joinToString(t.fullId,c.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.g.fire(a)}}e.$HM=p;class v extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.$IM=v;class n extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$JM=n;class o extends Error{constructor(a,u,h){super(`TestItem with ID "${a}" is from controller "${u}" and cannot be added as a child of an item from controller "${h}".`)}}e.$KM=o;const i=(s,a,u)=>{let h=new Map;return{get size(){return h.size},forEach(t,r){for(const c of h.values())t.call(r,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const r=new Map,c=new Set(h.keys()),f={op:5,ops:[]};for(const w of t){if(!(w instanceof u))throw new n(w.id);const d=a(w).controllerId;if(d!==s.controllerId)throw new o(w.id,d,s.controllerId);if(r.has(w.id))throw new v(w.id);r.set(w.id,w),c.delete(w.id),f.ops.push({op:0,item:w})}for(const w of c.keys())f.ops.push({op:3,id:w});s.listener?.(f),h=r},add(t){if(!(t instanceof u))throw new n(t.id);h.set(t.id,t),s.listener?.({op:0,item:t})},delete(t){h.delete(t)&&s.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$LM=i}),define(Re[104],Ae([1,0,77]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0;const P=new WeakMap,I=(M,m)=>{const g={controllerId:m};return P.set(M,g),g};e.$MM=I;const T=M=>{const m=P.get(M);if(!m)throw new $.$JM(M?.id||"<unknown>");return m};e.$NM=T}),define(Re[78],Ae([1,0,13,2]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pvb=e.$ovb=e.$nvb=e.$mvb=e.$lvb=void 0,e.$lvb="vscode-cdn.net",e.$mvb=`vscode-resource.${e.$lvb}`,e.$nvb=`'self' https://*.${e.$lvb}`;function I(m,g){return m.scheme===$.Schemas.http||m.scheme===$.Schemas.https?m:(g&&g.authority&&g.isRemote&&m.scheme===$.Schemas.file&&(m=P.URI.from({scheme:$.Schemas.vscodeRemote,authority:g.authority,path:m.path})),P.URI.from({scheme:$.Schemas.https,authority:`${m.scheme}+${T(m.authority)}.${e.$mvb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$ovb=I;function T(m){return m.replace(/./g,g=>{const b=g.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?g:"-"+b.toString(16).padStart(4,"0")})}function M(m){return m.replace(/-([0-9a-f]{4})/g,(g,b)=>String.fromCharCode(parseInt(b,16)))}e.$pvb=M}),define(Re[213],Ae([1,0,5,6,78]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class T{constructor(m,g,b){this.d=m,this.e=g,this.f=b,this.a=0,this.b=new P.$Rc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const A=g.getVisibleTextEditors();for(const C of this.c.values())A.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,g,b,A,C){let l;for(const a of this.e.getVisibleTextEditors(!0))if(a.value===m){l=a;break}if(!l)throw new Error("not a visible editor");const p=this,v=this.a++,n=new $.$Sd,o=new $.$Sd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(a){return(0,I.$ovb)(a,p.f)}get cspSource(){return I.$nvb}set options(a){this.b=a,p.d.$setOptions(v,a)}get options(){return this.b}set html(a){this.a=a,p.d.$setHtml(v,a)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(a){return p.d.$postMessage(v,a)}},s=new class{constructor(){this.editor=m,this.line=g,this.height=b,this.webview=i,this.onDidDispose=o.event}dispose(){p.c.has(v)&&(p.c.delete(v),p.d.$disposeEditorInset(v),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(v,l.id,l.value.document.uri,g+1,b,A||{},C.identifier,C.extensionLocation),this.c.set(v,{editor:m,inset:s,onDidReceiveMessage:n}),s}$onDidDispose(m){const g=this.c.get(m);g&&g.inset.dispose()}$onDidReceiveMessage(m,g){this.c.get(m)?.onDidReceiveMessage.fire(g)}}e.$ufc=T}),define(Re[214],Ae([1,0,4]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.VariableKind=e.$DN=void 0,e.$DN=(0,$.$2h)("configurationResolverService");var P;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator"})(P||(e.VariableKind=P={}));class I extends Error{constructor(M,m){super(m),this.variable=M}}e.$EN=I}),define(Re[215],Ae([1,0,19,74,16,26,21,91,177,214,12]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=void 0;class C{constructor(p,v,n,o){this.h=new Map,this.a=p,this.b=v,this.g=n,o&&(this.c=o.then(i=>this.i(i)))}i(p){if(M.$c){const v=Object.create(null);return Object.keys(p).forEach(n=>{v[n.toLowerCase()]=p[n]}),v}return p}resolveWithEnvironment(p,v,n){return this.l({env:this.i(p),userHome:void 0},v?v.uri:void 0,n)}async resolveAsync(p,v){const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,v)}async j(p,v,n,o){const i=T.$in(v);M.$c&&i.windows?Object.keys(i.windows).forEach(a=>i[a]=i.windows[a]):M.$d&&i.osx?Object.keys(i.osx).forEach(a=>i[a]=i.osx[a]):M.$e&&i.linux&&Object.keys(i.linux).forEach(a=>i[a]=i.linux[a]),delete i.windows,delete i.osx,delete i.linux;const s={env:await this.c,userHome:await this.g};return this.l(s,p?p.uri:void 0,i,n,o)}async resolveAnyAsync(p,v,n){return this.j(p,v,n)}async resolveAnyMap(p,v,n){const o=new Map;return{newConfig:await this.j(p,v,n,o),resolvedVariables:o}}resolveWithInteractionReplace(p,v,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,v,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,v){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,v)}async l(p,v,n,o,i){if(I.$Ef(n))return this.m(p,v,n,o,i);if(Array.isArray(n))return Promise.all(n.map(s=>this.l(p,v,s,o,i)));if(I.$Gf(n)){const s=Object.create(null),a=await Promise.all(Object.keys(n).map(async u=>[await this.m(p,v,u,o,i),await this.l(p,v,n[u],o,i)]));for(const[u,h]of a)s[u]=h;return s}return n}m(p,v,n,o,i){return(0,A.$Ze)(n,C.VARIABLE_REGEXP,async(s,a)=>{if(a.includes(C.VARIABLE_LHS))return s;let u=await this.o(p,s,a,v,o);return i?.set(a,u),u!==s&&I.$Ef(u)&&u.match(C.VARIABLE_REGEXP)&&(u=await this.m(p,v,u,o,i)),u})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,v,n,o,i){let s;const a=n.split(":");a.length>1&&(n=a[0],s=a[1]);const u=r=>{const c=this.a.getFilePath();if(c)return(0,m.$Iv)(c);throw new b.$EN(r,(0,g.localize)(0,null,v))},h=r=>{const c=u(r);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,m.$Iv)(f)}throw new b.$EN(r,(0,g.localize)(1,null,v,$.$nc(c)))},t=r=>{if(s){const c=this.a.getFolderUri(s);if(c)return c;throw new b.$EN(r,(0,g.localize)(2,null,v,s))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new b.$EN(r,(0,g.localize)(3,null,v)):new b.$EN(r,(0,g.localize)(4,null,v))};switch(n){case"env":if(s){if(p.env){const r=p.env[M.$c?s.toLowerCase():s];if(I.$Ef(r))return r}return""}throw new b.$EN(b.VariableKind.Env,(0,g.localize)(5,null,v));case"config":if(s){const r=this.a.getConfigurationValue(o,s);if(I.$Nf(r))throw new b.$EN(b.VariableKind.Config,(0,g.localize)(6,null,v,s));if(I.$Gf(r))throw new b.$EN(b.VariableKind.Config,(0,g.localize)(7,null,v,s));return r}throw new b.$EN(b.VariableKind.Config,(0,g.localize)(8,null,v));case"command":return this.p(b.VariableKind.Command,v,s,i,"command");case"input":return this.p(b.VariableKind.Input,v,s,i,"input");case"extensionInstallFolder":if(s){const r=await this.a.getExtension(s);if(!r)throw new b.$EN(b.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,v,s));return this.n(r.extensionLocation)}throw new b.$EN(b.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,v));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,m.$Iv)(this.n(t(b.VariableKind.WorkspaceFolder)));case"cwd":return o||s?(0,m.$Iv)(this.n(t(b.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Iv)($.$nc(this.n(t(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new b.$EN(b.VariableKind.UserHome,(0,g.localize)(11,null,v))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new b.$EN(b.VariableKind.LineNumber,(0,g.localize)(12,null,v))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new b.$EN(b.VariableKind.SelectedText,(0,g.localize)(13,null,v))}case"file":return u(b.VariableKind.File);case"fileWorkspaceFolder":return h(b.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return $.$nc(h(b.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||s?$.$lc(this.n(t(b.VariableKind.RelativeFile)),u(b.VariableKind.RelativeFile)):u(b.VariableKind.RelativeFile);case"relativeFileDirname":{const r=$.$mc(u(b.VariableKind.RelativeFileDirname));if(o||s){const c=$.$lc(this.n(t(b.VariableKind.RelativeFileDirname)),r);return c.length===0?".":c}return r}case"fileDirname":return $.$mc(u(b.VariableKind.FileDirname));case"fileExtname":return $.$oc(u(b.VariableKind.FileExtname));case"fileBasename":return $.$nc(u(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=$.$nc(u(b.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-$.$oc(r).length)}case"fileDirnameBasename":return $.$nc($.$mc(u(b.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||v}case"execInstallFolder":{const r=this.a.getAppRoot();return r||v}case"pathSeparator":return $.sep;default:try{const r=s?`${n}:${s}`:n;return this.p(b.VariableKind.Unknown,v,r,i,void 0)}catch{return v}}}}p(p,v,n,o,i){if(n&&o){const s=i===void 0?o[n]:o[i+":"+n];if(typeof s=="string")return s;throw new b.$EN(p,(0,g.localize)(14,null,v))}return v}}e.$SN=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Re[105],Ae([1,0,4,102]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$TC=e.OpenEditorContext=e.GroupsOrder=e.$SC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$RC=void 0,e.$RC=(0,$.$2h)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var T;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var M;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var m;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var g;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function b(v){const n=v;return(0,P.$AE)(n?.editor)&&(0,P.$AE)(n?.replacement)}e.$SC=b;var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var C;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function l(v){const n=v;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.$TC=l;function p(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$UC=p}),define(Re[216],Ae([1,0,4,105]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=e.$XC=e.$WC=e.$VC=void 0,e.$VC=(0,$.$2h)("editorService"),e.$WC=-1,e.$XC=-2;function I(T){const M=T;return typeof T=="number"||(0,P.$TC)(M)}e.$YC=I}),define(Re[217],Ae([1,0,4,184]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=void 0,e.$$J=(0,$.$3h)(P.$9h)}),define(Re[106],Ae([1,0,22,5,19,6]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=e.$q7b=e.$p7b=e.$o7b=e.$n7b=void 0;class M{constructor(i,s){this.versionId=i,this.removedDueToLooping=s}}e.$n7b=M;class m{static isHostExtension(i,s,a){if(s.getExtensionDescription(i))return!1;const u=a.getExtensionDescription(i);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(i,s){this.j=i,this.c=new P.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=s,this.k()}k(){this.e.sort(v),this.f=new $.$jm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const s=this.j.readActivationEvents(i);for(const a of s)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,s){this.e=n(this.e,s),this.e=this.e.concat(i);const a=m.l(this.e);return this.e=n(this.e,a.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new M(this.d,a)}static l(i){const s=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,c){this.addNode(r),this.addNode(c),this.c.has(r)?this.c.get(r).push(c):this.c.set(r,[c])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,c){const f=s.getArcs(r);for(let w=0;w<f.length;w++)if(!c.has(f[w]))return!1;return!0}getNodes(){return this.e}},a=new $.$jm;for(const r of i)if(a.set(r.identifier,r),r.extensionDependencies)for(const c of r.extensionDependencies)s.addArc($.$hm.toKey(r.identifier),$.$hm.toKey(c));const u=new Set;s.getNodes().filter(r=>s.getArcs(r).length===0).forEach(r=>u.add(r));const h=s.getNodes().filter(r=>!u.has(r));let t;do{t=!1;for(let r=0;r<h.length;r++){const c=h[r];s.hasOnlyGoodArcs(c,u)&&(h.splice(r,1),r--,u.add(c),t=!0)}}while(t);return h.map(r=>a.get(r))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const s=this.h.get(i);return s?s.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const s=this.f.get(i);return s||void 0}getExtensionDescriptionByUUID(i){for(const s of this.g)if(s.uuid===i)return s}getExtensionDescriptionByIdOrUUID(i,s){return this.getExtensionDescription(i)??(s?this.getExtensionDescriptionByUUID(s):void 0)}}e.$o7b=m;class g{constructor(i,s){this.versionId=i,this.extensions=s}}e.$p7b=g;class b{constructor(i){this.d=new l,this.c=new m(i,[])}async acquireLock(i){const s=await this.d.acquire(i);return new A(this,s)}deltaExtensions(i,s,a){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(s,a)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,s){return this.c.getExtensionDescriptionByIdOrUUID(i,s)}}e.$q7b=b;class A extends T.$Sc{constructor(i,s){super(),this.f=i,this.c=!1,this.B(s)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$r7b=A;class C{constructor(i){this.name=i,this.promise=new Promise((s,a)=>{this.c=s})}resolve(i){this.c(i)}}class l{constructor(){this.c=[],this.d=!1}async acquire(i){const s=new C(i);return this.c.push(s),this.e(),s.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let s=!0;const a=setTimeout(()=>{s&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{s&&(clearTimeout(a),s=!1,this.d=!1,this.e())};i.resolve((0,T.$Qc)(u))}}var p;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(p||(p={}));function v(o,i){const s=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(s!==a)return s-a;const u=I.$gc.basename(o.extensionLocation.path),h=I.$gc.basename(i.extensionLocation.path);return u<h?-1:u>h?1:0}function n(o,i){const s=new $.$im(i);return o.filter(a=>!s.has(a.identifier))}}),define(Re[79],Ae([1,0,24]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$qm=e.$pm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var P;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(P||(e.UIKind=P={}));var I;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var T;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function M(b){const A=$.$ge.alloc(1);switch(b){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$pm=M;function m(b,A){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$qm=m;var g;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Re[59],Ae([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.$0M=e.$9M=void 0;let p=class extends C.$Sc{constructor(i,s){super(),this.s=i,this.t=s,this.a=this.B(new P.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new P.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=s.createLogger(this.m,{id:g.$Co,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(s.onDidChangeLogLevel(a=>{(0,I.$lj)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,s,a){const u=this.getTelemetryDetails(),h=new v(s,a,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}),t=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(i,s,a){this.f=i,this.g=s,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const s=Object.create(null);switch(s["common.extname"]=`${i.publisher}.${i.name}`,s["common.extversion"]=i.version,s["common.vscodemachineid"]=this.s.telemetryInfo.machineId,s["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,s["common.sqmid"]=this.s.telemetryInfo.sqmId,s["common.vscodeversion"]=this.s.version,s["common.isnewappinstall"]=n(this.s.telemetryInfo.firstSessionDate),s["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:s["common.uikind"]="web";break;case M.UIKind.Desktop:s["common.uikind"]="desktop";break;default:s["common.uikind"]="unknown"}return s["common.remotename"]=(0,m.$9k)((0,g.$Jo)(this.s.remote.authority)),s}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const s=this.getTelemetryDetails();this.r.forEach((a,u)=>{const h=a.filter(t=>!t.isDisposed);h.length===0?this.r.delete(u):this.r.set(u,h)}),this.r.forEach(a=>{for(const u of a)u.updateTelemetryEnablements(s.isUsageEnabled,s.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,s){const u=this.r.get(i.value)?.filter(t=>!t.isDisposed);if(!u)return this.r.delete(i.value),!1;let h=!1;for(const t of u)t.ignoreUnhandledExtHostErrors||(t.logError(s),h=!0);return h}};e.$9M=p,e.$9M=p=Je([Ge(0,T.$8M),Ge(1,I.$kj)],p);class v{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,s,a,u,h,t,r){this.g=a,this.h=u,this.i=h,this.j=t,this.a=new P.$Sd,this.ignoreUnhandledExtHostErrors=s?.ignoreUnhandledErrors??!1,this.b=s?.ignoreBuiltInCommonProperties??!1,this.c=s?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(i,s){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:s},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let s="properties"in i?i.properties??{}:i;return s=(0,g.$Mo)(s,[]),this.c&&(s=(0,b.$ln)(s,this.c)),this.b||(s=(0,b.$ln)(s,this.j)),"properties"in i?i.properties=s:i=s,i}k(i,s){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f?.sendEventData(i,s),this.h.trace(i,s))}logUsage(i,s){this.d.isUsageEnabled&&this.k(i,s)}logError(i,s){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,s);else{const a={name:i.name,message:i.message,stack:i.stack,cause:i.cause},u=(0,g.$Mo)(a,[]),h=new Error(u.message,{cause:u.cause});h.stack=u.stack,h.name=u.name,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f.sendErrorData(h,s),this.h.trace("exception",s)}}get apiTelemetryLogger(){if(!this.e){const i=this,s={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(s)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$0M=v;function n(o){const i=Date.now()-new Date(o).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$$M=n,e.$_M=(0,$.$2h)("IExtHostTelemetry")}),define(Re[23],Ae([1,0,5,2,193,101,22,4]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.ActivationKind=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.ExtensionHostStartup=e.$iF=e.$hF=e.$gF=e.$fF=void 0,e.$fF=Object.freeze({identifier:new M.$hm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$gF="extensions.webWorker",e.$hF=(0,m.$2h)("extensionService");class g{constructor(h){this.dependency=h}}e.$iF=g;var b;(function(u){u[u.EagerAutoStart=1]="EagerAutoStart",u[u.EagerManualStart=2]="EagerManualStart",u[u.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,r){this.c=h,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$3E.createActivationEventsMap(this.d)}}set(h,t,r){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],f=[],w=[],d=[],D=C(this.d),L=C(t),y=(ee,J)=>ee.extensionLocation.toString()===J.extensionLocation.toString()||ee.isBuiltin===J.isBuiltin||ee.isUserBuiltin===J.isUserBuiltin||ee.isUnderDevelopment===J.isUnderDevelopment;for(const ee of this.d){const J=L.get(ee.identifier);if(!J){c.push(ee.identifier),D.delete(ee.identifier);continue}if(!y(ee,J)){c.push(ee.identifier),D.delete(ee.identifier);continue}}for(const ee of t){const J=D.get(ee.identifier);if(!J){f.push(ee);continue}if(!y(J,ee)){c.push(J.identifier),D.delete(J.identifier);continue}}const E=new M.$im(this.e),k=new M.$im(r);for(const ee of this.e)k.has(ee)||w.push(ee);for(const ee of r)E.has(ee)||d.push(ee);const F=T.$3E.createActivationEventsMap(f),B={versionId:h,toRemove:c,toAdd:f,addActivationEvents:F,myToRemove:w,myToAdd:d};return this.delta(B),B}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:c,myToAdd:f}=h,w=new M.$im(t),d=new M.$im(c);for(let D=0;D<this.d.length;D++)w.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)d.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of r)this.d.push(D);for(const D of f)this.e.push(D);return this.f=null,h}containsExtension(h){for(const t of this.e)if(M.$hm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=T.$3E.readActivationEvents(t);for(const c of r)h.add(c)}return h}}e.$jF=A;function C(u){const h=new M.$jm;for(const t of u)h.set(t.identifier,t);return h}function l(u,h){return!0}e.$kF=l;function p(u,h){if(!l(u,h))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.$lF=p;class v{constructor(h,t,r,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=c}}e.$mF=v;class n{constructor(h,t){this.description=h,this.value=t}}e.$nF=n;var o;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function i(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,I.$So)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}e.$oF=i;function s(u,h){return{identifier:new M.$hm((0,I.$Qo)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!h,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform}}e.$pF=s;class a{constructor(){this.onDidRegisterExtensions=$.Event.None,this.onDidChangeExtensionsStatus=$.Event.None,this.onDidChangeExtensions=$.Event.None,this.onWillActivateByEvent=$.Event.None,this.onDidChangeResponsiveChange=$.Event.None,this.onWillStop=$.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$qF=a}),define(Re[218],Ae([1,0,11,106,22,23,15,14]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=e.$Ufc=e.$Tfc=e.$Sfc=e.$Rfc=e.$Qfc=void 0;class g{constructor(i,s,a,u){this.startup=i,this.codeLoadingTime=s,this.activateCallTime=a,this.activateResolvedTime=u}}e.$Qfc=g,g.NONE=new g(!1,-1,-1,-1);class b{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,s){return i===-1||s===-1?-1:s-i}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Rfc=b;class A{constructor(i,s,a,u,h,t){this.activationFailed=i,this.activationFailedError=s,this.activationTimes=a,this.module=u,this.exports=h,this.subscriptions=t}}e.$Sfc=A;class C extends A{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Tfc=C;class l extends A{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ufc=l;class p extends A{constructor(i){super(!0,i,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(i,s,a,u){this.g=u,this.a=i,this.b=s,this.c=a,this.d=new I.$jm,this.f=Object.create(null)}dispose(){for(const[i,s]of this.d)s.dispose()}async waitForActivatingExtensions(){const i=[];for(const[s,a]of this.d)i.push(a.wait());await Promise.all(i)}isActivated(i){const s=this.d.get(i);return!!(s&&s.value)}getActivatedExtension(i){const s=this.d.get(i);if(!s||!s.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return s.value}async activateByEvent(i,s){if(this.f[i])return;const a=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(a.map(u=>({id:u.identifier,reason:{startup:s,extensionId:u.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,s){const a=this.a.getExtensionDescription(i);if(!a)throw new Error(`Extension '${i}' is not known`);return this.h([{id:a.identifier,reason:s}])}async h(i){const s=i.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(s.map(a=>a.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const s=this.a.getExtensionDescription(i.id);if(!s){const h=new Error(`Cannot activate unknown extension '${i.id.value}'`),t=this.k(i,null,[],new p(h));return this.c.onExtensionActivationError(i.id,h,new T.$iF(i.id.value)),t}const a=[],u=typeof s.extensionDependencies>"u"?[]:s.extensionDependencies;for(const h of u){if(this.m(h))continue;const t=this.d.get(h);if(t){a.push(t);continue}if(this.l(h)){a.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:i.reason}));continue}const r=this.a.getExtensionDescription(h);if(r){if(!r.main&&!r.browser)continue;a.push(this.j({id:r.identifier,reason:i.reason}));continue}const c=s.displayName||s.identifier.value,f=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),w=this.k(i,s.displayName,[],new p(f));return this.c.onExtensionActivationError(s.identifier,f,new T.$iF(h)),w}return this.k(i,s.displayName,a,null)}k(i,s,a,u){const h=new n(i.id,s,i.reason,a,u,this.c,this.g);return this.d.set(i.id,h),h}l(i){return P.$o7b.isHostExtension(i,this.a,this.b)}m(i){const s=this.b.getExtensionDescription(i);return s?!s.main&&!s.browser:!1}};e.$Vfc=v,e.$Vfc=v=Je([Ge(3,M.$jj)],v);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,s,a,u,h,t,r){this.c=i,this.d=s,this.f=a,this.g=u,this.h=h,this.j=t,this.k=r,this.a=new m.$1g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const s=this.g[i];if(s.value&&!s.value.activationFailed){this.g.splice(i,1),i--;continue}if(s.value&&s.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${s.friendlyName}' failed to activate`);a.detail=s.value.activationFailedError,this.h=new p(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const s=new Error;if(i&&i.name&&(s.name=i.name),i&&i.message?s.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:s.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(s.stack=i.stack),this.h=new p(s),this.b&&$.$4(i))return;this.j.onExtensionActivationError(this.c,s,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};n=Je([Ge(6,M.$jj)],n)}),define(Re[8],Ae([1,0,18,24,129,219,52,28,120,51,67,26,16,2,29,80,99,104,102,76,48,58,216,7,23]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u,h,t,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$QM=e.$PM=e.MarkdownString=e.$OM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(Ce){function Le(K){const{selectionStartLineNumber:Me,selectionStartColumn:Be,positionLineNumber:Xe,positionColumn:Ke}=K,tt=new r.$QK(Me-1,Be-1),$t=new r.$QK(Xe-1,Ke-1);return new r.$SK(tt,$t)}Ce.to=Le;function ve(K){const{anchor:Me,active:Be}=K;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ce.from=ve})(f||(e.Selection=f={}));var w;(function(Ce){function Le(K){if(!K)return;const{start:Me,end:Be}=K;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ce.from=Le;function ve(K){if(!K)return;const{startLineNumber:Me,startColumn:Be,endLineNumber:Xe,endColumn:Ke}=K;return new r.$RK(Me-1,Be-1,Xe-1,Ke-1)}Ce.to=ve})(w||(e.Range=w={}));var d;(function(Ce){function Le(ve){switch(ve){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ce.to=Le})(d||(e.TokenType=d={}));var D;(function(Ce){function Le(K){return new r.$QK(K.lineNumber-1,K.column-1)}Ce.to=Le;function ve(K){return{lineNumber:K.line+1,column:K.character+1}}Ce.from=ve})(D||(e.Position=D={}));var L;(function(Ce){function Le(Me,Be,Xe){return(0,$.$Hb)((0,$.$3b)(Me).map(Ke=>ve(Ke,Be,Xe)))}Ce.from=Le;function ve(Me,Be,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:K(Me.scheme,Be),pattern:Y.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function K(Me,Be){return Be&&typeof Me=="string"?Be.transformOutgoingScheme(Me):Me}})(L||(e.DocumentSelector=L={}));var y;(function(Ce){function Le(K){switch(K){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ce.from=Le;function ve(K){switch(K){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ce.to=ve})(y||(e.DiagnosticTag=y={}));var E;(function(Ce){function Le(K){let Me;return K.code&&((0,l.$Ef)(K.code)||(0,l.$If)(K.code)?Me=String(K.code):Me={value:String(K.code.value),target:K.code.target}),{...w.from(K.range),message:K.message,source:K.source,code:Me,severity:F.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(k.from),tags:Array.isArray(K.tags)?(0,$.$Hb)(K.tags.map(y.from)):void 0}}Ce.from=Le;function ve(K){const Me=new r.$4K(w.to(K),K.message,F.to(K.severity));return Me.source=K.source,Me.code=(0,l.$Ef)(K.code)?K.code:K.code?.value,Me.relatedInformation=K.relatedInformation&&K.relatedInformation.map(k.to),Me.tags=K.tags&&(0,$.$Hb)(K.tags.map(y.to)),Me}Ce.to=ve})(E||(e.Diagnostic=E={}));var k;(function(Ce){function Le(K){return{...w.from(K.location.range),message:K.message,resource:K.location.uri}}Ce.from=Le;function ve(K){return new r.$3K(new r.$2K(K.resource,w.to(K)),K.message)}Ce.to=ve})(k||(e.DiagnosticRelatedInformation=k={}));var F;(function(Ce){function Le(K){switch(K){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Ce.from=Le;function ve(K){switch(K){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ce.to=ve})(F||(e.DiagnosticSeverity=F={}));var B;(function(Ce){function Le(K){return typeof K=="number"&&K>=r.ViewColumn.One?K-1:K===r.ViewColumn.Beside?t.$XC:t.$WC}Ce.from=Le;function ve(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ve})(B||(e.ViewColumn=B={}));function ee(Ce){return typeof Ce.range<"u"}function J(Ce){return Ce.length===0?!0:!!ee(Ce[0])}e.$OM=J;var V;(function(Ce){function Le(Ke){return Ke.map(Ce.from)}Ce.fromMany=Le;function ve(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function K(Ke){let tt;if(ve(Ke)){const{language:kt,value:Ct}=Ke;tt={value:"```"+kt+`
`+Ct+"\n```\n"}}else r.$eL.isMarkdownString(Ke)?tt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?tt={value:Ke}:tt={value:""};const $t=Object.create(null);tt.uris=$t;const Vt=kt=>{try{let Ct=p.URI.parse(kt,!0);Ct=Ct.with({query:Me(Ct.query,$t)}),$t[kt]=Ct}catch{}return""},Dt=new g.marked.Renderer;return Dt.link=Vt,Dt.image=kt=>typeof kt=="string"?Vt(M.$kk(kt).href):"",(0,g.marked)(tt.value,{renderer:Dt}),tt}Ce.from=K;function Me(Ke,tt){if(!Ke)return Ke;let $t;try{$t=(0,b.$xh)(Ke)}catch{}if(!$t)return Ke;let Vt=!1;return $t=(0,C.$kn)($t,Dt=>{if(p.URI.isUri(Dt)){const kt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[kt]=Dt,Vt=!0,kt}else return}),Vt?JSON.stringify($t):Ke}function Be(Ke){const tt=new r.$eL(Ke.value,Ke.supportThemeIcons);return tt.isTrusted=Ke.isTrusted,tt.supportHtml=Ke.supportHtml,tt.baseUri=Ke.baseUri?p.URI.from(Ke.baseUri):void 0,tt}Ce.to=Be;function Xe(Ke){if(Ke)return typeof Ke=="string"?Ke:Ce.from(Ke)}Ce.fromStrict=Xe})(V||(e.MarkdownString=V={}));function R(Ce){return J(Ce)?Ce.map(Le=>({range:w.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?V.fromMany(Le.hoverMessage):Le.hoverMessage?V.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Ce.map(Le=>({range:w.from(Le)}))}e.$PM=R;function S(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?p.URI.file(Ce):Ce}e.$QM=S;var O;(function(Ce){function Le(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?S(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ce.from=Le})(O||(e.ThemableDecorationAttachmentRenderOptions=O={}));var Q;(function(Ce){function Le(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?S(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?O.from(ve.before):void 0,after:ve.after?O.from(ve.after):void 0}}Ce.from=Le})(Q||(e.ThemableDecorationRenderOptions=Q={}));var re;(function(Ce){function Le(ve){if(typeof ve>"u")return ve;switch(ve){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Le})(re||(e.DecorationRangeBehavior=re={}));var he;(function(Ce){function Le(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?re.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?Q.from(ve.light):void 0,dark:ve.dark?Q.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?S(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?O.from(ve.before):void 0,after:ve.after?O.from(ve.after):void 0}}Ce.from=Le})(he||(e.DecorationRenderOptions=he={}));var fe;(function(Ce){function Le(K){return{text:K.newText,eol:K.newEol&&it.from(K.newEol),range:w.from(K.range)}}Ce.from=Le;function ve(K){const Me=new r.$WK(w.to(K.range),K.text);return Me.newEol=typeof K.eol>"u"?void 0:it.to(K.eol),Me}Ce.to=ve})(fe||(e.TextEdit=fe={}));var ue;(function(Ce){function Le(K,Me){const Be={edits:[]};if(K instanceof r.$ZK){const Xe=new m.$Bc;for(const Ke of K._allEntries())Ke._type===1&&p.URI.isUri(Ke.to)&&Ke.from===void 0&&Xe.add(Ke.to);for(const Ke of K._allEntries())if(Ke._type===1){let tt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?tt={type:"base64",value:(0,P.$Ae)(P.$ge.wrap(Ke.options.contents))}:tt={type:"dataTransferItem",id:Ke.options.contents._itemId}),Be.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:tt},metadata:Ke.metadata})}else Ke._type===2?Be.edits.push({resource:Ke.uri,textEdit:fe.from(Ke.edit),versionId:Xe.has(Ke.uri)?void 0:Me?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Be.edits.push({resource:Ke.uri,textEdit:{range:w.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ke.uri)?void 0:Me?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Pt.from)}})}return Be}Ce.from=Le;function ve(K){const Me=new r.$ZK,Be=new m.$Ac;for(const Xe of K.edits)if(Xe.textEdit){const Ke=Xe,tt=p.URI.revive(Ke.resource),$t=w.to(Ke.textEdit.range),Vt=Ke.textEdit.text,Dt=Ke.textEdit.insertAsSnippet;let kt;Dt?kt=r.$YK.replace($t,new r.$1K(Vt)):kt=r.$WK.replace($t,Vt);const Ct=Be.get(tt);Ct?Ct.push(kt):Be.set(tt,[kt])}else Me.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ke]of Be)Me.set(Xe,Ke);return Me}Ce.to=ve})(ue||(e.WorkspaceEdit=ue={}));var $e;(function(Ce){const Le=Object.create(null);Le[r.SymbolKind.File]=0,Le[r.SymbolKind.Module]=1,Le[r.SymbolKind.Namespace]=2,Le[r.SymbolKind.Package]=3,Le[r.SymbolKind.Class]=4,Le[r.SymbolKind.Method]=5,Le[r.SymbolKind.Property]=6,Le[r.SymbolKind.Field]=7,Le[r.SymbolKind.Constructor]=8,Le[r.SymbolKind.Enum]=9,Le[r.SymbolKind.Interface]=10,Le[r.SymbolKind.Function]=11,Le[r.SymbolKind.Variable]=12,Le[r.SymbolKind.Constant]=13,Le[r.SymbolKind.String]=14,Le[r.SymbolKind.Number]=15,Le[r.SymbolKind.Boolean]=16,Le[r.SymbolKind.Array]=17,Le[r.SymbolKind.Object]=18,Le[r.SymbolKind.Key]=19,Le[r.SymbolKind.Null]=20,Le[r.SymbolKind.EnumMember]=21,Le[r.SymbolKind.Struct]=22,Le[r.SymbolKind.Event]=23,Le[r.SymbolKind.Operator]=24,Le[r.SymbolKind.TypeParameter]=25;function ve(Me){return typeof Le[Me]=="number"?Le[Me]:6}Ce.from=ve;function K(Me){for(const Be in Le)if(Le[Be]===Me)return Number(Be);return r.SymbolKind.Property}Ce.to=K})($e||(e.SymbolKind=$e={}));var ne;(function(Ce){function Le(K){switch(K){case r.SymbolTag.Deprecated:return 1}}Ce.from=Le;function ve(K){switch(K){case 1:return r.SymbolTag.Deprecated}}Ce.to=ve})(ne||(e.SymbolTag=ne={}));var Pe;(function(Ce){function Le(K){return{name:K.name,kind:$e.from(K.kind),tags:K.tags&&K.tags.map(ne.from),containerName:K.containerName,location:de.from(K.location)}}Ce.from=Le;function ve(K){const Me=new r.$8K(K.name,$e.to(K.kind),K.containerName,de.to(K.location));return Me.tags=K.tags&&K.tags.map(ne.to),Me}Ce.to=ve})(Pe||(e.WorkspaceSymbol=Pe={}));var le;(function(Ce){function Le(K){const Me={name:K.name||"!!MISSING: name!!",detail:K.detail,range:w.from(K.range),selectionRange:w.from(K.selectionRange),kind:$e.from(K.kind),tags:K.tags?.map(ne.from)??[]};return K.children&&(Me.children=K.children.map(Le)),Me}Ce.from=Le;function ve(K){const Me=new r.$9K(K.name,K.detail,$e.to(K.kind),w.to(K.range),w.to(K.selectionRange));return(0,$.$Lb)(K.tags)&&(Me.tags=K.tags.map(ne.to)),K.children&&(Me.children=K.children.map(ve)),Me}Ce.to=ve})(le||(e.DocumentSymbol=le={}));var me;(function(Ce){function Le(K){const Me=new r.$aL($e.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return Me._sessionId=K._sessionId,Me._itemId=K._itemId,Me}Ce.to=Le;function ve(K,Me,Be){if(Me=Me??K._sessionId,Be=Be??K._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,name:K.name,detail:K.detail,kind:$e.from(K.kind),uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(ne.from)}}Ce.from=ve})(me||(e.CallHierarchyItem=me={}));var W;(function(Ce){function Le(ve){return new r.$bL(me.to(ve.from),ve.fromRanges.map(K=>w.to(K)))}Ce.to=Le})(W||(e.CallHierarchyIncomingCall=W={}));var ae;(function(Ce){function Le(ve){return new r.$cL(me.to(ve.to),ve.fromRanges.map(K=>w.to(K)))}Ce.to=Le})(ae||(e.CallHierarchyOutgoingCall=ae={}));var de;(function(Ce){function Le(K){return{range:K.range&&w.from(K.range),uri:K.uri}}Ce.from=Le;function ve(K){return new r.$2K(p.URI.revive(K.uri),w.to(K.range))}Ce.to=ve})(de||(e.location=de={}));var ke;(function(Ce){function Le(K){const Me=K,Be=K;return{originSelectionRange:Me.originSelectionRange?w.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Be.uri,range:w.from(Me.targetRange?Me.targetRange:Be.range),targetSelectionRange:Me.targetSelectionRange?w.from(Me.targetSelectionRange):void 0}}Ce.from=Le;function ve(K){return{targetUri:p.URI.revive(K.uri),targetRange:w.to(K.range),targetSelectionRange:K.targetSelectionRange?w.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?w.to(K.originSelectionRange):void 0}}Ce.to=ve})(ke||(e.DefinitionLink=ke={}));var Ee;(function(Ce){function Le(K){return{range:w.from(K.range),contents:V.fromMany(K.contents)}}Ce.from=Le;function ve(K){return new r.$5K(K.contents.map(V.to),w.to(K.range))}Ce.to=ve})(Ee||(e.Hover=Ee={}));var ce;(function(Ce){function Le(K){return{range:w.from(K.range),expression:K.expression}}Ce.from=Le;function ve(K){return new r.$YL(w.to(K.range),K.expression)}Ce.to=ve})(ce||(e.EvaluatableExpression=ce={}));var _;(function(Ce){function Le(K){if(K instanceof r.$ZL)return{type:"text",range:w.from(K.range),text:K.text};if(K instanceof r.$1L)return{type:"variable",range:w.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof r.$2L)return{type:"expression",range:w.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Le;function ve(K){switch(K.type){case"text":return{range:w.to(K.range),text:K.text};case"variable":return{range:w.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:w.to(K.range),expression:K.expression}}}Ce.to=ve})(_||(e.InlineValue=_={}));var H;(function(Ce){function Le(K){return{frameId:K.frameId,stoppedLocation:w.from(K.stoppedLocation)}}Ce.from=Le;function ve(K){return new r.$3L(K.frameId,w.to(K.stoppedLocation))}Ce.to=ve})(H||(e.InlineValueContext=H={}));var te;(function(Ce){function Le(K){return{range:w.from(K.range),kind:K.kind}}Ce.from=Le;function ve(K){return new r.$6K(w.to(K.range),K.kind)}Ce.to=ve})(te||(e.DocumentHighlight=te={}));var we;(function(Ce){function Le(K){return{uri:K.uri,highlights:K.highlights.map(te.from)}}Ce.from=Le;function ve(K){return new r.$7K(p.URI.revive(K.uri),K.highlights.map(te.to))}Ce.to=ve})(we||(e.MultiDocumentHighlight=we={}));var be;(function(Ce){function Le(ve){switch(ve){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ce.to=Le})(be||(e.CompletionTriggerKind=be={}));var Fe;(function(Ce){function Le(ve){return{triggerKind:be.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ce.to=Le})(Fe||(e.CompletionContext=Fe={}));var pe;(function(Ce){function Le(K){switch(K){case r.CompletionItemTag.Deprecated:return 1}}Ce.from=Le;function ve(K){switch(K){case 1:return r.CompletionItemTag.Deprecated}}Ce.to=ve})(pe||(e.CompletionItemTag=pe={}));var Se;(function(Ce){const Le=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function ve(Be){return Le.get(Be)??9}Ce.from=ve;const K=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(Be){return K.get(Be)??r.CompletionItemKind.Property}Ce.to=Me})(Se||(e.CompletionItemKind=Se={}));var N;(function(Ce){function Le(ve,K){const Me=new r.$kL(ve.label);return Me.insertText=ve.insertText,Me.kind=Se.to(ve.kind),Me.tags=ve.tags?.map(pe.to),Me.detail=ve.detail,Me.documentation=M.$fk(ve.documentation)?V.to(ve.documentation):ve.documentation,Me.sortText=ve.sortText,Me.filterText=ve.filterText,Me.preselect=ve.preselect,Me.commitCharacters=ve.commitCharacters,v.$Hs.isIRange(ve.range)?Me.range=w.to(ve.range):typeof ve.range=="object"&&(Me.range={inserting:w.to(ve.range.insert),replacing:w.to(ve.range.replace)}),Me.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Me.insertText=new r.$1K(ve.insertText):(Me.insertText=ve.insertText,Me.textEdit=Me.range instanceof r.$RK?new r.$WK(Me.range,Me.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Me.additionalTextEdits=ve.additionalTextEdits.map(Be=>fe.to(Be))),Me.command=K&&ve.command?K.fromInternal(ve.command):void 0,Me}Ce.to=Le})(N||(e.CompletionItem=N={}));var q;(function(Ce){function Le(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:V.fromStrict(K.documentation)}}Ce.from=Le;function ve(K){return{label:K.label,documentation:M.$fk(K.documentation)?V.to(K.documentation):K.documentation}}Ce.to=ve})(q||(e.ParameterInformation=q={}));var G;(function(Ce){function Le(K){return{label:K.label,documentation:V.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(q.from):[],activeParameter:K.activeParameter}}Ce.from=Le;function ve(K){return{label:K.label,documentation:M.$fk(K.documentation)?V.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(q.to):[],activeParameter:K.activeParameter}}Ce.to=ve})(G||(e.SignatureInformation=G={}));var z;(function(Ce){function Le(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.from):[]}}Ce.from=Le;function ve(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.to):[]}}Ce.to=ve})(z||(e.SignatureHelp=z={}));var Z;(function(Ce){function Le(ve,K){const Me=new r.$jL(D.to(K.position),typeof K.label=="string"?K.label:K.label.map(X.to.bind(void 0,ve)),K.kind&&De.to(K.kind));return Me.textEdits=K.textEdits&&K.textEdits.map(fe.to),Me.tooltip=M.$fk(K.tooltip)?V.to(K.tooltip):K.tooltip,Me.paddingLeft=K.paddingLeft,Me.paddingRight=K.paddingRight,Me}Ce.to=Le})(Z||(e.InlayHint=Z={}));var X;(function(Ce){function Le(ve,K){const Me=new r.$iL(K.label);return Me.tooltip=M.$fk(K.tooltip)?V.to(K.tooltip):K.tooltip,n.Command.is(K.command)&&(Me.command=ve.fromInternal(K.command)),K.location&&(Me.location=de.to(K.location)),Me}Ce.to=Le})(X||(e.InlayHintLabelPart=X={}));var De;(function(Ce){function Le(K){return K}Ce.from=Le;function ve(K){return K}Ce.to=ve})(De||(e.InlayHintKind=De={}));var Te;(function(Ce){function Le(K){return{range:w.from(K.range),url:K.target,tooltip:K.tooltip}}Ce.from=Le;function ve(K){let Me;if(K.url)try{Me=typeof K.url=="string"?p.URI.parse(K.url,!0):p.URI.revive(K.url)}catch{}return new r.$pL(w.to(K.range),Me)}Ce.to=ve})(Te||(e.DocumentLink=Te={}));var qe;(function(Ce){function Le(K){const Me=new r.$sL(K.label);return K.textEdit&&(Me.textEdit=fe.to(K.textEdit)),K.additionalTextEdits&&(Me.additionalTextEdits=K.additionalTextEdits.map(Be=>fe.to(Be))),Me}Ce.to=Le;function ve(K){return{label:K.label,textEdit:K.textEdit?fe.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Me=>fe.from(Me)):void 0}}Ce.from=ve})(qe||(e.ColorPresentation=qe={}));var We;(function(Ce){function Le(K){return new r.$qL(K[0],K[1],K[2],K[3])}Ce.to=Le;function ve(K){return[K.red,K.green,K.blue,K.alpha]}Ce.from=ve})(We||(e.Color=We={}));var Ye;(function(Ce){function Le(K){return{range:w.from(K.range)}}Ce.from=Le;function ve(K){return new r.$_K(w.to(K.range))}Ce.to=ve})(Ye||(e.SelectionRange=Ye={}));var ot;(function(Ce){function Le(ve){switch(ve){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ce.to=Le})(ot||(e.TextDocumentSaveReason=ot={}));var rt;(function(Ce){function Le(K){switch(K){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Le;function ve(K){switch(K){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ce.to=ve})(rt||(e.TextEditorLineNumbersStyle=rt={}));var it;(function(Ce){function Le(K){if(K===r.EndOfLine.CRLF)return 1;if(K===r.EndOfLine.LF)return 0}Ce.from=Le;function ve(K){if(K===1)return r.EndOfLine.CRLF;if(K===0)return r.EndOfLine.LF}Ce.to=ve})(it||(e.EndOfLine=it={}));var ct;(function(Ce){function Le(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Le})(ct||(e.ProgressLocation=ct={}));var ut;(function(Ce){function Le(K){const Me={start:K.start+1,end:K.end+1};return K.kind&&(Me.kind=Ue.from(K.kind)),Me}Ce.from=Le;function ve(K){const Me={start:K.start-1,end:K.end-1};return K.kind&&(Me.kind=Ue.to(K.kind)),Me}Ce.to=ve})(ut||(e.FoldingRange=ut={}));var Ue;(function(Ce){function Le(K){if(K)switch(K){case r.FoldingRangeKind.Comment:return n.$xt.Comment;case r.FoldingRangeKind.Imports:return n.$xt.Imports;case r.FoldingRangeKind.Region:return n.$xt.Region}}Ce.from=Le;function ve(K){if(K)switch(K.value){case n.$xt.Comment.value:return r.FoldingRangeKind.Comment;case n.$xt.Imports.value:return r.FoldingRangeKind.Imports;case n.$xt.Region.value:return r.FoldingRangeKind.Region}}Ce.to=ve})(Ue||(e.FoldingRangeKind=Ue={}));var vt;(function(Ce){function Le(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?w.from(ve.selection):void 0,override:typeof ve.override=="boolean"?s.$mE.id:void 0}}Ce.from=Le})(vt||(e.TextEditorOpenOptions=vt={}));var Y;(function(Ce){function Le(Be){return Be instanceof r.$ML?Be.toJSON():typeof Be=="string"?Be:ve(Be)||K(Be)?new r.$ML(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ce.from=Le;function ve(Be){const Xe=Be;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function K(Be){const Xe=Be;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(Be){return typeof Be=="string"?Be:new r.$ML(p.URI.revive(Be.baseUri),Be.pattern)}Ce.to=Me})(Y||(e.GlobPattern=Y={}));var x;(function(Ce){function Le(ve){if(ve){if(Array.isArray(ve))return ve.map(Le);if(typeof ve=="string")return ve;{const K=ve;return{language:K.language,scheme:K.scheme,pattern:Y.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ce.from=Le})(x||(e.LanguageSelector=x={}));var ye;(function(Ce){function Le(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Me=>Array.isArray(Me)&&Me.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&p.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Xe=>Xe instanceof r.$RK)))}Ce.is=Le;function ve(K){return{documents:K.documents.map(Me=>Me.map(Be=>({uri:p.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Xe=>w.from(Xe))})))}}Ce.from=ve})(ye||(e.MappedEditsContext=ye={}));var Ve;(function(Ce){function Le(K){return{start:K.start,end:K.end}}Ce.from=Le;function ve(K){return new r.$bM(K.start,K.end)}Ce.to=ve})(Ve||(e.NotebookRange=Ve={}));var Ze;(function(Ce){function Le(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ce.to=Le;function ve(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ce.from=ve})(Ze||(e.NotebookCellExecutionSummary=Ze={}));var nt;(function(Ce){function Le(ve){if(ve===a.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(ve===a.NotebookCellExecutionState.Pending)return;if(ve===a.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ce.to=Le})(nt||(e.NotebookCellExecutionState=nt={}));var st;(function(Ce){function Le(K){switch(K){case r.NotebookCellKind.Markup:return a.CellKind.Markup;case r.NotebookCellKind.Code:default:return a.CellKind.Code}}Ce.from=Le;function ve(K){switch(K){case a.CellKind.Markup:return r.NotebookCellKind.Markup;case a.CellKind.Code:default:return r.NotebookCellKind.Code}}Ce.to=ve})(st||(e.NotebookCellKind=st={}));var Ne;(function(Ce){function Le(K){const Me={metadata:K.metadata??Object.create(null),cells:[]};for(const Be of K.cells)r.$cM.validate(Be),Me.cells.push(Pt.from(Be));return Me}Ce.from=Le;function ve(K){const Me=new r.$dM(K.cells.map(Pt.to));return(0,l.$Rf)(K.metadata)||(Me.metadata=K.metadata),Me}Ce.to=ve})(Ne||(e.NotebookData=Ne={}));var Pt;(function(Ce){function Le(K){return{cellKind:st.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ze.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Kt.from):[]}}Ce.from=Le;function ve(K){return new r.$cM(st.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Kt.to):void 0,K.metadata,K.internalMetadata?Ze.to(K.internalMetadata):void 0)}Ce.to=ve})(Pt||(e.NotebookCellData=Pt={}));var Mt;(function(Ce){function Le(K){return{mime:K.mime,valueBytes:P.$ge.wrap(K.data)}}Ce.from=Le;function ve(K){return new r.$eM(K.valueBytes.buffer,K.mime)}Ce.to=ve})(Mt||(e.NotebookCellOutputItem=Mt={}));var Kt;(function(Ce){function Le(K){return{outputId:K.id,items:K.items.map(Mt.from),metadata:K.metadata}}Ce.from=Le;function ve(K){const Me=K.items.map(Mt.to);return new r.$fM(Me,K.outputId,K.metadata)}Ce.to=ve})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ce){function Le(Me){return K(Me)?{include:Y.from(Me.include)??void 0,exclude:Y.from(Me.exclude)??void 0}:Y.from(Me)??void 0}Ce.from=Le;function ve(Me){return K(Me)?{include:Y.to(Me.include),exclude:Y.to(Me.exclude)}:Y.to(Me)}Ce.to=ve;function K(Me){const Be=Me;return Be?!(0,l.$Nf)(Be.include)&&!(0,l.$Nf)(Be.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var yt;(function(Ce){function Le(ve,K,Me){const Be=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Be,Me),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ce.from=Le})(yt||(e.NotebookStatusBarItem=yt={}));var Gt;(function(Ce){function Le(ve,K,Me){const Be=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:K.toInternal(Be,Me),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ce.from=Le})(Gt||(e.NotebookKernelSourceAction=Gt={}));var Ut;(function(Ce){function Le(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ce.from=Le})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var ni;(function(Ce){function Le(K){return{uri:K.uri,provides:K.provides}}Ce.from=Le;function ve(K){return new r.$hM(p.URI.revive(K.uri),K.provides)}Ce.to=ve})(ni||(e.NotebookRendererScript=ni={}));var Jt;(function(Ce){function Le(K){return{message:V.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:w.from(K.location.range),uri:K.location.uri}}}Ce.from=Le;function ve(K){const Me=new r.$nM(typeof K.message=="string"?K.message:V.to(K.message));return Me.actualOutput=K.actual,Me.expectedOutput=K.expected,Me.contextValue=K.contextValue,Me.location=K.location?de.to(K.location):void 0,Me}Ce.to=ve})(Jt||(e.TestMessage=Jt={}));var Ft;(function(Ce){Ce.namespace=h.$JJ,Ce.denamespace=h.$KJ})(Ft||(e.TestTag=Ft={}));var _e;(function(Ce){function Le(K){const Me=(0,i.$NM)(K).controllerId;return{extId:u.$FJ.fromExtHostTestItem(K,Me).toString(),label:K.label,uri:p.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Be=>Ft.namespace(Me,Be.id)),range:v.$Hs.lift(w.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&V.fromStrict(K.error)||null}}Ce.from=Le;function ve(K){return{parent:void 0,error:void 0,id:u.$FJ.fromString(K.extId).localId,label:K.label,uri:p.URI.revive(K.uri),tags:(K.tags||[]).map(Me=>{const{tagId:Be}=Ft.denamespace(Me);return new r.$oM(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:w.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ce.toPlain=ve})(_e||(e.TestItem=_e={})),function(Ce){function Le(K){return{id:K.id}}Ce.from=Le;function ve(K){return new r.$oM(K.id)}Ce.to=ve}(Ft||(e.TestTag=Ft={}));var Bt;(function(Ce){const Le=(K,Me)=>{const Be=[];for(const[Ke,tt]of Me)u.$FJ.compare(tt.item.extId,Ke)===2&&(Me.delete(Ke),Be.push(tt));const Xe={..._e.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(tt=>tt.type===0).map(Jt.to)})),children:Be.map(Ke=>Le(Ke,Me))};for(const Ke of Xe.children)Ke.parent=Xe;return Xe};function ve(K){const Me=[],Be=new Map;for(const Xe of K.items){Be.set(Xe.item.extId,Xe);const Ke=u.$FJ.root(Xe.item.extId);K.request.targets.some(tt=>tt.controllerId===Ke&&tt.testIds.includes(Xe.item.extId))&&Me.push(Xe)}return{completedAt:K.completedAt,results:Me.map(Xe=>Le(Xe,Be))}}Ce.to=ve})(Bt||(e.TestResults=Bt={}));var Zt;(function(Ce){function Le(Be){return{covered:Be.covered,total:Be.total}}function ve(Be){return"line"in Be?D.from(Be):w.from(Be)}function K(Be){return"branches"in Be?{count:Be.executionCount,location:ve(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&ve(Xe.location)})):void 0}:{type:0,name:Be.name,count:Be.executionCount,location:ve(Be.location)}}Ce.fromDetailed=K;function Me(Be){return{uri:Be.uri,statement:Le(Be.statementCoverage),branch:Be.branchCoverage&&Le(Be.branchCoverage),function:Be.functionCoverage&&Le(Be.functionCoverage),details:Be.detailedCoverage?.map(K)}}Ce.fromFile=Me})(Zt||(e.TestCoverage=Zt={}));var ht;(function(Ce){function Le(ve){switch(ve){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ce.to=Le})(ht||(e.CodeActionTriggerKind=ht={}));var mt;(function(Ce){function Le(K){const Me=new r.$uM($e.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return Me._sessionId=K._sessionId,Me._itemId=K._itemId,Me}Ce.to=Le;function ve(K,Me,Be){if(Me=Me??K._sessionId,Be=Be??K._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,kind:$e.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(ne.from)}}Ce.from=ve})(mt||(e.TypeHierarchyItem=mt={}));var Tt;(function(Ce){function Le(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ce.from=Le})(Tt||(e.ViewBadge=Tt={}));var Nt;(function(Ce){function Le(Be,Xe,Ke){const tt=Xe.fileData;return tt?new r.$FL(new r.$GL(tt.name,p.URI.revive(tt.uri),tt.id,(0,T.$db)(()=>Ke(tt.id)))):Be===A.$4r.uriList&&Xe.uriListData?new r.$EL(Me(Xe.uriListData)):new r.$EL(Xe.asString)}Ce.to=Le;async function ve(Be,Xe){const Ke=await Xe.asString();if(Be===A.$4r.uriList)return{asString:Ke,fileData:void 0,uriListData:K(Ke)};const tt=Xe.asFile();return{asString:Ke,fileData:tt?{name:tt.name,uri:tt.uri,id:tt._itemId??tt.id}:void 0}}Ce.from=ve;function K(Be){return I.$et.split(Be).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function Me(Be){return I.$et.create(Be.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})(Nt||(e.DataTransferItem=Nt={}));var Et;(function(Ce){function Le(K,Me){const Be=K.items.map(([Xe,Ke])=>[Xe,Nt.to(Xe,Ke,Me)]);return new r.$HL(Be)}Ce.toDataTransfer=Le;async function ve(K){const Me={items:[]},Be=[];for(const[Xe,Ke]of K)Be.push((async()=>{Me.items.push([Xe,await Nt.from(Xe,Ke)])})());return await Promise.all(Be),Me}Ce.from=ve})(Et||(e.DataTransfer=Et={}));var dt;(function(Ce){function Le(ve){return{kind:"reply",message:ve.message,title:ve.title,tooltip:ve.tooltip}}Ce.from=Le})(dt||(e.ChatReplyFollowup=dt={}));var Rt;(function(Ce){function Le(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",when:ve.when??"",args:ve.args}:dt.from(ve)}Ce.from=Le})(Rt||(e.ChatFollowup=Rt={}));var xt;(function(Ce){function Le(K){const Me=new r.$GM(It.to(K.role),K.content);return Me.name=K.name,Me}Ce.to=Le;function ve(K){return{role:It.from(K.role),content:K.content,name:K.name}}Ce.from=ve})(xt||(e.ChatMessage=xt={}));var It;(function(Ce){function Le(K){switch(K){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ce.to=Le;function ve(K){switch(K){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ce.from=ve})(It||(e.ChatMessageRole=It={}));var He;(function(Ce){function Le(Me){const Be={};for(const Xe of Object.keys(Me))Be[Xe]=Me[Xe].map(Ce.to);return Be}Ce.objectTo=Le;function ve(Me){return{level:Wt.to(Me.level),kind:Me.kind,value:(0,b.$yh)(Me.value),description:Me.description}}Ce.to=ve;function K(Me){return{level:Wt.from(Me.level),kind:Me.kind,value:Me.value,description:Me.description}}Ce.from=K})(He||(e.ChatVariable=He={}));var Wt;(function(Ce){function Le(K){switch(K){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ce.to=Le;function ve(K){switch(K){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ce.from=ve})(Wt||(e.ChatVariableLevel=Wt={}));var Yt;(function(Ce){function Le(ve){switch(ve){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Ce.to=Le})(Yt||(e.InteractiveEditorResponseFeedbackKind=Yt={}));var Xt;(function(Ce){function Le(ve,K){return"placeholder"in K&&"resolvedContent"in K?{content:K.placeholder,kind:"asyncContent"}:"markdownContent"in K?((0,c.$lF)(ve,"chatAgents2Additions"),{content:V.from(K.markdownContent),kind:"markdownContent"}):"content"in K?"vulnerabilities"in K&&K.vulnerabilities?((0,c.$lF)(ve,"chatAgents2Additions"),{content:K.content,vulnerabilities:K.vulnerabilities,kind:"vulnerability"}):typeof K.content=="string"?{content:K.content,kind:"content"}:((0,c.$lF)(ve,"chatAgents2Additions"),{content:V.from(K.content),kind:"markdownContent"}):"documents"in K?{documents:K.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(Be=>w.from(Be))})),kind:"usedContext"}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:w.from(K.reference.range)}:K.reference,kind:"reference"}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:w.from(K.inlineReference.range)}:K.inlineReference,name:K.title,kind:"inlineReference"}:"agentName"in K?((0,c.$lF)(ve,"chatAgents2Additions"),{agentName:K.agentName,command:K.command,kind:"agentDetection"}):"treeData"in K?{treeData:K.treeData,kind:"treeData"}:"message"in K?{content:K.message,kind:"progressMessage"}:void 0}Ce.from=Le})(Xt||(e.ChatResponseProgress=Xt={}));var pt;(function(Ce){function Le(ve){return{label:ve.label,values:ve.values.map(He.from),insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation}}Ce.from=Le})(pt||(e.ChatAgentCompletionItem=pt={}));var Ot;(function(Ce){function Le(ve,K,Me){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:K.toInternal(ve,Me)}Ce.from=Le})(Ot||(e.TerminalQuickFix=Ot={}))}),define(Re[220],Ae([1,0,2,11,7,8,186]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class m{constructor(b,A,C,l={timeout:1500,errors:3}){this.c=b,this.d=A,this.f=C,this.g=l,this.a=new M.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(A,C,l)=>{const v={dispose:this.a.push([A,C,b])};return Array.isArray(l)&&l.push(v),v}}async $participateInSave(b,A){const C=$.URI.revive(b);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),v=[];try{for(const n of[...this.a]){if(l)break;const o=this.d.getDocument(C),i=await this.h(n,{document:o,reason:T.TextDocumentSaveReason.to(A)});v.push(i)}}finally{clearTimeout(p)}return v}h([b,A,C],l){const p=this.b.get(b);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(C,b,A,l).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const n=this.b.get(b);this.b.set(b,n?n+1:1),typeof n=="number"&&n>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,A,C,l){const p=[],v=Date.now(),{document:n,reason:o}=l,{version:i}=n,s=Object.freeze({document:n,reason:o,waitUntil(a){if(Object.isFrozen(p))throw(0,P.$8)("waitUntil can not be called async");p.push(Promise.resolve(a))}});try{A.apply(C,[s])}catch(a){return Promise.reject(a)}return Object.freeze(p),new Promise((a,u)=>{const h=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(p).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(h),a(t)}).catch(t=>{clearTimeout(h),u(t)})}).then(a=>{const u={edits:[]};for(const h of a)if(Array.isArray(h)&&h.every(t=>t instanceof I.$WK))for(const{newText:t,newEol:r,range:c}of h)u.edits.push({resource:n.uri,versionId:void 0,textEdit:{range:c&&T.Range.from(c),text:t,eol:r&&T.EndOfLine.from(r)}});if(u.edits.length!==0)return i===n.version?this.f.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.$pgc=m}),define(Re[221],Ae([1,0,13,2,8,7,76]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0;class m{constructor(C,l,p,v){this.start=C,this.deletedCount=l,this.deletedItems=p,this.items=v}asApiEvent(){return{range:new T.$bM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(C,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,l,p){this.notebook=C,this.h=l,this.j=p,this.handle=p.handle,this.uri=P.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(I.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return C.g},set mime(v){C.g=v},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(p)}return this.f}setOutputs(C){this.a=C.map(I.NotebookCellOutput.to)}setOutputItems(C,l,p){const v=p.map(I.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===C);if(n&&(l||(n.items.length=0),n.items.push(...v),n.items.length>1&&n.items.every(o=>M.$RI(o.mime)))){const o=new Map,i=[];n.items.forEach(s=>{let a;o.has(s.mime)?a=o.get(s.mime):(a=[],o.set(s.mime,a),i.push(s.mime)),a.push(s.data)}),n.items.length=0,i.forEach(s=>{const a=M.$SI(o.get(s));n.items.push({mime:s,data:a.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$ugc=g;class b{constructor(C,l,p,v,n){this.k=C,this.l=l,this.m=p,this.uri=v,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,l={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===$.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(p){return p=C.n(p),C.b[p].apiCell},getCells(p){return(p?C.p(p):C.b).map(n=>n.apiCell)},save(){return C.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,l,p){this.g=C.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const v={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},n=[];for(const i of C.rawEvents)i.kind===M.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,v.contentChanges):i.kind===M.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,v.contentChanges):i.kind===M.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),n.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===M.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),n.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),n.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===M.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),n.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),n.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const o=new Map;for(let i=0;i<n.length;i++){const s=n[i],a=o.get(s.cell);if(a===void 0){const u=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...s});o.set(s.cell,u-1)}else v.cellChanges[a]={...v.cellChanges[a],...s}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let l=C.start|0,p=C.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),C.with({start:l,end:p})}p(C){C=this.o(C);const l=[];for(let p=C.start;p<C.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,l,p){if(this.j)return;const v=[],n=[],o=[];if(C.reverse().forEach(i=>{const a=i[2].map(t=>{const r=new g(this,this.l,t);return l||n.push(g.asModelAddData(this.apiNotebook,t)),r}),u=new m(i[0],i[1],[],a),h=this.b.splice(i[0],i[1],...a);for(const t of h)o.push(t.uri),u.deletedItems.push(t.apiCell);v.push(u)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),p)for(const i of v)p.push(i.asApiEvent())}s(C,l,p,v){const n=this.b.splice(C,l);this.b.splice(p,0,...n);const o=[new m(C,l,n.map(i=>i.apiCell),[]),new m(p,0,[],n)];for(const i of o)v.push(i.asApiEvent())}t(C,l){this.b[C].setOutputs(l)}u(C,l,p,v){this.b[C].setOutputItems(l,p,v)}v(C,l){const p=this.b[C];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(C,l){const p=this.b[C];p.apiCell.mime=l}x(C,l){this.b[C].setMetadata(l)}y(C,l){this.b[C].setInternalMetadata(l)}getCellFromApiCell(C){return this.b.find(l=>l.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(l=>l.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$vgc=b,b.a=0}),define(Re[222],Ae([1,0,5,2,8,7]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class M{constructor(g,b,A,C={timeout:1500,errors:3}){this.b=g,this.c=b,this.d=A,this.f=C,this.a=new $.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(b,A,C)=>{const l=function(v){b.call(A,v)};return l.extension=g,this.a.event(l,void 0,C)}}async $participateInSave(g,b,A){const C=P.URI.revive(g),l=this.c.getNotebookDocument(C);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(b)},A,async(n,o)=>{const i=Date.now(),s=await await Promise.resolve(n);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!A.isCancellationRequested&&s&&(s instanceof T.$ZK?p.push(s):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const v={edits:[]};for(const n of p){const{edits:o}=I.WorkspaceEdit.from(n);v.edits=v.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$Lgc=M}),define(Re[107],Ae([1,0,11,8,7]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class T{constructor(m,g,b,A,C,l){this.id=m,this.f=g,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=A,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(g){this.selections=[g]},get selections(){return m.a},set selections(g){if(!Array.isArray(g)||!g.every(I.$bM.isNotebookRange))throw(0,$.$7)("selections");m.a=g,m.g(g)},get visibleRanges(){return m.b},revealRange(g,b){m.f.$tryRevealRange(m.id,P.NotebookRange.from(g),b??I.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(P.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$wgc=T,T.apiEditorsToExtHost=new WeakMap}),define(Re[223],Ae([1,0,11,5,15,8]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;let M=class{constructor(g,b){this.c=g,this.d=b,this.a=new P.$Sd({onListenerError:$.$2}),this.b=new P.$Sd({onListenerError:$.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,b);const A=this.d.getEditorById(g);b.visibleRanges&&A._acceptVisibleRanges(b.visibleRanges.ranges.map(T.NotebookRange.to)),b.selections&&A._acceptSelections(b.selections.selections.map(T.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const b in g)this.d.getEditorById(b)._acceptViewColumn(T.ViewColumn.to(g[b]))}};e.$Ngc=M,e.$Ngc=M=Je([Ge(0,I.$jj)],M)}),define(Re[224],Ae([1,0,8,72,163,20,66,11]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class g{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,p,v){const n=this.b++,{title:o,location:i,cancellable:s}=p,a={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(n,{location:$.ProgressLocation.from(i),title:o,source:a,cancellable:s},l.isUnderDevelopment?void 0:l.identifier.value).catch(m.$2),this.d(n,v,!!s)}d(l,p,v){let n;v&&(n=new T.$3d,this.c.set(l,n));const o=s=>{this.a.$progressEnd(s),this.c.delete(s),n?.dispose()};let i;try{i=p(new A(this.a,l),v&&n?n.token:T.CancellationToken.None)}catch(s){throw o(l),s}return i.then(s=>o(l),s=>o(l)),i}$acceptProgressCanceled(l){const p=this.c.get(l);p&&(p.cancel(),this.c.delete(l))}}e.$Ugc=g;function b(C,l){return C.message=l.message,typeof l.increment=="number"&&(typeof C.increment=="number"?C.increment+=l.increment:C.increment=l.increment),C}class A extends P.$hv{constructor(l,p){super(v=>this.throttledReport(v)),this.c=l,this.d=p}throttledReport(l){this.c.$progressReport(this.d,l)}}Je([(0,M.$vh)(100,(C,l)=>b(C,l),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Re[108],Ae([1,0,29,104,48,77,58,8,2]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=e.$5M=e.$4M=void 0;const b=(a,u,h,t)=>{let r=u;return{enumerable:!0,configurable:!1,get(){return r},set(c){if(!h(r,c)){const f=r;r=c,a.listener?.(t(c,f))}}}},A=(a,u)=>a===u,C={range:(a,u)=>a===u?!0:!a||!u?!1:a.isEqual(u),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(a,u)=>!(a.length!==u.length||a.some(h=>!u.find(t=>h.id===t.id)))},l=a=>u=>({op:4,update:a(u)}),p=(a,u)=>({range:(()=>{let h;const t=l(r=>({range:$.$Hs.lift(m.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return h},set(r){a.listener?.({op:6}),C.range(h,r)||(h=r,a.listener?.(t(r)))}}})(),label:b(a,u,C.label,l(h=>({label:h}))),description:b(a,void 0,C.description,l(h=>({description:h}))),sortText:b(a,void 0,C.sortText,l(h=>({sortText:h}))),canResolveChildren:b(a,!1,C.canResolveChildren,h=>({op:2,state:h})),busy:b(a,!1,C.busy,l(h=>({busy:h}))),error:b(a,void 0,C.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:b(a,[],C.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),v=a=>{const u=I.$FJ.fromString(a.extId),h=new o(u.controllerId,u.localId,a.label,g.URI.revive(a.uri)||void 0);return h.range=m.Range.to(a.range||void 0),h.description=a.description||void 0,h.sortText=a.sortText||void 0,h.tags=a.tags.map(t=>m.TestTag.to({id:(0,M.$KJ)(t).tagId})),h},n=a=>{let u;for(const h of a.tests){const t=v(h.item);(0,P.$NM)(t).parent=u,u=t}return u};e.$4M=n;class o{constructor(u,h,t,r){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,P.$MM)(this,u);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof i?void 0:c.parent}},children:{value:(0,T.$LM)(c,P.$NM,o),enumerable:!0,writable:!1},...p(c,t)})}}e.$5M=o;class i extends o{constructor(u,h){super(u,u,h,void 0),this._isRoot=!0}}e.$6M=i;class s extends T.$HM{constructor(u,h,t){super({controllerId:u,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:P.$NM,getChildren:r=>r.children,root:new i(u,h),toITestItem:m.TestItem.from})}}e.$7M=s}),define(Re[109],Ae([1,0,53,11,89,8,7]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=e.$YM=void 0;class m{constructor(l,p,v){const n=m.c.nextId();l.$registerTextEditorDecorationType(p.identifier,n,T.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:n,dispose(){l.$removeTextEditorDecorationType(n)}})}}e.$YM=m,m.c=new I.$WM("TextEditorDecorationType");class g{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let v=null;if(l instanceof M.$QK)v=new M.$RK(l,l);else if(l instanceof M.$RK)v=l;else throw new Error("Unrecognized location");this.l(v,p,!1)}insert(l,p){this.k(),this.l(new M.$RK(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof M.$RK)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,v){const n=this.c.validateRange(l);this.g.push({range:n,text:p,forceMoveMarkers:v})}setEndOfLine(l){if(this.k(),l!==M.EndOfLine.LF&&l!==M.EndOfLine.CRLF)throw(0,P.$7)("endOfLine");this.h=l}}class b{constructor(l,p,v,n){this.c=l,this.d=p,this._accept(v),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(i){o.m(i)},get indentSize(){return o.g},set indentSize(i){o.o(i)},get insertSpaces(){return o.h},set insertSpaces(i){o.q(i)},get cursorStyle(){return o.j},set cursorStyle(i){o.s(i)},get lineNumbers(){return o.k},set lineNumbers(i){o.t(i)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.insertSpaces,this.j=l.cursorStyle,this.k=T.TextEditorLineNumbersStyle.to(l.lineNumbers)}l(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}m(l){const p=this.l(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}o(l){const p=this.n(l);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(l){return l==="auto"?"auto":l==="false"?!1:!!l}q(l){const p=this.p(l);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(l){this.j!==l&&(this.j=l,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}t(l){this.k!==l&&(this.k=l,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let v=!1;if(typeof l.tabSize<"u"){const n=this.l(l.tabSize);n==="auto"?(v=!0,p.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,v=!0,p.tabSize=n)}if(typeof l.indentSize<"u"){const n=this.n(l.indentSize);n==="tabSize"?(v=!0,p.indentSize=n):typeof n=="number"&&this.g!==n&&(this.g=n,v=!0,p.indentSize=n)}if(typeof l.insertSpaces<"u"){const n=this.p(l.insertSpaces);n==="auto"?(v=!0,p.insertSpaces=n):this.h!==n&&(this.h=n,v=!0,p.insertSpaces=n)}typeof l.cursorStyle<"u"&&this.j!==l.cursorStyle&&(this.j=l.cursorStyle,v=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.k!==l.lineNumbers&&(this.k=l.lineNumbers,v=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(l.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(l,p){p.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(v)})}}e.$ZM=b;class A{constructor(l,p,v,n,o,i,s,a){this.id=l,this.j=p,this.k=v,this.g=!1,this.h=new Set,this.c=o,this.d=new b(this.j,this.id,i,v),this.e=s,this.f=a;const u=this;this.value=Object.freeze({get document(){return n.value},set document(h){throw new P.$9("document")},get selection(){return u.c&&u.c[0]},set selection(h){if(!(h instanceof M.$SK))throw(0,P.$7)("selection");u.c=[h],u.l()},get selections(){return u.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof M.$SK)))throw(0,P.$7)("selections");u.c=h,u.l()},get visibleRanges(){return u.e},set visibleRanges(h){throw new P.$9("visibleRanges")},get options(){return u.d.value},set options(h){u.g||u.d.assign(h)},get viewColumn(){return u.f},set viewColumn(h){throw new P.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new g(n.value,t);return h(r),u.m(r)},insertSnippet(h,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=u.c.map(f=>T.Range.from(f));else if(t instanceof M.$QK){const{lineNumber:f,column:w}=T.Position.from(t);c=[{startLineNumber:f,startColumn:w,endLineNumber:f,endColumn:w}]}else if(t instanceof M.$RK)c=[T.Range.from(t)];else{c=[];for(const f of t)if(f instanceof M.$RK)c.push(T.Range.from(f));else{const{lineNumber:w,column:d}=T.Position.from(f);c.push({startLineNumber:w,startColumn:d,endLineNumber:w,endColumn:d})}}return p.$tryInsertSnippet(l,n.value.version,h.value,c,r)},setDecorations(h,t){const r=t.length===0;r&&!u.h.has(h.key)||(r?u.h.delete(h.key):u.h.add(h.key),u.n(()=>{if(T.$OM(t))return p.$trySetDecorations(l,h.key,T.$PM(t));{const c=new Array(4*t.length);for(let f=0,w=t.length;f<w;f++){const d=t[f];c[4*f]=d.start.line+1,c[4*f+1]=d.start.character+1,c[4*f+2]=d.end.line+1,c[4*f+3]=d.end.character+1}return p.$trySetDecorationsFast(l,h.key,c)}}))},revealRange(h,t){u.n(()=>p.$tryRevealRange(l,T.Range.from(h),t||M.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(l,T.ViewColumn.from(h))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,$.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,$.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,$.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,$.ok)(!this.g),this.f=l}_acceptSelections(l){(0,$.ok)(!this.g),this.c=l}async l(){const l=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const v=p.edits.map(o=>o.range);v.sort((o,i)=>o.end.line===i.end.line?o.end.character===i.end.character?o.start.line===i.start.line?o.start.character-i.start.character:o.start.line-i.start.line:o.end.character-i.end.character:o.end.line-i.end.line);for(let o=0,i=v.length-1;o<i;o++){const s=v[o].end;if(v[o+1].start.isBefore(s))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=p.edits.map(o=>({range:T.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,n,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$1M=A}),define(Re[225],Ae([1,0,167,25,2,5,6,205,14,7,16,18,8,52,20,139,23]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;function i(u,h){if((0,A.$Ef)(u))return{label:u};if(u&&typeof u=="object"&&typeof u.label=="string"){let t;return Array.isArray(u.highlights)&&(t=u.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:u.label,highlights:t}}}class s extends M.$Sc{constructor(h,t,r){super(),this.f=h,this.g=t,this.h=r,this.a=new Map,this.b=new n.$d8;function c(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:f=>c(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(w=>c(w)?this.r(w):w):f})}registerTreeDataProvider(h,t,r){const c=this.createTreeView(h,{treeDataProvider:t},r);return{dispose:()=>c.dispose()}}createTreeView(h,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],f=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,D=this.m(h,t,r),L={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:f,hasHandleDrag:w,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},y=this.f.$registerTreeViewDataProvider(h,L),E={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$lF)(r,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$lF)(r,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(k){(0,p.$fk)(k)&&(0,o.$lF)(r,"treeViewMarkdownMessage"),D.message=k},get title(){return D.title},set title(k){D.title=k},get description(){return D.description},set description(k){D.description=k},get badge(){return D.badge},set badge(k){k!==void 0&&b.ViewBadge.isViewBadge(k)?D.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(D.badge=void 0)},reveal:(k,F)=>D.reveal(k,F),dispose:async()=>{await y,this.a.delete(h),D.dispose()}};return this.B(E),E}$getChildren(h,t){const r=this.a.get(h);return r?r.getChildren(t):Promise.reject(new m.$VE(h))}async $handleDrop(h,t,r,c,f,w,d,D){const L=this.a.get(h);if(!L)return Promise.reject(new m.$VE(h));const y=l.DataTransfer.toDataTransfer(r,async E=>(await this.f.$resolveDropFileData(h,t,E)).buffer);return d===h&&D&&await this.j(y,L,D,f,w),L.onDrop(y,c,f)}async j(h,t,r,c,f){const w=this.b.removeDragOperationTransfer(f);if(w)(await w)?.forEach((d,D)=>{d&&h.set(D,d)});else if(f&&t.handleDrag){const d=t.handleDrag(r,h,c);this.b.addDragOperationTransfer(f,d),await d}return h}async $handleDrag(h,t,r,c){const f=this.a.get(h);if(!f)return Promise.reject(new m.$VE(h));const w=await this.j(new b.$HL,f,t,c,r);if(!(!w||c.isCancellationRequested))return l.DataTransfer.from(w)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$VE(h);return t.hasResolve}$resolve(h,t,r){const c=this.a.get(h);if(!c)throw new m.$VE(h);return c.resolveTreeItem(t,r)}$setExpanded(h,t,r){const c=this.a.get(h);if(!c)throw new m.$VE(h);c.setExpanded(t,r)}$setSelectionAndFocus(h,t,r){const c=this.a.get(h);if(!c)throw new m.$VE(h);c.setSelectionAndFocus(t,r)}$setVisible(h,t){const r=this.a.get(h);if(!r){if(!t)return;throw new m.$VE(h)}r.setVisible(t)}$changeCheckboxState(h,t){const r=this.a.get(h);if(!r)throw new m.$VE(h);r.setCheckboxState(t)}m(h,t,r){const c=this.B(new a(h,t,this.f,this.g.converter,this.h,r));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$bhc=s;class a extends M.$Sc{get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Nf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,r,c,f,w){if(super(),this.I=h,this.J=r,this.L=c,this.M=f,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$3d,w.contributes&&w.contributes.views)for(const y in w.contributes.views)for(const E of w.contributes.views[y])E.id===h&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(y=>this.F.fire({message:!1,element:y})));let d,D;const L=T.Event.debounce(this.F.event,(y,E)=>(y||(y={message:!1,elements:[]}),E.element!==!1&&(d||(d=new Promise(k=>D=k),this.G=this.G.then(()=>d)),Array.isArray(E.element)?y.elements.push(...E.element):y.elements.push(E.element)),E.message&&(y.message=!0),y),200,!0);this.B(L(({message:y,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const k=D;return d=null,this.$(E).then(()=>k())})),y&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let r=this.X(h);return r||(r=await this.Y(t)),r?r.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const r=(0,A.$Nf)(t.select)?!0:t.select,c=(0,A.$Nf)(t.focus)?!1:t.focus,f=(0,A.$Nf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(w=>this.W(h,w[w.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:w.map(D=>D.item)},{select:r,focus:c,expand:f})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:r,focus:c,expand:f})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const r=this.getExtensionElement(h);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(h,t){const r=!(0,C.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async r=>{const c=this.getExtensionElement(r.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:r.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(h,t,r){const c=[];for(const f of h){const w=this.getExtensionElement(f);w&&c.push(w)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,r){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,g.$Ug)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(h);if(r){const c=this.m.get(r);if(c){const f=await this.f.resolveTreeItem(c.extensionItem,r,t)??c.extensionItem;return this.hb(f),c.item.tooltip=this.eb(f.tooltip),c.item.command=this.fb(c.disposableStore,f.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(c=>(r.push(c),r))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,g.$Ug)(()=>this.f.getParent(h))}W(h,t){const r=this.m.get(h);return r?Promise.resolve(r):(0,g.$Ug)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const f=this.getExtensionElement(c);if(f){const w=this.m.get(f);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const r=this.getExtensionElement(h);t=r?this.m.get(r):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new v.$3d(this.Z.token);try{const r=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const f=await Promise.all((0,C.$Hb)(c||[]).map(async w=>{const d=await this.f.getTreeItem(w);return d&&!t.token.isCancellationRequested?this.db(w,d,r):null}));return t.token.isCancellationRequested?void 0:(0,C.$Hb)(f)}finally{t.dispose()}}$(h){if(h.some(r=>!r))return this.Z.dispose(!0),this.Z=new v.$3d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(h);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(h){const t=new Set,r=h.map(f=>this.m.get(f));for(const f of r)if(f&&!t.has(f.item.handle)){let w=f;for(;w&&w.parent&&r.findIndex(d=>w&&w.parent&&d&&d.item.handle===w.parent.item.handle)===-1;){const d=this.j.get(w.parent.item.handle);w=d?this.m.get(d):void 0}w&&!w.parent&&t.add(f.item.handle)}const c=[];return t.forEach(f=>{const w=this.j.get(f);if(w){const d=this.m.get(w);d&&(!d.parent||!t.has(d.parent.item.handle))&&c.push(f)}}),c}bb(h){const t={};return Promise.all(h.map(r=>this.cb(r).then(c=>{c&&(t[r]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,g.$Ug)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const f=this.ib(t,c,r.parent);return this.pb(t,f,r,r.parent),r.dispose(),f}return null})}return Promise.resolve(null)}db(h,t,r){const c=this.ib(h,t,r);if(t.id&&this.j.has(c.item.handle))throw new Error((0,$.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,r),c}eb(h){return b.$eL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,r,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,r=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===b.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:c}}hb(h){if(!b.$CL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,r){this.hb(t);const c=this.B(new M.$Rc),f=this.kb(h,t,r),w=this.lb(t);return{item:{handle:f,parentHandle:r?r.item.handle:void 0,label:i(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,A.$Nf)(t.collapsibleState)?b.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof b.$KL?h.iconPath:void 0}kb(h,{id:t,label:r,resourceUri:c},f,w){if(t)return`${a.b}/${t}`;const d=i(r,this.N),D=f?f.item.handle:a.a;let L=d?d.label:c?(0,P.$Ag)(c):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const y=this.m.has(h)?this.m.get(h).item.handle:void 0,E=this.X(f)||[];let k,F=0;do{if(k=`${D}/${F}:${L}`,w||!this.j.has(k)||y===k)break;F++}while(F<=E.length);return k}lb(h){if(h.iconPath&&!(h.iconPath instanceof b.$KL))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof b.$KL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return I.URI.isUri(h)?h:I.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,r,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(h,t);const f=this.X(c)||[],w=f.filter(d=>d.item.handle===r.item.handle)[0];w&&f.splice(f.indexOf(w),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const r of t.children){const c=this.j.get(r.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const r of t.children){const c=this.j.get(r.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}a.a="0",a.b="1"}),define(Re[226],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[227],Ae([1,0,179,11,31,97,73,30,22,226,189,101]),function(ie,e,$,P,I,T,M,m,g,b,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=void 0;const l=m.$un.as(M.$vn.JSONContribution);class p{constructor(h,t,r){this.a=h,this.b=t,this.c=r}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(I.default.Error,h)}warn(h){this.d(I.default.Warning,h)}info(h){this.d(I.default.Info,h)}}e.$_E=p;class v{static a(h){const t=new g.$im;for(let r=0,c=h.length;r<c;r++)t.add(h[r].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new v(t,[]);if(!t||!t.length)return new v([],h);const r=this.a(h),c=this.a(t),f=t.filter(d=>!r.has(d.description.identifier)),w=h.filter(d=>!c.has(d.description.identifier));return new v(f,w)}constructor(h,t){this.added=h,this.removed=t}}e.$aF=v;class n{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=v.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,P.$1)(h)}}}e.$bF=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[$.localize(0,null),$.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$cF={properties:{engines:{type:"object",description:$.localize(2,null),properties:{vscode:{type:"string",description:$.localize(3,null),default:"^1.22.0"}}},publisher:{description:$.localize(4,null),type:"string"},displayName:{description:$.localize(5,null),type:"string"},categories:{description:$.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$gm},{type:"string",const:"Languages",deprecationMessage:$.localize(7,null)}]}},galleryBanner:{type:"object",description:$.localize(8,null),properties:{color:{description:$.localize(9,null),type:"string"},theme:{description:$.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:$.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:$.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:$.localize(13,null)},enabledApiProposals:{markdownDescription:$.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:$.localize(15,null),type:"string",enum:["none"],enumDescriptions:[$.localize(16,null)]},activationEvents:{description:$.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:$.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:$.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:$.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:$.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:$.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:$.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:$.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:$.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:$.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:$.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:$.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:$.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:$.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:$.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:$.localize(32,null)},{label:"onUri",body:"onUri",description:$.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:$.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:$.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:$.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:$.localize(37,null)},{label:"onRenderer",description:$.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:$.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:$.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:$.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:$.localize(42,null)},{label:"*",description:$.localize(43,null),body:"*"}]}},badges:{type:"array",description:$.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:$.localize(45,null)},href:{type:"string",description:$.localize(46,null)},description:{type:"string",description:$.localize(47,null)}}}},markdown:{type:"string",description:$.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:$.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:$.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$_n}},extensionPack:{description:$.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$_n}},extensionKind:{description:$.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:$.localize(53,null)},{body:["workspace"],description:$.localize(54,null)},{body:["ui","workspace"],description:$.localize(55,null)},{body:["workspace","ui"],description:$.localize(56,null)},{body:[],description:$.localize(57,null)}]},capabilities:{description:$.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:$.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:$.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[$.localize(61,null),$.localize(62,null),$.localize(63,null)]},description:{type:"string",markdownDescription:$.localize(64,null)}}},untrustedWorkspaces:{description:$.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:$.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[$.localize(67,null),$.localize(68,null),$.localize(69,null)]},restrictedConfigurations:{description:$.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:$.localize(71,null)}}}}},sponsor:{description:$.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:$.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:$.localize(74,null),type:"string"},"vscode:uninstall":{description:$.localize(75,null),type:"string"}}},icon:{type:"string",description:$.localize(76,null)},l10n:{type:"string",description:$.localize(77,null)},pricing:{type:"string",markdownDescription:$.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class s{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new n(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&C.$3E.register(h.extensionPoint,h.activationEventsGenerator),e.$cF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(i,e.$cF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$dF=s;const a={ExtensionsRegistry:"ExtensionsRegistry"};m.$un.add(a.ExtensionsRegistry,new s),e.$eF=m.$un.as(a.ExtensionsRegistry),l.registerSchema(i,e.$cF),l.registerSchema(A.$Cj,{properties:{extensionEnabledApiProposals:{description:$.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(Re[228],Ae([1,0,175,16,26,227,35,5]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:$.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:$.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:$.localize(2,null),default:""}}};var b;(function(l){function p(v,n,o){if(!v)return;const i=P.$Ef(v.type)?v.type:void 0;if(!i||i.length===0){o.error($.localize(3,null));return}const s=[];if(Array.isArray(v.required))for(const a of v.required)P.$Ef(a)&&s.push(a);return{extensionId:n.value,taskType:i,required:s,properties:v.properties?I.$in(v.properties):{},when:v.when?M.$Zi.deserialize(v.when):void 0}}l.from=p})(b||(b={}));const A=T.$eF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const v of l)v.type&&p.push(`onTaskType:${v.type}`)},jsonSchema:{description:$.localize(4,null),type:"array",items:g}});class C{constructor(){this.d=new m.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,v)=>{A.setHandler((n,o)=>{this.c=void 0;try{for(const i of o.removed){const s=i.value;for(const a of s)this.a&&a.type&&this.a[a.type]&&delete this.a[a.type]}for(const i of o.added){const s=i.value;for(const a of s){const u=b.from(a,i.description.identifier,i.collector);u&&(this.a[u.taskType]=u)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const v of this.all()){const n={type:"object",additionalProperties:!1};v.required.length>0&&(n.required=v.required.slice(0)),v.properties!==void 0?n.properties=I.$in(v.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[v.taskType]},p.push(n)}this.c={oneOf:p}}return this.c}}e.$gG=new C}),define(Re[229],Ae([1,0,176,16,25,26,35,228]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$qG=e.JsonSchemaVersion=e.ExecutionEngine=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$kG=e.ShellQuoting=e.$jG=e.$iG=e.$hG=void 0,e.$hG="settings",e.$iG=new M.$gj("taskRunning",!1,$.localize(0,null)),e.$jG={value:$.localize(1,null),original:"Tasks"};var g;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$kG="$customized",function(R){function S(O){if(!O)return R.Strong;switch(O.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=S}(g||(e.ShellQuoting=g={}));var b;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var A;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(A||(e.RevealKind=A={})),function(R){function S(O){switch(O.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=S}(A||(e.RevealKind=A={}));var C;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(R){function S(O){switch(O.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=S}(C||(e.RevealProblemKind=C={}));var l;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(l||(e.PanelKind=l={})),function(R){function S(O){switch(O.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=S}(l||(e.PanelKind=l={}));var p;(function(R){R.defaults={echo:!0,reveal:A.Always,revealProblems:C.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var v;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(R){function S(Q){switch(Q.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=S;function O(Q){switch(Q){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=O}(v||(e.RuntimeType=v={}));var n;(function(R){function S(O){return P.$Ef(O)?O:O.value}R.value=S})(n||(e.CommandString=n={}));var o;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function S(Q){return Q===R.Clean._id||Q===R.Build._id||Q===R.Rebuild._id||Q===R.Test._id}R.is=S;function O(Q){if(Q!==void 0)return P.$Ef(Q)?S(Q)?{_id:Q,isDefault:!1}:void 0:Q}R.from=O})(o||(e.TaskGroup=o={}));var i;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var s;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function S(O){switch(O){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=S})(s||(e.TaskSourceKind=s={}));var a;(function(R){R.parallel="parallel",R.sequence="sequence"})(a||(e.DependsOrder=a={}));var u;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(u||(e.RunOnOptions=u={}));var h;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:u.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(S,O,Q,re,he,fe){this._label="",this._id=S,O&&(this._label=O),Q&&(this.type=Q),this.runOptions=re,this.configurationProperties=he,this._source=fe}getDefinition(S){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const S={folder:this.d(),id:this._id};return JSON.stringify(S)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(S,O=!1){if(S===void 0)return!1;if(P.$Ef(S))return S===this._label||S===this.configurationProperties.identifier||O&&S===this._id;const Q=this.getDefinition(!0);return Q!==void 0&&Q._key===S._key}getQualifiedLabel(){const S=this.getWorkspaceFolder();return S?`${this._label} (${S.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(S){this.c===void 0&&(this.c=[]),S&&(this.c=this.c.concat(S))}get taskLoadMessages(){return this.c}}e.$lG=t;class r extends t{constructor(S,O,Q,re,he,fe,ue,$e){super(S,Q,void 0,ue,$e,O),this.command={},this._source=O,this.hasDefinedMatchers=fe,he&&(this.command=he)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(S=!1){if(S&&this._source.customizes!==void 0)return this._source.customizes;{let O;switch(this.command?this.command.runtime:void 0){case v.Shell:O="shell";break;case v.Process:O="process";break;case v.CustomExecution:O="customExecution";break;case void 0:O="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:O,_key:this._id,id:this._id}}}static is(S){return S instanceof r}getMapKey(){const S=this._source.config.workspaceFolder;return S?`${S.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===s.User?e.$hG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const S=this.d();if(!S)return;let O=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(O+=this._source.kind);const Q={type:e.$kG,folder:S,id:O};return JSON.stringify(Q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Ag(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(S){return new r(S._id,S._source,S._label,S.type,S.command,S.hasDefinedMatchers,S.runOptions,S.configurationProperties)}}e.$mG=r;class c extends t{constructor(S,O,Q,re,he,fe,ue){super(S,Q,re,fe,ue,O),this._source=O,this.configures=he}static is(S){return S instanceof c}f(S){return S}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Ag(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===s.User?e.$hG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const S=this.d();if(!S)return;let O=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(O+=this._source.kind);const Q={type:e.$kG,folder:S,id:O};return JSON.stringify(Q)}}e.$nG=c;class f extends t{constructor(S,O,Q,re,he,fe,ue,$e,ne){super(S,Q,re,$e,ne,O),this.defines=he,this.hasDefinedMatchers=ue,this.command=fe,this.icon=ne.icon,this.hide=ne.hide}clone(){return new f(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(S){return S instanceof f}getMapKey(){const S=this._source.workspaceFolder;return S?`${this._source.scope.toString()}|${S.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const S={type:"contributed",scope:this._source.scope,id:this._id};return S.folder=this.d(),JSON.stringify(S)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(S){return new f(S._id,S._source,S._label,S.type,S.defines,S.command,S.hasDefinedMatchers,S.runOptions,S.configurationProperties)}}e.$oG=f;class w extends t{constructor(S,O,Q,re,he,fe){super(S,Q,re,he,fe,O),this._source=O}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(S){return S instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(S){return new w(S._id,S._source,S._label,S.type,S.runOptions,S.configurationProperties)}}e.$pG=w;var d;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(R){R._default=R.Terminal}(d||(e.ExecutionEngine=d={}));var D;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class L{constructor(S){this.c=new Map;for(let O=0;O<S.length;O++)this.c.set(S[O].uri.toString(),O)}compare(S,O){const Q=S.getWorkspaceFolder(),re=O.getWorkspaceFolder();if(Q&&re){let he=this.c.get(Q.uri.toString());he=he===void 0?0:he+1;let fe=this.c.get(re.uri.toString());return fe=fe===void 0?0:fe+1,he===fe?S._label.localeCompare(O._label):he-fe}else return!Q&&re?-1:Q&&!re?1:0}}e.$qG=L;var y;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(y||(e.TaskEventKind=y={}));var E;(function(R){R.SingleRun="singleRun",R.Background="background"})(E||(e.TaskRunType=E={}));var k;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var F;(function(R){function S($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function O($e,ne,Pe){return{...S($e),kind:"start",terminalId:ne,resolvedVariables:Pe}}R.start=O;function Q($e,ne,Pe){return{...S($e),kind:"processStarted",terminalId:ne,processId:Pe}}R.processStarted=Q;function re($e,ne,Pe){return{...S($e),kind:"processEnded",terminalId:ne,exitCode:Pe}}R.processEnded=re;function he($e,ne,Pe){return{...S($e),kind:"terminated",exitReason:Pe,terminalId:ne}}R.terminated=he;function fe($e,ne,Pe){return{...S(ne),kind:$e,terminalId:Pe}}R.general=fe;function ue(){return{kind:"changed"}}R.changed=ue})(F||(e.TaskEvent=F={}));var B;(function(R){function S(Q){const re=Object.keys(Q).sort();let he="";for(const fe of re){let ue=Q[fe];ue instanceof Object?ue=S(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),he+=fe+","+ue+","}return he}function O(Q){const he={_key:S(Q),type:Q.taskType};return Object.assign(he,Q),he}R.create=O})(B||(e.KeyedTaskIdentifier=B={}));var ee;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(ee||(e.TaskSettingId=ee={}));var J;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(J||(e.TasksSchemaProperties=J={}));var V;(function(R){function S(O,Q){const re=m.$gG.get(O.type);if(re===void 0){const $e=T.$in(O);return delete $e._key,B.create($e)}const he=Object.create(null);he.type=re.taskType;const fe=new Set;re.required.forEach($e=>fe.add($e));const ue=re.properties;for(const $e of Object.keys(ue)){const ne=O[$e];if(ne!=null)he[$e]=ne;else if(fe.has($e)){const Pe=ue[$e];if(Pe.default!==void 0)he[$e]=T.$in(Pe.default);else switch(Pe.type){case"boolean":he[$e]=!1;break;case"number":case"integer":he[$e]=0;break;case"string":he[$e]="";break;default:Q.error($.localize(2,null,JSON.stringify(O,void 0,0),$e));return}}}return B.create(he)}R.createTaskIdentifier=S})(V||(e.TaskDefinition=V={}))}),define(Re[230],Ae([1,0,11]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=e.$s7b=void 0;class P{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,m)=>{this.b=M,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,$.$1)(M))}then(M,m){return this.j().then(M,m)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$s7b=P;class I extends P{constructor(){super(),this.h=!0,this.i=new $.$5}}e.$t7b=I}),define(Re[49],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=e.$Cv=void 0;class ${constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++$.count}}e.$Cv=$,$.count=0;const P=[];function I(m){const g=new $(m);return P[g.nid]=g,g}e.$Dv=I;function T(m){return P[m].sid}e.$Ev=T;class M{constructor(g){this.value=g}}e.$Fv=M}),define(Re[3],Ae([1,0,49]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$MK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(P||(e.TextEditorRevealType=P={}));var I;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var T;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var M;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var m;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var g;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var b;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var A;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class C{static mixin(o){return o._id=C.a++,o}}e.$MK=C,C.a=0;var l;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var v;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$NK={MainThreadAuthentication:(0,$.$Dv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,$.$Dv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,$.$Dv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,$.$Dv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,$.$Dv)("MainThreadChatVariables"),MainThreadClipboard:(0,$.$Dv)("MainThreadClipboard"),MainThreadCommands:(0,$.$Dv)("MainThreadCommands"),MainThreadComments:(0,$.$Dv)("MainThreadComments"),MainThreadConfiguration:(0,$.$Dv)("MainThreadConfiguration"),MainThreadConsole:(0,$.$Dv)("MainThreadConsole"),MainThreadDebugService:(0,$.$Dv)("MainThreadDebugService"),MainThreadDecorations:(0,$.$Dv)("MainThreadDecorations"),MainThreadDiagnostics:(0,$.$Dv)("MainThreadDiagnostics"),MainThreadDialogs:(0,$.$Dv)("MainThreadDiaglogs"),MainThreadDocuments:(0,$.$Dv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,$.$Dv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,$.$Dv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,$.$Dv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,$.$Dv)("MainThreadEditorTabs"),MainThreadErrors:(0,$.$Dv)("MainThreadErrors"),MainThreadTreeViews:(0,$.$Dv)("MainThreadTreeViews"),MainThreadDownloadService:(0,$.$Dv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,$.$Dv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,$.$Dv)("MainThreadLanguages"),MainThreadLogger:(0,$.$Dv)("MainThreadLogger"),MainThreadMessageService:(0,$.$Dv)("MainThreadMessageService"),MainThreadOutputService:(0,$.$Dv)("MainThreadOutputService"),MainThreadProgress:(0,$.$Dv)("MainThreadProgress"),MainThreadQuickDiff:(0,$.$Dv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,$.$Dv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,$.$Dv)("MainThreadStatusBar"),MainThreadSecretState:(0,$.$Dv)("MainThreadSecretState"),MainThreadStorage:(0,$.$Dv)("MainThreadStorage"),MainThreadSpeech:(0,$.$Dv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,$.$Dv)("MainThreadTelemetry"),MainThreadTerminalService:(0,$.$Dv)("MainThreadTerminalService"),MainThreadWebviews:(0,$.$Dv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,$.$Dv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,$.$Dv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,$.$Dv)("MainThreadCustomEditors"),MainThreadUrls:(0,$.$Dv)("MainThreadUrls"),MainThreadUriOpeners:(0,$.$Dv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,$.$Dv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,$.$Dv)("MainThreadWorkspace"),MainThreadFileSystem:(0,$.$Dv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,$.$Dv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,$.$Dv)("MainThreadExtensionService"),MainThreadSCM:(0,$.$Dv)("MainThreadSCM"),MainThreadSearch:(0,$.$Dv)("MainThreadSearch"),MainThreadShare:(0,$.$Dv)("MainThreadShare"),MainThreadTask:(0,$.$Dv)("MainThreadTask"),MainThreadWindow:(0,$.$Dv)("MainThreadWindow"),MainThreadLabelService:(0,$.$Dv)("MainThreadLabelService"),MainThreadNotebook:(0,$.$Dv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,$.$Dv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,$.$Dv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,$.$Dv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,$.$Dv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,$.$Dv)("MainThreadInteractive"),MainThreadChat:(0,$.$Dv)("MainThreadChat"),MainThreadInlineChat:(0,$.$Dv)("MainThreadInlineChatShape"),MainThreadTheming:(0,$.$Dv)("MainThreadTheming"),MainThreadTunnelService:(0,$.$Dv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,$.$Dv)("MainThreadManagedSockets"),MainThreadTimeline:(0,$.$Dv)("MainThreadTimeline"),MainThreadTesting:(0,$.$Dv)("MainThreadTesting"),MainThreadLocalization:(0,$.$Dv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,$.$Dv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,$.$Dv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,$.$Dv)("MainThreadIssueReporter")},e.$OK={ExtHostCommands:(0,$.$Dv)("ExtHostCommands"),ExtHostConfiguration:(0,$.$Dv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,$.$Dv)("ExtHostDiagnostics"),ExtHostDebugService:(0,$.$Dv)("ExtHostDebugService"),ExtHostDecorations:(0,$.$Dv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,$.$Dv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,$.$Dv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,$.$Dv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,$.$Dv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,$.$Dv)("ExtHostEditors"),ExtHostTreeViews:(0,$.$Dv)("ExtHostTreeViews"),ExtHostFileSystem:(0,$.$Dv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,$.$Dv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,$.$Dv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,$.$Dv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,$.$Dv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,$.$Dv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,$.$Dv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,$.$Dv)("ExtHostStatusBar"),ExtHostShare:(0,$.$Dv)("ExtHostShare"),ExtHostExtensionService:(0,$.$Dv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,$.$Dv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,$.$Dv)("ExtHostTerminalService"),ExtHostSCM:(0,$.$Dv)("ExtHostSCM"),ExtHostSearch:(0,$.$Dv)("ExtHostSearch"),ExtHostTask:(0,$.$Dv)("ExtHostTask"),ExtHostWorkspace:(0,$.$Dv)("ExtHostWorkspace"),ExtHostWindow:(0,$.$Dv)("ExtHostWindow"),ExtHostWebviews:(0,$.$Dv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,$.$Dv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,$.$Dv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,$.$Dv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,$.$Dv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,$.$Dv)("ExtHostEditorTabs"),ExtHostProgress:(0,$.$Dv)("ExtHostProgress"),ExtHostComments:(0,$.$Dv)("ExtHostComments"),ExtHostSecretState:(0,$.$Dv)("ExtHostSecretState"),ExtHostStorage:(0,$.$Dv)("ExtHostStorage"),ExtHostUrls:(0,$.$Dv)("ExtHostUrls"),ExtHostUriOpeners:(0,$.$Dv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,$.$Dv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,$.$Dv)("ExtHostOutputService"),ExtHosLabelService:(0,$.$Dv)("ExtHostLabelService"),ExtHostNotebook:(0,$.$Dv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,$.$Dv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,$.$Dv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,$.$Dv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,$.$Dv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,$.$Dv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,$.$Dv)("ExtHostInteractive"),ExtHostInlineChat:(0,$.$Dv)("ExtHostInlineChatShape"),ExtHostChat:(0,$.$Dv)("ExtHostChat"),ExtHostChatAgents2:(0,$.$Dv)("ExtHostChatAgents"),ExtHostChatVariables:(0,$.$Dv)("ExtHostChatVariables"),ExtHostChatProvider:(0,$.$Dv)("ExtHostChatProvider"),ExtHostSpeech:(0,$.$Dv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,$.$Dv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,$.$Dv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,$.$Dv)("ExtHostTheming"),ExtHostTunnelService:(0,$.$Dv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,$.$Dv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,$.$Dv)("ExtHostAuthentication"),ExtHostTimeline:(0,$.$Dv)("ExtHostTimeline"),ExtHostTesting:(0,$.$Dv)("ExtHostTesting"),ExtHostTelemetry:(0,$.$Dv)("ExtHostTelemetry"),ExtHostLocalization:(0,$.$Dv)("ExtHostLocalization"),ExtHostIssueReporter:(0,$.$Dv)("ExtHostIssueReporter")}}),define(Re[231],Ae([1,0,3,7]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class I{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy($.$NK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,m,g){if(this.a.size===0)throw new Error("No related information providers registered");const b=this.a.get(M);if(!b)throw new Error("related information provider not found");return await b.provideRelatedInformation(m,g)??[]}getRelatedInformation(M,m,g){return this.c.$getAiRelatedInformation(m,g)}registerRelatedInformationProvider(M,m,g){const b=this.b;return this.b++,this.a.set(b,g),this.c.$registerAiRelatedInformationProvider(b,m),new P.$PK(()=>{this.c.$unregisterAiRelatedInformationProvider(b),this.a.delete(b)})}}e.$bfc=I}),define(Re[81],Ae([1,0,4,15,3,17]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=e.$hfc=void 0,e.$hfc=(0,$.$2h)("IExtHostApiDeprecationService");let M=class{constructor(g,b){this.c=b,this.a=new Set,this.b=g.getProxy(I.$NK.MainThreadTelemetry)}report(g,b,A){const C=this.d(g,b);this.a.has(C)||(this.a.add(C),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:g}))}d(g,b){return`${g}-${b.identifier.value}`}};e.$ifc=M,e.$ifc=M=Je([Ge(0,T.$RM),Ge(1,P.$jj)],M),e.$jfc=Object.freeze(new class{report(m,g,b){}})}),define(Re[232],Ae([1,0,5,3,7,22]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class M{constructor(b){this.b=new Map,this.c=[],this.d=new $.$Sd,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=b.getProxy(P.$NK.MainThreadAuthentication)}$setProviders(b){return this.c=b,Promise.resolve()}async getSession(b,A,C,l={}){const p=T.$hm.toKey(b.identifier),v=[...C].sort().join(" ");return await this.f.getOrCreate(`${p} ${A} ${v}`,async()=>{await this.a.$ensureProvider(A);const n=b.displayName||b.name;return this.a.$getSession(A,C,p,n,l)})}async getSessions(b,A,C){const l=T.$hm.toKey(b.identifier),p=[...C].sort().join(" ");return await this.g.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(A);const v=b.displayName||b.name;return this.a.$getSessions(A,C,l,v)})}async removeSession(b,A){const C=this.b.get(b);return C?C.provider.removeSession(A):this.a.$removeSession(b,A)}registerAuthenticationProvider(b,A,C,l){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:A,provider:C,options:l??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===b)||this.c.push({id:b,label:A});const p=C.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(b,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(b,A,l?.supportsMultipleAccounts??!1),new I.$PK(()=>{p.dispose(),this.b.delete(b);const v=this.c.findIndex(n=>n.id===b);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,A,C){const l=this.b.get(b);if(l)return Promise.resolve(l.provider.createSession(A,C));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,A){const C=this.b.get(b);if(C)return Promise.resolve(C.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,A){const C=this.b.get(b);if(C)return Promise.resolve(C.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,A){return this.d.fire({provider:{id:b,label:A}}),Promise.resolve()}}e.$mfc=M;class m{constructor(){this.a=new Map}getOrCreate(b,A){const C=this.a.get(b);if(C)return C;const l=A().finally(()=>this.a.delete(b));return this.a.set(b,l),l}}}),define(Re[233],Ae([1,0,3,17,8]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;let T=class{constructor(m,g){this.a=m.getProxy($.$NK.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>g.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,g,b){const A=I.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,b?.isRefactoring??!1)}};e.$nfc=T,e.$nfc=T=Je([Ge(0,P.$RM)],T)}),define(Re[234],Ae([1,0,5,68,6,3,8]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class m{constructor(A,C){this.extension=A,this.provider=C,this.handle=m.a++}}m.a=0;class g{constructor(A){this.b=new Map,this.c=new Map,this.d=new $.$Sd,this.onDidPerformUserAction=this.d.event,this.e=A.getProxy(T.$NK.MainThreadChat)}registerChatProvider(A,C,l){const p=new m(A,l);return this.b.set(p.handle,p),this.e.$registerChatProvider(p.handle,C),(0,I.$Qc)(()=>{this.e.$unregisterChatProvider(p.handle),this.b.delete(p.handle)})}transferChatSession(A,C){const l=P.Iterable.find(this.c.keys(),p=>this.c.get(p)===A)??0;typeof l=="number"&&this.e.$transferChatSession(l,C)}sendInteractiveRequestToProvider(A,C){this.e.$sendRequestToProvider(A,C)}async $prepareChat(A,C){const l=this.b.get(A);if(!l)return;const p=await l.provider.prepareSession(C);if(!p)return;const v=g.a++;return this.c.set(v,p),{id:v,requesterUsername:p.requester?.name,requesterAvatarIconUri:p.requester?.icon,responderUsername:p.responder?.name,responderAvatarIconUri:p.responder?.icon,inputPlaceholder:p.inputPlaceholder}}async $provideWelcomeMessage(A,C){const l=this.b.get(A);if(!l||!l.provider.provideWelcomeMessage)return;const p=await l.provider.provideWelcomeMessage(C);if(p)return p.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(n=>M.ChatReplyFollowup.from(n)):M.MarkdownString.from(v))}async $provideSampleQuestions(A,C){const l=this.b.get(A);if(!l||!l.provider.provideSampleQuestions)return;const p=await l.provider.provideSampleQuestions(C);if(p)return p?.map(v=>M.ChatReplyFollowup.from(v))}$releaseSession(A){this.c.delete(A)}async $onDidPerformUserAction(A){this.d.fire(A)}}e.$ofc=g,g.a=0}),define(Re[235],Ae([1,0,14,20,40,5,60,16,2,157,72,3,8,7,206,23]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class o{constructor(a,u,h){this.i=u,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=a.getProxy(C.$NK.MainThreadChatAgents2)}createChatAgent(a,u,h){const t=o.a++,r=new i(a,u,this.d,t,h);return this.b.set(t,r),this.d.$registerAgent(t,u,{}),r.apiAgent}async $invokeAgent(a,u,h,t,r,c){this.g.delete(u);const f=this.b.get(a);if(!f)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let w=!1;function d(){if(w)throw new Error("Only valid while executing the command")}const D=new $.$mh;c.onCancellationRequested(()=>D.complete()),setTimeout(()=>D.complete(),10*1e3),this.i.allowListExtensionWhile(f.extension.identifier,D.p);const L=t.command?await f.validateSlashCommand(t.command):void 0,y=M.$Od.create(!1);let E;try{const k=f.invoke({prompt:t.message,variables:l.ChatVariable.objectTo(t.variables),slashCommand:L},{history:r.history.map(l.ChatMessage.to)},new A.$hv(F=>{d(),typeof E>"u"&&"content"in F&&(E=y.elapsed());const B=l.ChatResponseProgress.from(f.extension,F);if(!B){this.j.error("Unknown progress type: "+JSON.stringify(F));return}if("placeholder"in F&&"resolvedContent"in F){const ee=Promise.all([this.d.$handleProgressChunk(h,B),F.resolvedContent]);(0,$.$Qg)(ee,c).then(J=>{if(!J)return;const[V,R]=J,S=l.ChatResponseProgress.from(f.extension,R);if(!S){this.j.error("Unknown progress type: "+JSON.stringify(R));return}this.d.$handleProgressChunk(h,S,V??void 0)})}else this.d.$handleProgressChunk(h,B)}),c);return await(0,$.$Qg)(Promise.resolve(k).then(F=>{if(F){this.g.set(u,F);let B=this.h.get(u);B||(B=new Map,this.h.set(u,B)),B.set(h,F);const ee={firstProgress:E,totalElapsed:y.elapsed()};return{errorDetails:F.errorDetails,timings:ee}}else this.g.delete(u)}),c)}catch(k){return this.j.error(k,f.extension),{errorDetails:{message:(0,b.localize)(0,null,(0,I.$Mi)(k)),responseIsIncomplete:!0}}}finally{w=!0,D.complete()}}$releaseSession(a){this.g.delete(a),this.h.delete(a)}async $provideSlashCommands(a,u){const h=this.b.get(a);return h?h.provideSlashCommand(u):[]}$provideFollowups(a,u,h){const t=this.b.get(a);if(!t)return Promise.resolve([]);const r=this.g.get(u);return r?t.provideFollowups(r,h):Promise.resolve([])}$acceptFeedback(a,u,h,t,r){const c=this.b.get(a);if(!c)return;const f=this.h.get(u)?.get(h);if(!f)return;let w;switch(t){case v.InteractiveSessionVoteDirection.Down:w=p.ChatAgentResultFeedbackKind.Unhelpful;break;case v.InteractiveSessionVoteDirection.Up:w=p.ChatAgentResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(r?{result:f,kind:w,reportIssue:r}:{result:f,kind:w}))}$acceptAction(a,u,h,t){const r=this.b.get(a);if(!r)return;const c=this.h.get(u)?.get(h);c&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:c}))}async $invokeCompletionProvider(a,u,h){const t=this.b.get(a);return t?(await t.invokeCompletionProvider(u,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$qfc=o,o.a=0;class i{constructor(a,u,h,t,r){this.extension=a,this.t=u,this.u=h,this.w=t,this.x=r,this.o=new T.$Sd,this.q=new T.$Sd}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.q.fire(a)}async invokeCompletionProvider(a,u){return this.s?await this.s.provider.provideCompletionItems(a,u)??[]:[]}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(P.CancellationToken.None),(0,m.$Of)(this.b));const u=this.b.find(h=>h.name===a);if(!u)throw new Error(`Unknown slashCommand: ${a}`);return u}async provideSlashCommand(a){if(!this.a)return[];const u=await this.a.provideSlashCommands(a);return u?(this.b=u,u.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(a,u){if(!this.d)return[];const h=await this.d.provideFollowups(a,u);return h?h.map(t=>l.ChatFollowup.from(t)):[]}get apiAgent(){let a=!1,u=!1;const h=()=>{a||u||(u=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$KL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),u=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(r){t.g=r,h()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,h()},get iconPath(){return t.i},set iconPath(r){t.i=r,h()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,h()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,h()},get isDefault(){return(0,n.$lF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,n.$lF)(t.extension,"defaultChatAgent"),t.j=r,h()},get helpTextPrefix(){return(0,n.$lF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(r){if((0,n.$lF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=r,h()},get helpTextPostfix(){return(0,n.$lF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(r){if((0,n.$lF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=r,h()},get isSecondary(){return(0,n.$lF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(r){(0,n.$lF)(t.extension,"defaultChatAgent"),t.n=r,h()},get sampleRequest(){return t.m},set sampleRequest(r){t.m=r,h()},get supportIssueReporting(){return(0,n.$lF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(r){(0,n.$lF)(t.extension,"chatAgents2Additions"),t.r=r,h()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(r){if(t.s=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,r.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,n.$kF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){a=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(a,u,h,t){return this.x(a,u,h,t)}}}),define(Re[236],Ae([1,0,20,6,3,8,72,22,14,5]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class A{constructor(v,n){this.stream=new g.$sh,this.stream=n??new g.$sh;const o=this;this.apiObj={option:v,response:o.stream.asyncIterable}}}class C{constructor(v,n){this.a=new b.$Sd,this.b=new Map,this.c=new g.$sh,this.d=!1;const o=this;this.apiObject={result:v,response:o.c.asyncIterable,onDidStartResponseStream:o.a.event,cancel(){n.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let n=this.b.get(v.index);n||(this.b.size===0?n=new A(v.index,this.c):n=new A(v.index),this.b.set(v.index,n),this.a.fire(n.apiObj)),n.stream.emitOne(v.part)}}class l{constructor(v,n){this.d=n,this.c=new Map,this.e=new Map,this.f=new m.$jm,this.b=v.getProxy(I.$NK.MainThreadChatProvider)}registerProvider(v,n,o,i){const s=l.a++;return this.c.set(s,{extension:v,provider:o}),this.b.$registerProvider(s,n,{extension:v,model:i.name??""}),(0,P.$Qc)(()=>{this.b.$unregisterProvider(s),this.c.delete(s)})}async $provideChatResponse(v,n,o,i,s){const a=this.c.get(v);if(!a)return;const u=new M.$hv(async h=>{if(s.isCancellationRequested){this.d.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(n,{index:h.index,part:h.part})});return a.provider.provideChatResponse(o.map(T.ChatMessage.to),i,u,s)}allowListExtensionWhile(v,n){this.f.set(v,n),n.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,n){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const o=await this.b.$prepareChatAccess(n);if(!o)throw new Error(`ChatAccess '${n}' NOT found`);const i=this;return{get model(){return o.model},get isRevoked(){return!i.f.has(v)},makeRequest(s,a,u){if(!i.f.has(v))throw new Error("Access to chat has been revoked");const h=new $.$3d(u),t=Math.random()*1e6|0,r=i.b.$fetchResponse(v,n,t,s.map(T.ChatMessage.from),a??{},h.token),c=new C(r,h);return i.e.set(t,{res:c}),r.finally(()=>{i.e.delete(t)}),c.apiObject}}}async $handleResponseFragment(v,n){const o=this.e.get(v);o&&o.res.handleFragment(n)}}e.$pfc=l,l.a=1}),define(Re[237],Ae([1,0,6,3,11,8]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class M{constructor(g){this.b=new Map,this.c=g.getProxy(P.$NK.MainThreadChatVariables)}async $resolveVariable(g,b,A){const C=this.b.get(g);if(C)try{const l=await C.resolver.resolve(C.data.name,{message:b},A);if(l)return l.map(T.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(g,b,A,C){const l=M.a++;return this.b.set(l,{extension:g.identifier,data:{name:b,description:A},resolver:C}),this.c.$registerVariable(l,{name:b,description:A}),(0,$.$Qc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$rfc=M,M.a=0}),define(Re[238],Ae([1,0,3]),function(ie,e,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class P{constructor(T){const M=T.getProxy($.$NK.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(m){return M.$writeText(m)}})}}e.$sfc=P});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[32],Ae([1,0,16,7,8,26,3,18,15,51,29,93,2,6,4,17,108,24,49,40,60,56,59,34]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u,h,t,r){"use strict";var c,f,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=void 0;let d=class{constructor(F,B,ee){c.set(this,void 0),this.b=new Map,this.c=new Map,f.set(this,void 0),w.set(this,void 0),xe(this,c,F.getProxy(M.$NK.MainThreadCommands),"f"),this.d=B,xe(this,w,ee,"f"),xe(this,f,F.getProxy(M.$NK.MainThreadTelemetry),"f"),this.converter=new D(this,J=>{const V=this.c.get(J);return V?.result===y.Void?V:void 0},B),this.f=[{processArgument(J){return(0,b.$yh)(J)}},{processArgument(J){return(0,T.$kn)(J,function(V){if(A.$Hs.isIRange(V))return I.Range.to(V);if(C.$Gs.isIPosition(V))return I.Position.to(V);if(A.$Hs.isIRange(V.range)&&l.URI.isUri(V.uri))return I.location.to(V);if(V instanceof i.$ge)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(F){this.f.push(F)}registerApiCommand(F){const B=this.registerCommand(!1,F.id,async(...ee)=>{const J=F.args.map((R,S)=>{if(!R.validate(ee[S]))throw new Error(`Invalid argument '${R.name}' when running '${F.id}', received: ${typeof ee[S]=="object"?JSON.stringify(ee[S],null,"	"):ee[S]} `);return R.convert(ee[S])}),V=await this.executeCommand(F.internalId,...J);return F.result.convert(V,ee,this.converter)},void 0,{description:F.description,args:F.args,returns:F.result.description});return this.c.set(F.id,F),new P.$PK(()=>{B.dispose(),this.c.delete(F.id)})}registerCommand(F,B,ee,J,V,R){if(this.d.trace("ExtHostCommands#registerCommand",B),!B.trim().length)throw new Error("invalid id");if(this.b.has(B))throw new Error(`command '${B}' already exists`);return this.b.set(B,{callback:ee,thisArg:J,metadata:V,extension:R}),F&&ze(this,c,"f").$registerCommand(B),new P.$PK(()=>{this.b.delete(B)&&F&&ze(this,c,"f").$unregisterCommand(B)})}executeCommand(F,...B){return this.d.trace("ExtHostCommands#executeCommand",F),this.g(F,B,!0)}async g(F,B,ee){if(this.b.has(F))return ze(this,c,"f").$fireCommandActivationEvent(F),this.h(F,B,!1);{let J=!1;const V=(0,T.$kn)(B,function(R){if(R instanceof P.$QK)return I.Position.from(R);if(R instanceof P.$RK)return I.Range.from(R);if(R instanceof P.$2K)return I.location.from(R);if(P.$bM.isNotebookRange(R))return I.NotebookRange.from(R);if(R instanceof ArrayBuffer)return J=!0,i.$ge.wrap(new Uint8Array(R));if(R instanceof Uint8Array)return J=!0,i.$ge.wrap(R);if(R instanceof i.$ge)return J=!0,R;if(!Array.isArray(R))return R});try{const R=await ze(this,c,"f").$executeCommand(F,J?new s.$Fv(V):V,ee);return(0,b.$yh)(R)}catch(R){if(R instanceof Error&&R.message==="$executeCommand:retry")return this.g(F,B,!1);throw R}}}async h(F,B,ee){const J=this.b.get(F);if(!J)throw new Error("Unknown command");const{callback:V,thisArg:R,metadata:S}=J;if(S?.args)for(let Q=0;Q<S.args.length;Q++)try{(0,$.$Vf)(B[Q],S.args[Q].constraint)}catch{throw new Error(`Running the contributed command: '${F}' failed. Illegal argument '${S.args[Q].name}' - ${S.args[Q].description}`)}const O=u.$Od.create();try{return await V.apply(R,B)}catch(Q){if(F===this.converter.delegatingCommandId){const re=this.converter.getActualCommand(...B);re&&(F=re.command)}if(this.d.error(Q,F,J.extension?.identifier),!ee)throw Q;if(J.extension?.identifier){const re=ze(this,w,"f").onExtensionError(J.extension.identifier,Q);this.d.trace("forwarded error to extension?",re,J.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.$Mi)(Q)),this.id=F,this.source=J.extension?.displayName??J.extension?.name}}}finally{this.j(J,F,O.elapsed())}}j(F,B,ee){F.extension&&ze(this,f,"f").$publicLog2("Extension:ActionExecuted",{extensionId:F.extension.identifier.value,id:new h.$xo(B),duration:ee})}$executeContributedCommand(F,...B){this.d.trace("ExtHostCommands#$executeContributedCommand",F);const ee=this.b.get(F);return ee?(B=B.map(J=>this.f.reduce((V,R)=>R.processArgument(V,ee.extension?.identifier),J)),this.h(F,B,!0)):Promise.reject(new Error(`Contributed command '${F}' does not exist.`))}getCommands(F=!1){return this.d.trace("ExtHostCommands#getCommands",F),ze(this,c,"f").$getCommands().then(B=>(F&&(B=B.filter(ee=>ee[0]!=="_")),B))}$getContributedCommandMetadata(){const F=Object.create(null);for(const[B,ee]of this.b){const{metadata:J}=ee;J&&(F[B]=J)}return Promise.resolve(F)}};e.$aN=d,c=new WeakMap,f=new WeakMap,w=new WeakMap,e.$aN=d=Je([Ge(0,n.$RM),Ge(1,g.$jj),Ge(2,t.$_M)],d),e.$bN=(0,v.$2h)("IExtHostCommands");class D{constructor(F,B,ee){this.d=F,this.f=B,this.g=ee,this.delegatingCommandId=`__vsc${(0,r.$mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(F,B){if(!F)return;const ee={$ident:void 0,id:F.command,title:F.title,tooltip:F.tooltip};if(!F.command)return ee;const J=this.f(F.command);if(J)ee.id=J.internalId,ee.arguments=J.args.map((V,R)=>V.convert(F.arguments&&F.arguments[R]));else if((0,m.$Lb)(F.arguments)){const V=`${F.command} /${++this.c}`;this.b.set(V,F),B.add((0,p.$Qc)(()=>{this.b.delete(V),this.g.trace("CommandsConverter#DISPOSE",V)})),ee.$ident=V,ee.id=this.delegatingCommandId,ee.arguments=[V],this.g.trace("CommandsConverter#CREATE",F.command,V)}return ee}fromInternal(F){return typeof F.$ident=="string"?this.b.get(F.$ident):{command:F.id,title:F.title,arguments:F.arguments}}getActualCommand(...F){return this.b.get(F[0])}h(...F){const B=this.getActualCommand(...F);return this.g.trace("CommandsConverter#EXECUTE",F[0],B?B.command:"MISSING"),B?this.d.executeCommand(B.command,...B.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${F[0]}`)}}e.$cN=D;class L{static Arr(F){return new L(`${F.name}_array`,`Array of ${F.name}, ${F.description}`,B=>Array.isArray(B)&&B.every(ee=>F.validate(ee)),B=>B.map(ee=>F.convert(ee)))}constructor(F,B,ee,J){this.name=F,this.description=B,this.validate=ee,this.convert=J}optional(){return new L(this.name,`(optional) ${this.description}`,F=>F==null||this.validate(F),F=>F===void 0?void 0:F===null?null:this.convert(F))}with(F,B){return new L(F??this.name,B??this.description,this.validate,this.convert)}}e.$dN=L,L.Uri=new L("uri","Uri of a text document",k=>l.URI.isUri(k),k=>k),L.Position=new L("position","A position in a text document",k=>P.$QK.isPosition(k),I.Position.from),L.Range=new L("range","A range in a text document",k=>P.$RK.isRange(k),I.Range.from),L.Selection=new L("selection","A selection in a text document",k=>P.$SK.isSelection(k),I.Selection.from),L.Number=new L("number","",k=>typeof k=="number",k=>k),L.String=new L("string","",k=>typeof k=="string",k=>k),L.StringArray=L.Arr(L.String),L.CallHierarchyItem=new L("item","A call hierarchy item",k=>k instanceof P.$aL,I.CallHierarchyItem.from),L.TypeHierarchyItem=new L("item","A type hierarchy item",k=>k instanceof P.$uM,I.TypeHierarchyItem.from),L.TestItem=new L("testItem","A VS Code TestItem",k=>k instanceof o.$5M,I.TestItem.from);class y{constructor(F,B){this.description=F,this.convert=B}}e.$eN=y,y.Void=new y("no result",k=>k);class E{constructor(F,B,ee,J,V){this.id=F,this.internalId=B,this.description=ee,this.args=J,this.result=V}}e.$fN=E}),define(Re[239],Ae([1,0,18,13,2,80,96,35,32,8,7]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;const C=[new g.$fN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of DocumentHighlight-instances.",p(b.DocumentHighlight.to))),new g.$fN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$dN.Uri],new g.$eN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,$.$Kb)(n))return;class i extends A.$8K{static to(a){const u=new i(a.name,b.SymbolKind.to(a.kind),a.containerName||"",new A.$2K(o[0],b.Range.to(a.range)));return u.detail=a.detail,u.range=u.location.range,u.selectionRange=b.Range.to(a.selectionRange),u.children=a.children?a.children.map(i.to):[],u}}return n.map(i.to)})),new g.$fN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$dN.Uri,new g.$dN("options","Formatting options",n=>!0,n=>n)],new g.$eN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new g.$fN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$dN.Uri,g.$dN.Range,new g.$dN("options","Formatting options",n=>!0,n=>n)],new g.$eN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new g.$fN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$dN.Uri,g.$dN.Position,new g.$dN("ch","Trigger character",n=>typeof n=="string",n=>n),new g.$dN("options","Formatting options",n=>!0,n=>n)],new g.$eN("A promise that resolves to an array of TextEdits.",p(b.TextEdit.to))),new g.$fN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$fN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$fN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$fN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$fN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location-instances.",p(b.location.to))),new g.$fN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Hover-instances.",p(b.Hover.to))),new g.$fN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$dN.Uri,new g.$dN("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>A.$QK.isPosition(o)),n=>n.map(b.Position.from))],new g.$eN("A promise that resolves to an array of ranges.",n=>n.map(o=>{let i;for(const s of o.reverse())i=new A.$_K(b.Range.to(s),i);return i}))),new g.$fN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$dN.String.with("query","Search string")],new g.$eN("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(b.WorkspaceSymbol.to))),new g.$fN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(b.CallHierarchyItem.to))),new g.$fN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$dN.CallHierarchyItem],new g.$eN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(b.CallHierarchyIncomingCall.to))),new g.$fN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$dN.CallHierarchyItem],new g.$eN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(b.CallHierarchyOutgoingCall.to))),new g.$fN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:b.Range.to(n.range),placeholder:n.text}})),new g.$fN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$dN.Uri,g.$dN.Position,g.$dN.String.with("newName","The new symbol name")],new g.$eN("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return b.WorkspaceEdit.to(n)}})),new g.$fN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$dN.Uri,g.$dN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$eN("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(b.DocumentLink.to))),new g.$fN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$dN.Uri],new g.$eN("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new A.$6L(n.tokenTypes,n.tokenModifiers)})),new g.$fN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$dN.Uri],new g.$eN("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,M.$n$)(n);if(o.type==="full")return new A.$8L(o.data,void 0)})),new g.$fN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$dN.Uri,g.$dN.Range.optional()],new g.$eN("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new A.$6L(n.tokenTypes,n.tokenModifiers)})),new g.$fN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$dN.Uri,g.$dN.Range],new g.$eN("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,M.$n$)(n);if(o.type==="full")return new A.$8L(o.data,void 0)})),new g.$fN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$dN.Uri,g.$dN.Position,g.$dN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$dN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$eN("A promise that resolves to a CompletionList-instance.",(n,o,i)=>{if(!n)return new A.$lL([]);const s=n.suggestions.map(a=>b.CompletionItem.to(a,i));return new A.$lL(s,n.incomplete)})),new g.$fN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$dN.Uri,g.$dN.Position,g.$dN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$eN("A promise that resolves to SignatureHelp.",n=>{if(n)return b.SignatureHelp.to(n)})),new g.$fN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$dN.Uri,g.$dN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$eN("A promise that resolves to an array of CodeLens-instances.",(n,o,i)=>p(s=>new A.$dL(b.Range.to(s.range),s.command&&i.fromInternal(s.command)))(n))),new g.$fN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$dN.Uri,new g.$dN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>A.$RK.isRange(n),n=>A.$SK.isSelection(n)?b.Selection.from(n):b.Range.from(n)),g.$dN.String.with("kind","Code action kind to return code actions for").optional(),g.$dN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$eN("A promise that resolves to an array of Command-instances.",(n,o,i)=>p(s=>{if(s._isSynthetic){if(!s.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(s.command)}else{const a=new A.$0K(s.title,s.kind?new A.$$K(s.kind):void 0);return s.edit&&(a.edit=b.WorkspaceEdit.to(s.edit)),s.command&&(a.command=i.fromInternal(s.command)),a.isPreferred=s.isPreferred,a}})(n))),new g.$fN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$dN.Uri],new g.$eN("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new A.$rL(b.Range.to(o.range),b.Color.to(o.color))):[])),new g.$fN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$dN("color","The color to show and insert",n=>n instanceof A.$qL,b.Color.from),new g.$dN("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:b.Range.from(n.range)}))],new g.$eN("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(b.ColorPresentation.to):[])),new g.$fN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$dN.Uri,g.$dN.Range],new g.$eN("A promise that resolves to an array of Inlay objects",(n,o,i)=>n.map(b.InlayHint.to.bind(void 0,i)))),new g.$fN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$dN.Uri],new g.$eN("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(b.FoldingRange.to)})),new g.$fN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$eN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>b.NotebookExclusiveDocumentPattern.to(o))})))),new g.$fN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$dN.Uri,g.$dN.Range,new g.$dN("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof A.$RK,n=>b.InlineValueContext.from(n))],new g.$eN("A promise that resolves to an array of InlineValue objects",n=>n.map(b.InlineValue.to))),new g.$fN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$dN("uriOrString","Uri-instance or string (only http/https)",n=>I.URI.isUri(n)||typeof n=="string"&&(0,P.$bg)(n,P.Schemas.http,P.Schemas.https),n=>n),new g.$dN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[b.ViewColumn.from(n),void 0]:[b.ViewColumn.from(n.viewColumn),b.TextEditorOpenOptions.from(n)])).optional(),g.$dN.String.with("label","").optional()],g.$eN.Void),new g.$fN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$dN.Uri.with("resource","Resource to open"),g.$dN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$dN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[b.ViewColumn.from(n),void 0]:[b.ViewColumn.from(n.viewColumn),b.TextEditorOpenOptions.from(n)])).optional()],g.$eN.Void),new g.$fN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$dN.Uri.with("left","Left-hand side resource of the diff editor"),g.$dN.Uri.with("right","Right-hand side resource of the diff editor"),g.$dN.String.with("title","Human readable title for the diff editor").optional(),new g.$dN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[b.ViewColumn.from(n.viewColumn),b.TextEditorOpenOptions.from(n)]).optional()],g.$eN.Void),new g.$fN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$dN.String.with("title","Human readable title for the changes editor"),new g.$dN("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[i,s,a]=o;if(!I.URI.isUri(i)||!I.URI.isUri(s)&&s!==void 0&&s!==null||!I.URI.isUri(a)&&a!==void 0&&a!==null)return!1}return!0},n=>n)],g.$eN.Void),new g.$fN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(b.TypeHierarchyItem.to))),new g.$fN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$dN.TypeHierarchyItem],new g.$eN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(b.TypeHierarchyItem.to))),new g.$fN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$dN.TypeHierarchyItem],new g.$eN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(b.TypeHierarchyItem.to))),new g.$fN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$dN.TestItem],g.$eN.Void),new g.$fN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$dN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$eN.Void),new g.$fN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$dN.String.with("name","The context key name"),new g.$dN("value","The context key value",()=>!0,n=>n)],g.$eN.Void),new g.$fN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$dN.Uri,g.$dN.StringArray,new g.$dN("MappedEditsContext","Mapped Edits Context",n=>b.MappedEditsContext.is(n),n=>b.MappedEditsContext.from(n))],new g.$eN("A promise that resolves to a workspace edit or null",n=>n?b.WorkspaceEdit.to(n):null))];class l{static register(o){C.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$1i)}}e.$lfc=l;function p(n){return o=>{if(Array.isArray(o))return o.map(n)}}function v(n){if(!Array.isArray(n))return;const o=[];for(const i of n)T.$tt(i)?o.push(b.DefinitionLink.to(i)):o.push(b.location.to(i));return o}}),define(Re[240],Ae([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;function p(v,n,o){const i=v.getProxy(C.$NK.MainThreadComments);class s{constructor(){this.b=new Map,this.c=new g.$jm,n.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const D=this.b.get(d.handle);return D?D.value:d}else if(d&&d.$mid===7){const D=this.b.get(d.commentControlHandle);if(!D)return d;const L=D.getCommentThread(d.commentThreadHandle);return L?L.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const L=D.getCommentThread(d.thread.commentThreadHandle);return L?d.$mid===8?L.value:{thread:L.value,text:d.text}:d}else if(d&&d.$mid===10){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const L=D.getCommentThread(d.thread.commentThreadHandle);if(!L)return d;const y=d.commentUniqueId,E=L.getCommentByUniqueId(y);return E||d}else if(d&&d.$mid===11){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const L=D.getCommentThread(d.thread.commentThreadHandle);if(!L)return d;const y=d.text,E=d.commentUniqueId,k=L.getCommentByUniqueId(E);return k?(typeof k.body=="string"?k.body=y:k.body=new A.$eL(y),k):d}return d}})}createCommentController(d,D,L){const y=s.a++,E=new u(d,y,D,L);this.b.set(E.handle,E);const k=this.c.get(d.identifier)||[];return k.push(E),this.c.set(d.identifier,k),E.value}async $createCommentThreadTemplate(d,D,L){const y=this.b.get(d);y&&y.$createCommentThreadTemplate(D,L)}async $updateCommentThreadTemplate(d,D,L){const y=this.b.get(d);y&&y.$updateCommentThreadTemplate(D,L)}$deleteCommentThread(d,D){this.b.get(d)?.$deleteCommentThread(D)}$provideCommentingRanges(d,D,L){const y=this.b.get(d);if(!y||!y.commentingRangeProvider)return Promise.resolve(void 0);const E=o.getDocument(M.URI.revive(D));return(0,$.$Ug)(async()=>{const k=await y.commentingRangeProvider.provideCommentingRanges(E,L);let F;return Array.isArray(k)?F={ranges:k,fileComments:!1}:k?F={ranges:k.ranges||[],fileComments:k.fileComments||!1}:F=k??void 0,F}).then(k=>{let F;return k&&(F={ranges:k.ranges.map(B=>b.Range.from(B)),fileComments:k.fileComments}),F})}$toggleReaction(d,D,L,y,E){const k=this.b.get(d);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,$.$Ug)(()=>{const F=k.getCommentThread(D);if(F){const B=F.getCommentByUniqueId(y.uniqueIdInThread);if(k!==void 0&&B&&k.reactionHandler)return k.reactionHandler(B,r(E))}return Promise.resolve(void 0)})}}s.a=0;class a{set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,D,L,y,E,k,F,B){this.m=D,this.n=L,this.o=y,this.p=E,this.q=k,this.extensionDescription=F,this.r=B,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Tc,this.l.value=new T.$Rc,this.n===void 0&&(this.n=`${d}.${this.handle}`),i.$createCommentThread(D,this.handle,this.n,this.o,b.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{i.$deleteCommentThread(D,this.handle)}});const ee=this;this.value={get uri(){return ee.uri},get range(){return ee.range},set range(J){ee.range=J},get comments(){return ee.comments},set comments(J){ee.comments=J},get collapsibleState(){return ee.collapsibleState},set collapsibleState(J){ee.collapsibleState=J},get canReply(){return ee.canReply},set canReply(J){ee.canReply=J},get contextValue(){return ee.contextValue},set contextValue(J){ee.contextValue=J},get label(){return ee.label},set label(J){ee.label=J},get state(){return ee.state},set state(J){ee.state=J},dispose:()=>{ee.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Rc);const d=L=>Object.prototype.hasOwnProperty.call(this.b,L),D={};d("range")&&(D.range=b.Range.from(this.p)),d("label")&&(D.label=this.label),d("contextValue")&&(D.contextValue=this.contextValue??null),d("comments")&&(D.comments=this.q.map(L=>h(this,L,this.k,this.extensionDescription))),d("collapsibleState")&&(D.collapseState=c(this.g)),d("canReply")&&(D.canReply=this.canReply),d("state")&&(D.state=f(this.h)),d("isTemplate")&&(D.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(d){for(const D of this.k){const L=D[0],y=D[1];if(d===y)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}a.a=0,Je([(0,P.$uh)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class u{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,D,L,y){this.f=d,this.g=D,this.h=L,this.i=y,this.a=new Map,i.$registerCommentController(this.handle,L,y,this.f.identifier.value);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(k){E.options=k},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(k){E.commentingRangeProvider=k},get reactionHandler(){return E.reactionHandler},set reactionHandler(k){E.reactionHandler=k},createCommentThread(k,F,B){return E.createCommentThread(k,F,B).value},dispose:()=>{E.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(d,D,L){D===void 0&&(0,l.$lF)(this.f,"fileComments");const y=new a(this.id,this.handle,void 0,d,D,L,this.f,!1);return this.a.set(y.handle,y),y}$createCommentThreadTemplate(d,D){const L=new a(this.id,this.handle,void 0,M.URI.revive(d),b.Range.to(D),[],this.f,!0);return L.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(d,D){const L=this.a.get(d);L&&(L.range=b.Range.to(D))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function h(w,d,D,L){let y=D.get(d);return y||(y=++w.commentHandle,D.set(d,y)),d.state!==void 0&&(0,l.$lF)(L,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:y,body:typeof d.body=="string"?d.body:b.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(E=>t(E)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(w){return{label:w.label,iconPath:w.iconPath?b.$QM(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function r(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?M.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function c(w){if(w!==void 0)switch(w){case A.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function f(w){if(w!==void 0)switch(w){case A.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new s}e.$vfc=p}),define(Re[241],Ae([1,0,26,3,27,17]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;let M=class{constructor(A,C){this.a=A.getProxy(P.$NK.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,C){const l=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,C,p,arguments)}})}e(A,C,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:g(p,this.b)}),this.c&&this.f(A,l,p)}};e.$jhc=M,e.$jhc=M=Je([Ge(0,T.$RM),Ge(1,I.$8M)],M);const m=1e5;function g(b,A){const C=[];if(b.length)for(let l=0;l<b.length;l++){let p=b[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const v=p;v.stack?p=v.stack:p=v.toString()}C.push(p)}if(A){const l=new Error().stack;l&&C.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,$.$nn)(C);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Re[110],Ae([1,0,2,3,7,4,17,15,18,12,19,23]),function(ie,e,$,P,I,T,M,m,g,b,A,C){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=e.$lgc=void 0;let p=l=class{constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(P.$NK.MainThreadDecorations)}registerFileDecorationProvider(n,o){const i=l.c++;this.f.set(i,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(i,o.identifier.value);const s=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(i,null);return}const u=(0,g.$3b)(a);if(u.length<=l.d){this.g.$onDidChange(i,u);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,u.length);const h=u.map(c=>({uri:c,rank:(0,b.$Le)(c.path,"/")})),t=(0,g.$zb)(h,(c,f)=>c.rank-f.rank||(0,b.$1e)(c.uri.path,f.uri.path)),r=[];e:for(const c of t){let f;for(const w of c){const d=(0,A.$mc)(w.uri.path);if(f!==d&&(f=d,r.push(w.uri)>=l.d))break e}}this.g.$onDidChange(i,r)});return new I.$PK(()=>{s?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(n,o,i){if(!this.f.has(n))return Object.create(null);const s=Object.create(null),{provider:a,extensionDescription:u}=this.f.get(n);return await Promise.all(o.map(async h=>{try{const{uri:t,id:r}=h,c=await Promise.resolve(a.provideFileDecoration($.URI.revive(t),i));if(!c)return;try{I.$_L.validate(c),c.badge&&typeof c.badge!="string"&&(0,C.$lF)(u,"codiconDecoration"),s[r]=[c.propagate,c.tooltip,c.badge,c.color]}catch(f){this.h.warn(`INVALID decoration from extension '${u.identifier.value}': ${f}`)}}catch(t){this.h.error(t)}})),s}};e.$lgc=p,p.c=0,p.d=250,e.$lgc=p=l=Je([Ge(0,M.$RM),Ge(1,m.$jj)],p),e.$mgc=(0,T.$2h)("IExtHostDecorations")});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[242],Ae([1,0,158,99,2,3,7,8,5,15,28,43]),function(ie,e,$,P,I,T,M,m,g,b,A,C){"use strict";var l,p,v,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0;class o{constructor(a,u,h,t,r,c,f,w){this.d=a,this.e=u,this.f=h,this.g=t,this.h=r,l.set(this,void 0),p.set(this,void 0),v.set(this,void 0),this.c=!1,this.f=Math.max(t,h),xe(this,v,new A.$Ac(d=>c.getComparisonKey(d)),"f"),xe(this,l,f,"f"),xe(this,p,w,"f")}dispose(){this.c||(ze(this,p,"f").fire([...ze(this,v,"f").keys()]),ze(this,l,"f")?.$clear(this.e),ze(this,v,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,u){if(!a){this.clear();return}this.j();let h=[];if(I.URI.isUri(a)){if(!u){this.delete(a);return}ze(this,v,"f").set(a,u.slice()),h=[a]}else if(Array.isArray(a)){h=[];let c;a=[...a].sort(o.k);for(const f of a){const[w,d]=f;if((!c||w.toString()!==c.toString())&&(c&&ze(this,v,"f").get(c).length===0&&ze(this,v,"f").delete(c),c=w,h.push(w),ze(this,v,"f").set(w,[])),d)ze(this,v,"f").get(w)?.push(...d);else{const D=ze(this,v,"f").get(w);D&&(D.length=0)}}}if(ze(this,p,"f").fire(h),!ze(this,l,"f"))return;const t=[];let r=0;for(const c of h){let f=[];const w=ze(this,v,"f").get(c);if(w)if(w.length>this.g){f=[];const d=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let D=0;D<4;D++)for(const L of w)if(L.severity===d[D]&&f.push({...m.Diagnostic.from(L),modelVersionId:this.h(c)})===this.g)break e;f.push({severity:P.MarkerSeverity.Info,message:(0,$.localize)(0,null,w.length-this.g),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=w.map(d=>({...m.Diagnostic.from(d),modelVersionId:this.h(c)}));if(t.push([c,f]),r+=f.length,r>this.f)break}ze(this,l,"f").$changeMany(this.e,t)}delete(a){this.j(),ze(this,p,"f").fire([a]),ze(this,v,"f").delete(a),ze(this,l,"f")?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),ze(this,p,"f").fire([...ze(this,v,"f").keys()]),ze(this,v,"f").clear(),ze(this,l,"f")?.$clear(this.e)}forEach(a,u){this.j();for(const[h,t]of this)a.call(u,h,t,this)}*[(l=new WeakMap,p=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.j();for(const a of ze(this,v,"f").keys())yield[a,this.get(a)]}get(a){this.j();const u=ze(this,v,"f").get(a);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(a){return this.j(),Array.isArray(ze(this,v,"f").get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,u){return a[0].toString()<u[0].toString()?-1:a[0].toString()>u[0].toString()?1:0}}e.$ffc=o;let i=n=class{static _mapper(a){const u=new A.$Ac;for(const h of a)u.set(h,h);return{uris:Object.freeze(Array.from(u.values()))}}constructor(a,u,h,t){this.j=u,this.k=h,this.l=t,this.g=new Map,this.h=new g.$Wd({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,n._mapper),this.f=a.getProxy(T.$NK.MainThreadDiagnostics)}createDiagnosticCollection(a,u){const{g:h,f:t,h:r,j:c,k:f,l:w}=this,d=new class{$changeMany(y,E){t.$changeMany(y,E),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,y,E.length===0?"CLEARING":E)}$clear(y){t.$clear(y),c.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,y)}dispose(){t.dispose()}};let D;if(!u)u="_generated_diagnostic_collection_name_#"+n.c++,D=u;else if(!h.has(u))D=u;else{this.j.warn(`DiagnosticCollection with name '${u}' does already exist.`);do D=u+n.c++;while(h.has(D))}return new class extends o{constructor(){super(u,D,n.e,n.d,y=>w.getDocument(y)?.version,f.extUri,d,r),h.set(D,this)}dispose(){super.dispose(),h.delete(D)}}}getDiagnostics(a){if(a)return this.m(a);{const u=new Map,h=[];for(const t of this.g.values())t.forEach((r,c)=>{let f=u.get(r.toString());typeof f>"u"&&(f=h.length,u.set(r.toString(),f),h.push([r,[]])),h[f][1]=h[f][1].concat(...c)});return h}}m(a){let u=[];for(const h of this.g.values())h.has(a)&&(u=u.concat(h.get(a)));return u}$acceptMarkersChange(a){if(!this.n){const u="_generated_mirror",h=new o(u,u,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(u,h),this.n=h}for(const[u,h]of a)this.n.set(I.URI.revive(u),h.map(m.Diagnostic.to))}};e.$gfc=i,i.c=0,i.d=1e3,i.e=1.1*n.d,e.$gfc=i=n=Je([Ge(1,b.$jj),Ge(2,C.$efc)],i)}),define(Re[243],Ae([1,0,2,3,23]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class T{constructor(m){this.a=m.getProxy(P.$NK.MainThreadDialogs)}showOpenDialog(m,g){return g?.allowUIResources&&(0,I.$lF)(m,"showLocal"),this.a.$showOpenDialog(g).then(b=>b?b.map(A=>$.URI.revive(A)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(g=>g?$.URI.revive(g):void 0)}}e.$ngc=T}),define(Re[244],Ae([1,0,11,2,7,3,13,20,12]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class b{constructor(C,l,p){this.d=l,this.e=p,this.b=new Map,this.c=C.getProxy(T.$NK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,l){if(Object.keys(M.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const p=b.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,C);let v;return typeof l.onDidChange=="function"&&(v=l.onDidChange(n=>{if(n.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this.d.getDocument(n)&&this.$provideTextDocumentContent(p,n).then(o=>{if(!o&&typeof o!="string")return;const i=this.d.getDocument(n);if(!i)return;const s=(0,g.$Ve)(o);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(n,o)},$.$1)})),new I.$PK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(C,l){const p=this.b.get(C);return p?Promise.resolve(p.provideTextDocumentContent(P.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$ogc=b,b.a=0}),define(Re[245],Ae([1,0,5,6,2,3,103,8,16,26,7,11]),function(ie,e,$,P,I,T,M,m,g,b,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class l{constructor(v,n){this.a=new $.$Sd({onListenerError:C.$2}),this.b=new $.$Sd({onListenerError:C.$2}),this.c=new $.$Sd({onListenerError:C.$2}),this.d=new $.$Sd({onListenerError:C.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new P.$Rc,this.h=new Map,this.f=v.getProxy(T.$NK.MainThreadDocuments),this.g=n,this.g.onDidRemoveDocuments(o=>{for(const i of o)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const i of o)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const n=this.g.getDocument(v);if(n)return n}getDocument(v){const n=this.getDocumentData(v);if(!n?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return n.document}ensureDocumentData(v){const n=this.g.getDocument(v);if(n)return Promise.resolve(n);let o=this.h.get(v.toString());return o||(o=this.f.$tryOpenDocument(v).then(i=>{this.h.delete(v.toString());const s=I.URI.revive(i);return(0,g.$Pf)(this.g.getDocument(s))},i=>(this.h.delete(v.toString()),Promise.reject(i))),this.h.set(v.toString(),o)),o}createDocumentData(v){return this.f.$tryCreateDocument(v).then(n=>I.URI.revive(n))}$acceptModelLanguageChanged(v,n){const o=I.URI.revive(v),i=this.g.getDocument(o);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(n),this.a.fire(i.document)}$acceptModelSaved(v){const n=I.URI.revive(v),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(v,n){const o=I.URI.revive(v),i=this.g.getDocument(o);if(!i)throw new Error("unknown document");i._acceptIsDirty(n),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,n,o){const i=I.URI.revive(v),s=this.g.getDocument(i);if(!s)throw new Error("unknown document");s._acceptIsDirty(o),s.onEvents(n);let a;n.isUndoing?a=A.TextDocumentChangeReason.Undo:n.isRedoing&&(a=A.TextDocumentChangeReason.Redo),this.c.fire((0,b.$jn)({document:s.document,contentChanges:n.changes.map(u=>({range:m.Range.to(u.range),rangeOffset:u.rangeOffset,rangeLength:u.rangeLength,text:u.text})),reason:a}))}setWordDefinitionFor(v,n){(0,M.$TM)(v,n)}}e.$cfc=l}),define(Re[61],Ae([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,68,39]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.$2M=void 0;class i{constructor(u){this.value=u,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let s=class{constructor(u,h){this.h=u,this.i=h,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new P.$Sd,this.e=new P.$Sd,this.f=new P.$Sd,this.g=new P.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const h=[],t=[],r=[];if(u.removedDocuments)for(const c of u.removedDocuments){const f=T.URI.revive(c),w=this.c.get(f);w?.unref()&&(this.c.delete(f),h.push(w.value))}if(u.addedDocuments)for(const c of u.addedDocuments){const f=T.URI.revive(c.uri);let w=this.c.get(f);if(w&&f.scheme!==v.Schemas.vscodeNotebookCell&&f.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);w||(w=new i(new g.$UM(this.h.getProxy(m.$NK.MainThreadDocuments),f,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(f,w),t.push(w.value)),w.ref()}if(u.removedEditors)for(const c of u.removedEditors){const f=this.b.get(c);this.b.delete(c),f&&r.push(f)}if(u.addedEditors)for(const c of u.addedEditors){const f=T.URI.revive(c.documentUri);$.ok(this.c.has(f),`document '${f}' does not exist`),$.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const w=this.c.get(f).value,d=new A.$1M(c.id,this.h.getProxy(m.$NK.MainThreadTextEditors),this.i,new o.$V(()=>w.document),c.selections.map(C.Selection.to),c.options,c.visibleRanges.map(D=>C.Range.to(D)),typeof c.editorPosition=="number"?C.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,d)}u.newActiveEditor!==void 0&&($.ok(u.newActiveEditor===null||this.b.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this.a=u.newActiveEditor),(0,I.$Nc)(h),(0,I.$Nc)(r),u.removedDocuments&&this.e.fire(h),u.addedDocuments&&this.d.fire(t),(u.removedEditors||u.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),u.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(u){return this.c.get(u)?.value}allDocuments(){return n.Iterable.map(this.c.values(),u=>u.value)}getEditor(u){return this.b.get(u)}activeEditor(u){if(!this.a)return;const h=this.b.get(this.a);return u?h:h?.value}allEditors(){return[...this.b.values()]}};e.$2M=s,e.$2M=s=Je([Ge(0,b.$RM),Ge(1,l.$jj)],s),e.$3M=(0,M.$2h)("IExtHostDocumentsAndEditors")}),define(Re[62],Ae([1,0,246,5,16,2,4,3,17,8,7]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=void 0,e.$Ofc=(0,M.$2h)("IExtHostEditorTabs");class C{constructor(o,i,s){this.e=s,this.d=i,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,i={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$vM(T.URI.revive(this.b.input.uri));case 2:return new A.$wM(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case 3:return new A.$xM(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case 6:return new A.$yM(T.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$zM(this.b.input.viewType);case 4:return new A.$AM(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$BM(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$CM;case 9:return new A.$DM(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$EM(this.b.input.providerId);default:return}}}class l{constructor(o,i){this.c=[],this.d="",this.b=o,this.e=i;for(const s of o.tabs)s.isActive&&(this.d=s.id),this.c.push(new C(s,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,i={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return b.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(s=>s.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(s=>s.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const s=new C(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,s),o.tabDto.isActive&&(this.d=s.tabId),s}else if(o.kind===1){const s=this.c.splice(o.index,1)[0];if(!s)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return s.tabId===this.d&&(this.d=""),s}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const s=this.c.splice(o.oldIndex,1)[0];if(!s)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,s),s}const i=this.c.find(s=>s.tabId===o.tabDto.id);if(!i)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(o.tabDto),i}activeTabId(){return this.d}}let p=class{constructor(o){this.b=new P.$Sd,this.c=new P.$Sd,this.e=[],this.a=o.getProxy(m.$NK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,i={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(s=>s.apiObject))},get activeTabGroup(){const s=o.d;return(0,I.$Pf)(o.e.find(u=>u.groupId===s)?.apiObject)},close:async(s,a)=>{const u=Array.isArray(s)?s:[s];return u.length?v(u[0])?this.j(u,a):this.i(u,a):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(o){const i=new Set(this.e.map(c=>c.groupId)),s=new Set(o.map(c=>c.groupId)),a=(0,$.$F)(i,s),u=this.e.filter(c=>a.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=o.map(c=>{const f=new l(c,()=>this.d);return a.added.includes(f.groupId)?h.push(f.apiObject):t.push(f.apiObject),f});const r=(0,I.$Pf)(o.find(c=>c.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:h,closed:u,changed:t}))}$acceptTabGroupUpdate(o){const i=this.e.find(s=>s.groupId===o.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const i=this.e.find(a=>a.groupId===o.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const s=i.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[s.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[s.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[s.apiObject]}));return}}g(o){for(const i of this.e)for(const s of i.tabs)if(s.apiObject===o)return s}h(o){return this.e.find(i=>i.apiObject===o)}async i(o,i){const s=[];for(const a of o){const u=this.g(a);if(!u)throw new Error("Tab close: Invalid tab not found!");s.push(u.tabId)}return this.a.$closeTab(s,i)}async j(o,i){const s=[];for(const a of o){const u=this.h(a);if(!u)throw new Error("Group close: Invalid group not found!");s.push(u.groupId)}return this.a.$closeGroup(s,i)}};e.$Pfc=p,e.$Pfc=p=Je([Ge(0,g.$RM)],p);function v(n){return n.tabs!==void 0}}),define(Re[247],Ae([1,0,3,7]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class I{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy($.$NK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,m,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const b=this.a.get(M);if(!b)throw new Error("Embedding vector provider not found");const A=await b.provideEmbeddingVector(m,g);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,m,g){const b=this.b;return this.b++,this.a.set(b,g),this.c.$registerAiEmbeddingVectorProvider(m,b),new P.$PK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(b),this.a.delete(b)})}}e.$qgc=I}),define(Re[248],Ae([1,0,2,3,6,7,8,296,12,24,23,52]),function(ie,e,$,P,I,T,M,m,g,b,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class l{constructor(){this.a=[]}add(n){this.b=void 0,this.a.push(n)}delete(n){const o=this.a.indexOf(n);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const n=this.a.sort(),o=[];let i,s,a=14,u=14;for(const h of n){let t=i?(0,g.$0e)(i,h):0;for(t===0?s=1:s=u;t<h.length;t++)t+1===h.length?(a=u,u=9):u+=1,o.push([s,h.toUpperCase().charCodeAt(t),u]),o.push([s,h.toLowerCase().charCodeAt(t),u]),s=u;i=h,u=a}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$pZ(o)}}provideDocumentLinks(n){this.c();const o=[],i=m.$qZ.computeLinks({getLineContent(s){return n.lineAt(s-1).text},getLineCount(){return n.lineCount}},this.b);for(const s of i){const a=M.DocumentLink.to(s);a.target&&o.push(a)}return o}}class p{constructor(n,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=n.getProxy(P.$NK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(n,o,i,s={}){if(p.j(i),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(n,"*",this.b));const a=this.h++;this.b.add(o),this.d.add(o),this.c.set(a,i);let u=2;s.isCaseSensitive&&(u+=1024),s.isReadonly&&(u+=2048),typeof i.copy=="function"&&(u+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,A.$lF)(n,"fsChunks"),u+=4);let h;s.isReadonly&&(0,C.$fk)(s.isReadonly)&&((0,A.$lF)(n,"readonlyMessage"),h={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(a,o,u,h).catch(r=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${o}`),console.error(r)});const t=i.onDidChangeFile(r=>{const c=[];for(const f of r){const{uri:w,type:d}=f;if(w.scheme!==o)continue;let D;switch(d){case T.FileChangeType.Changed:D=0;break;case T.FileChangeType.Created:D=1;break;case T.FileChangeType.Deleted:D=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:w,type:D})}this.a.$onFileSystemChange(a,c)});return(0,I.$Qc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(a),this.a.$unregisterProvider(a)})}static j(n){if(!n)throw new Error("MISSING provider");if(typeof n.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof n.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof n.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof n.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof n.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof n.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof n.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof n.rename!="function")throw new Error("Provider does NOT implement rename")}static k(n){const{type:o,ctime:i,mtime:s,size:a,permissions:u}=n;return{type:o,ctime:i,mtime:s,size:a,permissions:u}}$stat(n,o){return Promise.resolve(this.l(n).stat($.URI.revive(o))).then(i=>p.k(i))}$readdir(n,o){return Promise.resolve(this.l(n).readDirectory($.URI.revive(o)))}$readFile(n,o){return Promise.resolve(this.l(n).readFile($.URI.revive(o))).then(i=>b.$ge.wrap(i))}$writeFile(n,o,i,s){return Promise.resolve(this.l(n).writeFile($.URI.revive(o),i.buffer,s))}$delete(n,o,i){return Promise.resolve(this.l(n).delete($.URI.revive(o),i))}$rename(n,o,i,s){return Promise.resolve(this.l(n).rename($.URI.revive(o),$.URI.revive(i),s))}$copy(n,o,i,s){const a=this.l(n);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy($.URI.revive(o),$.URI.revive(i),s))}$mkdir(n,o){return Promise.resolve(this.l(n).createDirectory($.URI.revive(o)))}$watch(n,o,i,s){const a=this.l(n).watch($.URI.revive(i),s);this.f.set(o,a)}$unwatch(n,o){const i=this.f.get(o);i&&(i.dispose(),this.f.delete(o))}$open(n,o,i){const s=this.l(n);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open($.URI.revive(o),i))}$close(n,o){const i=this.l(n);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(o))}$read(n,o,i,s){const a=this.l(n);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const u=b.$ge.alloc(s);return Promise.resolve(a.read(o,i,u.buffer,0,s)).then(h=>u.slice(0,h))}$write(n,o,i,s){const a=this.l(n);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(o,i,s.buffer,0,s.byteLength))}l(n){const o=this.c.get(n);if(!o){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return o}}e.$rgc=p}),define(Re[63],Ae([1,0,3,42,7,24,4,17,43,6,14,25,13]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=void 0;let v=p=class{constructor(o,i){this.b=new Map,this.c=new A.$$g,this.a=o.getProxy($.$NK.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(a){try{let u;const h=s.b.get(a.scheme);return h?(await s.a.$ensureActivation(a.scheme),u=await h.impl.stat(a)):u=await s.a.$stat(a),{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===P.FilePermission.Readonly?1:void 0}}catch(u){p.e(u)}},async readDirectory(a){try{const u=s.b.get(a.scheme);return u?(await s.a.$ensureActivation(a.scheme),(await u.impl.readDirectory(a)).slice()):await s.a.$readdir(a)}catch(u){return p.e(u)}},async createDirectory(a){try{const u=s.b.get(a.scheme);return u&&!u.isReadonly?(await s.a.$ensureActivation(a.scheme),await s.d(u.impl,u.extUri,a)):await s.a.$mkdir(a)}catch(u){return p.e(u)}},async readFile(a){try{const u=s.b.get(a.scheme);return u?(await s.a.$ensureActivation(a.scheme),(await u.impl.readFile(a)).slice()):(await s.a.$readFile(a)).buffer}catch(u){return p.e(u)}},async writeFile(a,u){try{const h=s.b.get(a.scheme);return h&&!h.isReadonly?(await s.a.$ensureActivation(a.scheme),await s.d(h.impl,h.extUri,h.extUri.dirname(a)),await s.c.queueFor(a).queue(()=>Promise.resolve(h.impl.writeFile(a,u,{create:!0,overwrite:!0})))):await s.a.$writeFile(a,T.$ge.wrap(u))}catch(h){return p.e(h)}},async delete(a,u){try{const h=s.b.get(a.scheme);return h&&!h.isReadonly?(await s.a.$ensureActivation(a.scheme),await h.impl.delete(a,{recursive:!1,...u})):await s.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...u})}catch(h){return p.e(h)}},async rename(a,u,h){try{return await s.a.$rename(a,u,{overwrite:!1,...h})}catch(t){return p.e(t)}},async copy(a,u,h){try{return await s.a.$copy(a,u,{overwrite:!1,...h})}catch(t){return p.e(t)}},isWritableFileSystem(a){const u=i.getCapabilities(a);if(typeof u=="number")return!(u&2048)}})}async d(o,i,s){const a=[];for(;!i.isEqual(s,i.dirname(s));)try{if(!((await o.stat(s)).type&P.FileType.Directory))throw I.$4L.FileExists(`Unable to create folder '${s.scheme===l.Schemas.file?s.fsPath:s.toString(!0)}' that already exists but is not a directory`);break}catch(u){if(P.$Bk(u)!==P.FileSystemProviderErrorCode.FileNotFound)throw u;a.push(i.basename(s)),s=i.dirname(s)}for(let u=a.length-1;u>=0;u--){s=i.joinPath(s,a[u]);try{await o.createDirectory(s)}catch(h){if(P.$Bk(h)!==P.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof I.$4L)throw o;if(o instanceof P.$xk)switch(o.code){case P.FileSystemProviderErrorCode.FileExists:throw I.$4L.FileExists(o.message);case P.FileSystemProviderErrorCode.FileNotFound:throw I.$4L.FileNotFound(o.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw I.$4L.FileNotADirectory(o.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw I.$4L.FileIsADirectory(o.message);case P.FileSystemProviderErrorCode.NoPermissions:throw I.$4L.NoPermissions(o.message);case P.FileSystemProviderErrorCode.Unavailable:throw I.$4L.Unavailable(o.message);default:throw new I.$4L(o.message,o.name)}if(!(o instanceof Error))throw new I.$4L(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$4L.Unavailable(o.message);switch(o.name){case P.FileSystemProviderErrorCode.FileExists:throw I.$4L.FileExists(o.message);case P.FileSystemProviderErrorCode.FileNotFound:throw I.$4L.FileNotFound(o.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw I.$4L.FileNotADirectory(o.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw I.$4L.FileIsADirectory(o.message);case P.FileSystemProviderErrorCode.NoPermissions:throw I.$4L.NoPermissions(o.message);case P.FileSystemProviderErrorCode.Unavailable:throw I.$4L.Unavailable(o.message);default:throw new I.$4L(o.message,o.name)}}addFileSystemProvider(o,i,s){return this.b.set(o,{impl:i,extUri:s?.isCaseSensitive?C.$tg:C.$vg,isReadonly:!!s?.isReadonly}),(0,b.$Qc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??C.$tg}};e.$Dfc=v,e.$Dfc=v=p=Je([Ge(0,m.$RM),Ge(1,g.$efc)],v),e.$Efc=(0,M.$2h)("IExtHostConsumerFileSystem")}),define(Re[249],Ae([1,0,5,33,2,3,8,7,39]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class b{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,v,n,o,i,s){this.a=Math.random(),this.b=new $.$Sd,this.c=new $.$Sd,this.d=new $.$Sd,this.h=0,s?.ignoreCreateEvents&&(this.h+=1),s?.ignoreChangeEvents&&(this.h+=2),s?.ignoreDeleteEvents&&(this.h+=4);const a=(0,P.$Ij)(i),u=typeof i=="string",h=s?.correlate,t=o(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(h&&typeof r.session>"u")){if(!s?.ignoreCreateEvents)for(const c of r.created){const f=I.URI.revive(c);a(f.fsPath)&&(!u||v.getWorkspaceFolder(f))&&this.b.fire(f)}if(!s?.ignoreChangeEvents)for(const c of r.changed){const f=I.URI.revive(c);a(f.fsPath)&&(!u||v.getWorkspaceFolder(f))&&this.c.fire(f)}if(!s?.ignoreDeleteEvents)for(const c of r.deleted){const f=I.URI.revive(c);a(f.fsPath)&&(!u||v.getWorkspaceFolder(f))&&this.d.fire(f)}}});this.g=m.$PK.from(this.i(p,n,i,s,s?.correlate),this.b,this.c,this.d,t)}i(p,v,n,o,i){const s=m.$PK.from();if(typeof n=="string")return s;const a=p.getProxy(T.$NK.MainThreadFileSystemEventService);let u=!1;return(n.pattern.includes(P.$Ej)||n.pattern.includes(P.$Fj))&&(u=!0),a.$watch(v.identifier.value,this.a,n.baseUri,{recursive:u,excludes:o?.excludes??[]},!!i),m.$PK.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(I.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(p,v,n){this.j=p,this.k=v,this.l=n,this.a=new $.$Sd,this.b=new $.$Sd,this.c=new $.$Sd,this.d=new $.$Sd,this.g=new $.$Ud,this.h=new $.$Ud,this.i=new $.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,v,n,o){return new b(this.j,p,v,this.a.event,M.GlobPattern.from(n),o)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,v){switch(p){case 2:this.b.fire(Object.freeze({files:v.map(n=>({oldUri:I.URI.revive(n.source),newUri:I.URI.revive(n.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(n=>I.URI.revive(n.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(n=>I.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,v){return(n,o,i)=>{const s=function(u){n.call(o,u)};return s.extension=p,v.event(s,void 0,i)}}async $onWillRunFileOperation(p,v,n,o){switch(p){case 2:return await this.n(this.g,{files:v.map(i=>({oldUri:I.URI.revive(i.source),newUri:I.URI.revive(i.target)}))},n,o);case 1:return await this.n(this.i,{files:v.map(i=>I.URI.revive(i.target))},n,o);case 0:case 3:return await this.n(this.h,{files:v.map(i=>I.URI.revive(i.target))},n,o)}}async n(p,v,n,o){const i=new Set,s=[];if(await p.fireAsync(v,o,async(u,h)=>{const t=Date.now(),r=await Promise.resolve(u);r instanceof m.$ZK&&(s.push([h.extension,r]),i.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>n&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||s.length===0)return;const a={edits:[]};for(const[,u]of s){const{edits:h}=M.WorkspaceEdit.from(u,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(h)}return{edit:a,extensionNames:Array.from(i)}}}e.$sgc=C}),define(Re[250],Ae([1,0,6,2,3,8,7,32,14]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class b{constructor(p,v){this.extension=p,this.provider=v,this.handle=b.a++}}b.a=0;class A{constructor(p){this.session=p,this.responses=[]}}class C{constructor(p,v,n,o){this.f=n,this.g=o,this.b=new Map,this.d=new Map,this.e=p.getProxy(I.$NK.MainThreadInlineChat),v.registerApiCommand(new m.$fN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$dN("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?T.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?T.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?T.Position.from(i.position):void 0}})],m.$eN.Void))}registerProvider(p,v,n){const o=new b(p,v);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,n?.label??p.displayName??p.name,p.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",n?.supportReportIssue??!1),(0,$.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(p,v,n,o){const i=this.b.get(p);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const s=this.f.getDocument(P.URI.revive(v)),a=T.Selection.to(n),u=await i.provider.prepareInteractiveEditorSession({document:s,selection:a},o);if(!u)return;if(u.wholeRange&&!u.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=C.a++;return this.d.set(h,new A(u)),{id:h,placeholder:u.placeholder,input:u.input,slashCommands:u.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:T.Range.from(u.wholeRange),message:u.message}}async $provideResponse(p,v,n,o){const i=this.b.get(p);if(!i)return;const s=this.d.get(v.id);if(!s)return;const a={prompt:n.prompt,selection:T.Selection.to(n.selection),wholeRange:T.Range.to(n.wholeRange),attempt:n.attempt,live:n.live};let u=!1;const h={report:async w=>{if(!n.live&&w.edits?.length)throw new Error("Progress reporting is only supported for live sessions");u||o.isCancellationRequested||await this.e.$handleProgressChunk(n.requestId,{message:w.message,edits:w.edits?.map(T.TextEdit.from),editsShouldBeInstant:w.editsShouldBeInstant,slashCommand:w.slashCommand?.command,markdownFragment:M.$eL.isMarkdownString(w.content)?w.content.value:w.content})}},t=Promise.resolve(i.provider.provideInteractiveEditorResponse(s.session,a,h,o));let r;try{r=await(0,g.$Qg)(t,o)}finally{u=!0}if(!r)return;const c=s.responses.push(r)-1,f={wholeRange:T.Range.from(r.wholeRange),placeholder:r.placeholder};if(C.h(r)){const{edits:w,contents:d}=r,D=d!==void 0?T.MarkdownString.from(d):void 0;return w instanceof M.$ZK?{...f,id:c,type:"bulkEdit",edits:T.WorkspaceEdit.from(w),message:D}:{...f,id:c,type:"editorEdit",edits:w.map(T.TextEdit.from),message:D}}return{...f,id:c,type:"message",message:T.MarkdownString.from(r.contents)}}async $provideFollowups(p,v,n,o){const i=this.b.get(p),s=this.d.get(v),a=s?.responses[n];if(i&&a&&i.provider.provideFollowups){const u=Promise.resolve(i.provider.provideFollowups(s.session,a,o));return(await(0,g.$Qg)(u,o))?.map(T.ChatReplyFollowup.from)}}$handleFeedback(p,v,n,o){const i=this.b.get(p),s=this.d.get(v),a=s?.responses[n];if(i&&a){const u=T.InteractiveEditorResponseFeedbackKind.to(o);i.provider.handleInteractiveEditorResponseFeedback?.(s.session,a,u)}}$releaseSession(p,v){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$tgc=C,C.a=0}),define(Re[251],Ae([1,0,2,32]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;class I{constructor(M,m,g,b,A){this.a=m,this.b=g,this.c=b;const C=new P.$fN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.$dN("showOptions","Show Options",l=>!0,l=>l),new P.$dN("resource","Interactive resource Uri",l=>!0,l=>l),new P.$dN("controllerId","Notebook controller Id",l=>!0,l=>l),new P.$dN("title","Interactive editor title",l=>!0,l=>l)],new P.$eN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:$.URI.revive(l.notebookUri),inputUri:$.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:$.URI.revive(l.notebookUri),inputUri:$.URI.revive(l.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(M,m,g,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:g,uri:M,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument($.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(M,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Ggc=I}),define(Re[252],Ae([1,0,3,7]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class I{constructor(M){this.a=new Map,this.b=new Map,this.c=M.getProxy($.$NK.MainThreadIssueReporter)}async $getIssueReporterUri(M,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(M);if(!g)throw new Error("Issue request handler not found");const b=await g.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}async $getIssueReporterData(M,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(M);if(!g)throw new Error("Issue data provider not found");const b=await g.provideIssueData(m);if(!b)throw new Error("Issue data provider returned no result");return b}async $getIssueReporterTemplate(M,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(M);if(!g)throw new Error("Issue data provider not found");const b=await g.provideIssueTemplate(m);if(!b)throw new Error("Issue template provider returned no result");return b}registerIssueUriRequestHandler(M,m){const g=M.identifier.value;return this.a.set(g,m),this.c.$registerIssueUriRequestHandler(g),new P.$PK(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(M,m){const g=M.identifier.value;return this.b.set(g,m),this.c.$registerIssueDataProvider(g),new P.$PK(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$Hgc=I}),define(Re[253],Ae([1,0,6,3]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;class I{constructor(M){this.b=0,this.a=M.getProxy(P.$NK.MainThreadLabelService)}$registerResourceLabelFormatter(M){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,M),(0,$.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Igc=I}),define(Re[254],Ae([1,0,2,26,8,7,80,3,12,29,18,16,297,20,22,6,96,89,75,60,11,14,23,160]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u,h,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class c{constructor(N,q){this.d=N,this.e=q}async provideDocumentSymbols(N,q){const G=this.d.getDocument(N),z=await this.e.provideDocumentSymbols(G,q);if(!(0,A.$Kb)(z))return z[0]instanceof T.$9K?z.map(I.DocumentSymbol.from):c.f(z)}static f(N){N=N.slice(0).sort((z,Z)=>{let X=z.location.range.start.compareTo(Z.location.range.start);return X===0&&(X=Z.location.range.end.compareTo(z.location.range.end)),X});const q=[],G=[];for(const z of N){const Z={name:z.name||"!!MISSING: name!!",kind:I.SymbolKind.from(z.kind),tags:z.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:z.containerName,range:I.Range.from(z.location.range),selectionRange:I.Range.from(z.location.range),children:[]};for(;;){if(G.length===0){G.push(Z),q.push(Z);break}const X=G[G.length-1];if(b.$Hs.containsRange(X.range,Z.range)&&!b.$Hs.equalsRange(X.range,Z.range)){X.children?.push(Z),G.push(Z);break}G.pop()}}return q}}class f{constructor(N,q,G){this.g=N,this.h=q,this.j=G,this.e=new s.$afc("CodeLens"),this.f=new Map}async provideCodeLenses(N,q){const G=this.g.getDocument(N),z=await this.j.provideCodeLenses(G,q);if(!z||q.isCancellationRequested)return;const Z=this.e.add(z),X=new n.$Rc;this.f.set(Z,X);const De={cacheId:Z,lenses:[]};for(let Te=0;Te<z.length;Te++)De.lenses.push({cacheId:[Z,Te],range:I.Range.from(z[Te].range),command:this.h.toInternal(z[Te].command,X)});return De}async resolveCodeLens(N,q){const G=N.cacheId&&this.e.get(...N.cacheId);if(!G)return;let z;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?z=G:z=await this.j.resolveCodeLens(G,q),z||(z=G),q.isCancellationRequested)return;const Z=N.cacheId&&this.f.get(N.cacheId[0]);if(Z)return N.command=this.h.toInternal(z.command??f.d,Z),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}f.d={command:"missing",title:"!!MISSING: command!!"};function w(Se){return Array.isArray(Se)?Se.map(I.DefinitionLink.from):Se?[I.DefinitionLink.from(Se)]:[]}class d{constructor(N,q){this.d=N,this.e=q}async provideDefinition(N,q,G){const z=this.d.getDocument(N),Z=I.Position.to(q),X=await this.e.provideDefinition(z,Z,G);return w(X)}}class D{constructor(N,q){this.d=N,this.e=q}async provideDeclaration(N,q,G){const z=this.d.getDocument(N),Z=I.Position.to(q),X=await this.e.provideDeclaration(z,Z,G);return w(X)}}class L{constructor(N,q){this.d=N,this.e=q}async provideImplementation(N,q,G){const z=this.d.getDocument(N),Z=I.Position.to(q),X=await this.e.provideImplementation(z,Z,G);return w(X)}}class y{constructor(N,q){this.d=N,this.e=q}async provideTypeDefinition(N,q,G){const z=this.d.getDocument(N),Z=I.Position.to(q),X=await this.e.provideTypeDefinition(z,Z,G);return w(X)}}class E{constructor(N,q){this.d=N,this.e=q}async provideHover(N,q,G){const z=this.d.getDocument(N),Z=I.Position.to(q),X=await this.e.provideHover(z,Z,G);if(!(!X||(0,A.$Kb)(X.contents)))return X.range||(X.range=z.getWordRangeAtPosition(Z)),X.range||(X.range=new T.$RK(Z,Z)),I.Hover.from(X)}}class k{constructor(N,q){this.d=N,this.e=q}async provideEvaluatableExpression(N,q,G){const z=this.d.getDocument(N),Z=I.Position.to(q),X=await this.e.provideEvaluatableExpression(z,Z,G);if(X)return I.EvaluatableExpression.from(X)}}class F{constructor(N,q){this.d=N,this.e=q}async provideInlineValues(N,q,G,z){const Z=this.d.getDocument(N),X=await this.e.provideInlineValues(Z,I.Range.to(q),I.InlineValueContext.to(G),z);if(Array.isArray(X))return X.map(De=>I.InlineValue.from(De))}}class B{constructor(N,q){this.d=N,this.e=q}async provideDocumentHighlights(N,q,G){const z=this.d.getDocument(N),Z=I.Position.to(q),X=await this.e.provideDocumentHighlights(z,Z,G);if(Array.isArray(X))return X.map(I.DocumentHighlight.from)}}class ee{constructor(N,q){this.d=N,this.e=q}async provideMultiDocumentHighlights(N,q,G,z){const Z=this.d.getDocument(N),X=G.map(qe=>this.d.getDocument(qe)),De=I.Position.to(q),Te=await this.e.provideMultiDocumentHighlights(Z,De,X,z);if(Array.isArray(Te))return Te.map(I.MultiDocumentHighlight.from)}}class J{constructor(N,q){this.d=N,this.e=q}async provideLinkedEditingRanges(N,q,G){const z=this.d.getDocument(N),Z=I.Position.to(q),X=await this.e.provideLinkedEditingRanges(z,Z,G);if(X&&Array.isArray(X.ranges))return{ranges:(0,A.$Hb)(X.ranges.map(I.Range.from)),wordPattern:X.wordPattern}}}class V{constructor(N,q){this.d=N,this.e=q}async provideReferences(N,q,G,z){const Z=this.d.getDocument(N),X=I.Position.to(q),De=await this.e.provideReferences(Z,X,G,z);if(Array.isArray(De))return De.map(I.location.from)}}class R{constructor(N,q,G,z,Z,X,De){this.g=N,this.h=q,this.j=G,this.k=z,this.l=Z,this.m=X,this.n=De,this.e=new s.$afc("CodeAction"),this.f=new Map}async provideCodeActions(N,q,G,z){const Z=this.g.getDocument(N),X=l.$Js.isISelection(q)?I.Selection.to(q):I.Range.to(q),De=[];for(const rt of this.j.getDiagnostics(N))if(X.intersection(rt.range)&&De.push(rt)>R.d)break;const Te={diagnostics:De,only:G.only?new T.$$K(G.only):void 0,triggerKind:I.CodeActionTriggerKind.to(G.trigger)},qe=await this.k.provideCodeActions(Z,X,Te,z);if(!(0,A.$Lb)(qe)||z.isCancellationRequested)return;const We=this.e.add(qe),Ye=new n.$Rc;this.f.set(We,Ye);const ot=[];for(let rt=0;rt<qe.length;rt++){const it=qe[rt];it&&(R.o(it)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,Ye)})):(Te.only&&(it.kind?Te.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ot.push({cacheId:[We,rt],title:it.title,command:it.command&&this.h.toInternal(it.command,Ye),diagnostics:it.diagnostics&&it.diagnostics.map(I.Diagnostic.from),edit:it.edit&&I.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,t.$kF)(this.m,"codeActionAI")?it.isAI:!1,disabled:it.disabled?.reason})))}return{cacheId:We,actions:ot}}async resolveCodeAction(N,q){const[G,z]=N,Z=this.e.get(G,z);if(!Z||R.o(Z))return{};if(!this.k.resolveCodeAction)return{};const X=await this.k.resolveCodeAction(Z,q)??Z;let De;X.edit&&(De=I.WorkspaceEdit.from(X.edit,void 0));let Te;if(X.command){const qe=this.f.get(G);qe&&(Te=this.h.toInternal(X.command,qe))}return{edit:De,command:Te}}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}R.d=1e3;class S{static toInternalProviderId(N,q){return N+"."+q}constructor(N,q,G,z,Z){this.d=N,this.e=q,this.f=G,this.g=z,this.h=Z}async prepareDocumentPaste(N,q,G,z){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(N),X=q.map(qe=>I.Range.to(qe)),De=I.DataTransfer.toDataTransfer(G,()=>{throw new u.$$});if(await this.f.prepareDocumentPaste(Z,X,De,z),z.isCancellationRequested)return;const Te=Array.from(De).filter(([,qe])=>!(qe instanceof T.$EL));return I.DataTransfer.from(Te)}async providePasteEdits(N,q,G,z,Z){if(!this.f.provideDocumentPasteEdits)return;const X=this.e.getDocument(q),De=G.map(We=>I.Range.to(We)),Te=I.DataTransfer.toDataTransfer(z,async We=>(await this.d.$resolvePasteFileData(this.g,N,We)).buffer),qe=await this.f.provideDocumentPasteEdits(X,De,Te,Z);if(qe)return{label:qe.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:qe.yieldTo?.map(We=>"mimeType"in We?We:{providerId:S.toInternalProviderId(We.extensionId,We.providerId)}),insertText:typeof qe.insertText=="string"?qe.insertText:{snippet:qe.insertText.value},additionalEdit:qe.additionalEdit?I.WorkspaceEdit.from(qe.additionalEdit,void 0):void 0}}}class O{constructor(N,q){this.d=N,this.e=q}async provideDocumentFormattingEdits(N,q,G){const z=this.d.getDocument(N),Z=await this.e.provideDocumentFormattingEdits(z,q,G);if(Array.isArray(Z))return Z.map(I.TextEdit.from)}}class Q{constructor(N,q){this.d=N,this.e=q}async provideDocumentRangeFormattingEdits(N,q,G,z){const Z=this.d.getDocument(N),X=I.Range.to(q),De=await this.e.provideDocumentRangeFormattingEdits(Z,X,G,z);if(Array.isArray(De))return De.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(N,q,G,z){(0,C.$Of)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(N),X=q.map(I.Range.to),De=await this.e.provideDocumentRangesFormattingEdits(Z,X,G,z);if(Array.isArray(De))return De.map(I.TextEdit.from)}}class re{constructor(N,q){this.d=N,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,q,G,z,Z){const X=this.d.getDocument(N),De=I.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(X,De,G,z,Z);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class he{constructor(N,q){this.e=N,this.f=q,this.d=new s.$afc("WorkspaceSymbols")}async provideWorkspaceSymbols(N,q){const G=await this.e.provideWorkspaceSymbols(N,q);if(!(0,A.$Lb)(G))return{symbols:[]};const z=this.d.add(G),Z={cacheId:z,symbols:[]};for(let X=0;X<G.length;X++){const De=G[X];if(!De||!De.name){this.f.warn("INVALID SymbolInformation",De);continue}Z.symbols.push({...I.WorkspaceSymbol.from(De),cacheId:[z,X]})}return Z}async resolveWorkspaceSymbol(N,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const G=this.d.get(...N.cacheId);if(G){const z=await this.e.resolveWorkspaceSymbol(G,q);return z&&(0,P.$ln)(N,I.WorkspaceSymbol.from(z),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class fe{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,q,G){this.d=N,this.e=q,this.f=G}async provideRenameEdits(N,q,G,z){const Z=this.d.getDocument(N),X=I.Position.to(q);try{const De=await this.e.provideRenameEdits(Z,X,G,z);return De?I.WorkspaceEdit.from(De):void 0}catch(De){const Te=fe.g(De);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(De)}}async resolveRenameLocation(N,q,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const z=this.d.getDocument(N),Z=I.Position.to(q);try{const X=await this.e.prepareRename(z,Z,G);let De,Te;if(T.$RK.isRange(X)?(De=X,Te=z.getText(X)):(0,C.$Gf)(X)&&(De=X.range,Te=X.placeholder),!De||!Te)return;if(De.start.line>Z.line||De.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(De),text:Te}}catch(X){const De=fe.g(X);return De?{rejectReason:De,range:void 0,text:void 0}:Promise.reject(X)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class ue{constructor(N,q){this.resultId=N,this.tokens=q}}class $e{constructor(N,q){this.f=N,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,q,G){const z=this.f.getDocument(N),Z=q!==0?this.d.get(q):null;let X=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(z,Z.resultId,G):await this.g.provideDocumentSemanticTokens(z,G);return Z&&this.d.delete(q),X?(X=$e.h(X),this.o($e.n(Z,X),X)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return $e.j(N)?$e.k(N)?N:new T.$8L(new Uint32Array(N.data),N.resultId):$e.l(N)?$e.m(N)?N:new T.$0L(N.edits.map(q=>new T.$9L(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const q of N.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(N,q){if(!$e.j(q)||!N||!N.tokens)return q;const G=N.tokens,z=G.length,Z=q.data,X=Z.length;let De=0;const Te=Math.min(z,X);for(;De<Te&&G[De]===Z[De];)De++;if(De===z&&De===X)return new T.$0L([],q.resultId);let qe=0;const We=Te-De;for(;qe<We&&G[z-qe-1]===Z[X-qe-1];)qe++;return new T.$0L([{start:De,deleteCount:z-De-qe,data:Z.subarray(De,X-qe)}],q.resultId)}o(N,q){if($e.j(N)){const G=this.e++;return this.d.set(G,new ue(N.resultId,N.data)),(0,o.$m$)({id:G,type:"full",data:N.data})}if($e.l(N)){const G=this.e++;return $e.j(q)?this.d.set(G,new ue(q.resultId,q.data)):this.d.set(G,new ue(N.resultId)),(0,o.$m$)({id:G,type:"delta",deltas:(N.edits||[]).map(z=>({start:z.start,deleteCount:z.deleteCount,data:z.data}))})}return null}}class ne{constructor(N,q){this.d=N,this.e=q}async provideDocumentRangeSemanticTokens(N,q,G){const z=this.d.getDocument(N),Z=await this.e.provideDocumentRangeSemanticTokens(z,I.Range.to(q),G);return Z?this.f(Z):null}f(N){return(0,o.$m$)({id:0,type:"full",data:N.data})}}class Pe{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,q,G,z,Z){this.f=N,this.g=q,this.h=G,this.j=z,this.k=Z,this.d=new s.$afc("CompletionItem"),this.e=new Map}async provideCompletionItems(N,q,G,z){const Z=this.f.getDocument(N),X=I.Position.to(q),De=Z.getWordRangeAtPosition(X)||new T.$RK(X,X),Te=De.with({end:X}),qe=new a.$Od,We=await this.h.provideCompletionItems(Z,X,z,I.CompletionContext.to(G));if(!We||z.isCancellationRequested)return;const Ye=Array.isArray(We)?new T.$lL(We):We,ot=Pe.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),rt=new n.$Rc;this.e.set(ot,rt);const it=[],ct={x:ot,b:it,a:{replace:I.Range.from(De),insert:I.Range.from(Te)},c:Ye.isIncomplete||void 0,d:qe.elapsed()};for(let ut=0;ut<Ye.items.length;ut++){const Ue=Ye.items[ut],vt=this.l(Ue,[ot,ut],Te,De);it.push(vt)}return ct}async resolveCompletionItem(N,q){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...N);if(!G)return;const z=this.l(G,N),Z=await this.h.resolveCompletionItem(G,q);if(!Z)return;const X=this.l(Z,N);return(z.h!==X.h||z.i!==X.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(z.n!==X.n||z.o!==X.o||!(0,P.$mn)(z.p,X.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...z,d:X.d,c:X.c,l:X.l,h:X.h,i:X.i,n:X.n,o:X.o,p:X.p}}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,q,G,z){const Z=this.e.get(q[0]);if(!Z)throw Error("DisposableStore is missing...");const X=this.g.toInternal(N.command,Z),De={x:q,a:N.label,b:N.kind!==void 0?I.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(I.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:I.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(I.TextEdit.from),n:X?.$ident,o:X?.id,p:X?.$ident?void 0:X?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),De.h=N.textEdit.newText):typeof N.insertText=="string"?De.h=N.insertText:N.insertText instanceof T.$1K&&(De.h=N.insertText.value,De.i|=4);let Te;return N.textEdit?Te=N.textEdit.range:N.range&&(Te=N.range),T.$RK.isRange(Te)?De.j=I.Range.from(Te):Te&&(!G?.isEqual(Te.inserting)||!z?.isEqual(Te.replacing))&&(De.j={insert:I.Range.from(Te.inserting),replace:I.Range.from(Te.replacing)}),De}}class le{async provideInlineCompletions(N,q,G,z){}disposeCompletions(N){}handleDidShowCompletionItem(N,q,G){}handlePartialAccept(N,q,G){}}class me extends le{constructor(N,q,G,z){super(),this.f=N,this.g=q,this.h=G,this.j=z,this.d=new W,this.e=(0,t.$kF)(this.f,"inlineCompletionsAdditions"),this.k={[M.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKind.Automatic,[M.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$kF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,q,G,z){const Z=this.g.getDocument(N),X=I.Position.to(q),De=await this.h.provideInlineCompletionItems(Z,X,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},z);if(!De||z.isCancellationRequested)return;const Te=Array.isArray(De)?De:De.items,qe=this.e?Array.isArray(De)?[]:De.commands||[]:[],We=this.e&&!Array.isArray(De)?De.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:Te}),items:Te.map((rt,it)=>{let ct;rt.command&&(Ye||(Ye=new n.$Rc),ct=this.j.toInternal(rt.command,Ye));const ut=rt.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:rt.filterText,range:rt.range?I.Range.from(rt.range):void 0,command:ct,idx:it,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:qe.map(rt=>(Ye||(Ye=new n.$Rc),this.j.toInternal(rt,Ye))),suppressSuggestions:!1,enableForwardStability:We}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,q,G){const z=this.d.get(N)?.items[q];z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(z,G)}handlePartialAccept(N,q,G){const z=this.d.get(N)?.items[q];z&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(z,G)}}class W{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const q=this.e++;return this.d.set(q,N),q}disposeReferenceId(N){const q=this.d.get(N);return this.d.delete(N),q}get(N){return this.d.get(N)}}class ae{constructor(N,q){this.e=N,this.f=q,this.d=new s.$afc("SignatureHelp")}async provideSignatureHelp(N,q,G,z){const Z=this.e.getDocument(N),X=I.Position.to(q),De=this.g(G),Te=await this.f.provideSignatureHelp(Z,X,z,De);if(Te){const qe=this.d.add([Te]);return{...I.SignatureHelp.from(Te),id:qe}}}g(N){let q;if(N.activeSignatureHelp){const G=I.SignatureHelp.to(N.activeSignatureHelp),z=this.d.get(N.activeSignatureHelp.id,0);z?(q=z,q.activeSignature=G.activeSignature,q.activeParameter=G.activeParameter):q=G}return{...N,activeSignatureHelp:q}}releaseSignatureHelp(N){this.d.delete(N)}}class de{constructor(N,q,G,z,Z){this.f=N,this.g=q,this.h=G,this.j=z,this.k=Z,this.d=new s.$afc("InlayHints"),this.e=new Map}async provideInlayHints(N,q,G){const z=this.f.getDocument(N),Z=I.Range.to(q),X=await this.h.provideInlayHints(z,Z,G);if(!Array.isArray(X)||X.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(G.isCancellationRequested)return;const De=this.d.add(X);this.e.set(De,new n.$Rc);const Te={hints:[],cacheId:De};for(let qe=0;qe<X.length;qe++)this.l(X[qe],Z)&&Te.hints.push(this.m(X[qe],[De,qe]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Te}async resolveInlayHint(N,q){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...N);if(!G)return;const z=await this.h.resolveInlayHint(G,q);if(z&&this.l(z))return this.m(z,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,q){return N.label.length===0||Array.isArray(N.label)&&N.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(q&&!q.contains(N.position))}m(N,q){const G=this.e.get(q[0]);if(!G)throw Error("DisposableStore is missing...");const z={label:"",cacheId:q,tooltip:I.MarkdownString.fromStrict(N.tooltip),position:I.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(I.TextEdit.from),kind:N.kind&&I.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?z.label=N.label:z.label=N.label.map(Z=>{const X={label:Z.value};return X.tooltip=I.MarkdownString.fromStrict(Z.tooltip),T.$2K.isLocation(Z.location)&&(X.location=I.location.from(Z.location)),Z.command&&(X.command=this.g.toInternal(Z.command,G)),X}),z}}class ke{constructor(N,q){this.e=N,this.f=q,this.d=new s.$afc("DocumentLink")}async provideLinks(N,q){const G=this.e.getDocument(N),z=await this.f.provideDocumentLinks(G,q);if(!(!Array.isArray(z)||z.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:z.filter(ke.g).map(I.DocumentLink.from)};{const Z=this.d.add(z),X={links:[],cacheId:Z};for(let De=0;De<z.length;De++){if(!ke.g(z[De]))continue;const Te=I.DocumentLink.from(z[De]);Te.cacheId=[Z,De],X.links.push(Te)}return X}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,q){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...N);if(!G)return;const z=await this.f.resolveDocumentLink(G,q);if(!(!z||!ke.g(z)))return I.DocumentLink.from(z)}releaseLinks(N){this.d.delete(N)}}class Ee{constructor(N,q){this.d=N,this.e=q}async provideColors(N,q){const G=this.d.getDocument(N),z=await this.e.provideDocumentColors(G,q);return Array.isArray(z)?z.map(X=>({color:I.Color.from(X.color),range:I.Range.from(X.range)})):[]}async provideColorPresentations(N,q,G){const z=this.d.getDocument(N),Z=I.Range.to(q.range),X=I.Color.to(q.color),De=await this.e.provideColorPresentations(X,{document:z,range:Z},G);if(Array.isArray(De))return De.map(I.ColorPresentation.from)}}class ce{constructor(N,q){this.d=N,this.e=q}async provideFoldingRanges(N,q,G){const z=this.d.getDocument(N),Z=await this.e.provideFoldingRanges(z,q,G);if(Array.isArray(Z))return Z.map(I.FoldingRange.from)}}class _{constructor(N,q,G){this.d=N,this.e=q,this.f=G}async provideSelectionRanges(N,q,G){const z=this.d.getDocument(N),Z=q.map(I.Position.to),X=await this.e.provideSelectionRanges(z,Z,G);if(!(0,A.$Lb)(X))return[];if(X.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const De=[];for(let Te=0;Te<Z.length;Te++){const qe=[];De.push(qe);let We=Z[Te],Ye=X[Te];for(;;){if(!Ye.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(I.SelectionRange.from(Ye)),!Ye.parent)break;We=Ye.range,Ye=Ye.parent}}return De}}class H{constructor(N,q){this.f=N,this.g=q,this.d=new i.$WM(""),this.e=new Map}async prepareSession(N,q,G){const z=this.f.getDocument(N),Z=I.Position.to(q),X=await this.g.prepareCallHierarchy(z,Z,G);if(!X)return;const De=this.d.nextId();return this.e.set(De,new Map),Array.isArray(X)?X.map(Te=>this.h(De,Te)):[this.h(De,X)]}async provideCallsTo(N,q,G){const z=this.j(N,q);if(!z)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(z,G);if(Z)return Z.map(X=>({from:this.h(N,X.from),fromRanges:X.fromRanges.map(De=>I.Range.from(De))}))}async provideCallsFrom(N,q,G){const z=this.j(N,q);if(!z)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(z,G);if(Z)return Z.map(X=>({to:this.h(N,X.to),fromRanges:X.fromRanges.map(De=>I.Range.from(De))}))}releaseSession(N){this.e.delete(N)}h(N,q){const G=this.e.get(N),z=I.CallHierarchyItem.from(q,N,G.size.toString(36));return G.set(z._itemId,q),z}j(N,q){return this.e.get(N)?.get(q)}}class te{constructor(N,q){this.f=N,this.g=q,this.d=new i.$WM(""),this.e=new Map}async prepareSession(N,q,G){const z=this.f.getDocument(N),Z=I.Position.to(q),X=await this.g.prepareTypeHierarchy(z,Z,G);if(!X)return;const De=this.d.nextId();return this.e.set(De,new Map),Array.isArray(X)?X.map(Te=>this.h(De,Te)):[this.h(De,X)]}async provideSupertypes(N,q,G){const z=this.j(N,q);if(!z)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(z,G);if(Z)return Z.map(X=>this.h(N,X))}async provideSubtypes(N,q,G){const z=this.j(N,q);if(!z)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(z,G);if(Z)return Z.map(X=>this.h(N,X))}releaseSession(N){this.e.delete(N)}h(N,q){const G=this.e.get(N),z=I.TypeHierarchyItem.from(q,N,G.size.toString(36));return G.set(z._itemId,q),z}j(N,q){return this.e.get(N)?.get(q)}}class we{static toInternalProviderId(N,q){return N+"."+q}constructor(N,q,G,z,Z){this.d=N,this.e=q,this.f=G,this.g=z,this.h=Z}async provideDocumentOnDropEdits(N,q,G,z,Z){const X=this.e.getDocument(q),De=I.Position.to(G),Te=I.DataTransfer.toDataTransfer(z,async We=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,We)).buffer),qe=await this.f.provideDocumentDropEdits(X,De,Te,Z);if(qe)return{label:qe.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:qe.yieldTo?.map(We=>"mimeType"in We?We:{providerId:we.toInternalProviderId(We.extensionId,We.providerId)}),insertText:typeof qe.insertText=="string"?qe.insertText:{snippet:qe.insertText.value},additionalEdit:qe.additionalEdit?I.WorkspaceEdit.from(qe.additionalEdit,void 0):void 0}}}class be{constructor(N,q){this.d=N,this.e=q}async provideMappedEdits(N,q,G,z){const Z=$.URI.revive(N),X=this.d.getDocument(Z),De=G.documents.map(We=>We.map(Ye=>({uri:$.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(ot=>I.Range.to(ot))}))),Te={documents:De,selections:De[0]?.[0]?.ranges??[]},qe=await this.e.provideMappedEdits(X,q,Te,z);return qe?I.WorkspaceEdit.from(qe):null}}class Fe{constructor(N,q){this.adapter=N,this.extension=q}}class pe{constructor(N,q,G,z,Z,X,De,Te){this.g=q,this.h=G,this.j=z,this.k=Z,this.l=X,this.m=De,this.n=Te,this.f=new Map,this.e=N.getProxy(m.$NK.MainThreadLanguageFeatures)}o(N,q){return I.DocumentSelector.from(N,this.g,q)}p(N){return new T.$PK(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return pe.d++}async s(N,q,G,z,Z,X=!1){const De=this.f.get(N);if(!De||!(De.adapter instanceof q))return z;const Te=Date.now();X||this.l.trace(`[${De.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const qe=G(De.adapter,De.extension);return Promise.resolve(qe).catch(We=>{(0,u.$4)(We)||(this.l.error(`[${De.extension.identifier.value}] provider FAILED`),this.l.error(We),this.n.onExtensionError(De.extension.identifier,We))}).finally(()=>{X||this.l.trace(`[${De.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),p.CancellationToken.isCancellationToken(Z)?(0,h.$Rg)(qe,Z):qe}t(N,q){const G=this.q();return this.f.set(G,new Fe(N,q)),G}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,q,G,z){const Z=this.t(new c(this.h,G),N),X=z&&z.label||pe.u(N);return this.e.$registerDocumentSymbolProvider(Z,this.o(q,N),X),this.p(Z)}$provideDocumentSymbols(N,q,G){return this.s(N,c,z=>z.provideDocumentSymbols($.URI.revive(q),G),void 0,G)}registerCodeLensProvider(N,q,G){const z=this.q(),Z=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(z,new Fe(new f(this.h,this.j.converter,G),N)),this.e.$registerCodeLensSupport(z,this.o(q,N),Z);let X=this.p(z);if(Z!==void 0){const De=G.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(Z));X=T.$PK.from(X,De)}return X}$provideCodeLenses(N,q,G){return this.s(N,f,z=>z.provideCodeLenses($.URI.revive(q),G),void 0,G)}$resolveCodeLens(N,q,G){return this.s(N,f,z=>z.resolveCodeLens(q,G),void 0,void 0)}$releaseCodeLenses(N,q){this.s(N,f,G=>Promise.resolve(G.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(N,q,G){const z=this.t(new d(this.h,G),N);return this.e.$registerDefinitionSupport(z,this.o(q,N)),this.p(z)}$provideDefinition(N,q,G,z){return this.s(N,d,Z=>Z.provideDefinition($.URI.revive(q),G,z),[],z)}registerDeclarationProvider(N,q,G){const z=this.t(new D(this.h,G),N);return this.e.$registerDeclarationSupport(z,this.o(q,N)),this.p(z)}$provideDeclaration(N,q,G,z){return this.s(N,D,Z=>Z.provideDeclaration($.URI.revive(q),G,z),[],z)}registerImplementationProvider(N,q,G){const z=this.t(new L(this.h,G),N);return this.e.$registerImplementationSupport(z,this.o(q,N)),this.p(z)}$provideImplementation(N,q,G,z){return this.s(N,L,Z=>Z.provideImplementation($.URI.revive(q),G,z),[],z)}registerTypeDefinitionProvider(N,q,G){const z=this.t(new y(this.h,G),N);return this.e.$registerTypeDefinitionSupport(z,this.o(q,N)),this.p(z)}$provideTypeDefinition(N,q,G,z){return this.s(N,y,Z=>Z.provideTypeDefinition($.URI.revive(q),G,z),[],z)}registerHoverProvider(N,q,G,z){const Z=this.t(new E(this.h,G),N);return this.e.$registerHoverProvider(Z,this.o(q,N)),this.p(Z)}$provideHover(N,q,G,z){return this.s(N,E,Z=>Z.provideHover($.URI.revive(q),G,z),void 0,z)}registerEvaluatableExpressionProvider(N,q,G,z){const Z=this.t(new k(this.h,G),N);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(q,N)),this.p(Z)}$provideEvaluatableExpression(N,q,G,z){return this.s(N,k,Z=>Z.provideEvaluatableExpression($.URI.revive(q),G,z),void 0,z)}registerInlineValuesProvider(N,q,G,z){const Z=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,X=this.t(new F(this.h,G),N);this.e.$registerInlineValuesProvider(X,this.o(q,N),Z);let De=this.p(X);if(Z!==void 0){const Te=G.onDidChangeInlineValues(qe=>this.e.$emitInlineValuesEvent(Z));De=T.$PK.from(De,Te)}return De}$provideInlineValues(N,q,G,z,Z){return this.s(N,F,X=>X.provideInlineValues($.URI.revive(q),G,z,Z),void 0,Z)}registerDocumentHighlightProvider(N,q,G){const z=this.t(new B(this.h,G),N);return this.e.$registerDocumentHighlightProvider(z,this.o(q,N)),this.p(z)}registerMultiDocumentHighlightProvider(N,q,G){const z=this.t(new ee(this.h,G),N);return this.e.$registerMultiDocumentHighlightProvider(z,this.o(q,N)),this.p(z)}$provideDocumentHighlights(N,q,G,z){return this.s(N,B,Z=>Z.provideDocumentHighlights($.URI.revive(q),G,z),void 0,z)}$provideMultiDocumentHighlights(N,q,G,z,Z){return this.s(N,ee,X=>X.provideMultiDocumentHighlights($.URI.revive(q),G,z.map(De=>$.URI.revive(De)),Z),void 0,Z)}registerLinkedEditingRangeProvider(N,q,G){const z=this.t(new J(this.h,G),N);return this.e.$registerLinkedEditingRangeProvider(z,this.o(q,N)),this.p(z)}$provideLinkedEditingRanges(N,q,G,z){return this.s(N,J,async Z=>{const X=await Z.provideLinkedEditingRanges($.URI.revive(q),G,z);if(X)return{ranges:X.ranges,wordPattern:X.wordPattern?pe.w(X.wordPattern):void 0}},void 0,z)}registerReferenceProvider(N,q,G){const z=this.t(new V(this.h,G),N);return this.e.$registerReferenceSupport(z,this.o(q,N)),this.p(z)}$provideReferences(N,q,G,z,Z){return this.s(N,V,X=>X.provideReferences($.URI.revive(q),G,z,Z),void 0,Z)}registerCodeActionProvider(N,q,G,z){const Z=new n.$Rc,X=this.t(new R(this.h,this.j.converter,this.k,G,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(X,this.o(q,N),{providedKinds:z?.providedCodeActionKinds?.map(De=>De.value),documentation:z?.documentation?.map(De=>({kind:De.kind.value,command:this.j.converter.toInternal(De.command,Z)}))},pe.u(N),!!G.resolveCodeAction),Z.add(this.p(X)),Z}$provideCodeActions(N,q,G,z,Z){return this.s(N,R,X=>X.provideCodeActions($.URI.revive(q),G,z,Z),void 0,Z)}$resolveCodeAction(N,q,G){return this.s(N,R,z=>z.resolveCodeAction(q,G),{},void 0)}$releaseCodeActions(N,q){this.s(N,R,G=>Promise.resolve(G.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(N,q,G){const z=this.t(new O(this.h,G),N);return this.e.$registerDocumentFormattingSupport(z,this.o(q,N),N.identifier,N.displayName||N.name),this.p(z)}$provideDocumentFormattingEdits(N,q,G,z){return this.s(N,O,Z=>Z.provideDocumentFormattingEdits($.URI.revive(q),G,z),void 0,z)}registerDocumentRangeFormattingEditProvider(N,q,G){const z=typeof G.provideDocumentRangesFormattingEdits=="function",Z=this.t(new Q(this.h,G),N);return this.e.$registerRangeFormattingSupport(Z,this.o(q,N),N.identifier,N.displayName||N.name,z),this.p(Z)}$provideDocumentRangeFormattingEdits(N,q,G,z,Z){return this.s(N,Q,X=>X.provideDocumentRangeFormattingEdits($.URI.revive(q),G,z,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(N,q,G,z,Z){return this.s(N,Q,X=>X.provideDocumentRangesFormattingEdits($.URI.revive(q),G,z,Z),void 0,Z)}registerOnTypeFormattingEditProvider(N,q,G,z){const Z=this.t(new re(this.h,G),N);return this.e.$registerOnTypeFormattingSupport(Z,this.o(q,N),z,N.identifier),this.p(Z)}$provideOnTypeFormattingEdits(N,q,G,z,Z,X){return this.s(N,re,De=>De.provideOnTypeFormattingEdits($.URI.revive(q),G,z,Z,X),void 0,X)}registerWorkspaceSymbolProvider(N,q){const G=this.t(new he(q,this.l),N);return this.e.$registerNavigateTypeSupport(G,typeof q.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(N,q,G){return this.s(N,he,z=>z.provideWorkspaceSymbols(q,G),{symbols:[]},G)}$resolveWorkspaceSymbol(N,q,G){return this.s(N,he,z=>z.resolveWorkspaceSymbol(q,G),void 0,void 0)}$releaseWorkspaceSymbols(N,q){this.s(N,he,G=>G.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(N,q,G){const z=this.t(new fe(this.h,G,this.l),N);return this.e.$registerRenameSupport(z,this.o(q,N),fe.supportsResolving(G)),this.p(z)}$provideRenameEdits(N,q,G,z,Z){return this.s(N,fe,X=>X.provideRenameEdits($.URI.revive(q),G,z,Z),void 0,Z)}$resolveRenameLocation(N,q,G,z){return this.s(N,fe,Z=>Z.resolveRenameLocation($.URI.revive(q),G,z),void 0,z)}registerDocumentSemanticTokensProvider(N,q,G,z){const Z=this.t(new $e(this.h,G),N),X=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(q,N),z,X);let De=this.p(Z);if(X){const Te=G.onDidChangeSemanticTokens(qe=>this.e.$emitDocumentSemanticTokensEvent(X));De=T.$PK.from(De,Te)}return De}$provideDocumentSemanticTokens(N,q,G,z){return this.s(N,$e,Z=>Z.provideDocumentSemanticTokens($.URI.revive(q),G,z),null,z)}$releaseDocumentSemanticTokens(N,q){this.s(N,$e,G=>G.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,q,G,z){const Z=this.t(new ne(this.h,G),N);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(q,N),z),this.p(Z)}$provideDocumentRangeSemanticTokens(N,q,G,z){return this.s(N,ne,Z=>Z.provideDocumentRangeSemanticTokens($.URI.revive(q),G,z),null,z)}registerCompletionItemProvider(N,q,G,z){const Z=this.t(new Pe(this.h,this.j.converter,G,this.m,N),N);return this.e.$registerCompletionsProvider(Z,this.o(q,N),z,Pe.supportsResolving(G),N.identifier),this.p(Z)}$provideCompletionItems(N,q,G,z,Z){return this.s(N,Pe,X=>X.provideCompletionItems($.URI.revive(q),G,z,Z),void 0,Z)}$resolveCompletionItem(N,q,G){return this.s(N,Pe,z=>z.resolveCompletionItem(q,G),void 0,G)}$releaseCompletionItems(N,q){this.s(N,Pe,G=>G.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(N,q,G,z){const Z=new me(N,this.h,G,this.j.converter),X=this.t(Z,N);return this.e.$registerInlineCompletionsSupport(X,this.o(q,N),Z.supportsHandleEvents,v.$hm.toKey(N.identifier.value),z?.yieldTo?.map(De=>v.$hm.toKey(De))||[]),this.p(X)}$provideInlineCompletions(N,q,G,z,Z){return this.s(N,le,X=>X.provideInlineCompletions($.URI.revive(q),G,z,Z),void 0,Z)}$handleInlineCompletionDidShow(N,q,G,z){this.s(N,le,async Z=>{Z.handleDidShowCompletionItem(q,G,z)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,q,G,z){this.s(N,le,async Z=>{Z.handlePartialAccept(q,G,z)},void 0,void 0)}$freeInlineCompletionsList(N,q){this.s(N,le,async G=>{G.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(N,q,G,z){const Z=Array.isArray(z)?{triggerCharacters:z,retriggerCharacters:[]}:z,X=this.t(new ae(this.h,G),N);return this.e.$registerSignatureHelpProvider(X,this.o(q,N),Z),this.p(X)}$provideSignatureHelp(N,q,G,z,Z){return this.s(N,ae,X=>X.provideSignatureHelp($.URI.revive(q),G,z,Z),void 0,Z)}$releaseSignatureHelp(N,q){this.s(N,ae,G=>G.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(N,q,G){const z=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new de(this.h,this.j.converter,G,this.l,N),N);this.e.$registerInlayHintsProvider(Z,this.o(q,N),typeof G.resolveInlayHint=="function",z,pe.u(N));let X=this.p(Z);if(z!==void 0){const De=G.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(z));X=T.$PK.from(X,De)}return X}$provideInlayHints(N,q,G,z){return this.s(N,de,Z=>Z.provideInlayHints($.URI.revive(q),G,z),void 0,z)}$resolveInlayHint(N,q,G){return this.s(N,de,z=>z.resolveInlayHint(q,G),void 0,G)}$releaseInlayHints(N,q){this.s(N,de,G=>G.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(N,q,G){const z=this.t(new ke(this.h,G),N);return this.e.$registerDocumentLinkProvider(z,this.o(q,N),typeof G.resolveDocumentLink=="function"),this.p(z)}$provideDocumentLinks(N,q,G){return this.s(N,ke,z=>z.provideLinks($.URI.revive(q),G),void 0,G,q.scheme==="output")}$resolveDocumentLink(N,q,G){return this.s(N,ke,z=>z.resolveLink(q,G),void 0,void 0,!0)}$releaseDocumentLinks(N,q){this.s(N,ke,G=>G.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(N,q,G){const z=this.t(new Ee(this.h,G),N);return this.e.$registerDocumentColorProvider(z,this.o(q,N)),this.p(z)}$provideDocumentColors(N,q,G){return this.s(N,Ee,z=>z.provideColors($.URI.revive(q),G),[],G)}$provideColorPresentations(N,q,G,z){return this.s(N,Ee,Z=>Z.provideColorPresentations($.URI.revive(q),G,z),void 0,z)}registerFoldingRangeProvider(N,q,G){const z=this.q(),Z=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(z,new Fe(new ce(this.h,G),N)),this.e.$registerFoldingRangeProvider(z,this.o(q,N),N.identifier,Z);let X=this.p(z);if(Z!==void 0){const De=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));X=T.$PK.from(X,De)}return X}$provideFoldingRanges(N,q,G,z){return this.s(N,ce,Z=>Z.provideFoldingRanges($.URI.revive(q),G,z),void 0,z)}registerSelectionRangeProvider(N,q,G){const z=this.t(new _(this.h,G,this.l),N);return this.e.$registerSelectionRangeProvider(z,this.o(q,N)),this.p(z)}$provideSelectionRanges(N,q,G,z){return this.s(N,_,Z=>Z.provideSelectionRanges($.URI.revive(q),G,z),[],z)}registerCallHierarchyProvider(N,q,G){const z=this.t(new H(this.h,G),N);return this.e.$registerCallHierarchyProvider(z,this.o(q,N)),this.p(z)}$prepareCallHierarchy(N,q,G,z){return this.s(N,H,Z=>Promise.resolve(Z.prepareSession($.URI.revive(q),G,z)),void 0,z)}$provideCallHierarchyIncomingCalls(N,q,G,z){return this.s(N,H,Z=>Z.provideCallsTo(q,G,z),void 0,z)}$provideCallHierarchyOutgoingCalls(N,q,G,z){return this.s(N,H,Z=>Z.provideCallsFrom(q,G,z),void 0,z)}$releaseCallHierarchy(N,q){this.s(N,H,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(N,q,G){const z=this.t(new te(this.h,G),N);return this.e.$registerTypeHierarchyProvider(z,this.o(q,N)),this.p(z)}$prepareTypeHierarchy(N,q,G,z){return this.s(N,te,Z=>Promise.resolve(Z.prepareSession($.URI.revive(q),G,z)),void 0,z)}$provideTypeHierarchySupertypes(N,q,G,z){return this.s(N,te,Z=>Z.provideSupertypes(q,G,z),void 0,z)}$provideTypeHierarchySubtypes(N,q,G,z){return this.s(N,te,Z=>Z.provideSubtypes(q,G,z),void 0,z)}$releaseTypeHierarchy(N,q){this.s(N,te,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(N,q,G,z){const Z=this.q();this.f.set(Z,new Fe(new we(this.e,this.h,G,Z,N),N));const X=(0,t.$kF)(N,"dropMetadata")&&z?we.toInternalProviderId(N.identifier.value,z.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(q,N),X,(0,t.$kF)(N,"dropMetadata")?z:void 0),this.p(Z)}$provideDocumentOnDropEdits(N,q,G,z,Z,X){return this.s(N,we,De=>Promise.resolve(De.provideDocumentOnDropEdits(q,$.URI.revive(G),z,Z,X)),void 0,void 0)}registerMappedEditsProvider(N,q,G){const z=this.t(new be(this.h,G),N);return this.e.$registerMappedEditsProvider(z,this.o(q,N)),this.p(z)}$provideMappedEdits(N,q,G,z,Z){return this.s(N,be,X=>Promise.resolve(X.provideMappedEdits(q,G,z,Z)),null,Z)}registerDocumentPasteEditProvider(N,q,G,z){const Z=this.q();this.f.set(Z,new Fe(new S(this.e,this.h,G,Z,N),N));const X=S.toInternalProviderId(N.identifier.value,z.id);return this.e.$registerPasteEditProvider(Z,this.o(q,N),X,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:z.copyMimeTypes,pasteMimeTypes:z.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(N,q,G,z,Z){return this.s(N,S,X=>X.prepareDocumentPaste($.URI.revive(q),G,z,Z),void 0,Z)}$providePasteEdits(N,q,G,z,Z,X){return this.s(N,S,De=>De.providePasteEdits(q,$.URI.revive(G),z,Z,X),void 0,X)}static w(N){return{pattern:N.source,flags:N.flags}}static y(N){return{decreaseIndentPattern:pe.w(N.decreaseIndentPattern),increaseIndentPattern:pe.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?pe.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?pe.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:pe.w(N.beforeText),afterText:N.afterText?pe.w(N.afterText):void 0,previousLineText:N.previousLineText?pe.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(pe.z)}static C(N){return{open:N.open,close:N.close,notIn:N.notIn?N.notIn.map(q=>T.SyntaxTokenType.toString(q)):void 0}}static D(N){return N.map(pe.C)}setLanguageConfiguration(N,q,G){const{wordPattern:z}=G;if(z&&(0,g.$Ue)(z))throw new Error(`Invalid language configuration: wordPattern '${z}' is not allowed to match the empty string.`);z?this.h.setWordDefinitionFor(q,z):this.h.setWordDefinitionFor(q,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const Z=this.q(),X={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?pe.w(G.wordPattern):void 0,indentationRules:G.indentationRules?pe.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?pe.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?pe.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,q,X),this.p(Z)}$setWordDefinitions(N){for(const q of N)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$kfc=pe,pe.d=0}),define(Re[255],Ae([1,0,3,8,7,31,14,6,23]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class b{constructor(C,l,p,v){this.c=l,this.d=p,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy($.$NK.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,l){await this.a.$changeLanguage(C,l);const p=this.c.getDocumentData(C);if(!p)throw new Error(`document '${C.toString()}' NOT found`);return p.document}async tokenAtPosition(C,l){const p=C.version,v=P.Position.from(l),n=await this.a.$tokensAtPosition(C.uri,v),o={type:I.StandardTokenType.Other,range:C.getWordRangeAtPosition(l)??new I.$RK(l.line,l.character,l.line,l.character)};if(!n)return o;const i={range:P.Range.to(n.range),type:P.TokenType.to(n.type)};return!i.range.contains(l)||p!==C.version?o:i}createLanguageStatusItem(C,l,p){const v=this.f++,n=this.a,o=this.g,i=`${C.identifier.value}/${l}`;if(o.has(i))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(i);const s={selector:p,id:l,name:C.displayName??C.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const u=new m.$Rc,h=()=>{if(a?.dispose(),!o.has(i)){console.warn(`LanguageStatusItem (${l}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,M.$4g)(()=>{u.clear(),this.a.$setLanguageStatus(v,{id:i,name:s.name??C.displayName??C.name,source:C.displayName??C.name,selector:P.DocumentSelector.from(s.selector,this.e),label:s.text,detail:s.detail??"",severity:s.severity===I.LanguageStatusSeverity.Error?T.default.Error:s.severity===I.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:s.command&&this.d.toInternal(s.command,u),accessibilityInfo:s.accessibilityInformation,busy:s.busy})},0)},t={dispose(){u.dispose(),a?.dispose(),n.$removeLanguageStatus(v),o.delete(i)},get id(){return s.id},get name(){return s.name},set name(r){s.name=r,h()},get selector(){return s.selector},set selector(r){s.selector=r,h()},get text(){return s.text},set text(r){s.text=r,h()},set text2(r){(0,g.$lF)(C,"languageStatusText"),s.text=r,h()},get text2(){return(0,g.$lF)(C,"languageStatusText"),s.text},get detail(){return s.detail},set detail(r){s.detail=r,h()},get severity(){return s.severity},set severity(r){s.severity=r,h()},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(r){s.accessibilityInformation=r,h()},get command(){return s.command},set command(r){s.command=r,h()},get busy(){return s.busy},set busy(r){s.busy=r,h()}};return h(),t}}e.$Jgc=b}),define(Re[82],Ae([1,0,21,12,2,4,15,3,27,17]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;let A=class{constructor(l,p,v){this.f=v,this.d=new Map,this.a=p.getProxy(m.$NK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===$.$a}getMessage(l,p){const{message:v,args:n,comment:o}=p;if(this.c)return(0,P.$Ie)(v,n??{});let i=v;o&&o.length>0&&(i+=`/${Array.isArray(o)?o.join(""):o}`);const s=this.d.get(l)?.contents[i];return s||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,P.$Ie)(s??v,n??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const v=await this.g(l);if(!v){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(v),o=JSON.parse(n);p=l.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${l.identifier.value} from ${v}: ${n.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:v})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive(p)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$8fc=A,e.$8fc=A=Je([Ge(0,g.$8M),Ge(1,b.$RM),Ge(2,M.$jj)],A),e.$9fc=(0,T.$2h)("IExtHostLocalizationService")}),define(Re[256],Ae([1,0,15,3,27,17,2,51]),function(ie,e,$,P,I,T,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;let g=class extends $.$uj{constructor(C,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,m.$yh)(p))),this.r=C.getProxy(P.$NK.MainThreadLogger)}$setLogLevel(C,l){l?this.setLogLevel(M.URI.revive(l),C):this.setLogLevel(C)}setVisibility(C,l){super.setVisibility(C,l),this.r.$setVisibility(C,l)}s(C,l,p){return new b(this.r,C,l,p)}};e.$ihc=g,e.$ihc=g=Je([Ge(0,T.$RM),Ge(1,I.$8M)],g);class b extends $.$pj{constructor(C,l,p,v){super(v?.logLevel==="always"),this.r=C,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,v).then(()=>{this.u(this.n),this.m=!0})}g(C,l){const p=[[C,l]];this.m?this.u(p):this.n.push(...p)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Re[83],Ae([1,0,3,4,6,17,24]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0,e.$0fc=(0,P.$2h)("IExtHostManagedSockets");let m=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy($.$NK.MainThreadManagedSockets)}setFactory(C,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(C,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const l=++this.b,p=await this.c.makeConnection(),v=new I.$Rc;return this.d.set(l,new b(l,p,v)),v.add((0,I.$Qc)(()=>this.d.delete(l))),v.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),v.dispose()})),v.add(p.onDidClose(n=>{this.a.$onDidManagedSocketClose(l,n?.stack??n?.message),v.dispose()})),v.add(p.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(l,M.$ge.wrap(n)))),l}$remoteSocketWrite(C,l){this.d.get(C)?.actual.send(l.buffer)}$remoteSocketEnd(C){const l=this.d.get(C);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$$fc=m,e.$$fc=m=Je([Ge(0,T.$RM)],m);class g{constructor(C,l){this.socketFactoryId=C,this.makeConnection=l}}class b extends I.$Sc{constructor(C,l,p){super(),this.socketId=C,this.actual=l,this.B(p)}}}),define(Re[257],Ae([1,0,3,15,23]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;function T(m){return m&&m.title}let M=class{constructor(g,b){this.b=b,this.a=g.getProxy($.$NK.MainThreadMessageService)}showMessage(g,b,A,C,l){const p={source:{identifier:g.identifier,label:g.displayName||g.name}};let v;typeof C=="string"||T(C)?v=[C,...l]:(p.modal=C?.modal,p.useCustom=C?.useCustom,p.detail=C?.detail,v=l),p.useCustom&&(0,I.$lF)(g,"resolvers");const n=[];for(let o=0;o<v.length;o++){const i=v[o];if(typeof i=="string")n.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:s,isCloseAffordance:a}=i;n.push({title:s,isCloseAffordance:!!a,handle:o})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(b,A,p,n).then(o=>{if(typeof o=="number")return v[o]})}};e.$Kgc=M,e.$Kgc=M=Je([Ge(1,P.$jj)],M)}),define(Re[258],Ae([1,0,18,14,20,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0;let a=class{constructor(d,D,L,y,E){this.m=D,this.n=L,this.o=y,this.q=E,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=d.getProxy(C.$NK.MainThreadNotebookKernels);const k=new l.$fN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$dN("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const B=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:B}}else if(F&&"notebookEditor"in F){const B=this.n.getIdByEditor(F.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return F})],l.$eN.Void);this.o.registerApiCommand(k)}createNotebookController(d,D,L,y,E,k){for(const ne of this.j.values())if(ne.controller.id===D&&b.$hm.equals(d.identifier,ne.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const F=this.k++,B=this;this.q.trace(`NotebookController[${F}], CREATED by ${d.identifier.value}, ${D}`);const ee=()=>console.warn(`NO execute handler from notebook controller '${S.id}' of extension: '${d.identifier}'`);let J=!1;const V=new T.$Sd,R=new T.$Sd,S={id:f(d.identifier,D),notebookType:L,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:y||d.identifier.value,preloads:k?k.map(p.NotebookRendererScript.from):[]};let O=E??ee,Q,re;this.a.$addKernel(F,S).catch(ne=>{console.log(ne),J=!0});let he=0;const fe=()=>{if(J)return;const ne=++he;Promise.resolve().then(()=>{ne===he&&this.a.$updateKernel(F,S)})},ue=new m.$Ac,$e={get id(){return D},get notebookType(){return S.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return S.label},set label(ne){S.label=ne??d.displayName??d.name,fe()},get detail(){return S.detail??""},set detail(ne){S.detail=ne,fe()},get description(){return S.description??""},set description(ne){S.description=ne,fe()},get supportedLanguages(){return S.supportedLanguages},set supportedLanguages(ne){S.supportedLanguages=ne,fe()},get supportsExecutionOrder(){return S.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){S.supportsExecutionOrder=ne,fe()},get rendererScripts(){return S.preloads?S.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return O},set executeHandler(ne){O=ne??ee},get interruptHandler(){return Q},set interruptHandler(ne){Q=ne,S.supportsInterrupt=!!ne,fe()},set variableProvider(ne){(0,i.$lF)(d,"notebookVariableProvider"),re=ne,S.hasVariableProvider=!!ne,ne?.onDidChangeVariables(Pe=>B.a.$variablesUpdated(Pe.uri)),fe()},get variableProvider(){return re},createNotebookCellExecution(ne){if(J)throw new Error("notebook controller is DISPOSED");if(!ue.has(ne.notebook.uri))throw B.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return B._createNotebookCellExecution(ne,f(d.identifier,this.id))},createNotebookExecution(ne){if((0,i.$lF)(d,"notebookExecution"),J)throw new Error("notebook controller is DISPOSED");if(!ue.has(ne.uri))throw B.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return B._createNotebookExecution(ne,f(d.identifier,this.id))},dispose:()=>{J||(this.q.trace(`NotebookController[${F}], DISPOSED`),J=!0,this.j.delete(F),V.dispose(),R.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(ne,Pe){Pe===v.NotebookControllerAffinity2.Hidden&&(0,i.$lF)(d,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(F,ne.uri,Pe)},onDidReceiveMessage:R.event,postMessage(ne,Pe){return(0,i.$lF)(d,"notebookMessaging"),B.a.$postMessage(F,Pe&&B.n.getIdByEditor(Pe),ne)},asWebviewUri(ne){return(0,i.$lF)(d,"notebookMessaging"),(0,n.$ovb)(ne,B.m.remote)}};return this.j.set(F,{extensionId:d.identifier,controller:$e,onDidReceiveMessage:R,onDidChangeSelection:V,associatedNotebooks:ue}),$e}getIdByController(d){for(const[D,L]of this.j)if(L.controller===d)return f(L.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,D){const L=this.g++,y=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(L,D);const E={dispose:()=>{this.f.delete(L),y.a.$removeKernelDetectionTask(L)}};return this.f.set(L,E),E}registerKernelSourceActionProvider(d,D,L){const y=this.i++,E=typeof L.onDidChangeNotebookKernelSourceActions=="function"?y:void 0,k=this;this.h.set(y,L),this.q.trace(`NotebookKernelSourceActionProvider[${y}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(y,y,D);let F;return E!==void 0&&(F=L.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this.h.delete(y),k.a.$removeKernelSourceActionProvider(y,y),F?.dispose()}}}async $provideKernelSourceActions(d,D){const L=this.h.get(d);if(L){const y=new M.$Rc;return(await L.provideNotebookKernelSourceActions(D)??[]).map(k=>p.NotebookKernelSourceAction.from(k,this.o.converter,y))}return[]}$acceptNotebookAssociation(d,D,L){const y=this.j.get(d);if(y){const E=this.n.getNotebookDocument(g.URI.revive(D));L?y.associatedNotebooks.set(E.uri,!0):y.associatedNotebooks.delete(E.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,E.uri.toString(),L),y.onDidChangeSelection.fire({selected:L,notebook:E.apiNotebook})}}async $executeCells(d,D,L){const y=this.j.get(d);if(!y)return;const E=this.n.getNotebookDocument(g.URI.revive(D)),k=[];for(const F of L){const B=E.getCell(F);B&&k.push(B.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,E.uri.toString(),k.length),await y.controller.executeHandler.call(y.controller,k,E.apiNotebook,y.controller)}catch(F){this.q.error(`NotebookController[${d}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(d,D,L){const y=this.j.get(d);if(!y)return;const E=this.n.getNotebookDocument(g.URI.revive(D));if(y.controller.interruptHandler)await y.controller.interruptHandler.call(y.controller,E.apiNotebook);else for(const k of L){const F=E.getCell(k);F&&this.b.get(F.uri)?.cancel()}if(y.controller.interruptHandler){const k=this.c.get(E.uri);L.length&&Array.isArray(k)&&k.length&&k.forEach(F=>F.dispose())}}async $provideVariables(d,D,L,y,E,k,F){const B=this.j.get(d);if(!B)return;const ee=this.n.getNotebookDocument(g.URI.revive(L)),J=B.controller.variableProvider;if(!J)return;const V=y?{name:y,value:""}:void 0,R=E==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,S=J.provideVariables(ee.apiNotebook,V,R,k,F);for await(const O of S){if(F.isCancellationRequested)return;this.a.$receiveVariable(D,O)}}$acceptKernelMessageFromRenderer(d,D,L){const y=this.j.get(d);if(!y)return;const E=this.n.getEditorById(D);y.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:L}))}$cellExecutionChanged(d,D,L){const E=this.n.getNotebookDocument(g.URI.revive(d)).getCell(D);if(E){const k=L?p.NotebookCellExecutionState.to(L):v.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:E.apiCell,state:k})}}_createNotebookCellExecution(d,D){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const y=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!y)throw new Error("invalid cell");if(this.b.has(y.uri))throw new Error(`duplicate execution for ${y.uri}`);const E=new h(D,y,this.a);this.b.set(y.uri,E);const k=E.onDidChangeState(()=>{E.state===u.Resolved&&(E.dispose(),k.dispose(),this.b.delete(y.uri))});return E.asApiObject()}_createNotebookExecution(d,D){const L=this.n.getNotebookDocument(d.uri),y=d.getCells().find(F=>{const B=L.getCellFromApiCell(F);return B&&this.b.has(B.uri)});if(y)throw new Error(`duplicate cell execution for ${y.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const E=new r(D,L,this.a),k=E.onDidChangeState(()=>{E.state===t.Resolved&&(E.dispose(),k.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[E,k]),E.asApiObject()}};e.$Ogc=a,e.$Ogc=a=Je([Ge(4,A.$jj)],a);var u;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(u||(u={}));class h extends M.$Sc{get state(){return this.f}constructor(d,D,L){super(),this.m=D,this.n=L,this.b=h.a++,this.c=new T.$Sd,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new I.$3d),this.h=new c(10,y=>this.s(y)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const D=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new s.$Fv(D))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let D=this.m;if(d&&(D=this.m.notebook.getCellFromApiCell(d)),!D)throw new Error("INVALID cell");return D.handle}y(d){return d.map(D=>{const L=v.$fM.ensureUniqueMimeTypes(D.items,!0);return L===D.items?p.NotebookCellOutput.from(D):p.NotebookCellOutput.from({items:L,id:D.id,metadata:D.metadata})})}async z(d,D,L){const y=this.w(D),E=this.y((0,$.$3b)(d));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:y,append:L,outputs:E})}async C(d,D,L){return d=v.$fM.ensureUniqueMimeTypes((0,$.$3b)(d),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:d.map(p.NotebookCellOutputItem.from),outputId:D.id,append:L})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(L){d.j=L,d.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(L){if(d.f===u.Resolved||d.f===u.Started)throw new Error("Cannot call start again");d.f=u.Started,d.c.fire(),d.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,y){if(d.f===u.Resolved)throw new Error("Cannot call resolve twice");d.f=u.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new s.$Fv({runEndTime:y,lastRunSuccess:L}))},clearOutput(L){return d.t(),d.z([],L,!1)},appendOutput(L,y){return d.t(),d.z(L,y,!0)},replaceOutput(L,y){return d.t(),d.z(L,y,!1)},appendOutputItems(L,y){return d.t(),d.C(L,y,!0)},replaceOutputItems(L,y){return d.t(),d.C(L,y,!1)}})}}h.a=0;var t;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(t||(t={}));class r extends M.$Sc{get state(){return this.f}constructor(d,D,L){super(),this.h=D,this.j=L,this.b=r.a++,this.c=new T.$Sd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new I.$3d),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}r.a=0;class c{constructor(d,D){this.f=d,this.g=D,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new P.$mh,this.b=Date.now(),(0,P.$3g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>d.complete())}}function f(w,d){return`${w.value}/${d}`}e.$Pgc=f}),define(Re[259],Ae([1,0,5,3,107]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;class T{constructor(m,g){this.c=g,this.a=new Map,this.b=m.getProxy(P.$NK.MainThreadNotebookRenderers)}$postRendererMessage(m,g,b){const A=this.c.getEditorById(m);this.a.get(g)?.fire({editor:A.apiEditor,message:b})}createRendererMessaging(m,g){if(!m.contributes?.notebookRenderer?.some(A=>A.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(A,C,l)=>this.d(g).event(A,C,l),postMessage:(A,C)=>{I.$wgc.apiEditorsToExtHost.has(A)&&([A,C]=[C,A]);const l=C&&I.$wgc.apiEditorsToExtHost.get(C);return this.b.$postMessage(l?.id,g,A)}}}d(m){let g=this.a.get(m);return g||(g=new $.$Sd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(m)}}),this.a.set(m,g),g)}}e.$Qgc=T}),define(Re[260],Ae([1,0,6,16,2,23,3]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class m{constructor(b){this.b=new Map,this.a=b.getProxy(M.$NK.MainThreadProfileContentHandlers)}registrProfileContentHandler(b,A,C){if((0,T.$lF)(b,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,C),this.a.$registerProfileContentHandler(A,C.name,C.description,b.identifier.value),(0,$.$Qc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(b,A,C,l){const p=this.b.get(b);if(!p)throw new Error(`Unknown handler with id: ${b}`);return p.saveProfile(A,C,l)}async $readProfile(b,A,C){const l=this.b.get(b);if(!l)throw new Error(`Unknown handler with id: ${b}`);return l.readProfile((0,P.$Ef)(A)?A:I.URI.revive(A),C)}}e.$Tgc=m}),define(Re[261],Ae([1,0,2,3,14,8]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;class M{constructor(g,b){this.d=b,this.c=new Map,this.b=g.getProxy(P.$NK.MainThreadQuickDiff)}$provideOriginalResource(g,b,A){const C=$.URI.revive(b),l=this.c.get(g);return l?(0,I.$Ug)(()=>l.provideOriginalResource(C,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(g,b,A,C){const l=M.a++;return this.c.set(l,b),this.b.$registerQuickDiffProvider(l,T.DocumentSelector.from(g,this.d),A,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Vgc=M,M.a=0}),define(Re[262],Ae([1,0,20,5,6,3,2,7,11,18,31,46,23,8]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;function v(n,o,i){const s=n.getProxy(T.$NK.MainThreadQuickOpen);class a{constructor(D,L){this.e=new Map,this.f=0,this.a=D,this.b=L}showQuickPick(D,L,y,E=$.CancellationToken.None){this.c=void 0;const k=Promise.resolve(L),F=++this.f,B=s.$show(F,{title:y?.title,placeHolder:y?.placeHolder,matchOnDescription:y?.matchOnDescription,matchOnDetail:y?.matchOnDetail,ignoreFocusLost:y?.ignoreFocusOut,canPickMany:y?.canPickMany},E),ee={},J=B.then(()=>ee);return Promise.race([J,k]).then(V=>{if(V===ee)return;const R=(0,l.$kF)(D,"quickPickItemTooltip");return k.then(S=>{const O=[];for(let Q=0;Q<S.length;Q++){const re=S[Q];if(typeof re=="string")O.push({label:re,handle:Q});else if(re.kind===m.QuickPickItemKind.Separator)O.push({type:"separator",label:re.label});else{re.tooltip&&!R&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const he=re.iconPath?c(re.iconPath):void 0;O.push({label:re.label,iconPath:he?.iconPath,iconClass:he?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:R?p.MarkdownString.fromStrict(re.tooltip):void 0,handle:Q})}}return y&&typeof y.onDidSelectItem=="function"&&(this.c=Q=>{y.onDidSelectItem(S[Q])}),s.$setItems(F,O),B.then(Q=>{if(typeof Q=="number")return S[Q];if(Array.isArray(Q))return Q.map(re=>S[re])})})}).then(void 0,V=>{if(!(0,g.$4)(V))return s.$setError(F,V),Promise.reject(V)})}$onItemSelected(D){this.c?.(D)}showInput(D,L=$.CancellationToken.None){return this.d=D?.validateInput,s.$input(D,typeof this.d=="function",L).then(void 0,y=>{if(!(0,g.$4)(y))return Promise.reject(y)})}async $validateInput(D){if(!this.d)return;const L=await this.d(D);if(!L||typeof L=="string")return L;let y;switch(L.severity){case m.InputBoxValidationSeverity.Info:y=A.default.Info;break;case m.InputBoxValidationSeverity.Warning:y=A.default.Warning;break;case m.InputBoxValidationSeverity.Error:y=A.default.Error;break;default:y=L.message?A.default.Error:A.default.Ignore;break}return{content:L.message,severity:y}}async showWorkspaceFolderPick(D,L=$.CancellationToken.None){const y=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!y)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(k=>k.uri.toString()===y.uri.toString())}createQuickPick(D){const L=new f(D,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(D){const L=new w(D,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(D,L){this.e.get(D)?._fireDidChangeValue(L)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,L){const y=this.e.get(D);y instanceof f&&y._fireDidChangeActive(L)}$onDidChangeSelection(D,L){const y=this.e.get(D);y instanceof f&&y._fireDidChangeSelection(L)}$onDidTriggerButton(D,L){this.e.get(D)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(D,L,y){const E=this.e.get(D);E instanceof f&&E._fireDidTriggerItemButton(L,y)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class u{constructor(D,L){this.x=D,this.y=L,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new P.$Sd,this.q=new P.$Sd,this.r=new P.$Sd,this.s=new P.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((L,y)=>{const E=L===m.$$L.Back?-1:y;this.o.set(E,L)}),this.z({buttons:D.map((L,y)=>({...c(L.iconPath),tooltip:L.tooltip,handle:L===m.$$L.Back?-1:y}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const L=this.o.get(D);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),s.$dispose(this._id))}z(D){if(!this.v){for(const L of Object.keys(D)){const y=D[L];this.u[L]=y===void 0?null:y}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){s.$createOrUpdate(this.u),this.u={id:this._id}}}u.a=1;function h(d){if(d instanceof m.$KL)return{id:d.id};const D=r(d),L=t(d);return{dark:typeof D=="string"?M.URI.file(D):D,light:typeof L=="string"?M.URI.file(L):L}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function r(d){return typeof d=="object"&&"dark"in d?d.dark:d}function c(d){const D=h(d);let L,y;return"id"in D?y=C.ThemeIcon.asClassName(D):L=D,{iconPath:L,iconClass:y}}class f extends u{constructor(D,L){super(D.identifier,L),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new P.$Sd,this.L=[],this.M=new P.$Sd,this.N=new P.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((E,k)=>{this.C.set(k,E),this.D.set(E,k)});const L=(0,l.$kF)(this.O,"quickPickItemTooltip"),y=[];for(let E=0;E<D.length;E++){const k=D[E];if(k.kind===m.QuickPickItemKind.Separator)y.push({type:"separator",label:k.label});else{k.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const F=k.iconPath?c(k.iconPath):void 0;y.push({handle:E,label:k.label,iconPath:F?.iconPath,iconClass:F?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:L?p.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((B,ee)=>({...c(B.iconPath),tooltip:B.tooltip,handle:ee}))})}}this.z({items:y})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(D){const L=(0,b.$Hb)(D.map(y=>this.C.get(y)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(D){const L=(0,b.$Hb)(D.map(y=>this.C.get(y)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(D,L){const y=this.C.get(D);if(!y||!y.buttons||!y.buttons.length)return;const E=y.buttons[L];E&&this.N.fire({button:E,item:y})}}class w extends u{constructor(D,L){super(D.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:A.default.Error}):this.z({validationMessage:D.message,severity:D.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new a(o,i)}e.$Wgc=v});var ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)},xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$};define(Re[263],Ae([1,0,2,5,66,6,14,3,18,123,15,22,46,8,23,13,21]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o){"use strict";var i,s,a,u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0;function h(R){return R instanceof $.URI}function t(R,S){return R.scheme===n.Schemas.file&&S.scheme===n.Schemas.file&&o.$e?R.toString()===S.toString():R.toString().toLowerCase()===S.toString().toLowerCase()}function r(R){if(R)return typeof R.iconPath=="string"?$.URI.file(R.iconPath):$.URI.isUri(R.iconPath)||l.ThemeIcon.isThemeIcon(R.iconPath)?R.iconPath:void 0}function c(R){if(R?.icon){if($.URI.isUri(R.icon))return R.icon;if(l.ThemeIcon.isThemeIcon(R.icon))return R.icon;{const S=R.icon;return{light:S.light,dark:S.dark}}}else return}function f(R){if(R.icon){if($.URI.isUri(R.icon))return R.icon;if(l.ThemeIcon.isThemeIcon(R.icon))return R.icon;{const S=R.icon;return{light:S.light,dark:S.dark}}}else return}function w(R){if(R.icon){if($.URI.isUri(R.icon))return R.icon;if(l.ThemeIcon.isThemeIcon(R.icon))return R.icon;{const S=R.icon;return{light:S.light,dark:S.dark}}}else return}function d(R,S){if(!R.iconPath&&!S.iconPath)return 0;if(R.iconPath){if(!S.iconPath)return 1}else return-1;const O=typeof R.iconPath=="string"?R.iconPath:$.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id,Q=typeof S.iconPath=="string"?S.iconPath:$.URI.isUri(S.iconPath)?S.iconPath.fsPath:S.iconPath.id;return(0,b.$Fq)(O,Q)}function D(R,S){let O=0;if(R.strikeThrough!==S.strikeThrough)return R.strikeThrough?1:-1;if(R.faded!==S.faded)return R.faded?1:-1;if(R.tooltip!==S.tooltip)return(R.tooltip||"").localeCompare(S.tooltip||"");if(O=d(R,S),O!==0)return O;if(R.light&&S.light)O=d(R.light,S.light);else{if(R.light)return 1;if(S.light)return-1}if(O!==0)return O;if(R.dark&&S.dark)O=d(R.dark,S.dark);else{if(R.dark)return 1;if(S.dark)return-1}return O}function L(R,S){if(R.command!==S.command)return R.command<S.command?-1:1;if(R.title!==S.title)return R.title<S.title?-1:1;if(R.tooltip!==S.tooltip){if(R.tooltip!==void 0&&S.tooltip!==void 0)return R.tooltip<S.tooltip?-1:1;if(R.tooltip!==void 0)return 1;if(S.tooltip!==void 0)return-1}if(R.arguments===S.arguments)return 0;if(R.arguments)if(S.arguments){if(R.arguments.length!==S.arguments.length)return R.arguments.length-S.arguments.length}else return 1;else return-1;for(let O=0;O<R.arguments.length;O++){const Q=R.arguments[O],re=S.arguments[O];if(Q!==re&&!(h(Q)&&h(re)&&t(Q,re)))return Q<re?-1:1}return 0}function y(R,S){let O=(0,b.$Fq)(R.resourceUri.fsPath,S.resourceUri.fsPath,!0);if(O!==0)return O;if(R.command&&S.command)O=L(R.command,S.command);else{if(R.command)return 1;if(S.command)return-1}if(O!==0)return O;if(R.decorations&&S.decorations)O=D(R.decorations,S.decorations);else{if(R.decorations)return 1;if(S.decorations)return-1}return O}function E(R,S){for(let O=0;O<R.length;O++)if(R[O]!==S[O])return!1;return!0}function k(R,S){return R.command===S.command&&R.title===S.title&&R.tooltip===S.tooltip&&(R.arguments&&S.arguments?E(R.arguments,S.arguments):R.arguments===S.arguments)}function F(R,S){return(0,g.$ub)(R,S,k)}class B{get value(){return this.d}set value(S){S=S??"",ze(this,i,"f").$setInputBoxValue(this.o,S),this.q(S)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(S){ze(this,i,"f").$setInputBoxPlaceholder(this.o,S),this.f=S}get validateInput(){return(0,v.$lF)(this.m,"scmValidation"),this.g}set validateInput(S){if((0,v.$lF)(this.m,"scmValidation"),S&&typeof S!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=S,ze(this,i,"f").$setValidationProviderIsEnabled(this.o,!!S)}get enabled(){return this.h}set enabled(S){S=!!S,this.h!==S&&(this.h=S,ze(this,i,"f").$setInputBoxEnablement(this.o,S))}get visible(){return this.j}set visible(S){S=!!S,this.j!==S&&(this.j=S,ze(this,i,"f").$setInputBoxVisibility(this.o,S))}get actionButton(){return(0,v.$lF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(S){(0,v.$lF)(this.m,"scmInputBoxActionButton"),this.l.value=new T.$Rc,this.k=S;const O=S!==void 0?{command:this.n.converter.toInternal(S.command,this.l.value),icon:c(S),enabled:S.enabled}:void 0;ze(this,i,"f").$setInputBoxActionButton(this.o,O??null)}get document(){return(0,v.$lF)(this.m,"scmTextDocument"),ze(this,s,"f").getDocument(this.p)}constructor(S,O,Q,re,he,fe){this.m=S,this.n=O,this.o=he,this.p=fe,i.set(this,void 0),s.set(this,void 0),this.d="",this.e=new P.$Sd,this.f="",this.h=!0,this.j=!0,this.l=new T.$Tc,xe(this,s,Q,"f"),xe(this,i,re,"f")}showValidationMessage(S,O){(0,v.$lF)(this.m,"scmValidation"),ze(this,i,"f").$showValidationMessage(this.o,S,O)}$onInputBoxValueChange(S){this.q(S)}q(S){this.d=S,this.e.fire(S)}}e.$Xgc=B,i=new WeakMap,s=new WeakMap;class ee{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(S){this.v=S,this.q.$updateGroupLabel(this.t,this.handle,S)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(S){this.p=S,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(S){this.f=[...S],this.k.fire()}constructor(S,O,Q,re,he){this.q=S,this.s=O,this.t=Q,this.u=re,this.v=he,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new P.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new P.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=ee.d++}getResourceState(S){return this.g.get(S)}$executeResourceCommand(S,O){const Q=this.h.get(S);return Q?(0,M.$Ug)(()=>this.s.executeCommand(Q.command,...Q.arguments||[],O)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const S=[...this.f].sort(y),Q=(0,g.$Db)(this.o,S,y).map(fe=>{const ue=fe.toInsert.map($e=>{const ne=this.e++;this.g.set(ne,$e);const Pe=$e.resourceUri;let le;if($e.command)if($e.command.command==="vscode.open"||$e.command.command==="vscode.diff"||$e.command.command==="vscode.changes"){const te=new T.$Rc;le=this.s.converter.toInternal($e.command,te),this.j.set(ne,te)}else this.h.set(ne,$e.command);const me=r($e.decorations),W=$e.decorations&&r($e.decorations.light)||me,ae=$e.decorations&&r($e.decorations.dark)||me,de=[W,ae],ke=$e.decorations&&$e.decorations.tooltip||"",Ee=$e.decorations&&!!$e.decorations.strikeThrough,ce=$e.decorations&&!!$e.decorations.faded,_=$e.contextValue||"";return{rawResource:[ne,Pe,de,ke,Ee,ce,_,le],handle:ne}});return{start:fe.start,deleteCount:fe.deleteCount,toInsert:ue}}),re=Q.map(({start:fe,deleteCount:ue,toInsert:$e})=>[fe,ue,$e.map(ne=>ne.rawResource)]),he=Q.reverse();for(const{start:fe,deleteCount:ue,toInsert:$e}of he){const ne=$e.map(le=>le.handle),Pe=this.n.splice(fe,ue,...ne);for(const le of Pe)this.g.delete(le),this.h.delete(le),this.j.get(le)?.dispose(),this.j.delete(le)}return this.o=S,re}dispose(){this.l=!0,this.m.fire()}}ee.d=0;class J{get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(S){this.g!==S&&(this.g=S,ze(this,a,"f").$updateSourceControl(this.x,{count:S}))}get quickDiffProvider(){return this.h}set quickDiffProvider(S){this.h=S;let O;(0,v.$kF)(this.y,"quickDiffProvider")&&(O=S?.label),ze(this,a,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!S,quickDiffLabel:O})}get historyProvider(){return(0,v.$lF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(S){(0,v.$lF)(this.y,"scmHistoryProvider"),this.j=S,this.k.value=new T.$Rc,ze(this,a,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!S}),S&&(this.k.value.add(S.onDidChangeCurrentHistoryItemGroup(()=>{this.l=S?.currentHistoryItemGroup,ze(this,a,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(S.onDidChangeActionButton(()=>{(0,v.$lF)(this.y,"scmActionButton"),this.m.value=new T.$Rc;const O=S.actionButton!==void 0?{command:this.z.converter.toInternal(S.actionButton.command,this.m.value),description:S.actionButton.description,enabled:S.actionButton.enabled}:void 0;ze(this,a,"f").$onDidChangeHistoryProviderActionButton(this.x,O??null)})))}get commitTemplate(){return this.n}set commitTemplate(S){S!==this.n&&(this.n=S,ze(this,a,"f").$updateSourceControl(this.x,{commitTemplate:S}))}get acceptInputCommand(){return this.p}set acceptInputCommand(S){this.o.value=new T.$Rc,this.p=S;const O=this.z.converter.toInternal(S,this.o.value);ze(this,a,"f").$updateSourceControl(this.x,{acceptInputCommand:O})}get actionButton(){return(0,v.$lF)(this.y,"scmActionButton"),this.s}set actionButton(S){(0,v.$lF)(this.y,"scmActionButton"),this.q.value=new T.$Rc,this.s=S;const O=S!==void 0?{command:this.z.converter.toInternal(S.command,this.q.value),secondaryCommands:S.secondaryCommands?.map(Q=>Q.map(re=>this.z.converter.toInternal(re,this.q.value))),description:S.description,enabled:S.enabled}:void 0;ze(this,a,"f").$updateSourceControl(this.x,{actionButton:O??null})}get statusBarCommands(){return this.u}set statusBarCommands(S){if(this.u&&S&&F(this.u,S))return;this.t.value=new T.$Rc,this.u=S;const O=(S||[]).map(Q=>this.z.converter.toInternal(Q,this.t.value));ze(this,a,"f").$updateSourceControl(this.x,{statusBarCommands:O})}get selected(){return this.v}constructor(S,O,Q,re,he,fe,ue){this.y=S,this.z=re,this.A=he,this.B=fe,this.C=ue,a.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Tc,this.m=new T.$Tc,this.n=void 0,this.o=new T.$Tc,this.p=void 0,this.q=new T.$Tc,this.t=new T.$Tc,this.u=void 0,this.v=!1,this.w=new P.$Sd,this.onDidChangeSelection=this.w.event,this.x=J.d++,this.D=new Map,this.E=new Set,xe(this,a,Q,"f");const $e=$.URI.from({scheme:n.Schemas.vscodeSourceControl,path:`${he}/scm${this.x}/input`,query:ue?`rootUri=${encodeURIComponent(ue.toString())}`:void 0});this.f=new B(S,re,O,ze(this,a,"f"),this.x,$e),ze(this,a,"f").$registerSourceControl(this.x,he,fe,ue,$e)}createResourceGroup(S,O){const Q=new ee(ze(this,a,"f"),this.z,this.x,S,O),re=P.Event.once(Q.onDidDispose)(()=>this.D.delete(Q));return this.D.set(Q,re),this.eventuallyAddResourceGroups(),Q}eventuallyAddResourceGroups(){const S=[],O=[];for(const[Q,re]of this.D){re.dispose();const he=Q.onDidUpdateResourceStates(()=>{this.E.add(Q),this.eventuallyUpdateResourceStates()});P.Event.once(Q.onDidDispose)(()=>{this.E.delete(Q),he.dispose(),this.e.delete(Q.handle),ze(this,a,"f").$unregisterGroup(this.x,Q.handle)}),S.push([Q.handle,Q.id,Q.label,Q.features]);const fe=Q._takeResourceStateSnapshot();fe.length>0&&O.push([Q.handle,fe]),this.e.set(Q.handle,Q)}ze(this,a,"f").$registerGroups(this.x,S,O),this.D.clear()}eventuallyUpdateResourceStates(){const S=[];this.E.forEach(O=>{const Q=O._takeResourceStateSnapshot();Q.length!==0&&S.push([O.handle,Q])}),S.length>0&&ze(this,a,"f").$spliceResourceStates(this.x,S),this.E.clear()}getResourceGroup(S){return this.e.get(S)}setSelectionState(S){this.v=S,this.w.fire(S)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(S=>S.dispose()),ze(this,a,"f").$unregisterSourceControl(this.x)}}a=new WeakMap,J.d=0,Je([(0,I.$uh)(100)],J.prototype,"eventuallyAddResourceGroups",null),Je([(0,I.$uh)(100)],J.prototype,"eventuallyUpdateResourceStates",null);let V=u=class{get onDidChangeActiveProvider(){return this.k.event}constructor(S,O,Q,re){this.n=O,this.o=Q,this.p=re,this.h=new Map,this.j=new C.$jm,this.k=new P.$Sd,this.l=new Map,this.f=S.getProxy(m.$NK.MainThreadSCM),this.g=S.getProxy(m.$NK.MainThreadTelemetry),O.registerArgumentProcessor({processArgument:he=>{if(he&&he.$mid===3){const fe=this.h.get(he.sourceControlHandle);if(!fe)return he;const ue=fe.getResourceGroup(he.groupHandle);return ue?ue.getResourceState(he.handle):he}else if(he&&he.$mid===4){const fe=this.h.get(he.sourceControlHandle);return fe?fe.getResourceGroup(he.groupHandle):he}else if(he&&he.$mid===5){const fe=this.h.get(he.handle);return fe||he}return he}})}createSourceControl(S,O,Q,re){this.p.trace("ExtHostSCM#createSourceControl",S.identifier.value,O,Q,re),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:S.identifier.value});const he=u.d++,fe=new J(S,this.o,this.f,this.n,O,Q,re);this.h.set(he,fe);const ue=this.j.get(S.identifier)||[];return ue.push(fe),this.j.set(S.identifier,ue),fe}registerSourceControlInputBoxValueProvider(S,O,Q){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",S.identifier.value,Q.label);const re=u.e++;return this.l.set(re,Q),this.f.$registerSourceControlInputBoxValueProvider(re,O,Q.label,w(Q)),(0,T.$Qc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(re),this.l.delete(re)})}async $provideInputBoxValue(S,O,Q,re){const he=this.l.get(S);if(he)return await he.provideValue($.URI.revive(O),Q,re)??void 0}getLastInputBox(S){this.p.trace("ExtHostSCM#getLastInputBox",S.identifier.value);const O=this.j.get(S.identifier),Q=O&&O[O.length-1];return Q&&Q.inputBox}$provideOriginalResource(S,O,Q){const re=$.URI.revive(O);this.p.trace("ExtHostSCM#$provideOriginalResource",S,re.toString());const he=this.h.get(S);return!he||!he.quickDiffProvider||!he.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$Ug)(()=>he.quickDiffProvider.provideOriginalResource(re,Q)).then(fe=>fe||null)}$onInputBoxValueChange(S,O){this.p.trace("ExtHostSCM#$onInputBoxValueChange",S);const Q=this.h.get(S);return Q&&Q.inputBox.$onInputBoxValueChange(O),Promise.resolve(void 0)}$executeResourceCommand(S,O,Q,re){this.p.trace("ExtHostSCM#$executeResourceCommand",S,O,Q);const he=this.h.get(S);if(!he)return Promise.resolve(void 0);const fe=he.getResourceGroup(O);return fe?fe.$executeResourceCommand(Q,re):Promise.resolve(void 0)}$validateInput(S,O,Q){this.p.trace("ExtHostSCM#$validateInput",S);const re=this.h.get(S);return!re||!re.inputBox.validateInput?Promise.resolve(void 0):(0,M.$Ug)(()=>re.inputBox.validateInput(O,Q)).then(he=>{if(!he)return Promise.resolve(void 0);const fe=p.MarkdownString.fromStrict(he.message);return fe?Promise.resolve([fe,he.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(S){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",S),S!==void 0&&this.h.get(S)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=S,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(S,O,Q){return await this.h.get(S)?.historyProvider?.resolveHistoryItemGroupBase(O,Q)??void 0}async $resolveHistoryItemGroupCommonAncestor(S,O,Q,re){return await this.h.get(S)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(O,Q,re)??void 0}async $provideHistoryItems(S,O,Q,re){return(await this.h.get(S)?.historyProvider?.provideHistoryItems(O,Q,re))?.map(ue=>({...ue,icon:f(ue)}))??void 0}async $provideHistoryItemChanges(S,O,Q){return await this.h.get(S)?.historyProvider?.provideHistoryItemChanges(O,Q)??void 0}};e.$Ygc=V,V.d=0,V.e=0,e.$Ygc=V=u=Je([Ge(3,A.$jj)],V)}),define(Re[84],Ae([1,0,3,5,4]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=e.$5fc=void 0;class T{constructor(m){this.b=new P.$Sd,this.onDidChangePassword=this.b.event,this.a=m.getProxy($.$NK.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,g){return this.a.$getPassword(m,g)}store(m,g,b){return this.a.$setPassword(m,g,b)}delete(m,g){return this.a.$deletePassword(m,g)}}e.$5fc=T,e.$6fc=(0,I.$2h)("IExtHostSecretState")}),define(Re[264],Ae([1,0,3,8,2]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class T{constructor(m,g){this.d=g,this.c=new Map,this.b=m.getProxy($.$NK.MainThreadShare)}async $provideShare(m,g,b){return await this.c.get(m)?.provideShare({selection:P.Range.to(g.selection),resourceUri:I.URI.revive(g.resourceUri)},b)??void 0}registerShareProvider(m,g){const b=T.a++;return this.c.set(b,g),this.b.$registerShareProvider(b,P.DocumentSelector.from(m,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$Zgc=T,T.a=0}),define(Re[265],Ae([1,0,20,6,3]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0;class T{constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(I.$NK.MainThreadSpeech)}async $createSpeechToTextSession(m,g){const b=this.c.get(m);if(!b)return;const A=new P.$Rc,C=new $.$3d;this.d.set(g,C);const l=A.add(b.provideSpeechToTextSession(C.token));A.add(l.onDidChange(p=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,p)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,g,b){const A=T.a++;return this.c.set(A,b),this.b.$registerProvider(A,g,{extension:m,displayName:m.value}),(0,P.$Qc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$1gc=T,T.a=1});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[266],Ae([1,0,7,3,164,6,8,16]),function(ie,e,$,P,I,T,M,m){"use strict";var g,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=e.$2gc=void 0;class A{constructor(v,n,o,i,s,a=$.StatusBarAlignment.Left,u){if(g.set(this,void 0),b.set(this,void 0),this.i=!1,this.k="",this.q=new T.$Rc,xe(this,g,v,"f"),xe(this,b,n,"f"),s&&i){this.c=(0,$.$oL)(i.identifier,s);const h=o.get(this.c);h&&(a=h.alignLeft?$.StatusBarAlignment.Left:$.StatusBarAlignment.Right,u=h.priority,this.j=!0,this.name=h.name,this.text=h.text,this.tooltip=h.tooltip,this.command=h.command,this.accessibilityInformation=h.accessibilityInformation)}else this.c=String(A.a++);this.e=i,this.f=s,this.g=a,this.h=this.u(u)}u(v){if((0,m.$If)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!A.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new T.$Rc,typeof v=="string"?this.r={fromApi:v,internal:ze(this,b,"f").toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:ze(this,b,"f").toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,ze(this,g,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let n;this.m?n=this.m:n=(0,I.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=A.b.get(this.o.id));const i=M.MarkdownString.fromStrict(this.l);ze(this,g,"f").$setEntry(this.c,v,this.e?.identifier.value,n,this.k,i,this.r?.internal,o,this.o,this.g===$.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$2gc=A,g=new WeakMap,b=new WeakMap,A.a=0,A.b=new Map([["statusBarItem.errorBackground",new $.$LL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new $.$LL("statusBarItem.warningForeground")]]);class C{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",$.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const n={message:v};return this.b.unshift(n),this.c(),new $.$PK(()=>{const o=this.b.indexOf(n);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class l{constructor(v,n){this.e=new Map,this.a=v.getProxy(P.$NK.MainThreadStatusBar),this.b=n,this.c=new C(this)}$acceptStaticEntries(v){for(const n of v)this.e.set(n.entryId,n)}createStatusBarEntry(v,n,o,i){return new A(this.a,this.b,this.e,v,n,o,i)}setStatusBarMessage(v,n){const o=this.c.setMessage(v);let i;return typeof n=="number"?i=setTimeout(()=>o.dispose(),n):typeof n<"u"&&n.then(()=>o.dispose(),()=>o.dispose()),new $.$PK(()=>{o.dispose(),clearTimeout(i)})}}e.$3gc=l}),define(Re[85],Ae([1,0,3,5,4]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0;class T{constructor(m,g){this.c=g,this.b=new P.$Sd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy($.$NK.MainThreadStorage)}registerExtensionStorageKeysToSync(m,g){this.a.$registerExtensionStorageKeysToSync(m,g)}async initializeExtensionStorage(m,g,b){const A=await this.a.$initializeExtensionStorage(m,g);let C;return A&&(C=this.d(m,g,A)),C||b}setValue(m,g,b){return this.a.$setValue(m,g,b)}$acceptValue(m,g,b){const A=this.d(m,g,b);A&&this.b.fire({shared:m,key:g,value:A})}d(m,g,b){try{return JSON.parse(b)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${A}`)}}}e.$Wfc=T,e.$Xfc=(0,I.$2h)("IExtHostStorage")}),define(Re[86],Ae([1,0,4,27,15,63,2]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=void 0,e.$Ffc=(0,$.$2h)("IExtensionStoragePaths");let m=class{constructor(b,A,C){this.d=A,this.f=C,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(b){return M.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,A=await this.g(b);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(b){if(this.c)return M.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return M.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Gfc=m,e.$Gfc=m=Je([Ge(0,P.$8M),Ge(1,I.$jj),Ge(2,T.$Efc)],m)}),define(Re[64],Ae([1,0,5,3,4,2,17,6,7,166,11,194,20,34,195,46,14,8,32]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=e.$2fc=e.$1fc=void 0,e.$1fc=(0,I.$2h)("IExtHostTerminalService");class a{constructor(y,E,k,F){this.l=y,this._id=E,this.m=k,this.n=F,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(ee=>this.f=ee);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(ee,J=!0){B.q(),B.l.$sendText(B._id,ee,J)},show(ee){B.q(),B.l.$show(B._id,ee)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(y,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:y.name,shellPath:y.shellPath??void 0,shellArgs:y.shellArgs??void 0,cwd:y.cwd??E?.cwd??void 0,env:y.env??void 0,icon:w(y.iconPath)??void 0,color:n.ThemeColor.isThemeColor(y.color)?y.color.id:void 0,initialText:y.message??void 0,strictEnv:y.strictEnv??void 0,hideFromUser:y.hideFromUser??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.o(y.location,E?.resolvedExtHostIdentifier),isTransient:y.isTransient??void 0})}async createExtensionTerminal(y,E,k,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:k,color:n.ThemeColor.isThemeColor(F)?F.id:void 0,location:this.o(y,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(y,E){return typeof y=="object"?"parentTerminal"in y&&y.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in y?{viewColumn:i.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus}:void 0:y}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(y){this.n=y}setExitStatus(y,E){this.h=Object.freeze({code:y,reason:E})}setDimensions(y,E){return y===this.d&&E===this.g||y===0||E===0?!1:(this.d=y,this.g=E,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(y){this.k=y}_setProcessId(y){this.f?(this.f(y),this.f=void 0):this.b.then(E=>{E!==y&&(this.b=Promise.resolve(y))})}}e.$2fc=a;class u{get onProcessReady(){return this.b.event}constructor(y){this.g=y,this.id=0,this.shouldPersist=!1,this.a=new $.$Sd,this.onProcessData=this.a.event,this.b=new $.$Sd,this.d=new $.$Sd,this.onDidChangeProperty=this.d.event,this.f=new $.$Sd,this.onProcessExit=this.f.event}refreshProperty(y){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${y}`)}updateProperty(y,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${y}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(y){this.g.handleInput?.(y)}resize(y,E){this.g.setDimensions?.({columns:y,rows:E})}clearBuffer(){}async processBinary(y){}acknowledgeDataEvent(y){}async setUnicodeVersion(y){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(y){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(y||void 0),y&&this.g.setDimensions?.(y),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(y=>y.value)}constructor(y,E,k){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new $.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new $.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new $.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new $.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new $.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new $.$Sd,this.onDidChangeShell=this.N.event,this.O=new $.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new $.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(P.$NK.MainThreadTerminalService),this.y=new v.$Crb(this.a.$sendProcessData),this.a.$registerProcessSupport(y),this.Q.registerArgumentProcessor({processArgument:F=>{const B=ee=>{const J=ee;return this.W(J.instanceId)?.value};switch(F?.$mid){case 15:return B(F);default:{if(Array.isArray(F))for(let ee=0;ee<F.length&&F[ee].$mid===15;ee++)F[ee]=B(F[ee]);return F}}}}),this.B({dispose:()=>{for(const[F,B]of this.g)B.shutdown(!0)}})}getDefaultShell(y){return(y?this.u:this.s)?.path||""}getDefaultShellArgs(y){return(y?this.u:this.s)?.args||[]}createExtensionTerminal(y,E){const k=new a(this.a,(0,p.$mg)(),y,y.name),F=new u(y.pty);return k.createExtensionTerminal(y.location,this.R(y,E).resolvedExtHostIdentifier,w(y.iconPath),d(y.color)).then(B=>{const ee=this.S(B,F);this.h[B]=ee}),this.f.push(k),k.value}R(y,E){if(E=E||{},y.location&&typeof y.location=="object"&&"parentTerminal"in y.location){const k=y.location.parentTerminal;if(k){const F=this.f.find(B=>B.value===k);F&&(E.resolvedExtHostIdentifier=F._id)}}else y.location&&typeof y.location!="object"?E.location=y.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(y,E){if(!this.W(y))throw new Error(`Cannot resolve terminal with id ${y} for virtual process`);const F=new u(E),B=this.S(y,F);this.h[y]=B}async $acceptActiveTerminalChanged(y){const E=this.b;if(y===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const k=this.W(y);k&&(this.b=k,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(y,E){const k=this.W(y);k&&this.O.fire({terminal:k.value,data:E})}async $acceptTerminalDimensions(y,E,k){const F=this.W(y);F&&F.setDimensions(E,k)&&this.L.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptDidExecuteCommand(y,E){const k=this.W(y);k&&this.P.fire({terminal:k.value,...E})}async $acceptTerminalMaximumDimensions(y,E,k){this.g.get(y)?.resize(E,k)}async $acceptTerminalTitleChange(y,E){const k=this.W(y);k&&(k.name=E)}async $acceptTerminalClosed(y,E,k){const F=this.Y(this.f,y);if(F!==null){const B=this.f.splice(F,1)[0];B.setExitStatus(E,k),this.H.fire(B.value)}}$acceptTerminalOpened(y,E,k,F){if(E){const J=this.Y(this.f,E);if(J!==null){this.f[J]._id=y,this.I.fire(this.terminals[J]),this.f[J].isOpen=!0;return}}const B={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:T.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},ee=new a(this.a,y,B,k);this.f.push(ee),this.I.fire(ee.value),ee.isOpen=!0}async $acceptTerminalProcessId(y,E){this.W(y)?._setProcessId(E)}async $startExtensionTerminal(y,E){const k=this.W(y);if(!k)return{message:(0,b.localize)(0,null,y)};k.isOpen||await new Promise(B=>{const ee=this.onDidOpenTerminal(async J=>{J===k.value&&(ee.dispose(),B())})});const F=this.g.get(y);F?F.startSendingEvents(E):this.j[y]={initialDimensions:E}}S(y,E){const k=new m.$Rc;k.add(E.onProcessReady(B=>this.a.$sendProcessReady(y,B.pid,B.cwd,B.windowsPty))),k.add(E.onDidChangeProperty(B=>this.a.$sendProcessProperty(y,B))),this.y.startBuffering(y,E.onProcessData),k.add(E.onProcessExit(B=>this.U(y,B))),this.g.set(y,E);const F=this.j[y];return F&&E instanceof u&&(E.startSendingEvents(F.initialDimensions),delete this.j[y]),k}$acceptProcessAckDataEvent(y,E){this.g.get(y)?.acknowledgeDataEvent(E)}$acceptProcessInput(y,E){this.g.get(y)?.input(E)}$acceptTerminalInteraction(y){const E=this.W(y);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(y,E){this.W(y)?.setSelection(E)}$acceptProcessResize(y,E,k){try{this.g.get(y)?.resize(E,k)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(y,E){this.g.get(y)?.shutdown(E)}$acceptProcessRequestInitialCwd(y){this.g.get(y)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(y,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(y){this.g.get(y)?.getCwd().then(E=>this.a.$sendProcessProperty(y,{type:"cwd",value:E}))}$acceptProcessRequestLatency(y){return Promise.resolve(y)}registerLinkProvider(y){return this.z.add(y),this.z.size===1&&this.a.$startLinkProvider(),new g.$PK(()=>{this.z.delete(y),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(y,E,k){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,k),this.a.$registerProfileProvider(E,y.identifier.value),new g.$PK(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(y,E,k){if(this.D.has(y))throw new Error(`Terminal quick fix provider "${y}" is already registered`);return this.D.set(y,k),this.a.$registerQuickFixProvider(y,E),new g.$PK(()=>{this.D.delete(y),this.a.$unregisterQuickFixProvider(y)})}async $provideTerminalQuickFixes(y,E){const k=new l.$3d().token;if(k.isCancellationRequested)return;const F=this.D.get(y);if(!F)return;const B=await F.provideTerminalQuickFixes(E,k);if(B===null||Array.isArray(B)&&B.length===0)return;const ee=new m.$Rc;if(this.w.value=ee,!Array.isArray(B))return B?i.TerminalQuickFix.from(B,this.Q.converter,ee):void 0;const J=[];for(const V of B){const R=i.TerminalQuickFix.from(V,this.Q.converter,ee);R&&J.push(R)}return J}async $createContributedProfileTerminal(y,E){const k=new l.$3d().token;let F=await this.C.get(y)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${y}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,E);return}this.createTerminalFromOptions(F.options,E)}}async $provideLinks(y,E){const k=this.W(y);if(!k)return[];this.F.delete(y),this.G.get(y)?.dispose(!0);const B=new l.$3d;this.G.set(y,B);const ee=[],J={terminal:k.value,line:E},V=[];for(const O of this.z)V.push(o.Promises.withAsyncBody(async Q=>{B.token.onCancellationRequested(()=>Q({provider:O,links:[]}));const re=await O.provideTerminalLinks(J,B.token)||[];B.token.isCancellationRequested||Q({provider:O,links:re})}));const R=await Promise.all(V);if(B.token.isCancellationRequested)return[];const S=new Map;for(const O of R)O&&O.links.length>0&&ee.push(...O.links.map(Q=>{const re={id:h++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return S.set(re.id,{provider:O.provider,link:Q}),re}));return this.F.set(y,S),ee}$activateLink(y,E){const k=this.F.get(y)?.get(E);k&&k.provider.handleTerminalLink(k.link)}U(y,E){this.y.stopBuffering(y),this.g.delete(y),delete this.j[y];const k=this.h[y];k&&(k.dispose(),delete this.h[y]),this.a.$sendProcessExit(y,E)}W(y){return this.X(this.f,y)}X(y,E){const k=this.Y(y,E);return k!==null?y[k]:null}Y(y,E){const k=y.findIndex(F=>F._id===E);return k===-1?null:k}getEnvironmentVariableCollection(y){let E=this.n.get(y.identifier.value);return E||(E=new r,this.$(y.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Z(y,E){const k=(0,C.$yr)(E.map),F=(0,C.$zr)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(y,E.persistent,k.length===0?void 0:k,F)}$initEnvironmentVariableCollections(y){y.forEach(E=>{const k=E[0],F=new r(E[1]);this.$(k,F)})}$acceptDefaultProfile(y,E){const k=this.s;this.s=y,this.u=E,k?.path!==y.path&&this.N.fire(y.path)}$(y,E){this.n.set(y,E),E.onDidChangeCollection(()=>{this.Z(y,E)})}};e.$3fc=t,e.$3fc=t=Je([Ge(1,s.$bN),Ge(2,M.$RM)],t);class r{get persistent(){return this.b}set persistent(y){this.b=y,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(y){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new $.$Sd,this.map=new Map(y)}getScopedEnvironmentVariableCollection(y){const E=this.h(y);let k=this.a.get(E);return k||(k=new c(this,y),this.a.set(E,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(y,E,k,F){this.f(y,{value:E,type:g.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:F})}append(y,E,k,F){this.f(y,{value:E,type:g.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:F})}prepend(y,E,k,F){this.f(y,{value:E,type:g.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:F})}f(y,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(y,E.scope),F=this.map.get(k),B=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!F||F.value!==E.value||F.type!==E.type||F.options?.applyAtProcessCreation!==B.applyAtProcessCreation||F.options?.applyAtShellIntegration!==B.applyAtShellIntegration||F.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const ee=this.g(y,E.scope),J={variable:y,...E,options:B};this.map.set(ee,J),this.d.fire()}}get(y,E){const k=this.g(y,E),F=this.map.get(k);return F?D(F):void 0}g(y,E){const k=this.h(E);return k.length?`${y}:::${k}`:y}h(y){return this.j(y?.workspaceFolder)??""}j(y){return y?y.uri.toString():void 0}getVariableMap(y){const E=new Map;for(const[k,F]of this.map)this.h(F.scope)===this.h(y)&&E.set(F.variable,D(F));return E}delete(y,E){const k=this.g(y,E);this.map.delete(k),this.d.fire()}clear(y){if(y?.workspaceFolder){for(const[E,k]of this.map)k.scope?.workspaceFolder?.index===y.workspaceFolder.index&&this.map.delete(E);this.k(y)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(y,E){const k=this.h(E),F=this.descriptionMap.get(k);if(!F||F.description!==y){let B;typeof y=="string"?B=y:B=y?.value.split(`

`)[0];const ee={description:B,scope:E};this.descriptionMap.set(k,ee),this.d.fire()}}getDescription(y){const E=this.h(y);return this.descriptionMap.get(E)?.description}k(y){const E=this.h(y);this.descriptionMap.delete(E)}}class c{get persistent(){return this.b.persistent}set persistent(y){this.b.persistent=y}get onDidChangeCollection(){return this.a&&this.a.event}constructor(y,E){this.b=y,this.d=E,this.a=new $.$Sd}getScoped(y){return this.b.getScopedEnvironmentVariableCollection(y)}replace(y,E,k){this.b.replace(y,E,k,this.d)}append(y,E,k){this.b.append(y,E,k,this.d)}prepend(y,E,k){this.b.prepend(y,E,k,this.d)}get(y){return this.b.get(y,this.d)}forEach(y,E){this.b.getVariableMap(this.d).forEach((k,F)=>y.call(E,F,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(y){this.b.delete(y,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(y){this.b.setDescription(y,this.d)}get description(){return this.b.getDescription(this.d)}}let f=class extends t{constructor(y,E){super(!1,y,E)}createTerminal(y,E,k){throw new A.$_}createTerminalFromOptions(y,E){throw new A.$_}};e.$4fc=f,e.$4fc=f=Je([Ge(0,s.$bN),Ge(1,M.$RM)],f);function w(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function d(L){return n.ThemeColor.isThemeColor(L)?L:void 0}function D(L){const y={...L};return delete y.scope,y.options=y.options??void 0,delete y.variable,y}});var ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)},xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$};define(Re[267],Ae([1,0,14,24,20,5,219,98,6,26,16,34,3,17,108,8,7,48,77,58,23]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u){"use strict";var h,t,r,c,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=e.$8gc=e.$7gc=void 0;let w=class extends g.$Sc{constructor(O,Q,re){super(),this.u=re,this.f=this.B(new T.$Sd),this.g=new Map,this.s=this.B(new T.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=O.getProxy(l.$NK.MainThreadTesting),this.m=new J(this.h),this.j=new y(this.h),Q.registerArgumentProcessor({processArgument:he=>{switch(he?.$mid){case 16:{const fe=he,ue=fe.tests[fe.tests.length-1].item.extId;return this.g.get(i.$FJ.root(ue))?.collection.tree.get(ue)?.actual??(0,v.$4M)(he)}case 18:{const{extId:fe,message:ue}=he;return{test:this.g.get(i.$FJ.root(fe))?.collection.tree.get(fe)?.actual,message:n.TestMessage.to(ue)}}default:return he}}}),Q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const he=await Q.executeCommand("_testing.getExplorerSelection"),fe=ue=>{const $e=this.g.get(i.$FJ.root(ue));if($e)return i.$FJ.isRoot(ue)?$e.controller:$e.collection.tree.get(ue)?.actual};return{include:he?.include.map(fe).filter(A.$Mf)||[],exclude:he?.exclude.map(fe).filter(A.$Mf)||[]}})}createTestController(O,Q,re,he){if(this.g.has(Q))throw new Error(`Attempt to insert a duplicate controller with ID "${Q}"`);const fe=new g.$Rc,ue=fe.add(new v.$7M(Q,re,this.u));ue.root.label=re;const $e=new Map,ne=new Set,Pe=this.h,le={items:ue.root.children,get label(){return re},set label(W){re=W,ue.root.label=W,Pe.$updateController(Q,{label:re})},get refreshHandler(){return he},set refreshHandler(W){he=W,Pe.$updateController(Q,{canRefresh:!!W})},get id(){return Q},createRunProfile:(W,ae,de,ke,Ee,ce)=>{let _=(0,m.$Pi)(W);for(;$e.has(_);)_++;return new V(this.h,$e,O,ne,this.s.event,Q,_,W,ae,de,ke,Ee,ce)},createTestItem(W,ae,de){return new v.$5M(Q,W,ae,de)},createTestRun:(W,ae,de=!0)=>this.j.createTestRun(O,Q,ue,W,ae,de),invalidateTestResults:W=>{if(W===void 0)this.h.$markTestRetired(void 0);else{const ae=W instanceof Array?W:[W];this.h.$markTestRetired(ae.map(de=>i.$FJ.fromExtHostTestItem(de,Q).toString()))}},set resolveHandler(W){ue.resolveHandler=W},get resolveHandler(){return ue.resolveHandler},dispose:()=>{fe.dispose()}};Pe.$registerTestController(Q,re,!!he),fe.add((0,g.$Qc)(()=>Pe.$unregisterTestController(Q)));const me={controller:le,collection:ue,profiles:$e,extension:O,activeProfiles:ne};return this.g.set(Q,me),fe.add((0,g.$Qc)(()=>this.g.delete(Q))),fe.add(ue.onDidGenerateDiff(W=>Pe.$publishDiff(Q,W.map(a.TestsDiffOp.serialize)))),le}createTestObserver(){return this.m.checkout()}async runTests(O,Q=I.CancellationToken.None){const re=E(O);if(!re)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const he=this.g.get(re.controllerId);if(!he)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(fe=>i.$FJ.fromExtHostTestItem(fe,he.collection.root.id).toString())??[he.collection.root.id],profileGroup:R[re.kind],profileId:re.profileId,controllerId:re.controllerId}],exclude:O.exclude?.map(fe=>fe.id)},Q)}$syncTests(){for(const{collection:O}of this.g.values())O.flushDiff();return Promise.resolve()}async $provideFileCoverage(O,Q,re){return await this.j.getCoverageReport(O,Q)?.provideFileCoverage(re)??[]}async $resolveFileCoverage(O,Q,re,he){return await this.j.getCoverageReport(O,Q)?.resolveFileCoverage(re,he)??[]}$configureRunProfile(O,Q){this.g.get(O)?.profiles.get(Q)?.configureHandler?.()}$setActiveRunProfiles(O){const Q=new Map;for(const[re,he]of Object.entries(O)){const fe=this.g.get(re);if(!fe)continue;const ue=new Map,$e=he.filter(Pe=>!fe.activeProfiles.has(Pe)),ne=[...fe.activeProfiles].filter(Pe=>!he.includes(Pe));for(const Pe of $e)ue.set(Pe,!0),fe.activeProfiles.add(Pe);for(const Pe of ne)ue.set(Pe,!1),fe.activeProfiles.delete(Pe);ue.size&&Q.set(re,ue)}this.s.fire(Q)}async $refreshTests(O,Q){await this.g.get(O)?.controller.refreshHandler?.(Q)}$publishTestResults(O){this.results=Object.freeze(O.map(Q=>(0,b.$jn)(n.TestResults.to(Q))).concat(this.results).sort((Q,re)=>re.completedAt-Q.completedAt).slice(0,32)),this.f.fire()}async $expandTest(O,Q){const re=this.g.get(i.$FJ.fromString(O).controllerId)?.collection;re&&(await re.expand(O,Q<0?1/0:Q),re.flushDiff())}$acceptDiff(O){this.m.applyDiff(O.map(a.TestsDiffOp.deserialize))}async $runControllerTests(O,Q){return Promise.all(O.map(re=>this.w(re,!1,Q)))}async $startContinuousRun(O,Q){const re=new I.$3d(Q),he=await Promise.all(O.map(fe=>this.w(fe,!0,re.token)));return!Q.isCancellationRequested&&!he.some(fe=>fe.error)&&await new Promise(fe=>Q.onCancellationRequested(fe)),re.dispose(!0),he}async w(O,Q,re){const he=this.g.get(O.controllerId);if(!he)return{};const{collection:fe,profiles:ue,extension:$e}=he,ne=ue.get(O.profileId);if(!ne)return{};const Pe=O.testIds.map(ae=>fe.tree.get(ae)).filter(A.$Mf),le=O.excludeExtIds.map(ae=>he.collection.tree.get(ae)).filter(A.$Mf).filter(ae=>Pe.some(de=>de.fullId.compare(ae.fullId)===2));if(!Pe.length)return{};const me=new o.$mM(Pe.some(ae=>ae.actual instanceof v.$6M)?void 0:Pe.map(ae=>ae.actual),le.map(ae=>ae.actual),ne,Q),W=(0,a.$HJ)(O)&&this.j.prepareForMainThreadTestRun(me,k.fromInternal(O,he.collection),$e,re);try{return await ne.runHandler(me,re),{}}catch(ae){return{error:String(ae)}}finally{W&&(W.hasRunningTasks&&!re.isCancellationRequested&&await T.Event.toPromise(W.onEnd),W.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.j.cancelAllRuns():this.j.cancelRunById(O)}};e.$7gc=w,e.$7gc=w=Je([Ge(0,p.$RM)],w);const d=1e4;var D;(function(S){S[S.Running=0]="Running",S[S.Cancelling=1]="Cancelling",S[S.Ended=2]="Ended"})(D||(D={}));class L extends g.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(O,Q,re,he){super(),this.s=O,this.u=Q,this.w=re,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new T.$Sd),this.m=this.B(new T.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$3d(he));const fe=this.B(new $.$bh(()=>this.y(),d));this.B(this.h.token.onCancellationRequested(()=>fe.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(O){const Q=this.s.id,re=this.s.controllerId,he=(0,C.$mg)(),fe=this.w,ue=this.m;let $e;const ne=W=>(ae,...de)=>{if(le){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ae)&&(this.C(ae),W(ae,...de))},Pe=(W,ae)=>{const de=ae instanceof Array?ae.map(n.TestMessage.from):[n.TestMessage.from(ae)];if(W.uri&&W.range){const ke={range:n.Range.from(W.range),uri:W.uri};for(const Ee of de)Ee.location=Ee.location||ke}this.u.$appendTestMessagesInRun(Q,he,i.$FJ.fromExtHostTestItem(W,re).toString(),de)};let le=!1;const me={isPersisted:this.s.isPersisted,token:this.h.token,name:O,get coverageProvider(){return $e?.provider},set coverageProvider(W){(0,u.$lF)(fe,"testCoverage"),$e=W&&new F(W),ue.fire({taskId:he,runId:Q,coverage:$e})},enqueued:ne(W=>{this.u.$updateTestStateInRun(Q,he,i.$FJ.fromExtHostTestItem(W,re).toString(),1)}),skipped:ne(W=>{this.u.$updateTestStateInRun(Q,he,i.$FJ.fromExtHostTestItem(W,re).toString(),5)}),started:ne(W=>{this.u.$updateTestStateInRun(Q,he,i.$FJ.fromExtHostTestItem(W,re).toString(),2)}),errored:ne((W,ae,de)=>{Pe(W,ae),this.u.$updateTestStateInRun(Q,he,i.$FJ.fromExtHostTestItem(W,re).toString(),6,de)}),failed:ne((W,ae,de)=>{Pe(W,ae),this.u.$updateTestStateInRun(Q,he,i.$FJ.fromExtHostTestItem(W,re).toString(),4,de)}),passed:ne((W,ae)=>{this.u.$updateTestStateInRun(Q,he,i.$FJ.fromExtHostTestItem(W,this.s.controllerId).toString(),3,ae)}),appendOutput:(W,ae,de)=>{le||(de&&(this.s.isIncluded(de)?this.C(de):de=void 0),this.u.$appendOutputToRun(Q,he,P.$ge.fromString(W),ae&&n.location.from(ae),de&&i.$FJ.fromExtHostTestItem(de,re).toString()))},end:()=>{le||(le=!0,this.u.$finishedTestRunTask(Q,he),this.f.delete(he),this.f.size||this.z())}};return this.f.set(he,{run:me}),this.u.$startedTestRunTask(Q,{id:he,name:O,running:!0}),me}y(){for(const{run:O}of this.f.values())O.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(O){if(!(O instanceof v.$5M))throw new s.$JM(O.id);if(this.g.has(i.$FJ.fromExtHostTestItem(O,this.s.controllerId).toString()))return;const Q=[],re=this.s.colllection.root;for(;;){const he=n.TestItem.from(O);if(Q.unshift(he),this.g.has(he.extId)||(this.g.add(he.extId),O===re))break;O=O.parent||re}this.u.$addTestsToRun(this.s.controllerId,this.s.id,Q)}dispose(){this.z(),super.dispose()}}class y{get trackers(){return this.c.values()}constructor(O){this.f=O,this.c=new Map,this.d=[]}getCoverageReport(O,Q){return this.d.find(re=>re.runId===O)?.coverage.get(Q)}prepareForMainThreadTestRun(O,Q,re,he){return this.g(O,Q,re,he)}cancelRunById(O){for(const Q of this.c.values())if(Q.id===O){Q.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,Q,re,he,fe,ue){const $e=this.c.get(he);if($e)return $e.createRun(fe);const ne=k.fromPublic(Q,re,he,ue),Pe=E(he);this.f.$startedExtensionTestRun({controllerId:Q,continuous:!!he.continuous,profile:Pe&&{group:R[Pe.kind],id:Pe.profileId},exclude:he.exclude?.map(me=>i.$FJ.fromExtHostTestItem(me,re.root.id).toString())??[],id:ne.id,include:he.include?.map(me=>i.$FJ.fromExtHostTestItem(me,re.root.id).toString())??[re.root.id],persist:ue});const le=this.g(he,ne,O);return T.Event.once(le.onEnd)(()=>{this.f.$finishedExtensionTestRun(ne.id),le.dispose()}),le.createRun(fe)}g(O,Q,re,he){const fe=new L(Q,this.f,re,he);this.c.set(O,fe);let ue;const $e=fe.onDidCoverage(({runId:ne,taskId:Pe,coverage:le})=>{ue||(ue={runId:ne,coverage:new Map},this.d.unshift(ue),this.d.length>a.$MJ&&this.d.pop()),ue.coverage.set(Pe,le),this.f.$signalCoverageAvailable(ne,Pe,!!le)});return T.Event.once(fe.onEnd)(()=>{this.c.delete(O),$e.dispose()}),fe}}e.$8gc=y;const E=S=>{if(S.profile){if(!(S.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return S.profile}};class k{static fromPublic(O,Q,re,he){return new k(O,(0,C.$mg)(),re.include?.map(fe=>i.$FJ.fromExtHostTestItem(fe,O).toString())??[O],re.exclude?.map(fe=>i.$FJ.fromExtHostTestItem(fe,O).toString())??[],he,Q)}static fromInternal(O,Q){return new k(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,Q)}constructor(O,Q,re,he,fe,ue){this.controllerId=O,this.id=Q,this.isPersisted=fe,this.colllection=ue,this.c=re.map($e=>$e+"\0"),this.d=he.map($e=>$e+"\0")}isIncluded(O){const Q=i.$FJ.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const re of this.d)if(Q===re||Q.startsWith(re))return!1;for(const re of this.c)if(Q===re||Q.startsWith(re))return!0;return!1}}e.$9gc=k;class F{constructor(O){this.provider=O}async provideFileCoverage(O){this.c||(this.c=(async()=>this.provider.provideFileCoverage(O))());try{return(await this.c)?.map(n.TestCoverage.fromFile)??[]}catch(Q){throw this.c=void 0,Q}}async resolveFileCoverage(O,Q){const re=await this.c;let he=re?.[O];return!this.provider||!re||!he?[]:(he.detailedCoverage||(he=re[O]=await this.provider.resolveFileCoverage?.(he,Q)??he),he.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class B{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,n.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const Q=i.$FJ.parentId(O.item.extId);if(Q&&this.g.has(Q.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:Q,f:re}=this;return{get added(){return[...O].map(he=>he.revived)},get updated(){return[...Q].map(he=>he.revived)},get removed(){return[...re].map(he=>he.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class ee extends a.$NJ{constructor(){super(...arguments),this.q=new T.$Sd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,Q){return{...O,revived:n.TestItem.toPlain(O.item),depth:Q?Q.depth+1:0,children:new Set}}o(){return new B(this.q)}}class J{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(Q=>Q.revived)},dispose:(0,M.$db)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new ee;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class V{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,ze(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,ze(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,ze(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,ze(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?n.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,ze(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}get isSelected(){return(0,u.$lF)(ze(this,t,"f"),"testingActiveProfile"),ze(this,r,"f").has(this.profileId)}get onDidChangeSelected(){return(0,u.$lF)(ze(this,t,"f"),"testingActiveProfile"),T.Event.chain(ze(this,c,"f"),O=>O.map(Q=>Q.get(this.controllerId)?.get(this.profileId)).filter(A.$Mf))}constructor(O,Q,re,he,fe,ue,$e,ne,Pe,le,me=!1,W=void 0,ae=!1){this.controllerId=ue,this.profileId=$e,this.d=ne,this.kind=Pe,this.runHandler=le,this.f=me,this._tag=W,this.g=ae,h.set(this,void 0),t.set(this,void 0),r.set(this,void 0),c.set(this,void 0),f.set(this,void 0),xe(this,h,O,"f"),xe(this,f,Q,"f"),xe(this,t,re,"f"),xe(this,r,he,"f"),xe(this,c,fe,"f"),Q.set($e,this);const de=R[Pe];if(typeof de!="number")throw new Error(`Unknown TestRunProfile.group ${Pe}`);ze(this,h,"f").$publishTestRunProfile({profileId:$e,controllerId:ue,tag:W?n.TestTag.namespace(this.controllerId,W.id):null,label:ne,group:de,isDefault:me,hasConfigurationHandler:!1,supportsContinuousRun:ae})}dispose(){ze(this,f,"f")?.delete(this.profileId)&&(xe(this,f,void 0,"f"),ze(this,h,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.$0gc=V,h=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap,f=new WeakMap;const R={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Re[268],Ae([1,0,18,11,5,3,109,8,7]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class b{constructor(C,l){this.i=l,this.a=new I.$Sd({onListenerError:P.$2}),this.b=new I.$Sd({onListenerError:P.$2}),this.c=new I.$Sd({onListenerError:P.$2}),this.d=new I.$Sd({onListenerError:P.$2}),this.f=new I.$Sd({onListenerError:P.$2}),this.g=new I.$Sd({onListenerError:P.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(T.$NK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const l=this.i.allEditors();return C?l:l.map(p=>p.value)}async showTextDocument(C,l,p){let v;typeof l=="number"?v={position:m.ViewColumn.from(l),preserveFocus:p}:typeof l=="object"?v={position:m.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?m.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:v={preserveFocus:!1};const n=await this.h.$tryShowTextDocument(C.uri,v),o=n&&this.i.getEditor(n);if(o)return o.value;throw n?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,l){return new M.$YM(this.h,C,l).value}$acceptEditorPropertiesChanged(C,l){const p=this.i.getEditor(C);if(!p)throw new Error("unknown text editor");if(l.options&&p._acceptOptions(l.options),l.selections){const v=l.selections.selections.map(m.Selection.to);p._acceptSelections(v)}if(l.visibleRanges){const v=$.$Hb(l.visibleRanges.map(m.Range.to));p._acceptVisibleRanges(v)}if(l.options&&this.b.fire({textEditor:p.value,options:{...l.options,lineNumbers:m.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const v=g.TextEditorSelectionChangeKind.fromValue(l.selections.source),n=l.selections.selections.map(m.Selection.to);this.a.fire({textEditor:p.value,selections:n,kind:v})}if(l.visibleRanges){const v=$.$Hb(l.visibleRanges.map(m.Range.to));this.c.fire({textEditor:p.value,visibleRanges:v})}}$acceptEditorPositionData(C){for(const l in C){const p=this.i.getEditor(l);if(!p)throw new Error("Unknown text editor");const v=m.ViewColumn.to(C[l]);p.value.viewColumn!==v&&(p._acceptViewColumn(v),this.d.fire({textEditor:p.value,viewColumn:v}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$tfc=b}),define(Re[269],Ae([1,0,2,4,3,6,7,8,22,16]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=e.$_gc=void 0,e.$_gc=(0,P.$2h)("IExtHostTimeline");class A{constructor(p,v){this.b=new Map,this.c=new Map,this.a=p.getProxy(I.$NK.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(n,o)=>{if(n&&n.$mid===12)if(this.b.get(n.source)&&g.$hm.equals(o,this.b.get(n.source)?.extension)){const i=n.uri===void 0?void 0:$.URI.revive(n.uri);return this.c.get(n.source)?.get(C(i))?.get(n.handle)}else return;return n}})}async $getTimeline(p,v,n,o){return this.b.get(p)?.provider.provideTimeline($.URI.revive(v),n,o)}registerTimelineProvider(p,v,n,o){const i=new T.$Rc,s=this.d(v.id,o,i).bind(this);let a;v.onDidChange&&(a=v.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:v.id}),this));const u=this.c;return this.f({...v,scheme:p,onDidChange:void 0,async provideTimeline(h,t,r){t?.resetCache&&(i.clear(),u.get(v.id)?.clear());const c=await v.provideTimeline(h,t,r);if(c==null)return;const f=s(h,t);return{...c,source:v.id,items:c.items.map(f)}},dispose(){for(const h of u.values())h.get(v.id)?.clear();a?.dispose(),i.dispose()}},n)}d(p,v,n){return(o,i)=>{let s;if(i?.cacheResults){let a=this.c.get(p);a===void 0&&(a=new Map,this.c.set(p,a));const u=C(o);s=a.get(u),s===void 0&&(s=new Map,a.set(u,s))}return a=>{const{iconPath:u,...h}=a,t=`${p}|${a.id??a.timestamp}`;s?.set(t,a);let r,c,f;a.iconPath&&(u instanceof M.$KL?f={id:u.id,color:u.color}:$.URI.isUri(u)?(r=u,c=u):{light:r,dark:c}=u);let w;return M.$eL.isMarkdownString(h.tooltip)?w=m.MarkdownString.from(h.tooltip):(0,b.$Ef)(h.tooltip)?w=h.tooltip:M.$eL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=m.MarkdownString.from(h.detail)):(0,b.$Ef)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=h.detail),{...h,id:h.id??void 0,handle:t,source:p,command:a.command?v.toInternal(a.command,n):void 0,icon:r,iconDark:c,themeIcon:f,tooltip:w,accessibilityInformation:a.accessibilityInformation}}}}f(p,v){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:v}),(0,T.$Qc)(()=>{for(const o of this.c.values())o.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$ahc=A;function C(l){return l?.toString()}}),define(Re[87],Ae([1,0,20,5,6,168,4,15,197,3,27,17,7]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gyb=e.$fyb=e.TunnelDtoConverter=void 0;class p extends g.$vv{}var v;(function(o){function i(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:a.protocol}}o.fromApiTunnel=i;function s(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==g.TunnelPrivacyId.ConstantPrivate&&a.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}o.fromServiceTunnel=s})(v||(e.TunnelDtoConverter=v={})),e.$fyb=(0,M.$2h)("IExtHostTunnelService");let n=class extends I.$Sc{constructor(i,s,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new P.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(b.$NK.MainThreadTunnelService)}async openTunnel(i,s){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${s.remoteAddress.host}:${s.remoteAddress.port}.`);const a=await this.a.$openTunnel(s,i.displayName);if(a){const u=new p(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(u),u}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,s){const a=this.u();return this.r.set(a,{selector:i,provider:s}),this.a.$registerPortsAttributesProvider(i,a),new l.$PK(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(i,s,a,u,h){const t=[];for(const c of i){const f=this.r.get(c);if(!f)return[];t.push(...await Promise.all(s.map(async w=>{let d;try{d=await f.provider.providePortAttributes({port:w,pid:a,commandLine:u},h)}catch{d=await f.provider.providePortAttributes(w,a,u,h)}return{providedAttributes:d,port:w}})))}const r=t.filter(c=>!!c.providedAttributes);return r.length>0?r.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,s){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(u,h)=>await i.provideTunnel(u,h,new $.$3d().token)??void 0;const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,privacyOptions:s.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(a),Promise.resolve((0,I.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,s){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const a=i.tunnelFactory??(s?this.w(s):void 0);if(a){this.b=a;let u=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const h=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:u}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,I.$Qc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,s){if(this.g.has(i.host)){const a=this.g.get(i.host);a.has(i.port)&&(s&&a.get(i.port).disposeListener.dispose(),await a.get(i.port).tunnel.dispose(),a.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,s){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(i,s);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const u=await a;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),u===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const h=this.B(u.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(u.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:u,disposeListener:h}),v.fromApiTunnel(u)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(i){const s=await Promise.all(i.map(u=>this.f(u.host,u.port,u.detail??""))),a=i.filter((u,h)=>s[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(u=>u.port).join(", ")} to ${a.map(u=>u.port).join(", ")}`),a}};e.$gyb=n,e.$gyb=n=Je([Ge(0,C.$RM),Ge(1,A.$8M),Ge(2,m.$jj)],n)}),define(Re[270],Ae([1,0,6,13,2,3]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class M{constructor(g){this.c=new Map,this.b=g.getProxy(T.$NK.MainThreadUriOpeners)}registerExternalUriOpener(g,b,A,C){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const l=C.schemes.find(p=>!M.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(b,A),this.b.$registerUriOpener(b,C.schemes,g,C.label),(0,$.$Qc)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(g,b,A){const C=this.c.get(g);if(!C)throw new Error(`Unknown opener with id: ${g}`);const l=I.URI.revive(b);return C.canOpenExternalUri(l,A)}async $openUri(g,b,A){const C=this.c.get(g);if(!C)throw new Error(`Unknown opener id: '${g}'`);return C.openExternalUri(I.URI.revive(b.resolvedUri),{sourceUri:I.URI.revive(b.sourceUri)},A)}}e.$chc=M,M.a=new Set([P.Schemas.http,P.Schemas.https])}),define(Re[271],Ae([1,0,3,2,6,11,22]),function(ie,e,$,P,I,T,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class m{constructor(b){this.c=new M.$im,this.d=new Map,this.b=b.getProxy($.$NK.MainThreadUrls)}registerUriHandler(b,A){const C=b.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const l=m.a++;return this.c.add(C),this.d.set(l,A),this.b.$registerUriHandler(l,C,b.displayName||b.name),(0,I.$Qc)(()=>{this.c.delete(C),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(b,A){const C=this.d.get(b);if(!C)return Promise.resolve(void 0);try{C.handleUri(P.URI.revive(A))}catch(l){(0,T.$1)(l)}return Promise.resolve(void 0)}async createAppUri(b){return P.URI.revive(await this.b.$createAppUri(b))}}e.$dhc=m,m.a=0});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[65],Ae([1,0,5,6,13,26,2,182,204,78,3]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";var C,l,p,v,n,o,i,s,a,u,h,t,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=e.$Kfc=e.$Jfc=e.$Ifc=e.$Hfc=void 0;class c{constructor(F,B,ee,J,V,R,S){C.set(this,void 0),l.set(this,void 0),p.set(this,void 0),v.set(this,void 0),n.set(this,void 0),o.set(this,void 0),i.set(this,""),s.set(this,void 0),a.set(this,!1),u.set(this,!1),h.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new $.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new $.$Sd),this._onDidDispose=ze(this,r,"f").event,xe(this,C,F,"f"),xe(this,l,B,"f"),xe(this,s,ee,"f"),xe(this,v,J,"f"),xe(this,n,V,"f"),xe(this,o,R,"f"),xe(this,h,f(R),"f"),xe(this,t,w(R),"f"),xe(this,p,S,"f")}dispose(){xe(this,a,!0,"f"),ze(this,r,"f").fire(),ze(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(F){return xe(this,u,!0,"f"),(0,b.$ovb)(F,ze(this,v,"f"))}get cspSource(){const F=ze(this,o,"f").extensionLocation;if(F.scheme===I.Schemas.https||F.scheme===I.Schemas.http){let B=F.toString();return B.endsWith("/")||(B+="/"),B+" "+b.$nvb}return b.$nvb}get html(){return this.a(),ze(this,i,"f")}set html(F){this.a(),ze(this,i,"f")!==F&&(xe(this,i,F,"f"),ze(this,t,"f")&&!ze(this,u,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(F)&&(xe(this,u,!0,"f"),ze(this,p,"f").report("Webview vscode-resource: uris",ze(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),ze(this,l,"f").$setHtml(ze(this,C,"f"),this.b(F)))}get options(){return this.a(),ze(this,s,"f")}set options(F){this.a(),T.$mn(ze(this,s,"f"),F)||ze(this,l,"f").$setOptions(ze(this,C,"f"),L(ze(this,o,"f"),ze(this,n,"f"),F)),xe(this,s,F,"f")}async postMessage(F){if(ze(this,a,"f"))return!1;const B=(0,g.$6kb)(F,{serializeBuffersForPostMessage:ze(this,h,"f")});return ze(this,l,"f").$postMessage(ze(this,C,"f"),B.message,...B.buffers)}a(){if(ze(this,a,"f"))throw new Error("Webview is disposed")}b(F){if(!ze(this,t,"f"))return F;const B=ze(this,o,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,ee=ze(this,o,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?ze(this,o,"f").extensionLocation.authority:void 0;return F.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(J,V,R,S,O,Q)=>{const re=M.URI.from({scheme:S||"file",path:decodeURIComponent(O)}),he=(0,b.$ovb)(re,{isRemote:B,authority:ee}).toString();return`${V}${he}${Q}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(J,V,R,S,O,Q)=>{const re=M.URI.from({scheme:S||"file",path:decodeURIComponent(O)}),he=(0,b.$ovb)(re,{isRemote:B,authority:ee}).toString();return`${V}${he}${Q}`})}}e.$Hfc=c,C=new WeakMap,l=new WeakMap,p=new WeakMap,v=new WeakMap,n=new WeakMap,o=new WeakMap,i=new WeakMap,s=new WeakMap,a=new WeakMap,u=new WeakMap,h=new WeakMap,t=new WeakMap,r=new WeakMap;function f(k){try{const F=(0,m.$2o)((0,m.$1o)(k.engines.vscode));return!!F&&F.majorBase>=1&&F.minorBase>=57}catch{return!1}}e.$Ifc=f;function w(k){try{const F=(0,m.$2o)((0,m.$1o)(k.engines.vscode));return F?F.majorBase<1||F.majorBase===1&&F.minorBase<60:!1}catch{return!1}}class d extends P.$Sc{constructor(F,B,ee,J,V){super(),this.c=B,this.f=ee,this.g=J,this.h=V,this.b=new Map,this.a=F.getProxy(A.$NK.MainThreadWebviews)}dispose(){super.dispose();for(const F of this.b.values())F.dispose();this.b.clear()}$onMessage(F,B,ee){const J=this.j(F);if(J){const{message:V}=(0,g.$7kb)(B,ee.value);J._onMessageEmitter.fire(V)}}$onMissingCsp(F,B){this.g.warn(`${B} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(F,B,ee){const J=new c(F,this.a,y(B),this.c,this.f,ee,this.h);this.b.set(F,J);const V=J._onDidDispose(()=>{V.dispose(),this.deleteWebview(F)});return J}deleteWebview(F){this.b.delete(F)}j(F){return this.b.get(F)}}e.$Jfc=d;function D(k){return{id:k.identifier,location:k.extensionLocation}}e.$Kfc=D;function L(k,F,B){return{enableCommandUris:B.enableCommandUris,enableScripts:B.enableScripts,enableForms:B.enableForms,portMapping:B.portMapping,localResourceRoots:B.localResourceRoots||E(k,F)}}e.$Lfc=L;function y(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(F=>M.URI.from(F))}}function E(k,F){return[...(F?.getWorkspaceFolders()||[]).map(B=>B.uri),k.extensionLocation]}}),define(Re[272],Ae([1,0,20,98,6,13,25,2,8,65,75,3,7]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;class p{constructor(r,c){this.document=r,this.b=c,this.a=1,this.c=new A.$afc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,c){await this.f(r).undo(),c||this.disposeBackup()}async redo(r,c){await this.f(r).redo(),c||this.disposeBackup()}disposeEdits(r){for(const c of r)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=h(this.document.uri)+this.a++;return(0,M.$Dg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const c=this.c.get(r,0);if(!c)throw new Error("No edit found");return c}}class v{constructor(){this.a=new Map}get(r,c){return this.a.get(this.b(r,c))}add(r,c,f){const w=this.b(r,c.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${r} resource:${c.uri}`);const d=new p(c,f);return this.a.set(w,d),d}delete(r,c){const f=this.b(r,c.uri);this.a.delete(f)}b(r,c){return`${r}@@@${c}`}}var n;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(r,c,f){return this.b(0,r,c,f)}addCustomProvider(r,c,f){return this.b(1,r,c,f)}get(r){return this.a.get(r)}b(r,c,f,w){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:r,extension:f,provider:w}),new l.$PK(()=>this.a.delete(c))}}class i{constructor(r,c,f,w,d){this.d=c,this.f=f,this.g=w,this.h=d,this.b=new o,this.c=new v,this.a=r.getProxy(C.$NK.MainThreadCustomEditors)}registerCustomEditorProvider(r,c,f,w){const d=new I.$Rc;return a(f)?(d.add(this.b.addTextProvider(c,r,f)),this.a.$registerTextEditorProvider((0,b.$Kfc)(r),c,w.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,b.$Ifc)(r))):(d.add(this.b.addCustomProvider(c,r,f)),s(f)&&d.add(f.onDidChangeCustomDocument(D=>{const L=this.i(c,D.document.uri);if(u(D)){const y=L.addEdit(D);this.a.$onDidEdit(D.document.uri,c,y,D.label)}else this.a.$onContentChange(D.document.uri,c)})),this.a.$registerCustomEditorProvider((0,b.$Kfc)(r),c,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,b.$Ifc)(r))),l.$PK.from(d,new l.$PK(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(r,c,f,w,d){const D=this.b.get(c);if(!D)throw new Error(`No provider found for '${c}'`);if(D.type!==1)throw new Error(`Invalid provide type for '${c}'`);const L=m.URI.revive(r),y=await D.provider.openCustomDocument(L,{backupId:f,untitledDocumentData:w?.buffer},d);let E;return s(D.provider)&&this.f&&(E=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(c,y,E),{editable:s(D.provider)}}async $disposeCustomDocument(r,c){const f=this.b.get(c);if(!f)throw new Error(`No provider found for '${c}'`);if(f.type!==1)throw new Error(`Invalid provider type for '${c}'`);const w=m.URI.revive(r),{document:d}=this.i(c,w);this.c.delete(c,d),d.dispose()}async $resolveCustomEditor(r,c,f,w,d,D){const L=this.b.get(f);if(!L)throw new Error(`No provider found for '${f}'`);const y=g.ViewColumn.to(d),E=this.g.createNewWebview(c,w.contentOptions,L.extension),k=this.h.createNewWebviewPanel(c,f,w.title,y,w.options,E,w.active),F=m.URI.revive(r);switch(L.type){case 1:{const{document:B}=this.i(f,F);return L.provider.resolveCustomEditor(B,k,D)}case 0:{const B=this.d.getDocument(F);return L.provider.resolveCustomTextEditor(B,k,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,c,f){this.i(c,r).disposeEdits(f)}async $onMoveCustomEditor(r,c,f){const w=this.b.get(f);if(!w)throw new Error(`No provider found for '${f}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const d=this.h.getWebviewPanel(r);if(!d)throw new Error("No webview found");const D=m.URI.revive(c),L=this.d.getDocument(D);await w.provider.moveCustomTextEditor(L,d,$.CancellationToken.None)}async $undo(r,c,f,w){return this.i(c,r).undo(f,w)}async $redo(r,c,f,w){return this.i(c,r).redo(f,w)}async $revert(r,c,f){const w=this.i(c,r);await this.j(c).revertCustomDocument(w.document,f),w.disposeBackup()}async $onSave(r,c,f){const w=this.i(c,r);await this.j(c).saveCustomDocument(w.document,f),w.disposeBackup()}async $onSaveAs(r,c,f,w){const d=this.i(c,r);return this.j(c).saveCustomDocumentAs(d.document,m.URI.revive(f),w)}async $backup(r,c,f){const w=this.i(c,r),D=await this.j(c).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},f);return w.updateBackup(D),D.id}i(r,c){const f=this.c.get(r,m.URI.revive(c));if(!f)throw new Error("No custom document found");return f}j(r){const f=this.b.get(r)?.provider;if(!f||!s(f))throw new Error("Custom document is not editable");return f}}e.$Nfc=i;function s(t){return!!t.onDidChangeCustomDocument}function a(t){return typeof t.resolveCustomTextEditor=="function"}function u(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const r=t.scheme===T.Schemas.file||t.scheme===T.Schemas.untitled?t.fsPath:t.toString();return(0,P.$Pi)(r)+""}});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[273],Ae([1,0,5,6,2,34,8,65,3,7]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";var A,C,l,p,v,n,o,i,s,a,u,h,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class r extends P.$Sc{constructor(d,D,L,y){super(),A.set(this,void 0),C.set(this,void 0),l.set(this,void 0),p.set(this,void 0),v.set(this,void 0),n.set(this,void 0),o.set(this,void 0),i.set(this,void 0),s.set(this,!0),a.set(this,void 0),u.set(this,!1),h.set(this,this.B(new $.$Sd)),this.onDidDispose=ze(this,h,"f").event,t.set(this,this.B(new $.$Sd)),this.onDidChangeViewState=ze(this,t,"f").event,xe(this,A,d,"f"),xe(this,C,D,"f"),xe(this,p,L,"f"),xe(this,l,y.viewType,"f"),xe(this,v,y.panelOptions,"f"),xe(this,i,y.viewColumn,"f"),xe(this,n,y.title,"f"),xe(this,a,y.active,"f")}dispose(){ze(this,u,"f")||(xe(this,u,!0,"f"),ze(this,h,"f").fire(),ze(this,C,"f").$disposeWebview(ze(this,A,"f")),ze(this,p,"f").dispose(),super.dispose())}get webview(){return this.c(),ze(this,p,"f")}get viewType(){return this.c(),ze(this,l,"f")}get title(){return this.c(),ze(this,n,"f")}set title(d){this.c(),ze(this,n,"f")!==d&&(xe(this,n,d,"f"),ze(this,C,"f").$setTitle(ze(this,A,"f"),d))}get iconPath(){return this.c(),ze(this,o,"f")}set iconPath(d){this.c(),ze(this,o,"f")!==d&&(xe(this,o,d,"f"),ze(this,C,"f").$setIconPath(ze(this,A,"f"),I.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return ze(this,v,"f")}get viewColumn(){if(this.c(),!(typeof ze(this,i,"f")=="number"&&ze(this,i,"f")<0))return ze(this,i,"f")}get active(){return this.c(),ze(this,a,"f")}get visible(){return this.c(),ze(this,s,"f")}_updateViewState(d){ze(this,u,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(xe(this,a,d.active,"f"),xe(this,s,d.visible,"f"),xe(this,i,d.viewColumn,"f"),ze(this,t,"f").fire({webviewPanel:this}))}reveal(d,D){this.c(),ze(this,C,"f").$reveal(ze(this,A,"f"),{viewColumn:typeof d>"u"?void 0:M.ViewColumn.from(d),preserveFocus:!!D})}c(){if(ze(this,u,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,C=new WeakMap,l=new WeakMap,p=new WeakMap,v=new WeakMap,n=new WeakMap,o=new WeakMap,i=new WeakMap,s=new WeakMap,a=new WeakMap,u=new WeakMap,h=new WeakMap,t=new WeakMap;class c extends P.$Sc{static c(){return(0,T.$mg)()}constructor(d,D,L){super(),this.j=D,this.m=L,this.g=new Map,this.h=new Map,this.f=d.getProxy(g.$NK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,D,L,y,E={}){const k=typeof y=="object"?y.viewColumn:y,F={viewColumn:M.ViewColumn.from(k),preserveFocus:typeof y=="object"&&!!y.preserveFocus},B=(0,m.$Ifc)(d),ee=c.c();this.f.$createWebviewPanel((0,m.$Kfc)(d),ee,D,{title:L,panelOptions:f(E),webviewOptions:(0,m.$Lfc)(d,this.m,E),serializeBuffersForPostMessage:B},F);const J=this.j.createNewWebview(ee,E,d);return this.createNewWebviewPanel(ee,D,L,k,E,J,!0)}$onDidChangeWebviewPanelViewStates(d){const D=Object.keys(d);D.sort((L,y)=>{const E=d[L],k=d[y];return E.active?1:k.active?-1:+E.visible-+k.visible});for(const L of D){const y=this.getWebviewPanel(L);if(!y)continue;const E=d[L];y._updateViewState({active:E.active,visible:E.visible,viewColumn:M.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,D,L){if(this.h.has(D))throw new Error(`Serializer for '${D}' already registered`);return this.h.set(D,{serializer:L,extension:d}),this.f.$registerSerializer(D,{serializeBuffersForPostMessage:(0,m.$Ifc)(d)}),new b.$PK(()=>{this.h.delete(D),this.f.$unregisterSerializer(D)})}async $deserializeWebviewPanel(d,D,L,y){const E=this.h.get(D);if(!E)throw new Error(`No serializer found for '${D}'`);const{serializer:k,extension:F}=E,B=this.j.createNewWebview(d,L.webviewOptions,F),ee=this.createNewWebviewPanel(d,D,L.title,y,L.panelOptions,B,L.active);await k.deserializeWebviewPanel(ee,L.state)}createNewWebviewPanel(d,D,L,y,E,k,F){const B=new r(d,this.f,k,{viewType:D,title:L,viewColumn:y,panelOptions:E,active:F});return this.g.set(d,B),B}getWebviewPanel(d){return this.g.get(d)}}e.$Mfc=c;function f(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[274],Ae([1,0,5,6,65,8,3,7]),function(ie,e,$,P,I,T,M,m){"use strict";var g,b,A,C,l,p,v,n,o,i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class a extends P.$Sc{constructor(t,r,c,f,w,d){super(),g.set(this,void 0),b.set(this,void 0),A.set(this,void 0),C.set(this,void 0),l.set(this,!1),p.set(this,void 0),v.set(this,void 0),n.set(this,void 0),o.set(this,void 0),i.set(this,this.B(new $.$Sd)),this.onDidChangeVisibility=ze(this,i,"f").event,s.set(this,this.B(new $.$Sd)),this.onDidDispose=ze(this,s,"f").event,xe(this,A,c,"f"),xe(this,v,f,"f"),xe(this,g,t,"f"),xe(this,b,r,"f"),xe(this,C,w,"f"),xe(this,p,d,"f")}dispose(){ze(this,l,"f")||(xe(this,l,!0,"f"),ze(this,s,"f").fire(),ze(this,C,"f").dispose(),super.dispose())}get title(){return this.a(),ze(this,v,"f")}set title(t){this.a(),ze(this,v,"f")!==t&&(xe(this,v,t,"f"),ze(this,b,"f").$setWebviewViewTitle(ze(this,g,"f"),t))}get description(){return this.a(),ze(this,n,"f")}set description(t){this.a(),ze(this,n,"f")!==t&&(xe(this,n,t,"f"),ze(this,b,"f").$setWebviewViewDescription(ze(this,g,"f"),t))}get visible(){return ze(this,p,"f")}get webview(){return ze(this,C,"f")}get viewType(){return ze(this,A,"f")}_setVisible(t){t===ze(this,p,"f")||ze(this,l,"f")||(xe(this,p,t,"f"),ze(this,i,"f").fire())}get badge(){return this.a(),ze(this,o,"f")}set badge(t){this.a(),!(t?.value===ze(this,o,"f")?.value&&t?.tooltip===ze(this,o,"f")?.tooltip)&&(xe(this,o,T.ViewBadge.from(t),"f"),ze(this,b,"f").$setWebviewViewBadge(ze(this,g,"f"),t))}show(t){this.a(),ze(this,b,"f").$show(ze(this,g,"f"),!!t)}a(){if(ze(this,l,"f"))throw new Error("Webview is disposed")}}g=new WeakMap,b=new WeakMap,A=new WeakMap,C=new WeakMap,l=new WeakMap,p=new WeakMap,v=new WeakMap,n=new WeakMap,o=new WeakMap,i=new WeakMap,s=new WeakMap;class u{constructor(t,r){this.d=r,this.b=new Map,this.c=new Map,this.a=t.getProxy(M.$NK.MainThreadWebviewViews)}registerWebviewViewProvider(t,r,c,f){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:c,extension:t}),this.a.$registerWebviewViewProvider((0,I.$Kfc)(t),r,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Ifc)(t)}),new m.$PK(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(t,r,c,f,w){const d=this.b.get(r);if(!d)throw new Error(`No view provider found for '${r}'`);const{provider:D,extension:L}=d,y=this.d.createNewWebview(t,{},L),E=new a(t,this.a,r,c,y,!0);this.c.set(t,E),await D.resolveWebviewView(E,{state:f},w)}async $onDidChangeWebviewViewVisibility(t,r){this.e(t)._setVisible(r)}async $disposeWebviewView(t){const r=this.e(t);this.c.delete(t),r.dispose(),this.d.deleteWebview(t)}e(t){const r=this.c.get(t);if(!r)throw new Error("No webview found");return r}}e.$ehc=u}),define(Re[111],Ae([1,0,5,3,2,13,12,4,17,23]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=void 0;let C=A=class{getState(p){const v=this.d;return{get focused(){return v.focused},get active(){return(0,b.$lF)(p,"windowActivity"),v.active}}}constructor(p){this.c=new $.$Sd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(P.$NK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:n})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",n)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,v){v!==this.d[p]&&(this.d={...this.d,[p]:v},this.c.fire(this.d))}openUri(p,v){let n;if(typeof p=="string"){n=p;try{p=I.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,M.$Ge)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,n,v)}async asExternalUri(p,v){if((0,M.$Ge)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const n=await this.b.$asExternalUri(p,v);return I.URI.from(n)}};e.$fhc=C,C.a={focused:!0,active:!0},e.$fhc=C=A=Je([Ge(0,g.$RM)],C),e.$ghc=(0,m.$2h)("IExtHostWindow")}),define(Re[275],Ae([1,0,241,27,17]),function(ie,e,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0;let T=class extends $.$jhc{constructor(m,g){super(m,g)}f(m,g,b){g.apply(console,b)}};e.$rjc=T,e.$rjc=T=Je([Ge(0,I.$RM),Ge(1,P.$8M)],T)}),define(Re[276],Ae([1,0,14,24,20,11,5,6,128,230,49]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=e.ResponsiveState=e.RequestInitiator=e.$v7b=e.$u7b=void 0;function l(k,F){try{return JSON.stringify(k,F)}catch{return"null"}}const p="$$ref$$",v={[p]:-1};class n{constructor(F,B){this.jsonString=F,this.referencedBuffers=B}}function o(k,F=null,B=!1){const ee=[];return{jsonString:(B?l:JSON.stringify)(k,(V,R)=>{if(typeof R>"u")return v;if(typeof R=="object"){if(R instanceof P.$ge){const S=ee.push(R)-1;return{[p]:S}}if(F)return F(V,R)}return R}),referencedBuffers:ee}}e.$u7b=o;function i(k,F,B){return JSON.parse(k,(ee,J)=>{if(J){const V=J[p];if(typeof V=="number")return F[V];if(B&&J.$mid===1)return B.transformIncoming(J)}return J})}e.$v7b=i;function s(k,F){return JSON.stringify(k,F)}function a(k){return k?(F,B)=>B&&B.$mid===1?k.transformOutgoing(B):B:null}var u;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));var h;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},r=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class f extends m.$Sc{constructor(F,B=null,ee=null){super(),this[C]=!0,this.b=this.B(new M.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=F,this.f=B,this.g=ee,this.h=a(this.g),this.j=!1,this.m=[],this.s=[];for(let J=0,V=A.$Cv.count;J<V;J++)this.m[J]=null,this.s[J]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new $.$bh(()=>this.H(),1e3)),this.c.onMessage(J=>this.L(J))}dispose(){this.j=!0,Object.keys(this.w).forEach(F=>{const B=this.w[F];delete this.w[F],B.resolveErr(T.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(F){this.z===0&&(this.C=Date.now()+f.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(F){this.C=Date.now()+f.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(F){this.y!==F&&(this.y=F,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(F){return this.g?(0,g.$3m)(F,this.g):F}getProxy(F){const{nid:B,sid:ee}=F;return this.s[B]||(this.s[B]=this.J(B,ee)),this.s[B]}J(F,B){const ee={get:(J,V)=>(typeof V=="string"&&!J[V]&&V.charCodeAt(0)===36&&(J[V]=(...R)=>this.U(F,V,R)),V===c?B:J[V])};return new Proxy(Object.create(null),ee)}set(F,B){return this.m[F.nid]=B,B}assertRegistered(F){for(let B=0,ee=F.length;B<ee;B++){const J=F[B];if(!this.m[J.nid])throw new Error(`Missing proxy instance ${J.sid}`)}}L(F){if(this.j)return;const B=F.byteLength,ee=d.read(F,0),J=ee.readUInt8(),V=ee.readUInt32();switch(J){case 1:case 2:{let{rpcId:R,method:S,args:O}=L.deserializeRequestJSONArgs(ee);this.g&&(O=(0,g.$3m)(O,this.g)),this.M(B,V,R,S,O,J===2);break}case 3:case 4:{let{rpcId:R,method:S,args:O}=L.deserializeRequestMixedArgs(ee);this.g&&(O=(0,g.$3m)(O,this.g)),this.M(B,V,R,S,O,J===4);break}case 5:{this.f?.logIncoming(B,V,0,"ack"),this.G(V);break}case 6:{this.N(B,V);break}case 7:{this.O(B,V,void 0);break}case 9:{let R=L.deserializeReplyOKJSON(ee);this.g&&(R=(0,g.$3m)(R,this.g)),this.O(B,V,R);break}case 10:{const R=L.deserializeReplyOKJSONWithBuffers(ee,this.g);this.O(B,V,R);break}case 8:{const R=L.deserializeReplyOKVSBuffer(ee);this.O(B,V,R);break}case 11:{let R=L.deserializeReplyErrError(ee);this.g&&(R=(0,g.$3m)(R,this.g)),this.P(B,V,R);break}case 12:{this.P(B,V,void 0);break}default:console.error("received unexpected message"),console.error(F)}}M(F,B,ee,J,V,R){this.f?.logIncoming(F,B,1,`receiveRequest ${(0,A.$Ev)(ee)}.${J}(`,V);const S=String(B);let O,Q;if(R){const he=new I.$3d;V.push(he.token),O=this.Q(ee,J,V),Q=()=>he.cancel()}else O=this.Q(ee,J,V),Q=t;this.u[S]=Q;const re=L.serializeAcknowledged(B);this.f?.logOutgoing(re.byteLength,B,1,"ack"),this.c.send(re),O.then(he=>{delete this.u[S];const fe=L.serializeReplyOK(B,he,this.h);this.f?.logOutgoing(fe.byteLength,B,1,"reply:",he),this.c.send(fe)},he=>{delete this.u[S];const fe=L.serializeReplyErr(B,he);this.f?.logOutgoing(fe.byteLength,B,1,"replyErr:",he),this.c.send(fe)})}N(F,B){this.f?.logIncoming(F,B,1,"receiveCancel");const ee=String(B);this.u[ee]?.()}O(F,B,ee){this.f?.logIncoming(F,B,0,"receiveReply:",ee);const J=String(B);if(!this.w.hasOwnProperty(J))return;const V=this.w[J];delete this.w[J],V.resolveOk(ee)}P(F,B,ee){this.f?.logIncoming(F,B,0,"receiveReplyErr:",ee);const J=String(B);if(!this.w.hasOwnProperty(J))return;const V=this.w[J];delete this.w[J];let R;ee&&(ee.$isError?(R=new Error,R.name=ee.name,R.message=ee.message,R.stack=ee.stack):R=ee),V.resolveErr(R)}Q(F,B,ee){try{return Promise.resolve(this.S(F,B,ee))}catch(J){return Promise.reject(J)}}S(F,B,ee){const J=this.m[F];if(!J)throw new Error("Unknown actor "+(0,A.$Ev)(F));const V=J[B];if(typeof V!="function")throw new Error("Unknown method "+B+" on actor "+(0,A.$Ev)(F));return V.apply(J,ee)}U(F,B,ee){if(this.j)return new b.$t7b;let J=null;if(ee.length>0&&I.CancellationToken.isCancellationToken(ee[ee.length-1])&&(J=ee.pop()),J&&J.isCancellationRequested)return Promise.reject(T.$6());const V=L.serializeRequestArguments(ee,this.h),R=++this.t,S=String(R),O=new b.$s7b,Q=new m.$Rc;J&&Q.add(J.onCancellationRequested(()=>{const he=L.serializeCancel(R);this.f?.logOutgoing(he.byteLength,R,0,"cancel"),this.c.send(L.serializeCancel(R))})),this.w[S]=new w(O,Q),this.F(R);const re=L.serializeRequest(R,F,B,V,!!J);return this.f?.logOutgoing(re.byteLength,R,0,`request: ${(0,A.$Ev)(F)}.${B}(`,ee),this.c.send(re),O}}e.$w7b=f,C=r,f.a=3*1e3;class w{constructor(F,B){this.a=F,this.b=B}resolveOk(F){this.a.resolveOk(F),this.b.dispose()}resolveErr(F){this.a.resolveErr(F),this.b.dispose()}}class d{static alloc(F,B,ee){const J=new d(P.$ge.alloc(ee+1+4),0);return J.writeUInt8(F),J.writeUInt32(B),J}static read(F,B){return new d(F,B)}get buffer(){return this.a}constructor(F,B){this.a=F,this.b=B}static sizeUInt8(){return 1}writeUInt8(F){this.a.writeUInt8(F,this.b),this.b+=1}readUInt8(){const F=this.a.readUInt8(this.b);return this.b+=1,F}writeUInt32(F){this.a.writeUInt32BE(F,this.b),this.b+=4}readUInt32(){const F=this.a.readUInt32BE(this.b);return this.b+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this.a.writeUInt8(F.byteLength,this.b),this.b+=1,this.a.set(F,this.b),this.b+=F.byteLength}readShortString(){const F=this.a.readUInt8(this.b);this.b+=1;const ee=this.a.slice(this.b,this.b+F).toString();return this.b+=F,ee}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readLongString(){const F=this.a.readUInt32BE(this.b);this.b+=4;const ee=this.a.slice(this.b,this.b+F).toString();return this.b+=F,ee}writeBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readVSBuffer(){const F=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+F);return this.b+=F,B}static sizeMixedArray(F){let B=0;B+=1;for(let ee=0,J=F.length;ee<J;ee++){const V=F[ee];switch(B+=1,V.type){case 1:B+=this.sizeLongString(V.value);break;case 2:B+=this.sizeVSBuffer(V.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(V.value);for(let R=0;R<V.buffers.length;++R)B+=this.sizeVSBuffer(V.buffers[R]);break;case 4:break}}return B}writeMixedArray(F){this.a.writeUInt8(F.length,this.b),this.b+=1;for(let B=0,ee=F.length;B<ee;B++){const J=F[B];switch(J.type){case 1:this.writeUInt8(1),this.writeLongString(J.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(J.value);break;case 3:this.writeUInt8(3),this.writeUInt32(J.buffers.length),this.writeLongString(J.value);for(let V=0;V<J.buffers.length;++V)this.writeBuffer(J.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this.a.readUInt8(this.b);this.b+=1;const B=new Array(F);for(let ee=0;ee<F;ee++)switch(this.readUInt8()){case 1:B[ee]=this.readLongString();break;case 2:B[ee]=this.readVSBuffer();break;case 3:{const V=this.readUInt32(),R=this.readLongString(),S=[];for(let O=0;O<V;++O)S.push(this.readVSBuffer());B[ee]=new A.$Fv(i(R,S,null));break}case 4:B[ee]=void 0;break}return B}}d.sizeUInt32=4;var D;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(D||(D={}));class L{static a(F){for(let B=0,ee=F.length;B<ee;B++)if(F[B]instanceof P.$ge||F[B]instanceof A.$Fv||typeof F[B]>"u")return!0;return!1}static serializeRequestArguments(F,B){if(this.a(F)){const ee=[];for(let J=0,V=F.length;J<V;J++){const R=F[J];if(R instanceof P.$ge)ee[J]={type:2,value:R};else if(typeof R>"u")ee[J]={type:4};else if(R instanceof A.$Fv){const{jsonString:S,referencedBuffers:O}=o(R.value,B);ee[J]={type:3,value:P.$ge.fromString(S),buffers:O}}else ee[J]={type:1,value:P.$ge.fromString(s(R,B))}}return{type:1,args:ee}}return{type:0,args:s(F,B)}}static serializeRequest(F,B,ee,J,V){switch(J.type){case 0:return this.b(F,B,ee,J.args,V);case 1:return this.c(F,B,ee,J.args,V)}}static b(F,B,ee,J,V){const R=P.$ge.fromString(ee),S=P.$ge.fromString(J);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(R),O+=d.sizeLongString(S);const Q=d.alloc(V?2:1,F,O);return Q.writeUInt8(B),Q.writeShortString(R),Q.writeLongString(S),Q.buffer}static deserializeRequestJSONArgs(F){const B=F.readUInt8(),ee=F.readShortString(),J=F.readLongString();return{rpcId:B,method:ee,args:JSON.parse(J)}}static c(F,B,ee,J,V){const R=P.$ge.fromString(ee);let S=0;S+=d.sizeUInt8(),S+=d.sizeShortString(R),S+=d.sizeMixedArray(J);const O=d.alloc(V?4:3,F,S);return O.writeUInt8(B),O.writeShortString(R),O.writeMixedArray(J),O.buffer}static deserializeRequestMixedArgs(F){const B=F.readUInt8(),ee=F.readShortString(),J=F.readMixedArray(),V=new Array(J.length);for(let R=0,S=J.length;R<S;R++){const O=J[R];typeof O=="string"?V[R]=JSON.parse(O):V[R]=O}return{rpcId:B,method:ee,args:V}}static serializeAcknowledged(F){return d.alloc(5,F,0).buffer}static serializeCancel(F){return d.alloc(6,F,0).buffer}static serializeReplyOK(F,B,ee){if(typeof B>"u")return this.d(F);if(B instanceof P.$ge)return this.e(F,B);if(B instanceof A.$Fv){const{jsonString:J,referencedBuffers:V}=o(B.value,ee,!0);return this.g(F,J,V)}else return this.f(F,l(B,ee))}static d(F){return d.alloc(7,F,0).buffer}static e(F,B){let ee=0;ee+=d.sizeVSBuffer(B);const J=d.alloc(8,F,ee);return J.writeVSBuffer(B),J.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static f(F,B){const ee=P.$ge.fromString(B);let J=0;J+=d.sizeLongString(ee);const V=d.alloc(9,F,J);return V.writeLongString(ee),V.buffer}static g(F,B,ee){const J=P.$ge.fromString(B);let V=0;V+=d.sizeUInt32,V+=d.sizeLongString(J);for(const S of ee)V+=d.sizeVSBuffer(S);const R=d.alloc(10,F,V);R.writeUInt32(ee.length),R.writeLongString(J);for(const S of ee)R.writeBuffer(S);return R.buffer}static deserializeReplyOKJSON(F){const B=F.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(F,B){const ee=F.readUInt32(),J=F.readLongString(),V=[];for(let R=0;R<ee;++R)V.push(F.readVSBuffer());return new A.$Fv(i(J,V,B))}static serializeReplyErr(F,B){const ee=B?l(T.$3(B),null):void 0;if(typeof ee!="string")return this.h(F);const J=P.$ge.fromString(ee);let V=0;V+=d.sizeLongString(J);const R=d.alloc(11,F,V);return R.writeLongString(J),R.buffer}static deserializeReplyErrError(F){const B=F.readLongString();return JSON.parse(B)}static h(F){return d.alloc(12,F,0).buffer}}var y;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(y||(y={}));var E;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(E||(E={}))}),define(Re[277],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;const $=function(T){const M=m=>{globalThis.removeEventListener("message",M);const g=m.data;Object.defineProperties(globalThis,{postMessage:{value(b,A){g.postMessage(b,A)}},onmessage:{get(){return g.onmessage},set(b){g.onmessage=b}}}),g.addEventListener("message",b=>{globalThis.dispatchEvent(new MessageEvent("message",{data:b.data,ports:b.ports?[...b.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",M)}.toString();class P extends EventTarget{constructor(T,M,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${$})('${M}'))`,b=new Blob([g],{type:"application/javascript"}),A=URL.createObjectURL(b),C=new MessageChannel,l=A,p={type:"_newWorker",id:l,port:C.port2,url:A,options:m};T(p,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{T({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(v){C.port1.onmessage=v}},onmessageerror:{get(){return C.port1.onmessageerror},set(v){C.port1.onmessageerror=v}}}),C.port1.addEventListener("messageerror",v=>{const n=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(n)}),C.port1.addEventListener("message",v=>{const n=new MessageEvent("message",{data:v.data});this.dispatchEvent(n)}),C.port1.start()}}e.$tjc=P}),define(Re[278],Ae([1,0,5,30,35,4]),function(ie,e,$,P,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.OutputChannelUpdateMode=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=void 0,e.$YJ="text/x-code-output",e.$ZJ="output",e.$1J="Log",e.$2J="text/x-code-log-output",e.$3J="log",e.$4J="workbench.panel.output",e.$5J=new I.$gj("inOutput",!1),e.$6J=new I.$gj("activeLogOutput",!1),e.$7J=new I.$gj("outputView.scrollLock",!1),e.$8J=(0,T.$2h)("outputService");var M;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$9J={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new $.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new $.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(A=>b.push(A)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}P.$un.add(e.$9J.OutputChannels,new m),e.$0J=new I.$gj("activeOutputChannel","")}),define(Re[112],Ae([1,0,3,4,17,22,15,278,63,27,43,143,24,16,42,5,6]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=void 0;class i extends M.$pj{get disposed(){return this.n}constructor(h,t,r,c,f){super(),this.id=h,this.name=t,this.r=r,this.s=c,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=l.$ge.fromString(t).byteLength,(0,M.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class s extends i{appendLine(h){this.append(h)}}let a=class{constructor(h,t,r,c,f,w){this.i=t,this.j=r,this.k=c,this.l=f,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy($.$NK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$sm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(h,t,r){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,f=(0,p.$Ef)(t)?t:void 0;if((0,p.$Ef)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const d=this.i.environment.extensionLogLevel?.find(([L])=>T.$hm.equals(r.identifier,L))?.[1];d&&(w=(0,M.$zj)(d));const D=c?this.o(h,w,r):this.n(h,f,r);return D.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),c?this.r(h,w??this.m.getLevel(),D):this.q(h,D)}async n(h,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,f=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(h,f,t,r.identifier.value);return new i(d,h,w,this.a,r)}async o(h,t,r){const c=await this.p(r),f=h.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(c,`${f}.log`),d=`${r.identifier.value}.${f}`,D=this.l.createLogger(w,{id:d,name:h,logLevel:t,extensionId:r.identifier.value});return new s(d,h,D,this.a,r)}p(h){let t=this.d.get(h.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(c){if((0,v.$Bk)(c)!==v.FileSystemProviderErrorCode.FileExists)throw c}return r})())}return t}q(h,t){let r=!1;const c=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return h},append(f){c(),t.then(w=>w.append(f))},appendLine(f){c(),t.then(w=>w.appendLine(f))},clear(){c(),t.then(f=>f.clear())},replace(f){c(),t.then(w=>w.replace(f))},show(f,w){c(),t.then(d=>d.show(f,w))},hide(){c(),t.then(f=>f.hide())},dispose(){r=!0,t.then(f=>f.dispose())}}}r(h,t,r){const c=new o.$Rc,f=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},w=c.add(new n.$Sd);function d(D){t=D,w.fire(D)}return r.then(D=>{c.add(D),D.logLevel!==t&&d(D.logLevel),c.add(D.onDidChangeLogLevel(L=>d(L)))}),{...this.q(h,r),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(D,...L){f(),r.then(y=>y.trace(D,...L))},debug(D,...L){f(),r.then(y=>y.debug(D,...L))},info(D,...L){f(),r.then(y=>y.info(D,...L))},warn(D,...L){f(),r.then(y=>y.warn(D,...L))},error(D,...L){f(),r.then(y=>y.error(D,...L))},dispose(){c.dispose()}}}};e.$Rgc=a,e.$Rgc=a=Je([Ge(0,I.$RM),Ge(1,b.$8M),Ge(2,g.$Efc),Ge(3,A.$efc),Ge(4,M.$kj),Ge(5,M.$jj)],a),e.$Sgc=(0,P.$2h)("IExtHostOutputService")}),define(Re[113],Ae([1,0,4,14]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=(0,$.$2h)("remoteAgentService"),e.$Im=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let T=1/0;for(let m=0;m<this.maxSampleCount;m++){const g=await I.getRoundTripTime();if(g===void 0)return;T=Math.min(T,g/2),await(0,P.$3g)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(T):M=this.initial.reduce((m,g)=>m+g,0)/this.initial.length,this.lastMeasurement={initial:M,current:T,average:this.average.reduce((m,g)=>m+g,0)/this.average.length,high:(()=>typeof M>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>M*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Re[279],Ae([1,0,170,54,30,47,41,6,5,113,21,26]),function(ie,e,$,P,I,T,M,m,g,b,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=void 0,e.$AH=Object.freeze({id:"application",order:100,title:(0,$.localize)(0,null),type:"object"}),e.$BH=Object.freeze({id:"workbench",order:7,title:(0,$.localize)(1,null),type:"object"}),e.$CH=Object.freeze({id:"security",scope:1,title:(0,$.localize)(2,null),type:"object",order:7}),e.$DH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const p=new l;I.$un.add(e.$DH.ConfigurationMigration,p);let v=class extends m.$Sc{constructor(i,s){super(),this.a=i,this.b=s,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const u of a.added)await this.f(u,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(i){await this.f(void 0,i);for(const s of this.b.getWorkspace().folders)await this.f(s,i)}async f(i,s){await Promise.all([s.map(a=>this.g(a,i?.uri))])}async g(i,s){const a=this.a.inspect(i.key,{resource:s}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,t]of u){const r=[];for(const f of a.overrideIdentifiers??[]){const w=await this.h(i,{resource:s,overrideIdentifier:f},h);for(const d of w??[]){let D=r.find(([[L,y]])=>L===d[0]&&(0,C.$mn)(y.value,d[1].value));D||r.push(D=[d,[]]),D[1].push(f)}}const c=await this.h(i,{resource:s},h,a);for(const f of c??[])r.push([f,[]]);r.length&&await Promise.allSettled(r.map(async([[f,w],d])=>this.a.updateValue(f,w.value,{resource:s,overrideIdentifiers:d},t)))}}async h(i,s,a,u){const h=f=>t(this.a.inspect(f,s)),t=f=>{const w=f[a];return s.overrideIdentifier?w?.override:w?.value},r=u?t(u):h(i.key);if(r===void 0)return;const c=await i.migrateFn(r,h);return Array.isArray(c)?c:[[i.key,c]]}};e.$EH=v,e.$EH=v=Je([Ge(0,M.$vi),Ge(1,T.$$h)],v);let n=class extends m.$Sc{constructor(i){super(),(async()=>{if(!A.$c&&(await i.getEnvironment())?.os!==1)return;I.$un.as(P.$zn.Configuration).registerConfiguration({...e.$CH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,$.localize)(3,null)},default:[],markdownDescription:(0,$.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,$.localize)(5,null),scope:2}}})})()}};e.$FH=n,e.$FH=n=Je([Ge(0,b.$Hm)],n)}),define(Re[280],Ae([1,0,33,13,19,25,178,279,54,4,30]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cb=e.$0cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$9cb=e.$8cb=void 0,e.$8cb=(0,b.$2h)("editorResolverService"),e.$9cb="workbench.editorAssociations";const C=A.$un.as(g.$zn.Configuration),l={...m.$BH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(l);var p;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(p||(e.RegisteredEditorPriority=p={}));var v;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function n(i){switch(i){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$0cb=n;function o(i,s){if(new Set([P.Schemas.extension,P.Schemas.webviewPanel,P.Schemas.vscodeWorkspaceTrust,P.Schemas.vscodeSettings]).has(s.scheme))return!1;const h=typeof i=="string"&&i.indexOf(I.$gc.sep)>=0?`${s.scheme}:${s.path}`:(0,T.$Ag)(s);return $.$Hj(typeof i=="string"?i.toLowerCase():i,h.toLowerCase())}e.$$cb=o}),define(Re[281],Ae([1,0,45,13,19,21,25,2,4,199,47,217,113]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.$pK=void 0,e.$pK=(0,g.$2h)("pathService");let v=p=class{constructor(o,i,s,a){this.d=o,this.e=i,this.f=s,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const u=await this.e.getEnvironment();return this.c=u?.userHome??o})()}hasValidBasename(o,i,s){return typeof i=="string"||typeof i>"u"?this.a.then(a=>this.h(o,a,i)):this.h(o,i,s)}h(o,i,s){return o.scheme===P.Schemas.file||o.scheme===P.Schemas.vscodeRemote?(0,$.$2f)(s??(0,M.$Ag)(o),i===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,i){if(o.remoteAuthority)return P.Schemas.vscodeRemote;const s=(0,b.$mK)(i.getWorkspace());if(s)return s;const a=i.getWorkspace().folders[0];if(a)return a.uri.scheme;const u=i.getWorkspace().configuration;return u?u.scheme:P.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?I.$fc:I.$gc)}async fileURI(o){let i="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(i=o.substring(2),o="/"):(i=o.substring(2,a),o=o.substring(a)||"/")}return m.URI.from({scheme:P.Schemas.file,authority:i,path:o,query:"",fragment:""})}};e.$qK=v,e.$qK=v=p=Je([Ge(1,l.$Hm),Ge(2,C.$$J),Ge(3,A.$$h)],v)}),define(Re[114],Ae([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$5I=e.$4I=void 0;class ${constructor(M,m){this.line=M,this.character=m}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,m){return new $(0,0)}with(M){return new $(0,0)}}e.$4I=$;class P{constructor(M,m,g,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new $(M,m),this.end=new $(g,b)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new P(0,0,0,0)}with(M){return new P(0,0,0,0)}}e.$5I=P;var I;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Re[44],Ae([1,0,18,33,26,45,12,4,19,11,114,14]),function(ie,e,$,P,I,T,M,m,g,b,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.SearchErrorCode=e.$hJ=e.$gJ=e.SearchSortOrder=e.ViewMode=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.SearchCompletionExitCode=e.$bJ=e.$aJ=e.$_I=e.QueryType=e.SearchProviderType=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$6I="workbench.view.search",e.$7I="workbench.panel.search",e.$8I="workbench.view.search",e.$9I="search-result",e.$0I="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",v=(l.length+p.length+5)*2;e.$$I=(0,m.$2h)("searchService");var n;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(n||(e.SearchProviderType=n={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(o||(e.QueryType=o={}));function i(ue){return!!ue.preview}e.$_I=i;function s(ue){return!!ue.resource}e.$aJ=s;function a(ue){return!!ue.message}e.$bJ=a;var u;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(u||(e.SearchCompletionExitCode=u={}));class h{constructor($e){this.resource=$e,this.results=[]}}e.$cJ=h;class t{constructor($e,ne,Pe,le){this.ranges=ne,this.webviewIndex=le;const me=Array.isArray(ne)?ne:[ne];if(Pe&&Pe.matchLines===1&&r(me)){$e=(0,M.$xf)($e,Pe.matchLines);let W="",ae=0,de=0;const ke=Math.floor(Pe.charsPerLine/5),Ee=[];for(const ce of me){const _=Math.max(ce.startColumn-ke,0),H=ce.startColumn+Pe.charsPerLine;if(_>de+ke+v){const te=l+(_-de)+p;W+=te+$e.slice(_,H),ae+=_-(de+te.length)}else W+=$e.slice(de,H);Ee.push(new f(0,ce.startColumn-ae,ce.endColumn-ae)),de=H}this.preview={text:W,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const W=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:$e,matches:(0,$.$2b)(ne,ae=>new c(ae.startLineNumber-W,ae.startColumn,ae.endLineNumber-W,ae.endColumn))}}}}e.$dJ=t;function r(ue){const $e=ue[0].startLineNumber;for(const ne of ue)if(ne.startLineNumber!==$e||ne.endLineNumber!==$e)return!1;return!0}class c{constructor($e,ne,Pe,le){this.startLineNumber=$e,this.startColumn=ne,this.endLineNumber=Pe,this.endColumn=le}}e.$eJ=c;class f extends c{constructor($e,ne,Pe){super($e,ne,$e,Pe)}}e.$fJ=f;var w;(function(ue){ue.List="list",ue.Tree="tree"})(w||(e.ViewMode=w={}));var d;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function D(ue,$e=!0){const ne=ue&&ue.files&&ue.files.exclude,Pe=$e&&ue&&ue.search&&ue.search.exclude;if(!ne&&!Pe)return;if(!ne||!Pe)return ne||Pe;let le=Object.create(null);return le=I.$ln(le,I.$in(ne)),le=I.$ln(le,I.$in(Pe),!0),le}e.$gJ=D;function L(ue,$e){return ue.excludePattern&&P.$Hj(ue.excludePattern,$e)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&P.$Hj(ue.includePattern,$e)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(ne=>{const Pe=ne.folder.fsPath;if(T.$4f($e,Pe)){const le=g.$lc(Pe,$e);return!ne.includePattern||!!P.$Hj(ne.includePattern,le)}else return!1}):!1:!0}e.$hJ=L;var y;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(y||(e.SearchErrorCode=y={}));class E extends Error{constructor($e,ne){super($e),this.code=ne}}e.$iJ=E;function k(ue){const $e=ue.message;if((0,b.$4)(ue))return new E($e,y.canceled);try{const ne=JSON.parse($e);return new E(ne.message,ne.code)}catch{return new E($e,y.other)}}e.$jJ=k;function F(ue){const $e={message:ue.message,code:ue.code};return new Error(JSON.stringify($e))}e.$kJ=F;function B(ue){return ue.type==="error"?!0:ue.type==="success"}e.$lJ=B;function ee(ue){return ue.type==="success"}e.$mJ=ee;function J(ue){return!!ue.path}e.$nJ=J;function V(ue,$e){const ne=ue.searchPath?ue.searchPath:ue.relativePath;return(0,M.$uf)(ne,$e)}e.$oJ=V;class R{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$pJ=R;function S(ue,$e){const ne={...ue||{},...$e||{}};return Object.keys(ne).filter(Pe=>{const le=ne[Pe];return typeof le=="boolean"&&le})}e.$qJ=S;class O{constructor($e,ne){this.c=null,this.a={...$e.excludePattern||{},...ne.excludePattern||{}},this.b=P.$Ij(this.a);let Pe=$e.includePattern;ne.includePattern&&(Pe?Pe={...Pe,...ne.includePattern}:Pe=ne.includePattern),Pe&&(this.c=P.$Ij(Pe))}matchesExcludesSync($e,ne,Pe){return!!(this.b&&this.b($e,ne,Pe))}includedInQuerySync($e,ne,Pe){return!(this.b&&this.b($e,ne,Pe)||this.c&&!this.c($e,ne,Pe))}includedInQuery($e,ne,Pe){const le=this.b($e,ne,Pe),me=()=>this.c?!!this.c($e,ne,Pe):!0;return(0,C.$Og)(le)?le.then(W=>W?!1:me()):me()}hasSiblingExcludeClauses(){return Q(this.a)}}e.$rJ=O;function Q(ue){for(const $e in ue)if(typeof ue[$e]!="boolean")return!0;return!1}function re(ue){if(!ue)return;let $e;return ne=>($e||($e=(ue()||Promise.resolve([])).then(Pe=>Pe?fe(Pe):{})),$e.then(Pe=>!!Pe[ne]))}e.$sJ=re;function he(ue){if(!ue)return;let $e;return ne=>{if(!$e){const Pe=ue();$e=Pe?fe(Pe):{}}return!!$e[ne]}}e.$tJ=he;function fe(ue){const $e={};for(const ne of ue)$e[ne]=!0;return $e}}),define(Re[36],Ae([1,0,18,14,20,5,6,50,13,122,25,12,2,169,4,15,188,47,43,27,17,8,7,57,44,3,51]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u,h,t,r,c,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=e.$yfc=void 0;function d(ee,J,V){return new A.$sg(R=>E(R,V)).isEqual(ee,J)}function D(ee,J,V){return d(ee.uri,J.uri,V)?0:(0,C.$1e)(ee.uri.toString(),J.uri.toString())}function L(ee,J,V){return ee.index!==J.index?ee.index<J.index?-1:1:d(ee.uri,J.uri,V)?(0,C.$1e)(ee.name,J.name):(0,C.$1e)(ee.uri.toString(),J.uri.toString())}function y(ee,J,V,R){const S=ee.slice(0).sort((Q,re)=>V(Q,re,R)),O=J.slice(0).sort((Q,re)=>V(Q,re,R));return(0,$.$Eb)(S,O,(Q,re)=>V(Q,re,R))}function E(ee,J){const V=J.getCapabilities(ee.scheme);return!(V&&V&1024)}class k extends i.$ii{static toExtHostWorkspace(J,V,R,S){if(!J)return{workspace:null,added:[],removed:[]};const{id:O,name:Q,folders:re,configuration:he,transient:fe,isUntitled:ue}=J,$e=[],ne=V;V?re.forEach((W,ae)=>{const de=l.URI.revive(W.uri),ke=k.o(R||V,de,S);ke?(ke.name=W.name,ke.index=W.index,$e.push(ke)):$e.push({uri:de,name:W.name,index:ae})}):$e.push(...re.map(({uri:W,name:ae,index:de})=>({uri:l.URI.revive(W),name:ae,index:de}))),$e.sort((W,ae)=>W.index<ae.index?-1:1);const Pe=new k(O,Q,$e,!!fe,he?l.URI.revive(he):null,!!ue,W=>E(W,S)),{added:le,removed:me}=y(ne?ne.workspaceFolders:[],Pe.workspaceFolders,D,S);return{workspace:Pe,added:le,removed:me}}static o(J,V,R){for(let S=0;S<J.folders.length;S++){const O=J.workspaceFolders[S];if(d(O.uri,V,R))return O}}constructor(J,V,R,S,O,Q,re){super(J,R.map(he=>new i.$ji(he)),S,O,re),this.t=V,this.u=Q,this.q=[],this.s=m.$8h.forUris(re),R.forEach(he=>{this.q.push(he),this.s.set(he.uri,he)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(J,V){return V&&this.s.get(J)&&(J=(0,A.$Cg)(J)),this.s.findSubstr(J)}resolveWorkspaceFolder(J){return this.s.get(J)}}let F=class{constructor(J,V,R,S,O){this.c=new T.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new T.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new T.$Ud,this.B=new Map,this.h=S,this.s=R,this.t=O,this.j=new b.$5l,this.k=new P.$1g,this.o=J.getProxy(f.$NK.MainThreadWorkspace),this.q=J.getProxy(f.$NK.MainThreadMessageService);const Q=V.workspace;this.l=Q?new k(Q.id,Q.name,[],!!Q.transient,Q.configuration?l.URI.revive(Q.configuration):null,!!Q.isUntitled,re=>E(re,R)):void 0}$initializeWorkspace(J,V){this.v=V,this.$acceptWorkspaceData(J),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,A.$Ag)((0,A.$Cg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(J,V,R,...S){const O=[];if(Array.isArray(S)&&S.forEach(ue=>{l.URI.isUri(ue.uri)&&!O.some($e=>d($e.uri,ue.uri,this.s))&&O.push({uri:ue.uri,name:ue.name||(0,A.$zg)(ue.uri)})}),this.n||[V,R].some(ue=>typeof ue!="number"||ue<0)||R===0&&O.length===0)return!1;const Q=this.x?this.x.workspaceFolders:[];if(V+R>Q.length)return!1;const re=Q.slice(0);re.splice(V,R,...O.map(ue=>({uri:ue.uri,name:ue.name||(0,A.$zg)(ue.uri),index:void 0})));for(let ue=0;ue<re.length;ue++){const $e=re[ue];if(re.some((ne,Pe)=>Pe!==ue&&d($e.uri,ne.uri,this.s)))return!1}re.forEach((ue,$e)=>ue.index=$e);const{added:he,removed:fe}=y(Q,re,L,this.s);if(he.length===0&&fe.length===0)return!1;if(this.o){const ue=J.displayName||J.name;this.o.$updateWorkspaceFolders(ue,V,R,O).then(void 0,$e=>{this.n=void 0;const ne={source:{identifier:J.identifier,label:J.displayName||J.name}};this.q.$showMessage(o.Severity.Error,(0,p.localize)(0,null,ue,$e.toString()),ne,[])})}return this.y(re),!0}getWorkspaceFolder(J,V){if(this.x)return this.x.getWorkspaceFolder(J,V)}async getWorkspaceFolder2(J,V){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(J,V)}async resolveWorkspaceFolder(J){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(J)}getPath(){if(!this.x)return;const{folders:J}=this.x;if(J.length!==0)return J[0].uri.fsPath}getRelativePath(J,V){let R,S="";if(typeof J=="string"?(R=l.URI.file(J),S=J):typeof J<"u"&&(R=J,S=J.fsPath),!R)return S;const O=this.getWorkspaceFolder(R,!0);if(!O)return S;typeof V>"u"&&this.x&&(V=this.x.folders.length>1);let Q=(0,A.$Fg)(O.uri,R);return V&&O.name&&(Q=`${O.name}/${Q}`),Q}y(J){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:J,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(J){const{workspace:V,added:R,removed:S}=k.toExtHostWorkspace(J,this.l,this.n,this.s);this.l=V||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:S}))}findFiles(J,V,R,S,O=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${S.value}, entryPoint: findFiles`);let Q;if(V===null?Q=!1:V&&(typeof V=="string"?Q=V:Q=V.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:re,folder:he}=B(h.GlobPattern.from(J));return this.o.$startFileSearch(re??null,he??null,Q??null,R??null,O).then(fe=>Array.isArray(fe)?fe.map(ue=>l.URI.revive(ue)):[])}async findTextInFiles(J,V,R,S,O=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${S.value}, entryPoint: findTextInFiles`);const Q=this.j.getNext(),re=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:he,folder:fe}=B(h.GlobPattern.from(V.include)),ue=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,$e={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:re,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:he,excludePattern:ue},ne=!1;if(this.u[Q]=Pe=>{if(ne)return;const le=l.URI.revive(Pe.resource);Pe.results.forEach(me=>{const W=(0,w.$yh)(me);(0,c.$_I)(W)?R({uri:le,preview:{text:W.preview.text,matches:(0,$.$2b)(W.preview.matches,ae=>new t.$RK(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))},ranges:(0,$.$2b)(W.ranges,ae=>new t.$RK(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))}):R({uri:le,text:W.text,lineNumber:W.lineNumber})})},O.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(J,fe??null,$e,Q,O);return delete this.u[Q],Pe||{}}catch(Pe){throw delete this.u[Q],Pe}}$handleTextSearchResult(J,V){this.u[V]?.(J)}async save(J){const V=await this.o.$save(J,{saveAs:!1});return l.URI.revive(V)}async saveAs(J){const V=await this.o.$save(J,{saveAs:!0});return l.URI.revive(V)}saveAll(J){return this.o.$saveAll(J)}resolveProxy(J){return this.o.$resolveProxy(J)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(J){return this.o.$requestWorkspaceTrust(J)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(J,V){if(this.w.has(J))throw new Error(`A provider has already been registered for scheme ${J}`);this.w.set(J,V);const R=this.t.transformOutgoingScheme(J),S=this.z++;return this.o.$registerEditSessionIdentityProvider(S,R),(0,M.$Qc)(()=>{this.w.delete(J),this.o.$unregisterEditSessionIdentityProvider(S)})}async $getEditSessionIdentifier(J,V){this.h.info("Getting edit session identifier for workspaceFolder",J);const R=await this.resolveWorkspaceFolder(l.URI.revive(J));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const S=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!S),!S)return;const O=await S.provideEditSessionIdentity(R,V);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(J,V,R,S){this.h.info("Getting edit session identifier for workspaceFolder",J);const O=await this.resolveWorkspaceFolder(l.URI.revive(J));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const Q=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!Q),!Q)return;const re=await Q.provideEditSessionIdentityMatch?.(V,R,S);if(this.h.info("Provider returned edit session identifier match result: ",re),!!re)return re}getOnWillCreateEditSessionIdentityEvent(J){return(V,R,S)=>{const O=function(re){V.call(R,re)};return O.extension=J,this.A.event(O,void 0,S)}}async $onWillCreateEditSessionIdentity(J,V,R){const S=await this.resolveWorkspaceFolder(l.URI.revive(J));if(S===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:S},V,async(O,Q)=>{const re=Date.now();await Promise.resolve(O),Date.now()-re>R&&this.h.warn("SLOW edit session create-participant",Q.extension.identifier)}),V.isCancellationRequested}registerCanonicalUriProvider(J,V){if(this.B.has(J))throw new Error(`A provider has already been registered for scheme ${J}`);this.B.set(J,V);const R=this.t.transformOutgoingScheme(J),S=this.z++;return this.o.$registerCanonicalUriProvider(S,R),(0,M.$Qc)(()=>{this.B.delete(J),this.o.$unregisterCanonicalUriProvider(S)})}async provideCanonicalUri(J,V,R){const S=this.B.get(J.scheme);if(!S)return;const O=await S.provideCanonicalUri?.(l.URI.revive(J),V,R);if(O)return O}async $provideCanonicalUri(J,V,R){return this.provideCanonicalUri(l.URI.revive(J),{targetScheme:V},R)}};e.$yfc=F,e.$yfc=F=Je([Ge(0,u.$RM),Ge(1,a.$8M),Ge(2,s.$efc),Ge(3,n.$jj),Ge(4,r.$wfc)],F),e.$zfc=(0,v.$2h)("IExtHostWorkspace");function B(ee){let J,V;return ee&&(typeof ee=="string"?J=ee:(J=ee.pattern,V=l.URI.revive(ee.baseUri))),{includePattern:J,folder:V}}}),define(Re[37],Ae([1,0,26,5,36,3,7,190,54,16,14,4,17,15,2]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=e.$Afc=void 0;function n(r,c){if(c){const f=c.split(".");let w=r;for(let d=0;w&&d<f.length;d++)w=w[f[d]];return w}}function o(r){return r instanceof v.URI}function i(r){return r&&r.uri instanceof v.URI&&r.languageId&&typeof r.languageId=="string"}function s(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&r.uri instanceof v.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function u(r){if(o(r))return{resource:r};if(i(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(s(r))return{overrideIdentifier:r.languageId};if(a(r))return{resource:r.uri};if(r===null)return{resource:null}}let h=class{constructor(c,f,w){this.a=c.getProxy(T.$NK.MainThreadConfiguration),this.c=f,this.b=w,this.d=new A.$1g,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,f){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(c,f))}};e.$Afc=h,e.$Afc=h=Je([Ge(0,l.$RM),Ge(1,I.$zfc),Ge(2,p.$jj)],h);class t{constructor(c,f,w,d){this.a=new P.$Sd,this.b=c,this.f=d,this.c=f,this.e=m.$Sn.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,f){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$Sn.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(f,w))}getConfiguration(c,f,w){const d=u(f)||{},D=this.g(c?n(this.e.getValue(void 0,d,this.c.workspace),c):this.e.getValue(void 0,d,this.c.workspace));c&&this.h(c,d,w?.identifier);function L(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const y={has(E){return typeof n(D,E)<"u"},get:(E,k)=>{this.h(c?`${c}.${E}`:E,d,w?.identifier);let F=n(D,E);if(typeof F>"u")F=k;else{let B;const ee=(J,V)=>{if((0,b.$Gf)(J)){let R;const S=()=>{B=B||(0,$.$in)(D),R=R||n(B,V)};return new Proxy(J,{get:(O,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return S(),()=>R;if(B)return R=R||n(B,V),R[Q];const re=O[Q];return typeof Q=="string"?ee(re,`${V}.${Q}`):re},set:(O,Q,re)=>(S(),R&&(R[Q]=re),!0),deleteProperty:(O,Q)=>(S(),R&&delete R[Q],!0),defineProperty:(O,Q,re)=>(S(),R&&Object.defineProperty(R,Q,re),!0)})}return Array.isArray(J)?(0,$.$in)(J):J};F=ee(F,E)}return F},update:(E,k,F,B)=>{E=c?`${c}.${E}`:E;const ee=L(F);return k!==void 0?this.b.$updateConfigurationOption(ee,E,k,d,B):this.b.$removeConfigurationOption(ee,E,d,B)},inspect:E=>{E=c?`${c}.${E}`:E;const k=this.e.inspect(E,d,this.c.workspace);if(k)return{key:E,defaultValue:(0,$.$in)(k.policy?.value??k.default?.value),globalValue:(0,$.$in)(k.user?.value??k.application?.value),workspaceValue:(0,$.$in)(k.workspace?.value),workspaceFolderValue:(0,$.$in)(k.workspaceFolder?.value),defaultLanguageValue:(0,$.$in)(k.default?.override),globalLanguageValue:(0,$.$in)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,$.$in)(k.workspace?.override),workspaceFolderLanguageValue:(0,$.$in)(k.workspaceFolder?.override),languageIds:(0,$.$in)(k.overrideIdentifiers)}}};return typeof D=="object"&&(0,$.$ln)(y,D,!1),Object.freeze(y)}g(c){const f=w=>(0,b.$Gf)(w)?new Proxy(w,{get:(d,D)=>f(d[D]),set:(d,D,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(d,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(d,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return f(c)}h(c,f,w){const d=g.$Jn.test(c)?4:this.d.get(c),D=w?`[${w.value}] `:"";if(d===4){typeof f?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){f?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,f){const w=new m.$Un(c,f,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,D)=>w.affectsConfiguration(d,u(D))})}k(c){return c.reduce((f,w)=>(f.set(w[0],w[1]),f),new Map)}}e.$Bfc=t,e.$Cfc=(0,C.$2h)("IExtHostConfiguration")});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[115],Ae([1,0,2,14,5,3,7,36,61,37,20,64,17,27,4,13,21,15,81,229,11]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=e.$4gc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(J){function V(S){if(S!=null)return S}J.from=V;function R(S){if(S!=null)return S}J.to=R})(t||(t={}));var r;(function(J){function V(S){if(S!=null)return S}J.from=V;function R(S){if(S!=null)return S}J.to=R})(r||(r={}));var c;(function(J){function V(S){if(S!=null)return S}J.from=V;function R(S){if(S!=null)return S}J.to=R})(c||(c={}));var f;(function(J){function V(O){if(O){const Q=O;return Q&&!!Q.process}else return!1}J.is=V;function R(O){if(O==null)return;const Q={process:O.process,args:O.args};return O.options&&(Q.options=c.from(O.options)),Q}J.from=R;function S(O){if(O!=null)return new M.$yL(O.process,O.args,O.options)}J.to=S})(f||(f={}));var w;(function(J){function V(S){if(S!=null)return S}J.from=V;function R(S){if(S!=null)return S}J.to=R})(w||(w={}));var d;(function(J){function V(O){if(O){const Q=O;return Q&&(!!Q.commandLine||!!Q.command)}else return!1}J.is=V;function R(O){if(O==null)return;const Q={};return O.commandLine!==void 0?Q.commandLine=O.commandLine:(Q.command=O.command,Q.args=O.args),O.options&&(Q.options=w.from(O.options)),Q}J.from=R;function S(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new M.$zL(O.commandLine,O.options):new M.$zL(O.command,O.args?O.args:[],O.options)}J.to=S})(d||(d={}));var D;(function(J){function V(O){if(O){const Q=O;return Q&&Q.customExecution==="customExecution"}else return!1}J.is=V;function R(O){return{customExecution:"customExecution"}}J.from=R;function S(O,Q){return Q.get(O)}J.to=S})(D||(e.CustomExecutionDTO=D={}));var L;(function(J){function V(R,S){let O;return R.scope!==void 0&&typeof R.scope!="number"?O=R.scope.uri:R.scope!==void 0&&typeof R.scope=="number"&&(R.scope===M.TaskScope.Workspace&&S&&S.workspaceFile?O=S.workspaceFile:O=a.$hG),{id:R._id,workspaceFolder:O}}J.from=V})(L||(e.TaskHandleDTO=L={}));var y;(function(J){function V(R){if(R!=null)return{_id:R.id,isDefault:R.isDefault}}J.from=V})(y||(y={}));var E;(function(J){function V(O,Q){if(O==null)return[];const re=[];for(const he of O){const fe=R(he,Q);fe&&re.push(fe)}return re}J.fromMany=V;function R(O,Q){if(O==null)return;let re;O.execution instanceof M.$yL?re=f.from(O.execution):O.execution instanceof M.$zL?re=d.from(O.execution):O.execution&&O.execution instanceof M.$AL&&(re=D.from(O.execution));const he=t.from(O.definition);let fe;return O.scope?typeof O.scope=="number"?fe=O.scope:fe=O.scope.uri:fe=M.TaskScope.Workspace,!he||!fe?void 0:{_id:O._id,definition:he,name:O.name,source:{extensionId:Q.identifier.value,label:O.source,scope:fe},execution:re,isBackground:O.isBackground,group:y.from(O.group),presentationOptions:r.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}J.from=R;async function S(O,Q,re){if(O==null)return;let he;f.is(O.execution)?he=f.to(O.execution):d.is(O.execution)?he=d.to(O.execution):D.is(O.execution)&&(he=D.to(O._id,re));const fe=t.to(O.definition);let ue;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?ue=O.source.scope:ue=await Q.resolveWorkspaceFolder($.URI.revive(O.source.scope)):ue=M.TaskScope.Workspace),!fe||!ue)return;const $e=new M.$BL(fe,ue,O.name,O.source.label,he,O.problemMatchers);return O.isBackground!==void 0&&($e.isBackground=O.isBackground),O.group!==void 0&&($e.group=M.$xL.from(O.group._id),$e.group&&O.group.isDefault&&($e.group=new M.$xL($e.group.id,$e.group.label),O.group.isDefault===!0&&($e.group.isDefault=O.group.isDefault))),O.presentationOptions&&($e.presentationOptions=r.to(O.presentationOptions)),O._id&&($e._id=O._id),O.detail&&($e.detail=O.detail),$e}J.to=S})(E||(e.TaskDTO=E={}));var k;(function(J){function V(S){return S}J.from=V;function R(S){if(S)return Object.assign(Object.create(null),S)}J.to=R})(k||(k={}));class F{constructor(V,R,S){this._id=R,this.a=S,h.set(this,void 0),xe(this,h,V,"f")}get task(){return this.a}terminate(){ze(this,h,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}h=new WeakMap;let B=class{constructor(V,R,S,O,Q,re,he,fe){this.q=new I.$Sd,this.r=new I.$Sd,this.s=new I.$Sd,this.t=new I.$Sd,this.a=V.getProxy(T.$NK.MainThreadTask),this.b=S,this.c=O,this.d=Q,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=he,this.g=fe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,R,S){if(!S)return new M.$PK(()=>{});const O=this.w();return this.j.set(O,{type:R,provider:S,extension:V}),this.a.$registerTaskProvider(O,R),new M.$PK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(V,R){this.a.$registerTaskSystem(V,R)}fetchTasks(V){return this.a.$fetchTasks(k.from(V)).then(async R=>{const S=[];for(const O of R){const Q=await E.to(O,this.b,this.m);Q&&S.push(Q)}return S})}get taskExecutions(){const V=[];return this.k.forEach(R=>V.push(R)),V}terminateTask(V){if(!(V instanceof F))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,R,S){const O=this.m.get(V.id);O&&(this.o.set(V.id,O),this.e.attachPtyToTerminal(R,await O.callback(S))),this.p=V.id,this.q.fire({execution:await this.y(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){const R=await this.y(V);this.l.delete(V.id),this.k.delete(V.id),this.A(V),this.r.fire({execution:R})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const R=await this.y(V.id);this.s.fire({execution:R,processId:V.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(V){const R=await this.y(V.id);this.t.fire({execution:R,exitCode:V.exitCode})}$provideTasks(V,R){const S=this.j.get(V);if(!S)return Promise.reject(new Error("no handler found"));const O=[],Q=(0,P.$Ug)(()=>S.provider.provideTasks(A.CancellationToken.None)).then(re=>this.u(R,O,S,re));return new Promise(re=>{Q.then(he=>{Promise.all(O).then(()=>{re(he)})})})}async $resolveTask(V,R){const S=this.j.get(V);if(!S)return Promise.reject(new Error("no handler found"));if(R.definition.type!==S.type)throw new Error(`Unexpected: Task of type [${R.definition.type}] cannot be resolved by provider of type [${S.type}].`);const O=await E.to(R,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const Q=await S.provider.resolveTask(O,A.CancellationToken.None);if(!Q)return;this.z(Q,S);const re=E.from(Q,S.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(Q.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(re.execution)&&await this.x(re,Q,!0),await this.v(re)}w(){return this.h++}async x(V,R,S){const O=await this.a.$createTaskId(V);!S&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,R.execution)),this.m.set(O,R.execution)}async y(V,R){if(typeof V=="string"){const Q=this.l.get(V);if(!Q)throw new u.$bb("Unexpected: The specified task is missing an execution");return Q}const S=this.l.get(V.id);if(S)return S;const O=new Promise((Q,re)=>{function he(fe,ue,$e){$e?Q(new F(fe,ue.id,$e)):re("Unexpected: Task does not exist.")}R?he(this,V,R):E.to(V.task,this.b,this.m).then(fe=>he(this,V,fe))});return this.l.set(V.id,O),O.then(Q=>(this.k.set(V.id,Q),Q),Q=>Promise.reject(Q))}z(V,R){V._deprecated&&this.g.report("Task.constructor",R.extension,"Use the Task constructor that takes a `scope` instead.")}A(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const S=this.n.values();let O=S.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=S.next()}};e.$4gc=B,e.$4gc=B=Je([Ge(0,l.$RM),Ge(1,p.$8M),Ge(2,m.$zfc),Ge(3,g.$3M),Ge(4,b.$Cfc),Ge(5,C.$1fc),Ge(6,i.$jj),Ge(7,s.$hfc)],B);let ee=class extends B{constructor(V,R,S,O,Q,re,he,fe){super(V,R,S,O,Q,re,he,fe),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$b(0)})}async executeTask(V,R){if(!R.execution)throw new Error("Tasks to execute must include an execution");const S=E.from(R,V);if(S===void 0)throw new Error("Task is not valid");if(D.is(S.execution))await this.x(S,R,!1);else throw new u.$_;const O=await this.y(await this.a.$getTaskExecution(S),R);return this.a.$executeTask(S).catch(Q=>{throw new Error(Q)}),O}u(V,R,S,O){const Q=[];if(O)for(const re of O){if(this.z(re,S),!re.definition||!V[re.definition.type]){const fe=re.source?re.source:"No task source";this.f.warn(`The task [${fe}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const he=E.from(re,S.extension);he&&D.is(he.execution)?(Q.push(he),R.push(this.x(he,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Q,extension:S.extension}}async v(V){if(D.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,R){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,R,S){}};e.$5gc=ee,e.$5gc=ee=Je([Ge(0,l.$RM),Ge(1,p.$8M),Ge(2,m.$zfc),Ge(3,g.$3M),Ge(4,b.$Cfc),Ge(5,C.$1fc),Ge(6,i.$jj),Ge(7,s.$hfc)],ee),e.$6gc=(0,v.$2h)("IExtHostTask")}),define(Re[282],Ae([1,0,44,29]),function(ie,e,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BJ=e.$AJ=e.$zJ=void 0;function I(M){return"cellResults"in M}e.$zJ=I,e.$AJ="rawCell#";function T(M,m){let g=-1;const b=[];let A=[];return M.forEach(l=>{l.range.startLineNumber!==g&&A.length>0&&(b.push([...A]),A=[]),A.push(l),g=l.range.endLineNumber}),A.length>0&&b.push([...A]),b.map(l=>{const p=[],v=l[0].range.startLineNumber,n=l[l.length-1].range.endLineNumber;for(let o=v;o<=n;o++)p.push(m.getLineContent(o));return new $.$dJ(p.join(`
`)+`
`,l.map(o=>new P.$Hs(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.$BJ=T}),define(Re[283],Ae([1,0,162,24,5,6,28,12,16,2,42,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u,h,t,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class f{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(d=>d.apiEditor)}constructor(d,D,L,y,E,k){this.q=L,this.r=y,this.s=E,this.t=k,this.f=new Map,this.g=new M.$Ac,this.h=new Map,this.j=new I.$Sd({onListenerError:a.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Sd({onListenerError:a.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Sd({onListenerError:a.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Sd({onListenerError:a.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$afc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=d.getProxy(l.$NK.MainThreadNotebook),this.c=d.getProxy(l.$NK.MainThreadNotebookDocuments),this.d=d.getProxy(l.$NK.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===13){const B=F.notebookEditor?.notebookUri,ee=F.cell.handle,V=this.g.get(B)?.getCell(ee);if(V)return V.apiCell}if(F&&F.$mid===14){const B=F.uri,ee=this.g.get(B);if(ee)return ee.apiNotebook}return F}}),f.B(D)}getEditorById(d){const D=this.h.get(d);if(!D)throw new Error(`unknown text editor: ${d}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(d){for(const[D,L]of this.h)if(L.apiEditor===d)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(d,D){const L=this.g.get(d);if(!L&&!D)throw new Error(`NO notebook document for '${d}'`);return L}static u(d,D){if(!D)return;const L=D.filenamePattern.map(y=>v.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if(D.filenamePattern&&!L){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:D.displayName,filenamePattern:L,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(d,D,L){const y=f.a++,E=typeof L.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(y,L),this.b.$registerNotebookCellStatusBarItemProvider(y,E,D);let k;return E!==void 0&&(k=L.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(E))),new n.$PK(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,E),k?.dispose()})}async createNotebookDocument(d){const D=await this.c.$tryCreateNotebook({viewType:d.viewType,content:d.content&&v.NotebookData.from(d.content)});return b.URI.revive(D)}async openNotebookDocument(d){const D=this.g.get(d);if(D)return D.apiNotebook;const L=await this.c.$tryOpenNotebook(d),y=this.g.get(b.URI.revive(L));return(0,g.$Pf)(y?.apiNotebook)}async showNotebookDocument(d,D){b.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let L;typeof D=="object"?L={position:v.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(v.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:L={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument(d.uri,d.notebookType,L),E=y&&this.h.get(y)?.apiEditor;if(E)return E;throw y?new Error(`Could NOT open editor for "${d.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(d,D,L,y){const E=this.f.get(d),k=b.URI.revive(D),F=this.g.get(k);if(!F||!E)return;const B=F.getCellFromIndex(L);if(!B)return;const ee=await E.provideCellStatusBarItems(B.apiCell,y);if(!ee)return;const J=new T.$Rc,V=this.p.add([J]),S=(Array.isArray(ee)?ee:[ee]).map(O=>v.NotebookStatusBarItem.from(O,this.i,J));return{cacheId:V,items:S}}$releaseNotebookCellStatusBarItems(d){this.p.delete(d)}registerNotebookSerializer(d,D,L,y,E){if((0,m.$Ge)(D))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:D,serializer:L,options:y}),this.b.$registerNotebookSerializer(k,{id:d.identifier,location:d.extensionLocation},D,v.NotebookDocumentContentOptions.from(y),f.u(d,E)),(0,T.$Qc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(d,D,L){const y=this.x.get(d);if(!y)throw new Error("NO serializer found");const E=await y.serializer.deserializeNotebook(D.buffer,L);return new o.$Fv(v.NotebookData.from(E))}async $notebookToData(d,D,L){const y=this.x.get(d);if(!y)throw new Error("NO serializer found");const E=await y.serializer.serializeNotebook(v.NotebookData.to(D.value),L);return P.$ge.wrap(E)}async $saveNotebook(d,D,L,y,E){const k=b.URI.revive(D),F=this.x.get(d);if(!F)throw new Error("NO serializer found");const B=this.g.get(k);if(!B)throw new Error("Document NOT found");if(B.versionId!==L)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$Gk((0,$.localize)(0,null,this.z(k)),6);await this.y(k,y);const ee={metadata:(0,u.$qn)(B.apiNotebook.metadata,O=>!(F.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of B.apiNotebook.getCells()){const Q=new n.$cM(O.kind,O.document.getText(),O.document.languageId,O.mime,F.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);Q.metadata=(0,u.$qn)(O.metadata,re=>!(F.options?.transientCellMetadata??{})[re]),ee.cells.push(Q)}const J=await F.serializer.serializeNotebook(ee,E);await this.s.value.writeFile(k,J);const V=this.s.getFileSystemProviderExtUri(k.scheme),R=await this.s.value.stat(k);return{name:V.basename(k),isFile:(R.type&A.FileType.File)!==0,isDirectory:(R.type&A.FileType.Directory)!==0,isSymbolicLink:(R.type&A.FileType.SymbolicLink)!==0,mtime:R.mtime,ctime:R.ctime,size:R.size,readonly:!!((R.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((R.permissions??0)&A.FilePermission.Locked),etag:A.$Rk({mtime:R.mtime,size:R.size}),children:void 0}}async $searchInNotebooks(d,D,L,y,E){const k=this.x.get(d)?.serializer;if(!k)return{limitHit:!1,results:[]};const F=new M.$Bc;await(async(R,S,O)=>{await Promise.all(R.map(async Q=>await Promise.all(Q.filenamePatterns.map(re=>{const he={...O,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(he,S,fe=>{fe.forEach(ue=>{F.has(ue)||y.some(ne=>Q.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(Pe=>(0,c.$$cb)(Pe,ue)))||F.add(ue)})})}))))})(L,E,D);const ee=new M.$Ac;let J=!1;const V=Array.from(F).map(async R=>{const S=[];try{if(E.isCancellationRequested)return;if(D.maxResults&&[...ee.values()].reduce((he,fe)=>he+fe.cellResults.length,0)>D.maxResults){J=!0;return}const O=[],Q=this.g.get(R);if(Q)Q.apiNotebook.getCells().forEach(fe=>O.push({input:fe.document.getText(),outputs:fe.outputs.flatMap(ue=>ue.items.map($e=>$e.data.toString()))}));else{const he=await this.s.value.readFile(R),fe=P.$ge.fromString(he.toString()),ue=await k.deserializeNotebook(fe.buffer,E);if(E.isCancellationRequested)return;v.NotebookData.from(ue).cells.forEach(ne=>O.push({input:ne.source,outputs:ne.outputs.flatMap(Pe=>Pe.items.map(le=>le.valueBytes.toString()))}))}if(E.isCancellationRequested)return;O.forEach((he,fe)=>{const ue=D.contentPattern.pattern,$e=new t.$aQb(he.input,void 0,he.outputs),ne=$e.findInInputs(ue),Pe=$e.findInOutputs(ue),le=Pe.flatMap(me=>(0,r.$BJ)(me.matches,me.textBuffer)).map((me,W)=>(me.webviewIndex=W,me));if(ne.length>0||Pe.length>0){const me={index:fe,contentResults:(0,r.$BJ)(ne,$e.inputTextBuffer),webviewResults:le};S.push(me)}});const re={resource:R,cellResults:S};ee.set(R,re);return}catch{return}});return await Promise.all(V),{limitHit:J,results:[...ee.values()]}}async y(d,D){const L=await this.s.value.stat(d);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==A.$Qk&&typeof L.mtime=="number"&&typeof L.size=="number"&&D.mtime<L.mtime&&D.etag!==A.$Rk({mtime:D.mtime,size:L.size}))throw new A.$Gk((0,$.localize)(1,null),3,D)}z(d){return d.scheme===h.Schemas.file?d.fsPath:d.toString()}A(d,D,L){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const y=new s.$wgc(D,this.d,d,L.visibleRanges.map(v.NotebookRange.to),L.selections.map(v.NotebookRange.to),typeof L.viewColumn=="number"?v.ViewColumn.to(L.viewColumn):void 0);this.h.set(D,y)}$acceptDocumentAndEditorsDelta(d){if(d.value.removedDocuments)for(const L of d.value.removedDocuments){const y=b.URI.revive(L),E=this.g.get(y);E&&(E.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(E.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===y.toString()&&this.h.delete(k.id)}if(d.value.addedDocuments){const L=[];for(const y of d.value.addedDocuments){const E=b.URI.revive(y.uri);if(this.g.has(E))throw new Error(`adding EXISTING notebook ${E} `);const k=new i.$vgc(this.c,this.q,this.r,E,y);L.push(...y.cells.map(F=>i.$ugc.asModelAddData(k.apiNotebook,F))),this.g.get(E)?.dispose(),this.g.set(E,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:L}),this.m.fire(k.apiNotebook)}}if(d.value.addedEditors)for(const L of d.value.addedEditors){if(this.h.has(L.id))return;const y=b.URI.revive(L.documentUri),E=this.g.get(y);E&&this.A(E,L.id,L)}const D=[];if(d.value.removedEditors)for(const L of d.value.removedEditors){const y=this.h.get(L);y&&(this.h.delete(L),this.k?.id===y.id&&(this.k=void 0),D.push(y))}if(d.value.visibleEditors){this.l=d.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const L=new Set;this.l.forEach(y=>L.add(y.id));for(const y of this.h.values()){const E=L.has(y.id);y._acceptVisibility(E)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}d.value.newActiveEditor===null?this.k=void 0:d.value.newActiveEditor&&(this.h.get(d.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${d.value.newActiveEditor}`),this.k=this.h.get(d.value.newActiveEditor)),d.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(d){const D=p.$dN.String.with("notebookType","A notebook type"),L=new p.$fN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new p.$dN("data","Bytes to convert to data",E=>E instanceof Uint8Array,E=>P.$ge.wrap(E))],new p.$eN("Notebook Data",E=>v.NotebookData.to(E.value))),y=new p.$fN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new p.$dN("NotebookData","Notebook data to convert to bytes",E=>!0,E=>new o.$Fv(v.NotebookData.from(E)))],new p.$eN("Bytes",E=>E.buffer));d.registerApiCommand(L),d.registerApiCommand(y)}}e.$Fgc=f,f.a=0}),define(Re[284],Ae([1,0,19,20,40,33,25,60,44]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;class b{constructor(l,p,v){this.k=l,this.l=p,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&T.$Ij(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&T.$Ij(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((v,n)=>{const o=i=>{this.f++,l(i)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const s=i.toString(),a=$.$nc(s);this.j&&this.j(s,a)||this.v(o,{base:i,basename:a})}),Promise.all(p.map(i=>this.p(i,o))).then(i=>{v({limitHit:this.e,stats:i[0]||void 0})},i=>{n(new Error((0,I.$Mi)(i)))})})}async p(l,p){const v=new P.$3d,n=this.q(l),o=this.r(),i=new g.$rJ(this.k,l),s=!i.hasSiblingExcludeClauses();let a;try{this.h.add(v),a=m.$Od.create();const u=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,v.token),h=a.elapsed(),t=m.$Od.create();return this.g&&!this.e||(u&&u.forEach(r=>{const c=$.$gc.relative(l.folder.path,r.path);if(s){const f=$.$nc(r.path);this.v(p,{base:l.folder,relativePath:c,basename:f});return}this.s(o,l.folder,c,p)}),this.g&&!this.e)?null:(this.u(o,i,p),{providerTime:h,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(l){const p=(0,g.$qJ)(this.k.includePattern,l.includePattern),v=(0,g.$qJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:v,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,v,n){if(v===this.a){const i=$.$nc(this.a);this.v(n,{base:p,relativePath:this.a,basename:i})}function o(i){const s=$.$nc(i),a=$.$mc(i);let u=l[a];u||(u=l[a]=[],o(a)),u.push({base:p,relativePath:i,basename:s})}o(v)}u({rootEntries:l,pathToEntries:p},v,n){const o=this,i=this.a;function s(a){const u=(0,g.$tJ)(()=>a.map(h=>h.basename));for(let h=0,t=a.length;h<t;h++){const r=a[h],{relativePath:c,basename:f}=r;if(v.matchesExcludesSync(c,f,i!==f?u:void 0))continue;const w=p[c];if(w)s(w);else{if(c===i)continue;o.v(n,r)}if(o.e)break}}s(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class A{constructor(){this.b=new Map}fileSearch(l,p,v,n){const o=this.c(l.cacheKey),i=new b(l,p,o&&o.token);let s=0;const a=u=>{s+=u.length,v(u.map(h=>this.d(h)))};return this.e(i,A.a,a,n).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:s,detailStats:u.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new P.$3d),this.b.get(l)}d(l){return l.relativePath?{resource:M.$Dg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,v,n){const o=n.onCancellationRequested(()=>{l.cancel()}),i=a=>{a&&(s.push(a),p>0&&s.length>=p&&(v(s),s=[]))};let s=[];return l.search(i).then(a=>(s.length&&v(s),o.dispose(),a),a=>(s.length&&v(s),o.dispose(),Promise.reject(a)))}}e.$xgc=A,A.a=512}),define(Re[285],Ae([1,0,18,246,33,91,28,13,19,25,12,16,2,95,180,41,15,47,105,281,44]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.$rK=void 0;let h=class{constructor(E,k,F,B,ee){this.a=E,this.b=k,this.c=F,this.d=B,this.e=ee}text(E,k,F={}){E=this.f(E,F);const B=this.a.getValue(),ee=k&&k.some(V=>!this.a.getValue({resource:V}).search.useRipgrep);return{...this.h(k?.map(i.$ki),F),type:2,contentPattern:E,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:B.search.usePCRE2||ee||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(E,k){const F=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const B={...E,wordSeparators:F.editor.wordSeparators};return this.j(E,k)&&(B.isCaseSensitive=!0),this.k(E)&&(B.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),B}file(E,k={}){return{...this.h(E,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(E,k){return E?(E=Array.isArray(E)?E.map(w):w(E),k?this.parseSearchPaths(E):{pattern:r(...Array.isArray(E)?E:[E])}):{}}h(E=[],k={}){const F=this.g(k.includePattern,k.expandPatterns),B=this.g(k.excludePattern,k.expandPatterns),ee=E.length>1,J=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(S=>this.q(S,k,B)):E.map(S=>this.r(S,k,B,ee))).filter(S=>!!S),V={_reason:k._reason,folderQueries:J,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:B.pattern,includePattern:F.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const S=$.$Hb($.$Rb(this.c.groups.map(re=>re.editors.map(he=>he.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(S));const O=S.filter(re=>(0,u.$hJ)(V,re.fsPath)),Q=this.i(O);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...V,...Q}}const R=k.extraFileResources&&k.extraFileResources.filter(S=>(0,u.$hJ)(V,S.fsPath));return V.extraFileResources=R&&R.length?R:void 0,V}i(E){const k=[],F=new M.$Ac,B={};let ee=!1;return E.forEach(J=>{if(J.scheme===m.Schemas.walkThrough)return;if((0,b.$Hg)(J)){const R=this.b.getWorkspaceFolder(J)?.uri??J.with({path:g.$mc(J.fsPath)});let S=F.get(R);S||(ee=!0,S={folder:R,includePattern:{}},k.push(S),F.set(R,S));const O=g.$lc(R.fsPath,J.fsPath);(0,C.$Pf)(S.includePattern)[O.replace(/\\/g,"/")]=!0}else J.fsPath&&(ee=!0,B[J.fsPath]=!0)}),{folderQueries:k,includePattern:B,usingSearchPaths:!0,excludePattern:ee?void 0:{"**/*":!0}}}j(E,k){if(k.isSmartCase){if(E.isRegExp){if(A.$vf(E.pattern,!0))return!0}else if(A.$vf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,p.$MB)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const k=Q=>g.$ic(Q)||/^\.\.?([\/\\]|$)/.test(Q),B=(Array.isArray(E)?E:c(E)).map(Q=>{const re=this.e.resolvedUserHome;return re?(0,T.$Kv)(Q,re.scheme===m.Schemas.file?re.fsPath:re.path):Q}),ee=P.$E(B,Q=>k(Q)?"searchPaths":"exprSegments"),J=(ee.exprSegments||[]).map(Q=>A.$Qe(Q,"/")).map(Q=>A.$Qe(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),f(Q))),V={},R=this.m(ee.searchPaths||[]);R&&R.length&&(V.searchPaths=R);const S=$.$Rb(J),O=r(...S);return O&&(V.pattern=O),V}l(E,k){return k.disregardExcludeSettings?void 0:(0,u.$gJ)(E,!k.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const k=E.flatMap(B=>{let{pathPortion:ee,globPortion:J}=t(B);return J&&(J=d(J)),this.n(ee).flatMap(R=>this.o(R,J))}),F=new Map;return k.forEach(B=>{const ee=B.searchPath.toString(),J=F.get(ee);J?B.pattern&&(J.pattern=J.pattern||{},J.pattern[B.pattern]=!0):F.set(ee,{searchPath:B.searchPath,pattern:B.pattern?r(B.pattern):void 0})}),Array.from(F.values())}n(E){if(g.$ic(E)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==m.Schemas.file?[{searchPath:k[0].uri.with({path:E})}]:[{searchPath:l.URI.file(g.$hc(E))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(E=w(E),E.startsWith("../")||E===".."){const B=g.$gc.resolve(k.path,E);return[{searchPath:k.with({path:B})}]}const F=d(E);return[{searchPath:k,pattern:F}]}else{if(E==="./"||E===".\\")return[];{const k=E.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(ee=>{const J=k.match(new RegExp(`^${A.$Ke(ee.name)}(?:/(.*)|$)`));return J?{match:J,folder:ee}:null}).filter(C.$Mf);if(B.length)return B.map(ee=>{const J=ee.match[1];return{searchPath:ee.folder.uri,pattern:J&&d(J)}});{const ee=E.match(/\.[\/\\](.+)[\/\\]?/),J=ee?ee[1]:E,V=v.localize(0,null,J);throw new Error(V)}}}}o(E,k){const F=E.pattern&&k?`${E.pattern}/${k}`:E.pattern||k,B=[{searchPath:E.searchPath,pattern:F}];return F&&!F.endsWith("**")&&B.push({searchPath:E.searchPath,pattern:F+"/**"}),B}q(E,k,F){const B=this.r((0,i.$ki)(E.searchPath),k,F,!1);return B?{...B,includePattern:E.pattern}:null}r(E,k,F,B){let ee;const J=l.URI.isUri(E)?E:E.uri;if(F.searchPaths){const Q=F.searchPaths.filter(re=>(0,b.$wg)(re.searchPath,J))[0];if(Q&&!Q.pattern)return null;Q&&(ee=Q.pattern)}const V=this.a.getValue({resource:J}),S={...this.l(V,k)||{},...ee||{}},O=l.URI.isUri(E)?(0,b.$Ag)(E):E.name;return{folder:J,folderName:B?O:void 0,excludePattern:Object.keys(S).length>0?S:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!V.search.followSymlinks}}};e.$rK=h,e.$rK=h=Je([Ge(0,n.$vi),Ge(1,i.$$h),Ge(2,s.$RC),Ge(3,o.$jj),Ge(4,a.$pK)],h);function t(y){const E=y.match(/[\*\{\}\(\)\[\]\?]/);if(E){const k=E.index,F=y.substr(0,k).match(/[/|\\][^/\\]*$/);if(F){let B=y.substr(0,F.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:y.substr((F.index||0)+1)}}}return{pathPortion:y}}function r(...y){return y.length?y.reduce((E,k)=>(E[k]=!0,E),Object.create(null)):void 0}function c(y){return I.$Gj(y,",").map(E=>E.trim()).filter(E=>!!E.length)}function f(y){return[`**/${y}/**`,`**/${y}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function w(y){return y.replace(/\\/g,"/")}function d(y){return w(y).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(y){return y.replace(/([?*[\]])/g,"[$1]")}function L(y,E){y=$.$Mb(y,B=>B.toString());const k=[],F=E.getWorkspace();return y&&y.forEach(B=>{let ee;if(E.getWorkbenchState()===2)ee=(0,b.$Fg)(F.folders[0].uri,B),ee&&ee!=="."&&(ee="./"+ee);else{const J=E.getWorkspaceFolder(B);if(J){const V=J.name;if(F.folders.filter(S=>S.name===V).length===1){const S=(0,b.$Fg)(J.uri,B);S===""?ee=`./${J.name}`:ee=`./${J.name}/${S}`}else ee=B.fsPath}}ee&&k.push(D(ee))}),k}e.$sK=L}),define(Re[286],Ae([1,0,25,2,20,11,4,285,44,47]),function(ie,e,$,P,I,T,M,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jsb=e.$isb=void 0;const A=7e3;function C(n,o){const i=o.activationEvents;if(!i)return Promise.resolve(void 0);const s=[],a=[];for(const f of i)if(/^workspaceContains:/.test(f)){const w=f.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||n.forceUsingSearch?a.push(w):s.push(w)}if(s.length===0&&a.length===0)return Promise.resolve(void 0);let u;const h=new Promise((f,w)=>{u=f}),t=f=>u({activationEvent:f}),r=Promise.all(s.map(f=>l(n,f,t))).then(()=>{}),c=p(n,o.identifier,a,t);return Promise.all([r,c]).then(()=>{u(void 0)}),h}e.$isb=C;async function l(n,o,i){for(const s of n.folders)if(await n.exists($.$Dg(P.URI.revive(s),o))){i(`workspaceContains:${o}`);return}}async function p(n,o,i,s){if(i.length===0)return Promise.resolve(void 0);const a=new I.$3d,u=n.checkExists(n.folders,i,a.token),h=setTimeout(async()=>{a.cancel(),n.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},A);let t=!1;try{t=await u}catch(r){T.$4(r)||T.$1(r)}a.dispose(),clearTimeout(h),t&&s(`workspaceContains:${i.join(",")}`)}function v(n,o,i,s){const a=n.get(M.$1h),u=n.get(g.$$I),t=a.createInstance(m.$rK).file(o.map(r=>(0,b.$ki)(P.URI.revive(r))),{_reason:"checkExists",includePattern:i,exists:!0});return u.fileSearch(t,s).then(r=>!!r.limitHit,r=>T.$4(r)?!1:Promise.reject(r))}e.$jsb=v});var xe=this&&this.__classPrivateFieldSet||function(ie,e,$,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(ie,$):I?I.value=$:e.set(ie,$),$},ze=this&&this.__classPrivateFieldGet||function(ie,e,$,P){if($==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return $==="m"?P:$==="a"?P.call(ie):P?P.value:e.get(ie)};define(Re[38],Ae([1,0,159,19,88,25,14,6,50,2,15,3,37,218,85,36,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u,h,t,r,c,f,w,d,D,L,y,E,k,F,B,ee,J,V,R,S){"use strict";var O,Q,re,he;Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=e.$bgc=e.$agc=e.$_fc=void 0,e.$_fc=(0,c.$2h)("IHostUtils");let fe=he=class extends m.$Sc{constructor(de,ke,Ee,ce,_,H,te,we,be,Fe,pe,Se){super(),this.X=Se,this.a=this.B(new E.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=ke,this.g=Ee,this.f=te,this.j=ce,this.m=_,this.s=H,this.t=be,this.u=Fe,this.w=pe,this.y=this.g.getProxy(C.$NK.MainThreadWorkspace),this.z=this.g.getProxy(C.$NK.MainThreadTelemetry),this.C=this.g.getProxy(C.$NK.MainThreadExtensionService),this.D=new M.$1g,this.F=new M.$1g,this.G=new M.$1g,this.H=new M.$1g,this.I=new W(this.f.extensions.activationEvents),this.L=new i.$o7b(this.I,this.f.extensions.allExtensions);const N=new a.$im(this.f.extensions.myExtensions);this.J=new i.$o7b(this.I,le(this.L,N)),R.$n&&(this.s.info(`Creating extension host with the following global extensions: ${ne(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ne(this.J)}`)),this.M=new v.$Wfc(this.g,this.s),this.N=new F.$5fc(this.g),this.O=we,this.h=de.createChild(new D.$Zh([v.$Xfc,this.M],[F.$6fc,this.N])),this.P=this.B(new p.$Vfc(this.J,this.L,{onExtensionActivationError:(q,G,z)=>{this.C.$onExtensionActivationError(q,s.$3(G),z)},actualActivateExtension:async(q,G)=>{if(i.$o7b.isHostExtension(q,this.J,this.L))return await this.C.$activateExtension(q,G),new p.$Ufc;const z=this.J.getExtensionDescription(q);return this.db(z,G)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(de){s.$1(de)}}async Y(){this.O.onWillDeactivateAll();let de=[];try{de=this.J.getAllExtensionDescriptions().map(_=>_.identifier).filter(_=>this.isActivated(_)).map(_=>this.cb(_))}catch{}await Promise.all(de)}terminate(de,ke=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${de}`),this.s.flush(),this.u.dispose(),this.P.dispose(),s.setUnexpectedErrorHandler(ce=>{this.s.error(ce)}),this.g.dispose();const Ee=this.Y();Promise.race([(0,M.$3g)(5e3),Ee]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ke}`):this.s.info(`Extension host exiting with code ${ke}`),this.s.flush(),this.s.dispose(),this.c.exit(ke)})}isActivated(de){return this.G.isOpen()?this.P.isActivated(de):!1}async getExtension(de){const ke=await this.C.$getExtension(de);return ke&&{...ke,identifier:new a.$hm(ke.identifier.value),extensionLocation:b.URI.revive(ke.extensionLocation)}}Z(de,ke){return this.P.activateByEvent(de,ke)}$(de,ke){return this.P.activateById(de,ke)}activateByIdWithErrors(de,ke){return this.$(de,ke).then(()=>{const Ee=this.P.getActivatedExtension(de);if(Ee.activationFailed)return Promise.reject(Ee.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(de=>this.J)}getExtensionExports(de){if(this.G.isOpen())return this.P.getActivatedExtension(de).exports;try{return this.P.getActivatedExtension(de).exports}catch{return null}}async ab(de){if(de.scheme===ee.Schemas.file&&this.c.fsRealpath){const ke=await this.c.fsRealpath(de.fsPath);return b.URI.file(ke)}return de}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(de=>new me(de))),this.Q}async bb(de){const ke=g.$8h.forUris(Ee=>T.$ug.ignorePathCasing(Ee));return await Promise.all(de.map(async Ee=>{if(this.ub(Ee)){const ce=await this.ab(Ee.extensionLocation);ke.set(ce,Ee)}})),ke}cb(de){let ke=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(de))return ke;const Ee=this.P.getActivatedExtension(de);if(!Ee)return ke;try{typeof Ee.module.deactivate=="function"&&(ke=Promise.resolve(Ee.module.deactivate()).then(void 0,ce=>(this.s.error(ce),Promise.resolve(void 0))))}catch(ce){this.s.error(`An error occurred when deactivating the extension '${de.value}':`),this.s.error(ce)}try{(0,m.$Nc)(Ee.subscriptions)}catch(ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${de.value}':`),this.s.error(ce)}return ke}async db(de,ke){return this.f.remote.isRemote?this.C.$onWillActivateExtension(de.identifier):await this.C.$onWillActivateExtension(de.identifier),this.fb(de,ke).then(Ee=>{const ce=Ee.activationTimes;return this.C.$onDidActivateExtension(de.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,ke),this.eb(de,ke,"success",ce),Ee},Ee=>{throw this.eb(de,ke,"failure"),Ee})}eb(de,ke,Ee,ce){const _=$e(de,ke);this.z.$publicLog2("extensionActivationTimes",{..._,...ce||{},outcome:Ee})}fb(de,ke){const Ee=$e(de,ke);this.z.$publicLog2("activatePlugin",Ee);const ce=this.ub(de);if(!ce)return Promise.resolve(new p.$Tfc(p.$Qfc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${de.identifier.value}, startup: ${ke.startup}, activationEvent: '${ke.activationEvent}'${de.identifier.value!==ke.extensionId.value?`, root cause: ${ke.extensionId.value}`:""}`),this.s.flush();const _=new p.$Rfc(ke.startup);return Promise.all([this.vb(de,(0,T.$Dg)(de.extensionLocation,ce),_),this.gb(de)]).then(H=>(I.mark(`code/extHost/willActivateExtension/${de.identifier.value}`),he.hb(this.s,de.identifier,H[0],H[1],_))).then(H=>(I.mark(`code/extHost/didActivateExtension/${de.identifier.value}`),H))}gb(de){const ke=new h.$Zfc(de,this.M),Ee=new h.$Yfc(de.identifier.value,!1,this.M),ce=new B.$7fc(de,this.N),_=de.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,H=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${de.identifier.value}`),Promise.all([ke.whenReady,Ee.whenReady,this.O.whenReady]).then(()=>{const te=this;let we,be;const Fe=(0,o.$kF)(de,"ipc")?this.f.messagePorts?.get(a.$hm.toKey(de.identifier)):void 0;return Object.freeze({globalState:ke,workspaceState:Ee,secrets:ce,subscriptions:[],get extensionUri(){return de.extensionLocation},get extensionPath(){return de.extensionLocation.fsPath},asAbsolutePath(pe){return P.$jc(de.extensionLocation.fsPath,pe)},get storagePath(){return te.O.workspaceValue(de)?.fsPath},get globalStoragePath(){return te.O.globalValue(de).fsPath},get logPath(){return P.$jc(te.f.logsLocation.fsPath,de.identifier.value)},get logUri(){return b.URI.joinPath(te.f.logsLocation,de.identifier.value)},get storageUri(){return te.O.workspaceValue(de)},get globalStorageUri(){return te.O.globalValue(de)},get extensionMode(){return _},get extension(){return we===void 0&&(we=new Pe(te,de.identifier,de,H,!1)),we},get extensionRuntime(){return(0,o.$lF)(de,"extensionRuntime"),te.extensionRuntime},get environmentVariableCollection(){return te.u.getEnvironmentVariableCollection(de)},get messagePassingProtocol(){if(!be){if(!Fe)return;const pe=E.Event.buffer(E.Event.fromDOMEventEmitter(Fe,"message",Se=>Se.data));Fe.start(),be={onDidReceiveMessage:pe,postMessage:Fe.postMessage.bind(Fe)}}return be}})})}static hb(de,ke,Ee,ce,_){return Ee=Ee||{activate:void 0,deactivate:void 0},this.ib(de,ke,Ee,ce,_).then(H=>new p.$Sfc(!1,null,_.build(),Ee,H,ce.subscriptions))}static ib(de,ke,Ee,ce,_){if(typeof Ee.activate=="function")try{_.activateCallStart(),de.trace(`ExtensionService#_callActivateOptional ${ke.value}`);const H=typeof global=="object"?global:self,te=Ee.activate.apply(H,[ce]);return _.activateCallStop(),_.activateResolveStart(),Promise.resolve(te).then(we=>(_.activateResolveStop(),we))}catch(H){return Promise.reject(H)}else return Promise.resolve(Ee)}jb(de,ke){this.$(de.identifier,{startup:!1,extensionId:de.identifier,activationEvent:ke}).then(void 0,Ee=>{this.s.error(Ee)})}kb(de,ke=0){const ce=Date.now();(0,R.$v)(()=>{for(let _=ke;_<de.length;_+=1){const H=de[_];for(const te of H.activationEvents??[])if(te==="onStartupFinished")if(Date.now()-ce>50){this.kb(de,_);break}else this.jb(H,te)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(de=>{const ke=de.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Ee=this.J.getAllExtensionDescriptions();if(ke)this.kb(Ee);else for(const ce of Ee)if(ce.activationEvents)for(const _ of ce.activationEvents)_==="onStartupFinished"&&this.jb(ce,_)})}mb(){const de=this.Z("*",!0).then(void 0,H=>{this.s.error(H)});this.B(this.j.onDidChangeWorkspace(H=>this.nb(H.added)));const ke=this.j.workspace?this.j.workspace.folders:[],Ee=this.nb(ke),ce=this.pb(),_=Promise.all([ce,de,Ee]).then(()=>{});return Promise.race([_,(0,M.$3g)(1e4)]).then(()=>{this.lb()}),_}nb(de){return de.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ke=>this.ob(de,ke))).then(()=>{})}async ob(de,ke){if(this.isActivated(ke.identifier))return;const Ee=!this.f.remote.isRemote&&!!this.f.remote.authority,ce={logService:this.s,folders:de.map(H=>H.uri),forceUsingSearch:Ee||!this.c.fsExists,exists:H=>this.c.fsExists(H.fsPath),checkExists:(H,te,we)=>this.y.$checkExists(H,te,we)},_=await(0,k.$isb)(ce,ke);if(_)return this.$(ke.identifier,{startup:!0,extensionId:ke.identifier,activationEvent:_.activationEvent}).then(void 0,H=>this.s.error(H))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(de){throw console.error(de),de}}async qb(){const{extensionDevelopmentLocationURI:de,extensionTestsLocationURI:ke}=this.f.environment;if(!de||!ke)throw new Error($.localize(0,null));const Ee=await this.vb(null,ke,new p.$Rfc(!1));if(!Ee||typeof Ee.run!="function")throw new Error($.localize(1,null,ke.toString()));return new Promise((ce,_)=>{const H=(be,Fe)=>{be?(R.$n&&this.s.error("Test runner called back with error",be),_(be)):(R.$n&&(Fe?this.s.info(`Test runner called back with ${Fe} failures.`):this.s.info("Test runner called back with successful outcome.")),ce(typeof Fe=="number"&&Fe>0?1:0))},te=(0,T.$rg)(ke),we=Ee.run(te,H);we&&we.then&&we.then(()=>{R.$n&&this.s.info("Test runner finished successfully."),ce(0)}).catch(be=>{R.$n&&this.s.error("Test runner finished with error",be),_(be instanceof Error&&be.stack?be.stack:String(be))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$3g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(de,ke){return this.R[de]=ke,(0,m.$Qc)(()=>{delete this.R[de]})}async getRemoteExecServer(de){const{resolver:ke}=await this.sb(de);return ke?.resolveExecServer?.(de,{resolveAttempt:0})}async sb(de){const ke=de.indexOf("+");if(ke===-1)throw new t.$VK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Ee=de.substr(0,ke);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${Ee}`,!1),{authorityPrefix:Ee,resolver:this.R[Ee]}}async $resolveAuthority(de,ke){const Ee=V.$Od.create(!1),ce=()=>`[resolveAuthority(${(0,r.$7k)(de)},${ke})][${Ee.elapsed()}ms] `,_=X=>this.s.info(`${ce()}${X}`),H=X=>this.s.warn(`${ce()}${X}`),te=(X,De=void 0)=>this.s.error(`${ce()}${X}`,De),we=X=>{if(X instanceof t.$VK)return{type:"error",error:{code:X._code,message:X._message,detail:X._detail}};throw X},be=async X=>{_(`activating resolver for ${X}...`);const{resolver:De,authorityPrefix:Te}=await this.sb(X);if(!De)throw te(`no resolver for ${Te}`),new t.$VK(`No remote extension installed to resolve ${Te}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:De,authorityPrefix:Te,remoteAuthority:X}},Fe=de.split(/@|%40/g).reverse();_(`activating remote resolvers ${Fe.join(" -> ")}`);let pe;try{pe=await Promise.all(Fe.map(be)).catch(async X=>{if(!(X instanceof t.$VK)||X._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw X;return H(`resolving nested authorities failed: ${X.message}`),[await be(de)]})}catch(X){return we(X)}const Se=new M.$ah;Se.cancelAndSet(()=>_("waiting..."),1e3);let N,q;for(const[X,{authorityPrefix:De,resolver:Te,remoteAuthority:qe}]of pe.entries())try{if(X===pe.length-1)_("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${De}`),N=await Te.resolve(qe,{resolveAttempt:ke,execServer:q}),I.mark(`code/extHost/didResolveAuthorityOK/${De}`),_("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Te,t.$UK.isManagedResolvedAuthority(N)?N:void 0));else{if(_(`invoking resolveExecServer() for ${qe}`),I.mark(`code/extHost/willResolveExecServer/${De}`),q=await Te.resolveExecServer?.(qe,{resolveAttempt:ke,execServer:q}),!q)throw new t.$VK(`Exec server was not available for ${qe}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${De}`)}}catch(We){return I.mark(`code/extHost/didResolveAuthorityError/${De}`),te("returned an error",We),Se.dispose(),we(We)}Se.dispose();const G={environmentTunnels:N.environmentTunnels,features:N.tunnelFeatures},z={extensionHostEnv:N.extensionHostEnv,isTrusted:N.isTrusted,authenticationSession:N.authenticationSessionForInitializingExtensions?{id:N.authenticationSessionForInitializingExtensions.id,providerId:N.authenticationSessionForInitializingExtensions.providerId}:void 0};_(`returned ${t.$UK.isManagedResolvedAuthority(N)?"managed authority":`${N.host}:${N.port}`}`);let Z;if(t.$UK.isManagedResolvedAuthority(N)){const X=ke;this.X.setFactory(X,N.makeConnection),Z={authority:de,connectTo:new r.$4k(X),connectionToken:N.connectionToken}}else Z={authority:de,connectTo:new r.$5k(N.host,N.port),connectionToken:N.connectionToken};return{type:"ok",value:{authority:Z,options:z,tunnelInformation:G}}}async $getCanonicalURI(de,ke){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$7k)(de)})`);const{resolver:Ee}=await this.sb(de);if(!Ee)return null;const ce=b.URI.revive(ke);if(typeof Ee.getCanonicalURI>"u")return ce;const _=await(0,M.$Ug)(()=>Ee.getCanonicalURI(ce));return _||ce}$startExtensionHost(de){de.toAdd.forEach(ce=>ce.extensionLocation=b.URI.revive(ce.extensionLocation));const{globalRegistry:ke,myExtensions:Ee}=ue(this.I,this.L,this.J,de);return this.L.set(ke.getAllExtensionDescriptions()),this.J.set(Ee),R.$n&&(this.s.info(`$startExtensionHost: global extensions: ${ne(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ne(this.J)}`)),this.rb()}$activateByEvent(de,ke){return ke===1?this.D.wait().then(Ee=>this.Z(de,!1)):this.G.wait().then(Ee=>this.Z(de,!1))}async $activate(de,ke){return await this.G.wait(),this.J.getExtensionDescription(de)?(await this.$(de,ke),!0):!1}async $deltaExtensions(de){de.toAdd.forEach(H=>H.extensionLocation=b.URI.revive(H.extensionLocation));const{globalRegistry:ke,myExtensions:Ee}=ue(this.I,this.L,this.J,de),ce=await this.bb(Ee);return(await this.getExtensionPathIndex()).setSearchTree(ce),this.L.set(ke.getAllExtensionDescriptions()),this.J.set(Ee),R.$n&&(this.s.info(`$deltaExtensions: global extensions: ${ne(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ne(this.J)}`)),Promise.resolve(void 0)}async $test_latency(de){return de}async $test_up(de){return de.byteLength}async $test_down(de){const ke=u.$ge.alloc(de),Ee=Math.random()%256;for(let ce=0;ce<de;ce++)ke.writeUInt8(Ee,ce);return ke}async $updateRemoteConnectionData(de){this.W=de,this.a.fire()}};e.$agc=fe,e.$agc=fe=he=Je([Ge(0,c.$1h),Ge(1,e.$_fc),Ge(2,d.$RM),Ge(3,n.$zfc),Ge(4,l.$Cfc),Ge(5,A.$jj),Ge(6,f.$8M),Ge(7,w.$Ffc),Ge(8,L.$fyb),Ge(9,y.$1fc),Ge(10,J.$9fc),Ge(11,S.$0fc)],fe);function ue(ae,de,ke,Ee){ae.addActivationEvents(Ee.addActivationEvents);const ce=new i.$o7b(ae,de.getAllExtensionDescriptions());ce.deltaExtensions(Ee.toAdd,Ee.toRemove);const _=new a.$im(ke.getAllExtensionDescriptions().map(te=>te.identifier));for(const te of Ee.myToRemove)_.delete(te);for(const te of Ee.myToAdd)_.add(te);const H=le(ce,_);return{globalRegistry:ce,myExtensions:H}}function $e(ae,de){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:de.activationEvent,reasonId:de.extensionId.value}}function ne(ae){return ae.getAllExtensionDescriptions().map(de=>de.identifier.value).join(",")}e.$bgc=(0,c.$2h)("IExtHostExtensionService");class Pe{constructor(de,ke,Ee,ce,_){O.set(this,void 0),Q.set(this,void 0),re.set(this,void 0),xe(this,O,de,"f"),xe(this,Q,ke,"f"),xe(this,re,Ee.identifier,"f"),this.id=Ee.identifier.value,this.extensionUri=Ee.extensionLocation,this.extensionPath=P.$hc((0,T.$rg)(Ee.extensionLocation)),this.packageJSON=Ee,this.extensionKind=ce,this.isFromDifferentExtensionHost=_}get isActive(){return ze(this,O,"f").isActivated(ze(this,re,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return ze(this,O,"f").getExtensionExports(ze(this,re,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await ze(this,O,"f").activateByIdWithErrors(ze(this,re,"f"),{startup:!1,extensionId:ze(this,Q,"f"),activationEvent:"api"}),this.exports}}e.$cgc=Pe,O=new WeakMap,Q=new WeakMap,re=new WeakMap;function le(ae,de){return ae.getAllExtensionDescriptions().filter(ke=>de.has(ke.identifier))}class me{constructor(de){this.a=de}setSearchTree(de){this.a=de}findSubstr(de){return this.a.findSubstr(de)}forEach(de){return this.a.forEach(de)}}e.$dgc=me;class W{constructor(de){this.a=new a.$jm,this.addActivationEvents(de)}readActivationEvents(de){return this.a.get(de.identifier)??[]}addActivationEvents(de){for(const ke of Object.keys(de))this.a.set(ke,de[ke])}}}),define(Re[287],Ae([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;let n=class{constructor(u,h,t,r,c,f,w){this.c=u,this.d=h,this.f=t,this.g=r,this.h=c,this.i=f,this.j=w,this.a=new Map,this.b=[]}async install(){this.k(),$.mark("code/extHost/willWaitForConfig");const u=await this.g.getConfigProvider();$.mark("code/extHost/didWaitForConfig");const h=await this.h.getExtensionPathIndex();this.register(new i(this.c,h,this.d,u,this.j)),this.register(this.f.createInstance(o)),this.i.remote.isRemote&&this.register(this.f.createInstance(s,h,this.i.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(const h of u.nodeModuleName)this.a.set(h,u);else this.a.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this.b.push(h=>u.alternativeModuleName(h))}};e.$lhc=n,e.$lhc=n=Je([Ge(2,A.$1h),Ge(3,T.$Cfc),Ge(4,C.$bgc),Ge(5,b.$8M),Ge(6,l.$jj)],n);let o=v=class{constructor(u){if(u.environment.appRoot&&v.a.size){const h=(0,p.$Ke)(this.c(u.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(u){if(!this.b)return;const h=this.b.exec(this.c(u));if(!h)return;const[,t,r,c]=h,f=v.a.get(r);if(f!==void 0)return console.warn(`${r} as been renamed to ${f}, please update your imports`),t+f+c}c(u){return u.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=v=Je([Ge(0,b.$8M)],o);class i{constructor(u,h,t,r,c){this.c=u,this.d=h,this.e=t,this.f=r,this.g=c,this.nodeModuleName="vscode",this.a=new m.$jm}load(u,h){const t=this.d.findSubstr(h);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((c,f)=>r+=`	${f} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${r}`),this.b=this.c(M.$fF,this.e,this.f)}return this.b}}let s=class{constructor(u,h,t){this.e=u,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(I.$NK.MainThreadTelemetry);const r=t.getProxy(I.$NK.MainThreadWindow);this.c=(c,f)=>{const w=P.URI.parse(c);return f?this.g(c,f):w.scheme==="http"||w.scheme==="https"?r.$openUri(w,c,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?r.$openUri(w,c,{}):this.g(c,f)}}load(u,h,t){const r=this.e.findSubstr(h);return r&&(this.a=r.identifier.value,this.h()),this.b=t(u),this.c}g(u,h){return this.i(),this.b(u,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};s=Je([Ge(2,g.$RM)],s)}),define(Re[116],Ae([1,0,39,6,19,74,4,61,62,38,7,36,215,37]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0,e.$egc=(0,M.$2h)("IExtHostVariableResolverProvider");class v extends l.$SN{constructor(i,s,a,u,h,t,r){function c(){if(a){const f=a.activeEditor();if(f)return f.document.uri;const w=u.tabGroups.all.find(d=>d.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof A.$wM||w.input instanceof A.$BM)return w.input.modified;if(w.input instanceof A.$vM||w.input instanceof A.$AM||w.input instanceof A.$yM)return w.input.uri}}}super({getFolderUri:f=>{const w=t.folders.filter(d=>d.name===f);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(f,w)=>h.getConfiguration(void 0,f).get(w),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=c();if(f)return I.$hc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(s){const f=c();if(f){const w=s.getWorkspaceFolder(f);if(w)return I.$hc(w.uri.fsPath)}}},getSelectedText:()=>{if(a){const f=a.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(a){const f=a.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>i.getExtension(f)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(T.env))}}let n=class extends P.$Sc{constructor(i,s,a,u,h){super(),this.b=i,this.c=s,this.g=a,this.h=u,this.j=h,this.a=new $.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$fgc=n,e.$fgc=n=Je([Ge(0,b.$bgc),Ge(1,C.$zfc),Ge(2,m.$3M),Ge(3,p.$Cfc),Ge(4,g.$Ofc)],n)}),define(Re[117],Ae([1,0,14,5,2,4,3,62,38,17,7,36,207,209,37,116]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=e.$igc=e.$hgc=e.$ggc=void 0,e.$ggc=(0,T.$2h)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,c,f,w,d,D){this.E=c,this.F=f,this.G=w,this.H=d,this.I=D,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new P.$Sd,this.n=new P.$Sd,this.o=new P.$Sd,this.u=new P.$Sd,this.k=r.getProxy(M.$NK.MainThreadDebugService),this.y=new P.$Sd,this.A=new P.$Sd,this.v=new s(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(y=>{this.J(L)}),this.J(L)})}asDebugSourceUri(r,c){const f=r;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let w=`debug:${encodeURIComponent(f.path||"")}`,d="?";return c&&(w+=`${d}session=${encodeURIComponent(c.id)}`,d="&"),w+=`${d}ref=${f.sourceReference}`,I.URI.parse(w)}else{if(f.path)return I.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const c=[];for(const f of r.getAllExtensionDescriptions())if(f.contributes){const w=f.contributes.debuggers;if(w&&w.length>0)for(const d of w)(0,p.$WF)(d)&&c.push(d.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(c=>r.push(c)),r}addBreakpoints(r){const c=r.filter(d=>{const D=d.id;return this.w.has(D)?!1:(this.w.set(D,d),!0)});this.U(c,[],[]);const f=[],w=new Map;for(const d of c)if(d instanceof A.$PL){let D=w.get(d.location.uri.toString());D||(D={type:"sourceMulti",uri:d.location.uri,lines:[]},w.set(d.location.uri.toString(),D),f.push(D)),D.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof A.$QL&&f.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(f)}removeBreakpoints(r){const c=r.filter(D=>this.w.delete(D.id));this.U([],c,[]);const f=c.filter(D=>D instanceof A.$PL).map(D=>D.id),w=c.filter(D=>D instanceof A.$QL).map(D=>D.id),d=c.filter(D=>D instanceof A.$RL).map(D=>D.id);return this.k.$unregisterBreakpoints(f,w,d)}startDebugging(r,c,f){return this.k.$startDebugging(r?r.uri:void 0,c,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,c,f){if(!c)return new A.$PK(()=>{});const w=this.d++;return this.f.push({type:r,handle:w,provider:c}),this.k.$registerDebugConfigurationProvider(r,f,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,w),new A.$PK(()=>{this.f=this.f.filter(d=>d.provider!==c),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(r,c,f){if(!f)return new A.$PK(()=>{});if(!this.Q(r,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:c,handle:w,factory:f}),this.k.$registerDebugAdapterDescriptorFactory(c,w),new A.$PK(()=>{this.h=this.h.filter(d=>d.factory!==f),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(r,c){if(!c)return new A.$PK(()=>{});const f=this.i++;return this.j.push({type:r,handle:f,factory:c}),new A.$PK(()=>{this.j=this.j.filter(w=>w.factory!==c)})}async $runInTerminal(r,c){return Promise.resolve(void 0)}async $substituteVariables(r,c){let f;const w=await this.W(r);return w&&(f={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(f,c)}K(r,c){if(r.type==="implementation")return new u(r.implementation)}L(){}async $startDASession(r,c){const f=this,w=await this.V(c);return this.S(this.N(w.type),w).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const D=this.M(d),L=this.K(D,w);if(!L)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const y=L;return this.B.set(r,y),this.R(w).then(E=>(E&&this.C.set(r,E),y.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const F=k,B={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const ee=await this.D.sign(F.arguments.value);B.body={signature:ee},y.sendResponse(B)}else throw new Error("no signer")}catch(ee){B.success=!1,B.message=ee.message,y.sendResponse(B)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(k),k=(0,p.$2F)(k,!0),f.k.$acceptDAMessage(r,k)}),y.onError(k=>{E&&E.onError&&E.onError(k),this.k.$acceptDAError(r,k.name,k.message,k.stack)}),y.onExit(k=>{E&&E.onExit&&E.onExit(k??void 0,void 0),this.k.$acceptDAExit(r,k??void 0,void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),y.startSession()))})}$sendDAMessage(r,c){c=(0,p.$1F)(c,!1);const f=this.C.get(r);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(c),this.B.get(r)?.sendMessage(c)}$stopDASession(r){const c=this.C.get(r);this.C.delete(r),c&&c.onWillStopSession&&c.onWillStopSession();const f=this.B.get(r);return this.B.delete(r),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const c=[],f=[],w=[];if(r.added)for(const d of r.added){const D=d.id;if(D&&!this.w.has(D)){let L;if(d.type==="function")L=new A.$QL(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")L=new A.$RL(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const y=I.URI.revive(d.uri);L=new A.$PL(new A.$2K(y,new A.$QK(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,A.$NL)(L,D),this.w.set(D,L),c.push(L)}}if(r.removed)for(const d of r.removed){const D=this.w.get(d);D&&(this.w.delete(d),f.push(D))}if(r.changed){for(const d of r.changed)if(d.id){const D=this.w.get(d.id);if(D){if(D instanceof A.$QL&&d.type==="function"){const L=D;L.enabled=d.enabled,L.condition=d.condition,L.hitCondition=d.hitCondition,L.logMessage=d.logMessage,L.functionName=d.functionName}else if(D instanceof A.$PL&&d.type==="source"){const L=D;L.enabled=d.enabled,L.condition=d.condition,L.hitCondition=d.hitCondition,L.logMessage=d.logMessage,L.location=new A.$2K(I.URI.revive(d.uri),new A.$QK(d.line,d.character))}w.push(D)}}}this.U(c,f,w)}async $acceptStackFrameFocus(r){let c;const f=r.sessionId?await this.V(r.sessionId):void 0;if(!f)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?c=new A.$XL(f,r.threadId):c=new A.$WL(f,r.threadId,r.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(r,c,f){return(0,$.$Ug)(async()=>{const w=this.P(r);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(c);return w.provideDebugConfigurations(d,f)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(r,c,f,w){return(0,$.$Ug)(async()=>{const d=this.P(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.W(c);return d.resolveDebugConfiguration(D,f,w)})}$resolveDebugConfigurationWithSubstitutedVariables(r,c,f,w){return(0,$.$Ug)(async()=>{const d=this.P(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.W(c);return d.resolveDebugConfigurationWithSubstitutedVariables(D,f,w)})}async $provideDebugAdapter(r,c){const f=this.O(r);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(c);return this.S(f,w).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(r){const c=await this.V(r);this.m.fire(c)}async $acceptDebugSessionTerminated(r){const c=await this.V(r);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,c){(await this.V(r))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(r,c){const w={session:await this.V(r),event:c.event,body:c.body};this.u.fire(w)}M(r){if(r instanceof A.$SL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$TL)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$UL)return{type:"pipeServer",path:r.path};if(r instanceof A.$VL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const c=this.h.filter(f=>f.type===r);if(c.length>0)return c[0].factory}O(r){const c=this.h.filter(f=>f.handle===r);if(c.length>0)return c[0].factory}P(r){const c=this.f.filter(f=>f.handle===r);if(c.length>0)return c[0].provider}Q(r,c){if(r.contributes){const f=r.contributes.debuggers;if(f&&f.length>0){for(const w of f)if(w.label&&w.type&&w.type===c)return!0}}return!1}R(r){const f=r.configuration.type,w=this.j.filter(d=>d.type===f||d.type==="*").map(d=>(0,$.$Ug)(()=>d.factory.createDebugAdapterTracker(r)).then(D=>D,D=>null));return Promise.race([Promise.all(w).then(d=>{const D=d.filter(L=>!!L);if(D.length>0)return new a(D)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(r,c){const f=c.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new A.$TL(f));if(r){const d=await this.F.getExtensionRegistry();return(0,$.$Ug)(()=>r.createDebugAdapterDescriptor(c,this.T(c,d))).then(D=>{if(D)return D})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,w))}T(r,c){}U(r,c,f){(r.length>0||c.length>0||f.length>0)&&this.y.fire(Object.freeze({added:r,removed:c,changed:f}))}async V(r){if(r)if(typeof r=="string"){const c=this.l.get(r);if(c)return c}else{let c=this.l.get(r.id);if(!c){const f=await this.W(r.folderUri),w=r.parent?this.l.get(r.parent):void 0;c=new i(this.k,r.id,r.type,r.name,f,r.configuration,w),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(r){if(r){const c=I.URI.revive(r);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$hgc=o,e.$hgc=o=Je([Ge(0,b.$RM),Ge(1,C.$zfc),Ge(2,g.$bgc),Ge(3,v.$Cfc),Ge(4,m.$Ofc),Ge(5,n.$egc)],o);class i{constructor(r,c,f,w,d,D,L){this.d=r,this.f=c,this.g=f,this.h=w,this.i=d,this.j=D,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,c){return this.d.$customDebugAdapterRequest(this.f,r,c)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$igc=i;class s{constructor(r){this.value=Object.freeze({append(c){r.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$jgc=s;class a{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(c=>c.onError?c.onError(r):void 0)}onExit(r,c){this.d.forEach(f=>f.onExit?f.onExit(r,c):void 0)}}class u extends l.$zlb{constructor(r){super(),this.h=r,r.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends o{constructor(r,c,f,w,d,D){super(r,c,f,w,d,D)}};e.$kgc=h,e.$kgc=h=Je([Ge(0,b.$RM),Ge(1,C.$zfc),Ge(2,g.$bgc),Ge(3,v.$Cfc),Ge(4,m.$Ofc),Ge(5,n.$egc)],h)}),define(Re[288],Ae([1,0,11,88,2,3,276,15,70,71,27,185,17,57,38,59]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=void 0;class o{static async installEarlyHandler(a){Error.stackTraceLimit=100;const u=a.get(m.$jj),t=a.get(l.$RM).getProxy(T.$NK.MainThreadErrors);$.setUnexpectedErrorHandler(r=>{u.error(r);const c=$.$3(r);t.$onUnexpectedError(c)})}static async installFullHandler(a){const u=a.get(m.$jj),h=a.get(l.$RM),t=a.get(v.$bgc),r=a.get(n.$_M),c=h.getProxy(T.$NK.MainThreadExtensionService),f=h.getProxy(T.$NK.MainThreadErrors),w=await t.getExtensionPathIndex(),d=new WeakMap;function D(E,k){if(d.has(E))return d.get(E).stack;let F="",B,ee;for(const V of k)F+=`
	at ${V.toString()}`,ee=V.getFileName(),!B&&ee&&(B=w.findSubstr(I.URI.file(ee)));const J=`${E.name||"Error"}: ${E.message||""}${F}`;return d.set(E,{extensionIdentifier:B?.identifier,stack:J}),J}const L=Symbol("prepareStackTrace wrapped");let y=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return y},set(E){if(E===D||!E||E[L]){y=E||D;return}y=function(k,F){return D(k,F),E.call(Error,k,F)},Object.assign(y,{[L]:!0})}}),$.setUnexpectedErrorHandler(E=>{u.error(E);const k=$.$3(E),F=d.get(E);if(!F?.extensionIdentifier){f.$onUnexpectedError(k);return}c.$onExtensionRuntimeError(F.extensionIdentifier,k);const B=r.onExtensionError(F.extensionIdentifier,E);u.trace("forwarded error to extension?",B,F)})}}e.$mhc=o;class i{constructor(a,u,h,t,r){this.a=h,this.b=new M.$w7b(a,null,t),u=i.e(u,this.b);const c=new b.$Zh(...(0,g.$Lr)());c.set(A.$8M,{_serviceBrand:void 0,...u,messagePorts:r}),c.set(l.$RM,new l.$SM(this.b)),c.set(p.$wfc,new p.$xfc(t)),c.set(v.$_fc,h);const f=new C.$rq(c,!0);f.invokeFunction(o.installEarlyHandler),this.d=f.invokeFunction(w=>w.get(m.$jj)),P.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",u),this.c=f.invokeFunction(w=>w.get(v.$bgc)),this.c.initialize(),f.invokeFunction(o.installFullHandler)}async asBrowserUri(a){const u=this.b.getProxy(T.$NK.MainThreadExtensionService);return I.URI.revive(await u.$asBrowserUri(a))}terminate(a){this.c.terminate(a)}static e(a,u){a.extensions.allExtensions.forEach(t=>{t.extensionLocation=I.URI.revive(u.transformIncomingURIs(t.extensionLocation))}),a.environment.appRoot=I.URI.revive(u.transformIncomingURIs(a.environment.appRoot));const h=a.environment.extensionDevelopmentLocationURI;return h&&(a.environment.extensionDevelopmentLocationURI=h.map(t=>I.URI.revive(u.transformIncomingURIs(t)))),a.environment.extensionTestsLocationURI=I.URI.revive(u.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=I.URI.revive(u.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=I.URI.revive(u.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=I.URI.revive(u.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=I.URI.revive(u.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=I.URI.revive(u.transformIncomingURIs(a.logsLocation)),a.workspace=u.transformIncomingURIs(a.workspace),a}}e.$nhc=i}),define(Re[289],Ae([1,0,18,14,20,40,13,19,25,2,44]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=e.$Agc=e.$zgc=e.$ygc=void 0;class C{constructor(s,a,u,h){this.d=s,this.e=a,this.f=u,this.g=h,this.a=null,this.b=!1,this.c=0}search(s,a){const u=this.d.folderQueries||[],h=new I.$3d(a);return new Promise((t,r)=>{this.a=new p(s);let c=!1;const f=(w,d)=>{if(!c&&!this.b){const D=this.h(w);n(w)&&typeof this.d.maxResults=="number"&&this.c+D>this.d.maxResults&&(this.b=!0,c=!0,h.cancel(),w=this.j(w,this.d.maxResults-this.c));const L=this.h(w);this.c+=L,(L>0||!n(w))&&this.a.add(w,d)}};Promise.all(u.map((w,d)=>this.k(w,D=>f(D,d),h.token))).then(w=>{h.dispose(),this.a.flush();const d=w.some(D=>!!D&&!!D.limitHit);t({limitHit:this.b||d,messages:(0,$.$Rb)(w.map(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[])),stats:{type:this.g}})},w=>{h.dispose();const d=(0,T.$Mi)(w);r(new Error(d))})})}h(s){return n(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}j(s,a){const u=Array.isArray(s.ranges)?s.ranges:[s.ranges],h=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:u.slice(0,a),preview:{matches:h.slice(0,a),text:s.preview.text},uri:s.uri}}async k(s,a,u){const h=new A.$rJ(this.d,s),t=[],r={report:w=>{if(!this.l(w))return;const d=s.folder.scheme===M.Schemas.file?(0,A.$sJ)(()=>this.f.readdir(g.$Cg(w.uri))):void 0,D=g.$Fg(s.folder,w.uri);if(D){const L=h.includedInQuery(D,m.$nc(D),d);(0,P.$Og)(L)?t.push(L.then(y=>{y&&a(w)})):L&&a(w)}}},c=this.n(s),f=await this.e.provideTextSearchResults(l(this.d.contentPattern),c,r,u);return t.length&&await Promise.all(t),f}l(s){if(n(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(s){const a=(0,A.$qJ)(this.d.includePattern,s.includePattern),u=(0,A.$qJ)(this.d.excludePattern,s.excludePattern),h={folder:b.URI.from(s.folder),excludes:u,includes:a,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.f.toCanonicalName(s.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$ygc=C;function l(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class p{constructor(s){this.e=s,this.b=-1,this.d=null,this.a=new o(512,a=>this.g(a))}add(s,a){this.d&&(this.b!==a||!g.$wg(this.c,s.uri))&&(this.f(),this.d=null),this.d||(this.b=a,this.d={resource:s.uri,results:[]}),this.d.results.push(v(s))}f(){const s=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,s)}flush(){this.f(),this.a.flush()}g(s){this.e(s)}}e.$zgc=p;function v(i){return n(i)?{preview:{matches:(0,$.$2b)(i.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:i.preview.text},ranges:(0,$.$2b)(i.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function n(i){return!!i.preview}e.$Agc=n;class o{constructor(s,a){this.g=s,this.h=a,this.c=0,this.d=[],this.e=0}addItem(s,a){s&&this.j(s,a)}addItems(s,a){s&&this.k(s,a)}j(s,a){this.d.push(s),this.e+=a,this.l()}k(s,a){this.d=this.d.concat(s),this.e+=a,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Bgc=o,o.a=4e3,o.b=50}),define(Re[118],Ae([1,0,6,3,4,284,17,57,15,2,289]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=e.$Cgc=void 0,e.$Cgc=(0,I.$2h)("IExtHostSearch");let C=class{constructor(n,o,i){this.k=n,this.l=o,this.n=i,this.c=this.k.getProxy(P.$NK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new T.$xgc}o(n){return this.l.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const i=this.d++;return this.e.set(i,o),this.c.$registerTextSearchProvider(i,this.o(n)),(0,$.$Qc)(()=>{this.g.delete(n),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(n,o){if(this.i.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.i.add(n);const i=this.d++;return this.h.set(i,o),this.c.$registerFileSearchProvider(i,this.o(n)),(0,$.$Qc)(()=>{this.i.delete(n),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(n,o,i,s){const a=l(i),u=this.h.get(n);if(u)return this.j.fileSearch(a,u,h=>{this.c.$handleFileMatch(n,o,h.map(t=>t.resource))},s);throw new Error("unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,i){return{messages:[]}}$clearCache(n){return this.j.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,i,s){const a=this.e.get(n);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const u=l(i);return this.q(u,a).search(t=>this.c.$handleTextMatch(n,o,t),s)}$enableExtensionHostSearch(){}q(n,o){return new A.$ygc(n,o,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$Dgc=C,e.$Dgc=C=Je([Ge(0,M.$RM),Ge(1,m.$wfc),Ge(2,g.$jj)],C);function l(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(p),extraFileResources:v.extraFileResources&&v.extraFileResources.map(n=>b.URI.revive(n))}}e.$Egc=l;function p(v){return{...v,folder:b.URI.revive(v.folder)}}}),define(Re[290],Ae([1,0,20,11,5,6,13,31,2,146,134,135,94,22,42,15,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,37,272,117,110,242,243,244,220,245,61,62,247,38,248,63,249,43,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,36,208,79,23,114]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u,h,t,r,c,f,w,d,D,L,y,E,k,F,B,ee,J,V,R,S,O,Q,re,he,fe,ue,$e,ne,Pe,le,me,W,ae,de,ke,Ee,ce,_,H,te,we,be,Fe,pe,Se,N,q,G,z,Z,X,De,Te,qe,We,Ye,ot,rt,it,ct,ut,Ue,vt,Y,x,ye,Ve,Ze,nt,st,Ne,Pt,Mt,Kt,Ht,yt,Gt,Ut,ni,Jt,Ft,_e,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;function Zt(ht){const mt=ht.get(me.$8M),Tt=ht.get(le.$efc),Nt=ht.get(ne.$Efc),Et=ht.get(ue.$bgc),dt=ht.get(ni.$zfc),Rt=ht.get(Ue.$_M),xt=ht.get(F.$Cfc),It=ht.get(Mt.$wfc),He=ht.get(De.$RM),Wt=ht.get(it.$Xfc),Yt=ht.get(ct.$Ffc),Xt=ht.get(n.$kj),pt=ht.get(n.$jj),Ot=ht.get(nt.$fyb),Ce=ht.get(t.$hfc),Le=ht.get(Ut.$ghc),ve=ht.get(We.$6fc),K=ht.get(he.$Ofc),Me=ht.get(H.$0fc);He.set(a.$OK.ExtHostFileSystemInfo,Tt),He.set(a.$OK.ExtHostLogLevelServiceShape,Xt),He.set(a.$OK.ExtHostWorkspace,dt),He.set(a.$OK.ExtHostConfiguration,xt),He.set(a.$OK.ExtHostExtensionService,Et),He.set(a.$OK.ExtHostStorage,Wt),He.set(a.$OK.ExtHostTunnelService,Ot),He.set(a.$OK.ExtHostWindow,Le),He.set(a.$OK.ExtHostSecretState,ve),He.set(a.$OK.ExtHostTelemetry,Rt),He.set(a.$OK.ExtHostEditorTabs,K),He.set(a.$OK.ExtHostManagedSockets,Me);const Be=He.set(a.$OK.ExtHostDecorations,ht.get(J.$mgc)),Xe=He.set(a.$OK.ExtHostDocumentsAndEditors,ht.get(re.$3M)),Ke=He.set(a.$OK.ExtHostCommands,ht.get(E.$bN)),tt=He.set(a.$OK.ExtHostTerminalService,ht.get(vt.$1fc)),$t=He.set(a.$OK.ExtHostDebugService,ht.get(ee.$ggc)),Vt=He.set(a.$OK.ExtHostSearch,ht.get(qe.$Cgc)),Dt=He.set(a.$OK.ExtHostTask,ht.get(ut.$6gc)),kt=He.set(a.$OK.ExtHostOutputService,ht.get(q.$Sgc)),Ct=He.set(a.$OK.ExtHostLocalization,ht.get(_.$9fc)),hi=He.set(a.$OK.ExtHostUrls,new Kt.$dhc(He)),At=He.set(a.$OK.ExtHostDocuments,new Q.$cfc(He,Xe)),an=He.set(a.$OK.ExtHostDocumentContentProviders,new S.$ogc(He,Xe,pt)),cn=He.set(a.$OK.ExtHostDocumentSaveParticipant,new O.$pgc(pt,At,He.getProxy(a.$NK.MainThreadBulkEdits))),St=He.set(a.$OK.ExtHostNotebook,new we.$Fgc(He,Ke,Xe,At,Nt,Vt)),$i=He.set(a.$OK.ExtHostNotebookDocuments,new Fe.$Mgc(St)),pi=He.set(a.$OK.ExtHostNotebookEditors,new pe.$Ngc(pt,St)),Qt=He.set(a.$OK.ExtHostNotebookKernels,new Se.$Ogc(He,mt,St,Ke,pt)),Ii=He.set(a.$OK.ExtHostNotebookRenderers,new N.$Qgc(He,St)),Vi=He.set(a.$OK.ExtHostNotebookDocumentSaveParticipant,new be.$Lgc(pt,St,He.getProxy(a.$NK.MainThreadBulkEdits))),jt=He.set(a.$OK.ExtHostEditors,new x.$tfc(He,Xe)),Ci=He.set(a.$OK.ExtHostTreeViews,new Ze.$bhc(He.getProxy(a.$NK.MainThreadTreeViews),Ke,pt)),un=He.set(a.$OK.ExtHostEditorInsets,new y.$ufc(He.getProxy(a.$NK.MainThreadEditorInsets),jt,mt.remote)),ei=He.set(a.$OK.ExtHostDiagnostics,new V.$gfc(He,pt,Tt,Xe)),ci=He.set(a.$OK.ExtHostLanguages,new ce.$Jgc(He,At,Ke.converter,It)),ft=He.set(a.$OK.ExtHostLanguageFeatures,new Ee.$kfc(He,It,At,Ke,ei,pt,Ce,Rt)),Pi=He.set(a.$OK.ExtHostFileSystem,new $e.$rgc(He,ft)),ti=He.set(a.$OK.ExtHostFileSystemEventService,new Pe.$sgc(He,pt,Xe)),si=He.set(a.$OK.ExtHostQuickOpen,(0,X.$Wgc)(He,dt,Ke)),di=He.set(a.$OK.ExtHostSCM,new Te.$Ygc(He,Ke,At,pt)),Ri=He.set(a.$OK.ExtHostQuickDiff,new Z.$Vgc(He,It)),Ai=He.set(a.$OK.ExtHostShare,new Ye.$Zgc(He,It)),Li=He.set(a.$OK.ExtHostComments,(0,k.$vfc)(He,Ke,At)),vi=He.set(a.$OK.ExtHostProgress,new z.$Ugc(He.getProxy(a.$NK.MainThreadProgress))),qi=He.set(a.$OK.ExtHosLabelService,new ke.$Igc(He)),wi=He.set(a.$OK.ExtHostTheming,new ye.$$gc(He)),oi=He.set(a.$OK.ExtHostAuthentication,new r.$mfc(He)),Mi=He.set(a.$OK.ExtHostTimeline,new Ve.$ahc(He,Ke)),fi=He.set(a.$OK.ExtHostWebviews,new Ht.$Jfc(He,mt.remote,dt,pt,Ce)),bi=He.set(a.$OK.ExtHostWebviewPanels,new yt.$Mfc(He,fi,dt)),Fi=He.set(a.$OK.ExtHostCustomEditors,new B.$Nfc(He,At,Yt,fi,bi)),Ti=He.set(a.$OK.ExtHostWebviewViews,new Gt.$ehc(He,fi)),ui=He.set(a.$OK.ExtHostTesting,new Y.$7gc(He,Ke,Xe)),Ki=He.set(a.$OK.ExtHostUriOpeners,new Pt.$chc(He)),Hi=He.set(a.$OK.ExtHostProfileContentHandlers,new G.$Tgc(He));He.set(a.$OK.ExtHostInteractive,new ae.$Ggc(He,St,Xe,Ke,pt));const Gi=He.set(a.$OK.ExtHostInlineChat,new W.$tgc(He,Ke,At,pt)),yi=He.set(a.$OK.ExtHostChatProvider,new d.$pfc(He,pt)),ln=He.set(a.$OK.ExtHostChatAgents2,new w.$qfc(He,yi,pt)),hn=He.set(a.$OK.ExtHostChatVariables,new D.$rfc(He)),li=He.set(a.$OK.ExtHostChat,new f.$ofc(He)),Ei=He.set(a.$OK.ExtHostAiRelatedInformation,new u.$bfc(He)),dn=He.set(a.$OK.ExtHostAiEmbeddingVector,new fe.$qgc(He)),Ji=He.set(a.$OK.ExtHostIssueReporter,new de.$Hgc(He)),Ni=He.set(a.$OK.ExtHostStatusBar,new rt.$3gc(He,Ke.converter)),Di=He.set(a.$OK.ExtHostSpeech,new ot.$1gc(He)),Qi=Object.values(a.$OK);He.assertRegistered(Qi);const Zi=new c.$nfc(He,Xe),Xi=new L.$sfc(He),Oi=new te.$Kgc(He,pt),ki=new R.$ngc(He);return h.$lfc.register(Ke),function(je,zt,gi){const wt=function(){let se=!je.isUnderDevelopment;function ge(){se||(pt.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Oe(at){if(Array.isArray(at))at.forEach(Oe);else if(typeof at=="string")ge();else{const bt=at;typeof bt.scheme>"u"&&ge(),typeof bt.exclusive=="boolean"&&(0,_e.$lF)(je,"documentFiltersExclusive")}return at}}(),Yi={getSession(se,ge,Oe){return oi.getSession(je,se,ge,Oe)},getSessions(se,ge){return(0,_e.$lF)(je,"authGetSessions"),oi.getSessions(je,se,ge)},async hasSession(se,ge){return(0,_e.$lF)(je,"authSession"),!!await oi.getSession(je,se,ge,{silent:!0})},get onDidChangeSessions(){return oi.onDidChangeSessions},registerAuthenticationProvider(se,ge,Oe,at){return oi.registerAuthenticationProvider(se,ge,Oe,at)}},Si={registerCommand(se,ge,Oe){return Ke.registerCommand(!0,se,ge,Oe,void 0,je)},registerTextEditorCommand(se,ge,Oe){return Ke.registerCommand(!0,se,(...at)=>{const bt=jt.getActiveTextEditor();if(!bt){pt.warn("Cannot execute "+se+" because there is no active text editor.");return}return bt.edit(Lt=>{ge.apply(Oe,[bt,Lt,...at])}).then(Lt=>{Lt||pt.warn("Edits from command "+se+" were not applied.")},Lt=>{pt.warn("An error occurred while running command "+se,Lt)})},void 0,void 0,je)},registerDiffInformationCommand:(se,ge,Oe)=>((0,_e.$lF)(je,"diffCommand"),Ke.registerCommand(!0,se,async(...at)=>{const bt=Xe.activeEditor(!0);if(!bt){pt.warn("Cannot execute "+se+" because there is no active text editor.");return}const Lt=await jt.getDiffInformation(bt.id);ge.apply(Oe,[Lt,...at])},void 0,void 0,je)),executeCommand(se,...ge){return Ke.executeCommand(se,...ge)},getCommands(se=!1){return Ke.getCommands(se)}},ji={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Xi.value},get shell(){return tt.getDefaultShell(!1)},get onDidChangeShell(){return tt.onDidChangeShell},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Rt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,_e.$lF)(je,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$lF)(je,"telemetry"),Rt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ue.$$M)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(se,ge){return Ue.$0M.validateSender(se),Rt.instantiateLogger(je,se,ge)},openExternal(se,ge){return Le.openUri(se,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===mt.environment.appUriScheme)return hi.createAppUri(se);try{return await Le.asExternalUri(se,{allowTunneling:!!mt.remote.authority})}catch(ge){if((0,M.$ag)(se,M.Schemas.http)||(0,M.$ag)(se,M.Schemas.https))return se;throw ge}},get remoteName(){return(0,o.$9k)(mt.remote.authority)},get remoteAuthority(){return(0,_e.$lF)(je,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return pt.onDidChangeLogLevel},registerIssueUriRequestHandler(se){return(0,_e.$lF)(je,"handleIssueUri"),Ji.registerIssueUriRequestHandler(je,se)},registerIssueDataProvider(se){return(0,_e.$lF)(je,"handleIssueUri"),Ji.registerIssueDataProvider(je,se)},get appQuality(){return(0,_e.$lF)(je,"resolvers"),mt.quality},get appCommit(){return(0,_e.$lF)(je,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(ji);const _i={createTestController(se,ge,Oe){return ui.createTestController(je,se,ge,Oe)},createTestObserver(){return(0,_e.$lF)(je,"testObserver"),ui.createTestObserver()},runTests(se){return(0,_e.$lF)(je,"testObserver"),ui.runTests(se)},get onDidChangeTestResults(){return(0,_e.$lF)(je,"testObserver"),ui.onResultsChanged},get testResults(){return(0,_e.$lF)(je,"testObserver"),ui.results}},mi=mt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,xi={getExtension(se,ge){(0,_e.$kF)(je,"extensionsAny")||(ge=!1);const Oe=zt.mine.getExtensionDescription(se);if(Oe)return new ue.$cgc(Et,je.identifier,Oe,mi,!1);if(ge){const at=zt.all.getExtensionDescription(se);if(at)return new ue.$cgc(Et,je.identifier,at,mi,!0)}},get all(){const se=[];for(const ge of zt.mine.getAllExtensionDescriptions())se.push(new ue.$cgc(Et,je.identifier,ge,mi,!1));return se},get allAcrossExtensionHosts(){(0,_e.$lF)(je,"extensionsAny");const se=new p.$im(zt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ge=[];for(const Oe of zt.all.getAllExtensionDescriptions()){const at=!se.has(Oe.identifier);ge.push(new ue.$cgc(Et,je.identifier,Oe,mi,at))}return ge},get onDidChange(){return(0,_e.$kF)(je,"extensionsAny")?I.Event.any(zt.mine.onDidChange,zt.all.onDidChange):zt.mine.onDidChange}},fn={createDiagnosticCollection(se){return ei.createDiagnosticCollection(je.identifier,se)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:se=>ei.getDiagnostics(se),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(se,ge){return ci.changeLanguage(se.uri,ge)},match(se,ge){const Oe=At.getDocumentData(ge.uri)?.notebook;return(0,A.$ot)(st.LanguageSelector.from(se),ge.uri,ge.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(se,ge,Oe){return ft.registerCodeActionProvider(je,wt(se),ge,Oe)},registerDocumentPasteEditProvider(se,ge,Oe){return(0,_e.$lF)(je,"documentPaste"),ft.registerDocumentPasteEditProvider(je,wt(se),ge,Oe)},registerCodeLensProvider(se,ge){return ft.registerCodeLensProvider(je,wt(se),ge)},registerDefinitionProvider(se,ge){return ft.registerDefinitionProvider(je,wt(se),ge)},registerDeclarationProvider(se,ge){return ft.registerDeclarationProvider(je,wt(se),ge)},registerImplementationProvider(se,ge){return ft.registerImplementationProvider(je,wt(se),ge)},registerTypeDefinitionProvider(se,ge){return ft.registerTypeDefinitionProvider(je,wt(se),ge)},registerHoverProvider(se,ge){return ft.registerHoverProvider(je,wt(se),ge,je.identifier)},registerEvaluatableExpressionProvider(se,ge){return ft.registerEvaluatableExpressionProvider(je,wt(se),ge,je.identifier)},registerInlineValuesProvider(se,ge){return ft.registerInlineValuesProvider(je,wt(se),ge,je.identifier)},registerDocumentHighlightProvider(se,ge){return ft.registerDocumentHighlightProvider(je,wt(se),ge)},registerMultiDocumentHighlightProvider(se,ge){return ft.registerMultiDocumentHighlightProvider(je,wt(se),ge)},registerLinkedEditingRangeProvider(se,ge){return ft.registerLinkedEditingRangeProvider(je,wt(se),ge)},registerReferenceProvider(se,ge){return ft.registerReferenceProvider(je,wt(se),ge)},registerRenameProvider(se,ge){return ft.registerRenameProvider(je,wt(se),ge)},registerDocumentSymbolProvider(se,ge,Oe){return ft.registerDocumentSymbolProvider(je,wt(se),ge,Oe)},registerWorkspaceSymbolProvider(se){return ft.registerWorkspaceSymbolProvider(je,se)},registerDocumentFormattingEditProvider(se,ge){return ft.registerDocumentFormattingEditProvider(je,wt(se),ge)},registerDocumentRangeFormattingEditProvider(se,ge){return ft.registerDocumentRangeFormattingEditProvider(je,wt(se),ge)},registerOnTypeFormattingEditProvider(se,ge,Oe,...at){return ft.registerOnTypeFormattingEditProvider(je,wt(se),ge,[Oe].concat(at))},registerDocumentSemanticTokensProvider(se,ge,Oe){return ft.registerDocumentSemanticTokensProvider(je,wt(se),ge,Oe)},registerDocumentRangeSemanticTokensProvider(se,ge,Oe){return ft.registerDocumentRangeSemanticTokensProvider(je,wt(se),ge,Oe)},registerSignatureHelpProvider(se,ge,Oe,...at){return typeof Oe=="object"?ft.registerSignatureHelpProvider(je,wt(se),ge,Oe):ft.registerSignatureHelpProvider(je,wt(se),ge,typeof Oe>"u"?[]:[Oe,...at])},registerCompletionItemProvider(se,ge,...Oe){return ft.registerCompletionItemProvider(je,wt(se),ge,Oe)},registerInlineCompletionItemProvider(se,ge,Oe){return ge.handleDidShowCompletionItem&&(0,_e.$lF)(je,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,_e.$lF)(je,"inlineCompletionsAdditions"),Oe&&(0,_e.$lF)(je,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider(je,wt(se),ge,Oe)},registerDocumentLinkProvider(se,ge){return ft.registerDocumentLinkProvider(je,wt(se),ge)},registerColorProvider(se,ge){return ft.registerColorProvider(je,wt(se),ge)},registerFoldingRangeProvider(se,ge){return ft.registerFoldingRangeProvider(je,wt(se),ge)},registerSelectionRangeProvider(se,ge){return ft.registerSelectionRangeProvider(je,se,ge)},registerCallHierarchyProvider(se,ge){return ft.registerCallHierarchyProvider(je,se,ge)},registerTypeHierarchyProvider(se,ge){return ft.registerTypeHierarchyProvider(je,se,ge)},setLanguageConfiguration:(se,ge)=>ft.setLanguageConfiguration(je,se,ge),getTokenInformationAtPosition(se,ge){return(0,_e.$lF)(je,"tokenInformation"),ci.tokenAtPosition(se,ge)},registerInlayHintsProvider(se,ge){return ft.registerInlayHintsProvider(je,se,ge)},createLanguageStatusItem(se,ge){return ci.createLanguageStatusItem(je,se,ge)},registerDocumentDropEditProvider(se,ge,Oe){return ft.registerDocumentOnDropEditProvider(je,se,ge,(0,_e.$kF)(je,"dropMetadata")?Oe:void 0)}},en={get activeTextEditor(){return jt.getActiveTextEditor()},get visibleTextEditors(){return jt.getVisibleTextEditors()},get activeTerminal(){return tt.activeTerminal},get terminals(){return tt.terminals},async showTextDocument(se,ge,Oe){const at=await(g.URI.isUri(se)?Promise.resolve(zi.openTextDocument(se)):Promise.resolve(se));return jt.showTextDocument(at,ge,Oe)},createTextEditorDecorationType(se){return jt.createTextEditorDecorationType(je,se)},onDidChangeActiveTextEditor(se,ge,Oe){return jt.onDidChangeActiveTextEditor(se,ge,Oe)},onDidChangeVisibleTextEditors(se,ge,Oe){return jt.onDidChangeVisibleTextEditors(se,ge,Oe)},onDidChangeTextEditorSelection(se,ge,Oe){return jt.onDidChangeTextEditorSelection(se,ge,Oe)},onDidChangeTextEditorOptions(se,ge,Oe){return jt.onDidChangeTextEditorOptions(se,ge,Oe)},onDidChangeTextEditorVisibleRanges(se,ge,Oe){return jt.onDidChangeTextEditorVisibleRanges(se,ge,Oe)},onDidChangeTextEditorViewColumn(se,ge,Oe){return jt.onDidChangeTextEditorViewColumn(se,ge,Oe)},onDidCloseTerminal(se,ge,Oe){return tt.onDidCloseTerminal(se,ge,Oe)},onDidOpenTerminal(se,ge,Oe){return tt.onDidOpenTerminal(se,ge,Oe)},onDidChangeActiveTerminal(se,ge,Oe){return tt.onDidChangeActiveTerminal(se,ge,Oe)},onDidChangeTerminalDimensions(se,ge,Oe){return(0,_e.$lF)(je,"terminalDimensions"),tt.onDidChangeTerminalDimensions(se,ge,Oe)},onDidChangeTerminalState(se,ge,Oe){return tt.onDidChangeTerminalState(se,ge,Oe)},onDidWriteTerminalData(se,ge,Oe){return(0,_e.$lF)(je,"terminalDataWriteEvent"),tt.onDidWriteTerminalData(se,ge,Oe)},onDidExecuteTerminalCommand(se,ge,Oe){return(0,_e.$lF)(je,"terminalExecuteCommandEvent"),tt.onDidExecuteTerminalCommand(se,ge,Oe)},get state(){return Le.getState(je)},onDidChangeWindowState(se,ge,Oe){return Le.onDidChangeWindowState(se,ge,Oe)},showInformationMessage(se,...ge){return Oi.showMessage(je,m.default.Info,se,ge[0],ge.slice(1))},showWarningMessage(se,...ge){return Oi.showMessage(je,m.default.Warning,se,ge[0],ge.slice(1))},showErrorMessage(se,...ge){return Oi.showMessage(je,m.default.Error,se,ge[0],ge.slice(1))},showQuickPick(se,ge,Oe){return si.showQuickPick(je,se,ge,Oe)},showWorkspaceFolderPick(se){return si.showWorkspaceFolderPick(se)},showInputBox(se,ge){return si.showInput(se,ge)},showOpenDialog(se){return ki.showOpenDialog(je,se)},showSaveDialog(se){return ki.showSaveDialog(se)},createStatusBarItem(se,ge,Oe){let at,bt,Lt;return typeof se=="string"?(at=se,bt=ge,Lt=Oe):(bt=se,Lt=ge),Ni.createStatusBarEntry(je,at,bt,Lt)},setStatusBarMessage(se,ge){return Ni.setStatusBarMessage(se,ge)},withScmProgress(se){return Ce.report("window.withScmProgress",je,"Use 'withProgress' instead."),vi.withProgress(je,{location:Ne.ProgressLocation.SourceControl},(ge,Oe)=>se({report(at){}}))},withProgress(se,ge){return vi.withProgress(je,se,ge)},createOutputChannel(se,ge){return kt.createOutputChannel(se,ge,je)},createWebviewPanel(se,ge,Oe,at){return bi.createWebviewPanel(je,se,ge,Oe,at)},createWebviewTextEditorInset(se,ge,Oe,at){return(0,_e.$lF)(je,"editorInsets"),un.createWebviewEditorInset(se,ge,Oe,at,je)},createTerminal(se,ge,Oe){return typeof se=="object"?"pty"in se?tt.createExtensionTerminal(se):tt.createTerminalFromOptions(se):tt.createTerminal(se,ge,Oe)},registerTerminalLinkProvider(se){return tt.registerLinkProvider(se)},registerTerminalProfileProvider(se,ge){return tt.registerProfileProvider(je,se,ge)},registerTerminalQuickFixProvider(se,ge){return(0,_e.$lF)(je,"terminalQuickFixProvider"),tt.registerTerminalQuickFixProvider(se,je.identifier.value,ge)},registerTreeDataProvider(se,ge){return Ci.registerTreeDataProvider(se,ge,je)},createTreeView(se,ge){return Ci.createTreeView(se,ge,je)},registerWebviewPanelSerializer:(se,ge)=>bi.registerWebviewPanelSerializer(je,se,ge),registerCustomEditorProvider:(se,ge,Oe={})=>Fi.registerCustomEditorProvider(je,se,ge,Oe),registerFileDecorationProvider(se){return Be.registerFileDecorationProvider(se,je)},registerUriHandler(se){return hi.registerUriHandler(je,se)},createQuickPick(){return si.createQuickPick(je)},createInputBox(){return si.createInputBox(je)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(se,ge,Oe){return wi.onDidChangeActiveColorTheme(se,ge,Oe)},registerWebviewViewProvider(se,ge,Oe){return Ti.registerWebviewViewProvider(je,se,ge,Oe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,ge,Oe){return St.onDidChangeActiveNotebookEditor(se,ge,Oe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,ge,Oe){return pi.onDidChangeNotebookEditorSelection(se,ge,Oe)},onDidChangeNotebookEditorVisibleRanges(se,ge,Oe){return pi.onDidChangeNotebookEditorVisibleRanges(se,ge,Oe)},showNotebookDocument(se,ge){return St.showNotebookDocument(se,ge)},registerExternalUriOpener(se,ge,Oe){return(0,_e.$lF)(je,"externalUriOpener"),Ki.registerExternalUriOpener(je.identifier,se,ge,Oe)},registerProfileContentHandler(se,ge){return(0,_e.$lF)(je,"profileContentHandlers"),Hi.registrProfileContentHandler(je,se,ge)},registerQuickDiffProvider(se,ge,Oe,at){return(0,_e.$lF)(je,"quickDiffProvider"),Ri.registerQuickDiffProvider(wt(se),ge,Oe,at)},get tabGroups(){return K.tabGroups},registerShareProvider(se,ge){return(0,_e.$lF)(je,"shareProvider"),Ai.registerShareProvider(wt(se),ge)}},zi={get rootPath(){return Ce.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(se){throw new P.$9("rootPath")},getWorkspaceFolder(se){return dt.getWorkspaceFolder(se)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(se){throw new P.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(se){throw new P.$9("workspaceFile")},updateWorkspaceFolders:(se,ge,...Oe)=>dt.updateWorkspaceFolders(je,se,ge||0,...Oe),onDidChangeWorkspaceFolders:function(se,ge,Oe){return dt.onDidChangeWorkspace(se,ge,Oe)},asRelativePath:(se,ge)=>dt.getRelativePath(se,ge),findFiles:(se,ge,Oe,at)=>dt.findFiles(se,ge,Oe,je.identifier,at),findTextInFiles:(se,ge,Oe,at)=>{(0,_e.$lF)(je,"findTextInFiles");let bt,Lt;return typeof ge=="object"?(bt=ge,Lt=Oe):(bt={},Lt=ge,at=Oe),dt.findTextInFiles(se,bt||{},Lt,je.identifier,at)},save:se=>((0,_e.$lF)(je,"saveEditor"),dt.save(se)),saveAs:se=>((0,_e.$lF)(je,"saveEditor"),dt.saveAs(se)),saveAll:se=>dt.saveAll(se),applyEdit(se,ge){return Zi.applyWorkspaceEdit(se,je,ge)},createFileSystemWatcher:(se,ge,Oe,at)=>{let bt;return typeof ge=="boolean"?bt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!at,correlate:!1}:ge&&((0,_e.$lF)(je,"createFileSystemWatcher"),bt={...ge,correlate:!0}),ti.createFileSystemWatcher(dt,je,se,bt)},get textDocuments(){return At.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw new P.$9("textDocuments")},openTextDocument(se){let ge;const Oe=se;if(typeof se=="string")ge=Promise.resolve(g.URI.file(se));else if(g.URI.isUri(se))ge=Promise.resolve(se);else if(!Oe||typeof Oe=="object")ge=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(at=>At.ensureDocumentData(at).then(bt=>bt.document))},onDidOpenTextDocument:(se,ge,Oe)=>At.onDidAddDocument(se,ge,Oe),onDidCloseTextDocument:(se,ge,Oe)=>At.onDidRemoveDocument(se,ge,Oe),onDidChangeTextDocument:(se,ge,Oe)=>At.onDidChangeDocument(se,ge,Oe),onDidSaveTextDocument:(se,ge,Oe)=>At.onDidSaveDocument(se,ge,Oe),onWillSaveTextDocument:(se,ge,Oe)=>cn.getOnWillSaveTextDocumentEvent(je)(se,ge,Oe),get notebookDocuments(){return St.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,ge){let Oe;if(g.URI.isUri(se))Oe=se,await St.openNotebookDocument(se);else if(typeof se=="string")Oe=g.URI.revive(await St.createNotebookDocument({viewType:se,content:ge}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(se,ge,Oe){return $i.onDidSaveNotebookDocument(se,ge,Oe)},onDidChangeNotebookDocument(se,ge,Oe){return $i.onDidChangeNotebookDocument(se,ge,Oe)},onWillSaveNotebookDocument(se,ge,Oe){return Vi.getOnWillSaveNotebookDocumentEvent(je)(se,ge,Oe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(se,ge,Oe,at){return St.registerNotebookSerializer(je,se,ge,Oe,(0,_e.$kF)(je,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(se,ge,Oe)=>gi.onDidChangeConfiguration(se,ge,Oe),getConfiguration(se,ge){return ge=arguments.length===1?void 0:ge,gi.getConfiguration(se,ge,je)},registerTextDocumentContentProvider(se,ge){return an.registerTextDocumentContentProvider(se,ge)},registerTaskProvider:(se,ge)=>(Ce.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(je,se,ge)),registerFileSystemProvider(se,ge,Oe){return(0,T.$Pc)(Pi.registerFileSystemProvider(je,se,ge,Oe),Nt.addFileSystemProvider(se,ge,Oe))},get fs(){return Nt.value},registerFileSearchProvider:(se,ge)=>((0,_e.$lF)(je,"fileSearchProvider"),Vt.registerFileSearchProvider(se,ge)),registerTextSearchProvider:(se,ge)=>((0,_e.$lF)(je,"textSearchProvider"),Vt.registerTextSearchProvider(se,ge)),registerRemoteAuthorityResolver:(se,ge)=>((0,_e.$lF)(je,"resolvers"),Et.registerRemoteAuthorityResolver(se,ge)),registerResourceLabelFormatter:se=>((0,_e.$lF)(je,"resolvers"),qi.$registerResourceLabelFormatter(se)),getRemoteExecServer:se=>((0,_e.$lF)(je,"resolvers"),Et.getRemoteExecServer(se)),onDidCreateFiles:(se,ge,Oe)=>ti.onDidCreateFile(se,ge,Oe),onDidDeleteFiles:(se,ge,Oe)=>ti.onDidDeleteFile(se,ge,Oe),onDidRenameFiles:(se,ge,Oe)=>ti.onDidRenameFile(se,ge,Oe),onWillCreateFiles:(se,ge,Oe)=>ti.getOnWillCreateFileEvent(je)(se,ge,Oe),onWillDeleteFiles:(se,ge,Oe)=>ti.getOnWillDeleteFileEvent(je)(se,ge,Oe),onWillRenameFiles:(se,ge,Oe)=>ti.getOnWillRenameFileEvent(je)(se,ge,Oe),openTunnel:se=>((0,_e.$lF)(je,"tunnels"),Ot.openTunnel(je,se).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,_e.$lF)(je,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(se,ge,Oe)=>((0,_e.$lF)(je,"tunnels"),Ot.onDidChangeTunnels(se,ge,Oe)),registerPortAttributesProvider:(se,ge)=>((0,_e.$lF)(je,"portsAttributes"),Ot.registerPortsAttributesProvider(se,ge)),registerTunnelProvider:(se,ge)=>((0,_e.$lF)(je,"tunnelFactory"),Ot.registerTunnelProvider(se,ge)),registerTimelineProvider:(se,ge)=>((0,_e.$lF)(je,"timeline"),Mi.registerTimelineProvider(se,ge,je.identifier,Ke.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:se=>((0,_e.$lF)(je,"workspaceTrust"),dt.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,ge,Oe)=>dt.onDidGrantWorkspaceTrust(se,ge,Oe),registerEditSessionIdentityProvider:(se,ge)=>((0,_e.$lF)(je,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(se,ge)),onWillCreateEditSessionIdentity:(se,ge,Oe)=>((0,_e.$lF)(je,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(je)(se,ge,Oe)),registerCanonicalUriProvider:(se,ge)=>((0,_e.$lF)(je,"canonicalUriProvider"),dt.registerCanonicalUriProvider(se,ge)),getCanonicalUri:(se,ge,Oe)=>((0,_e.$lF)(je,"canonicalUriProvider"),dt.provideCanonicalUri(se,ge,Oe))},gn={get inputBox(){return Ce.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(je)},createSourceControl(se,ge,Oe){return di.createSourceControl(je,se,ge,Oe)},registerSourceControlInputBoxValueProvider(se,ge){return(0,_e.$lF)(je,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(je,se,ge)}},mn={createCommentController(se,ge){return Li.createCommentController(je,se,ge)}},tn={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession(se,ge,Oe){return $t.onDidStartDebugSession(se,ge,Oe)},onDidTerminateDebugSession(se,ge,Oe){return $t.onDidTerminateDebugSession(se,ge,Oe)},onDidChangeActiveDebugSession(se,ge,Oe){return $t.onDidChangeActiveDebugSession(se,ge,Oe)},onDidReceiveDebugSessionCustomEvent(se,ge,Oe){return $t.onDidReceiveDebugSessionCustomEvent(se,ge,Oe)},onDidChangeBreakpoints(se,ge,Oe){return $t.onDidChangeBreakpoints(se,ge,Oe)},onDidChangeStackFrameFocus(se,ge,Oe){return(0,_e.$lF)(je,"debugFocus"),$t.onDidChangeStackFrameFocus(se,ge,Oe)},registerDebugConfigurationProvider(se,ge,Oe){return $t.registerDebugConfigurationProvider(se,ge,Oe||Jt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,ge){return $t.registerDebugAdapterDescriptorFactory(je,se,ge)},registerDebugAdapterTrackerFactory(se,ge){return $t.registerDebugAdapterTrackerFactory(se,ge)},startDebugging(se,ge,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?$t.startDebugging(se,ge,{parentSession:Oe}):$t.startDebugging(se,ge,Oe||{})},stopDebugging(se){return $t.stopDebugging(se)},addBreakpoints(se){return $t.addBreakpoints(se)},removeBreakpoints(se){return $t.removeBreakpoints(se)},asDebugSourceUri(se,ge){return $t.asDebugSourceUri(se,ge)}},Ui={registerTaskProvider:(se,ge)=>Dt.registerTaskProvider(je,se,ge),fetchTasks:se=>Dt.fetchTasks(se),executeTask:se=>Dt.executeTask(je,se),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(se,ge,Oe)=>Dt.onDidStartTask(se,ge,Oe),onDidEndTask:(se,ge,Oe)=>Dt.onDidEndTask(se,ge,Oe),onDidStartTaskProcess:(se,ge,Oe)=>Dt.onDidStartTaskProcess(se,ge,Oe),onDidEndTaskProcess:(se,ge,Oe)=>Dt.onDidEndTaskProcess(se,ge,Oe)},nn={createNotebookController(se,ge,Oe,at,bt){return Qt.createNotebookController(je,se,ge,Oe,at,(0,_e.$kF)(je,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(se,ge)=>St.registerNotebookCellStatusBarItemProvider(je,se,ge),createRendererMessaging(se){return Ii.createRendererMessaging(je,se)},createNotebookControllerDetectionTask(se){return(0,_e.$lF)(je,"notebookKernelSource"),Qt.createNotebookControllerDetectionTask(je,se)},registerKernelSourceActionProvider(se,ge){return(0,_e.$lF)(je,"notebookKernelSource"),Qt.registerKernelSourceActionProvider(je,se,ge)},onDidChangeNotebookCellExecutionState(se,ge,Oe){return(0,_e.$lF)(je,"notebookCellExecutionState"),Qt.onDidChangeNotebookCellExecutionState(se,ge,Oe)}},rn={t(...se){if(typeof se[0]=="string"){const ge=se.shift(),Oe=!se||typeof se[0]!="object"?se:se[0];return Ct.getMessage(je.identifier.value,{message:ge,args:Oe})}return Ct.getMessage(je.identifier.value,se[0])},get bundle(){return Ct.getBundle(je.identifier.value)},get uri(){return Ct.getBundleUri(je.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(se,ge){return(0,_e.$lF)(je,"interactive"),Gi.registerProvider(je,se,ge)},registerInteractiveSessionProvider(se,ge){return(0,_e.$lF)(je,"interactive"),li.registerChatProvider(je,se,ge)},sendInteractiveRequestToProvider(se,ge){return(0,_e.$lF)(je,"interactive"),li.sendInteractiveRequestToProvider(se,ge)},get onDidPerformUserAction(){return(0,_e.$lF)(je,"interactiveUserActions"),li.onDidPerformUserAction},transferChatSession(se,ge){return(0,_e.$lF)(je,"interactive"),li.transferChatSession(se,ge)}},$n={getRelatedInformation(se,ge){return(0,_e.$lF)(je,"aiRelatedInformation"),Ei.getRelatedInformation(je,se,ge)},registerRelatedInformationProvider(se,ge){return(0,_e.$lF)(je,"aiRelatedInformation"),Ei.registerRelatedInformationProvider(je,se,ge)},registerEmbeddingVectorProvider(se,ge){return(0,_e.$lF)(je,"aiRelatedInformation"),dn.registerEmbeddingVectorProvider(je,se,ge)}},pn={registerChatResponseProvider(se,ge,Oe){return(0,_e.$lF)(je,"chatProvider"),yi.registerProvider(je.identifier,se,ge,Oe)},requestChatAccess(se){return(0,_e.$lF)(je,"chatRequestAccess"),yi.requestChatResponseProvider(je.identifier,se)},registerVariable(se,ge,Oe){return(0,_e.$lF)(je,"chatVariables"),hn.registerVariableResolver(je,se,ge,Oe)},registerMappedEditsProvider(se,ge){return(0,_e.$lF)(je,"mappedEditsProvider"),ft.registerMappedEditsProvider(je,se,ge)},createChatAgent(se,ge){return(0,_e.$lF)(je,"chatAgents2"),ln.createChatAgent(je,se,ge)}},on={registerSpeechProvider(se,ge){return(0,_e.$lF)(je,"speech"),Di.registerProvider(je.identifier,se,ge)}};return{version:mt.version,ai:$n,authentication:Yi,commands:Si,comments:mn,chat:pn,debug:tn,env:ji,extensions:xi,interactive:sn,l10n:rn,languages:fn,notebooks:nn,scm:gn,speech:on,tasks:Ui,tests:_i,window:en,workspace:zi,Breakpoint:Ne.$OL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$GM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$FM,CallHierarchyIncomingCall:Ne.$bL,CallHierarchyItem:Ne.$aL,CallHierarchyOutgoingCall:Ne.$cL,CancellationError:P.$5,CancellationTokenSource:$.$3d,CandidatePortSource:a.CandidatePortSource,CodeAction:Ne.$0K,CodeActionKind:Ne.$$K,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$dL,Color:Ne.$qL,ColorInformation:Ne.$rL,ColorPresentation:Ne.$sL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$kL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$lL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$AL,DebugAdapterExecutable:Ne.$SL,DebugAdapterInlineImplementation:Ne.$VL,DebugAdapterNamedPipeServer:Ne.$UL,DebugAdapterServer:Ne.$TL,DebugConfigurationProviderTriggerKind:Jt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$4K,DiagnosticRelatedInformation:Ne.$3K,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$PK,DocumentHighlight:Ne.$6K,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$7K,DocumentLink:Ne.$pL,DocumentSymbol:Ne.$9K,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$YL,InlineValueText:Ne.$ZL,InlineValueVariableLookup:Ne.$1L,InlineValueEvaluatableExpression:Ne.$2L,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Sd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$_L,FileDecoration2:Ne.$_L,FileSystemError:Ne.$4L,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Ne.$5L,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$QL,InlineCompletionItem:Ne.$mL,InlineCompletionList:Ne.$nL,Hover:Ne.$5K,IndentAction:C.IndentAction,Location:Ne.$2K,MarkdownString:Ne.$eL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$fL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$QK,ProcessExecution:Ne.$yL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$$L,Range:Ne.$RK,RelativePattern:Ne.$ML,Selection:Ne.$SK,SelectionRange:Ne.$_K,SemanticTokens:Ne.$8L,SemanticTokensBuilder:Ne.$7L,SemanticTokensEdit:Ne.$9L,SemanticTokensEdits:Ne.$0L,SemanticTokensLegend:Ne.$6L,ShellExecution:Ne.$zL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$hL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$gL,SnippetString:Ne.$1K,SourceBreakpoint:Ne.$PL,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$8K,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$BL,TaskGroup:Ne.$xL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$tL,TerminalQuickFixTerminalCommand:Ne.$vL,TerminalQuickFixOpener:Ne.$uL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$wL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$WK,SnippetTextEdit:Ne.$YK,TextEditorCursorStyle:b.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$LL,ThemeIcon:Ne.$KL,TreeItem:Ne.$CL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$uM,UIKind:Ft.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$ZK,DocumentDropEdit:Ne.$IL,DocumentPasteEdit:Ne.$JL,InlayHint:Ne.$jL,InlayHintLabelPart:Ne.$iL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$VK,ResolvedAuthority:Ne.$TK,ManagedResolvedAuthority:Ne.$UK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$jM,NotebookRange:Ne.$bM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$cM,NotebookData:Ne.$dM,NotebookRendererScript:Ne.$hM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$fM,NotebookCellOutputItem:Ne.$eM,NotebookCellStatusBarItem:Ne.$gM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$XK,NotebookKernelSourceAction:Ne.$iM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$lM,LinkedEditingRanges:Ne.$kM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$mM,TestMessage:Ne.$nM,TestMessage2:Ne.$nM,TestTag:Ne.$oM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Bt.TextSearchCompleteMessageType,DataTransfer:Ne.$HL,DataTransferItem:Ne.$DL,CoveredCount:Ne.$pM,FileCoverage:Ne.$qM,StatementCoverage:Ne.$rM,BranchCoverage:Ne.$sM,FunctionCoverage:Ne.$tM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$vM,TabInputTextDiff:Ne.$wM,TabInputTextMerge:Ne.$xM,TabInputCustom:Ne.$yM,TabInputNotebook:Ne.$AM,TabInputNotebookDiff:Ne.$BM,TabInputWebview:Ne.$zM,TabInputTerminal:Ne.$CM,TabInputInteractiveWindow:Ne.$DM,TabInputChat:Ne.$EM,TelemetryTrustedValue:i.$xo,LogLevel:n.LogLevel,EditSessionIdentityMatch:s.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ne.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$WL,ThreadFocus:Ne.$XL,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$hhc=Zt}),define(Re[291],Ae([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,256,15,116,82,83]),function(ie,e,$,P,I,T,M,m,g,b,A,C,l,p,v,n,o,i,s,a,u,h,t,r,c,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,$.$Kr)(f.$9fc,f.$8fc,1),(0,$.$Kr)(r.$kj,t.$ihc,1),(0,$.$Kr)(n.$hfc,n.$ifc,1),(0,$.$Kr)(m.$bN,m.$aN,0),(0,$.$Kr)(M.$Cfc,M.$Afc,0),(0,$.$Kr)(i.$Efc,i.$Dfc,0),(0,$.$Kr)(C.$ggc,C.$kgc,0),(0,$.$Kr)(T.$mgc,T.$lgc,0),(0,$.$Kr)(g.$3M,g.$2M,0),(0,$.$Kr)(w.$0fc,w.$$fc,0),(0,$.$Kr)(s.$efc,s.$dfc,0),(0,$.$Kr)(P.$Sgc,P.$Rgc,1),(0,$.$Kr)(l.$Cgc,l.$Dgc,0),(0,$.$Kr)(p.$Xfc,p.$Wfc,0),(0,$.$Kr)(A.$6gc,A.$5gc,0),(0,$.$Kr)(b.$1fc,b.$4fc,0),(0,$.$Kr)(v.$fyb,v.$gyb,0),(0,$.$Kr)(o.$ghc,o.$fhc,0),(0,$.$Kr)(I.$zfc,I.$yfc,0),(0,$.$Kr)(a.$6fc,a.$5fc,0),(0,$.$Kr)(u.$_M,u.$9M,0),(0,$.$Kr)(h.$Ofc,h.$Pfc,0),(0,$.$Kr)(c.$egc,c.$fgc,0)}),define(Re[292],Ae([1,0,290,38,2,287,7,14,275]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;class b extends T.$lhc{k(){}getModule(p,v){for(const n of this.b){const o=n(p);if(o){p=o;break}}if(this.a.has(p))return this.a.get(p).load(p,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends P.$agc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$rjc);const p=this.h.invokeFunction($.$hhc);this.r=this.h.createInstance(b,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,v,n){v=v.with({path:C(v.path,".js")});const o=p?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const i=I.URI.revive(await this.C.$asBrowserUri(v)),s=await fetch(i.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),s.status!==200)throw new Error(s.statusText);const a=await s.text(),u=`${v.toString(!0)}#vscode-extension`,h=`${a}
//# sourceURL=${u}`;let t;try{t=new Function("module","exports","require",h)}catch(w){throw console.error(o?`Loading code for extension ${o} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${v.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}p&&await this.w.initializeLocalizedMessages(p);const r={},c={exports:r},f=w=>{const d=this.r.getModule(w,v);if(d===void 0)throw new Error(`Cannot load module '${w}'`);return d};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,r,f),c.exports!==r?c.exports:r}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+p;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,m.$3g)(10)}}e.$sjc=A;function C(l,p){return l.endsWith(p)?l:l+p}}),define(Re[293],Ae([1,0,69,70,15,38,200,86,292]),function(ie,e,$,P,I,T,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.$Kr)(I.$jj,new $.$Yh(M.$khc,[!0],!0)),(0,P.$Kr)(T.$bgc,g.$sjc,0),(0,P.$Kr)(m.$Ffc,m.$Gfc,0)}),define(Re[298],Ae([1,0,24,5,79,288,277,19,88,13,2,291,293]),function(ie,e,$,P,I,T,M,m,g,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const C=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(t){return/^(file|vscode-remote):/i.test(t)}const v=fetch.bind(self);function n(t){self.fetch=async function(r,c){return r instanceof Request||p(String(r))&&(r=(await t(A.URI.parse(String(r)))).toString(!0)),v(r,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,c,f,w,d){(async()=>(p(c.toString())&&(c=(await t(A.URI.parse(c.toString()))).toString(!0)),super.open(r,c,f??!0,w,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(r,c){if(/^file:/i.test(r.toString()))r=b.$kg.uriToBrowserUri(A.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(y){function E(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const k=fetch.bind(self);self.fetch=function(B,ee){return B instanceof Request?k(B,ee):k(E(B),ee)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,ee,J,V,R){return super.open(B,E(ee),J??!0,V,R)}};const F=importScripts.bind(self);self.importScripts=(...B)=>{F(...B.map(E))},F(y)}.toString()}('${r}'))`;c=c||{},c.name=c.name||m.$nc(r.toString());const d=new Blob([w],{type:"application/javascript"}),D=URL.createObjectURL(d);return new t(D,c)}}else self.Worker=class extends M.$tjc{constructor(t,r){super(l,t,{name:m.$nc(t.toString()),...r})}};const o=new class{constructor(){this.pid=void 0}exit(t){C()}};class i{constructor(){const r=new MessageChannel,c=new P.$Sd;let f=!1;l(r.port2,[r.port2]),r.port1.onmessage=w=>{const{data:d}=w;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const D=$.$ge.wrap(new Uint8Array(d,0,d.byteLength));if((0,I.$qm)(D,2)){f=!0,a("received terminate message from renderer");return}c.fire(D)},this.protocol={onMessage:c.event,send:w=>{if(!f){const d=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);r.port1.postMessage(d,[d])}}}}}function s(t){return new Promise(r=>{const c=t.onMessage(f=>{c.dispose();const w=JSON.parse(f.toString());t.send((0,I.$pm)(0)),r({protocol:t,initData:w})});t.send((0,I.$pm)(1))})}let a=t=>C();function u(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const t=new i;return{onmessage(r){u(r)&&s(t.protocol).then(c=>{g.mark("code/extHost/didWaitForInitData");const f=new T.$nhc(c.protocol,c.initData,o,null,r.data);n(w=>f.asBrowserUri(w)),a=w=>f.terminate(w)})}}}e.create=h})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
